# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### AbstractPod <a name="AbstractPod" id="cdk8s-plus-28.AbstractPod"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AbstractPod.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AbstractPod(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AbstractPod.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AbstractPod.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AbstractPod.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.AbstractPod.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.AbstractPod.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.AbstractPod.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.AbstractPod.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.AbstractPod.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.AbstractPod.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.AbstractPod.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.AbstractPod.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.AbstractPod.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.AbstractPod.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.AbstractPod.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.AbstractPod.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.AbstractPod.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.AbstractPod.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.AbstractPod.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.AbstractPod.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.AbstractPod.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AbstractPod.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AbstractPod.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AbstractPod.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.AbstractPod.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.AbstractPod.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AbstractPod.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AbstractPod.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AbstractPod.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AbstractPod.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.AbstractPod.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.AbstractPod.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.AbstractPod.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.AbstractPod.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.AbstractPod.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.AbstractPod.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.AbstractPod.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.AbstractPod.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.AbstractPod.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.AbstractPod.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.AbstractPod.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.AbstractPod.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.AbstractPod.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.AbstractPod.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.AbstractPod.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---


### AwsElasticBlockStorePersistentVolume <a name="AwsElasticBlockStorePersistentVolume" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume"></a>

Represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AwsElasticBlockStorePersistentVolume(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  volume_id: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.volumeId">volume_id</a></code> | <code>str</code> | Unique ID of the persistent disk resource in AWS (Amazon EBS volume). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.accessModes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.mountOptions"></a>

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.reclaimPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.storage"></a>

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.storageClassName"></a>

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.volumeMode"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.volumeId"></a>

- *Type:* str

Unique ID of the persistent disk resource in AWS (Amazon EBS volume).

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.partition"></a>

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind"></a>

```python
def bind(
  claim: IPersistentVolumeClaim
) -> None
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.reserve"></a>

```python
def reserve() -> PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName">from_persistent_volume_name</a></code> | Imports a pv from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AwsElasticBlockStorePersistentVolume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_persistent_volume_name` <a name="from_persistent_volume_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AwsElasticBlockStorePersistentVolume.from_persistent_volume_name(
  scope: Construct,
  id: str,
  volume_name: str
)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* str

---

###### `volume_name`<sup>Required</sup> <a name="volume_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.fsType">fs_type</a></code> | <code>str</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.readOnly">read_only</a></code> | <code>bool</code> | Whether or not it is mounted as a read-only volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.volumeId">volume_id</a></code> | <code>str</code> | Volume id of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | Partition of this volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mode"></a>

```python
mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaim_policy`<sup>Required</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

Storage class this volume belongs to.

---

##### `fs_type`<sup>Required</sup> <a name="fs_type" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

File system type of this volume.

---

##### `read_only`<sup>Required</sup> <a name="read_only" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

Whether or not it is mounted as a read-only volume.

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

Volume id of this volume.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Partition of this volume.

---


### AzureDiskPersistentVolume <a name="AzureDiskPersistentVolume" id="cdk8s-plus-28.AzureDiskPersistentVolume"></a>

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AzureDiskPersistentVolume(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  disk_name: str,
  disk_uri: str,
  caching_mode: AzureDiskPersistentVolumeCachingMode = None,
  fs_type: str = None,
  kind: AzureDiskPersistentVolumeKind = None,
  read_only: bool = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.diskName">disk_name</a></code> | <code>str</code> | The Name of the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.diskUri">disk_uri</a></code> | <code>str</code> | The URI the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.cachingMode">caching_mode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Host Caching mode. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.fsType">fs_type</a></code> | <code>str</code> | Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.kind">kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Kind of disk. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.readOnly">read_only</a></code> | <code>bool</code> | Force the ReadOnly setting in VolumeMounts. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.accessModes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.mountOptions"></a>

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.reclaimPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.storage"></a>

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.storageClassName"></a>

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.volumeMode"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `disk_name`<sup>Required</sup> <a name="disk_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.diskName"></a>

- *Type:* str

The Name of the data disk in the blob storage.

---

##### `disk_uri`<sup>Required</sup> <a name="disk_uri" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.diskUri"></a>

- *Type:* str

The URI the data disk in the blob storage.

---

##### `caching_mode`<sup>Optional</sup> <a name="caching_mode" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.cachingMode"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.kind"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.AzureDiskPersistentVolume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.AzureDiskPersistentVolume.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.AzureDiskPersistentVolume.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.AzureDiskPersistentVolume.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.AzureDiskPersistentVolume.bind"></a>

```python
def bind(
  claim: IPersistentVolumeClaim
) -> None
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.AzureDiskPersistentVolume.reserve"></a>

```python
def reserve() -> PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName">from_persistent_volume_name</a></code> | Imports a pv from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AzureDiskPersistentVolume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_persistent_volume_name` <a name="from_persistent_volume_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AzureDiskPersistentVolume.from_persistent_volume_name(
  scope: Construct,
  id: str,
  volume_name: str
)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* str

---

###### `volume_name`<sup>Required</sup> <a name="volume_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.azureKind">azure_kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Azure kind of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.cachingMode">caching_mode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Caching mode of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.diskName">disk_name</a></code> | <code>str</code> | Disk name of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.diskUri">disk_uri</a></code> | <code>str</code> | Disk URI of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.fsType">fs_type</a></code> | <code>str</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.readOnly">read_only</a></code> | <code>bool</code> | Whether or not it is mounted as a read-only volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.mode"></a>

```python
mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaim_policy`<sup>Required</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

Storage class this volume belongs to.

---

##### `azure_kind`<sup>Required</sup> <a name="azure_kind" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.azureKind"></a>

```python
azure_kind: AzureDiskPersistentVolumeKind
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>

Azure kind of this volume.

---

##### `caching_mode`<sup>Required</sup> <a name="caching_mode" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.cachingMode"></a>

```python
caching_mode: AzureDiskPersistentVolumeCachingMode
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>

Caching mode of this volume.

---

##### `disk_name`<sup>Required</sup> <a name="disk_name" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.diskName"></a>

```python
disk_name: str
```

- *Type:* str

Disk name of this volume.

---

##### `disk_uri`<sup>Required</sup> <a name="disk_uri" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.diskUri"></a>

```python
disk_uri: str
```

- *Type:* str

Disk URI of this volume.

---

##### `fs_type`<sup>Required</sup> <a name="fs_type" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

File system type of this volume.

---

##### `read_only`<sup>Required</sup> <a name="read_only" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

Whether or not it is mounted as a read-only volume.

---


### BasicAuthSecret <a name="BasicAuthSecret" id="cdk8s-plus-28.BasicAuthSecret"></a>

Create a secret for basic authentication.

> [https://kubernetes.io/docs/concepts/configuration/secret/#basic-authentication-secret](https://kubernetes.io/docs/concepts/configuration/secret/#basic-authentication-secret)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.BasicAuthSecret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.BasicAuthSecret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  password: str,
  username: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.password">password</a></code> | <code>str</code> | The password or token for authentication. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.username">username</a></code> | <code>str</code> | The user name for authentication. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `password`<sup>Required</sup> <a name="password" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.password"></a>

- *Type:* str

The password or token for authentication.

---

##### `username`<sup>Required</sup> <a name="username" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.username"></a>

- *Type:* str

The user name for authentication.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.BasicAuthSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.BasicAuthSecret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.BasicAuthSecret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.BasicAuthSecret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.BasicAuthSecret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.BasicAuthSecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.BasicAuthSecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.BasicAuthSecret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.BasicAuthSecret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.BasicAuthSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.BasicAuthSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.BasicAuthSecret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.BasicAuthSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.BasicAuthSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.BasicAuthSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.BasicAuthSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.BasicAuthSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.BasicAuthSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.BasicAuthSecret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.BasicAuthSecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.BasicAuthSecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.BasicAuthSecret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### ClusterRole <a name="ClusterRole" id="cdk8s-plus-28.ClusterRole"></a>

- *Implements:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ClusterRole.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRole(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  aggregation_labels: typing.Mapping[str] = None,
  rules: typing.List[ClusterRolePolicyRule] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.aggregationLabels">aggregation_labels</a></code> | <code>typing.Mapping[str]</code> | Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules. |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]</code> | A list of rules the role should allow. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `aggregation_labels`<sup>Optional</sup> <a name="aggregation_labels" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.aggregationLabels"></a>

- *Type:* typing.Mapping[str]

Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.rules"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]
- *Default:* []

A list of rules the role should allow.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ClusterRole.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRole.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRole.aggregate">aggregate</a></code> | Aggregate rules from roles matching this label selector. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allow">allow</a></code> | Add permission to perform a list of HTTP verbs on a collection of resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowCreate">allow_create</a></code> | Add "create" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowDelete">allow_delete</a></code> | Add "delete" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowDeleteCollection">allow_delete_collection</a></code> | Add "deletecollection" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowGet">allow_get</a></code> | Add "get" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowList">allow_list</a></code> | Add "list" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowPatch">allow_patch</a></code> | Add "patch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowRead">allow_read</a></code> | Add "get", "list", and "watch" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowReadWrite">allow_read_write</a></code> | Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowUpdate">allow_update</a></code> | Add "update" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowWatch">allow_watch</a></code> | Add "watch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.bind">bind</a></code> | Create a ClusterRoleBinding that binds the permissions in this ClusterRole to a list of subjects, without namespace restrictions. |
| <code><a href="#cdk8s-plus-28.ClusterRole.bindInNamespace">bind_in_namespace</a></code> | Create a RoleBinding that binds the permissions in this ClusterRole to a list of subjects, that will only apply to the given namespace. |
| <code><a href="#cdk8s-plus-28.ClusterRole.combine">combine</a></code> | Combines the rules of the argument ClusterRole into this ClusterRole using aggregation labels. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.ClusterRole.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ClusterRole.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ClusterRole.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `aggregate` <a name="aggregate" id="cdk8s-plus-28.ClusterRole.aggregate"></a>

```python
def aggregate(
  key: str,
  value: str
) -> None
```

Aggregate rules from roles matching this label selector.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ClusterRole.aggregate.parameter.key"></a>

- *Type:* str

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ClusterRole.aggregate.parameter.value"></a>

- *Type:* str

---

##### `allow` <a name="allow" id="cdk8s-plus-28.ClusterRole.allow"></a>

```python
def allow(
  verbs: typing.List[str],
  endpoints: IApiEndpoint
) -> None
```

Add permission to perform a list of HTTP verbs on a collection of resources.

> [https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb](https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb)

###### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.ClusterRole.allow.parameter.verbs"></a>

- *Type:* typing.List[str]

---

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allow.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The endpoints(s) to apply to.

---

##### `allow_create` <a name="allow_create" id="cdk8s-plus-28.ClusterRole.allowCreate"></a>

```python
def allow_create(
  endpoints: IApiEndpoint
) -> None
```

Add "create" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowCreate.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_delete` <a name="allow_delete" id="cdk8s-plus-28.ClusterRole.allowDelete"></a>

```python
def allow_delete(
  endpoints: IApiEndpoint
) -> None
```

Add "delete" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowDelete.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_delete_collection` <a name="allow_delete_collection" id="cdk8s-plus-28.ClusterRole.allowDeleteCollection"></a>

```python
def allow_delete_collection(
  endpoints: IApiEndpoint
) -> None
```

Add "deletecollection" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowDeleteCollection.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_get` <a name="allow_get" id="cdk8s-plus-28.ClusterRole.allowGet"></a>

```python
def allow_get(
  endpoints: IApiEndpoint
) -> None
```

Add "get" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowGet.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_list` <a name="allow_list" id="cdk8s-plus-28.ClusterRole.allowList"></a>

```python
def allow_list(
  endpoints: IApiEndpoint
) -> None
```

Add "list" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowList.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_patch` <a name="allow_patch" id="cdk8s-plus-28.ClusterRole.allowPatch"></a>

```python
def allow_patch(
  endpoints: IApiEndpoint
) -> None
```

Add "patch" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowPatch.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_read` <a name="allow_read" id="cdk8s-plus-28.ClusterRole.allowRead"></a>

```python
def allow_read(
  endpoints: IApiEndpoint
) -> None
```

Add "get", "list", and "watch" permissions for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowRead.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_read_write` <a name="allow_read_write" id="cdk8s-plus-28.ClusterRole.allowReadWrite"></a>

```python
def allow_read_write(
  endpoints: IApiEndpoint
) -> None
```

Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowReadWrite.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_update` <a name="allow_update" id="cdk8s-plus-28.ClusterRole.allowUpdate"></a>

```python
def allow_update(
  endpoints: IApiEndpoint
) -> None
```

Add "update" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowUpdate.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allow_watch` <a name="allow_watch" id="cdk8s-plus-28.ClusterRole.allowWatch"></a>

```python
def allow_watch(
  endpoints: IApiEndpoint
) -> None
```

Add "watch" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowWatch.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `bind` <a name="bind" id="cdk8s-plus-28.ClusterRole.bind"></a>

```python
def bind(
  subjects: ISubject
) -> ClusterRoleBinding
```

Create a ClusterRoleBinding that binds the permissions in this ClusterRole to a list of subjects, without namespace restrictions.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRole.bind.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

##### `bind_in_namespace` <a name="bind_in_namespace" id="cdk8s-plus-28.ClusterRole.bindInNamespace"></a>

```python
def bind_in_namespace(
  namespace: str,
  subjects: ISubject
) -> RoleBinding
```

Create a RoleBinding that binds the permissions in this ClusterRole to a list of subjects, that will only apply to the given namespace.

###### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.ClusterRole.bindInNamespace.parameter.namespace"></a>

- *Type:* str

the namespace to limit permissions to.

---

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRole.bindInNamespace.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

##### `combine` <a name="combine" id="cdk8s-plus-28.ClusterRole.combine"></a>

```python
def combine(
  rol: ClusterRole
) -> None
```

Combines the rules of the argument ClusterRole into this ClusterRole using aggregation labels.

###### `rol`<sup>Required</sup> <a name="rol" id="cdk8s-plus-28.ClusterRole.combine.parameter.rol"></a>

- *Type:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ClusterRole.fromClusterRoleName">from_cluster_role_name</a></code> | Imports a role from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.ClusterRole.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRole.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ClusterRole.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_cluster_role_name` <a name="from_cluster_role_name" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRole.from_cluster_role_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a role from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]</code> | Rules associaated with this Role. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ClusterRole.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ClusterRole.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ClusterRole.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ClusterRole.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRole.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRole.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ClusterRole.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ClusterRole.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ClusterRole.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.ClusterRole.property.rules"></a>

```python
rules: typing.List[ClusterRolePolicyRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]

Rules associaated with this Role.

Returns a copy, use `allow` to add rules.

---


### ClusterRoleBinding <a name="ClusterRoleBinding" id="cdk8s-plus-28.ClusterRoleBinding"></a>

A ClusterRoleBinding grants permissions cluster-wide to a user or set of users.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ClusterRoleBinding.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRoleBinding(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  role: IClusterRole
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.role">role</a></code> | <code><a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a></code> | The role to bind to. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.role"></a>

- *Type:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

The role to bind to.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.addSubjects">add_subjects</a></code> | Adds a subject to the role. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.ClusterRoleBinding.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ClusterRoleBinding.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ClusterRoleBinding.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_subjects` <a name="add_subjects" id="cdk8s-plus-28.ClusterRoleBinding.addSubjects"></a>

```python
def add_subjects(
  subjects: ISubject
) -> None
```

Adds a subject to the role.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRoleBinding.addSubjects.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

The subjects to add.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.ClusterRoleBinding.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRoleBinding.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ClusterRoleBinding.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.subjects">subjects</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ISubject">ISubject</a>]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ClusterRoleBinding.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ClusterRoleBinding.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ClusterRoleBinding.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ClusterRoleBinding.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleBinding.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRoleBinding.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ClusterRoleBinding.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ClusterRoleBinding.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ClusterRoleBinding.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.ClusterRoleBinding.property.role"></a>

```python
role: IClusterRole
```

- *Type:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRoleBinding.property.subjects"></a>

```python
subjects: typing.List[ISubject]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ISubject">ISubject</a>]

---


### ConfigMap <a name="ConfigMap" id="cdk8s-plus-28.ConfigMap"></a>

- *Implements:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

ConfigMap holds configuration data for pods to consume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ConfigMap.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ConfigMap(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  binary_data: typing.Mapping[str] = None,
  data: typing.Mapping[str] = None,
  immutable: bool = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.binaryData">binary_data</a></code> | <code>typing.Mapping[str]</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `binary_data`<sup>Optional</sup> <a name="binary_data" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.binaryData"></a>

- *Type:* typing.Mapping[str]

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'.
BinaryData can contain byte sequences that are not in the UTF-8 range. The
keys stored in BinaryData must not overlap with the ones in the Data field,
this is enforced during validation process.

You can also add binary data using `configMap.addBinaryData()`.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.data"></a>

- *Type:* typing.Mapping[str]

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values
with non-UTF-8 byte sequences must use the BinaryData field. The keys
stored in Data must not overlap with the keys in the BinaryData field, this
is enforced during validation process.

You can also add data using `configMap.addData()`.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ConfigMap.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ConfigMap.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addBinaryData">add_binary_data</a></code> | Adds a binary data entry to the config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addData">add_data</a></code> | Adds a data entry to the config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addDirectory">add_directory</a></code> | Adds a directory to the ConfigMap. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addFile">add_file</a></code> | Adds a file to the ConfigMap. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.ConfigMap.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ConfigMap.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ConfigMap.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_binary_data` <a name="add_binary_data" id="cdk8s-plus-28.ConfigMap.addBinaryData"></a>

```python
def add_binary_data(
  key: str,
  value: str
) -> None
```

Adds a binary data entry to the config map.

BinaryData can contain byte
sequences that are not in the UTF-8 range.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addBinaryData.parameter.key"></a>

- *Type:* str

The key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ConfigMap.addBinaryData.parameter.value"></a>

- *Type:* str

The value.

---

##### `add_data` <a name="add_data" id="cdk8s-plus-28.ConfigMap.addData"></a>

```python
def add_data(
  key: str,
  value: str
) -> None
```

Adds a data entry to the config map.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addData.parameter.key"></a>

- *Type:* str

The key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ConfigMap.addData.parameter.value"></a>

- *Type:* str

The value.

---

##### `add_directory` <a name="add_directory" id="cdk8s-plus-28.ConfigMap.addDirectory"></a>

```python
def add_directory(
  local_dir: str,
  exclude: typing.List[str] = None,
  key_prefix: str = None
) -> None
```

Adds a directory to the ConfigMap.

###### `local_dir`<sup>Required</sup> <a name="local_dir" id="cdk8s-plus-28.ConfigMap.addDirectory.parameter.localDir"></a>

- *Type:* str

A path to a local directory.

---

###### `exclude`<sup>Optional</sup> <a name="exclude" id="cdk8s-plus-28.ConfigMap.addDirectory.parameter.exclude"></a>

- *Type:* typing.List[str]
- *Default:* include all files

Glob patterns to exclude when adding files.

---

###### `key_prefix`<sup>Optional</sup> <a name="key_prefix" id="cdk8s-plus-28.ConfigMap.addDirectory.parameter.keyPrefix"></a>

- *Type:* str
- *Default:* ""

A prefix to add to all keys in the config map.

---

##### `add_file` <a name="add_file" id="cdk8s-plus-28.ConfigMap.addFile"></a>

```python
def add_file(
  local_file: str,
  key: str = None
) -> None
```

Adds a file to the ConfigMap.

###### `local_file`<sup>Required</sup> <a name="local_file" id="cdk8s-plus-28.ConfigMap.addFile.parameter.localFile"></a>

- *Type:* str

The path to the local file.

---

###### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addFile.parameter.key"></a>

- *Type:* str

The ConfigMap key (default to the file name).

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ConfigMap.fromConfigMapName">from_config_map_name</a></code> | Represents a ConfigMap created elsewhere. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.ConfigMap.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ConfigMap.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ConfigMap.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_config_map_name` <a name="from_config_map_name" id="cdk8s-plus-28.ConfigMap.fromConfigMapName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ConfigMap.from_config_map_name(
  scope: Construct,
  id: str,
  name: str
)
```

Represents a ConfigMap created elsewhere.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.binaryData">binary_data</a></code> | <code>typing.Mapping[str]</code> | The binary data associated with this config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.data">data</a></code> | <code>typing.Mapping[str]</code> | The data associated with this config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not this config map is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ConfigMap.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ConfigMap.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ConfigMap.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ConfigMap.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ConfigMap.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ConfigMap.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ConfigMap.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ConfigMap.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ConfigMap.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `binary_data`<sup>Required</sup> <a name="binary_data" id="cdk8s-plus-28.ConfigMap.property.binaryData"></a>

```python
binary_data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The binary data associated with this config map.

Returns a copy. To add data records, use `addBinaryData()` or `addData()`.

---

##### `data`<sup>Required</sup> <a name="data" id="cdk8s-plus-28.ConfigMap.property.data"></a>

```python
data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The data associated with this config map.

Returns an copy. To add data records, use `addData()` or `addBinaryData()`.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.ConfigMap.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not this config map is immutable.

---


### CronJob <a name="CronJob" id="cdk8s-plus-28.CronJob"></a>

A CronJob is responsible for creating a Job and scheduling it based on provided cron schedule.

This helps running Jobs in a recurring manner.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.CronJob.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CronJob(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  active_deadline: Duration = None,
  backoff_limit: typing.Union[int, float] = None,
  ttl_after_finished: Duration = None,
  schedule: Cron,
  concurrency_policy: ConcurrencyPolicy = None,
  failed_jobs_retained: typing.Union[int, float] = None,
  starting_deadline: Duration = None,
  successful_jobs_retained: typing.Union[int, float] = None,
  suspend: bool = None,
  time_zone: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.activeDeadline">active_deadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.ttlAfterFinished">ttl_after_finished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.schedule">schedule</a></code> | <code>cdk8s.Cron</code> | Specifies the time in which the job would run again. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.concurrencyPolicy">concurrency_policy</a></code> | <code><a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a></code> | Specifies the concurrency policy for the job. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.failedJobsRetained">failed_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of failed jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.startingDeadline">starting_deadline</a></code> | <code>cdk8s.Duration</code> | Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.successfulJobsRetained">successful_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of successful jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.suspend">suspend</a></code> | <code>bool</code> | Specifies if the cron job should be suspended. |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.timeZone">time_zone</a></code> | <code>str</code> | Specifies the timezone for the job. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.CronJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.CronJob.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.CronJob.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.CronJob.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.CronJob.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.CronJob.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.CronJob.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.CronJob.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.CronJob.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.CronJob.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.CronJob.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.CronJob.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.CronJob.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.CronJob.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.CronJob.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.CronJob.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.CronJob.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.CronJob.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.CronJob.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `active_deadline`<sup>Optional</sup> <a name="active_deadline" id="cdk8s-plus-28.CronJob.Initializer.parameter.activeDeadline"></a>

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.CronJob.Initializer.parameter.backoffLimit"></a>

- *Type:* typing.Union[int, float]
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttl_after_finished`<sup>Optional</sup> <a name="ttl_after_finished" id="cdk8s-plus-28.CronJob.Initializer.parameter.ttlAfterFinished"></a>

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.CronJob.Initializer.parameter.schedule"></a>

- *Type:* cdk8s.Cron

Specifies the time in which the job would run again.

This is defined as a cron expression in the CronJob resource.

---

##### `concurrency_policy`<sup>Optional</sup> <a name="concurrency_policy" id="cdk8s-plus-28.CronJob.Initializer.parameter.concurrencyPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a>
- *Default:* ConcurrencyPolicy.Forbid

Specifies the concurrency policy for the job.

---

##### `failed_jobs_retained`<sup>Optional</sup> <a name="failed_jobs_retained" id="cdk8s-plus-28.CronJob.Initializer.parameter.failedJobsRetained"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1

Specifies the number of failed jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `starting_deadline`<sup>Optional</sup> <a name="starting_deadline" id="cdk8s-plus-28.CronJob.Initializer.parameter.startingDeadline"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10)

Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed.

This deadline specifies
how much time can pass after a schedule point, for which kubernetes can still start the job.
For example, if this is set to 100 seconds, kubernetes is allowed to start the job at a maximum 100 seconds after
the scheduled time.

Note that the Kubernetes CronJobController checks for things every 10 seconds, for this reason, a deadline below 10
seconds is not allowed, as it may cause your job to never be scheduled.

In addition, kubernetes will stop scheduling jobs if more than 100 schedules were missed (for any reason).
This property also controls what time interval should kubernetes consider when counting for missed schedules.

For example, suppose a CronJob is set to schedule a new Job every one minute beginning at 08:30:00,
and its `startingDeadline` field is not set. If the CronJob controller happens to be down from 08:29:00 to 10:21:00,
the job will not start as the number of missed jobs which missed their schedule is greater than 100.
However, if `startingDeadline` is set to 200 seconds, kubernetes will only count 3 missed schedules, and thus
start a new execution at 10:22:00.

---

##### `successful_jobs_retained`<sup>Optional</sup> <a name="successful_jobs_retained" id="cdk8s-plus-28.CronJob.Initializer.parameter.successfulJobsRetained"></a>

- *Type:* typing.Union[int, float]
- *Default:* 3

Specifies the number of successful jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.CronJob.Initializer.parameter.suspend"></a>

- *Type:* bool
- *Default:* false

Specifies if the cron job should be suspended.

Only applies to future executions, current ones are remained untouched.

---

##### `time_zone`<sup>Optional</sup> <a name="time_zone" id="cdk8s-plus-28.CronJob.Initializer.parameter.timeZone"></a>

- *Type:* str
- *Default:* Timezone of kube-controller-manager process.

Specifies the timezone for the job.

This helps aligining the schedule to follow the specified timezone.

> [{@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.]({@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.CronJob.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.CronJob.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.CronJob.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.CronJob.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.CronJob.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.CronJob.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.CronJob.select">select</a></code> | Configure selectors for this workload. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.CronJob.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.CronJob.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.CronJob.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.CronJob.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.CronJob.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.CronJob.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.CronJob.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.CronJob.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.CronJob.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.CronJob.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.CronJob.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.CronJob.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.CronJob.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.CronJob.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.CronJob.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.CronJob.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.CronJob.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.CronJob.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.CronJob.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.CronJob.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.CronJob.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.CronJob.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.CronJob.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.CronJob.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.CronJob.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.CronJob.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.CronJob.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.CronJob.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.CronJob.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.CronJob.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.CronJob.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.CronJob.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.CronJob.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.CronJob.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.CronJob.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.CronJob.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.CronJob.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.CronJob.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CronJob.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.CronJob.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.CronJob.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.CronJob.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.resourceType">resource_type</a></code> | <code>str</code> | Represents the resource type. |
| <code><a href="#cdk8s-plus-28.CronJob.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.CronJob.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.CronJob.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.CronJob.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.CronJob.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.concurrencyPolicy">concurrency_policy</a></code> | <code>str</code> | The policy used by this cron job to determine the concurrency mode in which to schedule jobs. |
| <code><a href="#cdk8s-plus-28.CronJob.property.failedJobsRetained">failed_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | The number of failed jobs retained by this cron job. |
| <code><a href="#cdk8s-plus-28.CronJob.property.schedule">schedule</a></code> | <code>cdk8s.Cron</code> | The schedule this cron job is scheduled to run in. |
| <code><a href="#cdk8s-plus-28.CronJob.property.startingDeadline">starting_deadline</a></code> | <code>cdk8s.Duration</code> | The time by which the running cron job needs to schedule the next job execution. |
| <code><a href="#cdk8s-plus-28.CronJob.property.successfulJobsRetained">successful_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | The number of successful jobs retained by this cron job. |
| <code><a href="#cdk8s-plus-28.CronJob.property.suspend">suspend</a></code> | <code>bool</code> | Whether or not the cron job is currently suspended or not. |
| <code><a href="#cdk8s-plus-28.CronJob.property.timeZone">time_zone</a></code> | <code>str</code> | The timezone which this cron job would follow to schedule jobs. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.CronJob.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.CronJob.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.CronJob.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.CronJob.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.CronJob.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.CronJob.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.CronJob.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.CronJob.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

Represents the resource type.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.CronJob.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.CronJob.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.CronJob.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.CronJob.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.CronJob.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.CronJob.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.CronJob.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.CronJob.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.CronJob.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.CronJob.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.CronJob.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.CronJob.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.CronJob.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.CronJob.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.CronJob.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.CronJob.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.CronJob.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.CronJob.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `concurrency_policy`<sup>Required</sup> <a name="concurrency_policy" id="cdk8s-plus-28.CronJob.property.concurrencyPolicy"></a>

```python
concurrency_policy: str
```

- *Type:* str

The policy used by this cron job to determine the concurrency mode in which to schedule jobs.

---

##### `failed_jobs_retained`<sup>Required</sup> <a name="failed_jobs_retained" id="cdk8s-plus-28.CronJob.property.failedJobsRetained"></a>

```python
failed_jobs_retained: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The number of failed jobs retained by this cron job.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.CronJob.property.schedule"></a>

```python
schedule: Cron
```

- *Type:* cdk8s.Cron

The schedule this cron job is scheduled to run in.

---

##### `starting_deadline`<sup>Required</sup> <a name="starting_deadline" id="cdk8s-plus-28.CronJob.property.startingDeadline"></a>

```python
starting_deadline: Duration
```

- *Type:* cdk8s.Duration

The time by which the running cron job needs to schedule the next job execution.

The job is considered as failed if it misses this deadline.

---

##### `successful_jobs_retained`<sup>Required</sup> <a name="successful_jobs_retained" id="cdk8s-plus-28.CronJob.property.successfulJobsRetained"></a>

```python
successful_jobs_retained: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The number of successful jobs retained by this cron job.

---

##### `suspend`<sup>Required</sup> <a name="suspend" id="cdk8s-plus-28.CronJob.property.suspend"></a>

```python
suspend: bool
```

- *Type:* bool

Whether or not the cron job is currently suspended or not.

---

##### `time_zone`<sup>Optional</sup> <a name="time_zone" id="cdk8s-plus-28.CronJob.property.timeZone"></a>

```python
time_zone: str
```

- *Type:* str

The timezone which this cron job would follow to schedule jobs.

---


### DaemonSet <a name="DaemonSet" id="cdk8s-plus-28.DaemonSet"></a>

A DaemonSet ensures that all (or some) Nodes run a copy of a Pod.

As nodes are added to the cluster, Pods are added to them.
As nodes are removed from the cluster, those Pods are garbage collected.
Deleting a DaemonSet will clean up the Pods it created.

Some typical uses of a DaemonSet are:

* running a cluster storage daemon on every node
* running a logs collection daemon on every node
* running a node monitoring daemon on every node

In a simple case, one DaemonSet, covering all nodes, would be used for each type of daemon.
A more complex setup might use multiple DaemonSets for a single type of daemon,
but with different flags and/or different memory and cpu requests for different hardware types.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.DaemonSet.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DaemonSet(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready_seconds: typing.Union[int, float] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.minReadySeconds"></a>

- *Type:* typing.Union[int, float]
- *Default:* 0

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.DaemonSet.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.DaemonSet.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.DaemonSet.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.DaemonSet.select">select</a></code> | Configure selectors for this workload. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.DaemonSet.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.DaemonSet.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.DaemonSet.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.DaemonSet.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.DaemonSet.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.DaemonSet.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.DaemonSet.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.DaemonSet.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.DaemonSet.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.DaemonSet.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.DaemonSet.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.DaemonSet.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.DaemonSet.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.DaemonSet.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.DaemonSet.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.DaemonSet.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.DaemonSet.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.DaemonSet.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.DaemonSet.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DaemonSet.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.DaemonSet.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.DaemonSet.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.DaemonSet.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.DaemonSet.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.DaemonSet.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.DaemonSet.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DaemonSet.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.DaemonSet.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.DaemonSet.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.DaemonSet.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.DaemonSet.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.DaemonSet.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.DaemonSet.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.DaemonSet.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.DaemonSet.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.DaemonSet.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.DaemonSet.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.DaemonSet.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.DaemonSet.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.DaemonSet.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DaemonSet.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.DaemonSet.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.DaemonSet.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.DaemonSet.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.DaemonSet.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.DaemonSet.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.DaemonSet.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `min_ready_seconds`<sup>Required</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.DaemonSet.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---


### Deployment <a name="Deployment" id="cdk8s-plus-28.Deployment"></a>

- *Implements:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

A Deployment provides declarative updates for Pods and ReplicaSets.

You describe a desired state in a Deployment, and the Deployment Controller changes the actual
state to the desired state at a controlled rate. You can define Deployments to create new ReplicaSets, or to remove
existing Deployments and adopt all their resources with new Deployments.

> Note: Do not manage ReplicaSets owned by a Deployment. Consider opening an issue in the main Kubernetes repository if your use case is not covered below.

Use Case

The following are typical use cases for Deployments:

* Create a Deployment to rollout a ReplicaSet. The ReplicaSet creates Pods in the background.
  Check the status of the rollout to see if it succeeds or not.
* Declare the new state of the Pods by updating the PodTemplateSpec of the Deployment.
  A new ReplicaSet is created and the Deployment manages moving the Pods from the old ReplicaSet to the new one at a controlled rate.
  Each new ReplicaSet updates the revision of the Deployment.
* Rollback to an earlier Deployment revision if the current state of the Deployment is not stable.
  Each rollback updates the revision of the Deployment.
* Scale up the Deployment to facilitate more load.
* Pause the Deployment to apply multiple fixes to its PodTemplateSpec and then resume it to start a new rollout.
* Use the status of the Deployment as an indicator that a rollout has stuck.
* Clean up older ReplicaSets that you don't need anymore.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Deployment.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Deployment(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready: Duration = None,
  progress_deadline: Duration = None,
  replicas: typing.Union[int, float] = None,
  strategy: DeploymentStrategy = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.progressDeadline">progress_deadline</a></code> | <code>cdk8s.Duration</code> | The maximum duration for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a></code> | Specifies the strategy used to replace old Pods by new ones. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Deployment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Deployment.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Deployment.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Deployment.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.Deployment.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.Deployment.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Deployment.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.Deployment.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Deployment.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.Deployment.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.Deployment.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Deployment.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Deployment.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Deployment.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Deployment.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.Deployment.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.Deployment.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.Deployment.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.Deployment.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready`<sup>Optional</sup> <a name="min_ready" id="cdk8s-plus-28.Deployment.Initializer.parameter.minReady"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `progress_deadline`<sup>Optional</sup> <a name="progress_deadline" id="cdk8s-plus-28.Deployment.Initializer.parameter.progressDeadline"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(600)

The maximum duration for a deployment to make progress before it is considered to be failed.

The deployment controller will continue
to process failed deployments and a condition with a ProgressDeadlineExceeded
reason will be surfaced in the deployment status.

Note that progress will not be estimated during the time a deployment is paused.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.Deployment.Initializer.parameter.replicas"></a>

- *Type:* typing.Union[int, float]
- *Default:* 2

Number of desired pods.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.Deployment.Initializer.parameter.strategy"></a>

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a>
- *Default:* RollingUpdate with maxSurge and maxUnavailable set to 25%.

Specifies the strategy used to replace old Pods by new ones.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Deployment.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Deployment.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Deployment.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Deployment.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Deployment.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Deployment.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Deployment.select">select</a></code> | Configure selectors for this workload. |
| <code><a href="#cdk8s-plus-28.Deployment.exposeViaIngress">expose_via_ingress</a></code> | Expose a deployment via an ingress. |
| <code><a href="#cdk8s-plus-28.Deployment.exposeViaService">expose_via_service</a></code> | Expose a deployment via a service. |
| <code><a href="#cdk8s-plus-28.Deployment.markHasAutoscaler">mark_has_autoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.Deployment.toScalingTarget">to_scaling_target</a></code> | Return the target spec properties of this Scalable. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Deployment.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Deployment.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Deployment.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.Deployment.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Deployment.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Deployment.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Deployment.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Deployment.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Deployment.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Deployment.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Deployment.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Deployment.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Deployment.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Deployment.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Deployment.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Deployment.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Deployment.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Deployment.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Deployment.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Deployment.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Deployment.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Deployment.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Deployment.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.Deployment.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.Deployment.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.Deployment.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.Deployment.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.Deployment.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Deployment.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.Deployment.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Deployment.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Deployment.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Deployment.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.Deployment.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.Deployment.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Deployment.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Deployment.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

##### `expose_via_ingress` <a name="expose_via_ingress" id="cdk8s-plus-28.Deployment.exposeViaIngress"></a>

```python
def expose_via_ingress(
  path: str,
  name: str = None,
  ports: typing.List[ServicePort] = None,
  service_type: ServiceType = None,
  ingress: Ingress = None,
  path_type: HttpIngressPathType = None
) -> Ingress
```

Expose a deployment via an ingress.

This will first expose the deployment with a service, and then expose the service via an ingress.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.path"></a>

- *Type:* str

The ingress path to register under.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.name"></a>

- *Type:* str
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

###### `service_type`<sup>Optional</sup> <a name="service_type" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.serviceType"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

###### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.ingress"></a>

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

###### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

##### `expose_via_service` <a name="expose_via_service" id="cdk8s-plus-28.Deployment.exposeViaService"></a>

```python
def expose_via_service(
  name: str = None,
  ports: typing.List[ServicePort] = None,
  service_type: ServiceType = None
) -> Service
```

Expose a deployment via a service.

This is equivalent to running `kubectl expose deployment <deployment-name>`.

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Deployment.exposeViaService.parameter.name"></a>

- *Type:* str
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Deployment.exposeViaService.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

###### `service_type`<sup>Optional</sup> <a name="service_type" id="cdk8s-plus-28.Deployment.exposeViaService.parameter.serviceType"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

##### `mark_has_autoscaler` <a name="mark_has_autoscaler" id="cdk8s-plus-28.Deployment.markHasAutoscaler"></a>

```python
def mark_has_autoscaler() -> None
```

Called on all IScalable targets when they are associated with an autoscaler.

> [IScalable.markHasAutoscaler()](IScalable.markHasAutoscaler())

##### `to_scaling_target` <a name="to_scaling_target" id="cdk8s-plus-28.Deployment.toScalingTarget"></a>

```python
def to_scaling_target() -> ScalingTarget
```

Return the target spec properties of this Scalable.

> [IScalable.toScalingTarget()](IScalable.toScalingTarget())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Deployment.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Deployment.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Deployment.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Deployment.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Deployment.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Deployment.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Deployment.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Deployment.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.Deployment.property.progressDeadline">progress_deadline</a></code> | <code>cdk8s.Duration</code> | The maximum duration for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.Deployment.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.hasAutoscaler">has_autoscaler</a></code> | <code>bool</code> | If this is a target of an autoscaler. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Deployment.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Deployment.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Deployment.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Deployment.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Deployment.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Deployment.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Deployment.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Deployment.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Deployment.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Deployment.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Deployment.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Deployment.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.Deployment.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.Deployment.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.Deployment.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.Deployment.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Deployment.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Deployment.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Deployment.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Deployment.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Deployment.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Deployment.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Deployment.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.Deployment.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.Deployment.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Deployment.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `min_ready`<sup>Required</sup> <a name="min_ready" id="cdk8s-plus-28.Deployment.property.minReady"></a>

```python
min_ready: Duration
```

- *Type:* cdk8s.Duration

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

##### `progress_deadline`<sup>Required</sup> <a name="progress_deadline" id="cdk8s-plus-28.Deployment.property.progressDeadline"></a>

```python
progress_deadline: Duration
```

- *Type:* cdk8s.Duration

The maximum duration for a deployment to make progress before it is considered to be failed.

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.Deployment.property.strategy"></a>

```python
strategy: DeploymentStrategy
```

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a>

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.Deployment.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of desired pods.

---

##### `has_autoscaler`<sup>Required</sup> <a name="has_autoscaler" id="cdk8s-plus-28.Deployment.property.hasAutoscaler"></a>

```python
has_autoscaler: bool
```

- *Type:* bool

If this is a target of an autoscaler.

---


### DockerConfigSecret <a name="DockerConfigSecret" id="cdk8s-plus-28.DockerConfigSecret"></a>

Create a secret for storing credentials for accessing a container image registry.

> [https://kubernetes.io/docs/concepts/configuration/secret/#docker-config-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#docker-config-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.DockerConfigSecret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DockerConfigSecret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  data: typing.Mapping[typing.Any]
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.data">data</a></code> | <code>typing.Mapping[typing.Any]</code> | JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `data`<sup>Required</sup> <a name="data" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.data"></a>

- *Type:* typing.Mapping[typing.Any]

JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData.

> [https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file](https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.DockerConfigSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.DockerConfigSecret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.DockerConfigSecret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.DockerConfigSecret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.DockerConfigSecret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.DockerConfigSecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.DockerConfigSecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.DockerConfigSecret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.DockerConfigSecret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DockerConfigSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.DockerConfigSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DockerConfigSecret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.DockerConfigSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.DockerConfigSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.DockerConfigSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.DockerConfigSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.DockerConfigSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DockerConfigSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.DockerConfigSecret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.DockerConfigSecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.DockerConfigSecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.DockerConfigSecret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### GCEPersistentDiskPersistentVolume <a name="GCEPersistentDiskPersistentVolume" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume"></a>

GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin.

> [https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk](https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.GCEPersistentDiskPersistentVolume(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  pd_name: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.pdName">pd_name</a></code> | <code>str</code> | Unique name of the PD resource in GCE. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.accessModes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.mountOptions"></a>

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.reclaimPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.storage"></a>

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.storageClassName"></a>

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.volumeMode"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `pd_name`<sup>Required</sup> <a name="pd_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.pdName"></a>

- *Type:* str

Unique name of the PD resource in GCE.

Used to identify the disk in GCE.

> [https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk](https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk)

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.partition"></a>

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind"></a>

```python
def bind(
  claim: IPersistentVolumeClaim
) -> None
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.reserve"></a>

```python
def reserve() -> PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName">from_persistent_volume_name</a></code> | Imports a pv from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.GCEPersistentDiskPersistentVolume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_persistent_volume_name` <a name="from_persistent_volume_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.GCEPersistentDiskPersistentVolume.from_persistent_volume_name(
  scope: Construct,
  id: str,
  volume_name: str
)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* str

---

###### `volume_name`<sup>Required</sup> <a name="volume_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.fsType">fs_type</a></code> | <code>str</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.pdName">pd_name</a></code> | <code>str</code> | PD resource in GCE of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.readOnly">read_only</a></code> | <code>bool</code> | Whether or not it is mounted as a read-only volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | Partition of this volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mode"></a>

```python
mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaim_policy`<sup>Required</sup> <a name="reclaim_policy" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

Storage class this volume belongs to.

---

##### `fs_type`<sup>Required</sup> <a name="fs_type" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

File system type of this volume.

---

##### `pd_name`<sup>Required</sup> <a name="pd_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.pdName"></a>

```python
pd_name: str
```

- *Type:* str

PD resource in GCE of this volume.

---

##### `read_only`<sup>Required</sup> <a name="read_only" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

Whether or not it is mounted as a read-only volume.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Partition of this volume.

---


### Group <a name="Group" id="cdk8s-plus-28.Group"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents a group.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Group.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Group.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Group.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.Group.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Group.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Group.fromName">from_name</a></code> | Reference a group by name. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Group.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Group.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Group.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_name` <a name="from_name" id="cdk8s-plus-28.Group.fromName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Group.from_name(
  scope: Construct,
  id: str,
  name: str
)
```

Reference a group by name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Group.fromName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Group.fromName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Group.fromName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Group.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Group.property.kind">kind</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Group.property.name">name</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Group.property.apiGroup">api_group</a></code> | <code>str</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Group.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Group.property.kind"></a>

```python
kind: str
```

- *Type:* str

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Group.property.name"></a>

```python
name: str
```

- *Type:* str

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.Group.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

---


### HorizontalPodAutoscaler <a name="HorizontalPodAutoscaler" id="cdk8s-plus-28.HorizontalPodAutoscaler"></a>

A HorizontalPodAutoscaler scales a workload up or down in response to a metric change.

This allows your services to scale up when demand is high and scale down
when they are no longer needed.

Typical use cases for HorizontalPodAutoscaler:

* When Memory usage is above 70%, scale up the number of replicas to meet the demand.
* When CPU usage is below 30%, scale down the number of replicas to save resources.
* When a service is experiencing a spike in traffic, scale up the number of replicas
  to meet the demand. Then, when the traffic subsides, scale down the number of
  replicas to save resources.

The autoscaler uses the following algorithm to determine the number of replicas to scale:

`desiredReplicas = ceil[currentReplicas * ( currentMetricValue / desiredMetricValue )]`

HorizontalPodAutoscaler's can be used to with any `Scalable` workload:

* Deployment
* StatefulSet

**Targets that already have a replica count defined:**

Remove any replica counts from the target resource before associating with a
HorizontalPodAutoscaler. If this isn't done, then any time a change to that object is applied,
Kubernetes will scale the current number of Pods to the value of the target.replicas key. This
may not be desired and could lead to unexpected behavior.

> [https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/#implicit-maintenance-mode-deactivation](https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/#implicit-maintenance-mode-deactivation)

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
backend = kplus.Deployment(self, "Backend", ...)

hpa = kplus.HorizontalPodAutoscaler(chart, "Hpa",
    target=backend,
    max_replicas=10,
    scale_up={
        "policies": [{
            "replicas": kplus.Replicas.absolute(3),
            "duration": Duration.minutes(5)
        }
        ]
    }
)
```


#### Initializers <a name="Initializers" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HorizontalPodAutoscaler(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  max_replicas: typing.Union[int, float],
  target: IScalable,
  metrics: typing.List[Metric] = None,
  min_replicas: typing.Union[int, float] = None,
  scale_down: ScalingRules = None,
  scale_up: ScalingRules = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.maxReplicas">max_replicas</a></code> | <code>typing.Union[int, float]</code> | The maximum number of replicas that can be scaled up to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.target">target</a></code> | <code><a href="#cdk8s-plus-28.IScalable">IScalable</a></code> | The workload to scale up or down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.metrics">metrics</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]</code> | The metric conditions that trigger a scale up or scale down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.minReplicas">min_replicas</a></code> | <code>typing.Union[int, float]</code> | The minimum number of replicas that can be scaled down to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scaleDown">scale_down</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scaleUp">scale_up</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling up. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `max_replicas`<sup>Required</sup> <a name="max_replicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.maxReplicas"></a>

- *Type:* typing.Union[int, float]

The maximum number of replicas that can be scaled up to.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

The workload to scale up or down.

Scalable workload types:

* Deployment
* StatefulSet

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.metrics"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]
- *Default:* If metrics are not provided, then the target resource constraints (e.g. cpu limit) will be used as scaling metrics.

The metric conditions that trigger a scale up or scale down.

---

##### `min_replicas`<sup>Optional</sup> <a name="min_replicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.minReplicas"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1

The minimum number of replicas that can be scaled down to.

Can be set to 0 if the alpha feature gate `HPAScaleToZero` is enabled and
at least one Object or External metric is configured.

---

##### `scale_down`<sup>Optional</sup> <a name="scale_down" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scaleDown"></a>

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Scale down to minReplica count with a 5 minute stabilization window.

The scaling behavior when scaling down.

---

##### `scale_up`<sup>Optional</sup> <a name="scale_up" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scaleUp"></a>

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Is the higher of: * Increase no more than 4 pods per 60 seconds * Double the number of pods per 60 seconds

The scaling behavior when scaling up.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.HorizontalPodAutoscaler.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.HorizontalPodAutoscaler.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.HorizontalPodAutoscaler.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HorizontalPodAutoscaler.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.maxReplicas">max_replicas</a></code> | <code>typing.Union[int, float]</code> | The maximum number of replicas that can be scaled up to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.minReplicas">min_replicas</a></code> | <code>typing.Union[int, float]</code> | The minimum number of replicas that can be scaled down to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleDown">scale_down</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleUp">scale_up</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling up. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.IScalable">IScalable</a></code> | The workload to scale up or down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.metrics">metrics</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]</code> | The metric conditions that trigger a scale up or scale down. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `max_replicas`<sup>Required</sup> <a name="max_replicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.maxReplicas"></a>

```python
max_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The maximum number of replicas that can be scaled up to.

---

##### `min_replicas`<sup>Required</sup> <a name="min_replicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.minReplicas"></a>

```python
min_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The minimum number of replicas that can be scaled down to.

---

##### `scale_down`<sup>Required</sup> <a name="scale_down" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleDown"></a>

```python
scale_down: ScalingRules
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>

The scaling behavior when scaling down.

---

##### `scale_up`<sup>Required</sup> <a name="scale_up" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleUp"></a>

```python
scale_up: ScalingRules
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>

The scaling behavior when scaling up.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.target"></a>

```python
target: IScalable
```

- *Type:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

The workload to scale up or down.

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.metrics"></a>

```python
metrics: typing.List[Metric]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]

The metric conditions that trigger a scale up or scale down.

---


### Ingress <a name="Ingress" id="cdk8s-plus-28.Ingress"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services
externally-reachable urls, load balance traffic, terminate SSL, offer name
based virtual hosting etc.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Ingress.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Ingress(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  class_name: str = None,
  default_backend: IngressBackend = None,
  rules: typing.List[IngressRule] = None,
  tls: typing.List[IngressTls] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.className">class_name</a></code> | <code>str</code> | Class Name for this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.defaultBackend">default_backend</a></code> | <code><a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a></code> | The default backend services requests that do not match any rule. |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IngressRule">IngressRule</a>]</code> | Routing rules for this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.tls">tls</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IngressTls">IngressTls</a>]</code> | TLS settings for this ingress. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Ingress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Ingress.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Ingress.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `class_name`<sup>Optional</sup> <a name="class_name" id="cdk8s-plus-28.Ingress.Initializer.parameter.className"></a>

- *Type:* str

Class Name for this ingress.

This field is a reference to an IngressClass resource that contains
additional Ingress configuration, including the name of the Ingress controller.

---

##### `default_backend`<sup>Optional</sup> <a name="default_backend" id="cdk8s-plus-28.Ingress.Initializer.parameter.defaultBackend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The default backend services requests that do not match any rule.

Using this option or the `addDefaultBackend()` method is equivalent to
adding a rule with both `path` and `host` undefined.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.Ingress.Initializer.parameter.rules"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.IngressRule">IngressRule</a>]

Routing rules for this ingress.

Each rule must define an `IngressBackend` that will receive the requests
that match this rule. If both `host` and `path` are not specifiec, this
backend will be used as the default backend of the ingress.

You can also add rules later using `addRule()`, `addHostRule()`,
`addDefaultBackend()` and `addHostDefaultBackend()`.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="cdk8s-plus-28.Ingress.Initializer.parameter.tls"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.IngressTls">IngressTls</a>]

TLS settings for this ingress.

Using this option tells the ingress controller to expose a TLS endpoint.
Currently the Ingress only supports a single TLS port, 443. If multiple
members of this list specify different hosts, they will be multiplexed on
the same port according to the hostname specified through the SNI TLS
extension, if the ingress controller fulfilling the ingress supports SNI.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Ingress.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Ingress.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Ingress.addDefaultBackend">add_default_backend</a></code> | Defines the default backend for this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.addHostDefaultBackend">add_host_default_backend</a></code> | Specify a default backend for a specific host name. |
| <code><a href="#cdk8s-plus-28.Ingress.addHostRule">add_host_rule</a></code> | Adds an ingress rule applied to requests to a specific host and a specific HTTP path (the `Host` header matches this value). |
| <code><a href="#cdk8s-plus-28.Ingress.addRule">add_rule</a></code> | Adds an ingress rule applied to requests sent to a specific HTTP path. |
| <code><a href="#cdk8s-plus-28.Ingress.addRules">add_rules</a></code> | Adds rules to this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.addTls">add_tls</a></code> | *No description.* |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Ingress.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Ingress.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Ingress.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_default_backend` <a name="add_default_backend" id="cdk8s-plus-28.Ingress.addDefaultBackend"></a>

```python
def add_default_backend(
  backend: IngressBackend
) -> None
```

Defines the default backend for this ingress.

A default backend capable of
servicing requests that don't match any rule.

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addDefaultBackend.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to use for requests that do not match any rule.

---

##### `add_host_default_backend` <a name="add_host_default_backend" id="cdk8s-plus-28.Ingress.addHostDefaultBackend"></a>

```python
def add_host_default_backend(
  host: str,
  backend: IngressBackend
) -> None
```

Specify a default backend for a specific host name.

This backend will be used as a catch-all for requests
targeted to this host name (the `Host` header matches this value).

###### `host`<sup>Required</sup> <a name="host" id="cdk8s-plus-28.Ingress.addHostDefaultBackend.parameter.host"></a>

- *Type:* str

The host name to match.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addHostDefaultBackend.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route to.

---

##### `add_host_rule` <a name="add_host_rule" id="cdk8s-plus-28.Ingress.addHostRule"></a>

```python
def add_host_rule(
  host: str,
  path: str,
  backend: IngressBackend,
  path_type: HttpIngressPathType = None
) -> None
```

Adds an ingress rule applied to requests to a specific host and a specific HTTP path (the `Host` header matches this value).

###### `host`<sup>Required</sup> <a name="host" id="cdk8s-plus-28.Ingress.addHostRule.parameter.host"></a>

- *Type:* str

The host name.

---

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Ingress.addHostRule.parameter.path"></a>

- *Type:* str

The HTTP path.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addHostRule.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route requests to.

---

###### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.Ingress.addHostRule.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

How the path is matched against request paths.

---

##### `add_rule` <a name="add_rule" id="cdk8s-plus-28.Ingress.addRule"></a>

```python
def add_rule(
  path: str,
  backend: IngressBackend,
  path_type: HttpIngressPathType = None
) -> None
```

Adds an ingress rule applied to requests sent to a specific HTTP path.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Ingress.addRule.parameter.path"></a>

- *Type:* str

The HTTP path.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addRule.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route requests to.

---

###### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.Ingress.addRule.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

How the path is matched against request paths.

---

##### `add_rules` <a name="add_rules" id="cdk8s-plus-28.Ingress.addRules"></a>

```python
def add_rules(
  backend: IngressBackend,
  host: str = None,
  path: str = None,
  path_type: HttpIngressPathType = None
) -> None
```

Adds rules to this ingress.

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addRules.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

Backend defines the referenced service endpoint to which the traffic will be forwarded to.

---

###### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.Ingress.addRules.parameter.host"></a>

- *Type:* str
- *Default:* If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.

Host is the fully qualified domain name of a network host, as defined by RFC 3986.

Note the following deviations from the "host" part of the URI as
defined in the RFC: 1. IPs are not allowed. Currently an IngressRuleValue
can only apply to the IP in the Spec of the parent Ingress. 2. The `:`
delimiter is not respected because ports are not allowed. Currently the
port of an Ingress is implicitly :80 for http and :443 for https. Both
these may change in the future. Incoming requests are matched against the
host before the IngressRuleValue.

---

###### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.Ingress.addRules.parameter.path"></a>

- *Type:* str
- *Default:* If unspecified, the path defaults to a catch all sending traffic to the backend.

Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/'.

---

###### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.Ingress.addRules.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

Specify how the path is matched against request paths.

By default, path
types will be matched by prefix.

> [https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types](https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types)

---

##### `add_tls` <a name="add_tls" id="cdk8s-plus-28.Ingress.addTls"></a>

```python
def add_tls(
  tls: typing.List[IngressTls]
) -> None
```

###### `tls`<sup>Required</sup> <a name="tls" id="cdk8s-plus-28.Ingress.addTls.parameter.tls"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.IngressTls">IngressTls</a>]

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Ingress.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Ingress.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Ingress.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Ingress.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Ingress.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Ingress.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Ingress.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Ingress.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Ingress.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Ingress.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Ingress.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Ingress.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Ingress.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Ingress.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Ingress.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### Job <a name="Job" id="cdk8s-plus-28.Job"></a>

A Job creates one or more Pods and ensures that a specified number of them successfully terminate.

As pods successfully complete,
the Job tracks the successful completions. When a specified number of successful completions is reached, the task (ie, Job) is complete.
Deleting a Job will clean up the Pods it created. A simple case is to create one Job object in order to reliably run one Pod to completion.
The Job object will start a new Pod if the first Pod fails or is deleted (for example due to a node hardware failure or a node reboot).
You can also use a Job to run multiple Pods in parallel.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Job.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Job(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  active_deadline: Duration = None,
  backoff_limit: typing.Union[int, float] = None,
  ttl_after_finished: Duration = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.activeDeadline">active_deadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.ttlAfterFinished">ttl_after_finished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Job.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Job.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Job.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Job.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.Job.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.Job.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Job.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.Job.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Job.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.Job.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.Job.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Job.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Job.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Job.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Job.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.Job.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.Job.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.Job.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.Job.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `active_deadline`<sup>Optional</sup> <a name="active_deadline" id="cdk8s-plus-28.Job.Initializer.parameter.activeDeadline"></a>

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.Job.Initializer.parameter.backoffLimit"></a>

- *Type:* typing.Union[int, float]
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttl_after_finished`<sup>Optional</sup> <a name="ttl_after_finished" id="cdk8s-plus-28.Job.Initializer.parameter.ttlAfterFinished"></a>

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Job.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Job.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Job.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Job.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Job.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Job.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Job.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Job.select">select</a></code> | Configure selectors for this workload. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Job.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Job.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Job.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.Job.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Job.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Job.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Job.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Job.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Job.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Job.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Job.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Job.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Job.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Job.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Job.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Job.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Job.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Job.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Job.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Job.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Job.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Job.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Job.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.Job.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.Job.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.Job.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.Job.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Job.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Job.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Job.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Job.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Job.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Job.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Job.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Job.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Job.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Job.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Job.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Job.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Job.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Job.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Job.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Job.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Job.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Job.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Job.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.Job.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Job.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.Job.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Job.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Job.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Job.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.Job.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.Job.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Job.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Job.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Job.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Job.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Job.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Job.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Job.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Job.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Job.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Job.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Job.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Job.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Job.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Job.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Job.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Job.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Job.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.activeDeadline">active_deadline</a></code> | <code>cdk8s.Duration</code> | Duration before job is terminated. |
| <code><a href="#cdk8s-plus-28.Job.property.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Number of retries before marking failed. |
| <code><a href="#cdk8s-plus-28.Job.property.ttlAfterFinished">ttl_after_finished</a></code> | <code>cdk8s.Duration</code> | TTL before the job is deleted after it is finished. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Job.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Job.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Job.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Job.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Job.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Job.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Job.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Job.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Job.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Job.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Job.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Job.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.Job.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.Job.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.Job.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.Job.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Job.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Job.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Job.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Job.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Job.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Job.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Job.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.Job.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.Job.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Job.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `active_deadline`<sup>Optional</sup> <a name="active_deadline" id="cdk8s-plus-28.Job.property.activeDeadline"></a>

```python
active_deadline: Duration
```

- *Type:* cdk8s.Duration

Duration before job is terminated.

If undefined, there is no deadline.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.Job.property.backoffLimit"></a>

```python
backoff_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of retries before marking failed.

---

##### `ttl_after_finished`<sup>Optional</sup> <a name="ttl_after_finished" id="cdk8s-plus-28.Job.property.ttlAfterFinished"></a>

```python
ttl_after_finished: Duration
```

- *Type:* cdk8s.Duration

TTL before the job is deleted after it is finished.

---


### KubeApiService <a name="KubeApiService" id="cdk8s-plus-28.k8s.KubeApiService"></a>

APIService represents a server for a particular GroupVersion.

Name must be "version.group".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeApiService.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiService(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ApiServiceSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ApiServiceSpec</code> | Spec contains information for locating and communicating with a server. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ApiServiceSpec

Spec contains information for locating and communicating with a server.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeApiService.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeApiService.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeApiService.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeApiService.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeApiService.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeApiService.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeApiService.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiService.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeApiService.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeApiService.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiService.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeApiService.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeApiService.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiService.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeApiService.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeApiService.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiService.manifest(
  metadata: ObjectMeta = None,
  spec: ApiServiceSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiService.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeApiService.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ApiServiceSpec

Spec contains information for locating and communicating with a server.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeApiService.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeApiService.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeApiService.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeApiService.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeApiService.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiService.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeApiService.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeApiService.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService".

---

### KubeApiServiceList <a name="KubeApiServiceList" id="cdk8s-plus-28.k8s.KubeApiServiceList"></a>

APIServiceList is a list of APIService objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceList(
  scope: Construct,
  id: str,
  items: typing.List[KubeApiServiceProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeApiServiceProps]</code> | Items is the list of APIService. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeApiServiceProps]

Items is the list of APIService.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeApiServiceList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeApiServiceList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeApiServiceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeApiServiceList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeApiServiceList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeApiServiceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeApiServiceList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceList.manifest(
  items: typing.List[KubeApiServiceProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeApiServiceList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeApiServiceProps]

Items is the list of APIService.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList".

---

### KubeBinding <a name="KubeBinding" id="cdk8s-plus-28.k8s.KubeBinding"></a>

Binding ties one object to another;

for example, a pod is bound to a node by a scheduler. Deprecated in 1.7, please use the bindings subresource of pods instead.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeBinding.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBinding(
  scope: Construct,
  id: str,
  target: ObjectReference,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.target">target</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | The target object that you want to bind to the standard object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.target"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

The target object that you want to bind to the standard object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeBinding.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeBinding.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeBinding.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeBinding.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Binding". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeBinding.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBinding.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeBinding.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeBinding.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBinding.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeBinding.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeBinding.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBinding.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeBinding.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBinding.manifest(
  target: ObjectReference,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Binding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.KubeBinding.manifest.parameter.target"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

The target object that you want to bind to the standard object.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBinding.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeBinding.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeBinding.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeBinding.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeBinding.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeBinding.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBinding.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeBinding.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Binding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeBinding.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Binding".

---

### KubeCertificateSigningRequest <a name="KubeCertificateSigningRequest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest"></a>

CertificateSigningRequest objects provide a mechanism to obtain x509 certificates by submitting a certificate signing request, and having it asynchronously approved and issued.

Kubelets use this API to obtain:

1. client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client-kubelet" signerName).
2. serving certificates for TLS endpoints kube-apiserver can connect to securely (with the "kubernetes.io/kubelet-serving" signerName).

This API can be used to request client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client" signerName), or to obtain certificates from custom non-Kubernetes signers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequest(
  scope: Construct,
  id: str,
  spec: CertificateSigningRequestSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CertificateSigningRequestSpec</code> | spec contains the certificate request, and is immutable after creation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CertificateSigningRequestSpec

spec contains the certificate request, and is immutable after creation.

Only the request, signerName, expirationSeconds, and usages fields can be set on creation. Other fields are derived by Kubernetes and cannot be modified by users.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequest". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequest.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequest.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequest.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequest.manifest(
  spec: CertificateSigningRequestSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequest".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CertificateSigningRequestSpec

spec contains the certificate request, and is immutable after creation.

Only the request, signerName, expirationSeconds, and usages fields can be set on creation. Other fields are derived by Kubernetes and cannot be modified by users.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequest". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequest".

---

### KubeCertificateSigningRequestList <a name="KubeCertificateSigningRequestList" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList"></a>

CertificateSigningRequestList is a collection of CertificateSigningRequest objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCertificateSigningRequestProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCertificateSigningRequestProps]</code> | items is a collection of CertificateSigningRequest objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCertificateSigningRequestProps]

items is a collection of CertificateSigningRequest objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequestList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestList.manifest(
  items: typing.List[KubeCertificateSigningRequestProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequestList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCertificateSigningRequestProps]

items is a collection of CertificateSigningRequest objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequestList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequestList".

---

### KubeClusterCidrListV1Alpha1 <a name="KubeClusterCidrListV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1"></a>

ClusterCIDRList contains a list of ClusterCIDR.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeClusterCidrv1Alpha1Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterCidrv1Alpha1Props]</code> | items is the list of ClusterCIDRs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterCidrv1Alpha1Props]

items is the list of ClusterCIDRs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDRList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1.manifest(
  items: typing.List[KubeClusterCidrv1Alpha1Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDRList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterCidrv1Alpha1Props]

items is the list of ClusterCIDRs.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDRList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDRList".

---

### KubeClusterCidrv1Alpha1 <a name="KubeClusterCidrv1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1"></a>

ClusterCIDR represents a single configuration for per-Node Pod CIDR allocations when the MultiCIDRRangeAllocator is enabled (see the config for kube-controller-manager).

A cluster may have any number of ClusterCIDR resources, all of which will be considered when allocating a CIDR for a Node.  A ClusterCIDR is eligible to be used for a given Node when the node selector matches the node in question and has free CIDRs to allocate.  In case of multiple matching ClusterCIDR resources, the allocator will attempt to break ties using internal heuristics, but any ClusterCIDR whose node selector matches the Node may be used.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ClusterCidrSpecV1Alpha1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ClusterCidrSpecV1Alpha1</code> | spec is the desired state of the ClusterCIDR. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ClusterCidrSpecV1Alpha1

spec is the desired state of the ClusterCIDR.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDR". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1.manifest(
  metadata: ObjectMeta = None,
  spec: ClusterCidrSpecV1Alpha1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDR".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ClusterCidrSpecV1Alpha1

spec is the desired state of the ClusterCIDR.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDR". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDR".

---

### KubeClusterRole <a name="KubeClusterRole" id="cdk8s-plus-28.k8s.KubeClusterRole"></a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRole(
  scope: Construct,
  id: str,
  aggregation_rule: AggregationRule = None,
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.aggregationRule">aggregation_rule</a></code> | <code>cdk8s_plus_28.k8s.AggregationRule</code> | AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRule]</code> | Rules holds all the PolicyRules for this ClusterRole. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `aggregation_rule`<sup>Optional</sup> <a name="aggregation_rule" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.aggregationRule"></a>

- *Type:* cdk8s_plus_28.k8s.AggregationRule

AggregationRule is an optional field that describes how to build the Rules for this ClusterRole.

If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.rules"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this ClusterRole.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterRole.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterRole.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRole.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterRole.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRole". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterRole.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRole.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRole.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterRole.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRole.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRole.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRole.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRole.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRole.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRole.manifest(
  aggregation_rule: AggregationRule = None,
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRole".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `aggregation_rule`<sup>Optional</sup> <a name="aggregation_rule" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest.parameter.aggregationRule"></a>

- *Type:* cdk8s_plus_28.k8s.AggregationRule

AggregationRule is an optional field that describes how to build the Rules for this ClusterRole.

If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

###### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest.parameter.rules"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this ClusterRole.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRole.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterRole.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterRole.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRole.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRole.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRole.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRole.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRole". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRole.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRole".

---

### KubeClusterRoleBinding <a name="KubeClusterRoleBinding" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding"></a>

ClusterRoleBinding references a ClusterRole, but not contain it.

It can reference a ClusterRole in the global namespace, and adds who information via Subject.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBinding(
  scope: Construct,
  id: str,
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.roleRef">role_ref</a></code> | <code>cdk8s_plus_28.k8s.RoleRef</code> | RoleRef can only reference a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Subject]</code> | Subjects holds references to the objects the role applies to. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.roleRef"></a>

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can only reference a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.subjects"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBinding". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBinding.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBinding.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBinding.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBinding.manifest(
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest.parameter.roleRef"></a>

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can only reference a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

###### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest.parameter.subjects"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBinding".

---

### KubeClusterRoleBindingList <a name="KubeClusterRoleBindingList" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList"></a>

ClusterRoleBindingList is a collection of ClusterRoleBindings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingList(
  scope: Construct,
  id: str,
  items: typing.List[KubeClusterRoleBindingProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterRoleBindingProps]</code> | Items is a list of ClusterRoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleBindingProps]

Items is a list of ClusterRoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBindingList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingList.manifest(
  items: typing.List[KubeClusterRoleBindingProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleBindingProps]

Items is a list of ClusterRoleBindings.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBindingList".

---

### KubeClusterRoleList <a name="KubeClusterRoleList" id="cdk8s-plus-28.k8s.KubeClusterRoleList"></a>

ClusterRoleList is a collection of ClusterRoles.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleList(
  scope: Construct,
  id: str,
  items: typing.List[KubeClusterRoleProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterRoleProps]</code> | Items is a list of ClusterRoles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleProps]

Items is a list of ClusterRoles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterRoleList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterRoleList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleList.manifest(
  items: typing.List[KubeClusterRoleProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleProps]

Items is a list of ClusterRoles.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleList".

---

### KubeClusterTrustBundleListV1Alpha1 <a name="KubeClusterTrustBundleListV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1"></a>

ClusterTrustBundleList is a collection of ClusterTrustBundle objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeClusterTrustBundleV1Alpha1Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterTrustBundleV1Alpha1Props]</code> | items is a collection of ClusterTrustBundle objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | metadata contains the list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterTrustBundleV1Alpha1Props]

items is a collection of ClusterTrustBundle objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata contains the list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1.manifest(
  items: typing.List[KubeClusterTrustBundleV1Alpha1Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterTrustBundleV1Alpha1Props]

items is a collection of ClusterTrustBundle objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata contains the list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList".

---

### KubeClusterTrustBundleV1Alpha1 <a name="KubeClusterTrustBundleV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1"></a>

ClusterTrustBundle is a cluster-scoped container for X.509 trust anchors (root certificates).

ClusterTrustBundle objects are considered to be readable by any authenticated user in the cluster, because they can be mounted by pods using the `clusterTrustBundle` projection.  All service accounts have read access to ClusterTrustBundles by default.  Users who only have namespace-level access to a cluster can read ClusterTrustBundles by impersonating a serviceaccount that they have access to.

It can be optionally associated with a particular assigner, in which case it contains one valid set of trust anchors for that signer. Signers may have multiple associated ClusterTrustBundles; each is an independent set of trust anchors for that signer. Admission control is used to enforce that only users with permissions on the signer can create or modify the corresponding bundle.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1(
  scope: Construct,
  id: str,
  spec: ClusterTrustBundleSpecV1Alpha1,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ClusterTrustBundleSpecV1Alpha1</code> | spec contains the signer (if any) and trust anchors. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | metadata contains the object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ClusterTrustBundleSpecV1Alpha1

spec contains the signer (if any) and trust anchors.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata contains the object metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1.manifest(
  spec: ClusterTrustBundleSpecV1Alpha1,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ClusterTrustBundleSpecV1Alpha1

spec contains the signer (if any) and trust anchors.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata contains the object metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle".

---

### KubeComponentStatus <a name="KubeComponentStatus" id="cdk8s-plus-28.k8s.KubeComponentStatus"></a>

ComponentStatus (and ComponentStatusList) holds the cluster validation info.

Deprecated: This API is deprecated in v1.19+

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatus(
  scope: Construct,
  id: str,
  conditions: typing.List[ComponentCondition] = None,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.conditions">conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ComponentCondition]</code> | List of component conditions observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.conditions"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ComponentCondition]

List of component conditions observed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeComponentStatus.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeComponentStatus.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeComponentStatus.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeComponentStatus.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatus". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatus.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatus.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeComponentStatus.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatus.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeComponentStatus.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeComponentStatus.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatus.manifest(
  conditions: typing.List[ComponentCondition] = None,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatus".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.KubeComponentStatus.manifest.parameter.conditions"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ComponentCondition]

List of component conditions observed.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatus.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatus". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatus".

---

### KubeComponentStatusList <a name="KubeComponentStatusList" id="cdk8s-plus-28.k8s.KubeComponentStatusList"></a>

Status of all the conditions for the component as a list of ComponentStatus objects.

Deprecated: This API is deprecated in v1.19+

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusList(
  scope: Construct,
  id: str,
  items: typing.List[KubeComponentStatusProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeComponentStatusProps]</code> | List of ComponentStatus objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeComponentStatusProps]

List of ComponentStatus objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeComponentStatusList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeComponentStatusList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatusList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeComponentStatusList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeComponentStatusList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeComponentStatusList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusList.manifest(
  items: typing.List[KubeComponentStatusProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatusList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeComponentStatusList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeComponentStatusProps]

List of ComponentStatus objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatusList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatusList".

---

### KubeConfigMap <a name="KubeConfigMap" id="cdk8s-plus-28.k8s.KubeConfigMap"></a>

ConfigMap holds configuration data for pods to consume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMap(
  scope: Construct,
  id: str,
  binary_data: typing.Mapping[str] = None,
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.binaryData">binary_data</a></code> | <code>typing.Mapping[str]</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `binary_data`<sup>Optional</sup> <a name="binary_data" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.binaryData"></a>

- *Type:* typing.Mapping[str]

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.data"></a>

- *Type:* typing.Mapping[str]

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.immutable"></a>

- *Type:* bool

Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeConfigMap.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeConfigMap.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeConfigMap.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeConfigMap.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMap". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeConfigMap.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMap.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeConfigMap.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeConfigMap.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMap.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeConfigMap.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeConfigMap.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMap.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeConfigMap.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMap.manifest(
  binary_data: typing.Mapping[str] = None,
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMap".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `binary_data`<sup>Optional</sup> <a name="binary_data" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest.parameter.binaryData"></a>

- *Type:* typing.Mapping[str]

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.

---

###### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest.parameter.data"></a>

- *Type:* typing.Mapping[str]

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.

---

###### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest.parameter.immutable"></a>

- *Type:* bool

Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeConfigMap.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeConfigMap.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeConfigMap.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeConfigMap.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeConfigMap.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMap.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeConfigMap.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMap". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeConfigMap.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMap".

---

### KubeConfigMapList <a name="KubeConfigMapList" id="cdk8s-plus-28.k8s.KubeConfigMapList"></a>

ConfigMapList is a resource containing a list of ConfigMap objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapList(
  scope: Construct,
  id: str,
  items: typing.List[KubeConfigMapProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeConfigMapProps]</code> | Items is the list of ConfigMaps. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeConfigMapProps]

Items is the list of ConfigMaps.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeConfigMapList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeConfigMapList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeConfigMapList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeConfigMapList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMapList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeConfigMapList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeConfigMapList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeConfigMapList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapList.manifest(
  items: typing.List[KubeConfigMapProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMapList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeConfigMapList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeConfigMapProps]

Items is the list of ConfigMaps.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMapList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMapList".

---

### KubeControllerRevision <a name="KubeControllerRevision" id="cdk8s-plus-28.k8s.KubeControllerRevision"></a>

ControllerRevision implements an immutable snapshot of state data.

Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevision(
  scope: Construct,
  id: str,
  revision: typing.Union[int, float],
  data: typing.Any = None,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.revision">revision</a></code> | <code>typing.Union[int, float]</code> | Revision indicates the revision of the state represented by Data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.data">data</a></code> | <code>typing.Any</code> | Data is the serialized representation of the state. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `revision`<sup>Required</sup> <a name="revision" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.revision"></a>

- *Type:* typing.Union[int, float]

Revision indicates the revision of the state represented by Data.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.data"></a>

- *Type:* typing.Any

Data is the serialized representation of the state.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeControllerRevision.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeControllerRevision.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeControllerRevision.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeControllerRevision.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevision". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevision.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevision.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeControllerRevision.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevision.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeControllerRevision.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevision.manifest(
  revision: typing.Union[int, float],
  data: typing.Any = None,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevision".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `revision`<sup>Required</sup> <a name="revision" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest.parameter.revision"></a>

- *Type:* typing.Union[int, float]

Revision indicates the revision of the state represented by Data.

---

###### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest.parameter.data"></a>

- *Type:* typing.Any

Data is the serialized representation of the state.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevision". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevision".

---

### KubeControllerRevisionList <a name="KubeControllerRevisionList" id="cdk8s-plus-28.k8s.KubeControllerRevisionList"></a>

ControllerRevisionList is a resource containing a list of ControllerRevision objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionList(
  scope: Construct,
  id: str,
  items: typing.List[KubeControllerRevisionProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeControllerRevisionProps]</code> | Items is the list of ControllerRevisions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeControllerRevisionProps]

Items is the list of ControllerRevisions.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevisionList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionList.manifest(
  items: typing.List[KubeControllerRevisionProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevisionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeControllerRevisionProps]

Items is the list of ControllerRevisions.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevisionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevisionList".

---

### KubeCronJob <a name="KubeCronJob" id="cdk8s-plus-28.k8s.KubeCronJob"></a>

CronJob represents the configuration of a single cron job.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJob(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: CronJobSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CronJobSpec</code> | Specification of the desired behavior of a cron job, including the schedule. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CronJobSpec

Specification of the desired behavior of a cron job, including the schedule.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCronJob.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCronJob.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCronJob.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCronJob.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJob". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCronJob.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJob.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCronJob.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCronJob.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJob.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCronJob.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCronJob.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJob.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCronJob.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCronJob.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJob.manifest(
  metadata: ObjectMeta = None,
  spec: CronJobSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJob".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJob.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCronJob.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CronJobSpec

Specification of the desired behavior of a cron job, including the schedule.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCronJob.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCronJob.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCronJob.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCronJob.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCronJob.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJob.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCronJob.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJob". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCronJob.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJob".

---

### KubeCronJobList <a name="KubeCronJobList" id="cdk8s-plus-28.k8s.KubeCronJobList"></a>

CronJobList is a collection of cron jobs.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCronJobProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCronJobProps]</code> | items is the list of CronJobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCronJobProps]

items is the list of CronJobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCronJobList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCronJobList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCronJobList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCronJobList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJobList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCronJobList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCronJobList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCronJobList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCronJobList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCronJobList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCronJobList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCronJobList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobList.manifest(
  items: typing.List[KubeCronJobProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJobList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCronJobList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCronJobProps]

items is the list of CronJobs.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCronJobList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCronJobList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCronJobList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCronJobList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCronJobList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCronJobList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJobList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCronJobList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJobList".

---

### KubeCsiDriver <a name="KubeCsiDriver" id="cdk8s-plus-28.k8s.KubeCsiDriver"></a>

CSIDriver captures information about a Container Storage Interface (CSI) volume driver deployed on the cluster.

Kubernetes attach detach controller uses this object to determine whether attach is required. Kubelet uses this object to determine whether pod information needs to be passed on mount. CSIDriver objects are non-namespaced.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriver(
  scope: Construct,
  id: str,
  spec: CsiDriverSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CsiDriverSpec</code> | spec represents the specification of the CSI Driver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CsiDriverSpec

spec represents the specification of the CSI Driver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

metadata.Name indicates the name of the CSI driver that this object refers to; it MUST be the same name returned by the CSI GetPluginName() call for that driver. The driver name must be 63 characters or less, beginning and ending with an alphanumeric character ([a-z0-9A-Z]) with dashes (-), dots (.), and alphanumerics between. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiDriver.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiDriver.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiDriver.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiDriver.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriver". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriver.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriver.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiDriver.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriver.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiDriver.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiDriver.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriver.manifest(
  spec: CsiDriverSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriver".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiDriver.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CsiDriverSpec

spec represents the specification of the CSI Driver.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriver.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

metadata.Name indicates the name of the CSI driver that this object refers to; it MUST be the same name returned by the CSI GetPluginName() call for that driver. The driver name must be 63 characters or less, beginning and ending with an alphanumeric character ([a-z0-9A-Z]) with dashes (-), dots (.), and alphanumerics between. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriver". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriver".

---

### KubeCsiDriverList <a name="KubeCsiDriverList" id="cdk8s-plus-28.k8s.KubeCsiDriverList"></a>

CSIDriverList is a collection of CSIDriver objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCsiDriverProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiDriverProps]</code> | items is the list of CSIDriver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiDriverProps]

items is the list of CSIDriver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiDriverList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiDriverList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriverList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiDriverList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiDriverList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiDriverList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverList.manifest(
  items: typing.List[KubeCsiDriverProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriverList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiDriverList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiDriverProps]

items is the list of CSIDriver.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriverList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriverList".

---

### KubeCsiNode <a name="KubeCsiNode" id="cdk8s-plus-28.k8s.KubeCsiNode"></a>

CSINode holds information about all CSI drivers installed on a node.

CSI drivers do not need to create the CSINode object directly. As long as they use the node-driver-registrar sidecar container, the kubelet will automatically populate the CSINode object for the CSI driver as part of kubelet plugin registration. CSINode has the same name as a node. If the object is missing, it means either there are no CSI Drivers available on the node, or the Kubelet version is low enough that it doesn't create this object. CSINode has an OwnerReference that points to the corresponding node object.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNode(
  scope: Construct,
  id: str,
  spec: CsiNodeSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CsiNodeSpec</code> | spec is the specification of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CsiNodeSpec

spec is the specification of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

metadata.name must be the Kubernetes node name.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiNode.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiNode.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiNode.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiNode.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINode". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiNode.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNode.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiNode.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiNode.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNode.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiNode.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiNode.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNode.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiNode.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiNode.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNode.manifest(
  spec: CsiNodeSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINode".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiNode.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CsiNodeSpec

spec is the specification of CSINode.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNode.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

metadata.name must be the Kubernetes node name.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiNode.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiNode.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiNode.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiNode.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiNode.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNode.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiNode.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINode". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiNode.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINode".

---

### KubeCsiNodeList <a name="KubeCsiNodeList" id="cdk8s-plus-28.k8s.KubeCsiNodeList"></a>

CSINodeList is a collection of CSINode objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCsiNodeProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiNodeProps]</code> | items is the list of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiNodeProps]

items is the list of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiNodeList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiNodeList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINodeList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiNodeList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiNodeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiNodeList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeList.manifest(
  items: typing.List[KubeCsiNodeProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINodeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiNodeList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiNodeProps]

items is the list of CSINode.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINodeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINodeList".

---

### KubeCsiStorageCapacity <a name="KubeCsiStorageCapacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity"></a>

CSIStorageCapacity stores the result of one CSI GetCapacity call.

For a given StorageClass, this describes the available capacity in a particular topology segment.  This can be used when considering where to instantiate new PersistentVolumes.

For example this can express things like: - StorageClass "standard" has "1234 GiB" available in "topology.kubernetes.io/zone=us-east1" - StorageClass "localssd" has "10 GiB" available in "kubernetes.io/hostname=knode-abc123"

The following three cases all imply that no capacity is available for a certain combination: - no object exists with suitable topology and storage class name - such an object exists, but the capacity is unset - such an object exists, but the capacity is zero

The producer of these objects can decide which approach is more suitable.

They are consumed by the kube-scheduler when a CSI driver opts into capacity-aware scheduling with CSIDriverSpec.StorageCapacity. The scheduler compares the MaximumVolumeSize against the requested size of pending volumes to filter out unsuitable nodes. If MaximumVolumeSize is unset, it falls back to a comparison against the less precise Capacity. If that is also unset, the scheduler assumes that capacity is insufficient and tries some other node.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacity(
  scope: Construct,
  id: str,
  storage_class_name: str,
  capacity: Quantity = None,
  maximum_volume_size: Quantity = None,
  metadata: ObjectMeta = None,
  node_topology: LabelSelector = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | storageClassName represents the name of the StorageClass that the reported capacity applies to. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.capacity">capacity</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.maximumVolumeSize">maximum_volume_size</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.nodeTopology">node_topology</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | nodeTopology defines which nodes have access to the storage for which capacity was reported. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `storage_class_name`<sup>Required</sup> <a name="storage_class_name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.storageClassName"></a>

- *Type:* str

storageClassName represents the name of the StorageClass that the reported capacity applies to.

It must meet the same requirements as the name of a StorageClass object (non-empty, DNS subdomain). If that object no longer exists, the CSIStorageCapacity object is obsolete and should be removed by its creator. This field is immutable.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.capacity"></a>

- *Type:* cdk8s_plus_28.k8s.Quantity

capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

The semantic is currently (CSI spec 1.2) defined as: The available capacity, in bytes, of the storage that can be used to provision volumes. If not set, that information is currently unavailable.

---

##### `maximum_volume_size`<sup>Optional</sup> <a name="maximum_volume_size" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.maximumVolumeSize"></a>

- *Type:* cdk8s_plus_28.k8s.Quantity

maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

This is defined since CSI spec 1.4.0 as the largest size that may be used in a CreateVolumeRequest.capacity_range.required_bytes field to create a volume with the same parameters as those in GetCapacityRequest. The corresponding value in the Kubernetes API is ResourceRequirements.Requests in a volume claim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

The name has no particular meaning. It must be a DNS subdomain (dots allowed, 253 characters). To ensure that there are no conflicts with other CSI drivers on the cluster, the recommendation is to use csisc-<uuid>, a generated name, or a reverse-domain name which ends with the unique CSI driver name.

Objects are namespaced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `node_topology`<sup>Optional</sup> <a name="node_topology" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.nodeTopology"></a>

- *Type:* cdk8s_plus_28.k8s.LabelSelector

nodeTopology defines which nodes have access to the storage for which capacity was reported.

If not set, the storage is not accessible from any node in the cluster. If empty, the storage is accessible from all nodes. This field is immutable.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacity". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacity.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacity.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacity.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacity.manifest(
  storage_class_name: str,
  capacity: Quantity = None,
  maximum_volume_size: Quantity = None,
  metadata: ObjectMeta = None,
  node_topology: LabelSelector = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacity".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `storage_class_name`<sup>Required</sup> <a name="storage_class_name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.storageClassName"></a>

- *Type:* str

storageClassName represents the name of the StorageClass that the reported capacity applies to.

It must meet the same requirements as the name of a StorageClass object (non-empty, DNS subdomain). If that object no longer exists, the CSIStorageCapacity object is obsolete and should be removed by its creator. This field is immutable.

---

###### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.capacity"></a>

- *Type:* cdk8s_plus_28.k8s.Quantity

capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

The semantic is currently (CSI spec 1.2) defined as: The available capacity, in bytes, of the storage that can be used to provision volumes. If not set, that information is currently unavailable.

---

###### `maximum_volume_size`<sup>Optional</sup> <a name="maximum_volume_size" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.maximumVolumeSize"></a>

- *Type:* cdk8s_plus_28.k8s.Quantity

maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

This is defined since CSI spec 1.4.0 as the largest size that may be used in a CreateVolumeRequest.capacity_range.required_bytes field to create a volume with the same parameters as those in GetCapacityRequest. The corresponding value in the Kubernetes API is ResourceRequirements.Requests in a volume claim.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

The name has no particular meaning. It must be a DNS subdomain (dots allowed, 253 characters). To ensure that there are no conflicts with other CSI drivers on the cluster, the recommendation is to use csisc-<uuid>, a generated name, or a reverse-domain name which ends with the unique CSI driver name.

Objects are namespaced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `node_topology`<sup>Optional</sup> <a name="node_topology" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.nodeTopology"></a>

- *Type:* cdk8s_plus_28.k8s.LabelSelector

nodeTopology defines which nodes have access to the storage for which capacity was reported.

If not set, the storage is not accessible from any node in the cluster. If empty, the storage is accessible from all nodes. This field is immutable.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacity". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacity".

---

### KubeCsiStorageCapacityList <a name="KubeCsiStorageCapacityList" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList"></a>

CSIStorageCapacityList is a collection of CSIStorageCapacity objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCsiStorageCapacityProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiStorageCapacityProps]</code> | items is the list of CSIStorageCapacity objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiStorageCapacityProps]

items is the list of CSIStorageCapacity objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacityList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityList.manifest(
  items: typing.List[KubeCsiStorageCapacityProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacityList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiStorageCapacityProps]

items is the list of CSIStorageCapacity objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacityList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacityList".

---

### KubeCustomResourceDefinition <a name="KubeCustomResourceDefinition" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition"></a>

CustomResourceDefinition represents a resource that should be exposed on the API server.

Its name MUST be in the format <.spec.name>.<.spec.group>.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinition(
  scope: Construct,
  id: str,
  spec: CustomResourceDefinitionSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceDefinitionSpec</code> | spec describes how the user wants the resources to appear. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CustomResourceDefinitionSpec

spec describes how the user wants the resources to appear.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinition.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinition.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinition.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinition.manifest(
  spec: CustomResourceDefinitionSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.CustomResourceDefinitionSpec

spec describes how the user wants the resources to appear.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition".

---

### KubeCustomResourceDefinitionList <a name="KubeCustomResourceDefinitionList" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList"></a>

CustomResourceDefinitionList is a list of CustomResourceDefinition objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionList(
  scope: Construct,
  id: str,
  items: typing.List[KubeCustomResourceDefinitionProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCustomResourceDefinitionProps]</code> | items list individual CustomResourceDefinition objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCustomResourceDefinitionProps]

items list individual CustomResourceDefinition objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionList.manifest(
  items: typing.List[KubeCustomResourceDefinitionProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCustomResourceDefinitionProps]

items list individual CustomResourceDefinition objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList".

---

### KubeDaemonSet <a name="KubeDaemonSet" id="cdk8s-plus-28.k8s.KubeDaemonSet"></a>

DaemonSet represents the configuration of a daemon set.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSet(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: DaemonSetSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.DaemonSetSpec</code> | The desired behavior of this daemon set. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.DaemonSetSpec

The desired behavior of this daemon set.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeDaemonSet.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeDaemonSet.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDaemonSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeDaemonSet.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSet". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSet.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSet.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDaemonSet.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSet.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDaemonSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDaemonSet.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSet.manifest(
  metadata: ObjectMeta = None,
  spec: DaemonSetSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSet.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDaemonSet.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.DaemonSetSpec

The desired behavior of this daemon set.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSet".

---

### KubeDaemonSetList <a name="KubeDaemonSetList" id="cdk8s-plus-28.k8s.KubeDaemonSetList"></a>

DaemonSetList is a collection of daemon sets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetList(
  scope: Construct,
  id: str,
  items: typing.List[KubeDaemonSetProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeDaemonSetProps]</code> | A list of daemon sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDaemonSetProps]

A list of daemon sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeDaemonSetList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeDaemonSetList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSetList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDaemonSetList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDaemonSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDaemonSetList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetList.manifest(
  items: typing.List[KubeDaemonSetProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDaemonSetList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDaemonSetProps]

A list of daemon sets.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSetList".

---

### KubeDeployment <a name="KubeDeployment" id="cdk8s-plus-28.k8s.KubeDeployment"></a>

Deployment enables declarative updates for Pods and ReplicaSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeployment(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: DeploymentSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.DeploymentSpec</code> | Specification of the desired behavior of the Deployment. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.DeploymentSpec

Specification of the desired behavior of the Deployment.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeDeployment.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeDeployment.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDeployment.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeDeployment.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.Deployment". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeDeployment.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeployment.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDeployment.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeDeployment.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeployment.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDeployment.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDeployment.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeployment.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDeployment.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDeployment.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeployment.manifest(
  metadata: ObjectMeta = None,
  spec: DeploymentSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.Deployment".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeployment.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDeployment.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.DeploymentSpec

Specification of the desired behavior of the Deployment.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDeployment.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeDeployment.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeDeployment.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDeployment.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDeployment.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeployment.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDeployment.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.Deployment". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDeployment.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.Deployment".

---

### KubeDeploymentList <a name="KubeDeploymentList" id="cdk8s-plus-28.k8s.KubeDeploymentList"></a>

DeploymentList is a list of Deployments.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentList(
  scope: Construct,
  id: str,
  items: typing.List[KubeDeploymentProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeDeploymentProps]</code> | Items is the list of Deployments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDeploymentProps]

Items is the list of Deployments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeDeploymentList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeDeploymentList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDeploymentList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeDeploymentList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DeploymentList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDeploymentList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDeploymentList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDeploymentList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentList.manifest(
  items: typing.List[KubeDeploymentProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DeploymentList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDeploymentList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDeploymentProps]

Items is the list of Deployments.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DeploymentList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DeploymentList".

---

### KubeEndpoints <a name="KubeEndpoints" id="cdk8s-plus-28.k8s.KubeEndpoints"></a>

Endpoints is a collection of endpoints that implement the actual service. Example:.

Name: "mysvc",
Subsets: [
{
Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
Ports: [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
},
{
Addresses: [{"ip": "10.10.3.3"}],
Ports: [{"name": "a", "port": 93}, {"name": "b", "port": 76}]
},
]

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpoints(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  subsets: typing.List[EndpointSubset] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.subsets">subsets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointSubset]</code> | The set of all endpoints is the union of all subsets. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `subsets`<sup>Optional</sup> <a name="subsets" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.subsets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointSubset]

The set of all endpoints is the union of all subsets.

Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEndpoints.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEndpoints.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpoints.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEndpoints.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Endpoints". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEndpoints.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpoints.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpoints.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEndpoints.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpoints.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpoints.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpoints.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpoints.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpoints.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpoints.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpoints.manifest(
  metadata: ObjectMeta = None,
  subsets: typing.List[EndpointSubset] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Endpoints".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpoints.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `subsets`<sup>Optional</sup> <a name="subsets" id="cdk8s-plus-28.k8s.KubeEndpoints.manifest.parameter.subsets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointSubset]

The set of all endpoints is the union of all subsets.

Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpoints.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEndpoints.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEndpoints.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpoints.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpoints.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpoints.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpoints.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Endpoints". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpoints.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Endpoints".

---

### KubeEndpointSlice <a name="KubeEndpointSlice" id="cdk8s-plus-28.k8s.KubeEndpointSlice"></a>

EndpointSlice represents a subset of the endpoints that implement a service.

For a given service there may be multiple EndpointSlice objects, selected by labels, which must be joined to produce the full set of endpoints.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSlice(
  scope: Construct,
  id: str,
  address_type: str,
  endpoints: typing.List[Endpoint],
  metadata: ObjectMeta = None,
  ports: typing.List[EndpointPort] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.addressType">address_type</a></code> | <code>str</code> | addressType specifies the type of address carried by this EndpointSlice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.endpoints">endpoints</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Endpoint]</code> | endpoints is a list of unique endpoints in this slice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointPort]</code> | ports specifies the list of network ports exposed by each endpoint in this slice. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `address_type`<sup>Required</sup> <a name="address_type" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.addressType"></a>

- *Type:* str

addressType specifies the type of address carried by this EndpointSlice.

All addresses in this slice must be the same type. This field is immutable after creation. The following address types are currently supported: * IPv4: Represents an IPv4 Address. * IPv6: Represents an IPv6 Address. * FQDN: Represents a Fully Qualified Domain Name.

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.endpoints"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Endpoint]

endpoints is a list of unique endpoints in this slice.

Each slice may include a maximum of 1000 endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.ports"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointPort]

ports specifies the list of network ports exposed by each endpoint in this slice.

Each port must have a unique name. When ports is empty, it indicates that there are no defined ports. When a port is defined with a nil port value, it indicates "all ports". Each slice may include a maximum of 100 ports.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEndpointSlice.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEndpointSlice.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSlice". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSlice.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSlice.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointSlice.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSlice.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointSlice.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSlice.manifest(
  address_type: str,
  endpoints: typing.List[Endpoint],
  metadata: ObjectMeta = None,
  ports: typing.List[EndpointPort] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSlice".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `address_type`<sup>Required</sup> <a name="address_type" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest.parameter.addressType"></a>

- *Type:* str

addressType specifies the type of address carried by this EndpointSlice.

All addresses in this slice must be the same type. This field is immutable after creation. The following address types are currently supported: * IPv4: Represents an IPv4 Address. * IPv6: Represents an IPv6 Address. * FQDN: Represents a Fully Qualified Domain Name.

---

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest.parameter.endpoints"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Endpoint]

endpoints is a list of unique endpoints in this slice.

Each slice may include a maximum of 1000 endpoints.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest.parameter.ports"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointPort]

ports specifies the list of network ports exposed by each endpoint in this slice.

Each port must have a unique name. When ports is empty, it indicates that there are no defined ports. When a port is defined with a nil port value, it indicates "all ports". Each slice may include a maximum of 100 ports.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSlice". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSlice".

---

### KubeEndpointSliceList <a name="KubeEndpointSliceList" id="cdk8s-plus-28.k8s.KubeEndpointSliceList"></a>

EndpointSliceList represents a list of endpoint slices.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceList(
  scope: Construct,
  id: str,
  items: typing.List[KubeEndpointSliceProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEndpointSliceProps]</code> | items is the list of endpoint slices. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointSliceProps]

items is the list of endpoint slices.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSliceList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceList.manifest(
  items: typing.List[KubeEndpointSliceProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSliceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointSliceProps]

items is the list of endpoint slices.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSliceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSliceList".

---

### KubeEndpointsList <a name="KubeEndpointsList" id="cdk8s-plus-28.k8s.KubeEndpointsList"></a>

EndpointsList is a list of endpoints.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsList(
  scope: Construct,
  id: str,
  items: typing.List[KubeEndpointsProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEndpointsProps]</code> | List of endpoints. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointsProps]

List of endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEndpointsList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEndpointsList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointsList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEndpointsList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.EndpointsList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointsList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointsList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointsList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsList.manifest(
  items: typing.List[KubeEndpointsProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.EndpointsList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointsList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointsProps]

List of endpoints.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.EndpointsList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.EndpointsList".

---

### KubeEvent <a name="KubeEvent" id="cdk8s-plus-28.k8s.KubeEvent"></a>

Event is a report of an event somewhere in the cluster.

It generally denotes some state change in the system. Events have a limited retention time and triggers and messages may evolve with time.  Event consumers should not rely on the timing of an event with a given Reason reflecting a consistent underlying trigger, or the continued existence of events with that Reason.  Events should be treated as informative, best-effort, supplemental data.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEvent.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvent(
  scope: Construct,
  id: str,
  event_time: datetime.datetime,
  action: str = None,
  deprecated_count: typing.Union[int, float] = None,
  deprecated_first_timestamp: datetime.datetime = None,
  deprecated_last_timestamp: datetime.datetime = None,
  deprecated_source: EventSource = None,
  metadata: ObjectMeta = None,
  note: str = None,
  reason: str = None,
  regarding: ObjectReference = None,
  related: ObjectReference = None,
  reporting_controller: str = None,
  reporting_instance: str = None,
  series: EventSeries = None,
  type: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.eventTime">event_time</a></code> | <code>datetime.datetime</code> | eventTime is the time when this Event was first observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.action">action</a></code> | <code>str</code> | action is what action was taken/failed regarding to the regarding object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedCount">deprecated_count</a></code> | <code>typing.Union[int, float]</code> | deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedFirstTimestamp">deprecated_first_timestamp</a></code> | <code>datetime.datetime</code> | deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedLastTimestamp">deprecated_last_timestamp</a></code> | <code>datetime.datetime</code> | deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedSource">deprecated_source</a></code> | <code>cdk8s_plus_28.k8s.EventSource</code> | deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.note">note</a></code> | <code>str</code> | note is a human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reason">reason</a></code> | <code>str</code> | reason is why the action was taken. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.regarding">regarding</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | regarding contains the object this Event is about. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.related">related</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | related is the optional secondary object for more complex actions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reportingController">reporting_controller</a></code> | <code>str</code> | reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reportingInstance">reporting_instance</a></code> | <code>str</code> | reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.series">series</a></code> | <code>cdk8s_plus_28.k8s.EventSeries</code> | series is data about the Event series this event represents or nil if it's a singleton Event. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.type">type</a></code> | <code>str</code> | type is the type of this event (Normal, Warning), new types could be added in the future. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `event_time`<sup>Required</sup> <a name="event_time" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.eventTime"></a>

- *Type:* datetime.datetime

eventTime is the time when this Event was first observed.

It is required.

---

##### `action`<sup>Optional</sup> <a name="action" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.action"></a>

- *Type:* str

action is what action was taken/failed regarding to the regarding object.

It is machine-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `deprecated_count`<sup>Optional</sup> <a name="deprecated_count" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedCount"></a>

- *Type:* typing.Union[int, float]

deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_first_timestamp`<sup>Optional</sup> <a name="deprecated_first_timestamp" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedFirstTimestamp"></a>

- *Type:* datetime.datetime

deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_last_timestamp`<sup>Optional</sup> <a name="deprecated_last_timestamp" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedLastTimestamp"></a>

- *Type:* datetime.datetime

deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_source`<sup>Optional</sup> <a name="deprecated_source" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.deprecatedSource"></a>

- *Type:* cdk8s_plus_28.k8s.EventSource

deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `note`<sup>Optional</sup> <a name="note" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.note"></a>

- *Type:* str

note is a human-readable description of the status of this operation.

Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reason"></a>

- *Type:* str

reason is why the action was taken.

It is human-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `regarding`<sup>Optional</sup> <a name="regarding" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.regarding"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

regarding contains the object this Event is about.

In most cases it's an Object reporting controller implements, e.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.

---

##### `related`<sup>Optional</sup> <a name="related" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.related"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

related is the optional secondary object for more complex actions.

E.g. when regarding object triggers a creation or deletion of related object.

---

##### `reporting_controller`<sup>Optional</sup> <a name="reporting_controller" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reportingController"></a>

- *Type:* str

reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events.

---

##### `reporting_instance`<sup>Optional</sup> <a name="reporting_instance" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.reportingInstance"></a>

- *Type:* str

reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `series`<sup>Optional</sup> <a name="series" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.series"></a>

- *Type:* cdk8s_plus_28.k8s.EventSeries

series is data about the Event series this event represents or nil if it's a singleton Event.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.type"></a>

- *Type:* str

type is the type of this event (Normal, Warning), new types could be added in the future.

It is machine-readable. This field cannot be empty for new Events.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEvent.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEvent.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEvent.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEvent.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEvent.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEvent.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.events.v1.Event". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEvent.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvent.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEvent.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEvent.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvent.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEvent.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEvent.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvent.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEvent.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEvent.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvent.manifest(
  event_time: datetime.datetime,
  action: str = None,
  deprecated_count: typing.Union[int, float] = None,
  deprecated_first_timestamp: datetime.datetime = None,
  deprecated_last_timestamp: datetime.datetime = None,
  deprecated_source: EventSource = None,
  metadata: ObjectMeta = None,
  note: str = None,
  reason: str = None,
  regarding: ObjectReference = None,
  related: ObjectReference = None,
  reporting_controller: str = None,
  reporting_instance: str = None,
  series: EventSeries = None,
  type: str = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.events.v1.Event".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `event_time`<sup>Required</sup> <a name="event_time" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.eventTime"></a>

- *Type:* datetime.datetime

eventTime is the time when this Event was first observed.

It is required.

---

###### `action`<sup>Optional</sup> <a name="action" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.action"></a>

- *Type:* str

action is what action was taken/failed regarding to the regarding object.

It is machine-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

###### `deprecated_count`<sup>Optional</sup> <a name="deprecated_count" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.deprecatedCount"></a>

- *Type:* typing.Union[int, float]

deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type.

---

###### `deprecated_first_timestamp`<sup>Optional</sup> <a name="deprecated_first_timestamp" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.deprecatedFirstTimestamp"></a>

- *Type:* datetime.datetime

deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

###### `deprecated_last_timestamp`<sup>Optional</sup> <a name="deprecated_last_timestamp" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.deprecatedLastTimestamp"></a>

- *Type:* datetime.datetime

deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

###### `deprecated_source`<sup>Optional</sup> <a name="deprecated_source" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.deprecatedSource"></a>

- *Type:* cdk8s_plus_28.k8s.EventSource

deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `note`<sup>Optional</sup> <a name="note" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.note"></a>

- *Type:* str

note is a human-readable description of the status of this operation.

Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.

---

###### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.reason"></a>

- *Type:* str

reason is why the action was taken.

It is human-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

###### `regarding`<sup>Optional</sup> <a name="regarding" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.regarding"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

regarding contains the object this Event is about.

In most cases it's an Object reporting controller implements, e.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.

---

###### `related`<sup>Optional</sup> <a name="related" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.related"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectReference

related is the optional secondary object for more complex actions.

E.g. when regarding object triggers a creation or deletion of related object.

---

###### `reporting_controller`<sup>Optional</sup> <a name="reporting_controller" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.reportingController"></a>

- *Type:* str

reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events.

---

###### `reporting_instance`<sup>Optional</sup> <a name="reporting_instance" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.reportingInstance"></a>

- *Type:* str

reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters.

---

###### `series`<sup>Optional</sup> <a name="series" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.series"></a>

- *Type:* cdk8s_plus_28.k8s.EventSeries

series is data about the Event series this event represents or nil if it's a singleton Event.

---

###### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.type"></a>

- *Type:* str

type is the type of this event (Normal, Warning), new types could be added in the future.

It is machine-readable. This field cannot be empty for new Events.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEvent.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEvent.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEvent.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEvent.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEvent.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvent.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEvent.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.events.v1.Event". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEvent.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.events.v1.Event".

---

### KubeEventList <a name="KubeEventList" id="cdk8s-plus-28.k8s.KubeEventList"></a>

EventList is a list of Event objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEventList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventList(
  scope: Construct,
  id: str,
  items: typing.List[KubeEventProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEventProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEventProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEventList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEventList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEventList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEventList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEventList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEventList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.events.v1.EventList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEventList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEventList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEventList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEventList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEventList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEventList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEventList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventList.manifest(
  items: typing.List[KubeEventProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.events.v1.EventList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEventList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEventProps]

items is a list of schema objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEventList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEventList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEventList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEventList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEventList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEventList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.events.v1.EventList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEventList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.events.v1.EventList".

---

### KubeEviction <a name="KubeEviction" id="cdk8s-plus-28.k8s.KubeEviction"></a>

Eviction evicts a pod from its node subject to certain policies and safety constraints.

This is a subresource of Pod.  A request to cause such an eviction is created by POSTing to .../pods/<pod name>/evictions.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEviction.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEviction(
  scope: Construct,
  id: str,
  delete_options: DeleteOptions = None,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.deleteOptions">delete_options</a></code> | <code>cdk8s_plus_28.k8s.DeleteOptions</code> | DeleteOptions may be provided. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | ObjectMeta describes the pod that is being evicted. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `delete_options`<sup>Optional</sup> <a name="delete_options" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.deleteOptions"></a>

- *Type:* cdk8s_plus_28.k8s.DeleteOptions

DeleteOptions may be provided.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

ObjectMeta describes the pod that is being evicted.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeEviction.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeEviction.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEviction.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeEviction.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEviction.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeEviction.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.Eviction". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeEviction.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEviction.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEviction.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeEviction.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEviction.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEviction.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEviction.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEviction.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEviction.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEviction.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEviction.manifest(
  delete_options: DeleteOptions = None,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.Eviction".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `delete_options`<sup>Optional</sup> <a name="delete_options" id="cdk8s-plus-28.k8s.KubeEviction.manifest.parameter.deleteOptions"></a>

- *Type:* cdk8s_plus_28.k8s.DeleteOptions

DeleteOptions may be provided.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEviction.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

ObjectMeta describes the pod that is being evicted.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEviction.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeEviction.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeEviction.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEviction.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEviction.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEviction.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEviction.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.Eviction". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEviction.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.Eviction".

---

### KubeFlowSchemaListV1Beta2 <a name="KubeFlowSchemaListV1Beta2" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2(
  scope: Construct,
  id: str,
  items: typing.List[KubeFlowSchemaV1Beta2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta2Props]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta2Props]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2.manifest(
  items: typing.List[KubeFlowSchemaV1Beta2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta2Props]

`items` is a list of FlowSchemas.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList".

---

### KubeFlowSchemaListV1Beta3 <a name="KubeFlowSchemaListV1Beta3" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3(
  scope: Construct,
  id: str,
  items: typing.List[KubeFlowSchemaV1Beta3Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta3Props]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta3Props]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3.manifest(
  items: typing.List[KubeFlowSchemaV1Beta3Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta3Props]

`items` is a list of FlowSchemas.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList".

---

### KubeFlowSchemaV1Beta2 <a name="KubeFlowSchemaV1Beta2" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta2 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta2

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchema". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2.manifest(
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta2 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchema".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta2

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchema". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchema".

---

### KubeFlowSchemaV1Beta3 <a name="KubeFlowSchemaV1Beta3" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta3 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta3

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchema". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3.manifest(
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta3 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchema".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta3

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchema". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchema".

---

### KubeHorizontalPodAutoscaler <a name="KubeHorizontalPodAutoscaler" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler"></a>

configuration of a horizontal pod autoscaler.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscaler(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpec</code> | spec defines the behaviour of autoscaler. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpec

spec defines the behaviour of autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscaler.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscaler.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscaler.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscaler.manifest(
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpec

spec defines the behaviour of autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler".

---

### KubeHorizontalPodAutoscalerList <a name="KubeHorizontalPodAutoscalerList" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList"></a>

list of horizontal pod autoscaler objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerList(
  scope: Construct,
  id: str,
  items: typing.List[KubeHorizontalPodAutoscalerProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerProps]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerProps]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerList.manifest(
  items: typing.List[KubeHorizontalPodAutoscalerProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerProps]

items is the list of horizontal pod autoscaler objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList".

---

### KubeHorizontalPodAutoscalerListV2 <a name="KubeHorizontalPodAutoscalerListV2" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2"></a>

HorizontalPodAutoscalerList is a list of horizontal pod autoscaler objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2(
  scope: Construct,
  id: str,
  items: typing.List[KubeHorizontalPodAutoscalerV2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerV2Props]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | metadata is the standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerV2Props]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata is the standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2.manifest(
  items: typing.List[KubeHorizontalPodAutoscalerV2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerV2Props]

items is the list of horizontal pod autoscaler objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata is the standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList".

---

### KubeHorizontalPodAutoscalerV2 <a name="KubeHorizontalPodAutoscalerV2" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2"></a>

HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpecV2 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | metadata is the standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpecV2</code> | spec is the specification for the behaviour of the autoscaler. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata is the standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpecV2

spec is the specification for the behaviour of the autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2.manifest(
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpecV2 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata is the standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpecV2

spec is the specification for the behaviour of the autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler".

---

### KubeIngress <a name="KubeIngress" id="cdk8s-plus-28.k8s.KubeIngress"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngress.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngress(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: IngressSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IngressSpec</code> | spec is the desired state of the Ingress. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IngressSpec

spec is the desired state of the Ingress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIngress.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIngress.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngress.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIngress.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngress.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIngress.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.Ingress". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIngress.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngress.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngress.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIngress.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngress.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngress.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngress.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngress.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngress.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngress.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngress.manifest(
  metadata: ObjectMeta = None,
  spec: IngressSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.Ingress".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngress.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngress.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IngressSpec

spec is the desired state of the Ingress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngress.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIngress.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIngress.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngress.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngress.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngress.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngress.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.Ingress". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngress.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.Ingress".

---

### KubeIngressClass <a name="KubeIngressClass" id="cdk8s-plus-28.k8s.KubeIngressClass"></a>

IngressClass represents the class of the Ingress, referenced by the Ingress Spec.

The `ingressclass.kubernetes.io/is-default-class` annotation can be used to indicate that an IngressClass should be considered default. When a single IngressClass resource has this annotation set to true, new Ingress resources without a class specified will be assigned this default class.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClass(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: IngressClassSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IngressClassSpec</code> | spec is the desired state of the IngressClass. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IngressClassSpec

spec is the desired state of the IngressClass.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIngressClass.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIngressClass.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIngressClass.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClass". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIngressClass.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClass.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressClass.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIngressClass.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClass.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressClass.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressClass.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClass.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressClass.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClass.manifest(
  metadata: ObjectMeta = None,
  spec: IngressClassSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClass.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressClass.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IngressClassSpec

spec is the desired state of the IngressClass.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressClass.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIngressClass.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIngressClass.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressClass.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressClass.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClass.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressClass.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressClass.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClass".

---

### KubeIngressClassList <a name="KubeIngressClassList" id="cdk8s-plus-28.k8s.KubeIngressClassList"></a>

IngressClassList is a collection of IngressClasses.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassList(
  scope: Construct,
  id: str,
  items: typing.List[KubeIngressClassProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIngressClassProps]</code> | items is the list of IngressClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressClassProps]

items is the list of IngressClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIngressClassList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIngressClassList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIngressClassList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClassList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressClassList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressClassList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassList.manifest(
  items: typing.List[KubeIngressClassProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressClassList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressClassProps]

items is the list of IngressClasses.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClassList".

---

### KubeIngressList <a name="KubeIngressList" id="cdk8s-plus-28.k8s.KubeIngressList"></a>

IngressList is a collection of Ingress.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressList(
  scope: Construct,
  id: str,
  items: typing.List[KubeIngressProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIngressProps]</code> | items is the list of Ingress. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressProps]

items is the list of Ingress.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIngressList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIngressList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIngressList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIngressList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIngressList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressList.manifest(
  items: typing.List[KubeIngressProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressProps]

items is the list of Ingress.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIngressList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIngressList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressList".

---

### KubeIpAddressListV1Alpha1 <a name="KubeIpAddressListV1Alpha1" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1"></a>

IPAddressList contains a list of IPAddress.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeIpAddressV1Alpha1Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIpAddressV1Alpha1Props]</code> | items is the list of IPAddresses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIpAddressV1Alpha1Props]

items is the list of IPAddresses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddressList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1.manifest(
  items: typing.List[KubeIpAddressV1Alpha1Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddressList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIpAddressV1Alpha1Props]

items is the list of IPAddresses.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddressList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddressList".

---

### KubeIpAddressV1Alpha1 <a name="KubeIpAddressV1Alpha1" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1"></a>

IPAddress represents a single IP of a single IP Family.

The object is designed to be used by APIs that operate on IP addresses. The object is used by the Service core API for allocation of IP addresses. An IP address can be represented in different formats, to guarantee the uniqueness of the IP, the name of the object is the IP address in canonical format, four decimal digits separated by dots suppressing leading zeros for IPv4 and the representation defined by RFC 5952 for IPv6. Valid: 192.168.1.5 or 2001:db8::1 or 2001:db8:aaaa:bbbb:cccc:dddd:eeee:1 Invalid: 10.01.2.3 or 2001:db8:0:0:0::1

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: IpAddressSpecV1Alpha1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IpAddressSpecV1Alpha1</code> | spec is the desired state of the IPAddress. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IpAddressSpecV1Alpha1

spec is the desired state of the IPAddress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddress". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1.manifest(
  metadata: ObjectMeta = None,
  spec: IpAddressSpecV1Alpha1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddress".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.IpAddressSpecV1Alpha1

spec is the desired state of the IPAddress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddress". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddress".

---

### KubeJob <a name="KubeJob" id="cdk8s-plus-28.k8s.KubeJob"></a>

Job represents the configuration of a single job.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeJob.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJob(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: JobSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.JobSpec</code> | Specification of the desired behavior of a job. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.JobSpec

Specification of the desired behavior of a job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeJob.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeJob.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeJob.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeJob.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeJob.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeJob.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.Job". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeJob.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJob.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeJob.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeJob.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJob.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeJob.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeJob.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJob.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeJob.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeJob.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJob.manifest(
  metadata: ObjectMeta = None,
  spec: JobSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.Job".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJob.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeJob.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.JobSpec

Specification of the desired behavior of a job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeJob.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeJob.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeJob.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeJob.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeJob.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJob.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeJob.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.Job". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeJob.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.Job".

---

### KubeJobList <a name="KubeJobList" id="cdk8s-plus-28.k8s.KubeJobList"></a>

JobList is a collection of jobs.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeJobList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobList(
  scope: Construct,
  id: str,
  items: typing.List[KubeJobProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeJobProps]</code> | items is the list of Jobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeJobProps]

items is the list of Jobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeJobList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeJobList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeJobList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeJobList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeJobList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeJobList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.JobList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeJobList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeJobList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeJobList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeJobList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeJobList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeJobList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeJobList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobList.manifest(
  items: typing.List[KubeJobProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.JobList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeJobList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeJobProps]

items is the list of Jobs.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeJobList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeJobList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeJobList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeJobList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeJobList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeJobList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.JobList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeJobList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.JobList".

---

### KubeLease <a name="KubeLease" id="cdk8s-plus-28.k8s.KubeLease"></a>

Lease defines a lease concept.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLease.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLease(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: LeaseSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.LeaseSpec</code> | spec contains the specification of the Lease. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.LeaseSpec

spec contains the specification of the Lease.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeLease.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeLease.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLease.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeLease.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLease.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeLease.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.Lease". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeLease.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLease.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLease.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeLease.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLease.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLease.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLease.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLease.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLease.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLease.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLease.manifest(
  metadata: ObjectMeta = None,
  spec: LeaseSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.Lease".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLease.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLease.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.LeaseSpec

spec contains the specification of the Lease.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLease.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeLease.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeLease.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLease.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLease.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLease.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLease.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.coordination.v1.Lease". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLease.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.coordination.v1.Lease".

---

### KubeLeaseList <a name="KubeLeaseList" id="cdk8s-plus-28.k8s.KubeLeaseList"></a>

LeaseList is a list of Lease objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseList(
  scope: Construct,
  id: str,
  items: typing.List[KubeLeaseProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeLeaseProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLeaseProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeLeaseList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeLeaseList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLeaseList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeLeaseList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.LeaseList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeLeaseList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLeaseList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeLeaseList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLeaseList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLeaseList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLeaseList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLeaseList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseList.manifest(
  items: typing.List[KubeLeaseProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.LeaseList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLeaseList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLeaseProps]

items is a list of schema objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLeaseList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeLeaseList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeLeaseList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLeaseList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLeaseList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLeaseList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.coordination.v1.LeaseList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLeaseList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.coordination.v1.LeaseList".

---

### KubeLimitRange <a name="KubeLimitRange" id="cdk8s-plus-28.k8s.KubeLimitRange"></a>

LimitRange sets resource usage limits for each kind of resource in a Namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRange(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: LimitRangeSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.LimitRangeSpec</code> | Spec defines the limits enforced. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.LimitRangeSpec

Spec defines the limits enforced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeLimitRange.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeLimitRange.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLimitRange.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeLimitRange.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRange". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeLimitRange.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRange.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLimitRange.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeLimitRange.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRange.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLimitRange.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLimitRange.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRange.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLimitRange.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLimitRange.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRange.manifest(
  metadata: ObjectMeta = None,
  spec: LimitRangeSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRange".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRange.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLimitRange.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.LimitRangeSpec

Spec defines the limits enforced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLimitRange.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeLimitRange.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeLimitRange.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLimitRange.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLimitRange.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRange.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLimitRange.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRange". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLimitRange.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRange".

---

### KubeLimitRangeList <a name="KubeLimitRangeList" id="cdk8s-plus-28.k8s.KubeLimitRangeList"></a>

LimitRangeList is a list of LimitRange items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeList(
  scope: Construct,
  id: str,
  items: typing.List[KubeLimitRangeProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeLimitRangeProps]</code> | Items is a list of LimitRange objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLimitRangeProps]

Items is a list of LimitRange objects.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeLimitRangeList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeLimitRangeList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRangeList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLimitRangeList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLimitRangeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLimitRangeList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeList.manifest(
  items: typing.List[KubeLimitRangeProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRangeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLimitRangeList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLimitRangeProps]

Items is a list of LimitRange objects.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRangeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRangeList".

---

### KubeLocalSubjectAccessReview <a name="KubeLocalSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview"></a>

LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace.

Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReview(
  scope: Construct,
  id: str,
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.LocalSubjectAccessReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReview.manifest(
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.LocalSubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.LocalSubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.LocalSubjectAccessReview".

---

### KubeMutatingWebhookConfiguration <a name="KubeMutatingWebhookConfiguration" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration"></a>

MutatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and may change the object.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfiguration(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  webhooks: typing.List[MutatingWebhook] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.webhooks">webhooks</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MutatingWebhook]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.webhooks"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.MutatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfiguration.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfiguration.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfiguration.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfiguration.manifest(
  metadata: ObjectMeta = None,
  webhooks: typing.List[MutatingWebhook] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest.parameter.webhooks"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.MutatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration".

---

### KubeMutatingWebhookConfigurationList <a name="KubeMutatingWebhookConfigurationList" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList"></a>

MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationList(
  scope: Construct,
  id: str,
  items: typing.List[KubeMutatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeMutatingWebhookConfigurationProps]</code> | List of MutatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeMutatingWebhookConfigurationProps]

List of MutatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationList.manifest(
  items: typing.List[KubeMutatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeMutatingWebhookConfigurationProps]

List of MutatingWebhookConfiguration.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList".

---

### KubeNamespace <a name="KubeNamespace" id="cdk8s-plus-28.k8s.KubeNamespace"></a>

Namespace provides a scope for Names.

Use of multiple namespaces is optional.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespace(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: NamespaceSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NamespaceSpec</code> | Spec defines the behavior of the Namespace. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NamespaceSpec

Spec defines the behavior of the Namespace.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNamespace.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNamespace.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNamespace.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNamespace.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Namespace". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNamespace.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespace.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNamespace.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNamespace.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespace.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNamespace.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNamespace.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespace.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNamespace.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNamespace.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespace.manifest(
  metadata: ObjectMeta = None,
  spec: NamespaceSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Namespace".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespace.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNamespace.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NamespaceSpec

Spec defines the behavior of the Namespace.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNamespace.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNamespace.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNamespace.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNamespace.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNamespace.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespace.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNamespace.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Namespace". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNamespace.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Namespace".

---

### KubeNamespaceList <a name="KubeNamespaceList" id="cdk8s-plus-28.k8s.KubeNamespaceList"></a>

NamespaceList is a list of Namespaces.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceList(
  scope: Construct,
  id: str,
  items: typing.List[KubeNamespaceProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNamespaceProps]</code> | Items is the list of Namespace objects in the list. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNamespaceProps]

Items is the list of Namespace objects in the list.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNamespaceList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNamespaceList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNamespaceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNamespaceList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.NamespaceList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNamespaceList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNamespaceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNamespaceList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceList.manifest(
  items: typing.List[KubeNamespaceProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.NamespaceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNamespaceList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNamespaceProps]

Items is the list of Namespace objects in the list.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.NamespaceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.NamespaceList".

---

### KubeNetworkPolicy <a name="KubeNetworkPolicy" id="cdk8s-plus-28.k8s.KubeNetworkPolicy"></a>

NetworkPolicy describes what network traffic is allowed for a set of Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicy(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: NetworkPolicySpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NetworkPolicySpec</code> | spec represents the specification of the desired behavior for this NetworkPolicy. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NetworkPolicySpec

spec represents the specification of the desired behavior for this NetworkPolicy.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicy". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicy.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicy.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicy.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicy.manifest(
  metadata: ObjectMeta = None,
  spec: NetworkPolicySpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NetworkPolicySpec

spec represents the specification of the desired behavior for this NetworkPolicy.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicy".

---

### KubeNetworkPolicyList <a name="KubeNetworkPolicyList" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList"></a>

NetworkPolicyList is a list of NetworkPolicy objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyList(
  scope: Construct,
  id: str,
  items: typing.List[KubeNetworkPolicyProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNetworkPolicyProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNetworkPolicyProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicyList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyList.manifest(
  items: typing.List[KubeNetworkPolicyProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNetworkPolicyProps]

items is a list of schema objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicyList".

---

### KubeNode <a name="KubeNode" id="cdk8s-plus-28.k8s.KubeNode"></a>

Node is a worker node in Kubernetes.

Each node will have a unique identifier in the cache (i.e. in etcd).

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNode.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNode(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: NodeSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NodeSpec</code> | Spec defines the behavior of a node. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NodeSpec

Spec defines the behavior of a node.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNode.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNode.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNode.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNode.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNode.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNode.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Node". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNode.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNode.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNode.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNode.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNode.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNode.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNode.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNode.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNode.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNode.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNode.manifest(
  metadata: ObjectMeta = None,
  spec: NodeSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Node".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNode.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNode.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.NodeSpec

Spec defines the behavior of a node.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNode.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNode.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNode.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNode.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNode.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNode.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNode.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Node". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNode.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Node".

---

### KubeNodeList <a name="KubeNodeList" id="cdk8s-plus-28.k8s.KubeNodeList"></a>

NodeList is the whole list of all Nodes which have been registered with master.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeList(
  scope: Construct,
  id: str,
  items: typing.List[KubeNodeProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNodeProps]</code> | List of nodes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNodeProps]

List of nodes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeNodeList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeNodeList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNodeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeNodeList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.NodeList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeNodeList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNodeList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeNodeList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNodeList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNodeList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNodeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNodeList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeList.manifest(
  items: typing.List[KubeNodeProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.NodeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNodeList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNodeProps]

List of nodes.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNodeList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeNodeList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeNodeList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNodeList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNodeList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNodeList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.NodeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNodeList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.NodeList".

---

### KubePersistentVolume <a name="KubePersistentVolume" id="cdk8s-plus-28.k8s.KubePersistentVolume"></a>

PersistentVolume (PV) is a storage resource provisioned by an administrator.

It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolume(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PersistentVolumeSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeSpec</code> | spec defines a specification of a persistent volume owned by the cluster. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeSpec

spec defines a specification of a persistent volume owned by the cluster.

Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePersistentVolume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePersistentVolume.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolume.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePersistentVolume.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolume". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolume.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolume.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolume.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolume.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolume.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolume.manifest(
  metadata: ObjectMeta = None,
  spec: PersistentVolumeSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolume".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolume.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolume.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeSpec

spec defines a specification of a persistent volume owned by the cluster.

Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolume". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolume".

---

### KubePersistentVolumeClaim <a name="KubePersistentVolumeClaim" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim"></a>

PersistentVolumeClaim is a user's request for and claim to a persistent volume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaim(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PersistentVolumeClaimSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeClaimSpec</code> | spec defines the desired characteristics of a volume requested by a pod author. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimSpec

spec defines the desired characteristics of a volume requested by a pod author.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaim". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaim.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaim.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaim.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaim.manifest(
  metadata: ObjectMeta = None,
  spec: PersistentVolumeClaimSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaim".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimSpec

spec defines the desired characteristics of a volume requested by a pod author.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaim". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaim".

---

### KubePersistentVolumeClaimList <a name="KubePersistentVolumeClaimList" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList"></a>

PersistentVolumeClaimList is a list of PersistentVolumeClaim items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimList(
  scope: Construct,
  id: str,
  items: typing.List[KubePersistentVolumeClaimProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]</code> | items is a list of persistent volume claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]

items is a list of persistent volume claims.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaimList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimList.manifest(
  items: typing.List[KubePersistentVolumeClaimProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaimList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]

items is a list of persistent volume claims.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaimList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaimList".

---

### KubePersistentVolumeList <a name="KubePersistentVolumeList" id="cdk8s-plus-28.k8s.KubePersistentVolumeList"></a>

PersistentVolumeList is a list of PersistentVolume items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeList(
  scope: Construct,
  id: str,
  items: typing.List[KubePersistentVolumeProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeProps]</code> | items is a list of persistent volumes. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeProps]

items is a list of persistent volumes.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeList.manifest(
  items: typing.List[KubePersistentVolumeProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeProps]

items is a list of persistent volumes.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeList".

---

### KubePod <a name="KubePod" id="cdk8s-plus-28.k8s.KubePod"></a>

Pod is a collection of containers that can run on a host.

This resource is created by clients and scheduled onto hosts.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePod.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePod(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PodSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodSpec</code> | Specification of the desired behavior of the pod. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePod.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePod.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePod.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePod.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePod.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePod.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Pod". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePod.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePod.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePod.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePod.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePod.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePod.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePod.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePod.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePod.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePod.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePod.manifest(
  metadata: ObjectMeta = None,
  spec: PodSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Pod".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePod.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePod.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePod.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePod.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePod.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePod.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePod.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePod.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePod.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Pod". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePod.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Pod".

---

### KubePodDisruptionBudget <a name="KubePodDisruptionBudget" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget"></a>

PodDisruptionBudget is an object to define the max disruption that can be caused to a collection of pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudget(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PodDisruptionBudgetSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodDisruptionBudgetSpec</code> | Specification of the desired behavior of the PodDisruptionBudget. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodDisruptionBudgetSpec

Specification of the desired behavior of the PodDisruptionBudget.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudget". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudget.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudget.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudget.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudget.manifest(
  metadata: ObjectMeta = None,
  spec: PodDisruptionBudgetSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudget".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodDisruptionBudgetSpec

Specification of the desired behavior of the PodDisruptionBudget.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudget". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudget".

---

### KubePodDisruptionBudgetList <a name="KubePodDisruptionBudgetList" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList"></a>

PodDisruptionBudgetList is a collection of PodDisruptionBudgets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetList(
  scope: Construct,
  id: str,
  items: typing.List[KubePodDisruptionBudgetProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodDisruptionBudgetProps]</code> | Items is a list of PodDisruptionBudgets. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodDisruptionBudgetProps]

Items is a list of PodDisruptionBudgets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudgetList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetList.manifest(
  items: typing.List[KubePodDisruptionBudgetProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudgetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodDisruptionBudgetProps]

Items is a list of PodDisruptionBudgets.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudgetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudgetList".

---

### KubePodList <a name="KubePodList" id="cdk8s-plus-28.k8s.KubePodList"></a>

PodList is a list of Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodList(
  scope: Construct,
  id: str,
  items: typing.List[KubePodProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodProps]</code> | List of pods. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodProps]

List of pods.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodList.manifest(
  items: typing.List[KubePodProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodProps]

List of pods.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodList".

---

### KubePodSchedulingContextListV1Alpha2 <a name="KubePodSchedulingContextListV1Alpha2" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2"></a>

PodSchedulingContextList is a collection of Pod scheduling objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2(
  scope: Construct,
  id: str,
  items: typing.List[KubePodSchedulingContextV1Alpha2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodSchedulingContextV1Alpha2Props]</code> | Items is the list of PodSchedulingContext objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodSchedulingContextV1Alpha2Props]

Items is the list of PodSchedulingContext objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2.manifest(
  items: typing.List[KubePodSchedulingContextV1Alpha2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodSchedulingContextV1Alpha2Props]

Items is the list of PodSchedulingContext objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList".

---

### KubePodSchedulingContextV1Alpha2 <a name="KubePodSchedulingContextV1Alpha2" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2"></a>

PodSchedulingContext objects hold information that is needed to schedule a Pod with ResourceClaims that use "WaitForFirstConsumer" allocation mode.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2(
  scope: Construct,
  id: str,
  spec: PodSchedulingContextSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodSchedulingContextSpecV1Alpha2</code> | Spec describes where resources for the Pod are needed. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodSchedulingContextSpecV1Alpha2

Spec describes where resources for the Pod are needed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContext". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2.manifest(
  spec: PodSchedulingContextSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContext".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PodSchedulingContextSpecV1Alpha2

Spec describes where resources for the Pod are needed.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContext". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContext".

---

### KubePodTemplate <a name="KubePodTemplate" id="cdk8s-plus-28.k8s.KubePodTemplate"></a>

PodTemplate describes a template for creating copies of a predefined pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplate(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  template: PodTemplateSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Template defines the pods that will be created from this pod template. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.template"></a>

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template defines the pods that will be created from this pod template.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodTemplate.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodTemplate.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodTemplate.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodTemplate.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplate". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodTemplate.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplate.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodTemplate.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodTemplate.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplate.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodTemplate.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodTemplate.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplate.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodTemplate.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodTemplate.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplate.manifest(
  metadata: ObjectMeta = None,
  template: PodTemplateSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplate".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplate.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.KubePodTemplate.manifest.parameter.template"></a>

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template defines the pods that will be created from this pod template.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodTemplate.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodTemplate.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodTemplate.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodTemplate.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodTemplate.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplate.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodTemplate.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplate". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodTemplate.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplate".

---

### KubePodTemplateList <a name="KubePodTemplateList" id="cdk8s-plus-28.k8s.KubePodTemplateList"></a>

PodTemplateList is a list of PodTemplates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateList(
  scope: Construct,
  id: str,
  items: typing.List[KubePodTemplateProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodTemplateProps]</code> | List of pod templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodTemplateProps]

List of pod templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePodTemplateList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePodTemplateList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodTemplateList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePodTemplateList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplateList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodTemplateList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodTemplateList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodTemplateList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateList.manifest(
  items: typing.List[KubePodTemplateProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplateList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodTemplateList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodTemplateProps]

List of pod templates.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplateList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplateList".

---

### KubePriorityClass <a name="KubePriorityClass" id="cdk8s-plus-28.k8s.KubePriorityClass"></a>

PriorityClass defines mapping from a priority class name to the priority integer value.

The value can be any valid integer.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClass(
  scope: Construct,
  id: str,
  value: typing.Union[int, float],
  description: str = None,
  global_default: bool = None,
  metadata: ObjectMeta = None,
  preemption_policy: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.value">value</a></code> | <code>typing.Union[int, float]</code> | value represents the integer value of this priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.description">description</a></code> | <code>str</code> | description is an arbitrary string that usually provides guidelines on when this priority class should be used. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.globalDefault">global_default</a></code> | <code>bool</code> | globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.preemptionPolicy">preemption_policy</a></code> | <code>str</code> | preemptionPolicy is the Policy for preempting pods with lower priority. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.value"></a>

- *Type:* typing.Union[int, float]

value represents the integer value of this priority class.

This is the actual priority that pods receive when they have the name of this class in their pod spec.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.description"></a>

- *Type:* str

description is an arbitrary string that usually provides guidelines on when this priority class should be used.

---

##### `global_default`<sup>Optional</sup> <a name="global_default" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.globalDefault"></a>

- *Type:* bool

globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class.

Only one PriorityClass can be marked as `globalDefault`. However, if more than one PriorityClasses exists with their `globalDefault` field set to true, the smallest value of such global default PriorityClasses will be used as the default priority.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `preemption_policy`<sup>Optional</sup> <a name="preemption_policy" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.preemptionPolicy"></a>

- *Type:* str
- *Default:* PreemptLowerPriority if unset.

preemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityClass.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityClass.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityClass.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClass". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityClass.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClass.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityClass.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityClass.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClass.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityClass.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityClass.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClass.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClass.manifest(
  value: typing.Union[int, float],
  description: str = None,
  global_default: bool = None,
  metadata: ObjectMeta = None,
  preemption_policy: str = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.value"></a>

- *Type:* typing.Union[int, float]

value represents the integer value of this priority class.

This is the actual priority that pods receive when they have the name of this class in their pod spec.

---

###### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.description"></a>

- *Type:* str

description is an arbitrary string that usually provides guidelines on when this priority class should be used.

---

###### `global_default`<sup>Optional</sup> <a name="global_default" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.globalDefault"></a>

- *Type:* bool

globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class.

Only one PriorityClass can be marked as `globalDefault`. However, if more than one PriorityClasses exists with their `globalDefault` field set to true, the smallest value of such global default PriorityClasses will be used as the default priority.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `preemption_policy`<sup>Optional</sup> <a name="preemption_policy" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.preemptionPolicy"></a>

- *Type:* str
- *Default:* PreemptLowerPriority if unset.

preemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityClass.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityClass.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityClass.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityClass.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityClass.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClass.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityClass.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityClass.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClass".

---

### KubePriorityClassList <a name="KubePriorityClassList" id="cdk8s-plus-28.k8s.KubePriorityClassList"></a>

PriorityClassList is a collection of priority classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassList(
  scope: Construct,
  id: str,
  items: typing.List[KubePriorityClassProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityClassProps]</code> | items is the list of PriorityClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityClassProps]

items is the list of PriorityClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityClassList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityClassList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityClassList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClassList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityClassList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityClassList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassList.manifest(
  items: typing.List[KubePriorityClassProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityClassList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityClassProps]

items is the list of PriorityClasses.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClassList".

---

### KubePriorityLevelConfigurationListV1Beta2 <a name="KubePriorityLevelConfigurationListV1Beta2" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2(
  scope: Construct,
  id: str,
  items: typing.List[KubePriorityLevelConfigurationV1Beta2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta2Props]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta2Props]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2.manifest(
  items: typing.List[KubePriorityLevelConfigurationV1Beta2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta2Props]

`items` is a list of request-priorities.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList".

---

### KubePriorityLevelConfigurationListV1Beta3 <a name="KubePriorityLevelConfigurationListV1Beta3" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3(
  scope: Construct,
  id: str,
  items: typing.List[KubePriorityLevelConfigurationV1Beta3Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta3Props]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta3Props]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3.manifest(
  items: typing.List[KubePriorityLevelConfigurationV1Beta3Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta3Props]

`items` is a list of request-priorities.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList".

---

### KubePriorityLevelConfigurationV1Beta2 <a name="KubePriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta2 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta2

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2.manifest(
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta2 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta2

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration".

---

### KubePriorityLevelConfigurationV1Beta3 <a name="KubePriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta3 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta3

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3.manifest(
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta3 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta3

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration".

---

### KubeReplicaSet <a name="KubeReplicaSet" id="cdk8s-plus-28.k8s.KubeReplicaSet"></a>

ReplicaSet ensures that a specified number of pod replicas are running at any given time.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSet(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ReplicaSetSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ReplicaSetSpec</code> | Spec defines the specification of the desired behavior of the ReplicaSet. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ReplicaSetSpec

Spec defines the specification of the desired behavior of the ReplicaSet.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeReplicaSet.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeReplicaSet.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicaSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeReplicaSet.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSet". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSet.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSet.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicaSet.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSet.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicaSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicaSet.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSet.manifest(
  metadata: ObjectMeta = None,
  spec: ReplicaSetSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSet.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicaSet.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ReplicaSetSpec

Spec defines the specification of the desired behavior of the ReplicaSet.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSet".

---

### KubeReplicaSetList <a name="KubeReplicaSetList" id="cdk8s-plus-28.k8s.KubeReplicaSetList"></a>

ReplicaSetList is a collection of ReplicaSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetList(
  scope: Construct,
  id: str,
  items: typing.List[KubeReplicaSetProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeReplicaSetProps]</code> | List of ReplicaSets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicaSetProps]

List of ReplicaSets.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeReplicaSetList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeReplicaSetList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSetList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicaSetList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicaSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicaSetList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetList.manifest(
  items: typing.List[KubeReplicaSetProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicaSetList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicaSetProps]

List of ReplicaSets.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSetList".

---

### KubeReplicationController <a name="KubeReplicationController" id="cdk8s-plus-28.k8s.KubeReplicationController"></a>

ReplicationController represents the configuration of a replication controller.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationController(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ReplicationControllerSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ReplicationControllerSpec</code> | Spec defines the specification of the desired behavior of the replication controller. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ReplicationControllerSpec

Spec defines the specification of the desired behavior of the replication controller.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeReplicationController.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeReplicationController.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicationController.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeReplicationController.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationController". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeReplicationController.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationController.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicationController.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeReplicationController.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationController.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicationController.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicationController.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationController.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicationController.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicationController.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationController.manifest(
  metadata: ObjectMeta = None,
  spec: ReplicationControllerSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationController".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationController.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicationController.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ReplicationControllerSpec

Spec defines the specification of the desired behavior of the replication controller.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicationController.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeReplicationController.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeReplicationController.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicationController.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicationController.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationController.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicationController.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationController". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicationController.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationController".

---

### KubeReplicationControllerList <a name="KubeReplicationControllerList" id="cdk8s-plus-28.k8s.KubeReplicationControllerList"></a>

ReplicationControllerList is a collection of replication controllers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerList(
  scope: Construct,
  id: str,
  items: typing.List[KubeReplicationControllerProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeReplicationControllerProps]</code> | List of replication controllers. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicationControllerProps]

List of replication controllers.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationControllerList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerList.manifest(
  items: typing.List[KubeReplicationControllerProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationControllerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicationControllerProps]

List of replication controllers.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationControllerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationControllerList".

---

### KubeResourceClaimListV1Alpha2 <a name="KubeResourceClaimListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2"></a>

ResourceClaimList is a collection of claims.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2(
  scope: Construct,
  id: str,
  items: typing.List[KubeResourceClaimV1Alpha2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClaimV1Alpha2Props]</code> | Items is the list of resource claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimV1Alpha2Props]

Items is the list of resource claims.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2.manifest(
  items: typing.List[KubeResourceClaimV1Alpha2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimV1Alpha2Props]

Items is the list of resource claims.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimList".

---

### KubeResourceClaimTemplateListV1Alpha2 <a name="KubeResourceClaimTemplateListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2"></a>

ResourceClaimTemplateList is a collection of claim templates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2(
  scope: Construct,
  id: str,
  items: typing.List[KubeResourceClaimTemplateV1Alpha2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClaimTemplateV1Alpha2Props]</code> | Items is the list of resource claim templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimTemplateV1Alpha2Props]

Items is the list of resource claim templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2.manifest(
  items: typing.List[KubeResourceClaimTemplateV1Alpha2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimTemplateV1Alpha2Props]

Items is the list of resource claim templates.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList".

---

### KubeResourceClaimTemplateV1Alpha2 <a name="KubeResourceClaimTemplateV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2"></a>

ResourceClaimTemplate is used to produce ResourceClaim objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2(
  scope: Construct,
  id: str,
  spec: ResourceClaimTemplateSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimTemplateSpecV1Alpha2</code> | Describes the ResourceClaim that is to be generated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClaimTemplateSpecV1Alpha2

Describes the ResourceClaim that is to be generated.

This field is immutable. A ResourceClaim will get created by the control plane for a Pod when needed and then not get updated anymore.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2.manifest(
  spec: ResourceClaimTemplateSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClaimTemplateSpecV1Alpha2

Describes the ResourceClaim that is to be generated.

This field is immutable. A ResourceClaim will get created by the control plane for a Pod when needed and then not get updated anymore.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate".

---

### KubeResourceClaimV1Alpha2 <a name="KubeResourceClaimV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2"></a>

ResourceClaim describes which resources are needed by a resource consumer.

Its status tracks whether the resource has been allocated and what the resulting attributes are.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2(
  scope: Construct,
  id: str,
  spec: ResourceClaimSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2</code> | Spec describes the desired attributes of a resource that then needs to be allocated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2

Spec describes the desired attributes of a resource that then needs to be allocated.

It can only be set once when creating the ResourceClaim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaim". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2.manifest(
  spec: ResourceClaimSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaim".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2

Spec describes the desired attributes of a resource that then needs to be allocated.

It can only be set once when creating the ResourceClaim.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaim". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaim".

---

### KubeResourceClassListV1Alpha2 <a name="KubeResourceClassListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2"></a>

ResourceClassList is a collection of classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2(
  scope: Construct,
  id: str,
  items: typing.List[KubeResourceClassV1Alpha2Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClassV1Alpha2Props]</code> | Items is the list of resource classes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClassV1Alpha2Props]

Items is the list of resource classes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClassList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2.manifest(
  items: typing.List[KubeResourceClassV1Alpha2Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClassV1Alpha2Props]

Items is the list of resource classes.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClassList".

---

### KubeResourceClassV1Alpha2 <a name="KubeResourceClassV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2"></a>

ResourceClass is used by administrators to influence how resources are allocated.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2(
  scope: Construct,
  id: str,
  driver_name: str,
  metadata: ObjectMeta = None,
  parameters_ref: ResourceClassParametersReferenceV1Alpha2 = None,
  suitable_nodes: NodeSelector = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.driverName">driver_name</a></code> | <code>str</code> | DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.parametersRef">parameters_ref</a></code> | <code>cdk8s_plus_28.k8s.ResourceClassParametersReferenceV1Alpha2</code> | ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.suitableNodes">suitable_nodes</a></code> | <code>cdk8s_plus_28.k8s.NodeSelector</code> | Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `driver_name`<sup>Required</sup> <a name="driver_name" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.driverName"></a>

- *Type:* str

DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class.

Resource drivers have a unique name in forward domain order (acme.example.com).

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

##### `parameters_ref`<sup>Optional</sup> <a name="parameters_ref" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.parametersRef"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClassParametersReferenceV1Alpha2

ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class.

A dynamic resource driver can distinguish between parameters stored here and and those stored in ResourceClaimSpec.

---

##### `suitable_nodes`<sup>Optional</sup> <a name="suitable_nodes" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.suitableNodes"></a>

- *Type:* cdk8s_plus_28.k8s.NodeSelector

Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet.

Setting this field is optional. If null, all nodes are candidates.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClass". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2.manifest(
  driver_name: str,
  metadata: ObjectMeta = None,
  parameters_ref: ResourceClassParametersReferenceV1Alpha2 = None,
  suitable_nodes: NodeSelector = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `driver_name`<sup>Required</sup> <a name="driver_name" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest.parameter.driverName"></a>

- *Type:* str

DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class.

Resource drivers have a unique name in forward domain order (acme.example.com).

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

###### `parameters_ref`<sup>Optional</sup> <a name="parameters_ref" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest.parameter.parametersRef"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceClassParametersReferenceV1Alpha2

ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class.

A dynamic resource driver can distinguish between parameters stored here and and those stored in ResourceClaimSpec.

---

###### `suitable_nodes`<sup>Optional</sup> <a name="suitable_nodes" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest.parameter.suitableNodes"></a>

- *Type:* cdk8s_plus_28.k8s.NodeSelector

Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet.

Setting this field is optional. If null, all nodes are candidates.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClass".

---

### KubeResourceQuota <a name="KubeResourceQuota" id="cdk8s-plus-28.k8s.KubeResourceQuota"></a>

ResourceQuota sets aggregate quota restrictions enforced per namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuota(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ResourceQuotaSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceQuotaSpec</code> | Spec defines the desired quota. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceQuotaSpec

Spec defines the desired quota.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceQuota.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceQuota.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceQuota.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceQuota.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuota". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuota.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuota.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceQuota.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuota.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceQuota.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceQuota.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuota.manifest(
  metadata: ObjectMeta = None,
  spec: ResourceQuotaSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuota".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuota.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceQuota.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ResourceQuotaSpec

Spec defines the desired quota.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuota". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuota".

---

### KubeResourceQuotaList <a name="KubeResourceQuotaList" id="cdk8s-plus-28.k8s.KubeResourceQuotaList"></a>

ResourceQuotaList is a list of ResourceQuota items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaList(
  scope: Construct,
  id: str,
  items: typing.List[KubeResourceQuotaProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceQuotaProps]</code> | Items is a list of ResourceQuota objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceQuotaProps]

Items is a list of ResourceQuota objects.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuotaList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaList.manifest(
  items: typing.List[KubeResourceQuotaProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuotaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceQuotaProps]

Items is a list of ResourceQuota objects.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuotaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuotaList".

---

### KubeRole <a name="KubeRole" id="cdk8s-plus-28.k8s.KubeRole"></a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRole.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRole(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRule]</code> | Rules holds all the PolicyRules for this Role. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.rules"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this Role.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRole.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRole.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRole.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRole.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRole.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRole.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.Role". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRole.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRole.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRole.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRole.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRole.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRole.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRole.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRole.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRole.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRole.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRole.manifest(
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.Role".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRole.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

###### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeRole.manifest.parameter.rules"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this Role.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRole.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRole.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRole.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRole.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRole.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRole.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRole.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.Role". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRole.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.Role".

---

### KubeRoleBinding <a name="KubeRoleBinding" id="cdk8s-plus-28.k8s.KubeRoleBinding"></a>

RoleBinding references a role, but does not contain it.

It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBinding(
  scope: Construct,
  id: str,
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.roleRef">role_ref</a></code> | <code>cdk8s_plus_28.k8s.RoleRef</code> | RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Subject]</code> | Subjects holds references to the objects the role applies to. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.roleRef"></a>

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.subjects"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRoleBinding.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRoleBinding.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRoleBinding.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBinding". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBinding.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBinding.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleBinding.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBinding.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBinding.manifest(
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest.parameter.roleRef"></a>

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

###### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest.parameter.subjects"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBinding".

---

### KubeRoleBindingList <a name="KubeRoleBindingList" id="cdk8s-plus-28.k8s.KubeRoleBindingList"></a>

RoleBindingList is a collection of RoleBindings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingList(
  scope: Construct,
  id: str,
  items: typing.List[KubeRoleBindingProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRoleBindingProps]</code> | Items is a list of RoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleBindingProps]

Items is a list of RoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRoleBindingList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRoleBindingList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBindingList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleBindingList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleBindingList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleBindingList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingList.manifest(
  items: typing.List[KubeRoleBindingProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleBindingList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleBindingProps]

Items is a list of RoleBindings.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBindingList".

---

### KubeRoleList <a name="KubeRoleList" id="cdk8s-plus-28.k8s.KubeRoleList"></a>

RoleList is a collection of Roles.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleList(
  scope: Construct,
  id: str,
  items: typing.List[KubeRoleProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRoleProps]</code> | Items is a list of Roles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleProps]

Items is a list of Roles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRoleList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRoleList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRoleList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRoleList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRoleList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleList.manifest(
  items: typing.List[KubeRoleProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleProps]

Items is a list of Roles.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRoleList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRoleList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleList".

---

### KubeRuntimeClass <a name="KubeRuntimeClass" id="cdk8s-plus-28.k8s.KubeRuntimeClass"></a>

RuntimeClass defines a class of container runtime supported in the cluster.

The RuntimeClass is used to determine which container runtime is used to run all containers in a pod. RuntimeClasses are manually defined by a user or cluster provisioner, and referenced in the PodSpec. The Kubelet is responsible for resolving the RuntimeClassName reference before running the pod.  For more details, see https://kubernetes.io/docs/concepts/containers/runtime-class/

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClass(
  scope: Construct,
  id: str,
  handler: str,
  metadata: ObjectMeta = None,
  overhead: Overhead = None,
  scheduling: Scheduling = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.handler">handler</a></code> | <code>str</code> | handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.overhead">overhead</a></code> | <code>cdk8s_plus_28.k8s.Overhead</code> | overhead represents the resource overhead associated with running a pod for a given RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scheduling">scheduling</a></code> | <code>cdk8s_plus_28.k8s.Scheduling</code> | scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `handler`<sup>Required</sup> <a name="handler" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.handler"></a>

- *Type:* str

handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class.

The possible values are specific to the node & CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called "runc" might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The Handler must be lowercase, conform to the DNS Label (RFC 1123) requirements, and is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.overhead"></a>

- *Type:* cdk8s_plus_28.k8s.Overhead

overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

For more details, see
https://kubernetes.io/docs/concepts/scheduling-eviction/pod-overhead/

---

##### `scheduling`<sup>Optional</sup> <a name="scheduling" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scheduling"></a>

- *Type:* cdk8s_plus_28.k8s.Scheduling

scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it.

If scheduling is nil, this RuntimeClass is assumed to be supported by all nodes.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRuntimeClass.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRuntimeClass.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClass". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClass.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClass.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRuntimeClass.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClass.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRuntimeClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClass.manifest(
  handler: str,
  metadata: ObjectMeta = None,
  overhead: Overhead = None,
  scheduling: Scheduling = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `handler`<sup>Required</sup> <a name="handler" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest.parameter.handler"></a>

- *Type:* str

handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class.

The possible values are specific to the node & CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called "runc" might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The Handler must be lowercase, conform to the DNS Label (RFC 1123) requirements, and is immutable.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest.parameter.overhead"></a>

- *Type:* cdk8s_plus_28.k8s.Overhead

overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

For more details, see
https://kubernetes.io/docs/concepts/scheduling-eviction/pod-overhead/

---

###### `scheduling`<sup>Optional</sup> <a name="scheduling" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest.parameter.scheduling"></a>

- *Type:* cdk8s_plus_28.k8s.Scheduling

scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it.

If scheduling is nil, this RuntimeClass is assumed to be supported by all nodes.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClass".

---

### KubeRuntimeClassList <a name="KubeRuntimeClassList" id="cdk8s-plus-28.k8s.KubeRuntimeClassList"></a>

RuntimeClassList is a list of RuntimeClass objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassList(
  scope: Construct,
  id: str,
  items: typing.List[KubeRuntimeClassProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRuntimeClassProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRuntimeClassProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClassList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassList.manifest(
  items: typing.List[KubeRuntimeClassProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRuntimeClassProps]

items is a list of schema objects.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClassList".

---

### KubeScale <a name="KubeScale" id="cdk8s-plus-28.k8s.KubeScale"></a>

Scale represents a scaling request for a resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeScale.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScale(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ScaleSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ScaleSpec</code> | spec defines the behavior of the scale. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ScaleSpec

spec defines the behavior of the scale.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeScale.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeScale.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeScale.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeScale.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeScale.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeScale.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.Scale". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeScale.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScale.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeScale.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeScale.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScale.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeScale.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeScale.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScale.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeScale.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeScale.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScale.manifest(
  metadata: ObjectMeta = None,
  spec: ScaleSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.Scale".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScale.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeScale.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ScaleSpec

spec defines the behavior of the scale.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeScale.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeScale.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeScale.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeScale.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeScale.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScale.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeScale.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.Scale". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeScale.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.Scale".

---

### KubeSecret <a name="KubeSecret" id="cdk8s-plus-28.k8s.KubeSecret"></a>

Secret holds secret data of a certain type.

The total bytes of the values in the Data field must be less than MaxSecretSize bytes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSecret.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecret(
  scope: Construct,
  id: str,
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None,
  string_data: typing.Mapping[str] = None,
  type: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the secret data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.stringData">string_data</a></code> | <code>typing.Mapping[str]</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.type">type</a></code> | <code>str</code> | Used to facilitate programmatic handling of secret data. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.data"></a>

- *Type:* typing.Mapping[str]

Data contains the secret data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.immutable"></a>

- *Type:* bool

Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `string_data`<sup>Optional</sup> <a name="string_data" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.stringData"></a>

- *Type:* typing.Mapping[str]

stringData allows specifying non-binary secret data in string form.

It is provided as a write-only input field for convenience. All keys and values are merged into the data field on write, overwriting any existing values. The stringData field is never output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.type"></a>

- *Type:* str

Used to facilitate programmatic handling of secret data.

More info: https://kubernetes.io/docs/concepts/configuration/secret/#secret-types

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSecret.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSecret.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSecret.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSecret.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSecret.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Secret". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSecret.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSecret.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecret.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSecret.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSecret.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecret.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSecret.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSecret.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecret.manifest(
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None,
  string_data: typing.Mapping[str] = None,
  type: str = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Secret".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.data"></a>

- *Type:* typing.Mapping[str]

Data contains the secret data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4

---

###### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.immutable"></a>

- *Type:* bool

Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `string_data`<sup>Optional</sup> <a name="string_data" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.stringData"></a>

- *Type:* typing.Mapping[str]

stringData allows specifying non-binary secret data in string form.

It is provided as a write-only input field for convenience. All keys and values are merged into the data field on write, overwriting any existing values. The stringData field is never output when reading from the API.

---

###### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.type"></a>

- *Type:* str

Used to facilitate programmatic handling of secret data.

More info: https://kubernetes.io/docs/concepts/configuration/secret/#secret-types

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSecret.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Secret". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSecret.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Secret".

---

### KubeSecretList <a name="KubeSecretList" id="cdk8s-plus-28.k8s.KubeSecretList"></a>

SecretList is a list of Secret.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretList(
  scope: Construct,
  id: str,
  items: typing.List[KubeSecretProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeSecretProps]</code> | Items is a list of secret objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeSecretProps]

Items is a list of secret objects.

More info: https://kubernetes.io/docs/concepts/configuration/secret

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSecretList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSecretList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSecretList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSecretList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.SecretList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSecretList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSecretList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSecretList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSecretList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSecretList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSecretList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSecretList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretList.manifest(
  items: typing.List[KubeSecretProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.SecretList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeSecretList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeSecretProps]

Items is a list of secret objects.

More info: https://kubernetes.io/docs/concepts/configuration/secret

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSecretList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSecretList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSecretList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSecretList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSecretList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSecretList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.SecretList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSecretList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.SecretList".

---

### KubeSelfSubjectAccessReview <a name="KubeSelfSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview"></a>

SelfSubjectAccessReview checks whether or the current user can perform an action.

Not filling in a spec.namespace means "in all namespaces".  Self is a special case, because users should always be able to check whether they can perform an action

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReview(
  scope: Construct,
  id: str,
  spec: SelfSubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SelfSubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SelfSubjectAccessReviewSpec

Spec holds information about the request being evaluated.

user and groups must be empty

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectAccessReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReview.manifest(
  spec: SelfSubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SelfSubjectAccessReviewSpec

Spec holds information about the request being evaluated.

user and groups must be empty

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectAccessReview".

---

### KubeSelfSubjectReview <a name="KubeSelfSubjectReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReview(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.SelfSubjectReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReview.manifest(
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.SelfSubjectReview".

---

### KubeSelfSubjectReviewV1Alpha1 <a name="KubeSelfSubjectReviewV1Alpha1" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1.manifest(
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview".

---

### KubeSelfSubjectReviewV1Beta1 <a name="KubeSelfSubjectReviewV1Beta1" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1beta1.SelfSubjectReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1.manifest(
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1beta1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1beta1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1beta1.SelfSubjectReview".

---

### KubeSelfSubjectRulesReview <a name="KubeSelfSubjectRulesReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview"></a>

SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace.

The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReview(
  scope: Construct,
  id: str,
  spec: SelfSubjectRulesReviewSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SelfSubjectRulesReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SelfSubjectRulesReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectRulesReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReview.manifest(
  spec: SelfSubjectRulesReviewSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectRulesReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SelfSubjectRulesReviewSpec

Spec holds information about the request being evaluated.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectRulesReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectRulesReview".

---

### KubeService <a name="KubeService" id="cdk8s-plus-28.k8s.KubeService"></a>

Service is a named abstraction of software service (for example, mysql) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeService.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeService(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ServiceSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ServiceSpec</code> | Spec defines the behavior of a service. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ServiceSpec

Spec defines the behavior of a service.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeService.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeService.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeService.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeService.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeService.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeService.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Service". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeService.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeService.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeService.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeService.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeService.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeService.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeService.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeService.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeService.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeService.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeService.manifest(
  metadata: ObjectMeta = None,
  spec: ServiceSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Service".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeService.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeService.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ServiceSpec

Spec defines the behavior of a service.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeService.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeService.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeService.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeService.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeService.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeService.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeService.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Service". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeService.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Service".

---

### KubeServiceAccount <a name="KubeServiceAccount" id="cdk8s-plus-28.k8s.KubeServiceAccount"></a>

ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccount(
  scope: Construct,
  id: str,
  automount_service_account_token: bool = None,
  image_pull_secrets: typing.List[LocalObjectReference] = None,
  metadata: ObjectMeta = None,
  secrets: typing.List[ObjectReference] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.imagePullSecrets">image_pull_secrets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LocalObjectReference]</code> | ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.secrets">secrets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ObjectReference]</code> | Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool

AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

---

##### `image_pull_secrets`<sup>Optional</sup> <a name="image_pull_secrets" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.imagePullSecrets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.LocalObjectReference]

ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount.

ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.secrets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ObjectReference]

Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use.

Pods are only limited to this list if this service account has a "kubernetes.io/enforce-mountable-secrets" annotation set to "true". This field should not be used to find auto-generated service account token secrets for use outside of pods. Instead, tokens can be requested directly using the TokenRequest API, or service account token secrets can be manually created. More info: https://kubernetes.io/docs/concepts/configuration/secret

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeServiceAccount.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeServiceAccount.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceAccount.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeServiceAccount.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccount". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccount.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccount.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceAccount.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccount.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceAccount.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccount.manifest(
  automount_service_account_token: bool = None,
  image_pull_secrets: typing.List[LocalObjectReference] = None,
  metadata: ObjectMeta = None,
  secrets: typing.List[ObjectReference] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccount".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest.parameter.automountServiceAccountToken"></a>

- *Type:* bool

AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

---

###### `image_pull_secrets`<sup>Optional</sup> <a name="image_pull_secrets" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest.parameter.imagePullSecrets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.LocalObjectReference]

ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount.

ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest.parameter.secrets"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ObjectReference]

Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use.

Pods are only limited to this list if this service account has a "kubernetes.io/enforce-mountable-secrets" annotation set to "true". This field should not be used to find auto-generated service account token secrets for use outside of pods. Instead, tokens can be requested directly using the TokenRequest API, or service account token secrets can be manually created. More info: https://kubernetes.io/docs/concepts/configuration/secret

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccount". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccount".

---

### KubeServiceAccountList <a name="KubeServiceAccountList" id="cdk8s-plus-28.k8s.KubeServiceAccountList"></a>

ServiceAccountList is a list of ServiceAccount objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountList(
  scope: Construct,
  id: str,
  items: typing.List[KubeServiceAccountProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeServiceAccountProps]</code> | List of ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceAccountProps]

List of ServiceAccounts.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeServiceAccountList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeServiceAccountList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccountList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceAccountList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceAccountList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceAccountList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountList.manifest(
  items: typing.List[KubeServiceAccountProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccountList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceAccountList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceAccountProps]

List of ServiceAccounts.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccountList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccountList".

---

### KubeServiceList <a name="KubeServiceList" id="cdk8s-plus-28.k8s.KubeServiceList"></a>

ServiceList holds a list of services.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceList(
  scope: Construct,
  id: str,
  items: typing.List[KubeServiceProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeServiceProps]</code> | List of services. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceProps]

List of services.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeServiceList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeServiceList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeServiceList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeServiceList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeServiceList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceList.manifest(
  items: typing.List[KubeServiceProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceProps]

List of services.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeServiceList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeServiceList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceList".

---

### KubeStatefulSet <a name="KubeStatefulSet" id="cdk8s-plus-28.k8s.KubeStatefulSet"></a>

StatefulSet represents a set of pods with consistent identities.

Identities are defined as:

* Network: A single stable DNS and hostname.
* Storage: As many VolumeClaims as requested.

The StatefulSet guarantees that a given network identity will always map to the same storage identity.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSet(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: StatefulSetSpec = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.StatefulSetSpec</code> | Spec defines the desired identities of pods in this set. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.StatefulSetSpec

Spec defines the desired identities of pods in this set.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStatefulSet.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStatefulSet.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatefulSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStatefulSet.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSet". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSet.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSet.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatefulSet.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSet.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatefulSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatefulSet.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSet.manifest(
  metadata: ObjectMeta = None,
  spec: StatefulSetSpec = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSet.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStatefulSet.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.StatefulSetSpec

Spec defines the desired identities of pods in this set.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSet".

---

### KubeStatefulSetList <a name="KubeStatefulSetList" id="cdk8s-plus-28.k8s.KubeStatefulSetList"></a>

StatefulSetList is a collection of StatefulSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetList(
  scope: Construct,
  id: str,
  items: typing.List[KubeStatefulSetProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStatefulSetProps]</code> | Items is the list of stateful sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStatefulSetProps]

Items is the list of stateful sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStatefulSetList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStatefulSetList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSetList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatefulSetList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatefulSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatefulSetList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetList.manifest(
  items: typing.List[KubeStatefulSetProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStatefulSetList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStatefulSetProps]

Items is the list of stateful sets.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSetList".

---

### KubeStatus <a name="KubeStatus" id="cdk8s-plus-28.k8s.KubeStatus"></a>

Status is a return value for calls that don't return other objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatus.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatus(
  scope: Construct,
  id: str,
  code: typing.Union[int, float] = None,
  details: StatusDetails = None,
  message: str = None,
  metadata: ListMeta = None,
  reason: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.code">code</a></code> | <code>typing.Union[int, float]</code> | Suggested HTTP return code for this status, 0 if not set. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.details">details</a></code> | <code>cdk8s_plus_28.k8s.StatusDetails</code> | Extended data associated with the reason. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.message">message</a></code> | <code>str</code> | A human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.reason">reason</a></code> | <code>str</code> | A machine-readable description of why this operation is in the "Failure" status. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `code`<sup>Optional</sup> <a name="code" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.code"></a>

- *Type:* typing.Union[int, float]

Suggested HTTP return code for this status, 0 if not set.

---

##### `details`<sup>Optional</sup> <a name="details" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.details"></a>

- *Type:* cdk8s_plus_28.k8s.StatusDetails

Extended data associated with the reason.

Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.message"></a>

- *Type:* str

A human-readable description of the status of this operation.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.reason"></a>

- *Type:* str

A machine-readable description of why this operation is in the "Failure" status.

If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStatus.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStatus.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatus.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStatus.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatus.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStatus.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apimachinery.pkg.apis.meta.v1.Status". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStatus.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatus.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatus.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStatus.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatus.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatus.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatus.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatus.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatus.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatus.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatus.manifest(
  code: typing.Union[int, float] = None,
  details: StatusDetails = None,
  message: str = None,
  metadata: ListMeta = None,
  reason: str = None
)
```

Renders a Kubernetes manifest for "io.k8s.apimachinery.pkg.apis.meta.v1.Status".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `code`<sup>Optional</sup> <a name="code" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.code"></a>

- *Type:* typing.Union[int, float]

Suggested HTTP return code for this status, 0 if not set.

---

###### `details`<sup>Optional</sup> <a name="details" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.details"></a>

- *Type:* cdk8s_plus_28.k8s.StatusDetails

Extended data associated with the reason.

Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.

---

###### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.message"></a>

- *Type:* str

A human-readable description of the status of this operation.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

###### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.reason"></a>

- *Type:* str

A machine-readable description of why this operation is in the "Failure" status.

If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatus.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStatus.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStatus.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatus.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatus.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatus.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatus.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apimachinery.pkg.apis.meta.v1.Status". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatus.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apimachinery.pkg.apis.meta.v1.Status".

---

### KubeStorageClass <a name="KubeStorageClass" id="cdk8s-plus-28.k8s.KubeStorageClass"></a>

StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.

StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClass(
  scope: Construct,
  id: str,
  provisioner: str,
  allowed_topologies: typing.List[TopologySelectorTerm] = None,
  allow_volume_expansion: bool = None,
  metadata: ObjectMeta = None,
  mount_options: typing.List[str] = None,
  parameters: typing.Mapping[str] = None,
  reclaim_policy: str = None,
  volume_binding_mode: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.provisioner">provisioner</a></code> | <code>str</code> | provisioner indicates the type of the provisioner. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.allowedTopologies">allowed_topologies</a></code> | <code>typing.List[cdk8s_plus_28.k8s.TopologySelectorTerm]</code> | allowedTopologies restrict the node topologies where volumes can be dynamically provisioned. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.allowVolumeExpansion">allow_volume_expansion</a></code> | <code>bool</code> | allowVolumeExpansion shows whether the storage class allow volume expand. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.parameters">parameters</a></code> | <code>typing.Mapping[str]</code> | parameters holds the parameters for the provisioner that should create volumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.reclaimPolicy">reclaim_policy</a></code> | <code>str</code> | reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.volumeBindingMode">volume_binding_mode</a></code> | <code>str</code> | volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `provisioner`<sup>Required</sup> <a name="provisioner" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.provisioner"></a>

- *Type:* str

provisioner indicates the type of the provisioner.

---

##### `allowed_topologies`<sup>Optional</sup> <a name="allowed_topologies" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.allowedTopologies"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.TopologySelectorTerm]

allowedTopologies restrict the node topologies where volumes can be dynamically provisioned.

Each volume plugin defines its own supported topology specifications. An empty TopologySelectorTerm list means there is no topology restriction. This field is only honored by servers that enable the VolumeScheduling feature.

---

##### `allow_volume_expansion`<sup>Optional</sup> <a name="allow_volume_expansion" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.allowVolumeExpansion"></a>

- *Type:* bool

allowVolumeExpansion shows whether the storage class allow volume expand.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.mountOptions"></a>

- *Type:* typing.List[str]

mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class.

e.g. ["ro", "soft"]. Not validated - mount of the PVs will simply fail if one is invalid.

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.parameters"></a>

- *Type:* typing.Mapping[str]

parameters holds the parameters for the provisioner that should create volumes of this storage class.

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.reclaimPolicy"></a>

- *Type:* str
- *Default:* Delete.

reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class.

Defaults to Delete.

---

##### `volume_binding_mode`<sup>Optional</sup> <a name="volume_binding_mode" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.volumeBindingMode"></a>

- *Type:* str

volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.

When unset, VolumeBindingImmediate is used. This field is only honored by servers that enable the VolumeScheduling feature.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStorageClass.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStorageClass.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStorageClass.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClass". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStorageClass.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClass.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageClass.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStorageClass.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClass.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageClass.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageClass.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClass.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClass.manifest(
  provisioner: str,
  allowed_topologies: typing.List[TopologySelectorTerm] = None,
  allow_volume_expansion: bool = None,
  metadata: ObjectMeta = None,
  mount_options: typing.List[str] = None,
  parameters: typing.Mapping[str] = None,
  reclaim_policy: str = None,
  volume_binding_mode: str = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `provisioner`<sup>Required</sup> <a name="provisioner" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.provisioner"></a>

- *Type:* str

provisioner indicates the type of the provisioner.

---

###### `allowed_topologies`<sup>Optional</sup> <a name="allowed_topologies" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.allowedTopologies"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.TopologySelectorTerm]

allowedTopologies restrict the node topologies where volumes can be dynamically provisioned.

Each volume plugin defines its own supported topology specifications. An empty TopologySelectorTerm list means there is no topology restriction. This field is only honored by servers that enable the VolumeScheduling feature.

---

###### `allow_volume_expansion`<sup>Optional</sup> <a name="allow_volume_expansion" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.allowVolumeExpansion"></a>

- *Type:* bool

allowVolumeExpansion shows whether the storage class allow volume expand.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

###### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.mountOptions"></a>

- *Type:* typing.List[str]

mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class.

e.g. ["ro", "soft"]. Not validated - mount of the PVs will simply fail if one is invalid.

---

###### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.parameters"></a>

- *Type:* typing.Mapping[str]

parameters holds the parameters for the provisioner that should create volumes of this storage class.

---

###### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.reclaimPolicy"></a>

- *Type:* str
- *Default:* Delete.

reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class.

Defaults to Delete.

---

###### `volume_binding_mode`<sup>Optional</sup> <a name="volume_binding_mode" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.volumeBindingMode"></a>

- *Type:* str

volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.

When unset, VolumeBindingImmediate is used. This field is only honored by servers that enable the VolumeScheduling feature.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageClass.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStorageClass.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStorageClass.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageClass.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageClass.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClass.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageClass.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageClass.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClass".

---

### KubeStorageClassList <a name="KubeStorageClassList" id="cdk8s-plus-28.k8s.KubeStorageClassList"></a>

StorageClassList is a collection of storage classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassList(
  scope: Construct,
  id: str,
  items: typing.List[KubeStorageClassProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStorageClassProps]</code> | items is the list of StorageClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageClassProps]

items is the list of StorageClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStorageClassList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStorageClassList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStorageClassList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClassList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageClassList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageClassList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassList.manifest(
  items: typing.List[KubeStorageClassProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageClassList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageClassProps]

items is the list of StorageClasses.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClassList".

---

### KubeStorageVersionListV1Alpha1 <a name="KubeStorageVersionListV1Alpha1" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1"></a>

A list of StorageVersions.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeStorageVersionV1Alpha1Props],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStorageVersionV1Alpha1Props]</code> | Items holds a list of StorageVersion. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageVersionV1Alpha1Props]

Items holds a list of StorageVersion.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1.manifest(
  items: typing.List[KubeStorageVersionV1Alpha1Props],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageVersionV1Alpha1Props]

Items holds a list of StorageVersion.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList".

---

### KubeStorageVersionV1Alpha1 <a name="KubeStorageVersionV1Alpha1" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1"></a>

Storage version of a specific resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1(
  scope: Construct,
  id: str,
  spec: typing.Any,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>typing.Any</code> | Spec is an empty spec. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | The name is <group>.<resource>. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.spec"></a>

- *Type:* typing.Any

Spec is an empty spec.

It is here to comply with Kubernetes API style.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

The name is <group>.<resource>.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1.manifest(
  spec: typing.Any,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest.parameter.spec"></a>

- *Type:* typing.Any

Spec is an empty spec.

It is here to comply with Kubernetes API style.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

The name is <group>.<resource>.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion".

---

### KubeSubjectAccessReview <a name="KubeSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview"></a>

SubjectAccessReview checks whether or not a user or group can perform an action.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReview(
  scope: Construct,
  id: str,
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SubjectAccessReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReview.manifest(
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SubjectAccessReview".

---

### KubeTokenRequest <a name="KubeTokenRequest" id="cdk8s-plus-28.k8s.KubeTokenRequest"></a>

TokenRequest requests a token for a given service account.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequest(
  scope: Construct,
  id: str,
  spec: TokenRequestSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.TokenRequestSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.TokenRequestSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeTokenRequest.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeTokenRequest.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeTokenRequest.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeTokenRequest.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenRequest". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequest.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequest.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeTokenRequest.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequest.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeTokenRequest.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeTokenRequest.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequest.manifest(
  spec: TokenRequestSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenRequest".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenRequest.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.TokenRequestSpec

Spec holds information about the request being evaluated.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequest.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenRequest". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenRequest".

---

### KubeTokenReview <a name="KubeTokenReview" id="cdk8s-plus-28.k8s.KubeTokenReview"></a>

TokenReview attempts to authenticate a token to a known user.

Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReview(
  scope: Construct,
  id: str,
  spec: TokenReviewSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.TokenReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.TokenReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeTokenReview.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeTokenReview.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeTokenReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeTokenReview.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenReview". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeTokenReview.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReview.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeTokenReview.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeTokenReview.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReview.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeTokenReview.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeTokenReview.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReview.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeTokenReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeTokenReview.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReview.manifest(
  spec: TokenReviewSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenReview.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.TokenReviewSpec

Spec holds information about the request being evaluated.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReview.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeTokenReview.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeTokenReview.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeTokenReview.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeTokenReview.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeTokenReview.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReview.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeTokenReview.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeTokenReview.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenReview".

---

### KubeValidatingAdmissionPolicyBindingListV1Alpha1 <a name="KubeValidatingAdmissionPolicyBindingListV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest(
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props]

List of PolicyBinding.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList".

---

### KubeValidatingAdmissionPolicyBindingListV1Beta1 <a name="KubeValidatingAdmissionPolicyBindingListV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1(
  scope: Construct,
  id: str,
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest(
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props]

List of PolicyBinding.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList".

---

### KubeValidatingAdmissionPolicyBindingV1Alpha1 <a name="KubeValidatingAdmissionPolicyBindingV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Alpha1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Alpha1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding".

---

### KubeValidatingAdmissionPolicyBindingV1Beta1 <a name="KubeValidatingAdmissionPolicyBindingV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Beta1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Beta1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding".

---

### KubeValidatingAdmissionPolicyListV1Alpha1 <a name="KubeValidatingAdmissionPolicyListV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1(
  scope: Construct,
  id: str,
  items: typing.List[KubeValidatingAdmissionPolicyV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest(
  items: typing.List[KubeValidatingAdmissionPolicyV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props]

List of ValidatingAdmissionPolicy.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList".

---

### KubeValidatingAdmissionPolicyListV1Beta1 <a name="KubeValidatingAdmissionPolicyListV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1(
  scope: Construct,
  id: str,
  items: typing.List[KubeValidatingAdmissionPolicyV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest(
  items: typing.List[KubeValidatingAdmissionPolicyV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props]

List of ValidatingAdmissionPolicy.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList".

---

### KubeValidatingAdmissionPolicyV1Alpha1 <a name="KubeValidatingAdmissionPolicyV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Alpha1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Alpha1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy".

---

### KubeValidatingAdmissionPolicyV1Beta1 <a name="KubeValidatingAdmissionPolicyV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Beta1 = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Beta1 = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy".

---

### KubeValidatingWebhookConfiguration <a name="KubeValidatingWebhookConfiguration" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration"></a>

ValidatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfiguration(
  scope: Construct,
  id: str,
  metadata: ObjectMeta = None,
  webhooks: typing.List[ValidatingWebhook] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.webhooks">webhooks</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ValidatingWebhook]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.webhooks"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfiguration.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfiguration.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfiguration.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfiguration.manifest(
  metadata: ObjectMeta = None,
  webhooks: typing.List[ValidatingWebhook] = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

###### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest.parameter.webhooks"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration".

---

### KubeValidatingWebhookConfigurationList <a name="KubeValidatingWebhookConfigurationList" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList"></a>

ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationList(
  scope: Construct,
  id: str,
  items: typing.List[KubeValidatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingWebhookConfigurationProps]</code> | List of ValidatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingWebhookConfigurationProps]

List of ValidatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationList.manifest(
  items: typing.List[KubeValidatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingWebhookConfigurationProps]

List of ValidatingWebhookConfiguration.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList".

---

### KubeVolumeAttachment <a name="KubeVolumeAttachment" id="cdk8s-plus-28.k8s.KubeVolumeAttachment"></a>

VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.

VolumeAttachment objects are non-namespaced.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachment(
  scope: Construct,
  id: str,
  spec: VolumeAttachmentSpec,
  metadata: ObjectMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.VolumeAttachmentSpec</code> | spec represents specification of the desired attach/detach volume behavior. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.VolumeAttachmentSpec

spec represents specification of the desired attach/detach volume behavior.

Populated by the Kubernetes system.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachment". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachment.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachment.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachment.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachment.manifest(
  spec: VolumeAttachmentSpec,
  metadata: ObjectMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachment".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest.parameter.spec"></a>

- *Type:* cdk8s_plus_28.k8s.VolumeAttachmentSpec

spec represents specification of the desired attach/detach volume behavior.

Populated by the Kubernetes system.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachment". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachment".

---

### KubeVolumeAttachmentList <a name="KubeVolumeAttachmentList" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList"></a>

VolumeAttachmentList is a collection of VolumeAttachment objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentList(
  scope: Construct,
  id: str,
  items: typing.List[KubeVolumeAttachmentProps],
  metadata: ListMeta = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.id">id</a></code> | <code>str</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeVolumeAttachmentProps]</code> | items is the list of VolumeAttachments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.id"></a>

- *Type:* str

a scope-local name for the object.

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeVolumeAttachmentProps]

items is the list of VolumeAttachments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency">add_dependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch">add_json_patch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toJson">to_json</a></code> | Renders the object to Kubernetes JSON. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `add_dependency` <a name="add_dependency" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency"></a>

```python
def add_dependency(
  dependencies: IConstruct
) -> None
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `add_json_patch` <a name="add_json_patch" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch"></a>

```python
def add_json_patch(
  ops: JsonPatch
) -> None
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```python
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `to_json` <a name="to_json" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toJson"></a>

```python
def to_json() -> typing.Any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject">is_api_object</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachmentList". |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentList.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `is_api_object` <a name="is_api_object" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentList.is_api_object(
  o: typing.Any
)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject.parameter.o"></a>

- *Type:* typing.Any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentList.of(
  c: IConstruct
)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentList.manifest(
  items: typing.List[KubeVolumeAttachmentProps],
  metadata: ListMeta = None
)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachmentList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest.parameter.items"></a>

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeVolumeAttachmentProps]

items is the list of VolumeAttachments.

---

###### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest.parameter.metadata"></a>

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.kind">kind</a></code> | <code>str</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.name">name</a></code> | <code>str</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.chart"></a>

```python
chart: Chart
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachmentList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.GVK"></a>

```python
GVK: GroupVersionKind
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachmentList".

---

### Namespace <a name="Namespace" id="cdk8s-plus-28.Namespace"></a>

- *Implements:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

In Kubernetes, namespaces provides a mechanism for isolating groups of resources within a single cluster.

Names of resources need to be unique within a namespace, but not across namespaces.
Namespace-based scoping is applicable only for namespaced objects (e.g. Deployments, Services, etc) and
not for cluster-wide objects (e.g. StorageClass, Nodes, PersistentVolumes, etc).

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Namespace.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespace(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespace.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespace.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Namespace.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Namespace.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Namespace.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Namespace.toNamespaceSelectorConfig">to_namespace_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Namespace.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Namespace.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Namespace.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Namespace.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Namespace.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `to_namespace_selector_config` <a name="to_namespace_selector_config" id="cdk8s-plus-28.Namespace.toNamespaceSelectorConfig"></a>

```python
def to_namespace_selector_config() -> NamespaceSelectorConfig
```

Return the configuration of this selector.

> [INamespaceSelector.toNamespaceSelectorConfig()](INamespaceSelector.toNamespaceSelectorConfig())

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Namespace.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Namespace.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Namespace.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespace.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Namespace.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Namespace.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Namespace.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Namespace.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Namespace.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Namespace.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Namespace.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Namespace.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Namespace.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Namespace.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Namespace.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Namespace.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Namespace.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.property.NAME_LABEL">NAME_LABEL</a></code> | <code>str</code> | *No description.* |

---

##### `NAME_LABEL`<sup>Required</sup> <a name="NAME_LABEL" id="cdk8s-plus-28.Namespace.property.NAME_LABEL"></a>

```python
NAME_LABEL: str
```

- *Type:* str

> [https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/#automatic-labelling](https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/#automatic-labelling)

---

### Namespaces <a name="Namespaces" id="cdk8s-plus-28.Namespaces"></a>

- *Implements:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Represents a group of namespaces.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Namespaces.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespaces(
  scope: Construct,
  id: str,
  expressions: typing.List[LabelExpression] = None,
  names: typing.List[str] = None,
  labels: typing.Mapping[str] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.expressions">expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.names">names</a></code> | <code>typing.List[str]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.labels">labels</a></code> | <code>typing.Mapping[str]</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.Initializer.parameter.id"></a>

- *Type:* str

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Namespaces.Initializer.parameter.expressions"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.Namespaces.Initializer.parameter.names"></a>

- *Type:* typing.List[str]

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Namespaces.Initializer.parameter.labels"></a>

- *Type:* typing.Mapping[str]

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Namespaces.toNamespaceSelectorConfig">to_namespace_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Namespaces.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Namespaces.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Namespaces.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `to_namespace_selector_config` <a name="to_namespace_selector_config" id="cdk8s-plus-28.Namespaces.toNamespaceSelectorConfig"></a>

```python
def to_namespace_selector_config() -> NamespaceSelectorConfig
```

Return the configuration of this selector.

> [INamespaceSelector.toNamespaceSelectorConfig()](INamespaceSelector.toNamespaceSelectorConfig())

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Namespaces.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Namespaces.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Namespaces.all">all</a></code> | Select all namespaces. |
| <code><a href="#cdk8s-plus-28.Namespaces.select">select</a></code> | Select specific namespaces. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Namespaces.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespaces.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Namespaces.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `all` <a name="all" id="cdk8s-plus-28.Namespaces.all"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespaces.all(
  scope: Construct,
  id: str
)
```

Select all namespaces.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.all.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.all.parameter.id"></a>

- *Type:* str

---

##### `select` <a name="select" id="cdk8s-plus-28.Namespaces.select"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Namespaces.select(
  scope: Construct,
  id: str,
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None,
  names: typing.List[str] = None
)
```

Select specific namespaces.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.select.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.select.parameter.id"></a>

- *Type:* str

---

###### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Namespaces.select.parameter.expressions"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]
- *Default:* no selector requirements.

Namespaces must satisfy these selectors.

The selectors query labels, just like the `labels` property, but they
provide a more advanced matching mechanism.

---

###### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Namespaces.select.parameter.labels"></a>

- *Type:* typing.Mapping[str]
- *Default:* no strict labels requirements.

Labels the namespaces must have.

This is equivalent to using an 'Is' selector.

---

###### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.Namespaces.select.parameter.names"></a>

- *Type:* typing.List[str]
- *Default:* no name requirements.

Namespaces names must be one of these.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Namespaces.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---


### NetworkPolicy <a name="NetworkPolicy" id="cdk8s-plus-28.NetworkPolicy"></a>

Control traffic flow at the IP address or port level (OSI layer 3 or 4), network policies are an application-centric construct which allow you to specify how a pod is allowed to communicate with various network peers.

* Outgoing traffic is allowed if there are no network policies selecting
  the pod (and cluster policy otherwise allows the traffic),
  OR if the traffic matches at least one egress rule across all of the
  network policies that select the pod.
* Incoming traffic is allowed to a pod if there are no network policies
  selecting the pod (and cluster policy otherwise allows the traffic),
  OR if the traffic source is the pod's local node,
  OR if the traffic matches at least one ingress rule across all of
  the network policies that select the pod.

Network policies do not conflict; they are additive.
If any policy or policies apply to a given pod for a given
direction, the connections allowed in that direction from
that pod is the union of what the applicable policies allow.
Thus, order of evaluation does not affect the policy result.

For a connection from a source pod to a destination pod to be allowed,
both the egress policy on the source pod and the ingress policy on the
destination pod need to allow the connection.
If either side does not allow the connection, it will not happen.

> [https://kubernetes.io/docs/concepts/services-networking/network-policies/#networkpolicy-resource](https://kubernetes.io/docs/concepts/services-networking/network-policies/#networkpolicy-resource)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.NetworkPolicy.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicy(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  egress: NetworkPolicyTraffic = None,
  ingress: NetworkPolicyTraffic = None,
  selector: IPodSelector = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.egress">egress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Egress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Ingress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods does this policy object applies to. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.egress"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change egress behavior of the pods it selects.

Egress traffic configuration.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.ingress"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change ingress behavior of the pods it selects.

Ingress traffic configuration.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* will select all pods in the namespace of the policy.

Which pods does this policy object applies to.

This can either be a single pod / workload, or a grouping of pods selected
via the `Pods.select` function. Rules is applied to any pods selected by this property.
Multiple network policies can select the same set of pods.
In this case, the rules for each are combined additively.

Note that

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.addEgressRule">add_egress_rule</a></code> | Allow outgoing traffic to the peer. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.addIngressRule">add_ingress_rule</a></code> | Allow incoming traffic from the peer. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.NetworkPolicy.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.NetworkPolicy.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.NetworkPolicy.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_egress_rule` <a name="add_egress_rule" id="cdk8s-plus-28.NetworkPolicy.addEgressRule"></a>

```python
def add_egress_rule(
  peer: INetworkPolicyPeer,
  ports: typing.List[NetworkPolicyPort] = None
) -> None
```

Allow outgoing traffic to the peer.

If ports are not passed, traffic will be allowed on all ports.

###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicy.addEgressRule.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicy.addEgressRule.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]

---

##### `add_ingress_rule` <a name="add_ingress_rule" id="cdk8s-plus-28.NetworkPolicy.addIngressRule"></a>

```python
def add_ingress_rule(
  peer: INetworkPolicyPeer,
  ports: typing.List[NetworkPolicyPort] = None
) -> None
```

Allow incoming traffic from the peer.

If ports are not passed, traffic will be allowed on all ports.

###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicy.addIngressRule.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicy.addIngressRule.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.NetworkPolicy.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicy.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.NetworkPolicy.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.NetworkPolicy.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.NetworkPolicy.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.NetworkPolicy.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.NetworkPolicy.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.NetworkPolicy.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NetworkPolicy.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.NetworkPolicy.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.NetworkPolicy.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.NetworkPolicy.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### NetworkPolicyIpBlock <a name="NetworkPolicyIpBlock" id="cdk8s-plus-28.NetworkPolicyIpBlock"></a>

- *Implements:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Describes a particular CIDR (Ex.

"192.168.1.1/24","2001:db9::/64") that is
allowed to the pods matched by a network policy selector.
The except entry describes CIDRs that should not be included within this rule.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.NetworkPolicyIpBlock.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.NetworkPolicyIpBlock.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.NetworkPolicyIpBlock.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4">any_ipv4</a></code> | Any IPv4 address. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6">any_ipv6</a></code> | Any IPv6 address. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.ipv4">ipv4</a></code> | Create an IPv4 peer from a CIDR. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.ipv6">ipv6</a></code> | Create an IPv6 peer from a CIDR. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyIpBlock.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `any_ipv4` <a name="any_ipv4" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyIpBlock.any_ipv4(
  scope: Construct,
  id: str
)
```

Any IPv4 address.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4.parameter.id"></a>

- *Type:* str

---

##### `any_ipv6` <a name="any_ipv6" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyIpBlock.any_ipv6(
  scope: Construct,
  id: str
)
```

Any IPv6 address.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6.parameter.id"></a>

- *Type:* str

---

##### `ipv4` <a name="ipv4" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyIpBlock.ipv4(
  scope: Construct,
  id: str,
  cidr_ip: str,
  except: typing.List[str] = None
)
```

Create an IPv4 peer from a CIDR.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.id"></a>

- *Type:* str

---

###### `cidr_ip`<sup>Required</sup> <a name="cidr_ip" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.cidrIp"></a>

- *Type:* str

---

###### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.except"></a>

- *Type:* typing.List[str]

---

##### `ipv6` <a name="ipv6" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyIpBlock.ipv6(
  scope: Construct,
  id: str,
  cidr_ip: str,
  except: typing.List[str] = None
)
```

Create an IPv6 peer from a CIDR.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.id"></a>

- *Type:* str

---

###### `cidr_ip`<sup>Required</sup> <a name="cidr_ip" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.cidrIp"></a>

- *Type:* str

---

###### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.except"></a>

- *Type:* typing.List[str]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.cidr">cidr</a></code> | <code>str</code> | A string representing the IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.except">except</a></code> | <code>typing.List[str]</code> | A slice of CIDRs that should not be included within an IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". Except values will be rejected if they are outside the CIDR range. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.cidr"></a>

```python
cidr: str
```

- *Type:* str

A string representing the IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64".

---

##### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.except"></a>

```python
except: typing.List[str]
```

- *Type:* typing.List[str]

A slice of CIDRs that should not be included within an IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". Except values will be rejected if they are outside the CIDR range.

---


### PersistentVolume <a name="PersistentVolume" id="cdk8s-plus-28.PersistentVolume"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IStorage">IStorage</a>

A PersistentVolume (PV) is a piece of storage in the cluster that has been provisioned by an administrator or dynamically provisioned using Storage Classes.

It is a resource in the cluster just like a node is a cluster resource.
PVs are volume plugins like Volumes, but have a lifecycle independent of any
individual Pod that uses the PV. This API object captures the details of the
implementation of the storage, be that NFS, iSCSI, or a
cloud-provider-specific storage system.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PersistentVolume.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolume(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.accessModes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.mountOptions"></a>

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.reclaimPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.storage"></a>

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.storageClassName"></a>

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.volumeMode"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.PersistentVolume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.PersistentVolume.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.PersistentVolume.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.PersistentVolume.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.PersistentVolume.bind"></a>

```python
def bind(
  claim: IPersistentVolumeClaim
) -> None
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.PersistentVolume.reserve"></a>

```python
def reserve() -> PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName">from_persistent_volume_name</a></code> | Imports a pv from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.PersistentVolume.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.PersistentVolume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_persistent_volume_name` <a name="from_persistent_volume_name" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolume.from_persistent_volume_name(
  scope: Construct,
  id: str,
  volume_name: str
)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* str

---

###### `volume_name`<sup>Required</sup> <a name="volume_name" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Storage class this volume belongs to. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.PersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.PersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.PersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolume.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.PersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.PersistentVolume.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.PersistentVolume.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.PersistentVolume.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.PersistentVolume.property.mode"></a>

```python
mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaim_policy`<sup>Required</sup> <a name="reclaim_policy" id="cdk8s-plus-28.PersistentVolume.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolume.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolume.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.PersistentVolume.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolume.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolume.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

Storage class this volume belongs to.

---


### PersistentVolumeClaim <a name="PersistentVolumeClaim" id="cdk8s-plus-28.PersistentVolumeClaim"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

A PersistentVolumeClaim (PVC) is a request for storage by a user.

It is similar to a Pod. Pods consume node resources and PVCs consume PV resources.
Pods can request specific levels of resources (CPU and Memory).
Claims can request specific size and access modes

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeClaim(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume: IPersistentVolume = None,
  volume_mode: PersistentVolumeMode = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains the access modes the volume should support. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.storage">storage</a></code> | <code>cdk8s.Size</code> | Minimum storage size the volume should have. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a></code> | The PersistentVolume backing this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.accessModes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes requirement.

Contains the access modes the volume should support.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.storage"></a>

- *Type:* cdk8s.Size
- *Default:* No storage requirement.

Minimum storage size the volume should have.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.storageClassName"></a>

- *Type:* str
- *Default:* Not set.

Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:.

* If the admission plugin is turned on, the storage class marked as default will be used.
* If the admission plugin is turned off, the pvc can only be bound to volumes without a storage class.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1)

---

##### `volume`<sup>Optional</sup> <a name="volume" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.volume"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>
- *Default:* No specific volume binding.

The PersistentVolume backing this claim.

The control plane still checks that storage class, access modes,
and requested storage size on the volume are valid.

Note that in order to guarantee a proper binding, the volume should
also define a `claimRef` referring to this claim. Otherwise, the volume may be
claimed be other pvc's before it gets a chance to bind to this one.

If the volume is managed (i.e not imported), you can use `pv.claim()` to easily
create a bi-directional bounded claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.)

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.volumeMode"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.bind">bind</a></code> | Bind a claim to a specific volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.PersistentVolumeClaim.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.PersistentVolumeClaim.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.PersistentVolumeClaim.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `bind` <a name="bind" id="cdk8s-plus-28.PersistentVolumeClaim.bind"></a>

```python
def bind(
  vol: IPersistentVolume
) -> None
```

Bind a claim to a specific volume.

Note that you must also bind the volume to the claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.PersistentVolumeClaim.bind.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

The PV to bind to.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.fromClaimName">from_claim_name</a></code> | Imports a pvc from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.PersistentVolumeClaim.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeClaim.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.PersistentVolumeClaim.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_claim_name` <a name="from_claim_name" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeClaim.from_claim_name(
  scope: Construct,
  id: str,
  claim_name: str
)
```

Imports a pvc from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.id"></a>

- *Type:* str

---

###### `claim_name`<sup>Required</sup> <a name="claim_name" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.claimName"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Storage class requirment of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a></code> | PV this claim is bound to. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PersistentVolumeClaim.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.PersistentVolumeClaim.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.PersistentVolumeClaim.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.PersistentVolumeClaim.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeClaim.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.PersistentVolumeClaim.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.PersistentVolumeClaim.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.PersistentVolumeClaim.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.PersistentVolumeClaim.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `volume_mode`<sup>Required</sup> <a name="volume_mode" id="cdk8s-plus-28.PersistentVolumeClaim.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode requirement of this claim.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolumeClaim.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]

Access modes requirement of this claim.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeClaim.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size

Storage requirement of this claim.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolumeClaim.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

Storage class requirment of this claim.

---

##### `volume`<sup>Optional</sup> <a name="volume" id="cdk8s-plus-28.PersistentVolumeClaim.property.volume"></a>

```python
volume: IPersistentVolume
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

PV this claim is bound to.

Undefined means the claim is not bound
to any specific volume.

---


### Pod <a name="Pod" id="cdk8s-plus-28.Pod"></a>

Pod is a collection of containers that can run on a host.

This resource is
created by clients and scheduled onto hosts.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Pod.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pod(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pod.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Pod.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Pod.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.Pod.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.Pod.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Pod.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.Pod.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Pod.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.Pod.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.Pod.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Pod.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Pod.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Pod.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Pod.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.Pod.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Pod.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Pod.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Pod.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Pod.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Pod.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Pod.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Pod.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Pod.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Pod.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.Pod.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Pod.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Pod.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Pod.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Pod.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Pod.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Pod.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Pod.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Pod.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Pod.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Pod.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Pod.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Pod.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Pod.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Pod.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Pod.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Pod.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Pod.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Pod.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Pod.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.Pod.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.Pod.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.Pod.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.Pod.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Pod.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Pod.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Pod.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Pod.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Pod.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Pod.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Pod.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Pod.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Pod.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Pod.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Pod.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Pod.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Pod.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Pod.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Pod.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Pod.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Pod.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Pod.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Pod.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.Pod.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Pod.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.Pod.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Pod.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Pod.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Pod.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.Pod.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.Pod.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Pod.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pod.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Pod.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Pod.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Pod.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Pod.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Pod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Pod.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Pod.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Pod.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.PodScheduling">PodScheduling</a></code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Pod.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Pod.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Pod.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Pod.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Pod.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Pod.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Pod.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Pod.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Pod.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Pod.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Pod.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Pod.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.Pod.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.Pod.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.Pod.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.Pod.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Pod.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Pod.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Pod.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Pod.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Pod.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Pod.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Pod.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Pod.property.scheduling"></a>

```python
scheduling: PodScheduling
```

- *Type:* <a href="#cdk8s-plus-28.PodScheduling">PodScheduling</a>

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.property.ADDRESS_LABEL">ADDRESS_LABEL</a></code> | <code>str</code> | This label is autoamtically added by cdk8s to any pod. |

---

##### `ADDRESS_LABEL`<sup>Required</sup> <a name="ADDRESS_LABEL" id="cdk8s-plus-28.Pod.property.ADDRESS_LABEL"></a>

```python
ADDRESS_LABEL: str
```

- *Type:* str

This label is autoamtically added by cdk8s to any pod.

It provides
a unique and stable identifier for the pod.

---

### Pods <a name="Pods" id="cdk8s-plus-28.Pods"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

Represents a group of pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Pods.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pods(
  scope: Construct,
  id: str,
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None,
  namespaces: INamespaceSelector = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.expressions">expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.labels">labels</a></code> | <code>typing.Mapping[str]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.Initializer.parameter.id"></a>

- *Type:* str

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Pods.Initializer.parameter.expressions"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Pods.Initializer.parameter.labels"></a>

- *Type:* typing.Mapping[str]

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.Pods.Initializer.parameter.namespaces"></a>

- *Type:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Pods.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.toPodSelector">to_pod_selector</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Pods.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Pods.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Pods.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.Pods.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Pods.all">all</a></code> | Select all pods. |
| <code><a href="#cdk8s-plus-28.Pods.select">select</a></code> | Select pods in the cluster with various selectors. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Pods.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pods.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Pods.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `all` <a name="all" id="cdk8s-plus-28.Pods.all"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pods.all(
  scope: Construct,
  id: str,
  namespaces: Namespaces = None
)
```

Select all pods.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.all.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.all.parameter.id"></a>

- *Type:* str

---

###### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.Pods.all.parameter.namespaces"></a>

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

##### `select` <a name="select" id="cdk8s-plus-28.Pods.select"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Pods.select(
  scope: Construct,
  id: str,
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None,
  namespaces: Namespaces = None
)
```

Select pods in the cluster with various selectors.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.select.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.select.parameter.id"></a>

- *Type:* str

---

###### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Pods.select.parameter.expressions"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]
- *Default:* no expressions requirements.

Expressions the pods must satisify.

---

###### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Pods.select.parameter.labels"></a>

- *Type:* typing.Mapping[str]
- *Default:* no strict labels requirements.

Labels the pods must have.

---

###### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.Pods.select.parameter.namespaces"></a>

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Pods.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---


### Resource <a name="Resource" id="cdk8s-plus-28.Resource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Base class for all Kubernetes objects in stdk8s.

Represents a single
resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Resource.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Resource(
  scope: Construct,
  id: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Resource.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Resource.Initializer.parameter.id"></a>

- *Type:* str

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Resource.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Resource.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Resource.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Resource.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Resource.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Resource.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Resource.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Resource.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Resource.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Resource.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Resource.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Resource.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Resource.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Resource.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Resource.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Resource.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Resource.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Resource.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Resource.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Resource.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Resource.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Resource.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Resource.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### Role <a name="Role" id="cdk8s-plus-28.Role"></a>

- *Implements:* <a href="#cdk8s-plus-28.IRole">IRole</a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Role.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Role(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  rules: typing.List[RolePolicyRule] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]</code> | A list of rules the role should allow. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Role.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Role.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Role.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.Role.Initializer.parameter.rules"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]
- *Default:* []

A list of rules the role should allow.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Role.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Role.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Role.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Role.allow">allow</a></code> | Add permission to perform a list of HTTP verbs on a collection of resources. |
| <code><a href="#cdk8s-plus-28.Role.allowCreate">allow_create</a></code> | Add "create" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowDelete">allow_delete</a></code> | Add "delete" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowDeleteCollection">allow_delete_collection</a></code> | Add "deletecollection" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowGet">allow_get</a></code> | Add "get" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowList">allow_list</a></code> | Add "list" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowPatch">allow_patch</a></code> | Add "patch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowRead">allow_read</a></code> | Add "get", "list", and "watch" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowReadWrite">allow_read_write</a></code> | Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowUpdate">allow_update</a></code> | Add "update" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowWatch">allow_watch</a></code> | Add "watch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.bind">bind</a></code> | Create a RoleBinding that binds the permissions in this Role to a list of subjects, that will only apply this role's namespace. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Role.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Role.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Role.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `allow` <a name="allow" id="cdk8s-plus-28.Role.allow"></a>

```python
def allow(
  verbs: typing.List[str],
  resources: IApiResource
) -> None
```

Add permission to perform a list of HTTP verbs on a collection of resources.

> [https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb](https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb)

###### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.Role.allow.parameter.verbs"></a>

- *Type:* typing.List[str]

---

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allow.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_create` <a name="allow_create" id="cdk8s-plus-28.Role.allowCreate"></a>

```python
def allow_create(
  resources: IApiResource
) -> None
```

Add "create" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowCreate.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_delete` <a name="allow_delete" id="cdk8s-plus-28.Role.allowDelete"></a>

```python
def allow_delete(
  resources: IApiResource
) -> None
```

Add "delete" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowDelete.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_delete_collection` <a name="allow_delete_collection" id="cdk8s-plus-28.Role.allowDeleteCollection"></a>

```python
def allow_delete_collection(
  resources: IApiResource
) -> None
```

Add "deletecollection" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowDeleteCollection.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_get` <a name="allow_get" id="cdk8s-plus-28.Role.allowGet"></a>

```python
def allow_get(
  resources: IApiResource
) -> None
```

Add "get" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowGet.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_list` <a name="allow_list" id="cdk8s-plus-28.Role.allowList"></a>

```python
def allow_list(
  resources: IApiResource
) -> None
```

Add "list" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowList.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_patch` <a name="allow_patch" id="cdk8s-plus-28.Role.allowPatch"></a>

```python
def allow_patch(
  resources: IApiResource
) -> None
```

Add "patch" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowPatch.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_read` <a name="allow_read" id="cdk8s-plus-28.Role.allowRead"></a>

```python
def allow_read(
  resources: IApiResource
) -> None
```

Add "get", "list", and "watch" permissions for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowRead.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_read_write` <a name="allow_read_write" id="cdk8s-plus-28.Role.allowReadWrite"></a>

```python
def allow_read_write(
  resources: IApiResource
) -> None
```

Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowReadWrite.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_update` <a name="allow_update" id="cdk8s-plus-28.Role.allowUpdate"></a>

```python
def allow_update(
  resources: IApiResource
) -> None
```

Add "update" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowUpdate.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allow_watch` <a name="allow_watch" id="cdk8s-plus-28.Role.allowWatch"></a>

```python
def allow_watch(
  resources: IApiResource
) -> None
```

Add "watch" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowWatch.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `bind` <a name="bind" id="cdk8s-plus-28.Role.bind"></a>

```python
def bind(
  subjects: ISubject
) -> RoleBinding
```

Create a RoleBinding that binds the permissions in this Role to a list of subjects, that will only apply this role's namespace.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.Role.bind.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Role.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Role.fromRoleName">from_role_name</a></code> | Imports a role from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Role.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Role.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Role.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_role_name` <a name="from_role_name" id="cdk8s-plus-28.Role.fromRoleName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Role.from_role_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a role from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Role.fromRoleName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Role.fromRoleName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Role.fromRoleName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Role.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Role.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Role.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Role.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Role.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Role.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Role.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Role.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]</code> | Rules associaated with this Role. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Role.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Role.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Role.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Role.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Role.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Role.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Role.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Role.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Role.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.Role.property.rules"></a>

```python
rules: typing.List[RolePolicyRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]

Rules associaated with this Role.

Returns a copy, use `allow` to add rules.

---


### RoleBinding <a name="RoleBinding" id="cdk8s-plus-28.RoleBinding"></a>

A RoleBinding grants permissions within a specific namespace to a user or set of users.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.RoleBinding.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.RoleBinding(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  role: IRole
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.role">role</a></code> | <code><a href="#cdk8s-plus-28.IRole">IRole</a></code> | The role to bind to. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.role"></a>

- *Type:* <a href="#cdk8s-plus-28.IRole">IRole</a>

The role to bind to.

A RoleBinding can reference a Role or a ClusterRole.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.RoleBinding.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.RoleBinding.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.RoleBinding.addSubjects">add_subjects</a></code> | Adds a subject to the role. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.RoleBinding.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.RoleBinding.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.RoleBinding.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_subjects` <a name="add_subjects" id="cdk8s-plus-28.RoleBinding.addSubjects"></a>

```python
def add_subjects(
  subjects: ISubject
) -> None
```

Adds a subject to the role.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.RoleBinding.addSubjects.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

The subjects to add.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.RoleBinding.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.RoleBinding.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.RoleBinding.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IRole">IRole</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.subjects">subjects</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ISubject">ISubject</a>]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.RoleBinding.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.RoleBinding.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.RoleBinding.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.RoleBinding.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.RoleBinding.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.RoleBinding.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.RoleBinding.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.RoleBinding.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.RoleBinding.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.RoleBinding.property.role"></a>

```python
role: IRole
```

- *Type:* <a href="#cdk8s-plus-28.IRole">IRole</a>

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.RoleBinding.property.subjects"></a>

```python
subjects: typing.List[ISubject]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ISubject">ISubject</a>]

---


### Secret <a name="Secret" id="cdk8s-plus-28.Secret"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

Kubernetes Secrets let you store and manage sensitive information, such as passwords, OAuth tokens, and ssh keys.

Storing confidential information in a
Secret is safer and more flexible than putting it verbatim in a Pod
definition or in a container image.

> [https://kubernetes.io/docs/concepts/configuration/secret](https://kubernetes.io/docs/concepts/configuration/secret)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Secret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Secret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  string_data: typing.Mapping[str] = None,
  type: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.stringData">string_data</a></code> | <code>typing.Mapping[str]</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.type">type</a></code> | <code>str</code> | Optional type associated with the secret. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Secret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Secret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Secret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.Secret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `string_data`<sup>Optional</sup> <a name="string_data" id="cdk8s-plus-28.Secret.Initializer.parameter.stringData"></a>

- *Type:* typing.Mapping[str]

stringData allows specifying non-binary secret data in string form.

It is
provided as a write-only convenience method. All keys and values are merged
into the data field on write, overwriting any existing values. It is never
output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.Secret.Initializer.parameter.type"></a>

- *Type:* str
- *Default:* undefined - Don't set a type.

Optional type associated with the secret.

Used to facilitate programmatic
handling of secret data by various controllers.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Secret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Secret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Secret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.Secret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.Secret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Secret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Secret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Secret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.Secret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Secret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.Secret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.Secret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.Secret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Secret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Secret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Secret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Secret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.Secret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Secret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Secret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Secret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Secret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Secret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Secret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Secret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Secret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Secret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Secret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Secret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Secret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Secret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Secret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Secret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Secret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Secret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Secret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Secret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Secret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.Secret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### Service <a name="Service" id="cdk8s-plus-28.Service"></a>

An abstract way to expose an application running on a set of Pods as a network service.

With Kubernetes you don't need to modify your application to use an unfamiliar service discovery mechanism.
Kubernetes gives Pods their own IP addresses and a single DNS name for a set of Pods, and can load-balance across them.

For example, consider a stateless image-processing backend which is running with 3 replicas. Those replicas are fungible—frontends do not care which backend they use.
While the actual Pods that compose the backend set may change, the frontend clients should not need to be aware of that,
nor should they need to keep track of the set of backends themselves.
The Service abstraction enables this decoupling.

If you're able to use Kubernetes APIs for service discovery in your application, you can query the API server for Endpoints,
that get updated whenever the set of Pods in a Service changes. For non-native applications, Kubernetes offers ways to place a network port
or load balancer in between your application and the backend Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Service.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Service(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  cluster_i_p: str = None,
  external_i_ps: typing.List[str] = None,
  external_name: str = None,
  load_balancer_source_ranges: typing.List[str] = None,
  ports: typing.List[ServicePort] = None,
  publish_not_ready_addresses: bool = None,
  selector: IPodSelector = None,
  type: ServiceType = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.clusterIP">cluster_i_p</a></code> | <code>str</code> | The IP address of the service and is usually assigned randomly by the master. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.externalIPs">external_i_ps</a></code> | <code>typing.List[str]</code> | A list of IP addresses for which nodes in the cluster will also accept traffic for this service. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.externalName">external_name</a></code> | <code>str</code> | The externalName to be used when ServiceType.EXTERNAL_NAME is set. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.loadBalancerSourceRanges">load_balancer_source_ranges</a></code> | <code>typing.List[str]</code> | A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]</code> | The ports this service binds to. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.publishNotReadyAddresses">publish_not_ready_addresses</a></code> | <code>bool</code> | The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods should the service select and route to. |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.type">type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | Determines how the Service is exposed. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Service.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Service.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Service.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `cluster_i_p`<sup>Optional</sup> <a name="cluster_i_p" id="cdk8s-plus-28.Service.Initializer.parameter.clusterIP"></a>

- *Type:* str
- *Default:* Automatically assigned.

The IP address of the service and is usually assigned randomly by the master.

If an address is specified manually and is not in use by others, it
will be allocated to the service; otherwise, creation of the service will
fail. This field can not be changed through updates. Valid values are
"None", empty string (""), or a valid IP address. "None" can be specified
for headless services when proxying is not required. Only applies to types
ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName.

> [https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies](https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies)

---

##### `external_i_ps`<sup>Optional</sup> <a name="external_i_ps" id="cdk8s-plus-28.Service.Initializer.parameter.externalIPs"></a>

- *Type:* typing.List[str]
- *Default:* No external IPs.

A list of IP addresses for which nodes in the cluster will also accept traffic for this service.

These IPs are not managed by Kubernetes. The user
is responsible for ensuring that traffic arrives at a node with this IP. A
common example is external load-balancers that are not part of the
Kubernetes system.

---

##### `external_name`<sup>Optional</sup> <a name="external_name" id="cdk8s-plus-28.Service.Initializer.parameter.externalName"></a>

- *Type:* str
- *Default:* No external name.

The externalName to be used when ServiceType.EXTERNAL_NAME is set.

---

##### `load_balancer_source_ranges`<sup>Optional</sup> <a name="load_balancer_source_ranges" id="cdk8s-plus-28.Service.Initializer.parameter.loadBalancerSourceRanges"></a>

- *Type:* typing.List[str]

A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs.

More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Service.Initializer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* either the selector ports, or none.

The ports this service binds to.

If the selector of the service is a managed pod / workload,
its ports will are automatically extracted and used as the default value.
Otherwise, no ports are bound.

---

##### `publish_not_ready_addresses`<sup>Optional</sup> <a name="publish_not_ready_addresses" id="cdk8s-plus-28.Service.Initializer.parameter.publishNotReadyAddresses"></a>

- *Type:* bool
- *Default:* false

The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready.

More info: https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.30/#servicespec-v1-core

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.Service.Initializer.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* unset, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify.

Which pods should the service select and route to.

You can pass one of the following:

* An instance of `Pod` or any workload resource (e.g `Deployment`, `StatefulSet`, ...)
* Pods selected by the `Pods.select` function. Note that in this case only labels can be specified.

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
# select the pods of a specific deployment
backend = kplus.Deployment(self, "Backend", ...)
kplus.Service(self, "Service", selector=backend)

# select all pods labeled with the `tier=backend` label
backend = kplus.Pod.labeled(tier="backend")
kplus.Service(self, "Service", selector=backend)
```


##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.Service.Initializer.parameter.type"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ServiceType.ClusterIP

Determines how the Service is exposed.

More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Service.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Service.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Service.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Service.bind">bind</a></code> | Configure a port the service will bind to. |
| <code><a href="#cdk8s-plus-28.Service.exposeViaIngress">expose_via_ingress</a></code> | Expose a service via an ingress using the specified path. |
| <code><a href="#cdk8s-plus-28.Service.select">select</a></code> | Require this service to select pods matching the selector. |
| <code><a href="#cdk8s-plus-28.Service.selectLabel">select_label</a></code> | Require this service to select pods with this label. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Service.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Service.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Service.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `bind` <a name="bind" id="cdk8s-plus-28.Service.bind"></a>

```python
def bind(
  port: typing.Union[int, float],
  name: str = None,
  node_port: typing.Union[int, float] = None,
  protocol: Protocol = None,
  target_port: typing.Union[int, float] = None
) -> None
```

Configure a port the service will bind to.

This method can be called multiple times.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.Service.bind.parameter.port"></a>

- *Type:* typing.Union[int, float]

The port definition.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Service.bind.parameter.name"></a>

- *Type:* str

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

###### `node_port`<sup>Optional</sup> <a name="node_port" id="cdk8s-plus-28.Service.bind.parameter.nodePort"></a>

- *Type:* typing.Union[int, float]
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

###### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.Service.bind.parameter.protocol"></a>

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

###### `target_port`<sup>Optional</sup> <a name="target_port" id="cdk8s-plus-28.Service.bind.parameter.targetPort"></a>

- *Type:* typing.Union[int, float]
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

##### `expose_via_ingress` <a name="expose_via_ingress" id="cdk8s-plus-28.Service.exposeViaIngress"></a>

```python
def expose_via_ingress(
  path: str,
  ingress: Ingress = None,
  path_type: HttpIngressPathType = None
) -> Ingress
```

Expose a service via an ingress using the specified path.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Service.exposeViaIngress.parameter.path"></a>

- *Type:* str

The path to expose the service under.

---

###### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.Service.exposeViaIngress.parameter.ingress"></a>

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

###### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.Service.exposeViaIngress.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

##### `select` <a name="select" id="cdk8s-plus-28.Service.select"></a>

```python
def select(
  selector: IPodSelector
) -> None
```

Require this service to select pods matching the selector.

Note that invoking this method multiple times acts as an AND operator
on the resulting labels.

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.Service.select.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

##### `select_label` <a name="select_label" id="cdk8s-plus-28.Service.selectLabel"></a>

```python
def select_label(
  key: str,
  value: str
) -> None
```

Require this service to select pods with this label.

Note that invoking this method multiple times acts as an AND operator
on the resulting labels.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Service.selectLabel.parameter.key"></a>

- *Type:* str

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Service.selectLabel.parameter.value"></a>

- *Type:* str

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Service.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Service.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Service.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Service.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Service.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Service.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Service.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Service.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Service.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Service.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Service.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Service.property.port">port</a></code> | <code>typing.Union[int, float]</code> | Return the first port of the service. |
| <code><a href="#cdk8s-plus-28.Service.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]</code> | Ports for this service. |
| <code><a href="#cdk8s-plus-28.Service.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | Determines how the Service is exposed. |
| <code><a href="#cdk8s-plus-28.Service.property.clusterIP">cluster_i_p</a></code> | <code>str</code> | The IP address of the service and is usually assigned randomly by the master. |
| <code><a href="#cdk8s-plus-28.Service.property.externalName">external_name</a></code> | <code>str</code> | The externalName to be used for EXTERNAL_NAME types. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Service.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Service.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Service.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Service.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Service.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Service.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Service.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Service.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Service.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.Service.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Return the first port of the service.

---

##### `ports`<sup>Required</sup> <a name="ports" id="cdk8s-plus-28.Service.property.ports"></a>

```python
ports: typing.List[ServicePort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]

Ports for this service.

Use `bind()` to bind additional service ports.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.Service.property.type"></a>

```python
type: ServiceType
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>

Determines how the Service is exposed.

---

##### `cluster_i_p`<sup>Optional</sup> <a name="cluster_i_p" id="cdk8s-plus-28.Service.property.clusterIP"></a>

```python
cluster_i_p: str
```

- *Type:* str

The IP address of the service and is usually assigned randomly by the master.

---

##### `external_name`<sup>Optional</sup> <a name="external_name" id="cdk8s-plus-28.Service.property.externalName"></a>

```python
external_name: str
```

- *Type:* str

The externalName to be used for EXTERNAL_NAME types.

---


### ServiceAccount <a name="ServiceAccount" id="cdk8s-plus-28.ServiceAccount"></a>

- *Implements:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the apiserver.
When they do, they are authenticated as a particular Service Account (for
example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ServiceAccount.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccount(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_token: bool = None,
  secrets: typing.List[ISecret] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.automountToken">automount_token</a></code> | <code>bool</code> | Indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.secrets">secrets</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]</code> | List of secrets allowed to be used by pods running using this ServiceAccount. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_token`<sup>Optional</sup> <a name="automount_token" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.automountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.secrets"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]

List of secrets allowed to be used by pods running using this ServiceAccount.

> [https://kubernetes.io/docs/concepts/configuration/secret](https://kubernetes.io/docs/concepts/configuration/secret)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.addSecret">add_secret</a></code> | Allow a secret to be accessed by pods using this service account. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.ServiceAccount.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ServiceAccount.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ServiceAccount.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_secret` <a name="add_secret" id="cdk8s-plus-28.ServiceAccount.addSecret"></a>

```python
def add_secret(
  secr: ISecret
) -> None
```

Allow a secret to be accessed by pods using this service account.

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.ServiceAccount.addSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret.

---

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.ServiceAccount.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.fromServiceAccountName">from_service_account_name</a></code> | Imports a service account from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.ServiceAccount.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccount.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ServiceAccount.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_service_account_name` <a name="from_service_account_name" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccount.from_service_account_name(
  scope: Construct,
  id: str,
  name: str,
  namespace_name: str = None
)
```

Imports a service account from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.name"></a>

- *Type:* str

The name of the service account resource.

---

###### `namespace_name`<sup>Optional</sup> <a name="namespace_name" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.namespaceName"></a>

- *Type:* str
- *Default:* "default"

The name of the namespace the service account belongs to.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.automountToken">automount_token</a></code> | <code>bool</code> | Whether or not a token is automatically mounted for this service account. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.secrets">secrets</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]</code> | List of secrets allowed to be used by pods running using this service account. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ServiceAccount.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ServiceAccount.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ServiceAccount.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ServiceAccount.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccount.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccount.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ServiceAccount.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ServiceAccount.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ServiceAccount.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_token`<sup>Required</sup> <a name="automount_token" id="cdk8s-plus-28.ServiceAccount.property.automountToken"></a>

```python
automount_token: bool
```

- *Type:* bool

Whether or not a token is automatically mounted for this service account.

---

##### `secrets`<sup>Required</sup> <a name="secrets" id="cdk8s-plus-28.ServiceAccount.property.secrets"></a>

```python
secrets: typing.List[ISecret]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]

List of secrets allowed to be used by pods running using this service account.

Returns a copy. To add a secret, use `addSecret()`.

---


### ServiceAccountTokenSecret <a name="ServiceAccountTokenSecret" id="cdk8s-plus-28.ServiceAccountTokenSecret"></a>

Create a secret for a service account token.

> [https://kubernetes.io/docs/concepts/configuration/secret/#service-account-token-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#service-account-token-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccountTokenSecret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  service_account: IServiceAccount
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | The service account to store a secret for. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `service_account`<sup>Required</sup> <a name="service_account" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

The service account to store a secret for.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.ServiceAccountTokenSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ServiceAccountTokenSecret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ServiceAccountTokenSecret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.ServiceAccountTokenSecret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccountTokenSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccountTokenSecret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### SshAuthSecret <a name="SshAuthSecret" id="cdk8s-plus-28.SshAuthSecret"></a>

Create a secret for ssh authentication.

> [https://kubernetes.io/docs/concepts/configuration/secret/#ssh-authentication-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#ssh-authentication-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.SshAuthSecret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SshAuthSecret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  ssh_private_key: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.sshPrivateKey">ssh_private_key</a></code> | <code>str</code> | The SSH private key to use. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `ssh_private_key`<sup>Required</sup> <a name="ssh_private_key" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.sshPrivateKey"></a>

- *Type:* str

The SSH private key to use.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.SshAuthSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.SshAuthSecret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.SshAuthSecret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.SshAuthSecret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.SshAuthSecret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.SshAuthSecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.SshAuthSecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.SshAuthSecret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.SshAuthSecret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SshAuthSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.SshAuthSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.SshAuthSecret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SshAuthSecret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.SshAuthSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.SshAuthSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.SshAuthSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.SshAuthSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.SshAuthSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SshAuthSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.SshAuthSecret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.SshAuthSecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.SshAuthSecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.SshAuthSecret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### StatefulSet <a name="StatefulSet" id="cdk8s-plus-28.StatefulSet"></a>

- *Implements:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

StatefulSet is the workload API object used to manage stateful applications.

Manages the deployment and scaling of a set of Pods, and provides guarantees
about the ordering and uniqueness of these Pods.

Like a Deployment, a StatefulSet manages Pods that are based on an identical
container spec. Unlike a Deployment, a StatefulSet maintains a sticky identity
for each of their Pods. These pods are created from the same spec, but are not
interchangeable: each has a persistent identifier that it maintains across any
rescheduling.

If you want to use storage volumes to provide persistence for your workload, you
can use a StatefulSet as part of the solution. Although individual Pods in a StatefulSet
are susceptible to failure, the persistent Pod identifiers make it easier to match existing
volumes to the new Pods that replace any that have failed.

## Using StatefulSets

StatefulSets are valuable for applications that require one or more of the following.

* Stable, unique network identifiers.
* Stable, persistent storage.
* Ordered, graceful deployment and scaling.
* Ordered, automated rolling updates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.StatefulSet.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSet(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready: Duration = None,
  pod_management_policy: PodManagementPolicy = None,
  replicas: typing.Union[int, float] = None,
  service: Service = None,
  strategy: StatefulSetUpdateStrategy = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.podManagementPolicy">pod_management_policy</a></code> | <code><a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a></code> | Pod management policy to use for this statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.service">service</a></code> | <code><a href="#cdk8s-plus-28.Service">Service</a></code> | Service to associate with the statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a></code> | Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready`<sup>Optional</sup> <a name="min_ready" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.minReady"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `pod_management_policy`<sup>Optional</sup> <a name="pod_management_policy" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.podManagementPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a>
- *Default:* PodManagementPolicy.ORDERED_READY

Pod management policy to use for this statefulset.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.replicas"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1

Number of desired pods.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.service"></a>

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>
- *Default:* A new headless service will be created.

Service to associate with the statefulset.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.strategy"></a>

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a>
- *Default:* RollingUpdate with partition set to 0

Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.StatefulSet.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.StatefulSet.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.StatefulSet.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.StatefulSet.select">select</a></code> | Configure selectors for this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSet.markHasAutoscaler">mark_has_autoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toScalingTarget">to_scaling_target</a></code> | Return the target spec properties of this Scalable. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.StatefulSet.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.StatefulSet.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.StatefulSet.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.StatefulSet.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.StatefulSet.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.StatefulSet.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.StatefulSet.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.StatefulSet.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.StatefulSet.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.StatefulSet.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.StatefulSet.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.StatefulSet.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.StatefulSet.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.StatefulSet.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.StatefulSet.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.StatefulSet.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.StatefulSet.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.StatefulSet.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

##### `mark_has_autoscaler` <a name="mark_has_autoscaler" id="cdk8s-plus-28.StatefulSet.markHasAutoscaler"></a>

```python
def mark_has_autoscaler() -> None
```

Called on all IScalable targets when they are associated with an autoscaler.

> [IScalable.markHasAutoscaler()](IScalable.markHasAutoscaler())

##### `to_scaling_target` <a name="to_scaling_target" id="cdk8s-plus-28.StatefulSet.toScalingTarget"></a>

```python
def to_scaling_target() -> ScalingTarget
```

Return the target spec properties of this Scalable.

> [IScalable.toScalingTarget()](IScalable.toScalingTarget())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.StatefulSet.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSet.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.StatefulSet.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.podManagementPolicy">pod_management_policy</a></code> | <code><a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a></code> | Management policy to use for the set. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.service">service</a></code> | <code><a href="#cdk8s-plus-28.Service">Service</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a></code> | The update startegy of this stateful set. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hasAutoscaler">has_autoscaler</a></code> | <code>bool</code> | If this is a target of an autoscaler. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.StatefulSet.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.StatefulSet.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.StatefulSet.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.StatefulSet.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.StatefulSet.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.StatefulSet.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.StatefulSet.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.StatefulSet.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.StatefulSet.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.StatefulSet.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.StatefulSet.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.StatefulSet.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.StatefulSet.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.StatefulSet.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.StatefulSet.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.StatefulSet.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.StatefulSet.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.StatefulSet.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.StatefulSet.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.StatefulSet.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.StatefulSet.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.StatefulSet.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.StatefulSet.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.StatefulSet.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.StatefulSet.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.StatefulSet.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `min_ready`<sup>Required</sup> <a name="min_ready" id="cdk8s-plus-28.StatefulSet.property.minReady"></a>

```python
min_ready: Duration
```

- *Type:* cdk8s.Duration

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

##### `pod_management_policy`<sup>Required</sup> <a name="pod_management_policy" id="cdk8s-plus-28.StatefulSet.property.podManagementPolicy"></a>

```python
pod_management_policy: PodManagementPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a>

Management policy to use for the set.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk8s-plus-28.StatefulSet.property.service"></a>

```python
service: Service
```

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.StatefulSet.property.strategy"></a>

```python
strategy: StatefulSetUpdateStrategy
```

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a>

The update startegy of this stateful set.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.StatefulSet.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of desired pods.

---

##### `has_autoscaler`<sup>Required</sup> <a name="has_autoscaler" id="cdk8s-plus-28.StatefulSet.property.hasAutoscaler"></a>

```python
has_autoscaler: bool
```

- *Type:* bool

If this is a target of an autoscaler.

---


### TlsSecret <a name="TlsSecret" id="cdk8s-plus-28.TlsSecret"></a>

Create a secret for storing a TLS certificate and its associated key.

> [https://kubernetes.io/docs/concepts/configuration/secret/#tls-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#tls-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.TlsSecret.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TlsSecret(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  tls_cert: str,
  tls_key: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.tlsCert">tls_cert</a></code> | <code>str</code> | The TLS cert. |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.tlsKey">tls_key</a></code> | <code>str</code> | The TLS key. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.immutable"></a>

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `tls_cert`<sup>Required</sup> <a name="tls_cert" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.tlsCert"></a>

- *Type:* str

The TLS cert.

---

##### `tls_key`<sup>Required</sup> <a name="tls_key" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.tlsKey"></a>

- *Type:* str

The TLS key.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.TlsSecret.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.TlsSecret.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.TlsSecret.addStringData">add_string_data</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.TlsSecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.TlsSecret.getStringData">get_string_data</a></code> | Gets a string data by key or undefined. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.TlsSecret.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.TlsSecret.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.TlsSecret.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_string_data` <a name="add_string_data" id="cdk8s-plus-28.TlsSecret.addStringData"></a>

```python
def add_string_data(
  key: str,
  value: str
) -> None
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.addStringData.parameter.key"></a>

- *Type:* str

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.TlsSecret.addStringData.parameter.value"></a>

- *Type:* str

Value.

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.TlsSecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.envValue.parameter.key"></a>

- *Type:* str

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.TlsSecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `get_string_data` <a name="get_string_data" id="cdk8s-plus-28.TlsSecret.getStringData"></a>

```python
def get_string_data(
  key: str
) -> str
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.getStringData.parameter.key"></a>

- *Type:* str

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.TlsSecret.fromSecretName">from_secret_name</a></code> | Imports a secret from the cluster as a reference. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.TlsSecret.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TlsSecret.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.TlsSecret.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_secret_name` <a name="from_secret_name" id="cdk8s-plus-28.TlsSecret.fromSecretName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TlsSecret.from_secret_name(
  scope: Construct,
  id: str,
  name: str
)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.immutable">immutable</a></code> | <code>bool</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.TlsSecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.TlsSecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.TlsSecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.TlsSecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.TlsSecret.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.TlsSecret.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.TlsSecret.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.TlsSecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.TlsSecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.TlsSecret.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Whether or not the secret is immutable.

---


### User <a name="User" id="cdk8s-plus-28.User"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents a user.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.User.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.User.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.User.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.User.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.User.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.User.fromName">from_name</a></code> | Reference a user in the cluster by name. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.User.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.User.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.User.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_name` <a name="from_name" id="cdk8s-plus-28.User.fromName"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.User.from_name(
  scope: Construct,
  id: str,
  name: str
)
```

Reference a user in the cluster by name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.User.fromName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.User.fromName.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.User.fromName.parameter.name"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.User.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.User.property.kind">kind</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.User.property.name">name</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.User.property.apiGroup">api_group</a></code> | <code>str</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.User.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.User.property.kind"></a>

```python
kind: str
```

- *Type:* str

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.User.property.name"></a>

```python
name: str
```

- *Type:* str

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.User.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

---


### Volume <a name="Volume" id="cdk8s-plus-28.Volume"></a>

- *Implements:* <a href="#cdk8s-plus-28.IStorage">IStorage</a>

Volume represents a named volume in a pod that may be accessed by any container in the pod.

Docker also has a concept of volumes, though it is somewhat looser and less
managed. In Docker, a volume is simply a directory on disk or in another
Container. Lifetimes are not managed and until very recently there were only
local-disk-backed volumes. Docker now provides volume drivers, but the
functionality is very limited for now (e.g. as of Docker 1.7 only one volume
driver is allowed per Container and there is no way to pass parameters to
volumes).

A Kubernetes volume, on the other hand, has an explicit lifetime - the same
as the Pod that encloses it. Consequently, a volume outlives any Containers
that run within the Pod, and data is preserved across Container restarts. Of
course, when a Pod ceases to exist, the volume will cease to exist, too.
Perhaps more importantly than this, Kubernetes supports many types of
volumes, and a Pod can use any number of them simultaneously.

At its core, a volume is just a directory, possibly with some data in it,
which is accessible to the Containers in a Pod. How that directory comes to
be, the medium that backs it, and the contents of it are determined by the
particular volume type used.

To use a volume, a Pod specifies what volumes to provide for the Pod (the
.spec.volumes field) and where to mount those into Containers (the
.spec.containers[*].volumeMounts field).

A process in a container sees a filesystem view composed from their Docker
image and volumes. The Docker image is at the root of the filesystem
hierarchy, and any volumes are mounted at the specified paths within the
image. Volumes can not mount onto other volumes

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Volume.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Volume.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.Volume.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Volume.fromAwsElasticBlockStore">from_aws_elastic_block_store</a></code> | Mounts an Amazon Web Services (AWS) EBS volume into your pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromAzureDisk">from_azure_disk</a></code> | Mounts a Microsoft Azure Data Disk into a pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromConfigMap">from_config_map</a></code> | Populate the volume from a ConfigMap. |
| <code><a href="#cdk8s-plus-28.Volume.fromCsi">from_csi</a></code> | Populate the volume from a CSI driver, for example the Secrets Store CSI Driver: https://secrets-store-csi-driver.sigs.k8s.io/introduction.html. Which in turn needs an associated provider to source the secrets, such as the AWS Secrets Manager and Systems Manager Parameter Store provider: https://aws.github.io/secrets-store-csi-driver-provider-aws/. |
| <code><a href="#cdk8s-plus-28.Volume.fromEmptyDir">from_empty_dir</a></code> | An emptyDir volume is first created when a Pod is assigned to a Node, and exists as long as that Pod is running on that node. |
| <code><a href="#cdk8s-plus-28.Volume.fromGcePersistentDisk">from_gce_persistent_disk</a></code> | Mounts a Google Compute Engine (GCE) persistent disk (PD) into your Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromHostPath">from_host_path</a></code> | Used to mount a file or directory from the host node's filesystem into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromNfs">from_nfs</a></code> | Used to mount an NFS share into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromPersistentVolumeClaim">from_persistent_volume_claim</a></code> | Used to mount a PersistentVolume into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromSecret">from_secret</a></code> | Populate the volume from a Secret. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Volume.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Volume.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

##### `from_aws_elastic_block_store` <a name="from_aws_elastic_block_store" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_aws_elastic_block_store(
  scope: Construct,
  id: str,
  volume_id: str,
  fs_type: str = None,
  name: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

Mounts an Amazon Web Services (AWS) EBS volume into your pod.

Unlike emptyDir, which is erased when a pod is removed, the contents of an EBS volume are
persisted and the volume is unmounted. This means that an EBS volume can be pre-populated with data,
and that data can be shared between pods.

There are some restrictions when using an awsElasticBlockStore volume:

* the nodes on which pods are running must be AWS EC2 instances.
* those instances need to be in the same region and availability zone as the EBS volume.
* EBS only supports a single EC2 instance mounting a volume.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.id"></a>

- *Type:* str

---

###### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.volumeId"></a>

- *Type:* str

---

###### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.partition"></a>

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `from_azure_disk` <a name="from_azure_disk" id="cdk8s-plus-28.Volume.fromAzureDisk"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_azure_disk(
  scope: Construct,
  id: str,
  disk_name: str,
  disk_uri: str,
  caching_mode: AzureDiskPersistentVolumeCachingMode = None,
  fs_type: str = None,
  kind: AzureDiskPersistentVolumeKind = None,
  name: str = None,
  read_only: bool = None
)
```

Mounts a Microsoft Azure Data Disk into a pod.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.id"></a>

- *Type:* str

---

###### `disk_name`<sup>Required</sup> <a name="disk_name" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.diskName"></a>

- *Type:* str

---

###### `disk_uri`<sup>Required</sup> <a name="disk_uri" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.diskUri"></a>

- *Type:* str

---

###### `caching_mode`<sup>Optional</sup> <a name="caching_mode" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.cachingMode"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

###### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

###### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.kind"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

##### `from_config_map` <a name="from_config_map" id="cdk8s-plus-28.Volume.fromConfigMap"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_config_map(
  scope: Construct,
  id: str,
  config_map: IConfigMap,
  default_mode: typing.Union[int, float] = None,
  items: typing.Mapping[PathMapping] = None,
  name: str = None,
  optional: bool = None
)
```

Populate the volume from a ConfigMap.

The configMap resource provides a way to inject configuration data into
Pods. The data stored in a ConfigMap object can be referenced in a volume
of type configMap and then consumed by containerized applications running
in a Pod.

When referencing a configMap object, you can simply provide its name in the
volume to reference it. You can also customize the path to use for a
specific entry in the ConfigMap.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.id"></a>

- *Type:* str

---

###### `config_map`<sup>Required</sup> <a name="config_map" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

The config map to use to populate the volume.

---

###### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.defaultMode"></a>

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.items"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the ConfigMap, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.optional"></a>

- *Type:* bool
- *Default:* undocumented

Specify whether the ConfigMap or its keys must be defined.

---

##### `from_csi` <a name="from_csi" id="cdk8s-plus-28.Volume.fromCsi"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_csi(
  scope: Construct,
  id: str,
  driver: str,
  attributes: typing.Mapping[str] = None,
  fs_type: str = None,
  name: str = None,
  read_only: bool = None
)
```

Populate the volume from a CSI driver, for example the Secrets Store CSI Driver: https://secrets-store-csi-driver.sigs.k8s.io/introduction.html. Which in turn needs an associated provider to source the secrets, such as the AWS Secrets Manager and Systems Manager Parameter Store provider: https://aws.github.io/secrets-store-csi-driver-provider-aws/.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromCsi.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromCsi.parameter.id"></a>

- *Type:* str

---

###### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.Volume.fromCsi.parameter.driver"></a>

- *Type:* str

The name of the CSI driver to use to populate the volume.

---

###### `attributes`<sup>Optional</sup> <a name="attributes" id="cdk8s-plus-28.Volume.fromCsi.parameter.attributes"></a>

- *Type:* typing.Mapping[str]
- *Default:* undefined

Any driver-specific attributes to pass to the CSI volume builder.

---

###### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.Volume.fromCsi.parameter.fsType"></a>

- *Type:* str
- *Default:* driver-dependent

The filesystem type to mount.

Ex. "ext4", "xfs", "ntfs". If not provided,
the empty value is passed to the associated CSI driver, which will
determine the default filesystem to apply.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromCsi.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromCsi.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Whether the mounted volume should be read-only or not.

---

##### `from_empty_dir` <a name="from_empty_dir" id="cdk8s-plus-28.Volume.fromEmptyDir"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_empty_dir(
  scope: Construct,
  id: str,
  name: str,
  medium: EmptyDirMedium = None,
  size_limit: Size = None
)
```

An emptyDir volume is first created when a Pod is assigned to a Node, and exists as long as that Pod is running on that node.

As the name says, it is
initially empty. Containers in the Pod can all read and write the same
files in the emptyDir volume, though that volume can be mounted at the same
or different paths in each Container. When a Pod is removed from a node for
any reason, the data in the emptyDir is deleted forever.

> [http://kubernetes.io/docs/user-guide/volumes#emptydir](http://kubernetes.io/docs/user-guide/volumes#emptydir)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.name"></a>

- *Type:* str

---

###### `medium`<sup>Optional</sup> <a name="medium" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.medium"></a>

- *Type:* <a href="#cdk8s-plus-28.EmptyDirMedium">EmptyDirMedium</a>
- *Default:* EmptyDirMedium.DEFAULT

By default, emptyDir volumes are stored on whatever medium is backing the node - that might be disk or SSD or network storage, depending on your environment.

However, you can set the emptyDir.medium field to
`EmptyDirMedium.MEMORY` to tell Kubernetes to mount a tmpfs (RAM-backed
filesystem) for you instead. While tmpfs is very fast, be aware that unlike
disks, tmpfs is cleared on node reboot and any files you write will count
against your Container's memory limit.

---

###### `size_limit`<sup>Optional</sup> <a name="size_limit" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.sizeLimit"></a>

- *Type:* cdk8s.Size
- *Default:* limit is undefined

Total amount of local storage required for this EmptyDir volume.

The size
limit is also applicable for memory medium. The maximum usage on memory
medium EmptyDir would be the minimum value between the SizeLimit specified
here and the sum of memory limits of all containers in a pod.

---

##### `from_gce_persistent_disk` <a name="from_gce_persistent_disk" id="cdk8s-plus-28.Volume.fromGcePersistentDisk"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_gce_persistent_disk(
  scope: Construct,
  id: str,
  pd_name: str,
  fs_type: str = None,
  name: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

Mounts a Google Compute Engine (GCE) persistent disk (PD) into your Pod.

Unlike emptyDir, which is erased when a pod is removed, the contents of a PD are
preserved and the volume is merely unmounted. This means that a PD can be pre-populated
with data, and that data can be shared between pods.

There are some restrictions when using a gcePersistentDisk:

* the nodes on which Pods are running must be GCE VMs
* those VMs need to be in the same GCE project and zone as the persistent disk

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.id"></a>

- *Type:* str

---

###### `pd_name`<sup>Required</sup> <a name="pd_name" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.pdName"></a>

- *Type:* str

---

###### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.fsType"></a>

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.partition"></a>

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `from_host_path` <a name="from_host_path" id="cdk8s-plus-28.Volume.fromHostPath"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_host_path(
  scope: Construct,
  id: str,
  name: str,
  path: str,
  type: HostPathVolumeType = None
)
```

Used to mount a file or directory from the host node's filesystem into a Pod.

This is not something that most Pods will need, but it offers a powerful
escape hatch for some applications.

> [https://kubernetes.io/docs/concepts/storage/volumes/#hostpath](https://kubernetes.io/docs/concepts/storage/volumes/#hostpath)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromHostPath.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromHostPath.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromHostPath.parameter.name"></a>

- *Type:* str

---

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Volume.fromHostPath.parameter.path"></a>

- *Type:* str

The path of the directory on the host.

---

###### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.Volume.fromHostPath.parameter.type"></a>

- *Type:* <a href="#cdk8s-plus-28.HostPathVolumeType">HostPathVolumeType</a>
- *Default:* HostPathVolumeType.DEFAULT

The expected type of the path found on the host.

---

##### `from_nfs` <a name="from_nfs" id="cdk8s-plus-28.Volume.fromNfs"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_nfs(
  scope: Construct,
  id: str,
  name: str,
  path: str,
  server: str,
  read_only: bool = None
)
```

Used to mount an NFS share into a Pod.

> [https://kubernetes.io/docs/concepts/storage/volumes/#nfs](https://kubernetes.io/docs/concepts/storage/volumes/#nfs)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromNfs.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromNfs.parameter.id"></a>

- *Type:* str

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromNfs.parameter.name"></a>

- *Type:* str

---

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Volume.fromNfs.parameter.path"></a>

- *Type:* str

Path that is exported by the NFS server.

---

###### `server`<sup>Required</sup> <a name="server" id="cdk8s-plus-28.Volume.fromNfs.parameter.server"></a>

- *Type:* str

Server is the hostname or IP address of the NFS server.

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromNfs.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

If set to true, will force the NFS export to be mounted with read-only permissions.

---

##### `from_persistent_volume_claim` <a name="from_persistent_volume_claim" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_persistent_volume_claim(
  scope: Construct,
  id: str,
  claim: IPersistentVolumeClaim,
  name: str = None,
  read_only: bool = None
)
```

Used to mount a PersistentVolume into a Pod.

PersistentVolumeClaims are a way for users to "claim" durable storage (such as a GCE PersistentDisk or an iSCSI volume)
without knowing the details of the particular cloud environment.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/](https://kubernetes.io/docs/concepts/storage/persistent-volumes/)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.id"></a>

- *Type:* str

---

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.name"></a>

- *Type:* str
- *Default:* Derived from the PVC name.

The volume name.

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Will force the ReadOnly setting in VolumeMounts.

---

##### `from_secret` <a name="from_secret" id="cdk8s-plus-28.Volume.fromSecret"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Volume.from_secret(
  scope: Construct,
  id: str,
  secr: ISecret,
  default_mode: typing.Union[int, float] = None,
  items: typing.Mapping[PathMapping] = None,
  name: str = None,
  optional: bool = None
)
```

Populate the volume from a Secret.

A secret volume is used to pass sensitive information, such as passwords, to Pods.
You can store secrets in the Kubernetes API and mount them as files for use by pods
without coupling to Kubernetes directly.

secret volumes are backed by tmpfs (a RAM-backed filesystem)
so they are never written to non-volatile storage.

> [https://kubernetes.io/docs/concepts/storage/volumes/#secret](https://kubernetes.io/docs/concepts/storage/volumes/#secret)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromSecret.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromSecret.parameter.id"></a>

- *Type:* str

---

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.Volume.fromSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret to use to populate the volume.

---

###### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.Volume.fromSecret.parameter.defaultMode"></a>

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

###### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.Volume.fromSecret.parameter.items"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the secret, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Volume.fromSecret.parameter.name"></a>

- *Type:* str
- *Default:* auto-generated

The volume name.

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.Volume.fromSecret.parameter.optional"></a>

- *Type:* bool
- *Default:* undocumented

Specify whether the secret or its keys must be defined.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Volume.property.name">name</a></code> | <code>str</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Volume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.property.name"></a>

```python
name: str
```

- *Type:* str

---


### Workload <a name="Workload" id="cdk8s-plus-28.Workload"></a>

A workload is an application running on Kubernetes.

Whether your workload is a single
component or several that work together, on Kubernetes you run it inside a set of pods.
In Kubernetes, a Pod represents a set of running containers on your cluster.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Workload.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Workload(
  scope: Construct,
  id: str,
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Workload.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Workload.Initializer.parameter.id"></a>

- *Type:* str

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.Workload.Initializer.parameter.metadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Workload.Initializer.parameter.automountServiceAccountToken"></a>

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.Workload.Initializer.parameter.containers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.Workload.Initializer.parameter.dns"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Workload.Initializer.parameter.dockerRegistryAuth"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.Workload.Initializer.parameter.hostAliases"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Workload.Initializer.parameter.hostNetwork"></a>

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.Workload.Initializer.parameter.initContainers"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.Workload.Initializer.parameter.isolate"></a>

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Workload.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Workload.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Workload.Initializer.parameter.serviceAccount"></a>

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Workload.Initializer.parameter.terminationGracePeriod"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.Workload.Initializer.parameter.volumes"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.Workload.Initializer.parameter.podMetadata"></a>

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.Workload.Initializer.parameter.select"></a>

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.Workload.Initializer.parameter.spread"></a>

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.toString">to_string</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Workload.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Workload.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Workload.addContainer">add_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addHostAlias">add_host_alias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addInitContainer">add_init_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addVolume">add_volume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.attachContainer">attach_container</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Workload.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Workload.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Workload.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Workload.select">select</a></code> | Configure selectors for this workload. |

---

##### `to_string` <a name="to_string" id="cdk8s-plus-28.Workload.toString"></a>

```python
def to_string() -> str
```

Returns a string representation of this construct.

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.Workload.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.Workload.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

##### `add_container` <a name="add_container" id="cdk8s-plus-28.Workload.addContainer"></a>

```python
def add_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Workload.addContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Workload.addContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Workload.addContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Workload.addContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Workload.addContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Workload.addContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Workload.addContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Workload.addContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Workload.addContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Workload.addContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Workload.addContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Workload.addContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Workload.addContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Workload.addContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Workload.addContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Workload.addContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Workload.addContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Workload.addContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Workload.addContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_host_alias` <a name="add_host_alias" id="cdk8s-plus-28.Workload.addHostAlias"></a>

```python
def add_host_alias(
  hostnames: typing.List[str],
  ip: str
) -> None
```

###### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.Workload.addHostAlias.parameter.hostnames"></a>

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

###### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.Workload.addHostAlias.parameter.ip"></a>

- *Type:* str

IP address of the host file entry.

---

##### `add_init_container` <a name="add_init_container" id="cdk8s-plus-28.Workload.addInitContainer"></a>

```python
def add_init_container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
) -> Container
```

###### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Workload.addInitContainer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

###### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Workload.addInitContainer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

###### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Workload.addInitContainer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

###### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Workload.addInitContainer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

###### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Workload.addInitContainer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

###### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Workload.addInitContainer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

###### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Workload.addInitContainer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Workload.addInitContainer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

###### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Workload.addInitContainer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

###### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Workload.addInitContainer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Workload.addInitContainer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

###### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Workload.addInitContainer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

###### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Workload.addInitContainer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

###### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Workload.addInitContainer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

###### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Workload.addInitContainer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

###### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Workload.addInitContainer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

###### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Workload.addInitContainer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

###### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Workload.addInitContainer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

###### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Workload.addInitContainer.parameter.image"></a>

- *Type:* str

Docker image name.

---

##### `add_volume` <a name="add_volume" id="cdk8s-plus-28.Workload.addVolume"></a>

```python
def add_volume(
  vol: Volume
) -> None
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Workload.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attach_container` <a name="attach_container" id="cdk8s-plus-28.Workload.attachContainer"></a>

```python
def attach_container(
  cont: Container
) -> None
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Workload.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.Workload.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.Workload.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.Workload.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.Workload.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Workload.select"></a>

```python
def select(
  selectors: LabelSelector
) -> None
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Workload.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.isConstruct">is_construct</a></code> | Checks if `x` is a construct. |

---

##### `is_construct` <a name="is_construct" id="cdk8s-plus-28.Workload.isConstruct"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Workload.is_construct(
  x: typing.Any
)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Workload.isConstruct.parameter.x"></a>

- *Type:* typing.Any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Workload.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Workload.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Workload.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Workload.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.name">name</a></code> | <code>str</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Workload.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Workload.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Workload.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Workload.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.hostNetwork">host_network</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.matchExpressions">match_expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Workload.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Workload.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Workload.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.Workload.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.Workload.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Workload.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Workload.property.metadata"></a>

```python
metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Workload.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Workload.property.permissions"></a>

```python
permissions: ResourcePermissions
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.Workload.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.Workload.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automount_service_account_token`<sup>Required</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.Workload.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Workload.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Workload.property.dns"></a>

```python
dns: PodDns
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `host_aliases`<sup>Required</sup> <a name="host_aliases" id="cdk8s-plus-28.Workload.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

---

##### `init_containers`<sup>Required</sup> <a name="init_containers" id="cdk8s-plus-28.Workload.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

---

##### `pod_metadata`<sup>Required</sup> <a name="pod_metadata" id="cdk8s-plus-28.Workload.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadataDefinition
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.Workload.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Workload.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.Workload.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.Workload.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Workload.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.Workload.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.Workload.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Workload.property.connections"></a>

```python
connections: PodConnections
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `match_expressions`<sup>Required</sup> <a name="match_expressions" id="cdk8s-plus-28.Workload.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `match_labels`<sup>Required</sup> <a name="match_labels" id="cdk8s-plus-28.Workload.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Workload.property.scheduling"></a>

```python
scheduling: WorkloadScheduling
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---


## Structs <a name="Structs" id="Structs"></a>

### AbstractPodProps <a name="AbstractPodProps" id="cdk8s-plus-28.AbstractPodProps"></a>

Properties for `AbstractPod`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AbstractPodProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AbstractPodProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AbstractPodProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.AbstractPodProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.AbstractPodProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.AbstractPodProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.AbstractPodProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.AbstractPodProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.AbstractPodProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.AbstractPodProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.AbstractPodProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.AbstractPodProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.AbstractPodProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.AbstractPodProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.AbstractPodProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.AbstractPodProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

### AddDeploymentOptions <a name="AddDeploymentOptions" id="cdk8s-plus-28.AddDeploymentOptions"></a>

Options to add a deployment to a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AddDeploymentOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AddDeploymentOptions(
  name: str = None,
  node_port: typing.Union[int, float] = None,
  protocol: Protocol = None,
  target_port: typing.Union[int, float] = None,
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.name">name</a></code> | <code>str</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.nodePort">node_port</a></code> | <code>typing.Union[int, float]</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.targetPort">target_port</a></code> | <code>typing.Union[int, float]</code> | The port number the service will redirect to. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The port number the service will bind to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AddDeploymentOptions.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `node_port`<sup>Optional</sup> <a name="node_port" id="cdk8s-plus-28.AddDeploymentOptions.property.nodePort"></a>

```python
node_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.AddDeploymentOptions.property.protocol"></a>

```python
protocol: Protocol
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `target_port`<sup>Optional</sup> <a name="target_port" id="cdk8s-plus-28.AddDeploymentOptions.property.targetPort"></a>

```python
target_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.AddDeploymentOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* Copied from the first container of the deployment.

The port number the service will bind to.

---

### AddDirectoryOptions <a name="AddDirectoryOptions" id="cdk8s-plus-28.AddDirectoryOptions"></a>

Options for `configmap.addDirectory()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AddDirectoryOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AddDirectoryOptions(
  exclude: typing.List[str] = None,
  key_prefix: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AddDirectoryOptions.property.exclude">exclude</a></code> | <code>typing.List[str]</code> | Glob patterns to exclude when adding files. |
| <code><a href="#cdk8s-plus-28.AddDirectoryOptions.property.keyPrefix">key_prefix</a></code> | <code>str</code> | A prefix to add to all keys in the config map. |

---

##### `exclude`<sup>Optional</sup> <a name="exclude" id="cdk8s-plus-28.AddDirectoryOptions.property.exclude"></a>

```python
exclude: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* include all files

Glob patterns to exclude when adding files.

---

##### `key_prefix`<sup>Optional</sup> <a name="key_prefix" id="cdk8s-plus-28.AddDirectoryOptions.property.keyPrefix"></a>

```python
key_prefix: str
```

- *Type:* str
- *Default:* ""

A prefix to add to all keys in the config map.

---

### Affinity <a name="Affinity" id="cdk8s-plus-28.k8s.Affinity"></a>

Affinity is a group of affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Affinity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Affinity(
  node_affinity: NodeAffinity = None,
  pod_affinity: PodAffinity = None,
  pod_anti_affinity: PodAntiAffinity = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.nodeAffinity">node_affinity</a></code> | <code>cdk8s_plus_28.k8s.NodeAffinity</code> | Describes node affinity scheduling rules for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.podAffinity">pod_affinity</a></code> | <code>cdk8s_plus_28.k8s.PodAffinity</code> | Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)). |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.podAntiAffinity">pod_anti_affinity</a></code> | <code>cdk8s_plus_28.k8s.PodAntiAffinity</code> | Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)). |

---

##### `node_affinity`<sup>Optional</sup> <a name="node_affinity" id="cdk8s-plus-28.k8s.Affinity.property.nodeAffinity"></a>

```python
node_affinity: NodeAffinity
```

- *Type:* cdk8s_plus_28.k8s.NodeAffinity

Describes node affinity scheduling rules for the pod.

---

##### `pod_affinity`<sup>Optional</sup> <a name="pod_affinity" id="cdk8s-plus-28.k8s.Affinity.property.podAffinity"></a>

```python
pod_affinity: PodAffinity
```

- *Type:* cdk8s_plus_28.k8s.PodAffinity

Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).

---

##### `pod_anti_affinity`<sup>Optional</sup> <a name="pod_anti_affinity" id="cdk8s-plus-28.k8s.Affinity.property.podAntiAffinity"></a>

```python
pod_anti_affinity: PodAntiAffinity
```

- *Type:* cdk8s_plus_28.k8s.PodAntiAffinity

Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).

---

### AggregationRule <a name="AggregationRule" id="cdk8s-plus-28.k8s.AggregationRule"></a>

AggregationRule describes how to locate ClusterRoles to aggregate into the ClusterRole.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AggregationRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AggregationRule(
  cluster_role_selectors: typing.List[LabelSelector] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AggregationRule.property.clusterRoleSelectors">cluster_role_selectors</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LabelSelector]</code> | ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. |

---

##### `cluster_role_selectors`<sup>Optional</sup> <a name="cluster_role_selectors" id="cdk8s-plus-28.k8s.AggregationRule.property.clusterRoleSelectors"></a>

```python
cluster_role_selectors: typing.List[LabelSelector]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.LabelSelector]

ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules.

If any of the selectors match, then the ClusterRole's permissions will be added

---

### ApiResourceOptions <a name="ApiResourceOptions" id="cdk8s-plus-28.ApiResourceOptions"></a>

Options for `ApiResource`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ApiResourceOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ApiResourceOptions(
  api_group: str,
  resource_type: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResourceOptions.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ApiResourceOptions.property.resourceType">resource_type</a></code> | <code>str</code> | The name of the resource type as it appears in the relevant API endpoint. |

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ApiResourceOptions.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ApiResourceOptions.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of the resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


### ApiServiceSpec <a name="ApiServiceSpec" id="cdk8s-plus-28.k8s.ApiServiceSpec"></a>

APIServiceSpec contains information for locating and communicating with a server.

Only https is supported, though you are able to disable certificate verification.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ApiServiceSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ApiServiceSpec(
  group_priority_minimum: typing.Union[int, float],
  version_priority: typing.Union[int, float],
  ca_bundle: str = None,
  group: str = None,
  insecure_skip_tls_verify: bool = None,
  service: ServiceReference = None,
  version: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.groupPriorityMinimum">group_priority_minimum</a></code> | <code>typing.Union[int, float]</code> | GroupPriorityMininum is the priority this group should have at least. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.versionPriority">version_priority</a></code> | <code>typing.Union[int, float]</code> | VersionPriority controls the ordering of this API version inside of its group. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.caBundle">ca_bundle</a></code> | <code>str</code> | CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.group">group</a></code> | <code>str</code> | Group is the API group name this server hosts. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.insecureSkipTlsVerify">insecure_skip_tls_verify</a></code> | <code>bool</code> | InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.service">service</a></code> | <code>cdk8s_plus_28.k8s.ServiceReference</code> | Service is a reference to the service for this API server. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.version">version</a></code> | <code>str</code> | Version is the API version this server hosts. |

---

##### `group_priority_minimum`<sup>Required</sup> <a name="group_priority_minimum" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.groupPriorityMinimum"></a>

```python
group_priority_minimum: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

GroupPriorityMininum is the priority this group should have at least.

Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s

---

##### `version_priority`<sup>Required</sup> <a name="version_priority" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.versionPriority"></a>

```python
version_priority: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

VersionPriority controls the ordering of this API version inside of its group.

Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). Since it's inside of a group, the number can be small, probably in the 10s. In case of equal version priorities, the version string will be used to compute the order inside a group. If the version string is "kube-like", it will sort above non "kube-like" version strings, which are ordered lexicographically. "Kube-like" versions start with a "v", then are followed by a number (the major version), then optionally the string "alpha" or "beta" and another number (the minor version). These are sorted first by GA > beta > alpha (where GA is a version with no suffix such as beta or alpha), and then by comparing major version, then minor version. An example sorted list of versions: v10, v2, v1, v11beta2, v10beta3, v3beta1, v12alpha1, v11alpha2, foo1, foo10.

---

##### `ca_bundle`<sup>Optional</sup> <a name="ca_bundle" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.caBundle"></a>

```python
ca_bundle: str
```

- *Type:* str

CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.

If unspecified, system trust roots on the apiserver are used.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.group"></a>

```python
group: str
```

- *Type:* str

Group is the API group name this server hosts.

---

##### `insecure_skip_tls_verify`<sup>Optional</sup> <a name="insecure_skip_tls_verify" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.insecureSkipTlsVerify"></a>

```python
insecure_skip_tls_verify: bool
```

- *Type:* bool

InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server.

This is strongly discouraged.  You should use the CABundle instead.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.service"></a>

```python
service: ServiceReference
```

- *Type:* cdk8s_plus_28.k8s.ServiceReference

Service is a reference to the service for this API server.

It must communicate on port 443. If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.version"></a>

```python
version: str
```

- *Type:* str

Version is the API version this server hosts.

For example, "v1"

---

### AuditAnnotationV1Alpha1 <a name="AuditAnnotationV1Alpha1" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1"></a>

AuditAnnotation describes how to produce an audit annotation for an API request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AuditAnnotationV1Alpha1(
  key: str,
  value_expression: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.key">key</a></code> | <code>str</code> | key specifies the audit annotation key. |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.valueExpression">value_expression</a></code> | <code>str</code> | valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.key"></a>

```python
key: str
```

- *Type:* str

key specifies the audit annotation key.

The audit annotation keys of a ValidatingAdmissionPolicy must be unique. The key must be a qualified name ([A-Za-z0-9][-A-Za-z0-9_.]*) no more than 63 bytes in length.

The key is combined with the resource name of the ValidatingAdmissionPolicy to construct an audit annotation key: "{ValidatingAdmissionPolicy name}/{key}".

If an admission webhook uses the same resource name as this ValidatingAdmissionPolicy and the same audit annotation key, the annotation key will be identical. In this case, the first annotation written with the key will be included in the audit event and all subsequent annotations with the same key will be discarded.

Required.

---

##### `value_expression`<sup>Required</sup> <a name="value_expression" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.valueExpression"></a>

```python
value_expression: str
```

- *Type:* str

valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value.

The expression must evaluate to either a string or null value. If the expression evaluates to a string, the audit annotation is included with the string value. If the expression evaluates to null or empty string the audit annotation will be omitted. The valueExpression may be no longer than 5kb in length. If the result of the valueExpression is more than 10kb in length, it will be truncated to 10kb.

If multiple ValidatingAdmissionPolicyBinding resources match an API request, then the valueExpression will be evaluated for each binding. All unique values produced by the valueExpressions will be joined together in a comma-separated list.

Required.

---

### AuditAnnotationV1Beta1 <a name="AuditAnnotationV1Beta1" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1"></a>

AuditAnnotation describes how to produce an audit annotation for an API request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AuditAnnotationV1Beta1(
  key: str,
  value_expression: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.key">key</a></code> | <code>str</code> | key specifies the audit annotation key. |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.valueExpression">value_expression</a></code> | <code>str</code> | valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.key"></a>

```python
key: str
```

- *Type:* str

key specifies the audit annotation key.

The audit annotation keys of a ValidatingAdmissionPolicy must be unique. The key must be a qualified name ([A-Za-z0-9][-A-Za-z0-9_.]*) no more than 63 bytes in length.

The key is combined with the resource name of the ValidatingAdmissionPolicy to construct an audit annotation key: "{ValidatingAdmissionPolicy name}/{key}".

If an admission webhook uses the same resource name as this ValidatingAdmissionPolicy and the same audit annotation key, the annotation key will be identical. In this case, the first annotation written with the key will be included in the audit event and all subsequent annotations with the same key will be discarded.

Required.

---

##### `value_expression`<sup>Required</sup> <a name="value_expression" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.valueExpression"></a>

```python
value_expression: str
```

- *Type:* str

valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value.

The expression must evaluate to either a string or null value. If the expression evaluates to a string, the audit annotation is included with the string value. If the expression evaluates to null or empty string the audit annotation will be omitted. The valueExpression may be no longer than 5kb in length. If the result of the valueExpression is more than 10kb in length, it will be truncated to 10kb.

If multiple ValidatingAdmissionPolicyBinding resources match an API request, then the valueExpression will be evaluated for each binding. All unique values produced by the valueExpressions will be joined together in a comma-separated list.

Required.

---

### AwsElasticBlockStorePersistentVolumeProps <a name="AwsElasticBlockStorePersistentVolumeProps" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps"></a>

Properties for `AwsElasticBlockStorePersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AwsElasticBlockStorePersistentVolumeProps(
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  volume_id: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeId">volume_id</a></code> | <code>str</code> | Unique ID of the persistent disk resource in AWS (Amazon EBS volume). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

Unique ID of the persistent disk resource in AWS (Amazon EBS volume).

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### AwsElasticBlockStoreVolumeOptions <a name="AwsElasticBlockStoreVolumeOptions" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions"></a>

Options of `Volume.fromAwsElasticBlockStore`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AwsElasticBlockStoreVolumeOptions(
  fs_type: str = None,
  name: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### AwsElasticBlockStoreVolumeSource <a name="AwsElasticBlockStoreVolumeSource" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource"></a>

Represents a Persistent Disk resource in AWS.

An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AwsElasticBlockStoreVolumeSource(
  volume_id: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.volumeId">volume_id</a></code> | <code>str</code> | volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume). |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | partition is the partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly value true will force the readOnly setting in VolumeMounts. |

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume).

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

partition is the partition in the volume that you want to mount.

If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly value true will force the readOnly setting in VolumeMounts.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

### AzureDiskPersistentVolumeProps <a name="AzureDiskPersistentVolumeProps" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps"></a>

Properties for `AzureDiskPersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AzureDiskPersistentVolumeProps(
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  disk_name: str,
  disk_uri: str,
  caching_mode: AzureDiskPersistentVolumeCachingMode = None,
  fs_type: str = None,
  kind: AzureDiskPersistentVolumeKind = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskName">disk_name</a></code> | <code>str</code> | The Name of the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskUri">disk_uri</a></code> | <code>str</code> | The URI the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.cachingMode">caching_mode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Host Caching mode. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.kind">kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Kind of disk. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.readOnly">read_only</a></code> | <code>bool</code> | Force the ReadOnly setting in VolumeMounts. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `disk_name`<sup>Required</sup> <a name="disk_name" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskName"></a>

```python
disk_name: str
```

- *Type:* str

The Name of the data disk in the blob storage.

---

##### `disk_uri`<sup>Required</sup> <a name="disk_uri" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskUri"></a>

```python
disk_uri: str
```

- *Type:* str

The URI the data disk in the blob storage.

---

##### `caching_mode`<sup>Optional</sup> <a name="caching_mode" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.cachingMode"></a>

```python
caching_mode: AzureDiskPersistentVolumeCachingMode
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.kind"></a>

```python
kind: AzureDiskPersistentVolumeKind
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

### AzureDiskVolumeOptions <a name="AzureDiskVolumeOptions" id="cdk8s-plus-28.AzureDiskVolumeOptions"></a>

Options of `Volume.fromAzureDisk`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AzureDiskVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.AzureDiskVolumeOptions(
  caching_mode: AzureDiskPersistentVolumeCachingMode = None,
  fs_type: str = None,
  kind: AzureDiskPersistentVolumeKind = None,
  name: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.cachingMode">caching_mode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Host Caching mode. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.kind">kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Kind of disk. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Force the ReadOnly setting in VolumeMounts. |

---

##### `caching_mode`<sup>Optional</sup> <a name="caching_mode" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.cachingMode"></a>

```python
caching_mode: AzureDiskPersistentVolumeCachingMode
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.kind"></a>

```python
kind: AzureDiskPersistentVolumeKind
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

### AzureDiskVolumeSource <a name="AzureDiskVolumeSource" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource"></a>

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AzureDiskVolumeSource(
  disk_name: str,
  disk_uri: str,
  caching_mode: str = None,
  fs_type: str = None,
  kind: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskName">disk_name</a></code> | <code>str</code> | diskName is the Name of the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskUri">disk_uri</a></code> | <code>str</code> | diskURI is the URI of data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.cachingMode">caching_mode</a></code> | <code>str</code> | cachingMode is the Host Caching mode: None, Read Only, Read Write. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.kind">kind</a></code> | <code>str</code> | kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly Defaults to false (read/write). |

---

##### `disk_name`<sup>Required</sup> <a name="disk_name" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskName"></a>

```python
disk_name: str
```

- *Type:* str

diskName is the Name of the data disk in the blob storage.

---

##### `disk_uri`<sup>Required</sup> <a name="disk_uri" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskUri"></a>

```python
disk_uri: str
```

- *Type:* str

diskURI is the URI of data disk in the blob storage.

---

##### `caching_mode`<sup>Optional</sup> <a name="caching_mode" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.cachingMode"></a>

```python
caching_mode: str
```

- *Type:* str

cachingMode is the Host Caching mode: None, Read Only, Read Write.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.kind"></a>

```python
kind: str
```

- *Type:* str

kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set).

defaults to shared

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### AzureFilePersistentVolumeSource <a name="AzureFilePersistentVolumeSource" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource"></a>

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AzureFilePersistentVolumeSource(
  secret_name: str,
  share_name: str,
  read_only: bool = None,
  secret_namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretName">secret_name</a></code> | <code>str</code> | secretName is the name of secret that contains Azure Storage Account Name and Key. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.shareName">share_name</a></code> | <code>str</code> | shareName is the azure Share Name. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretNamespace">secret_namespace</a></code> | <code>str</code> | secretNamespace is the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod. |

---

##### `secret_name`<sup>Required</sup> <a name="secret_name" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretName"></a>

```python
secret_name: str
```

- *Type:* str

secretName is the name of secret that contains Azure Storage Account Name and Key.

---

##### `share_name`<sup>Required</sup> <a name="share_name" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.shareName"></a>

```python
share_name: str
```

- *Type:* str

shareName is the azure Share Name.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secret_namespace`<sup>Optional</sup> <a name="secret_namespace" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretNamespace"></a>

```python
secret_namespace: str
```

- *Type:* str

secretNamespace is the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod.

---

### AzureFileVolumeSource <a name="AzureFileVolumeSource" id="cdk8s-plus-28.k8s.AzureFileVolumeSource"></a>

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.AzureFileVolumeSource(
  secret_name: str,
  share_name: str,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.secretName">secret_name</a></code> | <code>str</code> | secretName is the  name of secret that contains Azure Storage Account Name and Key. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.shareName">share_name</a></code> | <code>str</code> | shareName is the azure share Name. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |

---

##### `secret_name`<sup>Required</sup> <a name="secret_name" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.secretName"></a>

```python
secret_name: str
```

- *Type:* str

secretName is the  name of secret that contains Azure Storage Account Name and Key.

---

##### `share_name`<sup>Required</sup> <a name="share_name" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.shareName"></a>

```python
share_name: str
```

- *Type:* str

shareName is the azure share Name.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### BasicAuthSecretProps <a name="BasicAuthSecretProps" id="cdk8s-plus-28.BasicAuthSecretProps"></a>

Options for `BasicAuthSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.BasicAuthSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.BasicAuthSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  password: str,
  username: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.password">password</a></code> | <code>str</code> | The password or token for authentication. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.username">username</a></code> | <code>str</code> | The user name for authentication. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.BasicAuthSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.BasicAuthSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `password`<sup>Required</sup> <a name="password" id="cdk8s-plus-28.BasicAuthSecretProps.property.password"></a>

```python
password: str
```

- *Type:* str

The password or token for authentication.

---

##### `username`<sup>Required</sup> <a name="username" id="cdk8s-plus-28.BasicAuthSecretProps.property.username"></a>

```python
username: str
```

- *Type:* str

The user name for authentication.

---

### BoundObjectReference <a name="BoundObjectReference" id="cdk8s-plus-28.k8s.BoundObjectReference"></a>

BoundObjectReference is a reference to an object that a token is bound to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.BoundObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.BoundObjectReference(
  api_version: str = None,
  kind: str = None,
  name: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.apiVersion">api_version</a></code> | <code>str</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.kind">kind</a></code> | <code>str</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.uid">uid</a></code> | <code>str</code> | UID of the referent. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.BoundObjectReference.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

API version of the referent.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.BoundObjectReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind of the referent.

Valid kinds are 'Pod' and 'Secret'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.BoundObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.BoundObjectReference.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID of the referent.

---

### Capabilities <a name="Capabilities" id="cdk8s-plus-28.k8s.Capabilities"></a>

Adds and removes POSIX capabilities from running containers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Capabilities.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Capabilities(
  add: typing.List[str] = None,
  drop: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Capabilities.property.add">add</a></code> | <code>typing.List[str]</code> | Added capabilities. |
| <code><a href="#cdk8s-plus-28.k8s.Capabilities.property.drop">drop</a></code> | <code>typing.List[str]</code> | Removed capabilities. |

---

##### `add`<sup>Optional</sup> <a name="add" id="cdk8s-plus-28.k8s.Capabilities.property.add"></a>

```python
add: typing.List[str]
```

- *Type:* typing.List[str]

Added capabilities.

---

##### `drop`<sup>Optional</sup> <a name="drop" id="cdk8s-plus-28.k8s.Capabilities.property.drop"></a>

```python
drop: typing.List[str]
```

- *Type:* typing.List[str]

Removed capabilities.

---

### CephFsPersistentVolumeSource <a name="CephFsPersistentVolumeSource" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource"></a>

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CephFsPersistentVolumeSource(
  monitors: typing.List[str],
  path: str = None,
  read_only: bool = None,
  secret_file: str = None,
  secret_ref: SecretReference = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.monitors">monitors</a></code> | <code>typing.List[str]</code> | monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.path">path</a></code> | <code>str</code> | path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretFile">secret_file</a></code> | <code>str</code> | secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.user">user</a></code> | <code>str</code> | user is Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.monitors"></a>

```python
monitors: typing.List[str]
```

- *Type:* typing.List[str]

monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `secret_file`<sup>Optional</sup> <a name="secret_file" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretFile"></a>

```python
secret_file: str
```

- *Type:* str

secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty.

More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.user"></a>

```python
user: str
```

- *Type:* str

user is Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

### CephFsVolumeSource <a name="CephFsVolumeSource" id="cdk8s-plus-28.k8s.CephFsVolumeSource"></a>

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CephFsVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CephFsVolumeSource(
  monitors: typing.List[str],
  path: str = None,
  read_only: bool = None,
  secret_file: str = None,
  secret_ref: LocalObjectReference = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.monitors">monitors</a></code> | <code>typing.List[str]</code> | monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.path">path</a></code> | <code>str</code> | path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretFile">secret_file</a></code> | <code>str</code> | secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.user">user</a></code> | <code>str</code> | user is optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.monitors"></a>

```python
monitors: typing.List[str]
```

- *Type:* typing.List[str]

monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `secret_file`<sup>Optional</sup> <a name="secret_file" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretFile"></a>

```python
secret_file: str
```

- *Type:* str

secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty.

More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.user"></a>

```python
user: str
```

- *Type:* str

user is optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

### CertificateSigningRequestSpec <a name="CertificateSigningRequestSpec" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec"></a>

CertificateSigningRequestSpec contains the certificate request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CertificateSigningRequestSpec(
  request: str,
  signer_name: str,
  expiration_seconds: typing.Union[int, float] = None,
  extra: typing.Mapping[typing.List[str]] = None,
  groups: typing.List[str] = None,
  uid: str = None,
  usages: typing.List[str] = None,
  username: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.request">request</a></code> | <code>str</code> | request contains an x509 certificate signing request encoded in a "CERTIFICATE REQUEST" PEM block. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.signerName">signer_name</a></code> | <code>str</code> | signerName indicates the requested signer, and is a qualified name. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.expirationSeconds">expiration_seconds</a></code> | <code>typing.Union[int, float]</code> | expirationSeconds is the requested duration of validity of the issued certificate. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.extra">extra</a></code> | <code>typing.Mapping[typing.List[str]]</code> | extra contains extra attributes of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.groups">groups</a></code> | <code>typing.List[str]</code> | groups contains group membership of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.uid">uid</a></code> | <code>str</code> | uid contains the uid of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.usages">usages</a></code> | <code>typing.List[str]</code> | usages specifies a set of key usages requested in the issued certificate. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.username">username</a></code> | <code>str</code> | username contains the name of the user that created the CertificateSigningRequest. |

---

##### `request`<sup>Required</sup> <a name="request" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.request"></a>

```python
request: str
```

- *Type:* str

request contains an x509 certificate signing request encoded in a "CERTIFICATE REQUEST" PEM block.

When serialized as JSON or YAML, the data is additionally base64-encoded.

---

##### `signer_name`<sup>Required</sup> <a name="signer_name" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.signerName"></a>

```python
signer_name: str
```

- *Type:* str

signerName indicates the requested signer, and is a qualified name.

List/watch requests for CertificateSigningRequests can filter on this field using a "spec.signerName=NAME" fieldSelector.

Well-known Kubernetes signers are:

1. "kubernetes.io/kube-apiserver-client": issues client certificates that can be used to authenticate to kube-apiserver.
   Requests for this signer are never auto-approved by kube-controller-manager, can be issued by the "csrsigning" controller in kube-controller-manager.
2. "kubernetes.io/kube-apiserver-client-kubelet": issues client certificates that kubelets use to authenticate to kube-apiserver.
   Requests for this signer can be auto-approved by the "csrapproving" controller in kube-controller-manager, and can be issued by the "csrsigning" controller in kube-controller-manager.
3. "kubernetes.io/kubelet-serving" issues serving certificates that kubelets use to serve TLS endpoints, which kube-apiserver can connect to securely.
   Requests for this signer are never auto-approved by kube-controller-manager, and can be issued by the "csrsigning" controller in kube-controller-manager.

More details are available at https://k8s.io/docs/reference/access-authn-authz/certificate-signing-requests/#kubernetes-signers

Custom signerNames can also be specified. The signer defines:

1. Trust distribution: how trust (CA bundles) are distributed.
2. Permitted subjects: and behavior when a disallowed subject is requested.
3. Required, permitted, or forbidden x509 extensions in the request (including whether subjectAltNames are allowed, which types, restrictions on allowed values) and behavior when a disallowed extension is requested.
4. Required, permitted, or forbidden key usages / extended key usages.
5. Expiration/certificate lifetime: whether it is fixed by the signer, configurable by the admin.
6. Whether or not requests for CA certificates are allowed.

---

##### `expiration_seconds`<sup>Optional</sup> <a name="expiration_seconds" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.expirationSeconds"></a>

```python
expiration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

expirationSeconds is the requested duration of validity of the issued certificate.

The certificate signer may issue a certificate with a different validity duration so a client must check the delta between the notBefore and and notAfter fields in the issued certificate to determine the actual duration.

The v1.22+ in-tree implementations of the well-known Kubernetes signers will honor this field as long as the requested duration is not greater than the maximum duration they will honor per the --cluster-signing-duration CLI flag to the Kubernetes controller manager.

Certificate signers may not honor this field for various reasons:

1. Old signer that is unaware of the field (such as the in-tree
   implementations prior to v1.22)
2. Signer whose configured maximum is shorter than the requested duration
3. Signer whose configured minimum is longer than the requested duration

The minimum valid value for expirationSeconds is 600, i.e. 10 minutes.

---

##### `extra`<sup>Optional</sup> <a name="extra" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.extra"></a>

```python
extra: typing.Mapping[typing.List[str]]
```

- *Type:* typing.Mapping[typing.List[str]]

extra contains extra attributes of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `groups`<sup>Optional</sup> <a name="groups" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.groups"></a>

```python
groups: typing.List[str]
```

- *Type:* typing.List[str]

groups contains group membership of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.uid"></a>

```python
uid: str
```

- *Type:* str

uid contains the uid of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `usages`<sup>Optional</sup> <a name="usages" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.usages"></a>

```python
usages: typing.List[str]
```

- *Type:* typing.List[str]

usages specifies a set of key usages requested in the issued certificate.

Requests for TLS client certificates typically request: "digital signature", "key encipherment", "client auth".

Requests for TLS serving certificates typically request: "key encipherment", "digital signature", "server auth".

Valid values are:
"signing", "digital signature", "content commitment",
"key encipherment", "key agreement", "data encipherment",
"cert sign", "crl sign", "encipher only", "decipher only", "any",
"server auth", "client auth",
"code signing", "email protection", "s/mime",
"ipsec end system", "ipsec tunnel", "ipsec user",
"timestamping", "ocsp signing", "microsoft sgc", "netscape sgc"

---

##### `username`<sup>Optional</sup> <a name="username" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.username"></a>

```python
username: str
```

- *Type:* str

username contains the name of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

### CinderPersistentVolumeSource <a name="CinderPersistentVolumeSource" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource"></a>

Represents a cinder volume resource in Openstack.

A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CinderPersistentVolumeSource(
  volume_id: str,
  fs_type: str = None,
  read_only: bool = None,
  secret_ref: SecretReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.volumeId">volume_id</a></code> | <code>str</code> | volumeID used to identify the volume in cinder. |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef is Optional: points to a secret object containing parameters used to connect to OpenStack. |

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

volumeID used to identify the volume in cinder.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

secretRef is Optional: points to a secret object containing parameters used to connect to OpenStack.

---

### CinderVolumeSource <a name="CinderVolumeSource" id="cdk8s-plus-28.k8s.CinderVolumeSource"></a>

Represents a cinder volume resource in Openstack.

A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CinderVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CinderVolumeSource(
  volume_id: str,
  fs_type: str = None,
  read_only: bool = None,
  secret_ref: LocalObjectReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.volumeId">volume_id</a></code> | <code>str</code> | volumeID used to identify the volume in cinder. |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef is optional: points to a secret object containing parameters used to connect to OpenStack. |

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

volumeID used to identify the volume in cinder.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef is optional: points to a secret object containing parameters used to connect to OpenStack.

---

### ClaimSource <a name="ClaimSource" id="cdk8s-plus-28.k8s.ClaimSource"></a>

ClaimSource describes a reference to a ResourceClaim.

Exactly one of these fields should be set.  Consumers of this type must treat an empty object as if it has an unknown value.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClaimSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ClaimSource(
  resource_claim_name: str = None,
  resource_claim_template_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimName">resource_claim_name</a></code> | <code>str</code> | ResourceClaimName is the name of a ResourceClaim object in the same namespace as this pod. |
| <code><a href="#cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimTemplateName">resource_claim_template_name</a></code> | <code>str</code> | ResourceClaimTemplateName is the name of a ResourceClaimTemplate object in the same namespace as this pod. |

---

##### `resource_claim_name`<sup>Optional</sup> <a name="resource_claim_name" id="cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimName"></a>

```python
resource_claim_name: str
```

- *Type:* str

ResourceClaimName is the name of a ResourceClaim object in the same namespace as this pod.

---

##### `resource_claim_template_name`<sup>Optional</sup> <a name="resource_claim_template_name" id="cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimTemplateName"></a>

```python
resource_claim_template_name: str
```

- *Type:* str

ResourceClaimTemplateName is the name of a ResourceClaimTemplate object in the same namespace as this pod.

The template will be used to create a new ResourceClaim, which will be bound to this pod. When this pod is deleted, the ResourceClaim will also be deleted. The pod name and resource name, along with a generated component, will be used to form a unique name for the ResourceClaim, which will be recorded in pod.status.resourceClaimStatuses.

This field is immutable and no changes will be made to the corresponding ResourceClaim by the control plane after creating the ResourceClaim.

---

### ClientIpConfig <a name="ClientIpConfig" id="cdk8s-plus-28.k8s.ClientIpConfig"></a>

ClientIPConfig represents the configurations of Client IP based session affinity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClientIpConfig.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ClientIpConfig(
  timeout_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClientIpConfig.property.timeoutSeconds">timeout_seconds</a></code> | <code>typing.Union[int, float]</code> | timeoutSeconds specifies the seconds of ClientIP type session sticky time. |

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.k8s.ClientIpConfig.property.timeoutSeconds"></a>

```python
timeout_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

timeoutSeconds specifies the seconds of ClientIP type session sticky time.

The value must be >0 && <=86400(for 1 day) if ServiceAffinity == "ClientIP". Default value is 10800(for 3 hours).

---

### ClusterCidrSpecV1Alpha1 <a name="ClusterCidrSpecV1Alpha1" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1"></a>

ClusterCIDRSpec defines the desired state of ClusterCIDR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ClusterCidrSpecV1Alpha1(
  per_node_host_bits: typing.Union[int, float],
  ipv4: str = None,
  ipv6: str = None,
  node_selector: NodeSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.perNodeHostBits">per_node_host_bits</a></code> | <code>typing.Union[int, float]</code> | perNodeHostBits defines the number of host bits to be configured per node. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv4">ipv4</a></code> | <code>str</code> | ipv4 defines an IPv4 IP block in CIDR notation(e.g. "10.0.0.0/8"). At least one of ipv4 and ipv6 must be specified. This field is immutable. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv6">ipv6</a></code> | <code>str</code> | ipv6 defines an IPv6 IP block in CIDR notation(e.g. "2001:db8::/64"). At least one of ipv4 and ipv6 must be specified. This field is immutable. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.nodeSelector">node_selector</a></code> | <code>cdk8s_plus_28.k8s.NodeSelector</code> | nodeSelector defines which nodes the config is applicable to. |

---

##### `per_node_host_bits`<sup>Required</sup> <a name="per_node_host_bits" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.perNodeHostBits"></a>

```python
per_node_host_bits: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

perNodeHostBits defines the number of host bits to be configured per node.

A subnet mask determines how much of the address is used for network bits and host bits. For example an IPv4 address of 192.168.0.0/24, splits the address into 24 bits for the network portion and 8 bits for the host portion. To allocate 256 IPs, set this field to 8 (a /24 mask for IPv4 or a /120 for IPv6). Minimum value is 4 (16 IPs). This field is immutable.

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv4"></a>

```python
ipv4: str
```

- *Type:* str

ipv4 defines an IPv4 IP block in CIDR notation(e.g. "10.0.0.0/8"). At least one of ipv4 and ipv6 must be specified. This field is immutable.

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv6"></a>

```python
ipv6: str
```

- *Type:* str

ipv6 defines an IPv6 IP block in CIDR notation(e.g. "2001:db8::/64"). At least one of ipv4 and ipv6 must be specified. This field is immutable.

---

##### `node_selector`<sup>Optional</sup> <a name="node_selector" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.nodeSelector"></a>

```python
node_selector: NodeSelector
```

- *Type:* cdk8s_plus_28.k8s.NodeSelector

nodeSelector defines which nodes the config is applicable to.

An empty or nil nodeSelector selects all nodes. This field is immutable.

---

### ClusterRoleBindingProps <a name="ClusterRoleBindingProps" id="cdk8s-plus-28.ClusterRoleBindingProps"></a>

Properties for `ClusterRoleBinding`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRoleBindingProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRoleBindingProps(
  metadata: ApiObjectMetadata = None,
  role: IClusterRole
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBindingProps.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a></code> | The role to bind to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleBindingProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.ClusterRoleBindingProps.property.role"></a>

```python
role: IClusterRole
```

- *Type:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

The role to bind to.

---

### ClusterRolePolicyRule <a name="ClusterRolePolicyRule" id="cdk8s-plus-28.ClusterRolePolicyRule"></a>

Policy rule of a `ClusterRole.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRolePolicyRule.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRolePolicyRule(
  endpoints: typing.List[IApiEndpoint],
  verbs: typing.List[str]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule.property.endpoints">endpoints</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>]</code> | Endpoints this rule applies to. |
| <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | Verbs to allow. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRolePolicyRule.property.endpoints"></a>

```python
endpoints: typing.List[IApiEndpoint]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>]

Endpoints this rule applies to.

Can be either api resources
or non api resources.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.ClusterRolePolicyRule.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

Verbs to allow.

(e.g ['get', 'watch'])

---

### ClusterRoleProps <a name="ClusterRoleProps" id="cdk8s-plus-28.ClusterRoleProps"></a>

Properties for `ClusterRole`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRoleProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ClusterRoleProps(
  metadata: ApiObjectMetadata = None,
  aggregation_labels: typing.Mapping[str] = None,
  rules: typing.List[ClusterRolePolicyRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.aggregationLabels">aggregation_labels</a></code> | <code>typing.Mapping[str]</code> | Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules. |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]</code> | A list of rules the role should allow. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `aggregation_labels`<sup>Optional</sup> <a name="aggregation_labels" id="cdk8s-plus-28.ClusterRoleProps.property.aggregationLabels"></a>

```python
aggregation_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.ClusterRoleProps.property.rules"></a>

```python
rules: typing.List[ClusterRolePolicyRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>]
- *Default:* []

A list of rules the role should allow.

---

### ClusterTrustBundleSpecV1Alpha1 <a name="ClusterTrustBundleSpecV1Alpha1" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1"></a>

ClusterTrustBundleSpec contains the signer and trust anchors.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ClusterTrustBundleSpecV1Alpha1(
  trust_bundle: str,
  signer_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.trustBundle">trust_bundle</a></code> | <code>str</code> | trustBundle contains the individual X.509 trust anchors for this bundle, as PEM bundle of PEM-wrapped, DER-formatted X.509 certificates. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.signerName">signer_name</a></code> | <code>str</code> | signerName indicates the associated signer, if any. |

---

##### `trust_bundle`<sup>Required</sup> <a name="trust_bundle" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.trustBundle"></a>

```python
trust_bundle: str
```

- *Type:* str

trustBundle contains the individual X.509 trust anchors for this bundle, as PEM bundle of PEM-wrapped, DER-formatted X.509 certificates.

The data must consist only of PEM certificate blocks that parse as valid X.509 certificates.  Each certificate must include a basic constraints extension with the CA bit set.  The API server will reject objects that contain duplicate certificates, or that use PEM block headers.

Users of ClusterTrustBundles, including Kubelet, are free to reorder and deduplicate certificate blocks in this file according to their own logic, as well as to drop PEM block headers and inter-block data.

---

##### `signer_name`<sup>Optional</sup> <a name="signer_name" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.signerName"></a>

```python
signer_name: str
```

- *Type:* str

signerName indicates the associated signer, if any.

In order to create or update a ClusterTrustBundle that sets signerName, you must have the following cluster-scoped permission: group=certificates.k8s.io resource=signers resourceName=<the signer name> verb=attest.

If signerName is not empty, then the ClusterTrustBundle object must be named with the signer name as a prefix (translating slashes to colons). For example, for the signer name `example.com/foo`, valid ClusterTrustBundle object names include `example.com:foo:abc` and `example.com:foo:v1`.

If signerName is empty, then the ClusterTrustBundle object's name must not have such a prefix.

List/watch requests for ClusterTrustBundles can filter on this field using a `spec.signerName=NAME` field selector.

---

### CommandProbeOptions <a name="CommandProbeOptions" id="cdk8s-plus-28.CommandProbeOptions"></a>

Options for `Probe.fromCommand()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CommandProbeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CommandProbeOptions(
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.failureThreshold">failure_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.initialDelaySeconds">initial_delay_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.periodSeconds">period_seconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.successThreshold">success_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.timeoutSeconds">timeout_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |

---

##### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.CommandProbeOptions.property.failureThreshold"></a>

```python
failure_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.CommandProbeOptions.property.initialDelaySeconds"></a>

```python
initial_delay_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.CommandProbeOptions.property.periodSeconds"></a>

```python
period_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.CommandProbeOptions.property.successThreshold"></a>

```python
success_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.CommandProbeOptions.property.timeoutSeconds"></a>

```python
timeout_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

### CommonSecretProps <a name="CommonSecretProps" id="cdk8s-plus-28.CommonSecretProps"></a>

Common properties for `Secret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CommonSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CommonSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CommonSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.CommonSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.CommonSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.CommonSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

### ComponentCondition <a name="ComponentCondition" id="cdk8s-plus-28.k8s.ComponentCondition"></a>

Information about the condition of a component.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ComponentCondition.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ComponentCondition(
  status: str,
  type: str,
  error: str = None,
  message: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.status">status</a></code> | <code>str</code> | Status of the condition for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.type">type</a></code> | <code>str</code> | Type of condition for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.error">error</a></code> | <code>str</code> | Condition error code for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.message">message</a></code> | <code>str</code> | Message about the condition for a component. |

---

##### `status`<sup>Required</sup> <a name="status" id="cdk8s-plus-28.k8s.ComponentCondition.property.status"></a>

```python
status: str
```

- *Type:* str

Status of the condition for a component.

Valid values for "Healthy": "True", "False", or "Unknown".

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.ComponentCondition.property.type"></a>

```python
type: str
```

- *Type:* str

Type of condition for a component.

Valid value: "Healthy"

---

##### `error`<sup>Optional</sup> <a name="error" id="cdk8s-plus-28.k8s.ComponentCondition.property.error"></a>

```python
error: str
```

- *Type:* str

Condition error code for a component.

For example, a health check error code.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ComponentCondition.property.message"></a>

```python
message: str
```

- *Type:* str

Message about the condition for a component.

For example, information about a health check.

---

### ConfigMapEnvSource <a name="ConfigMapEnvSource" id="cdk8s-plus-28.k8s.ConfigMapEnvSource"></a>

ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap's Data field will represent the key-value pairs as environment variables.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ConfigMapEnvSource(
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapEnvSource.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapEnvSource.property.optional">optional</a></code> | <code>bool</code> | Specify whether the ConfigMap must be defined. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

Specify whether the ConfigMap must be defined.

---

### ConfigMapKeySelector <a name="ConfigMapKeySelector" id="cdk8s-plus-28.k8s.ConfigMapKeySelector"></a>

Selects a key from a ConfigMap.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ConfigMapKeySelector(
  key: str,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.key">key</a></code> | <code>str</code> | The key to select. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.optional">optional</a></code> | <code>bool</code> | Specify whether the ConfigMap or its key must be defined. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.key"></a>

```python
key: str
```

- *Type:* str

The key to select.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

Specify whether the ConfigMap or its key must be defined.

---

### ConfigMapNodeConfigSource <a name="ConfigMapNodeConfigSource" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource"></a>

ConfigMapNodeConfigSource contains the information to reference a ConfigMap as a config source for the Node.

This API is deprecated since 1.22: https://git.k8s.io/enhancements/keps/sig-node/281-dynamic-kubelet-configuration

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ConfigMapNodeConfigSource(
  kubelet_config_key: str,
  name: str,
  namespace: str,
  resource_version: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.kubeletConfigKey">kubelet_config_key</a></code> | <code>str</code> | KubeletConfigKey declares which key of the referenced ConfigMap corresponds to the KubeletConfiguration structure This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.name">name</a></code> | <code>str</code> | Name is the metadata.name of the referenced ConfigMap. This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.namespace">namespace</a></code> | <code>str</code> | Namespace is the metadata.namespace of the referenced ConfigMap. This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.resourceVersion">resource_version</a></code> | <code>str</code> | ResourceVersion is the metadata.ResourceVersion of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.uid">uid</a></code> | <code>str</code> | UID is the metadata.UID of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status. |

---

##### `kubelet_config_key`<sup>Required</sup> <a name="kubelet_config_key" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.kubeletConfigKey"></a>

```python
kubelet_config_key: str
```

- *Type:* str

KubeletConfigKey declares which key of the referenced ConfigMap corresponds to the KubeletConfiguration structure This field is required in all cases.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the metadata.name of the referenced ConfigMap. This field is required in all cases.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace is the metadata.namespace of the referenced ConfigMap. This field is required in all cases.

---

##### `resource_version`<sup>Optional</sup> <a name="resource_version" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.resourceVersion"></a>

```python
resource_version: str
```

- *Type:* str

ResourceVersion is the metadata.ResourceVersion of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID is the metadata.UID of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status.

---

### ConfigMapProjection <a name="ConfigMapProjection" id="cdk8s-plus-28.k8s.ConfigMapProjection"></a>

Adapts a ConfigMap into a projected volume.

The contents of the target ConfigMap's Data field will be presented in a projected volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. Note that this is identical to a configmap volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapProjection.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ConfigMapProjection(
  items: typing.List[KeyToPath] = None,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KeyToPath]</code> | items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.optional">optional</a></code> | <code>bool</code> | optional specify whether the ConfigMap or its keys must be defined. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.items"></a>

```python
items: typing.List[KeyToPath]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KeyToPath]

items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

optional specify whether the ConfigMap or its keys must be defined.

---

### ConfigMapProps <a name="ConfigMapProps" id="cdk8s-plus-28.ConfigMapProps"></a>

Properties for initialization of `ConfigMap`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ConfigMapProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ConfigMapProps(
  metadata: ApiObjectMetadata = None,
  binary_data: typing.Mapping[str] = None,
  data: typing.Mapping[str] = None,
  immutable: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.binaryData">binary_data</a></code> | <code>typing.Mapping[str]</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ConfigMapProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `binary_data`<sup>Optional</sup> <a name="binary_data" id="cdk8s-plus-28.ConfigMapProps.property.binaryData"></a>

```python
binary_data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'.
BinaryData can contain byte sequences that are not in the UTF-8 range. The
keys stored in BinaryData must not overlap with the ones in the Data field,
this is enforced during validation process.

You can also add binary data using `configMap.addBinaryData()`.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.ConfigMapProps.property.data"></a>

```python
data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values
with non-UTF-8 byte sequences must use the BinaryData field. The keys
stored in Data must not overlap with the keys in the BinaryData field, this
is enforced during validation process.

You can also add data using `configMap.addData()`.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ConfigMapProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

### ConfigMapVolumeOptions <a name="ConfigMapVolumeOptions" id="cdk8s-plus-28.ConfigMapVolumeOptions"></a>

Options for the ConfigMap-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ConfigMapVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ConfigMapVolumeOptions(
  default_mode: typing.Union[int, float] = None,
  items: typing.Mapping[PathMapping] = None,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | Mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.items">items</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]</code> | If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.optional">optional</a></code> | <code>bool</code> | Specify whether the ConfigMap or its keys must be defined. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.items"></a>

```python
items: typing.Mapping[PathMapping]
```

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the ConfigMap, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.optional"></a>

```python
optional: bool
```

- *Type:* bool
- *Default:* undocumented

Specify whether the ConfigMap or its keys must be defined.

---

### ConfigMapVolumeSource <a name="ConfigMapVolumeSource" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource"></a>

Adapts a ConfigMap into a volume.

The contents of the target ConfigMap's Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ConfigMapVolumeSource(
  default_mode: typing.Union[int, float] = None,
  items: typing.List[KeyToPath] = None,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | defaultMode is optional: mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KeyToPath]</code> | items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.optional">optional</a></code> | <code>bool</code> | optional specify whether the ConfigMap or its keys must be defined. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

defaultMode is optional: mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.items"></a>

```python
items: typing.List[KeyToPath]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KeyToPath]

items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

optional specify whether the ConfigMap or its keys must be defined.

---

### Container <a name="Container" id="cdk8s-plus-28.k8s.Container"></a>

A single application container that you want to run within a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Container.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Container(
  name: str,
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env: typing.List[EnvVar] = None,
  env_from: typing.List[EnvFromSource] = None,
  image: str = None,
  image_pull_policy: str = None,
  lifecycle: Lifecycle = None,
  liveness_probe: Probe = None,
  ports: typing.List[ContainerPort] = None,
  readiness_probe: Probe = None,
  resize_policy: typing.List[ContainerResizePolicy] = None,
  resources: ResourceRequirements = None,
  restart_policy: str = None,
  security_context: SecurityContext = None,
  startup_probe: Probe = None,
  stdin: bool = None,
  stdin_once: bool = None,
  termination_message_path: str = None,
  termination_message_policy: str = None,
  tty: bool = None,
  volume_devices: typing.List[VolumeDevice] = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.name">name</a></code> | <code>str</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.env">env</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EnvVar]</code> | List of environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.envFrom">env_from</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EnvFromSource]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.image">image</a></code> | <code>str</code> | Container image name. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.imagePullPolicy">image_pull_policy</a></code> | <code>str</code> | Image pull policy. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.lifecycle">lifecycle</a></code> | <code>cdk8s_plus_28.k8s.Lifecycle</code> | Actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.livenessProbe">liveness_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ContainerPort]</code> | List of ports to expose from the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.readinessProbe">readiness_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | Periodic probe of container service readiness. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.resizePolicy">resize_policy</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ContainerResizePolicy]</code> | Resources resize policy for the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.resources">resources</a></code> | <code>cdk8s_plus_28.k8s.ResourceRequirements</code> | Compute Resources required by this container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.restartPolicy">restart_policy</a></code> | <code>str</code> | RestartPolicy defines the restart behavior of individual containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.securityContext">security_context</a></code> | <code>cdk8s_plus_28.k8s.SecurityContext</code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.startupProbe">startup_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.stdin">stdin</a></code> | <code>bool</code> | Whether this container should allocate a buffer for stdin in the container runtime. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.stdinOnce">stdin_once</a></code> | <code>bool</code> | Whether the container runtime should close the stdin channel after it has been opened by a single attach. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.terminationMessagePath">termination_message_path</a></code> | <code>str</code> | Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.terminationMessagePolicy">termination_message_policy</a></code> | <code>str</code> | Indicate how the termination message should be populated. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.tty">tty</a></code> | <code>bool</code> | Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.volumeDevices">volume_devices</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VolumeDevice]</code> | volumeDevices is the list of block devices to be used by the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.volumeMounts">volume_mounts</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VolumeMount]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.workingDir">working_dir</a></code> | <code>str</code> | Container's working directory. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Container.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.k8s.Container.property.args"></a>

```python
args: typing.List[str]
```

- *Type:* typing.List[str]

Arguments to the entrypoint.

The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.Container.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]

Entrypoint array.

Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env`<sup>Optional</sup> <a name="env" id="cdk8s-plus-28.k8s.Container.property.env"></a>

```python
env: typing.List[EnvVar]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EnvVar]

List of environment variables to set in the container.

Cannot be updated.

---

##### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.k8s.Container.property.envFrom"></a>

```python
env_from: typing.List[EnvFromSource]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EnvFromSource]

List of sources to populate environment variables in the container.

The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

---

##### `image`<sup>Optional</sup> <a name="image" id="cdk8s-plus-28.k8s.Container.property.image"></a>

```python
image: str
```

- *Type:* str

Container image name.

More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.

---

##### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.k8s.Container.property.imagePullPolicy"></a>

```python
image_pull_policy: str
```

- *Type:* str
- *Default:* Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Image pull policy.

One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.k8s.Container.property.lifecycle"></a>

```python
lifecycle: Lifecycle
```

- *Type:* cdk8s_plus_28.k8s.Lifecycle

Actions that the management system should take in response to container lifecycle events.

Cannot be updated.

---

##### `liveness_probe`<sup>Optional</sup> <a name="liveness_probe" id="cdk8s-plus-28.k8s.Container.property.livenessProbe"></a>

```python
liveness_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

Periodic probe of container liveness.

Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.Container.property.ports"></a>

```python
ports: typing.List[ContainerPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ContainerPort]

List of ports to expose from the container.

Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Modifying this array with strategic merge patch may corrupt the data. For more information See https://github.com/kubernetes/kubernetes/issues/108255. Cannot be updated.

---

##### `readiness_probe`<sup>Optional</sup> <a name="readiness_probe" id="cdk8s-plus-28.k8s.Container.property.readinessProbe"></a>

```python
readiness_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

Periodic probe of container service readiness.

Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `resize_policy`<sup>Optional</sup> <a name="resize_policy" id="cdk8s-plus-28.k8s.Container.property.resizePolicy"></a>

```python
resize_policy: typing.List[ContainerResizePolicy]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ContainerResizePolicy]

Resources resize policy for the container.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.Container.property.resources"></a>

```python
resources: ResourceRequirements
```

- *Type:* cdk8s_plus_28.k8s.ResourceRequirements

Compute Resources required by this container.

Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.k8s.Container.property.restartPolicy"></a>

```python
restart_policy: str
```

- *Type:* str

RestartPolicy defines the restart behavior of individual containers in a pod.

This field may only be set for init containers, and the only allowed value is "Always". For non-init containers or when this field is not specified, the restart behavior is defined by the Pod's restart policy and the container type. Setting the RestartPolicy as "Always" for the init container will have the following effect: this init container will be continually restarted on exit until all regular containers have terminated. Once all regular containers have completed, all init containers with restartPolicy "Always" will be shut down. This lifecycle differs from normal init containers and is often referred to as a "sidecar" container. Although this init container still starts in the init container sequence, it does not wait for the container to complete before proceeding to the next init container. Instead, the next init container starts immediately after this init container is started, or after any startupProbe has successfully completed.

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.k8s.Container.property.securityContext"></a>

```python
security_context: SecurityContext
```

- *Type:* cdk8s_plus_28.k8s.SecurityContext

SecurityContext defines the security options the container should be run with.

If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/

---

##### `startup_probe`<sup>Optional</sup> <a name="startup_probe" id="cdk8s-plus-28.k8s.Container.property.startupProbe"></a>

```python
startup_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `stdin`<sup>Optional</sup> <a name="stdin" id="cdk8s-plus-28.k8s.Container.property.stdin"></a>

```python
stdin: bool
```

- *Type:* bool
- *Default:* false.

Whether this container should allocate a buffer for stdin in the container runtime.

If this is not set, reads from stdin in the container will always result in EOF. Default is false.

---

##### `stdin_once`<sup>Optional</sup> <a name="stdin_once" id="cdk8s-plus-28.k8s.Container.property.stdinOnce"></a>

```python
stdin_once: bool
```

- *Type:* bool
- *Default:* false

Whether the container runtime should close the stdin channel after it has been opened by a single attach.

When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

---

##### `termination_message_path`<sup>Optional</sup> <a name="termination_message_path" id="cdk8s-plus-28.k8s.Container.property.terminationMessagePath"></a>

```python
termination_message_path: str
```

- *Type:* str
- *Default:* dev/termination-log. Cannot be updated.

Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem.

Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

---

##### `termination_message_policy`<sup>Optional</sup> <a name="termination_message_policy" id="cdk8s-plus-28.k8s.Container.property.terminationMessagePolicy"></a>

```python
termination_message_policy: str
```

- *Type:* str
- *Default:* File. Cannot be updated.

Indicate how the termination message should be populated.

File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

---

##### `tty`<sup>Optional</sup> <a name="tty" id="cdk8s-plus-28.k8s.Container.property.tty"></a>

```python
tty: bool
```

- *Type:* bool
- *Default:* false.

Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.

Default is false.

---

##### `volume_devices`<sup>Optional</sup> <a name="volume_devices" id="cdk8s-plus-28.k8s.Container.property.volumeDevices"></a>

```python
volume_devices: typing.List[VolumeDevice]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VolumeDevice]

volumeDevices is the list of block devices to be used by the container.

---

##### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.k8s.Container.property.volumeMounts"></a>

```python
volume_mounts: typing.List[VolumeMount]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VolumeMount]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.k8s.Container.property.workingDir"></a>

```python
working_dir: str
```

- *Type:* str

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### ContainerLifecycle <a name="ContainerLifecycle" id="cdk8s-plus-28.ContainerLifecycle"></a>

Container lifecycle properties.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerLifecycle.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerLifecycle(
  post_start: Handler = None,
  pre_stop: Handler = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerLifecycle.property.postStart">post_start</a></code> | <code><a href="#cdk8s-plus-28.Handler">Handler</a></code> | This hook is executed immediately after a container is created. |
| <code><a href="#cdk8s-plus-28.ContainerLifecycle.property.preStop">pre_stop</a></code> | <code><a href="#cdk8s-plus-28.Handler">Handler</a></code> | This hook is called immediately before a container is terminated due to an API request or management event such as a liveness/startup probe failure, preemption, resource contention and others. |

---

##### `post_start`<sup>Optional</sup> <a name="post_start" id="cdk8s-plus-28.ContainerLifecycle.property.postStart"></a>

```python
post_start: Handler
```

- *Type:* <a href="#cdk8s-plus-28.Handler">Handler</a>
- *Default:* No post start handler.

This hook is executed immediately after a container is created.

However,
there is no guarantee that the hook will execute before the container ENTRYPOINT.

---

##### `pre_stop`<sup>Optional</sup> <a name="pre_stop" id="cdk8s-plus-28.ContainerLifecycle.property.preStop"></a>

```python
pre_stop: Handler
```

- *Type:* <a href="#cdk8s-plus-28.Handler">Handler</a>
- *Default:* No pre stop handler.

This hook is called immediately before a container is terminated due to an API request or management event such as a liveness/startup probe failure, preemption, resource contention and others.

A call to the PreStop hook fails if the container is already in a terminated or completed state
and the hook must complete before the TERM signal to stop the container can be sent.
The Pod's termination grace period countdown begins before the PreStop hook is executed,
so regardless of the outcome of the handler, the container will eventually terminate
within the Pod's termination grace period. No parameters are passed to the handler.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination)

---

### ContainerOpts <a name="ContainerOpts" id="cdk8s-plus-28.ContainerOpts"></a>

Optional properties of a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerOpts.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerOpts(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.envFrom">env_from</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.envVariables">env_variables</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]</code> | Environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.imagePullPolicy">image_pull_policy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.lifecycle">lifecycle</a></code> | <code><a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a></code> | Describes actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.liveness">liveness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.name">name</a></code> | <code>str</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.port">port</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.portNumber">port_number</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]</code> | List of ports to expose from this container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.readiness">readiness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Determines when the container is ready to serve traffic. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.startup">startup</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.volumeMounts">volume_mounts</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.workingDir">working_dir</a></code> | <code>str</code> | Container's working directory. |

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.ContainerOpts.property.args"></a>

```python
args: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.ContainerOpts.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.ContainerOpts.property.envFrom"></a>

```python
env_from: typing.List[EnvFrom]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

##### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.ContainerOpts.property.envVariables"></a>

```python
env_variables: typing.Mapping[EnvValue]
```

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

##### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.ContainerOpts.property.imagePullPolicy"></a>

```python
image_pull_policy: ImagePullPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.ContainerOpts.property.lifecycle"></a>

```python
lifecycle: ContainerLifecycle
```

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

##### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.ContainerOpts.property.liveness"></a>

```python
liveness: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerOpts.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ContainerOpts.property.port"></a>

- *Deprecated:* - use `portNumber`.

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.ContainerOpts.property.portNumber"></a>

```python
port_number: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ContainerOpts.property.ports"></a>

```python
ports: typing.List[ContainerPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

##### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.ContainerOpts.property.readiness"></a>

```python
readiness: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.ContainerOpts.property.resources"></a>

```python
resources: ContainerResources
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.ContainerOpts.property.restartPolicy"></a>

```python
restart_policy: ContainerRestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.ContainerOpts.property.securityContext"></a>

```python
security_context: ContainerSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

##### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.ContainerOpts.property.startup"></a>

```python
startup: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

##### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.ContainerOpts.property.volumeMounts"></a>

```python
volume_mounts: typing.List[VolumeMount]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.ContainerOpts.property.workingDir"></a>

```python
working_dir: str
```

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### ContainerPort <a name="ContainerPort" id="cdk8s-plus-28.ContainerPort"></a>

Represents a network port in a single container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerPort.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerPort(
  number: typing.Union[int, float],
  host_ip: str = None,
  host_port: typing.Union[int, float] = None,
  name: str = None,
  protocol: Protocol = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.number">number</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.hostIp">host_ip</a></code> | <code>str</code> | What host IP to bind the external port to. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.hostPort">host_port</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the host. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.name">name</a></code> | <code>str</code> | If specified, this must be an IANA_SVC_NAME and unique within the pod. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | Protocol for port. |

---

##### `number`<sup>Required</sup> <a name="number" id="cdk8s-plus-28.ContainerPort.property.number"></a>

```python
number: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

---

##### `host_ip`<sup>Optional</sup> <a name="host_ip" id="cdk8s-plus-28.ContainerPort.property.hostIp"></a>

```python
host_ip: str
```

- *Type:* str
- *Default:* 127.0.0.1.

What host IP to bind the external port to.

---

##### `host_port`<sup>Optional</sup> <a name="host_port" id="cdk8s-plus-28.ContainerPort.property.hostPort"></a>

```python
host_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* auto generated by kubernetes and might change on restarts.

Number of port to expose on the host.

If specified, this must be a valid port number, 0 < x < 65536.
Most containers do not need this.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerPort.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* port is not named.

If specified, this must be an IANA_SVC_NAME and unique within the pod.

Each named port in a pod must have a unique name.
Name for the port that can be referred to by services.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ContainerPort.property.protocol"></a>

```python
protocol: Protocol
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

Protocol for port.

Must be UDP, TCP, or SCTP. Defaults to "TCP".

---

### ContainerPort <a name="ContainerPort" id="cdk8s-plus-28.k8s.ContainerPort"></a>

ContainerPort represents a network port in a single container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerPort.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ContainerPort(
  container_port: typing.Union[int, float],
  host_ip: str = None,
  host_port: typing.Union[int, float] = None,
  name: str = None,
  protocol: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.containerPort">container_port</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.hostIp">host_ip</a></code> | <code>str</code> | What host IP to bind the external port to. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.hostPort">host_port</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the host. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.name">name</a></code> | <code>str</code> | If specified, this must be an IANA_SVC_NAME and unique within the pod. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.protocol">protocol</a></code> | <code>str</code> | Protocol for port. |

---

##### `container_port`<sup>Required</sup> <a name="container_port" id="cdk8s-plus-28.k8s.ContainerPort.property.containerPort"></a>

```python
container_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

---

##### `host_ip`<sup>Optional</sup> <a name="host_ip" id="cdk8s-plus-28.k8s.ContainerPort.property.hostIp"></a>

```python
host_ip: str
```

- *Type:* str

What host IP to bind the external port to.

---

##### `host_port`<sup>Optional</sup> <a name="host_port" id="cdk8s-plus-28.k8s.ContainerPort.property.hostPort"></a>

```python
host_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of port to expose on the host.

If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ContainerPort.property.name"></a>

```python
name: str
```

- *Type:* str

If specified, this must be an IANA_SVC_NAME and unique within the pod.

Each named port in a pod must have a unique name. Name for the port that can be referred to by services.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.ContainerPort.property.protocol"></a>

```python
protocol: str
```

- *Type:* str
- *Default:* TCP".

Protocol for port.

Must be UDP, TCP, or SCTP. Defaults to "TCP".

---

### ContainerProps <a name="ContainerProps" id="cdk8s-plus-28.ContainerProps"></a>

Properties for creating a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerProps(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.envFrom">env_from</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.envVariables">env_variables</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]</code> | Environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.imagePullPolicy">image_pull_policy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.lifecycle">lifecycle</a></code> | <code><a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a></code> | Describes actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.liveness">liveness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.name">name</a></code> | <code>str</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.port">port</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.portNumber">port_number</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]</code> | List of ports to expose from this container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.readiness">readiness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Determines when the container is ready to serve traffic. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.startup">startup</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.volumeMounts">volume_mounts</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.workingDir">working_dir</a></code> | <code>str</code> | Container's working directory. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.image">image</a></code> | <code>str</code> | Docker image name. |

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.ContainerProps.property.args"></a>

```python
args: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.ContainerProps.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.ContainerProps.property.envFrom"></a>

```python
env_from: typing.List[EnvFrom]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

##### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.ContainerProps.property.envVariables"></a>

```python
env_variables: typing.Mapping[EnvValue]
```

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

##### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.ContainerProps.property.imagePullPolicy"></a>

```python
image_pull_policy: ImagePullPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.ContainerProps.property.lifecycle"></a>

```python
lifecycle: ContainerLifecycle
```

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

##### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.ContainerProps.property.liveness"></a>

```python
liveness: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerProps.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ContainerProps.property.port"></a>

- *Deprecated:* - use `portNumber`.

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.ContainerProps.property.portNumber"></a>

```python
port_number: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ContainerProps.property.ports"></a>

```python
ports: typing.List[ContainerPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

##### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.ContainerProps.property.readiness"></a>

```python
readiness: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.ContainerProps.property.resources"></a>

```python
resources: ContainerResources
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.ContainerProps.property.restartPolicy"></a>

```python
restart_policy: ContainerRestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.ContainerProps.property.securityContext"></a>

```python
security_context: ContainerSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

##### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.ContainerProps.property.startup"></a>

```python
startup: Probe
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

##### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.ContainerProps.property.volumeMounts"></a>

```python
volume_mounts: typing.List[VolumeMount]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.ContainerProps.property.workingDir"></a>

```python
working_dir: str
```

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.ContainerProps.property.image"></a>

```python
image: str
```

- *Type:* str

Docker image name.

---

### ContainerResizePolicy <a name="ContainerResizePolicy" id="cdk8s-plus-28.k8s.ContainerResizePolicy"></a>

ContainerResizePolicy represents resource resize policy for the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerResizePolicy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ContainerResizePolicy(
  resource_name: str,
  restart_policy: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResizePolicy.property.resourceName">resource_name</a></code> | <code>str</code> | Name of the resource to which this resource resize policy applies. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResizePolicy.property.restartPolicy">restart_policy</a></code> | <code>str</code> | Restart policy to apply when specified resource is resized. |

---

##### `resource_name`<sup>Required</sup> <a name="resource_name" id="cdk8s-plus-28.k8s.ContainerResizePolicy.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

Name of the resource to which this resource resize policy applies.

Supported values: cpu, memory.

---

##### `restart_policy`<sup>Required</sup> <a name="restart_policy" id="cdk8s-plus-28.k8s.ContainerResizePolicy.property.restartPolicy"></a>

```python
restart_policy: str
```

- *Type:* str

Restart policy to apply when specified resource is resized.

If not specified, it defaults to NotRequired.

---

### ContainerResourceMetricSourceV2 <a name="ContainerResourceMetricSourceV2" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2"></a>

ContainerResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.  Only one "target" type should be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ContainerResourceMetricSourceV2(
  container: str,
  name: str,
  target: MetricTargetV2
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.container">container</a></code> | <code>str</code> | container is the name of the container in the pods of the scaling target. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.name">name</a></code> | <code>str</code> | name is the name of the resource in question. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.container"></a>

```python
container: str
```

- *Type:* str

container is the name of the container in the pods of the scaling target.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the resource in question.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.target"></a>

```python
target: MetricTargetV2
```

- *Type:* cdk8s_plus_28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ContainerResources <a name="ContainerResources" id="cdk8s-plus-28.ContainerResources"></a>

CPU and memory compute resources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerResources.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerResources(
  cpu: CpuResources = None,
  ephemeral_storage: EphemeralStorageResources = None,
  memory: MemoryResources = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.cpu">cpu</a></code> | <code><a href="#cdk8s-plus-28.CpuResources">CpuResources</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.ephemeralStorage">ephemeral_storage</a></code> | <code><a href="#cdk8s-plus-28.EphemeralStorageResources">EphemeralStorageResources</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.memory">memory</a></code> | <code><a href="#cdk8s-plus-28.MemoryResources">MemoryResources</a></code> | *No description.* |

---

##### `cpu`<sup>Optional</sup> <a name="cpu" id="cdk8s-plus-28.ContainerResources.property.cpu"></a>

```python
cpu: CpuResources
```

- *Type:* <a href="#cdk8s-plus-28.CpuResources">CpuResources</a>

---

##### `ephemeral_storage`<sup>Optional</sup> <a name="ephemeral_storage" id="cdk8s-plus-28.ContainerResources.property.ephemeralStorage"></a>

```python
ephemeral_storage: EphemeralStorageResources
```

- *Type:* <a href="#cdk8s-plus-28.EphemeralStorageResources">EphemeralStorageResources</a>

---

##### `memory`<sup>Optional</sup> <a name="memory" id="cdk8s-plus-28.ContainerResources.property.memory"></a>

```python
memory: MemoryResources
```

- *Type:* <a href="#cdk8s-plus-28.MemoryResources">MemoryResources</a>

---

### ContainerSecurityContextProps <a name="ContainerSecurityContextProps" id="cdk8s-plus-28.ContainerSecurityContextProps"></a>

Properties for `ContainerSecurityContext`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerSecurityContextProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerSecurityContextProps(
  allow_privilege_escalation: bool = None,
  capabilities: ContainerSecutiryContextCapabilities = None,
  ensure_non_root: bool = None,
  group: typing.Union[int, float] = None,
  privileged: bool = None,
  read_only_root_filesystem: bool = None,
  seccomp_profile: SeccompProfile = None,
  user: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.allowPrivilegeEscalation">allow_privilege_escalation</a></code> | <code>bool</code> | Whether a process can gain more privileges than its parent process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.capabilities">capabilities</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a></code> | POSIX capabilities for running containers. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.group">group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.privileged">privileged</a></code> | <code>bool</code> | Run container in privileged mode. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.readOnlyRootFilesystem">read_only_root_filesystem</a></code> | <code>bool</code> | Whether this container has a read-only root filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.seccompProfile">seccomp_profile</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a></code> | Container's seccomp profile settings. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.user">user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |

---

##### `allow_privilege_escalation`<sup>Optional</sup> <a name="allow_privilege_escalation" id="cdk8s-plus-28.ContainerSecurityContextProps.property.allowPrivilegeEscalation"></a>

```python
allow_privilege_escalation: bool
```

- *Type:* bool
- *Default:* false

Whether a process can gain more privileges than its parent process.

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.ContainerSecurityContextProps.property.capabilities"></a>

```python
capabilities: ContainerSecutiryContextCapabilities
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a>
- *Default:* none

POSIX capabilities for running containers.

---

##### `ensure_non_root`<sup>Optional</sup> <a name="ensure_non_root" id="cdk8s-plus-28.ContainerSecurityContextProps.property.ensureNonRoot"></a>

```python
ensure_non_root: bool
```

- *Type:* bool
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.ContainerSecurityContextProps.property.group"></a>

```python
group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 26000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The GID to run the entrypoint of the container process.

---

##### `privileged`<sup>Optional</sup> <a name="privileged" id="cdk8s-plus-28.ContainerSecurityContextProps.property.privileged"></a>

```python
privileged: bool
```

- *Type:* bool
- *Default:* false

Run container in privileged mode.

Processes in privileged containers are essentially equivalent to root on the host.

---

##### `read_only_root_filesystem`<sup>Optional</sup> <a name="read_only_root_filesystem" id="cdk8s-plus-28.ContainerSecurityContextProps.property.readOnlyRootFilesystem"></a>

```python
read_only_root_filesystem: bool
```

- *Type:* bool
- *Default:* true

Whether this container has a read-only root filesystem.

---

##### `seccomp_profile`<sup>Optional</sup> <a name="seccomp_profile" id="cdk8s-plus-28.ContainerSecurityContextProps.property.seccompProfile"></a>

```python
seccomp_profile: SeccompProfile
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a>
- *Default:* none

Container's seccomp profile settings.

Only one profile source may be set

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.ContainerSecurityContextProps.property.user"></a>

```python
user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 25000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The UID to run the entrypoint of the container process.

---

### ContainerSecutiryContextCapabilities <a name="ContainerSecutiryContextCapabilities" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerSecutiryContextCapabilities(
  add: typing.List[Capability] = None,
  drop: typing.List[Capability] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.add">add</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Capability">Capability</a>]</code> | Added capabilities. |
| <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.drop">drop</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Capability">Capability</a>]</code> | Removed capabilities. |

---

##### `add`<sup>Optional</sup> <a name="add" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.add"></a>

```python
add: typing.List[Capability]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Capability">Capability</a>]

Added capabilities.

---

##### `drop`<sup>Optional</sup> <a name="drop" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.drop"></a>

```python
drop: typing.List[Capability]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Capability">Capability</a>]

Removed capabilities.

---

### CpuResources <a name="CpuResources" id="cdk8s-plus-28.CpuResources"></a>

CPU request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CpuResources.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CpuResources(
  limit: Cpu = None,
  request: Cpu = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CpuResources.property.limit">limit</a></code> | <code><a href="#cdk8s-plus-28.Cpu">Cpu</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CpuResources.property.request">request</a></code> | <code><a href="#cdk8s-plus-28.Cpu">Cpu</a></code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.CpuResources.property.limit"></a>

```python
limit: Cpu
```

- *Type:* <a href="#cdk8s-plus-28.Cpu">Cpu</a>

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.CpuResources.property.request"></a>

```python
request: Cpu
```

- *Type:* <a href="#cdk8s-plus-28.Cpu">Cpu</a>

---

### CronJobProps <a name="CronJobProps" id="cdk8s-plus-28.CronJobProps"></a>

Properties for `CronJob`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CronJobProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CronJobProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  active_deadline: Duration = None,
  backoff_limit: typing.Union[int, float] = None,
  ttl_after_finished: Duration = None,
  schedule: Cron,
  concurrency_policy: ConcurrencyPolicy = None,
  failed_jobs_retained: typing.Union[int, float] = None,
  starting_deadline: Duration = None,
  successful_jobs_retained: typing.Union[int, float] = None,
  suspend: bool = None,
  time_zone: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.activeDeadline">active_deadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.ttlAfterFinished">ttl_after_finished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.schedule">schedule</a></code> | <code>cdk8s.Cron</code> | Specifies the time in which the job would run again. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.concurrencyPolicy">concurrency_policy</a></code> | <code><a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a></code> | Specifies the concurrency policy for the job. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.failedJobsRetained">failed_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of failed jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.startingDeadline">starting_deadline</a></code> | <code>cdk8s.Duration</code> | Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.successfulJobsRetained">successful_jobs_retained</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of successful jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.suspend">suspend</a></code> | <code>bool</code> | Specifies if the cron job should be suspended. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.timeZone">time_zone</a></code> | <code>str</code> | Specifies the timezone for the job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.CronJobProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.CronJobProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.CronJobProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.CronJobProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.CronJobProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.CronJobProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.CronJobProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.CronJobProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.CronJobProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.CronJobProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.CronJobProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.CronJobProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.CronJobProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.CronJobProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.CronJobProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.CronJobProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.CronJobProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `active_deadline`<sup>Optional</sup> <a name="active_deadline" id="cdk8s-plus-28.CronJobProps.property.activeDeadline"></a>

```python
active_deadline: Duration
```

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.CronJobProps.property.backoffLimit"></a>

```python
backoff_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttl_after_finished`<sup>Optional</sup> <a name="ttl_after_finished" id="cdk8s-plus-28.CronJobProps.property.ttlAfterFinished"></a>

```python
ttl_after_finished: Duration
```

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.CronJobProps.property.schedule"></a>

```python
schedule: Cron
```

- *Type:* cdk8s.Cron

Specifies the time in which the job would run again.

This is defined as a cron expression in the CronJob resource.

---

##### `concurrency_policy`<sup>Optional</sup> <a name="concurrency_policy" id="cdk8s-plus-28.CronJobProps.property.concurrencyPolicy"></a>

```python
concurrency_policy: ConcurrencyPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a>
- *Default:* ConcurrencyPolicy.Forbid

Specifies the concurrency policy for the job.

---

##### `failed_jobs_retained`<sup>Optional</sup> <a name="failed_jobs_retained" id="cdk8s-plus-28.CronJobProps.property.failedJobsRetained"></a>

```python
failed_jobs_retained: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1

Specifies the number of failed jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `starting_deadline`<sup>Optional</sup> <a name="starting_deadline" id="cdk8s-plus-28.CronJobProps.property.startingDeadline"></a>

```python
starting_deadline: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10)

Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed.

This deadline specifies
how much time can pass after a schedule point, for which kubernetes can still start the job.
For example, if this is set to 100 seconds, kubernetes is allowed to start the job at a maximum 100 seconds after
the scheduled time.

Note that the Kubernetes CronJobController checks for things every 10 seconds, for this reason, a deadline below 10
seconds is not allowed, as it may cause your job to never be scheduled.

In addition, kubernetes will stop scheduling jobs if more than 100 schedules were missed (for any reason).
This property also controls what time interval should kubernetes consider when counting for missed schedules.

For example, suppose a CronJob is set to schedule a new Job every one minute beginning at 08:30:00,
and its `startingDeadline` field is not set. If the CronJob controller happens to be down from 08:29:00 to 10:21:00,
the job will not start as the number of missed jobs which missed their schedule is greater than 100.
However, if `startingDeadline` is set to 200 seconds, kubernetes will only count 3 missed schedules, and thus
start a new execution at 10:22:00.

---

##### `successful_jobs_retained`<sup>Optional</sup> <a name="successful_jobs_retained" id="cdk8s-plus-28.CronJobProps.property.successfulJobsRetained"></a>

```python
successful_jobs_retained: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3

Specifies the number of successful jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.CronJobProps.property.suspend"></a>

```python
suspend: bool
```

- *Type:* bool
- *Default:* false

Specifies if the cron job should be suspended.

Only applies to future executions, current ones are remained untouched.

---

##### `time_zone`<sup>Optional</sup> <a name="time_zone" id="cdk8s-plus-28.CronJobProps.property.timeZone"></a>

```python
time_zone: str
```

- *Type:* str
- *Default:* Timezone of kube-controller-manager process.

Specifies the timezone for the job.

This helps aligining the schedule to follow the specified timezone.

> [{@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.]({@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.)

---

### CronJobSpec <a name="CronJobSpec" id="cdk8s-plus-28.k8s.CronJobSpec"></a>

CronJobSpec describes how the job execution will look like and when it will actually run.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CronJobSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CronJobSpec(
  job_template: JobTemplateSpec,
  schedule: str,
  concurrency_policy: str = None,
  failed_jobs_history_limit: typing.Union[int, float] = None,
  starting_deadline_seconds: typing.Union[int, float] = None,
  successful_jobs_history_limit: typing.Union[int, float] = None,
  suspend: bool = None,
  time_zone: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.jobTemplate">job_template</a></code> | <code>cdk8s_plus_28.k8s.JobTemplateSpec</code> | Specifies the job that will be created when executing a CronJob. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.schedule">schedule</a></code> | <code>str</code> | The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.concurrencyPolicy">concurrency_policy</a></code> | <code>str</code> | Specifies how to treat concurrent executions of a Job. Valid values are:. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.failedJobsHistoryLimit">failed_jobs_history_limit</a></code> | <code>typing.Union[int, float]</code> | The number of failed finished jobs to retain. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.startingDeadlineSeconds">starting_deadline_seconds</a></code> | <code>typing.Union[int, float]</code> | Optional deadline in seconds for starting the job if it misses scheduled time for any reason. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.successfulJobsHistoryLimit">successful_jobs_history_limit</a></code> | <code>typing.Union[int, float]</code> | The number of successful finished jobs to retain. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.suspend">suspend</a></code> | <code>bool</code> | This flag tells the controller to suspend subsequent executions, it does not apply to already started executions. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.timeZone">time_zone</a></code> | <code>str</code> | The time zone name for the given schedule, see https://en.wikipedia.org/wiki/List_of_tz_database_time_zones. If not specified, this will default to the time zone of the kube-controller-manager process. The set of valid time zone names and the time zone offset is loaded from the system-wide time zone database by the API server during CronJob validation and the controller manager during execution. If no system-wide time zone database can be found a bundled version of the database is used instead. If the time zone name becomes invalid during the lifetime of a CronJob or due to a change in host configuration, the controller will stop creating new new Jobs and will create a system event with the reason UnknownTimeZone. More information can be found in https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/#time-zones. |

---

##### `job_template`<sup>Required</sup> <a name="job_template" id="cdk8s-plus-28.k8s.CronJobSpec.property.jobTemplate"></a>

```python
job_template: JobTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.JobTemplateSpec

Specifies the job that will be created when executing a CronJob.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.k8s.CronJobSpec.property.schedule"></a>

```python
schedule: str
```

- *Type:* str

The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.

---

##### `concurrency_policy`<sup>Optional</sup> <a name="concurrency_policy" id="cdk8s-plus-28.k8s.CronJobSpec.property.concurrencyPolicy"></a>

```python
concurrency_policy: str
```

- *Type:* str

Specifies how to treat concurrent executions of a Job. Valid values are:.

* "Allow" (default): allows CronJobs to run concurrently; - "Forbid": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - "Replace": cancels currently running job and replaces it with a new one

---

##### `failed_jobs_history_limit`<sup>Optional</sup> <a name="failed_jobs_history_limit" id="cdk8s-plus-28.k8s.CronJobSpec.property.failedJobsHistoryLimit"></a>

```python
failed_jobs_history_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1.

The number of failed finished jobs to retain.

Value must be non-negative integer. Defaults to 1.

---

##### `starting_deadline_seconds`<sup>Optional</sup> <a name="starting_deadline_seconds" id="cdk8s-plus-28.k8s.CronJobSpec.property.startingDeadlineSeconds"></a>

```python
starting_deadline_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Optional deadline in seconds for starting the job if it misses scheduled time for any reason.

Missed jobs executions will be counted as failed ones.

---

##### `successful_jobs_history_limit`<sup>Optional</sup> <a name="successful_jobs_history_limit" id="cdk8s-plus-28.k8s.CronJobSpec.property.successfulJobsHistoryLimit"></a>

```python
successful_jobs_history_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3.

The number of successful finished jobs to retain.

Value must be non-negative integer. Defaults to 3.

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.k8s.CronJobSpec.property.suspend"></a>

```python
suspend: bool
```

- *Type:* bool
- *Default:* false.

This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.

Defaults to false.

---

##### `time_zone`<sup>Optional</sup> <a name="time_zone" id="cdk8s-plus-28.k8s.CronJobSpec.property.timeZone"></a>

```python
time_zone: str
```

- *Type:* str

The time zone name for the given schedule, see https://en.wikipedia.org/wiki/List_of_tz_database_time_zones. If not specified, this will default to the time zone of the kube-controller-manager process. The set of valid time zone names and the time zone offset is loaded from the system-wide time zone database by the API server during CronJob validation and the controller manager during execution. If no system-wide time zone database can be found a bundled version of the database is used instead. If the time zone name becomes invalid during the lifetime of a CronJob or due to a change in host configuration, the controller will stop creating new new Jobs and will create a system event with the reason UnknownTimeZone. More information can be found in https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/#time-zones.

---

### CrossVersionObjectReference <a name="CrossVersionObjectReference" id="cdk8s-plus-28.k8s.CrossVersionObjectReference"></a>

CrossVersionObjectReference contains enough information to let you identify the referred resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CrossVersionObjectReference(
  kind: str,
  name: str,
  api_version: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.kind">kind</a></code> | <code>str</code> | kind is the kind of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.name">name</a></code> | <code>str</code> | name is the name of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.apiVersion">api_version</a></code> | <code>str</code> | apiVersion is the API version of the referent. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

kind is the kind of the referent;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the referent;

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

apiVersion is the API version of the referent.

---

### CrossVersionObjectReferenceV2 <a name="CrossVersionObjectReferenceV2" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2"></a>

CrossVersionObjectReference contains enough information to let you identify the referred resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CrossVersionObjectReferenceV2(
  kind: str,
  name: str,
  api_version: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.kind">kind</a></code> | <code>str</code> | kind is the kind of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.name">name</a></code> | <code>str</code> | name is the name of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.apiVersion">api_version</a></code> | <code>str</code> | apiVersion is the API version of the referent. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.kind"></a>

```python
kind: str
```

- *Type:* str

kind is the kind of the referent;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the referent;

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

apiVersion is the API version of the referent.

---

### CsiDriverSpec <a name="CsiDriverSpec" id="cdk8s-plus-28.k8s.CsiDriverSpec"></a>

CSIDriverSpec is the specification of a CSIDriver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiDriverSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CsiDriverSpec(
  attach_required: bool = None,
  fs_group_policy: str = None,
  pod_info_on_mount: bool = None,
  requires_republish: bool = None,
  se_linux_mount: bool = None,
  storage_capacity: bool = None,
  token_requests: typing.List[TokenRequest] = None,
  volume_lifecycle_modes: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.attachRequired">attach_required</a></code> | <code>bool</code> | attachRequired indicates this CSI volume driver requires an attach operation (because it implements the CSI ControllerPublishVolume() method), and that the Kubernetes attach detach controller should call the attach volume interface which checks the volumeattachment status and waits until the volume is attached before proceeding to mounting. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.fsGroupPolicy">fs_group_policy</a></code> | <code>str</code> | fsGroupPolicy defines if the underlying volume supports changing ownership and permission of the volume before being mounted. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.podInfoOnMount">pod_info_on_mount</a></code> | <code>bool</code> | podInfoOnMount indicates this CSI volume driver requires additional pod information (like podName, podUID, etc.) during mount operations, if set to true. If set to false, pod information will not be passed on mount. Default is false. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.requiresRepublish">requires_republish</a></code> | <code>bool</code> | requiresRepublish indicates the CSI driver wants `NodePublishVolume` being periodically called to reflect any possible change in the mounted volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.seLinuxMount">se_linux_mount</a></code> | <code>bool</code> | seLinuxMount specifies if the CSI driver supports "-o context" mount option. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.storageCapacity">storage_capacity</a></code> | <code>bool</code> | storageCapacity indicates that the CSI volume driver wants pod scheduling to consider the storage capacity that the driver deployment will report by creating CSIStorageCapacity objects with capacity information, if set to true. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.tokenRequests">token_requests</a></code> | <code>typing.List[cdk8s_plus_28.k8s.TokenRequest]</code> | tokenRequests indicates the CSI driver needs pods' service account tokens it is mounting volume for to do necessary authentication. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.volumeLifecycleModes">volume_lifecycle_modes</a></code> | <code>typing.List[str]</code> | volumeLifecycleModes defines what kind of volumes this CSI volume driver supports. |

---

##### `attach_required`<sup>Optional</sup> <a name="attach_required" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.attachRequired"></a>

```python
attach_required: bool
```

- *Type:* bool

attachRequired indicates this CSI volume driver requires an attach operation (because it implements the CSI ControllerPublishVolume() method), and that the Kubernetes attach detach controller should call the attach volume interface which checks the volumeattachment status and waits until the volume is attached before proceeding to mounting.

The CSI external-attacher coordinates with CSI volume driver and updates the volumeattachment status when the attach operation is complete. If the CSIDriverRegistry feature gate is enabled and the value is specified to false, the attach operation will be skipped. Otherwise the attach operation will be called.

This field is immutable.

---

##### `fs_group_policy`<sup>Optional</sup> <a name="fs_group_policy" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.fsGroupPolicy"></a>

```python
fs_group_policy: str
```

- *Type:* str
- *Default:* ReadWriteOnceWithFSType, which will examine each volume to determine if Kubernetes should modify ownership and permissions of the volume. With the default policy the defined fsGroup will only be applied if a fstype is defined and the volume's access mode contains ReadWriteOnce.

fsGroupPolicy defines if the underlying volume supports changing ownership and permission of the volume before being mounted.

Refer to the specific FSGroupPolicy values for additional details.

This field is immutable.

Defaults to ReadWriteOnceWithFSType, which will examine each volume to determine if Kubernetes should modify ownership and permissions of the volume. With the default policy the defined fsGroup will only be applied if a fstype is defined and the volume's access mode contains ReadWriteOnce.

---

##### `pod_info_on_mount`<sup>Optional</sup> <a name="pod_info_on_mount" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.podInfoOnMount"></a>

```python
pod_info_on_mount: bool
```

- *Type:* bool
- *Default:* false.

podInfoOnMount indicates this CSI volume driver requires additional pod information (like podName, podUID, etc.) during mount operations, if set to true. If set to false, pod information will not be passed on mount. Default is false.

The CSI driver specifies podInfoOnMount as part of driver deployment. If true, Kubelet will pass pod information as VolumeContext in the CSI NodePublishVolume() calls. The CSI driver is responsible for parsing and validating the information passed in as VolumeContext.

The following VolumeConext will be passed if podInfoOnMount is set to true. This list might grow, but the prefix will be used. "csi.storage.k8s.io/pod.name": pod.Name "csi.storage.k8s.io/pod.namespace": pod.Namespace "csi.storage.k8s.io/pod.uid": string(pod.UID) "csi.storage.k8s.io/ephemeral": "true" if the volume is an ephemeral inline volume
defined by a CSIVolumeSource, otherwise "false"

"csi.storage.k8s.io/ephemeral" is a new feature in Kubernetes 1.16. It is only required for drivers which support both the "Persistent" and "Ephemeral" VolumeLifecycleMode. Other drivers can leave pod info disabled and/or ignore this field. As Kubernetes 1.15 doesn't support this field, drivers can only support one mode when deployed on such a cluster and the deployment determines which mode that is, for example via a command line parameter of the driver.

This field is immutable.

---

##### `requires_republish`<sup>Optional</sup> <a name="requires_republish" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.requiresRepublish"></a>

```python
requires_republish: bool
```

- *Type:* bool

requiresRepublish indicates the CSI driver wants `NodePublishVolume` being periodically called to reflect any possible change in the mounted volume.

This field defaults to false.

Note: After a successful initial NodePublishVolume call, subsequent calls to NodePublishVolume should only update the contents of the volume. New mount points will not be seen by a running container.

---

##### `se_linux_mount`<sup>Optional</sup> <a name="se_linux_mount" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.seLinuxMount"></a>

```python
se_linux_mount: bool
```

- *Type:* bool
- *Default:* false".

seLinuxMount specifies if the CSI driver supports "-o context" mount option.

When "true", the CSI driver must ensure that all volumes provided by this CSI driver can be mounted separately with different `-o context` options. This is typical for storage backends that provide volumes as filesystems on block devices or as independent shared volumes. Kubernetes will call NodeStage / NodePublish with "-o context=xyz" mount option when mounting a ReadWriteOncePod volume used in Pod that has explicitly set SELinux context. In the future, it may be expanded to other volume AccessModes. In any case, Kubernetes will ensure that the volume is mounted only with a single SELinux context.

When "false", Kubernetes won't pass any special SELinux mount options to the driver. This is typical for volumes that represent subdirectories of a bigger shared filesystem.

Default is "false".

---

##### `storage_capacity`<sup>Optional</sup> <a name="storage_capacity" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.storageCapacity"></a>

```python
storage_capacity: bool
```

- *Type:* bool

storageCapacity indicates that the CSI volume driver wants pod scheduling to consider the storage capacity that the driver deployment will report by creating CSIStorageCapacity objects with capacity information, if set to true.

The check can be enabled immediately when deploying a driver. In that case, provisioning new volumes with late binding will pause until the driver deployment has published some suitable CSIStorageCapacity object.

Alternatively, the driver can be deployed with the field unset or false and it can be flipped later when storage capacity information has been published.

This field was immutable in Kubernetes <= 1.22 and now is mutable.

---

##### `token_requests`<sup>Optional</sup> <a name="token_requests" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.tokenRequests"></a>

```python
token_requests: typing.List[TokenRequest]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.TokenRequest]

tokenRequests indicates the CSI driver needs pods' service account tokens it is mounting volume for to do necessary authentication.

Kubelet will pass the tokens in VolumeContext in the CSI NodePublishVolume calls. The CSI driver should parse and validate the following VolumeContext: "csi.storage.k8s.io/serviceAccount.tokens": {
"<audience>": {
"token": <token>,
"expirationTimestamp": <expiration timestamp in RFC3339>,
},
...
}

Note: Audience in each TokenRequest should be different and at most one token is empty string. To receive a new token after expiry, RequiresRepublish can be used to trigger NodePublishVolume periodically.

---

##### `volume_lifecycle_modes`<sup>Optional</sup> <a name="volume_lifecycle_modes" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.volumeLifecycleModes"></a>

```python
volume_lifecycle_modes: typing.List[str]
```

- *Type:* typing.List[str]

volumeLifecycleModes defines what kind of volumes this CSI volume driver supports.

The default if the list is empty is "Persistent", which is the usage defined by the CSI specification and implemented in Kubernetes via the usual PV/PVC mechanism.

The other mode is "Ephemeral". In this mode, volumes are defined inline inside the pod spec with CSIVolumeSource and their lifecycle is tied to the lifecycle of that pod. A driver has to be aware of this because it is only going to get a NodePublishVolume call for such a volume.

For more information about implementing this mode, see https://kubernetes-csi.github.io/docs/ephemeral-local-volumes.html A driver can support one or more of these modes and more modes may be added in the future.

This field is beta. This field is immutable.

---

### CsiNodeDriver <a name="CsiNodeDriver" id="cdk8s-plus-28.k8s.CsiNodeDriver"></a>

CSINodeDriver holds information about the specification of one CSI driver installed on a node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiNodeDriver.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CsiNodeDriver(
  name: str,
  node_id: str,
  allocatable: VolumeNodeResources = None,
  topology_keys: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.name">name</a></code> | <code>str</code> | name represents the name of the CSI driver that this object refers to. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.nodeId">node_id</a></code> | <code>str</code> | nodeID of the node from the driver point of view. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.allocatable">allocatable</a></code> | <code>cdk8s_plus_28.k8s.VolumeNodeResources</code> | allocatable represents the volume resources of a node that are available for scheduling. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.topologyKeys">topology_keys</a></code> | <code>typing.List[str]</code> | topologyKeys is the list of keys supported by the driver. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.name"></a>

```python
name: str
```

- *Type:* str

name represents the name of the CSI driver that this object refers to.

This MUST be the same name returned by the CSI GetPluginName() call for that driver.

---

##### `node_id`<sup>Required</sup> <a name="node_id" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.nodeId"></a>

```python
node_id: str
```

- *Type:* str

nodeID of the node from the driver point of view.

This field enables Kubernetes to communicate with storage systems that do not share the same nomenclature for nodes. For example, Kubernetes may refer to a given node as "node1", but the storage system may refer to the same node as "nodeA". When Kubernetes issues a command to the storage system to attach a volume to a specific node, it can use this field to refer to the node name using the ID that the storage system will understand, e.g. "nodeA" instead of "node1". This field is required.

---

##### `allocatable`<sup>Optional</sup> <a name="allocatable" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.allocatable"></a>

```python
allocatable: VolumeNodeResources
```

- *Type:* cdk8s_plus_28.k8s.VolumeNodeResources

allocatable represents the volume resources of a node that are available for scheduling.

This field is beta.

---

##### `topology_keys`<sup>Optional</sup> <a name="topology_keys" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.topologyKeys"></a>

```python
topology_keys: typing.List[str]
```

- *Type:* typing.List[str]

topologyKeys is the list of keys supported by the driver.

When a driver is initialized on a cluster, it provides a set of topology keys that it understands (e.g. "company.com/zone", "company.com/region"). When a driver is initialized on a node, it provides the same topology keys along with values. Kubelet will expose these topology keys as labels on its own node object. When Kubernetes does topology aware provisioning, it can use this list to determine which labels it should retrieve from the node object and pass back to the driver. It is possible for different nodes to use different topology keys. This can be empty if driver does not support topology.

---

### CsiNodeSpec <a name="CsiNodeSpec" id="cdk8s-plus-28.k8s.CsiNodeSpec"></a>

CSINodeSpec holds information about the specification of all CSI drivers installed on a node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiNodeSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CsiNodeSpec(
  drivers: typing.List[CsiNodeDriver]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeSpec.property.drivers">drivers</a></code> | <code>typing.List[cdk8s_plus_28.k8s.CsiNodeDriver]</code> | drivers is a list of information of all CSI Drivers existing on a node. |

---

##### `drivers`<sup>Required</sup> <a name="drivers" id="cdk8s-plus-28.k8s.CsiNodeSpec.property.drivers"></a>

```python
drivers: typing.List[CsiNodeDriver]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.CsiNodeDriver]

drivers is a list of information of all CSI Drivers existing on a node.

If all drivers in the list are uninstalled, this can become empty.

---

### CsiPersistentVolumeSource <a name="CsiPersistentVolumeSource" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource"></a>

Represents storage that is managed by an external CSI volume driver (Beta feature).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CsiPersistentVolumeSource(
  driver: str,
  volume_handle: str,
  controller_expand_secret_ref: SecretReference = None,
  controller_publish_secret_ref: SecretReference = None,
  fs_type: str = None,
  node_expand_secret_ref: SecretReference = None,
  node_publish_secret_ref: SecretReference = None,
  node_stage_secret_ref: SecretReference = None,
  read_only: bool = None,
  volume_attributes: typing.Mapping[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.driver">driver</a></code> | <code>str</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeHandle">volume_handle</a></code> | <code>str</code> | volumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerExpandSecretRef">controller_expand_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | controllerExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerExpandVolume call. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerPublishSecretRef">controller_publish_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | controllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeExpandSecretRef">node_expand_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | nodeExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeExpandVolume call. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodePublishSecretRef">node_publish_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeStageSecretRef">node_stage_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | nodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly value to pass to ControllerPublishVolumeRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeAttributes">volume_attributes</a></code> | <code>typing.Mapping[str]</code> | volumeAttributes of the volume to publish. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.driver"></a>

```python
driver: str
```

- *Type:* str

driver is the name of the driver to use for this volume.

Required.

---

##### `volume_handle`<sup>Required</sup> <a name="volume_handle" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeHandle"></a>

```python
volume_handle: str
```

- *Type:* str

volumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls.

Required.

---

##### `controller_expand_secret_ref`<sup>Optional</sup> <a name="controller_expand_secret_ref" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerExpandSecretRef"></a>

```python
controller_expand_secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

controllerExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerExpandVolume call.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `controller_publish_secret_ref`<sup>Optional</sup> <a name="controller_publish_secret_ref" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerPublishSecretRef"></a>

```python
controller_publish_secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

controllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs".

---

##### `node_expand_secret_ref`<sup>Optional</sup> <a name="node_expand_secret_ref" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeExpandSecretRef"></a>

```python
node_expand_secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

nodeExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeExpandVolume call.

This is a beta field which is enabled default by CSINodeExpandSecret feature gate. This field is optional, may be omitted if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `node_publish_secret_ref`<sup>Optional</sup> <a name="node_publish_secret_ref" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodePublishSecretRef"></a>

```python
node_publish_secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `node_stage_secret_ref`<sup>Optional</sup> <a name="node_stage_secret_ref" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeStageSecretRef"></a>

```python
node_stage_secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

nodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write).

readOnly value to pass to ControllerPublishVolumeRequest.

Defaults to false (read/write).

---

##### `volume_attributes`<sup>Optional</sup> <a name="volume_attributes" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeAttributes"></a>

```python
volume_attributes: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

volumeAttributes of the volume to publish.

---

### CsiVolumeOptions <a name="CsiVolumeOptions" id="cdk8s-plus-28.CsiVolumeOptions"></a>

Options for the CSI driver based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CsiVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.CsiVolumeOptions(
  attributes: typing.Mapping[str] = None,
  fs_type: str = None,
  name: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.attributes">attributes</a></code> | <code>typing.Mapping[str]</code> | Any driver-specific attributes to pass to the CSI volume builder. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.fsType">fs_type</a></code> | <code>str</code> | The filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Whether the mounted volume should be read-only or not. |

---

##### `attributes`<sup>Optional</sup> <a name="attributes" id="cdk8s-plus-28.CsiVolumeOptions.property.attributes"></a>

```python
attributes: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]
- *Default:* undefined

Any driver-specific attributes to pass to the CSI volume builder.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.CsiVolumeOptions.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* driver-dependent

The filesystem type to mount.

Ex. "ext4", "xfs", "ntfs". If not provided,
the empty value is passed to the associated CSI driver, which will
determine the default filesystem to apply.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.CsiVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.CsiVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Whether the mounted volume should be read-only or not.

---

### CsiVolumeSource <a name="CsiVolumeSource" id="cdk8s-plus-28.k8s.CsiVolumeSource"></a>

Represents a source location of a volume to mount, managed by an external CSI driver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CsiVolumeSource(
  driver: str,
  fs_type: str = None,
  node_publish_secret_ref: LocalObjectReference = None,
  read_only: bool = None,
  volume_attributes: typing.Mapping[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.driver">driver</a></code> | <code>str</code> | driver is the name of the CSI driver that handles this volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.nodePublishSecretRef">node_publish_secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly specifies a read-only configuration for the volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.volumeAttributes">volume_attributes</a></code> | <code>typing.Mapping[str]</code> | volumeAttributes stores driver-specific properties that are passed to the CSI driver. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.driver"></a>

```python
driver: str
```

- *Type:* str

driver is the name of the CSI driver that handles this volume.

Consult with your admin for the correct name as registered in the cluster.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType to mount.

Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.

---

##### `node_publish_secret_ref`<sup>Optional</sup> <a name="node_publish_secret_ref" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.nodePublishSecretRef"></a>

```python
node_publish_secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls.

This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write).

readOnly specifies a read-only configuration for the volume.

Defaults to false (read/write).

---

##### `volume_attributes`<sup>Optional</sup> <a name="volume_attributes" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.volumeAttributes"></a>

```python
volume_attributes: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

volumeAttributes stores driver-specific properties that are passed to the CSI driver.

Consult your driver's documentation for supported values.

---

### CustomResourceColumnDefinition <a name="CustomResourceColumnDefinition" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition"></a>

CustomResourceColumnDefinition specifies a column for server side printing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceColumnDefinition(
  json_path: str,
  name: str,
  type: str,
  description: str = None,
  format: str = None,
  priority: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.jsonPath">json_path</a></code> | <code>str</code> | jsonPath is a simple JSON path (i.e. with array notation) which is evaluated against each custom resource to produce the value for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.name">name</a></code> | <code>str</code> | name is a human readable name for the column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.type">type</a></code> | <code>str</code> | type is an OpenAPI type definition for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.description">description</a></code> | <code>str</code> | description is a human readable description of this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.format">format</a></code> | <code>str</code> | format is an optional OpenAPI type definition for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.priority">priority</a></code> | <code>typing.Union[int, float]</code> | priority is an integer defining the relative importance of this column compared to others. |

---

##### `json_path`<sup>Required</sup> <a name="json_path" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.jsonPath"></a>

```python
json_path: str
```

- *Type:* str

jsonPath is a simple JSON path (i.e. with array notation) which is evaluated against each custom resource to produce the value for this column.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.name"></a>

```python
name: str
```

- *Type:* str

name is a human readable name for the column.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.type"></a>

```python
type: str
```

- *Type:* str

type is an OpenAPI type definition for this column.

See https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#data-types for details.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.description"></a>

```python
description: str
```

- *Type:* str

description is a human readable description of this column.

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.format"></a>

```python
format: str
```

- *Type:* str

format is an optional OpenAPI type definition for this column.

The 'name' format is applied to the primary identifier column to assist in clients identifying column is the resource name. See https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#data-types for details.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.priority"></a>

```python
priority: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

priority is an integer defining the relative importance of this column compared to others.

Lower numbers are considered higher priority. Columns that may be omitted in limited space scenarios should be given a priority greater than 0.

---

### CustomResourceConversion <a name="CustomResourceConversion" id="cdk8s-plus-28.k8s.CustomResourceConversion"></a>

CustomResourceConversion describes how to convert different versions of a CR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceConversion.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceConversion(
  strategy: str,
  webhook: WebhookConversion = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceConversion.property.strategy">strategy</a></code> | <code>str</code> | strategy specifies how custom resources are converted between versions. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceConversion.property.webhook">webhook</a></code> | <code>cdk8s_plus_28.k8s.WebhookConversion</code> | webhook describes how to call the conversion webhook. |

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.k8s.CustomResourceConversion.property.strategy"></a>

```python
strategy: str
```

- *Type:* str

strategy specifies how custom resources are converted between versions.

Allowed values are: - `"None"`: The converter only change the apiVersion and would not touch any other field in the custom resource. - `"Webhook"`: API Server will call to an external webhook to do the conversion. Additional information
is needed for this option. This requires spec.preserveUnknownFields to be false, and spec.conversion.webhook to be set.

---

##### `webhook`<sup>Optional</sup> <a name="webhook" id="cdk8s-plus-28.k8s.CustomResourceConversion.property.webhook"></a>

```python
webhook: WebhookConversion
```

- *Type:* cdk8s_plus_28.k8s.WebhookConversion

webhook describes how to call the conversion webhook.

Required when `strategy` is set to `"Webhook"`.

---

### CustomResourceDefinitionNames <a name="CustomResourceDefinitionNames" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames"></a>

CustomResourceDefinitionNames indicates the names to serve this CustomResourceDefinition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceDefinitionNames(
  kind: str,
  plural: str,
  categories: typing.List[str] = None,
  list_kind: str = None,
  short_names: typing.List[str] = None,
  singular: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.kind">kind</a></code> | <code>str</code> | kind is the serialized kind of the resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.plural">plural</a></code> | <code>str</code> | plural is the plural name of the resource to serve. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.categories">categories</a></code> | <code>typing.List[str]</code> | categories is a list of grouped resources this custom resource belongs to (e.g. 'all'). This is published in API discovery documents, and used by clients to support invocations like `kubectl get all`. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.listKind">list_kind</a></code> | <code>str</code> | listKind is the serialized kind of the list for this resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.shortNames">short_names</a></code> | <code>typing.List[str]</code> | shortNames are short names for the resource, exposed in API discovery documents, and used by clients to support invocations like `kubectl get <shortname>`. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.singular">singular</a></code> | <code>str</code> | singular is the singular name of the resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.kind"></a>

```python
kind: str
```

- *Type:* str

kind is the serialized kind of the resource.

It is normally CamelCase and singular. Custom resource instances will use this value as the `kind` attribute in API calls.

---

##### `plural`<sup>Required</sup> <a name="plural" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.plural"></a>

```python
plural: str
```

- *Type:* str

plural is the plural name of the resource to serve.

The custom resources are served under `/apis/<group>/<version>/.../<plural>`. Must match the name of the CustomResourceDefinition (in the form `<names.plural>.<group>`). Must be all lowercase.

---

##### `categories`<sup>Optional</sup> <a name="categories" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.categories"></a>

```python
categories: typing.List[str]
```

- *Type:* typing.List[str]

categories is a list of grouped resources this custom resource belongs to (e.g. 'all'). This is published in API discovery documents, and used by clients to support invocations like `kubectl get all`.

---

##### `list_kind`<sup>Optional</sup> <a name="list_kind" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.listKind"></a>

```python
list_kind: str
```

- *Type:* str
- *Default:* kind`List".

listKind is the serialized kind of the list for this resource.

Defaults to "`kind`List".

---

##### `short_names`<sup>Optional</sup> <a name="short_names" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.shortNames"></a>

```python
short_names: typing.List[str]
```

- *Type:* typing.List[str]

shortNames are short names for the resource, exposed in API discovery documents, and used by clients to support invocations like `kubectl get <shortname>`.

It must be all lowercase.

---

##### `singular`<sup>Optional</sup> <a name="singular" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.singular"></a>

```python
singular: str
```

- *Type:* str
- *Default:* lowercased `kind`.

singular is the singular name of the resource.

It must be all lowercase. Defaults to lowercased `kind`.

---

### CustomResourceDefinitionSpec <a name="CustomResourceDefinitionSpec" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec"></a>

CustomResourceDefinitionSpec describes how a user wants their resource to appear.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceDefinitionSpec(
  group: str,
  names: CustomResourceDefinitionNames,
  scope: str,
  versions: typing.List[CustomResourceDefinitionVersion],
  conversion: CustomResourceConversion = None,
  preserve_unknown_fields: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.group">group</a></code> | <code>str</code> | group is the API group of the defined custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.names">names</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceDefinitionNames</code> | names specify the resource and kind names for the custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.scope">scope</a></code> | <code>str</code> | scope indicates whether the defined custom resource is cluster- or namespace-scoped. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.versions">versions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.CustomResourceDefinitionVersion]</code> | versions is the list of all API versions of the defined custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.conversion">conversion</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceConversion</code> | conversion defines conversion settings for the CRD. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.preserveUnknownFields">preserve_unknown_fields</a></code> | <code>bool</code> | preserveUnknownFields indicates that object fields which are not specified in the OpenAPI schema should be preserved when persisting to storage. |

---

##### `group`<sup>Required</sup> <a name="group" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.group"></a>

```python
group: str
```

- *Type:* str

group is the API group of the defined custom resource.

The custom resources are served under `/apis/<group>/...`. Must match the name of the CustomResourceDefinition (in the form `<names.plural>.<group>`).

---

##### `names`<sup>Required</sup> <a name="names" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.names"></a>

```python
names: CustomResourceDefinitionNames
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceDefinitionNames

names specify the resource and kind names for the custom resource.

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.scope"></a>

```python
scope: str
```

- *Type:* str

scope indicates whether the defined custom resource is cluster- or namespace-scoped.

Allowed values are `Cluster` and `Namespaced`.

---

##### `versions`<sup>Required</sup> <a name="versions" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.versions"></a>

```python
versions: typing.List[CustomResourceDefinitionVersion]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.CustomResourceDefinitionVersion]

versions is the list of all API versions of the defined custom resource.

Version names are used to compute the order in which served versions are listed in API discovery. If the version string is "kube-like", it will sort above non "kube-like" version strings, which are ordered lexicographically. "Kube-like" versions start with a "v", then are followed by a number (the major version), then optionally the string "alpha" or "beta" and another number (the minor version). These are sorted first by GA > beta > alpha (where GA is a version with no suffix such as beta or alpha), and then by comparing major version, then minor version. An example sorted list of versions: v10, v2, v1, v11beta2, v10beta3, v3beta1, v12alpha1, v11alpha2, foo1, foo10.

---

##### `conversion`<sup>Optional</sup> <a name="conversion" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.conversion"></a>

```python
conversion: CustomResourceConversion
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceConversion

conversion defines conversion settings for the CRD.

---

##### `preserve_unknown_fields`<sup>Optional</sup> <a name="preserve_unknown_fields" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.preserveUnknownFields"></a>

```python
preserve_unknown_fields: bool
```

- *Type:* bool

preserveUnknownFields indicates that object fields which are not specified in the OpenAPI schema should be preserved when persisting to storage.

apiVersion, kind, metadata and known fields inside metadata are always preserved. This field is deprecated in favor of setting `x-preserve-unknown-fields` to true in `spec.versions[*].schema.openAPIV3Schema`. See https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/#field-pruning for details.

---

### CustomResourceDefinitionVersion <a name="CustomResourceDefinitionVersion" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion"></a>

CustomResourceDefinitionVersion describes a version for CRD.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceDefinitionVersion(
  name: str,
  served: bool,
  storage: bool,
  additional_printer_columns: typing.List[CustomResourceColumnDefinition] = None,
  deprecated: bool = None,
  deprecation_warning: str = None,
  schema: CustomResourceValidation = None,
  subresources: CustomResourceSubresources = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.name">name</a></code> | <code>str</code> | name is the version name, e.g. “v1”, “v2beta1”, etc. The custom resources are served under this version at `/apis/<group>/<version>/...` if `served` is true. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.served">served</a></code> | <code>bool</code> | served is a flag enabling/disabling this version from being served via REST APIs. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.storage">storage</a></code> | <code>bool</code> | storage indicates this version should be used when persisting custom resources to storage. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.additionalPrinterColumns">additional_printer_columns</a></code> | <code>typing.List[cdk8s_plus_28.k8s.CustomResourceColumnDefinition]</code> | additionalPrinterColumns specifies additional columns returned in Table output. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecated">deprecated</a></code> | <code>bool</code> | deprecated indicates this version of the custom resource API is deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecationWarning">deprecation_warning</a></code> | <code>str</code> | deprecationWarning overrides the default warning returned to API clients. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.schema">schema</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceValidation</code> | schema describes the schema used for validation, pruning, and defaulting of this version of the custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.subresources">subresources</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceSubresources</code> | subresources specify what subresources this version of the defined custom resource have. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.name"></a>

```python
name: str
```

- *Type:* str

name is the version name, e.g. “v1”, “v2beta1”, etc. The custom resources are served under this version at `/apis/<group>/<version>/...` if `served` is true.

---

##### `served`<sup>Required</sup> <a name="served" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.served"></a>

```python
served: bool
```

- *Type:* bool

served is a flag enabling/disabling this version from being served via REST APIs.

---

##### `storage`<sup>Required</sup> <a name="storage" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.storage"></a>

```python
storage: bool
```

- *Type:* bool

storage indicates this version should be used when persisting custom resources to storage.

There must be exactly one version with storage=true.

---

##### `additional_printer_columns`<sup>Optional</sup> <a name="additional_printer_columns" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.additionalPrinterColumns"></a>

```python
additional_printer_columns: typing.List[CustomResourceColumnDefinition]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.CustomResourceColumnDefinition]

additionalPrinterColumns specifies additional columns returned in Table output.

See https://kubernetes.io/docs/reference/using-api/api-concepts/#receiving-resources-as-tables for details. If no columns are specified, a single column displaying the age of the custom resource is used.

---

##### `deprecated`<sup>Optional</sup> <a name="deprecated" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecated"></a>

```python
deprecated: bool
```

- *Type:* bool
- *Default:* false.

deprecated indicates this version of the custom resource API is deprecated.

When set to true, API requests to this version receive a warning header in the server response. Defaults to false.

---

##### `deprecation_warning`<sup>Optional</sup> <a name="deprecation_warning" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecationWarning"></a>

```python
deprecation_warning: str
```

- *Type:* str

deprecationWarning overrides the default warning returned to API clients.

May only be set when `deprecated` is true. The default warning indicates this version is deprecated and recommends use of the newest served version of equal or greater stability, if one exists.

---

##### `schema`<sup>Optional</sup> <a name="schema" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.schema"></a>

```python
schema: CustomResourceValidation
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceValidation

schema describes the schema used for validation, pruning, and defaulting of this version of the custom resource.

---

##### `subresources`<sup>Optional</sup> <a name="subresources" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.subresources"></a>

```python
subresources: CustomResourceSubresources
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceSubresources

subresources specify what subresources this version of the defined custom resource have.

---

### CustomResourceSubresources <a name="CustomResourceSubresources" id="cdk8s-plus-28.k8s.CustomResourceSubresources"></a>

CustomResourceSubresources defines the status and scale subresources for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceSubresources.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceSubresources(
  scale: CustomResourceSubresourceScale = None,
  status: typing.Any = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresources.property.scale">scale</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceSubresourceScale</code> | scale indicates the custom resource should serve a `/scale` subresource that returns an `autoscaling/v1` Scale object. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresources.property.status">status</a></code> | <code>typing.Any</code> | status indicates the custom resource should serve a `/status` subresource. |

---

##### `scale`<sup>Optional</sup> <a name="scale" id="cdk8s-plus-28.k8s.CustomResourceSubresources.property.scale"></a>

```python
scale: CustomResourceSubresourceScale
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceSubresourceScale

scale indicates the custom resource should serve a `/scale` subresource that returns an `autoscaling/v1` Scale object.

---

##### `status`<sup>Optional</sup> <a name="status" id="cdk8s-plus-28.k8s.CustomResourceSubresources.property.status"></a>

```python
status: typing.Any
```

- *Type:* typing.Any

status indicates the custom resource should serve a `/status` subresource.

When enabled: 1. requests to the custom resource primary endpoint ignore changes to the `status` stanza of the object. 2. requests to the custom resource `/status` subresource ignore changes to anything other than the `status` stanza of the object.

---

### CustomResourceSubresourceScale <a name="CustomResourceSubresourceScale" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale"></a>

CustomResourceSubresourceScale defines how to serve the scale subresource for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceSubresourceScale(
  spec_replicas_path: str,
  status_replicas_path: str,
  label_selector_path: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.specReplicasPath">spec_replicas_path</a></code> | <code>str</code> | specReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `spec.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.spec`. If there is no value under the given path in the custom resource, the `/scale` subresource will return an error on GET. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.statusReplicasPath">status_replicas_path</a></code> | <code>str</code> | statusReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `status.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status`. If there is no value under the given path in the custom resource, the `status.replicas` value in the `/scale` subresource will default to 0. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.labelSelectorPath">label_selector_path</a></code> | <code>str</code> | labelSelectorPath defines the JSON path inside of a custom resource that corresponds to Scale `status.selector`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status` or `.spec`. Must be set to work with HorizontalPodAutoscaler. The field pointed by this JSON path must be a string field (not a complex selector struct) which contains a serialized label selector in string form. More info: https://kubernetes.io/docs/tasks/access-kubernetes-api/custom-resources/custom-resource-definitions#scale-subresource If there is no value under the given path in the custom resource, the `status.selector` value in the `/scale` subresource will default to the empty string. |

---

##### `spec_replicas_path`<sup>Required</sup> <a name="spec_replicas_path" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.specReplicasPath"></a>

```python
spec_replicas_path: str
```

- *Type:* str

specReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `spec.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.spec`. If there is no value under the given path in the custom resource, the `/scale` subresource will return an error on GET.

---

##### `status_replicas_path`<sup>Required</sup> <a name="status_replicas_path" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.statusReplicasPath"></a>

```python
status_replicas_path: str
```

- *Type:* str

statusReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `status.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status`. If there is no value under the given path in the custom resource, the `status.replicas` value in the `/scale` subresource will default to 0.

---

##### `label_selector_path`<sup>Optional</sup> <a name="label_selector_path" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.labelSelectorPath"></a>

```python
label_selector_path: str
```

- *Type:* str

labelSelectorPath defines the JSON path inside of a custom resource that corresponds to Scale `status.selector`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status` or `.spec`. Must be set to work with HorizontalPodAutoscaler. The field pointed by this JSON path must be a string field (not a complex selector struct) which contains a serialized label selector in string form. More info: https://kubernetes.io/docs/tasks/access-kubernetes-api/custom-resources/custom-resource-definitions#scale-subresource If there is no value under the given path in the custom resource, the `status.selector` value in the `/scale` subresource will default to the empty string.

---

### CustomResourceValidation <a name="CustomResourceValidation" id="cdk8s-plus-28.k8s.CustomResourceValidation"></a>

CustomResourceValidation is a list of validation methods for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceValidation.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.CustomResourceValidation(
  open_apiv3_schema: JsonSchemaProps = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceValidation.property.openApiv3Schema">open_apiv3_schema</a></code> | <code>cdk8s_plus_28.k8s.JsonSchemaProps</code> | openAPIV3Schema is the OpenAPI v3 schema to use for validation and pruning. |

---

##### `open_apiv3_schema`<sup>Optional</sup> <a name="open_apiv3_schema" id="cdk8s-plus-28.k8s.CustomResourceValidation.property.openApiv3Schema"></a>

```python
open_apiv3_schema: JsonSchemaProps
```

- *Type:* cdk8s_plus_28.k8s.JsonSchemaProps

openAPIV3Schema is the OpenAPI v3 schema to use for validation and pruning.

---

### DaemonSetProps <a name="DaemonSetProps" id="cdk8s-plus-28.DaemonSetProps"></a>

Properties for `DaemonSet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DaemonSetProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DaemonSetProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DaemonSetProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.DaemonSetProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.DaemonSetProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.DaemonSetProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.DaemonSetProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.DaemonSetProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.DaemonSetProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.DaemonSetProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.DaemonSetProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DaemonSetProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.DaemonSetProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.DaemonSetProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.DaemonSetProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.DaemonSetProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.DaemonSetProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.DaemonSetProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.DaemonSetProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.DaemonSetProps.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

### DaemonSetSpec <a name="DaemonSetSpec" id="cdk8s-plus-28.k8s.DaemonSetSpec"></a>

DaemonSetSpec is the specification of a daemon set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DaemonSetSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DaemonSetSpec(
  selector: LabelSelector,
  template: PodTemplateSpec,
  min_ready_seconds: typing.Union[int, float] = None,
  revision_history_limit: typing.Union[int, float] = None,
  update_strategy: DaemonSetUpdateStrategy = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | A label query over pods that are managed by the daemon set. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | An object that describes the pod that will be created. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.revisionHistoryLimit">revision_history_limit</a></code> | <code>typing.Union[int, float]</code> | The number of old history to retain to allow rollback. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.updateStrategy">update_strategy</a></code> | <code>cdk8s_plus_28.k8s.DaemonSetUpdateStrategy</code> | An update strategy to replace existing DaemonSet pods with new pods. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

A label query over pods that are managed by the daemon set.

Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

An object that describes the pod that will be created.

The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). The only allowed template.spec.restartPolicy value is "Always". More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0 (pod will be considered available as soon as it is ready).

The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready).

---

##### `revision_history_limit`<sup>Optional</sup> <a name="revision_history_limit" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.revisionHistoryLimit"></a>

```python
revision_history_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 10.

The number of old history to retain to allow rollback.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.

---

##### `update_strategy`<sup>Optional</sup> <a name="update_strategy" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.updateStrategy"></a>

```python
update_strategy: DaemonSetUpdateStrategy
```

- *Type:* cdk8s_plus_28.k8s.DaemonSetUpdateStrategy

An update strategy to replace existing DaemonSet pods with new pods.

---

### DaemonSetUpdateStrategy <a name="DaemonSetUpdateStrategy" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy"></a>

DaemonSetUpdateStrategy is a struct used to control the update strategy for a DaemonSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DaemonSetUpdateStrategy(
  rolling_update: RollingUpdateDaemonSet = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.rollingUpdate">rolling_update</a></code> | <code>cdk8s_plus_28.k8s.RollingUpdateDaemonSet</code> | Rolling update config params. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.type">type</a></code> | <code>str</code> | Type of daemon set update. |

---

##### `rolling_update`<sup>Optional</sup> <a name="rolling_update" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.rollingUpdate"></a>

```python
rolling_update: RollingUpdateDaemonSet
```

- *Type:* cdk8s_plus_28.k8s.RollingUpdateDaemonSet

Rolling update config params.

Present only if type = "RollingUpdate".

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* RollingUpdate.

Type of daemon set update.

Can be "RollingUpdate" or "OnDelete". Default is RollingUpdate.

---

### DeleteOptions <a name="DeleteOptions" id="cdk8s-plus-28.k8s.DeleteOptions"></a>

DeleteOptions may be provided when deleting an API object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeleteOptions.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DeleteOptions(
  api_version: str = None,
  dry_run: typing.List[str] = None,
  grace_period_seconds: typing.Union[int, float] = None,
  kind: IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind = None,
  orphan_dependents: bool = None,
  preconditions: Preconditions = None,
  propagation_policy: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.apiVersion">api_version</a></code> | <code>str</code> | APIVersion defines the versioned schema of this representation of an object. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.dryRun">dry_run</a></code> | <code>typing.List[str]</code> | When present, indicates that modifications should not be persisted. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.gracePeriodSeconds">grace_period_seconds</a></code> | <code>typing.Union[int, float]</code> | The duration in seconds before the object should be deleted. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.kind">kind</a></code> | <code>cdk8s_plus_28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind</code> | Kind is a string value representing the REST resource this object represents. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.orphanDependents">orphan_dependents</a></code> | <code>bool</code> | Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.preconditions">preconditions</a></code> | <code>cdk8s_plus_28.k8s.Preconditions</code> | Must be fulfilled before a deletion is carried out. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.propagationPolicy">propagation_policy</a></code> | <code>str</code> | Whether and how garbage collection will be performed. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.DeleteOptions.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

APIVersion defines the versioned schema of this representation of an object.

Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

---

##### `dry_run`<sup>Optional</sup> <a name="dry_run" id="cdk8s-plus-28.k8s.DeleteOptions.property.dryRun"></a>

```python
dry_run: typing.List[str]
```

- *Type:* typing.List[str]

When present, indicates that modifications should not be persisted.

An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed

---

##### `grace_period_seconds`<sup>Optional</sup> <a name="grace_period_seconds" id="cdk8s-plus-28.k8s.DeleteOptions.property.gracePeriodSeconds"></a>

```python
grace_period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* a per object value if not specified. zero means delete immediately.

The duration in seconds before the object should be deleted.

Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.DeleteOptions.property.kind"></a>

```python
kind: IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind
```

- *Type:* cdk8s_plus_28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind

Kind is a string value representing the REST resource this object represents.

Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `orphan_dependents`<sup>Optional</sup> <a name="orphan_dependents" id="cdk8s-plus-28.k8s.DeleteOptions.property.orphanDependents"></a>

```python
orphan_dependents: bool
```

- *Type:* bool

Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.

---

##### `preconditions`<sup>Optional</sup> <a name="preconditions" id="cdk8s-plus-28.k8s.DeleteOptions.property.preconditions"></a>

```python
preconditions: Preconditions
```

- *Type:* cdk8s_plus_28.k8s.Preconditions

Must be fulfilled before a deletion is carried out.

If not possible, a 409 Conflict status will be returned.

---

##### `propagation_policy`<sup>Optional</sup> <a name="propagation_policy" id="cdk8s-plus-28.k8s.DeleteOptions.property.propagationPolicy"></a>

```python
propagation_policy: str
```

- *Type:* str

Whether and how garbage collection will be performed.

Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.

---

### DeploymentExposeViaServiceOptions <a name="DeploymentExposeViaServiceOptions" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions"></a>

Options for `Deployment.exposeViaService`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DeploymentExposeViaServiceOptions(
  name: str = None,
  ports: typing.List[ServicePort] = None,
  service_type: ServiceType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.name">name</a></code> | <code>str</code> | The name of the service to expose. |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]</code> | The ports that the service should bind to. |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.serviceType">service_type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | The type of the exposed service. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.ports"></a>

```python
ports: typing.List[ServicePort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

##### `service_type`<sup>Optional</sup> <a name="service_type" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.serviceType"></a>

```python
service_type: ServiceType
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

### DeploymentProps <a name="DeploymentProps" id="cdk8s-plus-28.DeploymentProps"></a>

Properties for `Deployment`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DeploymentProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready: Duration = None,
  progress_deadline: Duration = None,
  replicas: typing.Union[int, float] = None,
  strategy: DeploymentStrategy = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.progressDeadline">progress_deadline</a></code> | <code>cdk8s.Duration</code> | The maximum duration for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a></code> | Specifies the strategy used to replace old Pods by new ones. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DeploymentProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.DeploymentProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.DeploymentProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.DeploymentProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.DeploymentProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.DeploymentProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.DeploymentProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.DeploymentProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.DeploymentProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.DeploymentProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.DeploymentProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.DeploymentProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.DeploymentProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.DeploymentProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.DeploymentProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.DeploymentProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.DeploymentProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready`<sup>Optional</sup> <a name="min_ready" id="cdk8s-plus-28.DeploymentProps.property.minReady"></a>

```python
min_ready: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `progress_deadline`<sup>Optional</sup> <a name="progress_deadline" id="cdk8s-plus-28.DeploymentProps.property.progressDeadline"></a>

```python
progress_deadline: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(600)

The maximum duration for a deployment to make progress before it is considered to be failed.

The deployment controller will continue
to process failed deployments and a condition with a ProgressDeadlineExceeded
reason will be surfaced in the deployment status.

Note that progress will not be estimated during the time a deployment is paused.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.DeploymentProps.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 2

Number of desired pods.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.DeploymentProps.property.strategy"></a>

```python
strategy: DeploymentStrategy
```

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a>
- *Default:* RollingUpdate with maxSurge and maxUnavailable set to 25%.

Specifies the strategy used to replace old Pods by new ones.

---

### DeploymentSpec <a name="DeploymentSpec" id="cdk8s-plus-28.k8s.DeploymentSpec"></a>

DeploymentSpec is the specification of the desired behavior of the Deployment.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeploymentSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DeploymentSpec(
  selector: LabelSelector,
  template: PodTemplateSpec,
  min_ready_seconds: typing.Union[int, float] = None,
  paused: bool = None,
  progress_deadline_seconds: typing.Union[int, float] = None,
  replicas: typing.Union[int, float] = None,
  revision_history_limit: typing.Union[int, float] = None,
  strategy: DeploymentStrategy = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | Label selector for pods. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Template describes the pods that will be created. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.paused">paused</a></code> | <code>bool</code> | Indicates that the deployment is paused. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.progressDeadlineSeconds">progress_deadline_seconds</a></code> | <code>typing.Union[int, float]</code> | The maximum time in seconds for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.revisionHistoryLimit">revision_history_limit</a></code> | <code>typing.Union[int, float]</code> | The number of old ReplicaSets to retain to allow rollback. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.strategy">strategy</a></code> | <code>cdk8s_plus_28.k8s.DeploymentStrategy</code> | The deployment strategy to use to replace existing pods with new ones. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.DeploymentSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

Label selector for pods.

Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.DeploymentSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template describes the pods that will be created.

The only allowed template.spec.restartPolicy value is "Always".

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.k8s.DeploymentSpec.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `paused`<sup>Optional</sup> <a name="paused" id="cdk8s-plus-28.k8s.DeploymentSpec.property.paused"></a>

```python
paused: bool
```

- *Type:* bool

Indicates that the deployment is paused.

---

##### `progress_deadline_seconds`<sup>Optional</sup> <a name="progress_deadline_seconds" id="cdk8s-plus-28.k8s.DeploymentSpec.property.progressDeadlineSeconds"></a>

```python
progress_deadline_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 600s.

The maximum time in seconds for a deployment to make progress before it is considered to be failed.

The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.DeploymentSpec.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1.

Number of desired pods.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.

---

##### `revision_history_limit`<sup>Optional</sup> <a name="revision_history_limit" id="cdk8s-plus-28.k8s.DeploymentSpec.property.revisionHistoryLimit"></a>

```python
revision_history_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 10.

The number of old ReplicaSets to retain to allow rollback.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.k8s.DeploymentSpec.property.strategy"></a>

```python
strategy: DeploymentStrategy
```

- *Type:* cdk8s_plus_28.k8s.DeploymentStrategy

The deployment strategy to use to replace existing pods with new ones.

---

### DeploymentStrategy <a name="DeploymentStrategy" id="cdk8s-plus-28.k8s.DeploymentStrategy"></a>

DeploymentStrategy describes how to replace existing pods with new ones.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeploymentStrategy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DeploymentStrategy(
  rolling_update: RollingUpdateDeployment = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentStrategy.property.rollingUpdate">rolling_update</a></code> | <code>cdk8s_plus_28.k8s.RollingUpdateDeployment</code> | Rolling update config params. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentStrategy.property.type">type</a></code> | <code>str</code> | Type of deployment. |

---

##### `rolling_update`<sup>Optional</sup> <a name="rolling_update" id="cdk8s-plus-28.k8s.DeploymentStrategy.property.rollingUpdate"></a>

```python
rolling_update: RollingUpdateDeployment
```

- *Type:* cdk8s_plus_28.k8s.RollingUpdateDeployment

Rolling update config params.

Present only if DeploymentStrategyType = RollingUpdate.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.DeploymentStrategy.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* RollingUpdate.

Type of deployment.

Can be "Recreate" or "RollingUpdate". Default is RollingUpdate.

---

### DeploymentStrategyRollingUpdateOptions <a name="DeploymentStrategyRollingUpdateOptions" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions"></a>

Options for `DeploymentStrategy.rollingUpdate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DeploymentStrategyRollingUpdateOptions(
  max_surge: PercentOrAbsolute = None,
  max_unavailable: PercentOrAbsolute = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxSurge">max_surge</a></code> | <code><a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a></code> | The maximum number of pods that can be scheduled above the desired number of pods. |
| <code><a href="#cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxUnavailable">max_unavailable</a></code> | <code><a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a></code> | The maximum number of pods that can be unavailable during the update. |

---

##### `max_surge`<sup>Optional</sup> <a name="max_surge" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxSurge"></a>

```python
max_surge: PercentOrAbsolute
```

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be scheduled above the desired number of pods.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding up.
This can not be 0 if `maxUnavailable` is 0.

Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update
starts, such that the total number of old and new pods do not exceed 130% of desired pods.
Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that
total number of pods running at any time during the update is at most 130% of desired pods.

---

##### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxUnavailable"></a>

```python
max_unavailable: PercentOrAbsolute
```

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding down.
This can not be 0 if `maxSurge` is 0.

Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired
pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can
be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total
number of pods available at all times during the update is at least 70% of desired pods.

---

### DnsOption <a name="DnsOption" id="cdk8s-plus-28.DnsOption"></a>

Custom DNS option.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DnsOption.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DnsOption(
  name: str,
  value: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DnsOption.property.name">name</a></code> | <code>str</code> | Option name. |
| <code><a href="#cdk8s-plus-28.DnsOption.property.value">value</a></code> | <code>str</code> | Option value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DnsOption.property.name"></a>

```python
name: str
```

- *Type:* str

Option name.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.DnsOption.property.value"></a>

```python
value: str
```

- *Type:* str
- *Default:* No value.

Option value.

---

### DockerConfigSecretProps <a name="DockerConfigSecretProps" id="cdk8s-plus-28.DockerConfigSecretProps"></a>

Options for `DockerConfigSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DockerConfigSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DockerConfigSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  data: typing.Mapping[typing.Any]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.data">data</a></code> | <code>typing.Mapping[typing.Any]</code> | JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DockerConfigSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.DockerConfigSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `data`<sup>Required</sup> <a name="data" id="cdk8s-plus-28.DockerConfigSecretProps.property.data"></a>

```python
data: typing.Mapping[typing.Any]
```

- *Type:* typing.Mapping[typing.Any]

JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData.

> [https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file](https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file)

---

### DownwardApiProjection <a name="DownwardApiProjection" id="cdk8s-plus-28.k8s.DownwardApiProjection"></a>

Represents downward API info for projecting into a projected volume.

Note that this is identical to a downwardAPI volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiProjection.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DownwardApiProjection(
  items: typing.List[DownwardApiVolumeFile] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiProjection.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.DownwardApiVolumeFile]</code> | Items is a list of DownwardAPIVolume file. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.DownwardApiProjection.property.items"></a>

```python
items: typing.List[DownwardApiVolumeFile]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.DownwardApiVolumeFile]

Items is a list of DownwardAPIVolume file.

---

### DownwardApiVolumeFile <a name="DownwardApiVolumeFile" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile"></a>

DownwardAPIVolumeFile represents information to create the file containing the pod field.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DownwardApiVolumeFile(
  path: str,
  field_ref: ObjectFieldSelector = None,
  mode: typing.Union[int, float] = None,
  resource_field_ref: ResourceFieldSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.path">path</a></code> | <code>str</code> | Required: Path is  the relative path name of the file to be created. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.fieldRef">field_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectFieldSelector</code> | Required: Selects a field of the pod: only annotations, labels, name and namespace are supported. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.mode">mode</a></code> | <code>typing.Union[int, float]</code> | Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.resourceFieldRef">resource_field_ref</a></code> | <code>cdk8s_plus_28.k8s.ResourceFieldSelector</code> | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.path"></a>

```python
path: str
```

- *Type:* str

Required: Path is  the relative path name of the file to be created.

Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'

---

##### `field_ref`<sup>Optional</sup> <a name="field_ref" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.fieldRef"></a>

```python
field_ref: ObjectFieldSelector
```

- *Type:* cdk8s_plus_28.k8s.ObjectFieldSelector

Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.mode"></a>

```python
mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.

YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `resource_field_ref`<sup>Optional</sup> <a name="resource_field_ref" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.resourceFieldRef"></a>

```python
resource_field_ref: ResourceFieldSelector
```

- *Type:* cdk8s_plus_28.k8s.ResourceFieldSelector

Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.

---

### DownwardApiVolumeSource <a name="DownwardApiVolumeSource" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource"></a>

DownwardAPIVolumeSource represents a volume containing downward API info.

Downward API volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.DownwardApiVolumeSource(
  default_mode: typing.Union[int, float] = None,
  items: typing.List[DownwardApiVolumeFile] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | Optional: mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.DownwardApiVolumeFile]</code> | Items is a list of downward API volume file. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Optional: mode bits to use on created files by default.

Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.items"></a>

```python
items: typing.List[DownwardApiVolumeFile]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.DownwardApiVolumeFile]

Items is a list of downward API volume file.

---

### EmptyDirVolumeOptions <a name="EmptyDirVolumeOptions" id="cdk8s-plus-28.EmptyDirVolumeOptions"></a>

Options for volumes populated with an empty directory.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EmptyDirVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EmptyDirVolumeOptions(
  medium: EmptyDirMedium = None,
  size_limit: Size = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EmptyDirVolumeOptions.property.medium">medium</a></code> | <code><a href="#cdk8s-plus-28.EmptyDirMedium">EmptyDirMedium</a></code> | By default, emptyDir volumes are stored on whatever medium is backing the node - that might be disk or SSD or network storage, depending on your environment. |
| <code><a href="#cdk8s-plus-28.EmptyDirVolumeOptions.property.sizeLimit">size_limit</a></code> | <code>cdk8s.Size</code> | Total amount of local storage required for this EmptyDir volume. |

---

##### `medium`<sup>Optional</sup> <a name="medium" id="cdk8s-plus-28.EmptyDirVolumeOptions.property.medium"></a>

```python
medium: EmptyDirMedium
```

- *Type:* <a href="#cdk8s-plus-28.EmptyDirMedium">EmptyDirMedium</a>
- *Default:* EmptyDirMedium.DEFAULT

By default, emptyDir volumes are stored on whatever medium is backing the node - that might be disk or SSD or network storage, depending on your environment.

However, you can set the emptyDir.medium field to
`EmptyDirMedium.MEMORY` to tell Kubernetes to mount a tmpfs (RAM-backed
filesystem) for you instead. While tmpfs is very fast, be aware that unlike
disks, tmpfs is cleared on node reboot and any files you write will count
against your Container's memory limit.

---

##### `size_limit`<sup>Optional</sup> <a name="size_limit" id="cdk8s-plus-28.EmptyDirVolumeOptions.property.sizeLimit"></a>

```python
size_limit: Size
```

- *Type:* cdk8s.Size
- *Default:* limit is undefined

Total amount of local storage required for this EmptyDir volume.

The size
limit is also applicable for memory medium. The maximum usage on memory
medium EmptyDir would be the minimum value between the SizeLimit specified
here and the sum of memory limits of all containers in a pod.

---

### EmptyDirVolumeSource <a name="EmptyDirVolumeSource" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource"></a>

Represents an empty directory for a pod.

Empty directory volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EmptyDirVolumeSource(
  medium: str = None,
  size_limit: Quantity = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.medium">medium</a></code> | <code>str</code> | medium represents what type of storage medium should back this directory. |
| <code><a href="#cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.sizeLimit">size_limit</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | sizeLimit is the total amount of local storage required for this EmptyDir volume. |

---

##### `medium`<sup>Optional</sup> <a name="medium" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.medium"></a>

```python
medium: str
```

- *Type:* str

medium represents what type of storage medium should back this directory.

The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

##### `size_limit`<sup>Optional</sup> <a name="size_limit" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.sizeLimit"></a>

```python
size_limit: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

sizeLimit is the total amount of local storage required for this EmptyDir volume.

The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

### Endpoint <a name="Endpoint" id="cdk8s-plus-28.k8s.Endpoint"></a>

Endpoint represents a single logical "backend" implementing a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Endpoint.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Endpoint(
  addresses: typing.List[str],
  conditions: EndpointConditions = None,
  deprecated_topology: typing.Mapping[str] = None,
  hints: EndpointHints = None,
  hostname: str = None,
  node_name: str = None,
  target_ref: ObjectReference = None,
  zone: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.addresses">addresses</a></code> | <code>typing.List[str]</code> | addresses of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.conditions">conditions</a></code> | <code>cdk8s_plus_28.k8s.EndpointConditions</code> | conditions contains information about the current status of the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.deprecatedTopology">deprecated_topology</a></code> | <code>typing.Mapping[str]</code> | deprecatedTopology contains topology information part of the v1beta1 API. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.hints">hints</a></code> | <code>cdk8s_plus_28.k8s.EndpointHints</code> | hints contains information associated with how an endpoint should be consumed. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.hostname">hostname</a></code> | <code>str</code> | hostname of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.nodeName">node_name</a></code> | <code>str</code> | nodeName represents the name of the Node hosting this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.targetRef">target_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | targetRef is a reference to a Kubernetes object that represents this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.zone">zone</a></code> | <code>str</code> | zone is the name of the Zone this endpoint exists in. |

---

##### `addresses`<sup>Required</sup> <a name="addresses" id="cdk8s-plus-28.k8s.Endpoint.property.addresses"></a>

```python
addresses: typing.List[str]
```

- *Type:* typing.List[str]

addresses of this endpoint.

The contents of this field are interpreted according to the corresponding EndpointSlice addressType field. Consumers must handle different types of addresses in the context of their own capabilities. This must contain at least one address but no more than 100. These are all assumed to be fungible and clients may choose to only use the first element. Refer to: https://issue.k8s.io/106267

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.Endpoint.property.conditions"></a>

```python
conditions: EndpointConditions
```

- *Type:* cdk8s_plus_28.k8s.EndpointConditions

conditions contains information about the current status of the endpoint.

---

##### `deprecated_topology`<sup>Optional</sup> <a name="deprecated_topology" id="cdk8s-plus-28.k8s.Endpoint.property.deprecatedTopology"></a>

```python
deprecated_topology: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

deprecatedTopology contains topology information part of the v1beta1 API.

This field is deprecated, and will be removed when the v1beta1 API is removed (no sooner than kubernetes v1.24).  While this field can hold values, it is not writable through the v1 API, and any attempts to write to it will be silently ignored. Topology information can be found in the zone and nodeName fields instead.

---

##### `hints`<sup>Optional</sup> <a name="hints" id="cdk8s-plus-28.k8s.Endpoint.property.hints"></a>

```python
hints: EndpointHints
```

- *Type:* cdk8s_plus_28.k8s.EndpointHints

hints contains information associated with how an endpoint should be consumed.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.Endpoint.property.hostname"></a>

```python
hostname: str
```

- *Type:* str

hostname of this endpoint.

This field may be used by consumers of endpoints to distinguish endpoints from each other (e.g. in DNS names). Multiple endpoints which use the same hostname should be considered fungible (e.g. multiple A values in DNS). Must be lowercase and pass DNS Label (RFC 1123) validation.

---

##### `node_name`<sup>Optional</sup> <a name="node_name" id="cdk8s-plus-28.k8s.Endpoint.property.nodeName"></a>

```python
node_name: str
```

- *Type:* str

nodeName represents the name of the Node hosting this endpoint.

This can be used to determine endpoints local to a Node.

---

##### `target_ref`<sup>Optional</sup> <a name="target_ref" id="cdk8s-plus-28.k8s.Endpoint.property.targetRef"></a>

```python
target_ref: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

targetRef is a reference to a Kubernetes object that represents this endpoint.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="cdk8s-plus-28.k8s.Endpoint.property.zone"></a>

```python
zone: str
```

- *Type:* str

zone is the name of the Zone this endpoint exists in.

---

### EndpointAddress <a name="EndpointAddress" id="cdk8s-plus-28.k8s.EndpointAddress"></a>

EndpointAddress is a tuple that describes single IP address.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointAddress.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EndpointAddress(
  ip: str,
  hostname: str = None,
  node_name: str = None,
  target_ref: ObjectReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.ip">ip</a></code> | <code>str</code> | The IP of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.hostname">hostname</a></code> | <code>str</code> | The Hostname of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.nodeName">node_name</a></code> | <code>str</code> | Optional: Node hosting this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.targetRef">target_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | Reference to object providing the endpoint. |

---

##### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.k8s.EndpointAddress.property.ip"></a>

```python
ip: str
```

- *Type:* str

The IP of this endpoint.

May not be loopback (127.0.0.0/8 or ::1), link-local (169.254.0.0/16 or fe80::/10), or link-local multicast (224.0.0.0/24 or ff02::/16).

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.EndpointAddress.property.hostname"></a>

```python
hostname: str
```

- *Type:* str

The Hostname of this endpoint.

---

##### `node_name`<sup>Optional</sup> <a name="node_name" id="cdk8s-plus-28.k8s.EndpointAddress.property.nodeName"></a>

```python
node_name: str
```

- *Type:* str

Optional: Node hosting this endpoint.

This can be used to determine endpoints local to a node.

---

##### `target_ref`<sup>Optional</sup> <a name="target_ref" id="cdk8s-plus-28.k8s.EndpointAddress.property.targetRef"></a>

```python
target_ref: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

Reference to object providing the endpoint.

---

### EndpointConditions <a name="EndpointConditions" id="cdk8s-plus-28.k8s.EndpointConditions"></a>

EndpointConditions represents the current condition of an endpoint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointConditions.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EndpointConditions(
  ready: bool = None,
  serving: bool = None,
  terminating: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.ready">ready</a></code> | <code>bool</code> | ready indicates that this endpoint is prepared to receive traffic, according to whatever system is managing the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.serving">serving</a></code> | <code>bool</code> | serving is identical to ready except that it is set regardless of the terminating state of endpoints. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.terminating">terminating</a></code> | <code>bool</code> | terminating indicates that this endpoint is terminating. |

---

##### `ready`<sup>Optional</sup> <a name="ready" id="cdk8s-plus-28.k8s.EndpointConditions.property.ready"></a>

```python
ready: bool
```

- *Type:* bool

ready indicates that this endpoint is prepared to receive traffic, according to whatever system is managing the endpoint.

A nil value indicates an unknown state. In most cases consumers should interpret this unknown state as ready. For compatibility reasons, ready should never be "true" for terminating endpoints, except when the normal readiness behavior is being explicitly overridden, for example when the associated Service has set the publishNotReadyAddresses flag.

---

##### `serving`<sup>Optional</sup> <a name="serving" id="cdk8s-plus-28.k8s.EndpointConditions.property.serving"></a>

```python
serving: bool
```

- *Type:* bool

serving is identical to ready except that it is set regardless of the terminating state of endpoints.

This condition should be set to true for a ready endpoint that is terminating. If nil, consumers should defer to the ready condition.

---

##### `terminating`<sup>Optional</sup> <a name="terminating" id="cdk8s-plus-28.k8s.EndpointConditions.property.terminating"></a>

```python
terminating: bool
```

- *Type:* bool

terminating indicates that this endpoint is terminating.

A nil value indicates an unknown state. Consumers should interpret this unknown state to mean that the endpoint is not terminating.

---

### EndpointHints <a name="EndpointHints" id="cdk8s-plus-28.k8s.EndpointHints"></a>

EndpointHints provides hints describing how an endpoint should be consumed.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointHints.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EndpointHints(
  for_zones: typing.List[ForZone] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointHints.property.forZones">for_zones</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ForZone]</code> | forZones indicates the zone(s) this endpoint should be consumed by to enable topology aware routing. |

---

##### `for_zones`<sup>Optional</sup> <a name="for_zones" id="cdk8s-plus-28.k8s.EndpointHints.property.forZones"></a>

```python
for_zones: typing.List[ForZone]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ForZone]

forZones indicates the zone(s) this endpoint should be consumed by to enable topology aware routing.

---

### EndpointPort <a name="EndpointPort" id="cdk8s-plus-28.k8s.EndpointPort"></a>

EndpointPort is a tuple that describes a single port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointPort.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EndpointPort(
  port: typing.Union[int, float],
  app_protocol: str = None,
  name: str = None,
  protocol: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The port number of the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.appProtocol">app_protocol</a></code> | <code>str</code> | The application protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.name">name</a></code> | <code>str</code> | The name of this port. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.protocol">protocol</a></code> | <code>str</code> | The IP protocol for this port. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.EndpointPort.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The port number of the endpoint.

---

##### `app_protocol`<sup>Optional</sup> <a name="app_protocol" id="cdk8s-plus-28.k8s.EndpointPort.property.appProtocol"></a>

```python
app_protocol: str
```

- *Type:* str

The application protocol for this port.

This is used as a hint for implementations to offer richer behavior for protocols that they understand. This field follows standard Kubernetes label syntax. Valid values are either:

* Un-prefixed protocol names - reserved for IANA standard service names (as per RFC-6335 and https://www.iana.org/assignments/service-names).
* Kubernetes-defined prefixed names:
* 'kubernetes.io/h2c' - HTTP/2 over cleartext as described in https://www.rfc-editor.org/rfc/rfc7540
* 'kubernetes.io/ws'  - WebSocket over cleartext as described in https://www.rfc-editor.org/rfc/rfc6455
* 'kubernetes.io/wss' - WebSocket over TLS as described in https://www.rfc-editor.org/rfc/rfc6455
* Other protocols should use implementation-defined prefixed names such as mycompany.com/my-custom-protocol.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.EndpointPort.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this port.

This must match the 'name' field in the corresponding ServicePort. Must be a DNS_LABEL. Optional only if one port is defined.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.EndpointPort.property.protocol"></a>

```python
protocol: str
```

- *Type:* str
- *Default:* TCP.

The IP protocol for this port.

Must be UDP, TCP, or SCTP. Default is TCP.

---

### EndpointSubset <a name="EndpointSubset" id="cdk8s-plus-28.k8s.EndpointSubset"></a>

EndpointSubset is a group of addresses with a common set of ports.

The expanded set of endpoints is the Cartesian product of Addresses x Ports. For example, given:

{
Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
Ports:     [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
}

The resulting set of endpoints can be viewed as:

a: [ 10.10.1.1:8675, 10.10.2.2:8675 ],
b: [ 10.10.1.1:309, 10.10.2.2:309 ]

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointSubset.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EndpointSubset(
  addresses: typing.List[EndpointAddress] = None,
  not_ready_addresses: typing.List[EndpointAddress] = None,
  ports: typing.List[EndpointPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.addresses">addresses</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointAddress]</code> | IP addresses which offer the related ports that are marked as ready. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.notReadyAddresses">not_ready_addresses</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointAddress]</code> | IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointPort]</code> | Port numbers available on the related IP addresses. |

---

##### `addresses`<sup>Optional</sup> <a name="addresses" id="cdk8s-plus-28.k8s.EndpointSubset.property.addresses"></a>

```python
addresses: typing.List[EndpointAddress]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointAddress]

IP addresses which offer the related ports that are marked as ready.

These endpoints should be considered safe for load balancers and clients to utilize.

---

##### `not_ready_addresses`<sup>Optional</sup> <a name="not_ready_addresses" id="cdk8s-plus-28.k8s.EndpointSubset.property.notReadyAddresses"></a>

```python
not_ready_addresses: typing.List[EndpointAddress]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointAddress]

IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.EndpointSubset.property.ports"></a>

```python
ports: typing.List[EndpointPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointPort]

Port numbers available on the related IP addresses.

---

### EnvFromSource <a name="EnvFromSource" id="cdk8s-plus-28.k8s.EnvFromSource"></a>

EnvFromSource represents the source of a set of ConfigMaps.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvFromSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EnvFromSource(
  config_map_ref: ConfigMapEnvSource = None,
  prefix: str = None,
  secret_ref: SecretEnvSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.configMapRef">config_map_ref</a></code> | <code>cdk8s_plus_28.k8s.ConfigMapEnvSource</code> | The ConfigMap to select from. |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.prefix">prefix</a></code> | <code>str</code> | An optional identifier to prepend to each key in the ConfigMap. |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretEnvSource</code> | The Secret to select from. |

---

##### `config_map_ref`<sup>Optional</sup> <a name="config_map_ref" id="cdk8s-plus-28.k8s.EnvFromSource.property.configMapRef"></a>

```python
config_map_ref: ConfigMapEnvSource
```

- *Type:* cdk8s_plus_28.k8s.ConfigMapEnvSource

The ConfigMap to select from.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.k8s.EnvFromSource.property.prefix"></a>

```python
prefix: str
```

- *Type:* str

An optional identifier to prepend to each key in the ConfigMap.

Must be a C_IDENTIFIER.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.EnvFromSource.property.secretRef"></a>

```python
secret_ref: SecretEnvSource
```

- *Type:* cdk8s_plus_28.k8s.SecretEnvSource

The Secret to select from.

---

### EnvValueFromConfigMapOptions <a name="EnvValueFromConfigMapOptions" id="cdk8s-plus-28.EnvValueFromConfigMapOptions"></a>

Options to specify an envionment variable value from a ConfigMap key.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromConfigMapOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValueFromConfigMapOptions(
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromConfigMapOptions.property.optional">optional</a></code> | <code>bool</code> | Specify whether the ConfigMap or its key must be defined. |

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValueFromConfigMapOptions.property.optional"></a>

```python
optional: bool
```

- *Type:* bool
- *Default:* false

Specify whether the ConfigMap or its key must be defined.

---

### EnvValueFromFieldRefOptions <a name="EnvValueFromFieldRefOptions" id="cdk8s-plus-28.EnvValueFromFieldRefOptions"></a>

Options to specify an environment variable value from a field reference.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValueFromFieldRefOptions(
  api_version: str = None,
  key: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromFieldRefOptions.property.apiVersion">api_version</a></code> | <code>str</code> | Version of the schema the FieldPath is written in terms of. |
| <code><a href="#cdk8s-plus-28.EnvValueFromFieldRefOptions.property.key">key</a></code> | <code>str</code> | The key to select the pod label or annotation. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

Version of the schema the FieldPath is written in terms of.

---

##### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.property.key"></a>

```python
key: str
```

- *Type:* str

The key to select the pod label or annotation.

---

### EnvValueFromProcessOptions <a name="EnvValueFromProcessOptions" id="cdk8s-plus-28.EnvValueFromProcessOptions"></a>

Options to specify an environment variable value from the process environment.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromProcessOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValueFromProcessOptions(
  required: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromProcessOptions.property.required">required</a></code> | <code>bool</code> | Specify whether the key must exist in the environment. |

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.EnvValueFromProcessOptions.property.required"></a>

```python
required: bool
```

- *Type:* bool
- *Default:* false

Specify whether the key must exist in the environment.

If this is set to true, and the key does not exist, an error will thrown.

---

### EnvValueFromResourceOptions <a name="EnvValueFromResourceOptions" id="cdk8s-plus-28.EnvValueFromResourceOptions"></a>

Options to specify an environment variable value from a resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromResourceOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValueFromResourceOptions(
  container: Container = None,
  divisor: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromResourceOptions.property.container">container</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a></code> | The container to select the value from. |
| <code><a href="#cdk8s-plus-28.EnvValueFromResourceOptions.property.divisor">divisor</a></code> | <code>str</code> | The output format of the exposed resource. |

---

##### `container`<sup>Optional</sup> <a name="container" id="cdk8s-plus-28.EnvValueFromResourceOptions.property.container"></a>

```python
container: Container
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

The container to select the value from.

---

##### `divisor`<sup>Optional</sup> <a name="divisor" id="cdk8s-plus-28.EnvValueFromResourceOptions.property.divisor"></a>

```python
divisor: str
```

- *Type:* str

The output format of the exposed resource.

---

### EnvValueFromSecretOptions <a name="EnvValueFromSecretOptions" id="cdk8s-plus-28.EnvValueFromSecretOptions"></a>

Options to specify an environment variable value from a Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromSecretOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValueFromSecretOptions(
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromSecretOptions.property.optional">optional</a></code> | <code>bool</code> | Specify whether the Secret or its key must be defined. |

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValueFromSecretOptions.property.optional"></a>

```python
optional: bool
```

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

### EnvVar <a name="EnvVar" id="cdk8s-plus-28.k8s.EnvVar"></a>

EnvVar represents an environment variable present in a Container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvVar.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EnvVar(
  name: str,
  value: str = None,
  value_from: EnvVarSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.name">name</a></code> | <code>str</code> | Name of the environment variable. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.value">value</a></code> | <code>str</code> | Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.valueFrom">value_from</a></code> | <code>cdk8s_plus_28.k8s.EnvVarSource</code> | Source for the environment variable's value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.EnvVar.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the environment variable.

Must be a C_IDENTIFIER.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.EnvVar.property.value"></a>

```python
value: str
```

- *Type:* str
- *Default:* .

Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables.

If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".

---

##### `value_from`<sup>Optional</sup> <a name="value_from" id="cdk8s-plus-28.k8s.EnvVar.property.valueFrom"></a>

```python
value_from: EnvVarSource
```

- *Type:* cdk8s_plus_28.k8s.EnvVarSource

Source for the environment variable's value.

Cannot be used if value is not empty.

---

### EnvVarSource <a name="EnvVarSource" id="cdk8s-plus-28.k8s.EnvVarSource"></a>

EnvVarSource represents a source for the value of an EnvVar.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvVarSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EnvVarSource(
  config_map_key_ref: ConfigMapKeySelector = None,
  field_ref: ObjectFieldSelector = None,
  resource_field_ref: ResourceFieldSelector = None,
  secret_key_ref: SecretKeySelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.configMapKeyRef">config_map_key_ref</a></code> | <code>cdk8s_plus_28.k8s.ConfigMapKeySelector</code> | Selects a key of a ConfigMap. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.fieldRef">field_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectFieldSelector</code> | Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.resourceFieldRef">resource_field_ref</a></code> | <code>cdk8s_plus_28.k8s.ResourceFieldSelector</code> | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.secretKeyRef">secret_key_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretKeySelector</code> | Selects a key of a secret in the pod's namespace. |

---

##### `config_map_key_ref`<sup>Optional</sup> <a name="config_map_key_ref" id="cdk8s-plus-28.k8s.EnvVarSource.property.configMapKeyRef"></a>

```python
config_map_key_ref: ConfigMapKeySelector
```

- *Type:* cdk8s_plus_28.k8s.ConfigMapKeySelector

Selects a key of a ConfigMap.

---

##### `field_ref`<sup>Optional</sup> <a name="field_ref" id="cdk8s-plus-28.k8s.EnvVarSource.property.fieldRef"></a>

```python
field_ref: ObjectFieldSelector
```

- *Type:* cdk8s_plus_28.k8s.ObjectFieldSelector

Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.

---

##### `resource_field_ref`<sup>Optional</sup> <a name="resource_field_ref" id="cdk8s-plus-28.k8s.EnvVarSource.property.resourceFieldRef"></a>

```python
resource_field_ref: ResourceFieldSelector
```

- *Type:* cdk8s_plus_28.k8s.ResourceFieldSelector

Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.

---

##### `secret_key_ref`<sup>Optional</sup> <a name="secret_key_ref" id="cdk8s-plus-28.k8s.EnvVarSource.property.secretKeyRef"></a>

```python
secret_key_ref: SecretKeySelector
```

- *Type:* cdk8s_plus_28.k8s.SecretKeySelector

Selects a key of a secret in the pod's namespace.

---

### EphemeralContainer <a name="EphemeralContainer" id="cdk8s-plus-28.k8s.EphemeralContainer"></a>

An EphemeralContainer is a temporary container that you may add to an existing Pod for user-initiated activities such as debugging.

Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a Pod is removed or restarted. The kubelet may evict a Pod if an ephemeral container causes the Pod to exceed its resource allocation.

To add an ephemeral container, use the ephemeralcontainers subresource of an existing Pod. Ephemeral containers may not be removed or restarted.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EphemeralContainer.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EphemeralContainer(
  name: str,
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env: typing.List[EnvVar] = None,
  env_from: typing.List[EnvFromSource] = None,
  image: str = None,
  image_pull_policy: str = None,
  lifecycle: Lifecycle = None,
  liveness_probe: Probe = None,
  ports: typing.List[ContainerPort] = None,
  readiness_probe: Probe = None,
  resize_policy: typing.List[ContainerResizePolicy] = None,
  resources: ResourceRequirements = None,
  restart_policy: str = None,
  security_context: SecurityContext = None,
  startup_probe: Probe = None,
  stdin: bool = None,
  stdin_once: bool = None,
  target_container_name: str = None,
  termination_message_path: str = None,
  termination_message_policy: str = None,
  tty: bool = None,
  volume_devices: typing.List[VolumeDevice] = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.name">name</a></code> | <code>str</code> | Name of the ephemeral container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.env">env</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EnvVar]</code> | List of environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.envFrom">env_from</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EnvFromSource]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.image">image</a></code> | <code>str</code> | Container image name. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.imagePullPolicy">image_pull_policy</a></code> | <code>str</code> | Image pull policy. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.lifecycle">lifecycle</a></code> | <code>cdk8s_plus_28.k8s.Lifecycle</code> | Lifecycle is not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.livenessProbe">liveness_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ContainerPort]</code> | Ports are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.readinessProbe">readiness_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.resizePolicy">resize_policy</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ContainerResizePolicy]</code> | Resources resize policy for the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.resources">resources</a></code> | <code>cdk8s_plus_28.k8s.ResourceRequirements</code> | Resources are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.restartPolicy">restart_policy</a></code> | <code>str</code> | Restart policy for the container to manage the restart behavior of each container within a pod. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.securityContext">security_context</a></code> | <code>cdk8s_plus_28.k8s.SecurityContext</code> | Optional: SecurityContext defines the security options the ephemeral container should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.startupProbe">startup_probe</a></code> | <code>cdk8s_plus_28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.stdin">stdin</a></code> | <code>bool</code> | Whether this container should allocate a buffer for stdin in the container runtime. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.stdinOnce">stdin_once</a></code> | <code>bool</code> | Whether the container runtime should close the stdin channel after it has been opened by a single attach. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.targetContainerName">target_container_name</a></code> | <code>str</code> | If set, the name of the container from PodSpec that this ephemeral container targets. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePath">termination_message_path</a></code> | <code>str</code> | Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePolicy">termination_message_policy</a></code> | <code>str</code> | Indicate how the termination message should be populated. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.tty">tty</a></code> | <code>bool</code> | Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.volumeDevices">volume_devices</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VolumeDevice]</code> | volumeDevices is the list of block devices to be used by the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.volumeMounts">volume_mounts</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VolumeMount]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.workingDir">working_dir</a></code> | <code>str</code> | Container's working directory. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.EphemeralContainer.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the ephemeral container specified as a DNS_LABEL.

This name must be unique among all containers, init containers and ephemeral containers.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.k8s.EphemeralContainer.property.args"></a>

```python
args: typing.List[str]
```

- *Type:* typing.List[str]

Arguments to the entrypoint.

The image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.EphemeralContainer.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]

Entrypoint array.

Not executed within a shell. The image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env`<sup>Optional</sup> <a name="env" id="cdk8s-plus-28.k8s.EphemeralContainer.property.env"></a>

```python
env: typing.List[EnvVar]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EnvVar]

List of environment variables to set in the container.

Cannot be updated.

---

##### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.k8s.EphemeralContainer.property.envFrom"></a>

```python
env_from: typing.List[EnvFromSource]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EnvFromSource]

List of sources to populate environment variables in the container.

The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

---

##### `image`<sup>Optional</sup> <a name="image" id="cdk8s-plus-28.k8s.EphemeralContainer.property.image"></a>

```python
image: str
```

- *Type:* str

Container image name.

More info: https://kubernetes.io/docs/concepts/containers/images

---

##### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.imagePullPolicy"></a>

```python
image_pull_policy: str
```

- *Type:* str
- *Default:* Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Image pull policy.

One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.k8s.EphemeralContainer.property.lifecycle"></a>

```python
lifecycle: Lifecycle
```

- *Type:* cdk8s_plus_28.k8s.Lifecycle

Lifecycle is not allowed for ephemeral containers.

---

##### `liveness_probe`<sup>Optional</sup> <a name="liveness_probe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.livenessProbe"></a>

```python
liveness_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.EphemeralContainer.property.ports"></a>

```python
ports: typing.List[ContainerPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ContainerPort]

Ports are not allowed for ephemeral containers.

---

##### `readiness_probe`<sup>Optional</sup> <a name="readiness_probe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.readinessProbe"></a>

```python
readiness_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `resize_policy`<sup>Optional</sup> <a name="resize_policy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.resizePolicy"></a>

```python
resize_policy: typing.List[ContainerResizePolicy]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ContainerResizePolicy]

Resources resize policy for the container.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.EphemeralContainer.property.resources"></a>

```python
resources: ResourceRequirements
```

- *Type:* cdk8s_plus_28.k8s.ResourceRequirements

Resources are not allowed for ephemeral containers.

Ephemeral containers use spare resources already allocated to the pod.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.restartPolicy"></a>

```python
restart_policy: str
```

- *Type:* str

Restart policy for the container to manage the restart behavior of each container within a pod.

This may only be set for init containers. You cannot set this field on ephemeral containers.

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.k8s.EphemeralContainer.property.securityContext"></a>

```python
security_context: SecurityContext
```

- *Type:* cdk8s_plus_28.k8s.SecurityContext

Optional: SecurityContext defines the security options the ephemeral container should be run with.

If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext.

---

##### `startup_probe`<sup>Optional</sup> <a name="startup_probe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.startupProbe"></a>

```python
startup_probe: Probe
```

- *Type:* cdk8s_plus_28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `stdin`<sup>Optional</sup> <a name="stdin" id="cdk8s-plus-28.k8s.EphemeralContainer.property.stdin"></a>

```python
stdin: bool
```

- *Type:* bool
- *Default:* false.

Whether this container should allocate a buffer for stdin in the container runtime.

If this is not set, reads from stdin in the container will always result in EOF. Default is false.

---

##### `stdin_once`<sup>Optional</sup> <a name="stdin_once" id="cdk8s-plus-28.k8s.EphemeralContainer.property.stdinOnce"></a>

```python
stdin_once: bool
```

- *Type:* bool
- *Default:* false

Whether the container runtime should close the stdin channel after it has been opened by a single attach.

When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

---

##### `target_container_name`<sup>Optional</sup> <a name="target_container_name" id="cdk8s-plus-28.k8s.EphemeralContainer.property.targetContainerName"></a>

```python
target_container_name: str
```

- *Type:* str

If set, the name of the container from PodSpec that this ephemeral container targets.

The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container. If not set then the ephemeral container uses the namespaces configured in the Pod spec.

The container runtime must implement support for this feature. If the runtime does not support namespace targeting then the result of setting this field is undefined.

---

##### `termination_message_path`<sup>Optional</sup> <a name="termination_message_path" id="cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePath"></a>

```python
termination_message_path: str
```

- *Type:* str
- *Default:* dev/termination-log. Cannot be updated.

Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem.

Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

---

##### `termination_message_policy`<sup>Optional</sup> <a name="termination_message_policy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePolicy"></a>

```python
termination_message_policy: str
```

- *Type:* str
- *Default:* File. Cannot be updated.

Indicate how the termination message should be populated.

File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

---

##### `tty`<sup>Optional</sup> <a name="tty" id="cdk8s-plus-28.k8s.EphemeralContainer.property.tty"></a>

```python
tty: bool
```

- *Type:* bool
- *Default:* false.

Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.

Default is false.

---

##### `volume_devices`<sup>Optional</sup> <a name="volume_devices" id="cdk8s-plus-28.k8s.EphemeralContainer.property.volumeDevices"></a>

```python
volume_devices: typing.List[VolumeDevice]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VolumeDevice]

volumeDevices is the list of block devices to be used by the container.

---

##### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.k8s.EphemeralContainer.property.volumeMounts"></a>

```python
volume_mounts: typing.List[VolumeMount]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VolumeMount]

Pod volumes to mount into the container's filesystem.

Subpath mounts are not allowed for ephemeral containers. Cannot be updated.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.k8s.EphemeralContainer.property.workingDir"></a>

```python
working_dir: str
```

- *Type:* str

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### EphemeralStorageResources <a name="EphemeralStorageResources" id="cdk8s-plus-28.EphemeralStorageResources"></a>

Emphemeral storage request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EphemeralStorageResources.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EphemeralStorageResources(
  limit: Size = None,
  request: Size = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EphemeralStorageResources.property.limit">limit</a></code> | <code>cdk8s.Size</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EphemeralStorageResources.property.request">request</a></code> | <code>cdk8s.Size</code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.EphemeralStorageResources.property.limit"></a>

```python
limit: Size
```

- *Type:* cdk8s.Size

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.EphemeralStorageResources.property.request"></a>

```python
request: Size
```

- *Type:* cdk8s.Size

---

### EphemeralVolumeSource <a name="EphemeralVolumeSource" id="cdk8s-plus-28.k8s.EphemeralVolumeSource"></a>

Represents an ephemeral volume that is handled by a normal storage driver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EphemeralVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EphemeralVolumeSource(
  volume_claim_template: PersistentVolumeClaimTemplate = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralVolumeSource.property.volumeClaimTemplate">volume_claim_template</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeClaimTemplate</code> | Will be used to create a stand-alone PVC to provision the volume. |

---

##### `volume_claim_template`<sup>Optional</sup> <a name="volume_claim_template" id="cdk8s-plus-28.k8s.EphemeralVolumeSource.property.volumeClaimTemplate"></a>

```python
volume_claim_template: PersistentVolumeClaimTemplate
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimTemplate

Will be used to create a stand-alone PVC to provision the volume.

The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).

An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.

This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.

Required, must not be nil.

---

### EventSeries <a name="EventSeries" id="cdk8s-plus-28.k8s.EventSeries"></a>

EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time. How often to update the EventSeries is up to the event reporters. The default event reporter in "k8s.io/client-go/tools/events/event_broadcaster.go" shows how this struct is updated on heartbeats and can guide customized reporter implementations.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EventSeries.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EventSeries(
  count: typing.Union[int, float],
  last_observed_time: datetime.datetime
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EventSeries.property.count">count</a></code> | <code>typing.Union[int, float]</code> | count is the number of occurrences in this series up to the last heartbeat time. |
| <code><a href="#cdk8s-plus-28.k8s.EventSeries.property.lastObservedTime">last_observed_time</a></code> | <code>datetime.datetime</code> | lastObservedTime is the time when last Event from the series was seen before last heartbeat. |

---

##### `count`<sup>Required</sup> <a name="count" id="cdk8s-plus-28.k8s.EventSeries.property.count"></a>

```python
count: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

count is the number of occurrences in this series up to the last heartbeat time.

---

##### `last_observed_time`<sup>Required</sup> <a name="last_observed_time" id="cdk8s-plus-28.k8s.EventSeries.property.lastObservedTime"></a>

```python
last_observed_time: datetime.datetime
```

- *Type:* datetime.datetime

lastObservedTime is the time when last Event from the series was seen before last heartbeat.

---

### EventSource <a name="EventSource" id="cdk8s-plus-28.k8s.EventSource"></a>

EventSource contains information for an event.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EventSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.EventSource(
  component: str = None,
  host: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EventSource.property.component">component</a></code> | <code>str</code> | Component from which the event is generated. |
| <code><a href="#cdk8s-plus-28.k8s.EventSource.property.host">host</a></code> | <code>str</code> | Node name on which the event is generated. |

---

##### `component`<sup>Optional</sup> <a name="component" id="cdk8s-plus-28.k8s.EventSource.property.component"></a>

```python
component: str
```

- *Type:* str

Component from which the event is generated.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.EventSource.property.host"></a>

```python
host: str
```

- *Type:* str

Node name on which the event is generated.

---

### ExecAction <a name="ExecAction" id="cdk8s-plus-28.k8s.ExecAction"></a>

ExecAction describes a "run in container" action.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExecAction.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ExecAction(
  command: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExecAction.property.command">command</a></code> | <code>typing.List[str]</code> | Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. |

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.ExecAction.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]

Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem.

The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.

---

### ExemptPriorityLevelConfigurationV1Beta2 <a name="ExemptPriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2"></a>

ExemptPriorityLevelConfiguration describes the configurable aspects of the handling of exempt requests.

In the mandatory exempt configuration object the values in the fields here can be modified by authorized users, unlike the rest of the `spec`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ExemptPriorityLevelConfigurationV1Beta2(
  lendable_percent: typing.Union[int, float] = None,
  nominal_concurrency_shares: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.lendablePercent">lendable_percent</a></code> | <code>typing.Union[int, float]</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.nominalConcurrencyShares">nominal_concurrency_shares</a></code> | <code>typing.Union[int, float]</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `lendable_percent`<sup>Optional</sup> <a name="lendable_percent" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.lendablePercent"></a>

```python
lendable_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

This value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `nominal_concurrency_shares`<sup>Optional</sup> <a name="nominal_concurrency_shares" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.nominalConcurrencyShares"></a>

```python
nominal_concurrency_shares: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats nominally reserved for this priority level. This DOES NOT limit the dispatching from this priority level but affects the other priority levels through the borrowing mechanism. The server's concurrency limit (ServerCL) is divided among all the priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of zero.

---

### ExemptPriorityLevelConfigurationV1Beta3 <a name="ExemptPriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3"></a>

ExemptPriorityLevelConfiguration describes the configurable aspects of the handling of exempt requests.

In the mandatory exempt configuration object the values in the fields here can be modified by authorized users, unlike the rest of the `spec`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ExemptPriorityLevelConfigurationV1Beta3(
  lendable_percent: typing.Union[int, float] = None,
  nominal_concurrency_shares: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.lendablePercent">lendable_percent</a></code> | <code>typing.Union[int, float]</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares">nominal_concurrency_shares</a></code> | <code>typing.Union[int, float]</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `lendable_percent`<sup>Optional</sup> <a name="lendable_percent" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.lendablePercent"></a>

```python
lendable_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

This value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `nominal_concurrency_shares`<sup>Optional</sup> <a name="nominal_concurrency_shares" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares"></a>

```python
nominal_concurrency_shares: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats nominally reserved for this priority level. This DOES NOT limit the dispatching from this priority level but affects the other priority levels through the borrowing mechanism. The server's concurrency limit (ServerCL) is divided among all the priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of zero.

---

### ExposeDeploymentViaIngressOptions <a name="ExposeDeploymentViaIngressOptions" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions"></a>

Options for exposing a deployment via an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ExposeDeploymentViaIngressOptions(
  name: str = None,
  ports: typing.List[ServicePort] = None,
  service_type: ServiceType = None,
  ingress: Ingress = None,
  path_type: HttpIngressPathType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.name">name</a></code> | <code>str</code> | The name of the service to expose. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]</code> | The ports that the service should bind to. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.serviceType">service_type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | The type of the exposed service. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.Ingress">Ingress</a></code> | The ingress to add rules to. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.pathType">path_type</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | The type of the path. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ports"></a>

```python
ports: typing.List[ServicePort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

##### `service_type`<sup>Optional</sup> <a name="service_type" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.serviceType"></a>

```python
service_type: ServiceType
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ingress"></a>

```python
ingress: Ingress
```

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

##### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.pathType"></a>

```python
path_type: HttpIngressPathType
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

### ExposeServiceViaIngressOptions <a name="ExposeServiceViaIngressOptions" id="cdk8s-plus-28.ExposeServiceViaIngressOptions"></a>

Options for exposing a service using an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ExposeServiceViaIngressOptions(
  ingress: Ingress = None,
  path_type: HttpIngressPathType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ExposeServiceViaIngressOptions.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.Ingress">Ingress</a></code> | The ingress to add rules to. |
| <code><a href="#cdk8s-plus-28.ExposeServiceViaIngressOptions.property.pathType">path_type</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | The type of the path. |

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.property.ingress"></a>

```python
ingress: Ingress
```

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

##### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.property.pathType"></a>

```python
path_type: HttpIngressPathType
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

### ExternalDocumentation <a name="ExternalDocumentation" id="cdk8s-plus-28.k8s.ExternalDocumentation"></a>

ExternalDocumentation allows referencing an external resource for extended documentation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExternalDocumentation.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ExternalDocumentation(
  description: str = None,
  url: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExternalDocumentation.property.description">description</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.ExternalDocumentation.property.url">url</a></code> | <code>str</code> | *No description.* |

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.ExternalDocumentation.property.description"></a>

```python
description: str
```

- *Type:* str

---

##### `url`<sup>Optional</sup> <a name="url" id="cdk8s-plus-28.k8s.ExternalDocumentation.property.url"></a>

```python
url: str
```

- *Type:* str

---

### ExternalMetricSourceV2 <a name="ExternalMetricSourceV2" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2"></a>

ExternalMetricSource indicates how to scale on a metric not associated with any Kubernetes object (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ExternalMetricSourceV2(
  metric: MetricIdentifierV2,
  target: MetricTargetV2
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s_plus_28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.metric"></a>

```python
metric: MetricIdentifierV2
```

- *Type:* cdk8s_plus_28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.target"></a>

```python
target: MetricTargetV2
```

- *Type:* cdk8s_plus_28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### FcVolumeSource <a name="FcVolumeSource" id="cdk8s-plus-28.k8s.FcVolumeSource"></a>

Represents a Fibre Channel volume.

Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FcVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FcVolumeSource(
  fs_type: str = None,
  lun: typing.Union[int, float] = None,
  read_only: bool = None,
  target_ww_ns: typing.List[str] = None,
  wwids: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.lun">lun</a></code> | <code>typing.Union[int, float]</code> | lun is Optional: FC target lun number. |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.targetWwNs">target_ww_ns</a></code> | <code>typing.List[str]</code> | targetWWNs is Optional: FC target worldwide names (WWNs). |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.wwids">wwids</a></code> | <code>typing.List[str]</code> | wwids Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously. |

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.FcVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `lun`<sup>Optional</sup> <a name="lun" id="cdk8s-plus-28.k8s.FcVolumeSource.property.lun"></a>

```python
lun: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

lun is Optional: FC target lun number.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.FcVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `target_ww_ns`<sup>Optional</sup> <a name="target_ww_ns" id="cdk8s-plus-28.k8s.FcVolumeSource.property.targetWwNs"></a>

```python
target_ww_ns: typing.List[str]
```

- *Type:* typing.List[str]

targetWWNs is Optional: FC target worldwide names (WWNs).

---

##### `wwids`<sup>Optional</sup> <a name="wwids" id="cdk8s-plus-28.k8s.FcVolumeSource.property.wwids"></a>

```python
wwids: typing.List[str]
```

- *Type:* typing.List[str]

wwids Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.

---

### FlexPersistentVolumeSource <a name="FlexPersistentVolumeSource" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource"></a>

FlexPersistentVolumeSource represents a generic persistent volume resource that is provisioned/attached using an exec based plugin.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlexPersistentVolumeSource(
  driver: str,
  fs_type: str = None,
  options: typing.Mapping[str] = None,
  read_only: bool = None,
  secret_ref: SecretReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.driver">driver</a></code> | <code>str</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.options">options</a></code> | <code>typing.Mapping[str]</code> | options is Optional: this field holds extra command options if any. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef is Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.driver"></a>

```python
driver: str
```

- *Type:* str

driver is the name of the driver to use for this volume.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.options"></a>

```python
options: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

options is Optional: this field holds extra command options if any.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly is Optional: defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

secretRef is Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts.

This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

---

### FlexVolumeSource <a name="FlexVolumeSource" id="cdk8s-plus-28.k8s.FlexVolumeSource"></a>

FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlexVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlexVolumeSource(
  driver: str,
  fs_type: str = None,
  options: typing.Mapping[str] = None,
  read_only: bool = None,
  secret_ref: LocalObjectReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.driver">driver</a></code> | <code>str</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.options">options</a></code> | <code>typing.Mapping[str]</code> | options is Optional: this field holds extra command options if any. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly is Optional: defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef is Optional: secretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.driver"></a>

```python
driver: str
```

- *Type:* str

driver is the name of the driver to use for this volume.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.options"></a>

```python
options: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

options is Optional: this field holds extra command options if any.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly is Optional: defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef is Optional: secretRef is reference to the secret object containing sensitive information to pass to the plugin scripts.

This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

---

### FlockerVolumeSource <a name="FlockerVolumeSource" id="cdk8s-plus-28.k8s.FlockerVolumeSource"></a>

Represents a Flocker volume mounted by the Flocker agent.

One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlockerVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlockerVolumeSource(
  dataset_name: str = None,
  dataset_uuid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetName">dataset_name</a></code> | <code>str</code> | datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetUuid">dataset_uuid</a></code> | <code>str</code> | datasetUUID is the UUID of the dataset. |

---

##### `dataset_name`<sup>Optional</sup> <a name="dataset_name" id="cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetName"></a>

```python
dataset_name: str
```

- *Type:* str

datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated.

---

##### `dataset_uuid`<sup>Optional</sup> <a name="dataset_uuid" id="cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetUuid"></a>

```python
dataset_uuid: str
```

- *Type:* str

datasetUUID is the UUID of the dataset.

This is unique identifier of a Flocker dataset

---

### FlowDistinguisherMethodV1Beta2 <a name="FlowDistinguisherMethodV1Beta2" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2"></a>

FlowDistinguisherMethod specifies the method of a flow distinguisher.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlowDistinguisherMethodV1Beta2(
  type: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.property.type">type</a></code> | <code>str</code> | `type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace". |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.property.type"></a>

```python
type: str
```

- *Type:* str

`type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace".

Required.

---

### FlowDistinguisherMethodV1Beta3 <a name="FlowDistinguisherMethodV1Beta3" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3"></a>

FlowDistinguisherMethod specifies the method of a flow distinguisher.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlowDistinguisherMethodV1Beta3(
  type: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.property.type">type</a></code> | <code>str</code> | `type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace". |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.property.type"></a>

```python
type: str
```

- *Type:* str

`type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace".

Required.

---

### FlowSchemaSpecV1Beta2 <a name="FlowSchemaSpecV1Beta2" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2"></a>

FlowSchemaSpec describes how the FlowSchema's specification looks like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlowSchemaSpecV1Beta2(
  priority_level_configuration: PriorityLevelConfigurationReferenceV1Beta2,
  distinguisher_method: FlowDistinguisherMethodV1Beta2 = None,
  matching_precedence: typing.Union[int, float] = None,
  rules: typing.List[PolicyRulesWithSubjectsV1Beta2] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.priorityLevelConfiguration">priority_level_configuration</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationReferenceV1Beta2</code> | `priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.distinguisherMethod">distinguisher_method</a></code> | <code>cdk8s_plus_28.k8s.FlowDistinguisherMethodV1Beta2</code> | `distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.matchingPrecedence">matching_precedence</a></code> | <code>typing.Union[int, float]</code> | `matchingPrecedence` is used to choose among the FlowSchemas that match a given request. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRulesWithSubjectsV1Beta2]</code> | `rules` describes which requests will match this flow schema. |

---

##### `priority_level_configuration`<sup>Required</sup> <a name="priority_level_configuration" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.priorityLevelConfiguration"></a>

```python
priority_level_configuration: PriorityLevelConfigurationReferenceV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationReferenceV1Beta2

`priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster.

If the reference cannot be resolved, the FlowSchema will be ignored and marked as invalid in its status. Required.

---

##### `distinguisher_method`<sup>Optional</sup> <a name="distinguisher_method" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.distinguisherMethod"></a>

```python
distinguisher_method: FlowDistinguisherMethodV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.FlowDistinguisherMethodV1Beta2

`distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema.

`nil` specifies that the distinguisher is disabled and thus will always be the empty string.

---

##### `matching_precedence`<sup>Optional</sup> <a name="matching_precedence" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.matchingPrecedence"></a>

```python
matching_precedence: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`matchingPrecedence` is used to choose among the FlowSchemas that match a given request.

The chosen FlowSchema is among those with the numerically lowest (which we take to be logically highest) MatchingPrecedence.  Each MatchingPrecedence value must be ranged in [1,10000]. Note that if the precedence is not specified, it will be set to 1000 as default.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.rules"></a>

```python
rules: typing.List[PolicyRulesWithSubjectsV1Beta2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRulesWithSubjectsV1Beta2]

`rules` describes which requests will match this flow schema.

This FlowSchema matches a request if and only if at least one member of rules matches the request. if it is an empty slice, there will be no requests matching the FlowSchema.

---

### FlowSchemaSpecV1Beta3 <a name="FlowSchemaSpecV1Beta3" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3"></a>

FlowSchemaSpec describes how the FlowSchema's specification looks like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.FlowSchemaSpecV1Beta3(
  priority_level_configuration: PriorityLevelConfigurationReferenceV1Beta3,
  distinguisher_method: FlowDistinguisherMethodV1Beta3 = None,
  matching_precedence: typing.Union[int, float] = None,
  rules: typing.List[PolicyRulesWithSubjectsV1Beta3] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.priorityLevelConfiguration">priority_level_configuration</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationReferenceV1Beta3</code> | `priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.distinguisherMethod">distinguisher_method</a></code> | <code>cdk8s_plus_28.k8s.FlowDistinguisherMethodV1Beta3</code> | `distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.matchingPrecedence">matching_precedence</a></code> | <code>typing.Union[int, float]</code> | `matchingPrecedence` is used to choose among the FlowSchemas that match a given request. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRulesWithSubjectsV1Beta3]</code> | `rules` describes which requests will match this flow schema. |

---

##### `priority_level_configuration`<sup>Required</sup> <a name="priority_level_configuration" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.priorityLevelConfiguration"></a>

```python
priority_level_configuration: PriorityLevelConfigurationReferenceV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationReferenceV1Beta3

`priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster.

If the reference cannot be resolved, the FlowSchema will be ignored and marked as invalid in its status. Required.

---

##### `distinguisher_method`<sup>Optional</sup> <a name="distinguisher_method" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.distinguisherMethod"></a>

```python
distinguisher_method: FlowDistinguisherMethodV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.FlowDistinguisherMethodV1Beta3

`distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema.

`nil` specifies that the distinguisher is disabled and thus will always be the empty string.

---

##### `matching_precedence`<sup>Optional</sup> <a name="matching_precedence" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.matchingPrecedence"></a>

```python
matching_precedence: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`matchingPrecedence` is used to choose among the FlowSchemas that match a given request.

The chosen FlowSchema is among those with the numerically lowest (which we take to be logically highest) MatchingPrecedence.  Each MatchingPrecedence value must be ranged in [1,10000]. Note that if the precedence is not specified, it will be set to 1000 as default.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.rules"></a>

```python
rules: typing.List[PolicyRulesWithSubjectsV1Beta3]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRulesWithSubjectsV1Beta3]

`rules` describes which requests will match this flow schema.

This FlowSchema matches a request if and only if at least one member of rules matches the request. if it is an empty slice, there will be no requests matching the FlowSchema.

---

### ForZone <a name="ForZone" id="cdk8s-plus-28.k8s.ForZone"></a>

ForZone provides information about which zones should consume this endpoint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ForZone.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ForZone(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ForZone.property.name">name</a></code> | <code>str</code> | name represents the name of the zone. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ForZone.property.name"></a>

```python
name: str
```

- *Type:* str

name represents the name of the zone.

---

### FromServiceAccountNameOptions <a name="FromServiceAccountNameOptions" id="cdk8s-plus-28.FromServiceAccountNameOptions"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.FromServiceAccountNameOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.FromServiceAccountNameOptions(
  namespace_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.FromServiceAccountNameOptions.property.namespaceName">namespace_name</a></code> | <code>str</code> | The name of the namespace the service account belongs to. |

---

##### `namespace_name`<sup>Optional</sup> <a name="namespace_name" id="cdk8s-plus-28.FromServiceAccountNameOptions.property.namespaceName"></a>

```python
namespace_name: str
```

- *Type:* str
- *Default:* "default"

The name of the namespace the service account belongs to.

---

### GCEPersistentDiskPersistentVolumeProps <a name="GCEPersistentDiskPersistentVolumeProps" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps"></a>

Properties for `GCEPersistentDiskPersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.GCEPersistentDiskPersistentVolumeProps(
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None,
  pd_name: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.pdName">pd_name</a></code> | <code>str</code> | Unique name of the PD resource in GCE. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `pd_name`<sup>Required</sup> <a name="pd_name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.pdName"></a>

```python
pd_name: str
```

- *Type:* str

Unique name of the PD resource in GCE.

Used to identify the disk in GCE.

> [https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk](https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk)

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### GCEPersistentDiskVolumeOptions <a name="GCEPersistentDiskVolumeOptions" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions"></a>

Options of `Volume.fromGcePersistentDisk`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.GCEPersistentDiskVolumeOptions(
  fs_type: str = None,
  name: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.fsType">fs_type</a></code> | <code>str</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### GcePersistentDiskVolumeSource <a name="GcePersistentDiskVolumeSource" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource"></a>

Represents a Persistent Disk resource in Google Compute Engine.

A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GcePersistentDiskVolumeSource(
  pd_name: str,
  fs_type: str = None,
  partition: typing.Union[int, float] = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.pdName">pd_name</a></code> | <code>str</code> | pdName is unique name of the PD resource in GCE. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | partition is the partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |

---

##### `pd_name`<sup>Required</sup> <a name="pd_name" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.pdName"></a>

```python
pd_name: str
```

- *Type:* str

pdName is unique name of the PD resource in GCE.

Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

partition is the partition in the volume that you want to mount.

If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

### GitRepoVolumeSource <a name="GitRepoVolumeSource" id="cdk8s-plus-28.k8s.GitRepoVolumeSource"></a>

Represents a volume that is populated with the contents of a git repository.

Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.

DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GitRepoVolumeSource(
  repository: str,
  directory: str = None,
  revision: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.repository">repository</a></code> | <code>str</code> | repository is the URL. |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.directory">directory</a></code> | <code>str</code> | directory is the target directory name. |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.revision">revision</a></code> | <code>str</code> | revision is the commit hash for the specified revision. |

---

##### `repository`<sup>Required</sup> <a name="repository" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.repository"></a>

```python
repository: str
```

- *Type:* str

repository is the URL.

---

##### `directory`<sup>Optional</sup> <a name="directory" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.directory"></a>

```python
directory: str
```

- *Type:* str

directory is the target directory name.

Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.

---

##### `revision`<sup>Optional</sup> <a name="revision" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.revision"></a>

```python
revision: str
```

- *Type:* str

revision is the commit hash for the specified revision.

---

### GlusterfsPersistentVolumeSource <a name="GlusterfsPersistentVolumeSource" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource"></a>

Represents a Glusterfs mount that lasts the lifetime of a pod.

Glusterfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GlusterfsPersistentVolumeSource(
  endpoints: str,
  path: str,
  endpoints_namespace: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpoints">endpoints</a></code> | <code>str</code> | endpoints is the endpoint name that details Glusterfs topology. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.path">path</a></code> | <code>str</code> | path is the Glusterfs volume path. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpointsNamespace">endpoints_namespace</a></code> | <code>str</code> | endpointsNamespace is the namespace that contains Glusterfs endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the Glusterfs volume to be mounted with read-only permissions. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpoints"></a>

```python
endpoints: str
```

- *Type:* str

endpoints is the endpoint name that details Glusterfs topology.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path is the Glusterfs volume path.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `endpoints_namespace`<sup>Optional</sup> <a name="endpoints_namespace" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpointsNamespace"></a>

```python
endpoints_namespace: str
```

- *Type:* str

endpointsNamespace is the namespace that contains Glusterfs endpoint.

If this field is empty, the EndpointNamespace defaults to the same namespace as the bound PVC. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

readOnly here will force the Glusterfs volume to be mounted with read-only permissions.

Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

### GlusterfsVolumeSource <a name="GlusterfsVolumeSource" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource"></a>

Represents a Glusterfs mount that lasts the lifetime of a pod.

Glusterfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GlusterfsVolumeSource(
  endpoints: str,
  path: str,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.endpoints">endpoints</a></code> | <code>str</code> | endpoints is the endpoint name that details Glusterfs topology. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.path">path</a></code> | <code>str</code> | path is the Glusterfs volume path. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the Glusterfs volume to be mounted with read-only permissions. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.endpoints"></a>

```python
endpoints: str
```

- *Type:* str

endpoints is the endpoint name that details Glusterfs topology.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path is the Glusterfs volume path.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

readOnly here will force the Glusterfs volume to be mounted with read-only permissions.

Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

### GroupSubjectV1Beta2 <a name="GroupSubjectV1Beta2" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2"></a>

GroupSubject holds detailed information for group-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GroupSubjectV1Beta2(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GroupSubjectV1Beta2.property.name">name</a></code> | <code>str</code> | name is the user group that matches, or "*" to match all user groups. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

name is the user group that matches, or "*" to match all user groups.

See https://github.com/kubernetes/apiserver/blob/master/pkg/authentication/user/user.go for some well-known group names. Required.

---

### GroupSubjectV1Beta3 <a name="GroupSubjectV1Beta3" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3"></a>

GroupSubject holds detailed information for group-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GroupSubjectV1Beta3(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GroupSubjectV1Beta3.property.name">name</a></code> | <code>str</code> | name is the user group that matches, or "*" to match all user groups. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

name is the user group that matches, or "*" to match all user groups.

See https://github.com/kubernetes/apiserver/blob/master/pkg/authentication/user/user.go for some well-known group names. Required.

---

### GrpcAction <a name="GrpcAction" id="cdk8s-plus-28.k8s.GrpcAction"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GrpcAction.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.GrpcAction(
  port: typing.Union[int, float],
  service: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GrpcAction.property.port">port</a></code> | <code>typing.Union[int, float]</code> | Port number of the gRPC service. |
| <code><a href="#cdk8s-plus-28.k8s.GrpcAction.property.service">service</a></code> | <code>str</code> | Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md). |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.GrpcAction.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Port number of the gRPC service.

Number must be in the range 1 to 65535.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.GrpcAction.property.service"></a>

```python
service: str
```

- *Type:* str

Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).

If this is not specified, the default behavior is defined by gRPC.

---

### HandlerFromHttpGetOptions <a name="HandlerFromHttpGetOptions" id="cdk8s-plus-28.HandlerFromHttpGetOptions"></a>

Options for `Handler.fromHttpGet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HandlerFromHttpGetOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HandlerFromHttpGetOptions(
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HandlerFromHttpGetOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The TCP port to use when sending the GET request. |

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HandlerFromHttpGetOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

### HandlerFromTcpSocketOptions <a name="HandlerFromTcpSocketOptions" id="cdk8s-plus-28.HandlerFromTcpSocketOptions"></a>

Options for `Handler.fromTcpSocket`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HandlerFromTcpSocketOptions(
  host: str = None,
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HandlerFromTcpSocketOptions.property.host">host</a></code> | <code>str</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.HandlerFromTcpSocketOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The TCP port to connect to on the container. |

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.property.host"></a>

```python
host: str
```

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---

### HorizontalPodAutoscalerBehaviorV2 <a name="HorizontalPodAutoscalerBehaviorV2" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2"></a>

HorizontalPodAutoscalerBehavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HorizontalPodAutoscalerBehaviorV2(
  scale_down: HpaScalingRulesV2 = None,
  scale_up: HpaScalingRulesV2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleDown">scale_down</a></code> | <code>cdk8s_plus_28.k8s.HpaScalingRulesV2</code> | scaleDown is scaling policy for scaling Down. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleUp">scale_up</a></code> | <code>cdk8s_plus_28.k8s.HpaScalingRulesV2</code> | scaleUp is scaling policy for scaling Up. |

---

##### `scale_down`<sup>Optional</sup> <a name="scale_down" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleDown"></a>

```python
scale_down: HpaScalingRulesV2
```

- *Type:* cdk8s_plus_28.k8s.HpaScalingRulesV2

scaleDown is scaling policy for scaling Down.

If not set, the default value is to allow to scale down to minReplicas pods, with a 300 second stabilization window (i.e., the highest recommendation for the last 300sec is used).

---

##### `scale_up`<sup>Optional</sup> <a name="scale_up" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleUp"></a>

```python
scale_up: HpaScalingRulesV2
```

- *Type:* cdk8s_plus_28.k8s.HpaScalingRulesV2

scaleUp is scaling policy for scaling Up.

If not set, the default value is the higher of:

* increase no more than 4 pods per 60 seconds
* double the number of pods per 60 seconds
  No stabilization is used.

---

### HorizontalPodAutoscalerProps <a name="HorizontalPodAutoscalerProps" id="cdk8s-plus-28.HorizontalPodAutoscalerProps"></a>

Properties for HorizontalPodAutoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HorizontalPodAutoscalerProps(
  metadata: ApiObjectMetadata = None,
  max_replicas: typing.Union[int, float],
  target: IScalable,
  metrics: typing.List[Metric] = None,
  min_replicas: typing.Union[int, float] = None,
  scale_down: ScalingRules = None,
  scale_up: ScalingRules = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.maxReplicas">max_replicas</a></code> | <code>typing.Union[int, float]</code> | The maximum number of replicas that can be scaled up to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.IScalable">IScalable</a></code> | The workload to scale up or down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metrics">metrics</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]</code> | The metric conditions that trigger a scale up or scale down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.minReplicas">min_replicas</a></code> | <code>typing.Union[int, float]</code> | The minimum number of replicas that can be scaled down to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleDown">scale_down</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleUp">scale_up</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling up. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `max_replicas`<sup>Required</sup> <a name="max_replicas" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.maxReplicas"></a>

```python
max_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The maximum number of replicas that can be scaled up to.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.target"></a>

```python
target: IScalable
```

- *Type:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

The workload to scale up or down.

Scalable workload types:

* Deployment
* StatefulSet

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metrics"></a>

```python
metrics: typing.List[Metric]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Metric">Metric</a>]
- *Default:* If metrics are not provided, then the target resource constraints (e.g. cpu limit) will be used as scaling metrics.

The metric conditions that trigger a scale up or scale down.

---

##### `min_replicas`<sup>Optional</sup> <a name="min_replicas" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.minReplicas"></a>

```python
min_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1

The minimum number of replicas that can be scaled down to.

Can be set to 0 if the alpha feature gate `HPAScaleToZero` is enabled and
at least one Object or External metric is configured.

---

##### `scale_down`<sup>Optional</sup> <a name="scale_down" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleDown"></a>

```python
scale_down: ScalingRules
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Scale down to minReplica count with a 5 minute stabilization window.

The scaling behavior when scaling down.

---

##### `scale_up`<sup>Optional</sup> <a name="scale_up" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleUp"></a>

```python
scale_up: ScalingRules
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Is the higher of: * Increase no more than 4 pods per 60 seconds * Double the number of pods per 60 seconds

The scaling behavior when scaling up.

---

### HorizontalPodAutoscalerSpec <a name="HorizontalPodAutoscalerSpec" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec"></a>

specification of a horizontal pod autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HorizontalPodAutoscalerSpec(
  max_replicas: typing.Union[int, float],
  scale_target_ref: CrossVersionObjectReference,
  min_replicas: typing.Union[int, float] = None,
  target_cpu_utilization_percentage: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.maxReplicas">max_replicas</a></code> | <code>typing.Union[int, float]</code> | maxReplicas is the upper limit for the number of pods that can be set by the autoscaler; |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.scaleTargetRef">scale_target_ref</a></code> | <code>cdk8s_plus_28.k8s.CrossVersionObjectReference</code> | reference to scaled resource; |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.minReplicas">min_replicas</a></code> | <code>typing.Union[int, float]</code> | minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.targetCpuUtilizationPercentage">target_cpu_utilization_percentage</a></code> | <code>typing.Union[int, float]</code> | targetCPUUtilizationPercentage is the target average CPU utilization (represented as a percentage of requested CPU) over all the pods; |

---

##### `max_replicas`<sup>Required</sup> <a name="max_replicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.maxReplicas"></a>

```python
max_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

maxReplicas is the upper limit for the number of pods that can be set by the autoscaler;

cannot be smaller than MinReplicas.

---

##### `scale_target_ref`<sup>Required</sup> <a name="scale_target_ref" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.scaleTargetRef"></a>

```python
scale_target_ref: CrossVersionObjectReference
```

- *Type:* cdk8s_plus_28.k8s.CrossVersionObjectReference

reference to scaled resource;

horizontal pod autoscaler will learn the current resource consumption and will set the desired number of pods by using its Scale subresource.

---

##### `min_replicas`<sup>Optional</sup> <a name="min_replicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.minReplicas"></a>

```python
min_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down.

It defaults to 1 pod.  minReplicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured.  Scaling is active as long as at least one metric value is available.

---

##### `target_cpu_utilization_percentage`<sup>Optional</sup> <a name="target_cpu_utilization_percentage" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.targetCpuUtilizationPercentage"></a>

```python
target_cpu_utilization_percentage: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

targetCPUUtilizationPercentage is the target average CPU utilization (represented as a percentage of requested CPU) over all the pods;

if not specified the default autoscaling policy will be used.

---

### HorizontalPodAutoscalerSpecV2 <a name="HorizontalPodAutoscalerSpecV2" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2"></a>

HorizontalPodAutoscalerSpec describes the desired functionality of the HorizontalPodAutoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HorizontalPodAutoscalerSpecV2(
  max_replicas: typing.Union[int, float],
  scale_target_ref: CrossVersionObjectReferenceV2,
  behavior: HorizontalPodAutoscalerBehaviorV2 = None,
  metrics: typing.List[MetricSpecV2] = None,
  min_replicas: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.maxReplicas">max_replicas</a></code> | <code>typing.Union[int, float]</code> | maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.scaleTargetRef">scale_target_ref</a></code> | <code>cdk8s_plus_28.k8s.CrossVersionObjectReferenceV2</code> | scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.behavior">behavior</a></code> | <code>cdk8s_plus_28.k8s.HorizontalPodAutoscalerBehaviorV2</code> | behavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively). |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.metrics">metrics</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MetricSpecV2]</code> | metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used). |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.minReplicas">min_replicas</a></code> | <code>typing.Union[int, float]</code> | minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. |

---

##### `max_replicas`<sup>Required</sup> <a name="max_replicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.maxReplicas"></a>

```python
max_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up.

It cannot be less that minReplicas.

---

##### `scale_target_ref`<sup>Required</sup> <a name="scale_target_ref" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.scaleTargetRef"></a>

```python
scale_target_ref: CrossVersionObjectReferenceV2
```

- *Type:* cdk8s_plus_28.k8s.CrossVersionObjectReferenceV2

scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count.

---

##### `behavior`<sup>Optional</sup> <a name="behavior" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.behavior"></a>

```python
behavior: HorizontalPodAutoscalerBehaviorV2
```

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerBehaviorV2

behavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively).

If not set, the default HPAScalingRules for scale up and scale down are used.

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.metrics"></a>

```python
metrics: typing.List[MetricSpecV2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MetricSpecV2]

metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).

The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond. If not set, the default metric will be set to 80% average CPU utilization.

---

##### `min_replicas`<sup>Optional</sup> <a name="min_replicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.minReplicas"></a>

```python
min_replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down.

It defaults to 1 pod.  minReplicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured.  Scaling is active as long as at least one metric value is available.

---

### HostAlias <a name="HostAlias" id="cdk8s-plus-28.HostAlias"></a>

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's /etc/hosts file.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HostAlias.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HostAlias(
  hostnames: typing.List[str],
  ip: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HostAlias.property.hostnames">hostnames</a></code> | <code>typing.List[str]</code> | Hostnames for the chosen IP address. |
| <code><a href="#cdk8s-plus-28.HostAlias.property.ip">ip</a></code> | <code>str</code> | IP address of the host file entry. |

---

##### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.HostAlias.property.hostnames"></a>

```python
hostnames: typing.List[str]
```

- *Type:* typing.List[str]

Hostnames for the chosen IP address.

---

##### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.HostAlias.property.ip"></a>

```python
ip: str
```

- *Type:* str

IP address of the host file entry.

---

### HostAlias <a name="HostAlias" id="cdk8s-plus-28.k8s.HostAlias"></a>

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HostAlias.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HostAlias(
  hostnames: typing.List[str] = None,
  ip: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HostAlias.property.hostnames">hostnames</a></code> | <code>typing.List[str]</code> | Hostnames for the above IP address. |
| <code><a href="#cdk8s-plus-28.k8s.HostAlias.property.ip">ip</a></code> | <code>str</code> | IP address of the host file entry. |

---

##### `hostnames`<sup>Optional</sup> <a name="hostnames" id="cdk8s-plus-28.k8s.HostAlias.property.hostnames"></a>

```python
hostnames: typing.List[str]
```

- *Type:* typing.List[str]

Hostnames for the above IP address.

---

##### `ip`<sup>Optional</sup> <a name="ip" id="cdk8s-plus-28.k8s.HostAlias.property.ip"></a>

```python
ip: str
```

- *Type:* str

IP address of the host file entry.

---

### HostPathVolumeOptions <a name="HostPathVolumeOptions" id="cdk8s-plus-28.HostPathVolumeOptions"></a>

Options for a HostPathVolume-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HostPathVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HostPathVolumeOptions(
  path: str,
  type: HostPathVolumeType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HostPathVolumeOptions.property.path">path</a></code> | <code>str</code> | The path of the directory on the host. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeOptions.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.HostPathVolumeType">HostPathVolumeType</a></code> | The expected type of the path found on the host. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.HostPathVolumeOptions.property.path"></a>

```python
path: str
```

- *Type:* str

The path of the directory on the host.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.HostPathVolumeOptions.property.type"></a>

```python
type: HostPathVolumeType
```

- *Type:* <a href="#cdk8s-plus-28.HostPathVolumeType">HostPathVolumeType</a>
- *Default:* HostPathVolumeType.DEFAULT

The expected type of the path found on the host.

---

### HostPathVolumeSource <a name="HostPathVolumeSource" id="cdk8s-plus-28.k8s.HostPathVolumeSource"></a>

Represents a host path mapped into a pod.

Host path volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HostPathVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HostPathVolumeSource(
  path: str,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HostPathVolumeSource.property.path">path</a></code> | <code>str</code> | path of the directory on the host. |
| <code><a href="#cdk8s-plus-28.k8s.HostPathVolumeSource.property.type">type</a></code> | <code>str</code> | type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.HostPathVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path of the directory on the host.

If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.HostPathVolumeSource.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath.

---

### HpaScalingPolicyV2 <a name="HpaScalingPolicyV2" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2"></a>

HPAScalingPolicy is a single policy which must hold true for a specified past interval.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HpaScalingPolicyV2(
  period_seconds: typing.Union[int, float],
  type: str,
  value: typing.Union[int, float]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.periodSeconds">period_seconds</a></code> | <code>typing.Union[int, float]</code> | periodSeconds specifies the window of time for which the policy should hold true. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.type">type</a></code> | <code>str</code> | type is used to specify the scaling policy. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.value">value</a></code> | <code>typing.Union[int, float]</code> | value contains the amount of change which is permitted by the policy. |

---

##### `period_seconds`<sup>Required</sup> <a name="period_seconds" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.periodSeconds"></a>

```python
period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

periodSeconds specifies the window of time for which the policy should hold true.

PeriodSeconds must be greater than zero and less than or equal to 1800 (30 min).

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.type"></a>

```python
type: str
```

- *Type:* str

type is used to specify the scaling policy.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.value"></a>

```python
value: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

value contains the amount of change which is permitted by the policy.

It must be greater than zero

---

### HpaScalingRulesV2 <a name="HpaScalingRulesV2" id="cdk8s-plus-28.k8s.HpaScalingRulesV2"></a>

HPAScalingRules configures the scaling behavior for one direction.

These Rules are applied after calculating DesiredReplicas from metrics for the HPA. They can limit the scaling velocity by specifying scaling policies. They can prevent flapping by specifying the stabilization window, so that the number of replicas is not set instantly, instead, the safest value from the stabilization window is chosen.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HpaScalingRulesV2(
  policies: typing.List[HpaScalingPolicyV2] = None,
  select_policy: str = None,
  stabilization_window_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.policies">policies</a></code> | <code>typing.List[cdk8s_plus_28.k8s.HpaScalingPolicyV2]</code> | policies is a list of potential scaling polices which can be used during scaling. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.selectPolicy">select_policy</a></code> | <code>str</code> | selectPolicy is used to specify which policy should be used. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.stabilizationWindowSeconds">stabilization_window_seconds</a></code> | <code>typing.Union[int, float]</code> | stabilizationWindowSeconds is the number of seconds for which past recommendations should be considered while scaling up or scaling down. |

---

##### `policies`<sup>Optional</sup> <a name="policies" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.policies"></a>

```python
policies: typing.List[HpaScalingPolicyV2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.HpaScalingPolicyV2]

policies is a list of potential scaling polices which can be used during scaling.

At least one policy must be specified, otherwise the HPAScalingRules will be discarded as invalid

---

##### `select_policy`<sup>Optional</sup> <a name="select_policy" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.selectPolicy"></a>

```python
select_policy: str
```

- *Type:* str

selectPolicy is used to specify which policy should be used.

If not set, the default value Max is used.

---

##### `stabilization_window_seconds`<sup>Optional</sup> <a name="stabilization_window_seconds" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.stabilizationWindowSeconds"></a>

```python
stabilization_window_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

stabilizationWindowSeconds is the number of seconds for which past recommendations should be considered while scaling up or scaling down.

StabilizationWindowSeconds must be greater than or equal to zero and less than or equal to 3600 (one hour). If not set, use the default values: - For scale up: 0 (i.e. no stabilization is done). - For scale down: 300 (i.e. the stabilization window is 300 seconds long).

---

### HttpGetAction <a name="HttpGetAction" id="cdk8s-plus-28.k8s.HttpGetAction"></a>

HTTPGetAction describes an action based on HTTP Get requests.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpGetAction.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HttpGetAction(
  port: IntOrString,
  host: str = None,
  http_headers: typing.List[HttpHeader] = None,
  path: str = None,
  scheme: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.port">port</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | Name or number of the port to access on the container. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.host">host</a></code> | <code>str</code> | Host name to connect to, defaults to the pod IP. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.httpHeaders">http_headers</a></code> | <code>typing.List[cdk8s_plus_28.k8s.HttpHeader]</code> | Custom headers to set in the request. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.path">path</a></code> | <code>str</code> | Path to access on the HTTP server. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.scheme">scheme</a></code> | <code>str</code> | Scheme to use for connecting to the host. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.HttpGetAction.property.port"></a>

```python
port: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

Name or number of the port to access on the container.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.HttpGetAction.property.host"></a>

```python
host: str
```

- *Type:* str

Host name to connect to, defaults to the pod IP.

You probably want to set "Host" in httpHeaders instead.

---

##### `http_headers`<sup>Optional</sup> <a name="http_headers" id="cdk8s-plus-28.k8s.HttpGetAction.property.httpHeaders"></a>

```python
http_headers: typing.List[HttpHeader]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.HttpHeader]

Custom headers to set in the request.

HTTP allows repeated headers.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.HttpGetAction.property.path"></a>

```python
path: str
```

- *Type:* str

Path to access on the HTTP server.

---

##### `scheme`<sup>Optional</sup> <a name="scheme" id="cdk8s-plus-28.k8s.HttpGetAction.property.scheme"></a>

```python
scheme: str
```

- *Type:* str
- *Default:* HTTP.

Scheme to use for connecting to the host.

Defaults to HTTP.

---

### HttpGetProbeOptions <a name="HttpGetProbeOptions" id="cdk8s-plus-28.HttpGetProbeOptions"></a>

Options for `Probe.fromHttpGet()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HttpGetProbeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.HttpGetProbeOptions(
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None,
  host: str = None,
  port: typing.Union[int, float] = None,
  scheme: ConnectionScheme = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.failureThreshold">failure_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.initialDelaySeconds">initial_delay_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.periodSeconds">period_seconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.successThreshold">success_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.timeoutSeconds">timeout_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.host">host</a></code> | <code>str</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The TCP port to use when sending the GET request. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.scheme">scheme</a></code> | <code><a href="#cdk8s-plus-28.ConnectionScheme">ConnectionScheme</a></code> | Scheme to use for connecting to the host (HTTP or HTTPS). |

---

##### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.HttpGetProbeOptions.property.failureThreshold"></a>

```python
failure_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.initialDelaySeconds"></a>

```python
initial_delay_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.periodSeconds"></a>

```python
period_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.HttpGetProbeOptions.property.successThreshold"></a>

```python
success_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.timeoutSeconds"></a>

```python
timeout_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.HttpGetProbeOptions.property.host"></a>

```python
host: str
```

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HttpGetProbeOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

##### `scheme`<sup>Optional</sup> <a name="scheme" id="cdk8s-plus-28.HttpGetProbeOptions.property.scheme"></a>

```python
scheme: ConnectionScheme
```

- *Type:* <a href="#cdk8s-plus-28.ConnectionScheme">ConnectionScheme</a>
- *Default:* ConnectionScheme.HTTP

Scheme to use for connecting to the host (HTTP or HTTPS).

---

### HttpHeader <a name="HttpHeader" id="cdk8s-plus-28.k8s.HttpHeader"></a>

HTTPHeader describes a custom header to be used in HTTP probes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpHeader.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HttpHeader(
  name: str,
  value: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpHeader.property.name">name</a></code> | <code>str</code> | The header field name. |
| <code><a href="#cdk8s-plus-28.k8s.HttpHeader.property.value">value</a></code> | <code>str</code> | The header field value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.HttpHeader.property.name"></a>

```python
name: str
```

- *Type:* str

The header field name.

This will be canonicalized upon output, so case-variant names will be understood as the same header.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.HttpHeader.property.value"></a>

```python
value: str
```

- *Type:* str

The header field value.

---

### HttpIngressPath <a name="HttpIngressPath" id="cdk8s-plus-28.k8s.HttpIngressPath"></a>

HTTPIngressPath associates a path with a backend.

Incoming urls matching the path are forwarded to the backend.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpIngressPath.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HttpIngressPath(
  backend: IngressBackend,
  path_type: str,
  path: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.backend">backend</a></code> | <code>cdk8s_plus_28.k8s.IngressBackend</code> | backend defines the referenced service endpoint to which the traffic will be forwarded to. |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.pathType">path_type</a></code> | <code>str</code> | pathType determines the interpretation of the path matching. |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.path">path</a></code> | <code>str</code> | path is matched against the path of an incoming request. |

---

##### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.k8s.HttpIngressPath.property.backend"></a>

```python
backend: IngressBackend
```

- *Type:* cdk8s_plus_28.k8s.IngressBackend

backend defines the referenced service endpoint to which the traffic will be forwarded to.

---

##### `path_type`<sup>Required</sup> <a name="path_type" id="cdk8s-plus-28.k8s.HttpIngressPath.property.pathType"></a>

```python
path_type: str
```

- *Type:* str

pathType determines the interpretation of the path matching.

PathType can be one of the following values: * Exact: Matches the URL path exactly. * Prefix: Matches based on a URL path prefix split by '/'. Matching is
done on a path element by element basis. A path element refers is the
list of labels in the path split by the '/' separator. A request is a
match for path p if every p is an element-wise prefix of p of the
request path. Note that if the last element of the path is a substring
of the last element in request path, it is not a match (e.g. /foo/bar
matches /foo/bar/baz, but does not match /foo/barbaz).

* ImplementationSpecific: Interpretation of the Path matching is up to
  the IngressClass. Implementations can treat this as a separate PathType
  or treat it identically to Prefix or Exact path types.
  Implementations are required to support all path types.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.HttpIngressPath.property.path"></a>

```python
path: str
```

- *Type:* str

path is matched against the path of an incoming request.

Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/' and must be present when using PathType with value "Exact" or "Prefix".

---

### HttpIngressRuleValue <a name="HttpIngressRuleValue" id="cdk8s-plus-28.k8s.HttpIngressRuleValue"></a>

HTTPIngressRuleValue is a list of http selectors pointing to backends.

In the example: http://<host>/<path>?<searchpart> -> backend where where parts of the url correspond to RFC 3986, this resource will be used to match against everything after the last '/' and before the first '?' or '#'.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpIngressRuleValue.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.HttpIngressRuleValue(
  paths: typing.List[HttpIngressPath]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressRuleValue.property.paths">paths</a></code> | <code>typing.List[cdk8s_plus_28.k8s.HttpIngressPath]</code> | paths is a collection of paths that map requests to backends. |

---

##### `paths`<sup>Required</sup> <a name="paths" id="cdk8s-plus-28.k8s.HttpIngressRuleValue.property.paths"></a>

```python
paths: typing.List[HttpIngressPath]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.HttpIngressPath]

paths is a collection of paths that map requests to backends.

---

### IngressBackend <a name="IngressBackend" id="cdk8s-plus-28.k8s.IngressBackend"></a>

IngressBackend describes all endpoints for a given service and port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressBackend.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressBackend(
  resource: TypedLocalObjectReference = None,
  service: IngressServiceBackend = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressBackend.property.resource">resource</a></code> | <code>cdk8s_plus_28.k8s.TypedLocalObjectReference</code> | resource is an ObjectRef to another Kubernetes resource in the namespace of the Ingress object. |
| <code><a href="#cdk8s-plus-28.k8s.IngressBackend.property.service">service</a></code> | <code>cdk8s_plus_28.k8s.IngressServiceBackend</code> | service references a service as a backend. |

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.IngressBackend.property.resource"></a>

```python
resource: TypedLocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.TypedLocalObjectReference

resource is an ObjectRef to another Kubernetes resource in the namespace of the Ingress object.

If resource is specified, a service.Name and service.Port must not be specified. This is a mutually exclusive setting with "Service".

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.IngressBackend.property.service"></a>

```python
service: IngressServiceBackend
```

- *Type:* cdk8s_plus_28.k8s.IngressServiceBackend

service references a service as a backend.

This is a mutually exclusive setting with "Resource".

---

### IngressClassParametersReference <a name="IngressClassParametersReference" id="cdk8s-plus-28.k8s.IngressClassParametersReference"></a>

IngressClassParametersReference identifies an API object.

This can be used to specify a cluster or namespace-scoped resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressClassParametersReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressClassParametersReference(
  kind: str,
  name: str,
  api_group: str = None,
  namespace: str = None,
  scope: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.kind">kind</a></code> | <code>str</code> | kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.name">name</a></code> | <code>str</code> | name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.apiGroup">api_group</a></code> | <code>str</code> | apiGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.namespace">namespace</a></code> | <code>str</code> | namespace is the namespace of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.scope">scope</a></code> | <code>str</code> | scope represents if this refers to a cluster or namespace scoped resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of resource being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

apiGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

namespace is the namespace of the resource being referenced.

This field is required when scope is set to "Namespace" and must be unset when scope is set to "Cluster".

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.scope"></a>

```python
scope: str
```

- *Type:* str

scope represents if this refers to a cluster or namespace scoped resource.

This may be set to "Cluster" (default) or "Namespace".

---

### IngressClassSpec <a name="IngressClassSpec" id="cdk8s-plus-28.k8s.IngressClassSpec"></a>

IngressClassSpec provides information about the class of an Ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressClassSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressClassSpec(
  controller: str = None,
  parameters: IngressClassParametersReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassSpec.property.controller">controller</a></code> | <code>str</code> | controller refers to the name of the controller that should handle this class. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassSpec.property.parameters">parameters</a></code> | <code>cdk8s_plus_28.k8s.IngressClassParametersReference</code> | parameters is a link to a custom resource containing additional configuration for the controller. |

---

##### `controller`<sup>Optional</sup> <a name="controller" id="cdk8s-plus-28.k8s.IngressClassSpec.property.controller"></a>

```python
controller: str
```

- *Type:* str

controller refers to the name of the controller that should handle this class.

This allows for different "flavors" that are controlled by the same controller. For example, you may have different parameters for the same implementing controller. This should be specified as a domain-prefixed path no more than 250 characters in length, e.g. "acme.io/ingress-controller". This field is immutable.

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.IngressClassSpec.property.parameters"></a>

```python
parameters: IngressClassParametersReference
```

- *Type:* cdk8s_plus_28.k8s.IngressClassParametersReference

parameters is a link to a custom resource containing additional configuration for the controller.

This is optional if the controller does not require extra parameters.

---

### IngressProps <a name="IngressProps" id="cdk8s-plus-28.IngressProps"></a>

Properties for `Ingress`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.IngressProps(
  metadata: ApiObjectMetadata = None,
  class_name: str = None,
  default_backend: IngressBackend = None,
  rules: typing.List[IngressRule] = None,
  tls: typing.List[IngressTls] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.className">class_name</a></code> | <code>str</code> | Class Name for this ingress. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.defaultBackend">default_backend</a></code> | <code><a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a></code> | The default backend services requests that do not match any rule. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IngressRule">IngressRule</a>]</code> | Routing rules for this ingress. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.tls">tls</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IngressTls">IngressTls</a>]</code> | TLS settings for this ingress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.IngressProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `class_name`<sup>Optional</sup> <a name="class_name" id="cdk8s-plus-28.IngressProps.property.className"></a>

```python
class_name: str
```

- *Type:* str

Class Name for this ingress.

This field is a reference to an IngressClass resource that contains
additional Ingress configuration, including the name of the Ingress controller.

---

##### `default_backend`<sup>Optional</sup> <a name="default_backend" id="cdk8s-plus-28.IngressProps.property.defaultBackend"></a>

```python
default_backend: IngressBackend
```

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The default backend services requests that do not match any rule.

Using this option or the `addDefaultBackend()` method is equivalent to
adding a rule with both `path` and `host` undefined.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.IngressProps.property.rules"></a>

```python
rules: typing.List[IngressRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.IngressRule">IngressRule</a>]

Routing rules for this ingress.

Each rule must define an `IngressBackend` that will receive the requests
that match this rule. If both `host` and `path` are not specifiec, this
backend will be used as the default backend of the ingress.

You can also add rules later using `addRule()`, `addHostRule()`,
`addDefaultBackend()` and `addHostDefaultBackend()`.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="cdk8s-plus-28.IngressProps.property.tls"></a>

```python
tls: typing.List[IngressTls]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.IngressTls">IngressTls</a>]

TLS settings for this ingress.

Using this option tells the ingress controller to expose a TLS endpoint.
Currently the Ingress only supports a single TLS port, 443. If multiple
members of this list specify different hosts, they will be multiplexed on
the same port according to the hostname specified through the SNI TLS
extension, if the ingress controller fulfilling the ingress supports SNI.

---

### IngressRule <a name="IngressRule" id="cdk8s-plus-28.IngressRule"></a>

Represents the rules mapping the paths under a specified host to the related backend services.

Incoming requests are first evaluated for a host match,
then routed to the backend associated with the matching path.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressRule.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.IngressRule(
  backend: IngressBackend,
  host: str = None,
  path: str = None,
  path_type: HttpIngressPathType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressRule.property.backend">backend</a></code> | <code><a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a></code> | Backend defines the referenced service endpoint to which the traffic will be forwarded to. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.host">host</a></code> | <code>str</code> | Host is the fully qualified domain name of a network host, as defined by RFC 3986. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.path">path</a></code> | <code>str</code> | Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/'. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.pathType">path_type</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | Specify how the path is matched against request paths. |

---

##### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.IngressRule.property.backend"></a>

```python
backend: IngressBackend
```

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

Backend defines the referenced service endpoint to which the traffic will be forwarded to.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.IngressRule.property.host"></a>

```python
host: str
```

- *Type:* str
- *Default:* If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.

Host is the fully qualified domain name of a network host, as defined by RFC 3986.

Note the following deviations from the "host" part of the URI as
defined in the RFC: 1. IPs are not allowed. Currently an IngressRuleValue
can only apply to the IP in the Spec of the parent Ingress. 2. The `:`
delimiter is not respected because ports are not allowed. Currently the
port of an Ingress is implicitly :80 for http and :443 for https. Both
these may change in the future. Incoming requests are matched against the
host before the IngressRuleValue.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.IngressRule.property.path"></a>

```python
path: str
```

- *Type:* str
- *Default:* If unspecified, the path defaults to a catch all sending traffic to the backend.

Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/'.

---

##### `path_type`<sup>Optional</sup> <a name="path_type" id="cdk8s-plus-28.IngressRule.property.pathType"></a>

```python
path_type: HttpIngressPathType
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

Specify how the path is matched against request paths.

By default, path
types will be matched by prefix.

> [https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types](https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types)

---

### IngressRule <a name="IngressRule" id="cdk8s-plus-28.k8s.IngressRule"></a>

IngressRule represents the rules mapping the paths under a specified host to the related backend services.

Incoming requests are first evaluated for a host match, then routed to the backend associated with the matching IngressRuleValue.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressRule(
  host: str = None,
  http: HttpIngressRuleValue = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressRule.property.host">host</a></code> | <code>str</code> | host is the fully qualified domain name of a network host, as defined by RFC 3986. |
| <code><a href="#cdk8s-plus-28.k8s.IngressRule.property.http">http</a></code> | <code>cdk8s_plus_28.k8s.HttpIngressRuleValue</code> | *No description.* |

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.IngressRule.property.host"></a>

```python
host: str
```

- *Type:* str

host is the fully qualified domain name of a network host, as defined by RFC 3986.

Note the following deviations from the "host" part of the URI as defined in RFC 3986: 1. IPs are not allowed. Currently an IngressRuleValue can only apply to
the IP in the Spec of the parent Ingress.
2. The `:` delimiter is not respected because ports are not allowed.
Currently the port of an Ingress is implicitly :80 for http and
:443 for https.
Both these may change in the future. Incoming requests are matched against the host before the IngressRuleValue. If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.

host can be "precise" which is a domain name without the terminating dot of a network host (e.g. "foo.bar.com") or "wildcard", which is a domain name prefixed with a single wildcard label (e.g. "*.foo.com"). The wildcard character '*' must appear by itself as the first DNS label and matches only a single label. You cannot have a wildcard label by itself (e.g. Host == "*"). Requests will be matched against the Host field in the following way: 1. If host is precise, the request matches this rule if the http host header is equal to Host. 2. If host is a wildcard, then the request matches this rule if the http host header is to equal to the suffix (removing the first label) of the wildcard rule.

---

##### `http`<sup>Optional</sup> <a name="http" id="cdk8s-plus-28.k8s.IngressRule.property.http"></a>

```python
http: HttpIngressRuleValue
```

- *Type:* cdk8s_plus_28.k8s.HttpIngressRuleValue

---

### IngressServiceBackend <a name="IngressServiceBackend" id="cdk8s-plus-28.k8s.IngressServiceBackend"></a>

IngressServiceBackend references a Kubernetes Service as a Backend.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressServiceBackend.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressServiceBackend(
  name: str,
  port: ServiceBackendPort = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressServiceBackend.property.name">name</a></code> | <code>str</code> | name is the referenced service. |
| <code><a href="#cdk8s-plus-28.k8s.IngressServiceBackend.property.port">port</a></code> | <code>cdk8s_plus_28.k8s.ServiceBackendPort</code> | port of the referenced service. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.IngressServiceBackend.property.name"></a>

```python
name: str
```

- *Type:* str

name is the referenced service.

The service must exist in the same namespace as the Ingress object.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.IngressServiceBackend.property.port"></a>

```python
port: ServiceBackendPort
```

- *Type:* cdk8s_plus_28.k8s.ServiceBackendPort

port of the referenced service.

A port name or port number is required for a IngressServiceBackend.

---

### IngressSpec <a name="IngressSpec" id="cdk8s-plus-28.k8s.IngressSpec"></a>

IngressSpec describes the Ingress the user wishes to exist.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressSpec(
  default_backend: IngressBackend = None,
  ingress_class_name: str = None,
  rules: typing.List[IngressRule] = None,
  tls: typing.List[IngressTls] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.defaultBackend">default_backend</a></code> | <code>cdk8s_plus_28.k8s.IngressBackend</code> | defaultBackend is the backend that should handle requests that don't match any rule. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.ingressClassName">ingress_class_name</a></code> | <code>str</code> | ingressClassName is the name of an IngressClass cluster resource. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.IngressRule]</code> | rules is a list of host rules used to configure the Ingress. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.tls">tls</a></code> | <code>typing.List[cdk8s_plus_28.k8s.IngressTls]</code> | tls represents the TLS configuration. |

---

##### `default_backend`<sup>Optional</sup> <a name="default_backend" id="cdk8s-plus-28.k8s.IngressSpec.property.defaultBackend"></a>

```python
default_backend: IngressBackend
```

- *Type:* cdk8s_plus_28.k8s.IngressBackend

defaultBackend is the backend that should handle requests that don't match any rule.

If Rules are not specified, DefaultBackend must be specified. If DefaultBackend is not set, the handling of requests that do not match any of the rules will be up to the Ingress controller.

---

##### `ingress_class_name`<sup>Optional</sup> <a name="ingress_class_name" id="cdk8s-plus-28.k8s.IngressSpec.property.ingressClassName"></a>

```python
ingress_class_name: str
```

- *Type:* str

ingressClassName is the name of an IngressClass cluster resource.

Ingress controller implementations use this field to know whether they should be serving this Ingress resource, by a transitive connection (controller -> IngressClass -> Ingress resource). Although the `kubernetes.io/ingress.class` annotation (simple constant name) was never formally defined, it was widely supported by Ingress controllers to create a direct binding between Ingress controller and Ingress resources. Newly created Ingress resources should prefer using the field. However, even though the annotation is officially deprecated, for backwards compatibility reasons, ingress controllers should still honor that annotation if present.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.IngressSpec.property.rules"></a>

```python
rules: typing.List[IngressRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.IngressRule]

rules is a list of host rules used to configure the Ingress.

If unspecified, or no rule matches, all traffic is sent to the default backend.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="cdk8s-plus-28.k8s.IngressSpec.property.tls"></a>

```python
tls: typing.List[IngressTls]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.IngressTls]

tls represents the TLS configuration.

Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.

---

### IngressTls <a name="IngressTls" id="cdk8s-plus-28.IngressTls"></a>

Represents the TLS configuration mapping that is passed to the ingress controller for SSL termination.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressTls.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.IngressTls(
  hosts: typing.List[str] = None,
  secret: ISecret = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressTls.property.hosts">hosts</a></code> | <code>typing.List[str]</code> | Hosts are a list of hosts included in the TLS certificate. |
| <code><a href="#cdk8s-plus-28.IngressTls.property.secret">secret</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | Secret is the secret that contains the certificate and key used to terminate SSL traffic on 443. |

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="cdk8s-plus-28.IngressTls.property.hosts"></a>

```python
hosts: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* If unspecified, it defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress.

Hosts are a list of hosts included in the TLS certificate.

The values in
this list must match the name/s used in the TLS Secret.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.IngressTls.property.secret"></a>

```python
secret: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* If unspecified, it allows SSL routing based on SNI hostname.

Secret is the secret that contains the certificate and key used to terminate SSL traffic on 443.

If the SNI host in a listener conflicts with
the "Host" header field used by an IngressRule, the SNI host is used for
termination and value of the Host header is used for routing.

---

### IngressTls <a name="IngressTls" id="cdk8s-plus-28.k8s.IngressTls"></a>

IngressTLS describes the transport layer security associated with an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressTls.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IngressTls(
  hosts: typing.List[str] = None,
  secret_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressTls.property.hosts">hosts</a></code> | <code>typing.List[str]</code> | hosts is a list of hosts included in the TLS certificate. |
| <code><a href="#cdk8s-plus-28.k8s.IngressTls.property.secretName">secret_name</a></code> | <code>str</code> | secretName is the name of the secret used to terminate TLS traffic on port 443. |

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="cdk8s-plus-28.k8s.IngressTls.property.hosts"></a>

```python
hosts: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.

hosts is a list of hosts included in the TLS certificate.

The values in this list must match the name/s used in the tlsSecret. Defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.

---

##### `secret_name`<sup>Optional</sup> <a name="secret_name" id="cdk8s-plus-28.k8s.IngressTls.property.secretName"></a>

```python
secret_name: str
```

- *Type:* str

secretName is the name of the secret used to terminate TLS traffic on port 443.

Field is left optional to allow TLS routing based on SNI hostname alone. If the SNI host in a listener conflicts with the "Host" header field used by an IngressRule, the SNI host is used for termination and value of the "Host" header is used for routing.

---

### IpAddressSpecV1Alpha1 <a name="IpAddressSpecV1Alpha1" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1"></a>

IPAddressSpec describe the attributes in an IP Address.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IpAddressSpecV1Alpha1(
  parent_ref: ParentReferenceV1Alpha1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.property.parentRef">parent_ref</a></code> | <code>cdk8s_plus_28.k8s.ParentReferenceV1Alpha1</code> | ParentRef references the resource that an IPAddress is attached to. |

---

##### `parent_ref`<sup>Optional</sup> <a name="parent_ref" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.property.parentRef"></a>

```python
parent_ref: ParentReferenceV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ParentReferenceV1Alpha1

ParentRef references the resource that an IPAddress is attached to.

An IPAddress must reference a parent object.

---

### IpBlock <a name="IpBlock" id="cdk8s-plus-28.k8s.IpBlock"></a>

IPBlock describes a particular CIDR (Ex.

"192.168.1.0/24","2001:db8::/64") that is allowed to the pods matched by a NetworkPolicySpec's podSelector. The except entry describes CIDRs that should not be included within this rule.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IpBlock.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IpBlock(
  cidr: str,
  except: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IpBlock.property.cidr">cidr</a></code> | <code>str</code> | cidr is a string representing the IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64". |
| <code><a href="#cdk8s-plus-28.k8s.IpBlock.property.except">except</a></code> | <code>typing.List[str]</code> | except is a slice of CIDRs that should not be included within an IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64" Except values will be rejected if they are outside the cidr range. |

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk8s-plus-28.k8s.IpBlock.property.cidr"></a>

```python
cidr: str
```

- *Type:* str

cidr is a string representing the IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64".

---

##### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.k8s.IpBlock.property.except"></a>

```python
except: typing.List[str]
```

- *Type:* typing.List[str]

except is a slice of CIDRs that should not be included within an IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64" Except values will be rejected if they are outside the cidr range.

---

### IscsiPersistentVolumeSource <a name="IscsiPersistentVolumeSource" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource"></a>

ISCSIPersistentVolumeSource represents an ISCSI disk.

ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IscsiPersistentVolumeSource(
  iqn: str,
  lun: typing.Union[int, float],
  target_portal: str,
  chap_auth_discovery: bool = None,
  chap_auth_session: bool = None,
  fs_type: str = None,
  initiator_name: str = None,
  iscsi_interface: str = None,
  portals: typing.List[str] = None,
  read_only: bool = None,
  secret_ref: SecretReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iqn">iqn</a></code> | <code>str</code> | iqn is Target iSCSI Qualified Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.lun">lun</a></code> | <code>typing.Union[int, float]</code> | lun is iSCSI Target Lun number. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.targetPortal">target_portal</a></code> | <code>str</code> | targetPortal is iSCSI Target Portal. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthDiscovery">chap_auth_discovery</a></code> | <code>bool</code> | chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthSession">chap_auth_session</a></code> | <code>bool</code> | chapAuthSession defines whether support iSCSI Session CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.initiatorName">initiator_name</a></code> | <code>str</code> | initiatorName is the custom iSCSI Initiator Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iscsiInterface">iscsi_interface</a></code> | <code>str</code> | iscsiInterface is the interface Name that uses an iSCSI transport. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.portals">portals</a></code> | <code>typing.List[str]</code> | portals is the iSCSI Target Portal List. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef is the CHAP Secret for iSCSI target and initiator authentication. |

---

##### `iqn`<sup>Required</sup> <a name="iqn" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iqn"></a>

```python
iqn: str
```

- *Type:* str

iqn is Target iSCSI Qualified Name.

---

##### `lun`<sup>Required</sup> <a name="lun" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.lun"></a>

```python
lun: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

lun is iSCSI Target Lun number.

---

##### `target_portal`<sup>Required</sup> <a name="target_portal" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.targetPortal"></a>

```python
target_portal: str
```

- *Type:* str

targetPortal is iSCSI Target Portal.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `chap_auth_discovery`<sup>Optional</sup> <a name="chap_auth_discovery" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthDiscovery"></a>

```python
chap_auth_discovery: bool
```

- *Type:* bool

chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication.

---

##### `chap_auth_session`<sup>Optional</sup> <a name="chap_auth_session" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthSession"></a>

```python
chap_auth_session: bool
```

- *Type:* bool

chapAuthSession defines whether support iSCSI Session CHAP authentication.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

---

##### `initiator_name`<sup>Optional</sup> <a name="initiator_name" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.initiatorName"></a>

```python
initiator_name: str
```

- *Type:* str

initiatorName is the custom iSCSI Initiator Name.

If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

---

##### `iscsi_interface`<sup>Optional</sup> <a name="iscsi_interface" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iscsiInterface"></a>

```python
iscsi_interface: str
```

- *Type:* str
- *Default:* default' (tcp).

iscsiInterface is the interface Name that uses an iSCSI transport.

Defaults to 'default' (tcp).

---

##### `portals`<sup>Optional</sup> <a name="portals" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.portals"></a>

```python
portals: typing.List[str]
```

- *Type:* typing.List[str]

portals is the iSCSI Target Portal List.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false.

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

secretRef is the CHAP Secret for iSCSI target and initiator authentication.

---

### IscsiVolumeSource <a name="IscsiVolumeSource" id="cdk8s-plus-28.k8s.IscsiVolumeSource"></a>

Represents an ISCSI disk.

ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IscsiVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IscsiVolumeSource(
  iqn: str,
  lun: typing.Union[int, float],
  target_portal: str,
  chap_auth_discovery: bool = None,
  chap_auth_session: bool = None,
  fs_type: str = None,
  initiator_name: str = None,
  iscsi_interface: str = None,
  portals: typing.List[str] = None,
  read_only: bool = None,
  secret_ref: LocalObjectReference = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.iqn">iqn</a></code> | <code>str</code> | iqn is the target iSCSI Qualified Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.lun">lun</a></code> | <code>typing.Union[int, float]</code> | lun represents iSCSI Target Lun number. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.targetPortal">target_portal</a></code> | <code>str</code> | targetPortal is iSCSI Target Portal. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthDiscovery">chap_auth_discovery</a></code> | <code>bool</code> | chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthSession">chap_auth_session</a></code> | <code>bool</code> | chapAuthSession defines whether support iSCSI Session CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.initiatorName">initiator_name</a></code> | <code>str</code> | initiatorName is the custom iSCSI Initiator Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.iscsiInterface">iscsi_interface</a></code> | <code>str</code> | iscsiInterface is the interface Name that uses an iSCSI transport. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.portals">portals</a></code> | <code>typing.List[str]</code> | portals is the iSCSI Target Portal List. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef is the CHAP Secret for iSCSI target and initiator authentication. |

---

##### `iqn`<sup>Required</sup> <a name="iqn" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.iqn"></a>

```python
iqn: str
```

- *Type:* str

iqn is the target iSCSI Qualified Name.

---

##### `lun`<sup>Required</sup> <a name="lun" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.lun"></a>

```python
lun: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

lun represents iSCSI Target Lun number.

---

##### `target_portal`<sup>Required</sup> <a name="target_portal" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.targetPortal"></a>

```python
target_portal: str
```

- *Type:* str

targetPortal is iSCSI Target Portal.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `chap_auth_discovery`<sup>Optional</sup> <a name="chap_auth_discovery" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthDiscovery"></a>

```python
chap_auth_discovery: bool
```

- *Type:* bool

chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication.

---

##### `chap_auth_session`<sup>Optional</sup> <a name="chap_auth_session" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthSession"></a>

```python
chap_auth_session: bool
```

- *Type:* bool

chapAuthSession defines whether support iSCSI Session CHAP authentication.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

---

##### `initiator_name`<sup>Optional</sup> <a name="initiator_name" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.initiatorName"></a>

```python
initiator_name: str
```

- *Type:* str

initiatorName is the custom iSCSI Initiator Name.

If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

---

##### `iscsi_interface`<sup>Optional</sup> <a name="iscsi_interface" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.iscsiInterface"></a>

```python
iscsi_interface: str
```

- *Type:* str
- *Default:* default' (tcp).

iscsiInterface is the interface Name that uses an iSCSI transport.

Defaults to 'default' (tcp).

---

##### `portals`<sup>Optional</sup> <a name="portals" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.portals"></a>

```python
portals: typing.List[str]
```

- *Type:* typing.List[str]

portals is the iSCSI Target Portal List.

The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false.

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef is the CHAP Secret for iSCSI target and initiator authentication.

---

### JobProps <a name="JobProps" id="cdk8s-plus-28.JobProps"></a>

Properties for `Job`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.JobProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.JobProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  active_deadline: Duration = None,
  backoff_limit: typing.Union[int, float] = None,
  ttl_after_finished: Duration = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.JobProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.JobProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.JobProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.JobProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.JobProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.JobProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.JobProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.JobProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.JobProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.JobProps.property.activeDeadline">active_deadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.JobProps.property.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.JobProps.property.ttlAfterFinished">ttl_after_finished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.JobProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.JobProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.JobProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.JobProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.JobProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.JobProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.JobProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.JobProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.JobProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.JobProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.JobProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.JobProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.JobProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.JobProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.JobProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.JobProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.JobProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `active_deadline`<sup>Optional</sup> <a name="active_deadline" id="cdk8s-plus-28.JobProps.property.activeDeadline"></a>

```python
active_deadline: Duration
```

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.JobProps.property.backoffLimit"></a>

```python
backoff_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttl_after_finished`<sup>Optional</sup> <a name="ttl_after_finished" id="cdk8s-plus-28.JobProps.property.ttlAfterFinished"></a>

```python
ttl_after_finished: Duration
```

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

### JobSpec <a name="JobSpec" id="cdk8s-plus-28.k8s.JobSpec"></a>

JobSpec describes how the job execution will look like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JobSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.JobSpec(
  template: PodTemplateSpec,
  active_deadline_seconds: typing.Union[int, float] = None,
  backoff_limit: typing.Union[int, float] = None,
  backoff_limit_per_index: typing.Union[int, float] = None,
  completion_mode: str = None,
  completions: typing.Union[int, float] = None,
  manual_selector: bool = None,
  max_failed_indexes: typing.Union[int, float] = None,
  parallelism: typing.Union[int, float] = None,
  pod_failure_policy: PodFailurePolicy = None,
  pod_replacement_policy: str = None,
  selector: LabelSelector = None,
  suspend: bool = None,
  ttl_seconds_after_finished: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Describes the pod that will be created when executing a job. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.activeDeadlineSeconds">active_deadline_seconds</a></code> | <code>typing.Union[int, float]</code> | Specifies the duration in seconds relative to the startTime that the job may be continuously active before the system tries to terminate it; |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.backoffLimit">backoff_limit</a></code> | <code>typing.Union[int, float]</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.backoffLimitPerIndex">backoff_limit_per_index</a></code> | <code>typing.Union[int, float]</code> | Specifies the limit for the number of retries within an index before marking this index as failed. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.completionMode">completion_mode</a></code> | <code>str</code> | completionMode specifies how Pod completions are tracked. It can be `NonIndexed` (default) or `Indexed`. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.completions">completions</a></code> | <code>typing.Union[int, float]</code> | Specifies the desired number of successfully finished pods the job should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.manualSelector">manual_selector</a></code> | <code>bool</code> | manualSelector controls generation of pod labels and pod selectors. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.maxFailedIndexes">max_failed_indexes</a></code> | <code>typing.Union[int, float]</code> | Specifies the maximal number of failed indexes before marking the Job as failed, when backoffLimitPerIndex is set. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.parallelism">parallelism</a></code> | <code>typing.Union[int, float]</code> | Specifies the maximum desired number of pods the job should run at any given time. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.podFailurePolicy">pod_failure_policy</a></code> | <code>cdk8s_plus_28.k8s.PodFailurePolicy</code> | Specifies the policy of handling failed pods. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.podReplacementPolicy">pod_replacement_policy</a></code> | <code>str</code> | podReplacementPolicy specifies when to create replacement Pods. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | A label query over pods that should match the pod count. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.suspend">suspend</a></code> | <code>bool</code> | suspend specifies whether the Job controller should create Pods or not. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.ttlSecondsAfterFinished">ttl_seconds_after_finished</a></code> | <code>typing.Union[int, float]</code> | ttlSecondsAfterFinished limits the lifetime of a Job that has finished execution (either Complete or Failed). |

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.JobSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Describes the pod that will be created when executing a job.

The only allowed template.spec.restartPolicy values are "Never" or "OnFailure". More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `active_deadline_seconds`<sup>Optional</sup> <a name="active_deadline_seconds" id="cdk8s-plus-28.k8s.JobSpec.property.activeDeadlineSeconds"></a>

```python
active_deadline_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Specifies the duration in seconds relative to the startTime that the job may be continuously active before the system tries to terminate it;

value must be positive integer. If a Job is suspended (at creation or through an update), this timer will effectively be stopped and reset when the Job is resumed again.

---

##### `backoff_limit`<sup>Optional</sup> <a name="backoff_limit" id="cdk8s-plus-28.k8s.JobSpec.property.backoffLimit"></a>

```python
backoff_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 6

Specifies the number of retries before marking this job failed.

Defaults to 6

---

##### `backoff_limit_per_index`<sup>Optional</sup> <a name="backoff_limit_per_index" id="cdk8s-plus-28.k8s.JobSpec.property.backoffLimitPerIndex"></a>

```python
backoff_limit_per_index: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Specifies the limit for the number of retries within an index before marking this index as failed.

When enabled the number of failures per index is kept in the pod's batch.kubernetes.io/job-index-failure-count annotation. It can only be set when Job's completionMode=Indexed, and the Pod's restart policy is Never. The field is immutable. This field is alpha-level. It can be used when the `JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).

---

##### `completion_mode`<sup>Optional</sup> <a name="completion_mode" id="cdk8s-plus-28.k8s.JobSpec.property.completionMode"></a>

```python
completion_mode: str
```

- *Type:* str

completionMode specifies how Pod completions are tracked. It can be `NonIndexed` (default) or `Indexed`.

`NonIndexed` means that the Job is considered complete when there have been .spec.completions successfully completed Pods. Each Pod completion is homologous to each other.

`Indexed` means that the Pods of a Job get an associated completion index from 0 to (.spec.completions - 1), available in the annotation batch.kubernetes.io/job-completion-index. The Job is considered complete when there is one successfully completed Pod for each index. When value is `Indexed`, .spec.completions must be specified and `.spec.parallelism` must be less than or equal to 10^5. In addition, The Pod name takes the form `$(job-name)-$(index)-$(random-string)`, the Pod hostname takes the form `$(job-name)-$(index)`.

More completion modes can be added in the future. If the Job controller observes a mode that it doesn't recognize, which is possible during upgrades due to version skew, the controller skips updates for the Job.

---

##### `completions`<sup>Optional</sup> <a name="completions" id="cdk8s-plus-28.k8s.JobSpec.property.completions"></a>

```python
completions: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Specifies the desired number of successfully finished pods the job should be run with.

Setting to null means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `manual_selector`<sup>Optional</sup> <a name="manual_selector" id="cdk8s-plus-28.k8s.JobSpec.property.manualSelector"></a>

```python
manual_selector: bool
```

- *Type:* bool

manualSelector controls generation of pod labels and pod selectors.

Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector

---

##### `max_failed_indexes`<sup>Optional</sup> <a name="max_failed_indexes" id="cdk8s-plus-28.k8s.JobSpec.property.maxFailedIndexes"></a>

```python
max_failed_indexes: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Specifies the maximal number of failed indexes before marking the Job as failed, when backoffLimitPerIndex is set.

Once the number of failed indexes exceeds this number the entire Job is marked as Failed and its execution is terminated. When left as null the job continues execution of all of its indexes and is marked with the `Complete` Job condition. It can only be specified when backoffLimitPerIndex is set. It can be null or up to completions. It is required and must be less than or equal to 10^4 when is completions greater than 10^5. This field is alpha-level. It can be used when the `JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).

---

##### `parallelism`<sup>Optional</sup> <a name="parallelism" id="cdk8s-plus-28.k8s.JobSpec.property.parallelism"></a>

```python
parallelism: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Specifies the maximum desired number of pods the job should run at any given time.

The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `pod_failure_policy`<sup>Optional</sup> <a name="pod_failure_policy" id="cdk8s-plus-28.k8s.JobSpec.property.podFailurePolicy"></a>

```python
pod_failure_policy: PodFailurePolicy
```

- *Type:* cdk8s_plus_28.k8s.PodFailurePolicy

Specifies the policy of handling failed pods.

In particular, it allows to specify the set of actions and conditions which need to be satisfied to take the associated action. If empty, the default behaviour applies - the counter of failed pods, represented by the jobs's .status.failed field, is incremented and it is checked against the backoffLimit. This field cannot be used in combination with restartPolicy=OnFailure.

This field is beta-level. It can be used when the `JobPodFailurePolicy` feature gate is enabled (enabled by default).

---

##### `pod_replacement_policy`<sup>Optional</sup> <a name="pod_replacement_policy" id="cdk8s-plus-28.k8s.JobSpec.property.podReplacementPolicy"></a>

```python
pod_replacement_policy: str
```

- *Type:* str

podReplacementPolicy specifies when to create replacement Pods.

Possible values are: - TerminatingOrFailed means that we recreate pods
when they are terminating (has a metadata.deletionTimestamp) or failed.

* Failed means to wait until a previously created Pod is fully terminated (has phase
  Failed or Succeeded) before creating a replacement Pod.

When using podFailurePolicy, Failed is the the only allowed value. TerminatingOrFailed and Failed are allowed values when podFailurePolicy is not in use. This is an alpha field. Enable JobPodReplacementPolicy to be able to use this field.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.JobSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

A label query over pods that should match the pod count.

Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.k8s.JobSpec.property.suspend"></a>

```python
suspend: bool
```

- *Type:* bool
- *Default:* false.

suspend specifies whether the Job controller should create Pods or not.

If a Job is created with suspend set to true, no Pods are created by the Job controller. If a Job is suspended after creation (i.e. the flag goes from false to true), the Job controller will delete all active Pods associated with this Job. Users must design their workload to gracefully handle this. Suspending a Job will reset the StartTime field of the Job, effectively resetting the ActiveDeadlineSeconds timer too. Defaults to false.

---

##### `ttl_seconds_after_finished`<sup>Optional</sup> <a name="ttl_seconds_after_finished" id="cdk8s-plus-28.k8s.JobSpec.property.ttlSecondsAfterFinished"></a>

```python
ttl_seconds_after_finished: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

ttlSecondsAfterFinished limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, ttlSecondsAfterFinished after the Job finishes, it is eligible to be automatically deleted. When the Job is being deleted, its lifecycle guarantees (e.g. finalizers) will be honored. If this field is unset, the Job won't be automatically deleted. If this field is set to zero, the Job becomes eligible to be deleted immediately after it finishes.

---

### JobTemplateSpec <a name="JobTemplateSpec" id="cdk8s-plus-28.k8s.JobTemplateSpec"></a>

JobTemplateSpec describes the data a Job should have when created from a template.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JobTemplateSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.JobTemplateSpec(
  metadata: ObjectMeta = None,
  spec: JobSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JobTemplateSpec.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata of the jobs created from this template. |
| <code><a href="#cdk8s-plus-28.k8s.JobTemplateSpec.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.JobSpec</code> | Specification of the desired behavior of the job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.JobTemplateSpec.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata of the jobs created from this template.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.JobTemplateSpec.property.spec"></a>

```python
spec: JobSpec
```

- *Type:* cdk8s_plus_28.k8s.JobSpec

Specification of the desired behavior of the job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### JsonSchemaProps <a name="JsonSchemaProps" id="cdk8s-plus-28.k8s.JsonSchemaProps"></a>

JSONSchemaProps is a JSON-Schema following Specification Draft 4 (http://json-schema.org/).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JsonSchemaProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.JsonSchemaProps(
  additional_items: typing.Any = None,
  additional_properties: typing.Any = None,
  all_of: typing.List[JsonSchemaProps] = None,
  any_of: typing.List[JsonSchemaProps] = None,
  default: typing.Any = None,
  definitions: typing.Mapping[JsonSchemaProps] = None,
  dependencies: typing.Mapping[typing.Any] = None,
  description: str = None,
  enum: typing.List[typing.Any] = None,
  example: typing.Any = None,
  exclusive_maximum: bool = None,
  exclusive_minimum: bool = None,
  external_docs: ExternalDocumentation = None,
  format: str = None,
  id: str = None,
  items: typing.Any = None,
  maximum: typing.Union[int, float] = None,
  max_items: typing.Union[int, float] = None,
  max_length: typing.Union[int, float] = None,
  max_properties: typing.Union[int, float] = None,
  minimum: typing.Union[int, float] = None,
  min_items: typing.Union[int, float] = None,
  min_length: typing.Union[int, float] = None,
  min_properties: typing.Union[int, float] = None,
  multiple_of: typing.Union[int, float] = None,
  not: JsonSchemaProps = None,
  nullable: bool = None,
  one_of: typing.List[JsonSchemaProps] = None,
  pattern: str = None,
  pattern_properties: typing.Mapping[JsonSchemaProps] = None,
  properties: typing.Mapping[JsonSchemaProps] = None,
  ref: str = None,
  required: typing.List[str] = None,
  schema: str = None,
  title: str = None,
  type: str = None,
  unique_items: bool = None,
  x_kubernetes_embedded_resource: bool = None,
  x_kubernetes_int_or_string: bool = None,
  x_kubernetes_list_map_keys: typing.List[str] = None,
  x_kubernetes_list_type: str = None,
  x_kubernetes_map_type: str = None,
  x_kubernetes_preserve_unknown_fields: bool = None,
  x_kubernetes_validations: typing.List[ValidationRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalItems">additional_items</a></code> | <code>typing.Any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalProperties">additional_properties</a></code> | <code>typing.Any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.allOf">all_of</a></code> | <code>typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.anyOf">any_of</a></code> | <code>typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.default">default</a></code> | <code>typing.Any</code> | default is a default value for undefined object fields. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.definitions">definitions</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.dependencies">dependencies</a></code> | <code>typing.Mapping[typing.Any]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.description">description</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.enum">enum</a></code> | <code>typing.List[typing.Any]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.example">example</a></code> | <code>typing.Any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMaximum">exclusive_maximum</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMinimum">exclusive_minimum</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.externalDocs">external_docs</a></code> | <code>cdk8s_plus_28.k8s.ExternalDocumentation</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.format">format</a></code> | <code>str</code> | format is an OpenAPI v3 format string. Unknown formats are ignored. The following formats are validated:. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.id">id</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.items">items</a></code> | <code>typing.Any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maximum">maximum</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxItems">max_items</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxLength">max_length</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxProperties">max_properties</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minimum">minimum</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minItems">min_items</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minLength">min_length</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minProperties">min_properties</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.multipleOf">multiple_of</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.not">not</a></code> | <code>cdk8s_plus_28.k8s.JsonSchemaProps</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.nullable">nullable</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.oneOf">one_of</a></code> | <code>typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.pattern">pattern</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.patternProperties">pattern_properties</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.properties">properties</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.ref">ref</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.required">required</a></code> | <code>typing.List[str]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.schema">schema</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.title">title</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.type">type</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.uniqueItems">unique_items</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesEmbeddedResource">x_kubernetes_embedded_resource</a></code> | <code>bool</code> | x-kubernetes-embedded-resource defines that the value is an embedded Kubernetes runtime.Object, with TypeMeta and ObjectMeta. The type must be object. It is allowed to further restrict the embedded object. kind, apiVersion and metadata are validated automatically. x-kubernetes-preserve-unknown-fields is allowed to be true, but does not have to be if the object is fully specified (up to kind, apiVersion, metadata). |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesIntOrString">x_kubernetes_int_or_string</a></code> | <code>bool</code> | x-kubernetes-int-or-string specifies that this value is either an integer or a string. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListMapKeys">x_kubernetes_list_map_keys</a></code> | <code>typing.List[str]</code> | x-kubernetes-list-map-keys annotates an array with the x-kubernetes-list-type `map` by specifying the keys used as the index of the map. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListType">x_kubernetes_list_type</a></code> | <code>str</code> | x-kubernetes-list-type annotates an array to further describe its topology. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesMapType">x_kubernetes_map_type</a></code> | <code>str</code> | x-kubernetes-map-type annotates an object to further describe its topology. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesPreserveUnknownFields">x_kubernetes_preserve_unknown_fields</a></code> | <code>bool</code> | x-kubernetes-preserve-unknown-fields stops the API server decoding step from pruning fields which are not specified in the validation schema. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesValidations">x_kubernetes_validations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ValidationRule]</code> | x-kubernetes-validations describes a list of validation rules written in the CEL expression language. |

---

##### `additional_items`<sup>Optional</sup> <a name="additional_items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalItems"></a>

```python
additional_items: typing.Any
```

- *Type:* typing.Any

---

##### `additional_properties`<sup>Optional</sup> <a name="additional_properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalProperties"></a>

```python
additional_properties: typing.Any
```

- *Type:* typing.Any

---

##### `all_of`<sup>Optional</sup> <a name="all_of" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.allOf"></a>

```python
all_of: typing.List[JsonSchemaProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `any_of`<sup>Optional</sup> <a name="any_of" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.anyOf"></a>

```python
any_of: typing.List[JsonSchemaProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.default"></a>

```python
default: typing.Any
```

- *Type:* typing.Any

default is a default value for undefined object fields.

Defaulting is a beta feature under the CustomResourceDefaulting feature gate. Defaulting requires spec.preserveUnknownFields to be false.

---

##### `definitions`<sup>Optional</sup> <a name="definitions" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.definitions"></a>

```python
definitions: typing.Mapping[JsonSchemaProps]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `dependencies`<sup>Optional</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.dependencies"></a>

```python
dependencies: typing.Mapping[typing.Any]
```

- *Type:* typing.Mapping[typing.Any]

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.description"></a>

```python
description: str
```

- *Type:* str

---

##### `enum`<sup>Optional</sup> <a name="enum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.enum"></a>

```python
enum: typing.List[typing.Any]
```

- *Type:* typing.List[typing.Any]

---

##### `example`<sup>Optional</sup> <a name="example" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.example"></a>

```python
example: typing.Any
```

- *Type:* typing.Any

---

##### `exclusive_maximum`<sup>Optional</sup> <a name="exclusive_maximum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMaximum"></a>

```python
exclusive_maximum: bool
```

- *Type:* bool

---

##### `exclusive_minimum`<sup>Optional</sup> <a name="exclusive_minimum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMinimum"></a>

```python
exclusive_minimum: bool
```

- *Type:* bool

---

##### `external_docs`<sup>Optional</sup> <a name="external_docs" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.externalDocs"></a>

```python
external_docs: ExternalDocumentation
```

- *Type:* cdk8s_plus_28.k8s.ExternalDocumentation

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.format"></a>

```python
format: str
```

- *Type:* str

format is an OpenAPI v3 format string. Unknown formats are ignored. The following formats are validated:.

* bsonobjectid: a bson object ID, i.e. a 24 characters hex string - uri: an URI as parsed by Golang net/url.ParseRequestURI - email: an email address as parsed by Golang net/mail.ParseAddress - hostname: a valid representation for an Internet host name, as defined by RFC 1034, section 3.1 [RFC1034]. - ipv4: an IPv4 IP as parsed by Golang net.ParseIP - ipv6: an IPv6 IP as parsed by Golang net.ParseIP - cidr: a CIDR as parsed by Golang net.ParseCIDR - mac: a MAC address as parsed by Golang net.ParseMAC - uuid: an UUID that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid3: an UUID3 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?3[0-9a-f]{3}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid4: an UUID4 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?4[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - uuid5: an UUID5 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?5[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - isbn: an ISBN10 or ISBN13 number string like "0321751043" or "978-0321751041" - isbn10: an ISBN10 number string like "0321751043" - isbn13: an ISBN13 number string like "978-0321751041" - creditcard: a credit card number defined by the regex ^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$ with any non digit characters mixed in - ssn: a U.S. social security number following the regex ^\d{3}[- ]?\d{2}[- ]?\d{4}$ - hexcolor: an hexadecimal color code like "#FFFFFF: following the regex ^#?([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$ - rgbcolor: an RGB color code like rgb like "rgb(255,255,2559" - byte: base64 encoded binary data - password: any kind of string - date: a date string like "2006-01-02" as defined by full-date in RFC3339 - duration: a duration string like "22 ns" as parsed by Golang time.ParseDuration or compatible with Scala duration format - datetime: a date time string like "2014-12-15T19:30:20.000Z" as defined by date-time in RFC3339.

---

##### `id`<sup>Optional</sup> <a name="id" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.id"></a>

```python
id: str
```

- *Type:* str

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.items"></a>

```python
items: typing.Any
```

- *Type:* typing.Any

---

##### `maximum`<sup>Optional</sup> <a name="maximum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maximum"></a>

```python
maximum: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `max_items`<sup>Optional</sup> <a name="max_items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxItems"></a>

```python
max_items: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `max_length`<sup>Optional</sup> <a name="max_length" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxLength"></a>

```python
max_length: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `max_properties`<sup>Optional</sup> <a name="max_properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxProperties"></a>

```python
max_properties: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `minimum`<sup>Optional</sup> <a name="minimum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minimum"></a>

```python
minimum: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `min_items`<sup>Optional</sup> <a name="min_items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minItems"></a>

```python
min_items: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `min_length`<sup>Optional</sup> <a name="min_length" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minLength"></a>

```python
min_length: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `min_properties`<sup>Optional</sup> <a name="min_properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minProperties"></a>

```python
min_properties: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `multiple_of`<sup>Optional</sup> <a name="multiple_of" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.multipleOf"></a>

```python
multiple_of: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `not`<sup>Optional</sup> <a name="not" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.not"></a>

```python
not: JsonSchemaProps
```

- *Type:* cdk8s_plus_28.k8s.JsonSchemaProps

---

##### `nullable`<sup>Optional</sup> <a name="nullable" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.nullable"></a>

```python
nullable: bool
```

- *Type:* bool

---

##### `one_of`<sup>Optional</sup> <a name="one_of" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.oneOf"></a>

```python
one_of: typing.List[JsonSchemaProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `pattern`<sup>Optional</sup> <a name="pattern" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.pattern"></a>

```python
pattern: str
```

- *Type:* str

---

##### `pattern_properties`<sup>Optional</sup> <a name="pattern_properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.patternProperties"></a>

```python
pattern_properties: typing.Mapping[JsonSchemaProps]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `properties`<sup>Optional</sup> <a name="properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.properties"></a>

```python
properties: typing.Mapping[JsonSchemaProps]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.JsonSchemaProps]

---

##### `ref`<sup>Optional</sup> <a name="ref" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.ref"></a>

```python
ref: str
```

- *Type:* str

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.required"></a>

```python
required: typing.List[str]
```

- *Type:* typing.List[str]

---

##### `schema`<sup>Optional</sup> <a name="schema" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.schema"></a>

```python
schema: str
```

- *Type:* str

---

##### `title`<sup>Optional</sup> <a name="title" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.title"></a>

```python
title: str
```

- *Type:* str

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.type"></a>

```python
type: str
```

- *Type:* str

---

##### `unique_items`<sup>Optional</sup> <a name="unique_items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.uniqueItems"></a>

```python
unique_items: bool
```

- *Type:* bool

---

##### `x_kubernetes_embedded_resource`<sup>Optional</sup> <a name="x_kubernetes_embedded_resource" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesEmbeddedResource"></a>

```python
x_kubernetes_embedded_resource: bool
```

- *Type:* bool

x-kubernetes-embedded-resource defines that the value is an embedded Kubernetes runtime.Object, with TypeMeta and ObjectMeta. The type must be object. It is allowed to further restrict the embedded object. kind, apiVersion and metadata are validated automatically. x-kubernetes-preserve-unknown-fields is allowed to be true, but does not have to be if the object is fully specified (up to kind, apiVersion, metadata).

---

##### `x_kubernetes_int_or_string`<sup>Optional</sup> <a name="x_kubernetes_int_or_string" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesIntOrString"></a>

```python
x_kubernetes_int_or_string: bool
```

- *Type:* bool

x-kubernetes-int-or-string specifies that this value is either an integer or a string.

If this is true, an empty type is allowed and type as child of anyOf is permitted if following one of the following patterns:

1) anyOf:

* type: integer
* type: string

1) allOf:

* anyOf:
* type: integer
* type: string
* ... zero or more

---

##### `x_kubernetes_list_map_keys`<sup>Optional</sup> <a name="x_kubernetes_list_map_keys" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListMapKeys"></a>

```python
x_kubernetes_list_map_keys: typing.List[str]
```

- *Type:* typing.List[str]

x-kubernetes-list-map-keys annotates an array with the x-kubernetes-list-type `map` by specifying the keys used as the index of the map.

This tag MUST only be used on lists that have the "x-kubernetes-list-type" extension set to "map". Also, the values specified for this attribute must be a scalar typed field of the child structure (no nesting is supported).

The properties specified must either be required or have a default value, to ensure those properties are present for all list items.

---

##### `x_kubernetes_list_type`<sup>Optional</sup> <a name="x_kubernetes_list_type" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListType"></a>

```python
x_kubernetes_list_type: str
```

- *Type:* str
- *Default:* atomic for arrays.

x-kubernetes-list-type annotates an array to further describe its topology.

This extension must only be used on lists and may have 3 possible values:

1) `atomic`: the list is treated as a single entity, like a scalar.
   Atomic lists will be entirely replaced when updated. This extension
   may be used on any type of list (struct, scalar, ...).
2) `set`:
   Sets are lists that must not have multiple items with the same value. Each
   value must be a scalar, an object with x-kubernetes-map-type `atomic` or an
   array with x-kubernetes-list-type `atomic`.
3) `map`:
   These lists are like maps in that their elements have a non-index key
   used to identify them. Order is preserved upon merge. The map tag
   must only be used on a list with elements of type object.
   Defaults to atomic for arrays.

---

##### `x_kubernetes_map_type`<sup>Optional</sup> <a name="x_kubernetes_map_type" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesMapType"></a>

```python
x_kubernetes_map_type: str
```

- *Type:* str

x-kubernetes-map-type annotates an object to further describe its topology.

This extension must only be used when type is object and may have 2 possible values:

1) `granular`:
   These maps are actual maps (key-value pairs) and each fields are independent
   from each other (they can each be manipulated by separate actors). This is
   the default behaviour for all maps.
2) `atomic`: the list is treated as a single entity, like a scalar.
   Atomic maps will be entirely replaced when updated.

---

##### `x_kubernetes_preserve_unknown_fields`<sup>Optional</sup> <a name="x_kubernetes_preserve_unknown_fields" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesPreserveUnknownFields"></a>

```python
x_kubernetes_preserve_unknown_fields: bool
```

- *Type:* bool

x-kubernetes-preserve-unknown-fields stops the API server decoding step from pruning fields which are not specified in the validation schema.

This affects fields recursively, but switches back to normal pruning behaviour if nested properties or additionalProperties are specified in the schema. This can either be true or undefined. False is forbidden.

---

##### `x_kubernetes_validations`<sup>Optional</sup> <a name="x_kubernetes_validations" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesValidations"></a>

```python
x_kubernetes_validations: typing.List[ValidationRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidationRule]

x-kubernetes-validations describes a list of validation rules written in the CEL expression language.

This field is an alpha-level. Using this field requires the feature gate `CustomResourceValidationExpressions` to be enabled.

---

### KeyToPath <a name="KeyToPath" id="cdk8s-plus-28.k8s.KeyToPath"></a>

Maps a string key to a path within a volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KeyToPath.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KeyToPath(
  key: str,
  path: str,
  mode: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.key">key</a></code> | <code>str</code> | key is the key to project. |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.path">path</a></code> | <code>str</code> | path is the relative path of the file to map the key to. |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.mode">mode</a></code> | <code>typing.Union[int, float]</code> | mode is Optional: mode bits used to set permissions on this file. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.KeyToPath.property.key"></a>

```python
key: str
```

- *Type:* str

key is the key to project.

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.KeyToPath.property.path"></a>

```python
path: str
```

- *Type:* str

path is the relative path of the file to map the key to.

May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.k8s.KeyToPath.property.mode"></a>

```python
mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

mode is Optional: mode bits used to set permissions on this file.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

### KubeApiServiceListProps <a name="KubeApiServiceListProps" id="cdk8s-plus-28.k8s.KubeApiServiceListProps"></a>

APIServiceList is a list of APIService objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceListProps(
  items: typing.List[KubeApiServiceProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeApiServiceProps]</code> | Items is the list of APIService. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.property.items"></a>

```python
items: typing.List[KubeApiServiceProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeApiServiceProps]

Items is the list of APIService.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeApiServiceProps <a name="KubeApiServiceProps" id="cdk8s-plus-28.k8s.KubeApiServiceProps"></a>

APIService represents a server for a particular GroupVersion.

Name must be "version.group".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeApiServiceProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeApiServiceProps(
  metadata: ObjectMeta = None,
  spec: ApiServiceSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ApiServiceSpec</code> | Spec contains information for locating and communicating with a server. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeApiServiceProps.property.spec"></a>

```python
spec: ApiServiceSpec
```

- *Type:* cdk8s_plus_28.k8s.ApiServiceSpec

Spec contains information for locating and communicating with a server.

---

### KubeBindingProps <a name="KubeBindingProps" id="cdk8s-plus-28.k8s.KubeBindingProps"></a>

Binding ties one object to another;

for example, a pod is bound to a node by a scheduler. Deprecated in 1.7, please use the bindings subresource of pods instead.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeBindingProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeBindingProps(
  target: ObjectReference,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBindingProps.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | The target object that you want to bind to the standard object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBindingProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.KubeBindingProps.property.target"></a>

```python
target: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

The target object that you want to bind to the standard object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBindingProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCertificateSigningRequestListProps <a name="KubeCertificateSigningRequestListProps" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps"></a>

CertificateSigningRequestList is a collection of CertificateSigningRequest objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestListProps(
  items: typing.List[KubeCertificateSigningRequestProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCertificateSigningRequestProps]</code> | items is a collection of CertificateSigningRequest objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | *No description.* |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.items"></a>

```python
items: typing.List[KubeCertificateSigningRequestProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCertificateSigningRequestProps]

items is a collection of CertificateSigningRequest objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

---

### KubeCertificateSigningRequestProps <a name="KubeCertificateSigningRequestProps" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps"></a>

CertificateSigningRequest objects provide a mechanism to obtain x509 certificates by submitting a certificate signing request, and having it asynchronously approved and issued.

Kubelets use this API to obtain:

1. client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client-kubelet" signerName).
2. serving certificates for TLS endpoints kube-apiserver can connect to securely (with the "kubernetes.io/kubelet-serving" signerName).

This API can be used to request client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client" signerName), or to obtain certificates from custom non-Kubernetes signers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCertificateSigningRequestProps(
  spec: CertificateSigningRequestSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CertificateSigningRequestSpec</code> | spec contains the certificate request, and is immutable after creation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | *No description.* |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.spec"></a>

```python
spec: CertificateSigningRequestSpec
```

- *Type:* cdk8s_plus_28.k8s.CertificateSigningRequestSpec

spec contains the certificate request, and is immutable after creation.

Only the request, signerName, expirationSeconds, and usages fields can be set on creation. Other fields are derived by Kubernetes and cannot be modified by users.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

---

### KubeClusterCidrListV1Alpha1Props <a name="KubeClusterCidrListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props"></a>

ClusterCIDRList contains a list of ClusterCIDR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrListV1Alpha1Props(
  items: typing.List[KubeClusterCidrv1Alpha1Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterCidrv1Alpha1Props]</code> | items is the list of ClusterCIDRs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeClusterCidrv1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterCidrv1Alpha1Props]

items is the list of ClusterCIDRs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeClusterCidrv1Alpha1Props <a name="KubeClusterCidrv1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props"></a>

ClusterCIDR represents a single configuration for per-Node Pod CIDR allocations when the MultiCIDRRangeAllocator is enabled (see the config for kube-controller-manager).

A cluster may have any number of ClusterCIDR resources, all of which will be considered when allocating a CIDR for a Node.  A ClusterCIDR is eligible to be used for a given Node when the node selector matches the node in question and has free CIDRs to allocate.  In case of multiple matching ClusterCIDR resources, the allocator will attempt to break ties using internal heuristics, but any ClusterCIDR whose node selector matches the Node may be used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterCidrv1Alpha1Props(
  metadata: ObjectMeta = None,
  spec: ClusterCidrSpecV1Alpha1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ClusterCidrSpecV1Alpha1</code> | spec is the desired state of the ClusterCIDR. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.spec"></a>

```python
spec: ClusterCidrSpecV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ClusterCidrSpecV1Alpha1

spec is the desired state of the ClusterCIDR.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeClusterRoleBindingListProps <a name="KubeClusterRoleBindingListProps" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps"></a>

ClusterRoleBindingList is a collection of ClusterRoleBindings.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingListProps(
  items: typing.List[KubeClusterRoleBindingProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterRoleBindingProps]</code> | Items is a list of ClusterRoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.items"></a>

```python
items: typing.List[KubeClusterRoleBindingProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleBindingProps]

Items is a list of ClusterRoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

### KubeClusterRoleBindingProps <a name="KubeClusterRoleBindingProps" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps"></a>

ClusterRoleBinding references a ClusterRole, but not contain it.

It can reference a ClusterRole in the global namespace, and adds who information via Subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleBindingProps(
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.roleRef">role_ref</a></code> | <code>cdk8s_plus_28.k8s.RoleRef</code> | RoleRef can only reference a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Subject]</code> | Subjects holds references to the objects the role applies to. |

---

##### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.roleRef"></a>

```python
role_ref: RoleRef
```

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can only reference a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.subjects"></a>

```python
subjects: typing.List[Subject]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

### KubeClusterRoleListProps <a name="KubeClusterRoleListProps" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps"></a>

ClusterRoleList is a collection of ClusterRoles.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleListProps(
  items: typing.List[KubeClusterRoleProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterRoleProps]</code> | Items is a list of ClusterRoles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.items"></a>

```python
items: typing.List[KubeClusterRoleProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterRoleProps]

Items is a list of ClusterRoles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

### KubeClusterRoleProps <a name="KubeClusterRoleProps" id="cdk8s-plus-28.k8s.KubeClusterRoleProps"></a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterRoleProps(
  aggregation_rule: AggregationRule = None,
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.aggregationRule">aggregation_rule</a></code> | <code>cdk8s_plus_28.k8s.AggregationRule</code> | AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRule]</code> | Rules holds all the PolicyRules for this ClusterRole. |

---

##### `aggregation_rule`<sup>Optional</sup> <a name="aggregation_rule" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.aggregationRule"></a>

```python
aggregation_rule: AggregationRule
```

- *Type:* cdk8s_plus_28.k8s.AggregationRule

AggregationRule is an optional field that describes how to build the Rules for this ClusterRole.

If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.rules"></a>

```python
rules: typing.List[PolicyRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this ClusterRole.

---

### KubeClusterTrustBundleListV1Alpha1Props <a name="KubeClusterTrustBundleListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props"></a>

ClusterTrustBundleList is a collection of ClusterTrustBundle objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleListV1Alpha1Props(
  items: typing.List[KubeClusterTrustBundleV1Alpha1Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeClusterTrustBundleV1Alpha1Props]</code> | items is a collection of ClusterTrustBundle objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | metadata contains the list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeClusterTrustBundleV1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeClusterTrustBundleV1Alpha1Props]

items is a collection of ClusterTrustBundle objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata contains the list metadata.

---

### KubeClusterTrustBundleV1Alpha1Props <a name="KubeClusterTrustBundleV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props"></a>

ClusterTrustBundle is a cluster-scoped container for X.509 trust anchors (root certificates).

ClusterTrustBundle objects are considered to be readable by any authenticated user in the cluster, because they can be mounted by pods using the `clusterTrustBundle` projection.  All service accounts have read access to ClusterTrustBundles by default.  Users who only have namespace-level access to a cluster can read ClusterTrustBundles by impersonating a serviceaccount that they have access to.

It can be optionally associated with a particular assigner, in which case it contains one valid set of trust anchors for that signer. Signers may have multiple associated ClusterTrustBundles; each is an independent set of trust anchors for that signer. Admission control is used to enforce that only users with permissions on the signer can create or modify the corresponding bundle.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeClusterTrustBundleV1Alpha1Props(
  spec: ClusterTrustBundleSpecV1Alpha1,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ClusterTrustBundleSpecV1Alpha1</code> | spec contains the signer (if any) and trust anchors. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | metadata contains the object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.spec"></a>

```python
spec: ClusterTrustBundleSpecV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ClusterTrustBundleSpecV1Alpha1

spec contains the signer (if any) and trust anchors.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata contains the object metadata.

---

### KubeComponentStatusListProps <a name="KubeComponentStatusListProps" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps"></a>

Status of all the conditions for the component as a list of ComponentStatus objects.

Deprecated: This API is deprecated in v1.19+

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusListProps(
  items: typing.List[KubeComponentStatusProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeComponentStatusProps]</code> | List of ComponentStatus objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.items"></a>

```python
items: typing.List[KubeComponentStatusProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeComponentStatusProps]

List of ComponentStatus objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeComponentStatusProps <a name="KubeComponentStatusProps" id="cdk8s-plus-28.k8s.KubeComponentStatusProps"></a>

ComponentStatus (and ComponentStatusList) holds the cluster validation info.

Deprecated: This API is deprecated in v1.19+

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeComponentStatusProps(
  conditions: typing.List[ComponentCondition] = None,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusProps.property.conditions">conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ComponentCondition]</code> | List of component conditions observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.property.conditions"></a>

```python
conditions: typing.List[ComponentCondition]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ComponentCondition]

List of component conditions observed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeConfigMapListProps <a name="KubeConfigMapListProps" id="cdk8s-plus-28.k8s.KubeConfigMapListProps"></a>

ConfigMapList is a resource containing a list of ConfigMap objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapListProps(
  items: typing.List[KubeConfigMapProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeConfigMapProps]</code> | Items is the list of ConfigMaps. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.property.items"></a>

```python
items: typing.List[KubeConfigMapProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeConfigMapProps]

Items is the list of ConfigMaps.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeConfigMapProps <a name="KubeConfigMapProps" id="cdk8s-plus-28.k8s.KubeConfigMapProps"></a>

ConfigMap holds configuration data for pods to consume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeConfigMapProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeConfigMapProps(
  binary_data: typing.Mapping[str] = None,
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.binaryData">binary_data</a></code> | <code>typing.Mapping[str]</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.immutable">immutable</a></code> | <code>bool</code> | Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `binary_data`<sup>Optional</sup> <a name="binary_data" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.binaryData"></a>

```python
binary_data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.data"></a>

```python
data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeControllerRevisionListProps <a name="KubeControllerRevisionListProps" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps"></a>

ControllerRevisionList is a resource containing a list of ControllerRevision objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionListProps(
  items: typing.List[KubeControllerRevisionProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeControllerRevisionProps]</code> | Items is the list of ControllerRevisions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.items"></a>

```python
items: typing.List[KubeControllerRevisionProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeControllerRevisionProps]

Items is the list of ControllerRevisions.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeControllerRevisionProps <a name="KubeControllerRevisionProps" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps"></a>

ControllerRevision implements an immutable snapshot of state data.

Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeControllerRevisionProps(
  revision: typing.Union[int, float],
  data: typing.Any = None,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.revision">revision</a></code> | <code>typing.Union[int, float]</code> | Revision indicates the revision of the state represented by Data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.data">data</a></code> | <code>typing.Any</code> | Data is the serialized representation of the state. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `revision`<sup>Required</sup> <a name="revision" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.revision"></a>

```python
revision: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Revision indicates the revision of the state represented by Data.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.data"></a>

```python
data: typing.Any
```

- *Type:* typing.Any

Data is the serialized representation of the state.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCronJobListProps <a name="KubeCronJobListProps" id="cdk8s-plus-28.k8s.KubeCronJobListProps"></a>

CronJobList is a collection of cron jobs.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCronJobListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobListProps(
  items: typing.List[KubeCronJobProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCronJobProps]</code> | items is the list of CronJobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCronJobListProps.property.items"></a>

```python
items: typing.List[KubeCronJobProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCronJobProps]

items is the list of CronJobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCronJobProps <a name="KubeCronJobProps" id="cdk8s-plus-28.k8s.KubeCronJobProps"></a>

CronJob represents the configuration of a single cron job.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCronJobProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCronJobProps(
  metadata: ObjectMeta = None,
  spec: CronJobSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CronJobSpec</code> | Specification of the desired behavior of a cron job, including the schedule. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCronJobProps.property.spec"></a>

```python
spec: CronJobSpec
```

- *Type:* cdk8s_plus_28.k8s.CronJobSpec

Specification of the desired behavior of a cron job, including the schedule.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeCsiDriverListProps <a name="KubeCsiDriverListProps" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps"></a>

CSIDriverList is a collection of CSIDriver objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverListProps(
  items: typing.List[KubeCsiDriverProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiDriverProps]</code> | items is the list of CSIDriver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.items"></a>

```python
items: typing.List[KubeCsiDriverProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiDriverProps]

items is the list of CSIDriver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiDriverProps <a name="KubeCsiDriverProps" id="cdk8s-plus-28.k8s.KubeCsiDriverProps"></a>

CSIDriver captures information about a Container Storage Interface (CSI) volume driver deployed on the cluster.

Kubernetes attach detach controller uses this object to determine whether attach is required. Kubelet uses this object to determine whether pod information needs to be passed on mount. CSIDriver objects are non-namespaced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiDriverProps(
  spec: CsiDriverSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CsiDriverSpec</code> | spec represents the specification of the CSI Driver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.property.spec"></a>

```python
spec: CsiDriverSpec
```

- *Type:* cdk8s_plus_28.k8s.CsiDriverSpec

spec represents the specification of the CSI Driver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

metadata.Name indicates the name of the CSI driver that this object refers to; it MUST be the same name returned by the CSI GetPluginName() call for that driver. The driver name must be 63 characters or less, beginning and ending with an alphanumeric character ([a-z0-9A-Z]) with dashes (-), dots (.), and alphanumerics between. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCsiNodeListProps <a name="KubeCsiNodeListProps" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps"></a>

CSINodeList is a collection of CSINode objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeListProps(
  items: typing.List[KubeCsiNodeProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiNodeProps]</code> | items is the list of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.items"></a>

```python
items: typing.List[KubeCsiNodeProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiNodeProps]

items is the list of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiNodeProps <a name="KubeCsiNodeProps" id="cdk8s-plus-28.k8s.KubeCsiNodeProps"></a>

CSINode holds information about all CSI drivers installed on a node.

CSI drivers do not need to create the CSINode object directly. As long as they use the node-driver-registrar sidecar container, the kubelet will automatically populate the CSINode object for the CSI driver as part of kubelet plugin registration. CSINode has the same name as a node. If the object is missing, it means either there are no CSI Drivers available on the node, or the Kubelet version is low enough that it doesn't create this object. CSINode has an OwnerReference that points to the corresponding node object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiNodeProps(
  spec: CsiNodeSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CsiNodeSpec</code> | spec is the specification of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.property.spec"></a>

```python
spec: CsiNodeSpec
```

- *Type:* cdk8s_plus_28.k8s.CsiNodeSpec

spec is the specification of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

metadata.name must be the Kubernetes node name.

---

### KubeCsiStorageCapacityListProps <a name="KubeCsiStorageCapacityListProps" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps"></a>

CSIStorageCapacityList is a collection of CSIStorageCapacity objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityListProps(
  items: typing.List[KubeCsiStorageCapacityProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCsiStorageCapacityProps]</code> | items is the list of CSIStorageCapacity objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.items"></a>

```python
items: typing.List[KubeCsiStorageCapacityProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCsiStorageCapacityProps]

items is the list of CSIStorageCapacity objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiStorageCapacityProps <a name="KubeCsiStorageCapacityProps" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps"></a>

CSIStorageCapacity stores the result of one CSI GetCapacity call.

For a given StorageClass, this describes the available capacity in a particular topology segment.  This can be used when considering where to instantiate new PersistentVolumes.

For example this can express things like: - StorageClass "standard" has "1234 GiB" available in "topology.kubernetes.io/zone=us-east1" - StorageClass "localssd" has "10 GiB" available in "kubernetes.io/hostname=knode-abc123"

The following three cases all imply that no capacity is available for a certain combination: - no object exists with suitable topology and storage class name - such an object exists, but the capacity is unset - such an object exists, but the capacity is zero

The producer of these objects can decide which approach is more suitable.

They are consumed by the kube-scheduler when a CSI driver opts into capacity-aware scheduling with CSIDriverSpec.StorageCapacity. The scheduler compares the MaximumVolumeSize against the requested size of pending volumes to filter out unsuitable nodes. If MaximumVolumeSize is unset, it falls back to a comparison against the less precise Capacity. If that is also unset, the scheduler assumes that capacity is insufficient and tries some other node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCsiStorageCapacityProps(
  storage_class_name: str,
  capacity: Quantity = None,
  maximum_volume_size: Quantity = None,
  metadata: ObjectMeta = None,
  node_topology: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | storageClassName represents the name of the StorageClass that the reported capacity applies to. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.capacity">capacity</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.maximumVolumeSize">maximum_volume_size</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.nodeTopology">node_topology</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | nodeTopology defines which nodes have access to the storage for which capacity was reported. |

---

##### `storage_class_name`<sup>Required</sup> <a name="storage_class_name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

storageClassName represents the name of the StorageClass that the reported capacity applies to.

It must meet the same requirements as the name of a StorageClass object (non-empty, DNS subdomain). If that object no longer exists, the CSIStorageCapacity object is obsolete and should be removed by its creator. This field is immutable.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.capacity"></a>

```python
capacity: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

The semantic is currently (CSI spec 1.2) defined as: The available capacity, in bytes, of the storage that can be used to provision volumes. If not set, that information is currently unavailable.

---

##### `maximum_volume_size`<sup>Optional</sup> <a name="maximum_volume_size" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.maximumVolumeSize"></a>

```python
maximum_volume_size: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

This is defined since CSI spec 1.4.0 as the largest size that may be used in a CreateVolumeRequest.capacity_range.required_bytes field to create a volume with the same parameters as those in GetCapacityRequest. The corresponding value in the Kubernetes API is ResourceRequirements.Requests in a volume claim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

The name has no particular meaning. It must be a DNS subdomain (dots allowed, 253 characters). To ensure that there are no conflicts with other CSI drivers on the cluster, the recommendation is to use csisc-<uuid>, a generated name, or a reverse-domain name which ends with the unique CSI driver name.

Objects are namespaced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `node_topology`<sup>Optional</sup> <a name="node_topology" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.nodeTopology"></a>

```python
node_topology: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

nodeTopology defines which nodes have access to the storage for which capacity was reported.

If not set, the storage is not accessible from any node in the cluster. If empty, the storage is accessible from all nodes. This field is immutable.

---

### KubeCustomResourceDefinitionListProps <a name="KubeCustomResourceDefinitionListProps" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps"></a>

CustomResourceDefinitionList is a list of CustomResourceDefinition objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionListProps(
  items: typing.List[KubeCustomResourceDefinitionProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeCustomResourceDefinitionProps]</code> | items list individual CustomResourceDefinition objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.items"></a>

```python
items: typing.List[KubeCustomResourceDefinitionProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeCustomResourceDefinitionProps]

items list individual CustomResourceDefinition objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCustomResourceDefinitionProps <a name="KubeCustomResourceDefinitionProps" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps"></a>

CustomResourceDefinition represents a resource that should be exposed on the API server.

Its name MUST be in the format <.spec.name>.<.spec.group>.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeCustomResourceDefinitionProps(
  spec: CustomResourceDefinitionSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.CustomResourceDefinitionSpec</code> | spec describes how the user wants the resources to appear. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.spec"></a>

```python
spec: CustomResourceDefinitionSpec
```

- *Type:* cdk8s_plus_28.k8s.CustomResourceDefinitionSpec

spec describes how the user wants the resources to appear.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeDaemonSetListProps <a name="KubeDaemonSetListProps" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps"></a>

DaemonSetList is a collection of daemon sets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetListProps(
  items: typing.List[KubeDaemonSetProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeDaemonSetProps]</code> | A list of daemon sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.items"></a>

```python
items: typing.List[KubeDaemonSetProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDaemonSetProps]

A list of daemon sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeDaemonSetProps <a name="KubeDaemonSetProps" id="cdk8s-plus-28.k8s.KubeDaemonSetProps"></a>

DaemonSet represents the configuration of a daemon set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDaemonSetProps(
  metadata: ObjectMeta = None,
  spec: DaemonSetSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.DaemonSetSpec</code> | The desired behavior of this daemon set. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.property.spec"></a>

```python
spec: DaemonSetSpec
```

- *Type:* cdk8s_plus_28.k8s.DaemonSetSpec

The desired behavior of this daemon set.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeDeploymentListProps <a name="KubeDeploymentListProps" id="cdk8s-plus-28.k8s.KubeDeploymentListProps"></a>

DeploymentList is a list of Deployments.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentListProps(
  items: typing.List[KubeDeploymentProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeDeploymentProps]</code> | Items is the list of Deployments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.property.items"></a>

```python
items: typing.List[KubeDeploymentProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeDeploymentProps]

Items is the list of Deployments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeDeploymentProps <a name="KubeDeploymentProps" id="cdk8s-plus-28.k8s.KubeDeploymentProps"></a>

Deployment enables declarative updates for Pods and ReplicaSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDeploymentProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeDeploymentProps(
  metadata: ObjectMeta = None,
  spec: DeploymentSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.DeploymentSpec</code> | Specification of the desired behavior of the Deployment. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDeploymentProps.property.spec"></a>

```python
spec: DeploymentSpec
```

- *Type:* cdk8s_plus_28.k8s.DeploymentSpec

Specification of the desired behavior of the Deployment.

---

### KubeEndpointSliceListProps <a name="KubeEndpointSliceListProps" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps"></a>

EndpointSliceList represents a list of endpoint slices.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceListProps(
  items: typing.List[KubeEndpointSliceProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEndpointSliceProps]</code> | items is the list of endpoint slices. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.items"></a>

```python
items: typing.List[KubeEndpointSliceProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointSliceProps]

items is the list of endpoint slices.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeEndpointSliceProps <a name="KubeEndpointSliceProps" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps"></a>

EndpointSlice represents a subset of the endpoints that implement a service.

For a given service there may be multiple EndpointSlice objects, selected by labels, which must be joined to produce the full set of endpoints.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointSliceProps(
  address_type: str,
  endpoints: typing.List[Endpoint],
  metadata: ObjectMeta = None,
  ports: typing.List[EndpointPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.addressType">address_type</a></code> | <code>str</code> | addressType specifies the type of address carried by this EndpointSlice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.endpoints">endpoints</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Endpoint]</code> | endpoints is a list of unique endpoints in this slice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointPort]</code> | ports specifies the list of network ports exposed by each endpoint in this slice. |

---

##### `address_type`<sup>Required</sup> <a name="address_type" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.addressType"></a>

```python
address_type: str
```

- *Type:* str

addressType specifies the type of address carried by this EndpointSlice.

All addresses in this slice must be the same type. This field is immutable after creation. The following address types are currently supported: * IPv4: Represents an IPv4 Address. * IPv6: Represents an IPv6 Address. * FQDN: Represents a Fully Qualified Domain Name.

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.endpoints"></a>

```python
endpoints: typing.List[Endpoint]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Endpoint]

endpoints is a list of unique endpoints in this slice.

Each slice may include a maximum of 1000 endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.ports"></a>

```python
ports: typing.List[EndpointPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointPort]

ports specifies the list of network ports exposed by each endpoint in this slice.

Each port must have a unique name. When ports is empty, it indicates that there are no defined ports. When a port is defined with a nil port value, it indicates "all ports". Each slice may include a maximum of 100 ports.

---

### KubeEndpointsListProps <a name="KubeEndpointsListProps" id="cdk8s-plus-28.k8s.KubeEndpointsListProps"></a>

EndpointsList is a list of endpoints.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsListProps(
  items: typing.List[KubeEndpointsProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEndpointsProps]</code> | List of endpoints. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.property.items"></a>

```python
items: typing.List[KubeEndpointsProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEndpointsProps]

List of endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeEndpointsProps <a name="KubeEndpointsProps" id="cdk8s-plus-28.k8s.KubeEndpointsProps"></a>

Endpoints is a collection of endpoints that implement the actual service. Example:.

Name: "mysvc",
Subsets: [
{
Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
Ports: [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
},
{
Addresses: [{"ip": "10.10.3.3"}],
Ports: [{"name": "a", "port": 93}, {"name": "b", "port": 76}]
},
]

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointsProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEndpointsProps(
  metadata: ObjectMeta = None,
  subsets: typing.List[EndpointSubset] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsProps.property.subsets">subsets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EndpointSubset]</code> | The set of all endpoints is the union of all subsets. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `subsets`<sup>Optional</sup> <a name="subsets" id="cdk8s-plus-28.k8s.KubeEndpointsProps.property.subsets"></a>

```python
subsets: typing.List[EndpointSubset]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EndpointSubset]

The set of all endpoints is the union of all subsets.

Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.

---

### KubeEventListProps <a name="KubeEventListProps" id="cdk8s-plus-28.k8s.KubeEventListProps"></a>

EventList is a list of Event objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEventListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventListProps(
  items: typing.List[KubeEventProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeEventProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEventListProps.property.items"></a>

```python
items: typing.List[KubeEventProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeEventProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeEventProps <a name="KubeEventProps" id="cdk8s-plus-28.k8s.KubeEventProps"></a>

Event is a report of an event somewhere in the cluster.

It generally denotes some state change in the system. Events have a limited retention time and triggers and messages may evolve with time.  Event consumers should not rely on the timing of an event with a given Reason reflecting a consistent underlying trigger, or the continued existence of events with that Reason.  Events should be treated as informative, best-effort, supplemental data.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEventProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEventProps(
  event_time: datetime.datetime,
  action: str = None,
  deprecated_count: typing.Union[int, float] = None,
  deprecated_first_timestamp: datetime.datetime = None,
  deprecated_last_timestamp: datetime.datetime = None,
  deprecated_source: EventSource = None,
  metadata: ObjectMeta = None,
  note: str = None,
  reason: str = None,
  regarding: ObjectReference = None,
  related: ObjectReference = None,
  reporting_controller: str = None,
  reporting_instance: str = None,
  series: EventSeries = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.eventTime">event_time</a></code> | <code>datetime.datetime</code> | eventTime is the time when this Event was first observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.action">action</a></code> | <code>str</code> | action is what action was taken/failed regarding to the regarding object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedCount">deprecated_count</a></code> | <code>typing.Union[int, float]</code> | deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedFirstTimestamp">deprecated_first_timestamp</a></code> | <code>datetime.datetime</code> | deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedLastTimestamp">deprecated_last_timestamp</a></code> | <code>datetime.datetime</code> | deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedSource">deprecated_source</a></code> | <code>cdk8s_plus_28.k8s.EventSource</code> | deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.note">note</a></code> | <code>str</code> | note is a human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reason">reason</a></code> | <code>str</code> | reason is why the action was taken. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.regarding">regarding</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | regarding contains the object this Event is about. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.related">related</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | related is the optional secondary object for more complex actions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reportingController">reporting_controller</a></code> | <code>str</code> | reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reportingInstance">reporting_instance</a></code> | <code>str</code> | reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.series">series</a></code> | <code>cdk8s_plus_28.k8s.EventSeries</code> | series is data about the Event series this event represents or nil if it's a singleton Event. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.type">type</a></code> | <code>str</code> | type is the type of this event (Normal, Warning), new types could be added in the future. |

---

##### `event_time`<sup>Required</sup> <a name="event_time" id="cdk8s-plus-28.k8s.KubeEventProps.property.eventTime"></a>

```python
event_time: datetime.datetime
```

- *Type:* datetime.datetime

eventTime is the time when this Event was first observed.

It is required.

---

##### `action`<sup>Optional</sup> <a name="action" id="cdk8s-plus-28.k8s.KubeEventProps.property.action"></a>

```python
action: str
```

- *Type:* str

action is what action was taken/failed regarding to the regarding object.

It is machine-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `deprecated_count`<sup>Optional</sup> <a name="deprecated_count" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedCount"></a>

```python
deprecated_count: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_first_timestamp`<sup>Optional</sup> <a name="deprecated_first_timestamp" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedFirstTimestamp"></a>

```python
deprecated_first_timestamp: datetime.datetime
```

- *Type:* datetime.datetime

deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_last_timestamp`<sup>Optional</sup> <a name="deprecated_last_timestamp" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedLastTimestamp"></a>

```python
deprecated_last_timestamp: datetime.datetime
```

- *Type:* datetime.datetime

deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecated_source`<sup>Optional</sup> <a name="deprecated_source" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedSource"></a>

```python
deprecated_source: EventSource
```

- *Type:* cdk8s_plus_28.k8s.EventSource

deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `note`<sup>Optional</sup> <a name="note" id="cdk8s-plus-28.k8s.KubeEventProps.property.note"></a>

```python
note: str
```

- *Type:* str

note is a human-readable description of the status of this operation.

Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeEventProps.property.reason"></a>

```python
reason: str
```

- *Type:* str

reason is why the action was taken.

It is human-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `regarding`<sup>Optional</sup> <a name="regarding" id="cdk8s-plus-28.k8s.KubeEventProps.property.regarding"></a>

```python
regarding: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

regarding contains the object this Event is about.

In most cases it's an Object reporting controller implements, e.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.

---

##### `related`<sup>Optional</sup> <a name="related" id="cdk8s-plus-28.k8s.KubeEventProps.property.related"></a>

```python
related: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

related is the optional secondary object for more complex actions.

E.g. when regarding object triggers a creation or deletion of related object.

---

##### `reporting_controller`<sup>Optional</sup> <a name="reporting_controller" id="cdk8s-plus-28.k8s.KubeEventProps.property.reportingController"></a>

```python
reporting_controller: str
```

- *Type:* str

reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events.

---

##### `reporting_instance`<sup>Optional</sup> <a name="reporting_instance" id="cdk8s-plus-28.k8s.KubeEventProps.property.reportingInstance"></a>

```python
reporting_instance: str
```

- *Type:* str

reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `series`<sup>Optional</sup> <a name="series" id="cdk8s-plus-28.k8s.KubeEventProps.property.series"></a>

```python
series: EventSeries
```

- *Type:* cdk8s_plus_28.k8s.EventSeries

series is data about the Event series this event represents or nil if it's a singleton Event.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeEventProps.property.type"></a>

```python
type: str
```

- *Type:* str

type is the type of this event (Normal, Warning), new types could be added in the future.

It is machine-readable. This field cannot be empty for new Events.

---

### KubeEvictionProps <a name="KubeEvictionProps" id="cdk8s-plus-28.k8s.KubeEvictionProps"></a>

Eviction evicts a pod from its node subject to certain policies and safety constraints.

This is a subresource of Pod.  A request to cause such an eviction is created by POSTing to .../pods/<pod name>/evictions.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEvictionProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeEvictionProps(
  delete_options: DeleteOptions = None,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvictionProps.property.deleteOptions">delete_options</a></code> | <code>cdk8s_plus_28.k8s.DeleteOptions</code> | DeleteOptions may be provided. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvictionProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | ObjectMeta describes the pod that is being evicted. |

---

##### `delete_options`<sup>Optional</sup> <a name="delete_options" id="cdk8s-plus-28.k8s.KubeEvictionProps.property.deleteOptions"></a>

```python
delete_options: DeleteOptions
```

- *Type:* cdk8s_plus_28.k8s.DeleteOptions

DeleteOptions may be provided.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvictionProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

ObjectMeta describes the pod that is being evicted.

---

### KubeFlowSchemaListV1Beta2Props <a name="KubeFlowSchemaListV1Beta2Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta2Props(
  items: typing.List[KubeFlowSchemaV1Beta2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta2Props]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.items"></a>

```python
items: typing.List[KubeFlowSchemaV1Beta2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta2Props]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeFlowSchemaListV1Beta3Props <a name="KubeFlowSchemaListV1Beta3Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaListV1Beta3Props(
  items: typing.List[KubeFlowSchemaV1Beta3Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta3Props]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.items"></a>

```python
items: typing.List[KubeFlowSchemaV1Beta3Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeFlowSchemaV1Beta3Props]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeFlowSchemaV1Beta2Props <a name="KubeFlowSchemaV1Beta2Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta2Props(
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.spec"></a>

```python
spec: FlowSchemaSpecV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta2

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeFlowSchemaV1Beta3Props <a name="KubeFlowSchemaV1Beta3Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeFlowSchemaV1Beta3Props(
  metadata: ObjectMeta = None,
  spec: FlowSchemaSpecV1Beta3 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.spec"></a>

```python
spec: FlowSchemaSpecV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.FlowSchemaSpecV1Beta3

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeHorizontalPodAutoscalerListProps <a name="KubeHorizontalPodAutoscalerListProps" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps"></a>

list of horizontal pod autoscaler objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListProps(
  items: typing.List[KubeHorizontalPodAutoscalerProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerProps]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.items"></a>

```python
items: typing.List[KubeHorizontalPodAutoscalerProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerProps]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeHorizontalPodAutoscalerListV2Props <a name="KubeHorizontalPodAutoscalerListV2Props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props"></a>

HorizontalPodAutoscalerList is a list of horizontal pod autoscaler objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerListV2Props(
  items: typing.List[KubeHorizontalPodAutoscalerV2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerV2Props]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | metadata is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.items"></a>

```python
items: typing.List[KubeHorizontalPodAutoscalerV2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeHorizontalPodAutoscalerV2Props]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

metadata is the standard list metadata.

---

### KubeHorizontalPodAutoscalerProps <a name="KubeHorizontalPodAutoscalerProps" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps"></a>

configuration of a horizontal pod autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerProps(
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpec</code> | spec defines the behaviour of autoscaler. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.spec"></a>

```python
spec: HorizontalPodAutoscalerSpec
```

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpec

spec defines the behaviour of autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeHorizontalPodAutoscalerV2Props <a name="KubeHorizontalPodAutoscalerV2Props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props"></a>

HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeHorizontalPodAutoscalerV2Props(
  metadata: ObjectMeta = None,
  spec: HorizontalPodAutoscalerSpecV2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | metadata is the standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpecV2</code> | spec is the specification for the behaviour of the autoscaler. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

metadata is the standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.spec"></a>

```python
spec: HorizontalPodAutoscalerSpecV2
```

- *Type:* cdk8s_plus_28.k8s.HorizontalPodAutoscalerSpecV2

spec is the specification for the behaviour of the autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeIngressClassListProps <a name="KubeIngressClassListProps" id="cdk8s-plus-28.k8s.KubeIngressClassListProps"></a>

IngressClassList is a collection of IngressClasses.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassListProps(
  items: typing.List[KubeIngressClassProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIngressClassProps]</code> | items is the list of IngressClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.property.items"></a>

```python
items: typing.List[KubeIngressClassProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressClassProps]

items is the list of IngressClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeIngressClassProps <a name="KubeIngressClassProps" id="cdk8s-plus-28.k8s.KubeIngressClassProps"></a>

IngressClass represents the class of the Ingress, referenced by the Ingress Spec.

The `ingressclass.kubernetes.io/is-default-class` annotation can be used to indicate that an IngressClass should be considered default. When a single IngressClass resource has this annotation set to true, new Ingress resources without a class specified will be assigned this default class.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressClassProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressClassProps(
  metadata: ObjectMeta = None,
  spec: IngressClassSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IngressClassSpec</code> | spec is the desired state of the IngressClass. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressClassProps.property.spec"></a>

```python
spec: IngressClassSpec
```

- *Type:* cdk8s_plus_28.k8s.IngressClassSpec

spec is the desired state of the IngressClass.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeIngressListProps <a name="KubeIngressListProps" id="cdk8s-plus-28.k8s.KubeIngressListProps"></a>

IngressList is a collection of Ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressListProps(
  items: typing.List[KubeIngressProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIngressProps]</code> | items is the list of Ingress. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressListProps.property.items"></a>

```python
items: typing.List[KubeIngressProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIngressProps]

items is the list of Ingress.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeIngressProps <a name="KubeIngressProps" id="cdk8s-plus-28.k8s.KubeIngressProps"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIngressProps(
  metadata: ObjectMeta = None,
  spec: IngressSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IngressSpec</code> | spec is the desired state of the Ingress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressProps.property.spec"></a>

```python
spec: IngressSpec
```

- *Type:* cdk8s_plus_28.k8s.IngressSpec

spec is the desired state of the Ingress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeIpAddressListV1Alpha1Props <a name="KubeIpAddressListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props"></a>

IPAddressList contains a list of IPAddress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressListV1Alpha1Props(
  items: typing.List[KubeIpAddressV1Alpha1Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeIpAddressV1Alpha1Props]</code> | items is the list of IPAddresses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeIpAddressV1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeIpAddressV1Alpha1Props]

items is the list of IPAddresses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeIpAddressV1Alpha1Props <a name="KubeIpAddressV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props"></a>

IPAddress represents a single IP of a single IP Family.

The object is designed to be used by APIs that operate on IP addresses. The object is used by the Service core API for allocation of IP addresses. An IP address can be represented in different formats, to guarantee the uniqueness of the IP, the name of the object is the IP address in canonical format, four decimal digits separated by dots suppressing leading zeros for IPv4 and the representation defined by RFC 5952 for IPv6. Valid: 192.168.1.5 or 2001:db8::1 or 2001:db8:aaaa:bbbb:cccc:dddd:eeee:1 Invalid: 10.01.2.3 or 2001:db8:0:0:0::1

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeIpAddressV1Alpha1Props(
  metadata: ObjectMeta = None,
  spec: IpAddressSpecV1Alpha1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.IpAddressSpecV1Alpha1</code> | spec is the desired state of the IPAddress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.spec"></a>

```python
spec: IpAddressSpecV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.IpAddressSpecV1Alpha1

spec is the desired state of the IPAddress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeJobListProps <a name="KubeJobListProps" id="cdk8s-plus-28.k8s.KubeJobListProps"></a>

JobList is a collection of jobs.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeJobListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobListProps(
  items: typing.List[KubeJobProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeJobProps]</code> | items is the list of Jobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeJobListProps.property.items"></a>

```python
items: typing.List[KubeJobProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeJobProps]

items is the list of Jobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeJobProps <a name="KubeJobProps" id="cdk8s-plus-28.k8s.KubeJobProps"></a>

Job represents the configuration of a single job.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeJobProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeJobProps(
  metadata: ObjectMeta = None,
  spec: JobSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.JobSpec</code> | Specification of the desired behavior of a job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeJobProps.property.spec"></a>

```python
spec: JobSpec
```

- *Type:* cdk8s_plus_28.k8s.JobSpec

Specification of the desired behavior of a job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLeaseListProps <a name="KubeLeaseListProps" id="cdk8s-plus-28.k8s.KubeLeaseListProps"></a>

LeaseList is a list of Lease objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLeaseListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseListProps(
  items: typing.List[KubeLeaseProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeLeaseProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLeaseListProps.property.items"></a>

```python
items: typing.List[KubeLeaseProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLeaseProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeLeaseProps <a name="KubeLeaseProps" id="cdk8s-plus-28.k8s.KubeLeaseProps"></a>

Lease defines a lease concept.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLeaseProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLeaseProps(
  metadata: ObjectMeta = None,
  spec: LeaseSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.LeaseSpec</code> | spec contains the specification of the Lease. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLeaseProps.property.spec"></a>

```python
spec: LeaseSpec
```

- *Type:* cdk8s_plus_28.k8s.LeaseSpec

spec contains the specification of the Lease.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLimitRangeListProps <a name="KubeLimitRangeListProps" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps"></a>

LimitRangeList is a list of LimitRange items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeListProps(
  items: typing.List[KubeLimitRangeProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeLimitRangeProps]</code> | Items is a list of LimitRange objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.items"></a>

```python
items: typing.List[KubeLimitRangeProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeLimitRangeProps]

Items is a list of LimitRange objects.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeLimitRangeProps <a name="KubeLimitRangeProps" id="cdk8s-plus-28.k8s.KubeLimitRangeProps"></a>

LimitRange sets resource usage limits for each kind of resource in a Namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLimitRangeProps(
  metadata: ObjectMeta = None,
  spec: LimitRangeSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.LimitRangeSpec</code> | Spec defines the limits enforced. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.property.spec"></a>

```python
spec: LimitRangeSpec
```

- *Type:* cdk8s_plus_28.k8s.LimitRangeSpec

Spec defines the limits enforced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLocalSubjectAccessReviewProps <a name="KubeLocalSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps"></a>

LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace.

Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeLocalSubjectAccessReviewProps(
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.spec"></a>

```python
spec: SubjectAccessReviewSpec
```

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeMutatingWebhookConfigurationListProps <a name="KubeMutatingWebhookConfigurationListProps" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps"></a>

MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationListProps(
  items: typing.List[KubeMutatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeMutatingWebhookConfigurationProps]</code> | List of MutatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.items"></a>

```python
items: typing.List[KubeMutatingWebhookConfigurationProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeMutatingWebhookConfigurationProps]

List of MutatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeMutatingWebhookConfigurationProps <a name="KubeMutatingWebhookConfigurationProps" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps"></a>

MutatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and may change the object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeMutatingWebhookConfigurationProps(
  metadata: ObjectMeta = None,
  webhooks: typing.List[MutatingWebhook] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.webhooks">webhooks</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MutatingWebhook]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.webhooks"></a>

```python
webhooks: typing.List[MutatingWebhook]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MutatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

### KubeNamespaceListProps <a name="KubeNamespaceListProps" id="cdk8s-plus-28.k8s.KubeNamespaceListProps"></a>

NamespaceList is a list of Namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceListProps(
  items: typing.List[KubeNamespaceProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNamespaceProps]</code> | Items is the list of Namespace objects in the list. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.property.items"></a>

```python
items: typing.List[KubeNamespaceProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNamespaceProps]

Items is the list of Namespace objects in the list.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeNamespaceProps <a name="KubeNamespaceProps" id="cdk8s-plus-28.k8s.KubeNamespaceProps"></a>

Namespace provides a scope for Names.

Use of multiple namespaces is optional.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNamespaceProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNamespaceProps(
  metadata: ObjectMeta = None,
  spec: NamespaceSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NamespaceSpec</code> | Spec defines the behavior of the Namespace. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNamespaceProps.property.spec"></a>

```python
spec: NamespaceSpec
```

- *Type:* cdk8s_plus_28.k8s.NamespaceSpec

Spec defines the behavior of the Namespace.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeNetworkPolicyListProps <a name="KubeNetworkPolicyListProps" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps"></a>

NetworkPolicyList is a list of NetworkPolicy objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyListProps(
  items: typing.List[KubeNetworkPolicyProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNetworkPolicyProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.items"></a>

```python
items: typing.List[KubeNetworkPolicyProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNetworkPolicyProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeNetworkPolicyProps <a name="KubeNetworkPolicyProps" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps"></a>

NetworkPolicy describes what network traffic is allowed for a set of Pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNetworkPolicyProps(
  metadata: ObjectMeta = None,
  spec: NetworkPolicySpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NetworkPolicySpec</code> | spec represents the specification of the desired behavior for this NetworkPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.spec"></a>

```python
spec: NetworkPolicySpec
```

- *Type:* cdk8s_plus_28.k8s.NetworkPolicySpec

spec represents the specification of the desired behavior for this NetworkPolicy.

---

### KubeNodeListProps <a name="KubeNodeListProps" id="cdk8s-plus-28.k8s.KubeNodeListProps"></a>

NodeList is the whole list of all Nodes which have been registered with master.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNodeListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeListProps(
  items: typing.List[KubeNodeProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeNodeProps]</code> | List of nodes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNodeListProps.property.items"></a>

```python
items: typing.List[KubeNodeProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeNodeProps]

List of nodes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeNodeProps <a name="KubeNodeProps" id="cdk8s-plus-28.k8s.KubeNodeProps"></a>

Node is a worker node in Kubernetes.

Each node will have a unique identifier in the cache (i.e. in etcd).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNodeProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeNodeProps(
  metadata: ObjectMeta = None,
  spec: NodeSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.NodeSpec</code> | Spec defines the behavior of a node. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNodeProps.property.spec"></a>

```python
spec: NodeSpec
```

- *Type:* cdk8s_plus_28.k8s.NodeSpec

Spec defines the behavior of a node.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePersistentVolumeClaimListProps <a name="KubePersistentVolumeClaimListProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps"></a>

PersistentVolumeClaimList is a list of PersistentVolumeClaim items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimListProps(
  items: typing.List[KubePersistentVolumeClaimProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]</code> | items is a list of persistent volume claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.items"></a>

```python
items: typing.List[KubePersistentVolumeClaimProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]

items is a list of persistent volume claims.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePersistentVolumeClaimProps <a name="KubePersistentVolumeClaimProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps"></a>

PersistentVolumeClaim is a user's request for and claim to a persistent volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeClaimProps(
  metadata: ObjectMeta = None,
  spec: PersistentVolumeClaimSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeClaimSpec</code> | spec defines the desired characteristics of a volume requested by a pod author. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.spec"></a>

```python
spec: PersistentVolumeClaimSpec
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimSpec

spec defines the desired characteristics of a volume requested by a pod author.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

### KubePersistentVolumeListProps <a name="KubePersistentVolumeListProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps"></a>

PersistentVolumeList is a list of PersistentVolume items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeListProps(
  items: typing.List[KubePersistentVolumeProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeProps]</code> | items is a list of persistent volumes. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.items"></a>

```python
items: typing.List[KubePersistentVolumeProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeProps]

items is a list of persistent volumes.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePersistentVolumeProps <a name="KubePersistentVolumeProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps"></a>

PersistentVolume (PV) is a storage resource provisioned by an administrator.

It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePersistentVolumeProps(
  metadata: ObjectMeta = None,
  spec: PersistentVolumeSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeSpec</code> | spec defines a specification of a persistent volume owned by the cluster. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.spec"></a>

```python
spec: PersistentVolumeSpec
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeSpec

spec defines a specification of a persistent volume owned by the cluster.

Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes

---

### KubePodDisruptionBudgetListProps <a name="KubePodDisruptionBudgetListProps" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps"></a>

PodDisruptionBudgetList is a collection of PodDisruptionBudgets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetListProps(
  items: typing.List[KubePodDisruptionBudgetProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodDisruptionBudgetProps]</code> | Items is a list of PodDisruptionBudgets. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.items"></a>

```python
items: typing.List[KubePodDisruptionBudgetProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodDisruptionBudgetProps]

Items is a list of PodDisruptionBudgets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePodDisruptionBudgetProps <a name="KubePodDisruptionBudgetProps" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps"></a>

PodDisruptionBudget is an object to define the max disruption that can be caused to a collection of pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodDisruptionBudgetProps(
  metadata: ObjectMeta = None,
  spec: PodDisruptionBudgetSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodDisruptionBudgetSpec</code> | Specification of the desired behavior of the PodDisruptionBudget. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.spec"></a>

```python
spec: PodDisruptionBudgetSpec
```

- *Type:* cdk8s_plus_28.k8s.PodDisruptionBudgetSpec

Specification of the desired behavior of the PodDisruptionBudget.

---

### KubePodListProps <a name="KubePodListProps" id="cdk8s-plus-28.k8s.KubePodListProps"></a>

PodList is a list of Pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodListProps(
  items: typing.List[KubePodProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodProps]</code> | List of pods. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodListProps.property.items"></a>

```python
items: typing.List[KubePodProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodProps]

List of pods.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePodProps <a name="KubePodProps" id="cdk8s-plus-28.k8s.KubePodProps"></a>

Pod is a collection of containers that can run on a host.

This resource is created by clients and scheduled onto hosts.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodProps(
  metadata: ObjectMeta = None,
  spec: PodSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodSpec</code> | Specification of the desired behavior of the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodProps.property.spec"></a>

```python
spec: PodSpec
```

- *Type:* cdk8s_plus_28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePodSchedulingContextListV1Alpha2Props <a name="KubePodSchedulingContextListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props"></a>

PodSchedulingContextList is a collection of Pod scheduling objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextListV1Alpha2Props(
  items: typing.List[KubePodSchedulingContextV1Alpha2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodSchedulingContextV1Alpha2Props]</code> | Items is the list of PodSchedulingContext objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.items"></a>

```python
items: typing.List[KubePodSchedulingContextV1Alpha2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodSchedulingContextV1Alpha2Props]

Items is the list of PodSchedulingContext objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubePodSchedulingContextV1Alpha2Props <a name="KubePodSchedulingContextV1Alpha2Props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props"></a>

PodSchedulingContext objects hold information that is needed to schedule a Pod with ResourceClaims that use "WaitForFirstConsumer" allocation mode.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodSchedulingContextV1Alpha2Props(
  spec: PodSchedulingContextSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodSchedulingContextSpecV1Alpha2</code> | Spec describes where resources for the Pod are needed. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.spec"></a>

```python
spec: PodSchedulingContextSpecV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.PodSchedulingContextSpecV1Alpha2

Spec describes where resources for the Pod are needed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

### KubePodTemplateListProps <a name="KubePodTemplateListProps" id="cdk8s-plus-28.k8s.KubePodTemplateListProps"></a>

PodTemplateList is a list of PodTemplates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateListProps(
  items: typing.List[KubePodTemplateProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePodTemplateProps]</code> | List of pod templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.property.items"></a>

```python
items: typing.List[KubePodTemplateProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePodTemplateProps]

List of pod templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePodTemplateProps <a name="KubePodTemplateProps" id="cdk8s-plus-28.k8s.KubePodTemplateProps"></a>

PodTemplate describes a template for creating copies of a predefined pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodTemplateProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePodTemplateProps(
  metadata: ObjectMeta = None,
  template: PodTemplateSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateProps.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Template defines the pods that will be created from this pod template. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.KubePodTemplateProps.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template defines the pods that will be created from this pod template.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePriorityClassListProps <a name="KubePriorityClassListProps" id="cdk8s-plus-28.k8s.KubePriorityClassListProps"></a>

PriorityClassList is a collection of priority classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassListProps(
  items: typing.List[KubePriorityClassProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityClassProps]</code> | items is the list of PriorityClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.property.items"></a>

```python
items: typing.List[KubePriorityClassProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityClassProps]

items is the list of PriorityClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubePriorityClassProps <a name="KubePriorityClassProps" id="cdk8s-plus-28.k8s.KubePriorityClassProps"></a>

PriorityClass defines mapping from a priority class name to the priority integer value.

The value can be any valid integer.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityClassProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityClassProps(
  value: typing.Union[int, float],
  description: str = None,
  global_default: bool = None,
  metadata: ObjectMeta = None,
  preemption_policy: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.value">value</a></code> | <code>typing.Union[int, float]</code> | value represents the integer value of this priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.description">description</a></code> | <code>str</code> | description is an arbitrary string that usually provides guidelines on when this priority class should be used. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.globalDefault">global_default</a></code> | <code>bool</code> | globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.preemptionPolicy">preemption_policy</a></code> | <code>str</code> | preemptionPolicy is the Policy for preempting pods with lower priority. |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.value"></a>

```python
value: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

value represents the integer value of this priority class.

This is the actual priority that pods receive when they have the name of this class in their pod spec.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.description"></a>

```python
description: str
```

- *Type:* str

description is an arbitrary string that usually provides guidelines on when this priority class should be used.

---

##### `global_default`<sup>Optional</sup> <a name="global_default" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.globalDefault"></a>

```python
global_default: bool
```

- *Type:* bool

globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class.

Only one PriorityClass can be marked as `globalDefault`. However, if more than one PriorityClasses exists with their `globalDefault` field set to true, the smallest value of such global default PriorityClasses will be used as the default priority.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `preemption_policy`<sup>Optional</sup> <a name="preemption_policy" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.preemptionPolicy"></a>

```python
preemption_policy: str
```

- *Type:* str
- *Default:* PreemptLowerPriority if unset.

preemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

### KubePriorityLevelConfigurationListV1Beta2Props <a name="KubePriorityLevelConfigurationListV1Beta2Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta2Props(
  items: typing.List[KubePriorityLevelConfigurationV1Beta2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta2Props]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.items"></a>

```python
items: typing.List[KubePriorityLevelConfigurationV1Beta2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta2Props]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePriorityLevelConfigurationListV1Beta3Props <a name="KubePriorityLevelConfigurationListV1Beta3Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationListV1Beta3Props(
  items: typing.List[KubePriorityLevelConfigurationV1Beta3Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta3Props]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.items"></a>

```python
items: typing.List[KubePriorityLevelConfigurationV1Beta3Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePriorityLevelConfigurationV1Beta3Props]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePriorityLevelConfigurationV1Beta2Props <a name="KubePriorityLevelConfigurationV1Beta2Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta2Props(
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.spec"></a>

```python
spec: PriorityLevelConfigurationSpecV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta2

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePriorityLevelConfigurationV1Beta3Props <a name="KubePriorityLevelConfigurationV1Beta3Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubePriorityLevelConfigurationV1Beta3Props(
  metadata: ObjectMeta = None,
  spec: PriorityLevelConfigurationSpecV1Beta3 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.spec"></a>

```python
spec: PriorityLevelConfigurationSpecV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.PriorityLevelConfigurationSpecV1Beta3

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeReplicaSetListProps <a name="KubeReplicaSetListProps" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps"></a>

ReplicaSetList is a collection of ReplicaSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetListProps(
  items: typing.List[KubeReplicaSetProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeReplicaSetProps]</code> | List of ReplicaSets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.items"></a>

```python
items: typing.List[KubeReplicaSetProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicaSetProps]

List of ReplicaSets.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeReplicaSetProps <a name="KubeReplicaSetProps" id="cdk8s-plus-28.k8s.KubeReplicaSetProps"></a>

ReplicaSet ensures that a specified number of pod replicas are running at any given time.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicaSetProps(
  metadata: ObjectMeta = None,
  spec: ReplicaSetSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ReplicaSetSpec</code> | Spec defines the specification of the desired behavior of the ReplicaSet. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.property.spec"></a>

```python
spec: ReplicaSetSpec
```

- *Type:* cdk8s_plus_28.k8s.ReplicaSetSpec

Spec defines the specification of the desired behavior of the ReplicaSet.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeReplicationControllerListProps <a name="KubeReplicationControllerListProps" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps"></a>

ReplicationControllerList is a collection of replication controllers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerListProps(
  items: typing.List[KubeReplicationControllerProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeReplicationControllerProps]</code> | List of replication controllers. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.items"></a>

```python
items: typing.List[KubeReplicationControllerProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeReplicationControllerProps]

List of replication controllers.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeReplicationControllerProps <a name="KubeReplicationControllerProps" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps"></a>

ReplicationController represents the configuration of a replication controller.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeReplicationControllerProps(
  metadata: ObjectMeta = None,
  spec: ReplicationControllerSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ReplicationControllerSpec</code> | Spec defines the specification of the desired behavior of the replication controller. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.spec"></a>

```python
spec: ReplicationControllerSpec
```

- *Type:* cdk8s_plus_28.k8s.ReplicationControllerSpec

Spec defines the specification of the desired behavior of the replication controller.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeResourceClaimListV1Alpha2Props <a name="KubeResourceClaimListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props"></a>

ResourceClaimList is a collection of claims.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimListV1Alpha2Props(
  items: typing.List[KubeResourceClaimV1Alpha2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClaimV1Alpha2Props]</code> | Items is the list of resource claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.items"></a>

```python
items: typing.List[KubeResourceClaimV1Alpha2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimV1Alpha2Props]

Items is the list of resource claims.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClaimTemplateListV1Alpha2Props <a name="KubeResourceClaimTemplateListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props"></a>

ResourceClaimTemplateList is a collection of claim templates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateListV1Alpha2Props(
  items: typing.List[KubeResourceClaimTemplateV1Alpha2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClaimTemplateV1Alpha2Props]</code> | Items is the list of resource claim templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.items"></a>

```python
items: typing.List[KubeResourceClaimTemplateV1Alpha2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClaimTemplateV1Alpha2Props]

Items is the list of resource claim templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClaimTemplateV1Alpha2Props <a name="KubeResourceClaimTemplateV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props"></a>

ResourceClaimTemplate is used to produce ResourceClaim objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimTemplateV1Alpha2Props(
  spec: ResourceClaimTemplateSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimTemplateSpecV1Alpha2</code> | Describes the ResourceClaim that is to be generated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.spec"></a>

```python
spec: ResourceClaimTemplateSpecV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.ResourceClaimTemplateSpecV1Alpha2

Describes the ResourceClaim that is to be generated.

This field is immutable. A ResourceClaim will get created by the control plane for a Pod when needed and then not get updated anymore.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

### KubeResourceClaimV1Alpha2Props <a name="KubeResourceClaimV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props"></a>

ResourceClaim describes which resources are needed by a resource consumer.

Its status tracks whether the resource has been allocated and what the resulting attributes are.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClaimV1Alpha2Props(
  spec: ResourceClaimSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2</code> | Spec describes the desired attributes of a resource that then needs to be allocated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.spec"></a>

```python
spec: ResourceClaimSpecV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2

Spec describes the desired attributes of a resource that then needs to be allocated.

It can only be set once when creating the ResourceClaim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

### KubeResourceClassListV1Alpha2Props <a name="KubeResourceClassListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props"></a>

ResourceClassList is a collection of classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassListV1Alpha2Props(
  items: typing.List[KubeResourceClassV1Alpha2Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceClassV1Alpha2Props]</code> | Items is the list of resource classes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.items"></a>

```python
items: typing.List[KubeResourceClassV1Alpha2Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceClassV1Alpha2Props]

Items is the list of resource classes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClassV1Alpha2Props <a name="KubeResourceClassV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props"></a>

ResourceClass is used by administrators to influence how resources are allocated.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceClassV1Alpha2Props(
  driver_name: str,
  metadata: ObjectMeta = None,
  parameters_ref: ResourceClassParametersReferenceV1Alpha2 = None,
  suitable_nodes: NodeSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.driverName">driver_name</a></code> | <code>str</code> | DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.parametersRef">parameters_ref</a></code> | <code>cdk8s_plus_28.k8s.ResourceClassParametersReferenceV1Alpha2</code> | ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.suitableNodes">suitable_nodes</a></code> | <code>cdk8s_plus_28.k8s.NodeSelector</code> | Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet. |

---

##### `driver_name`<sup>Required</sup> <a name="driver_name" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.driverName"></a>

```python
driver_name: str
```

- *Type:* str

DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class.

Resource drivers have a unique name in forward domain order (acme.example.com).

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

---

##### `parameters_ref`<sup>Optional</sup> <a name="parameters_ref" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.parametersRef"></a>

```python
parameters_ref: ResourceClassParametersReferenceV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.ResourceClassParametersReferenceV1Alpha2

ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class.

A dynamic resource driver can distinguish between parameters stored here and and those stored in ResourceClaimSpec.

---

##### `suitable_nodes`<sup>Optional</sup> <a name="suitable_nodes" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.suitableNodes"></a>

```python
suitable_nodes: NodeSelector
```

- *Type:* cdk8s_plus_28.k8s.NodeSelector

Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet.

Setting this field is optional. If null, all nodes are candidates.

---

### KubeResourceQuotaListProps <a name="KubeResourceQuotaListProps" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps"></a>

ResourceQuotaList is a list of ResourceQuota items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaListProps(
  items: typing.List[KubeResourceQuotaProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeResourceQuotaProps]</code> | Items is a list of ResourceQuota objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.items"></a>

```python
items: typing.List[KubeResourceQuotaProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeResourceQuotaProps]

Items is a list of ResourceQuota objects.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeResourceQuotaProps <a name="KubeResourceQuotaProps" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps"></a>

ResourceQuota sets aggregate quota restrictions enforced per namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeResourceQuotaProps(
  metadata: ObjectMeta = None,
  spec: ResourceQuotaSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceQuotaSpec</code> | Spec defines the desired quota. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.spec"></a>

```python
spec: ResourceQuotaSpec
```

- *Type:* cdk8s_plus_28.k8s.ResourceQuotaSpec

Spec defines the desired quota.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeRoleBindingListProps <a name="KubeRoleBindingListProps" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps"></a>

RoleBindingList is a collection of RoleBindings.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingListProps(
  items: typing.List[KubeRoleBindingProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRoleBindingProps]</code> | Items is a list of RoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.items"></a>

```python
items: typing.List[KubeRoleBindingProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleBindingProps]

Items is a list of RoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

### KubeRoleBindingProps <a name="KubeRoleBindingProps" id="cdk8s-plus-28.k8s.KubeRoleBindingProps"></a>

RoleBinding references a role, but does not contain it.

It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleBindingProps(
  role_ref: RoleRef,
  metadata: ObjectMeta = None,
  subjects: typing.List[Subject] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.roleRef">role_ref</a></code> | <code>cdk8s_plus_28.k8s.RoleRef</code> | RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Subject]</code> | Subjects holds references to the objects the role applies to. |

---

##### `role_ref`<sup>Required</sup> <a name="role_ref" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.roleRef"></a>

```python
role_ref: RoleRef
```

- *Type:* cdk8s_plus_28.k8s.RoleRef

RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.subjects"></a>

```python
subjects: typing.List[Subject]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Subject]

Subjects holds references to the objects the role applies to.

---

### KubeRoleListProps <a name="KubeRoleListProps" id="cdk8s-plus-28.k8s.KubeRoleListProps"></a>

RoleList is a collection of Roles.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleListProps(
  items: typing.List[KubeRoleProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRoleProps]</code> | Items is a list of Roles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleListProps.property.items"></a>

```python
items: typing.List[KubeRoleProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRoleProps]

Items is a list of Roles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard object's metadata.

---

### KubeRoleProps <a name="KubeRoleProps" id="cdk8s-plus-28.k8s.KubeRoleProps"></a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRoleProps(
  metadata: ObjectMeta = None,
  rules: typing.List[PolicyRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleProps.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PolicyRule]</code> | Rules holds all the PolicyRules for this Role. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeRoleProps.property.rules"></a>

```python
rules: typing.List[PolicyRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PolicyRule]

Rules holds all the PolicyRules for this Role.

---

### KubeRuntimeClassListProps <a name="KubeRuntimeClassListProps" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps"></a>

RuntimeClassList is a list of RuntimeClass objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassListProps(
  items: typing.List[KubeRuntimeClassProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeRuntimeClassProps]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.items"></a>

```python
items: typing.List[KubeRuntimeClassProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeRuntimeClassProps]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeRuntimeClassProps <a name="KubeRuntimeClassProps" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps"></a>

RuntimeClass defines a class of container runtime supported in the cluster.

The RuntimeClass is used to determine which container runtime is used to run all containers in a pod. RuntimeClasses are manually defined by a user or cluster provisioner, and referenced in the PodSpec. The Kubelet is responsible for resolving the RuntimeClassName reference before running the pod.  For more details, see https://kubernetes.io/docs/concepts/containers/runtime-class/

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeRuntimeClassProps(
  handler: str,
  metadata: ObjectMeta = None,
  overhead: Overhead = None,
  scheduling: Scheduling = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.handler">handler</a></code> | <code>str</code> | handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.overhead">overhead</a></code> | <code>cdk8s_plus_28.k8s.Overhead</code> | overhead represents the resource overhead associated with running a pod for a given RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.scheduling">scheduling</a></code> | <code>cdk8s_plus_28.k8s.Scheduling</code> | scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it. |

---

##### `handler`<sup>Required</sup> <a name="handler" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.handler"></a>

```python
handler: str
```

- *Type:* str

handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class.

The possible values are specific to the node & CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called "runc" might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The Handler must be lowercase, conform to the DNS Label (RFC 1123) requirements, and is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.overhead"></a>

```python
overhead: Overhead
```

- *Type:* cdk8s_plus_28.k8s.Overhead

overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

For more details, see
https://kubernetes.io/docs/concepts/scheduling-eviction/pod-overhead/

---

##### `scheduling`<sup>Optional</sup> <a name="scheduling" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.scheduling"></a>

```python
scheduling: Scheduling
```

- *Type:* cdk8s_plus_28.k8s.Scheduling

scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it.

If scheduling is nil, this RuntimeClass is assumed to be supported by all nodes.

---

### KubeScaleProps <a name="KubeScaleProps" id="cdk8s-plus-28.k8s.KubeScaleProps"></a>

Scale represents a scaling request for a resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeScaleProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeScaleProps(
  metadata: ObjectMeta = None,
  spec: ScaleSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScaleProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeScaleProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ScaleSpec</code> | spec defines the behavior of the scale. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScaleProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeScaleProps.property.spec"></a>

```python
spec: ScaleSpec
```

- *Type:* cdk8s_plus_28.k8s.ScaleSpec

spec defines the behavior of the scale.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeSecretListProps <a name="KubeSecretListProps" id="cdk8s-plus-28.k8s.KubeSecretListProps"></a>

SecretList is a list of Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSecretListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretListProps(
  items: typing.List[KubeSecretProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeSecretProps]</code> | Items is a list of secret objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeSecretListProps.property.items"></a>

```python
items: typing.List[KubeSecretProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeSecretProps]

Items is a list of secret objects.

More info: https://kubernetes.io/docs/concepts/configuration/secret

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeSecretProps <a name="KubeSecretProps" id="cdk8s-plus-28.k8s.KubeSecretProps"></a>

Secret holds secret data of a certain type.

The total bytes of the values in the Data field must be less than MaxSecretSize bytes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSecretProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSecretProps(
  data: typing.Mapping[str] = None,
  immutable: bool = None,
  metadata: ObjectMeta = None,
  string_data: typing.Mapping[str] = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.data">data</a></code> | <code>typing.Mapping[str]</code> | Data contains the secret data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.stringData">string_data</a></code> | <code>typing.Mapping[str]</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.type">type</a></code> | <code>str</code> | Used to facilitate programmatic handling of secret data. |

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeSecretProps.property.data"></a>

```python
data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Data contains the secret data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool

Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `string_data`<sup>Optional</sup> <a name="string_data" id="cdk8s-plus-28.k8s.KubeSecretProps.property.stringData"></a>

```python
string_data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

stringData allows specifying non-binary secret data in string form.

It is provided as a write-only input field for convenience. All keys and values are merged into the data field on write, overwriting any existing values. The stringData field is never output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeSecretProps.property.type"></a>

```python
type: str
```

- *Type:* str

Used to facilitate programmatic handling of secret data.

More info: https://kubernetes.io/docs/concepts/configuration/secret/#secret-types

---

### KubeSelfSubjectAccessReviewProps <a name="KubeSelfSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps"></a>

SelfSubjectAccessReview checks whether or the current user can perform an action.

Not filling in a spec.namespace means "in all namespaces".  Self is a special case, because users should always be able to check whether they can perform an action

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectAccessReviewProps(
  spec: SelfSubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SelfSubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.spec"></a>

```python
spec: SelfSubjectAccessReviewSpec
```

- *Type:* cdk8s_plus_28.k8s.SelfSubjectAccessReviewSpec

Spec holds information about the request being evaluated.

user and groups must be empty

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewProps <a name="KubeSelfSubjectReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewProps(
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewV1Alpha1Props <a name="KubeSelfSubjectReviewV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Alpha1Props(
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewV1Beta1Props <a name="KubeSelfSubjectReviewV1Beta1Props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectReviewV1Beta1Props(
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectRulesReviewProps <a name="KubeSelfSubjectRulesReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps"></a>

SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace.

The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSelfSubjectRulesReviewProps(
  spec: SelfSubjectRulesReviewSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SelfSubjectRulesReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.spec"></a>

```python
spec: SelfSubjectRulesReviewSpec
```

- *Type:* cdk8s_plus_28.k8s.SelfSubjectRulesReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeServiceAccountListProps <a name="KubeServiceAccountListProps" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps"></a>

ServiceAccountList is a list of ServiceAccount objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountListProps(
  items: typing.List[KubeServiceAccountProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeServiceAccountProps]</code> | List of ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.items"></a>

```python
items: typing.List[KubeServiceAccountProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceAccountProps]

List of ServiceAccounts.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeServiceAccountProps <a name="KubeServiceAccountProps" id="cdk8s-plus-28.k8s.KubeServiceAccountProps"></a>

ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceAccountProps(
  automount_service_account_token: bool = None,
  image_pull_secrets: typing.List[LocalObjectReference] = None,
  metadata: ObjectMeta = None,
  secrets: typing.List[ObjectReference] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.imagePullSecrets">image_pull_secrets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LocalObjectReference]</code> | ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.secrets">secrets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ObjectReference]</code> | Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use. |

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

---

##### `image_pull_secrets`<sup>Optional</sup> <a name="image_pull_secrets" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.imagePullSecrets"></a>

```python
image_pull_secrets: typing.List[LocalObjectReference]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.LocalObjectReference]

ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount.

ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.secrets"></a>

```python
secrets: typing.List[ObjectReference]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ObjectReference]

Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use.

Pods are only limited to this list if this service account has a "kubernetes.io/enforce-mountable-secrets" annotation set to "true". This field should not be used to find auto-generated service account token secrets for use outside of pods. Instead, tokens can be requested directly using the TokenRequest API, or service account token secrets can be manually created. More info: https://kubernetes.io/docs/concepts/configuration/secret

---

### KubeServiceListProps <a name="KubeServiceListProps" id="cdk8s-plus-28.k8s.KubeServiceListProps"></a>

ServiceList holds a list of services.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceListProps(
  items: typing.List[KubeServiceProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeServiceProps]</code> | List of services. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceListProps.property.items"></a>

```python
items: typing.List[KubeServiceProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeServiceProps]

List of services.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeServiceProps <a name="KubeServiceProps" id="cdk8s-plus-28.k8s.KubeServiceProps"></a>

Service is a named abstraction of software service (for example, mysql) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeServiceProps(
  metadata: ObjectMeta = None,
  spec: ServiceSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ServiceSpec</code> | Spec defines the behavior of a service. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeServiceProps.property.spec"></a>

```python
spec: ServiceSpec
```

- *Type:* cdk8s_plus_28.k8s.ServiceSpec

Spec defines the behavior of a service.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeStatefulSetListProps <a name="KubeStatefulSetListProps" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps"></a>

StatefulSetList is a collection of StatefulSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetListProps(
  items: typing.List[KubeStatefulSetProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStatefulSetProps]</code> | Items is the list of stateful sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.items"></a>

```python
items: typing.List[KubeStatefulSetProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStatefulSetProps]

Items is the list of stateful sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeStatefulSetProps <a name="KubeStatefulSetProps" id="cdk8s-plus-28.k8s.KubeStatefulSetProps"></a>

StatefulSet represents a set of pods with consistent identities.

Identities are defined as:

* Network: A single stable DNS and hostname.
* Storage: As many VolumeClaims as requested.

The StatefulSet guarantees that a given network identity will always map to the same storage identity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatefulSetProps(
  metadata: ObjectMeta = None,
  spec: StatefulSetSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.StatefulSetSpec</code> | Spec defines the desired identities of pods in this set. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.property.spec"></a>

```python
spec: StatefulSetSpec
```

- *Type:* cdk8s_plus_28.k8s.StatefulSetSpec

Spec defines the desired identities of pods in this set.

---

### KubeStatusProps <a name="KubeStatusProps" id="cdk8s-plus-28.k8s.KubeStatusProps"></a>

Status is a return value for calls that don't return other objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatusProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStatusProps(
  code: typing.Union[int, float] = None,
  details: StatusDetails = None,
  message: str = None,
  metadata: ListMeta = None,
  reason: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.code">code</a></code> | <code>typing.Union[int, float]</code> | Suggested HTTP return code for this status, 0 if not set. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.details">details</a></code> | <code>cdk8s_plus_28.k8s.StatusDetails</code> | Extended data associated with the reason. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.message">message</a></code> | <code>str</code> | A human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.reason">reason</a></code> | <code>str</code> | A machine-readable description of why this operation is in the "Failure" status. |

---

##### `code`<sup>Optional</sup> <a name="code" id="cdk8s-plus-28.k8s.KubeStatusProps.property.code"></a>

```python
code: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Suggested HTTP return code for this status, 0 if not set.

---

##### `details`<sup>Optional</sup> <a name="details" id="cdk8s-plus-28.k8s.KubeStatusProps.property.details"></a>

```python
details: StatusDetails
```

- *Type:* cdk8s_plus_28.k8s.StatusDetails

Extended data associated with the reason.

Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.KubeStatusProps.property.message"></a>

```python
message: str
```

- *Type:* str

A human-readable description of the status of this operation.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatusProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeStatusProps.property.reason"></a>

```python
reason: str
```

- *Type:* str

A machine-readable description of why this operation is in the "Failure" status.

If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.

---

### KubeStorageClassListProps <a name="KubeStorageClassListProps" id="cdk8s-plus-28.k8s.KubeStorageClassListProps"></a>

StorageClassList is a collection of storage classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassListProps(
  items: typing.List[KubeStorageClassProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStorageClassProps]</code> | items is the list of StorageClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.property.items"></a>

```python
items: typing.List[KubeStorageClassProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageClassProps]

items is the list of StorageClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeStorageClassProps <a name="KubeStorageClassProps" id="cdk8s-plus-28.k8s.KubeStorageClassProps"></a>

StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.

StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageClassProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageClassProps(
  provisioner: str,
  allowed_topologies: typing.List[TopologySelectorTerm] = None,
  allow_volume_expansion: bool = None,
  metadata: ObjectMeta = None,
  mount_options: typing.List[str] = None,
  parameters: typing.Mapping[str] = None,
  reclaim_policy: str = None,
  volume_binding_mode: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.provisioner">provisioner</a></code> | <code>str</code> | provisioner indicates the type of the provisioner. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowedTopologies">allowed_topologies</a></code> | <code>typing.List[cdk8s_plus_28.k8s.TopologySelectorTerm]</code> | allowedTopologies restrict the node topologies where volumes can be dynamically provisioned. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowVolumeExpansion">allow_volume_expansion</a></code> | <code>bool</code> | allowVolumeExpansion shows whether the storage class allow volume expand. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.parameters">parameters</a></code> | <code>typing.Mapping[str]</code> | parameters holds the parameters for the provisioner that should create volumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.reclaimPolicy">reclaim_policy</a></code> | <code>str</code> | reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.volumeBindingMode">volume_binding_mode</a></code> | <code>str</code> | volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound. |

---

##### `provisioner`<sup>Required</sup> <a name="provisioner" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.provisioner"></a>

```python
provisioner: str
```

- *Type:* str

provisioner indicates the type of the provisioner.

---

##### `allowed_topologies`<sup>Optional</sup> <a name="allowed_topologies" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowedTopologies"></a>

```python
allowed_topologies: typing.List[TopologySelectorTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.TopologySelectorTerm]

allowedTopologies restrict the node topologies where volumes can be dynamically provisioned.

Each volume plugin defines its own supported topology specifications. An empty TopologySelectorTerm list means there is no topology restriction. This field is only honored by servers that enable the VolumeScheduling feature.

---

##### `allow_volume_expansion`<sup>Optional</sup> <a name="allow_volume_expansion" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowVolumeExpansion"></a>

```python
allow_volume_expansion: bool
```

- *Type:* bool

allowVolumeExpansion shows whether the storage class allow volume expand.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class.

e.g. ["ro", "soft"]. Not validated - mount of the PVs will simply fail if one is invalid.

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.parameters"></a>

```python
parameters: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

parameters holds the parameters for the provisioner that should create volumes of this storage class.

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.reclaimPolicy"></a>

```python
reclaim_policy: str
```

- *Type:* str
- *Default:* Delete.

reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class.

Defaults to Delete.

---

##### `volume_binding_mode`<sup>Optional</sup> <a name="volume_binding_mode" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.volumeBindingMode"></a>

```python
volume_binding_mode: str
```

- *Type:* str

volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.

When unset, VolumeBindingImmediate is used. This field is only honored by servers that enable the VolumeScheduling feature.

---

### KubeStorageVersionListV1Alpha1Props <a name="KubeStorageVersionListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props"></a>

A list of StorageVersions.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionListV1Alpha1Props(
  items: typing.List[KubeStorageVersionV1Alpha1Props],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeStorageVersionV1Alpha1Props]</code> | Items holds a list of StorageVersion. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeStorageVersionV1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeStorageVersionV1Alpha1Props]

Items holds a list of StorageVersion.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeStorageVersionV1Alpha1Props <a name="KubeStorageVersionV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props"></a>

Storage version of a specific resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeStorageVersionV1Alpha1Props(
  spec: typing.Any,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.spec">spec</a></code> | <code>typing.Any</code> | Spec is an empty spec. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | The name is <group>.<resource>. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.spec"></a>

```python
spec: typing.Any
```

- *Type:* typing.Any

Spec is an empty spec.

It is here to comply with Kubernetes API style.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

The name is <group>.<resource>.

---

### KubeSubjectAccessReviewProps <a name="KubeSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps"></a>

SubjectAccessReview checks whether or not a user or group can perform an action.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeSubjectAccessReviewProps(
  spec: SubjectAccessReviewSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.spec"></a>

```python
spec: SubjectAccessReviewSpec
```

- *Type:* cdk8s_plus_28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeTokenRequestProps <a name="KubeTokenRequestProps" id="cdk8s-plus-28.k8s.KubeTokenRequestProps"></a>

TokenRequest requests a token for a given service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenRequestProps(
  spec: TokenRequestSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequestProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.TokenRequestSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequestProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.property.spec"></a>

```python
spec: TokenRequestSpec
```

- *Type:* cdk8s_plus_28.k8s.TokenRequestSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeTokenReviewProps <a name="KubeTokenReviewProps" id="cdk8s-plus-28.k8s.KubeTokenReviewProps"></a>

TokenReview attempts to authenticate a token to a known user.

Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeTokenReviewProps(
  spec: TokenReviewSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReviewProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.TokenReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReviewProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.property.spec"></a>

```python
spec: TokenReviewSpec
```

- *Type:* cdk8s_plus_28.k8s.TokenReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeValidatingAdmissionPolicyBindingListV1Alpha1Props <a name="KubeValidatingAdmissionPolicyBindingListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props(
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeValidatingAdmissionPolicyBindingV1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyBindingListV1Beta1Props <a name="KubeValidatingAdmissionPolicyBindingListV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props(
  items: typing.List[KubeValidatingAdmissionPolicyBindingV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.items"></a>

```python
items: typing.List[KubeValidatingAdmissionPolicyBindingV1Beta1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyBindingV1Alpha1Props <a name="KubeValidatingAdmissionPolicyBindingV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Alpha1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.spec"></a>

```python
spec: ValidatingAdmissionPolicyBindingSpecV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

### KubeValidatingAdmissionPolicyBindingV1Beta1Props <a name="KubeValidatingAdmissionPolicyBindingV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicyBindingSpecV1Beta1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.spec"></a>

```python
spec: ValidatingAdmissionPolicyBindingSpecV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

### KubeValidatingAdmissionPolicyListV1Alpha1Props <a name="KubeValidatingAdmissionPolicyListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props(
  items: typing.List[KubeValidatingAdmissionPolicyV1Alpha1Props] = None,
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.items"></a>

```python
items: typing.List[KubeValidatingAdmissionPolicyV1Alpha1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyListV1Beta1Props <a name="KubeValidatingAdmissionPolicyListV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyListV1Beta1Props(
  items: typing.List[KubeValidatingAdmissionPolicyV1Beta1Props] = None,
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.items"></a>

```python
items: typing.List[KubeValidatingAdmissionPolicyV1Beta1Props]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyV1Alpha1Props <a name="KubeValidatingAdmissionPolicyV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Alpha1Props(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Alpha1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.spec"></a>

```python
spec: ValidatingAdmissionPolicySpecV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

### KubeValidatingAdmissionPolicyV1Beta1Props <a name="KubeValidatingAdmissionPolicyV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingAdmissionPolicyV1Beta1Props(
  metadata: ObjectMeta = None,
  spec: ValidatingAdmissionPolicySpecV1Beta1 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.spec"></a>

```python
spec: ValidatingAdmissionPolicySpecV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.ValidatingAdmissionPolicySpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

### KubeValidatingWebhookConfigurationListProps <a name="KubeValidatingWebhookConfigurationListProps" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps"></a>

ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationListProps(
  items: typing.List[KubeValidatingWebhookConfigurationProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeValidatingWebhookConfigurationProps]</code> | List of ValidatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.items"></a>

```python
items: typing.List[KubeValidatingWebhookConfigurationProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeValidatingWebhookConfigurationProps]

List of ValidatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingWebhookConfigurationProps <a name="KubeValidatingWebhookConfigurationProps" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps"></a>

ValidatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeValidatingWebhookConfigurationProps(
  metadata: ObjectMeta = None,
  webhooks: typing.List[ValidatingWebhook] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.webhooks">webhooks</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ValidatingWebhook]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.webhooks"></a>

```python
webhooks: typing.List[ValidatingWebhook]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidatingWebhook]

Webhooks is a list of webhooks and the affected resources and operations.

---

### KubeVolumeAttachmentListProps <a name="KubeVolumeAttachmentListProps" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps"></a>

VolumeAttachmentList is a collection of VolumeAttachment objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentListProps(
  items: typing.List[KubeVolumeAttachmentProps],
  metadata: ListMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubeVolumeAttachmentProps]</code> | items is the list of VolumeAttachments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.items"></a>

```python
items: typing.List[KubeVolumeAttachmentProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubeVolumeAttachmentProps]

items is the list of VolumeAttachments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.metadata"></a>

```python
metadata: ListMeta
```

- *Type:* cdk8s_plus_28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeVolumeAttachmentProps <a name="KubeVolumeAttachmentProps" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps"></a>

VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.

VolumeAttachment objects are non-namespaced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.KubeVolumeAttachmentProps(
  spec: VolumeAttachmentSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.VolumeAttachmentSpec</code> | spec represents specification of the desired attach/detach volume behavior. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.spec"></a>

```python
spec: VolumeAttachmentSpec
```

- *Type:* cdk8s_plus_28.k8s.VolumeAttachmentSpec

spec represents specification of the desired attach/detach volume behavior.

Populated by the Kubernetes system.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### LabelSelector <a name="LabelSelector" id="cdk8s-plus-28.k8s.LabelSelector"></a>

A label selector is a label query over a set of resources.

The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LabelSelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LabelSelector(
  match_expressions: typing.List[LabelSelectorRequirement] = None,
  match_labels: typing.Mapping[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelector.property.matchExpressions">match_expressions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LabelSelectorRequirement]</code> | matchExpressions is a list of label selector requirements. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelector.property.matchLabels">match_labels</a></code> | <code>typing.Mapping[str]</code> | matchLabels is a map of {key,value} pairs. |

---

##### `match_expressions`<sup>Optional</sup> <a name="match_expressions" id="cdk8s-plus-28.k8s.LabelSelector.property.matchExpressions"></a>

```python
match_expressions: typing.List[LabelSelectorRequirement]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.LabelSelectorRequirement]

matchExpressions is a list of label selector requirements.

The requirements are ANDed.

---

##### `match_labels`<sup>Optional</sup> <a name="match_labels" id="cdk8s-plus-28.k8s.LabelSelector.property.matchLabels"></a>

```python
match_labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

matchLabels is a map of {key,value} pairs.

A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

---

### LabelSelectorOptions <a name="LabelSelectorOptions" id="cdk8s-plus-28.LabelSelectorOptions"></a>

Options for `LabelSelector.of`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.LabelSelectorOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelSelectorOptions(
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelectorOptions.property.expressions">expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]</code> | Expression based label matchers. |
| <code><a href="#cdk8s-plus-28.LabelSelectorOptions.property.labels">labels</a></code> | <code>typing.Mapping[str]</code> | Strict label matchers. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.LabelSelectorOptions.property.expressions"></a>

```python
expressions: typing.List[LabelExpression]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]

Expression based label matchers.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.LabelSelectorOptions.property.labels"></a>

```python
labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Strict label matchers.

---

### LabelSelectorRequirement <a name="LabelSelectorRequirement" id="cdk8s-plus-28.LabelSelectorRequirement"></a>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.LabelSelectorRequirement.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelSelectorRequirement(
  key: str,
  operator: str,
  values: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.key">key</a></code> | <code>str</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.operator">operator</a></code> | <code>str</code> | Represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.values">values</a></code> | <code>typing.List[str]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelSelectorRequirement.property.key"></a>

```python
key: str
```

- *Type:* str

The label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.LabelSelectorRequirement.property.operator"></a>

```python
operator: str
```

- *Type:* str

Represents a key's relationship to a set of values.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.LabelSelectorRequirement.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

An array of string values.

If the operator is In or NotIn, the values array
must be non-empty. If the operator is Exists or DoesNotExist,
the values array must be empty. This array is replaced during a strategic merge patch.

---

### LabelSelectorRequirement <a name="LabelSelectorRequirement" id="cdk8s-plus-28.k8s.LabelSelectorRequirement"></a>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LabelSelectorRequirement(
  key: str,
  operator: str,
  values: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.key">key</a></code> | <code>str</code> | key is the label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.operator">operator</a></code> | <code>str</code> | operator represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.values">values</a></code> | <code>typing.List[str]</code> | values is an array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.key"></a>

```python
key: str
```

- *Type:* str

key is the label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.operator"></a>

```python
operator: str
```

- *Type:* str

operator represents a key's relationship to a set of values.

Valid operators are In, NotIn, Exists and DoesNotExist.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

values is an array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

---

### LeaseSpec <a name="LeaseSpec" id="cdk8s-plus-28.k8s.LeaseSpec"></a>

LeaseSpec is a specification of a Lease.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LeaseSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LeaseSpec(
  acquire_time: datetime.datetime = None,
  holder_identity: str = None,
  lease_duration_seconds: typing.Union[int, float] = None,
  lease_transitions: typing.Union[int, float] = None,
  renew_time: datetime.datetime = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.acquireTime">acquire_time</a></code> | <code>datetime.datetime</code> | acquireTime is a time when the current lease was acquired. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.holderIdentity">holder_identity</a></code> | <code>str</code> | holderIdentity contains the identity of the holder of a current lease. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.leaseDurationSeconds">lease_duration_seconds</a></code> | <code>typing.Union[int, float]</code> | leaseDurationSeconds is a duration that candidates for a lease need to wait to force acquire it. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.leaseTransitions">lease_transitions</a></code> | <code>typing.Union[int, float]</code> | leaseTransitions is the number of transitions of a lease between holders. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.renewTime">renew_time</a></code> | <code>datetime.datetime</code> | renewTime is a time when the current holder of a lease has last updated the lease. |

---

##### `acquire_time`<sup>Optional</sup> <a name="acquire_time" id="cdk8s-plus-28.k8s.LeaseSpec.property.acquireTime"></a>

```python
acquire_time: datetime.datetime
```

- *Type:* datetime.datetime

acquireTime is a time when the current lease was acquired.

---

##### `holder_identity`<sup>Optional</sup> <a name="holder_identity" id="cdk8s-plus-28.k8s.LeaseSpec.property.holderIdentity"></a>

```python
holder_identity: str
```

- *Type:* str

holderIdentity contains the identity of the holder of a current lease.

---

##### `lease_duration_seconds`<sup>Optional</sup> <a name="lease_duration_seconds" id="cdk8s-plus-28.k8s.LeaseSpec.property.leaseDurationSeconds"></a>

```python
lease_duration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

leaseDurationSeconds is a duration that candidates for a lease need to wait to force acquire it.

This is measure against time of last observed renewTime.

---

##### `lease_transitions`<sup>Optional</sup> <a name="lease_transitions" id="cdk8s-plus-28.k8s.LeaseSpec.property.leaseTransitions"></a>

```python
lease_transitions: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

leaseTransitions is the number of transitions of a lease between holders.

---

##### `renew_time`<sup>Optional</sup> <a name="renew_time" id="cdk8s-plus-28.k8s.LeaseSpec.property.renewTime"></a>

```python
renew_time: datetime.datetime
```

- *Type:* datetime.datetime

renewTime is a time when the current holder of a lease has last updated the lease.

---

### Lifecycle <a name="Lifecycle" id="cdk8s-plus-28.k8s.Lifecycle"></a>

Lifecycle describes actions that the management system should take in response to container lifecycle events.

For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Lifecycle.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Lifecycle(
  post_start: LifecycleHandler = None,
  pre_stop: LifecycleHandler = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Lifecycle.property.postStart">post_start</a></code> | <code>cdk8s_plus_28.k8s.LifecycleHandler</code> | PostStart is called immediately after a container is created. |
| <code><a href="#cdk8s-plus-28.k8s.Lifecycle.property.preStop">pre_stop</a></code> | <code>cdk8s_plus_28.k8s.LifecycleHandler</code> | PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. |

---

##### `post_start`<sup>Optional</sup> <a name="post_start" id="cdk8s-plus-28.k8s.Lifecycle.property.postStart"></a>

```python
post_start: LifecycleHandler
```

- *Type:* cdk8s_plus_28.k8s.LifecycleHandler

PostStart is called immediately after a container is created.

If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

---

##### `pre_stop`<sup>Optional</sup> <a name="pre_stop" id="cdk8s-plus-28.k8s.Lifecycle.property.preStop"></a>

```python
pre_stop: LifecycleHandler
```

- *Type:* cdk8s_plus_28.k8s.LifecycleHandler

PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc.

The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

---

### LifecycleHandler <a name="LifecycleHandler" id="cdk8s-plus-28.k8s.LifecycleHandler"></a>

LifecycleHandler defines a specific action that should be taken in a lifecycle hook.

One and only one of the fields, except TCPSocket must be specified.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LifecycleHandler.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LifecycleHandler(
  exec: ExecAction = None,
  http_get: HttpGetAction = None,
  tcp_socket: TcpSocketAction = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.exec">exec</a></code> | <code>cdk8s_plus_28.k8s.ExecAction</code> | Exec specifies the action to take. |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.httpGet">http_get</a></code> | <code>cdk8s_plus_28.k8s.HttpGetAction</code> | HTTPGet specifies the http request to perform. |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.tcpSocket">tcp_socket</a></code> | <code>cdk8s_plus_28.k8s.TcpSocketAction</code> | Deprecated. |

---

##### `exec`<sup>Optional</sup> <a name="exec" id="cdk8s-plus-28.k8s.LifecycleHandler.property.exec"></a>

```python
exec: ExecAction
```

- *Type:* cdk8s_plus_28.k8s.ExecAction

Exec specifies the action to take.

---

##### `http_get`<sup>Optional</sup> <a name="http_get" id="cdk8s-plus-28.k8s.LifecycleHandler.property.httpGet"></a>

```python
http_get: HttpGetAction
```

- *Type:* cdk8s_plus_28.k8s.HttpGetAction

HTTPGet specifies the http request to perform.

---

##### `tcp_socket`<sup>Optional</sup> <a name="tcp_socket" id="cdk8s-plus-28.k8s.LifecycleHandler.property.tcpSocket"></a>

```python
tcp_socket: TcpSocketAction
```

- *Type:* cdk8s_plus_28.k8s.TcpSocketAction

Deprecated.

TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.

---

### LimitedPriorityLevelConfigurationV1Beta2 <a name="LimitedPriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2"></a>

LimitedPriorityLevelConfiguration specifies how to handle requests that are subject to limits.

It addresses two issues:

* How are requests for this priority level limited?
* What should be done with requests that exceed the limit?

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitedPriorityLevelConfigurationV1Beta2(
  assured_concurrency_shares: typing.Union[int, float] = None,
  borrowing_limit_percent: typing.Union[int, float] = None,
  lendable_percent: typing.Union[int, float] = None,
  limit_response: LimitResponseV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.assuredConcurrencyShares">assured_concurrency_shares</a></code> | <code>typing.Union[int, float]</code> | `assuredConcurrencyShares` (ACS) configures the execution limit, which is a limit on the number of requests of this priority level that may be exeucting at a given time. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.borrowingLimitPercent">borrowing_limit_percent</a></code> | <code>typing.Union[int, float]</code> | `borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.lendablePercent">lendable_percent</a></code> | <code>typing.Union[int, float]</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.limitResponse">limit_response</a></code> | <code>cdk8s_plus_28.k8s.LimitResponseV1Beta2</code> | `limitResponse` indicates what to do with requests that can not be executed right now. |

---

##### `assured_concurrency_shares`<sup>Optional</sup> <a name="assured_concurrency_shares" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.assuredConcurrencyShares"></a>

```python
assured_concurrency_shares: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`assuredConcurrencyShares` (ACS) configures the execution limit, which is a limit on the number of requests of this priority level that may be exeucting at a given time.

ACS must be a positive number. The server's concurrency limit (SCL) is divided among the concurrency-controlled priority levels in proportion to their assured concurrency shares. This produces the assured concurrency value (ACV) --- the number of requests that may be executing at a time --- for each such priority level:

ACV(l) = ceil( SCL * ACS(l) / ( sum[priority levels k] ACS(k) ) )

bigger numbers of ACS mean more reserved concurrent requests (at the expense of every other PL). This field has a default value of 30.

---

##### `borrowing_limit_percent`<sup>Optional</sup> <a name="borrowing_limit_percent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.borrowingLimitPercent"></a>

```python
borrowing_limit_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels.

The limit is known as this level's BorrowingConcurrencyLimit (BorrowingCL) and is a limit on the total number of seats that this level may borrow at any one time. This field holds the ratio of that limit to the level's nominal concurrency limit. When this field is non-nil, it must hold a non-negative integer and the limit is calculated as follows.

BorrowingCL(i) = round( NominalCL(i) * borrowingLimitPercent(i)/100.0 )

The value of this field can be more than 100, implying that this priority level can borrow a number of seats that is greater than its own nominal concurrency limit (NominalCL). When this field is left `nil`, the limit is effectively infinite.

---

##### `lendable_percent`<sup>Optional</sup> <a name="lendable_percent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.lendablePercent"></a>

```python
lendable_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

The value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `limit_response`<sup>Optional</sup> <a name="limit_response" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.limitResponse"></a>

```python
limit_response: LimitResponseV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.LimitResponseV1Beta2

`limitResponse` indicates what to do with requests that can not be executed right now.

---

### LimitedPriorityLevelConfigurationV1Beta3 <a name="LimitedPriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3"></a>

LimitedPriorityLevelConfiguration specifies how to handle requests that are subject to limits.

It addresses two issues:

* How are requests for this priority level limited?
* What should be done with requests that exceed the limit?

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitedPriorityLevelConfigurationV1Beta3(
  borrowing_limit_percent: typing.Union[int, float] = None,
  lendable_percent: typing.Union[int, float] = None,
  limit_response: LimitResponseV1Beta3 = None,
  nominal_concurrency_shares: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.borrowingLimitPercent">borrowing_limit_percent</a></code> | <code>typing.Union[int, float]</code> | `borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.lendablePercent">lendable_percent</a></code> | <code>typing.Union[int, float]</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.limitResponse">limit_response</a></code> | <code>cdk8s_plus_28.k8s.LimitResponseV1Beta3</code> | `limitResponse` indicates what to do with requests that can not be executed right now. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares">nominal_concurrency_shares</a></code> | <code>typing.Union[int, float]</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `borrowing_limit_percent`<sup>Optional</sup> <a name="borrowing_limit_percent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.borrowingLimitPercent"></a>

```python
borrowing_limit_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels.

The limit is known as this level's BorrowingConcurrencyLimit (BorrowingCL) and is a limit on the total number of seats that this level may borrow at any one time. This field holds the ratio of that limit to the level's nominal concurrency limit. When this field is non-nil, it must hold a non-negative integer and the limit is calculated as follows.

BorrowingCL(i) = round( NominalCL(i) * borrowingLimitPercent(i)/100.0 )

The value of this field can be more than 100, implying that this priority level can borrow a number of seats that is greater than its own nominal concurrency limit (NominalCL). When this field is left `nil`, the limit is effectively infinite.

---

##### `lendable_percent`<sup>Optional</sup> <a name="lendable_percent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.lendablePercent"></a>

```python
lendable_percent: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

The value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `limit_response`<sup>Optional</sup> <a name="limit_response" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.limitResponse"></a>

```python
limit_response: LimitResponseV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.LimitResponseV1Beta3

`limitResponse` indicates what to do with requests that can not be executed right now.

---

##### `nominal_concurrency_shares`<sup>Optional</sup> <a name="nominal_concurrency_shares" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares"></a>

```python
nominal_concurrency_shares: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats available at this priority level. This is used both for requests dispatched from this priority level as well as requests dispatched from other priority levels borrowing seats from this level. The server's concurrency limit (ServerCL) is divided among the Limited priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of 30.

---

### LimitRangeItem <a name="LimitRangeItem" id="cdk8s-plus-28.k8s.LimitRangeItem"></a>

LimitRangeItem defines a min/max usage limit for any resource that matches on kind.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitRangeItem.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitRangeItem(
  type: str,
  default: typing.Mapping[Quantity] = None,
  default_request: typing.Mapping[Quantity] = None,
  max: typing.Mapping[Quantity] = None,
  max_limit_request_ratio: typing.Mapping[Quantity] = None,
  min: typing.Mapping[Quantity] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.type">type</a></code> | <code>str</code> | Type of resource that this limit applies to. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.default">default</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Default resource requirement limit value by resource name if resource limit is omitted. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.defaultRequest">default_request</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | DefaultRequest is the default resource requirement request value by resource name if resource request is omitted. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.max">max</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Max usage constraints on this kind by resource name. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.maxLimitRequestRatio">max_limit_request_ratio</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.min">min</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Min usage constraints on this kind by resource name. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitRangeItem.property.type"></a>

```python
type: str
```

- *Type:* str

Type of resource that this limit applies to.

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.k8s.LimitRangeItem.property.default"></a>

```python
default: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Default resource requirement limit value by resource name if resource limit is omitted.

---

##### `default_request`<sup>Optional</sup> <a name="default_request" id="cdk8s-plus-28.k8s.LimitRangeItem.property.defaultRequest"></a>

```python
default_request: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.

---

##### `max`<sup>Optional</sup> <a name="max" id="cdk8s-plus-28.k8s.LimitRangeItem.property.max"></a>

```python
max: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Max usage constraints on this kind by resource name.

---

##### `max_limit_request_ratio`<sup>Optional</sup> <a name="max_limit_request_ratio" id="cdk8s-plus-28.k8s.LimitRangeItem.property.maxLimitRequestRatio"></a>

```python
max_limit_request_ratio: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value;

this represents the max burst for the named resource.

---

##### `min`<sup>Optional</sup> <a name="min" id="cdk8s-plus-28.k8s.LimitRangeItem.property.min"></a>

```python
min: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Min usage constraints on this kind by resource name.

---

### LimitRangeSpec <a name="LimitRangeSpec" id="cdk8s-plus-28.k8s.LimitRangeSpec"></a>

LimitRangeSpec defines a min/max usage limit for resources that match on kind.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitRangeSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitRangeSpec(
  limits: typing.List[LimitRangeItem]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeSpec.property.limits">limits</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LimitRangeItem]</code> | Limits is the list of LimitRangeItem objects that are enforced. |

---

##### `limits`<sup>Required</sup> <a name="limits" id="cdk8s-plus-28.k8s.LimitRangeSpec.property.limits"></a>

```python
limits: typing.List[LimitRangeItem]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.LimitRangeItem]

Limits is the list of LimitRangeItem objects that are enforced.

---

### LimitResponseV1Beta2 <a name="LimitResponseV1Beta2" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2"></a>

LimitResponse defines how to handle requests that can not be executed right now.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitResponseV1Beta2(
  type: str,
  queuing: QueuingConfigurationV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.type">type</a></code> | <code>str</code> | `type` is "Queue" or "Reject". |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.queuing">queuing</a></code> | <code>cdk8s_plus_28.k8s.QueuingConfigurationV1Beta2</code> | `queuing` holds the configuration parameters for queuing. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.type"></a>

```python
type: str
```

- *Type:* str

`type` is "Queue" or "Reject".

"Queue" means that requests that can not be executed upon arrival are held in a queue until they can be executed or a queuing limit is reached. "Reject" means that requests that can not be executed upon arrival are rejected. Required.

---

##### `queuing`<sup>Optional</sup> <a name="queuing" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.queuing"></a>

```python
queuing: QueuingConfigurationV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.QueuingConfigurationV1Beta2

`queuing` holds the configuration parameters for queuing.

This field may be non-empty only if `type` is `"Queue"`.

---

### LimitResponseV1Beta3 <a name="LimitResponseV1Beta3" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3"></a>

LimitResponse defines how to handle requests that can not be executed right now.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LimitResponseV1Beta3(
  type: str,
  queuing: QueuingConfigurationV1Beta3 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.type">type</a></code> | <code>str</code> | `type` is "Queue" or "Reject". |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.queuing">queuing</a></code> | <code>cdk8s_plus_28.k8s.QueuingConfigurationV1Beta3</code> | `queuing` holds the configuration parameters for queuing. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.type"></a>

```python
type: str
```

- *Type:* str

`type` is "Queue" or "Reject".

"Queue" means that requests that can not be executed upon arrival are held in a queue until they can be executed or a queuing limit is reached. "Reject" means that requests that can not be executed upon arrival are rejected. Required.

---

##### `queuing`<sup>Optional</sup> <a name="queuing" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.queuing"></a>

```python
queuing: QueuingConfigurationV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.QueuingConfigurationV1Beta3

`queuing` holds the configuration parameters for queuing.

This field may be non-empty only if `type` is `"Queue"`.

---

### ListMeta <a name="ListMeta" id="cdk8s-plus-28.k8s.ListMeta"></a>

ListMeta describes metadata that synthetic resources must have, including lists and various status objects.

A resource may have only one of {ObjectMeta, ListMeta}.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ListMeta.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ListMeta(
  continue: str = None,
  remaining_item_count: typing.Union[int, float] = None,
  resource_version: str = None,
  self_link: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.continue">continue</a></code> | <code>str</code> | continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.remainingItemCount">remaining_item_count</a></code> | <code>typing.Union[int, float]</code> | remainingItemCount is the number of subsequent items in the list which are not included in this list response. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.resourceVersion">resource_version</a></code> | <code>str</code> | String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.selfLink">self_link</a></code> | <code>str</code> | Deprecated: selfLink is a legacy read-only field that is no longer populated by the system. |

---

##### `continue`<sup>Optional</sup> <a name="continue" id="cdk8s-plus-28.k8s.ListMeta.property.continue"></a>

```python
continue: str
```

- *Type:* str

continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available.

The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.

---

##### `remaining_item_count`<sup>Optional</sup> <a name="remaining_item_count" id="cdk8s-plus-28.k8s.ListMeta.property.remainingItemCount"></a>

```python
remaining_item_count: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

remainingItemCount is the number of subsequent items in the list which are not included in this list response.

If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact.

---

##### `resource_version`<sup>Optional</sup> <a name="resource_version" id="cdk8s-plus-28.k8s.ListMeta.property.resourceVersion"></a>

```python
resource_version: str
```

- *Type:* str

String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed.

Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `self_link`<sup>Optional</sup> <a name="self_link" id="cdk8s-plus-28.k8s.ListMeta.property.selfLink"></a>

```python
self_link: str
```

- *Type:* str

Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

---

### LocalObjectReference <a name="LocalObjectReference" id="cdk8s-plus-28.k8s.LocalObjectReference"></a>

LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LocalObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LocalObjectReference(
  name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LocalObjectReference.property.name">name</a></code> | <code>str</code> | Name of the referent. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.LocalObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

### LocalVolumeSource <a name="LocalVolumeSource" id="cdk8s-plus-28.k8s.LocalVolumeSource"></a>

Local represents directly-attached storage with node affinity (Beta feature).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LocalVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.LocalVolumeSource(
  path: str,
  fs_type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LocalVolumeSource.property.path">path</a></code> | <code>str</code> | path of the full path to the volume on the node. |
| <code><a href="#cdk8s-plus-28.k8s.LocalVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.LocalVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path of the full path to the volume on the node.

It can be either a directory or block device (disk, partition, ...).

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.LocalVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

It applies only when the Path is a block device. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default value is to auto-select a filesystem if unspecified.

---

### ManagedFieldsEntry <a name="ManagedFieldsEntry" id="cdk8s-plus-28.k8s.ManagedFieldsEntry"></a>

ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource that the fieldset applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ManagedFieldsEntry(
  api_version: str = None,
  fields_type: str = None,
  fields_v1: typing.Any = None,
  manager: str = None,
  operation: str = None,
  subresource: str = None,
  time: datetime.datetime = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.apiVersion">api_version</a></code> | <code>str</code> | APIVersion defines the version of this resource that this field set applies to. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsType">fields_type</a></code> | <code>str</code> | FieldsType is the discriminator for the different fields format and version. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsV1">fields_v1</a></code> | <code>typing.Any</code> | FieldsV1 holds the first JSON version format as described in the "FieldsV1" type. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.manager">manager</a></code> | <code>str</code> | Manager is an identifier of the workflow managing these fields. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.operation">operation</a></code> | <code>str</code> | Operation is the type of operation which lead to this ManagedFieldsEntry being created. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.subresource">subresource</a></code> | <code>str</code> | Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.time">time</a></code> | <code>datetime.datetime</code> | Time is the timestamp of when the ManagedFields entry was added. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

APIVersion defines the version of this resource that this field set applies to.

The format is "group/version" just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

---

##### `fields_type`<sup>Optional</sup> <a name="fields_type" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsType"></a>

```python
fields_type: str
```

- *Type:* str

FieldsType is the discriminator for the different fields format and version.

There is currently only one possible value: "FieldsV1"

---

##### `fields_v1`<sup>Optional</sup> <a name="fields_v1" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsV1"></a>

```python
fields_v1: typing.Any
```

- *Type:* typing.Any

FieldsV1 holds the first JSON version format as described in the "FieldsV1" type.

---

##### `manager`<sup>Optional</sup> <a name="manager" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.manager"></a>

```python
manager: str
```

- *Type:* str

Manager is an identifier of the workflow managing these fields.

---

##### `operation`<sup>Optional</sup> <a name="operation" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.operation"></a>

```python
operation: str
```

- *Type:* str

Operation is the type of operation which lead to this ManagedFieldsEntry being created.

The only valid values for this field are 'Apply' and 'Update'.

---

##### `subresource`<sup>Optional</sup> <a name="subresource" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.subresource"></a>

```python
subresource: str
```

- *Type:* str

Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource.

The value of this field is used to distinguish between managers, even if they share the same name. For example, a status update will be distinct from a regular update using the same manager name. Note that the APIVersion field is not related to the Subresource field and it always corresponds to the version of the main resource.

---

##### `time`<sup>Optional</sup> <a name="time" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.time"></a>

```python
time: datetime.datetime
```

- *Type:* datetime.datetime

Time is the timestamp of when the ManagedFields entry was added.

The timestamp will also be updated if a field is added, the manager changes any of the owned fields value or removes a field. The timestamp does not update when a field is removed from the entry because another manager took it over.

---

### MatchCondition <a name="MatchCondition" id="cdk8s-plus-28.k8s.MatchCondition"></a>

MatchCondition represents a condition which must by fulfilled for a request to be sent to a webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchCondition.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MatchCondition(
  expression: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchCondition.property.expression">expression</a></code> | <code>str</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchCondition.property.name">name</a></code> | <code>str</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchCondition.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchCondition.property.name"></a>

```python
name: str
```

- *Type:* str

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '*' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9*.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchConditionV1Alpha1 <a name="MatchConditionV1Alpha1" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MatchConditionV1Alpha1(
  expression: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.expression">expression</a></code> | <code>str</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.name">name</a></code> | <code>str</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '*' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9*.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchConditionV1Beta1 <a name="MatchConditionV1Beta1" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1"></a>

MatchCondition represents a condition which must be fulfilled for a request to be sent to a webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MatchConditionV1Beta1(
  expression: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.expression">expression</a></code> | <code>str</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.name">name</a></code> | <code>str</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '*' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9*.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchResourcesV1Alpha1 <a name="MatchResourcesV1Alpha1" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1"></a>

MatchResources decides whether to run the admission control policy on an object based on whether it meets the match criteria.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MatchResourcesV1Alpha1(
  exclude_resource_rules: typing.List[NamedRuleWithOperationsV1Alpha1] = None,
  match_policy: str = None,
  namespace_selector: LabelSelector = None,
  object_selector: LabelSelector = None,
  resource_rules: typing.List[NamedRuleWithOperationsV1Alpha1] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.excludeResourceRules">exclude_resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Alpha1]</code> | ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.matchPolicy">match_policy</a></code> | <code>str</code> | matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.objectSelector">object_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the validation based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.resourceRules">resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Alpha1]</code> | ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches. |

---

##### `exclude_resource_rules`<sup>Optional</sup> <a name="exclude_resource_rules" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.excludeResourceRules"></a>

```python
exclude_resource_rules: typing.List[NamedRuleWithOperationsV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Alpha1]

ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

---

##### `match_policy`<sup>Optional</sup> <a name="match_policy" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.matchPolicy"></a>

```python
match_policy: str
```

- *Type:* str
- *Default:* Equivalent"

matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

* Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the ValidatingAdmissionPolicy.
* Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the ValidatingAdmissionPolicy.

Defaults to "Equivalent"

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the policy.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the policy on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `object_selector`<sup>Optional</sup> <a name="object_selector" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.objectSelector"></a>

```python
object_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the validation based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the cel validation, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `resource_rules`<sup>Optional</sup> <a name="resource_rules" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.resourceRules"></a>

```python
resource_rules: typing.List[NamedRuleWithOperationsV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Alpha1]

ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches.

The policy cares about an operation if it matches *any* Rule.

---

### MatchResourcesV1Beta1 <a name="MatchResourcesV1Beta1" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1"></a>

MatchResources decides whether to run the admission control policy on an object based on whether it meets the match criteria.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MatchResourcesV1Beta1(
  exclude_resource_rules: typing.List[NamedRuleWithOperationsV1Beta1] = None,
  match_policy: str = None,
  namespace_selector: LabelSelector = None,
  object_selector: LabelSelector = None,
  resource_rules: typing.List[NamedRuleWithOperationsV1Beta1] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.excludeResourceRules">exclude_resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Beta1]</code> | ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.matchPolicy">match_policy</a></code> | <code>str</code> | matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.objectSelector">object_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the validation based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.resourceRules">resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Beta1]</code> | ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches. |

---

##### `exclude_resource_rules`<sup>Optional</sup> <a name="exclude_resource_rules" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.excludeResourceRules"></a>

```python
exclude_resource_rules: typing.List[NamedRuleWithOperationsV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Beta1]

ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

---

##### `match_policy`<sup>Optional</sup> <a name="match_policy" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.matchPolicy"></a>

```python
match_policy: str
```

- *Type:* str
- *Default:* Equivalent"

matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

* Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the ValidatingAdmissionPolicy.
* Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the ValidatingAdmissionPolicy.

Defaults to "Equivalent"

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the policy.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the policy on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `object_selector`<sup>Optional</sup> <a name="object_selector" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.objectSelector"></a>

```python
object_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the validation based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the cel validation, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `resource_rules`<sup>Optional</sup> <a name="resource_rules" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.resourceRules"></a>

```python
resource_rules: typing.List[NamedRuleWithOperationsV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NamedRuleWithOperationsV1Beta1]

ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches.

The policy cares about an operation if it matches *any* Rule.

---

### MemoryResources <a name="MemoryResources" id="cdk8s-plus-28.MemoryResources"></a>

Memory request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MemoryResources.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MemoryResources(
  limit: Size = None,
  request: Size = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MemoryResources.property.limit">limit</a></code> | <code>cdk8s.Size</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.MemoryResources.property.request">request</a></code> | <code>cdk8s.Size</code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.MemoryResources.property.limit"></a>

```python
limit: Size
```

- *Type:* cdk8s.Size

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.MemoryResources.property.request"></a>

```python
request: Size
```

- *Type:* cdk8s.Size

---

### MetricContainerResourceOptions <a name="MetricContainerResourceOptions" id="cdk8s-plus-28.MetricContainerResourceOptions"></a>

Options for `Metric.containerResource()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricContainerResourceOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricContainerResourceOptions(
  container: Container,
  target: MetricTarget
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricContainerResourceOptions.property.container">container</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a></code> | Container where the metric can be found. |
| <code><a href="#cdk8s-plus-28.MetricContainerResourceOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | Target metric value that will trigger scaling. |

---

##### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.MetricContainerResourceOptions.property.container"></a>

```python
container: Container
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricContainerResourceOptions.property.target"></a>

```python
target: MetricTarget
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

### MetricIdentifierV2 <a name="MetricIdentifierV2" id="cdk8s-plus-28.k8s.MetricIdentifierV2"></a>

MetricIdentifier defines the name and optionally selector for a metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricIdentifierV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MetricIdentifierV2(
  name: str,
  selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricIdentifierV2.property.name">name</a></code> | <code>str</code> | name is the name of the given metric. |
| <code><a href="#cdk8s-plus-28.k8s.MetricIdentifierV2.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | selector is the string-encoded form of a standard kubernetes label selector for the given metric When set, it is passed as an additional parameter to the metrics server for more specific metrics scoping. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MetricIdentifierV2.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the given metric.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.MetricIdentifierV2.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

selector is the string-encoded form of a standard kubernetes label selector for the given metric When set, it is passed as an additional parameter to the metrics server for more specific metrics scoping.

When unset, just the metricName will be used to gather metrics.

---

### MetricObjectOptions <a name="MetricObjectOptions" id="cdk8s-plus-28.MetricObjectOptions"></a>

Options for `Metric.object()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricObjectOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricObjectOptions(
  name: str,
  target: MetricTarget,
  label_selector: LabelSelector = None,
  object: IResource
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.name">name</a></code> | <code>str</code> | The name of the metric to scale on. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | The target metric value that will trigger scaling. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.labelSelector">label_selector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to find a metric by label. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.object">object</a></code> | <code><a href="#cdk8s-plus-28.IResource">IResource</a></code> | Resource where the metric can be found. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.MetricObjectOptions.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the metric to scale on.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricObjectOptions.property.target"></a>

```python
target: MetricTarget
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

##### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.MetricObjectOptions.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

##### `object`<sup>Required</sup> <a name="object" id="cdk8s-plus-28.MetricObjectOptions.property.object"></a>

```python
object: IResource
```

- *Type:* <a href="#cdk8s-plus-28.IResource">IResource</a>

Resource where the metric can be found.

---

### MetricOptions <a name="MetricOptions" id="cdk8s-plus-28.MetricOptions"></a>

Base options for a Metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricOptions(
  name: str,
  target: MetricTarget,
  label_selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.name">name</a></code> | <code>str</code> | The name of the metric to scale on. |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | The target metric value that will trigger scaling. |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.labelSelector">label_selector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to find a metric by label. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.MetricOptions.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the metric to scale on.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricOptions.property.target"></a>

```python
target: MetricTarget
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

##### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.MetricOptions.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

### MetricSpecV2 <a name="MetricSpecV2" id="cdk8s-plus-28.k8s.MetricSpecV2"></a>

MetricSpec specifies how to scale based on a single metric (only `type` and one other matching field should be set at once).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricSpecV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MetricSpecV2(
  type: str,
  container_resource: ContainerResourceMetricSourceV2 = None,
  external: ExternalMetricSourceV2 = None,
  object: ObjectMetricSourceV2 = None,
  pods: PodsMetricSourceV2 = None,
  resource: ResourceMetricSourceV2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.type">type</a></code> | <code>str</code> | type is the type of metric source. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.containerResource">container_resource</a></code> | <code>cdk8s_plus_28.k8s.ContainerResourceMetricSourceV2</code> | containerResource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing a single container in each pod of the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. This is an alpha feature and can be enabled by the HPAContainerMetrics feature flag. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.external">external</a></code> | <code>cdk8s_plus_28.k8s.ExternalMetricSourceV2</code> | external refers to a global metric that is not associated with any Kubernetes object. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.object">object</a></code> | <code>cdk8s_plus_28.k8s.ObjectMetricSourceV2</code> | object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object). |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.pods">pods</a></code> | <code>cdk8s_plus_28.k8s.PodsMetricSourceV2</code> | pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second). |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.resource">resource</a></code> | <code>cdk8s_plus_28.k8s.ResourceMetricSourceV2</code> | resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.MetricSpecV2.property.type"></a>

```python
type: str
```

- *Type:* str

type is the type of metric source.

It should be one of "ContainerResource", "External", "Object", "Pods" or "Resource", each mapping to a matching field in the object. Note: "ContainerResource" type is available on when the feature-gate HPAContainerMetrics is enabled

---

##### `container_resource`<sup>Optional</sup> <a name="container_resource" id="cdk8s-plus-28.k8s.MetricSpecV2.property.containerResource"></a>

```python
container_resource: ContainerResourceMetricSourceV2
```

- *Type:* cdk8s_plus_28.k8s.ContainerResourceMetricSourceV2

containerResource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing a single container in each pod of the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. This is an alpha feature and can be enabled by the HPAContainerMetrics feature flag.

---

##### `external`<sup>Optional</sup> <a name="external" id="cdk8s-plus-28.k8s.MetricSpecV2.property.external"></a>

```python
external: ExternalMetricSourceV2
```

- *Type:* cdk8s_plus_28.k8s.ExternalMetricSourceV2

external refers to a global metric that is not associated with any Kubernetes object.

It allows autoscaling based on information coming from components running outside of cluster (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).

---

##### `object`<sup>Optional</sup> <a name="object" id="cdk8s-plus-28.k8s.MetricSpecV2.property.object"></a>

```python
object: ObjectMetricSourceV2
```

- *Type:* cdk8s_plus_28.k8s.ObjectMetricSourceV2

object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object).

---

##### `pods`<sup>Optional</sup> <a name="pods" id="cdk8s-plus-28.k8s.MetricSpecV2.property.pods"></a>

```python
pods: PodsMetricSourceV2
```

- *Type:* cdk8s_plus_28.k8s.PodsMetricSourceV2

pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second).

The values will be averaged together before being compared to the target value.

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.MetricSpecV2.property.resource"></a>

```python
resource: ResourceMetricSourceV2
```

- *Type:* cdk8s_plus_28.k8s.ResourceMetricSourceV2

resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.

---

### MetricTargetV2 <a name="MetricTargetV2" id="cdk8s-plus-28.k8s.MetricTargetV2"></a>

MetricTarget defines the target value, average value, or average utilization of a specific metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricTargetV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MetricTargetV2(
  type: str,
  average_utilization: typing.Union[int, float] = None,
  average_value: Quantity = None,
  value: Quantity = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.type">type</a></code> | <code>str</code> | type represents whether the metric type is Utilization, Value, or AverageValue. |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.averageUtilization">average_utilization</a></code> | <code>typing.Union[int, float]</code> | averageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods. |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.averageValue">average_value</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | averageValue is the target value of the average of the metric across all relevant pods (as a quantity). |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.value">value</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | value is the target value of the metric (as a quantity). |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.MetricTargetV2.property.type"></a>

```python
type: str
```

- *Type:* str

type represents whether the metric type is Utilization, Value, or AverageValue.

---

##### `average_utilization`<sup>Optional</sup> <a name="average_utilization" id="cdk8s-plus-28.k8s.MetricTargetV2.property.averageUtilization"></a>

```python
average_utilization: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

averageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.

Currently only valid for Resource metric source type

---

##### `average_value`<sup>Optional</sup> <a name="average_value" id="cdk8s-plus-28.k8s.MetricTargetV2.property.averageValue"></a>

```python
average_value: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

averageValue is the target value of the average of the metric across all relevant pods (as a quantity).

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.MetricTargetV2.property.value"></a>

```python
value: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

value is the target value of the metric (as a quantity).

---

### MountOptions <a name="MountOptions" id="cdk8s-plus-28.MountOptions"></a>

Options for mounts.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MountOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MountOptions(
  propagation: MountPropagation = None,
  read_only: bool = None,
  sub_path: str = None,
  sub_path_expr: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MountOptions.property.propagation">propagation</a></code> | <code><a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a></code> | Determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.MountOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.MountOptions.property.subPath">sub_path</a></code> | <code>str</code> | Path within the volume from which the container's volume should be mounted.). |
| <code><a href="#cdk8s-plus-28.MountOptions.property.subPathExpr">sub_path_expr</a></code> | <code>str</code> | Expanded path within the volume from which the container's volume should be mounted. |

---

##### `propagation`<sup>Optional</sup> <a name="propagation" id="cdk8s-plus-28.MountOptions.property.propagation"></a>

```python
propagation: MountPropagation
```

- *Type:* <a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a>
- *Default:* MountPropagation.NONE

Determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used.

Mount propagation allows for sharing volumes mounted by a Container to
other Containers in the same Pod, or even to other Pods on the same node.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.MountOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `sub_path`<sup>Optional</sup> <a name="sub_path" id="cdk8s-plus-28.MountOptions.property.subPath"></a>

```python
sub_path: str
```

- *Type:* str
- *Default:* "" the volume's root

Path within the volume from which the container's volume should be mounted.).

---

##### `sub_path_expr`<sup>Optional</sup> <a name="sub_path_expr" id="cdk8s-plus-28.MountOptions.property.subPathExpr"></a>

```python
sub_path_expr: str
```

- *Type:* str
- *Default:* "" volume's root.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references
$(VAR_NAME) are expanded using the container's environment. Defaults to ""
(volume's root).

`subPathExpr` and `subPath` are mutually exclusive.

---

### MutatingWebhook <a name="MutatingWebhook" id="cdk8s-plus-28.k8s.MutatingWebhook"></a>

MutatingWebhook describes an admission webhook and the resources and operations it applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MutatingWebhook.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.MutatingWebhook(
  admission_review_versions: typing.List[str],
  client_config: WebhookClientConfig,
  name: str,
  side_effects: str,
  failure_policy: str = None,
  match_conditions: typing.List[MatchCondition] = None,
  match_policy: str = None,
  namespace_selector: LabelSelector = None,
  object_selector: LabelSelector = None,
  reinvocation_policy: str = None,
  rules: typing.List[RuleWithOperations] = None,
  timeout_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.admissionReviewVersions">admission_review_versions</a></code> | <code>typing.List[str]</code> | AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.clientConfig">client_config</a></code> | <code>cdk8s_plus_28.k8s.WebhookClientConfig</code> | ClientConfig defines how to communicate with the hook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.name">name</a></code> | <code>str</code> | The name of the admission webhook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.sideEffects">side_effects</a></code> | <code>str</code> | SideEffects states whether this webhook has side effects. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.failurePolicy">failure_policy</a></code> | <code>str</code> | FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.matchConditions">match_conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MatchCondition]</code> | MatchConditions is a list of conditions that must be met for a request to be sent to this webhook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.matchPolicy">match_policy</a></code> | <code>str</code> | matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.objectSelector">object_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the webhook based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.reinvocationPolicy">reinvocation_policy</a></code> | <code>str</code> | reinvocationPolicy indicates whether this webhook should be called multiple times as part of a single admission evaluation. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.RuleWithOperations]</code> | Rules describes what operations on what resources/subresources the webhook cares about. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.timeoutSeconds">timeout_seconds</a></code> | <code>typing.Union[int, float]</code> | TimeoutSeconds specifies the timeout for this webhook. |

---

##### `admission_review_versions`<sup>Required</sup> <a name="admission_review_versions" id="cdk8s-plus-28.k8s.MutatingWebhook.property.admissionReviewVersions"></a>

```python
admission_review_versions: typing.List[str]
```

- *Type:* typing.List[str]

AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects.

API server will try to use first version in the list which it supports. If none of the versions specified in this list supported by API server, validation will fail for this object. If a persisted webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail and be subject to the failure policy.

---

##### `client_config`<sup>Required</sup> <a name="client_config" id="cdk8s-plus-28.k8s.MutatingWebhook.property.clientConfig"></a>

```python
client_config: WebhookClientConfig
```

- *Type:* cdk8s_plus_28.k8s.WebhookClientConfig

ClientConfig defines how to communicate with the hook.

Required

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MutatingWebhook.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the admission webhook.

Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where "imagepolicy" is the name of the webhook, and kubernetes.io is the name of the organization. Required.

---

##### `side_effects`<sup>Required</sup> <a name="side_effects" id="cdk8s-plus-28.k8s.MutatingWebhook.property.sideEffects"></a>

```python
side_effects: str
```

- *Type:* str

SideEffects states whether this webhook has side effects.

Acceptable values are: None, NoneOnDryRun (webhooks created via v1beta1 may also specify Some or Unknown). Webhooks with side effects MUST implement a reconciliation system, since a request may be rejected by a future step in the admission chain and the side effects therefore need to be undone. Requests with the dryRun attribute will be auto-rejected if they match a webhook with sideEffects == Unknown or Some.

---

##### `failure_policy`<sup>Optional</sup> <a name="failure_policy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.failurePolicy"></a>

```python
failure_policy: str
```

- *Type:* str
- *Default:* Fail.

FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail.

Defaults to Fail.

---

##### `match_conditions`<sup>Optional</sup> <a name="match_conditions" id="cdk8s-plus-28.k8s.MutatingWebhook.property.matchConditions"></a>

```python
match_conditions: typing.List[MatchCondition]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MatchCondition]

MatchConditions is a list of conditions that must be met for a request to be sent to this webhook.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

The exact matching logic is (in order):

1. If ANY matchCondition evaluates to FALSE, the webhook is skipped.
2. If ALL matchConditions evaluate to TRUE, the webhook is called.
3. If any matchCondition evaluates to an error (but none are FALSE):

* If failurePolicy=Fail, reject the request
* If failurePolicy=Ignore, the error is ignored and the webhook is skipped

This is a beta feature and managed by the AdmissionWebhookMatchConditions feature gate.

---

##### `match_policy`<sup>Optional</sup> <a name="match_policy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.matchPolicy"></a>

```python
match_policy: str
```

- *Type:* str
- *Default:* Equivalent"

matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

* Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the webhook.
* Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the webhook.

Defaults to "Equivalent"

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.MutatingWebhook.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the webhook.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the webhook on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `object_selector`<sup>Optional</sup> <a name="object_selector" id="cdk8s-plus-28.k8s.MutatingWebhook.property.objectSelector"></a>

```python
object_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the webhook based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the webhook, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `reinvocation_policy`<sup>Optional</sup> <a name="reinvocation_policy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.reinvocationPolicy"></a>

```python
reinvocation_policy: str
```

- *Type:* str
- *Default:* Never".

reinvocationPolicy indicates whether this webhook should be called multiple times as part of a single admission evaluation.

Allowed values are "Never" and "IfNeeded".

Never: the webhook will not be called more than once in a single admission evaluation.

IfNeeded: the webhook will be called at least one additional time as part of the admission evaluation if the object being admitted is modified by other admission plugins after the initial webhook call. Webhooks that specify this option *must* be idempotent, able to process objects they previously admitted. Note: * the number of additional invocations is not guaranteed to be exactly one. * if additional invocations result in further modifications to the object, webhooks are not guaranteed to be invoked again. * webhooks that use this option may be reordered to minimize the number of additional invocations. * to validate an object after all mutations are guaranteed complete, use a validating admission webhook instead.

Defaults to "Never".

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.MutatingWebhook.property.rules"></a>

```python
rules: typing.List[RuleWithOperations]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.RuleWithOperations]

Rules describes what operations on what resources/subresources the webhook cares about.

The webhook cares about an operation if it matches *any* Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.k8s.MutatingWebhook.property.timeoutSeconds"></a>

```python
timeout_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 10 seconds.

TimeoutSeconds specifies the timeout for this webhook.

After the timeout passes, the webhook call will be ignored or the API call will fail based on the failure policy. The timeout value must be between 1 and 30 seconds. Default to 10 seconds.

---

### NamedRuleWithOperationsV1Alpha1 <a name="NamedRuleWithOperationsV1Alpha1" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1"></a>

NamedRuleWithOperations is a tuple of Operations and Resources with ResourceNames.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NamedRuleWithOperationsV1Alpha1(
  api_groups: typing.List[str] = None,
  api_versions: typing.List[str] = None,
  operations: typing.List[str] = None,
  resource_names: typing.List[str] = None,
  resources: typing.List[str] = None,
  scope: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiVersions">api_versions</a></code> | <code>typing.List[str]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.operations">operations</a></code> | <code>typing.List[str]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resourceNames">resource_names</a></code> | <code>typing.List[str]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resources">resources</a></code> | <code>typing.List[str]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.scope">scope</a></code> | <code>str</code> | scope specifies the scope of this rule. |

---

##### `api_groups`<sup>Optional</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `api_versions`<sup>Optional</sup> <a name="api_versions" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiVersions"></a>

```python
api_versions: typing.List[str]
```

- *Type:* typing.List[str]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.operations"></a>

```python
operations: typing.List[str]
```

- *Type:* typing.List[str]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resource_names`<sup>Optional</sup> <a name="resource_names" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resourceNames"></a>

```python
resource_names: typing.List[str]
```

- *Type:* typing.List[str]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.scope"></a>

```python
scope: str
```

- *Type:* str
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### NamedRuleWithOperationsV1Beta1 <a name="NamedRuleWithOperationsV1Beta1" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1"></a>

NamedRuleWithOperations is a tuple of Operations and Resources with ResourceNames.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NamedRuleWithOperationsV1Beta1(
  api_groups: typing.List[str] = None,
  api_versions: typing.List[str] = None,
  operations: typing.List[str] = None,
  resource_names: typing.List[str] = None,
  resources: typing.List[str] = None,
  scope: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiVersions">api_versions</a></code> | <code>typing.List[str]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.operations">operations</a></code> | <code>typing.List[str]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resourceNames">resource_names</a></code> | <code>typing.List[str]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resources">resources</a></code> | <code>typing.List[str]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.scope">scope</a></code> | <code>str</code> | scope specifies the scope of this rule. |

---

##### `api_groups`<sup>Optional</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `api_versions`<sup>Optional</sup> <a name="api_versions" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiVersions"></a>

```python
api_versions: typing.List[str]
```

- *Type:* typing.List[str]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.operations"></a>

```python
operations: typing.List[str]
```

- *Type:* typing.List[str]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resource_names`<sup>Optional</sup> <a name="resource_names" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resourceNames"></a>

```python
resource_names: typing.List[str]
```

- *Type:* typing.List[str]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.scope"></a>

```python
scope: str
```

- *Type:* str
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### NamespaceProps <a name="NamespaceProps" id="cdk8s-plus-28.NamespaceProps"></a>

Properties for `Namespace`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespaceProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NamespaceProps(
  metadata: ApiObjectMetadata = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespaceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.NamespaceProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

### NamespaceSelectorConfig <a name="NamespaceSelectorConfig" id="cdk8s-plus-28.NamespaceSelectorConfig"></a>

Configuration for selecting namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespaceSelectorConfig.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NamespaceSelectorConfig(
  label_selector: LabelSelector = None,
  names: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig.property.labelSelector">label_selector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to select namespaces by labels. |
| <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig.property.names">names</a></code> | <code>typing.List[str]</code> | A list of names to select namespaces by names. |

---

##### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.NamespaceSelectorConfig.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

A selector to select namespaces by labels.

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.NamespaceSelectorConfig.property.names"></a>

```python
names: typing.List[str]
```

- *Type:* typing.List[str]

A list of names to select namespaces by names.

---

### NamespaceSpec <a name="NamespaceSpec" id="cdk8s-plus-28.k8s.NamespaceSpec"></a>

NamespaceSpec describes the attributes on a Namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamespaceSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NamespaceSpec(
  finalizers: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamespaceSpec.property.finalizers">finalizers</a></code> | <code>typing.List[str]</code> | Finalizers is an opaque list of values that must be empty to permanently remove object from storage. |

---

##### `finalizers`<sup>Optional</sup> <a name="finalizers" id="cdk8s-plus-28.k8s.NamespaceSpec.property.finalizers"></a>

```python
finalizers: typing.List[str]
```

- *Type:* typing.List[str]

Finalizers is an opaque list of values that must be empty to permanently remove object from storage.

More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/

---

### NamespacesSelectOptions <a name="NamespacesSelectOptions" id="cdk8s-plus-28.NamespacesSelectOptions"></a>

Options for `Namespaces.select`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespacesSelectOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NamespacesSelectOptions(
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None,
  names: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.expressions">expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]</code> | Namespaces must satisfy these selectors. |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.labels">labels</a></code> | <code>typing.Mapping[str]</code> | Labels the namespaces must have. |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.names">names</a></code> | <code>typing.List[str]</code> | Namespaces names must be one of these. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.NamespacesSelectOptions.property.expressions"></a>

```python
expressions: typing.List[LabelExpression]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]
- *Default:* no selector requirements.

Namespaces must satisfy these selectors.

The selectors query labels, just like the `labels` property, but they
provide a more advanced matching mechanism.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.NamespacesSelectOptions.property.labels"></a>

```python
labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]
- *Default:* no strict labels requirements.

Labels the namespaces must have.

This is equivalent to using an 'Is' selector.

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.NamespacesSelectOptions.property.names"></a>

```python
names: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* no name requirements.

Namespaces names must be one of these.

---

### NetworkPolicyAddEgressRuleOptions <a name="NetworkPolicyAddEgressRuleOptions" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions"></a>

Options for `NetworkPolicy.addEgressRule`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyAddEgressRuleOptions(
  ports: typing.List[NetworkPolicyPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]</code> | Ports the rule should allow outgoing traffic to. |

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* If the peer is a managed pod, take its ports. Otherwise, all ports are allowed.

Ports the rule should allow outgoing traffic to.

---

### NetworkPolicyEgressRule <a name="NetworkPolicyEgressRule" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule"></a>

NetworkPolicyEgressRule describes a particular set of traffic that is allowed out of pods matched by a NetworkPolicySpec's podSelector.

The traffic must match both ports and to. This type is beta-level in 1.8

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NetworkPolicyEgressRule(
  ports: typing.List[NetworkPolicyPort] = None,
  to: typing.List[NetworkPolicyPeer] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyPort]</code> | ports is a list of destination ports for outgoing traffic. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.to">to</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyPeer]</code> | to is a list of destinations for outgoing traffic of pods selected for this rule. |

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyPort]

ports is a list of destination ports for outgoing traffic.

Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.

---

##### `to`<sup>Optional</sup> <a name="to" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.to"></a>

```python
to: typing.List[NetworkPolicyPeer]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyPeer]

to is a list of destinations for outgoing traffic of pods selected for this rule.

Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.

---

### NetworkPolicyIngressRule <a name="NetworkPolicyIngressRule" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule"></a>

NetworkPolicyIngressRule describes a particular set of traffic that is allowed to the pods matched by a NetworkPolicySpec's podSelector.

The traffic must match both ports and from.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NetworkPolicyIngressRule(
  from: typing.List[NetworkPolicyPeer] = None,
  ports: typing.List[NetworkPolicyPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.from">from</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyPeer]</code> | from is a list of sources which should be able to access the pods selected for this rule. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyPort]</code> | ports is a list of ports which should be made accessible on the pods selected for this rule. |

---

##### `from`<sup>Optional</sup> <a name="from" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.from"></a>

```python
from: typing.List[NetworkPolicyPeer]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyPeer]

from is a list of sources which should be able to access the pods selected for this rule.

Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the from list.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyPort]

ports is a list of ports which should be made accessible on the pods selected for this rule.

Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.

---

### NetworkPolicyPeer <a name="NetworkPolicyPeer" id="cdk8s-plus-28.k8s.NetworkPolicyPeer"></a>

NetworkPolicyPeer describes a peer to allow traffic to/from.

Only certain combinations of fields are allowed

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NetworkPolicyPeer(
  ip_block: IpBlock = None,
  namespace_selector: LabelSelector = None,
  pod_selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.ipBlock">ip_block</a></code> | <code>cdk8s_plus_28.k8s.IpBlock</code> | ipBlock defines policy on a particular IPBlock. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | namespaceSelector selects namespaces using cluster-scoped labels. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.podSelector">pod_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | podSelector is a label selector which selects pods. |

---

##### `ip_block`<sup>Optional</sup> <a name="ip_block" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.ipBlock"></a>

```python
ip_block: IpBlock
```

- *Type:* cdk8s_plus_28.k8s.IpBlock

ipBlock defines policy on a particular IPBlock.

If this field is set then neither of the other fields can be.

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

namespaceSelector selects namespaces using cluster-scoped labels.

This field follows standard label selector semantics; if present but empty, it selects all namespaces.

If podSelector is also set, then the NetworkPolicyPeer as a whole selects the pods matching podSelector in the namespaces selected by namespaceSelector. Otherwise it selects all pods in the namespaces selected by namespaceSelector.

---

##### `pod_selector`<sup>Optional</sup> <a name="pod_selector" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.podSelector"></a>

```python
pod_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

podSelector is a label selector which selects pods.

This field follows standard label selector semantics; if present but empty, it selects all pods.

If namespaceSelector is also set, then the NetworkPolicyPeer as a whole selects the pods matching podSelector in the Namespaces selected by NamespaceSelector. Otherwise it selects the pods matching podSelector in the policy's own namespace.

---

### NetworkPolicyPeerConfig <a name="NetworkPolicyPeerConfig" id="cdk8s-plus-28.NetworkPolicyPeerConfig"></a>

Configuration for network peers.

A peer can either by an ip block, or a selection of pods, not both.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyPeerConfig.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPeerConfig(
  ip_block: NetworkPolicyIpBlock = None,
  pod_selector: PodSelectorConfig = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPeerConfig.property.ipBlock">ip_block</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a></code> | The ip block this peer represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPeerConfig.property.podSelector">pod_selector</a></code> | <code><a href="#cdk8s-plus-28.PodSelectorConfig">PodSelectorConfig</a></code> | The pod selector this peer represents. |

---

##### `ip_block`<sup>Optional</sup> <a name="ip_block" id="cdk8s-plus-28.NetworkPolicyPeerConfig.property.ipBlock"></a>

```python
ip_block: NetworkPolicyIpBlock
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a>

The ip block this peer represents.

---

##### `pod_selector`<sup>Optional</sup> <a name="pod_selector" id="cdk8s-plus-28.NetworkPolicyPeerConfig.property.podSelector"></a>

```python
pod_selector: PodSelectorConfig
```

- *Type:* <a href="#cdk8s-plus-28.PodSelectorConfig">PodSelectorConfig</a>

The pod selector this peer represents.

---

### NetworkPolicyPort <a name="NetworkPolicyPort" id="cdk8s-plus-28.k8s.NetworkPolicyPort"></a>

NetworkPolicyPort describes a port to allow traffic on.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyPort.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NetworkPolicyPort(
  end_port: typing.Union[int, float] = None,
  port: IntOrString = None,
  protocol: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.endPort">end_port</a></code> | <code>typing.Union[int, float]</code> | endPort indicates that the range of ports from port to endPort if set, inclusive, should be allowed by the policy. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.port">port</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | port represents the port on the given protocol. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.protocol">protocol</a></code> | <code>str</code> | protocol represents the protocol (TCP, UDP, or SCTP) which traffic must match. |

---

##### `end_port`<sup>Optional</sup> <a name="end_port" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.endPort"></a>

```python
end_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

endPort indicates that the range of ports from port to endPort if set, inclusive, should be allowed by the policy.

This field cannot be defined if the port field is not defined or if the port field is defined as a named (string) port. The endPort must be equal or greater than port.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.port"></a>

```python
port: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

port represents the port on the given protocol.

This can either be a numerical or named port on a pod. If this field is not provided, this matches all port names and numbers. If present, only traffic on the specified protocol AND port will be matched.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.protocol"></a>

```python
protocol: str
```

- *Type:* str

protocol represents the protocol (TCP, UDP, or SCTP) which traffic must match.

If not specified, this field defaults to TCP.

---

### NetworkPolicyPortProps <a name="NetworkPolicyPortProps" id="cdk8s-plus-28.NetworkPolicyPortProps"></a>

Properties for `NetworkPolicyPort`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyPortProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPortProps(
  end_port: typing.Union[int, float] = None,
  port: typing.Union[int, float] = None,
  protocol: NetworkProtocol = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.endPort">end_port</a></code> | <code>typing.Union[int, float]</code> | End port (relative to `port`). |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.port">port</a></code> | <code>typing.Union[int, float]</code> | Specific port number. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.NetworkProtocol">NetworkProtocol</a></code> | Protocol. |

---

##### `end_port`<sup>Optional</sup> <a name="end_port" id="cdk8s-plus-28.NetworkPolicyPortProps.property.endPort"></a>

```python
end_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* not a port range.

End port (relative to `port`).

Only applies if `port` is defined.
Use this to specify a port range, rather that a specific one.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPortProps.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* all ports are allowed.

Specific port number.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.NetworkPolicyPortProps.property.protocol"></a>

```python
protocol: NetworkProtocol
```

- *Type:* <a href="#cdk8s-plus-28.NetworkProtocol">NetworkProtocol</a>
- *Default:* NetworkProtocol.TCP

Protocol.

---

### NetworkPolicyProps <a name="NetworkPolicyProps" id="cdk8s-plus-28.NetworkPolicyProps"></a>

Properties for `NetworkPolicy`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyProps(
  metadata: ApiObjectMetadata = None,
  egress: NetworkPolicyTraffic = None,
  ingress: NetworkPolicyTraffic = None,
  selector: IPodSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.egress">egress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Egress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Ingress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods does this policy object applies to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.NetworkPolicyProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="cdk8s-plus-28.NetworkPolicyProps.property.egress"></a>

```python
egress: NetworkPolicyTraffic
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change egress behavior of the pods it selects.

Egress traffic configuration.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.NetworkPolicyProps.property.ingress"></a>

```python
ingress: NetworkPolicyTraffic
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change ingress behavior of the pods it selects.

Ingress traffic configuration.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.NetworkPolicyProps.property.selector"></a>

```python
selector: IPodSelector
```

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* will select all pods in the namespace of the policy.

Which pods does this policy object applies to.

This can either be a single pod / workload, or a grouping of pods selected
via the `Pods.select` function. Rules is applied to any pods selected by this property.
Multiple network policies can select the same set of pods.
In this case, the rules for each are combined additively.

Note that

---

### NetworkPolicyRule <a name="NetworkPolicyRule" id="cdk8s-plus-28.NetworkPolicyRule"></a>

Describes a rule allowing traffic from / to pods matched by a network policy selector.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyRule.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyRule(
  peer: INetworkPolicyPeer,
  ports: typing.List[NetworkPolicyPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyRule.property.peer">peer</a></code> | <code><a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a></code> | Peer this rule interacts with. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyRule.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]</code> | The ports of the rule. |

---

##### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicyRule.property.peer"></a>

```python
peer: INetworkPolicyPeer
```

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Peer this rule interacts with.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicyRule.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* traffic is allowed on all ports.

The ports of the rule.

---

### NetworkPolicySpec <a name="NetworkPolicySpec" id="cdk8s-plus-28.k8s.NetworkPolicySpec"></a>

NetworkPolicySpec provides the specification of a NetworkPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicySpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NetworkPolicySpec(
  pod_selector: LabelSelector,
  egress: typing.List[NetworkPolicyEgressRule] = None,
  ingress: typing.List[NetworkPolicyIngressRule] = None,
  policy_types: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.podSelector">pod_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | podSelector selects the pods to which this NetworkPolicy object applies. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.egress">egress</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyEgressRule]</code> | egress is a list of egress rules to be applied to the selected pods. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.ingress">ingress</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NetworkPolicyIngressRule]</code> | ingress is a list of ingress rules to be applied to the selected pods. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.policyTypes">policy_types</a></code> | <code>typing.List[str]</code> | policyTypes is a list of rule types that the NetworkPolicy relates to. |

---

##### `pod_selector`<sup>Required</sup> <a name="pod_selector" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.podSelector"></a>

```python
pod_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

podSelector selects the pods to which this NetworkPolicy object applies.

The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods. In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.egress"></a>

```python
egress: typing.List[NetworkPolicyEgressRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyEgressRule]

egress is a list of egress rules to be applied to the selected pods.

Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.ingress"></a>

```python
ingress: typing.List[NetworkPolicyIngressRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NetworkPolicyIngressRule]

ingress is a list of ingress rules to be applied to the selected pods.

Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)

---

##### `policy_types`<sup>Optional</sup> <a name="policy_types" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.policyTypes"></a>

```python
policy_types: typing.List[str]
```

- *Type:* typing.List[str]

policyTypes is a list of rule types that the NetworkPolicy relates to.

Valid options are ["Ingress"], ["Egress"], or ["Ingress", "Egress"]. If this field is not specified, it will default based on the existence of ingress or egress rules; policies that contain an egress section are assumed to affect egress, and all policies (whether or not they contain an ingress section) are assumed to affect ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ "Egress" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include "Egress" (since such a policy would not include an egress section and would otherwise default to just [ "Ingress" ]). This field is beta-level in 1.8

---

### NetworkPolicyTraffic <a name="NetworkPolicyTraffic" id="cdk8s-plus-28.NetworkPolicyTraffic"></a>

Describes how the network policy should configure egress / ingress traffic.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyTraffic.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyTraffic(
  default: NetworkPolicyTrafficDefault = None,
  rules: typing.List[NetworkPolicyRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic.property.default">default</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault">NetworkPolicyTrafficDefault</a></code> | Specifies the default behavior of the policy when no rules are defined. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NetworkPolicyRule">NetworkPolicyRule</a>]</code> | List of rules to be applied to the selected pods. |

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.NetworkPolicyTraffic.property.default"></a>

```python
default: NetworkPolicyTrafficDefault
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault">NetworkPolicyTrafficDefault</a>
- *Default:* unset, the policy does not change the behavior.

Specifies the default behavior of the policy when no rules are defined.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.NetworkPolicyTraffic.property.rules"></a>

```python
rules: typing.List[NetworkPolicyRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyRule">NetworkPolicyRule</a>]
- *Default:* no rules

List of rules to be applied to the selected pods.

If empty, the behavior of the policy is dictated by the `default` property.

---

### NfsVolumeOptions <a name="NfsVolumeOptions" id="cdk8s-plus-28.NfsVolumeOptions"></a>

Options for the NFS based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NfsVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NfsVolumeOptions(
  path: str,
  server: str,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.path">path</a></code> | <code>str</code> | Path that is exported by the NFS server. |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.server">server</a></code> | <code>str</code> | Server is the hostname or IP address of the NFS server. |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | If set to true, will force the NFS export to be mounted with read-only permissions. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.NfsVolumeOptions.property.path"></a>

```python
path: str
```

- *Type:* str

Path that is exported by the NFS server.

---

##### `server`<sup>Required</sup> <a name="server" id="cdk8s-plus-28.NfsVolumeOptions.property.server"></a>

```python
server: str
```

- *Type:* str

Server is the hostname or IP address of the NFS server.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.NfsVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

If set to true, will force the NFS export to be mounted with read-only permissions.

---

### NfsVolumeSource <a name="NfsVolumeSource" id="cdk8s-plus-28.k8s.NfsVolumeSource"></a>

Represents an NFS mount that lasts the lifetime of a pod.

NFS volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NfsVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NfsVolumeSource(
  path: str,
  server: str,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.path">path</a></code> | <code>str</code> | path that is exported by the NFS server. |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.server">server</a></code> | <code>str</code> | server is the hostname or IP address of the NFS server. |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the NFS export to be mounted with read-only permissions. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.path"></a>

```python
path: str
```

- *Type:* str

path that is exported by the NFS server.

More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `server`<sup>Required</sup> <a name="server" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.server"></a>

```python
server: str
```

- *Type:* str

server is the hostname or IP address of the NFS server.

More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

readOnly here will force the NFS export to be mounted with read-only permissions.

Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

### NodeAffinity <a name="NodeAffinity" id="cdk8s-plus-28.k8s.NodeAffinity"></a>

Node affinity is a group of node affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeAffinity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeAffinity(
  preferred_during_scheduling_ignored_during_execution: typing.List[PreferredSchedulingTerm] = None,
  required_during_scheduling_ignored_during_execution: NodeSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferred_during_scheduling_ignored_during_execution</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PreferredSchedulingTerm]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.NodeAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">required_during_scheduling_ignored_during_execution</a></code> | <code>cdk8s_plus_28.k8s.NodeSelector</code> | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferred_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="preferred_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.NodeAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```python
preferred_during_scheduling_ignored_during_execution: typing.List[PreferredSchedulingTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PreferredSchedulingTerm]

The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.

---

##### `required_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="required_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.NodeAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```python
required_during_scheduling_ignored_during_execution: NodeSelector
```

- *Type:* cdk8s_plus_28.k8s.NodeSelector

If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.

---

### NodeConfigSource <a name="NodeConfigSource" id="cdk8s-plus-28.k8s.NodeConfigSource"></a>

NodeConfigSource specifies a source of node configuration.

Exactly one subfield (excluding metadata) must be non-nil. This API is deprecated since 1.22

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeConfigSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeConfigSource(
  config_map: ConfigMapNodeConfigSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeConfigSource.property.configMap">config_map</a></code> | <code>cdk8s_plus_28.k8s.ConfigMapNodeConfigSource</code> | ConfigMap is a reference to a Node's ConfigMap. |

---

##### `config_map`<sup>Optional</sup> <a name="config_map" id="cdk8s-plus-28.k8s.NodeConfigSource.property.configMap"></a>

```python
config_map: ConfigMapNodeConfigSource
```

- *Type:* cdk8s_plus_28.k8s.ConfigMapNodeConfigSource

ConfigMap is a reference to a Node's ConfigMap.

---

### NodeSelector <a name="NodeSelector" id="cdk8s-plus-28.k8s.NodeSelector"></a>

A node selector represents the union of the results of one or more label queries over a set of nodes;

that is, it represents the OR of the selectors represented by the node selector terms.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeSelector(
  node_selector_terms: typing.List[NodeSelectorTerm]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelector.property.nodeSelectorTerms">node_selector_terms</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NodeSelectorTerm]</code> | Required. |

---

##### `node_selector_terms`<sup>Required</sup> <a name="node_selector_terms" id="cdk8s-plus-28.k8s.NodeSelector.property.nodeSelectorTerms"></a>

```python
node_selector_terms: typing.List[NodeSelectorTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NodeSelectorTerm]

Required.

A list of node selector terms. The terms are ORed.

---

### NodeSelectorRequirement <a name="NodeSelectorRequirement" id="cdk8s-plus-28.k8s.NodeSelectorRequirement"></a>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeSelectorRequirement(
  key: str,
  operator: str,
  values: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.key">key</a></code> | <code>str</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.operator">operator</a></code> | <code>str</code> | Represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.values">values</a></code> | <code>typing.List[str]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.key"></a>

```python
key: str
```

- *Type:* str

The label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.operator"></a>

```python
operator: str
```

- *Type:* str

Represents a key's relationship to a set of values.

Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

An array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.

---

### NodeSelectorTerm <a name="NodeSelectorTerm" id="cdk8s-plus-28.k8s.NodeSelectorTerm"></a>

A null or empty node selector term matches no objects.

The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelectorTerm.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeSelectorTerm(
  match_expressions: typing.List[NodeSelectorRequirement] = None,
  match_fields: typing.List[NodeSelectorRequirement] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchExpressions">match_expressions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NodeSelectorRequirement]</code> | A list of node selector requirements by node's labels. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchFields">match_fields</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NodeSelectorRequirement]</code> | A list of node selector requirements by node's fields. |

---

##### `match_expressions`<sup>Optional</sup> <a name="match_expressions" id="cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchExpressions"></a>

```python
match_expressions: typing.List[NodeSelectorRequirement]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NodeSelectorRequirement]

A list of node selector requirements by node's labels.

---

##### `match_fields`<sup>Optional</sup> <a name="match_fields" id="cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchFields"></a>

```python
match_fields: typing.List[NodeSelectorRequirement]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NodeSelectorRequirement]

A list of node selector requirements by node's fields.

---

### NodeSpec <a name="NodeSpec" id="cdk8s-plus-28.k8s.NodeSpec"></a>

NodeSpec describes the attributes that a node is created with.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NodeSpec(
  config_source: NodeConfigSource = None,
  external_id: str = None,
  pod_cidr: str = None,
  pod_cid_rs: typing.List[str] = None,
  provider_id: str = None,
  taints: typing.List[Taint] = None,
  unschedulable: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.configSource">config_source</a></code> | <code>cdk8s_plus_28.k8s.NodeConfigSource</code> | Deprecated: Previously used to specify the source of the node's configuration for the DynamicKubeletConfig feature. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.externalId">external_id</a></code> | <code>str</code> | Deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.podCidr">pod_cidr</a></code> | <code>str</code> | PodCIDR represents the pod IP range assigned to the node. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.podCidRs">pod_cid_rs</a></code> | <code>typing.List[str]</code> | podCIDRs represents the IP ranges assigned to the node for usage by Pods on that node. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.providerId">provider_id</a></code> | <code>str</code> | ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.taints">taints</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Taint]</code> | If specified, the node's taints. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.unschedulable">unschedulable</a></code> | <code>bool</code> | Unschedulable controls node schedulability of new pods. |

---

##### `config_source`<sup>Optional</sup> <a name="config_source" id="cdk8s-plus-28.k8s.NodeSpec.property.configSource"></a>

```python
config_source: NodeConfigSource
```

- *Type:* cdk8s_plus_28.k8s.NodeConfigSource

Deprecated: Previously used to specify the source of the node's configuration for the DynamicKubeletConfig feature.

This feature is removed.

---

##### `external_id`<sup>Optional</sup> <a name="external_id" id="cdk8s-plus-28.k8s.NodeSpec.property.externalId"></a>

```python
external_id: str
```

- *Type:* str

Deprecated.

Not all kubelets will set this field. Remove field after 1.13. see: https://issues.k8s.io/61966

---

##### `pod_cidr`<sup>Optional</sup> <a name="pod_cidr" id="cdk8s-plus-28.k8s.NodeSpec.property.podCidr"></a>

```python
pod_cidr: str
```

- *Type:* str

PodCIDR represents the pod IP range assigned to the node.

---

##### `pod_cid_rs`<sup>Optional</sup> <a name="pod_cid_rs" id="cdk8s-plus-28.k8s.NodeSpec.property.podCidRs"></a>

```python
pod_cid_rs: typing.List[str]
```

- *Type:* typing.List[str]

podCIDRs represents the IP ranges assigned to the node for usage by Pods on that node.

If this field is specified, the 0th entry must match the podCIDR field. It may contain at most 1 value for each of IPv4 and IPv6.

---

##### `provider_id`<sup>Optional</sup> <a name="provider_id" id="cdk8s-plus-28.k8s.NodeSpec.property.providerId"></a>

```python
provider_id: str
```

- *Type:* str

ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>.

---

##### `taints`<sup>Optional</sup> <a name="taints" id="cdk8s-plus-28.k8s.NodeSpec.property.taints"></a>

```python
taints: typing.List[Taint]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Taint]

If specified, the node's taints.

---

##### `unschedulable`<sup>Optional</sup> <a name="unschedulable" id="cdk8s-plus-28.k8s.NodeSpec.property.unschedulable"></a>

```python
unschedulable: bool
```

- *Type:* bool

Unschedulable controls node schedulability of new pods.

By default, node is schedulable. More info: https://kubernetes.io/docs/concepts/nodes/node/#manual-node-administration

---

### NodeTaintQueryOptions <a name="NodeTaintQueryOptions" id="cdk8s-plus-28.NodeTaintQueryOptions"></a>

Options for `NodeTaintQuery`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NodeTaintQueryOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeTaintQueryOptions(
  effect: TaintEffect = None,
  evict_after: Duration = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NodeTaintQueryOptions.property.effect">effect</a></code> | <code><a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a></code> | The taint effect to match. |
| <code><a href="#cdk8s-plus-28.NodeTaintQueryOptions.property.evictAfter">evict_after</a></code> | <code>cdk8s.Duration</code> | How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node. |

---

##### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.NodeTaintQueryOptions.property.effect"></a>

```python
effect: TaintEffect
```

- *Type:* <a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a>
- *Default:* all effects are matched.

The taint effect to match.

---

##### `evict_after`<sup>Optional</sup> <a name="evict_after" id="cdk8s-plus-28.NodeTaintQueryOptions.property.evictAfter"></a>

```python
evict_after: Duration
```

- *Type:* cdk8s.Duration
- *Default:* bound forever.

How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node.

Only applies for the `NO_EXECUTE` effect.

---

### NonResourceAttributes <a name="NonResourceAttributes" id="cdk8s-plus-28.k8s.NonResourceAttributes"></a>

NonResourceAttributes includes the authorization attributes available for non-resource requests to the Authorizer interface.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourceAttributes.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NonResourceAttributes(
  path: str = None,
  verb: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourceAttributes.property.path">path</a></code> | <code>str</code> | Path is the URL path of the request. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourceAttributes.property.verb">verb</a></code> | <code>str</code> | Verb is the standard HTTP verb. |

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.NonResourceAttributes.property.path"></a>

```python
path: str
```

- *Type:* str

Path is the URL path of the request.

---

##### `verb`<sup>Optional</sup> <a name="verb" id="cdk8s-plus-28.k8s.NonResourceAttributes.property.verb"></a>

```python
verb: str
```

- *Type:* str

Verb is the standard HTTP verb.

---

### NonResourcePolicyRuleV1Beta2 <a name="NonResourcePolicyRuleV1Beta2" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2"></a>

NonResourcePolicyRule is a predicate that matches non-resource requests according to their verb and the target non-resource URL.

A NonResourcePolicyRule matches a request if and only if both (a) at least one member of verbs matches the request and (b) at least one member of nonResourceURLs matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NonResourcePolicyRuleV1Beta2(
  non_resource_ur_ls: typing.List[str],
  verbs: typing.List[str]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.nonResourceUrLs">non_resource_ur_ls</a></code> | <code>typing.List[str]</code> | `nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | `verbs` is a list of matching verbs and may not be empty. |

---

##### `non_resource_ur_ls`<sup>Required</sup> <a name="non_resource_ur_ls" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.nonResourceUrLs"></a>

```python
non_resource_ur_ls: typing.List[str]
```

- *Type:* typing.List[str]

`nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty.

For example:

* "/healthz" is legal
* "/hea*" is illegal
* "/hea" is legal but matches nothing
* "/hea/*" also matches nothing
* "/healthz/*" matches all per-component health checks.
  "*" matches all non-resource urls. if it is present, it must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs. If it is present, it must be the only entry. Required.

---

### NonResourcePolicyRuleV1Beta3 <a name="NonResourcePolicyRuleV1Beta3" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3"></a>

NonResourcePolicyRule is a predicate that matches non-resource requests according to their verb and the target non-resource URL.

A NonResourcePolicyRule matches a request if and only if both (a) at least one member of verbs matches the request and (b) at least one member of nonResourceURLs matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.NonResourcePolicyRuleV1Beta3(
  non_resource_ur_ls: typing.List[str],
  verbs: typing.List[str]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.nonResourceUrLs">non_resource_ur_ls</a></code> | <code>typing.List[str]</code> | `nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | `verbs` is a list of matching verbs and may not be empty. |

---

##### `non_resource_ur_ls`<sup>Required</sup> <a name="non_resource_ur_ls" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.nonResourceUrLs"></a>

```python
non_resource_ur_ls: typing.List[str]
```

- *Type:* typing.List[str]

`nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty.

For example:

* "/healthz" is legal
* "/hea*" is illegal
* "/hea" is legal but matches nothing
* "/hea/*" also matches nothing
* "/healthz/*" matches all per-component health checks.
  "*" matches all non-resource urls. if it is present, it must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs. If it is present, it must be the only entry. Required.

---

### ObjectFieldSelector <a name="ObjectFieldSelector" id="cdk8s-plus-28.k8s.ObjectFieldSelector"></a>

ObjectFieldSelector selects an APIVersioned field of an object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectFieldSelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ObjectFieldSelector(
  field_path: str,
  api_version: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectFieldSelector.property.fieldPath">field_path</a></code> | <code>str</code> | Path of the field to select in the specified API version. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectFieldSelector.property.apiVersion">api_version</a></code> | <code>str</code> | Version of the schema the FieldPath is written in terms of, defaults to "v1". |

---

##### `field_path`<sup>Required</sup> <a name="field_path" id="cdk8s-plus-28.k8s.ObjectFieldSelector.property.fieldPath"></a>

```python
field_path: str
```

- *Type:* str

Path of the field to select in the specified API version.

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.ObjectFieldSelector.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

Version of the schema the FieldPath is written in terms of, defaults to "v1".

---

### ObjectMeta <a name="ObjectMeta" id="cdk8s-plus-28.k8s.ObjectMeta"></a>

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectMeta.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ObjectMeta(
  annotations: typing.Mapping[str] = None,
  creation_timestamp: datetime.datetime = None,
  deletion_grace_period_seconds: typing.Union[int, float] = None,
  deletion_timestamp: datetime.datetime = None,
  finalizers: typing.List[str] = None,
  generate_name: str = None,
  generation: typing.Union[int, float] = None,
  labels: typing.Mapping[str] = None,
  managed_fields: typing.List[ManagedFieldsEntry] = None,
  name: str = None,
  namespace: str = None,
  owner_references: typing.List[OwnerReference] = None,
  resource_version: str = None,
  self_link: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.annotations">annotations</a></code> | <code>typing.Mapping[str]</code> | Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.creationTimestamp">creation_timestamp</a></code> | <code>datetime.datetime</code> | CreationTimestamp is a timestamp representing the server time when this object was created. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.deletionGracePeriodSeconds">deletion_grace_period_seconds</a></code> | <code>typing.Union[int, float]</code> | Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.deletionTimestamp">deletion_timestamp</a></code> | <code>datetime.datetime</code> | DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.finalizers">finalizers</a></code> | <code>typing.List[str]</code> | Must be empty before the object is deleted from the registry. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.generateName">generate_name</a></code> | <code>str</code> | GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.generation">generation</a></code> | <code>typing.Union[int, float]</code> | A sequence number representing a specific generation of the desired state. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.labels">labels</a></code> | <code>typing.Mapping[str]</code> | Map of string keys and values that can be used to organize and categorize (scope and select) objects. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.managedFields">managed_fields</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ManagedFieldsEntry]</code> | ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.name">name</a></code> | <code>str</code> | Name must be unique within a namespace. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.namespace">namespace</a></code> | <code>str</code> | Namespace defines the space within which each name must be unique. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.ownerReferences">owner_references</a></code> | <code>typing.List[cdk8s_plus_28.k8s.OwnerReference]</code> | List of objects depended by this object. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.resourceVersion">resource_version</a></code> | <code>str</code> | An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.selfLink">self_link</a></code> | <code>str</code> | Deprecated: selfLink is a legacy read-only field that is no longer populated by the system. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.uid">uid</a></code> | <code>str</code> | UID is the unique in time and space value for this object. |

---

##### `annotations`<sup>Optional</sup> <a name="annotations" id="cdk8s-plus-28.k8s.ObjectMeta.property.annotations"></a>

```python
annotations: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata.

They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations

---

##### `creation_timestamp`<sup>Optional</sup> <a name="creation_timestamp" id="cdk8s-plus-28.k8s.ObjectMeta.property.creationTimestamp"></a>

```python
creation_timestamp: datetime.datetime
```

- *Type:* datetime.datetime

CreationTimestamp is a timestamp representing the server time when this object was created.

It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

Populated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `deletion_grace_period_seconds`<sup>Optional</sup> <a name="deletion_grace_period_seconds" id="cdk8s-plus-28.k8s.ObjectMeta.property.deletionGracePeriodSeconds"></a>

```python
deletion_grace_period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of seconds allowed for this object to gracefully terminate before it will be removed from the system.

Only set when deletionTimestamp is also set. May only be shortened. Read-only.

---

##### `deletion_timestamp`<sup>Optional</sup> <a name="deletion_timestamp" id="cdk8s-plus-28.k8s.ObjectMeta.property.deletionTimestamp"></a>

```python
deletion_timestamp: datetime.datetime
```

- *Type:* datetime.datetime

DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted.

This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `finalizers`<sup>Optional</sup> <a name="finalizers" id="cdk8s-plus-28.k8s.ObjectMeta.property.finalizers"></a>

```python
finalizers: typing.List[str]
```

- *Type:* typing.List[str]

Must be empty before the object is deleted from the registry.

Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order.  Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list.

---

##### `generate_name`<sup>Optional</sup> <a name="generate_name" id="cdk8s-plus-28.k8s.ObjectMeta.property.generateName"></a>

```python
generate_name: str
```

- *Type:* str

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided.

If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will return a 409.

Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency

---

##### `generation`<sup>Optional</sup> <a name="generation" id="cdk8s-plus-28.k8s.ObjectMeta.property.generation"></a>

```python
generation: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

A sequence number representing a specific generation of the desired state.

Populated by the system. Read-only.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.k8s.ObjectMeta.property.labels"></a>

```python
labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Map of string keys and values that can be used to organize and categorize (scope and select) objects.

May match selectors of replication controllers and services. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels

---

##### `managed_fields`<sup>Optional</sup> <a name="managed_fields" id="cdk8s-plus-28.k8s.ObjectMeta.property.managedFields"></a>

```python
managed_fields: typing.List[ManagedFieldsEntry]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ManagedFieldsEntry]

ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow.

This is mostly for internal housekeeping, and users typically shouldn't need to set or understand this field. A workflow can be the user's name, a controller's name, or the name of a specific apply path like "ci-cd". The set of fields is always in the version that the workflow used when modifying the object.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ObjectMeta.property.name"></a>

```python
name: str
```

- *Type:* str

Name must be unique within a namespace.

Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ObjectMeta.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace defines the space within which each name must be unique.

An empty namespace is equivalent to the "default" namespace, but "default" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces

---

##### `owner_references`<sup>Optional</sup> <a name="owner_references" id="cdk8s-plus-28.k8s.ObjectMeta.property.ownerReferences"></a>

```python
owner_references: typing.List[OwnerReference]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.OwnerReference]

List of objects depended by this object.

If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.

---

##### `resource_version`<sup>Optional</sup> <a name="resource_version" id="cdk8s-plus-28.k8s.ObjectMeta.property.resourceVersion"></a>

```python
resource_version: str
```

- *Type:* str

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed.

May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `self_link`<sup>Optional</sup> <a name="self_link" id="cdk8s-plus-28.k8s.ObjectMeta.property.selfLink"></a>

```python
self_link: str
```

- *Type:* str

Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ObjectMeta.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID is the unique in time and space value for this object.

It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

### ObjectMetricSourceV2 <a name="ObjectMetricSourceV2" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2"></a>

ObjectMetricSource indicates how to scale on a metric describing a kubernetes object (for example, hits-per-second on an Ingress object).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ObjectMetricSourceV2(
  described_object: CrossVersionObjectReferenceV2,
  metric: MetricIdentifierV2,
  target: MetricTargetV2
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.describedObject">described_object</a></code> | <code>cdk8s_plus_28.k8s.CrossVersionObjectReferenceV2</code> | describedObject specifies the descriptions of a object,such as kind,name apiVersion. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s_plus_28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `described_object`<sup>Required</sup> <a name="described_object" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.describedObject"></a>

```python
described_object: CrossVersionObjectReferenceV2
```

- *Type:* cdk8s_plus_28.k8s.CrossVersionObjectReferenceV2

describedObject specifies the descriptions of a object,such as kind,name apiVersion.

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.metric"></a>

```python
metric: MetricIdentifierV2
```

- *Type:* cdk8s_plus_28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.target"></a>

```python
target: MetricTargetV2
```

- *Type:* cdk8s_plus_28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ObjectReference <a name="ObjectReference" id="cdk8s-plus-28.k8s.ObjectReference"></a>

ObjectReference contains enough information to let you inspect or modify the referred object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ObjectReference(
  api_version: str = None,
  field_path: str = None,
  kind: str = None,
  name: str = None,
  namespace: str = None,
  resource_version: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.apiVersion">api_version</a></code> | <code>str</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.fieldPath">field_path</a></code> | <code>str</code> | If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.kind">kind</a></code> | <code>str</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.namespace">namespace</a></code> | <code>str</code> | Namespace of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.resourceVersion">resource_version</a></code> | <code>str</code> | Specific resourceVersion to which this reference is made, if any. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.uid">uid</a></code> | <code>str</code> | UID of the referent. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.ObjectReference.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

API version of the referent.

---

##### `field_path`<sup>Optional</sup> <a name="field_path" id="cdk8s-plus-28.k8s.ObjectReference.property.fieldPath"></a>

```python
field_path: str
```

- *Type:* str

If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ObjectReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind of the referent.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ObjectReference.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

##### `resource_version`<sup>Optional</sup> <a name="resource_version" id="cdk8s-plus-28.k8s.ObjectReference.property.resourceVersion"></a>

```python
resource_version: str
```

- *Type:* str

Specific resourceVersion to which this reference is made, if any.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ObjectReference.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

---

### Overhead <a name="Overhead" id="cdk8s-plus-28.k8s.Overhead"></a>

Overhead structure represents the resource overhead associated with running a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Overhead.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Overhead(
  pod_fixed: typing.Mapping[Quantity] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Overhead.property.podFixed">pod_fixed</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | podFixed represents the fixed resource overhead associated with running a pod. |

---

##### `pod_fixed`<sup>Optional</sup> <a name="pod_fixed" id="cdk8s-plus-28.k8s.Overhead.property.podFixed"></a>

```python
pod_fixed: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

podFixed represents the fixed resource overhead associated with running a pod.

---

### OwnerReference <a name="OwnerReference" id="cdk8s-plus-28.k8s.OwnerReference"></a>

OwnerReference contains enough information to let you identify an owning object.

An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.OwnerReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.OwnerReference(
  api_version: str,
  kind: str,
  name: str,
  uid: str,
  block_owner_deletion: bool = None,
  controller: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.apiVersion">api_version</a></code> | <code>str</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.kind">kind</a></code> | <code>str</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.uid">uid</a></code> | <code>str</code> | UID of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.blockOwnerDeletion">block_owner_deletion</a></code> | <code>bool</code> | If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.controller">controller</a></code> | <code>bool</code> | If true, this reference points to the managing controller. |

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.k8s.OwnerReference.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

API version of the referent.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.OwnerReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind of the referent.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.OwnerReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

---

##### `uid`<sup>Required</sup> <a name="uid" id="cdk8s-plus-28.k8s.OwnerReference.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

##### `block_owner_deletion`<sup>Optional</sup> <a name="block_owner_deletion" id="cdk8s-plus-28.k8s.OwnerReference.property.blockOwnerDeletion"></a>

```python
block_owner_deletion: bool
```

- *Type:* bool
- *Default:* false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.

If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed.

See https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion for how the garbage collector interacts with this field and enforces the foreground deletion. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.

---

##### `controller`<sup>Optional</sup> <a name="controller" id="cdk8s-plus-28.k8s.OwnerReference.property.controller"></a>

```python
controller: bool
```

- *Type:* bool

If true, this reference points to the managing controller.

---

### ParamKindV1Alpha1 <a name="ParamKindV1Alpha1" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1"></a>

ParamKind is a tuple of Group Kind and Version.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ParamKindV1Alpha1(
  api_version: str = None,
  kind: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.apiVersion">api_version</a></code> | <code>str</code> | APIVersion is the API group version the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.kind">kind</a></code> | <code>str</code> | Kind is the API kind the resources belong to. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

APIVersion is the API group version the resources belong to.

In format of "group/version". Required.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the API kind the resources belong to.

Required.

---

### ParamKindV1Beta1 <a name="ParamKindV1Beta1" id="cdk8s-plus-28.k8s.ParamKindV1Beta1"></a>

ParamKind is a tuple of Group Kind and Version.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ParamKindV1Beta1(
  api_version: str = None,
  kind: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Beta1.property.apiVersion">api_version</a></code> | <code>str</code> | APIVersion is the API group version the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Beta1.property.kind">kind</a></code> | <code>str</code> | Kind is the API kind the resources belong to. |

---

##### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

APIVersion is the API group version the resources belong to.

In format of "group/version". Required.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the API kind the resources belong to.

Required.

---

### ParamRefV1Alpha1 <a name="ParamRefV1Alpha1" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1"></a>

ParamRef describes how to locate the params to be used as input to expressions of rules applied by a policy binding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ParamRefV1Alpha1(
  name: str = None,
  namespace: str = None,
  parameter_not_found_action: str = None,
  selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.name">name</a></code> | <code>str</code> | `name` is the name of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.namespace">namespace</a></code> | <code>str</code> | namespace is the namespace of the referenced resource. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.parameterNotFoundAction">parameter_not_found_action</a></code> | <code>str</code> | `parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | selector can be used to match multiple param objects based on their labels. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of the resource being referenced.

`name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

namespace is the namespace of the referenced resource.

Allows limiting the search for params to a specific namespace. Applies to both `name` and `selector` fields.

A per-namespace parameter may be used by specifying a namespace-scoped `paramKind` in the policy and leaving this field empty.

* If `paramKind` is cluster-scoped, this field MUST be unset. Setting this field results in a configuration error.
* If `paramKind` is namespace-scoped, the namespace of the object being evaluated for admission will be used when this field is left unset. Take care that if this is left empty the binding must not match any cluster-scoped resources, which will result in an error.

---

##### `parameter_not_found_action`<sup>Optional</sup> <a name="parameter_not_found_action" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.parameterNotFoundAction"></a>

```python
parameter_not_found_action: str
```

- *Type:* str
- *Default:* Deny`

`parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding.

If the value is set to `Allow`, then no matched parameters will be treated as successful validation by the binding. If set to `Deny`, then no matched parameters will be subject to the `failurePolicy` of the policy.

Allowed values are `Allow` or `Deny` Default to `Deny`

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

selector can be used to match multiple param objects based on their labels.

Supply selector: {} to match all resources of the ParamKind.

If multiple params are found, they are all evaluated with the policy expressions and the results are ANDed together.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

### ParamRefV1Beta1 <a name="ParamRefV1Beta1" id="cdk8s-plus-28.k8s.ParamRefV1Beta1"></a>

ParamRef describes how to locate the params to be used as input to expressions of rules applied by a policy binding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ParamRefV1Beta1(
  name: str = None,
  namespace: str = None,
  parameter_not_found_action: str = None,
  selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.name">name</a></code> | <code>str</code> | name is the name of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.namespace">namespace</a></code> | <code>str</code> | namespace is the namespace of the referenced resource. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.parameterNotFoundAction">parameter_not_found_action</a></code> | <code>str</code> | `parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | selector can be used to match multiple param objects based on their labels. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the resource being referenced.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

A single parameter used for all admission requests can be configured by setting the `name` field, leaving `selector` blank, and setting namespace if `paramKind` is namespace-scoped.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

namespace is the namespace of the referenced resource.

Allows limiting the search for params to a specific namespace. Applies to both `name` and `selector` fields.

A per-namespace parameter may be used by specifying a namespace-scoped `paramKind` in the policy and leaving this field empty.

* If `paramKind` is cluster-scoped, this field MUST be unset. Setting this field results in a configuration error.
* If `paramKind` is namespace-scoped, the namespace of the object being evaluated for admission will be used when this field is left unset. Take care that if this is left empty the binding must not match any cluster-scoped resources, which will result in an error.

---

##### `parameter_not_found_action`<sup>Optional</sup> <a name="parameter_not_found_action" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.parameterNotFoundAction"></a>

```python
parameter_not_found_action: str
```

- *Type:* str

`parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding.

If the value is set to `Allow`, then no matched parameters will be treated as successful validation by the binding. If set to `Deny`, then no matched parameters will be subject to the `failurePolicy` of the policy.

Allowed values are `Allow` or `Deny`

Required

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

selector can be used to match multiple param objects based on their labels.

Supply selector: {} to match all resources of the ParamKind.

If multiple params are found, they are all evaluated with the policy expressions and the results are ANDed together.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

### ParentReferenceV1Alpha1 <a name="ParentReferenceV1Alpha1" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1"></a>

ParentReference describes a reference to a parent object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ParentReferenceV1Alpha1(
  group: str = None,
  name: str = None,
  namespace: str = None,
  resource: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.group">group</a></code> | <code>str</code> | Group is the group of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.name">name</a></code> | <code>str</code> | Name is the name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.namespace">namespace</a></code> | <code>str</code> | Namespace is the namespace of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.resource">resource</a></code> | <code>str</code> | Resource is the resource of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.uid">uid</a></code> | <code>str</code> | UID is the uid of the object being referenced. |

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.group"></a>

```python
group: str
```

- *Type:* str

Group is the group of the object being referenced.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of the object being referenced.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace is the namespace of the object being referenced.

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.resource"></a>

```python
resource: str
```

- *Type:* str

Resource is the resource of the object being referenced.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID is the uid of the object being referenced.

---

### PathMapping <a name="PathMapping" id="cdk8s-plus-28.PathMapping"></a>

Maps a string key to a path within a volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PathMapping.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PathMapping(
  path: str,
  mode: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PathMapping.property.path">path</a></code> | <code>str</code> | The relative path of the file to map the key to. |
| <code><a href="#cdk8s-plus-28.PathMapping.property.mode">mode</a></code> | <code>typing.Union[int, float]</code> | Optional: mode bits to use on this file, must be a value between 0 and 0777. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.PathMapping.property.path"></a>

```python
path: str
```

- *Type:* str

The relative path of the file to map the key to.

May not be an absolute
path. May not contain the path element '..'. May not start with the string
'..'.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.PathMapping.property.mode"></a>

```python
mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Optional: mode bits to use on this file, must be a value between 0 and 0777.

If not specified, the volume defaultMode will be used. This might be
in conflict with other options that affect the file mode, like fsGroup, and
the result can be other mode bits set.

---

### PersistentVolumeClaimProps <a name="PersistentVolumeClaimProps" id="cdk8s-plus-28.PersistentVolumeClaimProps"></a>

Properties for `PersistentVolumeClaim`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeClaimProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeClaimProps(
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume: IPersistentVolume = None,
  volume_mode: PersistentVolumeMode = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains the access modes the volume should support. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Minimum storage size the volume should have. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a></code> | The PersistentVolume backing this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes requirement.

Contains the access modes the volume should support.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size
- *Default:* No storage requirement.

Minimum storage size the volume should have.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str
- *Default:* Not set.

Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:.

* If the admission plugin is turned on, the storage class marked as default will be used.
* If the admission plugin is turned off, the pvc can only be bound to volumes without a storage class.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1)

---

##### `volume`<sup>Optional</sup> <a name="volume" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.volume"></a>

```python
volume: IPersistentVolume
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>
- *Default:* No specific volume binding.

The PersistentVolume backing this claim.

The control plane still checks that storage class, access modes,
and requested storage size on the volume are valid.

Note that in order to guarantee a proper binding, the volume should
also define a `claimRef` referring to this claim. Otherwise, the volume may be
claimed be other pvc's before it gets a chance to bind to this one.

If the volume is managed (i.e not imported), you can use `pv.claim()` to easily
create a bi-directional bounded claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.)

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

### PersistentVolumeClaimSpec <a name="PersistentVolumeClaimSpec" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec"></a>

PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PersistentVolumeClaimSpec(
  access_modes: typing.List[str] = None,
  data_source: TypedLocalObjectReference = None,
  data_source_ref: TypedObjectReference = None,
  resources: ResourceRequirements = None,
  selector: LabelSelector = None,
  storage_class_name: str = None,
  volume_mode: str = None,
  volume_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.accessModes">access_modes</a></code> | <code>typing.List[str]</code> | accessModes contains the desired access modes the volume should have. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSource">data_source</a></code> | <code>cdk8s_plus_28.k8s.TypedLocalObjectReference</code> | dataSource field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. When the AnyVolumeDataSource feature gate is enabled, dataSource contents will be copied to dataSourceRef, and dataSourceRef contents will be copied to dataSource when dataSourceRef.namespace is not specified. If the namespace is specified, then dataSourceRef will not be copied to dataSource. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSourceRef">data_source_ref</a></code> | <code>cdk8s_plus_28.k8s.TypedObjectReference</code> | dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.resources">resources</a></code> | <code>cdk8s_plus_28.k8s.ResourceRequirements</code> | resources represents the minimum resources the volume should have. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | selector is a label query over volumes to consider for binding. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.storageClassName">storage_class_name</a></code> | <code>str</code> | storageClassName is the name of the StorageClass required by the claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeMode">volume_mode</a></code> | <code>str</code> | volumeMode defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeName">volume_name</a></code> | <code>str</code> | volumeName is the binding reference to the PersistentVolume backing this claim. |

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.accessModes"></a>

```python
access_modes: typing.List[str]
```

- *Type:* typing.List[str]

accessModes contains the desired access modes the volume should have.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1

---

##### `data_source`<sup>Optional</sup> <a name="data_source" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSource"></a>

```python
data_source: TypedLocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.TypedLocalObjectReference

dataSource field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. When the AnyVolumeDataSource feature gate is enabled, dataSource contents will be copied to dataSourceRef, and dataSourceRef contents will be copied to dataSource when dataSourceRef.namespace is not specified. If the namespace is specified, then dataSourceRef will not be copied to dataSource.

---

##### `data_source_ref`<sup>Optional</sup> <a name="data_source_ref" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSourceRef"></a>

```python
data_source_ref: TypedObjectReference
```

- *Type:* cdk8s_plus_28.k8s.TypedObjectReference

dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired.

This may be any object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the dataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, when namespace isn't specified in dataSourceRef, both fields (dataSource and dataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. When namespace is specified in dataSourceRef, dataSource isn't set to the same value and must be empty. There are three important differences between dataSource and dataSourceRef: * While dataSource only allows two specific types of objects, dataSourceRef
allows any non-core object, as well as PersistentVolumeClaim objects.

* While dataSource ignores disallowed values (dropping them), dataSourceRef
  preserves all values, and generates an error if a disallowed value is
  specified.
* While dataSource only allows local objects, dataSourceRef allows objects
  in any namespaces.
  (Beta) Using this field requires the AnyVolumeDataSource feature gate to be enabled. (Alpha) Using the namespace field of dataSourceRef requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.resources"></a>

```python
resources: ResourceRequirements
```

- *Type:* cdk8s_plus_28.k8s.ResourceRequirements

resources represents the minimum resources the volume should have.

If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

selector is a label query over volumes to consider for binding.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

storageClassName is the name of the StorageClass required by the claim.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeMode"></a>

```python
volume_mode: str
```

- *Type:* str

volumeMode defines what type of volume is required by the claim.

Value of Filesystem is implied when not included in claim spec.

---

##### `volume_name`<sup>Optional</sup> <a name="volume_name" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeName"></a>

```python
volume_name: str
```

- *Type:* str

volumeName is the binding reference to the PersistentVolume backing this claim.

---

### PersistentVolumeClaimTemplate <a name="PersistentVolumeClaimTemplate" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate"></a>

PersistentVolumeClaimTemplate is used to produce PersistentVolumeClaim objects as part of an EphemeralVolumeSource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PersistentVolumeClaimTemplate(
  spec: PersistentVolumeClaimSpec,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeClaimSpec</code> | The specification for the PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | May contain labels and annotations that will be copied into the PVC when creating it. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.spec"></a>

```python
spec: PersistentVolumeClaimSpec
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimSpec

The specification for the PersistentVolumeClaim.

The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

May contain labels and annotations that will be copied into the PVC when creating it.

No other fields are allowed and will be rejected during validation.

---

### PersistentVolumeClaimVolumeOptions <a name="PersistentVolumeClaimVolumeOptions" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions"></a>

Options for a PersistentVolumeClaim-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeClaimVolumeOptions(
  name: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.readOnly">read_only</a></code> | <code>bool</code> | Will force the ReadOnly setting in VolumeMounts. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* Derived from the PVC name.

The volume name.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Will force the ReadOnly setting in VolumeMounts.

---

### PersistentVolumeClaimVolumeSource <a name="PersistentVolumeClaimVolumeSource" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource"></a>

PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace.

This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PersistentVolumeClaimVolumeSource(
  claim_name: str,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.claimName">claim_name</a></code> | <code>str</code> | claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly Will force the ReadOnly setting in VolumeMounts. |

---

##### `claim_name`<sup>Required</sup> <a name="claim_name" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.claimName"></a>

```python
claim_name: str
```

- *Type:* str

claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly Will force the ReadOnly setting in VolumeMounts.

Default false.

---

### PersistentVolumeProps <a name="PersistentVolumeProps" id="cdk8s-plus-28.PersistentVolumeProps"></a>

Properties for `PersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PersistentVolumeProps(
  metadata: ApiObjectMetadata = None,
  access_modes: typing.List[PersistentVolumeAccessMode] = None,
  claim: IPersistentVolumeClaim = None,
  mount_options: typing.List[str] = None,
  reclaim_policy: PersistentVolumeReclaimPolicy = None,
  storage: Size = None,
  storage_class_name: str = None,
  volume_mode: PersistentVolumeMode = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.accessModes">access_modes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.reclaimPolicy">reclaim_policy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.storageClassName">storage_class_name</a></code> | <code>str</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.volumeMode">volume_mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.PersistentVolumeProps.property.accessModes"></a>

```python
access_modes: typing.List[PersistentVolumeAccessMode]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolumeProps.property.claim"></a>

```python
claim: IPersistentVolumeClaim
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.PersistentVolumeProps.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaim_policy`<sup>Optional</sup> <a name="reclaim_policy" id="cdk8s-plus-28.PersistentVolumeProps.property.reclaimPolicy"></a>

```python
reclaim_policy: PersistentVolumeReclaimPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeProps.property.storage"></a>

```python
storage: Size
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.PersistentVolumeProps.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.PersistentVolumeProps.property.volumeMode"></a>

```python
volume_mode: PersistentVolumeMode
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

### PersistentVolumeSpec <a name="PersistentVolumeSpec" id="cdk8s-plus-28.k8s.PersistentVolumeSpec"></a>

PersistentVolumeSpec is the specification of a persistent volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PersistentVolumeSpec(
  access_modes: typing.List[str] = None,
  aws_elastic_block_store: AwsElasticBlockStoreVolumeSource = None,
  azure_disk: AzureDiskVolumeSource = None,
  azure_file: AzureFilePersistentVolumeSource = None,
  capacity: typing.Mapping[Quantity] = None,
  cephfs: CephFsPersistentVolumeSource = None,
  cinder: CinderPersistentVolumeSource = None,
  claim_ref: ObjectReference = None,
  csi: CsiPersistentVolumeSource = None,
  fc: FcVolumeSource = None,
  flex_volume: FlexPersistentVolumeSource = None,
  flocker: FlockerVolumeSource = None,
  gce_persistent_disk: GcePersistentDiskVolumeSource = None,
  glusterfs: GlusterfsPersistentVolumeSource = None,
  host_path: HostPathVolumeSource = None,
  iscsi: IscsiPersistentVolumeSource = None,
  local: LocalVolumeSource = None,
  mount_options: typing.List[str] = None,
  nfs: NfsVolumeSource = None,
  node_affinity: VolumeNodeAffinity = None,
  persistent_volume_reclaim_policy: str = None,
  photon_persistent_disk: PhotonPersistentDiskVolumeSource = None,
  portworx_volume: PortworxVolumeSource = None,
  quobyte: QuobyteVolumeSource = None,
  rbd: RbdPersistentVolumeSource = None,
  scale_io: ScaleIoPersistentVolumeSource = None,
  storage_class_name: str = None,
  storageos: StorageOsPersistentVolumeSource = None,
  volume_mode: str = None,
  vsphere_volume: VsphereVirtualDiskVolumeSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.accessModes">access_modes</a></code> | <code>typing.List[str]</code> | accessModes contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.awsElasticBlockStore">aws_elastic_block_store</a></code> | <code>cdk8s_plus_28.k8s.AwsElasticBlockStoreVolumeSource</code> | awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureDisk">azure_disk</a></code> | <code>cdk8s_plus_28.k8s.AzureDiskVolumeSource</code> | azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureFile">azure_file</a></code> | <code>cdk8s_plus_28.k8s.AzureFilePersistentVolumeSource</code> | azureFile represents an Azure File Service mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.capacity">capacity</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | capacity is the description of the persistent volume's resources and capacity. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cephfs">cephfs</a></code> | <code>cdk8s_plus_28.k8s.CephFsPersistentVolumeSource</code> | cephFS represents a Ceph FS mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cinder">cinder</a></code> | <code>cdk8s_plus_28.k8s.CinderPersistentVolumeSource</code> | cinder represents a cinder volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.claimRef">claim_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | claimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.csi">csi</a></code> | <code>cdk8s_plus_28.k8s.CsiPersistentVolumeSource</code> | csi represents storage that is handled by an external CSI driver (Beta feature). |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.fc">fc</a></code> | <code>cdk8s_plus_28.k8s.FcVolumeSource</code> | fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flexVolume">flex_volume</a></code> | <code>cdk8s_plus_28.k8s.FlexPersistentVolumeSource</code> | flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flocker">flocker</a></code> | <code>cdk8s_plus_28.k8s.FlockerVolumeSource</code> | flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.gcePersistentDisk">gce_persistent_disk</a></code> | <code>cdk8s_plus_28.k8s.GcePersistentDiskVolumeSource</code> | gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.glusterfs">glusterfs</a></code> | <code>cdk8s_plus_28.k8s.GlusterfsPersistentVolumeSource</code> | glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.hostPath">host_path</a></code> | <code>cdk8s_plus_28.k8s.HostPathVolumeSource</code> | hostPath represents a directory on the host. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.iscsi">iscsi</a></code> | <code>cdk8s_plus_28.k8s.IscsiPersistentVolumeSource</code> | iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.local">local</a></code> | <code>cdk8s_plus_28.k8s.LocalVolumeSource</code> | local represents directly-attached storage with node affinity. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.mountOptions">mount_options</a></code> | <code>typing.List[str]</code> | mountOptions is the list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nfs">nfs</a></code> | <code>cdk8s_plus_28.k8s.NfsVolumeSource</code> | nfs represents an NFS mount on the host. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nodeAffinity">node_affinity</a></code> | <code>cdk8s_plus_28.k8s.VolumeNodeAffinity</code> | nodeAffinity defines constraints that limit what nodes this volume can be accessed from. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.persistentVolumeReclaimPolicy">persistent_volume_reclaim_policy</a></code> | <code>str</code> | persistentVolumeReclaimPolicy defines what happens to a persistent volume when released from its claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.photonPersistentDisk">photon_persistent_disk</a></code> | <code>cdk8s_plus_28.k8s.PhotonPersistentDiskVolumeSource</code> | photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.portworxVolume">portworx_volume</a></code> | <code>cdk8s_plus_28.k8s.PortworxVolumeSource</code> | portworxVolume represents a portworx volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.quobyte">quobyte</a></code> | <code>cdk8s_plus_28.k8s.QuobyteVolumeSource</code> | quobyte represents a Quobyte mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.rbd">rbd</a></code> | <code>cdk8s_plus_28.k8s.RbdPersistentVolumeSource</code> | rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.scaleIo">scale_io</a></code> | <code>cdk8s_plus_28.k8s.ScaleIoPersistentVolumeSource</code> | scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageClassName">storage_class_name</a></code> | <code>str</code> | storageClassName is the name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageos">storageos</a></code> | <code>cdk8s_plus_28.k8s.StorageOsPersistentVolumeSource</code> | storageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://examples.k8s.io/volumes/storageos/README.md. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.volumeMode">volume_mode</a></code> | <code>str</code> | volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.vsphereVolume">vsphere_volume</a></code> | <code>cdk8s_plus_28.k8s.VsphereVirtualDiskVolumeSource</code> | vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine. |

---

##### `access_modes`<sup>Optional</sup> <a name="access_modes" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.accessModes"></a>

```python
access_modes: typing.List[str]
```

- *Type:* typing.List[str]

accessModes contains all ways the volume can be mounted.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes

---

##### `aws_elastic_block_store`<sup>Optional</sup> <a name="aws_elastic_block_store" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.awsElasticBlockStore"></a>

```python
aws_elastic_block_store: AwsElasticBlockStoreVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AwsElasticBlockStoreVolumeSource

awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `azure_disk`<sup>Optional</sup> <a name="azure_disk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureDisk"></a>

```python
azure_disk: AzureDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AzureDiskVolumeSource

azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

---

##### `azure_file`<sup>Optional</sup> <a name="azure_file" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureFile"></a>

```python
azure_file: AzureFilePersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AzureFilePersistentVolumeSource

azureFile represents an Azure File Service mount on the host and bind mount to the pod.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.capacity"></a>

```python
capacity: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

capacity is the description of the persistent volume's resources and capacity.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity

---

##### `cephfs`<sup>Optional</sup> <a name="cephfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cephfs"></a>

```python
cephfs: CephFsPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CephFsPersistentVolumeSource

cephFS represents a Ceph FS mount on the host that shares a pod's lifetime.

---

##### `cinder`<sup>Optional</sup> <a name="cinder" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cinder"></a>

```python
cinder: CinderPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CinderPersistentVolumeSource

cinder represents a cinder volume attached and mounted on kubelets host machine.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `claim_ref`<sup>Optional</sup> <a name="claim_ref" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.claimRef"></a>

```python
claim_ref: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

claimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding

---

##### `csi`<sup>Optional</sup> <a name="csi" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.csi"></a>

```python
csi: CsiPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CsiPersistentVolumeSource

csi represents storage that is handled by an external CSI driver (Beta feature).

---

##### `fc`<sup>Optional</sup> <a name="fc" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.fc"></a>

```python
fc: FcVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FcVolumeSource

fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

---

##### `flex_volume`<sup>Optional</sup> <a name="flex_volume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flexVolume"></a>

```python
flex_volume: FlexPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FlexPersistentVolumeSource

flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

---

##### `flocker`<sup>Optional</sup> <a name="flocker" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flocker"></a>

```python
flocker: FlockerVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FlockerVolumeSource

flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage.

This depends on the Flocker control service being running

---

##### `gce_persistent_disk`<sup>Optional</sup> <a name="gce_persistent_disk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.gcePersistentDisk"></a>

```python
gce_persistent_disk: GcePersistentDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.GcePersistentDiskVolumeSource

gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `glusterfs`<sup>Optional</sup> <a name="glusterfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.glusterfs"></a>

```python
glusterfs: GlusterfsPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.GlusterfsPersistentVolumeSource

glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod.

Provisioned by an admin. More info: https://examples.k8s.io/volumes/glusterfs/README.md

---

##### `host_path`<sup>Optional</sup> <a name="host_path" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.hostPath"></a>

```python
host_path: HostPathVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.HostPathVolumeSource

hostPath represents a directory on the host.

Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `iscsi`<sup>Optional</sup> <a name="iscsi" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.iscsi"></a>

```python
iscsi: IscsiPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.IscsiPersistentVolumeSource

iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin.

---

##### `local`<sup>Optional</sup> <a name="local" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.local"></a>

```python
local: LocalVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.LocalVolumeSource

local represents directly-attached storage with node affinity.

---

##### `mount_options`<sup>Optional</sup> <a name="mount_options" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.mountOptions"></a>

```python
mount_options: typing.List[str]
```

- *Type:* typing.List[str]

mountOptions is the list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options.

---

##### `nfs`<sup>Optional</sup> <a name="nfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nfs"></a>

```python
nfs: NfsVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.NfsVolumeSource

nfs represents an NFS mount on the host.

Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `node_affinity`<sup>Optional</sup> <a name="node_affinity" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nodeAffinity"></a>

```python
node_affinity: VolumeNodeAffinity
```

- *Type:* cdk8s_plus_28.k8s.VolumeNodeAffinity

nodeAffinity defines constraints that limit what nodes this volume can be accessed from.

This field influences the scheduling of pods that use this volume.

---

##### `persistent_volume_reclaim_policy`<sup>Optional</sup> <a name="persistent_volume_reclaim_policy" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.persistentVolumeReclaimPolicy"></a>

```python
persistent_volume_reclaim_policy: str
```

- *Type:* str

persistentVolumeReclaimPolicy defines what happens to a persistent volume when released from its claim.

Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming

---

##### `photon_persistent_disk`<sup>Optional</sup> <a name="photon_persistent_disk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.photonPersistentDisk"></a>

```python
photon_persistent_disk: PhotonPersistentDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.PhotonPersistentDiskVolumeSource

photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine.

---

##### `portworx_volume`<sup>Optional</sup> <a name="portworx_volume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.portworxVolume"></a>

```python
portworx_volume: PortworxVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.PortworxVolumeSource

portworxVolume represents a portworx volume attached and mounted on kubelets host machine.

---

##### `quobyte`<sup>Optional</sup> <a name="quobyte" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.quobyte"></a>

```python
quobyte: QuobyteVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.QuobyteVolumeSource

quobyte represents a Quobyte mount on the host that shares a pod's lifetime.

---

##### `rbd`<sup>Optional</sup> <a name="rbd" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.rbd"></a>

```python
rbd: RbdPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.RbdPersistentVolumeSource

rbd represents a Rados Block Device mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/rbd/README.md

---

##### `scale_io`<sup>Optional</sup> <a name="scale_io" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.scaleIo"></a>

```python
scale_io: ScaleIoPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.ScaleIoPersistentVolumeSource

scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

---

##### `storage_class_name`<sup>Optional</sup> <a name="storage_class_name" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageClassName"></a>

```python
storage_class_name: str
```

- *Type:* str

storageClassName is the name of StorageClass to which this persistent volume belongs.

Empty value means that this volume does not belong to any StorageClass.

---

##### `storageos`<sup>Optional</sup> <a name="storageos" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageos"></a>

```python
storageos: StorageOsPersistentVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.StorageOsPersistentVolumeSource

storageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://examples.k8s.io/volumes/storageos/README.md.

---

##### `volume_mode`<sup>Optional</sup> <a name="volume_mode" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.volumeMode"></a>

```python
volume_mode: str
```

- *Type:* str

volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state.

Value of Filesystem is implied when not included in spec.

---

##### `vsphere_volume`<sup>Optional</sup> <a name="vsphere_volume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.vsphereVolume"></a>

```python
vsphere_volume: VsphereVirtualDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.VsphereVirtualDiskVolumeSource

vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine.

---

### PhotonPersistentDiskVolumeSource <a name="PhotonPersistentDiskVolumeSource" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource"></a>

Represents a Photon Controller persistent disk resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PhotonPersistentDiskVolumeSource(
  pd_id: str,
  fs_type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.pdId">pd_id</a></code> | <code>str</code> | pdID is the ID that identifies Photon Controller persistent disk. |
| <code><a href="#cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |

---

##### `pd_id`<sup>Required</sup> <a name="pd_id" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.pdId"></a>

```python
pd_id: str
```

- *Type:* str

pdID is the ID that identifies Photon Controller persistent disk.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

### PodAffinity <a name="PodAffinity" id="cdk8s-plus-28.k8s.PodAffinity"></a>

Pod affinity is a group of inter pod affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAffinity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodAffinity(
  preferred_during_scheduling_ignored_during_execution: typing.List[WeightedPodAffinityTerm] = None,
  required_during_scheduling_ignored_during_execution: typing.List[PodAffinityTerm] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferred_during_scheduling_ignored_during_execution</a></code> | <code>typing.List[cdk8s_plus_28.k8s.WeightedPodAffinityTerm]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">required_during_scheduling_ignored_during_execution</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodAffinityTerm]</code> | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferred_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="preferred_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.PodAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```python
preferred_during_scheduling_ignored_during_execution: typing.List[WeightedPodAffinityTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.WeightedPodAffinityTerm]

The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

---

##### `required_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="required_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.PodAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```python
required_during_scheduling_ignored_during_execution: typing.List[PodAffinityTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodAffinityTerm]

If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

---

### PodAffinityTerm <a name="PodAffinityTerm" id="cdk8s-plus-28.k8s.PodAffinityTerm"></a>

Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAffinityTerm.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodAffinityTerm(
  topology_key: str,
  label_selector: LabelSelector = None,
  namespaces: typing.List[str] = None,
  namespace_selector: LabelSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.topologyKey">topology_key</a></code> | <code>str</code> | This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.labelSelector">label_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | A label query over a set of resources, in this case pods. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaces">namespaces</a></code> | <code>typing.List[str]</code> | namespaces specifies a static list of namespace names that the term applies to. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | A label query over the set of namespaces that the term applies to. |

---

##### `topology_key`<sup>Required</sup> <a name="topology_key" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.topologyKey"></a>

```python
topology_key: str
```

- *Type:* str

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running.

Empty topologyKey is not allowed.

---

##### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

A label query over a set of resources, in this case pods.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaces"></a>

```python
namespaces: typing.List[str]
```

- *Type:* typing.List[str]

namespaces specifies a static list of namespace names that the term applies to.

The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace".

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

A label query over the set of namespaces that the term applies to.

The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces.

---

### PodAntiAffinity <a name="PodAntiAffinity" id="cdk8s-plus-28.k8s.PodAntiAffinity"></a>

Pod anti affinity is a group of inter pod anti affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAntiAffinity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodAntiAffinity(
  preferred_during_scheduling_ignored_during_execution: typing.List[WeightedPodAffinityTerm] = None,
  required_during_scheduling_ignored_during_execution: typing.List[PodAffinityTerm] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAntiAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferred_during_scheduling_ignored_during_execution</a></code> | <code>typing.List[cdk8s_plus_28.k8s.WeightedPodAffinityTerm]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.PodAntiAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">required_during_scheduling_ignored_during_execution</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodAffinityTerm]</code> | If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferred_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="preferred_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.PodAntiAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```python
preferred_during_scheduling_ignored_during_execution: typing.List[WeightedPodAffinityTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.WeightedPodAffinityTerm]

The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

---

##### `required_during_scheduling_ignored_during_execution`<sup>Optional</sup> <a name="required_during_scheduling_ignored_during_execution" id="cdk8s-plus-28.k8s.PodAntiAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```python
required_during_scheduling_ignored_during_execution: typing.List[PodAffinityTerm]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodAffinityTerm]

If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

---

### PodConnectionsAllowFromOptions <a name="PodConnectionsAllowFromOptions" id="cdk8s-plus-28.PodConnectionsAllowFromOptions"></a>

Options for `PodConnections.allowFrom`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodConnectionsAllowFromOptions(
  isolation: PodConnectionsIsolation = None,
  ports: typing.List[NetworkPolicyPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowFromOptions.property.isolation">isolation</a></code> | <code><a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a></code> | Which isolation should be applied to establish the connection. |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowFromOptions.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]</code> | Ports to allow incoming traffic to. |

---

##### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.property.isolation"></a>

```python
isolation: PodConnectionsIsolation
```

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* The pod ports.

Ports to allow incoming traffic to.

---

### PodConnectionsAllowToOptions <a name="PodConnectionsAllowToOptions" id="cdk8s-plus-28.PodConnectionsAllowToOptions"></a>

Options for `PodConnections.allowTo`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodConnectionsAllowToOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodConnectionsAllowToOptions(
  isolation: PodConnectionsIsolation = None,
  ports: typing.List[NetworkPolicyPort] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowToOptions.property.isolation">isolation</a></code> | <code><a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a></code> | Which isolation should be applied to establish the connection. |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowToOptions.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]</code> | Ports to allow outgoing traffic to. |

---

##### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnectionsAllowToOptions.property.isolation"></a>

```python
isolation: PodConnectionsIsolation
```

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnectionsAllowToOptions.property.ports"></a>

```python
ports: typing.List[NetworkPolicyPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* If the peer is a managed pod, take its ports. Otherwise, all ports are allowed.

Ports to allow outgoing traffic to.

---

### PodDisruptionBudgetSpec <a name="PodDisruptionBudgetSpec" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec"></a>

PodDisruptionBudgetSpec is a description of a PodDisruptionBudget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodDisruptionBudgetSpec(
  max_unavailable: IntOrString = None,
  min_available: IntOrString = None,
  selector: LabelSelector = None,
  unhealthy_pod_eviction_policy: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.maxUnavailable">max_unavailable</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | An eviction is allowed if at most "maxUnavailable" pods selected by "selector" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with "minAvailable". |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.minAvailable">min_available</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | An eviction is allowed if at least "minAvailable" pods selected by "selector" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying "100%". |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | Label query over pods whose evictions are managed by the disruption budget. |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.unhealthyPodEvictionPolicy">unhealthy_pod_eviction_policy</a></code> | <code>str</code> | UnhealthyPodEvictionPolicy defines the criteria for when unhealthy pods should be considered for eviction. |

---

##### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.maxUnavailable"></a>

```python
max_unavailable: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

An eviction is allowed if at most "maxUnavailable" pods selected by "selector" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with "minAvailable".

---

##### `min_available`<sup>Optional</sup> <a name="min_available" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.minAvailable"></a>

```python
min_available: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

An eviction is allowed if at least "minAvailable" pods selected by "selector" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying "100%".

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

Label query over pods whose evictions are managed by the disruption budget.

A null selector will match no pods, while an empty ({}) selector will select all pods within the namespace.

---

##### `unhealthy_pod_eviction_policy`<sup>Optional</sup> <a name="unhealthy_pod_eviction_policy" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.unhealthyPodEvictionPolicy"></a>

```python
unhealthy_pod_eviction_policy: str
```

- *Type:* str

UnhealthyPodEvictionPolicy defines the criteria for when unhealthy pods should be considered for eviction.

Current implementation considers healthy pods, as pods that have status.conditions item with type="Ready",status="True".

Valid policies are IfHealthyBudget and AlwaysAllow. If no policy is specified, the default behavior will be used, which corresponds to the IfHealthyBudget policy.

IfHealthyBudget policy means that running pods (status.phase="Running"), but not yet healthy can be evicted only if the guarded application is not disrupted (status.currentHealthy is at least equal to status.desiredHealthy). Healthy pods will be subject to the PDB for eviction.

AlwaysAllow policy means that all running pods (status.phase="Running"), but not yet healthy are considered disrupted and can be evicted regardless of whether the criteria in a PDB is met. This means perspective running pods of a disrupted application might not get a chance to become healthy. Healthy pods will be subject to the PDB for eviction.

Additional policies may be added in the future. Clients making eviction decisions should disallow eviction of unhealthy pods if they encounter an unrecognized policy in this field.

This field is beta-level. The eviction API uses this field when the feature gate PDBUnhealthyPodEvictionPolicy is enabled (enabled by default).

---

### PodDnsConfig <a name="PodDnsConfig" id="cdk8s-plus-28.k8s.PodDnsConfig"></a>

PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDnsConfig.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodDnsConfig(
  nameservers: typing.List[str] = None,
  options: typing.List[PodDnsConfigOption] = None,
  searches: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.nameservers">nameservers</a></code> | <code>typing.List[str]</code> | A list of DNS name server IP addresses. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.options">options</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodDnsConfigOption]</code> | A list of DNS resolver options. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.searches">searches</a></code> | <code>typing.List[str]</code> | A list of DNS search domains for host-name lookup. |

---

##### `nameservers`<sup>Optional</sup> <a name="nameservers" id="cdk8s-plus-28.k8s.PodDnsConfig.property.nameservers"></a>

```python
nameservers: typing.List[str]
```

- *Type:* typing.List[str]

A list of DNS name server IP addresses.

This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.PodDnsConfig.property.options"></a>

```python
options: typing.List[PodDnsConfigOption]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodDnsConfigOption]

A list of DNS resolver options.

This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.

---

##### `searches`<sup>Optional</sup> <a name="searches" id="cdk8s-plus-28.k8s.PodDnsConfig.property.searches"></a>

```python
searches: typing.List[str]
```

- *Type:* typing.List[str]

A list of DNS search domains for host-name lookup.

This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.

---

### PodDnsConfigOption <a name="PodDnsConfigOption" id="cdk8s-plus-28.k8s.PodDnsConfigOption"></a>

PodDNSConfigOption defines DNS resolver options of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDnsConfigOption.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodDnsConfigOption(
  name: str = None,
  value: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfigOption.property.name">name</a></code> | <code>str</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfigOption.property.value">value</a></code> | <code>str</code> | *No description.* |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.PodDnsConfigOption.property.name"></a>

```python
name: str
```

- *Type:* str

Required.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.PodDnsConfigOption.property.value"></a>

```python
value: str
```

- *Type:* str

---

### PodDnsProps <a name="PodDnsProps" id="cdk8s-plus-28.PodDnsProps"></a>

Properties for `PodDns`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodDnsProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodDnsProps(
  hostname: str = None,
  hostname_as_fqd_n: bool = None,
  nameservers: typing.List[str] = None,
  options: typing.List[DnsOption] = None,
  policy: DnsPolicy = None,
  searches: typing.List[str] = None,
  subdomain: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.hostname">hostname</a></code> | <code>str</code> | Specifies the hostname of the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.hostnameAsFQDN">hostname_as_fqd_n</a></code> | <code>bool</code> | If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.nameservers">nameservers</a></code> | <code>typing.List[str]</code> | A list of IP addresses that will be used as DNS servers for the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.options">options</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]</code> | List of objects where each object may have a name property (required) and a value property (optional). |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.policy">policy</a></code> | <code><a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a></code> | Set DNS policy for the pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.searches">searches</a></code> | <code>typing.List[str]</code> | A list of DNS search domains for hostname lookup in the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.subdomain">subdomain</a></code> | <code>str</code> | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". |

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.PodDnsProps.property.hostname"></a>

```python
hostname: str
```

- *Type:* str
- *Default:* Set to a system-defined value.

Specifies the hostname of the Pod.

---

##### `hostname_as_fqd_n`<sup>Optional</sup> <a name="hostname_as_fqd_n" id="cdk8s-plus-28.PodDnsProps.property.hostnameAsFQDN"></a>

```python
hostname_as_fqd_n: bool
```

- *Type:* bool
- *Default:* false

If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).

In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname).
In Windows containers, this means setting the registry value of hostname for the registry
key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN.
If a pod does not have FQDN, this has no effect.

---

##### `nameservers`<sup>Optional</sup> <a name="nameservers" id="cdk8s-plus-28.PodDnsProps.property.nameservers"></a>

```python
nameservers: typing.List[str]
```

- *Type:* typing.List[str]

A list of IP addresses that will be used as DNS servers for the Pod.

There can be at most 3 IP addresses specified.
When the policy is set to "NONE", the list must contain at least one IP address,
otherwise this property is optional.
The servers listed will be combined to the base nameservers generated from
the specified DNS policy with duplicate addresses removed.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodDnsProps.property.options"></a>

```python
options: typing.List[DnsOption]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]

List of objects where each object may have a name property (required) and a value property (optional).

The contents in this property
will be merged to the options generated from the specified DNS policy.
Duplicate entries are removed.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk8s-plus-28.PodDnsProps.property.policy"></a>

```python
policy: DnsPolicy
```

- *Type:* <a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a>
- *Default:* DnsPolicy.CLUSTER_FIRST

Set DNS policy for the pod.

If policy is set to `None`, other configuration must be supplied.

---

##### `searches`<sup>Optional</sup> <a name="searches" id="cdk8s-plus-28.PodDnsProps.property.searches"></a>

```python
searches: typing.List[str]
```

- *Type:* typing.List[str]

A list of DNS search domains for hostname lookup in the Pod.

When specified, the provided list will be merged into the base
search domain names generated from the chosen DNS policy.
Duplicate domain names are removed.

Kubernetes allows for at most 6 search domains.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.PodDnsProps.property.subdomain"></a>

```python
subdomain: str
```

- *Type:* str
- *Default:* No subdomain.

If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>".

---

### PodFailurePolicy <a name="PodFailurePolicy" id="cdk8s-plus-28.k8s.PodFailurePolicy"></a>

PodFailurePolicy describes how failed pods influence the backoffLimit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodFailurePolicy(
  rules: typing.List[PodFailurePolicyRule]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicy.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodFailurePolicyRule]</code> | A list of pod failure policy rules. |

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.k8s.PodFailurePolicy.property.rules"></a>

```python
rules: typing.List[PodFailurePolicyRule]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodFailurePolicyRule]

A list of pod failure policy rules.

The rules are evaluated in order. Once a rule matches a Pod failure, the remaining of the rules are ignored. When no rule matches the Pod failure, the default handling applies - the counter of pod failures is incremented and it is checked against the backoffLimit. At most 20 elements are allowed.

---

### PodFailurePolicyOnExitCodesRequirement <a name="PodFailurePolicyOnExitCodesRequirement" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement"></a>

PodFailurePolicyOnExitCodesRequirement describes the requirement for handling a failed pod based on its container exit codes.

In particular, it lookups the .state.terminated.exitCode for each app container and init container status, represented by the .status.containerStatuses and .status.initContainerStatuses fields in the Pod status, respectively. Containers completed with success (exit code 0) are excluded from the requirement check.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodFailurePolicyOnExitCodesRequirement(
  operator: str,
  values: typing.List[typing.Union[int, float]],
  container_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.operator">operator</a></code> | <code>str</code> | Represents the relationship between the container exit code(s) and the specified values. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.values">values</a></code> | <code>typing.List[typing.Union[int, float]]</code> | Specifies the set of values. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.containerName">container_name</a></code> | <code>str</code> | Restricts the check for exit codes to the container with the specified name. |

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.operator"></a>

```python
operator: str
```

- *Type:* str

Represents the relationship between the container exit code(s) and the specified values.

Containers completed with success (exit code 0) are excluded from the requirement check. Possible values are:

* In: the requirement is satisfied if at least one container exit code
  (might be multiple if there are multiple containers not restricted
  by the 'containerName' field) is in the set of specified values.
* NotIn: the requirement is satisfied if at least one container exit code
  (might be multiple if there are multiple containers not restricted
  by the 'containerName' field) is not in the set of specified values.
  Additional values are considered to be added in the future. Clients should react to an unknown operator by assuming the requirement is not satisfied.

---

##### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.values"></a>

```python
values: typing.List[typing.Union[int, float]]
```

- *Type:* typing.List[typing.Union[int, float]]

Specifies the set of values.

Each returned container exit code (might be multiple in case of multiple containers) is checked against this set of values with respect to the operator. The list of values must be ordered and must not contain duplicates. Value '0' cannot be used for the In operator. At least one element is required. At most 255 elements are allowed.

---

##### `container_name`<sup>Optional</sup> <a name="container_name" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.containerName"></a>

```python
container_name: str
```

- *Type:* str

Restricts the check for exit codes to the container with the specified name.

When null, the rule applies to all containers. When specified, it should match one the container or initContainer names in the pod template.

---

### PodFailurePolicyOnPodConditionsPattern <a name="PodFailurePolicyOnPodConditionsPattern" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern"></a>

PodFailurePolicyOnPodConditionsPattern describes a pattern for matching an actual pod condition type.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodFailurePolicyOnPodConditionsPattern(
  status: str,
  type: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.status">status</a></code> | <code>str</code> | Specifies the required Pod condition status. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.type">type</a></code> | <code>str</code> | Specifies the required Pod condition type. |

---

##### `status`<sup>Required</sup> <a name="status" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.status"></a>

```python
status: str
```

- *Type:* str
- *Default:* True.

Specifies the required Pod condition status.

To match a pod condition it is required that the specified status equals the pod condition status. Defaults to True.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.type"></a>

```python
type: str
```

- *Type:* str

Specifies the required Pod condition type.

To match a pod condition it is required that specified type equals the pod condition type.

---

### PodFailurePolicyRule <a name="PodFailurePolicyRule" id="cdk8s-plus-28.k8s.PodFailurePolicyRule"></a>

PodFailurePolicyRule describes how a pod failure is handled when the requirements are met.

One of onExitCodes and onPodConditions, but not both, can be used in each rule.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodFailurePolicyRule(
  action: str,
  on_pod_conditions: typing.List[PodFailurePolicyOnPodConditionsPattern],
  on_exit_codes: PodFailurePolicyOnExitCodesRequirement = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.action">action</a></code> | <code>str</code> | Specifies the action taken on a pod failure when the requirements are satisfied. Possible values are:. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onPodConditions">on_pod_conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodFailurePolicyOnPodConditionsPattern]</code> | Represents the requirement on the pod conditions. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onExitCodes">on_exit_codes</a></code> | <code>cdk8s_plus_28.k8s.PodFailurePolicyOnExitCodesRequirement</code> | Represents the requirement on the container exit codes. |

---

##### `action`<sup>Required</sup> <a name="action" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.action"></a>

```python
action: str
```

- *Type:* str

Specifies the action taken on a pod failure when the requirements are satisfied. Possible values are:.

* FailJob: indicates that the pod's job is marked as Failed and all
  running pods are terminated.
* FailIndex: indicates that the pod's index is marked as Failed and will
  not be restarted.
  This value is alpha-level. It can be used when the
  `JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).
* Ignore: indicates that the counter towards the .backoffLimit is not
  incremented and a replacement pod is created.
* Count: indicates that the pod is handled in the default way - the
  counter towards the .backoffLimit is incremented.
  Additional values are considered to be added in the future. Clients should react to an unknown action by skipping the rule.

---

##### `on_pod_conditions`<sup>Required</sup> <a name="on_pod_conditions" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onPodConditions"></a>

```python
on_pod_conditions: typing.List[PodFailurePolicyOnPodConditionsPattern]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodFailurePolicyOnPodConditionsPattern]

Represents the requirement on the pod conditions.

The requirement is represented as a list of pod condition patterns. The requirement is satisfied if at least one pattern matches an actual pod condition. At most 20 elements are allowed.

---

##### `on_exit_codes`<sup>Optional</sup> <a name="on_exit_codes" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onExitCodes"></a>

```python
on_exit_codes: PodFailurePolicyOnExitCodesRequirement
```

- *Type:* cdk8s_plus_28.k8s.PodFailurePolicyOnExitCodesRequirement

Represents the requirement on the container exit codes.

---

### PodOs <a name="PodOs" id="cdk8s-plus-28.k8s.PodOs"></a>

PodOS defines the OS parameters of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodOs.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodOs(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodOs.property.name">name</a></code> | <code>str</code> | Name is the name of the operating system. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodOs.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of the operating system.

The currently supported values are linux and windows. Additional value may be defined in future and can be one of: https://github.com/opencontainers/runtime-spec/blob/master/config.md#platform-specific-configuration Clients should expect to handle additional values and treat unrecognized values in this field as os: null

---

### PodProps <a name="PodProps" id="cdk8s-plus-28.PodProps"></a>

Properties for `Pod`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PodProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.PodProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.PodProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.PodProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.PodProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.PodProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PodProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.PodProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.PodProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.PodProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.PodProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.PodProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.PodProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.PodProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.PodProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.PodProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.PodProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.PodProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.PodProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.PodProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

### PodReadinessGate <a name="PodReadinessGate" id="cdk8s-plus-28.k8s.PodReadinessGate"></a>

PodReadinessGate contains the reference to a pod condition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodReadinessGate.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodReadinessGate(
  condition_type: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodReadinessGate.property.conditionType">condition_type</a></code> | <code>str</code> | ConditionType refers to a condition in the pod's condition list with matching type. |

---

##### `condition_type`<sup>Required</sup> <a name="condition_type" id="cdk8s-plus-28.k8s.PodReadinessGate.property.conditionType"></a>

```python
condition_type: str
```

- *Type:* str

ConditionType refers to a condition in the pod's condition list with matching type.

---

### PodResourceClaim <a name="PodResourceClaim" id="cdk8s-plus-28.k8s.PodResourceClaim"></a>

PodResourceClaim references exactly one ResourceClaim through a ClaimSource.

It adds a name to it that uniquely identifies the ResourceClaim inside the Pod. Containers that need access to the ResourceClaim reference it with this name.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodResourceClaim.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodResourceClaim(
  name: str,
  source: ClaimSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodResourceClaim.property.name">name</a></code> | <code>str</code> | Name uniquely identifies this resource claim inside the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodResourceClaim.property.source">source</a></code> | <code>cdk8s_plus_28.k8s.ClaimSource</code> | Source describes where to find the ResourceClaim. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodResourceClaim.property.name"></a>

```python
name: str
```

- *Type:* str

Name uniquely identifies this resource claim inside the pod.

This must be a DNS_LABEL.

---

##### `source`<sup>Optional</sup> <a name="source" id="cdk8s-plus-28.k8s.PodResourceClaim.property.source"></a>

```python
source: ClaimSource
```

- *Type:* cdk8s_plus_28.k8s.ClaimSource

Source describes where to find the ResourceClaim.

---

### PodsAllOptions <a name="PodsAllOptions" id="cdk8s-plus-28.PodsAllOptions"></a>

Options for `Pods.all`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodsAllOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodsAllOptions(
  namespaces: Namespaces = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodsAllOptions.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.Namespaces">Namespaces</a></code> | Namespaces the pods are allowed to be in. |

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodsAllOptions.property.namespaces"></a>

```python
namespaces: Namespaces
```

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

### PodSchedulingAttractOptions <a name="PodSchedulingAttractOptions" id="cdk8s-plus-28.PodSchedulingAttractOptions"></a>

Options for `PodScheduling.attract`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingAttractOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSchedulingAttractOptions(
  weight: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingAttractOptions.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | Indicates the attraction is optional (soft), with this weight score. |

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingAttractOptions.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* no weight. assignment is assumed to be required (hard).

Indicates the attraction is optional (soft), with this weight score.

---

### PodSchedulingColocateOptions <a name="PodSchedulingColocateOptions" id="cdk8s-plus-28.PodSchedulingColocateOptions"></a>

Options for `PodScheduling.colocate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingColocateOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSchedulingColocateOptions(
  topology: Topology = None,
  weight: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingColocateOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to coloate on. |
| <code><a href="#cdk8s-plus-28.PodSchedulingColocateOptions.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | Indicates the co-location is optional (soft), with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodSchedulingColocateOptions.property.topology"></a>

```python
topology: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to coloate on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingColocateOptions.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* no weight. co-location is assumed to be required (hard).

Indicates the co-location is optional (soft), with this weight score.

---

### PodSchedulingContextSpecV1Alpha2 <a name="PodSchedulingContextSpecV1Alpha2" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2"></a>

PodSchedulingContextSpec describes where resources for the Pod are needed.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodSchedulingContextSpecV1Alpha2(
  potential_nodes: typing.List[str] = None,
  selected_node: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.potentialNodes">potential_nodes</a></code> | <code>typing.List[str]</code> | PotentialNodes lists nodes where the Pod might be able to run. |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.selectedNode">selected_node</a></code> | <code>str</code> | SelectedNode is the node for which allocation of ResourceClaims that are referenced by the Pod and that use "WaitForFirstConsumer" allocation is to be attempted. |

---

##### `potential_nodes`<sup>Optional</sup> <a name="potential_nodes" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.potentialNodes"></a>

```python
potential_nodes: typing.List[str]
```

- *Type:* typing.List[str]

PotentialNodes lists nodes where the Pod might be able to run.

The size of this field is limited to 128. This is large enough for many clusters. Larger clusters may need more attempts to find a node that suits all pending resources. This may get increased in the future, but not reduced.

---

##### `selected_node`<sup>Optional</sup> <a name="selected_node" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.selectedNode"></a>

```python
selected_node: str
```

- *Type:* str

SelectedNode is the node for which allocation of ResourceClaims that are referenced by the Pod and that use "WaitForFirstConsumer" allocation is to be attempted.

---

### PodSchedulingGate <a name="PodSchedulingGate" id="cdk8s-plus-28.k8s.PodSchedulingGate"></a>

PodSchedulingGate is associated to a Pod to guard its scheduling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSchedulingGate.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodSchedulingGate(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingGate.property.name">name</a></code> | <code>str</code> | Name of the scheduling gate. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodSchedulingGate.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the scheduling gate.

Each scheduling gate must have a unique name field.

---

### PodSchedulingSeparateOptions <a name="PodSchedulingSeparateOptions" id="cdk8s-plus-28.PodSchedulingSeparateOptions"></a>

Options for `PodScheduling.separate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingSeparateOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSchedulingSeparateOptions(
  topology: Topology = None,
  weight: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingSeparateOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to separate on. |
| <code><a href="#cdk8s-plus-28.PodSchedulingSeparateOptions.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | Indicates the separation is optional (soft), with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodSchedulingSeparateOptions.property.topology"></a>

```python
topology: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to separate on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingSeparateOptions.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* no weight. separation is assumed to be required (hard).

Indicates the separation is optional (soft), with this weight score.

---

### PodSecurityContext <a name="PodSecurityContext" id="cdk8s-plus-28.k8s.PodSecurityContext"></a>

PodSecurityContext holds pod-level security attributes and common container settings.

Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSecurityContext.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodSecurityContext(
  fs_group: typing.Union[int, float] = None,
  fs_group_change_policy: str = None,
  run_as_group: typing.Union[int, float] = None,
  run_as_non_root: bool = None,
  run_as_user: typing.Union[int, float] = None,
  seccomp_profile: SeccompProfile = None,
  se_linux_options: SeLinuxOptions = None,
  supplemental_groups: typing.List[typing.Union[int, float]] = None,
  sysctls: typing.List[Sysctl] = None,
  windows_options: WindowsSecurityContextOptions = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroup">fs_group</a></code> | <code>typing.Union[int, float]</code> | A special supplemental group that applies to all containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroupChangePolicy">fs_group_change_policy</a></code> | <code>str</code> | fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsGroup">run_as_group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsNonRoot">run_as_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsUser">run_as_user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.seccompProfile">seccomp_profile</a></code> | <code>cdk8s_plus_28.k8s.SeccompProfile</code> | The seccomp options to use by the containers in this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.seLinuxOptions">se_linux_options</a></code> | <code>cdk8s_plus_28.k8s.SeLinuxOptions</code> | The SELinux context to be applied to all containers. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.supplementalGroups">supplemental_groups</a></code> | <code>typing.List[typing.Union[int, float]]</code> | A list of groups applied to the first process run in each container, in addition to the container's primary GID, the fsGroup (if specified), and group memberships defined in the container image for the uid of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.sysctls">sysctls</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Sysctl]</code> | Sysctls hold a list of namespaced sysctls used for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.windowsOptions">windows_options</a></code> | <code>cdk8s_plus_28.k8s.WindowsSecurityContextOptions</code> | The Windows specific settings applied to all containers. |

---

##### `fs_group`<sup>Optional</sup> <a name="fs_group" id="cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroup"></a>

```python
fs_group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

A special supplemental group that applies to all containers in a pod.

Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:

1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----

If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.

---

##### `fs_group_change_policy`<sup>Optional</sup> <a name="fs_group_change_policy" id="cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroupChangePolicy"></a>

```python
fs_group_change_policy: str
```

- *Type:* str

fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod.

This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.

---

##### `run_as_group`<sup>Optional</sup> <a name="run_as_group" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsGroup"></a>

```python
run_as_group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The GID to run the entrypoint of the container process.

Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `run_as_non_root`<sup>Optional</sup> <a name="run_as_non_root" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsNonRoot"></a>

```python
run_as_non_root: bool
```

- *Type:* bool

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

##### `run_as_user`<sup>Optional</sup> <a name="run_as_user" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsUser"></a>

```python
run_as_user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

The UID to run the entrypoint of the container process.

Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `seccomp_profile`<sup>Optional</sup> <a name="seccomp_profile" id="cdk8s-plus-28.k8s.PodSecurityContext.property.seccompProfile"></a>

```python
seccomp_profile: SeccompProfile
```

- *Type:* cdk8s_plus_28.k8s.SeccompProfile

The seccomp options to use by the containers in this pod.

Note that this field cannot be set when spec.os.name is windows.

---

##### `se_linux_options`<sup>Optional</sup> <a name="se_linux_options" id="cdk8s-plus-28.k8s.PodSecurityContext.property.seLinuxOptions"></a>

```python
se_linux_options: SeLinuxOptions
```

- *Type:* cdk8s_plus_28.k8s.SeLinuxOptions

The SELinux context to be applied to all containers.

If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `supplemental_groups`<sup>Optional</sup> <a name="supplemental_groups" id="cdk8s-plus-28.k8s.PodSecurityContext.property.supplementalGroups"></a>

```python
supplemental_groups: typing.List[typing.Union[int, float]]
```

- *Type:* typing.List[typing.Union[int, float]]

A list of groups applied to the first process run in each container, in addition to the container's primary GID, the fsGroup (if specified), and group memberships defined in the container image for the uid of the container process.

If unspecified, no additional groups are added to any container. Note that group memberships defined in the container image for the uid of the container process are still effective, even if they are not included in this list. Note that this field cannot be set when spec.os.name is windows.

---

##### `sysctls`<sup>Optional</sup> <a name="sysctls" id="cdk8s-plus-28.k8s.PodSecurityContext.property.sysctls"></a>

```python
sysctls: typing.List[Sysctl]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Sysctl]

Sysctls hold a list of namespaced sysctls used for the pod.

Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.

---

##### `windows_options`<sup>Optional</sup> <a name="windows_options" id="cdk8s-plus-28.k8s.PodSecurityContext.property.windowsOptions"></a>

```python
windows_options: WindowsSecurityContextOptions
```

- *Type:* cdk8s_plus_28.k8s.WindowsSecurityContextOptions

The Windows specific settings applied to all containers.

If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

---

### PodSecurityContextProps <a name="PodSecurityContextProps" id="cdk8s-plus-28.PodSecurityContextProps"></a>

Properties for `PodSecurityContext`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSecurityContextProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSecurityContextProps(
  ensure_non_root: bool = None,
  fs_group: typing.Union[int, float] = None,
  fs_group_change_policy: FsGroupChangePolicy = None,
  group: typing.Union[int, float] = None,
  sysctls: typing.List[Sysctl] = None,
  user: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.fsGroup">fs_group</a></code> | <code>typing.Union[int, float]</code> | Modify the ownership and permissions of pod volumes to this GID. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.fsGroupChangePolicy">fs_group_change_policy</a></code> | <code><a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a></code> | Defines behavior of changing ownership and permission of the volume before being exposed inside Pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.group">group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.sysctls">sysctls</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]</code> | Sysctls hold a list of namespaced sysctls used for the pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.user">user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |

---

##### `ensure_non_root`<sup>Optional</sup> <a name="ensure_non_root" id="cdk8s-plus-28.PodSecurityContextProps.property.ensureNonRoot"></a>

```python
ensure_non_root: bool
```

- *Type:* bool
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `fs_group`<sup>Optional</sup> <a name="fs_group" id="cdk8s-plus-28.PodSecurityContextProps.property.fsGroup"></a>

```python
fs_group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* Volume ownership is not changed.

Modify the ownership and permissions of pod volumes to this GID.

---

##### `fs_group_change_policy`<sup>Optional</sup> <a name="fs_group_change_policy" id="cdk8s-plus-28.PodSecurityContextProps.property.fsGroupChangePolicy"></a>

```python
fs_group_change_policy: FsGroupChangePolicy
```

- *Type:* <a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a>
- *Default:* FsGroupChangePolicy.ALWAYS

Defines behavior of changing ownership and permission of the volume before being exposed inside Pod.

This field will only apply to volume types which support fsGroup based ownership(and permissions).
It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.PodSecurityContextProps.property.group"></a>

```python
group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* Group configured by container runtime

The GID to run the entrypoint of the container process.

---

##### `sysctls`<sup>Optional</sup> <a name="sysctls" id="cdk8s-plus-28.PodSecurityContextProps.property.sysctls"></a>

```python
sysctls: typing.List[Sysctl]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]
- *Default:* No sysctls

Sysctls hold a list of namespaced sysctls used for the pod.

Pods with unsupported sysctls (by the container runtime) might fail to launch.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.PodSecurityContextProps.property.user"></a>

```python
user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* User specified in image metadata

The UID to run the entrypoint of the container process.

---

### PodSelectorConfig <a name="PodSelectorConfig" id="cdk8s-plus-28.PodSelectorConfig"></a>

Configuration for selecting pods, optionally in particular namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSelectorConfig.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSelectorConfig(
  label_selector: LabelSelector,
  namespaces: NamespaceSelectorConfig = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSelectorConfig.property.labelSelector">label_selector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to select pods by labels. |
| <code><a href="#cdk8s-plus-28.PodSelectorConfig.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig">NamespaceSelectorConfig</a></code> | Configuration for selecting which namepsaces are the pods allowed to be in. |

---

##### `label_selector`<sup>Required</sup> <a name="label_selector" id="cdk8s-plus-28.PodSelectorConfig.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

A selector to select pods by labels.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodSelectorConfig.property.namespaces"></a>

```python
namespaces: NamespaceSelectorConfig
```

- *Type:* <a href="#cdk8s-plus-28.NamespaceSelectorConfig">NamespaceSelectorConfig</a>

Configuration for selecting which namepsaces are the pods allowed to be in.

---

### PodsMetricSourceV2 <a name="PodsMetricSourceV2" id="cdk8s-plus-28.k8s.PodsMetricSourceV2"></a>

PodsMetricSource indicates how to scale on a metric describing each pod in the current scale target (for example, transactions-processed-per-second).

The values will be averaged together before being compared to the target value.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodsMetricSourceV2(
  metric: MetricIdentifierV2,
  target: MetricTargetV2
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodsMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s_plus_28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.PodsMetricSourceV2.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.property.metric"></a>

```python
metric: MetricIdentifierV2
```

- *Type:* cdk8s_plus_28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.property.target"></a>

```python
target: MetricTargetV2
```

- *Type:* cdk8s_plus_28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### PodSpec <a name="PodSpec" id="cdk8s-plus-28.k8s.PodSpec"></a>

PodSpec is a description of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodSpec(
  containers: typing.List[Container],
  active_deadline_seconds: typing.Union[int, float] = None,
  affinity: Affinity = None,
  automount_service_account_token: bool = None,
  dns_config: PodDnsConfig = None,
  dns_policy: str = None,
  enable_service_links: bool = None,
  ephemeral_containers: typing.List[EphemeralContainer] = None,
  host_aliases: typing.List[HostAlias] = None,
  host_ipc: bool = None,
  hostname: str = None,
  host_network: bool = None,
  host_pid: bool = None,
  host_users: bool = None,
  image_pull_secrets: typing.List[LocalObjectReference] = None,
  init_containers: typing.List[Container] = None,
  node_name: str = None,
  node_selector: typing.Mapping[str] = None,
  os: PodOs = None,
  overhead: typing.Mapping[Quantity] = None,
  preemption_policy: str = None,
  priority: typing.Union[int, float] = None,
  priority_class_name: str = None,
  readiness_gates: typing.List[PodReadinessGate] = None,
  resource_claims: typing.List[PodResourceClaim] = None,
  restart_policy: str = None,
  runtime_class_name: str = None,
  scheduler_name: str = None,
  scheduling_gates: typing.List[PodSchedulingGate] = None,
  security_context: PodSecurityContext = None,
  service_account: str = None,
  service_account_name: str = None,
  set_hostname_as_fqdn: bool = None,
  share_process_namespace: bool = None,
  subdomain: str = None,
  termination_grace_period_seconds: typing.Union[int, float] = None,
  tolerations: typing.List[Toleration] = None,
  topology_spread_constraints: typing.List[TopologySpreadConstraint] = None,
  volumes: typing.List[Volume] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.containers">containers</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Container]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.activeDeadlineSeconds">active_deadline_seconds</a></code> | <code>typing.Union[int, float]</code> | Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.affinity">affinity</a></code> | <code>cdk8s_plus_28.k8s.Affinity</code> | If specified, the pod's scheduling constraints. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | AutomountServiceAccountToken indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.dnsConfig">dns_config</a></code> | <code>cdk8s_plus_28.k8s.PodDnsConfig</code> | Specifies the DNS parameters of a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.dnsPolicy">dns_policy</a></code> | <code>str</code> | Set DNS policy for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.enableServiceLinks">enable_service_links</a></code> | <code>bool</code> | EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.ephemeralContainers">ephemeral_containers</a></code> | <code>typing.List[cdk8s_plus_28.k8s.EphemeralContainer]</code> | List of ephemeral containers run in this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostAliases">host_aliases</a></code> | <code>typing.List[cdk8s_plus_28.k8s.HostAlias]</code> | HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostIpc">host_ipc</a></code> | <code>bool</code> | Use the host's ipc namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostname">hostname</a></code> | <code>str</code> | Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host networking requested for this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostPid">host_pid</a></code> | <code>bool</code> | Use the host's pid namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostUsers">host_users</a></code> | <code>bool</code> | Use the host's user namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.imagePullSecrets">image_pull_secrets</a></code> | <code>typing.List[cdk8s_plus_28.k8s.LocalObjectReference]</code> | ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.initContainers">init_containers</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Container]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.nodeName">node_name</a></code> | <code>str</code> | NodeName is a request to schedule this pod onto a specific node. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.nodeSelector">node_selector</a></code> | <code>typing.Mapping[str]</code> | NodeSelector is a selector which must be true for the pod to fit on a node. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.os">os</a></code> | <code>cdk8s_plus_28.k8s.PodOs</code> | Specifies the OS of the containers in the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.overhead">overhead</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Overhead represents the resource overhead associated with running a pod for a given RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.preemptionPolicy">preemption_policy</a></code> | <code>str</code> | PreemptionPolicy is the Policy for preempting pods with lower priority. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.priority">priority</a></code> | <code>typing.Union[int, float]</code> | The priority value. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.priorityClassName">priority_class_name</a></code> | <code>str</code> | If specified, indicates the pod's priority. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.readinessGates">readiness_gates</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodReadinessGate]</code> | If specified, all readiness gates will be evaluated for pod readiness. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.resourceClaims">resource_claims</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodResourceClaim]</code> | ResourceClaims defines which ResourceClaims must be allocated and reserved before the Pod is allowed to start. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.restartPolicy">restart_policy</a></code> | <code>str</code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.runtimeClassName">runtime_class_name</a></code> | <code>str</code> | RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.schedulerName">scheduler_name</a></code> | <code>str</code> | If specified, the pod will be dispatched by specified scheduler. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.schedulingGates">scheduling_gates</a></code> | <code>typing.List[cdk8s_plus_28.k8s.PodSchedulingGate]</code> | SchedulingGates is an opaque list of values that if specified will block scheduling the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.securityContext">security_context</a></code> | <code>cdk8s_plus_28.k8s.PodSecurityContext</code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.serviceAccount">service_account</a></code> | <code>str</code> | DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.serviceAccountName">service_account_name</a></code> | <code>str</code> | ServiceAccountName is the name of the ServiceAccount to use to run this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.setHostnameAsFqdn">set_hostname_as_fqdn</a></code> | <code>bool</code> | If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.shareProcessNamespace">share_process_namespace</a></code> | <code>bool</code> | Share a single process namespace between all of the containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.subdomain">subdomain</a></code> | <code>str</code> | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.terminationGracePeriodSeconds">termination_grace_period_seconds</a></code> | <code>typing.Union[int, float]</code> | Optional duration in seconds the pod needs to terminate gracefully. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.tolerations">tolerations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Toleration]</code> | If specified, the pod's tolerations. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.topologySpreadConstraints">topology_spread_constraints</a></code> | <code>typing.List[cdk8s_plus_28.k8s.TopologySpreadConstraint]</code> | TopologySpreadConstraints describes how a group of pods ought to spread across topology domains. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.volumes">volumes</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Volume]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.k8s.PodSpec.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Container]

List of containers belonging to the pod.

Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.

---

##### `active_deadline_seconds`<sup>Optional</sup> <a name="active_deadline_seconds" id="cdk8s-plus-28.k8s.PodSpec.property.activeDeadlineSeconds"></a>

```python
active_deadline_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers.

Value must be a positive integer.

---

##### `affinity`<sup>Optional</sup> <a name="affinity" id="cdk8s-plus-28.k8s.PodSpec.property.affinity"></a>

```python
affinity: Affinity
```

- *Type:* cdk8s_plus_28.k8s.Affinity

If specified, the pod's scheduling constraints.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.k8s.PodSpec.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool

AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.

---

##### `dns_config`<sup>Optional</sup> <a name="dns_config" id="cdk8s-plus-28.k8s.PodSpec.property.dnsConfig"></a>

```python
dns_config: PodDnsConfig
```

- *Type:* cdk8s_plus_28.k8s.PodDnsConfig

Specifies the DNS parameters of a pod.

Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.

---

##### `dns_policy`<sup>Optional</sup> <a name="dns_policy" id="cdk8s-plus-28.k8s.PodSpec.property.dnsPolicy"></a>

```python
dns_policy: str
```

- *Type:* str
- *Default:* ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.

Set DNS policy for the pod.

Defaults to "ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.

---

##### `enable_service_links`<sup>Optional</sup> <a name="enable_service_links" id="cdk8s-plus-28.k8s.PodSpec.property.enableServiceLinks"></a>

```python
enable_service_links: bool
```

- *Type:* bool
- *Default:* true.

EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links.

Optional: Defaults to true.

---

##### `ephemeral_containers`<sup>Optional</sup> <a name="ephemeral_containers" id="cdk8s-plus-28.k8s.PodSpec.property.ephemeralContainers"></a>

```python
ephemeral_containers: typing.List[EphemeralContainer]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.EphemeralContainer]

List of ephemeral containers run in this pod.

Ephemeral containers may be run in an existing pod to perform user-initiated actions such as debugging. This list cannot be specified when creating a pod, and it cannot be modified by updating the pod spec. In order to add an ephemeral container to an existing pod, use the pod's ephemeralcontainers subresource.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.k8s.PodSpec.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.HostAlias]

HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified.

This is only valid for non-hostNetwork pods.

---

##### `host_ipc`<sup>Optional</sup> <a name="host_ipc" id="cdk8s-plus-28.k8s.PodSpec.property.hostIpc"></a>

```python
host_ipc: bool
```

- *Type:* bool
- *Default:* false.

Use the host's ipc namespace.

Optional: Default to false.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.PodSpec.property.hostname"></a>

```python
hostname: str
```

- *Type:* str

Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.k8s.PodSpec.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false.

Host networking requested for this pod.

Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.

---

##### `host_pid`<sup>Optional</sup> <a name="host_pid" id="cdk8s-plus-28.k8s.PodSpec.property.hostPid"></a>

```python
host_pid: bool
```

- *Type:* bool
- *Default:* false.

Use the host's pid namespace.

Optional: Default to false.

---

##### `host_users`<sup>Optional</sup> <a name="host_users" id="cdk8s-plus-28.k8s.PodSpec.property.hostUsers"></a>

```python
host_users: bool
```

- *Type:* bool
- *Default:* true. If set to true or not present, the pod will be run in the host user namespace, useful for when the pod needs a feature only available to the host user namespace, such as loading a kernel module with CAP_SYS_MODULE. When set to false, a new userns is created for the pod. Setting false is useful for mitigating container breakout vulnerabilities even allowing users to run their containers as root without actually having root privileges on the host. This field is alpha-level and is only honored by servers that enable the UserNamespacesSupport feature.

Use the host's user namespace.

Optional: Default to true. If set to true or not present, the pod will be run in the host user namespace, useful for when the pod needs a feature only available to the host user namespace, such as loading a kernel module with CAP_SYS_MODULE. When set to false, a new userns is created for the pod. Setting false is useful for mitigating container breakout vulnerabilities even allowing users to run their containers as root without actually having root privileges on the host. This field is alpha-level and is only honored by servers that enable the UserNamespacesSupport feature.

---

##### `image_pull_secrets`<sup>Optional</sup> <a name="image_pull_secrets" id="cdk8s-plus-28.k8s.PodSpec.property.imagePullSecrets"></a>

```python
image_pull_secrets: typing.List[LocalObjectReference]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.LocalObjectReference]

ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec.

If specified, these secrets will be passed to individual puller implementations for them to use. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.k8s.PodSpec.property.initContainers"></a>

```python
init_containers: typing.List[Container]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Container]

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/

---

##### `node_name`<sup>Optional</sup> <a name="node_name" id="cdk8s-plus-28.k8s.PodSpec.property.nodeName"></a>

```python
node_name: str
```

- *Type:* str

NodeName is a request to schedule this pod onto a specific node.

If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.

---

##### `node_selector`<sup>Optional</sup> <a name="node_selector" id="cdk8s-plus-28.k8s.PodSpec.property.nodeSelector"></a>

```python
node_selector: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

NodeSelector is a selector which must be true for the pod to fit on a node.

Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/

---

##### `os`<sup>Optional</sup> <a name="os" id="cdk8s-plus-28.k8s.PodSpec.property.os"></a>

```python
os: PodOs
```

- *Type:* cdk8s_plus_28.k8s.PodOs

Specifies the OS of the containers in the pod.

Some pod and container fields are restricted if this is set.

If the OS field is set to linux, the following fields must be unset: -securityContext.windowsOptions

If the OS field is set to windows, following fields must be unset: - spec.hostPID - spec.hostIPC - spec.hostUsers - spec.securityContext.seLinuxOptions - spec.securityContext.seccompProfile - spec.securityContext.fsGroup - spec.securityContext.fsGroupChangePolicy - spec.securityContext.sysctls - spec.shareProcessNamespace - spec.securityContext.runAsUser - spec.securityContext.runAsGroup - spec.securityContext.supplementalGroups - spec.containers[*].securityContext.seLinuxOptions - spec.containers[*].securityContext.seccompProfile - spec.containers[*].securityContext.capabilities - spec.containers[*].securityContext.readOnlyRootFilesystem - spec.containers[*].securityContext.privileged - spec.containers[*].securityContext.allowPrivilegeEscalation - spec.containers[*].securityContext.procMount - spec.containers[*].securityContext.runAsUser - spec.containers[*].securityContext.runAsGroup

---

##### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.PodSpec.property.overhead"></a>

```python
overhead: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

This field will be autopopulated at admission time by the RuntimeClass admission controller. If the RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests. The RuntimeClass admission controller will reject Pod create requests which have the overhead already set. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value defined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero. More info: https://git.k8s.io/enhancements/keps/sig-node/688-pod-overhead/README.md

---

##### `preemption_policy`<sup>Optional</sup> <a name="preemption_policy" id="cdk8s-plus-28.k8s.PodSpec.property.preemptionPolicy"></a>

```python
preemption_policy: str
```

- *Type:* str
- *Default:* PreemptLowerPriority if unset.

PreemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="cdk8s-plus-28.k8s.PodSpec.property.priority"></a>

```python
priority: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The priority value.

Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.

---

##### `priority_class_name`<sup>Optional</sup> <a name="priority_class_name" id="cdk8s-plus-28.k8s.PodSpec.property.priorityClassName"></a>

```python
priority_class_name: str
```

- *Type:* str

If specified, indicates the pod's priority.

"system-node-critical" and "system-cluster-critical" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.

---

##### `readiness_gates`<sup>Optional</sup> <a name="readiness_gates" id="cdk8s-plus-28.k8s.PodSpec.property.readinessGates"></a>

```python
readiness_gates: typing.List[PodReadinessGate]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodReadinessGate]

If specified, all readiness gates will be evaluated for pod readiness.

A pod is ready when all its containers are ready AND all conditions specified in the readiness gates have status equal to "True" More info: https://git.k8s.io/enhancements/keps/sig-network/580-pod-readiness-gates

---

##### `resource_claims`<sup>Optional</sup> <a name="resource_claims" id="cdk8s-plus-28.k8s.PodSpec.property.resourceClaims"></a>

```python
resource_claims: typing.List[PodResourceClaim]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodResourceClaim]

ResourceClaims defines which ResourceClaims must be allocated and reserved before the Pod is allowed to start.

The resources will be made available to those containers which consume them by name.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.k8s.PodSpec.property.restartPolicy"></a>

```python
restart_policy: str
```

- *Type:* str
- *Default:* Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy

Restart policy for all containers within the pod.

One of Always, OnFailure, Never. In some contexts, only a subset of those values may be permitted. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy

---

##### `runtime_class_name`<sup>Optional</sup> <a name="runtime_class_name" id="cdk8s-plus-28.k8s.PodSpec.property.runtimeClassName"></a>

```python
runtime_class_name: str
```

- *Type:* str

RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class.

---

##### `scheduler_name`<sup>Optional</sup> <a name="scheduler_name" id="cdk8s-plus-28.k8s.PodSpec.property.schedulerName"></a>

```python
scheduler_name: str
```

- *Type:* str

If specified, the pod will be dispatched by specified scheduler.

If not specified, the pod will be dispatched by default scheduler.

---

##### `scheduling_gates`<sup>Optional</sup> <a name="scheduling_gates" id="cdk8s-plus-28.k8s.PodSpec.property.schedulingGates"></a>

```python
scheduling_gates: typing.List[PodSchedulingGate]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.PodSchedulingGate]

SchedulingGates is an opaque list of values that if specified will block scheduling the pod.

If schedulingGates is not empty, the pod will stay in the SchedulingGated state and the scheduler will not attempt to schedule the pod.

SchedulingGates can only be set at pod creation time, and be removed only afterwards.

This is a beta feature enabled by the PodSchedulingReadiness feature gate.

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.k8s.PodSpec.property.securityContext"></a>

```python
security_context: PodSecurityContext
```

- *Type:* cdk8s_plus_28.k8s.PodSecurityContext
- *Default:* empty.  See type description for default values of each field.

SecurityContext holds pod-level security attributes and common container settings.

Optional: Defaults to empty.  See type description for default values of each field.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.k8s.PodSpec.property.serviceAccount"></a>

```python
service_account: str
```

- *Type:* str

DeprecatedServiceAccount is a depreciated alias for ServiceAccountName.

Deprecated: Use serviceAccountName instead.

---

##### `service_account_name`<sup>Optional</sup> <a name="service_account_name" id="cdk8s-plus-28.k8s.PodSpec.property.serviceAccountName"></a>

```python
service_account_name: str
```

- *Type:* str

ServiceAccountName is the name of the ServiceAccount to use to run this pod.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

##### `set_hostname_as_fqdn`<sup>Optional</sup> <a name="set_hostname_as_fqdn" id="cdk8s-plus-28.k8s.PodSpec.property.setHostnameAsFqdn"></a>

```python
set_hostname_as_fqdn: bool
```

- *Type:* bool
- *Default:* false.

If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).

In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname). In Windows containers, this means setting the registry value of hostname for the registry key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN. If a pod does not have FQDN, this has no effect. Default to false.

---

##### `share_process_namespace`<sup>Optional</sup> <a name="share_process_namespace" id="cdk8s-plus-28.k8s.PodSpec.property.shareProcessNamespace"></a>

```python
share_process_namespace: bool
```

- *Type:* bool
- *Default:* false.

Share a single process namespace between all of the containers in a pod.

When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.k8s.PodSpec.property.subdomain"></a>

```python
subdomain: str
```

- *Type:* str

If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all.

---

##### `termination_grace_period_seconds`<sup>Optional</sup> <a name="termination_grace_period_seconds" id="cdk8s-plus-28.k8s.PodSpec.property.terminationGracePeriodSeconds"></a>

```python
termination_grace_period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 30 seconds.

Optional duration in seconds the pod needs to terminate gracefully.

May be decreased in delete request. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.

---

##### `tolerations`<sup>Optional</sup> <a name="tolerations" id="cdk8s-plus-28.k8s.PodSpec.property.tolerations"></a>

```python
tolerations: typing.List[Toleration]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Toleration]

If specified, the pod's tolerations.

---

##### `topology_spread_constraints`<sup>Optional</sup> <a name="topology_spread_constraints" id="cdk8s-plus-28.k8s.PodSpec.property.topologySpreadConstraints"></a>

```python
topology_spread_constraints: typing.List[TopologySpreadConstraint]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.TopologySpreadConstraint]

TopologySpreadConstraints describes how a group of pods ought to spread across topology domains.

Scheduler will schedule pods in a way which abides by the constraints. All topologySpreadConstraints are ANDed.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.k8s.PodSpec.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Volume]

List of volumes that can be mounted by containers belonging to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes

---

### PodsSelectOptions <a name="PodsSelectOptions" id="cdk8s-plus-28.PodsSelectOptions"></a>

Options for `Pods.select`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodsSelectOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodsSelectOptions(
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None,
  namespaces: Namespaces = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.expressions">expressions</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]</code> | Expressions the pods must satisify. |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.labels">labels</a></code> | <code>typing.Mapping[str]</code> | Labels the pods must have. |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.Namespaces">Namespaces</a></code> | Namespaces the pods are allowed to be in. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.PodsSelectOptions.property.expressions"></a>

```python
expressions: typing.List[LabelExpression]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]
- *Default:* no expressions requirements.

Expressions the pods must satisify.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.PodsSelectOptions.property.labels"></a>

```python
labels: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]
- *Default:* no strict labels requirements.

Labels the pods must have.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodsSelectOptions.property.namespaces"></a>

```python
namespaces: Namespaces
```

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

### PodTemplateSpec <a name="PodTemplateSpec" id="cdk8s-plus-28.k8s.PodTemplateSpec"></a>

PodTemplateSpec describes the data a pod should have when created from a template.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodTemplateSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PodTemplateSpec(
  metadata: ObjectMeta = None,
  spec: PodSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodTemplateSpec.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.PodTemplateSpec.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.PodSpec</code> | Specification of the desired behavior of the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.PodTemplateSpec.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.PodTemplateSpec.property.spec"></a>

```python
spec: PodSpec
```

- *Type:* cdk8s_plus_28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### PolicyRule <a name="PolicyRule" id="cdk8s-plus-28.k8s.PolicyRule"></a>

PolicyRule holds information that describes a policy rule, but does not contain information about who the rule applies to or which namespace the rule applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PolicyRule(
  verbs: typing.List[str],
  api_groups: typing.List[str] = None,
  non_resource_ur_ls: typing.List[str] = None,
  resource_names: typing.List[str] = None,
  resources: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | Verbs is a list of Verbs that apply to ALL the ResourceKinds contained in this rule. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | APIGroups is the name of the APIGroup that contains the resources. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.nonResourceUrLs">non_resource_ur_ls</a></code> | <code>typing.List[str]</code> | NonResourceURLs is a set of partial urls that a user should have access to. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.resourceNames">resource_names</a></code> | <code>typing.List[str]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.resources">resources</a></code> | <code>typing.List[str]</code> | Resources is a list of resources this rule applies to. |

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.PolicyRule.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

Verbs is a list of Verbs that apply to ALL the ResourceKinds contained in this rule.

'*' represents all verbs.

---

##### `api_groups`<sup>Optional</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.PolicyRule.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

APIGroups is the name of the APIGroup that contains the resources.

If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed. "" represents the core API group and "*" represents all API groups.

---

##### `non_resource_ur_ls`<sup>Optional</sup> <a name="non_resource_ur_ls" id="cdk8s-plus-28.k8s.PolicyRule.property.nonResourceUrLs"></a>

```python
non_resource_ur_ls: typing.List[str]
```

- *Type:* typing.List[str]

NonResourceURLs is a set of partial urls that a user should have access to.

*s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as "pods" or "secrets") or non-resource URL paths (such as "/api"),  but not both.

---

##### `resource_names`<sup>Optional</sup> <a name="resource_names" id="cdk8s-plus-28.k8s.PolicyRule.property.resourceNames"></a>

```python
resource_names: typing.List[str]
```

- *Type:* typing.List[str]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.PolicyRule.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

Resources is a list of resources this rule applies to.

'*' represents all resources.

---

### PolicyRulesWithSubjectsV1Beta2 <a name="PolicyRulesWithSubjectsV1Beta2" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2"></a>

PolicyRulesWithSubjects prescribes a test that applies to a request to an apiserver.

The test considers the subject making the request, the verb being requested, and the resource to be acted upon. This PolicyRulesWithSubjects matches a request if and only if both (a) at least one member of subjects matches the request and (b) at least one member of resourceRules or nonResourceRules matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PolicyRulesWithSubjectsV1Beta2(
  subjects: typing.List[SubjectV1Beta2],
  non_resource_rules: typing.List[NonResourcePolicyRuleV1Beta2] = None,
  resource_rules: typing.List[ResourcePolicyRuleV1Beta2] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.SubjectV1Beta2]</code> | subjects is the list of normal user, serviceaccount, or group that this rule cares about. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.nonResourceRules">non_resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NonResourcePolicyRuleV1Beta2]</code> | `nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.resourceRules">resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ResourcePolicyRuleV1Beta2]</code> | `resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource. |

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.subjects"></a>

```python
subjects: typing.List[SubjectV1Beta2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.SubjectV1Beta2]

subjects is the list of normal user, serviceaccount, or group that this rule cares about.

There must be at least one member in this slice. A slice that includes both the system:authenticated and system:unauthenticated user groups matches every request. Required.

---

##### `non_resource_rules`<sup>Optional</sup> <a name="non_resource_rules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.nonResourceRules"></a>

```python
non_resource_rules: typing.List[NonResourcePolicyRuleV1Beta2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NonResourcePolicyRuleV1Beta2]

`nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL.

---

##### `resource_rules`<sup>Optional</sup> <a name="resource_rules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.resourceRules"></a>

```python
resource_rules: typing.List[ResourcePolicyRuleV1Beta2]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ResourcePolicyRuleV1Beta2]

`resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource.

At least one of `resourceRules` and `nonResourceRules` has to be non-empty.

---

### PolicyRulesWithSubjectsV1Beta3 <a name="PolicyRulesWithSubjectsV1Beta3" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3"></a>

PolicyRulesWithSubjects prescribes a test that applies to a request to an apiserver.

The test considers the subject making the request, the verb being requested, and the resource to be acted upon. This PolicyRulesWithSubjects matches a request if and only if both (a) at least one member of subjects matches the request and (b) at least one member of resourceRules or nonResourceRules matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PolicyRulesWithSubjectsV1Beta3(
  subjects: typing.List[SubjectV1Beta3],
  non_resource_rules: typing.List[NonResourcePolicyRuleV1Beta3] = None,
  resource_rules: typing.List[ResourcePolicyRuleV1Beta3] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.subjects">subjects</a></code> | <code>typing.List[cdk8s_plus_28.k8s.SubjectV1Beta3]</code> | subjects is the list of normal user, serviceaccount, or group that this rule cares about. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.nonResourceRules">non_resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.NonResourcePolicyRuleV1Beta3]</code> | `nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.resourceRules">resource_rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ResourcePolicyRuleV1Beta3]</code> | `resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource. |

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.subjects"></a>

```python
subjects: typing.List[SubjectV1Beta3]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.SubjectV1Beta3]

subjects is the list of normal user, serviceaccount, or group that this rule cares about.

There must be at least one member in this slice. A slice that includes both the system:authenticated and system:unauthenticated user groups matches every request. Required.

---

##### `non_resource_rules`<sup>Optional</sup> <a name="non_resource_rules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.nonResourceRules"></a>

```python
non_resource_rules: typing.List[NonResourcePolicyRuleV1Beta3]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.NonResourcePolicyRuleV1Beta3]

`nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL.

---

##### `resource_rules`<sup>Optional</sup> <a name="resource_rules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.resourceRules"></a>

```python
resource_rules: typing.List[ResourcePolicyRuleV1Beta3]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ResourcePolicyRuleV1Beta3]

`resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource.

At least one of `resourceRules` and `nonResourceRules` has to be non-empty.

---

### PortworxVolumeSource <a name="PortworxVolumeSource" id="cdk8s-plus-28.k8s.PortworxVolumeSource"></a>

PortworxVolumeSource represents a Portworx volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PortworxVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PortworxVolumeSource(
  volume_id: str,
  fs_type: str = None,
  read_only: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.volumeId">volume_id</a></code> | <code>str</code> | volumeID uniquely identifies a Portworx volume. |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |

---

##### `volume_id`<sup>Required</sup> <a name="volume_id" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.volumeId"></a>

```python
volume_id: str
```

- *Type:* str

volumeID uniquely identifies a Portworx volume.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system.

Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### Preconditions <a name="Preconditions" id="cdk8s-plus-28.k8s.Preconditions"></a>

Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Preconditions.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Preconditions(
  resource_version: str = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Preconditions.property.resourceVersion">resource_version</a></code> | <code>str</code> | Specifies the target ResourceVersion. |
| <code><a href="#cdk8s-plus-28.k8s.Preconditions.property.uid">uid</a></code> | <code>str</code> | Specifies the target UID. |

---

##### `resource_version`<sup>Optional</sup> <a name="resource_version" id="cdk8s-plus-28.k8s.Preconditions.property.resourceVersion"></a>

```python
resource_version: str
```

- *Type:* str

Specifies the target ResourceVersion.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.Preconditions.property.uid"></a>

```python
uid: str
```

- *Type:* str

Specifies the target UID.

---

### PreferredSchedulingTerm <a name="PreferredSchedulingTerm" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm"></a>

An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PreferredSchedulingTerm(
  preference: NodeSelectorTerm,
  weight: typing.Union[int, float]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.preference">preference</a></code> | <code>cdk8s_plus_28.k8s.NodeSelectorTerm</code> | A node selector term, associated with the corresponding weight. |
| <code><a href="#cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100. |

---

##### `preference`<sup>Required</sup> <a name="preference" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.preference"></a>

```python
preference: NodeSelectorTerm
```

- *Type:* cdk8s_plus_28.k8s.NodeSelectorTerm

A node selector term, associated with the corresponding weight.

---

##### `weight`<sup>Required</sup> <a name="weight" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.

---

### PriorityLevelConfigurationReferenceV1Beta2 <a name="PriorityLevelConfigurationReferenceV1Beta2" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2"></a>

PriorityLevelConfigurationReference contains information that points to the "request-priority" being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PriorityLevelConfigurationReferenceV1Beta2(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.property.name">name</a></code> | <code>str</code> | `name` is the name of the priority level configuration being referenced Required. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of the priority level configuration being referenced Required.

---

### PriorityLevelConfigurationReferenceV1Beta3 <a name="PriorityLevelConfigurationReferenceV1Beta3" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3"></a>

PriorityLevelConfigurationReference contains information that points to the "request-priority" being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PriorityLevelConfigurationReferenceV1Beta3(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.property.name">name</a></code> | <code>str</code> | `name` is the name of the priority level configuration being referenced Required. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of the priority level configuration being referenced Required.

---

### PriorityLevelConfigurationSpecV1Beta2 <a name="PriorityLevelConfigurationSpecV1Beta2" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2"></a>

PriorityLevelConfigurationSpec specifies the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PriorityLevelConfigurationSpecV1Beta2(
  type: str,
  exempt: ExemptPriorityLevelConfigurationV1Beta2 = None,
  limited: LimitedPriorityLevelConfigurationV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.type">type</a></code> | <code>str</code> | `type` indicates whether this priority level is subject to limitation on request execution. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.exempt">exempt</a></code> | <code>cdk8s_plus_28.k8s.ExemptPriorityLevelConfigurationV1Beta2</code> | `exempt` specifies how requests are handled for an exempt priority level. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.limited">limited</a></code> | <code>cdk8s_plus_28.k8s.LimitedPriorityLevelConfigurationV1Beta2</code> | `limited` specifies how requests are handled for a Limited priority level. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.type"></a>

```python
type: str
```

- *Type:* str

`type` indicates whether this priority level is subject to limitation on request execution.

A value of `"Exempt"` means that requests of this priority level are not subject to a limit (and thus are never queued) and do not detract from the capacity made available to other priority levels.  A value of `"Limited"` means that (a) requests of this priority level *are* subject to limits and (b) some of the server's limited capacity is made available exclusively to this priority level. Required.

---

##### `exempt`<sup>Optional</sup> <a name="exempt" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.exempt"></a>

```python
exempt: ExemptPriorityLevelConfigurationV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.ExemptPriorityLevelConfigurationV1Beta2

`exempt` specifies how requests are handled for an exempt priority level.

This field MUST be empty if `type` is `"Limited"`. This field MAY be non-empty if `type` is `"Exempt"`. If empty and `type` is `"Exempt"` then the default values for `ExemptPriorityLevelConfiguration` apply.

---

##### `limited`<sup>Optional</sup> <a name="limited" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.limited"></a>

```python
limited: LimitedPriorityLevelConfigurationV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.LimitedPriorityLevelConfigurationV1Beta2

`limited` specifies how requests are handled for a Limited priority level.

This field must be non-empty if and only if `type` is `"Limited"`.

---

### PriorityLevelConfigurationSpecV1Beta3 <a name="PriorityLevelConfigurationSpecV1Beta3" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3"></a>

PriorityLevelConfigurationSpec specifies the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.PriorityLevelConfigurationSpecV1Beta3(
  type: str,
  exempt: ExemptPriorityLevelConfigurationV1Beta3 = None,
  limited: LimitedPriorityLevelConfigurationV1Beta3 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.type">type</a></code> | <code>str</code> | `type` indicates whether this priority level is subject to limitation on request execution. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.exempt">exempt</a></code> | <code>cdk8s_plus_28.k8s.ExemptPriorityLevelConfigurationV1Beta3</code> | `exempt` specifies how requests are handled for an exempt priority level. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.limited">limited</a></code> | <code>cdk8s_plus_28.k8s.LimitedPriorityLevelConfigurationV1Beta3</code> | `limited` specifies how requests are handled for a Limited priority level. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.type"></a>

```python
type: str
```

- *Type:* str

`type` indicates whether this priority level is subject to limitation on request execution.

A value of `"Exempt"` means that requests of this priority level are not subject to a limit (and thus are never queued) and do not detract from the capacity made available to other priority levels.  A value of `"Limited"` means that (a) requests of this priority level *are* subject to limits and (b) some of the server's limited capacity is made available exclusively to this priority level. Required.

---

##### `exempt`<sup>Optional</sup> <a name="exempt" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.exempt"></a>

```python
exempt: ExemptPriorityLevelConfigurationV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.ExemptPriorityLevelConfigurationV1Beta3

`exempt` specifies how requests are handled for an exempt priority level.

This field MUST be empty if `type` is `"Limited"`. This field MAY be non-empty if `type` is `"Exempt"`. If empty and `type` is `"Exempt"` then the default values for `ExemptPriorityLevelConfiguration` apply.

---

##### `limited`<sup>Optional</sup> <a name="limited" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.limited"></a>

```python
limited: LimitedPriorityLevelConfigurationV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.LimitedPriorityLevelConfigurationV1Beta3

`limited` specifies how requests are handled for a Limited priority level.

This field must be non-empty if and only if `type` is `"Limited"`.

---

### Probe <a name="Probe" id="cdk8s-plus-28.k8s.Probe"></a>

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Probe.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Probe(
  exec: ExecAction = None,
  failure_threshold: typing.Union[int, float] = None,
  grpc: GrpcAction = None,
  http_get: HttpGetAction = None,
  initial_delay_seconds: typing.Union[int, float] = None,
  period_seconds: typing.Union[int, float] = None,
  success_threshold: typing.Union[int, float] = None,
  tcp_socket: TcpSocketAction = None,
  termination_grace_period_seconds: typing.Union[int, float] = None,
  timeout_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.exec">exec</a></code> | <code>cdk8s_plus_28.k8s.ExecAction</code> | Exec specifies the action to take. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.failureThreshold">failure_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.grpc">grpc</a></code> | <code>cdk8s_plus_28.k8s.GrpcAction</code> | GRPC specifies an action involving a GRPC port. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.httpGet">http_get</a></code> | <code>cdk8s_plus_28.k8s.HttpGetAction</code> | HTTPGet specifies the http request to perform. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.initialDelaySeconds">initial_delay_seconds</a></code> | <code>typing.Union[int, float]</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.periodSeconds">period_seconds</a></code> | <code>typing.Union[int, float]</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.successThreshold">success_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive successes for the probe to be considered successful after having failed. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.tcpSocket">tcp_socket</a></code> | <code>cdk8s_plus_28.k8s.TcpSocketAction</code> | TCPSocket specifies an action involving a TCP port. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.terminationGracePeriodSeconds">termination_grace_period_seconds</a></code> | <code>typing.Union[int, float]</code> | Optional duration in seconds the pod needs to terminate gracefully upon probe failure. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.timeoutSeconds">timeout_seconds</a></code> | <code>typing.Union[int, float]</code> | Number of seconds after which the probe times out. |

---

##### `exec`<sup>Optional</sup> <a name="exec" id="cdk8s-plus-28.k8s.Probe.property.exec"></a>

```python
exec: ExecAction
```

- *Type:* cdk8s_plus_28.k8s.ExecAction

Exec specifies the action to take.

---

##### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.k8s.Probe.property.failureThreshold"></a>

```python
failure_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3. Minimum value is 1.

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `grpc`<sup>Optional</sup> <a name="grpc" id="cdk8s-plus-28.k8s.Probe.property.grpc"></a>

```python
grpc: GrpcAction
```

- *Type:* cdk8s_plus_28.k8s.GrpcAction

GRPC specifies an action involving a GRPC port.

---

##### `http_get`<sup>Optional</sup> <a name="http_get" id="cdk8s-plus-28.k8s.Probe.property.httpGet"></a>

```python
http_get: HttpGetAction
```

- *Type:* cdk8s_plus_28.k8s.HttpGetAction

HTTPGet specifies the http request to perform.

---

##### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.k8s.Probe.property.initialDelaySeconds"></a>

```python
initial_delay_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Number of seconds after the container has started before liveness probes are initiated.

More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.k8s.Probe.property.periodSeconds"></a>

```python
period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 10 seconds. Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.k8s.Probe.property.successThreshold"></a>

```python
success_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1. Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed.

Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.

---

##### `tcp_socket`<sup>Optional</sup> <a name="tcp_socket" id="cdk8s-plus-28.k8s.Probe.property.tcpSocket"></a>

```python
tcp_socket: TcpSocketAction
```

- *Type:* cdk8s_plus_28.k8s.TcpSocketAction

TCPSocket specifies an action involving a TCP port.

---

##### `termination_grace_period_seconds`<sup>Optional</sup> <a name="termination_grace_period_seconds" id="cdk8s-plus-28.k8s.Probe.property.terminationGracePeriodSeconds"></a>

```python
termination_grace_period_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Optional duration in seconds the pod needs to terminate gracefully upon probe failure.

The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.k8s.Probe.property.timeoutSeconds"></a>

```python
timeout_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

### ProbeOptions <a name="ProbeOptions" id="cdk8s-plus-28.ProbeOptions"></a>

Probe options.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ProbeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ProbeOptions(
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.failureThreshold">failure_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.initialDelaySeconds">initial_delay_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.periodSeconds">period_seconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.successThreshold">success_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.timeoutSeconds">timeout_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |

---

##### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.ProbeOptions.property.failureThreshold"></a>

```python
failure_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.ProbeOptions.property.initialDelaySeconds"></a>

```python
initial_delay_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.ProbeOptions.property.periodSeconds"></a>

```python
period_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.ProbeOptions.property.successThreshold"></a>

```python
success_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.ProbeOptions.property.timeoutSeconds"></a>

```python
timeout_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

### ProjectedVolumeSource <a name="ProjectedVolumeSource" id="cdk8s-plus-28.k8s.ProjectedVolumeSource"></a>

Represents a projected volume source.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ProjectedVolumeSource(
  default_mode: typing.Union[int, float] = None,
  sources: typing.List[VolumeProjection] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ProjectedVolumeSource.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | defaultMode are the mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.ProjectedVolumeSource.property.sources">sources</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VolumeProjection]</code> | sources is the list of volume projections. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

defaultMode are the mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `sources`<sup>Optional</sup> <a name="sources" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.property.sources"></a>

```python
sources: typing.List[VolumeProjection]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VolumeProjection]

sources is the list of volume projections.

---

### QueuingConfigurationV1Beta2 <a name="QueuingConfigurationV1Beta2" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2"></a>

QueuingConfiguration holds the configuration parameters for queuing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.QueuingConfigurationV1Beta2(
  hand_size: typing.Union[int, float] = None,
  queue_length_limit: typing.Union[int, float] = None,
  queues: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.handSize">hand_size</a></code> | <code>typing.Union[int, float]</code> | `handSize` is a small positive number that configures the shuffle sharding of requests into queues. |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queueLengthLimit">queue_length_limit</a></code> | <code>typing.Union[int, float]</code> | `queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time; |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queues">queues</a></code> | <code>typing.Union[int, float]</code> | `queues` is the number of queues for this priority level. |

---

##### `hand_size`<sup>Optional</sup> <a name="hand_size" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.handSize"></a>

```python
hand_size: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`handSize` is a small positive number that configures the shuffle sharding of requests into queues.

When enqueuing a request at this priority level the request's flow identifier (a string pair) is hashed and the hash value is used to shuffle the list of queues and deal a hand of the size specified here.  The request is put into one of the shortest queues in that hand. `handSize` must be no larger than `queues`, and should be significantly smaller (so that a few heavy flows do not saturate most of the queues).  See the user-facing documentation for more extensive guidance on setting this field.  This field has a default value of 8.

---

##### `queue_length_limit`<sup>Optional</sup> <a name="queue_length_limit" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queueLengthLimit"></a>

```python
queue_length_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time;

excess requests are rejected.  This value must be positive.  If not specified, it will be defaulted to 50.

---

##### `queues`<sup>Optional</sup> <a name="queues" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queues"></a>

```python
queues: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`queues` is the number of queues for this priority level.

The queues exist independently at each apiserver. The value must be positive.  Setting it to 1 effectively precludes shufflesharding and thus makes the distinguisher method of associated flow schemas irrelevant.  This field has a default value of 64.

---

### QueuingConfigurationV1Beta3 <a name="QueuingConfigurationV1Beta3" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3"></a>

QueuingConfiguration holds the configuration parameters for queuing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.QueuingConfigurationV1Beta3(
  hand_size: typing.Union[int, float] = None,
  queue_length_limit: typing.Union[int, float] = None,
  queues: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.handSize">hand_size</a></code> | <code>typing.Union[int, float]</code> | `handSize` is a small positive number that configures the shuffle sharding of requests into queues. |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queueLengthLimit">queue_length_limit</a></code> | <code>typing.Union[int, float]</code> | `queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time; |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queues">queues</a></code> | <code>typing.Union[int, float]</code> | `queues` is the number of queues for this priority level. |

---

##### `hand_size`<sup>Optional</sup> <a name="hand_size" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.handSize"></a>

```python
hand_size: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`handSize` is a small positive number that configures the shuffle sharding of requests into queues.

When enqueuing a request at this priority level the request's flow identifier (a string pair) is hashed and the hash value is used to shuffle the list of queues and deal a hand of the size specified here.  The request is put into one of the shortest queues in that hand. `handSize` must be no larger than `queues`, and should be significantly smaller (so that a few heavy flows do not saturate most of the queues).  See the user-facing documentation for more extensive guidance on setting this field.  This field has a default value of 8.

---

##### `queue_length_limit`<sup>Optional</sup> <a name="queue_length_limit" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queueLengthLimit"></a>

```python
queue_length_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time;

excess requests are rejected.  This value must be positive.  If not specified, it will be defaulted to 50.

---

##### `queues`<sup>Optional</sup> <a name="queues" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queues"></a>

```python
queues: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

`queues` is the number of queues for this priority level.

The queues exist independently at each apiserver. The value must be positive.  Setting it to 1 effectively precludes shufflesharding and thus makes the distinguisher method of associated flow schemas irrelevant.  This field has a default value of 64.

---

### QuobyteVolumeSource <a name="QuobyteVolumeSource" id="cdk8s-plus-28.k8s.QuobyteVolumeSource"></a>

Represents a Quobyte mount that lasts the lifetime of a pod.

Quobyte volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.QuobyteVolumeSource(
  registry: str,
  volume: str,
  group: str = None,
  read_only: bool = None,
  tenant: str = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.registry">registry</a></code> | <code>str</code> | registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.volume">volume</a></code> | <code>str</code> | volume is a string that references an already created Quobyte volume by name. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.group">group</a></code> | <code>str</code> | group to map volume access to Default is no group. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the Quobyte volume to be mounted with read-only permissions. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.tenant">tenant</a></code> | <code>str</code> | tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.user">user</a></code> | <code>str</code> | user to map volume access to Defaults to serivceaccount user. |

---

##### `registry`<sup>Required</sup> <a name="registry" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.registry"></a>

```python
registry: str
```

- *Type:* str

registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes.

---

##### `volume`<sup>Required</sup> <a name="volume" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.volume"></a>

```python
volume: str
```

- *Type:* str

volume is a string that references an already created Quobyte volume by name.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.group"></a>

```python
group: str
```

- *Type:* str
- *Default:* no group

group to map volume access to Default is no group.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false.

readOnly here will force the Quobyte volume to be mounted with read-only permissions.

Defaults to false.

---

##### `tenant`<sup>Optional</sup> <a name="tenant" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.tenant"></a>

```python
tenant: str
```

- *Type:* str

tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.user"></a>

```python
user: str
```

- *Type:* str
- *Default:* serivceaccount user

user to map volume access to Defaults to serivceaccount user.

---

### RbdPersistentVolumeSource <a name="RbdPersistentVolumeSource" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource"></a>

Represents a Rados Block Device mount that lasts the lifetime of a pod.

RBD volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RbdPersistentVolumeSource(
  image: str,
  monitors: typing.List[str],
  fs_type: str = None,
  keyring: str = None,
  pool: str = None,
  read_only: bool = None,
  secret_ref: SecretReference = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.image">image</a></code> | <code>str</code> | image is the rados image name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.monitors">monitors</a></code> | <code>typing.List[str]</code> | monitors is a collection of Ceph monitors. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.keyring">keyring</a></code> | <code>str</code> | keyring is the path to key ring for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.pool">pool</a></code> | <code>str</code> | pool is the rados pool name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef is name of the authentication secret for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.user">user</a></code> | <code>str</code> | user is the rados user name. |

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.image"></a>

```python
image: str
```

- *Type:* str

image is the rados image name.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.monitors"></a>

```python
monitors: typing.List[str]
```

- *Type:* typing.List[str]

monitors is a collection of Ceph monitors.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

---

##### `keyring`<sup>Optional</sup> <a name="keyring" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.keyring"></a>

```python
keyring: str
```

- *Type:* str
- *Default:* etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

keyring is the path to key ring for RBDUser.

Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `pool`<sup>Optional</sup> <a name="pool" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.pool"></a>

```python
pool: str
```

- *Type:* str
- *Default:* rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

pool is the rados pool name.

Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference
- *Default:* nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

secretRef is name of the authentication secret for RBDUser.

If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.user"></a>

```python
user: str
```

- *Type:* str
- *Default:* admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

user is the rados user name.

Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

### RbdVolumeSource <a name="RbdVolumeSource" id="cdk8s-plus-28.k8s.RbdVolumeSource"></a>

Represents a Rados Block Device mount that lasts the lifetime of a pod.

RBD volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RbdVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RbdVolumeSource(
  image: str,
  monitors: typing.List[str],
  fs_type: str = None,
  keyring: str = None,
  pool: str = None,
  read_only: bool = None,
  secret_ref: LocalObjectReference = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.image">image</a></code> | <code>str</code> | image is the rados image name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.monitors">monitors</a></code> | <code>typing.List[str]</code> | monitors is a collection of Ceph monitors. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.keyring">keyring</a></code> | <code>str</code> | keyring is the path to key ring for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.pool">pool</a></code> | <code>str</code> | pool is the rados pool name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef is name of the authentication secret for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.user">user</a></code> | <code>str</code> | user is the rados user name. |

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.image"></a>

```python
image: str
```

- *Type:* str

image is the rados image name.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.monitors"></a>

```python
monitors: typing.List[str]
```

- *Type:* typing.List[str]

monitors is a collection of Ceph monitors.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

---

##### `keyring`<sup>Optional</sup> <a name="keyring" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.keyring"></a>

```python
keyring: str
```

- *Type:* str
- *Default:* etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

keyring is the path to key ring for RBDUser.

Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `pool`<sup>Optional</sup> <a name="pool" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.pool"></a>

```python
pool: str
```

- *Type:* str
- *Default:* rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

pool is the rados pool name.

Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference
- *Default:* nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

secretRef is name of the authentication secret for RBDUser.

If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.user"></a>

```python
user: str
```

- *Type:* str
- *Default:* admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

user is the rados user name.

Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

### ReplicaSetSpec <a name="ReplicaSetSpec" id="cdk8s-plus-28.k8s.ReplicaSetSpec"></a>

ReplicaSetSpec is the specification of a ReplicaSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ReplicaSetSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ReplicaSetSpec(
  selector: LabelSelector,
  min_ready_seconds: typing.Union[int, float] = None,
  replicas: typing.Union[int, float] = None,
  template: PodTemplateSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | Selector is a label query over pods that should match the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Replicas is the number of desired replicas. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Template is the object that describes the pod that will be created if insufficient replicas are detected. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

Selector is a label query over pods that should match the replica count.

Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller

Replicas is the number of desired replicas.

This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template is the object that describes the pod that will be created if insufficient replicas are detected.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

### ReplicationControllerSpec <a name="ReplicationControllerSpec" id="cdk8s-plus-28.k8s.ReplicationControllerSpec"></a>

ReplicationControllerSpec is the specification of a replication controller.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ReplicationControllerSpec(
  min_ready_seconds: typing.Union[int, float] = None,
  replicas: typing.Union[int, float] = None,
  selector: typing.Mapping[str] = None,
  template: PodTemplateSpec = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Replicas is the number of desired replicas. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.selector">selector</a></code> | <code>typing.Mapping[str]</code> | Selector is a label query over pods that should match the Replicas count. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | Template is the object that describes the pod that will be created if insufficient replicas are detected. |

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller

Replicas is the number of desired replicas.

This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.selector"></a>

```python
selector: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Selector is a label query over pods that should match the Replicas count.

If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

Template is the object that describes the pod that will be created if insufficient replicas are detected.

This takes precedence over a TemplateRef. The only allowed template.spec.restartPolicy value is "Always". More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

### ResourceAttributes <a name="ResourceAttributes" id="cdk8s-plus-28.k8s.ResourceAttributes"></a>

ResourceAttributes includes the authorization attributes available for resource requests to the Authorizer interface.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceAttributes.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceAttributes(
  group: str = None,
  name: str = None,
  namespace: str = None,
  resource: str = None,
  subresource: str = None,
  verb: str = None,
  version: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.group">group</a></code> | <code>str</code> | Group is the API Group of the Resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.name">name</a></code> | <code>str</code> | Name is the name of the resource being requested for a "get" or deleted for a "delete". |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.namespace">namespace</a></code> | <code>str</code> | Namespace is the namespace of the action being requested. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.resource">resource</a></code> | <code>str</code> | Resource is one of the existing resource types. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.subresource">subresource</a></code> | <code>str</code> | Subresource is one of the existing resource types. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.verb">verb</a></code> | <code>str</code> | Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.version">version</a></code> | <code>str</code> | Version is the API Version of the Resource. |

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ResourceAttributes.property.group"></a>

```python
group: str
```

- *Type:* str

Group is the API Group of the Resource.

"*" means all.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceAttributes.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of the resource being requested for a "get" or deleted for a "delete".

"" (empty) means all.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ResourceAttributes.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace is the namespace of the action being requested.

Currently, there is no distinction between no namespace and all namespaces "" (empty) is defaulted for LocalSubjectAccessReviews "" (empty) is empty for cluster-scoped resources "" (empty) means "all" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.ResourceAttributes.property.resource"></a>

```python
resource: str
```

- *Type:* str

Resource is one of the existing resource types.

"*" means all.

---

##### `subresource`<sup>Optional</sup> <a name="subresource" id="cdk8s-plus-28.k8s.ResourceAttributes.property.subresource"></a>

```python
subresource: str
```

- *Type:* str

Subresource is one of the existing resource types.

"" means none.

---

##### `verb`<sup>Optional</sup> <a name="verb" id="cdk8s-plus-28.k8s.ResourceAttributes.property.verb"></a>

```python
verb: str
```

- *Type:* str

Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.

"*" means all.

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk8s-plus-28.k8s.ResourceAttributes.property.version"></a>

```python
version: str
```

- *Type:* str

Version is the API Version of the Resource.

"*" means all.

---

### ResourceClaim <a name="ResourceClaim" id="cdk8s-plus-28.k8s.ResourceClaim"></a>

ResourceClaim references one entry in PodSpec.ResourceClaims.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaim.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceClaim(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaim.property.name">name</a></code> | <code>str</code> | Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClaim.property.name"></a>

```python
name: str
```

- *Type:* str

Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container.

---

### ResourceClaimParametersReferenceV1Alpha2 <a name="ResourceClaimParametersReferenceV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2"></a>

ResourceClaimParametersReference contains enough information to let you locate the parameters for a ResourceClaim.

The object must be in the same namespace as the ResourceClaim.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceClaimParametersReferenceV1Alpha2(
  kind: str,
  name: str,
  api_group: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.kind">kind</a></code> | <code>str</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.name">name</a></code> | <code>str</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup is the group for the resource being referenced. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the type of resource being referenced.

This is the same value as in the parameter object's metadata, for example "ConfigMap".

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of resource being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup is the group for the resource being referenced.

It is empty for the core API. This matches the group in the APIVersion that is used when creating the resources.

---

### ResourceClaimSpecV1Alpha2 <a name="ResourceClaimSpecV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2"></a>

ResourceClaimSpec defines how a resource is to be allocated.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceClaimSpecV1Alpha2(
  resource_class_name: str,
  allocation_mode: str = None,
  parameters_ref: ResourceClaimParametersReferenceV1Alpha2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.resourceClassName">resource_class_name</a></code> | <code>str</code> | ResourceClassName references the driver and additional parameters via the name of a ResourceClass that was created as part of the driver deployment. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.allocationMode">allocation_mode</a></code> | <code>str</code> | Allocation can start immediately or when a Pod wants to use the resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.parametersRef">parameters_ref</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimParametersReferenceV1Alpha2</code> | ParametersRef references a separate object with arbitrary parameters that will be used by the driver when allocating a resource for the claim. |

---

##### `resource_class_name`<sup>Required</sup> <a name="resource_class_name" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.resourceClassName"></a>

```python
resource_class_name: str
```

- *Type:* str

ResourceClassName references the driver and additional parameters via the name of a ResourceClass that was created as part of the driver deployment.

---

##### `allocation_mode`<sup>Optional</sup> <a name="allocation_mode" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.allocationMode"></a>

```python
allocation_mode: str
```

- *Type:* str

Allocation can start immediately or when a Pod wants to use the resource.

"WaitForFirstConsumer" is the default.

---

##### `parameters_ref`<sup>Optional</sup> <a name="parameters_ref" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.parametersRef"></a>

```python
parameters_ref: ResourceClaimParametersReferenceV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.ResourceClaimParametersReferenceV1Alpha2

ParametersRef references a separate object with arbitrary parameters that will be used by the driver when allocating a resource for the claim.

The object must be in the same namespace as the ResourceClaim.

---

### ResourceClaimTemplateSpecV1Alpha2 <a name="ResourceClaimTemplateSpecV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2"></a>

ResourceClaimTemplateSpec contains the metadata and fields for a ResourceClaim.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceClaimTemplateSpecV1Alpha2(
  spec: ResourceClaimSpecV1Alpha2,
  metadata: ObjectMeta = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.spec">spec</a></code> | <code>cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2</code> | Spec for the ResourceClaim. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s_plus_28.k8s.ObjectMeta</code> | ObjectMeta may contain labels and annotations that will be copied into the PVC when creating it. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.spec"></a>

```python
spec: ResourceClaimSpecV1Alpha2
```

- *Type:* cdk8s_plus_28.k8s.ResourceClaimSpecV1Alpha2

Spec for the ResourceClaim.

The entire content is copied unchanged into the ResourceClaim that gets created from this template. The same fields as in a ResourceClaim are also valid here.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.metadata"></a>

```python
metadata: ObjectMeta
```

- *Type:* cdk8s_plus_28.k8s.ObjectMeta

ObjectMeta may contain labels and annotations that will be copied into the PVC when creating it.

No other fields are allowed and will be rejected during validation.

---

### ResourceClassParametersReferenceV1Alpha2 <a name="ResourceClassParametersReferenceV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2"></a>

ResourceClassParametersReference contains enough information to let you locate the parameters for a ResourceClass.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceClassParametersReferenceV1Alpha2(
  kind: str,
  name: str,
  api_group: str = None,
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.kind">kind</a></code> | <code>str</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.name">name</a></code> | <code>str</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.namespace">namespace</a></code> | <code>str</code> | Namespace that contains the referenced resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the type of resource being referenced.

This is the same value as in the parameter object's metadata.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of resource being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup is the group for the resource being referenced.

It is empty for the core API. This matches the group in the APIVersion that is used when creating the resources.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace that contains the referenced resource.

Must be empty for cluster-scoped resources and non-empty for namespaced resources.

---

### ResourceFieldSelector <a name="ResourceFieldSelector" id="cdk8s-plus-28.k8s.ResourceFieldSelector"></a>

ResourceFieldSelector represents container resources (cpu, memory) and their output format.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceFieldSelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceFieldSelector(
  resource: str,
  container_name: str = None,
  divisor: Quantity = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.resource">resource</a></code> | <code>str</code> | Required: resource to select. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.containerName">container_name</a></code> | <code>str</code> | Container name: required for volumes, optional for env vars. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.divisor">divisor</a></code> | <code>cdk8s_plus_28.k8s.Quantity</code> | Specifies the output format of the exposed resources, defaults to "1". |

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.resource"></a>

```python
resource: str
```

- *Type:* str

Required: resource to select.

---

##### `container_name`<sup>Optional</sup> <a name="container_name" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.containerName"></a>

```python
container_name: str
```

- *Type:* str

Container name: required for volumes, optional for env vars.

---

##### `divisor`<sup>Optional</sup> <a name="divisor" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.divisor"></a>

```python
divisor: Quantity
```

- *Type:* cdk8s_plus_28.k8s.Quantity

Specifies the output format of the exposed resources, defaults to "1".

---

### ResourceMetricSourceV2 <a name="ResourceMetricSourceV2" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2"></a>

ResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.  Only one "target" type should be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceMetricSourceV2(
  name: str,
  target: MetricTargetV2
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.name">name</a></code> | <code>str</code> | name is the name of the resource in question. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.target">target</a></code> | <code>cdk8s_plus_28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the resource in question.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.target"></a>

```python
target: MetricTargetV2
```

- *Type:* cdk8s_plus_28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ResourcePolicyRuleV1Beta2 <a name="ResourcePolicyRuleV1Beta2" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2"></a>

ResourcePolicyRule is a predicate that matches some resource requests, testing the request's verb and the target resource.

A ResourcePolicyRule matches a resource request if and only if: (a) at least one member of verbs matches the request, (b) at least one member of apiGroups matches the request, (c) at least one member of resources matches the request, and (d) either (d1) the request does not specify a namespace (i.e., `Namespace==""`) and clusterScope is true or (d2) the request specifies a namespace and least one member of namespaces matches the request's namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourcePolicyRuleV1Beta2(
  api_groups: typing.List[str],
  resources: typing.List[str],
  verbs: typing.List[str],
  cluster_scope: bool = None,
  namespaces: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | `apiGroups` is a list of matching API groups and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.resources">resources</a></code> | <code>typing.List[str]</code> | `resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | `verbs` is a list of matching verbs and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.clusterScope">cluster_scope</a></code> | <code>bool</code> | `clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces). |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.namespaces">namespaces</a></code> | <code>typing.List[str]</code> | `namespaces` is a list of target namespaces that restricts matches. |

---

##### `api_groups`<sup>Required</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

`apiGroups` is a list of matching API groups and may not be empty.

"*" matches all API groups and, if present, must be the only entry. Required.

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

`resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs and, if present, must be the only entry. Required.

---

##### `cluster_scope`<sup>Optional</sup> <a name="cluster_scope" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.clusterScope"></a>

```python
cluster_scope: bool
```

- *Type:* bool

`clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces).

If this field is omitted or false then the `namespaces` field must contain a non-empty list.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.namespaces"></a>

```python
namespaces: typing.List[str]
```

- *Type:* typing.List[str]

`namespaces` is a list of target namespaces that restricts matches.

A request that specifies a target namespace matches only if either (a) this list contains that target namespace or (b) this list contains "*".  Note that "*" matches any specified namespace but does not match a request that *does not specify* a namespace (see the `clusterScope` field for that). This list may be empty, but only if `clusterScope` is true.

---

### ResourcePolicyRuleV1Beta3 <a name="ResourcePolicyRuleV1Beta3" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3"></a>

ResourcePolicyRule is a predicate that matches some resource requests, testing the request's verb and the target resource.

A ResourcePolicyRule matches a resource request if and only if: (a) at least one member of verbs matches the request, (b) at least one member of apiGroups matches the request, (c) at least one member of resources matches the request, and (d) either (d1) the request does not specify a namespace (i.e., `Namespace==""`) and clusterScope is true or (d2) the request specifies a namespace and least one member of namespaces matches the request's namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourcePolicyRuleV1Beta3(
  api_groups: typing.List[str],
  resources: typing.List[str],
  verbs: typing.List[str],
  cluster_scope: bool = None,
  namespaces: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | `apiGroups` is a list of matching API groups and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.resources">resources</a></code> | <code>typing.List[str]</code> | `resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | `verbs` is a list of matching verbs and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.clusterScope">cluster_scope</a></code> | <code>bool</code> | `clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces). |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.namespaces">namespaces</a></code> | <code>typing.List[str]</code> | `namespaces` is a list of target namespaces that restricts matches. |

---

##### `api_groups`<sup>Required</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

`apiGroups` is a list of matching API groups and may not be empty.

"*" matches all API groups and, if present, must be the only entry. Required.

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

`resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs and, if present, must be the only entry. Required.

---

##### `cluster_scope`<sup>Optional</sup> <a name="cluster_scope" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.clusterScope"></a>

```python
cluster_scope: bool
```

- *Type:* bool

`clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces).

If this field is omitted or false then the `namespaces` field must contain a non-empty list.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.namespaces"></a>

```python
namespaces: typing.List[str]
```

- *Type:* typing.List[str]

`namespaces` is a list of target namespaces that restricts matches.

A request that specifies a target namespace matches only if either (a) this list contains that target namespace or (b) this list contains "*".  Note that "*" matches any specified namespace but does not match a request that *does not specify* a namespace (see the `clusterScope` field for that). This list may be empty, but only if `clusterScope` is true.

---

### ResourceProps <a name="ResourceProps" id="cdk8s-plus-28.ResourceProps"></a>

Initialization properties for resources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ResourceProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ResourceProps(
  metadata: ApiObjectMetadata = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ResourceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ResourceProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

### ResourceQuotaSpec <a name="ResourceQuotaSpec" id="cdk8s-plus-28.k8s.ResourceQuotaSpec"></a>

ResourceQuotaSpec defines the desired hard limits to enforce for Quota.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceQuotaSpec(
  hard: typing.Mapping[Quantity] = None,
  scopes: typing.List[str] = None,
  scope_selector: ScopeSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.hard">hard</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | hard is the set of desired hard limits for each named resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopes">scopes</a></code> | <code>typing.List[str]</code> | A collection of filters that must match each object tracked by a quota. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopeSelector">scope_selector</a></code> | <code>cdk8s_plus_28.k8s.ScopeSelector</code> | scopeSelector is also a collection of filters like scopes that must match each object tracked by a quota but expressed using ScopeSelectorOperator in combination with possible values. |

---

##### `hard`<sup>Optional</sup> <a name="hard" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.hard"></a>

```python
hard: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

hard is the set of desired hard limits for each named resource.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

##### `scopes`<sup>Optional</sup> <a name="scopes" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopes"></a>

```python
scopes: typing.List[str]
```

- *Type:* typing.List[str]

A collection of filters that must match each object tracked by a quota.

If not specified, the quota matches all objects.

---

##### `scope_selector`<sup>Optional</sup> <a name="scope_selector" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopeSelector"></a>

```python
scope_selector: ScopeSelector
```

- *Type:* cdk8s_plus_28.k8s.ScopeSelector

scopeSelector is also a collection of filters like scopes that must match each object tracked by a quota but expressed using ScopeSelectorOperator in combination with possible values.

For a resource to match, both scopes AND scopeSelector (if specified in spec), must be matched.

---

### ResourceRequirements <a name="ResourceRequirements" id="cdk8s-plus-28.k8s.ResourceRequirements"></a>

ResourceRequirements describes the compute resource requirements.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceRequirements.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ResourceRequirements(
  claims: typing.List[ResourceClaim] = None,
  limits: typing.Mapping[Quantity] = None,
  requests: typing.Mapping[Quantity] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.claims">claims</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ResourceClaim]</code> | Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.limits">limits</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Limits describes the maximum amount of compute resources allowed. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.requests">requests</a></code> | <code>typing.Mapping[cdk8s_plus_28.k8s.Quantity]</code> | Requests describes the minimum amount of compute resources required. |

---

##### `claims`<sup>Optional</sup> <a name="claims" id="cdk8s-plus-28.k8s.ResourceRequirements.property.claims"></a>

```python
claims: typing.List[ResourceClaim]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ResourceClaim]

Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable. It can only be set for containers.

---

##### `limits`<sup>Optional</sup> <a name="limits" id="cdk8s-plus-28.k8s.ResourceRequirements.property.limits"></a>

```python
limits: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Limits describes the maximum amount of compute resources allowed.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `requests`<sup>Optional</sup> <a name="requests" id="cdk8s-plus-28.k8s.ResourceRequirements.property.requests"></a>

```python
requests: typing.Mapping[Quantity]
```

- *Type:* typing.Mapping[cdk8s_plus_28.k8s.Quantity]

Requests describes the minimum amount of compute resources required.

If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. Requests cannot exceed Limits. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

### RoleBindingProps <a name="RoleBindingProps" id="cdk8s-plus-28.RoleBindingProps"></a>

Properties for `RoleBinding`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RoleBindingProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.RoleBindingProps(
  metadata: ApiObjectMetadata = None,
  role: IRole
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.RoleBindingProps.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IRole">IRole</a></code> | The role to bind to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.RoleBindingProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.RoleBindingProps.property.role"></a>

```python
role: IRole
```

- *Type:* <a href="#cdk8s-plus-28.IRole">IRole</a>

The role to bind to.

A RoleBinding can reference a Role or a ClusterRole.

---

### RolePolicyRule <a name="RolePolicyRule" id="cdk8s-plus-28.RolePolicyRule"></a>

Policy rule of a `Role.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RolePolicyRule.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.RolePolicyRule(
  resources: typing.List[IApiResource],
  verbs: typing.List[str]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RolePolicyRule.property.resources">resources</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.IApiResource">IApiResource</a>]</code> | Resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.RolePolicyRule.property.verbs">verbs</a></code> | <code>typing.List[str]</code> | Verbs to allow. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.RolePolicyRule.property.resources"></a>

```python
resources: typing.List[IApiResource]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.IApiResource">IApiResource</a>]

Resources this rule applies to.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.RolePolicyRule.property.verbs"></a>

```python
verbs: typing.List[str]
```

- *Type:* typing.List[str]

Verbs to allow.

(e.g ['get', 'watch'])

---

### RoleProps <a name="RoleProps" id="cdk8s-plus-28.RoleProps"></a>

Properties for `Role`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RoleProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.RoleProps(
  metadata: ApiObjectMetadata = None,
  rules: typing.List[RolePolicyRule] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.RoleProps.property.rules">rules</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]</code> | A list of rules the role should allow. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.RoleProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.RoleProps.property.rules"></a>

```python
rules: typing.List[RolePolicyRule]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>]
- *Default:* []

A list of rules the role should allow.

---

### RoleRef <a name="RoleRef" id="cdk8s-plus-28.k8s.RoleRef"></a>

RoleRef contains information that points to the role being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RoleRef.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RoleRef(
  api_group: str,
  kind: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.kind">kind</a></code> | <code>str</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.name">name</a></code> | <code>str</code> | Name is the name of resource being referenced. |

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.k8s.RoleRef.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup is the group for the resource being referenced.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.RoleRef.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.RoleRef.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of resource being referenced.

---

### RollingUpdateDaemonSet <a name="RollingUpdateDaemonSet" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet"></a>

Spec to control the desired behavior of daemon set rolling update.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RollingUpdateDaemonSet(
  max_surge: IntOrString = None,
  max_unavailable: IntOrString = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxSurge">max_surge</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | The maximum number of nodes with an existing available DaemonSet pod that can have an updated DaemonSet pod during during an update. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxUnavailable">max_unavailable</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | The maximum number of DaemonSet pods that can be unavailable during the update. |

---

##### `max_surge`<sup>Optional</sup> <a name="max_surge" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxSurge"></a>

```python
max_surge: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

The maximum number of nodes with an existing available DaemonSet pod that can have an updated DaemonSet pod during during an update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up to a minimum of 1. Default value is 0. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their a new pod created before the old pod is marked as deleted. The update starts by launching new pods on 30% of nodes. Once an updated pod is available (Ready for at least minReadySeconds) the old DaemonSet pod on that node is marked deleted. If the old pod becomes unavailable for any reason (Ready transitions to false, is evicted, or is drained) an updated pod is immediatedly created on that node without considering surge limits. Allowing surge implies the possibility that the resources consumed by the daemonset on any given node can double if the readiness check fails, and so resource intensive daemonsets should take into account that they may cause evictions during disruption.

---

##### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxUnavailable"></a>

```python
max_unavailable: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

The maximum number of DaemonSet pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0 if MaxSurge is 0 Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.

---

### RollingUpdateDeployment <a name="RollingUpdateDeployment" id="cdk8s-plus-28.k8s.RollingUpdateDeployment"></a>

Spec to control the desired behavior of rolling update.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RollingUpdateDeployment(
  max_surge: IntOrString = None,
  max_unavailable: IntOrString = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxSurge">max_surge</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | The maximum number of pods that can be scheduled above the desired number of pods. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxUnavailable">max_unavailable</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | The maximum number of pods that can be unavailable during the update. |

---

##### `max_surge`<sup>Optional</sup> <a name="max_surge" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxSurge"></a>

```python
max_surge: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString
- *Default:* 25%. Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.

The maximum number of pods that can be scheduled above the desired number of pods.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.

---

##### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxUnavailable"></a>

```python
max_unavailable: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString
- *Default:* 25%. Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.

---

### RollingUpdateStatefulSetStrategy <a name="RollingUpdateStatefulSetStrategy" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy"></a>

RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RollingUpdateStatefulSetStrategy(
  max_unavailable: IntOrString = None,
  partition: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.maxUnavailable">max_unavailable</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | The maximum number of pods that can be unavailable during the update. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | Partition indicates the ordinal at which the StatefulSet should be partitioned for updates. |

---

##### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.maxUnavailable"></a>

```python
max_unavailable: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString
- *Default:* 1. This field is alpha-level and is only honored by servers that enable the MaxUnavailableStatefulSet feature. The field applies to all pods in the range 0 to Replicas-1. That means if there is any unavailable pod in the range 0 to Replicas-1, it will be counted towards MaxUnavailable.

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding up. This can not be 0. Defaults to 1. This field is alpha-level and is only honored by servers that enable the MaxUnavailableStatefulSet feature. The field applies to all pods in the range 0 to Replicas-1. That means if there is any unavailable pod in the range 0 to Replicas-1, it will be counted towards MaxUnavailable.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

Partition indicates the ordinal at which the StatefulSet should be partitioned for updates.

During a rolling update, all pods from ordinal Replicas-1 to Partition are updated. All pods from ordinal Partition-1 to 0 remain untouched. This is helpful in being able to do a canary based deployment. The default value is 0.

---

### RuleWithOperations <a name="RuleWithOperations" id="cdk8s-plus-28.k8s.RuleWithOperations"></a>

RuleWithOperations is a tuple of Operations and Resources.

It is recommended to make sure that all the tuple expansions are valid.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RuleWithOperations.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.RuleWithOperations(
  api_groups: typing.List[str] = None,
  api_versions: typing.List[str] = None,
  operations: typing.List[str] = None,
  resources: typing.List[str] = None,
  scope: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.apiGroups">api_groups</a></code> | <code>typing.List[str]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.apiVersions">api_versions</a></code> | <code>typing.List[str]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.operations">operations</a></code> | <code>typing.List[str]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.resources">resources</a></code> | <code>typing.List[str]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.scope">scope</a></code> | <code>str</code> | scope specifies the scope of this rule. |

---

##### `api_groups`<sup>Optional</sup> <a name="api_groups" id="cdk8s-plus-28.k8s.RuleWithOperations.property.apiGroups"></a>

```python
api_groups: typing.List[str]
```

- *Type:* typing.List[str]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `api_versions`<sup>Optional</sup> <a name="api_versions" id="cdk8s-plus-28.k8s.RuleWithOperations.property.apiVersions"></a>

```python
api_versions: typing.List[str]
```

- *Type:* typing.List[str]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.RuleWithOperations.property.operations"></a>

```python
operations: typing.List[str]
```

- *Type:* typing.List[str]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.RuleWithOperations.property.resources"></a>

```python
resources: typing.List[str]
```

- *Type:* typing.List[str]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '*/scale' means all scale subresources. '*/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.RuleWithOperations.property.scope"></a>

```python
scope: str
```

- *Type:* str
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### ScaleIoPersistentVolumeSource <a name="ScaleIoPersistentVolumeSource" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource"></a>

ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ScaleIoPersistentVolumeSource(
  gateway: str,
  secret_ref: SecretReference,
  system: str,
  fs_type: str = None,
  protection_domain: str = None,
  read_only: bool = None,
  ssl_enabled: bool = None,
  storage_mode: str = None,
  storage_pool: str = None,
  volume_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.gateway">gateway</a></code> | <code>str</code> | gateway is the host address of the ScaleIO API Gateway. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.SecretReference</code> | secretRef references to the secret for ScaleIO user and other sensitive information. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.system">system</a></code> | <code>str</code> | system is the name of the storage system as configured in ScaleIO. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.protectionDomain">protection_domain</a></code> | <code>str</code> | protectionDomain is the name of the ScaleIO Protection Domain for the configured storage. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.sslEnabled">ssl_enabled</a></code> | <code>bool</code> | sslEnabled is the flag to enable/disable SSL communication with Gateway, default false. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storageMode">storage_mode</a></code> | <code>str</code> | storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storagePool">storage_pool</a></code> | <code>str</code> | storagePool is the ScaleIO Storage Pool associated with the protection domain. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.volumeName">volume_name</a></code> | <code>str</code> | volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source. |

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.gateway"></a>

```python
gateway: str
```

- *Type:* str

gateway is the host address of the ScaleIO API Gateway.

---

##### `secret_ref`<sup>Required</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: SecretReference
```

- *Type:* cdk8s_plus_28.k8s.SecretReference

secretRef references to the secret for ScaleIO user and other sensitive information.

If this is not provided, Login operation will fail.

---

##### `system`<sup>Required</sup> <a name="system" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.system"></a>

```python
system: str
```

- *Type:* str

system is the name of the storage system as configured in ScaleIO.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* xfs"

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs"

---

##### `protection_domain`<sup>Optional</sup> <a name="protection_domain" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.protectionDomain"></a>

```python
protection_domain: str
```

- *Type:* str

protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `ssl_enabled`<sup>Optional</sup> <a name="ssl_enabled" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.sslEnabled"></a>

```python
ssl_enabled: bool
```

- *Type:* bool

sslEnabled is the flag to enable/disable SSL communication with Gateway, default false.

---

##### `storage_mode`<sup>Optional</sup> <a name="storage_mode" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storageMode"></a>

```python
storage_mode: str
```

- *Type:* str
- *Default:* ThinProvisioned.

storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.

Default is ThinProvisioned.

---

##### `storage_pool`<sup>Optional</sup> <a name="storage_pool" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storagePool"></a>

```python
storage_pool: str
```

- *Type:* str

storagePool is the ScaleIO Storage Pool associated with the protection domain.

---

##### `volume_name`<sup>Optional</sup> <a name="volume_name" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.volumeName"></a>

```python
volume_name: str
```

- *Type:* str

volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

---

### ScaleIoVolumeSource <a name="ScaleIoVolumeSource" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource"></a>

ScaleIOVolumeSource represents a persistent ScaleIO volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ScaleIoVolumeSource(
  gateway: str,
  secret_ref: LocalObjectReference,
  system: str,
  fs_type: str = None,
  protection_domain: str = None,
  read_only: bool = None,
  ssl_enabled: bool = None,
  storage_mode: str = None,
  storage_pool: str = None,
  volume_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.gateway">gateway</a></code> | <code>str</code> | gateway is the host address of the ScaleIO API Gateway. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef references to the secret for ScaleIO user and other sensitive information. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.system">system</a></code> | <code>str</code> | system is the name of the storage system as configured in ScaleIO. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.protectionDomain">protection_domain</a></code> | <code>str</code> | protectionDomain is the name of the ScaleIO Protection Domain for the configured storage. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.sslEnabled">ssl_enabled</a></code> | <code>bool</code> | sslEnabled Flag enable/disable SSL communication with Gateway, default false. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storageMode">storage_mode</a></code> | <code>str</code> | storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storagePool">storage_pool</a></code> | <code>str</code> | storagePool is the ScaleIO Storage Pool associated with the protection domain. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.volumeName">volume_name</a></code> | <code>str</code> | volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source. |

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.gateway"></a>

```python
gateway: str
```

- *Type:* str

gateway is the host address of the ScaleIO API Gateway.

---

##### `secret_ref`<sup>Required</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef references to the secret for ScaleIO user and other sensitive information.

If this is not provided, Login operation will fail.

---

##### `system`<sup>Required</sup> <a name="system" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.system"></a>

```python
system: str
```

- *Type:* str

system is the name of the storage system as configured in ScaleIO.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str
- *Default:* xfs".

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".

---

##### `protection_domain`<sup>Optional</sup> <a name="protection_domain" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.protectionDomain"></a>

```python
protection_domain: str
```

- *Type:* str

protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `ssl_enabled`<sup>Optional</sup> <a name="ssl_enabled" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.sslEnabled"></a>

```python
ssl_enabled: bool
```

- *Type:* bool

sslEnabled Flag enable/disable SSL communication with Gateway, default false.

---

##### `storage_mode`<sup>Optional</sup> <a name="storage_mode" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storageMode"></a>

```python
storage_mode: str
```

- *Type:* str
- *Default:* ThinProvisioned.

storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.

Default is ThinProvisioned.

---

##### `storage_pool`<sup>Optional</sup> <a name="storage_pool" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storagePool"></a>

```python
storage_pool: str
```

- *Type:* str

storagePool is the ScaleIO Storage Pool associated with the protection domain.

---

##### `volume_name`<sup>Optional</sup> <a name="volume_name" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.volumeName"></a>

```python
volume_name: str
```

- *Type:* str

volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

---

### ScaleSpec <a name="ScaleSpec" id="cdk8s-plus-28.k8s.ScaleSpec"></a>

ScaleSpec describes the attributes of a scale subresource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ScaleSpec(
  replicas: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleSpec.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | replicas is the desired number of instances for the scaled object. |

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ScaleSpec.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

replicas is the desired number of instances for the scaled object.

---

### ScalingPolicy <a name="ScalingPolicy" id="cdk8s-plus-28.ScalingPolicy"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingPolicy.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ScalingPolicy(
  replicas: Replicas,
  duration: Duration = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingPolicy.property.replicas">replicas</a></code> | <code><a href="#cdk8s-plus-28.Replicas">Replicas</a></code> | The type and quantity of replicas to change. |
| <code><a href="#cdk8s-plus-28.ScalingPolicy.property.duration">duration</a></code> | <code>cdk8s.Duration</code> | The amount of time the scaling policy has to continue scaling before the target metric must be revalidated. |

---

##### `replicas`<sup>Required</sup> <a name="replicas" id="cdk8s-plus-28.ScalingPolicy.property.replicas"></a>

```python
replicas: Replicas
```

- *Type:* <a href="#cdk8s-plus-28.Replicas">Replicas</a>

The type and quantity of replicas to change.

---

##### `duration`<sup>Optional</sup> <a name="duration" id="cdk8s-plus-28.ScalingPolicy.property.duration"></a>

```python
duration: Duration
```

- *Type:* cdk8s.Duration
- *Default:* 15 seconds

The amount of time the scaling policy has to continue scaling before the target metric must be revalidated.

Must be greater than 0 seconds and no longer than 30 minutes.

---

### ScalingRules <a name="ScalingRules" id="cdk8s-plus-28.ScalingRules"></a>

Defines the scaling behavior for one direction.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingRules.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ScalingRules(
  policies: typing.List[ScalingPolicy] = None,
  stabilization_window: Duration = None,
  strategy: ScalingStrategy = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.policies">policies</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ScalingPolicy">ScalingPolicy</a>]</code> | The scaling policies. |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.stabilizationWindow">stabilization_window</a></code> | <code>cdk8s.Duration</code> | Defines the window of past metrics that the autoscaler should consider when calculating wether or not autoscaling should occur. |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.ScalingStrategy">ScalingStrategy</a></code> | The strategy to use when scaling. |

---

##### `policies`<sup>Optional</sup> <a name="policies" id="cdk8s-plus-28.ScalingRules.property.policies"></a>

```python
policies: typing.List[ScalingPolicy]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ScalingPolicy">ScalingPolicy</a>]
- *Default:* * Scale up   * Increase no more than 4 pods per 60 seconds   * Double the number of pods per 60 seconds * Scale down   * Decrease to minReplica count

The scaling policies.

---

##### `stabilization_window`<sup>Optional</sup> <a name="stabilization_window" id="cdk8s-plus-28.ScalingRules.property.stabilizationWindow"></a>

```python
stabilization_window: Duration
```

- *Type:* cdk8s.Duration
- *Default:* * On scale down no stabilization is performed. * On scale up stabilization is performed for 5 minutes.

Defines the window of past metrics that the autoscaler should consider when calculating wether or not autoscaling should occur.

Minimum duration is 1 second, max is 1 hour.

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
stabilizationWindow: Duration.minutes(30)
```


##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.ScalingRules.property.strategy"></a>

```python
strategy: ScalingStrategy
```

- *Type:* <a href="#cdk8s-plus-28.ScalingStrategy">ScalingStrategy</a>
- *Default:* MAX_CHANGE

The strategy to use when scaling.

---

### ScalingTarget <a name="ScalingTarget" id="cdk8s-plus-28.ScalingTarget"></a>

Properties used to configure the target of an Autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingTarget.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ScalingTarget(
  api_version: str,
  containers: typing.List[Container],
  kind: str,
  name: str,
  replicas: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]</code> | Container definitions associated with the target. |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | The fixed number of replicas defined on the target. |

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ScalingTarget.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.ScalingTarget.property.containers"></a>

```python
containers: typing.List[Container]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Container">Container</a>]

Container definitions associated with the target.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ScalingTarget.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ScalingTarget.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.ScalingTarget.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The fixed number of replicas defined on the target.

This is used
for validation purposes as Scalable targets should not have a
fixed number of replicas.

---

### Scheduling <a name="Scheduling" id="cdk8s-plus-28.k8s.Scheduling"></a>

Scheduling specifies the scheduling constraints for nodes supporting a RuntimeClass.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Scheduling.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Scheduling(
  node_selector: typing.Mapping[str] = None,
  tolerations: typing.List[Toleration] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Scheduling.property.nodeSelector">node_selector</a></code> | <code>typing.Mapping[str]</code> | nodeSelector lists labels that must be present on nodes that support this RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.Scheduling.property.tolerations">tolerations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.Toleration]</code> | tolerations are appended (excluding duplicates) to pods running with this RuntimeClass during admission, effectively unioning the set of nodes tolerated by the pod and the RuntimeClass. |

---

##### `node_selector`<sup>Optional</sup> <a name="node_selector" id="cdk8s-plus-28.k8s.Scheduling.property.nodeSelector"></a>

```python
node_selector: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

nodeSelector lists labels that must be present on nodes that support this RuntimeClass.

Pods using this RuntimeClass can only be scheduled to a node matched by this selector. The RuntimeClass nodeSelector is merged with a pod's existing nodeSelector. Any conflicts will cause the pod to be rejected in admission.

---

##### `tolerations`<sup>Optional</sup> <a name="tolerations" id="cdk8s-plus-28.k8s.Scheduling.property.tolerations"></a>

```python
tolerations: typing.List[Toleration]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.Toleration]

tolerations are appended (excluding duplicates) to pods running with this RuntimeClass during admission, effectively unioning the set of nodes tolerated by the pod and the RuntimeClass.

---

### ScopedResourceSelectorRequirement <a name="ScopedResourceSelectorRequirement" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement"></a>

A scoped-resource selector requirement is a selector that contains values, a scope name, and an operator that relates the scope name and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ScopedResourceSelectorRequirement(
  operator: str,
  scope_name: str,
  values: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.operator">operator</a></code> | <code>str</code> | Represents a scope's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.scopeName">scope_name</a></code> | <code>str</code> | The name of the scope that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.values">values</a></code> | <code>typing.List[str]</code> | An array of string values. |

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.operator"></a>

```python
operator: str
```

- *Type:* str

Represents a scope's relationship to a set of values.

Valid operators are In, NotIn, Exists, DoesNotExist.

---

##### `scope_name`<sup>Required</sup> <a name="scope_name" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.scopeName"></a>

```python
scope_name: str
```

- *Type:* str

The name of the scope that the selector applies to.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

An array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

---

### ScopeSelector <a name="ScopeSelector" id="cdk8s-plus-28.k8s.ScopeSelector"></a>

A scope selector represents the AND of the selectors represented by the scoped-resource selector requirements.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScopeSelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ScopeSelector(
  match_expressions: typing.List[ScopedResourceSelectorRequirement] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScopeSelector.property.matchExpressions">match_expressions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ScopedResourceSelectorRequirement]</code> | A list of scope selector requirements by scope of the resources. |

---

##### `match_expressions`<sup>Optional</sup> <a name="match_expressions" id="cdk8s-plus-28.k8s.ScopeSelector.property.matchExpressions"></a>

```python
match_expressions: typing.List[ScopedResourceSelectorRequirement]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ScopedResourceSelectorRequirement]

A list of scope selector requirements by scope of the resources.

---

### SeccompProfile <a name="SeccompProfile" id="cdk8s-plus-28.SeccompProfile"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SeccompProfile.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SeccompProfile(
  type: SeccompProfileType,
  localhost_profile: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SeccompProfile.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfileType">SeccompProfileType</a></code> | Indicates which kind of seccomp profile will be applied. |
| <code><a href="#cdk8s-plus-28.SeccompProfile.property.localhostProfile">localhost_profile</a></code> | <code>str</code> | localhostProfile indicates a profile defined in a file on the node should be used. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.SeccompProfile.property.type"></a>

```python
type: SeccompProfileType
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfileType">SeccompProfileType</a>

Indicates which kind of seccomp profile will be applied.

---

##### `localhost_profile`<sup>Optional</sup> <a name="localhost_profile" id="cdk8s-plus-28.SeccompProfile.property.localhostProfile"></a>

```python
localhost_profile: str
```

- *Type:* str
- *Default:* empty string

localhostProfile indicates a profile defined in a file on the node should be used.

The profile must be preconfigured on the node to work. Must be a descending path,
relative to the kubelet's configured seccomp profile location.
Must only be set if type is "Localhost".

---

### SeccompProfile <a name="SeccompProfile" id="cdk8s-plus-28.k8s.SeccompProfile"></a>

SeccompProfile defines a pod/container's seccomp profile settings.

Only one profile source may be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SeccompProfile.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SeccompProfile(
  type: str,
  localhost_profile: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SeccompProfile.property.type">type</a></code> | <code>str</code> | type indicates which kind of seccomp profile will be applied. Valid options are:. |
| <code><a href="#cdk8s-plus-28.k8s.SeccompProfile.property.localhostProfile">localhost_profile</a></code> | <code>str</code> | localhostProfile indicates a profile defined in a file on the node should be used. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.SeccompProfile.property.type"></a>

```python
type: str
```

- *Type:* str

type indicates which kind of seccomp profile will be applied. Valid options are:.

Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.

---

##### `localhost_profile`<sup>Optional</sup> <a name="localhost_profile" id="cdk8s-plus-28.k8s.SeccompProfile.property.localhostProfile"></a>

```python
localhost_profile: str
```

- *Type:* str

localhostProfile indicates a profile defined in a file on the node should be used.

The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must be set if type is "Localhost". Must NOT be set for any other type.

---

### SecretEnvSource <a name="SecretEnvSource" id="cdk8s-plus-28.k8s.SecretEnvSource"></a>

SecretEnvSource selects a Secret to populate the environment variables with.

The contents of the target Secret's Data field will represent the key-value pairs as environment variables.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretEnvSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecretEnvSource(
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretEnvSource.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretEnvSource.property.optional">optional</a></code> | <code>bool</code> | Specify whether the Secret must be defined. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretEnvSource.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretEnvSource.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

Specify whether the Secret must be defined.

---

### SecretKeySelector <a name="SecretKeySelector" id="cdk8s-plus-28.k8s.SecretKeySelector"></a>

SecretKeySelector selects a key of a Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretKeySelector.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecretKeySelector(
  key: str,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.key">key</a></code> | <code>str</code> | The key of the secret to select from. |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.optional">optional</a></code> | <code>bool</code> | Specify whether the Secret or its key must be defined. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.SecretKeySelector.property.key"></a>

```python
key: str
```

- *Type:* str

The key of the secret to select from.

Must be a valid secret key.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretKeySelector.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretKeySelector.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

Specify whether the Secret or its key must be defined.

---

### SecretProjection <a name="SecretProjection" id="cdk8s-plus-28.k8s.SecretProjection"></a>

Adapts a secret into a projected volume.

The contents of the target Secret's Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretProjection.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecretProjection(
  items: typing.List[KeyToPath] = None,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KeyToPath]</code> | items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.name">name</a></code> | <code>str</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.optional">optional</a></code> | <code>bool</code> | optional field specify whether the Secret or its key must be defined. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.SecretProjection.property.items"></a>

```python
items: typing.List[KeyToPath]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KeyToPath]

items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretProjection.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretProjection.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

optional field specify whether the Secret or its key must be defined.

---

### SecretProps <a name="SecretProps" id="cdk8s-plus-28.SecretProps"></a>

Options for `Secret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  string_data: typing.Mapping[str] = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.SecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.SecretProps.property.stringData">string_data</a></code> | <code>typing.Mapping[str]</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.SecretProps.property.type">type</a></code> | <code>str</code> | Optional type associated with the secret. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.SecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.SecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `string_data`<sup>Optional</sup> <a name="string_data" id="cdk8s-plus-28.SecretProps.property.stringData"></a>

```python
string_data: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

stringData allows specifying non-binary secret data in string form.

It is
provided as a write-only convenience method. All keys and values are merged
into the data field on write, overwriting any existing values. It is never
output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.SecretProps.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* undefined - Don't set a type.

Optional type associated with the secret.

Used to facilitate programmatic
handling of secret data by various controllers.

---

### SecretReference <a name="SecretReference" id="cdk8s-plus-28.k8s.SecretReference"></a>

SecretReference represents a Secret Reference.

It has enough information to retrieve secret in any namespace

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecretReference(
  name: str = None,
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretReference.property.name">name</a></code> | <code>str</code> | name is unique within a namespace to reference a secret resource. |
| <code><a href="#cdk8s-plus-28.k8s.SecretReference.property.namespace">namespace</a></code> | <code>str</code> | namespace defines the space within which the secret name must be unique. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretReference.property.name"></a>

```python
name: str
```

- *Type:* str

name is unique within a namespace to reference a secret resource.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.SecretReference.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

namespace defines the space within which the secret name must be unique.

---

### SecretValue <a name="SecretValue" id="cdk8s-plus-28.SecretValue"></a>

Represents a specific value in JSON secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretValue.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SecretValue(
  key: str,
  secret: ISecret
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretValue.property.key">key</a></code> | <code>str</code> | The JSON key. |
| <code><a href="#cdk8s-plus-28.SecretValue.property.secret">secret</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | The secret. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SecretValue.property.key"></a>

```python
key: str
```

- *Type:* str

The JSON key.

---

##### `secret`<sup>Required</sup> <a name="secret" id="cdk8s-plus-28.SecretValue.property.secret"></a>

```python
secret: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret.

---

### SecretVolumeOptions <a name="SecretVolumeOptions" id="cdk8s-plus-28.SecretVolumeOptions"></a>

Options for the Secret-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretVolumeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SecretVolumeOptions(
  default_mode: typing.Union[int, float] = None,
  items: typing.Mapping[PathMapping] = None,
  name: str = None,
  optional: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | Mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.items">items</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]</code> | If unspecified, each key-value pair in the Data field of the referenced secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.name">name</a></code> | <code>str</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.optional">optional</a></code> | <code>bool</code> | Specify whether the secret or its keys must be defined. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.SecretVolumeOptions.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.SecretVolumeOptions.property.items"></a>

```python
items: typing.Mapping[PathMapping]
```

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.PathMapping">PathMapping</a>]
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the secret, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.SecretVolumeOptions.property.name"></a>

```python
name: str
```

- *Type:* str
- *Default:* auto-generated

The volume name.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.SecretVolumeOptions.property.optional"></a>

```python
optional: bool
```

- *Type:* bool
- *Default:* undocumented

Specify whether the secret or its keys must be defined.

---

### SecretVolumeSource <a name="SecretVolumeSource" id="cdk8s-plus-28.k8s.SecretVolumeSource"></a>

Adapts a Secret into a volume.

The contents of the target Secret's Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecretVolumeSource(
  default_mode: typing.Union[int, float] = None,
  items: typing.List[KeyToPath] = None,
  optional: bool = None,
  secret_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.defaultMode">default_mode</a></code> | <code>typing.Union[int, float]</code> | defaultMode is Optional: mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.items">items</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KeyToPath]</code> | items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.optional">optional</a></code> | <code>bool</code> | optional field specify whether the Secret or its keys must be defined. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.secretName">secret_name</a></code> | <code>str</code> | secretName is the name of the secret in the pod's namespace to use. |

---

##### `default_mode`<sup>Optional</sup> <a name="default_mode" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.defaultMode"></a>

```python
default_mode: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

defaultMode is Optional: mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.items"></a>

```python
items: typing.List[KeyToPath]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KeyToPath]

items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.optional"></a>

```python
optional: bool
```

- *Type:* bool

optional field specify whether the Secret or its keys must be defined.

---

##### `secret_name`<sup>Optional</sup> <a name="secret_name" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.secretName"></a>

```python
secret_name: str
```

- *Type:* str

secretName is the name of the secret in the pod's namespace to use.

More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

---

### SecurityContext <a name="SecurityContext" id="cdk8s-plus-28.k8s.SecurityContext"></a>

SecurityContext holds security configuration that will be applied to a container.

Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecurityContext.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SecurityContext(
  allow_privilege_escalation: bool = None,
  capabilities: Capabilities = None,
  privileged: bool = None,
  proc_mount: str = None,
  read_only_root_filesystem: bool = None,
  run_as_group: typing.Union[int, float] = None,
  run_as_non_root: bool = None,
  run_as_user: typing.Union[int, float] = None,
  seccomp_profile: SeccompProfile = None,
  se_linux_options: SeLinuxOptions = None,
  windows_options: WindowsSecurityContextOptions = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.allowPrivilegeEscalation">allow_privilege_escalation</a></code> | <code>bool</code> | AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.capabilities">capabilities</a></code> | <code>cdk8s_plus_28.k8s.Capabilities</code> | The capabilities to add/drop when running containers. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.privileged">privileged</a></code> | <code>bool</code> | Run container in privileged mode. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.procMount">proc_mount</a></code> | <code>str</code> | procMount denotes the type of proc mount to use for the containers. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.readOnlyRootFilesystem">read_only_root_filesystem</a></code> | <code>bool</code> | Whether this container has a read-only root filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsGroup">run_as_group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsNonRoot">run_as_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsUser">run_as_user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.seccompProfile">seccomp_profile</a></code> | <code>cdk8s_plus_28.k8s.SeccompProfile</code> | The seccomp options to use by this container. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.seLinuxOptions">se_linux_options</a></code> | <code>cdk8s_plus_28.k8s.SeLinuxOptions</code> | The SELinux context to be applied to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.windowsOptions">windows_options</a></code> | <code>cdk8s_plus_28.k8s.WindowsSecurityContextOptions</code> | The Windows specific settings applied to all containers. |

---

##### `allow_privilege_escalation`<sup>Optional</sup> <a name="allow_privilege_escalation" id="cdk8s-plus-28.k8s.SecurityContext.property.allowPrivilegeEscalation"></a>

```python
allow_privilege_escalation: bool
```

- *Type:* bool

AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process.

This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.k8s.SecurityContext.property.capabilities"></a>

```python
capabilities: Capabilities
```

- *Type:* cdk8s_plus_28.k8s.Capabilities
- *Default:* the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.

The capabilities to add/drop when running containers.

Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.

---

##### `privileged`<sup>Optional</sup> <a name="privileged" id="cdk8s-plus-28.k8s.SecurityContext.property.privileged"></a>

```python
privileged: bool
```

- *Type:* bool
- *Default:* false. Note that this field cannot be set when spec.os.name is windows.

Run container in privileged mode.

Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.

---

##### `proc_mount`<sup>Optional</sup> <a name="proc_mount" id="cdk8s-plus-28.k8s.SecurityContext.property.procMount"></a>

```python
proc_mount: str
```

- *Type:* str

procMount denotes the type of proc mount to use for the containers.

The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.

---

##### `read_only_root_filesystem`<sup>Optional</sup> <a name="read_only_root_filesystem" id="cdk8s-plus-28.k8s.SecurityContext.property.readOnlyRootFilesystem"></a>

```python
read_only_root_filesystem: bool
```

- *Type:* bool
- *Default:* false. Note that this field cannot be set when spec.os.name is windows.

Whether this container has a read-only root filesystem.

Default is false. Note that this field cannot be set when spec.os.name is windows.

---

##### `run_as_group`<sup>Optional</sup> <a name="run_as_group" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsGroup"></a>

```python
run_as_group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The GID to run the entrypoint of the container process.

Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `run_as_non_root`<sup>Optional</sup> <a name="run_as_non_root" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsNonRoot"></a>

```python
run_as_non_root: bool
```

- *Type:* bool

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

##### `run_as_user`<sup>Optional</sup> <a name="run_as_user" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsUser"></a>

```python
run_as_user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

The UID to run the entrypoint of the container process.

Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `seccomp_profile`<sup>Optional</sup> <a name="seccomp_profile" id="cdk8s-plus-28.k8s.SecurityContext.property.seccompProfile"></a>

```python
seccomp_profile: SeccompProfile
```

- *Type:* cdk8s_plus_28.k8s.SeccompProfile

The seccomp options to use by this container.

If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.

---

##### `se_linux_options`<sup>Optional</sup> <a name="se_linux_options" id="cdk8s-plus-28.k8s.SecurityContext.property.seLinuxOptions"></a>

```python
se_linux_options: SeLinuxOptions
```

- *Type:* cdk8s_plus_28.k8s.SeLinuxOptions

The SELinux context to be applied to the container.

If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `windows_options`<sup>Optional</sup> <a name="windows_options" id="cdk8s-plus-28.k8s.SecurityContext.property.windowsOptions"></a>

```python
windows_options: WindowsSecurityContextOptions
```

- *Type:* cdk8s_plus_28.k8s.WindowsSecurityContextOptions

The Windows specific settings applied to all containers.

If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

---

### SelfSubjectAccessReviewSpec <a name="SelfSubjectAccessReviewSpec" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec"></a>

SelfSubjectAccessReviewSpec is a description of the access request.

Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SelfSubjectAccessReviewSpec(
  non_resource_attributes: NonResourceAttributes = None,
  resource_attributes: ResourceAttributes = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.nonResourceAttributes">non_resource_attributes</a></code> | <code>cdk8s_plus_28.k8s.NonResourceAttributes</code> | NonResourceAttributes describes information for a non-resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.resourceAttributes">resource_attributes</a></code> | <code>cdk8s_plus_28.k8s.ResourceAttributes</code> | ResourceAuthorizationAttributes describes information for a resource access request. |

---

##### `non_resource_attributes`<sup>Optional</sup> <a name="non_resource_attributes" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.nonResourceAttributes"></a>

```python
non_resource_attributes: NonResourceAttributes
```

- *Type:* cdk8s_plus_28.k8s.NonResourceAttributes

NonResourceAttributes describes information for a non-resource access request.

---

##### `resource_attributes`<sup>Optional</sup> <a name="resource_attributes" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.resourceAttributes"></a>

```python
resource_attributes: ResourceAttributes
```

- *Type:* cdk8s_plus_28.k8s.ResourceAttributes

ResourceAuthorizationAttributes describes information for a resource access request.

---

### SelfSubjectRulesReviewSpec <a name="SelfSubjectRulesReviewSpec" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec"></a>

SelfSubjectRulesReviewSpec defines the specification for SelfSubjectRulesReview.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SelfSubjectRulesReviewSpec(
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.property.namespace">namespace</a></code> | <code>str</code> | Namespace to evaluate rules for. |

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace to evaluate rules for.

Required.

---

### SeLinuxOptions <a name="SeLinuxOptions" id="cdk8s-plus-28.k8s.SeLinuxOptions"></a>

SELinuxOptions are the labels to be applied to the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SeLinuxOptions.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SeLinuxOptions(
  level: str = None,
  role: str = None,
  type: str = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.level">level</a></code> | <code>str</code> | Level is SELinux level label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.role">role</a></code> | <code>str</code> | Role is a SELinux role label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.type">type</a></code> | <code>str</code> | Type is a SELinux type label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.user">user</a></code> | <code>str</code> | User is a SELinux user label that applies to the container. |

---

##### `level`<sup>Optional</sup> <a name="level" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.level"></a>

```python
level: str
```

- *Type:* str

Level is SELinux level label that applies to the container.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.role"></a>

```python
role: str
```

- *Type:* str

Role is a SELinux role label that applies to the container.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.type"></a>

```python
type: str
```

- *Type:* str

Type is a SELinux type label that applies to the container.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.user"></a>

```python
user: str
```

- *Type:* str

User is a SELinux user label that applies to the container.

---

### ServiceAccountProps <a name="ServiceAccountProps" id="cdk8s-plus-28.ServiceAccountProps"></a>

Properties for initialization of `ServiceAccount`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceAccountProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccountProps(
  metadata: ApiObjectMetadata = None,
  automount_token: bool = None,
  secrets: typing.List[ISecret] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.automountToken">automount_token</a></code> | <code>bool</code> | Indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.secrets">secrets</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]</code> | List of secrets allowed to be used by pods running using this ServiceAccount. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_token`<sup>Optional</sup> <a name="automount_token" id="cdk8s-plus-28.ServiceAccountProps.property.automountToken"></a>

```python
automount_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.ServiceAccountProps.property.secrets"></a>

```python
secrets: typing.List[ISecret]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ISecret">ISecret</a>]

List of secrets allowed to be used by pods running using this ServiceAccount.

> [https://kubernetes.io/docs/concepts/configuration/secret](https://kubernetes.io/docs/concepts/configuration/secret)

---

### ServiceAccountSubjectV1Beta2 <a name="ServiceAccountSubjectV1Beta2" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2"></a>

ServiceAccountSubject holds detailed information for service-account-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceAccountSubjectV1Beta2(
  name: str,
  namespace: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.name">name</a></code> | <code>str</code> | `name` is the name of matching ServiceAccount objects, or "*" to match regardless of name. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.namespace">namespace</a></code> | <code>str</code> | `namespace` is the namespace of matching ServiceAccount objects. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of matching ServiceAccount objects, or "*" to match regardless of name.

Required.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

`namespace` is the namespace of matching ServiceAccount objects.

Required.

---

### ServiceAccountSubjectV1Beta3 <a name="ServiceAccountSubjectV1Beta3" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3"></a>

ServiceAccountSubject holds detailed information for service-account-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceAccountSubjectV1Beta3(
  name: str,
  namespace: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.name">name</a></code> | <code>str</code> | `name` is the name of matching ServiceAccount objects, or "*" to match regardless of name. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.namespace">namespace</a></code> | <code>str</code> | `namespace` is the namespace of matching ServiceAccount objects. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of matching ServiceAccount objects, or "*" to match regardless of name.

Required.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

`namespace` is the namespace of matching ServiceAccount objects.

Required.

---

### ServiceAccountTokenProjection <a name="ServiceAccountTokenProjection" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection"></a>

ServiceAccountTokenProjection represents a projected service account token volume.

This projection can be used to insert a service account token into the pods runtime filesystem for use against APIs (Kubernetes API Server or otherwise).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceAccountTokenProjection(
  path: str,
  audience: str = None,
  expiration_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.path">path</a></code> | <code>str</code> | path is the path relative to the mount point of the file to project the token into. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.audience">audience</a></code> | <code>str</code> | audience is the intended audience of the token. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.expirationSeconds">expiration_seconds</a></code> | <code>typing.Union[int, float]</code> | expirationSeconds is the requested duration of validity of the service account token. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.path"></a>

```python
path: str
```

- *Type:* str

path is the path relative to the mount point of the file to project the token into.

---

##### `audience`<sup>Optional</sup> <a name="audience" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.audience"></a>

```python
audience: str
```

- *Type:* str

audience is the intended audience of the token.

A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.

---

##### `expiration_seconds`<sup>Optional</sup> <a name="expiration_seconds" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.expirationSeconds"></a>

```python
expiration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 hour and must be at least 10 minutes.

expirationSeconds is the requested duration of validity of the service account token.

As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.

---

### ServiceAccountTokenSecretProps <a name="ServiceAccountTokenSecretProps" id="cdk8s-plus-28.ServiceAccountTokenSecretProps"></a>

Options for `ServiceAccountTokenSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceAccountTokenSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  service_account: IServiceAccount
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | The service account to store a secret for. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `service_account`<sup>Required</sup> <a name="service_account" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

The service account to store a secret for.

---

### ServiceBackendPort <a name="ServiceBackendPort" id="cdk8s-plus-28.k8s.ServiceBackendPort"></a>

ServiceBackendPort is the service port being referenced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceBackendPort.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceBackendPort(
  name: str = None,
  number: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceBackendPort.property.name">name</a></code> | <code>str</code> | name is the name of the port on the Service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceBackendPort.property.number">number</a></code> | <code>typing.Union[int, float]</code> | number is the numerical port number (e.g. 80) on the Service. This is a mutually exclusive setting with "Name". |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceBackendPort.property.name"></a>

```python
name: str
```

- *Type:* str

name is the name of the port on the Service.

This is a mutually exclusive setting with "Number".

---

##### `number`<sup>Optional</sup> <a name="number" id="cdk8s-plus-28.k8s.ServiceBackendPort.property.number"></a>

```python
number: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

number is the numerical port number (e.g. 80) on the Service. This is a mutually exclusive setting with "Name".

---

### ServiceBindOptions <a name="ServiceBindOptions" id="cdk8s-plus-28.ServiceBindOptions"></a>

Options for `Service.bind`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceBindOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceBindOptions(
  name: str = None,
  node_port: typing.Union[int, float] = None,
  protocol: Protocol = None,
  target_port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.name">name</a></code> | <code>str</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.nodePort">node_port</a></code> | <code>typing.Union[int, float]</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.targetPort">target_port</a></code> | <code>typing.Union[int, float]</code> | The port number the service will redirect to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ServiceBindOptions.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `node_port`<sup>Optional</sup> <a name="node_port" id="cdk8s-plus-28.ServiceBindOptions.property.nodePort"></a>

```python
node_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ServiceBindOptions.property.protocol"></a>

```python
protocol: Protocol
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `target_port`<sup>Optional</sup> <a name="target_port" id="cdk8s-plus-28.ServiceBindOptions.property.targetPort"></a>

```python
target_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

### ServiceIngressBackendOptions <a name="ServiceIngressBackendOptions" id="cdk8s-plus-28.ServiceIngressBackendOptions"></a>

Options for setting up backends for ingress rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceIngressBackendOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceIngressBackendOptions(
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceIngressBackendOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The port to use to access the service. |

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ServiceIngressBackendOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* if the service exposes a single port, this port will be used.

The port to use to access the service.

* This option will fail if the service does not expose any ports.
* If the service exposes multiple ports, this option must be specified.
* If the service exposes a single port, this option is optional and if
  specified, it must be the same port exposed by the service.

---

### ServicePort <a name="ServicePort" id="cdk8s-plus-28.ServicePort"></a>

Definition of a service port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServicePort.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServicePort(
  name: str = None,
  node_port: typing.Union[int, float] = None,
  protocol: Protocol = None,
  target_port: typing.Union[int, float] = None,
  port: typing.Union[int, float]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServicePort.property.name">name</a></code> | <code>str</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.nodePort">node_port</a></code> | <code>typing.Union[int, float]</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.targetPort">target_port</a></code> | <code>typing.Union[int, float]</code> | The port number the service will redirect to. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The port number the service will bind to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ServicePort.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `node_port`<sup>Optional</sup> <a name="node_port" id="cdk8s-plus-28.ServicePort.property.nodePort"></a>

```python
node_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ServicePort.property.protocol"></a>

```python
protocol: Protocol
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `target_port`<sup>Optional</sup> <a name="target_port" id="cdk8s-plus-28.ServicePort.property.targetPort"></a>

```python
target_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.ServicePort.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The port number the service will bind to.

---

### ServicePort <a name="ServicePort" id="cdk8s-plus-28.k8s.ServicePort"></a>

ServicePort contains information on service's port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServicePort.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServicePort(
  port: typing.Union[int, float],
  app_protocol: str = None,
  name: str = None,
  node_port: typing.Union[int, float] = None,
  protocol: str = None,
  target_port: IntOrString = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The port that will be exposed by this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.appProtocol">app_protocol</a></code> | <code>str</code> | The application protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.name">name</a></code> | <code>str</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.nodePort">node_port</a></code> | <code>typing.Union[int, float]</code> | The port on each node on which this service is exposed when type is NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.protocol">protocol</a></code> | <code>str</code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.targetPort">target_port</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | Number or name of the port to access on the pods targeted by the service. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.ServicePort.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The port that will be exposed by this service.

---

##### `app_protocol`<sup>Optional</sup> <a name="app_protocol" id="cdk8s-plus-28.k8s.ServicePort.property.appProtocol"></a>

```python
app_protocol: str
```

- *Type:* str

The application protocol for this port.

This is used as a hint for implementations to offer richer behavior for protocols that they understand. This field follows standard Kubernetes label syntax. Valid values are either:

* Un-prefixed protocol names - reserved for IANA standard service names (as per RFC-6335 and https://www.iana.org/assignments/service-names).
* Kubernetes-defined prefixed names:
* 'kubernetes.io/h2c' - HTTP/2 over cleartext as described in https://www.rfc-editor.org/rfc/rfc7540
* 'kubernetes.io/ws'  - WebSocket over cleartext as described in https://www.rfc-editor.org/rfc/rfc6455
* 'kubernetes.io/wss' - WebSocket over TLS as described in https://www.rfc-editor.org/rfc/rfc6455
* Other protocols should use implementation-defined prefixed names such as mycompany.com/my-custom-protocol.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ServicePort.property.name"></a>

```python
name: str
```

- *Type:* str

The name of this port within the service.

This must be a DNS_LABEL. All ports within a ServiceSpec must have unique names. When considering the endpoints for a Service, this must match the 'name' field in the EndpointPort. Optional if only one ServicePort is defined on this service.

---

##### `node_port`<sup>Optional</sup> <a name="node_port" id="cdk8s-plus-28.k8s.ServicePort.property.nodePort"></a>

```python
node_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The port on each node on which this service is exposed when type is NodePort or LoadBalancer.

Usually assigned by the system. If a value is specified, in-range, and not in use it will be used, otherwise the operation will fail.  If not specified, a port will be allocated if this Service requires one.  If this field is specified when creating a Service which does not need it, creation will fail. This field will be wiped when updating a Service to no longer need it (e.g. changing type from NodePort to ClusterIP). More info: https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.ServicePort.property.protocol"></a>

```python
protocol: str
```

- *Type:* str
- *Default:* TCP.

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `target_port`<sup>Optional</sup> <a name="target_port" id="cdk8s-plus-28.k8s.ServicePort.property.targetPort"></a>

```python
target_port: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

Number or name of the port to access on the pods targeted by the service.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. If this is a string, it will be looked up as a named port in the target Pod's container ports. If this is not specified, the value of the 'port' field is used (an identity map). This field is ignored for services with clusterIP=None, and should be omitted or set equal to the 'port' field. More info: https://kubernetes.io/docs/concepts/services-networking/service/#defining-a-service

---

### ServiceProps <a name="ServiceProps" id="cdk8s-plus-28.ServiceProps"></a>

Properties for `Service`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ServiceProps(
  metadata: ApiObjectMetadata = None,
  cluster_i_p: str = None,
  external_i_ps: typing.List[str] = None,
  external_name: str = None,
  load_balancer_source_ranges: typing.List[str] = None,
  ports: typing.List[ServicePort] = None,
  publish_not_ready_addresses: bool = None,
  selector: IPodSelector = None,
  type: ServiceType = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.clusterIP">cluster_i_p</a></code> | <code>str</code> | The IP address of the service and is usually assigned randomly by the master. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.externalIPs">external_i_ps</a></code> | <code>typing.List[str]</code> | A list of IP addresses for which nodes in the cluster will also accept traffic for this service. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.externalName">external_name</a></code> | <code>str</code> | The externalName to be used when ServiceType.EXTERNAL_NAME is set. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.loadBalancerSourceRanges">load_balancer_source_ranges</a></code> | <code>typing.List[str]</code> | A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]</code> | The ports this service binds to. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.publishNotReadyAddresses">publish_not_ready_addresses</a></code> | <code>bool</code> | The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods should the service select and route to. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | Determines how the Service is exposed. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `cluster_i_p`<sup>Optional</sup> <a name="cluster_i_p" id="cdk8s-plus-28.ServiceProps.property.clusterIP"></a>

```python
cluster_i_p: str
```

- *Type:* str
- *Default:* Automatically assigned.

The IP address of the service and is usually assigned randomly by the master.

If an address is specified manually and is not in use by others, it
will be allocated to the service; otherwise, creation of the service will
fail. This field can not be changed through updates. Valid values are
"None", empty string (""), or a valid IP address. "None" can be specified
for headless services when proxying is not required. Only applies to types
ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName.

> [https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies](https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies)

---

##### `external_i_ps`<sup>Optional</sup> <a name="external_i_ps" id="cdk8s-plus-28.ServiceProps.property.externalIPs"></a>

```python
external_i_ps: typing.List[str]
```

- *Type:* typing.List[str]
- *Default:* No external IPs.

A list of IP addresses for which nodes in the cluster will also accept traffic for this service.

These IPs are not managed by Kubernetes. The user
is responsible for ensuring that traffic arrives at a node with this IP. A
common example is external load-balancers that are not part of the
Kubernetes system.

---

##### `external_name`<sup>Optional</sup> <a name="external_name" id="cdk8s-plus-28.ServiceProps.property.externalName"></a>

```python
external_name: str
```

- *Type:* str
- *Default:* No external name.

The externalName to be used when ServiceType.EXTERNAL_NAME is set.

---

##### `load_balancer_source_ranges`<sup>Optional</sup> <a name="load_balancer_source_ranges" id="cdk8s-plus-28.ServiceProps.property.loadBalancerSourceRanges"></a>

```python
load_balancer_source_ranges: typing.List[str]
```

- *Type:* typing.List[str]

A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs.

More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ServiceProps.property.ports"></a>

```python
ports: typing.List[ServicePort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ServicePort">ServicePort</a>]
- *Default:* either the selector ports, or none.

The ports this service binds to.

If the selector of the service is a managed pod / workload,
its ports will are automatically extracted and used as the default value.
Otherwise, no ports are bound.

---

##### `publish_not_ready_addresses`<sup>Optional</sup> <a name="publish_not_ready_addresses" id="cdk8s-plus-28.ServiceProps.property.publishNotReadyAddresses"></a>

```python
publish_not_ready_addresses: bool
```

- *Type:* bool
- *Default:* false

The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready.

More info: https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.30/#servicespec-v1-core

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.ServiceProps.property.selector"></a>

```python
selector: IPodSelector
```

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* unset, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify.

Which pods should the service select and route to.

You can pass one of the following:

* An instance of `Pod` or any workload resource (e.g `Deployment`, `StatefulSet`, ...)
* Pods selected by the `Pods.select` function. Note that in this case only labels can be specified.

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
# select the pods of a specific deployment
backend = kplus.Deployment(self, "Backend", ...)
kplus.Service(self, "Service", selector=backend)

# select all pods labeled with the `tier=backend` label
backend = kplus.Pod.labeled(tier="backend")
kplus.Service(self, "Service", selector=backend)
```


##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.ServiceProps.property.type"></a>

```python
type: ServiceType
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ServiceType.ClusterIP

Determines how the Service is exposed.

More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

---

### ServiceReference <a name="ServiceReference" id="cdk8s-plus-28.k8s.ServiceReference"></a>

ServiceReference holds a reference to Service.legacy.k8s.io.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceReference(
  name: str,
  namespace: str,
  path: str = None,
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.name">name</a></code> | <code>str</code> | `name` is the name of the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.namespace">namespace</a></code> | <code>str</code> | `namespace` is the namespace of the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.path">path</a></code> | <code>str</code> | `path` is an optional URL path which will be sent in any request to this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.port">port</a></code> | <code>typing.Union[int, float]</code> | If specified, the port on the service that hosting webhook. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceReference.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the name of the service.

Required

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceReference.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

`namespace` is the namespace of the service.

Required

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.ServiceReference.property.path"></a>

```python
path: str
```

- *Type:* str

`path` is an optional URL path which will be sent in any request to this service.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.ServiceReference.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 443 for backward compatibility. `port` should be a valid port number (1-65535, inclusive).

If specified, the port on the service that hosting webhook.

Default to 443 for backward compatibility. `port` should be a valid port number (1-65535, inclusive).

---

### ServiceSpec <a name="ServiceSpec" id="cdk8s-plus-28.k8s.ServiceSpec"></a>

ServiceSpec describes the attributes that a user creates on a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ServiceSpec(
  allocate_load_balancer_node_ports: bool = None,
  cluster_ip: str = None,
  cluster_i_ps: typing.List[str] = None,
  external_i_ps: typing.List[str] = None,
  external_name: str = None,
  external_traffic_policy: str = None,
  health_check_node_port: typing.Union[int, float] = None,
  internal_traffic_policy: str = None,
  ip_families: typing.List[str] = None,
  ip_family_policy: str = None,
  load_balancer_class: str = None,
  load_balancer_ip: str = None,
  load_balancer_source_ranges: typing.List[str] = None,
  ports: typing.List[ServicePort] = None,
  publish_not_ready_addresses: bool = None,
  selector: typing.Mapping[str] = None,
  session_affinity: str = None,
  session_affinity_config: SessionAffinityConfig = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.allocateLoadBalancerNodePorts">allocate_load_balancer_node_ports</a></code> | <code>bool</code> | allocateLoadBalancerNodePorts defines if NodePorts will be automatically allocated for services with type LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.clusterIp">cluster_ip</a></code> | <code>str</code> | clusterIP is the IP address of the service and is usually assigned randomly. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.clusterIPs">cluster_i_ps</a></code> | <code>typing.List[str]</code> | ClusterIPs is a list of IP addresses assigned to this service, and are usually assigned randomly. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalIPs">external_i_ps</a></code> | <code>typing.List[str]</code> | externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalName">external_name</a></code> | <code>str</code> | externalName is the external reference that discovery mechanisms will return as an alias for this service (e.g. a DNS CNAME record). No proxying will be involved.  Must be a lowercase RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires `type` to be "ExternalName". |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalTrafficPolicy">external_traffic_policy</a></code> | <code>str</code> | externalTrafficPolicy describes how nodes distribute service traffic they receive on one of the Service's "externally-facing" addresses (NodePorts, ExternalIPs, and LoadBalancer IPs). |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.healthCheckNodePort">health_check_node_port</a></code> | <code>typing.Union[int, float]</code> | healthCheckNodePort specifies the healthcheck nodePort for the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.internalTrafficPolicy">internal_traffic_policy</a></code> | <code>str</code> | InternalTrafficPolicy describes how nodes distribute service traffic they receive on the ClusterIP. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilies">ip_families</a></code> | <code>typing.List[str]</code> | IPFamilies is a list of IP families (e.g. IPv4, IPv6) assigned to this service. This field is usually assigned automatically based on cluster configuration and the ipFamilyPolicy field. If this field is specified manually, the requested family is available in the cluster, and ipFamilyPolicy allows it, it will be used; otherwise creation of the service will fail. This field is conditionally mutable: it allows for adding or removing a secondary IP family, but it does not allow changing the primary IP family of the Service. Valid values are "IPv4" and "IPv6".  This field only applies to Services of types ClusterIP, NodePort, and LoadBalancer, and does apply to "headless" services. This field will be wiped when updating a Service to type ExternalName. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilyPolicy">ip_family_policy</a></code> | <code>str</code> | IPFamilyPolicy represents the dual-stack-ness requested or required by this Service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerClass">load_balancer_class</a></code> | <code>str</code> | loadBalancerClass is the class of the load balancer implementation this Service belongs to. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerIp">load_balancer_ip</a></code> | <code>str</code> | Only applies to Service Type: LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerSourceRanges">load_balancer_source_ranges</a></code> | <code>typing.List[str]</code> | If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ports">ports</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ServicePort]</code> | The list of ports that are exposed by this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.publishNotReadyAddresses">publish_not_ready_addresses</a></code> | <code>bool</code> | publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.selector">selector</a></code> | <code>typing.Mapping[str]</code> | Route service traffic to pods with label keys and values matching this selector. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinity">session_affinity</a></code> | <code>str</code> | Supports "ClientIP" and "None". |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinityConfig">session_affinity_config</a></code> | <code>cdk8s_plus_28.k8s.SessionAffinityConfig</code> | sessionAffinityConfig contains the configurations of session affinity. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.type">type</a></code> | <code>str</code> | type determines how the Service is exposed. |

---

##### `allocate_load_balancer_node_ports`<sup>Optional</sup> <a name="allocate_load_balancer_node_ports" id="cdk8s-plus-28.k8s.ServiceSpec.property.allocateLoadBalancerNodePorts"></a>

```python
allocate_load_balancer_node_ports: bool
```

- *Type:* bool
- *Default:* true". It may be set to "false" if the cluster load-balancer does not rely on NodePorts.  If the caller requests specific NodePorts (by specifying a value), those requests will be respected, regardless of this field. This field may only be set for services with type LoadBalancer and will be cleared if the type is changed to any other type.

allocateLoadBalancerNodePorts defines if NodePorts will be automatically allocated for services with type LoadBalancer.

Default is "true". It may be set to "false" if the cluster load-balancer does not rely on NodePorts.  If the caller requests specific NodePorts (by specifying a value), those requests will be respected, regardless of this field. This field may only be set for services with type LoadBalancer and will be cleared if the type is changed to any other type.

---

##### `cluster_ip`<sup>Optional</sup> <a name="cluster_ip" id="cdk8s-plus-28.k8s.ServiceSpec.property.clusterIp"></a>

```python
cluster_ip: str
```

- *Type:* str

clusterIP is the IP address of the service and is usually assigned randomly.

If an address is specified manually, is in-range (as per system configuration), and is not in use, it will be allocated to the service; otherwise creation of the service will fail. This field may not be changed through updates unless the type field is also being changed to ExternalName (which requires this field to be blank) or the type field is being changed from ExternalName (in which case this field may optionally be specified, as describe above).  Valid values are "None", empty string (""), or a valid IP address. Setting this to "None" makes a "headless service" (no virtual IP), which is useful when direct endpoint connections are preferred and proxying is not required.  Only applies to types ClusterIP, NodePort, and LoadBalancer. If this field is specified when creating a Service of type ExternalName, creation will fail. This field will be wiped when updating a Service to type ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `cluster_i_ps`<sup>Optional</sup> <a name="cluster_i_ps" id="cdk8s-plus-28.k8s.ServiceSpec.property.clusterIPs"></a>

```python
cluster_i_ps: typing.List[str]
```

- *Type:* typing.List[str]

ClusterIPs is a list of IP addresses assigned to this service, and are usually assigned randomly.

If an address is specified manually, is in-range (as per system configuration), and is not in use, it will be allocated to the service; otherwise creation of the service will fail. This field may not be changed through updates unless the type field is also being changed to ExternalName (which requires this field to be empty) or the type field is being changed from ExternalName (in which case this field may optionally be specified, as describe above).  Valid values are "None", empty string (""), or a valid IP address.  Setting this to "None" makes a "headless service" (no virtual IP), which is useful when direct endpoint connections are preferred and proxying is not required.  Only applies to types ClusterIP, NodePort, and LoadBalancer. If this field is specified when creating a Service of type ExternalName, creation will fail. This field will be wiped when updating a Service to type ExternalName.  If this field is not specified, it will be initialized from the clusterIP field.  If this field is specified, clients must ensure that clusterIPs[0] and clusterIP have the same value.

This field may hold a maximum of two entries (dual-stack IPs, in either order). These IPs must correspond to the values of the ipFamilies field. Both clusterIPs and ipFamilies are governed by the ipFamilyPolicy field. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `external_i_ps`<sup>Optional</sup> <a name="external_i_ps" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalIPs"></a>

```python
external_i_ps: typing.List[str]
```

- *Type:* typing.List[str]

externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.

These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.

---

##### `external_name`<sup>Optional</sup> <a name="external_name" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalName"></a>

```python
external_name: str
```

- *Type:* str

externalName is the external reference that discovery mechanisms will return as an alias for this service (e.g. a DNS CNAME record). No proxying will be involved.  Must be a lowercase RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires `type` to be "ExternalName".

---

##### `external_traffic_policy`<sup>Optional</sup> <a name="external_traffic_policy" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalTrafficPolicy"></a>

```python
external_traffic_policy: str
```

- *Type:* str

externalTrafficPolicy describes how nodes distribute service traffic they receive on one of the Service's "externally-facing" addresses (NodePorts, ExternalIPs, and LoadBalancer IPs).

If set to "Local", the proxy will configure the service in a way that assumes that external load balancers will take care of balancing the service traffic between nodes, and so each node will deliver traffic only to the node-local endpoints of the service, without masquerading the client source IP. (Traffic mistakenly sent to a node with no endpoints will be dropped.) The default value, "Cluster", uses the standard behavior of routing to all endpoints evenly (possibly modified by topology and other features). Note that traffic sent to an External IP or LoadBalancer IP from within the cluster will always get "Cluster" semantics, but clients sending to a NodePort from within the cluster may need to take traffic policy into account when picking a node.

---

##### `health_check_node_port`<sup>Optional</sup> <a name="health_check_node_port" id="cdk8s-plus-28.k8s.ServiceSpec.property.healthCheckNodePort"></a>

```python
health_check_node_port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

healthCheckNodePort specifies the healthcheck nodePort for the service.

This only applies when type is set to LoadBalancer and externalTrafficPolicy is set to Local. If a value is specified, is in-range, and is not in use, it will be used.  If not specified, a value will be automatically allocated.  External systems (e.g. load-balancers) can use this port to determine if a given node holds endpoints for this service or not.  If this field is specified when creating a Service which does not need it, creation will fail. This field will be wiped when updating a Service to no longer need it (e.g. changing type). This field cannot be updated once set.

---

##### `internal_traffic_policy`<sup>Optional</sup> <a name="internal_traffic_policy" id="cdk8s-plus-28.k8s.ServiceSpec.property.internalTrafficPolicy"></a>

```python
internal_traffic_policy: str
```

- *Type:* str

InternalTrafficPolicy describes how nodes distribute service traffic they receive on the ClusterIP.

If set to "Local", the proxy will assume that pods only want to talk to endpoints of the service on the same node as the pod, dropping the traffic if there are no local endpoints. The default value, "Cluster", uses the standard behavior of routing to all endpoints evenly (possibly modified by topology and other features).

---

##### `ip_families`<sup>Optional</sup> <a name="ip_families" id="cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilies"></a>

```python
ip_families: typing.List[str]
```

- *Type:* typing.List[str]

IPFamilies is a list of IP families (e.g. IPv4, IPv6) assigned to this service. This field is usually assigned automatically based on cluster configuration and the ipFamilyPolicy field. If this field is specified manually, the requested family is available in the cluster, and ipFamilyPolicy allows it, it will be used; otherwise creation of the service will fail. This field is conditionally mutable: it allows for adding or removing a secondary IP family, but it does not allow changing the primary IP family of the Service. Valid values are "IPv4" and "IPv6".  This field only applies to Services of types ClusterIP, NodePort, and LoadBalancer, and does apply to "headless" services. This field will be wiped when updating a Service to type ExternalName.

This field may hold a maximum of two entries (dual-stack families, in either order).  These families must correspond to the values of the clusterIPs field, if specified. Both clusterIPs and ipFamilies are governed by the ipFamilyPolicy field.

---

##### `ip_family_policy`<sup>Optional</sup> <a name="ip_family_policy" id="cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilyPolicy"></a>

```python
ip_family_policy: str
```

- *Type:* str

IPFamilyPolicy represents the dual-stack-ness requested or required by this Service.

If there is no value provided, then this field will be set to SingleStack. Services can be "SingleStack" (a single IP family), "PreferDualStack" (two IP families on dual-stack configured clusters or a single IP family on single-stack clusters), or "RequireDualStack" (two IP families on dual-stack configured clusters, otherwise fail). The ipFamilies and clusterIPs fields depend on the value of this field. This field will be wiped when updating a service to type ExternalName.

---

##### `load_balancer_class`<sup>Optional</sup> <a name="load_balancer_class" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerClass"></a>

```python
load_balancer_class: str
```

- *Type:* str

loadBalancerClass is the class of the load balancer implementation this Service belongs to.

If specified, the value of this field must be a label-style identifier, with an optional prefix, e.g. "internal-vip" or "example.com/internal-vip". Unprefixed names are reserved for end-users. This field can only be set when the Service type is 'LoadBalancer'. If not set, the default load balancer implementation is used, today this is typically done through the cloud provider integration, but should apply for any default implementation. If set, it is assumed that a load balancer implementation is watching for Services with a matching class. Any default load balancer implementation (e.g. cloud providers) should ignore Services that set this field. This field can only be set when creating or updating a Service to type 'LoadBalancer'. Once set, it can not be changed. This field will be wiped when a service is updated to a non 'LoadBalancer' type.

---

##### `load_balancer_ip`<sup>Optional</sup> <a name="load_balancer_ip" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerIp"></a>

```python
load_balancer_ip: str
```

- *Type:* str

Only applies to Service Type: LoadBalancer.

This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature. Deprecated: This field was under-specified and its meaning varies across implementations. Using it is non-portable and it may not support dual-stack. Users are encouraged to use implementation-specific annotations when available.

---

##### `load_balancer_source_ranges`<sup>Optional</sup> <a name="load_balancer_source_ranges" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerSourceRanges"></a>

```python
load_balancer_source_ranges: typing.List[str]
```

- *Type:* typing.List[str]

If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs.

This field will be ignored if the cloud-provider does not support the feature." More info: https://kubernetes.io/docs/tasks/access-application-cluster/create-external-load-balancer/

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.ServiceSpec.property.ports"></a>

```python
ports: typing.List[ServicePort]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ServicePort]

The list of ports that are exposed by this service.

More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `publish_not_ready_addresses`<sup>Optional</sup> <a name="publish_not_ready_addresses" id="cdk8s-plus-28.k8s.ServiceSpec.property.publishNotReadyAddresses"></a>

```python
publish_not_ready_addresses: bool
```

- *Type:* bool

publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready.

The primary use case for setting this field is for a StatefulSet's Headless Service to propagate SRV DNS records for its Pods for the purpose of peer discovery. The Kubernetes controllers that generate Endpoints and EndpointSlice resources for Services interpret this to mean that all endpoints are considered "ready" even if the Pods themselves are not. Agents which consume only Kubernetes generated endpoints through the Endpoints or EndpointSlice resources can safely assume this behavior.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ServiceSpec.property.selector"></a>

```python
selector: typing.Mapping[str]
```

- *Type:* typing.Mapping[str]

Route service traffic to pods with label keys and values matching this selector.

If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/

---

##### `session_affinity`<sup>Optional</sup> <a name="session_affinity" id="cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinity"></a>

```python
session_affinity: str
```

- *Type:* str
- *Default:* None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

Supports "ClientIP" and "None".

Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `session_affinity_config`<sup>Optional</sup> <a name="session_affinity_config" id="cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinityConfig"></a>

```python
session_affinity_config: SessionAffinityConfig
```

- *Type:* cdk8s_plus_28.k8s.SessionAffinityConfig

sessionAffinityConfig contains the configurations of session affinity.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.ServiceSpec.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. "ClusterIP" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object or EndpointSlice objects. If clusterIP is "None", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a virtual IP. "NodePort" builds on ClusterIP and allocates a port on every node which routes to the same endpoints as the clusterIP. "LoadBalancer" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the same endpoints as the clusterIP. "ExternalName" aliases this service to the specified externalName. Several other fields do not apply to ExternalName services. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

type determines how the Service is exposed.

Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. "ClusterIP" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object or EndpointSlice objects. If clusterIP is "None", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a virtual IP. "NodePort" builds on ClusterIP and allocates a port on every node which routes to the same endpoints as the clusterIP. "LoadBalancer" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the same endpoints as the clusterIP. "ExternalName" aliases this service to the specified externalName. Several other fields do not apply to ExternalName services. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

---

### SessionAffinityConfig <a name="SessionAffinityConfig" id="cdk8s-plus-28.k8s.SessionAffinityConfig"></a>

SessionAffinityConfig represents the configurations of session affinity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SessionAffinityConfig.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SessionAffinityConfig(
  client_ip: ClientIpConfig = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SessionAffinityConfig.property.clientIp">client_ip</a></code> | <code>cdk8s_plus_28.k8s.ClientIpConfig</code> | clientIP contains the configurations of Client IP based session affinity. |

---

##### `client_ip`<sup>Optional</sup> <a name="client_ip" id="cdk8s-plus-28.k8s.SessionAffinityConfig.property.clientIp"></a>

```python
client_ip: ClientIpConfig
```

- *Type:* cdk8s_plus_28.k8s.ClientIpConfig

clientIP contains the configurations of Client IP based session affinity.

---

### SshAuthSecretProps <a name="SshAuthSecretProps" id="cdk8s-plus-28.SshAuthSecretProps"></a>

Options for `SshAuthSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SshAuthSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SshAuthSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  ssh_private_key: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.sshPrivateKey">ssh_private_key</a></code> | <code>str</code> | The SSH private key to use. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.SshAuthSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.SshAuthSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `ssh_private_key`<sup>Required</sup> <a name="ssh_private_key" id="cdk8s-plus-28.SshAuthSecretProps.property.sshPrivateKey"></a>

```python
ssh_private_key: str
```

- *Type:* str

The SSH private key to use.

---

### StatefulSetOrdinals <a name="StatefulSetOrdinals" id="cdk8s-plus-28.k8s.StatefulSetOrdinals"></a>

StatefulSetOrdinals describes the policy used for replica ordinal assignment in this StatefulSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetOrdinals.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatefulSetOrdinals(
  start: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetOrdinals.property.start">start</a></code> | <code>typing.Union[int, float]</code> | start is the number representing the first replica's index. |

---

##### `start`<sup>Optional</sup> <a name="start" id="cdk8s-plus-28.k8s.StatefulSetOrdinals.property.start"></a>

```python
start: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

start is the number representing the first replica's index.

It may be used to number replicas from an alternate index (eg: 1-indexed) over the default 0-indexed names, or to orchestrate progressive movement of replicas from one StatefulSet to another. If set, replica indices will be in the range:
[.spec.ordinals.start, .spec.ordinals.start + .spec.replicas).
If unset, defaults to 0. Replica indices will be in the range:
[0, .spec.replicas).

---

### StatefulSetPersistentVolumeClaimRetentionPolicy <a name="StatefulSetPersistentVolumeClaimRetentionPolicy" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy"></a>

StatefulSetPersistentVolumeClaimRetentionPolicy describes the policy used for PVCs created from the StatefulSet VolumeClaimTemplates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatefulSetPersistentVolumeClaimRetentionPolicy(
  when_deleted: str = None,
  when_scaled: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenDeleted">when_deleted</a></code> | <code>str</code> | WhenDeleted specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is deleted. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenScaled">when_scaled</a></code> | <code>str</code> | WhenScaled specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is scaled down. |

---

##### `when_deleted`<sup>Optional</sup> <a name="when_deleted" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenDeleted"></a>

```python
when_deleted: str
```

- *Type:* str

WhenDeleted specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is deleted.

The default policy of `Retain` causes PVCs to not be affected by StatefulSet deletion. The `Delete` policy causes those PVCs to be deleted.

---

##### `when_scaled`<sup>Optional</sup> <a name="when_scaled" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenScaled"></a>

```python
when_scaled: str
```

- *Type:* str

WhenScaled specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is scaled down.

The default policy of `Retain` causes PVCs to not be affected by a scaledown. The `Delete` policy causes the associated PVCs for any excess pods above the replica count to be deleted.

---

### StatefulSetProps <a name="StatefulSetProps" id="cdk8s-plus-28.StatefulSetProps"></a>

Properties for initialization of `StatefulSet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.StatefulSetProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSetProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None,
  min_ready: Duration = None,
  pod_management_policy: PodManagementPolicy = None,
  replicas: typing.Union[int, float] = None,
  service: Service = None,
  strategy: StatefulSetUpdateStrategy = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.minReady">min_ready</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.podManagementPolicy">pod_management_policy</a></code> | <code><a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a></code> | Pod management policy to use for this statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.service">service</a></code> | <code><a href="#cdk8s-plus-28.Service">Service</a></code> | Service to associate with the statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a></code> | Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.StatefulSetProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.StatefulSetProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.StatefulSetProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.StatefulSetProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.StatefulSetProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.StatefulSetProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.StatefulSetProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.StatefulSetProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.StatefulSetProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.StatefulSetProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.StatefulSetProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.StatefulSetProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.StatefulSetProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.StatefulSetProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.StatefulSetProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.StatefulSetProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.StatefulSetProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `min_ready`<sup>Optional</sup> <a name="min_ready" id="cdk8s-plus-28.StatefulSetProps.property.minReady"></a>

```python
min_ready: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `pod_management_policy`<sup>Optional</sup> <a name="pod_management_policy" id="cdk8s-plus-28.StatefulSetProps.property.podManagementPolicy"></a>

```python
pod_management_policy: PodManagementPolicy
```

- *Type:* <a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a>
- *Default:* PodManagementPolicy.ORDERED_READY

Pod management policy to use for this statefulset.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.StatefulSetProps.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1

Number of desired pods.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.StatefulSetProps.property.service"></a>

```python
service: Service
```

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>
- *Default:* A new headless service will be created.

Service to associate with the statefulset.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.StatefulSetProps.property.strategy"></a>

```python
strategy: StatefulSetUpdateStrategy
```

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a>
- *Default:* RollingUpdate with partition set to 0

Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.

---

### StatefulSetSpec <a name="StatefulSetSpec" id="cdk8s-plus-28.k8s.StatefulSetSpec"></a>

A StatefulSetSpec is the specification of a StatefulSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatefulSetSpec(
  selector: LabelSelector,
  service_name: str,
  template: PodTemplateSpec,
  min_ready_seconds: typing.Union[int, float] = None,
  ordinals: StatefulSetOrdinals = None,
  persistent_volume_claim_retention_policy: StatefulSetPersistentVolumeClaimRetentionPolicy = None,
  pod_management_policy: str = None,
  replicas: typing.Union[int, float] = None,
  revision_history_limit: typing.Union[int, float] = None,
  update_strategy: StatefulSetUpdateStrategy = None,
  volume_claim_templates: typing.List[KubePersistentVolumeClaimProps] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.selector">selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | selector is a label query over pods that should match the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.serviceName">service_name</a></code> | <code>str</code> | serviceName is the name of the service that governs this StatefulSet. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.template">template</a></code> | <code>cdk8s_plus_28.k8s.PodTemplateSpec</code> | template is the object that describes the pod that will be created if insufficient replicas are detected. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.minReadySeconds">min_ready_seconds</a></code> | <code>typing.Union[int, float]</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.ordinals">ordinals</a></code> | <code>cdk8s_plus_28.k8s.StatefulSetOrdinals</code> | ordinals controls the numbering of replica indices in a StatefulSet. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.persistentVolumeClaimRetentionPolicy">persistent_volume_claim_retention_policy</a></code> | <code>cdk8s_plus_28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy</code> | persistentVolumeClaimRetentionPolicy describes the lifecycle of persistent volume claims created from volumeClaimTemplates. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.podManagementPolicy">pod_management_policy</a></code> | <code>str</code> | podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.replicas">replicas</a></code> | <code>typing.Union[int, float]</code> | replicas is the desired number of replicas of the given Template. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.revisionHistoryLimit">revision_history_limit</a></code> | <code>typing.Union[int, float]</code> | revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.updateStrategy">update_strategy</a></code> | <code>cdk8s_plus_28.k8s.StatefulSetUpdateStrategy</code> | updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.volumeClaimTemplates">volume_claim_templates</a></code> | <code>typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]</code> | volumeClaimTemplates is a list of claims that pods are allowed to reference. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.selector"></a>

```python
selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

selector is a label query over pods that should match the replica count.

It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `service_name`<sup>Required</sup> <a name="service_name" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.serviceName"></a>

```python
service_name: str
```

- *Type:* str

serviceName is the name of the service that governs this StatefulSet.

This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where "pod-specific-string" is managed by the StatefulSet controller.

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.template"></a>

```python
template: PodTemplateSpec
```

- *Type:* cdk8s_plus_28.k8s.PodTemplateSpec

template is the object that describes the pod that will be created if insufficient replicas are detected.

Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet. Each pod will be named with the format <statefulsetname>-<podindex>. For example, a pod in a StatefulSet named "web" with index number "3" would be named "web-3". The only allowed template.spec.restartPolicy value is "Always".

---

##### `min_ready_seconds`<sup>Optional</sup> <a name="min_ready_seconds" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.minReadySeconds"></a>

```python
min_ready_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `ordinals`<sup>Optional</sup> <a name="ordinals" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.ordinals"></a>

```python
ordinals: StatefulSetOrdinals
```

- *Type:* cdk8s_plus_28.k8s.StatefulSetOrdinals

ordinals controls the numbering of replica indices in a StatefulSet.

The default ordinals behavior assigns a "0" index to the first replica and increments the index by one for each additional replica requested. Using the ordinals field requires the StatefulSetStartOrdinal feature gate to be enabled, which is beta.

---

##### `persistent_volume_claim_retention_policy`<sup>Optional</sup> <a name="persistent_volume_claim_retention_policy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.persistentVolumeClaimRetentionPolicy"></a>

```python
persistent_volume_claim_retention_policy: StatefulSetPersistentVolumeClaimRetentionPolicy
```

- *Type:* cdk8s_plus_28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy

persistentVolumeClaimRetentionPolicy describes the lifecycle of persistent volume claims created from volumeClaimTemplates.

By default, all persistent volume claims are created as needed and retained until manually deleted. This policy allows the lifecycle to be altered, for example by deleting persistent volume claims when their stateful set is deleted, or when their pod is scaled down. This requires the StatefulSetAutoDeletePVC feature gate to be enabled, which is alpha.  +optional

---

##### `pod_management_policy`<sup>Optional</sup> <a name="pod_management_policy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.podManagementPolicy"></a>

```python
pod_management_policy: str
```

- *Type:* str

podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down.

The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.replicas"></a>

```python
replicas: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

replicas is the desired number of replicas of the given Template.

These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.

---

##### `revision_history_limit`<sup>Optional</sup> <a name="revision_history_limit" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.revisionHistoryLimit"></a>

```python
revision_history_limit: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history.

The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.

---

##### `update_strategy`<sup>Optional</sup> <a name="update_strategy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.updateStrategy"></a>

```python
update_strategy: StatefulSetUpdateStrategy
```

- *Type:* cdk8s_plus_28.k8s.StatefulSetUpdateStrategy

updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.

---

##### `volume_claim_templates`<sup>Optional</sup> <a name="volume_claim_templates" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.volumeClaimTemplates"></a>

```python
volume_claim_templates: typing.List[KubePersistentVolumeClaimProps]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.KubePersistentVolumeClaimProps]

volumeClaimTemplates is a list of claims that pods are allowed to reference.

The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.

---

### StatefulSetUpdateStrategy <a name="StatefulSetUpdateStrategy" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy"></a>

StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates.

It includes any additional parameters necessary to perform the update for the indicated strategy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatefulSetUpdateStrategy(
  rolling_update: RollingUpdateStatefulSetStrategy = None,
  type: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.rollingUpdate">rolling_update</a></code> | <code>cdk8s_plus_28.k8s.RollingUpdateStatefulSetStrategy</code> | RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.type">type</a></code> | <code>str</code> | Type indicates the type of the StatefulSetUpdateStrategy. |

---

##### `rolling_update`<sup>Optional</sup> <a name="rolling_update" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.rollingUpdate"></a>

```python
rolling_update: RollingUpdateStatefulSetStrategy
```

- *Type:* cdk8s_plus_28.k8s.RollingUpdateStatefulSetStrategy

RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.type"></a>

```python
type: str
```

- *Type:* str
- *Default:* RollingUpdate.

Type indicates the type of the StatefulSetUpdateStrategy.

Default is RollingUpdate.

---

### StatefulSetUpdateStrategyRollingUpdateOptions <a name="StatefulSetUpdateStrategyRollingUpdateOptions" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions"></a>

Options for `StatefulSetUpdateStrategy.rollingUpdate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSetUpdateStrategyRollingUpdateOptions(
  partition: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.property.partition">partition</a></code> | <code>typing.Union[int, float]</code> | If specified, all Pods with an ordinal that is greater than or equal to the partition will be updated when the StatefulSet's .spec.template is updated. All Pods with an ordinal that is less than the partition will not be updated, and, even if they are deleted, they will be recreated at the previous version. |

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.property.partition"></a>

```python
partition: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 0

If specified, all Pods with an ordinal that is greater than or equal to the partition will be updated when the StatefulSet's .spec.template is updated. All Pods with an ordinal that is less than the partition will not be updated, and, even if they are deleted, they will be recreated at the previous version.

If the partition is greater than replicas, updates to the pod template will not be propagated to Pods.
In most cases you will not need to use a partition, but they are useful if you want to stage an
update, roll out a canary, or perform a phased roll out.

> [https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions](https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions)

---

### StatusCause <a name="StatusCause" id="cdk8s-plus-28.k8s.StatusCause"></a>

StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatusCause.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatusCause(
  field: str = None,
  message: str = None,
  reason: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.field">field</a></code> | <code>str</code> | The field of the resource that has caused this error, as named by its JSON serialization. |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.message">message</a></code> | <code>str</code> | A human-readable description of the cause of the error. |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.reason">reason</a></code> | <code>str</code> | A machine-readable description of the cause of the error. |

---

##### `field`<sup>Optional</sup> <a name="field" id="cdk8s-plus-28.k8s.StatusCause.property.field"></a>

```python
field: str
```

- *Type:* str

The field of the resource that has caused this error, as named by its JSON serialization.

May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.

Examples:
"name" - the field "name" on the current resource
"items[0].name" - the field "name" on the first array entry in "items"

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.StatusCause.property.message"></a>

```python
message: str
```

- *Type:* str

A human-readable description of the cause of the error.

This field may be presented as-is to a reader.

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.StatusCause.property.reason"></a>

```python
reason: str
```

- *Type:* str

A machine-readable description of the cause of the error.

If this value is empty there is no information available.

---

### StatusDetails <a name="StatusDetails" id="cdk8s-plus-28.k8s.StatusDetails"></a>

StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response.

The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatusDetails.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StatusDetails(
  causes: typing.List[StatusCause] = None,
  group: str = None,
  kind: str = None,
  name: str = None,
  retry_after_seconds: typing.Union[int, float] = None,
  uid: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.causes">causes</a></code> | <code>typing.List[cdk8s_plus_28.k8s.StatusCause]</code> | The Causes array includes more details associated with the StatusReason failure. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.group">group</a></code> | <code>str</code> | The group attribute of the resource associated with the status StatusReason. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.kind">kind</a></code> | <code>str</code> | The kind attribute of the resource associated with the status StatusReason. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.name">name</a></code> | <code>str</code> | The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described). |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.retryAfterSeconds">retry_after_seconds</a></code> | <code>typing.Union[int, float]</code> | If specified, the time in seconds before the operation should be retried. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.uid">uid</a></code> | <code>str</code> | UID of the resource. |

---

##### `causes`<sup>Optional</sup> <a name="causes" id="cdk8s-plus-28.k8s.StatusDetails.property.causes"></a>

```python
causes: typing.List[StatusCause]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.StatusCause]

The Causes array includes more details associated with the StatusReason failure.

Not all StatusReasons may provide detailed causes.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.StatusDetails.property.group"></a>

```python
group: str
```

- *Type:* str

The group attribute of the resource associated with the status StatusReason.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.StatusDetails.property.kind"></a>

```python
kind: str
```

- *Type:* str

The kind attribute of the resource associated with the status StatusReason.

On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.StatusDetails.property.name"></a>

```python
name: str
```

- *Type:* str

The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).

---

##### `retry_after_seconds`<sup>Optional</sup> <a name="retry_after_seconds" id="cdk8s-plus-28.k8s.StatusDetails.property.retryAfterSeconds"></a>

```python
retry_after_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

If specified, the time in seconds before the operation should be retried.

Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.StatusDetails.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID of the resource.

(when there is a single resource which can be described). More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

### StorageOsPersistentVolumeSource <a name="StorageOsPersistentVolumeSource" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource"></a>

Represents a StorageOS persistent volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StorageOsPersistentVolumeSource(
  fs_type: str = None,
  read_only: bool = None,
  secret_ref: ObjectReference = None,
  volume_name: str = None,
  volume_namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.ObjectReference</code> | secretRef specifies the secret to use for obtaining the StorageOS API credentials. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeName">volume_name</a></code> | <code>str</code> | volumeName is the human-readable name of the StorageOS volume. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeNamespace">volume_namespace</a></code> | <code>str</code> | volumeNamespace specifies the scope of the volume within StorageOS. |

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.secretRef"></a>

```python
secret_ref: ObjectReference
```

- *Type:* cdk8s_plus_28.k8s.ObjectReference

secretRef specifies the secret to use for obtaining the StorageOS API credentials.

If not specified, default values will be attempted.

---

##### `volume_name`<sup>Optional</sup> <a name="volume_name" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeName"></a>

```python
volume_name: str
```

- *Type:* str

volumeName is the human-readable name of the StorageOS volume.

Volume names are only unique within a namespace.

---

##### `volume_namespace`<sup>Optional</sup> <a name="volume_namespace" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeNamespace"></a>

```python
volume_namespace: str
```

- *Type:* str

volumeNamespace specifies the scope of the volume within StorageOS.

If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

---

### StorageOsVolumeSource <a name="StorageOsVolumeSource" id="cdk8s-plus-28.k8s.StorageOsVolumeSource"></a>

Represents a StorageOS persistent volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.StorageOsVolumeSource(
  fs_type: str = None,
  read_only: bool = None,
  secret_ref: LocalObjectReference = None,
  volume_name: str = None,
  volume_namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.readOnly">read_only</a></code> | <code>bool</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.secretRef">secret_ref</a></code> | <code>cdk8s_plus_28.k8s.LocalObjectReference</code> | secretRef specifies the secret to use for obtaining the StorageOS API credentials. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeName">volume_name</a></code> | <code>str</code> | volumeName is the human-readable name of the StorageOS volume. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeNamespace">volume_namespace</a></code> | <code>str</code> | volumeNamespace specifies the scope of the volume within StorageOS. |

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secret_ref`<sup>Optional</sup> <a name="secret_ref" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.secretRef"></a>

```python
secret_ref: LocalObjectReference
```

- *Type:* cdk8s_plus_28.k8s.LocalObjectReference

secretRef specifies the secret to use for obtaining the StorageOS API credentials.

If not specified, default values will be attempted.

---

##### `volume_name`<sup>Optional</sup> <a name="volume_name" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeName"></a>

```python
volume_name: str
```

- *Type:* str

volumeName is the human-readable name of the StorageOS volume.

Volume names are only unique within a namespace.

---

##### `volume_namespace`<sup>Optional</sup> <a name="volume_namespace" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeNamespace"></a>

```python
volume_namespace: str
```

- *Type:* str

volumeNamespace specifies the scope of the volume within StorageOS.

If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

---

### Subject <a name="Subject" id="cdk8s-plus-28.k8s.Subject"></a>

Subject contains a reference to the object or user identities a role binding applies to.

This can either hold a direct API object reference, or a value for non-objects such as user and group names.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Subject.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Subject(
  kind: str,
  name: str,
  api_group: str = None,
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.kind">kind</a></code> | <code>str</code> | Kind of object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.name">name</a></code> | <code>str</code> | Name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup holds the API group of the referenced subject. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.namespace">namespace</a></code> | <code>str</code> | Namespace of the referenced object. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.Subject.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind of object being referenced.

Values defined by this API group are "User", "Group", and "ServiceAccount". If the Authorizer does not recognized the kind value, the Authorizer should report an error.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Subject.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the object being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.Subject.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str
- *Default:* for ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User and Group subjects.

APIGroup holds the API group of the referenced subject.

Defaults to "" for ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User and Group subjects.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.Subject.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace of the referenced object.

If the object kind is non-namespace, such as "User" or "Group", and this value is not empty the Authorizer should report an error.

---

### SubjectAccessReviewSpec <a name="SubjectAccessReviewSpec" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec"></a>

SubjectAccessReviewSpec is a description of the access request.

Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SubjectAccessReviewSpec(
  extra: typing.Mapping[typing.List[str]] = None,
  groups: typing.List[str] = None,
  non_resource_attributes: NonResourceAttributes = None,
  resource_attributes: ResourceAttributes = None,
  uid: str = None,
  user: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.extra">extra</a></code> | <code>typing.Mapping[typing.List[str]]</code> | Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.groups">groups</a></code> | <code>typing.List[str]</code> | Groups is the groups you're testing for. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.nonResourceAttributes">non_resource_attributes</a></code> | <code>cdk8s_plus_28.k8s.NonResourceAttributes</code> | NonResourceAttributes describes information for a non-resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.resourceAttributes">resource_attributes</a></code> | <code>cdk8s_plus_28.k8s.ResourceAttributes</code> | ResourceAuthorizationAttributes describes information for a resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.uid">uid</a></code> | <code>str</code> | UID information about the requesting user. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.user">user</a></code> | <code>str</code> | User is the user you're testing for. |

---

##### `extra`<sup>Optional</sup> <a name="extra" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.extra"></a>

```python
extra: typing.Mapping[typing.List[str]]
```

- *Type:* typing.Mapping[typing.List[str]]

Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.

---

##### `groups`<sup>Optional</sup> <a name="groups" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.groups"></a>

```python
groups: typing.List[str]
```

- *Type:* typing.List[str]

Groups is the groups you're testing for.

---

##### `non_resource_attributes`<sup>Optional</sup> <a name="non_resource_attributes" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.nonResourceAttributes"></a>

```python
non_resource_attributes: NonResourceAttributes
```

- *Type:* cdk8s_plus_28.k8s.NonResourceAttributes

NonResourceAttributes describes information for a non-resource access request.

---

##### `resource_attributes`<sup>Optional</sup> <a name="resource_attributes" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.resourceAttributes"></a>

```python
resource_attributes: ResourceAttributes
```

- *Type:* cdk8s_plus_28.k8s.ResourceAttributes

ResourceAuthorizationAttributes describes information for a resource access request.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.uid"></a>

```python
uid: str
```

- *Type:* str

UID information about the requesting user.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.user"></a>

```python
user: str
```

- *Type:* str

User is the user you're testing for.

If you specify "User" but not "Groups", then is it interpreted as "What if User were not a member of any groups

---

### SubjectConfiguration <a name="SubjectConfiguration" id="cdk8s-plus-28.SubjectConfiguration"></a>

Subject contains a reference to the object or user identities a role binding applies to.

This can either hold a direct API object reference, or a value
for non-objects such as user and group names.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SubjectConfiguration.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.SubjectConfiguration(
  kind: str,
  name: str,
  api_group: str = None,
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.kind">kind</a></code> | <code>str</code> | Kind of object being referenced. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.name">name</a></code> | <code>str</code> | Name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup holds the API group of the referenced subject. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.namespace">namespace</a></code> | <code>str</code> | Namespace of the referenced object. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.SubjectConfiguration.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind of object being referenced.

Values defined by this API group are
"User", "Group", and "ServiceAccount". If the Authorizer does not
recognized the kind value, the Authorizer should report an error.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SubjectConfiguration.property.name"></a>

```python
name: str
```

- *Type:* str

Name of the object being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.SubjectConfiguration.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup holds the API group of the referenced subject.

Defaults to "" for
ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User
and Group subjects.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.SubjectConfiguration.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace of the referenced object.

If the object kind is non-namespace,
such as "User" or "Group", and this value is not empty the Authorizer
should report an error.

---

### SubjectV1Beta2 <a name="SubjectV1Beta2" id="cdk8s-plus-28.k8s.SubjectV1Beta2"></a>

Subject matches the originator of a request, as identified by the request authentication system.

There are three ways of matching an originator; by user, group, or service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SubjectV1Beta2(
  kind: str,
  group: GroupSubjectV1Beta2 = None,
  service_account: ServiceAccountSubjectV1Beta2 = None,
  user: UserSubjectV1Beta2 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.kind">kind</a></code> | <code>str</code> | `kind` indicates which one of the other fields is non-empty. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.group">group</a></code> | <code>cdk8s_plus_28.k8s.GroupSubjectV1Beta2</code> | `group` matches based on user group name. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.serviceAccount">service_account</a></code> | <code>cdk8s_plus_28.k8s.ServiceAccountSubjectV1Beta2</code> | `serviceAccount` matches ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.user">user</a></code> | <code>cdk8s_plus_28.k8s.UserSubjectV1Beta2</code> | `user` matches based on username. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.kind"></a>

```python
kind: str
```

- *Type:* str

`kind` indicates which one of the other fields is non-empty.

Required

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.group"></a>

```python
group: GroupSubjectV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.GroupSubjectV1Beta2

`group` matches based on user group name.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.serviceAccount"></a>

```python
service_account: ServiceAccountSubjectV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.ServiceAccountSubjectV1Beta2

`serviceAccount` matches ServiceAccounts.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.user"></a>

```python
user: UserSubjectV1Beta2
```

- *Type:* cdk8s_plus_28.k8s.UserSubjectV1Beta2

`user` matches based on username.

---

### SubjectV1Beta3 <a name="SubjectV1Beta3" id="cdk8s-plus-28.k8s.SubjectV1Beta3"></a>

Subject matches the originator of a request, as identified by the request authentication system.

There are three ways of matching an originator; by user, group, or service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.SubjectV1Beta3(
  kind: str,
  group: GroupSubjectV1Beta3 = None,
  service_account: ServiceAccountSubjectV1Beta3 = None,
  user: UserSubjectV1Beta3 = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.kind">kind</a></code> | <code>str</code> | `kind` indicates which one of the other fields is non-empty. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.group">group</a></code> | <code>cdk8s_plus_28.k8s.GroupSubjectV1Beta3</code> | `group` matches based on user group name. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.serviceAccount">service_account</a></code> | <code>cdk8s_plus_28.k8s.ServiceAccountSubjectV1Beta3</code> | `serviceAccount` matches ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.user">user</a></code> | <code>cdk8s_plus_28.k8s.UserSubjectV1Beta3</code> | `user` matches based on username. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.kind"></a>

```python
kind: str
```

- *Type:* str

`kind` indicates which one of the other fields is non-empty.

Required

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.group"></a>

```python
group: GroupSubjectV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.GroupSubjectV1Beta3

`group` matches based on user group name.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.serviceAccount"></a>

```python
service_account: ServiceAccountSubjectV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.ServiceAccountSubjectV1Beta3

`serviceAccount` matches ServiceAccounts.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.user"></a>

```python
user: UserSubjectV1Beta3
```

- *Type:* cdk8s_plus_28.k8s.UserSubjectV1Beta3

`user` matches based on username.

---

### Sysctl <a name="Sysctl" id="cdk8s-plus-28.Sysctl"></a>

Sysctl defines a kernel parameter to be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.Sysctl.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Sysctl(
  name: str,
  value: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Sysctl.property.name">name</a></code> | <code>str</code> | Name of a property to set. |
| <code><a href="#cdk8s-plus-28.Sysctl.property.value">value</a></code> | <code>str</code> | Value of a property to set. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Sysctl.property.name"></a>

```python
name: str
```

- *Type:* str

Name of a property to set.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Sysctl.property.value"></a>

```python
value: str
```

- *Type:* str

Value of a property to set.

---

### Sysctl <a name="Sysctl" id="cdk8s-plus-28.k8s.Sysctl"></a>

Sysctl defines a kernel parameter to be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Sysctl.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Sysctl(
  name: str,
  value: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Sysctl.property.name">name</a></code> | <code>str</code> | Name of a property to set. |
| <code><a href="#cdk8s-plus-28.k8s.Sysctl.property.value">value</a></code> | <code>str</code> | Value of a property to set. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Sysctl.property.name"></a>

```python
name: str
```

- *Type:* str

Name of a property to set.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Sysctl.property.value"></a>

```python
value: str
```

- *Type:* str

Value of a property to set.

---

### Taint <a name="Taint" id="cdk8s-plus-28.k8s.Taint"></a>

The node this Taint is attached to has the "effect" on any pod that does not tolerate the Taint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Taint.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Taint(
  effect: str,
  key: str,
  time_added: datetime.datetime = None,
  value: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.effect">effect</a></code> | <code>str</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.key">key</a></code> | <code>str</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.timeAdded">time_added</a></code> | <code>datetime.datetime</code> | TimeAdded represents the time at which the taint was added. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.value">value</a></code> | <code>str</code> | The taint value corresponding to the taint key. |

---

##### `effect`<sup>Required</sup> <a name="effect" id="cdk8s-plus-28.k8s.Taint.property.effect"></a>

```python
effect: str
```

- *Type:* str

Required.

The effect of the taint on pods that do not tolerate the taint. Valid effects are NoSchedule, PreferNoSchedule and NoExecute.

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.Taint.property.key"></a>

```python
key: str
```

- *Type:* str

Required.

The taint key to be applied to a node.

---

##### `time_added`<sup>Optional</sup> <a name="time_added" id="cdk8s-plus-28.k8s.Taint.property.timeAdded"></a>

```python
time_added: datetime.datetime
```

- *Type:* datetime.datetime

TimeAdded represents the time at which the taint was added.

It is only written for NoExecute taints.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.Taint.property.value"></a>

```python
value: str
```

- *Type:* str

The taint value corresponding to the taint key.

---

### TcpSocketAction <a name="TcpSocketAction" id="cdk8s-plus-28.k8s.TcpSocketAction"></a>

TCPSocketAction describes an action based on opening a socket.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TcpSocketAction.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TcpSocketAction(
  port: IntOrString,
  host: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TcpSocketAction.property.port">port</a></code> | <code>cdk8s_plus_28.k8s.IntOrString</code> | Number or name of the port to access on the container. |
| <code><a href="#cdk8s-plus-28.k8s.TcpSocketAction.property.host">host</a></code> | <code>str</code> | Optional: Host name to connect to, defaults to the pod IP. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.TcpSocketAction.property.port"></a>

```python
port: IntOrString
```

- *Type:* cdk8s_plus_28.k8s.IntOrString

Number or name of the port to access on the container.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.TcpSocketAction.property.host"></a>

```python
host: str
```

- *Type:* str

Optional: Host name to connect to, defaults to the pod IP.

---

### TcpSocketProbeOptions <a name="TcpSocketProbeOptions" id="cdk8s-plus-28.TcpSocketProbeOptions"></a>

Options for `Probe.fromTcpSocket()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.TcpSocketProbeOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TcpSocketProbeOptions(
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None,
  host: str = None,
  port: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.failureThreshold">failure_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.initialDelaySeconds">initial_delay_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.periodSeconds">period_seconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.successThreshold">success_threshold</a></code> | <code>typing.Union[int, float]</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.timeoutSeconds">timeout_seconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.host">host</a></code> | <code>str</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.port">port</a></code> | <code>typing.Union[int, float]</code> | The TCP port to connect to on the container. |

---

##### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.TcpSocketProbeOptions.property.failureThreshold"></a>

```python
failure_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.initialDelaySeconds"></a>

```python
initial_delay_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.periodSeconds"></a>

```python
period_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.TcpSocketProbeOptions.property.successThreshold"></a>

```python
success_threshold: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.timeoutSeconds"></a>

```python
timeout_seconds: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.TcpSocketProbeOptions.property.host"></a>

```python
host: str
```

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.TcpSocketProbeOptions.property.port"></a>

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---

### TlsSecretProps <a name="TlsSecretProps" id="cdk8s-plus-28.TlsSecretProps"></a>

Options for `TlsSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.TlsSecretProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TlsSecretProps(
  metadata: ApiObjectMetadata = None,
  immutable: bool = None,
  tls_cert: str,
  tls_key: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.immutable">immutable</a></code> | <code>bool</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.tlsCert">tls_cert</a></code> | <code>str</code> | The TLS cert. |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.tlsKey">tls_key</a></code> | <code>str</code> | The TLS key. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.TlsSecretProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.TlsSecretProps.property.immutable"></a>

```python
immutable: bool
```

- *Type:* bool
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `tls_cert`<sup>Required</sup> <a name="tls_cert" id="cdk8s-plus-28.TlsSecretProps.property.tlsCert"></a>

```python
tls_cert: str
```

- *Type:* str

The TLS cert.

---

##### `tls_key`<sup>Required</sup> <a name="tls_key" id="cdk8s-plus-28.TlsSecretProps.property.tlsKey"></a>

```python
tls_key: str
```

- *Type:* str

The TLS key.

---

### TokenRequest <a name="TokenRequest" id="cdk8s-plus-28.k8s.TokenRequest"></a>

TokenRequest contains parameters of a service account token.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenRequest.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TokenRequest(
  audience: str,
  expiration_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequest.property.audience">audience</a></code> | <code>str</code> | audience is the intended audience of the token in "TokenRequestSpec". |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequest.property.expirationSeconds">expiration_seconds</a></code> | <code>typing.Union[int, float]</code> | expirationSeconds is the duration of validity of the token in "TokenRequestSpec". |

---

##### `audience`<sup>Required</sup> <a name="audience" id="cdk8s-plus-28.k8s.TokenRequest.property.audience"></a>

```python
audience: str
```

- *Type:* str

audience is the intended audience of the token in "TokenRequestSpec".

It will default to the audiences of kube apiserver.

---

##### `expiration_seconds`<sup>Optional</sup> <a name="expiration_seconds" id="cdk8s-plus-28.k8s.TokenRequest.property.expirationSeconds"></a>

```python
expiration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

expirationSeconds is the duration of validity of the token in "TokenRequestSpec".

It has the same default value of "ExpirationSeconds" in "TokenRequestSpec".

---

### TokenRequestSpec <a name="TokenRequestSpec" id="cdk8s-plus-28.k8s.TokenRequestSpec"></a>

TokenRequestSpec contains client provided parameters of a token request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenRequestSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TokenRequestSpec(
  audiences: typing.List[str],
  bound_object_ref: BoundObjectReference = None,
  expiration_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.audiences">audiences</a></code> | <code>typing.List[str]</code> | Audiences are the intendend audiences of the token. |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.boundObjectRef">bound_object_ref</a></code> | <code>cdk8s_plus_28.k8s.BoundObjectReference</code> | BoundObjectRef is a reference to an object that the token will be bound to. |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.expirationSeconds">expiration_seconds</a></code> | <code>typing.Union[int, float]</code> | ExpirationSeconds is the requested duration of validity of the request. |

---

##### `audiences`<sup>Required</sup> <a name="audiences" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.audiences"></a>

```python
audiences: typing.List[str]
```

- *Type:* typing.List[str]

Audiences are the intendend audiences of the token.

A recipient of a token must identify themself with an identifier in the list of audiences of the token, and otherwise should reject the token. A token issued for multiple audiences may be used to authenticate against any of the audiences listed but implies a high degree of trust between the target audiences.

---

##### `bound_object_ref`<sup>Optional</sup> <a name="bound_object_ref" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.boundObjectRef"></a>

```python
bound_object_ref: BoundObjectReference
```

- *Type:* cdk8s_plus_28.k8s.BoundObjectReference

BoundObjectRef is a reference to an object that the token will be bound to.

The token will only be valid for as long as the bound object exists. NOTE: The API server's TokenReview endpoint will validate the BoundObjectRef, but other audiences may not. Keep ExpirationSeconds small if you want prompt revocation.

---

##### `expiration_seconds`<sup>Optional</sup> <a name="expiration_seconds" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.expirationSeconds"></a>

```python
expiration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

ExpirationSeconds is the requested duration of validity of the request.

The token issuer may return a token with a different validity duration so a client needs to check the 'expiration' field in a response.

---

### TokenReviewSpec <a name="TokenReviewSpec" id="cdk8s-plus-28.k8s.TokenReviewSpec"></a>

TokenReviewSpec is a description of the token authentication request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenReviewSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TokenReviewSpec(
  audiences: typing.List[str] = None,
  token: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenReviewSpec.property.audiences">audiences</a></code> | <code>typing.List[str]</code> | Audiences is a list of the identifiers that the resource server presented with the token identifies as. |
| <code><a href="#cdk8s-plus-28.k8s.TokenReviewSpec.property.token">token</a></code> | <code>str</code> | Token is the opaque bearer token. |

---

##### `audiences`<sup>Optional</sup> <a name="audiences" id="cdk8s-plus-28.k8s.TokenReviewSpec.property.audiences"></a>

```python
audiences: typing.List[str]
```

- *Type:* typing.List[str]

Audiences is a list of the identifiers that the resource server presented with the token identifies as.

Audience-aware token authenticators will verify that the token was intended for at least one of the audiences in this list. If no audiences are provided, the audience will default to the audience of the Kubernetes apiserver.

---

##### `token`<sup>Optional</sup> <a name="token" id="cdk8s-plus-28.k8s.TokenReviewSpec.property.token"></a>

```python
token: str
```

- *Type:* str

Token is the opaque bearer token.

---

### Toleration <a name="Toleration" id="cdk8s-plus-28.k8s.Toleration"></a>

The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Toleration.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Toleration(
  effect: str = None,
  key: str = None,
  operator: str = None,
  toleration_seconds: typing.Union[int, float] = None,
  value: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.effect">effect</a></code> | <code>str</code> | Effect indicates the taint effect to match. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.key">key</a></code> | <code>str</code> | Key is the taint key that the toleration applies to. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.operator">operator</a></code> | <code>str</code> | Operator represents a key's relationship to the value. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.tolerationSeconds">toleration_seconds</a></code> | <code>typing.Union[int, float]</code> | TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.value">value</a></code> | <code>str</code> | Value is the taint value the toleration matches to. |

---

##### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.k8s.Toleration.property.effect"></a>

```python
effect: str
```

- *Type:* str

Effect indicates the taint effect to match.

Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.

---

##### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.k8s.Toleration.property.key"></a>

```python
key: str
```

- *Type:* str

Key is the taint key that the toleration applies to.

Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.

---

##### `operator`<sup>Optional</sup> <a name="operator" id="cdk8s-plus-28.k8s.Toleration.property.operator"></a>

```python
operator: str
```

- *Type:* str
- *Default:* Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

Operator represents a key's relationship to the value.

Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

---

##### `toleration_seconds`<sup>Optional</sup> <a name="toleration_seconds" id="cdk8s-plus-28.k8s.Toleration.property.tolerationSeconds"></a>

```python
toleration_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint.

By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.Toleration.property.value"></a>

```python
value: str
```

- *Type:* str

Value is the taint value the toleration matches to.

If the operator is Exists, the value should be empty, otherwise just a regular string.

---

### TopologySelectorLabelRequirement <a name="TopologySelectorLabelRequirement" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement"></a>

A topology selector requirement is a selector that matches given label.

This is an alpha feature and may change in the future.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TopologySelectorLabelRequirement(
  key: str,
  values: typing.List[str]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.key">key</a></code> | <code>str</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.values">values</a></code> | <code>typing.List[str]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.key"></a>

```python
key: str
```

- *Type:* str

The label key that the selector applies to.

---

##### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

An array of string values.

One value must match the label to be selected. Each entry in Values is ORed.

---

### TopologySelectorTerm <a name="TopologySelectorTerm" id="cdk8s-plus-28.k8s.TopologySelectorTerm"></a>

A topology selector term represents the result of label queries.

A null or empty topology selector term matches no objects. The requirements of them are ANDed. It provides a subset of functionality as NodeSelectorTerm. This is an alpha feature and may change in the future.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySelectorTerm.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TopologySelectorTerm(
  match_label_expressions: typing.List[TopologySelectorLabelRequirement] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorTerm.property.matchLabelExpressions">match_label_expressions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.TopologySelectorLabelRequirement]</code> | A list of topology selector requirements by labels. |

---

##### `match_label_expressions`<sup>Optional</sup> <a name="match_label_expressions" id="cdk8s-plus-28.k8s.TopologySelectorTerm.property.matchLabelExpressions"></a>

```python
match_label_expressions: typing.List[TopologySelectorLabelRequirement]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.TopologySelectorLabelRequirement]

A list of topology selector requirements by labels.

---

### TopologySpreadConstraint <a name="TopologySpreadConstraint" id="cdk8s-plus-28.k8s.TopologySpreadConstraint"></a>

TopologySpreadConstraint specifies how to spread matching pods among the given topology.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TopologySpreadConstraint(
  max_skew: typing.Union[int, float],
  topology_key: str,
  when_unsatisfiable: str,
  label_selector: LabelSelector = None,
  match_label_keys: typing.List[str] = None,
  min_domains: typing.Union[int, float] = None,
  node_affinity_policy: str = None,
  node_taints_policy: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.maxSkew">max_skew</a></code> | <code>typing.Union[int, float]</code> | MaxSkew describes the degree to which pods may be unevenly distributed. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.topologyKey">topology_key</a></code> | <code>str</code> | TopologyKey is the key of node labels. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.whenUnsatisfiable">when_unsatisfiable</a></code> | <code>str</code> | WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.labelSelector">label_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | LabelSelector is used to find matching pods. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.matchLabelKeys">match_label_keys</a></code> | <code>typing.List[str]</code> | MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.minDomains">min_domains</a></code> | <code>typing.Union[int, float]</code> | MinDomains indicates a minimum number of eligible domains. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeAffinityPolicy">node_affinity_policy</a></code> | <code>str</code> | NodeAffinityPolicy indicates how we will treat Pod's nodeAffinity/nodeSelector when calculating pod topology spread skew. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeTaintsPolicy">node_taints_policy</a></code> | <code>str</code> | NodeTaintsPolicy indicates how we will treat node taints when calculating pod topology spread skew. |

---

##### `max_skew`<sup>Required</sup> <a name="max_skew" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.maxSkew"></a>

```python
max_skew: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

MaxSkew describes the degree to which pods may be unevenly distributed.

When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. The global minimum is the minimum number of matching pods in an eligible domain or zero if the number of eligible domains is less than MinDomains. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 2/2/1: In this case, the global minimum is 1. | zone1 | zone2 | zone3 | |  P P  |  P P  |   P   | - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 2/2/2; scheduling it onto zone1(zone2) would make the ActualSkew(3-1) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.

---

##### `topology_key`<sup>Required</sup> <a name="topology_key" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.topologyKey"></a>

```python
topology_key: str
```

- *Type:* str

TopologyKey is the key of node labels.

Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. We define a domain as a particular instance of a topology. Also, we define an eligible domain as a domain whose nodes meet the requirements of nodeAffinityPolicy and nodeTaintsPolicy. e.g. If TopologyKey is "kubernetes.io/hostname", each Node is a domain of that topology. And, if TopologyKey is "topology.kubernetes.io/zone", each zone is a domain of that topology. It's a required field.

---

##### `when_unsatisfiable`<sup>Required</sup> <a name="when_unsatisfiable" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.whenUnsatisfiable"></a>

```python
when_unsatisfiable: str
```

- *Type:* str

WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint.

* DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location,
  but giving higher precedence to topologies that would help reduce the
  skew.
  A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: | zone1 | zone2 | zone3 | | P P P |   P   |   P   | If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.

---

##### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.labelSelector"></a>

```python
label_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector

LabelSelector is used to find matching pods.

Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.

---

##### `match_label_keys`<sup>Optional</sup> <a name="match_label_keys" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.matchLabelKeys"></a>

```python
match_label_keys: typing.List[str]
```

- *Type:* typing.List[str]

MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated.

The keys are used to lookup values from the incoming pod labels, those key-value labels are ANDed with labelSelector to select the group of existing pods over which spreading will be calculated for the incoming pod. The same key is forbidden to exist in both MatchLabelKeys and LabelSelector. MatchLabelKeys cannot be set when LabelSelector isn't set. Keys that don't exist in the incoming pod labels will be ignored. A null or empty list means only match against labelSelector.

This is a beta field and requires the MatchLabelKeysInPodTopologySpread feature gate to be enabled (enabled by default).

---

##### `min_domains`<sup>Optional</sup> <a name="min_domains" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.minDomains"></a>

```python
min_domains: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

MinDomains indicates a minimum number of eligible domains.

When the number of eligible domains with matching topology keys is less than minDomains, Pod Topology Spread treats "global minimum" as 0, and then the calculation of Skew is performed. And when the number of eligible domains with matching topology keys equals or greater than minDomains, this value has no effect on scheduling. As a result, when the number of eligible domains is less than minDomains, scheduler won't schedule more than maxSkew Pods to those domains. If value is nil, the constraint behaves as if MinDomains is equal to 1. Valid values are integers greater than 0. When value is not nil, WhenUnsatisfiable must be DoNotSchedule.

For example, in a 3-zone cluster, MaxSkew is set to 2, MinDomains is set to 5 and pods with the same labelSelector spread as 2/2/2: | zone1 | zone2 | zone3 | |  P P  |  P P  |  P P  | The number of domains is less than 5(MinDomains), so "global minimum" is treated as 0. In this situation, new pod with the same labelSelector cannot be scheduled, because computed skew will be 3(3 - 0) if new Pod is scheduled to any of the three zones, it will violate MaxSkew.

This is a beta field and requires the MinDomainsInPodTopologySpread feature gate to be enabled (enabled by default).

---

##### `node_affinity_policy`<sup>Optional</sup> <a name="node_affinity_policy" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeAffinityPolicy"></a>

```python
node_affinity_policy: str
```

- *Type:* str

NodeAffinityPolicy indicates how we will treat Pod's nodeAffinity/nodeSelector when calculating pod topology spread skew.

Options are: - Honor: only nodes matching nodeAffinity/nodeSelector are included in the calculations. - Ignore: nodeAffinity/nodeSelector are ignored. All nodes are included in the calculations.

If this value is nil, the behavior is equivalent to the Honor policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

---

##### `node_taints_policy`<sup>Optional</sup> <a name="node_taints_policy" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeTaintsPolicy"></a>

```python
node_taints_policy: str
```

- *Type:* str

NodeTaintsPolicy indicates how we will treat node taints when calculating pod topology spread skew.

Options are: - Honor: nodes without taints, along with tainted nodes for which the incoming pod has a toleration, are included. - Ignore: node taints are ignored. All nodes are included.

If this value is nil, the behavior is equivalent to the Ignore policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

---

### TypedLocalObjectReference <a name="TypedLocalObjectReference" id="cdk8s-plus-28.k8s.TypedLocalObjectReference"></a>

TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TypedLocalObjectReference(
  kind: str,
  name: str,
  api_group: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.kind">kind</a></code> | <code>str</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.name">name</a></code> | <code>str</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup is the group for the resource being referenced. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of resource being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

### TypedObjectReference <a name="TypedObjectReference" id="cdk8s-plus-28.k8s.TypedObjectReference"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TypedObjectReference.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.TypedObjectReference(
  kind: str,
  name: str,
  api_group: str = None,
  namespace: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.kind">kind</a></code> | <code>str</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.name">name</a></code> | <code>str</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.apiGroup">api_group</a></code> | <code>str</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.namespace">namespace</a></code> | <code>str</code> | Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.TypedObjectReference.property.kind"></a>

```python
kind: str
```

- *Type:* str

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.TypedObjectReference.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of resource being referenced.

---

##### `api_group`<sup>Optional</sup> <a name="api_group" id="cdk8s-plus-28.k8s.TypedObjectReference.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

APIGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.TypedObjectReference.property.namespace"></a>

```python
namespace: str
```

- *Type:* str

Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

---

### UserSubjectV1Beta2 <a name="UserSubjectV1Beta2" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2"></a>

UserSubject holds detailed information for user-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.UserSubjectV1Beta2(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.UserSubjectV1Beta2.property.name">name</a></code> | <code>str</code> | `name` is the username that matches, or "*" to match all usernames. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the username that matches, or "*" to match all usernames.

Required.

---

### UserSubjectV1Beta3 <a name="UserSubjectV1Beta3" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3"></a>

UserSubject holds detailed information for user-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.UserSubjectV1Beta3(
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.UserSubjectV1Beta3.property.name">name</a></code> | <code>str</code> | `name` is the username that matches, or "*" to match all usernames. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3.property.name"></a>

```python
name: str
```

- *Type:* str

`name` is the username that matches, or "*" to match all usernames.

Required.

---

### ValidatingAdmissionPolicyBindingSpecV1Alpha1 <a name="ValidatingAdmissionPolicyBindingSpecV1Alpha1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1"></a>

ValidatingAdmissionPolicyBindingSpec is the specification of the ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1(
  match_resources: MatchResourcesV1Alpha1 = None,
  param_ref: ParamRefV1Alpha1 = None,
  policy_name: str = None,
  validation_actions: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.matchResources">match_resources</a></code> | <code>cdk8s_plus_28.k8s.MatchResourcesV1Alpha1</code> | MatchResources declares what resources match this binding and will be validated by it. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.paramRef">param_ref</a></code> | <code>cdk8s_plus_28.k8s.ParamRefV1Alpha1</code> | paramRef specifies the parameter resource used to configure the admission control policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.policyName">policy_name</a></code> | <code>str</code> | PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.validationActions">validation_actions</a></code> | <code>typing.List[str]</code> | validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced. |

---

##### `match_resources`<sup>Optional</sup> <a name="match_resources" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.matchResources"></a>

```python
match_resources: MatchResourcesV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.MatchResourcesV1Alpha1

MatchResources declares what resources match this binding and will be validated by it.

Note that this is intersected with the policy's matchConstraints, so only requests that are matched by the policy can be selected by this. If this is unset, all resources matched by the policy are validated by this binding When resourceRules is unset, it does not constrain resource matching. If a resource is matched by the other fields of this object, it will be validated. Note that this is differs from ValidatingAdmissionPolicy matchConstraints, where resourceRules are required.

---

##### `param_ref`<sup>Optional</sup> <a name="param_ref" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.paramRef"></a>

```python
param_ref: ParamRefV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ParamRefV1Alpha1

paramRef specifies the parameter resource used to configure the admission control policy.

It should point to a resource of the type specified in ParamKind of the bound ValidatingAdmissionPolicy. If the policy specifies a ParamKind and the resource referred to by ParamRef does not exist, this binding is considered mis-configured and the FailurePolicy of the ValidatingAdmissionPolicy applied. If the policy does not specify a ParamKind then this field is ignored, and the rules are evaluated without a param.

---

##### `policy_name`<sup>Optional</sup> <a name="policy_name" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.policyName"></a>

```python
policy_name: str
```

- *Type:* str

PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to.

If the referenced resource does not exist, this binding is considered invalid and will be ignored Required.

---

##### `validation_actions`<sup>Optional</sup> <a name="validation_actions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.validationActions"></a>

```python
validation_actions: typing.List[str]
```

- *Type:* typing.List[str]

validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced.

If a validation evaluates to false it is always enforced according to these actions.

Failures defined by the ValidatingAdmissionPolicy's FailurePolicy are enforced according to these actions only if the FailurePolicy is set to Fail, otherwise the failures are ignored. This includes compilation errors, runtime errors and misconfigurations of the policy.

validationActions is declared as a set of action values. Order does not matter. validationActions may not contain duplicates of the same action.

The supported actions values are:

"Deny" specifies that a validation failure results in a denied request.

"Warn" specifies that a validation failure is reported to the request client in HTTP Warning headers, with a warning code of 299. Warnings can be sent both for allowed or denied admission responses.

"Audit" specifies that a validation failure is included in the published audit event for the request. The audit event will contain a `validation.policy.admission.k8s.io/validation_failure` audit annotation with a value containing the details of the validation failures, formatted as a JSON list of objects, each with the following fields: - message: The validation failure message string - policy: The resource name of the ValidatingAdmissionPolicy - binding: The resource name of the ValidatingAdmissionPolicyBinding - expressionIndex: The index of the failed validations in the ValidatingAdmissionPolicy - validationActions: The enforcement actions enacted for the validation failure Example audit annotation: `"validation.policy.admission.k8s.io/validation_failure": "[{"message": "Invalid value", {"policy": "policy.example.com", {"binding": "policybinding.example.com", {"expressionIndex": "1", {"validationActions": ["Audit"]}]"`

Clients should expect to handle additional values by ignoring any values not recognized.

"Deny" and "Warn" may not be used together since this combination needlessly duplicates the validation failure both in the API response body and the HTTP warning headers.

Required.

---

### ValidatingAdmissionPolicyBindingSpecV1Beta1 <a name="ValidatingAdmissionPolicyBindingSpecV1Beta1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1"></a>

ValidatingAdmissionPolicyBindingSpec is the specification of the ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1(
  match_resources: MatchResourcesV1Beta1 = None,
  param_ref: ParamRefV1Beta1 = None,
  policy_name: str = None,
  validation_actions: typing.List[str] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.matchResources">match_resources</a></code> | <code>cdk8s_plus_28.k8s.MatchResourcesV1Beta1</code> | MatchResources declares what resources match this binding and will be validated by it. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.paramRef">param_ref</a></code> | <code>cdk8s_plus_28.k8s.ParamRefV1Beta1</code> | paramRef specifies the parameter resource used to configure the admission control policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.policyName">policy_name</a></code> | <code>str</code> | PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.validationActions">validation_actions</a></code> | <code>typing.List[str]</code> | validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced. |

---

##### `match_resources`<sup>Optional</sup> <a name="match_resources" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.matchResources"></a>

```python
match_resources: MatchResourcesV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.MatchResourcesV1Beta1

MatchResources declares what resources match this binding and will be validated by it.

Note that this is intersected with the policy's matchConstraints, so only requests that are matched by the policy can be selected by this. If this is unset, all resources matched by the policy are validated by this binding When resourceRules is unset, it does not constrain resource matching. If a resource is matched by the other fields of this object, it will be validated. Note that this is differs from ValidatingAdmissionPolicy matchConstraints, where resourceRules are required.

---

##### `param_ref`<sup>Optional</sup> <a name="param_ref" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.paramRef"></a>

```python
param_ref: ParamRefV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.ParamRefV1Beta1

paramRef specifies the parameter resource used to configure the admission control policy.

It should point to a resource of the type specified in ParamKind of the bound ValidatingAdmissionPolicy. If the policy specifies a ParamKind and the resource referred to by ParamRef does not exist, this binding is considered mis-configured and the FailurePolicy of the ValidatingAdmissionPolicy applied. If the policy does not specify a ParamKind then this field is ignored, and the rules are evaluated without a param.

---

##### `policy_name`<sup>Optional</sup> <a name="policy_name" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.policyName"></a>

```python
policy_name: str
```

- *Type:* str

PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to.

If the referenced resource does not exist, this binding is considered invalid and will be ignored Required.

---

##### `validation_actions`<sup>Optional</sup> <a name="validation_actions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.validationActions"></a>

```python
validation_actions: typing.List[str]
```

- *Type:* typing.List[str]

validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced.

If a validation evaluates to false it is always enforced according to these actions.

Failures defined by the ValidatingAdmissionPolicy's FailurePolicy are enforced according to these actions only if the FailurePolicy is set to Fail, otherwise the failures are ignored. This includes compilation errors, runtime errors and misconfigurations of the policy.

validationActions is declared as a set of action values. Order does not matter. validationActions may not contain duplicates of the same action.

The supported actions values are:

"Deny" specifies that a validation failure results in a denied request.

"Warn" specifies that a validation failure is reported to the request client in HTTP Warning headers, with a warning code of 299. Warnings can be sent both for allowed or denied admission responses.

"Audit" specifies that a validation failure is included in the published audit event for the request. The audit event will contain a `validation.policy.admission.k8s.io/validation_failure` audit annotation with a value containing the details of the validation failures, formatted as a JSON list of objects, each with the following fields: - message: The validation failure message string - policy: The resource name of the ValidatingAdmissionPolicy - binding: The resource name of the ValidatingAdmissionPolicyBinding - expressionIndex: The index of the failed validations in the ValidatingAdmissionPolicy - validationActions: The enforcement actions enacted for the validation failure Example audit annotation: `"validation.policy.admission.k8s.io/validation_failure": "[{"message": "Invalid value", {"policy": "policy.example.com", {"binding": "policybinding.example.com", {"expressionIndex": "1", {"validationActions": ["Audit"]}]"`

Clients should expect to handle additional values by ignoring any values not recognized.

"Deny" and "Warn" may not be used together since this combination needlessly duplicates the validation failure both in the API response body and the HTTP warning headers.

Required.

---

### ValidatingAdmissionPolicySpecV1Alpha1 <a name="ValidatingAdmissionPolicySpecV1Alpha1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1"></a>

ValidatingAdmissionPolicySpec is the specification of the desired behavior of the AdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidatingAdmissionPolicySpecV1Alpha1(
  audit_annotations: typing.List[AuditAnnotationV1Alpha1] = None,
  failure_policy: str = None,
  match_conditions: typing.List[MatchConditionV1Alpha1] = None,
  match_constraints: MatchResourcesV1Alpha1 = None,
  param_kind: ParamKindV1Alpha1 = None,
  validations: typing.List[ValidationV1Alpha1] = None,
  variables: typing.List[VariableV1Alpha1] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.auditAnnotations">audit_annotations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.AuditAnnotationV1Alpha1]</code> | auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.failurePolicy">failure_policy</a></code> | <code>str</code> | failurePolicy defines how to handle failures for the admission policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConditions">match_conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MatchConditionV1Alpha1]</code> | MatchConditions is a list of conditions that must be met for a request to be validated. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConstraints">match_constraints</a></code> | <code>cdk8s_plus_28.k8s.MatchResourcesV1Alpha1</code> | MatchConstraints specifies what resources this policy is designed to validate. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.paramKind">param_kind</a></code> | <code>cdk8s_plus_28.k8s.ParamKindV1Alpha1</code> | ParamKind specifies the kind of resources used to parameterize this policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.validations">validations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ValidationV1Alpha1]</code> | Validations contain CEL expressions which is used to apply the validation. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.variables">variables</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VariableV1Alpha1]</code> | Variables contain definitions of variables that can be used in composition of other expressions. |

---

##### `audit_annotations`<sup>Optional</sup> <a name="audit_annotations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.auditAnnotations"></a>

```python
audit_annotations: typing.List[AuditAnnotationV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.AuditAnnotationV1Alpha1]

auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request.

validations and auditAnnotations may not both be empty; a least one of validations or auditAnnotations is required.

---

##### `failure_policy`<sup>Optional</sup> <a name="failure_policy" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.failurePolicy"></a>

```python
failure_policy: str
```

- *Type:* str
- *Default:* Fail.

failurePolicy defines how to handle failures for the admission policy.

Failures can occur from CEL expression parse errors, type check errors, runtime errors and invalid or mis-configured policy definitions or bindings.

A policy is invalid if spec.paramKind refers to a non-existent Kind. A binding is invalid if spec.paramRef.name refers to a non-existent resource.

failurePolicy does not define how validations that evaluate to false are handled.

When failurePolicy is set to Fail, ValidatingAdmissionPolicyBinding validationActions define how failures are enforced.

Allowed values are Ignore or Fail. Defaults to Fail.

---

##### `match_conditions`<sup>Optional</sup> <a name="match_conditions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConditions"></a>

```python
match_conditions: typing.List[MatchConditionV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MatchConditionV1Alpha1]

MatchConditions is a list of conditions that must be met for a request to be validated.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

If a parameter object is provided, it can be accessed via the `params` handle in the same manner as validation expressions.

The exact matching logic is (in order):

1. If ANY matchCondition evaluates to FALSE, the policy is skipped.
2. If ALL matchConditions evaluate to TRUE, the policy is evaluated.
3. If any matchCondition evaluates to an error (but none are FALSE):

* If failurePolicy=Fail, reject the request
* If failurePolicy=Ignore, the policy is skipped

---

##### `match_constraints`<sup>Optional</sup> <a name="match_constraints" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConstraints"></a>

```python
match_constraints: MatchResourcesV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.MatchResourcesV1Alpha1

MatchConstraints specifies what resources this policy is designed to validate.

The AdmissionPolicy cares about a request if it matches *all* Constraints. However, in order to prevent clusters from being put into an unstable state that cannot be recovered from via the API ValidatingAdmissionPolicy cannot match ValidatingAdmissionPolicy and ValidatingAdmissionPolicyBinding. Required.

---

##### `param_kind`<sup>Optional</sup> <a name="param_kind" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.paramKind"></a>

```python
param_kind: ParamKindV1Alpha1
```

- *Type:* cdk8s_plus_28.k8s.ParamKindV1Alpha1

ParamKind specifies the kind of resources used to parameterize this policy.

If absent, there are no parameters for this policy and the param CEL variable will not be provided to validation expressions. If ParamKind refers to a non-existent kind, this policy definition is mis-configured and the FailurePolicy is applied. If paramKind is specified but paramRef is unset in ValidatingAdmissionPolicyBinding, the params variable will be null.

---

##### `validations`<sup>Optional</sup> <a name="validations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.validations"></a>

```python
validations: typing.List[ValidationV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidationV1Alpha1]

Validations contain CEL expressions which is used to apply the validation.

Validations and AuditAnnotations may not both be empty; a minimum of one Validations or AuditAnnotations is required.

---

##### `variables`<sup>Optional</sup> <a name="variables" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.variables"></a>

```python
variables: typing.List[VariableV1Alpha1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VariableV1Alpha1]

Variables contain definitions of variables that can be used in composition of other expressions.

Each variable is defined as a named CEL expression. The variables defined here will be available under `variables` in other expressions of the policy except MatchConditions because MatchConditions are evaluated before the rest of the policy.

The expression of a variable can refer to other variables defined earlier in the list but not those after. Thus, Variables must be sorted by the order of first appearance and acyclic.

---

### ValidatingAdmissionPolicySpecV1Beta1 <a name="ValidatingAdmissionPolicySpecV1Beta1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1"></a>

ValidatingAdmissionPolicySpec is the specification of the desired behavior of the AdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidatingAdmissionPolicySpecV1Beta1(
  audit_annotations: typing.List[AuditAnnotationV1Beta1] = None,
  failure_policy: str = None,
  match_conditions: typing.List[MatchConditionV1Beta1] = None,
  match_constraints: MatchResourcesV1Beta1 = None,
  param_kind: ParamKindV1Beta1 = None,
  validations: typing.List[ValidationV1Beta1] = None,
  variables: typing.List[VariableV1Beta1] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.auditAnnotations">audit_annotations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.AuditAnnotationV1Beta1]</code> | auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.failurePolicy">failure_policy</a></code> | <code>str</code> | failurePolicy defines how to handle failures for the admission policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConditions">match_conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MatchConditionV1Beta1]</code> | MatchConditions is a list of conditions that must be met for a request to be validated. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConstraints">match_constraints</a></code> | <code>cdk8s_plus_28.k8s.MatchResourcesV1Beta1</code> | MatchConstraints specifies what resources this policy is designed to validate. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.paramKind">param_kind</a></code> | <code>cdk8s_plus_28.k8s.ParamKindV1Beta1</code> | ParamKind specifies the kind of resources used to parameterize this policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.validations">validations</a></code> | <code>typing.List[cdk8s_plus_28.k8s.ValidationV1Beta1]</code> | Validations contain CEL expressions which is used to apply the validation. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.variables">variables</a></code> | <code>typing.List[cdk8s_plus_28.k8s.VariableV1Beta1]</code> | Variables contain definitions of variables that can be used in composition of other expressions. |

---

##### `audit_annotations`<sup>Optional</sup> <a name="audit_annotations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.auditAnnotations"></a>

```python
audit_annotations: typing.List[AuditAnnotationV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.AuditAnnotationV1Beta1]

auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request.

validations and auditAnnotations may not both be empty; a least one of validations or auditAnnotations is required.

---

##### `failure_policy`<sup>Optional</sup> <a name="failure_policy" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.failurePolicy"></a>

```python
failure_policy: str
```

- *Type:* str
- *Default:* Fail.

failurePolicy defines how to handle failures for the admission policy.

Failures can occur from CEL expression parse errors, type check errors, runtime errors and invalid or mis-configured policy definitions or bindings.

A policy is invalid if spec.paramKind refers to a non-existent Kind. A binding is invalid if spec.paramRef.name refers to a non-existent resource.

failurePolicy does not define how validations that evaluate to false are handled.

When failurePolicy is set to Fail, ValidatingAdmissionPolicyBinding validationActions define how failures are enforced.

Allowed values are Ignore or Fail. Defaults to Fail.

---

##### `match_conditions`<sup>Optional</sup> <a name="match_conditions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConditions"></a>

```python
match_conditions: typing.List[MatchConditionV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MatchConditionV1Beta1]

MatchConditions is a list of conditions that must be met for a request to be validated.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

If a parameter object is provided, it can be accessed via the `params` handle in the same manner as validation expressions.

The exact matching logic is (in order):

1. If ANY matchCondition evaluates to FALSE, the policy is skipped.
2. If ALL matchConditions evaluate to TRUE, the policy is evaluated.
3. If any matchCondition evaluates to an error (but none are FALSE):

* If failurePolicy=Fail, reject the request
* If failurePolicy=Ignore, the policy is skipped

---

##### `match_constraints`<sup>Optional</sup> <a name="match_constraints" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConstraints"></a>

```python
match_constraints: MatchResourcesV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.MatchResourcesV1Beta1

MatchConstraints specifies what resources this policy is designed to validate.

The AdmissionPolicy cares about a request if it matches *all* Constraints. However, in order to prevent clusters from being put into an unstable state that cannot be recovered from via the API ValidatingAdmissionPolicy cannot match ValidatingAdmissionPolicy and ValidatingAdmissionPolicyBinding. Required.

---

##### `param_kind`<sup>Optional</sup> <a name="param_kind" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.paramKind"></a>

```python
param_kind: ParamKindV1Beta1
```

- *Type:* cdk8s_plus_28.k8s.ParamKindV1Beta1

ParamKind specifies the kind of resources used to parameterize this policy.

If absent, there are no parameters for this policy and the param CEL variable will not be provided to validation expressions. If ParamKind refers to a non-existent kind, this policy definition is mis-configured and the FailurePolicy is applied. If paramKind is specified but paramRef is unset in ValidatingAdmissionPolicyBinding, the params variable will be null.

---

##### `validations`<sup>Optional</sup> <a name="validations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.validations"></a>

```python
validations: typing.List[ValidationV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.ValidationV1Beta1]

Validations contain CEL expressions which is used to apply the validation.

Validations and AuditAnnotations may not both be empty; a minimum of one Validations or AuditAnnotations is required.

---

##### `variables`<sup>Optional</sup> <a name="variables" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.variables"></a>

```python
variables: typing.List[VariableV1Beta1]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.VariableV1Beta1]

Variables contain definitions of variables that can be used in composition of other expressions.

Each variable is defined as a named CEL expression. The variables defined here will be available under `variables` in other expressions of the policy except MatchConditions because MatchConditions are evaluated before the rest of the policy.

The expression of a variable can refer to other variables defined earlier in the list but not those after. Thus, Variables must be sorted by the order of first appearance and acyclic.

---

### ValidatingWebhook <a name="ValidatingWebhook" id="cdk8s-plus-28.k8s.ValidatingWebhook"></a>

ValidatingWebhook describes an admission webhook and the resources and operations it applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingWebhook.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidatingWebhook(
  admission_review_versions: typing.List[str],
  client_config: WebhookClientConfig,
  name: str,
  side_effects: str,
  failure_policy: str = None,
  match_conditions: typing.List[MatchCondition] = None,
  match_policy: str = None,
  namespace_selector: LabelSelector = None,
  object_selector: LabelSelector = None,
  rules: typing.List[RuleWithOperations] = None,
  timeout_seconds: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.admissionReviewVersions">admission_review_versions</a></code> | <code>typing.List[str]</code> | AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.clientConfig">client_config</a></code> | <code>cdk8s_plus_28.k8s.WebhookClientConfig</code> | ClientConfig defines how to communicate with the hook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.name">name</a></code> | <code>str</code> | The name of the admission webhook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.sideEffects">side_effects</a></code> | <code>str</code> | SideEffects states whether this webhook has side effects. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.failurePolicy">failure_policy</a></code> | <code>str</code> | FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.matchConditions">match_conditions</a></code> | <code>typing.List[cdk8s_plus_28.k8s.MatchCondition]</code> | MatchConditions is a list of conditions that must be met for a request to be sent to this webhook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.matchPolicy">match_policy</a></code> | <code>str</code> | matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.namespaceSelector">namespace_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.objectSelector">object_selector</a></code> | <code>cdk8s_plus_28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the webhook based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.rules">rules</a></code> | <code>typing.List[cdk8s_plus_28.k8s.RuleWithOperations]</code> | Rules describes what operations on what resources/subresources the webhook cares about. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.timeoutSeconds">timeout_seconds</a></code> | <code>typing.Union[int, float]</code> | TimeoutSeconds specifies the timeout for this webhook. |

---

##### `admission_review_versions`<sup>Required</sup> <a name="admission_review_versions" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.admissionReviewVersions"></a>

```python
admission_review_versions: typing.List[str]
```

- *Type:* typing.List[str]

AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects.

API server will try to use first version in the list which it supports. If none of the versions specified in this list supported by API server, validation will fail for this object. If a persisted webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail and be subject to the failure policy.

---

##### `client_config`<sup>Required</sup> <a name="client_config" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.clientConfig"></a>

```python
client_config: WebhookClientConfig
```

- *Type:* cdk8s_plus_28.k8s.WebhookClientConfig

ClientConfig defines how to communicate with the hook.

Required

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the admission webhook.

Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where "imagepolicy" is the name of the webhook, and kubernetes.io is the name of the organization. Required.

---

##### `side_effects`<sup>Required</sup> <a name="side_effects" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.sideEffects"></a>

```python
side_effects: str
```

- *Type:* str

SideEffects states whether this webhook has side effects.

Acceptable values are: None, NoneOnDryRun (webhooks created via v1beta1 may also specify Some or Unknown). Webhooks with side effects MUST implement a reconciliation system, since a request may be rejected by a future step in the admission chain and the side effects therefore need to be undone. Requests with the dryRun attribute will be auto-rejected if they match a webhook with sideEffects == Unknown or Some.

---

##### `failure_policy`<sup>Optional</sup> <a name="failure_policy" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.failurePolicy"></a>

```python
failure_policy: str
```

- *Type:* str
- *Default:* Fail.

FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail.

Defaults to Fail.

---

##### `match_conditions`<sup>Optional</sup> <a name="match_conditions" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.matchConditions"></a>

```python
match_conditions: typing.List[MatchCondition]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.MatchCondition]

MatchConditions is a list of conditions that must be met for a request to be sent to this webhook.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

The exact matching logic is (in order):

1. If ANY matchCondition evaluates to FALSE, the webhook is skipped.
2. If ALL matchConditions evaluate to TRUE, the webhook is called.
3. If any matchCondition evaluates to an error (but none are FALSE):

* If failurePolicy=Fail, reject the request
* If failurePolicy=Ignore, the error is ignored and the webhook is skipped

This is a beta feature and managed by the AdmissionWebhookMatchConditions feature gate.

---

##### `match_policy`<sup>Optional</sup> <a name="match_policy" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.matchPolicy"></a>

```python
match_policy: str
```

- *Type:* str
- *Default:* Equivalent"

matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

* Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the webhook.
* Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the webhook.

Defaults to "Equivalent"

---

##### `namespace_selector`<sup>Optional</sup> <a name="namespace_selector" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.namespaceSelector"></a>

```python
namespace_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the webhook.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the webhook on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `object_selector`<sup>Optional</sup> <a name="object_selector" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.objectSelector"></a>

```python
object_selector: LabelSelector
```

- *Type:* cdk8s_plus_28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the webhook based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the webhook, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.rules"></a>

```python
rules: typing.List[RuleWithOperations]
```

- *Type:* typing.List[cdk8s_plus_28.k8s.RuleWithOperations]

Rules describes what operations on what resources/subresources the webhook cares about.

The webhook cares about an operation if it matches *any* Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.

---

##### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.timeoutSeconds"></a>

```python
timeout_seconds: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* 10 seconds.

TimeoutSeconds specifies the timeout for this webhook.

After the timeout passes, the webhook call will be ignored or the API call will fail based on the failure policy. The timeout value must be between 1 and 30 seconds. Default to 10 seconds.

---

### ValidationRule <a name="ValidationRule" id="cdk8s-plus-28.k8s.ValidationRule"></a>

ValidationRule describes a validation rule written in the CEL expression language.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationRule.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidationRule(
  rule: str,
  field_path: str = None,
  message: str = None,
  message_expression: str = None,
  reason: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.rule">rule</a></code> | <code>str</code> | Rule represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.fieldPath">field_path</a></code> | <code>str</code> | fieldPath represents the field path returned when the validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.message">message</a></code> | <code>str</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.messageExpression">message_expression</a></code> | <code>str</code> | MessageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.reason">reason</a></code> | <code>str</code> | reason provides a machine-readable validation failure reason that is returned to the caller when a request fails this validation rule. |

---

##### `rule`<sup>Required</sup> <a name="rule" id="cdk8s-plus-28.k8s.ValidationRule.property.rule"></a>

```python
rule: str
```

- *Type:* str

Rule represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec The Rule is scoped to the location of the x-kubernetes-validations extension in the schema. The `self` variable in the CEL expression is bound to the scoped value. Example: - Rule scoped to the root of a resource with a status subresource: {"rule": "self.status.actual <= self.spec.maxDesired"}

If the Rule is scoped to an object with properties, the accessible properties of the object are field selectable via `self.field` and field presence can be checked via `has(self.field)`. Null valued fields are treated as absent fields in CEL expressions. If the Rule is scoped to an object with additionalProperties (i.e. a map) the value of the map are accessible via `self[mapKey]`, map containment can be checked via `mapKey in self` and all entries of the map are accessible via CEL macros and functions such as `self.all(...)`. If the Rule is scoped to an array, the elements of the array are accessible via `self[i]` and also by macros and functions. If the Rule is scoped to a scalar, `self` is bound to the scalar value. Examples: - Rule scoped to a map of objects: {"rule": "self.components['Widget'].priority < 10"} - Rule scoped to a list of integers: {"rule": "self.values.all(value, value >= 0 && value < 100)"} - Rule scoped to a string value: {"rule": "self.startsWith('kube')"}

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object and from any x-kubernetes-embedded-resource annotated objects. No other metadata properties are accessible.

Unknown data preserved in custom resources via x-kubernetes-preserve-unknown-fields is not accessible in CEL expressions. This includes: - Unknown field values that are preserved by object schemas with x-kubernetes-preserve-unknown-fields. - Object properties where the property schema is of an "unknown type". An "unknown type" is recursively defined as:

* A schema with no type and x-kubernetes-preserve-unknown-fields set to true
* An array where the items schema is of an "unknown type"
* An object where the additionalProperties schema is of an "unknown type"

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '**' escapes to '**underscores**' - '.' escapes to '**dot**' - '-' escapes to '**dash**' - '/' escapes to '**slash**' - Property names that exactly match a CEL RESERVED keyword escape to '**{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:

* Rule accessing a property named "namespace": {"rule": "self.**namespace** > 0"}
* Rule accessing a property named "x-prop": {"rule": "self.x__dash__prop > 0"}
* Rule accessing a property named "redact__d": {"rule": "self.redact__underscores__d > 0"}

Equality on arrays with x-kubernetes-list-type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:

* 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
  non-intersecting elements in `Y` are appended, retaining their partial order.
* 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
  are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
  non-intersecting keys are appended, retaining their partial order.

---

##### `field_path`<sup>Optional</sup> <a name="field_path" id="cdk8s-plus-28.k8s.ValidationRule.property.fieldPath"></a>

```python
field_path: str
```

- *Type:* str

fieldPath represents the field path returned when the validation fails.

It must be a relative JSON path (i.e. with array notation) scoped to the location of this x-kubernetes-validations extension in the schema and refer to an existing field. e.g. when validation checks if a specific attribute `foo` under a map `testMap`, the fieldPath could be set to `.testMap.foo` If the validation checks two lists must have unique attributes, the fieldPath could be set to either of the list: e.g. `.testList` It does not support list numeric index. It supports child operation to refer to an existing field currently. Refer to [JSONPath support in Kubernetes](https://kubernetes.io/docs/reference/kubectl/jsonpath/) for more info. Numeric index of array is not supported. For field name which contains special characters, use `['specialName']` to refer the field name. e.g. for attribute `foo.34$` appears in a list `testList`, the fieldPath could be set to `.testList['foo.34$']`

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationRule.property.message"></a>

```python
message: str
```

- *Type:* str

Message represents the message displayed when validation fails.

The message is required if the Rule contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host"

---

##### `message_expression`<sup>Optional</sup> <a name="message_expression" id="cdk8s-plus-28.k8s.ValidationRule.property.messageExpression"></a>

```python
message_expression: str
```

- *Type:* str

MessageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a rule, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the rule; the only difference is the return type. Example: "x must be less than max ("+string(self.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationRule.property.reason"></a>

```python
reason: str
```

- *Type:* str

reason provides a machine-readable validation failure reason that is returned to the caller when a request fails this validation rule.

The HTTP status code returned to the caller will match the reason of the reason of the first failed validation rule. The currently supported reasons are: "FieldValueInvalid", "FieldValueForbidden", "FieldValueRequired", "FieldValueDuplicate". If not set, default to use "FieldValueInvalid". All future added reasons must be accepted by clients when reading this value and unknown reasons should be treated as FieldValueInvalid.

---

### ValidationV1Alpha1 <a name="ValidationV1Alpha1" id="cdk8s-plus-28.k8s.ValidationV1Alpha1"></a>

Validation specifies the CEL expression which is used to apply the validation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidationV1Alpha1(
  expression: str,
  message: str = None,
  message_expression: str = None,
  reason: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.expression">expression</a></code> | <code>str</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.message">message</a></code> | <code>str</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.messageExpression">message_expression</a></code> | <code>str</code> | messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.reason">reason</a></code> | <code>str</code> | Reason represents a machine-readable description of why this validation failed. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec CEL expressions have access to the contents of the API request/response, organized into CEL variables as well as some other useful variables:

* 'object' - The object from the incoming request. The value is null for DELETE requests. - 'oldObject' - The existing object. The value is null for CREATE requests. - 'request' - Attributes of the API request([ref](/pkg/apis/admission/types.go#AdmissionRequest)). - 'params' - Parameter resource referred to by the policy binding being evaluated. Only populated if the policy has a ParamKind. - 'namespaceObject' - The namespace object that the incoming object belongs to. The value is null for cluster-scoped resources. - 'variables' - Map of composited variables, from its name to its lazily evaluated value.
  For example, a variable named 'foo' can be accessed as 'variables.foo'.
* 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
  See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
* 'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
  request resource.

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object. No other metadata properties are accessible.

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '**' escapes to '**underscores**' - '.' escapes to '**dot**' - '-' escapes to '**dash**' - '/' escapes to '**slash**' - Property names that exactly match a CEL RESERVED keyword escape to '**{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:

* Expression accessing a property named "namespace": {"Expression": "object.**namespace** > 0"}
* Expression accessing a property named "x-prop": {"Expression": "object.x__dash__prop > 0"}
* Expression accessing a property named "redact__d": {"Expression": "object.redact__underscores__d > 0"}

Equality on arrays with list type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:

* 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
  non-intersecting elements in `Y` are appended, retaining their partial order.
* 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
  are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
  non-intersecting keys are appended, retaining their partial order.
  Required.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.message"></a>

```python
message: str
```

- *Type:* str

Message represents the message displayed when validation fails.

The message is required if the Expression contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host" If the Expression contains line breaks. Message is required. The message must not contain line breaks. If unset, the message is "failed Expression: {Expression}".

---

##### `message_expression`<sup>Optional</sup> <a name="message_expression" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.messageExpression"></a>

```python
message_expression: str
```

- *Type:* str

messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a validation, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the `expression` except for 'authorizer' and 'authorizer.requestResource'. Example: "object.x must be less than max ("+string(params.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.reason"></a>

```python
reason: str
```

- *Type:* str

Reason represents a machine-readable description of why this validation failed.

If this is the first validation in the list to fail, this reason, as well as the corresponding HTTP response code, are used in the HTTP response to the client. The currently supported reasons are: "Unauthorized", "Forbidden", "Invalid", "RequestEntityTooLarge". If not set, StatusReasonInvalid is used in the response to the client.

---

### ValidationV1Beta1 <a name="ValidationV1Beta1" id="cdk8s-plus-28.k8s.ValidationV1Beta1"></a>

Validation specifies the CEL expression which is used to apply the validation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.ValidationV1Beta1(
  expression: str,
  message: str = None,
  message_expression: str = None,
  reason: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.expression">expression</a></code> | <code>str</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.message">message</a></code> | <code>str</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.messageExpression">message_expression</a></code> | <code>str</code> | messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.reason">reason</a></code> | <code>str</code> | Reason represents a machine-readable description of why this validation failed. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec CEL expressions have access to the contents of the API request/response, organized into CEL variables as well as some other useful variables:

* 'object' - The object from the incoming request. The value is null for DELETE requests. - 'oldObject' - The existing object. The value is null for CREATE requests. - 'request' - Attributes of the API request([ref](/pkg/apis/admission/types.go#AdmissionRequest)). - 'params' - Parameter resource referred to by the policy binding being evaluated. Only populated if the policy has a ParamKind. - 'namespaceObject' - The namespace object that the incoming object belongs to. The value is null for cluster-scoped resources. - 'variables' - Map of composited variables, from its name to its lazily evaluated value.
  For example, a variable named 'foo' can be accessed as 'variables.foo'.
* 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
  See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
* 'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
  request resource.

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object. No other metadata properties are accessible.

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '**' escapes to '**underscores**' - '.' escapes to '**dot**' - '-' escapes to '**dash**' - '/' escapes to '**slash**' - Property names that exactly match a CEL RESERVED keyword escape to '**{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:

* Expression accessing a property named "namespace": {"Expression": "object.**namespace** > 0"}
* Expression accessing a property named "x-prop": {"Expression": "object.x__dash__prop > 0"}
* Expression accessing a property named "redact__d": {"Expression": "object.redact__underscores__d > 0"}

Equality on arrays with list type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:

* 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
  non-intersecting elements in `Y` are appended, retaining their partial order.
* 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
  are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
  non-intersecting keys are appended, retaining their partial order.
  Required.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.message"></a>

```python
message: str
```

- *Type:* str

Message represents the message displayed when validation fails.

The message is required if the Expression contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host" If the Expression contains line breaks. Message is required. The message must not contain line breaks. If unset, the message is "failed Expression: {Expression}".

---

##### `message_expression`<sup>Optional</sup> <a name="message_expression" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.messageExpression"></a>

```python
message_expression: str
```

- *Type:* str

messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a validation, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the `expression` except for 'authorizer' and 'authorizer.requestResource'. Example: "object.x must be less than max ("+string(params.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.reason"></a>

```python
reason: str
```

- *Type:* str

Reason represents a machine-readable description of why this validation failed.

If this is the first validation in the list to fail, this reason, as well as the corresponding HTTP response code, are used in the HTTP response to the client. The currently supported reasons are: "Unauthorized", "Forbidden", "Invalid", "RequestEntityTooLarge". If not set, StatusReasonInvalid is used in the response to the client.

---

### VariableV1Alpha1 <a name="VariableV1Alpha1" id="cdk8s-plus-28.k8s.VariableV1Alpha1"></a>

Variable is the definition of a variable that is used for composition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VariableV1Alpha1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VariableV1Alpha1(
  expression: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Alpha1.property.expression">expression</a></code> | <code>str</code> | Expression is the expression that will be evaluated as the value of the variable. |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Alpha1.property.name">name</a></code> | <code>str</code> | Name is the name of the variable. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.VariableV1Alpha1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression is the expression that will be evaluated as the value of the variable.

The CEL expression has access to the same identifiers as the CEL expressions in Validation.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VariableV1Alpha1.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of the variable.

The name must be a valid CEL identifier and unique among all variables. The variable can be accessed in other expressions through `variables` For example, if name is "foo", the variable will be available as `variables.foo`

---

### VariableV1Beta1 <a name="VariableV1Beta1" id="cdk8s-plus-28.k8s.VariableV1Beta1"></a>

Variable is the definition of a variable that is used for composition.

A variable is defined as a named expression.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VariableV1Beta1.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VariableV1Beta1(
  expression: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Beta1.property.expression">expression</a></code> | <code>str</code> | Expression is the expression that will be evaluated as the value of the variable. |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Beta1.property.name">name</a></code> | <code>str</code> | Name is the name of the variable. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.VariableV1Beta1.property.expression"></a>

```python
expression: str
```

- *Type:* str

Expression is the expression that will be evaluated as the value of the variable.

The CEL expression has access to the same identifiers as the CEL expressions in Validation.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VariableV1Beta1.property.name"></a>

```python
name: str
```

- *Type:* str

Name is the name of the variable.

The name must be a valid CEL identifier and unique among all variables. The variable can be accessed in other expressions through `variables` For example, if name is "foo", the variable will be available as `variables.foo`

---

### Volume <a name="Volume" id="cdk8s-plus-28.k8s.Volume"></a>

Volume represents a named volume in a pod that may be accessed by any container in the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Volume.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Volume(
  name: str,
  aws_elastic_block_store: AwsElasticBlockStoreVolumeSource = None,
  azure_disk: AzureDiskVolumeSource = None,
  azure_file: AzureFileVolumeSource = None,
  cephfs: CephFsVolumeSource = None,
  cinder: CinderVolumeSource = None,
  config_map: ConfigMapVolumeSource = None,
  csi: CsiVolumeSource = None,
  downward_api: DownwardApiVolumeSource = None,
  empty_dir: EmptyDirVolumeSource = None,
  ephemeral: EphemeralVolumeSource = None,
  fc: FcVolumeSource = None,
  flex_volume: FlexVolumeSource = None,
  flocker: FlockerVolumeSource = None,
  gce_persistent_disk: GcePersistentDiskVolumeSource = None,
  git_repo: GitRepoVolumeSource = None,
  glusterfs: GlusterfsVolumeSource = None,
  host_path: HostPathVolumeSource = None,
  iscsi: IscsiVolumeSource = None,
  nfs: NfsVolumeSource = None,
  persistent_volume_claim: PersistentVolumeClaimVolumeSource = None,
  photon_persistent_disk: PhotonPersistentDiskVolumeSource = None,
  portworx_volume: PortworxVolumeSource = None,
  projected: ProjectedVolumeSource = None,
  quobyte: QuobyteVolumeSource = None,
  rbd: RbdVolumeSource = None,
  scale_io: ScaleIoVolumeSource = None,
  secret: SecretVolumeSource = None,
  storageos: StorageOsVolumeSource = None,
  vsphere_volume: VsphereVirtualDiskVolumeSource = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.name">name</a></code> | <code>str</code> | name of the volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.awsElasticBlockStore">aws_elastic_block_store</a></code> | <code>cdk8s_plus_28.k8s.AwsElasticBlockStoreVolumeSource</code> | awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.azureDisk">azure_disk</a></code> | <code>cdk8s_plus_28.k8s.AzureDiskVolumeSource</code> | azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.azureFile">azure_file</a></code> | <code>cdk8s_plus_28.k8s.AzureFileVolumeSource</code> | azureFile represents an Azure File Service mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.cephfs">cephfs</a></code> | <code>cdk8s_plus_28.k8s.CephFsVolumeSource</code> | cephFS represents a Ceph FS mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.cinder">cinder</a></code> | <code>cdk8s_plus_28.k8s.CinderVolumeSource</code> | cinder represents a cinder volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.configMap">config_map</a></code> | <code>cdk8s_plus_28.k8s.ConfigMapVolumeSource</code> | configMap represents a configMap that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.csi">csi</a></code> | <code>cdk8s_plus_28.k8s.CsiVolumeSource</code> | csi (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature). |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.downwardApi">downward_api</a></code> | <code>cdk8s_plus_28.k8s.DownwardApiVolumeSource</code> | downwardAPI represents downward API about the pod that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.emptyDir">empty_dir</a></code> | <code>cdk8s_plus_28.k8s.EmptyDirVolumeSource</code> | emptyDir represents a temporary directory that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.ephemeral">ephemeral</a></code> | <code>cdk8s_plus_28.k8s.EphemeralVolumeSource</code> | ephemeral represents a volume that is handled by a cluster storage driver. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.fc">fc</a></code> | <code>cdk8s_plus_28.k8s.FcVolumeSource</code> | fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.flexVolume">flex_volume</a></code> | <code>cdk8s_plus_28.k8s.FlexVolumeSource</code> | flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.flocker">flocker</a></code> | <code>cdk8s_plus_28.k8s.FlockerVolumeSource</code> | flocker represents a Flocker volume attached to a kubelet's host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.gcePersistentDisk">gce_persistent_disk</a></code> | <code>cdk8s_plus_28.k8s.GcePersistentDiskVolumeSource</code> | gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.gitRepo">git_repo</a></code> | <code>cdk8s_plus_28.k8s.GitRepoVolumeSource</code> | gitRepo represents a git repository at a particular revision. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.glusterfs">glusterfs</a></code> | <code>cdk8s_plus_28.k8s.GlusterfsVolumeSource</code> | glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.hostPath">host_path</a></code> | <code>cdk8s_plus_28.k8s.HostPathVolumeSource</code> | hostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.iscsi">iscsi</a></code> | <code>cdk8s_plus_28.k8s.IscsiVolumeSource</code> | iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.nfs">nfs</a></code> | <code>cdk8s_plus_28.k8s.NfsVolumeSource</code> | nfs represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.persistentVolumeClaim">persistent_volume_claim</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeClaimVolumeSource</code> | persistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.photonPersistentDisk">photon_persistent_disk</a></code> | <code>cdk8s_plus_28.k8s.PhotonPersistentDiskVolumeSource</code> | photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.portworxVolume">portworx_volume</a></code> | <code>cdk8s_plus_28.k8s.PortworxVolumeSource</code> | portworxVolume represents a portworx volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.projected">projected</a></code> | <code>cdk8s_plus_28.k8s.ProjectedVolumeSource</code> | projected items for all in one resources secrets, configmaps, and downward API. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.quobyte">quobyte</a></code> | <code>cdk8s_plus_28.k8s.QuobyteVolumeSource</code> | quobyte represents a Quobyte mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.rbd">rbd</a></code> | <code>cdk8s_plus_28.k8s.RbdVolumeSource</code> | rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.scaleIo">scale_io</a></code> | <code>cdk8s_plus_28.k8s.ScaleIoVolumeSource</code> | scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.secret">secret</a></code> | <code>cdk8s_plus_28.k8s.SecretVolumeSource</code> | secret represents a secret that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.storageos">storageos</a></code> | <code>cdk8s_plus_28.k8s.StorageOsVolumeSource</code> | storageOS represents a StorageOS volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.vsphereVolume">vsphere_volume</a></code> | <code>cdk8s_plus_28.k8s.VsphereVirtualDiskVolumeSource</code> | vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Volume.property.name"></a>

```python
name: str
```

- *Type:* str

name of the volume.

Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `aws_elastic_block_store`<sup>Optional</sup> <a name="aws_elastic_block_store" id="cdk8s-plus-28.k8s.Volume.property.awsElasticBlockStore"></a>

```python
aws_elastic_block_store: AwsElasticBlockStoreVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AwsElasticBlockStoreVolumeSource

awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `azure_disk`<sup>Optional</sup> <a name="azure_disk" id="cdk8s-plus-28.k8s.Volume.property.azureDisk"></a>

```python
azure_disk: AzureDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AzureDiskVolumeSource

azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

---

##### `azure_file`<sup>Optional</sup> <a name="azure_file" id="cdk8s-plus-28.k8s.Volume.property.azureFile"></a>

```python
azure_file: AzureFileVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.AzureFileVolumeSource

azureFile represents an Azure File Service mount on the host and bind mount to the pod.

---

##### `cephfs`<sup>Optional</sup> <a name="cephfs" id="cdk8s-plus-28.k8s.Volume.property.cephfs"></a>

```python
cephfs: CephFsVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CephFsVolumeSource

cephFS represents a Ceph FS mount on the host that shares a pod's lifetime.

---

##### `cinder`<sup>Optional</sup> <a name="cinder" id="cdk8s-plus-28.k8s.Volume.property.cinder"></a>

```python
cinder: CinderVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CinderVolumeSource

cinder represents a cinder volume attached and mounted on kubelets host machine.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `config_map`<sup>Optional</sup> <a name="config_map" id="cdk8s-plus-28.k8s.Volume.property.configMap"></a>

```python
config_map: ConfigMapVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.ConfigMapVolumeSource

configMap represents a configMap that should populate this volume.

---

##### `csi`<sup>Optional</sup> <a name="csi" id="cdk8s-plus-28.k8s.Volume.property.csi"></a>

```python
csi: CsiVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.CsiVolumeSource

csi (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).

---

##### `downward_api`<sup>Optional</sup> <a name="downward_api" id="cdk8s-plus-28.k8s.Volume.property.downwardApi"></a>

```python
downward_api: DownwardApiVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.DownwardApiVolumeSource

downwardAPI represents downward API about the pod that should populate this volume.

---

##### `empty_dir`<sup>Optional</sup> <a name="empty_dir" id="cdk8s-plus-28.k8s.Volume.property.emptyDir"></a>

```python
empty_dir: EmptyDirVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.EmptyDirVolumeSource

emptyDir represents a temporary directory that shares a pod's lifetime.

More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

##### `ephemeral`<sup>Optional</sup> <a name="ephemeral" id="cdk8s-plus-28.k8s.Volume.property.ephemeral"></a>

```python
ephemeral: EphemeralVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.EphemeralVolumeSource

ephemeral represents a volume that is handled by a cluster storage driver.

The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.

Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity
tracking are needed,
c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through
a PersistentVolumeClaim (see EphemeralVolumeSource for more
information on the connection between this volume type
and PersistentVolumeClaim).

Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.

Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.

A pod can use both types of ephemeral volumes and persistent volumes at the same time.

---

##### `fc`<sup>Optional</sup> <a name="fc" id="cdk8s-plus-28.k8s.Volume.property.fc"></a>

```python
fc: FcVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FcVolumeSource

fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

---

##### `flex_volume`<sup>Optional</sup> <a name="flex_volume" id="cdk8s-plus-28.k8s.Volume.property.flexVolume"></a>

```python
flex_volume: FlexVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FlexVolumeSource

flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

---

##### `flocker`<sup>Optional</sup> <a name="flocker" id="cdk8s-plus-28.k8s.Volume.property.flocker"></a>

```python
flocker: FlockerVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.FlockerVolumeSource

flocker represents a Flocker volume attached to a kubelet's host machine.

This depends on the Flocker control service being running

---

##### `gce_persistent_disk`<sup>Optional</sup> <a name="gce_persistent_disk" id="cdk8s-plus-28.k8s.Volume.property.gcePersistentDisk"></a>

```python
gce_persistent_disk: GcePersistentDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.GcePersistentDiskVolumeSource

gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `git_repo`<sup>Optional</sup> <a name="git_repo" id="cdk8s-plus-28.k8s.Volume.property.gitRepo"></a>

```python
git_repo: GitRepoVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.GitRepoVolumeSource

gitRepo represents a git repository at a particular revision.

DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.

---

##### `glusterfs`<sup>Optional</sup> <a name="glusterfs" id="cdk8s-plus-28.k8s.Volume.property.glusterfs"></a>

```python
glusterfs: GlusterfsVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.GlusterfsVolumeSource

glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/glusterfs/README.md

---

##### `host_path`<sup>Optional</sup> <a name="host_path" id="cdk8s-plus-28.k8s.Volume.property.hostPath"></a>

```python
host_path: HostPathVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.HostPathVolumeSource

hostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container.

This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `iscsi`<sup>Optional</sup> <a name="iscsi" id="cdk8s-plus-28.k8s.Volume.property.iscsi"></a>

```python
iscsi: IscsiVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.IscsiVolumeSource

iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://examples.k8s.io/volumes/iscsi/README.md

---

##### `nfs`<sup>Optional</sup> <a name="nfs" id="cdk8s-plus-28.k8s.Volume.property.nfs"></a>

```python
nfs: NfsVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.NfsVolumeSource

nfs represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs.

---

##### `persistent_volume_claim`<sup>Optional</sup> <a name="persistent_volume_claim" id="cdk8s-plus-28.k8s.Volume.property.persistentVolumeClaim"></a>

```python
persistent_volume_claim: PersistentVolumeClaimVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeClaimVolumeSource

persistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `photon_persistent_disk`<sup>Optional</sup> <a name="photon_persistent_disk" id="cdk8s-plus-28.k8s.Volume.property.photonPersistentDisk"></a>

```python
photon_persistent_disk: PhotonPersistentDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.PhotonPersistentDiskVolumeSource

photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine.

---

##### `portworx_volume`<sup>Optional</sup> <a name="portworx_volume" id="cdk8s-plus-28.k8s.Volume.property.portworxVolume"></a>

```python
portworx_volume: PortworxVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.PortworxVolumeSource

portworxVolume represents a portworx volume attached and mounted on kubelets host machine.

---

##### `projected`<sup>Optional</sup> <a name="projected" id="cdk8s-plus-28.k8s.Volume.property.projected"></a>

```python
projected: ProjectedVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.ProjectedVolumeSource

projected items for all in one resources secrets, configmaps, and downward API.

---

##### `quobyte`<sup>Optional</sup> <a name="quobyte" id="cdk8s-plus-28.k8s.Volume.property.quobyte"></a>

```python
quobyte: QuobyteVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.QuobyteVolumeSource

quobyte represents a Quobyte mount on the host that shares a pod's lifetime.

---

##### `rbd`<sup>Optional</sup> <a name="rbd" id="cdk8s-plus-28.k8s.Volume.property.rbd"></a>

```python
rbd: RbdVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.RbdVolumeSource

rbd represents a Rados Block Device mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/rbd/README.md

---

##### `scale_io`<sup>Optional</sup> <a name="scale_io" id="cdk8s-plus-28.k8s.Volume.property.scaleIo"></a>

```python
scale_io: ScaleIoVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.ScaleIoVolumeSource

scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.k8s.Volume.property.secret"></a>

```python
secret: SecretVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.SecretVolumeSource

secret represents a secret that should populate this volume.

More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

---

##### `storageos`<sup>Optional</sup> <a name="storageos" id="cdk8s-plus-28.k8s.Volume.property.storageos"></a>

```python
storageos: StorageOsVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.StorageOsVolumeSource

storageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.

---

##### `vsphere_volume`<sup>Optional</sup> <a name="vsphere_volume" id="cdk8s-plus-28.k8s.Volume.property.vsphereVolume"></a>

```python
vsphere_volume: VsphereVirtualDiskVolumeSource
```

- *Type:* cdk8s_plus_28.k8s.VsphereVirtualDiskVolumeSource

vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine.

---

### VolumeAttachmentSource <a name="VolumeAttachmentSource" id="cdk8s-plus-28.k8s.VolumeAttachmentSource"></a>

VolumeAttachmentSource represents a volume that should be attached.

Right now only PersistenVolumes can be attached via external attacher, in future we may allow also inline volumes in pods. Exactly one member can be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeAttachmentSource(
  inline_volume_spec: PersistentVolumeSpec = None,
  persistent_volume_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSource.property.inlineVolumeSpec">inline_volume_spec</a></code> | <code>cdk8s_plus_28.k8s.PersistentVolumeSpec</code> | inlineVolumeSpec contains all the information necessary to attach a persistent volume defined by a pod's inline VolumeSource. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSource.property.persistentVolumeName">persistent_volume_name</a></code> | <code>str</code> | persistentVolumeName represents the name of the persistent volume to attach. |

---

##### `inline_volume_spec`<sup>Optional</sup> <a name="inline_volume_spec" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.property.inlineVolumeSpec"></a>

```python
inline_volume_spec: PersistentVolumeSpec
```

- *Type:* cdk8s_plus_28.k8s.PersistentVolumeSpec

inlineVolumeSpec contains all the information necessary to attach a persistent volume defined by a pod's inline VolumeSource.

This field is populated only for the CSIMigration feature. It contains translated fields from a pod's inline VolumeSource to a PersistentVolumeSpec. This field is beta-level and is only honored by servers that enabled the CSIMigration feature.

---

##### `persistent_volume_name`<sup>Optional</sup> <a name="persistent_volume_name" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.property.persistentVolumeName"></a>

```python
persistent_volume_name: str
```

- *Type:* str

persistentVolumeName represents the name of the persistent volume to attach.

---

### VolumeAttachmentSpec <a name="VolumeAttachmentSpec" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec"></a>

VolumeAttachmentSpec is the specification of a VolumeAttachment request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeAttachmentSpec(
  attacher: str,
  node_name: str,
  source: VolumeAttachmentSource
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.attacher">attacher</a></code> | <code>str</code> | attacher indicates the name of the volume driver that MUST handle this request. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.nodeName">node_name</a></code> | <code>str</code> | nodeName represents the node that the volume should be attached to. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.source">source</a></code> | <code>cdk8s_plus_28.k8s.VolumeAttachmentSource</code> | source represents the volume that should be attached. |

---

##### `attacher`<sup>Required</sup> <a name="attacher" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.attacher"></a>

```python
attacher: str
```

- *Type:* str

attacher indicates the name of the volume driver that MUST handle this request.

This is the name returned by GetPluginName().

---

##### `node_name`<sup>Required</sup> <a name="node_name" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.nodeName"></a>

```python
node_name: str
```

- *Type:* str

nodeName represents the node that the volume should be attached to.

---

##### `source`<sup>Required</sup> <a name="source" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.source"></a>

```python
source: VolumeAttachmentSource
```

- *Type:* cdk8s_plus_28.k8s.VolumeAttachmentSource

source represents the volume that should be attached.

---

### VolumeDevice <a name="VolumeDevice" id="cdk8s-plus-28.k8s.VolumeDevice"></a>

volumeDevice describes a mapping of a raw block device within a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeDevice.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeDevice(
  device_path: str,
  name: str
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeDevice.property.devicePath">device_path</a></code> | <code>str</code> | devicePath is the path inside of the container that the device will be mapped to. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeDevice.property.name">name</a></code> | <code>str</code> | name must match the name of a persistentVolumeClaim in the pod. |

---

##### `device_path`<sup>Required</sup> <a name="device_path" id="cdk8s-plus-28.k8s.VolumeDevice.property.devicePath"></a>

```python
device_path: str
```

- *Type:* str

devicePath is the path inside of the container that the device will be mapped to.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VolumeDevice.property.name"></a>

```python
name: str
```

- *Type:* str

name must match the name of a persistentVolumeClaim in the pod.

---

### VolumeMount <a name="VolumeMount" id="cdk8s-plus-28.VolumeMount"></a>

Mount a volume from the pod to the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.VolumeMount.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.VolumeMount(
  propagation: MountPropagation = None,
  read_only: bool = None,
  sub_path: str = None,
  sub_path_expr: str = None,
  path: str,
  volume: Volume
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.propagation">propagation</a></code> | <code><a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a></code> | Determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.readOnly">read_only</a></code> | <code>bool</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.subPath">sub_path</a></code> | <code>str</code> | Path within the volume from which the container's volume should be mounted.). |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.subPathExpr">sub_path_expr</a></code> | <code>str</code> | Expanded path within the volume from which the container's volume should be mounted. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.path">path</a></code> | <code>str</code> | Path within the container at which the volume should be mounted. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a></code> | The volume to mount. |

---

##### `propagation`<sup>Optional</sup> <a name="propagation" id="cdk8s-plus-28.VolumeMount.property.propagation"></a>

```python
propagation: MountPropagation
```

- *Type:* <a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a>
- *Default:* MountPropagation.NONE

Determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used.

Mount propagation allows for sharing volumes mounted by a Container to
other Containers in the same Pod, or even to other Pods on the same node.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.VolumeMount.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `sub_path`<sup>Optional</sup> <a name="sub_path" id="cdk8s-plus-28.VolumeMount.property.subPath"></a>

```python
sub_path: str
```

- *Type:* str
- *Default:* "" the volume's root

Path within the volume from which the container's volume should be mounted.).

---

##### `sub_path_expr`<sup>Optional</sup> <a name="sub_path_expr" id="cdk8s-plus-28.VolumeMount.property.subPathExpr"></a>

```python
sub_path_expr: str
```

- *Type:* str
- *Default:* "" volume's root.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references
$(VAR_NAME) are expanded using the container's environment. Defaults to ""
(volume's root).

`subPathExpr` and `subPath` are mutually exclusive.

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.VolumeMount.property.path"></a>

```python
path: str
```

- *Type:* str

Path within the container at which the volume should be mounted.

Must not
contain ':'.

---

##### `volume`<sup>Required</sup> <a name="volume" id="cdk8s-plus-28.VolumeMount.property.volume"></a>

```python
volume: Volume
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

The volume to mount.

---

### VolumeMount <a name="VolumeMount" id="cdk8s-plus-28.k8s.VolumeMount"></a>

VolumeMount describes a mounting of a Volume within a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeMount.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeMount(
  mount_path: str,
  name: str,
  mount_propagation: str = None,
  read_only: bool = None,
  sub_path: str = None,
  sub_path_expr: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.mountPath">mount_path</a></code> | <code>str</code> | Path within the container at which the volume should be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.name">name</a></code> | <code>str</code> | This must match the Name of a Volume. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.mountPropagation">mount_propagation</a></code> | <code>str</code> | mountPropagation determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.readOnly">read_only</a></code> | <code>bool</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.subPath">sub_path</a></code> | <code>str</code> | Path within the volume from which the container's volume should be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.subPathExpr">sub_path_expr</a></code> | <code>str</code> | Expanded path within the volume from which the container's volume should be mounted. |

---

##### `mount_path`<sup>Required</sup> <a name="mount_path" id="cdk8s-plus-28.k8s.VolumeMount.property.mountPath"></a>

```python
mount_path: str
```

- *Type:* str

Path within the container at which the volume should be mounted.

Must not contain ':'.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VolumeMount.property.name"></a>

```python
name: str
```

- *Type:* str

This must match the Name of a Volume.

---

##### `mount_propagation`<sup>Optional</sup> <a name="mount_propagation" id="cdk8s-plus-28.k8s.VolumeMount.property.mountPropagation"></a>

```python
mount_propagation: str
```

- *Type:* str

mountPropagation determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used. This field is beta in 1.10.

---

##### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.k8s.VolumeMount.property.readOnly"></a>

```python
read_only: bool
```

- *Type:* bool
- *Default:* false.

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `sub_path`<sup>Optional</sup> <a name="sub_path" id="cdk8s-plus-28.k8s.VolumeMount.property.subPath"></a>

```python
sub_path: str
```

- *Type:* str
- *Default:* volume's root).

Path within the volume from which the container's volume should be mounted.

Defaults to "" (volume's root).

---

##### `sub_path_expr`<sup>Optional</sup> <a name="sub_path_expr" id="cdk8s-plus-28.k8s.VolumeMount.property.subPathExpr"></a>

```python
sub_path_expr: str
```

- *Type:* str
- *Default:* volume's root). SubPathExpr and SubPath are mutually exclusive.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.

---

### VolumeNodeAffinity <a name="VolumeNodeAffinity" id="cdk8s-plus-28.k8s.VolumeNodeAffinity"></a>

VolumeNodeAffinity defines constraints that limit what nodes this volume can be accessed from.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeNodeAffinity.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeNodeAffinity(
  required: NodeSelector = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeNodeAffinity.property.required">required</a></code> | <code>cdk8s_plus_28.k8s.NodeSelector</code> | required specifies hard node constraints that must be met. |

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.k8s.VolumeNodeAffinity.property.required"></a>

```python
required: NodeSelector
```

- *Type:* cdk8s_plus_28.k8s.NodeSelector

required specifies hard node constraints that must be met.

---

### VolumeNodeResources <a name="VolumeNodeResources" id="cdk8s-plus-28.k8s.VolumeNodeResources"></a>

VolumeNodeResources is a set of resource limits for scheduling of volumes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeNodeResources.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeNodeResources(
  count: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeNodeResources.property.count">count</a></code> | <code>typing.Union[int, float]</code> | count indicates the maximum number of unique volumes managed by the CSI driver that can be used on a node. |

---

##### `count`<sup>Optional</sup> <a name="count" id="cdk8s-plus-28.k8s.VolumeNodeResources.property.count"></a>

```python
count: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

count indicates the maximum number of unique volumes managed by the CSI driver that can be used on a node.

A volume that is both attached and mounted on a node is considered to be used once, not twice. The same rule applies for a unique volume that is shared among multiple pods on the same node. If this field is not specified, then the supported number of volumes on this node is unbounded.

---

### VolumeProjection <a name="VolumeProjection" id="cdk8s-plus-28.k8s.VolumeProjection"></a>

Projection that may be projected along with other supported volume types.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeProjection.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VolumeProjection(
  config_map: ConfigMapProjection = None,
  downward_api: DownwardApiProjection = None,
  secret: SecretProjection = None,
  service_account_token: ServiceAccountTokenProjection = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.configMap">config_map</a></code> | <code>cdk8s_plus_28.k8s.ConfigMapProjection</code> | configMap information about the configMap data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.downwardApi">downward_api</a></code> | <code>cdk8s_plus_28.k8s.DownwardApiProjection</code> | downwardAPI information about the downwardAPI data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.secret">secret</a></code> | <code>cdk8s_plus_28.k8s.SecretProjection</code> | secret information about the secret data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.serviceAccountToken">service_account_token</a></code> | <code>cdk8s_plus_28.k8s.ServiceAccountTokenProjection</code> | serviceAccountToken is information about the serviceAccountToken data to project. |

---

##### `config_map`<sup>Optional</sup> <a name="config_map" id="cdk8s-plus-28.k8s.VolumeProjection.property.configMap"></a>

```python
config_map: ConfigMapProjection
```

- *Type:* cdk8s_plus_28.k8s.ConfigMapProjection

configMap information about the configMap data to project.

---

##### `downward_api`<sup>Optional</sup> <a name="downward_api" id="cdk8s-plus-28.k8s.VolumeProjection.property.downwardApi"></a>

```python
downward_api: DownwardApiProjection
```

- *Type:* cdk8s_plus_28.k8s.DownwardApiProjection

downwardAPI information about the downwardAPI data to project.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.k8s.VolumeProjection.property.secret"></a>

```python
secret: SecretProjection
```

- *Type:* cdk8s_plus_28.k8s.SecretProjection

secret information about the secret data to project.

---

##### `service_account_token`<sup>Optional</sup> <a name="service_account_token" id="cdk8s-plus-28.k8s.VolumeProjection.property.serviceAccountToken"></a>

```python
service_account_token: ServiceAccountTokenProjection
```

- *Type:* cdk8s_plus_28.k8s.ServiceAccountTokenProjection

serviceAccountToken is information about the serviceAccountToken data to project.

---

### VsphereVirtualDiskVolumeSource <a name="VsphereVirtualDiskVolumeSource" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource"></a>

Represents a vSphere volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.VsphereVirtualDiskVolumeSource(
  volume_path: str,
  fs_type: str = None,
  storage_policy_id: str = None,
  storage_policy_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.volumePath">volume_path</a></code> | <code>str</code> | volumePath is the path that identifies vSphere volume vmdk. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.fsType">fs_type</a></code> | <code>str</code> | fsType is filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyId">storage_policy_id</a></code> | <code>str</code> | storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyName">storage_policy_name</a></code> | <code>str</code> | storagePolicyName is the storage Policy Based Management (SPBM) profile name. |

---

##### `volume_path`<sup>Required</sup> <a name="volume_path" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.volumePath"></a>

```python
volume_path: str
```

- *Type:* str

volumePath is the path that identifies vSphere volume vmdk.

---

##### `fs_type`<sup>Optional</sup> <a name="fs_type" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.fsType"></a>

```python
fs_type: str
```

- *Type:* str

fsType is filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `storage_policy_id`<sup>Optional</sup> <a name="storage_policy_id" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyId"></a>

```python
storage_policy_id: str
```

- *Type:* str

storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.

---

##### `storage_policy_name`<sup>Optional</sup> <a name="storage_policy_name" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyName"></a>

```python
storage_policy_name: str
```

- *Type:* str

storagePolicyName is the storage Policy Based Management (SPBM) profile name.

---

### WebhookClientConfig <a name="WebhookClientConfig" id="cdk8s-plus-28.k8s.WebhookClientConfig"></a>

WebhookClientConfig contains the information to make a TLS connection with the webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WebhookClientConfig.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.WebhookClientConfig(
  ca_bundle: str = None,
  service: ServiceReference = None,
  url: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.caBundle">ca_bundle</a></code> | <code>str</code> | `caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.service">service</a></code> | <code>cdk8s_plus_28.k8s.ServiceReference</code> | `service` is a reference to the service for this webhook. Either `service` or `url` must be specified. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.url">url</a></code> | <code>str</code> | `url` gives the location of the webhook, in standard URL form (`scheme://host:port/path`). |

---

##### `ca_bundle`<sup>Optional</sup> <a name="ca_bundle" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.caBundle"></a>

```python
ca_bundle: str
```

- *Type:* str

`caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate.

If unspecified, system trust roots on the apiserver are used.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.service"></a>

```python
service: ServiceReference
```

- *Type:* cdk8s_plus_28.k8s.ServiceReference

`service` is a reference to the service for this webhook. Either `service` or `url` must be specified.

If the webhook is running within the cluster, then you should use `service`.

---

##### `url`<sup>Optional</sup> <a name="url" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.url"></a>

```python
url: str
```

- *Type:* str

`url` gives the location of the webhook, in standard URL form (`scheme://host:port/path`).

Exactly one of `url` or `service` must be specified.

The `host` should not refer to a service running in the cluster; use the `service` field instead. The host might be resolved via external DNS in some apiservers (e.g., `kube-apiserver` cannot resolve in-cluster DNS as that would be a layering violation). `host` may also be an IP address.

Please note that using `localhost` or `127.0.0.1` as a `host` is risky unless you take great care to run this webhook on all hosts which run an apiserver which might need to make calls to this webhook. Such installs are likely to be non-portable, i.e., not easy to turn up in a new cluster.

The scheme must be "https"; the URL must begin with "https://".

A path is optional, and if present may be any string permissible in a URL. You may use the path to pass an arbitrary string to the webhook, for example, a cluster identifier.

Attempting to use a user or basic auth e.g. "user:password@" is not allowed. Fragments ("#...") and query parameters ("?...") are not allowed, either.

---

### WebhookConversion <a name="WebhookConversion" id="cdk8s-plus-28.k8s.WebhookConversion"></a>

WebhookConversion describes how to call a conversion webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WebhookConversion.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.WebhookConversion(
  conversion_review_versions: typing.List[str],
  client_config: WebhookClientConfig = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WebhookConversion.property.conversionReviewVersions">conversion_review_versions</a></code> | <code>typing.List[str]</code> | conversionReviewVersions is an ordered list of preferred `ConversionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookConversion.property.clientConfig">client_config</a></code> | <code>cdk8s_plus_28.k8s.WebhookClientConfig</code> | clientConfig is the instructions for how to call the webhook if strategy is `Webhook`. |

---

##### `conversion_review_versions`<sup>Required</sup> <a name="conversion_review_versions" id="cdk8s-plus-28.k8s.WebhookConversion.property.conversionReviewVersions"></a>

```python
conversion_review_versions: typing.List[str]
```

- *Type:* typing.List[str]

conversionReviewVersions is an ordered list of preferred `ConversionReview` versions the Webhook expects.

The API server will use the first version in the list which it supports. If none of the versions specified in this list are supported by API server, conversion will fail for the custom resource. If a persisted Webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail.

---

##### `client_config`<sup>Optional</sup> <a name="client_config" id="cdk8s-plus-28.k8s.WebhookConversion.property.clientConfig"></a>

```python
client_config: WebhookClientConfig
```

- *Type:* cdk8s_plus_28.k8s.WebhookClientConfig

clientConfig is the instructions for how to call the webhook if strategy is `Webhook`.

---

### WeightedPodAffinityTerm <a name="WeightedPodAffinityTerm" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm"></a>

The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.WeightedPodAffinityTerm(
  pod_affinity_term: PodAffinityTerm,
  weight: typing.Union[int, float]
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.podAffinityTerm">pod_affinity_term</a></code> | <code>cdk8s_plus_28.k8s.PodAffinityTerm</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | weight associated with matching the corresponding podAffinityTerm, in the range 1-100. |

---

##### `pod_affinity_term`<sup>Required</sup> <a name="pod_affinity_term" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.podAffinityTerm"></a>

```python
pod_affinity_term: PodAffinityTerm
```

- *Type:* cdk8s_plus_28.k8s.PodAffinityTerm

Required.

A pod affinity term, associated with the corresponding weight.

---

##### `weight`<sup>Required</sup> <a name="weight" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

weight associated with matching the corresponding podAffinityTerm, in the range 1-100.

---

### WindowsSecurityContextOptions <a name="WindowsSecurityContextOptions" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions"></a>

WindowsSecurityContextOptions contain Windows-specific options and credentials.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.Initializer"></a>

```python
from cdk8s_plus_28 import k8s

k8s.WindowsSecurityContextOptions(
  gmsa_credential_spec: str = None,
  gmsa_credential_spec_name: str = None,
  host_process: bool = None,
  run_as_user_name: str = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpec">gmsa_credential_spec</a></code> | <code>str</code> | GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpecName">gmsa_credential_spec_name</a></code> | <code>str</code> | GMSACredentialSpecName is the name of the GMSA credential spec to use. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.hostProcess">host_process</a></code> | <code>bool</code> | HostProcess determines if a container should be run as a 'Host Process' container. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.runAsUserName">run_as_user_name</a></code> | <code>str</code> | The UserName in Windows to run the entrypoint of the container process. |

---

##### `gmsa_credential_spec`<sup>Optional</sup> <a name="gmsa_credential_spec" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpec"></a>

```python
gmsa_credential_spec: str
```

- *Type:* str

GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.

---

##### `gmsa_credential_spec_name`<sup>Optional</sup> <a name="gmsa_credential_spec_name" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpecName"></a>

```python
gmsa_credential_spec_name: str
```

- *Type:* str

GMSACredentialSpecName is the name of the GMSA credential spec to use.

---

##### `host_process`<sup>Optional</sup> <a name="host_process" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.hostProcess"></a>

```python
host_process: bool
```

- *Type:* bool

HostProcess determines if a container should be run as a 'Host Process' container.

All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers). In addition, if HostProcess is true then HostNetwork must also be set to true.

---

##### `run_as_user_name`<sup>Optional</sup> <a name="run_as_user_name" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.runAsUserName"></a>

```python
run_as_user_name: str
```

- *Type:* str
- *Default:* the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

The UserName in Windows to run the entrypoint of the container process.

Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

### WorkloadProps <a name="WorkloadProps" id="cdk8s-plus-28.WorkloadProps"></a>

Properties for `Workload`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.WorkloadProps.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.WorkloadProps(
  metadata: ApiObjectMetadata = None,
  automount_service_account_token: bool = None,
  containers: typing.List[ContainerProps] = None,
  dns: PodDnsProps = None,
  docker_registry_auth: ISecret = None,
  host_aliases: typing.List[HostAlias] = None,
  host_network: bool = None,
  init_containers: typing.List[ContainerProps] = None,
  isolate: bool = None,
  restart_policy: RestartPolicy = None,
  security_context: PodSecurityContextProps = None,
  service_account: IServiceAccount = None,
  termination_grace_period: Duration = None,
  volumes: typing.List[Volume] = None,
  pod_metadata: ApiObjectMetadata = None,
  select: bool = None,
  spread: bool = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.automountServiceAccountToken">automount_service_account_token</a></code> | <code>bool</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.containers">containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.dockerRegistryAuth">docker_registry_auth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.hostAliases">host_aliases</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.hostNetwork">host_network</a></code> | <code>bool</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.initContainers">init_containers</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.isolate">isolate</a></code> | <code>bool</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.serviceAccount">service_account</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.terminationGracePeriod">termination_grace_period</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.volumes">volumes</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.podMetadata">pod_metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.select">select</a></code> | <code>bool</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.spread">spread</a></code> | <code>bool</code> | Automatically spread pods across hostname and zones. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.WorkloadProps.property.metadata"></a>

```python
metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automount_service_account_token`<sup>Optional</sup> <a name="automount_service_account_token" id="cdk8s-plus-28.WorkloadProps.property.automountServiceAccountToken"></a>

```python
automount_service_account_token: bool
```

- *Type:* bool
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.WorkloadProps.property.containers"></a>

```python
containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.WorkloadProps.property.dns"></a>

```python
dns: PodDnsProps
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `docker_registry_auth`<sup>Optional</sup> <a name="docker_registry_auth" id="cdk8s-plus-28.WorkloadProps.property.dockerRegistryAuth"></a>

```python
docker_registry_auth: ISecret
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `host_aliases`<sup>Optional</sup> <a name="host_aliases" id="cdk8s-plus-28.WorkloadProps.property.hostAliases"></a>

```python
host_aliases: typing.List[HostAlias]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.HostAlias">HostAlias</a>]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `host_network`<sup>Optional</sup> <a name="host_network" id="cdk8s-plus-28.WorkloadProps.property.hostNetwork"></a>

```python
host_network: bool
```

- *Type:* bool
- *Default:* false

Host network for the pod.

---

##### `init_containers`<sup>Optional</sup> <a name="init_containers" id="cdk8s-plus-28.WorkloadProps.property.initContainers"></a>

```python
init_containers: typing.List[ContainerProps]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.WorkloadProps.property.isolate"></a>

```python
isolate: bool
```

- *Type:* bool
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.WorkloadProps.property.restartPolicy"></a>

```python
restart_policy: RestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.WorkloadProps.property.securityContext"></a>

```python
security_context: PodSecurityContextProps
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `service_account`<sup>Optional</sup> <a name="service_account" id="cdk8s-plus-28.WorkloadProps.property.serviceAccount"></a>

```python
service_account: IServiceAccount
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `termination_grace_period`<sup>Optional</sup> <a name="termination_grace_period" id="cdk8s-plus-28.WorkloadProps.property.terminationGracePeriod"></a>

```python
termination_grace_period: Duration
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.WorkloadProps.property.volumes"></a>

```python
volumes: typing.List[Volume]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Volume">Volume</a>]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `pod_metadata`<sup>Optional</sup> <a name="pod_metadata" id="cdk8s-plus-28.WorkloadProps.property.podMetadata"></a>

```python
pod_metadata: ApiObjectMetadata
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.WorkloadProps.property.select"></a>

```python
select: bool
```

- *Type:* bool
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.WorkloadProps.property.spread"></a>

```python
spread: bool
```

- *Type:* bool
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

### WorkloadSchedulingSpreadOptions <a name="WorkloadSchedulingSpreadOptions" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions"></a>

Options for `WorkloadScheduling.spread`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.WorkloadSchedulingSpreadOptions(
  topology: Topology = None,
  weight: typing.Union[int, float] = None
)
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to spread on. |
| <code><a href="#cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.weight">weight</a></code> | <code>typing.Union[int, float]</code> | Indicates the spread is optional, with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.topology"></a>

```python
topology: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to spread on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.weight"></a>

```python
weight: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]
- *Default:* no weight. spread is assumed to be required.

Indicates the spread is optional, with this weight score.

---

## Classes <a name="Classes" id="Classes"></a>

### ApiResource <a name="ApiResource" id="cdk8s-plus-28.ApiResource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Represents information about an API resource type.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ApiResource.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |

---

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.ApiResource.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.ApiResource.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.custom">custom</a></code> | API resource information for a custom resource type. |

---

##### `custom` <a name="custom" id="cdk8s-plus-28.ApiResource.custom"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ApiResource.custom(
  api_group: str,
  resource_type: str
)
```

API resource information for a custom resource type.

###### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ApiResource.custom.parameter.apiGroup"></a>

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

###### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ApiResource.custom.parameter.resourceType"></a>

- *Type:* str

The name of the resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ApiResource.property.resourceType">resource_type</a></code> | <code>str</code> | The name of the resource type as it appears in the relevant API endpoint. |

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ApiResource.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ApiResource.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of the resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.property.API_SERVICES">API_SERVICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for APIService. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.BINDINGS">BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Binding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CERTIFICATE_SIGNING_REQUESTS">CERTIFICATE_SIGNING_REQUESTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CLUSTER_ROLE_BINDINGS">CLUSTER_ROLE_BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ClusterRoleBinding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CLUSTER_ROLES">CLUSTER_ROLES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ClusterRole. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.COMPONENT_STATUSES">COMPONENT_STATUSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ComponentStatus. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CONFIG_MAPS">CONFIG_MAPS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ConfigMap. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CONTROLLER_REVISIONS">CONTROLLER_REVISIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ControllerRevision. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CRON_JOBS">CRON_JOBS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CronJob. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_DRIVERS">CSI_DRIVERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSIDriver. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_NODES">CSI_NODES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSINode. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_STORAGE_CAPACITIES">CSI_STORAGE_CAPACITIES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSIStorageCapacity. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CUSTOM_RESOURCE_DEFINITIONS">CUSTOM_RESOURCE_DEFINITIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CustomResourceDefinition. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.DAEMON_SETS">DAEMON_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for DaemonSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.DEPLOYMENTS">DEPLOYMENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Deployment. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ENDPOINT_SLICES">ENDPOINT_SLICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for EndpointSlice. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ENDPOINTS">ENDPOINTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Endpoints. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.EVENTS">EVENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Event. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.FLOW_SCHEMAS">FLOW_SCHEMAS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for FlowSchema. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.HORIZONTAL_POD_AUTOSCALERS">HORIZONTAL_POD_AUTOSCALERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for HorizontalPodAutoscaler. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.INGRESS_CLASSES">INGRESS_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for IngressClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.INGRESSES">INGRESSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Ingress. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.JOBS">JOBS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Job. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LEASES">LEASES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Lease. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LIMIT_RANGES">LIMIT_RANGES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for LimitRange. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LOCAL_SUBJECT_ACCESS_REVIEWS">LOCAL_SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for LocalSubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.MUTATING_WEBHOOK_CONFIGURATIONS">MUTATING_WEBHOOK_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for MutatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NAMESPACES">NAMESPACES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Namespace. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NETWORK_POLICIES">NETWORK_POLICIES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for NetworkPolicy. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NODES">NODES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Node. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUME_CLAIMS">PERSISTENT_VOLUME_CLAIMS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUMES">PERSISTENT_VOLUMES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PersistentVolume. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.POD_DISRUPTION_BUDGETS">POD_DISRUPTION_BUDGETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PodDisruptionBudget. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.POD_TEMPLATES">POD_TEMPLATES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PodTemplate. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PODS">PODS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Pod. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PRIORITY_CLASSES">PRIORITY_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PriorityClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PRIORITY_LEVEL_CONFIGURATIONS">PRIORITY_LEVEL_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PriorityLevelConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.REPLICA_SETS">REPLICA_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ReplicaSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.REPLICATION_CONTROLLERS">REPLICATION_CONTROLLERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ReplicationController. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.RESOURCE_QUOTAS">RESOURCE_QUOTAS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ResourceQuota. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ROLE_BINDINGS">ROLE_BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for RoleBinding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ROLES">ROLES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Role. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.RUNTIME_CLASSES">RUNTIME_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for RuntimeClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SECRETS">SECRETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Secret. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_ACCESS_REVIEWS">SELF_SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SelfSubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_RULES_REVIEWS">SELF_SUBJECT_RULES_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SelfSubjectRulesReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SERVICE_ACCOUNTS">SERVICE_ACCOUNTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ServiceAccount. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SERVICES">SERVICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Service. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.STATEFUL_SETS">STATEFUL_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for StatefulSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.STORAGE_CLASSES">STORAGE_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for StorageClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SUBJECT_ACCESS_REVIEWS">SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.TOKEN_REVIEWS">TOKEN_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for TokenReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.VALIDATING_WEBHOOK_CONFIGURATIONS">VALIDATING_WEBHOOK_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ValidatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.VOLUME_ATTACHMENTS">VOLUME_ATTACHMENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for VolumeAttachment. |

---

##### `API_SERVICES`<sup>Required</sup> <a name="API_SERVICES" id="cdk8s-plus-28.ApiResource.property.API_SERVICES"></a>

```python
API_SERVICES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for APIService.

---

##### `BINDINGS`<sup>Required</sup> <a name="BINDINGS" id="cdk8s-plus-28.ApiResource.property.BINDINGS"></a>

```python
BINDINGS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Binding.

---

##### `CERTIFICATE_SIGNING_REQUESTS`<sup>Required</sup> <a name="CERTIFICATE_SIGNING_REQUESTS" id="cdk8s-plus-28.ApiResource.property.CERTIFICATE_SIGNING_REQUESTS"></a>

```python
CERTIFICATE_SIGNING_REQUESTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CertificateSigningRequest.

---

##### `CLUSTER_ROLE_BINDINGS`<sup>Required</sup> <a name="CLUSTER_ROLE_BINDINGS" id="cdk8s-plus-28.ApiResource.property.CLUSTER_ROLE_BINDINGS"></a>

```python
CLUSTER_ROLE_BINDINGS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ClusterRoleBinding.

---

##### `CLUSTER_ROLES`<sup>Required</sup> <a name="CLUSTER_ROLES" id="cdk8s-plus-28.ApiResource.property.CLUSTER_ROLES"></a>

```python
CLUSTER_ROLES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ClusterRole.

---

##### `COMPONENT_STATUSES`<sup>Required</sup> <a name="COMPONENT_STATUSES" id="cdk8s-plus-28.ApiResource.property.COMPONENT_STATUSES"></a>

```python
COMPONENT_STATUSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ComponentStatus.

---

##### `CONFIG_MAPS`<sup>Required</sup> <a name="CONFIG_MAPS" id="cdk8s-plus-28.ApiResource.property.CONFIG_MAPS"></a>

```python
CONFIG_MAPS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ConfigMap.

---

##### `CONTROLLER_REVISIONS`<sup>Required</sup> <a name="CONTROLLER_REVISIONS" id="cdk8s-plus-28.ApiResource.property.CONTROLLER_REVISIONS"></a>

```python
CONTROLLER_REVISIONS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ControllerRevision.

---

##### `CRON_JOBS`<sup>Required</sup> <a name="CRON_JOBS" id="cdk8s-plus-28.ApiResource.property.CRON_JOBS"></a>

```python
CRON_JOBS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CronJob.

---

##### `CSI_DRIVERS`<sup>Required</sup> <a name="CSI_DRIVERS" id="cdk8s-plus-28.ApiResource.property.CSI_DRIVERS"></a>

```python
CSI_DRIVERS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSIDriver.

---

##### `CSI_NODES`<sup>Required</sup> <a name="CSI_NODES" id="cdk8s-plus-28.ApiResource.property.CSI_NODES"></a>

```python
CSI_NODES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSINode.

---

##### `CSI_STORAGE_CAPACITIES`<sup>Required</sup> <a name="CSI_STORAGE_CAPACITIES" id="cdk8s-plus-28.ApiResource.property.CSI_STORAGE_CAPACITIES"></a>

```python
CSI_STORAGE_CAPACITIES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSIStorageCapacity.

---

##### `CUSTOM_RESOURCE_DEFINITIONS`<sup>Required</sup> <a name="CUSTOM_RESOURCE_DEFINITIONS" id="cdk8s-plus-28.ApiResource.property.CUSTOM_RESOURCE_DEFINITIONS"></a>

```python
CUSTOM_RESOURCE_DEFINITIONS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CustomResourceDefinition.

---

##### `DAEMON_SETS`<sup>Required</sup> <a name="DAEMON_SETS" id="cdk8s-plus-28.ApiResource.property.DAEMON_SETS"></a>

```python
DAEMON_SETS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for DaemonSet.

---

##### `DEPLOYMENTS`<sup>Required</sup> <a name="DEPLOYMENTS" id="cdk8s-plus-28.ApiResource.property.DEPLOYMENTS"></a>

```python
DEPLOYMENTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Deployment.

---

##### `ENDPOINT_SLICES`<sup>Required</sup> <a name="ENDPOINT_SLICES" id="cdk8s-plus-28.ApiResource.property.ENDPOINT_SLICES"></a>

```python
ENDPOINT_SLICES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for EndpointSlice.

---

##### `ENDPOINTS`<sup>Required</sup> <a name="ENDPOINTS" id="cdk8s-plus-28.ApiResource.property.ENDPOINTS"></a>

```python
ENDPOINTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Endpoints.

---

##### `EVENTS`<sup>Required</sup> <a name="EVENTS" id="cdk8s-plus-28.ApiResource.property.EVENTS"></a>

```python
EVENTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Event.

---

##### `FLOW_SCHEMAS`<sup>Required</sup> <a name="FLOW_SCHEMAS" id="cdk8s-plus-28.ApiResource.property.FLOW_SCHEMAS"></a>

```python
FLOW_SCHEMAS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for FlowSchema.

---

##### `HORIZONTAL_POD_AUTOSCALERS`<sup>Required</sup> <a name="HORIZONTAL_POD_AUTOSCALERS" id="cdk8s-plus-28.ApiResource.property.HORIZONTAL_POD_AUTOSCALERS"></a>

```python
HORIZONTAL_POD_AUTOSCALERS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for HorizontalPodAutoscaler.

---

##### `INGRESS_CLASSES`<sup>Required</sup> <a name="INGRESS_CLASSES" id="cdk8s-plus-28.ApiResource.property.INGRESS_CLASSES"></a>

```python
INGRESS_CLASSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for IngressClass.

---

##### `INGRESSES`<sup>Required</sup> <a name="INGRESSES" id="cdk8s-plus-28.ApiResource.property.INGRESSES"></a>

```python
INGRESSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Ingress.

---

##### `JOBS`<sup>Required</sup> <a name="JOBS" id="cdk8s-plus-28.ApiResource.property.JOBS"></a>

```python
JOBS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Job.

---

##### `LEASES`<sup>Required</sup> <a name="LEASES" id="cdk8s-plus-28.ApiResource.property.LEASES"></a>

```python
LEASES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Lease.

---

##### `LIMIT_RANGES`<sup>Required</sup> <a name="LIMIT_RANGES" id="cdk8s-plus-28.ApiResource.property.LIMIT_RANGES"></a>

```python
LIMIT_RANGES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for LimitRange.

---

##### `LOCAL_SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="LOCAL_SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.LOCAL_SUBJECT_ACCESS_REVIEWS"></a>

```python
LOCAL_SUBJECT_ACCESS_REVIEWS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for LocalSubjectAccessReview.

---

##### `MUTATING_WEBHOOK_CONFIGURATIONS`<sup>Required</sup> <a name="MUTATING_WEBHOOK_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.MUTATING_WEBHOOK_CONFIGURATIONS"></a>

```python
MUTATING_WEBHOOK_CONFIGURATIONS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for MutatingWebhookConfiguration.

---

##### `NAMESPACES`<sup>Required</sup> <a name="NAMESPACES" id="cdk8s-plus-28.ApiResource.property.NAMESPACES"></a>

```python
NAMESPACES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Namespace.

---

##### `NETWORK_POLICIES`<sup>Required</sup> <a name="NETWORK_POLICIES" id="cdk8s-plus-28.ApiResource.property.NETWORK_POLICIES"></a>

```python
NETWORK_POLICIES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for NetworkPolicy.

---

##### `NODES`<sup>Required</sup> <a name="NODES" id="cdk8s-plus-28.ApiResource.property.NODES"></a>

```python
NODES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Node.

---

##### `PERSISTENT_VOLUME_CLAIMS`<sup>Required</sup> <a name="PERSISTENT_VOLUME_CLAIMS" id="cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUME_CLAIMS"></a>

```python
PERSISTENT_VOLUME_CLAIMS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PersistentVolumeClaim.

---

##### `PERSISTENT_VOLUMES`<sup>Required</sup> <a name="PERSISTENT_VOLUMES" id="cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUMES"></a>

```python
PERSISTENT_VOLUMES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PersistentVolume.

---

##### `POD_DISRUPTION_BUDGETS`<sup>Required</sup> <a name="POD_DISRUPTION_BUDGETS" id="cdk8s-plus-28.ApiResource.property.POD_DISRUPTION_BUDGETS"></a>

```python
POD_DISRUPTION_BUDGETS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PodDisruptionBudget.

---

##### `POD_TEMPLATES`<sup>Required</sup> <a name="POD_TEMPLATES" id="cdk8s-plus-28.ApiResource.property.POD_TEMPLATES"></a>

```python
POD_TEMPLATES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PodTemplate.

---

##### `PODS`<sup>Required</sup> <a name="PODS" id="cdk8s-plus-28.ApiResource.property.PODS"></a>

```python
PODS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Pod.

---

##### `PRIORITY_CLASSES`<sup>Required</sup> <a name="PRIORITY_CLASSES" id="cdk8s-plus-28.ApiResource.property.PRIORITY_CLASSES"></a>

```python
PRIORITY_CLASSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PriorityClass.

---

##### `PRIORITY_LEVEL_CONFIGURATIONS`<sup>Required</sup> <a name="PRIORITY_LEVEL_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.PRIORITY_LEVEL_CONFIGURATIONS"></a>

```python
PRIORITY_LEVEL_CONFIGURATIONS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PriorityLevelConfiguration.

---

##### `REPLICA_SETS`<sup>Required</sup> <a name="REPLICA_SETS" id="cdk8s-plus-28.ApiResource.property.REPLICA_SETS"></a>

```python
REPLICA_SETS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ReplicaSet.

---

##### `REPLICATION_CONTROLLERS`<sup>Required</sup> <a name="REPLICATION_CONTROLLERS" id="cdk8s-plus-28.ApiResource.property.REPLICATION_CONTROLLERS"></a>

```python
REPLICATION_CONTROLLERS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ReplicationController.

---

##### `RESOURCE_QUOTAS`<sup>Required</sup> <a name="RESOURCE_QUOTAS" id="cdk8s-plus-28.ApiResource.property.RESOURCE_QUOTAS"></a>

```python
RESOURCE_QUOTAS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ResourceQuota.

---

##### `ROLE_BINDINGS`<sup>Required</sup> <a name="ROLE_BINDINGS" id="cdk8s-plus-28.ApiResource.property.ROLE_BINDINGS"></a>

```python
ROLE_BINDINGS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for RoleBinding.

---

##### `ROLES`<sup>Required</sup> <a name="ROLES" id="cdk8s-plus-28.ApiResource.property.ROLES"></a>

```python
ROLES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Role.

---

##### `RUNTIME_CLASSES`<sup>Required</sup> <a name="RUNTIME_CLASSES" id="cdk8s-plus-28.ApiResource.property.RUNTIME_CLASSES"></a>

```python
RUNTIME_CLASSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for RuntimeClass.

---

##### `SECRETS`<sup>Required</sup> <a name="SECRETS" id="cdk8s-plus-28.ApiResource.property.SECRETS"></a>

```python
SECRETS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Secret.

---

##### `SELF_SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="SELF_SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_ACCESS_REVIEWS"></a>

```python
SELF_SUBJECT_ACCESS_REVIEWS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SelfSubjectAccessReview.

---

##### `SELF_SUBJECT_RULES_REVIEWS`<sup>Required</sup> <a name="SELF_SUBJECT_RULES_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_RULES_REVIEWS"></a>

```python
SELF_SUBJECT_RULES_REVIEWS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SelfSubjectRulesReview.

---

##### `SERVICE_ACCOUNTS`<sup>Required</sup> <a name="SERVICE_ACCOUNTS" id="cdk8s-plus-28.ApiResource.property.SERVICE_ACCOUNTS"></a>

```python
SERVICE_ACCOUNTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ServiceAccount.

---

##### `SERVICES`<sup>Required</sup> <a name="SERVICES" id="cdk8s-plus-28.ApiResource.property.SERVICES"></a>

```python
SERVICES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Service.

---

##### `STATEFUL_SETS`<sup>Required</sup> <a name="STATEFUL_SETS" id="cdk8s-plus-28.ApiResource.property.STATEFUL_SETS"></a>

```python
STATEFUL_SETS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for StatefulSet.

---

##### `STORAGE_CLASSES`<sup>Required</sup> <a name="STORAGE_CLASSES" id="cdk8s-plus-28.ApiResource.property.STORAGE_CLASSES"></a>

```python
STORAGE_CLASSES: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for StorageClass.

---

##### `SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SUBJECT_ACCESS_REVIEWS"></a>

```python
SUBJECT_ACCESS_REVIEWS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SubjectAccessReview.

---

##### `TOKEN_REVIEWS`<sup>Required</sup> <a name="TOKEN_REVIEWS" id="cdk8s-plus-28.ApiResource.property.TOKEN_REVIEWS"></a>

```python
TOKEN_REVIEWS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for TokenReview.

---

##### `VALIDATING_WEBHOOK_CONFIGURATIONS`<sup>Required</sup> <a name="VALIDATING_WEBHOOK_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.VALIDATING_WEBHOOK_CONFIGURATIONS"></a>

```python
VALIDATING_WEBHOOK_CONFIGURATIONS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ValidatingWebhookConfiguration.

---

##### `VOLUME_ATTACHMENTS`<sup>Required</sup> <a name="VOLUME_ATTACHMENTS" id="cdk8s-plus-28.ApiResource.property.VOLUME_ATTACHMENTS"></a>

```python
VOLUME_ATTACHMENTS: ApiResource
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for VolumeAttachment.

---

### Container <a name="Container" id="cdk8s-plus-28.Container"></a>

A single application container that you want to run within a pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Container.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Container(
  args: typing.List[str] = None,
  command: typing.List[str] = None,
  env_from: typing.List[EnvFrom] = None,
  env_variables: typing.Mapping[EnvValue] = None,
  image_pull_policy: ImagePullPolicy = None,
  lifecycle: ContainerLifecycle = None,
  liveness: Probe = None,
  name: str = None,
  port: typing.Union[int, float] = None,
  port_number: typing.Union[int, float] = None,
  ports: typing.List[ContainerPort] = None,
  readiness: Probe = None,
  resources: ContainerResources = None,
  restart_policy: ContainerRestartPolicy = None,
  security_context: ContainerSecurityContextProps = None,
  startup: Probe = None,
  volume_mounts: typing.List[VolumeMount] = None,
  working_dir: str = None,
  image: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.envFrom">env_from</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.envVariables">env_variables</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]</code> | Environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.imagePullPolicy">image_pull_policy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.lifecycle">lifecycle</a></code> | <code><a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a></code> | Describes actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.liveness">liveness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.name">name</a></code> | <code>str</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.port">port</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.portNumber">port_number</a></code> | <code>typing.Union[int, float]</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]</code> | List of ports to expose from this container. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.readiness">readiness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Determines when the container is ready to serve traffic. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.startup">startup</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.volumeMounts">volume_mounts</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.workingDir">working_dir</a></code> | <code>str</code> | Container's working directory. |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.image">image</a></code> | <code>str</code> | Docker image name. |

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Container.Initializer.parameter.args"></a>

- *Type:* typing.List[str]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Container.Initializer.parameter.command"></a>

- *Type:* typing.List[str]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env_from`<sup>Optional</sup> <a name="env_from" id="cdk8s-plus-28.Container.Initializer.parameter.envFrom"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

##### `env_variables`<sup>Optional</sup> <a name="env_variables" id="cdk8s-plus-28.Container.Initializer.parameter.envVariables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]
- *Default:* No environment variables.

Environment variables to set in the container.

---

##### `image_pull_policy`<sup>Optional</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Container.Initializer.parameter.imagePullPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.Container.Initializer.parameter.lifecycle"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

##### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.Container.Initializer.parameter.liveness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Container.Initializer.parameter.name"></a>

- *Type:* str
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Container.Initializer.parameter.port"></a>

- *Deprecated:* - use `portNumber`.

- *Type:* typing.Union[int, float]

---

##### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Container.Initializer.parameter.portNumber"></a>

- *Type:* typing.Union[int, float]
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.Container.Initializer.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

##### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.Container.Initializer.parameter.readiness"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Container.Initializer.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Container.Initializer.parameter.restartPolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

##### `security_context`<sup>Optional</sup> <a name="security_context" id="cdk8s-plus-28.Container.Initializer.parameter.securityContext"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

##### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.Container.Initializer.parameter.startup"></a>

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

##### `volume_mounts`<sup>Optional</sup> <a name="volume_mounts" id="cdk8s-plus-28.Container.Initializer.parameter.volumeMounts"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Container.Initializer.parameter.workingDir"></a>

- *Type:* str
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Container.Initializer.parameter.image"></a>

- *Type:* str

Docker image name.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Container.addPort">add_port</a></code> | Add a port to expose from this container. |
| <code><a href="#cdk8s-plus-28.Container.mount">mount</a></code> | Mount a volume to a specific path so that it is accessible by the container. |

---

##### `add_port` <a name="add_port" id="cdk8s-plus-28.Container.addPort"></a>

```python
def add_port(
  number: typing.Union[int, float],
  host_ip: str = None,
  host_port: typing.Union[int, float] = None,
  name: str = None,
  protocol: Protocol = None
) -> None
```

Add a port to expose from this container.

###### `number`<sup>Required</sup> <a name="number" id="cdk8s-plus-28.Container.addPort.parameter.number"></a>

- *Type:* typing.Union[int, float]

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

---

###### `host_ip`<sup>Optional</sup> <a name="host_ip" id="cdk8s-plus-28.Container.addPort.parameter.hostIp"></a>

- *Type:* str
- *Default:* 127.0.0.1.

What host IP to bind the external port to.

---

###### `host_port`<sup>Optional</sup> <a name="host_port" id="cdk8s-plus-28.Container.addPort.parameter.hostPort"></a>

- *Type:* typing.Union[int, float]
- *Default:* auto generated by kubernetes and might change on restarts.

Number of port to expose on the host.

If specified, this must be a valid port number, 0 < x < 65536.
Most containers do not need this.

---

###### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.Container.addPort.parameter.name"></a>

- *Type:* str
- *Default:* port is not named.

If specified, this must be an IANA_SVC_NAME and unique within the pod.

Each named port in a pod must have a unique name.
Name for the port that can be referred to by services.

---

###### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.Container.addPort.parameter.protocol"></a>

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

Protocol for port.

Must be UDP, TCP, or SCTP. Defaults to "TCP".

---

##### `mount` <a name="mount" id="cdk8s-plus-28.Container.mount"></a>

```python
def mount(
  path: str,
  storage: IStorage,
  propagation: MountPropagation = None,
  read_only: bool = None,
  sub_path: str = None,
  sub_path_expr: str = None
) -> None
```

Mount a volume to a specific path so that it is accessible by the container.

Every pod that is configured to use this container will autmoatically have access to the volume.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Container.mount.parameter.path"></a>

- *Type:* str

The desired path in the container.

---

###### `storage`<sup>Required</sup> <a name="storage" id="cdk8s-plus-28.Container.mount.parameter.storage"></a>

- *Type:* <a href="#cdk8s-plus-28.IStorage">IStorage</a>

The storage to mount.

---

###### `propagation`<sup>Optional</sup> <a name="propagation" id="cdk8s-plus-28.Container.mount.parameter.propagation"></a>

- *Type:* <a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a>
- *Default:* MountPropagation.NONE

Determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used.

Mount propagation allows for sharing volumes mounted by a Container to
other Containers in the same Pod, or even to other Pods on the same node.

---

###### `read_only`<sup>Optional</sup> <a name="read_only" id="cdk8s-plus-28.Container.mount.parameter.readOnly"></a>

- *Type:* bool
- *Default:* false

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

###### `sub_path`<sup>Optional</sup> <a name="sub_path" id="cdk8s-plus-28.Container.mount.parameter.subPath"></a>

- *Type:* str
- *Default:* "" the volume's root

Path within the volume from which the container's volume should be mounted.).

---

###### `sub_path_expr`<sup>Optional</sup> <a name="sub_path_expr" id="cdk8s-plus-28.Container.mount.parameter.subPathExpr"></a>

- *Type:* str
- *Default:* "" volume's root.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references
$(VAR_NAME) are expanded using the container's environment. Defaults to ""
(volume's root).

`subPathExpr` and `subPath` are mutually exclusive.

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Container.property.env">env</a></code> | <code><a href="#cdk8s-plus-28.Env">Env</a></code> | The environment of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.image">image</a></code> | <code>str</code> | The container image. |
| <code><a href="#cdk8s-plus-28.Container.property.imagePullPolicy">image_pull_policy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.mounts">mounts</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]</code> | Volume mounts configured for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.name">name</a></code> | <code>str</code> | The name of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.ports">ports</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]</code> | Ports exposed by this containers. |
| <code><a href="#cdk8s-plus-28.Container.property.securityContext">security_context</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContext">ContainerSecurityContext</a></code> | The security context of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.args">args</a></code> | <code>typing.List[str]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.Container.property.command">command</a></code> | <code>typing.List[str]</code> | Entrypoint array (the command to execute when the container starts). |
| <code><a href="#cdk8s-plus-28.Container.property.port">port</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Container.property.portNumber">port_number</a></code> | <code>typing.Union[int, float]</code> | The port number that was configured for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.Container.property.restartPolicy">restart_policy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | The restart policy of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.workingDir">working_dir</a></code> | <code>str</code> | The working directory inside the container. |

---

##### `env`<sup>Required</sup> <a name="env" id="cdk8s-plus-28.Container.property.env"></a>

```python
env: Env
```

- *Type:* <a href="#cdk8s-plus-28.Env">Env</a>

The environment of the container.

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Container.property.image"></a>

```python
image: str
```

- *Type:* str

The container image.

---

##### `image_pull_policy`<sup>Required</sup> <a name="image_pull_policy" id="cdk8s-plus-28.Container.property.imagePullPolicy"></a>

```python
image_pull_policy: ImagePullPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>

Image pull policy for this container.

---

##### `mounts`<sup>Required</sup> <a name="mounts" id="cdk8s-plus-28.Container.property.mounts"></a>

```python
mounts: typing.List[VolumeMount]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>]

Volume mounts configured for this container.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Container.property.name"></a>

```python
name: str
```

- *Type:* str

The name of the container.

---

##### `ports`<sup>Required</sup> <a name="ports" id="cdk8s-plus-28.Container.property.ports"></a>

```python
ports: typing.List[ContainerPort]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>]

Ports exposed by this containers.

Returns a copy, use `addPort` to modify.

---

##### `security_context`<sup>Required</sup> <a name="security_context" id="cdk8s-plus-28.Container.property.securityContext"></a>

```python
security_context: ContainerSecurityContext
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContext">ContainerSecurityContext</a>

The security context of the container.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Container.property.args"></a>

```python
args: typing.List[str]
```

- *Type:* typing.List[str]

Arguments to the entrypoint.

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Container.property.command"></a>

```python
command: typing.List[str]
```

- *Type:* typing.List[str]

Entrypoint array (the command to execute when the container starts).

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Container.property.port"></a>

- *Deprecated:* - use `portNumber`.

```python
port: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `port_number`<sup>Optional</sup> <a name="port_number" id="cdk8s-plus-28.Container.property.portNumber"></a>

```python
port_number: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

The port number that was configured for this container.

If undefined, either the container doesn't expose a port, or its
port configuration is stored in the `ports` field.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Container.property.resources"></a>

```python
resources: ContainerResources
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restart_policy`<sup>Optional</sup> <a name="restart_policy" id="cdk8s-plus-28.Container.property.restartPolicy"></a>

```python
restart_policy: ContainerRestartPolicy
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>

The restart policy of the container.

---

##### `working_dir`<sup>Optional</sup> <a name="working_dir" id="cdk8s-plus-28.Container.property.workingDir"></a>

```python
working_dir: str
```

- *Type:* str

The working directory inside the container.

---


### ContainerSecurityContext <a name="ContainerSecurityContext" id="cdk8s-plus-28.ContainerSecurityContext"></a>

Container security attributes and settings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ContainerSecurityContext.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ContainerSecurityContext(
  allow_privilege_escalation: bool = None,
  capabilities: ContainerSecutiryContextCapabilities = None,
  ensure_non_root: bool = None,
  group: typing.Union[int, float] = None,
  privileged: bool = None,
  read_only_root_filesystem: bool = None,
  seccomp_profile: SeccompProfile = None,
  user: typing.Union[int, float] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.allowPrivilegeEscalation">allow_privilege_escalation</a></code> | <code>bool</code> | Whether a process can gain more privileges than its parent process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.capabilities">capabilities</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a></code> | POSIX capabilities for running containers. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.group">group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.privileged">privileged</a></code> | <code>bool</code> | Run container in privileged mode. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.readOnlyRootFilesystem">read_only_root_filesystem</a></code> | <code>bool</code> | Whether this container has a read-only root filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.seccompProfile">seccomp_profile</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a></code> | Container's seccomp profile settings. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.user">user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |

---

##### `allow_privilege_escalation`<sup>Optional</sup> <a name="allow_privilege_escalation" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.allowPrivilegeEscalation"></a>

- *Type:* bool
- *Default:* false

Whether a process can gain more privileges than its parent process.

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.capabilities"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a>
- *Default:* none

POSIX capabilities for running containers.

---

##### `ensure_non_root`<sup>Optional</sup> <a name="ensure_non_root" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.ensureNonRoot"></a>

- *Type:* bool
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.group"></a>

- *Type:* typing.Union[int, float]
- *Default:* 26000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The GID to run the entrypoint of the container process.

---

##### `privileged`<sup>Optional</sup> <a name="privileged" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.privileged"></a>

- *Type:* bool
- *Default:* false

Run container in privileged mode.

Processes in privileged containers are essentially equivalent to root on the host.

---

##### `read_only_root_filesystem`<sup>Optional</sup> <a name="read_only_root_filesystem" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.readOnlyRootFilesystem"></a>

- *Type:* bool
- *Default:* true

Whether this container has a read-only root filesystem.

---

##### `seccomp_profile`<sup>Optional</sup> <a name="seccomp_profile" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.seccompProfile"></a>

- *Type:* <a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a>
- *Default:* none

Container's seccomp profile settings.

Only one profile source may be set

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.user"></a>

- *Type:* typing.Union[int, float]
- *Default:* 25000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The UID to run the entrypoint of the container process.

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.privileged">privileged</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.readOnlyRootFilesystem">read_only_root_filesystem</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.allowPrivilegeEscalation">allow_privilege_escalation</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.capabilities">capabilities</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.group">group</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.seccompProfile">seccomp_profile</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.user">user</a></code> | <code>typing.Union[int, float]</code> | *No description.* |

---

##### `ensure_non_root`<sup>Required</sup> <a name="ensure_non_root" id="cdk8s-plus-28.ContainerSecurityContext.property.ensureNonRoot"></a>

```python
ensure_non_root: bool
```

- *Type:* bool

---

##### `privileged`<sup>Required</sup> <a name="privileged" id="cdk8s-plus-28.ContainerSecurityContext.property.privileged"></a>

```python
privileged: bool
```

- *Type:* bool

---

##### `read_only_root_filesystem`<sup>Required</sup> <a name="read_only_root_filesystem" id="cdk8s-plus-28.ContainerSecurityContext.property.readOnlyRootFilesystem"></a>

```python
read_only_root_filesystem: bool
```

- *Type:* bool

---

##### `allow_privilege_escalation`<sup>Optional</sup> <a name="allow_privilege_escalation" id="cdk8s-plus-28.ContainerSecurityContext.property.allowPrivilegeEscalation"></a>

```python
allow_privilege_escalation: bool
```

- *Type:* bool

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.ContainerSecurityContext.property.capabilities"></a>

```python
capabilities: ContainerSecutiryContextCapabilities
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a>

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.ContainerSecurityContext.property.group"></a>

```python
group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `seccomp_profile`<sup>Optional</sup> <a name="seccomp_profile" id="cdk8s-plus-28.ContainerSecurityContext.property.seccompProfile"></a>

```python
seccomp_profile: SeccompProfile
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a>

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.ContainerSecurityContext.property.user"></a>

```python
user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---


### Cpu <a name="Cpu" id="cdk8s-plus-28.Cpu"></a>

Represents the amount of CPU.

The amount can be passed as millis or units.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Cpu.millis">millis</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Cpu.units">units</a></code> | *No description.* |

---

##### `millis` <a name="millis" id="cdk8s-plus-28.Cpu.millis"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Cpu.millis(
  amount: typing.Union[int, float]
)
```

###### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.millis.parameter.amount"></a>

- *Type:* typing.Union[int, float]

---

##### `units` <a name="units" id="cdk8s-plus-28.Cpu.units"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Cpu.units(
  amount: typing.Union[int, float]
)
```

###### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.units.parameter.amount"></a>

- *Type:* typing.Union[int, float]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Cpu.property.amount">amount</a></code> | <code>str</code> | *No description.* |

---

##### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.property.amount"></a>

```python
amount: str
```

- *Type:* str

---


### DeploymentStrategy <a name="DeploymentStrategy" id="cdk8s-plus-28.DeploymentStrategy"></a>

Deployment strategies.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentStrategy.recreate">recreate</a></code> | All existing Pods are killed before new ones are created. |
| <code><a href="#cdk8s-plus-28.DeploymentStrategy.rollingUpdate">rolling_update</a></code> | *No description.* |

---

##### `recreate` <a name="recreate" id="cdk8s-plus-28.DeploymentStrategy.recreate"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DeploymentStrategy.recreate()
```

All existing Pods are killed before new ones are created.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#recreate-deployment](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#recreate-deployment)

##### `rolling_update` <a name="rolling_update" id="cdk8s-plus-28.DeploymentStrategy.rollingUpdate"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.DeploymentStrategy.rolling_update(
  max_surge: PercentOrAbsolute = None,
  max_unavailable: PercentOrAbsolute = None
)
```

###### `max_surge`<sup>Optional</sup> <a name="max_surge" id="cdk8s-plus-28.DeploymentStrategy.rollingUpdate.parameter.maxSurge"></a>

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be scheduled above the desired number of pods.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding up.
This can not be 0 if `maxUnavailable` is 0.

Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update
starts, such that the total number of old and new pods do not exceed 130% of desired pods.
Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that
total number of pods running at any time during the update is at most 130% of desired pods.

---

###### `max_unavailable`<sup>Optional</sup> <a name="max_unavailable" id="cdk8s-plus-28.DeploymentStrategy.rollingUpdate.parameter.maxUnavailable"></a>

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding down.
This can not be 0 if `maxSurge` is 0.

Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired
pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can
be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total
number of pods available at all times during the update is at least 70% of desired pods.

---



### Env <a name="Env" id="cdk8s-plus-28.Env"></a>

Container environment variables.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Env.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Env(
  sources: typing.List[EnvFrom],
  variables: typing.Mapping[EnvValue]
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Env.Initializer.parameter.sources">sources</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Env.Initializer.parameter.variables">variables</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]</code> | *No description.* |

---

##### `sources`<sup>Required</sup> <a name="sources" id="cdk8s-plus-28.Env.Initializer.parameter.sources"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]

---

##### `variables`<sup>Required</sup> <a name="variables" id="cdk8s-plus-28.Env.Initializer.parameter.variables"></a>

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Env.addVariable">add_variable</a></code> | Add a single variable by name and value. |
| <code><a href="#cdk8s-plus-28.Env.copyFrom">copy_from</a></code> | Add a collection of variables by copying from another source. |

---

##### `add_variable` <a name="add_variable" id="cdk8s-plus-28.Env.addVariable"></a>

```python
def add_variable(
  name: str,
  value: EnvValue
) -> None
```

Add a single variable by name and value.

The variable value can come from various dynamic sources such a secrets of config maps.
Use `EnvValue.fromXXX` to select sources.

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Env.addVariable.parameter.name"></a>

- *Type:* str

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Env.addVariable.parameter.value"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>

---

##### `copy_from` <a name="copy_from" id="cdk8s-plus-28.Env.copyFrom"></a>

```python
def copy_from(
  from: EnvFrom
) -> None
```

Add a collection of variables by copying from another source.

Use `Env.fromXXX` functions to select sources.

###### `from`<sup>Required</sup> <a name="from" id="cdk8s-plus-28.Env.copyFrom.parameter.from"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Env.fromConfigMap">from_config_map</a></code> | Selects a ConfigMap to populate the environment variables with. |
| <code><a href="#cdk8s-plus-28.Env.fromSecret">from_secret</a></code> | Selects a Secret to populate the environment variables with. |

---

##### `from_config_map` <a name="from_config_map" id="cdk8s-plus-28.Env.fromConfigMap"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Env.from_config_map(
  config_map: IConfigMap,
  prefix: str = None
)
```

Selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap's Data field will represent
the key-value pairs as environment variables.

###### `config_map`<sup>Required</sup> <a name="config_map" id="cdk8s-plus-28.Env.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

---

###### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.Env.fromConfigMap.parameter.prefix"></a>

- *Type:* str

---

##### `from_secret` <a name="from_secret" id="cdk8s-plus-28.Env.fromSecret"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Env.from_secret(
  secr: ISecret
)
```

Selects a Secret to populate the environment variables with.

The contents of the target Secret's Data field will represent
the key-value pairs as environment variables.

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.Env.fromSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Env.property.sources">sources</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]</code> | The list of sources used to populate the container environment, in addition to the `variables`. |
| <code><a href="#cdk8s-plus-28.Env.property.variables">variables</a></code> | <code>typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]</code> | The environment variables for this container. |

---

##### `sources`<sup>Required</sup> <a name="sources" id="cdk8s-plus-28.Env.property.sources"></a>

```python
sources: typing.List[EnvFrom]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>]

The list of sources used to populate the container environment, in addition to the `variables`.

Returns a copy. To add a source use `container.env.copyFrom()`.

---

##### `variables`<sup>Required</sup> <a name="variables" id="cdk8s-plus-28.Env.property.variables"></a>

```python
variables: typing.Mapping[EnvValue]
```

- *Type:* typing.Mapping[<a href="#cdk8s-plus-28.EnvValue">EnvValue</a>]

The environment variables for this container.

Returns a copy. To add environment variables use `container.env.addVariable()`.

---


### EnvFrom <a name="EnvFrom" id="cdk8s-plus-28.EnvFrom"></a>

A collection of env variables defined in other resources.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.EnvFrom.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvFrom(
  config_map: IConfigMap = None,
  prefix: str = None,
  sec: ISecret = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.configMap">config_map</a></code> | <code><a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.prefix">prefix</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.sec">sec</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |

---

##### `config_map`<sup>Optional</sup> <a name="config_map" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.prefix"></a>

- *Type:* str

---

##### `sec`<sup>Optional</sup> <a name="sec" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.sec"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---





### EnvValue <a name="EnvValue" id="cdk8s-plus-28.EnvValue"></a>

Utility class for creating reading env values from various sources.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValue.fromConfigMap">from_config_map</a></code> | Create a value by reading a specific key inside a config map. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromFieldRef">from_field_ref</a></code> | Create a value from a field reference. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromProcess">from_process</a></code> | Create a value from a key in the current process environment. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromResource">from_resource</a></code> | Create a value from a resource. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromSecretValue">from_secret_value</a></code> | Defines an environment value from a secret JSON value. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromValue">from_value</a></code> | Create a value from the given argument. |

---

##### `from_config_map` <a name="from_config_map" id="cdk8s-plus-28.EnvValue.fromConfigMap"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_config_map(
  config_map: IConfigMap,
  key: str,
  optional: bool = None
)
```

Create a value by reading a specific key inside a config map.

###### `config_map`<sup>Required</sup> <a name="config_map" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

The config map.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.key"></a>

- *Type:* str

The key to extract the value from.

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the ConfigMap or its key must be defined.

---

##### `from_field_ref` <a name="from_field_ref" id="cdk8s-plus-28.EnvValue.fromFieldRef"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_field_ref(
  field_path: EnvFieldPaths,
  api_version: str = None,
  key: str = None
)
```

Create a value from a field reference.

###### `field_path`<sup>Required</sup> <a name="field_path" id="cdk8s-plus-28.EnvValue.fromFieldRef.parameter.fieldPath"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvFieldPaths">EnvFieldPaths</a>

: The field reference.

---

###### `api_version`<sup>Optional</sup> <a name="api_version" id="cdk8s-plus-28.EnvValue.fromFieldRef.parameter.apiVersion"></a>

- *Type:* str

Version of the schema the FieldPath is written in terms of.

---

###### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromFieldRef.parameter.key"></a>

- *Type:* str

The key to select the pod label or annotation.

---

##### `from_process` <a name="from_process" id="cdk8s-plus-28.EnvValue.fromProcess"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_process(
  key: str,
  required: bool = None
)
```

Create a value from a key in the current process environment.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromProcess.parameter.key"></a>

- *Type:* str

The key to read.

---

###### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.EnvValue.fromProcess.parameter.required"></a>

- *Type:* bool
- *Default:* false

Specify whether the key must exist in the environment.

If this is set to true, and the key does not exist, an error will thrown.

---

##### `from_resource` <a name="from_resource" id="cdk8s-plus-28.EnvValue.fromResource"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_resource(
  resource: ResourceFieldPaths,
  container: Container = None,
  divisor: str = None
)
```

Create a value from a resource.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.EnvValue.fromResource.parameter.resource"></a>

- *Type:* <a href="#cdk8s-plus-28.ResourceFieldPaths">ResourceFieldPaths</a>

: Resource to select the value from.

---

###### `container`<sup>Optional</sup> <a name="container" id="cdk8s-plus-28.EnvValue.fromResource.parameter.container"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

The container to select the value from.

---

###### `divisor`<sup>Optional</sup> <a name="divisor" id="cdk8s-plus-28.EnvValue.fromResource.parameter.divisor"></a>

- *Type:* str

The output format of the exposed resource.

---

##### `from_secret_value` <a name="from_secret_value" id="cdk8s-plus-28.EnvValue.fromSecretValue"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_secret_value(
  key: str,
  secret: ISecret,
  optional: bool = None
)
```

Defines an environment value from a secret JSON value.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromSecretValue.parameter.key"></a>

- *Type:* str

The JSON key.

---

###### `secret`<sup>Required</sup> <a name="secret" id="cdk8s-plus-28.EnvValue.fromSecretValue.parameter.secret"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret.

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValue.fromSecretValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

##### `from_value` <a name="from_value" id="cdk8s-plus-28.EnvValue.fromValue"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.EnvValue.from_value(
  value: str
)
```

Create a value from the given argument.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.EnvValue.fromValue.parameter.value"></a>

- *Type:* str

The value.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValue.property.value">value</a></code> | <code>typing.Any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvValue.property.valueFrom">value_from</a></code> | <code>typing.Any</code> | *No description.* |

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.EnvValue.property.value"></a>

```python
value: typing.Any
```

- *Type:* typing.Any

---

##### `value_from`<sup>Optional</sup> <a name="value_from" id="cdk8s-plus-28.EnvValue.property.valueFrom"></a>

```python
value_from: typing.Any
```

- *Type:* typing.Any

---


### Handler <a name="Handler" id="cdk8s-plus-28.Handler"></a>

Defines a specific action that should be taken.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Handler.fromCommand">from_command</a></code> | Defines a handler based on a command which is executed within the container. |
| <code><a href="#cdk8s-plus-28.Handler.fromHttpGet">from_http_get</a></code> | Defines a handler based on an HTTP GET request to the IP address of the container. |
| <code><a href="#cdk8s-plus-28.Handler.fromTcpSocket">from_tcp_socket</a></code> | Defines a handler based opening a connection to a TCP socket on the container. |

---

##### `from_command` <a name="from_command" id="cdk8s-plus-28.Handler.fromCommand"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Handler.from_command(
  command: typing.List[str]
)
```

Defines a handler based on a command which is executed within the container.

###### `command`<sup>Required</sup> <a name="command" id="cdk8s-plus-28.Handler.fromCommand.parameter.command"></a>

- *Type:* typing.List[str]

The command to execute.

---

##### `from_http_get` <a name="from_http_get" id="cdk8s-plus-28.Handler.fromHttpGet"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Handler.from_http_get(
  path: str,
  port: typing.Union[int, float] = None
)
```

Defines a handler based on an HTTP GET request to the IP address of the container.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Handler.fromHttpGet.parameter.path"></a>

- *Type:* str

The URL path to hit.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Handler.fromHttpGet.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

##### `from_tcp_socket` <a name="from_tcp_socket" id="cdk8s-plus-28.Handler.fromTcpSocket"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Handler.from_tcp_socket(
  host: str = None,
  port: typing.Union[int, float] = None
)
```

Defines a handler based opening a connection to a TCP socket on the container.

###### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.Handler.fromTcpSocket.parameter.host"></a>

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Handler.fromTcpSocket.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---



### IngressBackend <a name="IngressBackend" id="cdk8s-plus-28.IngressBackend"></a>

The backend for an ingress path.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IngressBackend.fromResource">from_resource</a></code> | A Resource backend is an ObjectRef to another Kubernetes resource within the same namespace as the Ingress object. |
| <code><a href="#cdk8s-plus-28.IngressBackend.fromService">from_service</a></code> | A Kubernetes `Service` to use as the backend for this path. |

---

##### `from_resource` <a name="from_resource" id="cdk8s-plus-28.IngressBackend.fromResource"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.IngressBackend.from_resource(
  resource: IResource
)
```

A Resource backend is an ObjectRef to another Kubernetes resource within the same namespace as the Ingress object.

A common usage for a Resource backend is to ingress data to an object
storage backend with static assets.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.IngressBackend.fromResource.parameter.resource"></a>

- *Type:* <a href="#cdk8s-plus-28.IResource">IResource</a>

---

##### `from_service` <a name="from_service" id="cdk8s-plus-28.IngressBackend.fromService"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.IngressBackend.from_service(
  serv: Service,
  port: typing.Union[int, float] = None
)
```

A Kubernetes `Service` to use as the backend for this path.

###### `serv`<sup>Required</sup> <a name="serv" id="cdk8s-plus-28.IngressBackend.fromService.parameter.serv"></a>

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>

The service object.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.IngressBackend.fromService.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* if the service exposes a single port, this port will be used.

The port to use to access the service.

* This option will fail if the service does not expose any ports.
* If the service exposes multiple ports, this option must be specified.
* If the service exposes a single port, this option is optional and if
  specified, it must be the same port exposed by the service.

---



### IntOrString <a name="IntOrString" id="cdk8s-plus-28.k8s.IntOrString"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.fromNumber">from_number</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.fromString">from_string</a></code> | *No description.* |

---

##### `from_number` <a name="from_number" id="cdk8s-plus-28.k8s.IntOrString.fromNumber"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IntOrString.from_number(
  value: typing.Union[int, float]
)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.fromNumber.parameter.value"></a>

- *Type:* typing.Union[int, float]

---

##### `from_string` <a name="from_string" id="cdk8s-plus-28.k8s.IntOrString.fromString"></a>

```python
from cdk8s_plus_28 import k8s

k8s.IntOrString.from_string(
  value: str
)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.fromString.parameter.value"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.property.value">value</a></code> | <code>typing.Union[str, typing.Union[int, float]]</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.property.value"></a>

```python
value: typing.Union[str, typing.Union[int, float]]
```

- *Type:* typing.Union[str, typing.Union[int, float]]

---


### LabeledNode <a name="LabeledNode" id="cdk8s-plus-28.LabeledNode"></a>

A node that is matched by label selectors.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.LabeledNode.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabeledNode(
  label_selector: typing.List[NodeLabelQuery]
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabeledNode.Initializer.parameter.labelSelector">label_selector</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>]</code> | *No description.* |

---

##### `label_selector`<sup>Required</sup> <a name="label_selector" id="cdk8s-plus-28.LabeledNode.Initializer.parameter.labelSelector"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>]

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabeledNode.property.labelSelector">label_selector</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>]</code> | *No description.* |

---

##### `label_selector`<sup>Required</sup> <a name="label_selector" id="cdk8s-plus-28.LabeledNode.property.labelSelector"></a>

```python
label_selector: typing.List[NodeLabelQuery]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>]

---


### LabelExpression <a name="LabelExpression" id="cdk8s-plus-28.LabelExpression"></a>

Represents a query that can be performed against resources with labels.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelExpression.doesNotExist">does_not_exist</a></code> | Requires label `key` to not exist. |
| <code><a href="#cdk8s-plus-28.LabelExpression.exists">exists</a></code> | Requires label `key` to exist. |
| <code><a href="#cdk8s-plus-28.LabelExpression.in">in</a></code> | Requires value of label `key` to be one of `values`. |
| <code><a href="#cdk8s-plus-28.LabelExpression.notIn">not_in</a></code> | Requires value of label `key` to be none of `values`. |

---

##### `does_not_exist` <a name="does_not_exist" id="cdk8s-plus-28.LabelExpression.doesNotExist"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelExpression.does_not_exist(
  key: str
)
```

Requires label `key` to not exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.doesNotExist.parameter.key"></a>

- *Type:* str

---

##### `exists` <a name="exists" id="cdk8s-plus-28.LabelExpression.exists"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelExpression.exists(
  key: str
)
```

Requires label `key` to exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.exists.parameter.key"></a>

- *Type:* str

---

##### `in` <a name="in" id="cdk8s-plus-28.LabelExpression.in"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelExpression.in(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to be one of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.in.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.in.parameter.values"></a>

- *Type:* typing.List[str]

---

##### `not_in` <a name="not_in" id="cdk8s-plus-28.LabelExpression.notIn"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelExpression.not_in(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to be none of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.notIn.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.notIn.parameter.values"></a>

- *Type:* typing.List[str]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.key">key</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.operator">operator</a></code> | <code>str</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.values">values</a></code> | <code>typing.List[str]</code> | *No description.* |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.property.key"></a>

```python
key: str
```

- *Type:* str

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.LabelExpression.property.operator"></a>

```python
operator: str
```

- *Type:* str

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.property.values"></a>

```python
values: typing.List[str]
```

- *Type:* typing.List[str]

---


### LabelSelector <a name="LabelSelector" id="cdk8s-plus-28.LabelSelector"></a>

Match a resource by labels.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelector.isEmpty">is_empty</a></code> | *No description.* |

---

##### `is_empty` <a name="is_empty" id="cdk8s-plus-28.LabelSelector.isEmpty"></a>

```python
def is_empty() -> bool
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelector.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk8s-plus-28.LabelSelector.of"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.LabelSelector.of(
  expressions: typing.List[LabelExpression] = None,
  labels: typing.Mapping[str] = None
)
```

###### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.LabelSelector.of.parameter.expressions"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>]

Expression based label matchers.

---

###### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.LabelSelector.of.parameter.labels"></a>

- *Type:* typing.Mapping[str]

Strict label matchers.

---



### Metric <a name="Metric" id="cdk8s-plus-28.Metric"></a>

A metric condition that HorizontalPodAutoscaler's scale on.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Metric.containerCpu">container_cpu</a></code> | Metric that tracks the CPU of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerEphemeralStorage">container_ephemeral_storage</a></code> | Metric that tracks the local ephemeral storage of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerMemory">container_memory</a></code> | Metric that tracks the Memory of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerStorage">container_storage</a></code> | Metric that tracks the volume size of a container. |
| <code><a href="#cdk8s-plus-28.Metric.external">external</a></code> | A global metric that is not associated with any Kubernetes object. |
| <code><a href="#cdk8s-plus-28.Metric.object">object</a></code> | Metric that describes a metric of a kubernetes object. |
| <code><a href="#cdk8s-plus-28.Metric.pods">pods</a></code> | A pod metric that will be averaged across all pods of the current scale target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceCpu">resource_cpu</a></code> | Tracks the available CPU of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceEphemeralStorage">resource_ephemeral_storage</a></code> | Tracks the available Ephemeral Storage of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceMemory">resource_memory</a></code> | Tracks the available Memory of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceStorage">resource_storage</a></code> | Tracks the available Storage of the pods in a target. |

---

##### `container_cpu` <a name="container_cpu" id="cdk8s-plus-28.Metric.containerCpu"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.container_cpu(
  container: Container,
  target: MetricTarget
)
```

Metric that tracks the CPU of a container.

This metric
will be tracked across all pods of the current scale target.

###### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.Metric.containerCpu.parameter.container"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.containerCpu.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

##### `container_ephemeral_storage` <a name="container_ephemeral_storage" id="cdk8s-plus-28.Metric.containerEphemeralStorage"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.container_ephemeral_storage(
  container: Container,
  target: MetricTarget
)
```

Metric that tracks the local ephemeral storage of a container.

This metric
will be tracked across all pods of the current scale target.

###### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.Metric.containerEphemeralStorage.parameter.container"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.containerEphemeralStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

##### `container_memory` <a name="container_memory" id="cdk8s-plus-28.Metric.containerMemory"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.container_memory(
  container: Container,
  target: MetricTarget
)
```

Metric that tracks the Memory of a container.

This metric
will be tracked across all pods of the current scale target.

###### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.Metric.containerMemory.parameter.container"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.containerMemory.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

##### `container_storage` <a name="container_storage" id="cdk8s-plus-28.Metric.containerStorage"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.container_storage(
  container: Container,
  target: MetricTarget
)
```

Metric that tracks the volume size of a container.

This metric
will be tracked across all pods of the current scale target.

###### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.Metric.containerStorage.parameter.container"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.containerStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

##### `external` <a name="external" id="cdk8s-plus-28.Metric.external"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.external(
  name: str,
  target: MetricTarget,
  label_selector: LabelSelector = None
)
```

A global metric that is not associated with any Kubernetes object.

Allows for autoscaling based on information coming from components running outside of
the cluster.

Use case:

* Scale up when the length of an SQS queue is greater than 10 messages.
* Scale down when an outside load balancer's queries are less than 10000 per second.

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Metric.external.parameter.name"></a>

- *Type:* str

The name of the metric to scale on.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.external.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

###### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.Metric.external.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

##### `object` <a name="object" id="cdk8s-plus-28.Metric.object"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.object(
  name: str,
  target: MetricTarget,
  label_selector: LabelSelector = None,
  object: IResource
)
```

Metric that describes a metric of a kubernetes object.

Use case:

* Scale on a Kubernetes Ingress's hits-per-second metric.

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Metric.object.parameter.name"></a>

- *Type:* str

The name of the metric to scale on.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.object.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

###### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.Metric.object.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

###### `object`<sup>Required</sup> <a name="object" id="cdk8s-plus-28.Metric.object.parameter.object"></a>

- *Type:* <a href="#cdk8s-plus-28.IResource">IResource</a>

Resource where the metric can be found.

---

##### `pods` <a name="pods" id="cdk8s-plus-28.Metric.pods"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.pods(
  name: str,
  target: MetricTarget,
  label_selector: LabelSelector = None
)
```

A pod metric that will be averaged across all pods of the current scale target.

Use case:

* Average CPU utilization across all pods
* Transactions processed per second across all pods

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Metric.pods.parameter.name"></a>

- *Type:* str

The name of the metric to scale on.

---

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.pods.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

###### `label_selector`<sup>Optional</sup> <a name="label_selector" id="cdk8s-plus-28.Metric.pods.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

##### `resource_cpu` <a name="resource_cpu" id="cdk8s-plus-28.Metric.resourceCpu"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.resource_cpu(
  target: MetricTarget
)
```

Tracks the available CPU of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

Use case:

* Scale up when CPU is above 40%.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceCpu.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resource_ephemeral_storage` <a name="resource_ephemeral_storage" id="cdk8s-plus-28.Metric.resourceEphemeralStorage"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.resource_ephemeral_storage(
  target: MetricTarget
)
```

Tracks the available Ephemeral Storage of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceEphemeralStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resource_memory` <a name="resource_memory" id="cdk8s-plus-28.Metric.resourceMemory"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.resource_memory(
  target: MetricTarget
)
```

Tracks the available Memory of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

Use case:

* Scale up when Memory is above 512MB.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceMemory.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resource_storage` <a name="resource_storage" id="cdk8s-plus-28.Metric.resourceStorage"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Metric.resource_storage(
  target: MetricTarget
)
```

Tracks the available Storage of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Metric.property.type">type</a></code> | <code>str</code> | *No description.* |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.Metric.property.type"></a>

```python
type: str
```

- *Type:* str

---


### MetricTarget <a name="MetricTarget" id="cdk8s-plus-28.MetricTarget"></a>

A metric condition that will trigger scaling behavior when satisfied.

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
MetricTarget.average_utilization(70)
```



#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.MetricTarget.averageUtilization">average_utilization</a></code> | Target a percentage value across all relevant pods. |
| <code><a href="#cdk8s-plus-28.MetricTarget.averageValue">average_value</a></code> | Target the average value across all relevant pods. |
| <code><a href="#cdk8s-plus-28.MetricTarget.value">value</a></code> | Target a specific target value. |

---

##### `average_utilization` <a name="average_utilization" id="cdk8s-plus-28.MetricTarget.averageUtilization"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricTarget.average_utilization(
  average_utilization: typing.Union[int, float]
)
```

Target a percentage value across all relevant pods.

###### `average_utilization`<sup>Required</sup> <a name="average_utilization" id="cdk8s-plus-28.MetricTarget.averageUtilization.parameter.averageUtilization"></a>

- *Type:* typing.Union[int, float]

The percentage of the utilization metric.

e.g. `50` for 50%.

---

##### `average_value` <a name="average_value" id="cdk8s-plus-28.MetricTarget.averageValue"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricTarget.average_value(
  average_value: typing.Union[int, float]
)
```

Target the average value across all relevant pods.

###### `average_value`<sup>Required</sup> <a name="average_value" id="cdk8s-plus-28.MetricTarget.averageValue.parameter.averageValue"></a>

- *Type:* typing.Union[int, float]

The average metric value.

---

##### `value` <a name="value" id="cdk8s-plus-28.MetricTarget.value"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.MetricTarget.value(
  value: typing.Union[int, float]
)
```

Target a specific target value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.MetricTarget.value.parameter.value"></a>

- *Type:* typing.Union[int, float]

The target value.

---



### NamedNode <a name="NamedNode" id="cdk8s-plus-28.NamedNode"></a>

A node that is matched by its name.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.NamedNode.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NamedNode(
  name: str
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamedNode.Initializer.parameter.name">name</a></code> | <code>str</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NamedNode.Initializer.parameter.name"></a>

- *Type:* str

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamedNode.property.name">name</a></code> | <code>str</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NamedNode.property.name"></a>

```python
name: str
```

- *Type:* str

---


### NetworkPolicyPort <a name="NetworkPolicyPort" id="cdk8s-plus-28.NetworkPolicyPort"></a>

Describes a port to allow traffic on.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.allTcp">all_tcp</a></code> | Any TCP traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.allUdp">all_udp</a></code> | Any UDP traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.of">of</a></code> | Custom port configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.tcp">tcp</a></code> | Distinct TCP ports. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.tcpRange">tcp_range</a></code> | A TCP port range. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.udp">udp</a></code> | Distinct UDP ports. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.udpRange">udp_range</a></code> | A UDP port range. |

---

##### `all_tcp` <a name="all_tcp" id="cdk8s-plus-28.NetworkPolicyPort.allTcp"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.all_tcp()
```

Any TCP traffic.

##### `all_udp` <a name="all_udp" id="cdk8s-plus-28.NetworkPolicyPort.allUdp"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.all_udp()
```

Any UDP traffic.

##### `of` <a name="of" id="cdk8s-plus-28.NetworkPolicyPort.of"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.of(
  end_port: typing.Union[int, float] = None,
  port: typing.Union[int, float] = None,
  protocol: NetworkProtocol = None
)
```

Custom port configuration.

###### `end_port`<sup>Optional</sup> <a name="end_port" id="cdk8s-plus-28.NetworkPolicyPort.of.parameter.endPort"></a>

- *Type:* typing.Union[int, float]
- *Default:* not a port range.

End port (relative to `port`).

Only applies if `port` is defined.
Use this to specify a port range, rather that a specific one.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPort.of.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* all ports are allowed.

Specific port number.

---

###### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.NetworkPolicyPort.of.parameter.protocol"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkProtocol">NetworkProtocol</a>
- *Default:* NetworkProtocol.TCP

Protocol.

---

##### `tcp` <a name="tcp" id="cdk8s-plus-28.NetworkPolicyPort.tcp"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.tcp(
  port: typing.Union[int, float]
)
```

Distinct TCP ports.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPort.tcp.parameter.port"></a>

- *Type:* typing.Union[int, float]

---

##### `tcp_range` <a name="tcp_range" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.tcp_range(
  start_port: typing.Union[int, float],
  end_port: typing.Union[int, float]
)
```

A TCP port range.

###### `start_port`<sup>Required</sup> <a name="start_port" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange.parameter.startPort"></a>

- *Type:* typing.Union[int, float]

---

###### `end_port`<sup>Required</sup> <a name="end_port" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange.parameter.endPort"></a>

- *Type:* typing.Union[int, float]

---

##### `udp` <a name="udp" id="cdk8s-plus-28.NetworkPolicyPort.udp"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.udp(
  port: typing.Union[int, float]
)
```

Distinct UDP ports.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPort.udp.parameter.port"></a>

- *Type:* typing.Union[int, float]

---

##### `udp_range` <a name="udp_range" id="cdk8s-plus-28.NetworkPolicyPort.udpRange"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NetworkPolicyPort.udp_range(
  start_port: typing.Union[int, float],
  end_port: typing.Union[int, float]
)
```

A UDP port range.

###### `start_port`<sup>Required</sup> <a name="start_port" id="cdk8s-plus-28.NetworkPolicyPort.udpRange.parameter.startPort"></a>

- *Type:* typing.Union[int, float]

---

###### `end_port`<sup>Required</sup> <a name="end_port" id="cdk8s-plus-28.NetworkPolicyPort.udpRange.parameter.endPort"></a>

- *Type:* typing.Union[int, float]

---



### Node <a name="Node" id="cdk8s-plus-28.Node"></a>

Represents a node in the cluster.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Node.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Node()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Node.labeled">labeled</a></code> | Match a node by its labels. |
| <code><a href="#cdk8s-plus-28.Node.named">named</a></code> | Match a node by its name. |
| <code><a href="#cdk8s-plus-28.Node.tainted">tainted</a></code> | Match a node by its taints. |

---

##### `labeled` <a name="labeled" id="cdk8s-plus-28.Node.labeled"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Node.labeled(
  label_selector: NodeLabelQuery
)
```

Match a node by its labels.

###### `label_selector`<sup>Required</sup> <a name="label_selector" id="cdk8s-plus-28.Node.labeled.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>

---

##### `named` <a name="named" id="cdk8s-plus-28.Node.named"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Node.named(
  node_name: str
)
```

Match a node by its name.

###### `node_name`<sup>Required</sup> <a name="node_name" id="cdk8s-plus-28.Node.named.parameter.nodeName"></a>

- *Type:* str

---

##### `tainted` <a name="tainted" id="cdk8s-plus-28.Node.tainted"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Node.tainted(
  taint_selector: NodeTaintQuery
)
```

Match a node by its taints.

###### `taint_selector`<sup>Required</sup> <a name="taint_selector" id="cdk8s-plus-28.Node.tainted.parameter.taintSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>

---



### NodeLabelQuery <a name="NodeLabelQuery" id="cdk8s-plus-28.NodeLabelQuery"></a>

Represents a query that can be performed against nodes with labels.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.doesNotExist">does_not_exist</a></code> | Requires label `key` to not exist. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.exists">exists</a></code> | Requires label `key` to exist. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.gt">gt</a></code> | Requires value of label `key` to greater than all elements in `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.in">in</a></code> | Requires value of label `key` to be one of `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.is">is</a></code> | Requires value of label `key` to equal `value`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.lt">lt</a></code> | Requires value of label `key` to less than all elements in `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.notIn">not_in</a></code> | Requires value of label `key` to be none of `values`. |

---

##### `does_not_exist` <a name="does_not_exist" id="cdk8s-plus-28.NodeLabelQuery.doesNotExist"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.does_not_exist(
  key: str
)
```

Requires label `key` to not exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.doesNotExist.parameter.key"></a>

- *Type:* str

---

##### `exists` <a name="exists" id="cdk8s-plus-28.NodeLabelQuery.exists"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.exists(
  key: str
)
```

Requires label `key` to exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.exists.parameter.key"></a>

- *Type:* str

---

##### `gt` <a name="gt" id="cdk8s-plus-28.NodeLabelQuery.gt"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.gt(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to greater than all elements in `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.gt.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.gt.parameter.values"></a>

- *Type:* typing.List[str]

---

##### `in` <a name="in" id="cdk8s-plus-28.NodeLabelQuery.in"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.in(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to be one of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.in.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.in.parameter.values"></a>

- *Type:* typing.List[str]

---

##### `is` <a name="is" id="cdk8s-plus-28.NodeLabelQuery.is"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.is(
  key: str,
  value: str
)
```

Requires value of label `key` to equal `value`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.is.parameter.key"></a>

- *Type:* str

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.NodeLabelQuery.is.parameter.value"></a>

- *Type:* str

---

##### `lt` <a name="lt" id="cdk8s-plus-28.NodeLabelQuery.lt"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.lt(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to less than all elements in `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.lt.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.lt.parameter.values"></a>

- *Type:* typing.List[str]

---

##### `not_in` <a name="not_in" id="cdk8s-plus-28.NodeLabelQuery.notIn"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeLabelQuery.not_in(
  key: str,
  values: typing.List[str]
)
```

Requires value of label `key` to be none of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.notIn.parameter.key"></a>

- *Type:* str

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.notIn.parameter.values"></a>

- *Type:* typing.List[str]

---



### NodeTaintQuery <a name="NodeTaintQuery" id="cdk8s-plus-28.NodeTaintQuery"></a>

Taint queries that can be perfomed against nodes.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.any">any</a></code> | Matches any taint. |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.exists">exists</a></code> | Matches a tain with any value of a specific key. |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.is">is</a></code> | Matches a taint with a specific key and value. |

---

##### `any` <a name="any" id="cdk8s-plus-28.NodeTaintQuery.any"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeTaintQuery.any()
```

Matches any taint.

##### `exists` <a name="exists" id="cdk8s-plus-28.NodeTaintQuery.exists"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeTaintQuery.exists(
  key: str,
  effect: TaintEffect = None,
  evict_after: Duration = None
)
```

Matches a tain with any value of a specific key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeTaintQuery.exists.parameter.key"></a>

- *Type:* str

---

###### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.NodeTaintQuery.exists.parameter.effect"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a>
- *Default:* all effects are matched.

The taint effect to match.

---

###### `evict_after`<sup>Optional</sup> <a name="evict_after" id="cdk8s-plus-28.NodeTaintQuery.exists.parameter.evictAfter"></a>

- *Type:* cdk8s.Duration
- *Default:* bound forever.

How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node.

Only applies for the `NO_EXECUTE` effect.

---

##### `is` <a name="is" id="cdk8s-plus-28.NodeTaintQuery.is"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NodeTaintQuery.is(
  key: str,
  value: str,
  effect: TaintEffect = None,
  evict_after: Duration = None
)
```

Matches a taint with a specific key and value.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.key"></a>

- *Type:* str

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.value"></a>

- *Type:* str

---

###### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.effect"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a>
- *Default:* all effects are matched.

The taint effect to match.

---

###### `evict_after`<sup>Optional</sup> <a name="evict_after" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.evictAfter"></a>

- *Type:* cdk8s.Duration
- *Default:* bound forever.

How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node.

Only applies for the `NO_EXECUTE` effect.

---



### NonApiResource <a name="NonApiResource" id="cdk8s-plus-28.NonApiResource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Factory for creating non api resources.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NonApiResource.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.NonApiResource.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |

---

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.NonApiResource.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.NonApiResource.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NonApiResource.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk8s-plus-28.NonApiResource.of"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.NonApiResource.of(
  url: str
)
```

###### `url`<sup>Required</sup> <a name="url" id="cdk8s-plus-28.NonApiResource.of.parameter.url"></a>

- *Type:* str

---



### PercentOrAbsolute <a name="PercentOrAbsolute" id="cdk8s-plus-28.PercentOrAbsolute"></a>

Union like class repsenting either a ration in percents or an absolute number.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.isZero">is_zero</a></code> | *No description.* |

---

##### `is_zero` <a name="is_zero" id="cdk8s-plus-28.PercentOrAbsolute.isZero"></a>

```python
def is_zero() -> bool
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.absolute">absolute</a></code> | Absolute number. |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.percent">percent</a></code> | Percent ratio. |

---

##### `absolute` <a name="absolute" id="cdk8s-plus-28.PercentOrAbsolute.absolute"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PercentOrAbsolute.absolute(
  num: typing.Union[int, float]
)
```

Absolute number.

###### `num`<sup>Required</sup> <a name="num" id="cdk8s-plus-28.PercentOrAbsolute.absolute.parameter.num"></a>

- *Type:* typing.Union[int, float]

---

##### `percent` <a name="percent" id="cdk8s-plus-28.PercentOrAbsolute.percent"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PercentOrAbsolute.percent(
  percent: typing.Union[int, float]
)
```

Percent ratio.

###### `percent`<sup>Required</sup> <a name="percent" id="cdk8s-plus-28.PercentOrAbsolute.percent.parameter.percent"></a>

- *Type:* typing.Union[int, float]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.property.value">value</a></code> | <code>typing.Any</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.PercentOrAbsolute.property.value"></a>

```python
value: typing.Any
```

- *Type:* typing.Any

---


### PodConnections <a name="PodConnections" id="cdk8s-plus-28.PodConnections"></a>

Controls network isolation rules for inter-pod communication.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodConnections.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodConnections(
  instance: AbstractPod
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnections.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.PodConnections.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnections.allowFrom">allow_from</a></code> | Allow network traffic from the peer to this pod. |
| <code><a href="#cdk8s-plus-28.PodConnections.allowTo">allow_to</a></code> | Allow network traffic from this pod to the peer. |
| <code><a href="#cdk8s-plus-28.PodConnections.isolate">isolate</a></code> | Sets the default network policy for Pod/Workload to have all egress and ingress connections as disabled. |

---

##### `allow_from` <a name="allow_from" id="cdk8s-plus-28.PodConnections.allowFrom"></a>

```python
def allow_from(
  peer: INetworkPolicyPeer,
  isolation: PodConnectionsIsolation = None,
  ports: typing.List[NetworkPolicyPort] = None
) -> None
```

Allow network traffic from the peer to this pod.

By default, this will create an ingress network policy for this pod, and an egress
network policy for the peer. This is required if both sides are already isolated.
Use `options.isolation` to control this behavior.

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
# create only an egress policy that selects the 'web' pod to allow outgoing traffic
# to the 'redis' pod. this requires the 'redis' pod to not be isolated for ingress.
redis.connections.allow_from(web, isolation=Isolation.PEER)

# create only an ingress policy that selects the 'redis' peer to allow incoming traffic
# from the 'web' pod. this requires the 'web' pod to not be isolated for egress.
redis.connections.allow_from(web, isolation=Isolation.POD)
```


###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.PodConnections.allowFrom.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnections.allowFrom.parameter.isolation"></a>

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnections.allowFrom.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* The pod ports.

Ports to allow incoming traffic to.

---

##### `allow_to` <a name="allow_to" id="cdk8s-plus-28.PodConnections.allowTo"></a>

```python
def allow_to(
  peer: INetworkPolicyPeer,
  isolation: PodConnectionsIsolation = None,
  ports: typing.List[NetworkPolicyPort] = None
) -> None
```

Allow network traffic from this pod to the peer.

By default, this will create an egress network policy for this pod, and an ingress
network policy for the peer. This is required if both sides are already isolated.
Use `options.isolation` to control this behavior.

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
# create only an egress policy that selects the 'web' pod to allow outgoing traffic
# to the 'redis' pod. this requires the 'redis' pod to not be isolated for ingress.
web.connections.allow_to(redis, isolation=Isolation.POD)

# create only an ingress policy that selects the 'redis' peer to allow incoming traffic
# from the 'web' pod. this requires the 'web' pod to not be isolated for egress.
web.connections.allow_to(redis, isolation=Isolation.PEER)
```


###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.PodConnections.allowTo.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnections.allowTo.parameter.isolation"></a>

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnections.allowTo.parameter.ports"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>]
- *Default:* If the peer is a managed pod, take its ports. Otherwise, all ports are allowed.

Ports to allow outgoing traffic to.

---

##### `isolate` <a name="isolate" id="cdk8s-plus-28.PodConnections.isolate"></a>

```python
def isolate() -> None
```

Sets the default network policy for Pod/Workload to have all egress and ingress connections as disabled.




### PodDns <a name="PodDns" id="cdk8s-plus-28.PodDns"></a>

Holds dns settings of the pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodDns.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodDns(
  hostname: str = None,
  hostname_as_fqd_n: bool = None,
  nameservers: typing.List[str] = None,
  options: typing.List[DnsOption] = None,
  policy: DnsPolicy = None,
  searches: typing.List[str] = None,
  subdomain: str = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.hostname">hostname</a></code> | <code>str</code> | Specifies the hostname of the Pod. |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.hostnameAsFQDN">hostname_as_fqd_n</a></code> | <code>bool</code> | If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.nameservers">nameservers</a></code> | <code>typing.List[str]</code> | A list of IP addresses that will be used as DNS servers for the Pod. |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.options">options</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]</code> | List of objects where each object may have a name property (required) and a value property (optional). |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.policy">policy</a></code> | <code><a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a></code> | Set DNS policy for the pod. |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.searches">searches</a></code> | <code>typing.List[str]</code> | A list of DNS search domains for hostname lookup in the Pod. |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.subdomain">subdomain</a></code> | <code>str</code> | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". |

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.PodDns.Initializer.parameter.hostname"></a>

- *Type:* str
- *Default:* Set to a system-defined value.

Specifies the hostname of the Pod.

---

##### `hostname_as_fqd_n`<sup>Optional</sup> <a name="hostname_as_fqd_n" id="cdk8s-plus-28.PodDns.Initializer.parameter.hostnameAsFQDN"></a>

- *Type:* bool
- *Default:* false

If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).

In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname).
In Windows containers, this means setting the registry value of hostname for the registry
key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN.
If a pod does not have FQDN, this has no effect.

---

##### `nameservers`<sup>Optional</sup> <a name="nameservers" id="cdk8s-plus-28.PodDns.Initializer.parameter.nameservers"></a>

- *Type:* typing.List[str]

A list of IP addresses that will be used as DNS servers for the Pod.

There can be at most 3 IP addresses specified.
When the policy is set to "NONE", the list must contain at least one IP address,
otherwise this property is optional.
The servers listed will be combined to the base nameservers generated from
the specified DNS policy with duplicate addresses removed.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodDns.Initializer.parameter.options"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]

List of objects where each object may have a name property (required) and a value property (optional).

The contents in this property
will be merged to the options generated from the specified DNS policy.
Duplicate entries are removed.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk8s-plus-28.PodDns.Initializer.parameter.policy"></a>

- *Type:* <a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a>
- *Default:* DnsPolicy.CLUSTER_FIRST

Set DNS policy for the pod.

If policy is set to `None`, other configuration must be supplied.

---

##### `searches`<sup>Optional</sup> <a name="searches" id="cdk8s-plus-28.PodDns.Initializer.parameter.searches"></a>

- *Type:* typing.List[str]

A list of DNS search domains for hostname lookup in the Pod.

When specified, the provided list will be merged into the base
search domain names generated from the chosen DNS policy.
Duplicate domain names are removed.

Kubernetes allows for at most 6 search domains.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.PodDns.Initializer.parameter.subdomain"></a>

- *Type:* str
- *Default:* No subdomain.

If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>".

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.addNameserver">add_nameserver</a></code> | Add a nameserver. |
| <code><a href="#cdk8s-plus-28.PodDns.addOption">add_option</a></code> | Add a custom option. |
| <code><a href="#cdk8s-plus-28.PodDns.addSearch">add_search</a></code> | Add a search domain. |

---

##### `add_nameserver` <a name="add_nameserver" id="cdk8s-plus-28.PodDns.addNameserver"></a>

```python
def add_nameserver(
  nameservers: str
) -> None
```

Add a nameserver.

###### `nameservers`<sup>Required</sup> <a name="nameservers" id="cdk8s-plus-28.PodDns.addNameserver.parameter.nameservers"></a>

- *Type:* str

---

##### `add_option` <a name="add_option" id="cdk8s-plus-28.PodDns.addOption"></a>

```python
def add_option(
  name: str,
  value: str = None
) -> None
```

Add a custom option.

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.PodDns.addOption.parameter.name"></a>

- *Type:* str

Option name.

---

###### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.PodDns.addOption.parameter.value"></a>

- *Type:* str
- *Default:* No value.

Option value.

---

##### `add_search` <a name="add_search" id="cdk8s-plus-28.PodDns.addSearch"></a>

```python
def add_search(
  searches: str
) -> None
```

Add a search domain.

###### `searches`<sup>Required</sup> <a name="searches" id="cdk8s-plus-28.PodDns.addSearch.parameter.searches"></a>

- *Type:* str

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.property.hostnameAsFQDN">hostname_as_fqd_n</a></code> | <code>bool</code> | Whether or not the pods hostname is set to its FQDN. |
| <code><a href="#cdk8s-plus-28.PodDns.property.nameservers">nameservers</a></code> | <code>typing.List[str]</code> | Nameservers defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.options">options</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]</code> | Custom dns options defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.policy">policy</a></code> | <code><a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a></code> | The DNS policy of this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.searches">searches</a></code> | <code>typing.List[str]</code> | Search domains defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.hostname">hostname</a></code> | <code>str</code> | The configured hostname of the pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.subdomain">subdomain</a></code> | <code>str</code> | The configured subdomain of the pod. |

---

##### `hostname_as_fqd_n`<sup>Required</sup> <a name="hostname_as_fqd_n" id="cdk8s-plus-28.PodDns.property.hostnameAsFQDN"></a>

```python
hostname_as_fqd_n: bool
```

- *Type:* bool

Whether or not the pods hostname is set to its FQDN.

---

##### `nameservers`<sup>Required</sup> <a name="nameservers" id="cdk8s-plus-28.PodDns.property.nameservers"></a>

```python
nameservers: typing.List[str]
```

- *Type:* typing.List[str]

Nameservers defined for this pod.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.PodDns.property.options"></a>

```python
options: typing.List[DnsOption]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.DnsOption">DnsOption</a>]

Custom dns options defined for this pod.

---

##### `policy`<sup>Required</sup> <a name="policy" id="cdk8s-plus-28.PodDns.property.policy"></a>

```python
policy: DnsPolicy
```

- *Type:* <a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a>

The DNS policy of this pod.

---

##### `searches`<sup>Required</sup> <a name="searches" id="cdk8s-plus-28.PodDns.property.searches"></a>

```python
searches: typing.List[str]
```

- *Type:* typing.List[str]

Search domains defined for this pod.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.PodDns.property.hostname"></a>

```python
hostname: str
```

- *Type:* str

The configured hostname of the pod.

Undefined means its set to a system-defined value.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.PodDns.property.subdomain"></a>

```python
subdomain: str
```

- *Type:* str

The configured subdomain of the pod.

---


### PodScheduling <a name="PodScheduling" id="cdk8s-plus-28.PodScheduling"></a>

Controls the pod scheduling strategy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodScheduling.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodScheduling(
  instance: AbstractPod
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodScheduling.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.PodScheduling.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodScheduling.assign">assign</a></code> | Assign this pod a specific node by name. |
| <code><a href="#cdk8s-plus-28.PodScheduling.attract">attract</a></code> | Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`. |
| <code><a href="#cdk8s-plus-28.PodScheduling.colocate">colocate</a></code> | Co-locate this pod with a scheduling selection. |
| <code><a href="#cdk8s-plus-28.PodScheduling.separate">separate</a></code> | Seperate this pod from a scheduling selection. |
| <code><a href="#cdk8s-plus-28.PodScheduling.tolerate">tolerate</a></code> | Allow this pod to tolerate taints matching these tolerations. |

---

##### `assign` <a name="assign" id="cdk8s-plus-28.PodScheduling.assign"></a>

```python
def assign(
  node: NamedNode
) -> None
```

Assign this pod a specific node by name.

The scheduler ignores the Pod, and the kubelet on the named node
tries to place the Pod on that node. Overrules any affinity rules of the pod.

Some limitations of static assignment are:

* If the named node does not exist, the Pod will not run, and in some
  cases may be automatically deleted.
* If the named node does not have the resources to accommodate the Pod,
  the Pod will fail and its reason will indicate why, for example OutOfmemory or OutOfcpu.
* Node names in cloud environments are not always predictable or stable.

Will throw is the pod is already assigned to named node.

Under the hood, this method utilizes the `nodeName` property.

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.assign.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.NamedNode">NamedNode</a>

---

##### `attract` <a name="attract" id="cdk8s-plus-28.PodScheduling.attract"></a>

```python
def attract(
  node: LabeledNode,
  weight: typing.Union[int, float] = None
) -> None
```

Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`.

Attracting to multiple nodes (i.e invoking this method multiple times) acts as
an OR condition, meaning the pod will be assigned to either one of the nodes.

Under the hood, this method utilizes the `nodeAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.attract.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.LabeledNode">LabeledNode</a>

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodScheduling.attract.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. assignment is assumed to be required (hard).

Indicates the attraction is optional (soft), with this weight score.

---

##### `colocate` <a name="colocate" id="cdk8s-plus-28.PodScheduling.colocate"></a>

```python
def colocate(
  selector: IPodSelector,
  topology: Topology = None,
  weight: typing.Union[int, float] = None
) -> None
```

Co-locate this pod with a scheduling selection.

A selection can be one of:

* An instance of a `Pod`.
* An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
* An un-managed pod that can be selected via `Pods.select()`.

Co-locating with multiple selections ((i.e invoking this method multiple times)) acts as
an AND condition. meaning the pod will be assigned to a node that satisfies all
selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.PodScheduling.colocate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodScheduling.colocate.parameter.topology"></a>

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to coloate on.

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodScheduling.colocate.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. co-location is assumed to be required (hard).

Indicates the co-location is optional (soft), with this weight score.

---

##### `separate` <a name="separate" id="cdk8s-plus-28.PodScheduling.separate"></a>

```python
def separate(
  selector: IPodSelector,
  topology: Topology = None,
  weight: typing.Union[int, float] = None
) -> None
```

Seperate this pod from a scheduling selection.

A selection can be one of:

* An instance of a `Pod`.
* An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
* An un-managed pod that can be selected via `Pods.select()`.

Seperating from multiple selections acts as an AND condition. meaning the pod
will not be assigned to a node that satisfies all selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAntiAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.PodScheduling.separate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodScheduling.separate.parameter.topology"></a>

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to separate on.

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodScheduling.separate.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. separation is assumed to be required (hard).

Indicates the separation is optional (soft), with this weight score.

---

##### `tolerate` <a name="tolerate" id="cdk8s-plus-28.PodScheduling.tolerate"></a>

```python
def tolerate(
  node: TaintedNode
) -> None
```

Allow this pod to tolerate taints matching these tolerations.

You can put multiple taints on the same node and multiple tolerations on the same pod.
The way Kubernetes processes multiple taints and tolerations is like a filter: start with
all of a node's taints, then ignore the ones for which the pod has a matching toleration;
the remaining un-ignored taints have the indicated effects on the pod. In particular:

* if there is at least one un-ignored taint with effect NoSchedule then Kubernetes will
  not schedule the pod onto that node
* if there is no un-ignored taint with effect NoSchedule but there is at least one un-ignored
  taint with effect PreferNoSchedule then Kubernetes will try to not schedule the pod onto the node
* if there is at least one un-ignored taint with effect NoExecute then the pod will be evicted from
  the node (if it is already running on the node), and will not be scheduled onto the node (if it is
  not yet running on the node).

Under the hood, this method utilizes the `tolerations` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/](https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.tolerate.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintedNode">TaintedNode</a>

---




### PodSecurityContext <a name="PodSecurityContext" id="cdk8s-plus-28.PodSecurityContext"></a>

Holds pod-level security attributes and common container settings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodSecurityContext.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.PodSecurityContext(
  ensure_non_root: bool = None,
  fs_group: typing.Union[int, float] = None,
  fs_group_change_policy: FsGroupChangePolicy = None,
  group: typing.Union[int, float] = None,
  sysctls: typing.List[Sysctl] = None,
  user: typing.Union[int, float] = None
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.fsGroup">fs_group</a></code> | <code>typing.Union[int, float]</code> | Modify the ownership and permissions of pod volumes to this GID. |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.fsGroupChangePolicy">fs_group_change_policy</a></code> | <code><a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a></code> | Defines behavior of changing ownership and permission of the volume before being exposed inside Pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.group">group</a></code> | <code>typing.Union[int, float]</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.sysctls">sysctls</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]</code> | Sysctls hold a list of namespaced sysctls used for the pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.user">user</a></code> | <code>typing.Union[int, float]</code> | The UID to run the entrypoint of the container process. |

---

##### `ensure_non_root`<sup>Optional</sup> <a name="ensure_non_root" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.ensureNonRoot"></a>

- *Type:* bool
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `fs_group`<sup>Optional</sup> <a name="fs_group" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.fsGroup"></a>

- *Type:* typing.Union[int, float]
- *Default:* Volume ownership is not changed.

Modify the ownership and permissions of pod volumes to this GID.

---

##### `fs_group_change_policy`<sup>Optional</sup> <a name="fs_group_change_policy" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.fsGroupChangePolicy"></a>

- *Type:* <a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a>
- *Default:* FsGroupChangePolicy.ALWAYS

Defines behavior of changing ownership and permission of the volume before being exposed inside Pod.

This field will only apply to volume types which support fsGroup based ownership(and permissions).
It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.group"></a>

- *Type:* typing.Union[int, float]
- *Default:* Group configured by container runtime

The GID to run the entrypoint of the container process.

---

##### `sysctls`<sup>Optional</sup> <a name="sysctls" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.sysctls"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]
- *Default:* No sysctls

Sysctls hold a list of namespaced sysctls used for the pod.

Pods with unsupported sysctls (by the container runtime) might fail to launch.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.user"></a>

- *Type:* typing.Union[int, float]
- *Default:* User specified in image metadata

The UID to run the entrypoint of the container process.

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.ensureNonRoot">ensure_non_root</a></code> | <code>bool</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.fsGroupChangePolicy">fs_group_change_policy</a></code> | <code><a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.sysctls">sysctls</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.fsGroup">fs_group</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.group">group</a></code> | <code>typing.Union[int, float]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.user">user</a></code> | <code>typing.Union[int, float]</code> | *No description.* |

---

##### `ensure_non_root`<sup>Required</sup> <a name="ensure_non_root" id="cdk8s-plus-28.PodSecurityContext.property.ensureNonRoot"></a>

```python
ensure_non_root: bool
```

- *Type:* bool

---

##### `fs_group_change_policy`<sup>Required</sup> <a name="fs_group_change_policy" id="cdk8s-plus-28.PodSecurityContext.property.fsGroupChangePolicy"></a>

```python
fs_group_change_policy: FsGroupChangePolicy
```

- *Type:* <a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a>

---

##### `sysctls`<sup>Required</sup> <a name="sysctls" id="cdk8s-plus-28.PodSecurityContext.property.sysctls"></a>

```python
sysctls: typing.List[Sysctl]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.Sysctl">Sysctl</a>]

---

##### `fs_group`<sup>Optional</sup> <a name="fs_group" id="cdk8s-plus-28.PodSecurityContext.property.fsGroup"></a>

```python
fs_group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.PodSecurityContext.property.group"></a>

```python
group: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.PodSecurityContext.property.user"></a>

```python
user: typing.Union[int, float]
```

- *Type:* typing.Union[int, float]

---


### Probe <a name="Probe" id="cdk8s-plus-28.Probe"></a>

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Probe.fromCommand">from_command</a></code> | Defines a probe based on a command which is executed within the container. |
| <code><a href="#cdk8s-plus-28.Probe.fromHttpGet">from_http_get</a></code> | Defines a probe based on an HTTP GET request to the IP address of the container. |
| <code><a href="#cdk8s-plus-28.Probe.fromTcpSocket">from_tcp_socket</a></code> | Defines a probe based opening a connection to a TCP socket on the container. |

---

##### `from_command` <a name="from_command" id="cdk8s-plus-28.Probe.fromCommand"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Probe.from_command(
  command: typing.List[str],
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None
)
```

Defines a probe based on a command which is executed within the container.

###### `command`<sup>Required</sup> <a name="command" id="cdk8s-plus-28.Probe.fromCommand.parameter.command"></a>

- *Type:* typing.List[str]

The command to execute.

---

###### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.Probe.fromCommand.parameter.failureThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

###### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.Probe.fromCommand.parameter.initialDelaySeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

###### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.Probe.fromCommand.parameter.periodSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

###### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.Probe.fromCommand.parameter.successThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

###### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.Probe.fromCommand.parameter.timeoutSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `from_http_get` <a name="from_http_get" id="cdk8s-plus-28.Probe.fromHttpGet"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Probe.from_http_get(
  path: str,
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None,
  host: str = None,
  port: typing.Union[int, float] = None,
  scheme: ConnectionScheme = None
)
```

Defines a probe based on an HTTP GET request to the IP address of the container.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.path"></a>

- *Type:* str

The URL path to hit.

---

###### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.failureThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

###### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.initialDelaySeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

###### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.periodSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

###### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.successThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

###### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.timeoutSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

###### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.host"></a>

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

###### `scheme`<sup>Optional</sup> <a name="scheme" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.scheme"></a>

- *Type:* <a href="#cdk8s-plus-28.ConnectionScheme">ConnectionScheme</a>
- *Default:* ConnectionScheme.HTTP

Scheme to use for connecting to the host (HTTP or HTTPS).

---

##### `from_tcp_socket` <a name="from_tcp_socket" id="cdk8s-plus-28.Probe.fromTcpSocket"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Probe.from_tcp_socket(
  failure_threshold: typing.Union[int, float] = None,
  initial_delay_seconds: Duration = None,
  period_seconds: Duration = None,
  success_threshold: typing.Union[int, float] = None,
  timeout_seconds: Duration = None,
  host: str = None,
  port: typing.Union[int, float] = None
)
```

Defines a probe based opening a connection to a TCP socket on the container.

###### `failure_threshold`<sup>Optional</sup> <a name="failure_threshold" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.failureThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

###### `initial_delay_seconds`<sup>Optional</sup> <a name="initial_delay_seconds" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.initialDelaySeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

###### `period_seconds`<sup>Optional</sup> <a name="period_seconds" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.periodSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

###### `success_threshold`<sup>Optional</sup> <a name="success_threshold" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.successThreshold"></a>

- *Type:* typing.Union[int, float]
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

###### `timeout_seconds`<sup>Optional</sup> <a name="timeout_seconds" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.timeoutSeconds"></a>

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

###### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.host"></a>

- *Type:* str
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

###### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.port"></a>

- *Type:* typing.Union[int, float]
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---



### Quantity <a name="Quantity" id="cdk8s-plus-28.k8s.Quantity"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.fromNumber">from_number</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.fromString">from_string</a></code> | *No description.* |

---

##### `from_number` <a name="from_number" id="cdk8s-plus-28.k8s.Quantity.fromNumber"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Quantity.from_number(
  value: typing.Union[int, float]
)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.fromNumber.parameter.value"></a>

- *Type:* typing.Union[int, float]

---

##### `from_string` <a name="from_string" id="cdk8s-plus-28.k8s.Quantity.fromString"></a>

```python
from cdk8s_plus_28 import k8s

k8s.Quantity.from_string(
  value: str
)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.fromString.parameter.value"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.property.value">value</a></code> | <code>typing.Union[str, typing.Union[int, float]]</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.property.value"></a>

```python
value: typing.Union[str, typing.Union[int, float]]
```

- *Type:* typing.Union[str, typing.Union[int, float]]

---


### Replicas <a name="Replicas" id="cdk8s-plus-28.Replicas"></a>

The amount of replicas that will change.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Replicas.absolute">absolute</a></code> | Changes the pods by a percentage of the it's current value. |
| <code><a href="#cdk8s-plus-28.Replicas.percent">percent</a></code> | Changes the pods by a percentage of the it's current value. |

---

##### `absolute` <a name="absolute" id="cdk8s-plus-28.Replicas.absolute"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Replicas.absolute(
  value: typing.Union[int, float]
)
```

Changes the pods by a percentage of the it's current value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Replicas.absolute.parameter.value"></a>

- *Type:* typing.Union[int, float]

The amount of change to apply.

Must be greater than 0.

---

##### `percent` <a name="percent" id="cdk8s-plus-28.Replicas.percent"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Replicas.percent(
  value: typing.Union[int, float]
)
```

Changes the pods by a percentage of the it's current value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Replicas.percent.parameter.value"></a>

- *Type:* typing.Union[int, float]

The percentage of change to apply.

Must be greater than 0.

---



### ResourcePermissions <a name="ResourcePermissions" id="cdk8s-plus-28.ResourcePermissions"></a>

Controls permissions for operations on resources.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ResourcePermissions.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.ResourcePermissions(
  instance: Resource
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.Resource">Resource</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.ResourcePermissions.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.Resource">Resource</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.grantRead">grant_read</a></code> | Grants the list of subjects permissions to read this resource. |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.grantReadWrite">grant_read_write</a></code> | Grants the list of subjects permissions to read and write this resource. |

---

##### `grant_read` <a name="grant_read" id="cdk8s-plus-28.ResourcePermissions.grantRead"></a>

```python
def grant_read(
  subjects: ISubject
) -> RoleBinding
```

Grants the list of subjects permissions to read this resource.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ResourcePermissions.grantRead.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

---

##### `grant_read_write` <a name="grant_read_write" id="cdk8s-plus-28.ResourcePermissions.grantReadWrite"></a>

```python
def grant_read_write(
  subjects: ISubject
) -> RoleBinding
```

Grants the list of subjects permissions to read and write this resource.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ResourcePermissions.grantReadWrite.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

---




### StatefulSetUpdateStrategy <a name="StatefulSetUpdateStrategy" id="cdk8s-plus-28.StatefulSetUpdateStrategy"></a>

StatefulSet update strategies.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy.onDelete">on_delete</a></code> | The controller will not automatically update the Pods in a StatefulSet. |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate">rolling_update</a></code> | The controller will delete and recreate each Pod in the StatefulSet. |

---

##### `on_delete` <a name="on_delete" id="cdk8s-plus-28.StatefulSetUpdateStrategy.onDelete"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSetUpdateStrategy.on_delete()
```

The controller will not automatically update the Pods in a StatefulSet.

Users must manually delete Pods to cause the controller to create new Pods
that reflect modifications.

##### `rolling_update` <a name="rolling_update" id="cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.StatefulSetUpdateStrategy.rolling_update(
  partition: typing.Union[int, float] = None
)
```

The controller will delete and recreate each Pod in the StatefulSet.

It will proceed in the same order as Pod termination (from the largest ordinal to the smallest),
updating each Pod one at a time. The Kubernetes control plane waits until an updated
Pod is Running and Ready prior to updating its predecessor.

###### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate.parameter.partition"></a>

- *Type:* typing.Union[int, float]
- *Default:* 0

If specified, all Pods with an ordinal that is greater than or equal to the partition will be updated when the StatefulSet's .spec.template is updated. All Pods with an ordinal that is less than the partition will not be updated, and, even if they are deleted, they will be recreated at the previous version.

If the partition is greater than replicas, updates to the pod template will not be propagated to Pods.
In most cases you will not need to use a partition, but they are useful if you want to stage an
update, roll out a canary, or perform a phased roll out.

> [https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions](https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions)

---



### TaintedNode <a name="TaintedNode" id="cdk8s-plus-28.TaintedNode"></a>

A node that is matched by taint selectors.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.TaintedNode.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.TaintedNode(
  taint_selector: typing.List[NodeTaintQuery]
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TaintedNode.Initializer.parameter.taintSelector">taint_selector</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>]</code> | *No description.* |

---

##### `taint_selector`<sup>Required</sup> <a name="taint_selector" id="cdk8s-plus-28.TaintedNode.Initializer.parameter.taintSelector"></a>

- *Type:* typing.List[<a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>]

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TaintedNode.property.taintSelector">taint_selector</a></code> | <code>typing.List[<a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>]</code> | *No description.* |

---

##### `taint_selector`<sup>Required</sup> <a name="taint_selector" id="cdk8s-plus-28.TaintedNode.property.taintSelector"></a>

```python
taint_selector: typing.List[NodeTaintQuery]
```

- *Type:* typing.List[<a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>]

---


### Topology <a name="Topology" id="cdk8s-plus-28.Topology"></a>

Available topology domains.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.custom">custom</a></code> | Custom key for the node label that the system uses to denote the topology domain. |

---

##### `custom` <a name="custom" id="cdk8s-plus-28.Topology.custom"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.Topology.custom(
  key: str
)
```

Custom key for the node label that the system uses to denote the topology domain.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Topology.custom.parameter.key"></a>

- *Type:* str

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.property.key">key</a></code> | <code>str</code> | *No description.* |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Topology.property.key"></a>

```python
key: str
```

- *Type:* str

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.property.HOSTNAME">HOSTNAME</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A hostname represents a single node in the cluster. |
| <code><a href="#cdk8s-plus-28.Topology.property.REGION">REGION</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A region represents a larger domain, made up of one or more zones. |
| <code><a href="#cdk8s-plus-28.Topology.property.ZONE">ZONE</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A zone represents a logical failure domain. |

---

##### `HOSTNAME`<sup>Required</sup> <a name="HOSTNAME" id="cdk8s-plus-28.Topology.property.HOSTNAME"></a>

```python
HOSTNAME: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A hostname represents a single node in the cluster.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#kubernetesiohostname](https://kubernetes.io/docs/reference/labels-annotations-taints/#kubernetesiohostname)

---

##### `REGION`<sup>Required</sup> <a name="REGION" id="cdk8s-plus-28.Topology.property.REGION"></a>

```python
REGION: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A region represents a larger domain, made up of one or more zones.

It is uncommon
for Kubernetes clusters to span multiple regions. While the exact definition of a
zone or region is left to infrastructure implementations, common properties of a region
include higher network latency between them than within them, non-zero cost for network
traffic between them, and failure independence from other zones or regions.

For example, nodes within a region might share power infrastructure (e.g. a UPS or generator), but
nodes in different regions typically would not.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesioregion](https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesioregion)

---

##### `ZONE`<sup>Required</sup> <a name="ZONE" id="cdk8s-plus-28.Topology.property.ZONE"></a>

```python
ZONE: Topology
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A zone represents a logical failure domain.

It is common for Kubernetes clusters to
span multiple zones for increased availability. While the exact definition of a zone is
left to infrastructure implementations, common properties of a zone include very low
network latency within a zone, no-cost network traffic within a zone, and failure
independence from other zones. For example, nodes within a zone might share a network
switch, but nodes in different zones should not.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesiozone](https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesiozone)

---

### WorkloadScheduling <a name="WorkloadScheduling" id="cdk8s-plus-28.WorkloadScheduling"></a>

Controls the pod scheduling strategy of this workload.

It offers some additional API's on top of the core pod scheduling.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.WorkloadScheduling.Initializer"></a>

```python
import cdk8s_plus_28

cdk8s_plus_28.WorkloadScheduling(
  instance: AbstractPod
)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.WorkloadScheduling.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.assign">assign</a></code> | Assign this pod a specific node by name. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.attract">attract</a></code> | Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.colocate">colocate</a></code> | Co-locate this pod with a scheduling selection. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.separate">separate</a></code> | Seperate this pod from a scheduling selection. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.tolerate">tolerate</a></code> | Allow this pod to tolerate taints matching these tolerations. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.spread">spread</a></code> | Spread the pods in this workload by the topology key. |

---

##### `assign` <a name="assign" id="cdk8s-plus-28.WorkloadScheduling.assign"></a>

```python
def assign(
  node: NamedNode
) -> None
```

Assign this pod a specific node by name.

The scheduler ignores the Pod, and the kubelet on the named node
tries to place the Pod on that node. Overrules any affinity rules of the pod.

Some limitations of static assignment are:

* If the named node does not exist, the Pod will not run, and in some
  cases may be automatically deleted.
* If the named node does not have the resources to accommodate the Pod,
  the Pod will fail and its reason will indicate why, for example OutOfmemory or OutOfcpu.
* Node names in cloud environments are not always predictable or stable.

Will throw is the pod is already assigned to named node.

Under the hood, this method utilizes the `nodeName` property.

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.assign.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.NamedNode">NamedNode</a>

---

##### `attract` <a name="attract" id="cdk8s-plus-28.WorkloadScheduling.attract"></a>

```python
def attract(
  node: LabeledNode,
  weight: typing.Union[int, float] = None
) -> None
```

Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`.

Attracting to multiple nodes (i.e invoking this method multiple times) acts as
an OR condition, meaning the pod will be assigned to either one of the nodes.

Under the hood, this method utilizes the `nodeAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.attract.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.LabeledNode">LabeledNode</a>

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadScheduling.attract.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. assignment is assumed to be required (hard).

Indicates the attraction is optional (soft), with this weight score.

---

##### `colocate` <a name="colocate" id="cdk8s-plus-28.WorkloadScheduling.colocate"></a>

```python
def colocate(
  selector: IPodSelector,
  topology: Topology = None,
  weight: typing.Union[int, float] = None
) -> None
```

Co-locate this pod with a scheduling selection.

A selection can be one of:

* An instance of a `Pod`.
* An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
* An un-managed pod that can be selected via `Pods.select()`.

Co-locating with multiple selections ((i.e invoking this method multiple times)) acts as
an AND condition. meaning the pod will be assigned to a node that satisfies all
selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.WorkloadScheduling.colocate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.WorkloadScheduling.colocate.parameter.topology"></a>

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to coloate on.

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadScheduling.colocate.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. co-location is assumed to be required (hard).

Indicates the co-location is optional (soft), with this weight score.

---

##### `separate` <a name="separate" id="cdk8s-plus-28.WorkloadScheduling.separate"></a>

```python
def separate(
  selector: IPodSelector,
  topology: Topology = None,
  weight: typing.Union[int, float] = None
) -> None
```

Seperate this pod from a scheduling selection.

A selection can be one of:

* An instance of a `Pod`.
* An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
* An un-managed pod that can be selected via `Pods.select()`.

Seperating from multiple selections acts as an AND condition. meaning the pod
will not be assigned to a node that satisfies all selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAntiAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.WorkloadScheduling.separate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.WorkloadScheduling.separate.parameter.topology"></a>

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to separate on.

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadScheduling.separate.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. separation is assumed to be required (hard).

Indicates the separation is optional (soft), with this weight score.

---

##### `tolerate` <a name="tolerate" id="cdk8s-plus-28.WorkloadScheduling.tolerate"></a>

```python
def tolerate(
  node: TaintedNode
) -> None
```

Allow this pod to tolerate taints matching these tolerations.

You can put multiple taints on the same node and multiple tolerations on the same pod.
The way Kubernetes processes multiple taints and tolerations is like a filter: start with
all of a node's taints, then ignore the ones for which the pod has a matching toleration;
the remaining un-ignored taints have the indicated effects on the pod. In particular:

* if there is at least one un-ignored taint with effect NoSchedule then Kubernetes will
  not schedule the pod onto that node
* if there is no un-ignored taint with effect NoSchedule but there is at least one un-ignored
  taint with effect PreferNoSchedule then Kubernetes will try to not schedule the pod onto the node
* if there is at least one un-ignored taint with effect NoExecute then the pod will be evicted from
  the node (if it is already running on the node), and will not be scheduled onto the node (if it is
  not yet running on the node).

Under the hood, this method utilizes the `tolerations` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/](https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.tolerate.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintedNode">TaintedNode</a>

---

##### `spread` <a name="spread" id="cdk8s-plus-28.WorkloadScheduling.spread"></a>

```python
def spread(
  topology: Topology = None,
  weight: typing.Union[int, float] = None
) -> None
```

Spread the pods in this workload by the topology key.

A spread is a separation of the pod from itself and is used to
balance out pod replicas across a given topology.

###### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.WorkloadScheduling.spread.parameter.topology"></a>

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to spread on.

---

###### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadScheduling.spread.parameter.weight"></a>

- *Type:* typing.Union[int, float]
- *Default:* no weight. spread is assumed to be required.

Indicates the spread is optional, with this weight score.

---




## Protocols <a name="Protocols" id="Protocols"></a>

### IApiEndpoint <a name="IApiEndpoint" id="cdk8s-plus-28.IApiEndpoint"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.NonApiResource">NonApiResource</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

An API Endpoint can either be a resource descriptor (e.g /pods) or a non resource url (e.g /healthz). It must be one or the other, and not both.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IApiEndpoint.asApiResource">as_api_resource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.IApiEndpoint.asNonApiResource">as_non_api_resource</a></code> | Return the non resource url this object represents. |

---

##### `as_api_resource` <a name="as_api_resource" id="cdk8s-plus-28.IApiEndpoint.asApiResource"></a>

```python
def as_api_resource() -> IApiResource
```

Return the IApiResource this object represents.

##### `as_non_api_resource` <a name="as_non_api_resource" id="cdk8s-plus-28.IApiEndpoint.asNonApiResource"></a>

```python
def as_non_api_resource() -> str
```

Return the non resource url this object represents.


### IApiResource <a name="IApiResource" id="cdk8s-plus-28.IApiResource"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

Represents a resource or collection of resources.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IApiResource.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IApiResource.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IApiResource.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IApiResource.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IApiResource.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IApiResource.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

### IClusterRole <a name="IClusterRole" id="cdk8s-plus-28.IClusterRole"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

Represents a cluster-level role.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IClusterRole.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IClusterRole.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IClusterRole.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IClusterRole.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IClusterRole.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IClusterRole.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IClusterRole.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IConfigMap <a name="IConfigMap" id="cdk8s-plus-28.IConfigMap"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

Represents a config map.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IConfigMap.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IConfigMap.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IConfigMap.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IConfigMap.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IConfigMap.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IConfigMap.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IConfigMap.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### INamespaceSelector <a name="INamespaceSelector" id="cdk8s-plus-28.INamespaceSelector"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>, <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>

Represents an object that can select namespaces.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.INamespaceSelector.toNamespaceSelectorConfig">to_namespace_selector_config</a></code> | Return the configuration of this selector. |

---

##### `to_namespace_selector_config` <a name="to_namespace_selector_config" id="cdk8s-plus-28.INamespaceSelector.toNamespaceSelectorConfig"></a>

```python
def to_namespace_selector_config() -> NamespaceSelectorConfig
```

Return the configuration of this selector.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.INamespaceSelector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.INamespaceSelector.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

### INetworkPolicyPeer <a name="INetworkPolicyPeer" id="cdk8s-plus-28.INetworkPolicyPeer"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>, <a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Describes a peer to allow traffic to/from.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.toNetworkPolicyPeerConfig">to_network_policy_peer_config</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.toPodSelector">to_pod_selector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `to_network_policy_peer_config` <a name="to_network_policy_peer_config" id="cdk8s-plus-28.INetworkPolicyPeer.toNetworkPolicyPeerConfig"></a>

```python
def to_network_policy_peer_config() -> NetworkPolicyPeerConfig
```

Return the configuration of this peer.

##### `to_pod_selector` <a name="to_pod_selector" id="cdk8s-plus-28.INetworkPolicyPeer.toPodSelector"></a>

```python
def to_pod_selector() -> IPodSelector
```

Convert the peer into a pod selector, if possible.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.INetworkPolicyPeer.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

### IPersistentVolume <a name="IPersistentVolume" id="cdk8s-plus-28.IPersistentVolume"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

Contract of a `PersistentVolumeClaim`.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPersistentVolume.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IPersistentVolume.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IPersistentVolume.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IPersistentVolume.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IPersistentVolume.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IPersistentVolume.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IPersistentVolume.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IPersistentVolumeClaim <a name="IPersistentVolumeClaim" id="cdk8s-plus-28.IPersistentVolumeClaim"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

Contract of a `PersistentVolumeClaim`.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPersistentVolumeClaim.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IPersistentVolumeClaim.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IPersistentVolumeClaim.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IPersistentVolumeClaim.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IPersistentVolumeClaim.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IPersistentVolumeClaim.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IPersistentVolumeClaim.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IPodSelector <a name="IPodSelector" id="cdk8s-plus-28.IPodSelector"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Pods">Pods</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

Represents an object that can select pods.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IPodSelector.toPodSelectorConfig">to_pod_selector_config</a></code> | Return the configuration of this selector. |

---

##### `to_pod_selector_config` <a name="to_pod_selector_config" id="cdk8s-plus-28.IPodSelector.toPodSelectorConfig"></a>

```python
def to_pod_selector_config() -> PodSelectorConfig
```

Return the configuration of this selector.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPodSelector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPodSelector.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

### IResource <a name="IResource" id="cdk8s-plus-28.IResource"></a>

- *Extends:* constructs.IConstruct, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

Represents a resource.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IResource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IResource.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IResource.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IResource.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IResource.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IResource.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IResource.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IResource.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IResource.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IResource.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IResource.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IResource.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IResource.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IResource.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IRole <a name="IRole" id="cdk8s-plus-28.IRole"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>

A reference to any Role or ClusterRole.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IRole.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IRole.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IRole.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IRole.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IRole.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IRole.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IRole.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IRole.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IRole.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IRole.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IRole.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IRole.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IRole.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IScalable <a name="IScalable" id="cdk8s-plus-28.IScalable"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.IScalable">IScalable</a>

Represents a scalable workload.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IScalable.markHasAutoscaler">mark_has_autoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.IScalable.toScalingTarget">to_scaling_target</a></code> | Return the target spec properties of this Scalable. |

---

##### `mark_has_autoscaler` <a name="mark_has_autoscaler" id="cdk8s-plus-28.IScalable.markHasAutoscaler"></a>

```python
def mark_has_autoscaler() -> None
```

Called on all IScalable targets when they are associated with an autoscaler.

##### `to_scaling_target` <a name="to_scaling_target" id="cdk8s-plus-28.IScalable.toScalingTarget"></a>

```python
def to_scaling_target() -> ScalingTarget
```

Return the target spec properties of this Scalable.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IScalable.property.hasAutoscaler">has_autoscaler</a></code> | <code>bool</code> | If this is a target of an autoscaler. |

---

##### `has_autoscaler`<sup>Required</sup> <a name="has_autoscaler" id="cdk8s-plus-28.IScalable.property.hasAutoscaler"></a>

```python
has_autoscaler: bool
```

- *Type:* bool

If this is a target of an autoscaler.

---

### ISecret <a name="ISecret" id="cdk8s-plus-28.ISecret"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ISecret.envValue">env_value</a></code> | Returns EnvValue object from a secret's key. |

---

##### `env_value` <a name="env_value" id="cdk8s-plus-28.ISecret.envValue"></a>

```python
def env_value(
  key: str,
  optional: bool = None
) -> EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ISecret.envValue.parameter.key"></a>

- *Type:* str

Secret's key.

---

###### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.ISecret.envValue.parameter.optional"></a>

- *Type:* bool
- *Default:* false

Specify whether the Secret or its key must be defined.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ISecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ISecret.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ISecret.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ISecret.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ISecret.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ISecret.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ISecret.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ISecret.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.ISecret.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.ISecret.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.ISecret.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.ISecret.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ISecret.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ISecret.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IServiceAccount <a name="IServiceAccount" id="cdk8s-plus-28.IServiceAccount"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.apiGroup">api_group</a></code> | <code>str</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.resourceType">resource_type</a></code> | <code>str</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.resourceName">resource_name</a></code> | <code>str</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.apiVersion">api_version</a></code> | <code>str</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.kind">kind</a></code> | <code>str</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.name">name</a></code> | <code>str</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IServiceAccount.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

##### `api_group`<sup>Required</sup> <a name="api_group" id="cdk8s-plus-28.IServiceAccount.property.apiGroup"></a>

```python
api_group: str
```

- *Type:* str

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resource_type`<sup>Required</sup> <a name="resource_type" id="cdk8s-plus-28.IServiceAccount.property.resourceType"></a>

```python
resource_type: str
```

- *Type:* str

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```python
# Example automatically generated from non-compiling source. May contain errors.
-"pods"or"pods/log"
```


##### `resource_name`<sup>Optional</sup> <a name="resource_name" id="cdk8s-plus-28.IServiceAccount.property.resourceName"></a>

```python
resource_name: str
```

- *Type:* str

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `api_version`<sup>Required</sup> <a name="api_version" id="cdk8s-plus-28.IServiceAccount.property.apiVersion"></a>

```python
api_version: str
```

- *Type:* str

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IServiceAccount.property.kind"></a>

```python
kind: str
```

- *Type:* str

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IServiceAccount.property.name"></a>

```python
name: str
```

- *Type:* str

The Kubernetes name of this resource.

---

### IStorage <a name="IStorage" id="cdk8s-plus-28.IStorage"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.Volume">Volume</a>, <a href="#cdk8s-plus-28.IStorage">IStorage</a>

Represents a piece of storage in the cluster.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IStorage.asVolume">as_volume</a></code> | Convert the piece of storage into a concrete volume. |

---

##### `as_volume` <a name="as_volume" id="cdk8s-plus-28.IStorage.asVolume"></a>

```python
def as_volume() -> Volume
```

Convert the piece of storage into a concrete volume.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IStorage.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IStorage.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

### ISubject <a name="ISubject" id="cdk8s-plus-28.ISubject"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Group">Group</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.User">User</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents an object that can be used as a role binding subject.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ISubject.toSubjectConfiguration">to_subject_configuration</a></code> | Return the subject configuration. |

---

##### `to_subject_configuration` <a name="to_subject_configuration" id="cdk8s-plus-28.ISubject.toSubjectConfiguration"></a>

```python
def to_subject_configuration() -> SubjectConfiguration
```

Return the subject configuration.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ISubject.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ISubject.property.node"></a>

```python
node: Node
```

- *Type:* constructs.Node

The tree node.

---

## Enums <a name="Enums" id="Enums"></a>

### AzureDiskPersistentVolumeCachingMode <a name="AzureDiskPersistentVolumeCachingMode" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode"></a>

Azure disk caching modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.NONE">NONE</a></code> | None. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_ONLY">READ_ONLY</a></code> | ReadOnly. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_WRITE">READ_WRITE</a></code> | ReadWrite. |

---

##### `NONE` <a name="NONE" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.NONE"></a>

None.

---


##### `READ_ONLY` <a name="READ_ONLY" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_ONLY"></a>

ReadOnly.

---


##### `READ_WRITE` <a name="READ_WRITE" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_WRITE"></a>

ReadWrite.

---


### AzureDiskPersistentVolumeKind <a name="AzureDiskPersistentVolumeKind" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind"></a>

Azure Disk kinds.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.SHARED">SHARED</a></code> | Multiple blob disks per storage account. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.DEDICATED">DEDICATED</a></code> | Single blob disk per storage account. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.MANAGED">MANAGED</a></code> | Azure managed data disk. |

---

##### `SHARED` <a name="SHARED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.SHARED"></a>

Multiple blob disks per storage account.

---


##### `DEDICATED` <a name="DEDICATED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.DEDICATED"></a>

Single blob disk per storage account.

---


##### `MANAGED` <a name="MANAGED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.MANAGED"></a>

Azure managed data disk.

---


### Capability <a name="Capability" id="cdk8s-plus-28.Capability"></a>

Capability - complete list of POSIX capabilities.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Capability.ALL">ALL</a></code> | ALL. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_CONTROL">AUDIT_CONTROL</a></code> | CAP_AUDIT_CONTROL. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_READ">AUDIT_READ</a></code> | CAP_AUDIT_READ. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_WRITE">AUDIT_WRITE</a></code> | CAP_AUDIT_WRITE. |
| <code><a href="#cdk8s-plus-28.Capability.BLOCK_SUSPEND">BLOCK_SUSPEND</a></code> | CAP_BLOCK_SUSPEND. |
| <code><a href="#cdk8s-plus-28.Capability.BPF">BPF</a></code> | CAP_BPF. |
| <code><a href="#cdk8s-plus-28.Capability.CHECKPOINT_RESTORE">CHECKPOINT_RESTORE</a></code> | CAP_CHECKPOINT_RESTORE. |
| <code><a href="#cdk8s-plus-28.Capability.CHOWN">CHOWN</a></code> | CAP_CHOWN. |
| <code><a href="#cdk8s-plus-28.Capability.DAC_OVERRIDE">DAC_OVERRIDE</a></code> | CAP_DAC_OVERRIDE. |
| <code><a href="#cdk8s-plus-28.Capability.DAC_READ_SEARCH">DAC_READ_SEARCH</a></code> | CAP_DAC_READ_SEARCH. |
| <code><a href="#cdk8s-plus-28.Capability.FOWNER">FOWNER</a></code> | CAP_FOWNER. |
| <code><a href="#cdk8s-plus-28.Capability.FSETID">FSETID</a></code> | CAP_FSETID. |
| <code><a href="#cdk8s-plus-28.Capability.IPC_LOCK">IPC_LOCK</a></code> | CAP_IPC_LOCK. |
| <code><a href="#cdk8s-plus-28.Capability.IPC_OWNER">IPC_OWNER</a></code> | CAP_IPC_OWNER. |
| <code><a href="#cdk8s-plus-28.Capability.KILL">KILL</a></code> | CAP_KILL. |
| <code><a href="#cdk8s-plus-28.Capability.LEASE">LEASE</a></code> | CAP_LEASE. |
| <code><a href="#cdk8s-plus-28.Capability.LINUX_IMMUTABLE">LINUX_IMMUTABLE</a></code> | CAP_LINUX_IMMUTABLE. |
| <code><a href="#cdk8s-plus-28.Capability.MAC_ADMIN">MAC_ADMIN</a></code> | CAP_MAC_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.MAC_OVERRIDE">MAC_OVERRIDE</a></code> | CAP_MAC_OVERRIDE. |
| <code><a href="#cdk8s-plus-28.Capability.MKNOD">MKNOD</a></code> | CAP_MKNOD. |
| <code><a href="#cdk8s-plus-28.Capability.NET_ADMIN">NET_ADMIN</a></code> | CAP_NET_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.NET_BIND_SERVICE">NET_BIND_SERVICE</a></code> | CAP_NET_BIND_SERVICE. |
| <code><a href="#cdk8s-plus-28.Capability.NET_BROADCAST">NET_BROADCAST</a></code> | CAP_NET_BROADCAST. |
| <code><a href="#cdk8s-plus-28.Capability.NET_RAW">NET_RAW</a></code> | CAP_NET_RAW. |
| <code><a href="#cdk8s-plus-28.Capability.PERFMON">PERFMON</a></code> | CAP_PERFMON. |
| <code><a href="#cdk8s-plus-28.Capability.SETGID">SETGID</a></code> | CAP_SETGID. |
| <code><a href="#cdk8s-plus-28.Capability.SETFCAP">SETFCAP</a></code> | CAP_SETFCAP. |
| <code><a href="#cdk8s-plus-28.Capability.SETPCAP">SETPCAP</a></code> | CAP_SETPCAP. |
| <code><a href="#cdk8s-plus-28.Capability.SETUID">SETUID</a></code> | CAP_SETUID. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_ADMIN">SYS_ADMIN</a></code> | CAP_SYS_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_BOOT">SYS_BOOT</a></code> | CAP_SYS_BOOT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_CHROOT">SYS_CHROOT</a></code> | CAP_SYS_CHROOT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_MODULE">SYS_MODULE</a></code> | CAP_SYS_MODULE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_NICE">SYS_NICE</a></code> | CAP_SYS_NICE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_PACCT">SYS_PACCT</a></code> | CAP_SYS_PACCT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_PTRACE">SYS_PTRACE</a></code> | CAP_SYS_PTRACE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_RAWIO">SYS_RAWIO</a></code> | CAP_SYS_RAWIO. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_RESOURCE">SYS_RESOURCE</a></code> | CAP_SYS_RESOURCE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_TIME">SYS_TIME</a></code> | CAP_SYS_TIME. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_TTY_CONFIG">SYS_TTY_CONFIG</a></code> | CAP_SYS_TTY_CONFIG. |
| <code><a href="#cdk8s-plus-28.Capability.SYSLOG">SYSLOG</a></code> | CAP_SYSLOG. |
| <code><a href="#cdk8s-plus-28.Capability.WAKE_ALARM">WAKE_ALARM</a></code> | CAP_WAKE_ALARM. |

---

##### `ALL` <a name="ALL" id="cdk8s-plus-28.Capability.ALL"></a>

ALL.

---


##### `AUDIT_CONTROL` <a name="AUDIT_CONTROL" id="cdk8s-plus-28.Capability.AUDIT_CONTROL"></a>

CAP_AUDIT_CONTROL.

---


##### `AUDIT_READ` <a name="AUDIT_READ" id="cdk8s-plus-28.Capability.AUDIT_READ"></a>

CAP_AUDIT_READ.

---


##### `AUDIT_WRITE` <a name="AUDIT_WRITE" id="cdk8s-plus-28.Capability.AUDIT_WRITE"></a>

CAP_AUDIT_WRITE.

---


##### `BLOCK_SUSPEND` <a name="BLOCK_SUSPEND" id="cdk8s-plus-28.Capability.BLOCK_SUSPEND"></a>

CAP_BLOCK_SUSPEND.

---


##### `BPF` <a name="BPF" id="cdk8s-plus-28.Capability.BPF"></a>

CAP_BPF.

---


##### `CHECKPOINT_RESTORE` <a name="CHECKPOINT_RESTORE" id="cdk8s-plus-28.Capability.CHECKPOINT_RESTORE"></a>

CAP_CHECKPOINT_RESTORE.

---


##### `CHOWN` <a name="CHOWN" id="cdk8s-plus-28.Capability.CHOWN"></a>

CAP_CHOWN.

---


##### `DAC_OVERRIDE` <a name="DAC_OVERRIDE" id="cdk8s-plus-28.Capability.DAC_OVERRIDE"></a>

CAP_DAC_OVERRIDE.

---


##### `DAC_READ_SEARCH` <a name="DAC_READ_SEARCH" id="cdk8s-plus-28.Capability.DAC_READ_SEARCH"></a>

CAP_DAC_READ_SEARCH.

---


##### `FOWNER` <a name="FOWNER" id="cdk8s-plus-28.Capability.FOWNER"></a>

CAP_FOWNER.

---


##### `FSETID` <a name="FSETID" id="cdk8s-plus-28.Capability.FSETID"></a>

CAP_FSETID.

---


##### `IPC_LOCK` <a name="IPC_LOCK" id="cdk8s-plus-28.Capability.IPC_LOCK"></a>

CAP_IPC_LOCK.

---


##### `IPC_OWNER` <a name="IPC_OWNER" id="cdk8s-plus-28.Capability.IPC_OWNER"></a>

CAP_IPC_OWNER.

---


##### `KILL` <a name="KILL" id="cdk8s-plus-28.Capability.KILL"></a>

CAP_KILL.

---


##### `LEASE` <a name="LEASE" id="cdk8s-plus-28.Capability.LEASE"></a>

CAP_LEASE.

---


##### `LINUX_IMMUTABLE` <a name="LINUX_IMMUTABLE" id="cdk8s-plus-28.Capability.LINUX_IMMUTABLE"></a>

CAP_LINUX_IMMUTABLE.

---


##### `MAC_ADMIN` <a name="MAC_ADMIN" id="cdk8s-plus-28.Capability.MAC_ADMIN"></a>

CAP_MAC_ADMIN.

---


##### `MAC_OVERRIDE` <a name="MAC_OVERRIDE" id="cdk8s-plus-28.Capability.MAC_OVERRIDE"></a>

CAP_MAC_OVERRIDE.

---


##### `MKNOD` <a name="MKNOD" id="cdk8s-plus-28.Capability.MKNOD"></a>

CAP_MKNOD.

---


##### `NET_ADMIN` <a name="NET_ADMIN" id="cdk8s-plus-28.Capability.NET_ADMIN"></a>

CAP_NET_ADMIN.

---


##### `NET_BIND_SERVICE` <a name="NET_BIND_SERVICE" id="cdk8s-plus-28.Capability.NET_BIND_SERVICE"></a>

CAP_NET_BIND_SERVICE.

---


##### `NET_BROADCAST` <a name="NET_BROADCAST" id="cdk8s-plus-28.Capability.NET_BROADCAST"></a>

CAP_NET_BROADCAST.

---


##### `NET_RAW` <a name="NET_RAW" id="cdk8s-plus-28.Capability.NET_RAW"></a>

CAP_NET_RAW.

---


##### `PERFMON` <a name="PERFMON" id="cdk8s-plus-28.Capability.PERFMON"></a>

CAP_PERFMON.

---


##### `SETGID` <a name="SETGID" id="cdk8s-plus-28.Capability.SETGID"></a>

CAP_SETGID.

---


##### `SETFCAP` <a name="SETFCAP" id="cdk8s-plus-28.Capability.SETFCAP"></a>

CAP_SETFCAP.

---


##### `SETPCAP` <a name="SETPCAP" id="cdk8s-plus-28.Capability.SETPCAP"></a>

CAP_SETPCAP.

---


##### `SETUID` <a name="SETUID" id="cdk8s-plus-28.Capability.SETUID"></a>

CAP_SETUID.

---


##### `SYS_ADMIN` <a name="SYS_ADMIN" id="cdk8s-plus-28.Capability.SYS_ADMIN"></a>

CAP_SYS_ADMIN.

---


##### `SYS_BOOT` <a name="SYS_BOOT" id="cdk8s-plus-28.Capability.SYS_BOOT"></a>

CAP_SYS_BOOT.

---


##### `SYS_CHROOT` <a name="SYS_CHROOT" id="cdk8s-plus-28.Capability.SYS_CHROOT"></a>

CAP_SYS_CHROOT.

---


##### `SYS_MODULE` <a name="SYS_MODULE" id="cdk8s-plus-28.Capability.SYS_MODULE"></a>

CAP_SYS_MODULE.

---


##### `SYS_NICE` <a name="SYS_NICE" id="cdk8s-plus-28.Capability.SYS_NICE"></a>

CAP_SYS_NICE.

---


##### `SYS_PACCT` <a name="SYS_PACCT" id="cdk8s-plus-28.Capability.SYS_PACCT"></a>

CAP_SYS_PACCT.

---


##### `SYS_PTRACE` <a name="SYS_PTRACE" id="cdk8s-plus-28.Capability.SYS_PTRACE"></a>

CAP_SYS_PTRACE.

---


##### `SYS_RAWIO` <a name="SYS_RAWIO" id="cdk8s-plus-28.Capability.SYS_RAWIO"></a>

CAP_SYS_RAWIO.

---


##### `SYS_RESOURCE` <a name="SYS_RESOURCE" id="cdk8s-plus-28.Capability.SYS_RESOURCE"></a>

CAP_SYS_RESOURCE.

---


##### `SYS_TIME` <a name="SYS_TIME" id="cdk8s-plus-28.Capability.SYS_TIME"></a>

CAP_SYS_TIME.

---


##### `SYS_TTY_CONFIG` <a name="SYS_TTY_CONFIG" id="cdk8s-plus-28.Capability.SYS_TTY_CONFIG"></a>

CAP_SYS_TTY_CONFIG.

---


##### `SYSLOG` <a name="SYSLOG" id="cdk8s-plus-28.Capability.SYSLOG"></a>

CAP_SYSLOG.

---


##### `WAKE_ALARM` <a name="WAKE_ALARM" id="cdk8s-plus-28.Capability.WAKE_ALARM"></a>

CAP_WAKE_ALARM.

---


### ConcurrencyPolicy <a name="ConcurrencyPolicy" id="cdk8s-plus-28.ConcurrencyPolicy"></a>

Concurrency policy for CronJobs.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.ALLOW">ALLOW</a></code> | This policy allows to run job concurrently. |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.FORBID">FORBID</a></code> | This policy does not allow to run job concurrently. |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.REPLACE">REPLACE</a></code> | This policy replaces the currently running job if a new job is being scheduled. |

---

##### `ALLOW` <a name="ALLOW" id="cdk8s-plus-28.ConcurrencyPolicy.ALLOW"></a>

This policy allows to run job concurrently.

---


##### `FORBID` <a name="FORBID" id="cdk8s-plus-28.ConcurrencyPolicy.FORBID"></a>

This policy does not allow to run job concurrently.

It does not let a new job to be scheduled if the previous one is not finished yet.

---


##### `REPLACE` <a name="REPLACE" id="cdk8s-plus-28.ConcurrencyPolicy.REPLACE"></a>

This policy replaces the currently running job if a new job is being scheduled.

---


### ConnectionScheme <a name="ConnectionScheme" id="cdk8s-plus-28.ConnectionScheme"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConnectionScheme.HTTP">HTTP</a></code> | Use HTTP request for connecting to host. |
| <code><a href="#cdk8s-plus-28.ConnectionScheme.HTTPS">HTTPS</a></code> | Use HTTPS request for connecting to host. |

---

##### `HTTP` <a name="HTTP" id="cdk8s-plus-28.ConnectionScheme.HTTP"></a>

Use HTTP request for connecting to host.

---


##### `HTTPS` <a name="HTTPS" id="cdk8s-plus-28.ConnectionScheme.HTTPS"></a>

Use HTTPS request for connecting to host.

---


### ContainerRestartPolicy <a name="ContainerRestartPolicy" id="cdk8s-plus-28.ContainerRestartPolicy"></a>

RestartPolicy defines the restart behavior of individual containers in a pod.

This field may only be set for init containers, and the only allowed value is "Always".
For non-init containers or when this field is not specified,
the restart behavior is defined by the Pod's restart policy and the container type.
Setting the RestartPolicy as "Always" for the init container will have the following effect:
this init container will be continually restarted on exit until all regular containers have terminated.
Once all regular containers have completed, all init containers with restartPolicy "Always" will be shut down.
This lifecycle differs from normal init containers and is often referred to as a "sidecar" container.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerRestartPolicy.ALWAYS">ALWAYS</a></code> | If an init container is created with its restartPolicy set to Always, it will start and remain running during the entire life of the Pod. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.ContainerRestartPolicy.ALWAYS"></a>

If an init container is created with its restartPolicy set to Always, it will start and remain running during the entire life of the Pod.

For regular containers, this is ignored by Kubernetes.

---


### DnsPolicy <a name="DnsPolicy" id="cdk8s-plus-28.DnsPolicy"></a>

Pod DNS policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST">CLUSTER_FIRST</a></code> | Any DNS query that does not match the configured cluster domain suffix, such as "www.kubernetes.io", is forwarded to the upstream nameserver inherited from the node. Cluster administrators may have extra stub-domain and upstream DNS servers configured. |
| <code><a href="#cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST_WITH_HOST_NET">CLUSTER_FIRST_WITH_HOST_NET</a></code> | For Pods running with hostNetwork, you should explicitly set its DNS policy "ClusterFirstWithHostNet". |
| <code><a href="#cdk8s-plus-28.DnsPolicy.DEFAULT">DEFAULT</a></code> | The Pod inherits the name resolution configuration from the node that the pods run on. |
| <code><a href="#cdk8s-plus-28.DnsPolicy.NONE">NONE</a></code> | It allows a Pod to ignore DNS settings from the Kubernetes environment. |

---

##### `CLUSTER_FIRST` <a name="CLUSTER_FIRST" id="cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST"></a>

Any DNS query that does not match the configured cluster domain suffix, such as "www.kubernetes.io", is forwarded to the upstream nameserver inherited from the node. Cluster administrators may have extra stub-domain and upstream DNS servers configured.

---


##### `CLUSTER_FIRST_WITH_HOST_NET` <a name="CLUSTER_FIRST_WITH_HOST_NET" id="cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST_WITH_HOST_NET"></a>

For Pods running with hostNetwork, you should explicitly set its DNS policy "ClusterFirstWithHostNet".

---


##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.DnsPolicy.DEFAULT"></a>

The Pod inherits the name resolution configuration from the node that the pods run on.

---


##### `NONE` <a name="NONE" id="cdk8s-plus-28.DnsPolicy.NONE"></a>

It allows a Pod to ignore DNS settings from the Kubernetes environment.

All DNS settings are supposed to be provided using the dnsConfig
field in the Pod Spec.

---


### EmptyDirMedium <a name="EmptyDirMedium" id="cdk8s-plus-28.EmptyDirMedium"></a>

The medium on which to store the volume.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EmptyDirMedium.DEFAULT">DEFAULT</a></code> | The default volume of the backing node. |
| <code><a href="#cdk8s-plus-28.EmptyDirMedium.MEMORY">MEMORY</a></code> | Mount a tmpfs (RAM-backed filesystem) for you instead. |

---

##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.EmptyDirMedium.DEFAULT"></a>

The default volume of the backing node.

---


##### `MEMORY` <a name="MEMORY" id="cdk8s-plus-28.EmptyDirMedium.MEMORY"></a>

Mount a tmpfs (RAM-backed filesystem) for you instead.

While tmpfs is very
fast, be aware that unlike disks, tmpfs is cleared on node reboot and any
files you write will count against your Container's memory limit.

---


### EnvFieldPaths <a name="EnvFieldPaths" id="cdk8s-plus-28.EnvFieldPaths"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_NAME">POD_NAME</a></code> | The name of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_NAMESPACE">POD_NAMESPACE</a></code> | The namespace of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_UID">POD_UID</a></code> | The uid of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_LABEL">POD_LABEL</a></code> | The labels of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_ANNOTATION">POD_ANNOTATION</a></code> | The annotations of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_IP">POD_IP</a></code> | The ipAddress of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.SERVICE_ACCOUNT_NAME">SERVICE_ACCOUNT_NAME</a></code> | The service account name of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.NODE_NAME">NODE_NAME</a></code> | The name of the node. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.NODE_IP">NODE_IP</a></code> | The ipAddress of the node. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_IPS">POD_IPS</a></code> | The ipAddresess of the pod. |

---

##### `POD_NAME` <a name="POD_NAME" id="cdk8s-plus-28.EnvFieldPaths.POD_NAME"></a>

The name of the pod.

---


##### `POD_NAMESPACE` <a name="POD_NAMESPACE" id="cdk8s-plus-28.EnvFieldPaths.POD_NAMESPACE"></a>

The namespace of the pod.

---


##### `POD_UID` <a name="POD_UID" id="cdk8s-plus-28.EnvFieldPaths.POD_UID"></a>

The uid of the pod.

---


##### `POD_LABEL` <a name="POD_LABEL" id="cdk8s-plus-28.EnvFieldPaths.POD_LABEL"></a>

The labels of the pod.

---


##### `POD_ANNOTATION` <a name="POD_ANNOTATION" id="cdk8s-plus-28.EnvFieldPaths.POD_ANNOTATION"></a>

The annotations of the pod.

---


##### `POD_IP` <a name="POD_IP" id="cdk8s-plus-28.EnvFieldPaths.POD_IP"></a>

The ipAddress of the pod.

---


##### `SERVICE_ACCOUNT_NAME` <a name="SERVICE_ACCOUNT_NAME" id="cdk8s-plus-28.EnvFieldPaths.SERVICE_ACCOUNT_NAME"></a>

The service account name of the pod.

---


##### `NODE_NAME` <a name="NODE_NAME" id="cdk8s-plus-28.EnvFieldPaths.NODE_NAME"></a>

The name of the node.

---


##### `NODE_IP` <a name="NODE_IP" id="cdk8s-plus-28.EnvFieldPaths.NODE_IP"></a>

The ipAddress of the node.

---


##### `POD_IPS` <a name="POD_IPS" id="cdk8s-plus-28.EnvFieldPaths.POD_IPS"></a>

The ipAddresess of the pod.

---


### FsGroupChangePolicy <a name="FsGroupChangePolicy" id="cdk8s-plus-28.FsGroupChangePolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.FsGroupChangePolicy.ON_ROOT_MISMATCH">ON_ROOT_MISMATCH</a></code> | Only change permissions and ownership if permission and ownership of root directory does not match with expected permissions of the volume. |
| <code><a href="#cdk8s-plus-28.FsGroupChangePolicy.ALWAYS">ALWAYS</a></code> | Always change permission and ownership of the volume when volume is mounted. |

---

##### `ON_ROOT_MISMATCH` <a name="ON_ROOT_MISMATCH" id="cdk8s-plus-28.FsGroupChangePolicy.ON_ROOT_MISMATCH"></a>

Only change permissions and ownership if permission and ownership of root directory does not match with expected permissions of the volume.

This could help shorten the time it takes to change ownership and permission of a volume

---


##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.FsGroupChangePolicy.ALWAYS"></a>

Always change permission and ownership of the volume when volume is mounted.

---


### HostPathVolumeType <a name="HostPathVolumeType" id="cdk8s-plus-28.HostPathVolumeType"></a>

Host path types.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DEFAULT">DEFAULT</a></code> | Empty string (default) is for backward compatibility, which means that no checks will be performed before mounting the hostPath volume. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DIRECTORY_OR_CREATE">DIRECTORY_OR_CREATE</a></code> | If nothing exists at the given path, an empty directory will be created there as needed with permission set to 0755, having the same group and ownership with Kubelet. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DIRECTORY">DIRECTORY</a></code> | A directory must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.FILE_OR_CREATE">FILE_OR_CREATE</a></code> | If nothing exists at the given path, an empty file will be created there as needed with permission set to 0644, having the same group and ownership with Kubelet. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.FILE">FILE</a></code> | A file must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.SOCKET">SOCKET</a></code> | A UNIX socket must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.CHAR_DEVICE">CHAR_DEVICE</a></code> | A character device must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.BLOCK_DEVICE">BLOCK_DEVICE</a></code> | A block device must exist at the given path. |

---

##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.HostPathVolumeType.DEFAULT"></a>

Empty string (default) is for backward compatibility, which means that no checks will be performed before mounting the hostPath volume.

---


##### `DIRECTORY_OR_CREATE` <a name="DIRECTORY_OR_CREATE" id="cdk8s-plus-28.HostPathVolumeType.DIRECTORY_OR_CREATE"></a>

If nothing exists at the given path, an empty directory will be created there as needed with permission set to 0755, having the same group and ownership with Kubelet.

---


##### `DIRECTORY` <a name="DIRECTORY" id="cdk8s-plus-28.HostPathVolumeType.DIRECTORY"></a>

A directory must exist at the given path.

---


##### `FILE_OR_CREATE` <a name="FILE_OR_CREATE" id="cdk8s-plus-28.HostPathVolumeType.FILE_OR_CREATE"></a>

If nothing exists at the given path, an empty file will be created there as needed with permission set to 0644, having the same group and ownership with Kubelet.

---


##### `FILE` <a name="FILE" id="cdk8s-plus-28.HostPathVolumeType.FILE"></a>

A file must exist at the given path.

---


##### `SOCKET` <a name="SOCKET" id="cdk8s-plus-28.HostPathVolumeType.SOCKET"></a>

A UNIX socket must exist at the given path.

---


##### `CHAR_DEVICE` <a name="CHAR_DEVICE" id="cdk8s-plus-28.HostPathVolumeType.CHAR_DEVICE"></a>

A character device must exist at the given path.

---


##### `BLOCK_DEVICE` <a name="BLOCK_DEVICE" id="cdk8s-plus-28.HostPathVolumeType.BLOCK_DEVICE"></a>

A block device must exist at the given path.

---


### HttpIngressPathType <a name="HttpIngressPathType" id="cdk8s-plus-28.HttpIngressPathType"></a>

Specify how the path is matched against request paths.

> [https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types](https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.PREFIX">PREFIX</a></code> | Matches the URL path exactly. |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.EXACT">EXACT</a></code> | Matches based on a URL path prefix split by '/'. |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.IMPLEMENTATION_SPECIFIC">IMPLEMENTATION_SPECIFIC</a></code> | Matching is specified by the underlying IngressClass. |

---

##### `PREFIX` <a name="PREFIX" id="cdk8s-plus-28.HttpIngressPathType.PREFIX"></a>

Matches the URL path exactly.

---


##### `EXACT` <a name="EXACT" id="cdk8s-plus-28.HttpIngressPathType.EXACT"></a>

Matches based on a URL path prefix split by '/'.

---


##### `IMPLEMENTATION_SPECIFIC` <a name="IMPLEMENTATION_SPECIFIC" id="cdk8s-plus-28.HttpIngressPathType.IMPLEMENTATION_SPECIFIC"></a>

Matching is specified by the underlying IngressClass.

---


### ImagePullPolicy <a name="ImagePullPolicy" id="cdk8s-plus-28.ImagePullPolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.ALWAYS">ALWAYS</a></code> | Every time the kubelet launches a container, the kubelet queries the container image registry to resolve the name to an image digest. |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.IF_NOT_PRESENT">IF_NOT_PRESENT</a></code> | The image is pulled only if it is not already present locally. |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.NEVER">NEVER</a></code> | The image is assumed to exist locally. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.ImagePullPolicy.ALWAYS"></a>

Every time the kubelet launches a container, the kubelet queries the container image registry to resolve the name to an image digest.

If the kubelet has a container image with that exact
digest cached locally, the kubelet uses its cached image; otherwise, the kubelet downloads
(pulls) the image with the resolved digest, and uses that image to launch the container.

Default is Always if ImagePullPolicy is omitted and either the image tag is :latest or
the image tag is omitted.

---


##### `IF_NOT_PRESENT` <a name="IF_NOT_PRESENT" id="cdk8s-plus-28.ImagePullPolicy.IF_NOT_PRESENT"></a>

The image is pulled only if it is not already present locally.

Default is IfNotPresent if ImagePullPolicy is omitted and the image tag is present but
not :latest

---


##### `NEVER` <a name="NEVER" id="cdk8s-plus-28.ImagePullPolicy.NEVER"></a>

The image is assumed to exist locally.

No attempt is made to pull the image.

---


### IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind <a name="IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind" id="cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind"></a>

Kind is a string value representing the REST resource this object represents.

Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind.DELETE_OPTIONS">DELETE_OPTIONS</a></code> | DeleteOptions. |

---

##### `DELETE_OPTIONS` <a name="DELETE_OPTIONS" id="cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind.DELETE_OPTIONS"></a>

DeleteOptions.

---


### MountPropagation <a name="MountPropagation" id="cdk8s-plus-28.MountPropagation"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.MountPropagation.NONE">NONE</a></code> | This volume mount will not receive any subsequent mounts that are mounted to this volume or any of its subdirectories by the host. |
| <code><a href="#cdk8s-plus-28.MountPropagation.HOST_TO_CONTAINER">HOST_TO_CONTAINER</a></code> | This volume mount will receive all subsequent mounts that are mounted to this volume or any of its subdirectories. |
| <code><a href="#cdk8s-plus-28.MountPropagation.BIDIRECTIONAL">BIDIRECTIONAL</a></code> | This volume mount behaves the same the HostToContainer mount. |

---

##### `NONE` <a name="NONE" id="cdk8s-plus-28.MountPropagation.NONE"></a>

This volume mount will not receive any subsequent mounts that are mounted to this volume or any of its subdirectories by the host.

In similar
fashion, no mounts created by the Container will be visible on the host.

This is the default mode.

This mode is equal to `private` mount propagation as described in the Linux
kernel documentation

---


##### `HOST_TO_CONTAINER` <a name="HOST_TO_CONTAINER" id="cdk8s-plus-28.MountPropagation.HOST_TO_CONTAINER"></a>

This volume mount will receive all subsequent mounts that are mounted to this volume or any of its subdirectories.

In other words, if the host mounts anything inside the volume mount, the
Container will see it mounted there.

Similarly, if any Pod with Bidirectional mount propagation to the same
volume mounts anything there, the Container with HostToContainer mount
propagation will see it.

This mode is equal to `rslave` mount propagation as described in the Linux
kernel documentation

---


##### `BIDIRECTIONAL` <a name="BIDIRECTIONAL" id="cdk8s-plus-28.MountPropagation.BIDIRECTIONAL"></a>

This volume mount behaves the same the HostToContainer mount.

In addition,
all volume mounts created by the Container will be propagated back to the
host and to all Containers of all Pods that use the same volume

A typical use case for this mode is a Pod with a FlexVolume or CSI driver
or a Pod that needs to mount something on the host using a hostPath volume.

This mode is equal to `rshared` mount propagation as described in the Linux
kernel documentation

Caution: Bidirectional mount propagation can be dangerous. It can damage
the host operating system and therefore it is allowed only in privileged
Containers. Familiarity with Linux kernel behavior is strongly recommended.
In addition, any volume mounts created by Containers in Pods must be
destroyed (unmounted) by the Containers on termination.

---


### NetworkPolicyTrafficDefault <a name="NetworkPolicyTrafficDefault" id="cdk8s-plus-28.NetworkPolicyTrafficDefault"></a>

Default behaviors of network traffic in policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault.DENY">DENY</a></code> | The policy denies all traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault.ALLOW">ALLOW</a></code> | The policy allows all traffic (either ingress or egress). |

---

##### `DENY` <a name="DENY" id="cdk8s-plus-28.NetworkPolicyTrafficDefault.DENY"></a>

The policy denies all traffic.

Since rules are additive, additional rules or policies can allow
specific traffic.

---


##### `ALLOW` <a name="ALLOW" id="cdk8s-plus-28.NetworkPolicyTrafficDefault.ALLOW"></a>

The policy allows all traffic (either ingress or egress).

Since rules are additive, no additional rule or policies can
subsequently deny the traffic.

---


### NetworkProtocol <a name="NetworkProtocol" id="cdk8s-plus-28.NetworkProtocol"></a>

Network protocols.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.TCP">TCP</a></code> | TCP. |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.UDP">UDP</a></code> | UDP. |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.SCTP">SCTP</a></code> | SCTP. |

---

##### `TCP` <a name="TCP" id="cdk8s-plus-28.NetworkProtocol.TCP"></a>

TCP.

---


##### `UDP` <a name="UDP" id="cdk8s-plus-28.NetworkProtocol.UDP"></a>

UDP.

---


##### `SCTP` <a name="SCTP" id="cdk8s-plus-28.NetworkProtocol.SCTP"></a>

SCTP.

---


### PersistentVolumeAccessMode <a name="PersistentVolumeAccessMode" id="cdk8s-plus-28.PersistentVolumeAccessMode"></a>

Access Modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE">READ_WRITE_ONCE</a></code> | The volume can be mounted as read-write by a single node. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_ONLY_MANY">READ_ONLY_MANY</a></code> | The volume can be mounted as read-only by many nodes. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_MANY">READ_WRITE_MANY</a></code> | The volume can be mounted as read-write by many nodes. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE_POD">READ_WRITE_ONCE_POD</a></code> | The volume can be mounted as read-write by a single Pod. |

---

##### `READ_WRITE_ONCE` <a name="READ_WRITE_ONCE" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE"></a>

The volume can be mounted as read-write by a single node.

ReadWriteOnce access mode still can allow multiple pods to access
the volume when the pods are running on the same node.

---


##### `READ_ONLY_MANY` <a name="READ_ONLY_MANY" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_ONLY_MANY"></a>

The volume can be mounted as read-only by many nodes.

---


##### `READ_WRITE_MANY` <a name="READ_WRITE_MANY" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_MANY"></a>

The volume can be mounted as read-write by many nodes.

---


##### `READ_WRITE_ONCE_POD` <a name="READ_WRITE_ONCE_POD" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE_POD"></a>

The volume can be mounted as read-write by a single Pod.

Use ReadWriteOncePod access mode if you want to ensure that
only one pod across whole cluster can read that PVC or write to it.
This is only supported for CSI volumes and Kubernetes version 1.22+.

---


### PersistentVolumeMode <a name="PersistentVolumeMode" id="cdk8s-plus-28.PersistentVolumeMode"></a>

Volume Modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeMode.FILE_SYSTEM">FILE_SYSTEM</a></code> | Volume is ounted into Pods into a directory. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeMode.BLOCK">BLOCK</a></code> | Use a volume as a raw block device. |

---

##### `FILE_SYSTEM` <a name="FILE_SYSTEM" id="cdk8s-plus-28.PersistentVolumeMode.FILE_SYSTEM"></a>

Volume is ounted into Pods into a directory.

If the volume is backed by a block device and the device is empty,
Kubernetes creates a filesystem on the device before mounting it
for the first time.

---


##### `BLOCK` <a name="BLOCK" id="cdk8s-plus-28.PersistentVolumeMode.BLOCK"></a>

Use a volume as a raw block device.

Such volume is presented into a Pod as a block device,
without any filesystem on it. This mode is useful to provide a Pod the fastest possible way
to access a volume, without any filesystem layer between the Pod
and the volume. On the other hand, the application running in
the Pod must know how to handle a raw block device

---


### PersistentVolumeReclaimPolicy <a name="PersistentVolumeReclaimPolicy" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy"></a>

Reclaim Policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy.RETAIN">RETAIN</a></code> | The Retain reclaim policy allows for manual reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy.DELETE">DELETE</a></code> | For volume plugins that support the Delete reclaim policy, deletion removes both the PersistentVolume object from Kubernetes, as well as the associated storage asset in the external infrastructure, such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume. |

---

##### `RETAIN` <a name="RETAIN" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy.RETAIN"></a>

The Retain reclaim policy allows for manual reclamation of the resource.

When the PersistentVolumeClaim is deleted, the PersistentVolume still exists and the
volume is considered "released". But it is not yet available for another claim
because the previous claimant's data remains on the volume.
An administrator can manually reclaim the volume with the following steps:

1. Delete the PersistentVolume. The associated storage asset in external
   infrastructure (such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume) still exists after the PV is deleted.
2. Manually clean up the data on the associated storage asset accordingly.
3. Manually delete the associated storage asset.

If you want to reuse the same storage asset, create a new PersistentVolume
with the same storage asset definition.

---


##### `DELETE` <a name="DELETE" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy.DELETE"></a>

For volume plugins that support the Delete reclaim policy, deletion removes both the PersistentVolume object from Kubernetes, as well as the associated storage asset in the external infrastructure, such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume.

Volumes that were dynamically provisioned inherit the reclaim policy of their StorageClass, which defaults to Delete.
The administrator should configure the StorageClass according to users' expectations; otherwise,
the PV must be edited or patched after it is created

---


### PodConnectionsIsolation <a name="PodConnectionsIsolation" id="cdk8s-plus-28.PodConnectionsIsolation"></a>

Isolation determines which policies are created when allowing connections from a a pod / workload to peers.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsIsolation.POD">POD</a></code> | Only creates network policies that select the pod. |
| <code><a href="#cdk8s-plus-28.PodConnectionsIsolation.PEER">PEER</a></code> | Only creates network policies that select the peer. |

---

##### `POD` <a name="POD" id="cdk8s-plus-28.PodConnectionsIsolation.POD"></a>

Only creates network policies that select the pod.

---


##### `PEER` <a name="PEER" id="cdk8s-plus-28.PodConnectionsIsolation.PEER"></a>

Only creates network policies that select the peer.

---


### PodManagementPolicy <a name="PodManagementPolicy" id="cdk8s-plus-28.PodManagementPolicy"></a>

Controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down.

The default policy is `OrderedReady`, where pods are created in increasing order
(pod-0, then pod-1, etc) and the controller will wait until each pod is ready before
continuing. When scaling down, the pods are removed in the opposite order.

The alternative policy is `Parallel` which will create pods in parallel to match the
desired scale without waiting, and on scale down will delete all pods at once.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodManagementPolicy.ORDERED_READY">ORDERED_READY</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodManagementPolicy.PARALLEL">PARALLEL</a></code> | *No description.* |

---

##### `ORDERED_READY` <a name="ORDERED_READY" id="cdk8s-plus-28.PodManagementPolicy.ORDERED_READY"></a>

---


##### `PARALLEL` <a name="PARALLEL" id="cdk8s-plus-28.PodManagementPolicy.PARALLEL"></a>

---


### Protocol <a name="Protocol" id="cdk8s-plus-28.Protocol"></a>

Network protocols.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Protocol.TCP">TCP</a></code> | TCP. |
| <code><a href="#cdk8s-plus-28.Protocol.UDP">UDP</a></code> | UDP. |
| <code><a href="#cdk8s-plus-28.Protocol.SCTP">SCTP</a></code> | SCTP. |

---

##### `TCP` <a name="TCP" id="cdk8s-plus-28.Protocol.TCP"></a>

TCP.

---


##### `UDP` <a name="UDP" id="cdk8s-plus-28.Protocol.UDP"></a>

UDP.

---


##### `SCTP` <a name="SCTP" id="cdk8s-plus-28.Protocol.SCTP"></a>

SCTP.

---


### ResourceFieldPaths <a name="ResourceFieldPaths" id="cdk8s-plus-28.ResourceFieldPaths"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.CPU_LIMIT">CPU_LIMIT</a></code> | CPU limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.MEMORY_LIMIT">MEMORY_LIMIT</a></code> | Memory limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.CPU_REQUEST">CPU_REQUEST</a></code> | CPU request of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.MEMORY_REQUEST">MEMORY_REQUEST</a></code> | Memory request of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.STORAGE_LIMIT">STORAGE_LIMIT</a></code> | Ephemeral storage limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.STORAGE_REQUEST">STORAGE_REQUEST</a></code> | Ephemeral storage request of the container. |

---

##### `CPU_LIMIT` <a name="CPU_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.CPU_LIMIT"></a>

CPU limit of the container.

---


##### `MEMORY_LIMIT` <a name="MEMORY_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.MEMORY_LIMIT"></a>

Memory limit of the container.

---


##### `CPU_REQUEST` <a name="CPU_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.CPU_REQUEST"></a>

CPU request of the container.

---


##### `MEMORY_REQUEST` <a name="MEMORY_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.MEMORY_REQUEST"></a>

Memory request of the container.

---


##### `STORAGE_LIMIT` <a name="STORAGE_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.STORAGE_LIMIT"></a>

Ephemeral storage limit of the container.

---


##### `STORAGE_REQUEST` <a name="STORAGE_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.STORAGE_REQUEST"></a>

Ephemeral storage request of the container.

---


### RestartPolicy <a name="RestartPolicy" id="cdk8s-plus-28.RestartPolicy"></a>

Restart policy for all containers within the pod.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RestartPolicy.ALWAYS">ALWAYS</a></code> | Always restart the pod after it exits. |
| <code><a href="#cdk8s-plus-28.RestartPolicy.ON_FAILURE">ON_FAILURE</a></code> | Only restart if the pod exits with a non-zero exit code. |
| <code><a href="#cdk8s-plus-28.RestartPolicy.NEVER">NEVER</a></code> | Never restart the pod. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.RestartPolicy.ALWAYS"></a>

Always restart the pod after it exits.

---


##### `ON_FAILURE` <a name="ON_FAILURE" id="cdk8s-plus-28.RestartPolicy.ON_FAILURE"></a>

Only restart if the pod exits with a non-zero exit code.

---


##### `NEVER` <a name="NEVER" id="cdk8s-plus-28.RestartPolicy.NEVER"></a>

Never restart the pod.

---


### ScalingStrategy <a name="ScalingStrategy" id="cdk8s-plus-28.ScalingStrategy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.MAX_CHANGE">MAX_CHANGE</a></code> | Use the policy that provisions the most changes. |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.MIN_CHANGE">MIN_CHANGE</a></code> | Use the policy that provisions the least amount of changes. |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.DISABLED">DISABLED</a></code> | Disables scaling in this direction. |

---

##### `MAX_CHANGE` <a name="MAX_CHANGE" id="cdk8s-plus-28.ScalingStrategy.MAX_CHANGE"></a>

Use the policy that provisions the most changes.

---


##### `MIN_CHANGE` <a name="MIN_CHANGE" id="cdk8s-plus-28.ScalingStrategy.MIN_CHANGE"></a>

Use the policy that provisions the least amount of changes.

---


##### ~~`DISABLED`~~ <a name="DISABLED" id="cdk8s-plus-28.ScalingStrategy.DISABLED"></a>

- *Deprecated:* - Omit the ScalingRule instead

Disables scaling in this direction.

---


### SeccompProfileType <a name="SeccompProfileType" id="cdk8s-plus-28.SeccompProfileType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.LOCALHOST">LOCALHOST</a></code> | A profile defined in a file on the node should be used. |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.RUNTIME_DEFAULT">RUNTIME_DEFAULT</a></code> | The container runtime default profile should be used. |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.UNCONFINED">UNCONFINED</a></code> | No profile should be applied. |

---

##### `LOCALHOST` <a name="LOCALHOST" id="cdk8s-plus-28.SeccompProfileType.LOCALHOST"></a>

A profile defined in a file on the node should be used.

---


##### `RUNTIME_DEFAULT` <a name="RUNTIME_DEFAULT" id="cdk8s-plus-28.SeccompProfileType.RUNTIME_DEFAULT"></a>

The container runtime default profile should be used.

---


##### `UNCONFINED` <a name="UNCONFINED" id="cdk8s-plus-28.SeccompProfileType.UNCONFINED"></a>

No profile should be applied.

---


### ServiceType <a name="ServiceType" id="cdk8s-plus-28.ServiceType"></a>

For some parts of your application (for example, frontends) you may want to expose a Service onto an external IP address, that's outside of your cluster.

Kubernetes ServiceTypes allow you to specify what kind of Service you want.
The default is ClusterIP.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceType.CLUSTER_IP">CLUSTER_IP</a></code> | Exposes the Service on a cluster-internal IP. |
| <code><a href="#cdk8s-plus-28.ServiceType.NODE_PORT">NODE_PORT</a></code> | Exposes the Service on each Node's IP at a static port (the NodePort). |
| <code><a href="#cdk8s-plus-28.ServiceType.LOAD_BALANCER">LOAD_BALANCER</a></code> | Exposes the Service externally using a cloud provider's load balancer. |
| <code><a href="#cdk8s-plus-28.ServiceType.EXTERNAL_NAME">EXTERNAL_NAME</a></code> | Maps the Service to the contents of the externalName field (e.g. foo.bar.example.com), by returning a CNAME record with its value. No proxying of any kind is set up. |

---

##### `CLUSTER_IP` <a name="CLUSTER_IP" id="cdk8s-plus-28.ServiceType.CLUSTER_IP"></a>

Exposes the Service on a cluster-internal IP.

Choosing this value makes the Service only reachable from within the cluster.
This is the default ServiceType

---


##### `NODE_PORT` <a name="NODE_PORT" id="cdk8s-plus-28.ServiceType.NODE_PORT"></a>

Exposes the Service on each Node's IP at a static port (the NodePort).

A ClusterIP Service, to which the NodePort Service routes, is automatically created.
You'll be able to contact the NodePort Service, from outside the cluster,
by requesting <NodeIP>:<NodePort>.

---


##### `LOAD_BALANCER` <a name="LOAD_BALANCER" id="cdk8s-plus-28.ServiceType.LOAD_BALANCER"></a>

Exposes the Service externally using a cloud provider's load balancer.

NodePort and ClusterIP Services, to which the external load balancer routes,
are automatically created.

---


##### `EXTERNAL_NAME` <a name="EXTERNAL_NAME" id="cdk8s-plus-28.ServiceType.EXTERNAL_NAME"></a>

Maps the Service to the contents of the externalName field (e.g. foo.bar.example.com), by returning a CNAME record with its value. No proxying of any kind is set up.

> Note: You need either kube-dns version 1.7 or CoreDNS version 0.0.8 or higher to use the ExternalName type.

---


### TaintEffect <a name="TaintEffect" id="cdk8s-plus-28.TaintEffect"></a>

Taint effects.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TaintEffect.NO_SCHEDULE">NO_SCHEDULE</a></code> | This means that no pod will be able to schedule onto the node unless it has a matching toleration. |
| <code><a href="#cdk8s-plus-28.TaintEffect.PREFER_NO_SCHEDULE">PREFER_NO_SCHEDULE</a></code> | This is a "preference" or "soft" version of `NO_SCHEDULE` -- the system will try to avoid placing a pod that does not tolerate the taint on the node, but it is not required. |
| <code><a href="#cdk8s-plus-28.TaintEffect.NO_EXECUTE">NO_EXECUTE</a></code> | This affects pods that are already running on the node as follows:. |

---

##### `NO_SCHEDULE` <a name="NO_SCHEDULE" id="cdk8s-plus-28.TaintEffect.NO_SCHEDULE"></a>

This means that no pod will be able to schedule onto the node unless it has a matching toleration.

---


##### `PREFER_NO_SCHEDULE` <a name="PREFER_NO_SCHEDULE" id="cdk8s-plus-28.TaintEffect.PREFER_NO_SCHEDULE"></a>

This is a "preference" or "soft" version of `NO_SCHEDULE` -- the system will try to avoid placing a pod that does not tolerate the taint on the node, but it is not required.

---


##### `NO_EXECUTE` <a name="NO_EXECUTE" id="cdk8s-plus-28.TaintEffect.NO_EXECUTE"></a>

This affects pods that are already running on the node as follows:.

* Pods that do not tolerate the taint are evicted immediately.
* Pods that tolerate the taint without specifying `duration` remain bound forever.
* Pods that tolerate the taint with a specified `duration` remain bound for
  the specified amount of time.

---

