# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### AbstractPod <a name="AbstractPod" id="cdk8s-plus-28.AbstractPod"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AbstractPod.Initializer"></a>

```typescript
import { AbstractPod } from 'cdk8s-plus-28'

new AbstractPod(scope: Construct, id: string, props?: AbstractPodProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.AbstractPodProps">AbstractPodProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.AbstractPod.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPodProps">AbstractPodProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AbstractPod.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AbstractPod.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AbstractPod.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.AbstractPod.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.AbstractPod.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.AbstractPod.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.AbstractPod.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.AbstractPod.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.AbstractPod.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.AbstractPod.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.AbstractPod.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.AbstractPod.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.AbstractPod.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.AbstractPod.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.AbstractPod.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.AbstractPod.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.AbstractPod.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.AbstractPod.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.AbstractPod.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.AbstractPod.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.AbstractPod.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.AbstractPod.isConstruct"></a>

```typescript
import { AbstractPod } from 'cdk8s-plus-28'

AbstractPod.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AbstractPod.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AbstractPod.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AbstractPod.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.AbstractPod.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.AbstractPod.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AbstractPod.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AbstractPod.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AbstractPod.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AbstractPod.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.AbstractPod.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.AbstractPod.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.AbstractPod.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.AbstractPod.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.AbstractPod.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.AbstractPod.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.AbstractPod.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.AbstractPod.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.AbstractPod.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.AbstractPod.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.AbstractPod.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.AbstractPod.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.AbstractPod.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.AbstractPod.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.AbstractPod.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---


### AwsElasticBlockStorePersistentVolume <a name="AwsElasticBlockStorePersistentVolume" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume"></a>

Represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer"></a>

```typescript
import { AwsElasticBlockStorePersistentVolume } from 'cdk8s-plus-28'

new AwsElasticBlockStorePersistentVolume(scope: Construct, id: string, props: AwsElasticBlockStorePersistentVolumeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps">AwsElasticBlockStorePersistentVolumeProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps">AwsElasticBlockStorePersistentVolumeProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind"></a>

```typescript
public bind(claim: IPersistentVolumeClaim): void
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.reserve"></a>

```typescript
public reserve(): PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName">fromPersistentVolumeName</a></code> | Imports a pv from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct"></a>

```typescript
import { AwsElasticBlockStorePersistentVolume } from 'cdk8s-plus-28'

AwsElasticBlockStorePersistentVolume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromPersistentVolumeName` <a name="fromPersistentVolumeName" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName"></a>

```typescript
import { AwsElasticBlockStorePersistentVolume } from 'cdk8s-plus-28'

AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName(scope: Construct, id: string, volumeName: string)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* string

---

###### `volumeName`<sup>Required</sup> <a name="volumeName" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storageClassName">storageClassName</a></code> | <code>string</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.fsType">fsType</a></code> | <code>string</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.readOnly">readOnly</a></code> | <code>boolean</code> | Whether or not it is mounted as a read-only volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.volumeId">volumeId</a></code> | <code>string</code> | Volume id of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.partition">partition</a></code> | <code>number</code> | Partition of this volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mode"></a>

```typescript
public readonly mode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaimPolicy`<sup>Required</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

Storage class this volume belongs to.

---

##### `fsType`<sup>Required</sup> <a name="fsType" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

File system type of this volume.

---

##### `readOnly`<sup>Required</sup> <a name="readOnly" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

Whether or not it is mounted as a read-only volume.

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

Volume id of this volume.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolume.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number

Partition of this volume.

---


### AzureDiskPersistentVolume <a name="AzureDiskPersistentVolume" id="cdk8s-plus-28.AzureDiskPersistentVolume"></a>

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer"></a>

```typescript
import { AzureDiskPersistentVolume } from 'cdk8s-plus-28'

new AzureDiskPersistentVolume(scope: Construct, id: string, props: AzureDiskPersistentVolumeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps">AzureDiskPersistentVolumeProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.AzureDiskPersistentVolume.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps">AzureDiskPersistentVolumeProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.AzureDiskPersistentVolume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.AzureDiskPersistentVolume.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.AzureDiskPersistentVolume.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.AzureDiskPersistentVolume.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.AzureDiskPersistentVolume.bind"></a>

```typescript
public bind(claim: IPersistentVolumeClaim): void
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.AzureDiskPersistentVolume.reserve"></a>

```typescript
public reserve(): PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName">fromPersistentVolumeName</a></code> | Imports a pv from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct"></a>

```typescript
import { AzureDiskPersistentVolume } from 'cdk8s-plus-28'

AzureDiskPersistentVolume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.AzureDiskPersistentVolume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromPersistentVolumeName` <a name="fromPersistentVolumeName" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName"></a>

```typescript
import { AzureDiskPersistentVolume } from 'cdk8s-plus-28'

AzureDiskPersistentVolume.fromPersistentVolumeName(scope: Construct, id: string, volumeName: string)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* string

---

###### `volumeName`<sup>Required</sup> <a name="volumeName" id="cdk8s-plus-28.AzureDiskPersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.storageClassName">storageClassName</a></code> | <code>string</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.azureKind">azureKind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Azure kind of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.cachingMode">cachingMode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Caching mode of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.diskName">diskName</a></code> | <code>string</code> | Disk name of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.diskUri">diskUri</a></code> | <code>string</code> | Disk URI of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.fsType">fsType</a></code> | <code>string</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolume.property.readOnly">readOnly</a></code> | <code>boolean</code> | Whether or not it is mounted as a read-only volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.mode"></a>

```typescript
public readonly mode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaimPolicy`<sup>Required</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

Storage class this volume belongs to.

---

##### `azureKind`<sup>Required</sup> <a name="azureKind" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.azureKind"></a>

```typescript
public readonly azureKind: AzureDiskPersistentVolumeKind;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>

Azure kind of this volume.

---

##### `cachingMode`<sup>Required</sup> <a name="cachingMode" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.cachingMode"></a>

```typescript
public readonly cachingMode: AzureDiskPersistentVolumeCachingMode;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>

Caching mode of this volume.

---

##### `diskName`<sup>Required</sup> <a name="diskName" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.diskName"></a>

```typescript
public readonly diskName: string;
```

- *Type:* string

Disk name of this volume.

---

##### `diskUri`<sup>Required</sup> <a name="diskUri" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.diskUri"></a>

```typescript
public readonly diskUri: string;
```

- *Type:* string

Disk URI of this volume.

---

##### `fsType`<sup>Required</sup> <a name="fsType" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

File system type of this volume.

---

##### `readOnly`<sup>Required</sup> <a name="readOnly" id="cdk8s-plus-28.AzureDiskPersistentVolume.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

Whether or not it is mounted as a read-only volume.

---


### BasicAuthSecret <a name="BasicAuthSecret" id="cdk8s-plus-28.BasicAuthSecret"></a>

Create a secret for basic authentication.

> [https://kubernetes.io/docs/concepts/configuration/secret/#basic-authentication-secret](https://kubernetes.io/docs/concepts/configuration/secret/#basic-authentication-secret)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.BasicAuthSecret.Initializer"></a>

```typescript
import { BasicAuthSecret } from 'cdk8s-plus-28'

new BasicAuthSecret(scope: Construct, id: string, props: BasicAuthSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.BasicAuthSecretProps">BasicAuthSecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.BasicAuthSecret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.BasicAuthSecretProps">BasicAuthSecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.BasicAuthSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.BasicAuthSecret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.BasicAuthSecret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.BasicAuthSecret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.BasicAuthSecret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.BasicAuthSecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.BasicAuthSecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.BasicAuthSecret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.BasicAuthSecret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.BasicAuthSecret.isConstruct"></a>

```typescript
import { BasicAuthSecret } from 'cdk8s-plus-28'

BasicAuthSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.BasicAuthSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName"></a>

```typescript
import { BasicAuthSecret } from 'cdk8s-plus-28'

BasicAuthSecret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.BasicAuthSecret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.BasicAuthSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.BasicAuthSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.BasicAuthSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.BasicAuthSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.BasicAuthSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.BasicAuthSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.BasicAuthSecret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.BasicAuthSecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.BasicAuthSecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.BasicAuthSecret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### ClusterRole <a name="ClusterRole" id="cdk8s-plus-28.ClusterRole"></a>

- *Implements:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ClusterRole.Initializer"></a>

```typescript
import { ClusterRole } from 'cdk8s-plus-28'

new ClusterRole(scope: Construct, id: string, props?: ClusterRoleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ClusterRoleProps">ClusterRoleProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.ClusterRole.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ClusterRoleProps">ClusterRoleProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ClusterRole.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRole.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRole.aggregate">aggregate</a></code> | Aggregate rules from roles matching this label selector. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allow">allow</a></code> | Add permission to perform a list of HTTP verbs on a collection of resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowCreate">allowCreate</a></code> | Add "create" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowDelete">allowDelete</a></code> | Add "delete" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowDeleteCollection">allowDeleteCollection</a></code> | Add "deletecollection" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowGet">allowGet</a></code> | Add "get" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowList">allowList</a></code> | Add "list" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowPatch">allowPatch</a></code> | Add "patch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowRead">allowRead</a></code> | Add "get", "list", and "watch" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowReadWrite">allowReadWrite</a></code> | Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowUpdate">allowUpdate</a></code> | Add "update" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.allowWatch">allowWatch</a></code> | Add "watch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.ClusterRole.bind">bind</a></code> | Create a ClusterRoleBinding that binds the permissions in this ClusterRole to a list of subjects, without namespace restrictions. |
| <code><a href="#cdk8s-plus-28.ClusterRole.bindInNamespace">bindInNamespace</a></code> | Create a RoleBinding that binds the permissions in this ClusterRole to a list of subjects, that will only apply to the given namespace. |
| <code><a href="#cdk8s-plus-28.ClusterRole.combine">combine</a></code> | Combines the rules of the argument ClusterRole into this ClusterRole using aggregation labels. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.ClusterRole.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ClusterRole.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ClusterRole.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `aggregate` <a name="aggregate" id="cdk8s-plus-28.ClusterRole.aggregate"></a>

```typescript
public aggregate(key: string, value: string): void
```

Aggregate rules from roles matching this label selector.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ClusterRole.aggregate.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ClusterRole.aggregate.parameter.value"></a>

- *Type:* string

---

##### `allow` <a name="allow" id="cdk8s-plus-28.ClusterRole.allow"></a>

```typescript
public allow(verbs: string[], endpoints: IApiEndpoint): void
```

Add permission to perform a list of HTTP verbs on a collection of resources.

> [https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb](https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb)

###### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.ClusterRole.allow.parameter.verbs"></a>

- *Type:* string[]

---

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allow.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The endpoints(s) to apply to.

---

##### `allowCreate` <a name="allowCreate" id="cdk8s-plus-28.ClusterRole.allowCreate"></a>

```typescript
public allowCreate(endpoints: IApiEndpoint): void
```

Add "create" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowCreate.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowDelete` <a name="allowDelete" id="cdk8s-plus-28.ClusterRole.allowDelete"></a>

```typescript
public allowDelete(endpoints: IApiEndpoint): void
```

Add "delete" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowDelete.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowDeleteCollection` <a name="allowDeleteCollection" id="cdk8s-plus-28.ClusterRole.allowDeleteCollection"></a>

```typescript
public allowDeleteCollection(endpoints: IApiEndpoint): void
```

Add "deletecollection" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowDeleteCollection.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowGet` <a name="allowGet" id="cdk8s-plus-28.ClusterRole.allowGet"></a>

```typescript
public allowGet(endpoints: IApiEndpoint): void
```

Add "get" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowGet.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowList` <a name="allowList" id="cdk8s-plus-28.ClusterRole.allowList"></a>

```typescript
public allowList(endpoints: IApiEndpoint): void
```

Add "list" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowList.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowPatch` <a name="allowPatch" id="cdk8s-plus-28.ClusterRole.allowPatch"></a>

```typescript
public allowPatch(endpoints: IApiEndpoint): void
```

Add "patch" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowPatch.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowRead` <a name="allowRead" id="cdk8s-plus-28.ClusterRole.allowRead"></a>

```typescript
public allowRead(endpoints: IApiEndpoint): void
```

Add "get", "list", and "watch" permissions for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowRead.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowReadWrite` <a name="allowReadWrite" id="cdk8s-plus-28.ClusterRole.allowReadWrite"></a>

```typescript
public allowReadWrite(endpoints: IApiEndpoint): void
```

Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowReadWrite.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowUpdate` <a name="allowUpdate" id="cdk8s-plus-28.ClusterRole.allowUpdate"></a>

```typescript
public allowUpdate(endpoints: IApiEndpoint): void
```

Add "update" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowUpdate.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `allowWatch` <a name="allowWatch" id="cdk8s-plus-28.ClusterRole.allowWatch"></a>

```typescript
public allowWatch(endpoints: IApiEndpoint): void
```

Add "watch" permission for the resources.

###### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRole.allowWatch.parameter.endpoints"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

The resource(s) to apply to.

---

##### `bind` <a name="bind" id="cdk8s-plus-28.ClusterRole.bind"></a>

```typescript
public bind(subjects: ISubject): ClusterRoleBinding
```

Create a ClusterRoleBinding that binds the permissions in this ClusterRole to a list of subjects, without namespace restrictions.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRole.bind.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

##### `bindInNamespace` <a name="bindInNamespace" id="cdk8s-plus-28.ClusterRole.bindInNamespace"></a>

```typescript
public bindInNamespace(namespace: string, subjects: ISubject): RoleBinding
```

Create a RoleBinding that binds the permissions in this ClusterRole to a list of subjects, that will only apply to the given namespace.

###### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.ClusterRole.bindInNamespace.parameter.namespace"></a>

- *Type:* string

the namespace to limit permissions to.

---

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRole.bindInNamespace.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

##### `combine` <a name="combine" id="cdk8s-plus-28.ClusterRole.combine"></a>

```typescript
public combine(rol: ClusterRole): void
```

Combines the rules of the argument ClusterRole into this ClusterRole using aggregation labels.

###### `rol`<sup>Required</sup> <a name="rol" id="cdk8s-plus-28.ClusterRole.combine.parameter.rol"></a>

- *Type:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ClusterRole.fromClusterRoleName">fromClusterRoleName</a></code> | Imports a role from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.ClusterRole.isConstruct"></a>

```typescript
import { ClusterRole } from 'cdk8s-plus-28'

ClusterRole.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ClusterRole.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromClusterRoleName` <a name="fromClusterRoleName" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName"></a>

```typescript
import { ClusterRole } from 'cdk8s-plus-28'

ClusterRole.fromClusterRoleName(scope: Construct, id: string, name: string)
```

Imports a role from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRole.fromClusterRoleName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ClusterRole.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>[]</code> | Rules associaated with this Role. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ClusterRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ClusterRole.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ClusterRole.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ClusterRole.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRole.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRole.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ClusterRole.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ClusterRole.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ClusterRole.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.ClusterRole.property.rules"></a>

```typescript
public readonly rules: ClusterRolePolicyRule[];
```

- *Type:* <a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>[]

Rules associaated with this Role.

Returns a copy, use `allow` to add rules.

---


### ClusterRoleBinding <a name="ClusterRoleBinding" id="cdk8s-plus-28.ClusterRoleBinding"></a>

A ClusterRoleBinding grants permissions cluster-wide to a user or set of users.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ClusterRoleBinding.Initializer"></a>

```typescript
import { ClusterRoleBinding } from 'cdk8s-plus-28'

new ClusterRoleBinding(scope: Construct, id: string, props: ClusterRoleBindingProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ClusterRoleBindingProps">ClusterRoleBindingProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.ClusterRoleBinding.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ClusterRoleBindingProps">ClusterRoleBindingProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.addSubjects">addSubjects</a></code> | Adds a subject to the role. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.ClusterRoleBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ClusterRoleBinding.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ClusterRoleBinding.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addSubjects` <a name="addSubjects" id="cdk8s-plus-28.ClusterRoleBinding.addSubjects"></a>

```typescript
public addSubjects(subjects: ISubject): void
```

Adds a subject to the role.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRoleBinding.addSubjects.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

The subjects to add.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.ClusterRoleBinding.isConstruct"></a>

```typescript
import { ClusterRoleBinding } from 'cdk8s-plus-28'

ClusterRoleBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ClusterRoleBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ClusterRoleBinding.property.subjects">subjects</a></code> | <code><a href="#cdk8s-plus-28.ISubject">ISubject</a>[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ClusterRoleBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ClusterRoleBinding.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ClusterRoleBinding.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ClusterRoleBinding.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleBinding.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ClusterRoleBinding.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ClusterRoleBinding.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ClusterRoleBinding.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ClusterRoleBinding.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.ClusterRoleBinding.property.role"></a>

```typescript
public readonly role: IClusterRole;
```

- *Type:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ClusterRoleBinding.property.subjects"></a>

```typescript
public readonly subjects: ISubject[];
```

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>[]

---


### ConfigMap <a name="ConfigMap" id="cdk8s-plus-28.ConfigMap"></a>

- *Implements:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

ConfigMap holds configuration data for pods to consume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ConfigMap.Initializer"></a>

```typescript
import { ConfigMap } from 'cdk8s-plus-28'

new ConfigMap(scope: Construct, id: string, props?: ConfigMapProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ConfigMapProps">ConfigMapProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.ConfigMap.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ConfigMapProps">ConfigMapProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ConfigMap.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ConfigMap.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addBinaryData">addBinaryData</a></code> | Adds a binary data entry to the config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addData">addData</a></code> | Adds a data entry to the config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addDirectory">addDirectory</a></code> | Adds a directory to the ConfigMap. |
| <code><a href="#cdk8s-plus-28.ConfigMap.addFile">addFile</a></code> | Adds a file to the ConfigMap. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.ConfigMap.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ConfigMap.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ConfigMap.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addBinaryData` <a name="addBinaryData" id="cdk8s-plus-28.ConfigMap.addBinaryData"></a>

```typescript
public addBinaryData(key: string, value: string): void
```

Adds a binary data entry to the config map.

BinaryData can contain byte
sequences that are not in the UTF-8 range.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addBinaryData.parameter.key"></a>

- *Type:* string

The key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ConfigMap.addBinaryData.parameter.value"></a>

- *Type:* string

The value.

---

##### `addData` <a name="addData" id="cdk8s-plus-28.ConfigMap.addData"></a>

```typescript
public addData(key: string, value: string): void
```

Adds a data entry to the config map.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addData.parameter.key"></a>

- *Type:* string

The key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ConfigMap.addData.parameter.value"></a>

- *Type:* string

The value.

---

##### `addDirectory` <a name="addDirectory" id="cdk8s-plus-28.ConfigMap.addDirectory"></a>

```typescript
public addDirectory(localDir: string, options?: AddDirectoryOptions): void
```

Adds a directory to the ConfigMap.

###### `localDir`<sup>Required</sup> <a name="localDir" id="cdk8s-plus-28.ConfigMap.addDirectory.parameter.localDir"></a>

- *Type:* string

A path to a local directory.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.ConfigMap.addDirectory.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.AddDirectoryOptions">AddDirectoryOptions</a>

Options.

---

##### `addFile` <a name="addFile" id="cdk8s-plus-28.ConfigMap.addFile"></a>

```typescript
public addFile(localFile: string, key?: string): void
```

Adds a file to the ConfigMap.

###### `localFile`<sup>Required</sup> <a name="localFile" id="cdk8s-plus-28.ConfigMap.addFile.parameter.localFile"></a>

- *Type:* string

The path to the local file.

---

###### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.ConfigMap.addFile.parameter.key"></a>

- *Type:* string

The ConfigMap key (default to the file name).

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ConfigMap.fromConfigMapName">fromConfigMapName</a></code> | Represents a ConfigMap created elsewhere. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.ConfigMap.isConstruct"></a>

```typescript
import { ConfigMap } from 'cdk8s-plus-28'

ConfigMap.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ConfigMap.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromConfigMapName` <a name="fromConfigMapName" id="cdk8s-plus-28.ConfigMap.fromConfigMapName"></a>

```typescript
import { ConfigMap } from 'cdk8s-plus-28'

ConfigMap.fromConfigMapName(scope: Construct, id: string, name: string)
```

Represents a ConfigMap created elsewhere.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ConfigMap.fromConfigMapName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.binaryData">binaryData</a></code> | <code>{[ key: string ]: string}</code> | The binary data associated with this config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.data">data</a></code> | <code>{[ key: string ]: string}</code> | The data associated with this config map. |
| <code><a href="#cdk8s-plus-28.ConfigMap.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not this config map is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ConfigMap.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ConfigMap.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ConfigMap.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ConfigMap.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ConfigMap.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ConfigMap.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ConfigMap.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ConfigMap.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ConfigMap.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `binaryData`<sup>Required</sup> <a name="binaryData" id="cdk8s-plus-28.ConfigMap.property.binaryData"></a>

```typescript
public readonly binaryData: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The binary data associated with this config map.

Returns a copy. To add data records, use `addBinaryData()` or `addData()`.

---

##### `data`<sup>Required</sup> <a name="data" id="cdk8s-plus-28.ConfigMap.property.data"></a>

```typescript
public readonly data: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The data associated with this config map.

Returns an copy. To add data records, use `addData()` or `addBinaryData()`.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.ConfigMap.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not this config map is immutable.

---


### CronJob <a name="CronJob" id="cdk8s-plus-28.CronJob"></a>

A CronJob is responsible for creating a Job and scheduling it based on provided cron schedule.

This helps running Jobs in a recurring manner.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.CronJob.Initializer"></a>

```typescript
import { CronJob } from 'cdk8s-plus-28'

new CronJob(scope: Construct, id: string, props: CronJobProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.CronJobProps">CronJobProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.CronJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.CronJob.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.CronJob.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.CronJobProps">CronJobProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.CronJob.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.CronJob.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.CronJob.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.CronJob.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.CronJob.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.CronJob.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.CronJob.select">select</a></code> | Configure selectors for this workload. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.CronJob.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.CronJob.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.CronJob.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.CronJob.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.CronJob.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.CronJob.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.CronJob.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.CronJob.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.CronJob.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.CronJob.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.CronJob.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.CronJob.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.CronJob.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.CronJob.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.CronJob.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.CronJob.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.CronJob.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.CronJob.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.CronJob.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.CronJob.isConstruct"></a>

```typescript
import { CronJob } from 'cdk8s-plus-28'

CronJob.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.CronJob.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.CronJob.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.CronJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.CronJob.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.resourceType">resourceType</a></code> | <code>string</code> | Represents the resource type. |
| <code><a href="#cdk8s-plus-28.CronJob.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.CronJob.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.CronJob.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.CronJob.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.CronJob.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CronJob.property.concurrencyPolicy">concurrencyPolicy</a></code> | <code>string</code> | The policy used by this cron job to determine the concurrency mode in which to schedule jobs. |
| <code><a href="#cdk8s-plus-28.CronJob.property.failedJobsRetained">failedJobsRetained</a></code> | <code>number</code> | The number of failed jobs retained by this cron job. |
| <code><a href="#cdk8s-plus-28.CronJob.property.schedule">schedule</a></code> | <code>cdk8s.Cron</code> | The schedule this cron job is scheduled to run in. |
| <code><a href="#cdk8s-plus-28.CronJob.property.startingDeadline">startingDeadline</a></code> | <code>cdk8s.Duration</code> | The time by which the running cron job needs to schedule the next job execution. |
| <code><a href="#cdk8s-plus-28.CronJob.property.successfulJobsRetained">successfulJobsRetained</a></code> | <code>number</code> | The number of successful jobs retained by this cron job. |
| <code><a href="#cdk8s-plus-28.CronJob.property.suspend">suspend</a></code> | <code>boolean</code> | Whether or not the cron job is currently suspended or not. |
| <code><a href="#cdk8s-plus-28.CronJob.property.timeZone">timeZone</a></code> | <code>string</code> | The timezone which this cron job would follow to schedule jobs. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.CronJob.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.CronJob.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.CronJob.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.CronJob.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.CronJob.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.CronJob.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.CronJob.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.CronJob.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

Represents the resource type.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.CronJob.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.CronJob.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.CronJob.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.CronJob.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.CronJob.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.CronJob.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.CronJob.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.CronJob.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.CronJob.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.CronJob.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.CronJob.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.CronJob.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.CronJob.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.CronJob.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.CronJob.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.CronJob.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.CronJob.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.CronJob.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `concurrencyPolicy`<sup>Required</sup> <a name="concurrencyPolicy" id="cdk8s-plus-28.CronJob.property.concurrencyPolicy"></a>

```typescript
public readonly concurrencyPolicy: string;
```

- *Type:* string

The policy used by this cron job to determine the concurrency mode in which to schedule jobs.

---

##### `failedJobsRetained`<sup>Required</sup> <a name="failedJobsRetained" id="cdk8s-plus-28.CronJob.property.failedJobsRetained"></a>

```typescript
public readonly failedJobsRetained: number;
```

- *Type:* number

The number of failed jobs retained by this cron job.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.CronJob.property.schedule"></a>

```typescript
public readonly schedule: Cron;
```

- *Type:* cdk8s.Cron

The schedule this cron job is scheduled to run in.

---

##### `startingDeadline`<sup>Required</sup> <a name="startingDeadline" id="cdk8s-plus-28.CronJob.property.startingDeadline"></a>

```typescript
public readonly startingDeadline: Duration;
```

- *Type:* cdk8s.Duration

The time by which the running cron job needs to schedule the next job execution.

The job is considered as failed if it misses this deadline.

---

##### `successfulJobsRetained`<sup>Required</sup> <a name="successfulJobsRetained" id="cdk8s-plus-28.CronJob.property.successfulJobsRetained"></a>

```typescript
public readonly successfulJobsRetained: number;
```

- *Type:* number

The number of successful jobs retained by this cron job.

---

##### `suspend`<sup>Required</sup> <a name="suspend" id="cdk8s-plus-28.CronJob.property.suspend"></a>

```typescript
public readonly suspend: boolean;
```

- *Type:* boolean

Whether or not the cron job is currently suspended or not.

---

##### `timeZone`<sup>Optional</sup> <a name="timeZone" id="cdk8s-plus-28.CronJob.property.timeZone"></a>

```typescript
public readonly timeZone: string;
```

- *Type:* string

The timezone which this cron job would follow to schedule jobs.

---


### DaemonSet <a name="DaemonSet" id="cdk8s-plus-28.DaemonSet"></a>

A DaemonSet ensures that all (or some) Nodes run a copy of a Pod.

As nodes are added to the cluster, Pods are added to them.
As nodes are removed from the cluster, those Pods are garbage collected.
Deleting a DaemonSet will clean up the Pods it created.

Some typical uses of a DaemonSet are:

- running a cluster storage daemon on every node
- running a logs collection daemon on every node
- running a node monitoring daemon on every node

In a simple case, one DaemonSet, covering all nodes, would be used for each type of daemon.
A more complex setup might use multiple DaemonSets for a single type of daemon,
but with different flags and/or different memory and cpu requests for different hardware types.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.DaemonSet.Initializer"></a>

```typescript
import { DaemonSet } from 'cdk8s-plus-28'

new DaemonSet(scope: Construct, id: string, props?: DaemonSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.DaemonSetProps">DaemonSetProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.DaemonSet.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.DaemonSetProps">DaemonSetProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.DaemonSet.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.DaemonSet.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.DaemonSet.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.DaemonSet.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.DaemonSet.select">select</a></code> | Configure selectors for this workload. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.DaemonSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.DaemonSet.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.DaemonSet.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.DaemonSet.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.DaemonSet.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.DaemonSet.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.DaemonSet.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.DaemonSet.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.DaemonSet.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.DaemonSet.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.DaemonSet.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.DaemonSet.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.DaemonSet.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.DaemonSet.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.DaemonSet.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.DaemonSet.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.DaemonSet.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.DaemonSet.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.DaemonSet.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.DaemonSet.isConstruct"></a>

```typescript
import { DaemonSet } from 'cdk8s-plus-28'

DaemonSet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.DaemonSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DaemonSet.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.DaemonSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.DaemonSet.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.DaemonSet.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.DaemonSet.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.DaemonSet.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DaemonSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.DaemonSet.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.DaemonSet.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.DaemonSet.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.DaemonSet.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.DaemonSet.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.DaemonSet.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.DaemonSet.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.DaemonSet.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.DaemonSet.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.DaemonSet.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.DaemonSet.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.DaemonSet.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.DaemonSet.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.DaemonSet.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.DaemonSet.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.DaemonSet.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.DaemonSet.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.DaemonSet.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.DaemonSet.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.DaemonSet.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `minReadySeconds`<sup>Required</sup> <a name="minReadySeconds" id="cdk8s-plus-28.DaemonSet.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number

---


### Deployment <a name="Deployment" id="cdk8s-plus-28.Deployment"></a>

- *Implements:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

A Deployment provides declarative updates for Pods and ReplicaSets.

You describe a desired state in a Deployment, and the Deployment Controller changes the actual
state to the desired state at a controlled rate. You can define Deployments to create new ReplicaSets, or to remove
existing Deployments and adopt all their resources with new Deployments.

> Note: Do not manage ReplicaSets owned by a Deployment. Consider opening an issue in the main Kubernetes repository if your use case is not covered below.

Use Case

The following are typical use cases for Deployments:

- Create a Deployment to rollout a ReplicaSet. The ReplicaSet creates Pods in the background.
   Check the status of the rollout to see if it succeeds or not.
- Declare the new state of the Pods by updating the PodTemplateSpec of the Deployment.
   A new ReplicaSet is created and the Deployment manages moving the Pods from the old ReplicaSet to the new one at a controlled rate.
   Each new ReplicaSet updates the revision of the Deployment.
- Rollback to an earlier Deployment revision if the current state of the Deployment is not stable.
   Each rollback updates the revision of the Deployment.
- Scale up the Deployment to facilitate more load.
- Pause the Deployment to apply multiple fixes to its PodTemplateSpec and then resume it to start a new rollout.
- Use the status of the Deployment as an indicator that a rollout has stuck.
- Clean up older ReplicaSets that you don't need anymore.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Deployment.Initializer"></a>

```typescript
import { Deployment } from 'cdk8s-plus-28'

new Deployment(scope: Construct, id: string, props?: DeploymentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.DeploymentProps">DeploymentProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Deployment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Deployment.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Deployment.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.DeploymentProps">DeploymentProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Deployment.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Deployment.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Deployment.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Deployment.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Deployment.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Deployment.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Deployment.select">select</a></code> | Configure selectors for this workload. |
| <code><a href="#cdk8s-plus-28.Deployment.exposeViaIngress">exposeViaIngress</a></code> | Expose a deployment via an ingress. |
| <code><a href="#cdk8s-plus-28.Deployment.exposeViaService">exposeViaService</a></code> | Expose a deployment via a service. |
| <code><a href="#cdk8s-plus-28.Deployment.markHasAutoscaler">markHasAutoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.Deployment.toScalingTarget">toScalingTarget</a></code> | Return the target spec properties of this Scalable. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Deployment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Deployment.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Deployment.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.Deployment.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Deployment.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.Deployment.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.Deployment.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.Deployment.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Deployment.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.Deployment.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Deployment.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.Deployment.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Deployment.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Deployment.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Deployment.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.Deployment.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.Deployment.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Deployment.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Deployment.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

##### `exposeViaIngress` <a name="exposeViaIngress" id="cdk8s-plus-28.Deployment.exposeViaIngress"></a>

```typescript
public exposeViaIngress(path: string, options?: ExposeDeploymentViaIngressOptions): Ingress
```

Expose a deployment via an ingress.

This will first expose the deployment with a service, and then expose the service via an ingress.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.path"></a>

- *Type:* string

The ingress path to register under.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Deployment.exposeViaIngress.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions">ExposeDeploymentViaIngressOptions</a>

Additional options.

---

##### `exposeViaService` <a name="exposeViaService" id="cdk8s-plus-28.Deployment.exposeViaService"></a>

```typescript
public exposeViaService(options?: DeploymentExposeViaServiceOptions): Service
```

Expose a deployment via a service.

This is equivalent to running `kubectl expose deployment <deployment-name>`.

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Deployment.exposeViaService.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions">DeploymentExposeViaServiceOptions</a>

Options to determine details of the service and port exposed.

---

##### `markHasAutoscaler` <a name="markHasAutoscaler" id="cdk8s-plus-28.Deployment.markHasAutoscaler"></a>

```typescript
public markHasAutoscaler(): void
```

Called on all IScalable targets when they are associated with an autoscaler.

> [IScalable.markHasAutoscaler()](IScalable.markHasAutoscaler())

##### `toScalingTarget` <a name="toScalingTarget" id="cdk8s-plus-28.Deployment.toScalingTarget"></a>

```typescript
public toScalingTarget(): ScalingTarget
```

Return the target spec properties of this Scalable.

> [IScalable.toScalingTarget()](IScalable.toScalingTarget())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Deployment.isConstruct"></a>

```typescript
import { Deployment } from 'cdk8s-plus-28'

Deployment.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Deployment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Deployment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Deployment.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Deployment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Deployment.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Deployment.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Deployment.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Deployment.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.minReady">minReady</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.Deployment.property.progressDeadline">progressDeadline</a></code> | <code>cdk8s.Duration</code> | The maximum duration for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.Deployment.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Deployment.property.replicas">replicas</a></code> | <code>number</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.Deployment.property.hasAutoscaler">hasAutoscaler</a></code> | <code>boolean</code> | If this is a target of an autoscaler. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Deployment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Deployment.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Deployment.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Deployment.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Deployment.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Deployment.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Deployment.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Deployment.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Deployment.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.Deployment.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Deployment.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Deployment.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.Deployment.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.Deployment.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.Deployment.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.Deployment.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Deployment.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.Deployment.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.Deployment.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.Deployment.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.Deployment.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.Deployment.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Deployment.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.Deployment.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.Deployment.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Deployment.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `minReady`<sup>Required</sup> <a name="minReady" id="cdk8s-plus-28.Deployment.property.minReady"></a>

```typescript
public readonly minReady: Duration;
```

- *Type:* cdk8s.Duration

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

##### `progressDeadline`<sup>Required</sup> <a name="progressDeadline" id="cdk8s-plus-28.Deployment.property.progressDeadline"></a>

```typescript
public readonly progressDeadline: Duration;
```

- *Type:* cdk8s.Duration

The maximum duration for a deployment to make progress before it is considered to be failed.

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.Deployment.property.strategy"></a>

```typescript
public readonly strategy: DeploymentStrategy;
```

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a>

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.Deployment.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

Number of desired pods.

---

##### `hasAutoscaler`<sup>Required</sup> <a name="hasAutoscaler" id="cdk8s-plus-28.Deployment.property.hasAutoscaler"></a>

```typescript
public readonly hasAutoscaler: boolean;
```

- *Type:* boolean

If this is a target of an autoscaler.

---


### DockerConfigSecret <a name="DockerConfigSecret" id="cdk8s-plus-28.DockerConfigSecret"></a>

Create a secret for storing credentials for accessing a container image registry.

> [https://kubernetes.io/docs/concepts/configuration/secret/#docker-config-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#docker-config-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.DockerConfigSecret.Initializer"></a>

```typescript
import { DockerConfigSecret } from 'cdk8s-plus-28'

new DockerConfigSecret(scope: Construct, id: string, props: DockerConfigSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.DockerConfigSecretProps">DockerConfigSecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.DockerConfigSecret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.DockerConfigSecretProps">DockerConfigSecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.DockerConfigSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.DockerConfigSecret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.DockerConfigSecret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.DockerConfigSecret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.DockerConfigSecret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.DockerConfigSecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.DockerConfigSecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.DockerConfigSecret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.DockerConfigSecret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.DockerConfigSecret.isConstruct"></a>

```typescript
import { DockerConfigSecret } from 'cdk8s-plus-28'

DockerConfigSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.DockerConfigSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName"></a>

```typescript
import { DockerConfigSecret } from 'cdk8s-plus-28'

DockerConfigSecret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DockerConfigSecret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.DockerConfigSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.DockerConfigSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.DockerConfigSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.DockerConfigSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.DockerConfigSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DockerConfigSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.DockerConfigSecret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.DockerConfigSecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.DockerConfigSecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.DockerConfigSecret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### GCEPersistentDiskPersistentVolume <a name="GCEPersistentDiskPersistentVolume" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume"></a>

GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin.

> [https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk](https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer"></a>

```typescript
import { GCEPersistentDiskPersistentVolume } from 'cdk8s-plus-28'

new GCEPersistentDiskPersistentVolume(scope: Construct, id: string, props: GCEPersistentDiskPersistentVolumeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps">GCEPersistentDiskPersistentVolumeProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps">GCEPersistentDiskPersistentVolumeProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind"></a>

```typescript
public bind(claim: IPersistentVolumeClaim): void
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.reserve"></a>

```typescript
public reserve(): PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName">fromPersistentVolumeName</a></code> | Imports a pv from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct"></a>

```typescript
import { GCEPersistentDiskPersistentVolume } from 'cdk8s-plus-28'

GCEPersistentDiskPersistentVolume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromPersistentVolumeName` <a name="fromPersistentVolumeName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName"></a>

```typescript
import { GCEPersistentDiskPersistentVolume } from 'cdk8s-plus-28'

GCEPersistentDiskPersistentVolume.fromPersistentVolumeName(scope: Construct, id: string, volumeName: string)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* string

---

###### `volumeName`<sup>Required</sup> <a name="volumeName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storageClassName">storageClassName</a></code> | <code>string</code> | Storage class this volume belongs to. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.fsType">fsType</a></code> | <code>string</code> | File system type of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.pdName">pdName</a></code> | <code>string</code> | PD resource in GCE of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.readOnly">readOnly</a></code> | <code>boolean</code> | Whether or not it is mounted as a read-only volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.partition">partition</a></code> | <code>number</code> | Partition of this volume. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mode"></a>

```typescript
public readonly mode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaimPolicy`<sup>Required</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

Storage class this volume belongs to.

---

##### `fsType`<sup>Required</sup> <a name="fsType" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

File system type of this volume.

---

##### `pdName`<sup>Required</sup> <a name="pdName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.pdName"></a>

```typescript
public readonly pdName: string;
```

- *Type:* string

PD resource in GCE of this volume.

---

##### `readOnly`<sup>Required</sup> <a name="readOnly" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

Whether or not it is mounted as a read-only volume.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolume.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number

Partition of this volume.

---


### Group <a name="Group" id="cdk8s-plus-28.Group"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents a group.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Group.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Group.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Group.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.Group.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Group.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Group.fromName">fromName</a></code> | Reference a group by name. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Group.isConstruct"></a>

```typescript
import { Group } from 'cdk8s-plus-28'

Group.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Group.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromName` <a name="fromName" id="cdk8s-plus-28.Group.fromName"></a>

```typescript
import { Group } from 'cdk8s-plus-28'

Group.fromName(scope: Construct, id: string, name: string)
```

Reference a group by name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Group.fromName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Group.fromName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Group.fromName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Group.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Group.property.kind">kind</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Group.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Group.property.apiGroup">apiGroup</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Group.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Group.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Group.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.Group.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

---


### HorizontalPodAutoscaler <a name="HorizontalPodAutoscaler" id="cdk8s-plus-28.HorizontalPodAutoscaler"></a>

A HorizontalPodAutoscaler scales a workload up or down in response to a metric change.

This allows your services to scale up when demand is high and scale down
when they are no longer needed.


Typical use cases for HorizontalPodAutoscaler:

* When Memory usage is above 70%, scale up the number of replicas to meet the demand.
* When CPU usage is below 30%, scale down the number of replicas to save resources.
* When a service is experiencing a spike in traffic, scale up the number of replicas
   to meet the demand. Then, when the traffic subsides, scale down the number of
   replicas to save resources.

The autoscaler uses the following algorithm to determine the number of replicas to scale:

`desiredReplicas = ceil[currentReplicas * ( currentMetricValue / desiredMetricValue )]`

HorizontalPodAutoscaler's can be used to with any `Scalable` workload:
* Deployment
* StatefulSet

**Targets that already have a replica count defined:**

Remove any replica counts from the target resource before associating with a
HorizontalPodAutoscaler. If this isn't done, then any time a change to that object is applied,
Kubernetes will scale the current number of Pods to the value of the target.replicas key. This
may not be desired and could lead to unexpected behavior.

> [https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/#implicit-maintenance-mode-deactivation](https://kubernetes.io/docs/tasks/run-application/horizontal-pod-autoscale/#implicit-maintenance-mode-deactivation)

*Example*

```typescript
const backend = new kplus.Deployment(this, 'Backend', ...);

const hpa = new kplus.HorizontalPodAutoscaler(chart, 'Hpa', {
 target: backend,
 maxReplicas: 10,
 scaleUp: {
   policies: [
     {
       replicas: kplus.Replicas.absolute(3),
       duration: Duration.minutes(5),
     },
   ],
 },
});
```


#### Initializers <a name="Initializers" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer"></a>

```typescript
import { HorizontalPodAutoscaler } from 'cdk8s-plus-28'

new HorizontalPodAutoscaler(scope: Construct, id: string, props: HorizontalPodAutoscalerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps">HorizontalPodAutoscalerProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.HorizontalPodAutoscaler.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps">HorizontalPodAutoscalerProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.HorizontalPodAutoscaler.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.HorizontalPodAutoscaler.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.HorizontalPodAutoscaler.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct"></a>

```typescript
import { HorizontalPodAutoscaler } from 'cdk8s-plus-28'

HorizontalPodAutoscaler.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.HorizontalPodAutoscaler.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.maxReplicas">maxReplicas</a></code> | <code>number</code> | The maximum number of replicas that can be scaled up to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.minReplicas">minReplicas</a></code> | <code>number</code> | The minimum number of replicas that can be scaled down to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleDown">scaleDown</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleUp">scaleUp</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling up. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.IScalable">IScalable</a></code> | The workload to scale up or down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscaler.property.metrics">metrics</a></code> | <code><a href="#cdk8s-plus-28.Metric">Metric</a>[]</code> | The metric conditions that trigger a scale up or scale down. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `maxReplicas`<sup>Required</sup> <a name="maxReplicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.maxReplicas"></a>

```typescript
public readonly maxReplicas: number;
```

- *Type:* number

The maximum number of replicas that can be scaled up to.

---

##### `minReplicas`<sup>Required</sup> <a name="minReplicas" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.minReplicas"></a>

```typescript
public readonly minReplicas: number;
```

- *Type:* number

The minimum number of replicas that can be scaled down to.

---

##### `scaleDown`<sup>Required</sup> <a name="scaleDown" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleDown"></a>

```typescript
public readonly scaleDown: ScalingRules;
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>

The scaling behavior when scaling down.

---

##### `scaleUp`<sup>Required</sup> <a name="scaleUp" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.scaleUp"></a>

```typescript
public readonly scaleUp: ScalingRules;
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>

The scaling behavior when scaling up.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.target"></a>

```typescript
public readonly target: IScalable;
```

- *Type:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

The workload to scale up or down.

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.HorizontalPodAutoscaler.property.metrics"></a>

```typescript
public readonly metrics: Metric[];
```

- *Type:* <a href="#cdk8s-plus-28.Metric">Metric</a>[]

The metric conditions that trigger a scale up or scale down.

---


### Ingress <a name="Ingress" id="cdk8s-plus-28.Ingress"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services
externally-reachable urls, load balance traffic, terminate SSL, offer name
based virtual hosting etc.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Ingress.Initializer"></a>

```typescript
import { Ingress } from 'cdk8s-plus-28'

new Ingress(scope: Construct, id: string, props?: IngressProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.IngressProps">IngressProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Ingress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Ingress.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Ingress.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressProps">IngressProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Ingress.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Ingress.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Ingress.addDefaultBackend">addDefaultBackend</a></code> | Defines the default backend for this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.addHostDefaultBackend">addHostDefaultBackend</a></code> | Specify a default backend for a specific host name. |
| <code><a href="#cdk8s-plus-28.Ingress.addHostRule">addHostRule</a></code> | Adds an ingress rule applied to requests to a specific host and a specific HTTP path (the `Host` header matches this value). |
| <code><a href="#cdk8s-plus-28.Ingress.addRule">addRule</a></code> | Adds an ingress rule applied to requests sent to a specific HTTP path. |
| <code><a href="#cdk8s-plus-28.Ingress.addRules">addRules</a></code> | Adds rules to this ingress. |
| <code><a href="#cdk8s-plus-28.Ingress.addTls">addTls</a></code> | *No description.* |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Ingress.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Ingress.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Ingress.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addDefaultBackend` <a name="addDefaultBackend" id="cdk8s-plus-28.Ingress.addDefaultBackend"></a>

```typescript
public addDefaultBackend(backend: IngressBackend): void
```

Defines the default backend for this ingress.

A default backend capable of
servicing requests that don't match any rule.

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addDefaultBackend.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to use for requests that do not match any rule.

---

##### `addHostDefaultBackend` <a name="addHostDefaultBackend" id="cdk8s-plus-28.Ingress.addHostDefaultBackend"></a>

```typescript
public addHostDefaultBackend(host: string, backend: IngressBackend): void
```

Specify a default backend for a specific host name.

This backend will be used as a catch-all for requests
targeted to this host name (the `Host` header matches this value).

###### `host`<sup>Required</sup> <a name="host" id="cdk8s-plus-28.Ingress.addHostDefaultBackend.parameter.host"></a>

- *Type:* string

The host name to match.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addHostDefaultBackend.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route to.

---

##### `addHostRule` <a name="addHostRule" id="cdk8s-plus-28.Ingress.addHostRule"></a>

```typescript
public addHostRule(host: string, path: string, backend: IngressBackend, pathType?: HttpIngressPathType): void
```

Adds an ingress rule applied to requests to a specific host and a specific HTTP path (the `Host` header matches this value).

###### `host`<sup>Required</sup> <a name="host" id="cdk8s-plus-28.Ingress.addHostRule.parameter.host"></a>

- *Type:* string

The host name.

---

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Ingress.addHostRule.parameter.path"></a>

- *Type:* string

The HTTP path.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addHostRule.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route requests to.

---

###### `pathType`<sup>Optional</sup> <a name="pathType" id="cdk8s-plus-28.Ingress.addHostRule.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

How the path is matched against request paths.

---

##### `addRule` <a name="addRule" id="cdk8s-plus-28.Ingress.addRule"></a>

```typescript
public addRule(path: string, backend: IngressBackend, pathType?: HttpIngressPathType): void
```

Adds an ingress rule applied to requests sent to a specific HTTP path.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Ingress.addRule.parameter.path"></a>

- *Type:* string

The HTTP path.

---

###### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.Ingress.addRule.parameter.backend"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The backend to route requests to.

---

###### `pathType`<sup>Optional</sup> <a name="pathType" id="cdk8s-plus-28.Ingress.addRule.parameter.pathType"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

How the path is matched against request paths.

---

##### `addRules` <a name="addRules" id="cdk8s-plus-28.Ingress.addRules"></a>

```typescript
public addRules(rules: IngressRule): void
```

Adds rules to this ingress.

###### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.Ingress.addRules.parameter.rules"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressRule">IngressRule</a>

The rules to add.

---

##### `addTls` <a name="addTls" id="cdk8s-plus-28.Ingress.addTls"></a>

```typescript
public addTls(tls: IngressTls[]): void
```

###### `tls`<sup>Required</sup> <a name="tls" id="cdk8s-plus-28.Ingress.addTls.parameter.tls"></a>

- *Type:* <a href="#cdk8s-plus-28.IngressTls">IngressTls</a>[]

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Ingress.isConstruct"></a>

```typescript
import { Ingress } from 'cdk8s-plus-28'

Ingress.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Ingress.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Ingress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Ingress.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Ingress.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Ingress.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Ingress.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Ingress.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Ingress.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Ingress.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Ingress.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Ingress.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Ingress.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Ingress.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Ingress.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Ingress.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Ingress.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### Job <a name="Job" id="cdk8s-plus-28.Job"></a>

A Job creates one or more Pods and ensures that a specified number of them successfully terminate.

As pods successfully complete,
the Job tracks the successful completions. When a specified number of successful completions is reached, the task (ie, Job) is complete.
Deleting a Job will clean up the Pods it created. A simple case is to create one Job object in order to reliably run one Pod to completion.
The Job object will start a new Pod if the first Pod fails or is deleted (for example due to a node hardware failure or a node reboot).
You can also use a Job to run multiple Pods in parallel.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Job.Initializer"></a>

```typescript
import { Job } from 'cdk8s-plus-28'

new Job(scope: Construct, id: string, props?: JobProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.JobProps">JobProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Job.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Job.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Job.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.JobProps">JobProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Job.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Job.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Job.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Job.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Job.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Job.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Job.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Job.select">select</a></code> | Configure selectors for this workload. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Job.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Job.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Job.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.Job.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Job.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.Job.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.Job.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.Job.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Job.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.Job.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Job.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.Job.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Job.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Job.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Job.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.Job.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.Job.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Job.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Job.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Job.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Job.isConstruct"></a>

```typescript
import { Job } from 'cdk8s-plus-28'

Job.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Job.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Job.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Job.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Job.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Job.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Job.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Job.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Job.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Job.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Job.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Job.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Job.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Job.property.activeDeadline">activeDeadline</a></code> | <code>cdk8s.Duration</code> | Duration before job is terminated. |
| <code><a href="#cdk8s-plus-28.Job.property.backoffLimit">backoffLimit</a></code> | <code>number</code> | Number of retries before marking failed. |
| <code><a href="#cdk8s-plus-28.Job.property.ttlAfterFinished">ttlAfterFinished</a></code> | <code>cdk8s.Duration</code> | TTL before the job is deleted after it is finished. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Job.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Job.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Job.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Job.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Job.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Job.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Job.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Job.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Job.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.Job.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Job.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Job.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.Job.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.Job.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.Job.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.Job.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Job.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.Job.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.Job.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.Job.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.Job.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.Job.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Job.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.Job.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.Job.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Job.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `activeDeadline`<sup>Optional</sup> <a name="activeDeadline" id="cdk8s-plus-28.Job.property.activeDeadline"></a>

```typescript
public readonly activeDeadline: Duration;
```

- *Type:* cdk8s.Duration

Duration before job is terminated.

If undefined, there is no deadline.

---

##### `backoffLimit`<sup>Optional</sup> <a name="backoffLimit" id="cdk8s-plus-28.Job.property.backoffLimit"></a>

```typescript
public readonly backoffLimit: number;
```

- *Type:* number

Number of retries before marking failed.

---

##### `ttlAfterFinished`<sup>Optional</sup> <a name="ttlAfterFinished" id="cdk8s-plus-28.Job.property.ttlAfterFinished"></a>

```typescript
public readonly ttlAfterFinished: Duration;
```

- *Type:* cdk8s.Duration

TTL before the job is deleted after it is finished.

---


### KubeApiService <a name="KubeApiService" id="cdk8s-plus-28.k8s.KubeApiService"></a>

APIService represents a server for a particular GroupVersion.

Name must be "version.group".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeApiService.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeApiService(scope: Construct, id: string, props?: KubeApiServiceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeApiServiceProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeApiService.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeApiServiceProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeApiService.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeApiService.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeApiService.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeApiService.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeApiService.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeApiService.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeApiService.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiService.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeApiService.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeApiService.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiService.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeApiService.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeApiService.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiService.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeApiService.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeApiService.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiService.manifest(props?: KubeApiServiceProps)
```

Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeApiService.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeApiServiceProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeApiService.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeApiService.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeApiService.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeApiService.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeApiService.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiService.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeApiService.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiService.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeApiService.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIService".

---

### KubeApiServiceList <a name="KubeApiServiceList" id="cdk8s-plus-28.k8s.KubeApiServiceList"></a>

APIServiceList is a list of APIService objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeApiServiceList(scope: Construct, id: string, props: KubeApiServiceListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeApiServiceListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeApiServiceList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeApiServiceListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeApiServiceList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeApiServiceList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeApiServiceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeApiServiceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeApiServiceList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiServiceList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeApiServiceList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiServiceList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeApiServiceList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeApiServiceList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiServiceList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeApiServiceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeApiServiceList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeApiServiceList.manifest(props: KubeApiServiceListProps)
```

Renders a Kubernetes manifest for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeApiServiceList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeApiServiceListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeApiServiceList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList".

---

### KubeBinding <a name="KubeBinding" id="cdk8s-plus-28.k8s.KubeBinding"></a>

Binding ties one object to another;

for example, a pod is bound to a node by a scheduler. Deprecated in 1.7, please use the bindings subresource of pods instead.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeBinding.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeBinding(scope: Construct, id: string, props: KubeBindingProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeBindingProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeBinding.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeBindingProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeBinding.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeBinding.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeBinding.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Binding". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeBinding.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeBinding.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeBinding.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeBinding.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeBinding.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeBinding.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeBinding.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeBinding.manifest(props: KubeBindingProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Binding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeBinding.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeBindingProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeBinding.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeBinding.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeBinding.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeBinding.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBinding.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeBinding.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Binding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeBinding.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Binding".

---

### KubeCertificateSigningRequest <a name="KubeCertificateSigningRequest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest"></a>

CertificateSigningRequest objects provide a mechanism to obtain x509 certificates by submitting a certificate signing request, and having it asynchronously approved and issued.

Kubelets use this API to obtain:
1. client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client-kubelet" signerName).
2. serving certificates for TLS endpoints kube-apiserver can connect to securely (with the "kubernetes.io/kubelet-serving" signerName).

This API can be used to request client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client" signerName), or to obtain certificates from custom non-Kubernetes signers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCertificateSigningRequest(scope: Construct, id: string, props: KubeCertificateSigningRequestProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequest". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequest.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequest.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequest.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequest.manifest(props: KubeCertificateSigningRequestProps)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequest".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequest". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequest.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequest".

---

### KubeCertificateSigningRequestList <a name="KubeCertificateSigningRequestList" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList"></a>

CertificateSigningRequestList is a collection of CertificateSigningRequest objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCertificateSigningRequestList(scope: Construct, id: string, props: KubeCertificateSigningRequestListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequestList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequestList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequestList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequestList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCertificateSigningRequestList.manifest(props: KubeCertificateSigningRequestListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1.CertificateSigningRequestList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequestList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1.CertificateSigningRequestList".

---

### KubeClusterCidrListV1Alpha1 <a name="KubeClusterCidrListV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1"></a>

ClusterCIDRList contains a list of ClusterCIDR.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterCidrListV1Alpha1(scope: Construct, id: string, props: KubeClusterCidrListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDRList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrListV1Alpha1.manifest(props: KubeClusterCidrListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDRList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDRList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDRList".

---

### KubeClusterCidrv1Alpha1 <a name="KubeClusterCidrv1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1"></a>

ClusterCIDR represents a single configuration for per-Node Pod CIDR allocations when the MultiCIDRRangeAllocator is enabled (see the config for kube-controller-manager).

A cluster may have any number of ClusterCIDR resources, all of which will be considered when allocating a CIDR for a Node.  A ClusterCIDR is eligible to be used for a given Node when the node selector matches the node in question and has free CIDRs to allocate.  In case of multiple matching ClusterCIDR resources, the allocator will attempt to break ties using internal heuristics, but any ClusterCIDR whose node selector matches the Node may be used.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterCidrv1Alpha1(scope: Construct, id: string, props?: KubeClusterCidrv1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDR". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrv1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrv1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrv1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterCidrv1Alpha1.manifest(props?: KubeClusterCidrv1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.ClusterCIDR".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDR". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.ClusterCIDR".

---

### KubeClusterRole <a name="KubeClusterRole" id="cdk8s-plus-28.k8s.KubeClusterRole"></a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterRole(scope: Construct, id: string, props?: KubeClusterRoleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRole.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterRole.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterRole.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRole.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRole.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterRole.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRole". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterRole.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRole.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRole.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterRole.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRole.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRole.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRole.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRole.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRole.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRole.manifest(props?: KubeClusterRoleProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRole".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRole.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterRole.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterRole.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRole.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRole.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRole.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRole.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRole.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRole". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRole.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRole".

---

### KubeClusterRoleBinding <a name="KubeClusterRoleBinding" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding"></a>

ClusterRoleBinding references a ClusterRole, but not contain it.

It can reference a ClusterRole in the global namespace, and adds who information via Subject.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterRoleBinding(scope: Construct, id: string, props: KubeClusterRoleBindingProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleBindingProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleBindingProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBinding". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBinding.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBinding.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBinding.manifest(props: KubeClusterRoleBindingProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleBindingProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleBinding.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBinding".

---

### KubeClusterRoleBindingList <a name="KubeClusterRoleBindingList" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList"></a>

ClusterRoleBindingList is a collection of ClusterRoleBindings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterRoleBindingList(scope: Construct, id: string, props: KubeClusterRoleBindingListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBindingList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBindingList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBindingList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBindingList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleBindingList.manifest(props: KubeClusterRoleBindingListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleBindingList".

---

### KubeClusterRoleList <a name="KubeClusterRoleList" id="cdk8s-plus-28.k8s.KubeClusterRoleList"></a>

ClusterRoleList is a collection of ClusterRoles.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterRoleList(scope: Construct, id: string, props: KubeClusterRoleListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterRoleList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterRoleList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterRoleList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterRoleList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterRoleList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterRoleList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterRoleList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterRoleList.manifest(props: KubeClusterRoleListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.ClusterRoleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterRoleList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterRoleList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.ClusterRoleList".

---

### KubeClusterTrustBundleListV1Alpha1 <a name="KubeClusterTrustBundleListV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1"></a>

ClusterTrustBundleList is a collection of ClusterTrustBundle objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterTrustBundleListV1Alpha1(scope: Construct, id: string, props: KubeClusterTrustBundleListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleListV1Alpha1.manifest(props: KubeClusterTrustBundleListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundleList".

---

### KubeClusterTrustBundleV1Alpha1 <a name="KubeClusterTrustBundleV1Alpha1" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1"></a>

ClusterTrustBundle is a cluster-scoped container for X.509 trust anchors (root certificates).

ClusterTrustBundle objects are considered to be readable by any authenticated user in the cluster, because they can be mounted by pods using the `clusterTrustBundle` projection.  All service accounts have read access to ClusterTrustBundles by default.  Users who only have namespace-level access to a cluster can read ClusterTrustBundles by impersonating a serviceaccount that they have access to.

It can be optionally associated with a particular assigner, in which case it contains one valid set of trust anchors for that signer. Signers may have multiple associated ClusterTrustBundles; each is an independent set of trust anchors for that signer. Admission control is used to enforce that only users with permissions on the signer can create or modify the corresponding bundle.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeClusterTrustBundleV1Alpha1(scope: Construct, id: string, props: KubeClusterTrustBundleV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeClusterTrustBundleV1Alpha1.manifest(props: KubeClusterTrustBundleV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.certificates.v1alpha1.ClusterTrustBundle".

---

### KubeComponentStatus <a name="KubeComponentStatus" id="cdk8s-plus-28.k8s.KubeComponentStatus"></a>

ComponentStatus (and ComponentStatusList) holds the cluster validation info.

Deprecated: This API is deprecated in v1.19+

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeComponentStatus(scope: Construct, id: string, props?: KubeComponentStatusProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeComponentStatusProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeComponentStatus.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeComponentStatusProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeComponentStatus.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeComponentStatus.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeComponentStatus.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeComponentStatus.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeComponentStatus.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatus". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatus.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeComponentStatus.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatus.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeComponentStatus.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeComponentStatus.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatus.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeComponentStatus.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeComponentStatus.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatus.manifest(props?: KubeComponentStatusProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatus".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeComponentStatus.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeComponentStatusProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatus.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatus". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeComponentStatus.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatus".

---

### KubeComponentStatusList <a name="KubeComponentStatusList" id="cdk8s-plus-28.k8s.KubeComponentStatusList"></a>

Status of all the conditions for the component as a list of ComponentStatus objects.

Deprecated: This API is deprecated in v1.19+

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeComponentStatusList(scope: Construct, id: string, props: KubeComponentStatusListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeComponentStatusListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeComponentStatusList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeComponentStatusListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeComponentStatusList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeComponentStatusList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeComponentStatusList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatusList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatusList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatusList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeComponentStatusList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeComponentStatusList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatusList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeComponentStatusList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeComponentStatusList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeComponentStatusList.manifest(props: KubeComponentStatusListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ComponentStatusList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeComponentStatusList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeComponentStatusListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatusList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeComponentStatusList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ComponentStatusList".

---

### KubeConfigMap <a name="KubeConfigMap" id="cdk8s-plus-28.k8s.KubeConfigMap"></a>

ConfigMap holds configuration data for pods to consume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeConfigMap(scope: Construct, id: string, props?: KubeConfigMapProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeConfigMapProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeConfigMap.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeConfigMapProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeConfigMap.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeConfigMap.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeConfigMap.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeConfigMap.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeConfigMap.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMap". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeConfigMap.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMap.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeConfigMap.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeConfigMap.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMap.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeConfigMap.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeConfigMap.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMap.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeConfigMap.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMap.manifest(props?: KubeConfigMapProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMap".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeConfigMap.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeConfigMapProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeConfigMap.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeConfigMap.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeConfigMap.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeConfigMap.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeConfigMap.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMap.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeConfigMap.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMap.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMap". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeConfigMap.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMap".

---

### KubeConfigMapList <a name="KubeConfigMapList" id="cdk8s-plus-28.k8s.KubeConfigMapList"></a>

ConfigMapList is a resource containing a list of ConfigMap objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeConfigMapList(scope: Construct, id: string, props: KubeConfigMapListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeConfigMapListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeConfigMapList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeConfigMapListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeConfigMapList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeConfigMapList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeConfigMapList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeConfigMapList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeConfigMapList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMapList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMapList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeConfigMapList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMapList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeConfigMapList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeConfigMapList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMapList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeConfigMapList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeConfigMapList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeConfigMapList.manifest(props: KubeConfigMapListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ConfigMapList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeConfigMapList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeConfigMapListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMapList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeConfigMapList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ConfigMapList".

---

### KubeControllerRevision <a name="KubeControllerRevision" id="cdk8s-plus-28.k8s.KubeControllerRevision"></a>

ControllerRevision implements an immutable snapshot of state data.

Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeControllerRevision(scope: Construct, id: string, props: KubeControllerRevisionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeControllerRevisionProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeControllerRevision.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeControllerRevisionProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeControllerRevision.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeControllerRevision.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeControllerRevision.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeControllerRevision.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeControllerRevision.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevision". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevision.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeControllerRevision.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevision.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeControllerRevision.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeControllerRevision.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevision.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeControllerRevision.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevision.manifest(props: KubeControllerRevisionProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevision".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeControllerRevision.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeControllerRevisionProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevision.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevision". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeControllerRevision.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevision".

---

### KubeControllerRevisionList <a name="KubeControllerRevisionList" id="cdk8s-plus-28.k8s.KubeControllerRevisionList"></a>

ControllerRevisionList is a resource containing a list of ControllerRevision objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeControllerRevisionList(scope: Construct, id: string, props: KubeControllerRevisionListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeControllerRevisionListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeControllerRevisionListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevisionList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevisionList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevisionList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevisionList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeControllerRevisionList.manifest(props: KubeControllerRevisionListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ControllerRevisionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeControllerRevisionListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevisionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeControllerRevisionList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ControllerRevisionList".

---

### KubeCronJob <a name="KubeCronJob" id="cdk8s-plus-28.k8s.KubeCronJob"></a>

CronJob represents the configuration of a single cron job.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCronJob(scope: Construct, id: string, props?: KubeCronJobProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCronJobProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCronJob.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCronJobProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCronJob.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCronJob.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCronJob.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCronJob.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCronJob.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJob". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCronJob.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJob.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCronJob.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCronJob.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJob.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCronJob.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCronJob.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJob.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCronJob.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCronJob.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJob.manifest(props?: KubeCronJobProps)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJob".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCronJob.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCronJobProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCronJob.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCronJob.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCronJob.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCronJob.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCronJob.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJob.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCronJob.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJob.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJob". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCronJob.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJob".

---

### KubeCronJobList <a name="KubeCronJobList" id="cdk8s-plus-28.k8s.KubeCronJobList"></a>

CronJobList is a collection of cron jobs.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCronJobList(scope: Construct, id: string, props: KubeCronJobListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCronJobListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCronJobList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCronJobListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCronJobList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCronJobList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCronJobList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCronJobList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCronJobList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJobList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCronJobList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJobList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCronJobList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCronJobList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJobList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCronJobList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCronJobList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJobList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCronJobList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCronJobList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCronJobList.manifest(props: KubeCronJobListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.CronJobList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCronJobList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCronJobListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCronJobList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCronJobList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCronJobList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCronJobList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCronJobList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCronJobList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJobList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCronJobList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.CronJobList".

---

### KubeCsiDriver <a name="KubeCsiDriver" id="cdk8s-plus-28.k8s.KubeCsiDriver"></a>

CSIDriver captures information about a Container Storage Interface (CSI) volume driver deployed on the cluster.

Kubernetes attach detach controller uses this object to determine whether attach is required. Kubelet uses this object to determine whether pod information needs to be passed on mount. CSIDriver objects are non-namespaced.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiDriver(scope: Construct, id: string, props: KubeCsiDriverProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiDriverProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiDriver.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiDriverProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiDriver.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiDriver.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiDriver.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiDriver.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiDriver.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriver". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriver.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiDriver.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriver.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiDriver.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiDriver.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriver.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiDriver.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiDriver.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriver.manifest(props: KubeCsiDriverProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriver".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiDriver.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiDriverProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriver.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriver". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiDriver.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriver".

---

### KubeCsiDriverList <a name="KubeCsiDriverList" id="cdk8s-plus-28.k8s.KubeCsiDriverList"></a>

CSIDriverList is a collection of CSIDriver objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiDriverList(scope: Construct, id: string, props: KubeCsiDriverListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiDriverListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiDriverList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiDriverListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiDriverList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiDriverList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiDriverList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriverList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriverList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriverList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiDriverList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiDriverList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriverList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiDriverList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiDriverList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiDriverList.manifest(props: KubeCsiDriverListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIDriverList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiDriverList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiDriverListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriverList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiDriverList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIDriverList".

---

### KubeCsiNode <a name="KubeCsiNode" id="cdk8s-plus-28.k8s.KubeCsiNode"></a>

CSINode holds information about all CSI drivers installed on a node.

CSI drivers do not need to create the CSINode object directly. As long as they use the node-driver-registrar sidecar container, the kubelet will automatically populate the CSINode object for the CSI driver as part of kubelet plugin registration. CSINode has the same name as a node. If the object is missing, it means either there are no CSI Drivers available on the node, or the Kubelet version is low enough that it doesn't create this object. CSINode has an OwnerReference that points to the corresponding node object.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiNode(scope: Construct, id: string, props: KubeCsiNodeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiNodeProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiNode.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiNodeProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiNode.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiNode.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiNode.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiNode.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiNode.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINode". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiNode.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNode.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiNode.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiNode.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNode.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiNode.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiNode.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNode.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiNode.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiNode.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNode.manifest(props: KubeCsiNodeProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINode".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiNode.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiNodeProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiNode.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiNode.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiNode.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiNode.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiNode.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNode.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiNode.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNode.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINode". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiNode.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINode".

---

### KubeCsiNodeList <a name="KubeCsiNodeList" id="cdk8s-plus-28.k8s.KubeCsiNodeList"></a>

CSINodeList is a collection of CSINode objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiNodeList(scope: Construct, id: string, props: KubeCsiNodeListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiNodeListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiNodeList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiNodeListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiNodeList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiNodeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiNodeList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINodeList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNodeList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNodeList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiNodeList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiNodeList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNodeList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiNodeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiNodeList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiNodeList.manifest(props: KubeCsiNodeListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSINodeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiNodeList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiNodeListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINodeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiNodeList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSINodeList".

---

### KubeCsiStorageCapacity <a name="KubeCsiStorageCapacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity"></a>

CSIStorageCapacity stores the result of one CSI GetCapacity call.

For a given StorageClass, this describes the available capacity in a particular topology segment.  This can be used when considering where to instantiate new PersistentVolumes.

For example this can express things like: - StorageClass "standard" has "1234 GiB" available in "topology.kubernetes.io/zone=us-east1" - StorageClass "localssd" has "10 GiB" available in "kubernetes.io/hostname=knode-abc123"

The following three cases all imply that no capacity is available for a certain combination: - no object exists with suitable topology and storage class name - such an object exists, but the capacity is unset - such an object exists, but the capacity is zero

The producer of these objects can decide which approach is more suitable.

They are consumed by the kube-scheduler when a CSI driver opts into capacity-aware scheduling with CSIDriverSpec.StorageCapacity. The scheduler compares the MaximumVolumeSize against the requested size of pending volumes to filter out unsuitable nodes. If MaximumVolumeSize is unset, it falls back to a comparison against the less precise Capacity. If that is also unset, the scheduler assumes that capacity is insufficient and tries some other node.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiStorageCapacity(scope: Construct, id: string, props: KubeCsiStorageCapacityProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacity". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacity.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacity.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacity.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacity.manifest(props: KubeCsiStorageCapacityProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacity".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacity". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacity.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacity".

---

### KubeCsiStorageCapacityList <a name="KubeCsiStorageCapacityList" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList"></a>

CSIStorageCapacityList is a collection of CSIStorageCapacity objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCsiStorageCapacityList(scope: Construct, id: string, props: KubeCsiStorageCapacityListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacityList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacityList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacityList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacityList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCsiStorageCapacityList.manifest(props: KubeCsiStorageCapacityListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.CSIStorageCapacityList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacityList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.CSIStorageCapacityList".

---

### KubeCustomResourceDefinition <a name="KubeCustomResourceDefinition" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition"></a>

CustomResourceDefinition represents a resource that should be exposed on the API server.

Its name MUST be in the format <.spec.name>.<.spec.group>.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCustomResourceDefinition(scope: Construct, id: string, props: KubeCustomResourceDefinitionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinition.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinition.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinition.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinition.manifest(props: KubeCustomResourceDefinitionProps)
```

Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinition.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinition".

---

### KubeCustomResourceDefinitionList <a name="KubeCustomResourceDefinitionList" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList"></a>

CustomResourceDefinitionList is a list of CustomResourceDefinition objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeCustomResourceDefinitionList(scope: Construct, id: string, props: KubeCustomResourceDefinitionListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinitionList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinitionList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinitionList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeCustomResourceDefinitionList.manifest(props: KubeCustomResourceDefinitionListProps)
```

Renders a Kubernetes manifest for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList".

---

### KubeDaemonSet <a name="KubeDaemonSet" id="cdk8s-plus-28.k8s.KubeDaemonSet"></a>

DaemonSet represents the configuration of a daemon set.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeDaemonSet(scope: Construct, id: string, props?: KubeDaemonSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeDaemonSetProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDaemonSet.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDaemonSetProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeDaemonSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeDaemonSet.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDaemonSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDaemonSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeDaemonSet.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSet". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDaemonSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSet.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDaemonSet.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDaemonSet.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSet.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDaemonSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDaemonSet.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSet.manifest(props?: KubeDaemonSetProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDaemonSet.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDaemonSetProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDaemonSet.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSet".

---

### KubeDaemonSetList <a name="KubeDaemonSetList" id="cdk8s-plus-28.k8s.KubeDaemonSetList"></a>

DaemonSetList is a collection of daemon sets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeDaemonSetList(scope: Construct, id: string, props: KubeDaemonSetListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeDaemonSetListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDaemonSetList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDaemonSetListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeDaemonSetList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDaemonSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeDaemonSetList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSetList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSetList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSetList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDaemonSetList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDaemonSetList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSetList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDaemonSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDaemonSetList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDaemonSetList.manifest(props: KubeDaemonSetListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DaemonSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDaemonSetList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDaemonSetListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDaemonSetList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DaemonSetList".

---

### KubeDeployment <a name="KubeDeployment" id="cdk8s-plus-28.k8s.KubeDeployment"></a>

Deployment enables declarative updates for Pods and ReplicaSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeDeployment(scope: Construct, id: string, props?: KubeDeploymentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeDeploymentProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDeployment.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDeploymentProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeDeployment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeDeployment.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDeployment.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDeployment.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeDeployment.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.Deployment". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeDeployment.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeployment.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDeployment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeDeployment.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeployment.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDeployment.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDeployment.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeployment.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDeployment.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDeployment.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeployment.manifest(props?: KubeDeploymentProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.Deployment".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDeployment.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDeploymentProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDeployment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeDeployment.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeDeployment.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDeployment.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDeployment.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeployment.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDeployment.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeployment.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.Deployment". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDeployment.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.Deployment".

---

### KubeDeploymentList <a name="KubeDeploymentList" id="cdk8s-plus-28.k8s.KubeDeploymentList"></a>

DeploymentList is a list of Deployments.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeDeploymentList(scope: Construct, id: string, props: KubeDeploymentListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeDeploymentListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDeploymentList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDeploymentListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeDeploymentList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeDeploymentList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeDeploymentList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeDeploymentList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeDeploymentList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DeploymentList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeploymentList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeDeploymentList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeploymentList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeDeploymentList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeDeploymentList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeploymentList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeDeploymentList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeDeploymentList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeDeploymentList.manifest(props: KubeDeploymentListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.DeploymentList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeDeploymentList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeDeploymentListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.DeploymentList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeDeploymentList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.DeploymentList".

---

### KubeEndpoints <a name="KubeEndpoints" id="cdk8s-plus-28.k8s.KubeEndpoints"></a>

Endpoints is a collection of endpoints that implement the actual service. Example:.

Name: "mysvc",
Subsets: [
  {
    Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
    Ports: [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
  },
  {
    Addresses: [{"ip": "10.10.3.3"}],
    Ports: [{"name": "a", "port": 93}, {"name": "b", "port": 76}]
  },
]

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEndpoints(scope: Construct, id: string, props?: KubeEndpointsProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointsProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpoints.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointsProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEndpoints.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEndpoints.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpoints.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpoints.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEndpoints.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Endpoints". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEndpoints.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpoints.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpoints.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEndpoints.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpoints.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpoints.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpoints.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpoints.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpoints.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpoints.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpoints.manifest(props?: KubeEndpointsProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Endpoints".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpoints.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointsProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpoints.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEndpoints.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEndpoints.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpoints.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpoints.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpoints.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpoints.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpoints.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Endpoints". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpoints.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Endpoints".

---

### KubeEndpointSlice <a name="KubeEndpointSlice" id="cdk8s-plus-28.k8s.KubeEndpointSlice"></a>

EndpointSlice represents a subset of the endpoints that implement a service.

For a given service there may be multiple EndpointSlice objects, selected by labels, which must be joined to produce the full set of endpoints.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEndpointSlice(scope: Construct, id: string, props: KubeEndpointSliceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointSliceProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointSlice.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointSliceProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEndpointSlice.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointSlice.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEndpointSlice.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSlice". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSlice.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSlice.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointSlice.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointSlice.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSlice.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointSlice.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSlice.manifest(props: KubeEndpointSliceProps)
```

Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSlice".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointSlice.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointSliceProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSlice.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSlice". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointSlice.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSlice".

---

### KubeEndpointSliceList <a name="KubeEndpointSliceList" id="cdk8s-plus-28.k8s.KubeEndpointSliceList"></a>

EndpointSliceList represents a list of endpoint slices.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEndpointSliceList(scope: Construct, id: string, props: KubeEndpointSliceListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointSliceListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointSliceListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSliceList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSliceList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSliceList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSliceList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointSliceList.manifest(props: KubeEndpointSliceListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.discovery.v1.EndpointSliceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointSliceListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSliceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointSliceList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.discovery.v1.EndpointSliceList".

---

### KubeEndpointsList <a name="KubeEndpointsList" id="cdk8s-plus-28.k8s.KubeEndpointsList"></a>

EndpointsList is a list of endpoints.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEndpointsList(scope: Construct, id: string, props: KubeEndpointsListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointsListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointsList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointsListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEndpointsList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEndpointsList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEndpointsList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEndpointsList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEndpointsList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.EndpointsList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointsList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEndpointsList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointsList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEndpointsList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEndpointsList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointsList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEndpointsList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEndpointsList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEndpointsList.manifest(props: KubeEndpointsListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.EndpointsList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEndpointsList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEndpointsListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.EndpointsList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEndpointsList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.EndpointsList".

---

### KubeEvent <a name="KubeEvent" id="cdk8s-plus-28.k8s.KubeEvent"></a>

Event is a report of an event somewhere in the cluster.

It generally denotes some state change in the system. Events have a limited retention time and triggers and messages may evolve with time.  Event consumers should not rely on the timing of an event with a given Reason reflecting a consistent underlying trigger, or the continued existence of events with that Reason.  Events should be treated as informative, best-effort, supplemental data.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEvent.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEvent(scope: Construct, id: string, props: KubeEventProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEventProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEvent.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEventProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEvent.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEvent.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEvent.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEvent.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEvent.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEvent.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.events.v1.Event". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEvent.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEvent.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEvent.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEvent.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEvent.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEvent.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEvent.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEvent.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEvent.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEvent.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEvent.manifest(props: KubeEventProps)
```

Renders a Kubernetes manifest for "io.k8s.api.events.v1.Event".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEvent.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEventProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEvent.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEvent.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEvent.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEvent.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEvent.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvent.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEvent.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvent.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.events.v1.Event". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEvent.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.events.v1.Event".

---

### KubeEventList <a name="KubeEventList" id="cdk8s-plus-28.k8s.KubeEventList"></a>

EventList is a list of Event objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEventList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEventList(scope: Construct, id: string, props: KubeEventListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEventListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEventList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEventListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEventList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEventList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEventList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEventList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEventList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEventList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.events.v1.EventList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEventList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEventList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEventList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEventList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEventList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEventList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEventList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEventList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEventList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEventList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEventList.manifest(props: KubeEventListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.events.v1.EventList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEventList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEventListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEventList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEventList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEventList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEventList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEventList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEventList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.events.v1.EventList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEventList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.events.v1.EventList".

---

### KubeEviction <a name="KubeEviction" id="cdk8s-plus-28.k8s.KubeEviction"></a>

Eviction evicts a pod from its node subject to certain policies and safety constraints.

This is a subresource of Pod.  A request to cause such an eviction is created by POSTing to .../pods/<pod name>/evictions.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeEviction.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeEviction(scope: Construct, id: string, props?: KubeEvictionProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeEvictionProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEviction.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEvictionProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeEviction.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeEviction.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeEviction.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeEviction.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeEviction.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeEviction.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.Eviction". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeEviction.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEviction.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeEviction.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeEviction.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEviction.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeEviction.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeEviction.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEviction.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeEviction.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeEviction.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeEviction.manifest(props?: KubeEvictionProps)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.Eviction".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeEviction.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeEvictionProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeEviction.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeEviction.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeEviction.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeEviction.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeEviction.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEviction.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeEviction.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEviction.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.Eviction". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeEviction.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.Eviction".

---

### KubeFlowSchemaListV1Beta2 <a name="KubeFlowSchemaListV1Beta2" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeFlowSchemaListV1Beta2(scope: Construct, id: string, props: KubeFlowSchemaListV1Beta2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta2.manifest(props: KubeFlowSchemaListV1Beta2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchemaList".

---

### KubeFlowSchemaListV1Beta3 <a name="KubeFlowSchemaListV1Beta3" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeFlowSchemaListV1Beta3(scope: Construct, id: string, props: KubeFlowSchemaListV1Beta3Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta3.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta3.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta3.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaListV1Beta3.manifest(props: KubeFlowSchemaListV1Beta3Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchemaList".

---

### KubeFlowSchemaV1Beta2 <a name="KubeFlowSchemaV1Beta2" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeFlowSchemaV1Beta2(scope: Construct, id: string, props?: KubeFlowSchemaV1Beta2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchema". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta2.manifest(props?: KubeFlowSchemaV1Beta2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.FlowSchema".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchema". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.FlowSchema".

---

### KubeFlowSchemaV1Beta3 <a name="KubeFlowSchemaV1Beta3" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeFlowSchemaV1Beta3(scope: Construct, id: string, props?: KubeFlowSchemaV1Beta3Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchema". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta3.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta3.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta3.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeFlowSchemaV1Beta3.manifest(props?: KubeFlowSchemaV1Beta3Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.FlowSchema".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchema". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.FlowSchema".

---

### KubeHorizontalPodAutoscaler <a name="KubeHorizontalPodAutoscaler" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler"></a>

configuration of a horizontal pod autoscaler.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeHorizontalPodAutoscaler(scope: Construct, id: string, props?: KubeHorizontalPodAutoscalerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscaler.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscaler.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscaler.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscaler.manifest(props?: KubeHorizontalPodAutoscalerProps)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscaler.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscaler".

---

### KubeHorizontalPodAutoscalerList <a name="KubeHorizontalPodAutoscalerList" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList"></a>

list of horizontal pod autoscaler objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeHorizontalPodAutoscalerList(scope: Construct, id: string, props: KubeHorizontalPodAutoscalerListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerList.manifest(props: KubeHorizontalPodAutoscalerListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.HorizontalPodAutoscalerList".

---

### KubeHorizontalPodAutoscalerListV2 <a name="KubeHorizontalPodAutoscalerListV2" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2"></a>

HorizontalPodAutoscalerList is a list of horizontal pod autoscaler objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeHorizontalPodAutoscalerListV2(scope: Construct, id: string, props: KubeHorizontalPodAutoscalerListV2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerListV2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerListV2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerListV2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerListV2.manifest(props: KubeHorizontalPodAutoscalerListV2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList".

---

### KubeHorizontalPodAutoscalerV2 <a name="KubeHorizontalPodAutoscalerV2" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2"></a>

HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeHorizontalPodAutoscalerV2(scope: Construct, id: string, props?: KubeHorizontalPodAutoscalerV2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerV2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerV2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerV2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeHorizontalPodAutoscalerV2.manifest(props?: KubeHorizontalPodAutoscalerV2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v2.HorizontalPodAutoscaler".

---

### KubeIngress <a name="KubeIngress" id="cdk8s-plus-28.k8s.KubeIngress"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngress.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIngress(scope: Construct, id: string, props?: KubeIngressProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngress.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIngress.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIngress.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngress.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIngress.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngress.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIngress.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.Ingress". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIngress.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngress.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngress.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIngress.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngress.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngress.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngress.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngress.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngress.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngress.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngress.manifest(props?: KubeIngressProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.Ingress".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngress.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngress.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIngress.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIngress.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngress.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngress.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngress.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngress.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngress.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.Ingress". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngress.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.Ingress".

---

### KubeIngressClass <a name="KubeIngressClass" id="cdk8s-plus-28.k8s.KubeIngressClass"></a>

IngressClass represents the class of the Ingress, referenced by the Ingress Spec.

The `ingressclass.kubernetes.io/is-default-class` annotation can be used to indicate that an IngressClass should be considered default. When a single IngressClass resource has this annotation set to true, new Ingress resources without a class specified will be assigned this default class.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIngressClass(scope: Construct, id: string, props?: KubeIngressClassProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressClassProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressClass.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressClassProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIngressClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIngressClass.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIngressClass.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClass". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIngressClass.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIngressClass.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClass.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressClass.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressClass.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClass.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressClass.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClass.manifest(props?: KubeIngressClassProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressClass.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressClassProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIngressClass.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIngressClass.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressClass.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressClass.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClass.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressClass.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressClass.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClass".

---

### KubeIngressClassList <a name="KubeIngressClassList" id="cdk8s-plus-28.k8s.KubeIngressClassList"></a>

IngressClassList is a collection of IngressClasses.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIngressClassList(scope: Construct, id: string, props: KubeIngressClassListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressClassListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressClassList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressClassListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIngressClassList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIngressClassList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIngressClassList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClassList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClassList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressClassList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClassList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressClassList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressClassList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClassList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressClassList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressClassList.manifest(props: KubeIngressClassListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressClassList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressClassListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressClassList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressClassList".

---

### KubeIngressList <a name="KubeIngressList" id="cdk8s-plus-28.k8s.KubeIngressList"></a>

IngressList is a collection of Ingress.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIngressList(scope: Construct, id: string, props: KubeIngressListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIngressList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIngressList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIngressList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIngressList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIngressList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIngressList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIngressList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIngressList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIngressList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIngressList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIngressList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIngressList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIngressList.manifest(props: KubeIngressListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.IngressList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIngressList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIngressListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIngressList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIngressList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIngressList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIngressList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIngressList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIngressList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIngressList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.IngressList".

---

### KubeIpAddressListV1Alpha1 <a name="KubeIpAddressListV1Alpha1" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1"></a>

IPAddressList contains a list of IPAddress.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIpAddressListV1Alpha1(scope: Construct, id: string, props: KubeIpAddressListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddressList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressListV1Alpha1.manifest(props: KubeIpAddressListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddressList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddressList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddressList".

---

### KubeIpAddressV1Alpha1 <a name="KubeIpAddressV1Alpha1" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1"></a>

IPAddress represents a single IP of a single IP Family.

The object is designed to be used by APIs that operate on IP addresses. The object is used by the Service core API for allocation of IP addresses. An IP address can be represented in different formats, to guarantee the uniqueness of the IP, the name of the object is the IP address in canonical format, four decimal digits separated by dots suppressing leading zeros for IPv4 and the representation defined by RFC 5952 for IPv6. Valid: 192.168.1.5 or 2001:db8::1 or 2001:db8:aaaa:bbbb:cccc:dddd:eeee:1 Invalid: 10.01.2.3 or 2001:db8:0:0:0::1

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeIpAddressV1Alpha1(scope: Construct, id: string, props?: KubeIpAddressV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddress". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeIpAddressV1Alpha1.manifest(props?: KubeIpAddressV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1alpha1.IPAddress".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddress". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1alpha1.IPAddress".

---

### KubeJob <a name="KubeJob" id="cdk8s-plus-28.k8s.KubeJob"></a>

Job represents the configuration of a single job.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeJob.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeJob(scope: Construct, id: string, props?: KubeJobProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeJobProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeJob.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeJobProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeJob.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeJob.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeJob.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeJob.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeJob.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeJob.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.Job". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeJob.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJob.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeJob.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeJob.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJob.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeJob.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeJob.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJob.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeJob.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeJob.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJob.manifest(props?: KubeJobProps)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.Job".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeJob.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeJobProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeJob.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeJob.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeJob.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeJob.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeJob.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJob.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeJob.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJob.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.Job". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeJob.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.Job".

---

### KubeJobList <a name="KubeJobList" id="cdk8s-plus-28.k8s.KubeJobList"></a>

JobList is a collection of jobs.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeJobList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeJobList(scope: Construct, id: string, props: KubeJobListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeJobListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeJobList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeJobListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeJobList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeJobList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeJobList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeJobList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeJobList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeJobList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.batch.v1.JobList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeJobList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJobList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeJobList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeJobList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJobList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeJobList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeJobList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJobList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeJobList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeJobList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeJobList.manifest(props: KubeJobListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.batch.v1.JobList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeJobList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeJobListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeJobList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeJobList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeJobList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeJobList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeJobList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeJobList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.batch.v1.JobList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeJobList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.batch.v1.JobList".

---

### KubeLease <a name="KubeLease" id="cdk8s-plus-28.k8s.KubeLease"></a>

Lease defines a lease concept.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLease.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeLease(scope: Construct, id: string, props?: KubeLeaseProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeLeaseProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLease.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLeaseProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeLease.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeLease.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLease.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeLease.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLease.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeLease.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.Lease". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeLease.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLease.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLease.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeLease.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLease.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLease.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLease.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLease.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLease.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLease.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLease.manifest(props?: KubeLeaseProps)
```

Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.Lease".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLease.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLeaseProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLease.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeLease.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeLease.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLease.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLease.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLease.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLease.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLease.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.coordination.v1.Lease". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLease.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.coordination.v1.Lease".

---

### KubeLeaseList <a name="KubeLeaseList" id="cdk8s-plus-28.k8s.KubeLeaseList"></a>

LeaseList is a list of Lease objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeLeaseList(scope: Construct, id: string, props: KubeLeaseListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeLeaseListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLeaseList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLeaseListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeLeaseList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeLeaseList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLeaseList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLeaseList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeLeaseList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.LeaseList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeLeaseList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLeaseList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLeaseList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeLeaseList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLeaseList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLeaseList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLeaseList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLeaseList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLeaseList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLeaseList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLeaseList.manifest(props: KubeLeaseListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.coordination.v1.LeaseList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLeaseList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLeaseListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLeaseList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeLeaseList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeLeaseList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLeaseList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLeaseList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLeaseList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.coordination.v1.LeaseList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLeaseList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.coordination.v1.LeaseList".

---

### KubeLimitRange <a name="KubeLimitRange" id="cdk8s-plus-28.k8s.KubeLimitRange"></a>

LimitRange sets resource usage limits for each kind of resource in a Namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeLimitRange(scope: Construct, id: string, props?: KubeLimitRangeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeLimitRangeProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLimitRange.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLimitRangeProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeLimitRange.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeLimitRange.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLimitRange.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLimitRange.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeLimitRange.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRange". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeLimitRange.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRange.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLimitRange.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeLimitRange.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRange.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLimitRange.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLimitRange.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRange.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLimitRange.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLimitRange.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRange.manifest(props?: KubeLimitRangeProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRange".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLimitRange.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLimitRangeProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLimitRange.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeLimitRange.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeLimitRange.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLimitRange.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLimitRange.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRange.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLimitRange.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRange.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRange". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLimitRange.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRange".

---

### KubeLimitRangeList <a name="KubeLimitRangeList" id="cdk8s-plus-28.k8s.KubeLimitRangeList"></a>

LimitRangeList is a list of LimitRange items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeLimitRangeList(scope: Construct, id: string, props: KubeLimitRangeListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeLimitRangeListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLimitRangeList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLimitRangeListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeLimitRangeList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLimitRangeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeLimitRangeList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRangeList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRangeList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRangeList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLimitRangeList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLimitRangeList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRangeList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLimitRangeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLimitRangeList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLimitRangeList.manifest(props: KubeLimitRangeListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.LimitRangeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLimitRangeList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLimitRangeListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRangeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLimitRangeList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.LimitRangeList".

---

### KubeLocalSubjectAccessReview <a name="KubeLocalSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview"></a>

LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace.

Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeLocalSubjectAccessReview(scope: Construct, id: string, props: KubeLocalSubjectAccessReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.LocalSubjectAccessReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLocalSubjectAccessReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLocalSubjectAccessReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLocalSubjectAccessReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeLocalSubjectAccessReview.manifest(props: KubeLocalSubjectAccessReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.LocalSubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.LocalSubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.LocalSubjectAccessReview".

---

### KubeMutatingWebhookConfiguration <a name="KubeMutatingWebhookConfiguration" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration"></a>

MutatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and may change the object.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeMutatingWebhookConfiguration(scope: Construct, id: string, props?: KubeMutatingWebhookConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfiguration.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfiguration.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfiguration.manifest(props?: KubeMutatingWebhookConfigurationProps)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfiguration.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfiguration".

---

### KubeMutatingWebhookConfigurationList <a name="KubeMutatingWebhookConfigurationList" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList"></a>

MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeMutatingWebhookConfigurationList(scope: Construct, id: string, props: KubeMutatingWebhookConfigurationListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfigurationList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfigurationList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfigurationList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeMutatingWebhookConfigurationList.manifest(props: KubeMutatingWebhookConfigurationListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList".

---

### KubeNamespace <a name="KubeNamespace" id="cdk8s-plus-28.k8s.KubeNamespace"></a>

Namespace provides a scope for Names.

Use of multiple namespaces is optional.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNamespace(scope: Construct, id: string, props?: KubeNamespaceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNamespaceProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNamespace.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNamespaceProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNamespace.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNamespace.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNamespace.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNamespace.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNamespace.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Namespace". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNamespace.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespace.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNamespace.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNamespace.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespace.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNamespace.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNamespace.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespace.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNamespace.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNamespace.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespace.manifest(props?: KubeNamespaceProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Namespace".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNamespace.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNamespaceProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNamespace.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNamespace.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNamespace.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNamespace.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNamespace.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespace.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNamespace.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespace.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Namespace". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNamespace.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Namespace".

---

### KubeNamespaceList <a name="KubeNamespaceList" id="cdk8s-plus-28.k8s.KubeNamespaceList"></a>

NamespaceList is a list of Namespaces.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNamespaceList(scope: Construct, id: string, props: KubeNamespaceListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNamespaceListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNamespaceList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNamespaceListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNamespaceList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNamespaceList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNamespaceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNamespaceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNamespaceList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.NamespaceList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespaceList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNamespaceList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespaceList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNamespaceList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNamespaceList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespaceList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNamespaceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNamespaceList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNamespaceList.manifest(props: KubeNamespaceListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.NamespaceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNamespaceList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNamespaceListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.NamespaceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNamespaceList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.NamespaceList".

---

### KubeNetworkPolicy <a name="KubeNetworkPolicy" id="cdk8s-plus-28.k8s.KubeNetworkPolicy"></a>

NetworkPolicy describes what network traffic is allowed for a set of Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNetworkPolicy(scope: Construct, id: string, props?: KubeNetworkPolicyProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNetworkPolicyProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNetworkPolicyProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicy". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicy.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicy.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicy.manifest(props?: KubeNetworkPolicyProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNetworkPolicyProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicy.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNetworkPolicy.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicy".

---

### KubeNetworkPolicyList <a name="KubeNetworkPolicyList" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList"></a>

NetworkPolicyList is a list of NetworkPolicy objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNetworkPolicyList(scope: Construct, id: string, props: KubeNetworkPolicyListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNetworkPolicyListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNetworkPolicyListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicyList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicyList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicyList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicyList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNetworkPolicyList.manifest(props: KubeNetworkPolicyListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.networking.v1.NetworkPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNetworkPolicyListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNetworkPolicyList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.networking.v1.NetworkPolicyList".

---

### KubeNode <a name="KubeNode" id="cdk8s-plus-28.k8s.KubeNode"></a>

Node is a worker node in Kubernetes.

Each node will have a unique identifier in the cache (i.e. in etcd).

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNode.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNode(scope: Construct, id: string, props?: KubeNodeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNodeProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNode.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNodeProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNode.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNode.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNode.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNode.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNode.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNode.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Node". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNode.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNode.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNode.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNode.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNode.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNode.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNode.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNode.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNode.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNode.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNode.manifest(props?: KubeNodeProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Node".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNode.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNodeProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNode.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNode.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNode.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNode.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNode.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNode.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNode.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNode.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Node". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNode.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Node".

---

### KubeNodeList <a name="KubeNodeList" id="cdk8s-plus-28.k8s.KubeNodeList"></a>

NodeList is the whole list of all Nodes which have been registered with master.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeNodeList(scope: Construct, id: string, props: KubeNodeListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeNodeListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNodeList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNodeListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeNodeList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeNodeList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeNodeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeNodeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeNodeList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.NodeList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeNodeList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNodeList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeNodeList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeNodeList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNodeList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeNodeList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeNodeList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNodeList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeNodeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeNodeList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeNodeList.manifest(props: KubeNodeListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.NodeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeNodeList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeNodeListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeNodeList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeNodeList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeNodeList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeNodeList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeNodeList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeNodeList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.NodeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeNodeList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.NodeList".

---

### KubePersistentVolume <a name="KubePersistentVolume" id="cdk8s-plus-28.k8s.KubePersistentVolume"></a>

PersistentVolume (PV) is a storage resource provisioned by an administrator.

It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePersistentVolume(scope: Construct, id: string, props?: KubePersistentVolumeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolume.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePersistentVolume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePersistentVolume.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolume.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolume.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePersistentVolume.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolume". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolume.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolume.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolume.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolume.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolume.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolume.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolume.manifest(props?: KubePersistentVolumeProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolume".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolume.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolume.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolume". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolume.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolume".

---

### KubePersistentVolumeClaim <a name="KubePersistentVolumeClaim" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim"></a>

PersistentVolumeClaim is a user's request for and claim to a persistent volume.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePersistentVolumeClaim(scope: Construct, id: string, props?: KubePersistentVolumeClaimProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaim". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaim.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaim.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaim.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaim.manifest(props?: KubePersistentVolumeClaimProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaim".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaim". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaim.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaim".

---

### KubePersistentVolumeClaimList <a name="KubePersistentVolumeClaimList" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList"></a>

PersistentVolumeClaimList is a list of PersistentVolumeClaim items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePersistentVolumeClaimList(scope: Construct, id: string, props: KubePersistentVolumeClaimListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaimList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaimList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaimList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaimList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeClaimList.manifest(props: KubePersistentVolumeClaimListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeClaimList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaimList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeClaimList".

---

### KubePersistentVolumeList <a name="KubePersistentVolumeList" id="cdk8s-plus-28.k8s.KubePersistentVolumeList"></a>

PersistentVolumeList is a list of PersistentVolume items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePersistentVolumeList(scope: Construct, id: string, props: KubePersistentVolumeListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePersistentVolumeList.manifest(props: KubePersistentVolumeListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PersistentVolumeList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePersistentVolumeList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PersistentVolumeList".

---

### KubePod <a name="KubePod" id="cdk8s-plus-28.k8s.KubePod"></a>

Pod is a collection of containers that can run on a host.

This resource is created by clients and scheduled onto hosts.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePod.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePod(scope: Construct, id: string, props?: KubePodProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePod.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePod.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePod.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePod.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePod.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePod.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePod.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Pod". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePod.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePod.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePod.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePod.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePod.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePod.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePod.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePod.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePod.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePod.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePod.manifest(props?: KubePodProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Pod".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePod.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePod.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePod.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePod.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePod.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePod.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePod.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePod.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePod.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Pod". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePod.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Pod".

---

### KubePodDisruptionBudget <a name="KubePodDisruptionBudget" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget"></a>

PodDisruptionBudget is an object to define the max disruption that can be caused to a collection of pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodDisruptionBudget(scope: Construct, id: string, props?: KubePodDisruptionBudgetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudget". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudget.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudget.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudget.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudget.manifest(props?: KubePodDisruptionBudgetProps)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudget".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudget". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodDisruptionBudget.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudget".

---

### KubePodDisruptionBudgetList <a name="KubePodDisruptionBudgetList" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList"></a>

PodDisruptionBudgetList is a collection of PodDisruptionBudgets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodDisruptionBudgetList(scope: Construct, id: string, props: KubePodDisruptionBudgetListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudgetList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudgetList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudgetList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudgetList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodDisruptionBudgetList.manifest(props: KubePodDisruptionBudgetListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.policy.v1.PodDisruptionBudgetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudgetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.policy.v1.PodDisruptionBudgetList".

---

### KubePodList <a name="KubePodList" id="cdk8s-plus-28.k8s.KubePodList"></a>

PodList is a list of Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodList(scope: Construct, id: string, props: KubePodListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodList.manifest(props: KubePodListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodList".

---

### KubePodSchedulingContextListV1Alpha2 <a name="KubePodSchedulingContextListV1Alpha2" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2"></a>

PodSchedulingContextList is a collection of Pod scheduling objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodSchedulingContextListV1Alpha2(scope: Construct, id: string, props: KubePodSchedulingContextListV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextListV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextListV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextListV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextListV1Alpha2.manifest(props: KubePodSchedulingContextListV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContextList".

---

### KubePodSchedulingContextV1Alpha2 <a name="KubePodSchedulingContextV1Alpha2" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2"></a>

PodSchedulingContext objects hold information that is needed to schedule a Pod with ResourceClaims that use "WaitForFirstConsumer" allocation mode.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodSchedulingContextV1Alpha2(scope: Construct, id: string, props: KubePodSchedulingContextV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContext". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodSchedulingContextV1Alpha2.manifest(props: KubePodSchedulingContextV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.PodSchedulingContext".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContext". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.PodSchedulingContext".

---

### KubePodTemplate <a name="KubePodTemplate" id="cdk8s-plus-28.k8s.KubePodTemplate"></a>

PodTemplate describes a template for creating copies of a predefined pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodTemplate(scope: Construct, id: string, props?: KubePodTemplateProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodTemplateProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodTemplate.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodTemplateProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodTemplate.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodTemplate.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodTemplate.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodTemplate.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodTemplate.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplate". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodTemplate.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplate.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodTemplate.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodTemplate.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplate.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodTemplate.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodTemplate.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplate.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodTemplate.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodTemplate.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplate.manifest(props?: KubePodTemplateProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplate".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodTemplate.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodTemplateProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodTemplate.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodTemplate.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodTemplate.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodTemplate.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodTemplate.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplate.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodTemplate.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplate.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplate". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodTemplate.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplate".

---

### KubePodTemplateList <a name="KubePodTemplateList" id="cdk8s-plus-28.k8s.KubePodTemplateList"></a>

PodTemplateList is a list of PodTemplates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePodTemplateList(scope: Construct, id: string, props: KubePodTemplateListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePodTemplateListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodTemplateList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodTemplateListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePodTemplateList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePodTemplateList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePodTemplateList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePodTemplateList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePodTemplateList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplateList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplateList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePodTemplateList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplateList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePodTemplateList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePodTemplateList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplateList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePodTemplateList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePodTemplateList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePodTemplateList.manifest(props: KubePodTemplateListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.PodTemplateList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePodTemplateList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePodTemplateListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplateList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePodTemplateList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.PodTemplateList".

---

### KubePriorityClass <a name="KubePriorityClass" id="cdk8s-plus-28.k8s.KubePriorityClass"></a>

PriorityClass defines mapping from a priority class name to the priority integer value.

The value can be any valid integer.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityClass(scope: Construct, id: string, props: KubePriorityClassProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityClassProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityClass.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityClassProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityClass.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityClass.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClass". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityClass.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityClass.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClass.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityClass.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityClass.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClass.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClass.manifest(props: KubePriorityClassProps)
```

Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityClass.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityClassProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityClass.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityClass.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityClass.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityClass.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClass.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityClass.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityClass.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClass".

---

### KubePriorityClassList <a name="KubePriorityClassList" id="cdk8s-plus-28.k8s.KubePriorityClassList"></a>

PriorityClassList is a collection of priority classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityClassList(scope: Construct, id: string, props: KubePriorityClassListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityClassListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityClassList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityClassListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityClassList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityClassList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityClassList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClassList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClassList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityClassList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClassList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityClassList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityClassList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClassList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityClassList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityClassList.manifest(props: KubePriorityClassListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.scheduling.v1.PriorityClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityClassList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityClassListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityClassList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.scheduling.v1.PriorityClassList".

---

### KubePriorityLevelConfigurationListV1Beta2 <a name="KubePriorityLevelConfigurationListV1Beta2" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityLevelConfigurationListV1Beta2(scope: Construct, id: string, props: KubePriorityLevelConfigurationListV1Beta2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta2.manifest(props: KubePriorityLevelConfigurationListV1Beta2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfigurationList".

---

### KubePriorityLevelConfigurationListV1Beta3 <a name="KubePriorityLevelConfigurationListV1Beta3" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityLevelConfigurationListV1Beta3(scope: Construct, id: string, props: KubePriorityLevelConfigurationListV1Beta3Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta3.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationListV1Beta3.manifest(props: KubePriorityLevelConfigurationListV1Beta3Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList".

---

### KubePriorityLevelConfigurationV1Beta2 <a name="KubePriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityLevelConfigurationV1Beta2(scope: Construct, id: string, props?: KubePriorityLevelConfigurationV1Beta2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta2.manifest(props?: KubePriorityLevelConfigurationV1Beta2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta2.PriorityLevelConfiguration".

---

### KubePriorityLevelConfigurationV1Beta3 <a name="KubePriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubePriorityLevelConfigurationV1Beta3(scope: Construct, id: string, props?: KubePriorityLevelConfigurationV1Beta3Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta3.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubePriorityLevelConfigurationV1Beta3.manifest(props?: KubePriorityLevelConfigurationV1Beta3Props)
```

Renders a Kubernetes manifest for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfiguration".

---

### KubeReplicaSet <a name="KubeReplicaSet" id="cdk8s-plus-28.k8s.KubeReplicaSet"></a>

ReplicaSet ensures that a specified number of pod replicas are running at any given time.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeReplicaSet(scope: Construct, id: string, props?: KubeReplicaSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicaSetProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicaSet.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicaSetProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeReplicaSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeReplicaSet.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicaSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicaSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeReplicaSet.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSet". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicaSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSet.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicaSet.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicaSet.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSet.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicaSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicaSet.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSet.manifest(props?: KubeReplicaSetProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicaSet.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicaSetProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicaSet.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSet".

---

### KubeReplicaSetList <a name="KubeReplicaSetList" id="cdk8s-plus-28.k8s.KubeReplicaSetList"></a>

ReplicaSetList is a collection of ReplicaSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeReplicaSetList(scope: Construct, id: string, props: KubeReplicaSetListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicaSetListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicaSetList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicaSetListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeReplicaSetList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicaSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeReplicaSetList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSetList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSetList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSetList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicaSetList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicaSetList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSetList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicaSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicaSetList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicaSetList.manifest(props: KubeReplicaSetListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.ReplicaSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicaSetList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicaSetListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicaSetList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.ReplicaSetList".

---

### KubeReplicationController <a name="KubeReplicationController" id="cdk8s-plus-28.k8s.KubeReplicationController"></a>

ReplicationController represents the configuration of a replication controller.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeReplicationController(scope: Construct, id: string, props?: KubeReplicationControllerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicationControllerProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicationController.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicationControllerProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeReplicationController.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeReplicationController.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicationController.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicationController.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeReplicationController.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationController". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeReplicationController.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationController.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicationController.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeReplicationController.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationController.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicationController.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicationController.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationController.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicationController.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicationController.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationController.manifest(props?: KubeReplicationControllerProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationController".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicationController.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicationControllerProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicationController.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeReplicationController.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeReplicationController.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicationController.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicationController.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationController.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicationController.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationController.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationController". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicationController.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationController".

---

### KubeReplicationControllerList <a name="KubeReplicationControllerList" id="cdk8s-plus-28.k8s.KubeReplicationControllerList"></a>

ReplicationControllerList is a collection of replication controllers.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeReplicationControllerList(scope: Construct, id: string, props: KubeReplicationControllerListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicationControllerListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicationControllerListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationControllerList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationControllerList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationControllerList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationControllerList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeReplicationControllerList.manifest(props: KubeReplicationControllerListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ReplicationControllerList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeReplicationControllerListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationControllerList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeReplicationControllerList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ReplicationControllerList".

---

### KubeResourceClaimListV1Alpha2 <a name="KubeResourceClaimListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2"></a>

ResourceClaimList is a collection of claims.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClaimListV1Alpha2(scope: Construct, id: string, props: KubeResourceClaimListV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimListV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimListV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimListV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimListV1Alpha2.manifest(props: KubeResourceClaimListV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimList".

---

### KubeResourceClaimTemplateListV1Alpha2 <a name="KubeResourceClaimTemplateListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2"></a>

ResourceClaimTemplateList is a collection of claim templates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClaimTemplateListV1Alpha2(scope: Construct, id: string, props: KubeResourceClaimTemplateListV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateListV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateListV1Alpha2.manifest(props: KubeResourceClaimTemplateListV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplateList".

---

### KubeResourceClaimTemplateV1Alpha2 <a name="KubeResourceClaimTemplateV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2"></a>

ResourceClaimTemplate is used to produce ResourceClaim objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClaimTemplateV1Alpha2(scope: Construct, id: string, props: KubeResourceClaimTemplateV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimTemplateV1Alpha2.manifest(props: KubeResourceClaimTemplateV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaimTemplate".

---

### KubeResourceClaimV1Alpha2 <a name="KubeResourceClaimV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2"></a>

ResourceClaim describes which resources are needed by a resource consumer.

Its status tracks whether the resource has been allocated and what the resulting attributes are.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClaimV1Alpha2(scope: Construct, id: string, props: KubeResourceClaimV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaim". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClaimV1Alpha2.manifest(props: KubeResourceClaimV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClaim".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaim". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClaim".

---

### KubeResourceClassListV1Alpha2 <a name="KubeResourceClassListV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2"></a>

ResourceClassList is a collection of classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClassListV1Alpha2(scope: Construct, id: string, props: KubeResourceClassListV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClassList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassListV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassListV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassListV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassListV1Alpha2.manifest(props: KubeResourceClassListV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClassList".

---

### KubeResourceClassV1Alpha2 <a name="KubeResourceClassV1Alpha2" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2"></a>

ResourceClass is used by administrators to influence how resources are allocated.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceClassV1Alpha2(scope: Construct, id: string, props: KubeResourceClassV1Alpha2Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClass". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassV1Alpha2.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassV1Alpha2.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassV1Alpha2.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceClassV1Alpha2.manifest(props: KubeResourceClassV1Alpha2Props)
```

Renders a Kubernetes manifest for "io.k8s.api.resource.v1alpha2.ResourceClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.resource.v1alpha2.ResourceClass".

---

### KubeResourceQuota <a name="KubeResourceQuota" id="cdk8s-plus-28.k8s.KubeResourceQuota"></a>

ResourceQuota sets aggregate quota restrictions enforced per namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceQuota(scope: Construct, id: string, props?: KubeResourceQuotaProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceQuotaProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceQuota.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceQuotaProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceQuota.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceQuota.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceQuota.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceQuota.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceQuota.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuota". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuota.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceQuota.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuota.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceQuota.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceQuota.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuota.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceQuota.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceQuota.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuota.manifest(props?: KubeResourceQuotaProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuota".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceQuota.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceQuotaProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuota.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuota". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceQuota.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuota".

---

### KubeResourceQuotaList <a name="KubeResourceQuotaList" id="cdk8s-plus-28.k8s.KubeResourceQuotaList"></a>

ResourceQuotaList is a list of ResourceQuota items.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeResourceQuotaList(scope: Construct, id: string, props: KubeResourceQuotaListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceQuotaListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceQuotaListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuotaList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuotaList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuotaList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuotaList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeResourceQuotaList.manifest(props: KubeResourceQuotaListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ResourceQuotaList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeResourceQuotaListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuotaList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeResourceQuotaList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ResourceQuotaList".

---

### KubeRole <a name="KubeRole" id="cdk8s-plus-28.k8s.KubeRole"></a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRole.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRole(scope: Construct, id: string, props?: KubeRoleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRole.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRole.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRole.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRole.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRole.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRole.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRole.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.Role". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRole.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRole.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRole.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRole.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRole.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRole.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRole.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRole.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRole.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRole.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRole.manifest(props?: KubeRoleProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.Role".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRole.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRole.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRole.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRole.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRole.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRole.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRole.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRole.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.Role". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRole.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.Role".

---

### KubeRoleBinding <a name="KubeRoleBinding" id="cdk8s-plus-28.k8s.KubeRoleBinding"></a>

RoleBinding references a role, but does not contain it.

It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRoleBinding(scope: Construct, id: string, props: KubeRoleBindingProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleBindingProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleBinding.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleBindingProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRoleBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRoleBinding.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleBinding.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleBinding.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRoleBinding.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBinding". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBinding.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleBinding.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleBinding.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBinding.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleBinding.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBinding.manifest(props: KubeRoleBindingProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleBinding.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleBindingProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBinding.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleBinding.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBinding".

---

### KubeRoleBindingList <a name="KubeRoleBindingList" id="cdk8s-plus-28.k8s.KubeRoleBindingList"></a>

RoleBindingList is a collection of RoleBindings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRoleBindingList(scope: Construct, id: string, props: KubeRoleBindingListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleBindingListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleBindingList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleBindingListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRoleBindingList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleBindingList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRoleBindingList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBindingList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBindingList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBindingList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleBindingList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleBindingList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBindingList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleBindingList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleBindingList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleBindingList.manifest(props: KubeRoleBindingListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleBindingList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleBindingListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleBindingList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleBindingList".

---

### KubeRoleList <a name="KubeRoleList" id="cdk8s-plus-28.k8s.KubeRoleList"></a>

RoleList is a collection of Roles.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRoleList(scope: Construct, id: string, props: KubeRoleListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRoleList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRoleList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRoleList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRoleList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRoleList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRoleList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRoleList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRoleList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRoleList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRoleList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRoleList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRoleList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRoleList.manifest(props: KubeRoleListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.rbac.v1.RoleList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRoleList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRoleListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRoleList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRoleList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRoleList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRoleList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRoleList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRoleList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRoleList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.rbac.v1.RoleList".

---

### KubeRuntimeClass <a name="KubeRuntimeClass" id="cdk8s-plus-28.k8s.KubeRuntimeClass"></a>

RuntimeClass defines a class of container runtime supported in the cluster.

The RuntimeClass is used to determine which container runtime is used to run all containers in a pod. RuntimeClasses are manually defined by a user or cluster provisioner, and referenced in the PodSpec. The Kubelet is responsible for resolving the RuntimeClassName reference before running the pod.  For more details, see https://kubernetes.io/docs/concepts/containers/runtime-class/

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRuntimeClass(scope: Construct, id: string, props: KubeRuntimeClassProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRuntimeClassProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRuntimeClass.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRuntimeClassProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRuntimeClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRuntimeClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRuntimeClass.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClass". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClass.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRuntimeClass.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRuntimeClass.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClass.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRuntimeClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClass.manifest(props: KubeRuntimeClassProps)
```

Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRuntimeClass.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRuntimeClassProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRuntimeClass.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClass".

---

### KubeRuntimeClassList <a name="KubeRuntimeClassList" id="cdk8s-plus-28.k8s.KubeRuntimeClassList"></a>

RuntimeClassList is a list of RuntimeClass objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeRuntimeClassList(scope: Construct, id: string, props: KubeRuntimeClassListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeRuntimeClassListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRuntimeClassListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClassList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClassList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClassList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClassList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeRuntimeClassList.manifest(props: KubeRuntimeClassListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.node.v1.RuntimeClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeRuntimeClassListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeRuntimeClassList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.node.v1.RuntimeClassList".

---

### KubeScale <a name="KubeScale" id="cdk8s-plus-28.k8s.KubeScale"></a>

Scale represents a scaling request for a resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeScale.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeScale(scope: Construct, id: string, props?: KubeScaleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeScaleProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeScale.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeScaleProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeScale.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeScale.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeScale.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeScale.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeScale.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeScale.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.Scale". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeScale.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeScale.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeScale.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeScale.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeScale.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeScale.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeScale.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeScale.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeScale.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeScale.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeScale.manifest(props?: KubeScaleProps)
```

Renders a Kubernetes manifest for "io.k8s.api.autoscaling.v1.Scale".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeScale.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeScaleProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeScale.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeScale.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeScale.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeScale.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeScale.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScale.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeScale.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScale.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.Scale". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeScale.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.autoscaling.v1.Scale".

---

### KubeSecret <a name="KubeSecret" id="cdk8s-plus-28.k8s.KubeSecret"></a>

Secret holds secret data of a certain type.

The total bytes of the values in the Data field must be less than MaxSecretSize bytes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSecret.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSecret(scope: Construct, id: string, props?: KubeSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSecretProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSecret.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSecretProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSecret.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSecret.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSecret.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSecret.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSecret.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Secret". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSecret.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSecret.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecret.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSecret.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSecret.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecret.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSecret.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSecret.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecret.manifest(props?: KubeSecretProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Secret".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSecret.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSecretProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSecret.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecret.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Secret". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSecret.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Secret".

---

### KubeSecretList <a name="KubeSecretList" id="cdk8s-plus-28.k8s.KubeSecretList"></a>

SecretList is a list of Secret.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSecretList(scope: Construct, id: string, props: KubeSecretListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSecretListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSecretList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSecretListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSecretList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSecretList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSecretList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSecretList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSecretList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.SecretList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSecretList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecretList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSecretList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSecretList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecretList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSecretList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSecretList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecretList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSecretList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSecretList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSecretList.manifest(props: KubeSecretListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.SecretList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSecretList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSecretListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSecretList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSecretList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSecretList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSecretList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSecretList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSecretList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.SecretList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSecretList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.SecretList".

---

### KubeSelfSubjectAccessReview <a name="KubeSelfSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview"></a>

SelfSubjectAccessReview checks whether or the current user can perform an action.

Not filling in a spec.namespace means "in all namespaces".  Self is a special case, because users should always be able to check whether they can perform an action

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSelfSubjectAccessReview(scope: Construct, id: string, props: KubeSelfSubjectAccessReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectAccessReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectAccessReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectAccessReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectAccessReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectAccessReview.manifest(props: KubeSelfSubjectAccessReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectAccessReview".

---

### KubeSelfSubjectReview <a name="KubeSelfSubjectReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSelfSubjectReview(scope: Construct, id: string, props?: KubeSelfSubjectReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.SelfSubjectReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReview.manifest(props?: KubeSelfSubjectReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.SelfSubjectReview".

---

### KubeSelfSubjectReviewV1Alpha1 <a name="KubeSelfSubjectReviewV1Alpha1" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSelfSubjectReviewV1Alpha1(scope: Construct, id: string, props?: KubeSelfSubjectReviewV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Alpha1.manifest(props?: KubeSelfSubjectReviewV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1alpha1.SelfSubjectReview".

---

### KubeSelfSubjectReviewV1Beta1 <a name="KubeSelfSubjectReviewV1Beta1" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSelfSubjectReviewV1Beta1(scope: Construct, id: string, props?: KubeSelfSubjectReviewV1Beta1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1beta1.SelfSubjectReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Beta1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Beta1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Beta1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectReviewV1Beta1.manifest(props?: KubeSelfSubjectReviewV1Beta1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1beta1.SelfSubjectReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1beta1.SelfSubjectReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1beta1.SelfSubjectReview".

---

### KubeSelfSubjectRulesReview <a name="KubeSelfSubjectRulesReview" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview"></a>

SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace.

The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSelfSubjectRulesReview(scope: Construct, id: string, props: KubeSelfSubjectRulesReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectRulesReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectRulesReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectRulesReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectRulesReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSelfSubjectRulesReview.manifest(props: KubeSelfSubjectRulesReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SelfSubjectRulesReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectRulesReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SelfSubjectRulesReview".

---

### KubeService <a name="KubeService" id="cdk8s-plus-28.k8s.KubeService"></a>

Service is a named abstraction of software service (for example, mysql) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeService.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeService(scope: Construct, id: string, props?: KubeServiceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeService.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeService.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeService.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeService.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeService.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeService.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeService.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.Service". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeService.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeService.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeService.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeService.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeService.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeService.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeService.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeService.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeService.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeService.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeService.manifest(props?: KubeServiceProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.Service".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeService.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeService.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeService.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeService.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeService.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeService.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeService.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeService.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeService.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.Service". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeService.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.Service".

---

### KubeServiceAccount <a name="KubeServiceAccount" id="cdk8s-plus-28.k8s.KubeServiceAccount"></a>

ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeServiceAccount(scope: Construct, id: string, props?: KubeServiceAccountProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceAccountProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceAccount.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceAccountProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeServiceAccount.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeServiceAccount.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceAccount.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceAccount.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeServiceAccount.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccount". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccount.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceAccount.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccount.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceAccount.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceAccount.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccount.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceAccount.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccount.manifest(props?: KubeServiceAccountProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccount".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceAccount.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceAccountProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccount.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccount". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceAccount.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccount".

---

### KubeServiceAccountList <a name="KubeServiceAccountList" id="cdk8s-plus-28.k8s.KubeServiceAccountList"></a>

ServiceAccountList is a list of ServiceAccount objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeServiceAccountList(scope: Construct, id: string, props: KubeServiceAccountListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceAccountListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceAccountList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceAccountListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeServiceAccountList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceAccountList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeServiceAccountList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccountList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccountList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccountList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceAccountList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceAccountList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccountList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceAccountList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceAccountList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceAccountList.manifest(props: KubeServiceAccountListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceAccountList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceAccountList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceAccountListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccountList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceAccountList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceAccountList".

---

### KubeServiceList <a name="KubeServiceList" id="cdk8s-plus-28.k8s.KubeServiceList"></a>

ServiceList holds a list of services.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeServiceList(scope: Construct, id: string, props: KubeServiceListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeServiceList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeServiceList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeServiceList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeServiceList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeServiceList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeServiceList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeServiceList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeServiceList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeServiceList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeServiceList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeServiceList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeServiceList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeServiceList.manifest(props: KubeServiceListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.core.v1.ServiceList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeServiceList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeServiceListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeServiceList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeServiceList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeServiceList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeServiceList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeServiceList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeServiceList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeServiceList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.core.v1.ServiceList".

---

### KubeStatefulSet <a name="KubeStatefulSet" id="cdk8s-plus-28.k8s.KubeStatefulSet"></a>

StatefulSet represents a set of pods with consistent identities.

Identities are defined as:
- Network: A single stable DNS and hostname.
- Storage: As many VolumeClaims as requested.

The StatefulSet guarantees that a given network identity will always map to the same storage identity.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStatefulSet(scope: Construct, id: string, props?: KubeStatefulSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStatefulSetProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatefulSet.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatefulSetProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStatefulSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStatefulSet.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatefulSet.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatefulSet.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStatefulSet.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSet". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatefulSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSet.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatefulSet.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatefulSet.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSet.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatefulSet.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatefulSet.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSet.manifest(props?: KubeStatefulSetProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSet".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatefulSet.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatefulSetProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSet.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSet". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatefulSet.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSet".

---

### KubeStatefulSetList <a name="KubeStatefulSetList" id="cdk8s-plus-28.k8s.KubeStatefulSetList"></a>

StatefulSetList is a collection of StatefulSets.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStatefulSetList(scope: Construct, id: string, props: KubeStatefulSetListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStatefulSetListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatefulSetList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatefulSetListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStatefulSetList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatefulSetList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStatefulSetList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSetList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSetList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSetList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatefulSetList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatefulSetList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSetList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatefulSetList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatefulSetList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatefulSetList.manifest(props: KubeStatefulSetListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.apps.v1.StatefulSetList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatefulSetList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatefulSetListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSetList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatefulSetList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apps.v1.StatefulSetList".

---

### KubeStatus <a name="KubeStatus" id="cdk8s-plus-28.k8s.KubeStatus"></a>

Status is a return value for calls that don't return other objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStatus.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStatus(scope: Construct, id: string, props?: KubeStatusProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStatusProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatus.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatusProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStatus.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStatus.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStatus.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStatus.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStatus.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStatus.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.apimachinery.pkg.apis.meta.v1.Status". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStatus.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatus.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStatus.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStatus.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatus.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStatus.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStatus.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatus.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStatus.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStatus.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStatus.manifest(props?: KubeStatusProps)
```

Renders a Kubernetes manifest for "io.k8s.apimachinery.pkg.apis.meta.v1.Status".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStatus.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStatusProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStatus.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStatus.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStatus.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStatus.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStatus.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatus.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStatus.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatus.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.apimachinery.pkg.apis.meta.v1.Status". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStatus.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.apimachinery.pkg.apis.meta.v1.Status".

---

### KubeStorageClass <a name="KubeStorageClass" id="cdk8s-plus-28.k8s.KubeStorageClass"></a>

StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.

StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStorageClass(scope: Construct, id: string, props: KubeStorageClassProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageClassProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageClass.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageClassProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStorageClass.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStorageClass.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageClass.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageClass.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStorageClass.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClass". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStorageClass.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClass.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageClass.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStorageClass.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClass.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageClass.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageClass.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClass.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageClass.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClass.manifest(props: KubeStorageClassProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClass".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageClass.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageClassProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageClass.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStorageClass.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStorageClass.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageClass.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageClass.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClass.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageClass.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClass.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClass". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageClass.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClass".

---

### KubeStorageClassList <a name="KubeStorageClassList" id="cdk8s-plus-28.k8s.KubeStorageClassList"></a>

StorageClassList is a collection of storage classes.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStorageClassList(scope: Construct, id: string, props: KubeStorageClassListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageClassListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageClassList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageClassListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStorageClassList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStorageClassList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageClassList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageClassList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStorageClassList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClassList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClassList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageClassList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClassList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageClassList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageClassList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClassList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageClassList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageClassList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageClassList.manifest(props: KubeStorageClassListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.StorageClassList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageClassList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageClassListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClassList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageClassList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.StorageClassList".

---

### KubeStorageVersionListV1Alpha1 <a name="KubeStorageVersionListV1Alpha1" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1"></a>

A list of StorageVersions.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStorageVersionListV1Alpha1(scope: Construct, id: string, props: KubeStorageVersionListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionListV1Alpha1.manifest(props: KubeStorageVersionListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersionList".

---

### KubeStorageVersionV1Alpha1 <a name="KubeStorageVersionV1Alpha1" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1"></a>

Storage version of a specific resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeStorageVersionV1Alpha1(scope: Construct, id: string, props: KubeStorageVersionV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeStorageVersionV1Alpha1.manifest(props: KubeStorageVersionV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.apiserverinternal.v1alpha1.StorageVersion".

---

### KubeSubjectAccessReview <a name="KubeSubjectAccessReview" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview"></a>

SubjectAccessReview checks whether or not a user or group can perform an action.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeSubjectAccessReview(scope: Construct, id: string, props: KubeSubjectAccessReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SubjectAccessReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSubjectAccessReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSubjectAccessReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSubjectAccessReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeSubjectAccessReview.manifest(props: KubeSubjectAccessReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authorization.v1.SubjectAccessReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SubjectAccessReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeSubjectAccessReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authorization.v1.SubjectAccessReview".

---

### KubeTokenRequest <a name="KubeTokenRequest" id="cdk8s-plus-28.k8s.KubeTokenRequest"></a>

TokenRequest requests a token for a given service account.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeTokenRequest(scope: Construct, id: string, props: KubeTokenRequestProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeTokenRequestProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeTokenRequest.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeTokenRequestProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeTokenRequest.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeTokenRequest.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeTokenRequest.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeTokenRequest.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeTokenRequest.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenRequest". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenRequest.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeTokenRequest.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenRequest.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeTokenRequest.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeTokenRequest.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenRequest.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeTokenRequest.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeTokenRequest.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenRequest.manifest(props: KubeTokenRequestProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenRequest".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeTokenRequest.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeTokenRequestProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequest.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenRequest". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeTokenRequest.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenRequest".

---

### KubeTokenReview <a name="KubeTokenReview" id="cdk8s-plus-28.k8s.KubeTokenReview"></a>

TokenReview attempts to authenticate a token to a known user.

Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeTokenReview(scope: Construct, id: string, props: KubeTokenReviewProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeTokenReviewProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeTokenReview.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeTokenReviewProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeTokenReview.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeTokenReview.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeTokenReview.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeTokenReview.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeTokenReview.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenReview". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeTokenReview.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenReview.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeTokenReview.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeTokenReview.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenReview.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeTokenReview.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeTokenReview.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenReview.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeTokenReview.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeTokenReview.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeTokenReview.manifest(props: KubeTokenReviewProps)
```

Renders a Kubernetes manifest for "io.k8s.api.authentication.v1.TokenReview".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeTokenReview.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeTokenReviewProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeTokenReview.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeTokenReview.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeTokenReview.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeTokenReview.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeTokenReview.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReview.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeTokenReview.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReview.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenReview". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeTokenReview.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.authentication.v1.TokenReview".

---

### KubeValidatingAdmissionPolicyBindingListV1Alpha1 <a name="KubeValidatingAdmissionPolicyBindingListV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyBindingListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest(props?: KubeValidatingAdmissionPolicyBindingListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBindingList".

---

### KubeValidatingAdmissionPolicyBindingListV1Beta1 <a name="KubeValidatingAdmissionPolicyBindingListV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyBindingListV1Beta1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest(props?: KubeValidatingAdmissionPolicyBindingListV1Beta1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBindingList".

---

### KubeValidatingAdmissionPolicyBindingV1Alpha1 <a name="KubeValidatingAdmissionPolicyBindingV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyBindingV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest(props?: KubeValidatingAdmissionPolicyBindingV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyBinding".

---

### KubeValidatingAdmissionPolicyBindingV1Beta1 <a name="KubeValidatingAdmissionPolicyBindingV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyBindingV1Beta1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyBindingV1Beta1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest(props?: KubeValidatingAdmissionPolicyBindingV1Beta1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyBinding".

---

### KubeValidatingAdmissionPolicyListV1Alpha1 <a name="KubeValidatingAdmissionPolicyListV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyListV1Alpha1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyListV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest(props?: KubeValidatingAdmissionPolicyListV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicyList".

---

### KubeValidatingAdmissionPolicyListV1Beta1 <a name="KubeValidatingAdmissionPolicyListV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyListV1Beta1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyListV1Beta1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Beta1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest(props?: KubeValidatingAdmissionPolicyListV1Beta1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicyList".

---

### KubeValidatingAdmissionPolicyV1Alpha1 <a name="KubeValidatingAdmissionPolicyV1Alpha1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyV1Alpha1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyV1Alpha1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Alpha1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest(props?: KubeValidatingAdmissionPolicyV1Alpha1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1alpha1.ValidatingAdmissionPolicy".

---

### KubeValidatingAdmissionPolicyV1Beta1 <a name="KubeValidatingAdmissionPolicyV1Beta1" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingAdmissionPolicyV1Beta1(scope: Construct, id: string, props?: KubeValidatingAdmissionPolicyV1Beta1Props)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Beta1.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest(props?: KubeValidatingAdmissionPolicyV1Beta1Props)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1beta1.ValidatingAdmissionPolicy".

---

### KubeValidatingWebhookConfiguration <a name="KubeValidatingWebhookConfiguration" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration"></a>

ValidatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and object without changing it.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingWebhookConfiguration(scope: Construct, id: string, props?: KubeValidatingWebhookConfigurationProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfiguration.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfiguration.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfiguration.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfiguration.manifest(props?: KubeValidatingWebhookConfigurationProps)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfiguration.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfiguration".

---

### KubeValidatingWebhookConfigurationList <a name="KubeValidatingWebhookConfigurationList" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList"></a>

ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeValidatingWebhookConfigurationList(scope: Construct, id: string, props: KubeValidatingWebhookConfigurationListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfigurationList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfigurationList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfigurationList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeValidatingWebhookConfigurationList.manifest(props: KubeValidatingWebhookConfigurationListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList".

---

### KubeVolumeAttachment <a name="KubeVolumeAttachment" id="cdk8s-plus-28.k8s.KubeVolumeAttachment"></a>

VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.

VolumeAttachment objects are non-namespaced.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeVolumeAttachment(scope: Construct, id: string, props: KubeVolumeAttachmentProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeVolumeAttachmentProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeVolumeAttachmentProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachment". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachment.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachment.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachment.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachment.manifest(props: KubeVolumeAttachmentProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachment".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeVolumeAttachmentProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachment.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachment". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeVolumeAttachment.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachment".

---

### KubeVolumeAttachmentList <a name="KubeVolumeAttachmentList" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList"></a>

VolumeAttachmentList is a collection of VolumeAttachment objects.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

new k8s.KubeVolumeAttachmentList(scope: Construct, id: string, props: KubeVolumeAttachmentListProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | the scope in which to define this object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.id">id</a></code> | <code>string</code> | a scope-local name for the object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.props">props</a></code> | <code>cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps</code> | initialization props. |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

the scope in which to define this object.

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.id"></a>

- *Type:* string

a scope-local name for the object.

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.Initializer.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps

initialization props.

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency">addDependency</a></code> | Create a dependency between this ApiObject and other constructs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch">addJsonPatch</a></code> | Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toJson">toJson</a></code> | Renders the object to Kubernetes JSON. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `addDependency` <a name="addDependency" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency"></a>

```typescript
public addDependency(dependencies: IConstruct): void
```

Create a dependency between this ApiObject and other constructs.

These can be other ApiObjects, Charts, or custom.

###### `dependencies`<sup>Required</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addDependency.parameter.dependencies"></a>

- *Type:* constructs.IConstruct

the dependencies to add.

---

##### `addJsonPatch` <a name="addJsonPatch" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch"></a>

```typescript
public addJsonPatch(ops: JsonPatch): void
```

Applies a set of RFC-6902 JSON-Patch operations to the manifest synthesized for this API object.

*Example*

```typescript
  kubePod.addJsonPatch(JsonPatch.replace('/spec/enableServiceLinks', true));
```


###### `ops`<sup>Required</sup> <a name="ops" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.addJsonPatch.parameter.ops"></a>

- *Type:* cdk8s.JsonPatch

The JSON-Patch operations to apply.

---

##### `toJson` <a name="toJson" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.toJson"></a>

```typescript
public toJson(): any
```

Renders the object to Kubernetes JSON.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject">isApiObject</a></code> | Return whether the given object is an `ApiObject`. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of">of</a></code> | Returns the `ApiObject` named `Resource` which is a child of the given construct. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest">manifest</a></code> | Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachmentList". |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachmentList.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `isApiObject` <a name="isApiObject" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachmentList.isApiObject(o: any)
```

Return whether the given object is an `ApiObject`.

We do attribute detection since we can't reliably use 'instanceof'.

###### `o`<sup>Required</sup> <a name="o" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.isApiObject.parameter.o"></a>

- *Type:* any

The object to check.

---

##### `of` <a name="of" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachmentList.of(c: IConstruct)
```

Returns the `ApiObject` named `Resource` which is a child of the given construct.

If `c` is an `ApiObject`, it is returned directly. Throws an
exception if the construct does not have a child named `Default` _or_ if
this child is not an `ApiObject`.

###### `c`<sup>Required</sup> <a name="c" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.of.parameter.c"></a>

- *Type:* constructs.IConstruct

The higher-level construct.

---

##### `manifest` <a name="manifest" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.KubeVolumeAttachmentList.manifest(props: KubeVolumeAttachmentListProps)
```

Renders a Kubernetes manifest for "io.k8s.api.storage.v1.VolumeAttachmentList".

This can be used to inline resource manifests inside other objects (e.g. as templates).

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.manifest.parameter.props"></a>

- *Type:* cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps

initialization props.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. `authorization.k8s.io/v1`). |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.chart">chart</a></code> | <code>cdk8s.Chart</code> | The chart in which this object is defined. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.kind">kind</a></code> | <code>string</code> | The object kind. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | Metadata associated with this API object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.name">name</a></code> | <code>string</code> | The name of the API object. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. `authorization.k8s.io/v1`).

---

##### `chart`<sup>Required</sup> <a name="chart" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.chart"></a>

```typescript
public readonly chart: Chart;
```

- *Type:* cdk8s.Chart

The chart in which this object is defined.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind.

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

Metadata associated with this API object.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the API object.

If a name is specified in `metadata.name` this will be the name returned.
Otherwise, a name will be generated by calling
`Chart.of(this).generatedObjectName(this)`, which by default uses the
construct path to generate a DNS-compatible name for the resource.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.GVK">GVK</a></code> | <code>cdk8s.GroupVersionKind</code> | Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachmentList". |

---

##### `GVK`<sup>Required</sup> <a name="GVK" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentList.property.GVK"></a>

```typescript
public readonly GVK: GroupVersionKind;
```

- *Type:* cdk8s.GroupVersionKind

Returns the apiVersion and kind for "io.k8s.api.storage.v1.VolumeAttachmentList".

---

### Namespace <a name="Namespace" id="cdk8s-plus-28.Namespace"></a>

- *Implements:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

In Kubernetes, namespaces provides a mechanism for isolating groups of resources within a single cluster.

Names of resources need to be unique within a namespace, but not across namespaces.
Namespace-based scoping is applicable only for namespaced objects (e.g. Deployments, Services, etc) and
not for cluster-wide objects (e.g. StorageClass, Nodes, PersistentVolumes, etc).

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Namespace.Initializer"></a>

```typescript
import { Namespace } from 'cdk8s-plus-28'

new Namespace(scope: Construct, id: string, props?: NamespaceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.NamespaceProps">NamespaceProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespace.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespace.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Namespace.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.NamespaceProps">NamespaceProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Namespace.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Namespace.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Namespace.toNamespaceSelectorConfig">toNamespaceSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Namespace.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Namespace.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Namespace.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Namespace.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Namespace.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `toNamespaceSelectorConfig` <a name="toNamespaceSelectorConfig" id="cdk8s-plus-28.Namespace.toNamespaceSelectorConfig"></a>

```typescript
public toNamespaceSelectorConfig(): NamespaceSelectorConfig
```

Return the configuration of this selector.

> [INamespaceSelector.toNamespaceSelectorConfig()](INamespaceSelector.toNamespaceSelectorConfig())

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Namespace.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Namespace.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Namespace.isConstruct"></a>

```typescript
import { Namespace } from 'cdk8s-plus-28'

Namespace.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Namespace.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Namespace.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Namespace.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Namespace.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespace.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Namespace.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Namespace.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Namespace.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Namespace.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Namespace.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Namespace.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Namespace.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Namespace.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Namespace.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Namespace.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespace.property.NAME_LABEL">NAME_LABEL</a></code> | <code>string</code> | *No description.* |

---

##### `NAME_LABEL`<sup>Required</sup> <a name="NAME_LABEL" id="cdk8s-plus-28.Namespace.property.NAME_LABEL"></a>

```typescript
public readonly NAME_LABEL: string;
```

- *Type:* string

> [https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/#automatic-labelling](https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/#automatic-labelling)

---

### Namespaces <a name="Namespaces" id="cdk8s-plus-28.Namespaces"></a>

- *Implements:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Represents a group of namespaces.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Namespaces.Initializer"></a>

```typescript
import { Namespaces } from 'cdk8s-plus-28'

new Namespaces(scope: Construct, id: string, expressions?: LabelExpression[], names?: string[], labels?: {[ key: string ]: string})
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.expressions">expressions</a></code> | <code><a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.names">names</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Namespaces.Initializer.parameter.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.Initializer.parameter.id"></a>

- *Type:* string

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Namespaces.Initializer.parameter.expressions"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.Namespaces.Initializer.parameter.names"></a>

- *Type:* string[]

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Namespaces.Initializer.parameter.labels"></a>

- *Type:* {[ key: string ]: string}

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Namespaces.toNamespaceSelectorConfig">toNamespaceSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Namespaces.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Namespaces.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Namespaces.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `toNamespaceSelectorConfig` <a name="toNamespaceSelectorConfig" id="cdk8s-plus-28.Namespaces.toNamespaceSelectorConfig"></a>

```typescript
public toNamespaceSelectorConfig(): NamespaceSelectorConfig
```

Return the configuration of this selector.

> [INamespaceSelector.toNamespaceSelectorConfig()](INamespaceSelector.toNamespaceSelectorConfig())

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Namespaces.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Namespaces.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Namespaces.all">all</a></code> | Select all namespaces. |
| <code><a href="#cdk8s-plus-28.Namespaces.select">select</a></code> | Select specific namespaces. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Namespaces.isConstruct"></a>

```typescript
import { Namespaces } from 'cdk8s-plus-28'

Namespaces.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Namespaces.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `all` <a name="all" id="cdk8s-plus-28.Namespaces.all"></a>

```typescript
import { Namespaces } from 'cdk8s-plus-28'

Namespaces.all(scope: Construct, id: string)
```

Select all namespaces.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.all.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.all.parameter.id"></a>

- *Type:* string

---

##### `select` <a name="select" id="cdk8s-plus-28.Namespaces.select"></a>

```typescript
import { Namespaces } from 'cdk8s-plus-28'

Namespaces.select(scope: Construct, id: string, options: NamespacesSelectOptions)
```

Select specific namespaces.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Namespaces.select.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Namespaces.select.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Namespaces.select.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.NamespacesSelectOptions">NamespacesSelectOptions</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Namespaces.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Namespaces.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---


### NetworkPolicy <a name="NetworkPolicy" id="cdk8s-plus-28.NetworkPolicy"></a>

Control traffic flow at the IP address or port level (OSI layer 3 or 4), network policies are an application-centric construct which allow you to specify how a pod is allowed to communicate with various network peers.

Outgoing traffic is allowed if there are no network policies selecting
   the pod (and cluster policy otherwise allows the traffic),
   OR if the traffic matches at least one egress rule across all of the
   network policies that select the pod.

- Incoming traffic is allowed to a pod if there are no network policies
   selecting the pod (and cluster policy otherwise allows the traffic),
   OR if the traffic source is the pod's local node,
   OR if the traffic matches at least one ingress rule across all of
   the network policies that select the pod.

Network policies do not conflict; they are additive.
If any policy or policies apply to a given pod for a given
direction, the connections allowed in that direction from
that pod is the union of what the applicable policies allow.
Thus, order of evaluation does not affect the policy result.

For a connection from a source pod to a destination pod to be allowed,
both the egress policy on the source pod and the ingress policy on the
destination pod need to allow the connection.
If either side does not allow the connection, it will not happen.

> [https://kubernetes.io/docs/concepts/services-networking/network-policies/#networkpolicy-resource](https://kubernetes.io/docs/concepts/services-networking/network-policies/#networkpolicy-resource)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.NetworkPolicy.Initializer"></a>

```typescript
import { NetworkPolicy } from 'cdk8s-plus-28'

new NetworkPolicy(scope: Construct, id: string, props?: NetworkPolicyProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyProps">NetworkPolicyProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.NetworkPolicy.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyProps">NetworkPolicyProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.addEgressRule">addEgressRule</a></code> | Allow outgoing traffic to the peer. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.addIngressRule">addIngressRule</a></code> | Allow incoming traffic from the peer. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.NetworkPolicy.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.NetworkPolicy.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.NetworkPolicy.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addEgressRule` <a name="addEgressRule" id="cdk8s-plus-28.NetworkPolicy.addEgressRule"></a>

```typescript
public addEgressRule(peer: INetworkPolicyPeer, ports?: NetworkPolicyPort[]): void
```

Allow outgoing traffic to the peer.

If ports are not passed, traffic will be allowed on all ports.

###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicy.addEgressRule.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicy.addEgressRule.parameter.ports"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]

---

##### `addIngressRule` <a name="addIngressRule" id="cdk8s-plus-28.NetworkPolicy.addIngressRule"></a>

```typescript
public addIngressRule(peer: INetworkPolicyPeer, ports?: NetworkPolicyPort[]): void
```

Allow incoming traffic from the peer.

If ports are not passed, traffic will be allowed on all ports.

###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicy.addIngressRule.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicy.addIngressRule.parameter.ports"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.NetworkPolicy.isConstruct"></a>

```typescript
import { NetworkPolicy } from 'cdk8s-plus-28'

NetworkPolicy.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.NetworkPolicy.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.NetworkPolicy.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.NetworkPolicy.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.NetworkPolicy.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.NetworkPolicy.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.NetworkPolicy.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.NetworkPolicy.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NetworkPolicy.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.NetworkPolicy.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.NetworkPolicy.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.NetworkPolicy.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### NetworkPolicyIpBlock <a name="NetworkPolicyIpBlock" id="cdk8s-plus-28.NetworkPolicyIpBlock"></a>

- *Implements:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Describes a particular CIDR (Ex.

"192.168.1.1/24","2001:db9::/64") that is
allowed to the pods matched by a network policy selector.
The except entry describes CIDRs that should not be included within this rule.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.NetworkPolicyIpBlock.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.NetworkPolicyIpBlock.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.NetworkPolicyIpBlock.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4">anyIpv4</a></code> | Any IPv4 address. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6">anyIpv6</a></code> | Any IPv6 address. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.ipv4">ipv4</a></code> | Create an IPv4 peer from a CIDR. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.ipv6">ipv6</a></code> | Create an IPv6 peer from a CIDR. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct"></a>

```typescript
import { NetworkPolicyIpBlock } from 'cdk8s-plus-28'

NetworkPolicyIpBlock.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.NetworkPolicyIpBlock.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `anyIpv4` <a name="anyIpv4" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4"></a>

```typescript
import { NetworkPolicyIpBlock } from 'cdk8s-plus-28'

NetworkPolicyIpBlock.anyIpv4(scope: Construct, id: string)
```

Any IPv4 address.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv4.parameter.id"></a>

- *Type:* string

---

##### `anyIpv6` <a name="anyIpv6" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6"></a>

```typescript
import { NetworkPolicyIpBlock } from 'cdk8s-plus-28'

NetworkPolicyIpBlock.anyIpv6(scope: Construct, id: string)
```

Any IPv6 address.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.anyIpv6.parameter.id"></a>

- *Type:* string

---

##### `ipv4` <a name="ipv4" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4"></a>

```typescript
import { NetworkPolicyIpBlock } from 'cdk8s-plus-28'

NetworkPolicyIpBlock.ipv4(scope: Construct, id: string, cidrIp: string, except?: string[])
```

Create an IPv4 peer from a CIDR.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.id"></a>

- *Type:* string

---

###### `cidrIp`<sup>Required</sup> <a name="cidrIp" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.cidrIp"></a>

- *Type:* string

---

###### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv4.parameter.except"></a>

- *Type:* string[]

---

##### `ipv6` <a name="ipv6" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6"></a>

```typescript
import { NetworkPolicyIpBlock } from 'cdk8s-plus-28'

NetworkPolicyIpBlock.ipv6(scope: Construct, id: string, cidrIp: string, except?: string[])
```

Create an IPv6 peer from a CIDR.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.id"></a>

- *Type:* string

---

###### `cidrIp`<sup>Required</sup> <a name="cidrIp" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.cidrIp"></a>

- *Type:* string

---

###### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.ipv6.parameter.except"></a>

- *Type:* string[]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.cidr">cidr</a></code> | <code>string</code> | A string representing the IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". |
| <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock.property.except">except</a></code> | <code>string[]</code> | A slice of CIDRs that should not be included within an IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". Except values will be rejected if they are outside the CIDR range. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

A string representing the IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64".

---

##### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.NetworkPolicyIpBlock.property.except"></a>

```typescript
public readonly except: string[];
```

- *Type:* string[]

A slice of CIDRs that should not be included within an IP Block Valid examples are "192.168.1.1/24" or "2001:db9::/64". Except values will be rejected if they are outside the CIDR range.

---


### PersistentVolume <a name="PersistentVolume" id="cdk8s-plus-28.PersistentVolume"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IStorage">IStorage</a>

A PersistentVolume (PV) is a piece of storage in the cluster that has been provisioned by an administrator or dynamically provisioned using Storage Classes.

It is a resource in the cluster just like a node is a cluster resource.
PVs are volume plugins like Volumes, but have a lifecycle independent of any
individual Pod that uses the PV. This API object captures the details of the
implementation of the storage, be that NFS, iSCSI, or a
cloud-provider-specific storage system.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PersistentVolume.Initializer"></a>

```typescript
import { PersistentVolume } from 'cdk8s-plus-28'

new PersistentVolume(scope: Construct, id: string, props?: PersistentVolumeProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeProps">PersistentVolumeProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.PersistentVolume.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeProps">PersistentVolumeProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.bind">bind</a></code> | Bind a volume to a specific claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.reserve">reserve</a></code> | Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.PersistentVolume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.PersistentVolume.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.PersistentVolume.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.PersistentVolume.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

##### `bind` <a name="bind" id="cdk8s-plus-28.PersistentVolume.bind"></a>

```typescript
public bind(claim: IPersistentVolumeClaim): void
```

Bind a volume to a specific claim.

Note that you must also bind the claim to the volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolume.bind.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

The PVC to bind to.

---

##### `reserve` <a name="reserve" id="cdk8s-plus-28.PersistentVolume.reserve"></a>

```typescript
public reserve(): PersistentVolumeClaim
```

Reserve a `PersistentVolume` by creating a `PersistentVolumeClaim` that is wired to claim this volume.

Note that this method will throw in case the volume is already claimed.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#reserving-a-persistentvolume)

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName">fromPersistentVolumeName</a></code> | Imports a pv from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.PersistentVolume.isConstruct"></a>

```typescript
import { PersistentVolume } from 'cdk8s-plus-28'

PersistentVolume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.PersistentVolume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromPersistentVolumeName` <a name="fromPersistentVolumeName" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName"></a>

```typescript
import { PersistentVolume } from 'cdk8s-plus-28'

PersistentVolume.fromPersistentVolumeName(scope: Construct, id: string, volumeName: string)
```

Imports a pv from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.id"></a>

- *Type:* string

---

###### `volumeName`<sup>Required</sup> <a name="volumeName" id="cdk8s-plus-28.PersistentVolume.fromPersistentVolumeName.parameter.volumeName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.mode">mode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | Reclaim policy of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | PVC this volume is bound to. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | Mount options of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage size of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolume.property.storageClassName">storageClassName</a></code> | <code>string</code> | Storage class this volume belongs to. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.PersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.PersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.PersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolume.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.PersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.PersistentVolume.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.PersistentVolume.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.PersistentVolume.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `mode`<sup>Required</sup> <a name="mode" id="cdk8s-plus-28.PersistentVolume.property.mode"></a>

```typescript
public readonly mode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode of this volume.

---

##### `reclaimPolicy`<sup>Required</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.PersistentVolume.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>

Reclaim policy of this volume.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.PersistentVolume.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]

Access modes requirement of this claim.

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolume.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

PVC this volume is bound to.

Undefined means this volume is not yet
claimed by any PVC.

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.PersistentVolume.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

Mount options of this volume.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolume.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size

Storage size of this volume.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.PersistentVolume.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

Storage class this volume belongs to.

---


### PersistentVolumeClaim <a name="PersistentVolumeClaim" id="cdk8s-plus-28.PersistentVolumeClaim"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

A PersistentVolumeClaim (PVC) is a request for storage by a user.

It is similar to a Pod. Pods consume node resources and PVCs consume PV resources.
Pods can request specific levels of resources (CPU and Memory).
Claims can request specific size and access modes

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer"></a>

```typescript
import { PersistentVolumeClaim } from 'cdk8s-plus-28'

new PersistentVolumeClaim(scope: Construct, id: string, props?: PersistentVolumeClaimProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps">PersistentVolumeClaimProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.PersistentVolumeClaim.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeClaimProps">PersistentVolumeClaimProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.bind">bind</a></code> | Bind a claim to a specific volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.PersistentVolumeClaim.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.PersistentVolumeClaim.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.PersistentVolumeClaim.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `bind` <a name="bind" id="cdk8s-plus-28.PersistentVolumeClaim.bind"></a>

```typescript
public bind(vol: IPersistentVolume): void
```

Bind a claim to a specific volume.

Note that you must also bind the volume to the claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding)

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.PersistentVolumeClaim.bind.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

The PV to bind to.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.fromClaimName">fromClaimName</a></code> | Imports a pvc from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.PersistentVolumeClaim.isConstruct"></a>

```typescript
import { PersistentVolumeClaim } from 'cdk8s-plus-28'

PersistentVolumeClaim.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.PersistentVolumeClaim.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromClaimName` <a name="fromClaimName" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName"></a>

```typescript
import { PersistentVolumeClaim } from 'cdk8s-plus-28'

PersistentVolumeClaim.fromClaimName(scope: Construct, id: string, claimName: string)
```

Imports a pvc from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.id"></a>

- *Type:* string

---

###### `claimName`<sup>Required</sup> <a name="claimName" id="cdk8s-plus-28.PersistentVolumeClaim.fromClaimName.parameter.claimName"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Volume mode requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Access modes requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Storage requirement of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.storageClassName">storageClassName</a></code> | <code>string</code> | Storage class requirment of this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaim.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a></code> | PV this claim is bound to. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PersistentVolumeClaim.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.PersistentVolumeClaim.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.PersistentVolumeClaim.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.PersistentVolumeClaim.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeClaim.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.PersistentVolumeClaim.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.PersistentVolumeClaim.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.PersistentVolumeClaim.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.PersistentVolumeClaim.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `volumeMode`<sup>Required</sup> <a name="volumeMode" id="cdk8s-plus-28.PersistentVolumeClaim.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>

Volume mode requirement of this claim.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.PersistentVolumeClaim.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]

Access modes requirement of this claim.

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeClaim.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size

Storage requirement of this claim.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.PersistentVolumeClaim.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

Storage class requirment of this claim.

---

##### `volume`<sup>Optional</sup> <a name="volume" id="cdk8s-plus-28.PersistentVolumeClaim.property.volume"></a>

```typescript
public readonly volume: IPersistentVolume;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

PV this claim is bound to.

Undefined means the claim is not bound
to any specific volume.

---


### Pod <a name="Pod" id="cdk8s-plus-28.Pod"></a>

Pod is a collection of containers that can run on a host.

This resource is
created by clients and scheduled onto hosts.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Pod.Initializer"></a>

```typescript
import { Pod } from 'cdk8s-plus-28'

new Pod(scope: Construct, id: string, props?: PodProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.PodProps">PodProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pod.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pod.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Pod.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.PodProps">PodProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Pod.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Pod.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Pod.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Pod.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Pod.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Pod.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Pod.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Pod.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Pod.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.Pod.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Pod.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.Pod.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.Pod.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.Pod.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Pod.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.Pod.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Pod.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.Pod.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Pod.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Pod.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Pod.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.Pod.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.Pod.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Pod.isConstruct"></a>

```typescript
import { Pod } from 'cdk8s-plus-28'

Pod.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Pod.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Pod.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Pod.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Pod.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Pod.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Pod.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Pod.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Pod.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pod.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.PodScheduling">PodScheduling</a></code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Pod.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Pod.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Pod.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Pod.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Pod.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Pod.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Pod.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Pod.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Pod.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.Pod.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Pod.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Pod.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.Pod.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.Pod.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.Pod.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.Pod.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Pod.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.Pod.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.Pod.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.Pod.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.Pod.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.Pod.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Pod.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Pod.property.scheduling"></a>

```typescript
public readonly scheduling: PodScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.PodScheduling">PodScheduling</a>

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pod.property.ADDRESS_LABEL">ADDRESS_LABEL</a></code> | <code>string</code> | This label is autoamtically added by cdk8s to any pod. |

---

##### `ADDRESS_LABEL`<sup>Required</sup> <a name="ADDRESS_LABEL" id="cdk8s-plus-28.Pod.property.ADDRESS_LABEL"></a>

```typescript
public readonly ADDRESS_LABEL: string;
```

- *Type:* string

This label is autoamtically added by cdk8s to any pod.

It provides
a unique and stable identifier for the pod.

---

### Pods <a name="Pods" id="cdk8s-plus-28.Pods"></a>

- *Implements:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

Represents a group of pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Pods.Initializer"></a>

```typescript
import { Pods } from 'cdk8s-plus-28'

new Pods(scope: Construct, id: string, expressions?: LabelExpression[], labels?: {[ key: string ]: string}, namespaces?: INamespaceSelector)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.expressions">expressions</a></code> | <code><a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.Initializer.parameter.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.Initializer.parameter.id"></a>

- *Type:* string

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.Pods.Initializer.parameter.expressions"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.Pods.Initializer.parameter.labels"></a>

- *Type:* {[ key: string ]: string}

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.Pods.Initializer.parameter.namespaces"></a>

- *Type:* <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Pods.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.toPodSelector">toPodSelector</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Pods.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Pods.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Pods.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Pods.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.Pods.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Pods.all">all</a></code> | Select all pods. |
| <code><a href="#cdk8s-plus-28.Pods.select">select</a></code> | Select pods in the cluster with various selectors. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Pods.isConstruct"></a>

```typescript
import { Pods } from 'cdk8s-plus-28'

Pods.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Pods.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `all` <a name="all" id="cdk8s-plus-28.Pods.all"></a>

```typescript
import { Pods } from 'cdk8s-plus-28'

Pods.all(scope: Construct, id: string, options?: PodsAllOptions)
```

Select all pods.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.all.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.all.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Pods.all.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodsAllOptions">PodsAllOptions</a>

---

##### `select` <a name="select" id="cdk8s-plus-28.Pods.select"></a>

```typescript
import { Pods } from 'cdk8s-plus-28'

Pods.select(scope: Construct, id: string, options: PodsSelectOptions)
```

Select pods in the cluster with various selectors.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Pods.select.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Pods.select.parameter.id"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Pods.select.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodsSelectOptions">PodsSelectOptions</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Pods.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Pods.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---


### Resource <a name="Resource" id="cdk8s-plus-28.Resource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Base class for all Kubernetes objects in stdk8s.

Represents a single
resource.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Resource.Initializer"></a>

```typescript
import { Resource } from 'cdk8s-plus-28'

new Resource(scope: Construct, id: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Resource.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Resource.Initializer.parameter.id"></a>

- *Type:* string

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Resource.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Resource.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Resource.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Resource.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Resource.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Resource.isConstruct"></a>

```typescript
import { Resource } from 'cdk8s-plus-28'

Resource.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Resource.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Resource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Resource.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Resource.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Resource.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Resource.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Resource.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Resource.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Resource.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Resource.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Resource.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Resource.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Resource.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Resource.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Resource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Resource.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Resource.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Resource.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---


### Role <a name="Role" id="cdk8s-plus-28.Role"></a>

- *Implements:* <a href="#cdk8s-plus-28.IRole">IRole</a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Role.Initializer"></a>

```typescript
import { Role } from 'cdk8s-plus-28'

new Role(scope: Construct, id: string, props?: RoleProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.RoleProps">RoleProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Role.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Role.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Role.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.RoleProps">RoleProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Role.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Role.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Role.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Role.allow">allow</a></code> | Add permission to perform a list of HTTP verbs on a collection of resources. |
| <code><a href="#cdk8s-plus-28.Role.allowCreate">allowCreate</a></code> | Add "create" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowDelete">allowDelete</a></code> | Add "delete" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowDeleteCollection">allowDeleteCollection</a></code> | Add "deletecollection" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowGet">allowGet</a></code> | Add "get" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowList">allowList</a></code> | Add "list" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowPatch">allowPatch</a></code> | Add "patch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowRead">allowRead</a></code> | Add "get", "list", and "watch" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowReadWrite">allowReadWrite</a></code> | Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowUpdate">allowUpdate</a></code> | Add "update" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.allowWatch">allowWatch</a></code> | Add "watch" permission for the resources. |
| <code><a href="#cdk8s-plus-28.Role.bind">bind</a></code> | Create a RoleBinding that binds the permissions in this Role to a list of subjects, that will only apply this role's namespace. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Role.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Role.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Role.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `allow` <a name="allow" id="cdk8s-plus-28.Role.allow"></a>

```typescript
public allow(verbs: string[], resources: IApiResource): void
```

Add permission to perform a list of HTTP verbs on a collection of resources.

> [https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb](https://kubernetes.io/docs/reference/access-authn-authz/authorization/#determine-the-request-verb)

###### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.Role.allow.parameter.verbs"></a>

- *Type:* string[]

---

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allow.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowCreate` <a name="allowCreate" id="cdk8s-plus-28.Role.allowCreate"></a>

```typescript
public allowCreate(resources: IApiResource): void
```

Add "create" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowCreate.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowDelete` <a name="allowDelete" id="cdk8s-plus-28.Role.allowDelete"></a>

```typescript
public allowDelete(resources: IApiResource): void
```

Add "delete" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowDelete.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowDeleteCollection` <a name="allowDeleteCollection" id="cdk8s-plus-28.Role.allowDeleteCollection"></a>

```typescript
public allowDeleteCollection(resources: IApiResource): void
```

Add "deletecollection" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowDeleteCollection.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowGet` <a name="allowGet" id="cdk8s-plus-28.Role.allowGet"></a>

```typescript
public allowGet(resources: IApiResource): void
```

Add "get" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowGet.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowList` <a name="allowList" id="cdk8s-plus-28.Role.allowList"></a>

```typescript
public allowList(resources: IApiResource): void
```

Add "list" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowList.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowPatch` <a name="allowPatch" id="cdk8s-plus-28.Role.allowPatch"></a>

```typescript
public allowPatch(resources: IApiResource): void
```

Add "patch" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowPatch.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowRead` <a name="allowRead" id="cdk8s-plus-28.Role.allowRead"></a>

```typescript
public allowRead(resources: IApiResource): void
```

Add "get", "list", and "watch" permissions for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowRead.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowReadWrite` <a name="allowReadWrite" id="cdk8s-plus-28.Role.allowReadWrite"></a>

```typescript
public allowReadWrite(resources: IApiResource): void
```

Add "get", "list", "watch", "create", "update", "patch", "delete", and "deletecollection" permissions for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowReadWrite.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowUpdate` <a name="allowUpdate" id="cdk8s-plus-28.Role.allowUpdate"></a>

```typescript
public allowUpdate(resources: IApiResource): void
```

Add "update" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowUpdate.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `allowWatch` <a name="allowWatch" id="cdk8s-plus-28.Role.allowWatch"></a>

```typescript
public allowWatch(resources: IApiResource): void
```

Add "watch" permission for the resources.

###### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.Role.allowWatch.parameter.resources"></a>

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

The resource(s) to apply to.

---

##### `bind` <a name="bind" id="cdk8s-plus-28.Role.bind"></a>

```typescript
public bind(subjects: ISubject): RoleBinding
```

Create a RoleBinding that binds the permissions in this Role to a list of subjects, that will only apply this role's namespace.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.Role.bind.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

a list of subjects to bind to.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Role.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Role.fromRoleName">fromRoleName</a></code> | Imports a role from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Role.isConstruct"></a>

```typescript
import { Role } from 'cdk8s-plus-28'

Role.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Role.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromRoleName` <a name="fromRoleName" id="cdk8s-plus-28.Role.fromRoleName"></a>

```typescript
import { Role } from 'cdk8s-plus-28'

Role.fromRoleName(scope: Construct, id: string, name: string)
```

Imports a role from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Role.fromRoleName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Role.fromRoleName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Role.fromRoleName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Role.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Role.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Role.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Role.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Role.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Role.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Role.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Role.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Role.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>[]</code> | Rules associaated with this Role. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Role.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Role.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Role.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Role.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Role.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Role.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Role.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Role.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Role.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.Role.property.rules"></a>

```typescript
public readonly rules: RolePolicyRule[];
```

- *Type:* <a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>[]

Rules associaated with this Role.

Returns a copy, use `allow` to add rules.

---


### RoleBinding <a name="RoleBinding" id="cdk8s-plus-28.RoleBinding"></a>

A RoleBinding grants permissions within a specific namespace to a user or set of users.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.RoleBinding.Initializer"></a>

```typescript
import { RoleBinding } from 'cdk8s-plus-28'

new RoleBinding(scope: Construct, id: string, props: RoleBindingProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.RoleBindingProps">RoleBindingProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.RoleBinding.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.RoleBindingProps">RoleBindingProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.RoleBinding.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.RoleBinding.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.RoleBinding.addSubjects">addSubjects</a></code> | Adds a subject to the role. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.RoleBinding.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.RoleBinding.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.RoleBinding.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addSubjects` <a name="addSubjects" id="cdk8s-plus-28.RoleBinding.addSubjects"></a>

```typescript
public addSubjects(subjects: ISubject): void
```

Adds a subject to the role.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.RoleBinding.addSubjects.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

The subjects to add.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.RoleBinding.isConstruct"></a>

```typescript
import { RoleBinding } from 'cdk8s-plus-28'

RoleBinding.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.RoleBinding.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IRole">IRole</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.RoleBinding.property.subjects">subjects</a></code> | <code><a href="#cdk8s-plus-28.ISubject">ISubject</a>[]</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.RoleBinding.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.RoleBinding.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.RoleBinding.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.RoleBinding.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.RoleBinding.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.RoleBinding.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.RoleBinding.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.RoleBinding.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.RoleBinding.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.RoleBinding.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* <a href="#cdk8s-plus-28.IRole">IRole</a>

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.RoleBinding.property.subjects"></a>

```typescript
public readonly subjects: ISubject[];
```

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>[]

---


### Secret <a name="Secret" id="cdk8s-plus-28.Secret"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

Kubernetes Secrets let you store and manage sensitive information, such as passwords, OAuth tokens, and ssh keys.

Storing confidential information in a
Secret is safer and more flexible than putting it verbatim in a Pod
definition or in a container image.

> [https://kubernetes.io/docs/concepts/configuration/secret](https://kubernetes.io/docs/concepts/configuration/secret)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Secret.Initializer"></a>

```typescript
import { Secret } from 'cdk8s-plus-28'

new Secret(scope: Construct, id: string, props?: SecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.SecretProps">SecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Secret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Secret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Secret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.SecretProps">SecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Secret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Secret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Secret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.Secret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.Secret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Secret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Secret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Secret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.Secret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Secret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.Secret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Secret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.Secret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Secret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Secret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Secret.isConstruct"></a>

```typescript
import { Secret } from 'cdk8s-plus-28'

Secret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Secret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.Secret.fromSecretName"></a>

```typescript
import { Secret } from 'cdk8s-plus-28'

Secret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Secret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Secret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Secret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Secret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Secret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Secret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Secret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Secret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Secret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Secret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Secret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Secret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Secret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Secret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Secret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Secret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Secret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Secret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Secret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Secret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Secret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.Secret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### Service <a name="Service" id="cdk8s-plus-28.Service"></a>

An abstract way to expose an application running on a set of Pods as a network service.

With Kubernetes you don't need to modify your application to use an unfamiliar service discovery mechanism.
Kubernetes gives Pods their own IP addresses and a single DNS name for a set of Pods, and can load-balance across them.

For example, consider a stateless image-processing backend which is running with 3 replicas. Those replicas are fungible—frontends do not care which backend they use.
While the actual Pods that compose the backend set may change, the frontend clients should not need to be aware of that,
nor should they need to keep track of the set of backends themselves.
The Service abstraction enables this decoupling.

If you're able to use Kubernetes APIs for service discovery in your application, you can query the API server for Endpoints,
that get updated whenever the set of Pods in a Service changes. For non-native applications, Kubernetes offers ways to place a network port
or load balancer in between your application and the backend Pods.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Service.Initializer"></a>

```typescript
import { Service } from 'cdk8s-plus-28'

new Service(scope: Construct, id: string, props?: ServiceProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ServiceProps">ServiceProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Service.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Service.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.Service.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceProps">ServiceProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Service.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Service.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Service.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Service.bind">bind</a></code> | Configure a port the service will bind to. |
| <code><a href="#cdk8s-plus-28.Service.exposeViaIngress">exposeViaIngress</a></code> | Expose a service via an ingress using the specified path. |
| <code><a href="#cdk8s-plus-28.Service.select">select</a></code> | Require this service to select pods matching the selector. |
| <code><a href="#cdk8s-plus-28.Service.selectLabel">selectLabel</a></code> | Require this service to select pods with this label. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Service.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Service.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Service.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `bind` <a name="bind" id="cdk8s-plus-28.Service.bind"></a>

```typescript
public bind(port: number, options?: ServiceBindOptions): void
```

Configure a port the service will bind to.

This method can be called multiple times.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.Service.bind.parameter.port"></a>

- *Type:* number

The port definition.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Service.bind.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceBindOptions">ServiceBindOptions</a>

---

##### `exposeViaIngress` <a name="exposeViaIngress" id="cdk8s-plus-28.Service.exposeViaIngress"></a>

```typescript
public exposeViaIngress(path: string, options?: ExposeServiceViaIngressOptions): Ingress
```

Expose a service via an ingress using the specified path.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Service.exposeViaIngress.parameter.path"></a>

- *Type:* string

The path to expose the service under.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Service.exposeViaIngress.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ExposeServiceViaIngressOptions">ExposeServiceViaIngressOptions</a>

Additional options.

---

##### `select` <a name="select" id="cdk8s-plus-28.Service.select"></a>

```typescript
public select(selector: IPodSelector): void
```

Require this service to select pods matching the selector.

Note that invoking this method multiple times acts as an AND operator
on the resulting labels.

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.Service.select.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

##### `selectLabel` <a name="selectLabel" id="cdk8s-plus-28.Service.selectLabel"></a>

```typescript
public selectLabel(key: string, value: string): void
```

Require this service to select pods with this label.

Note that invoking this method multiple times acts as an AND operator
on the resulting labels.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Service.selectLabel.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Service.selectLabel.parameter.value"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Service.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Service.isConstruct"></a>

```typescript
import { Service } from 'cdk8s-plus-28'

Service.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Service.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Service.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Service.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Service.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Service.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Service.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Service.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Service.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Service.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Service.property.port">port</a></code> | <code>number</code> | Return the first port of the service. |
| <code><a href="#cdk8s-plus-28.Service.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]</code> | Ports for this service. |
| <code><a href="#cdk8s-plus-28.Service.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | Determines how the Service is exposed. |
| <code><a href="#cdk8s-plus-28.Service.property.clusterIP">clusterIP</a></code> | <code>string</code> | The IP address of the service and is usually assigned randomly by the master. |
| <code><a href="#cdk8s-plus-28.Service.property.externalName">externalName</a></code> | <code>string</code> | The externalName to be used for EXTERNAL_NAME types. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Service.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Service.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Service.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Service.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Service.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Service.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Service.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Service.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Service.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.Service.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Return the first port of the service.

---

##### `ports`<sup>Required</sup> <a name="ports" id="cdk8s-plus-28.Service.property.ports"></a>

```typescript
public readonly ports: ServicePort[];
```

- *Type:* <a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]

Ports for this service.

Use `bind()` to bind additional service ports.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.Service.property.type"></a>

```typescript
public readonly type: ServiceType;
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>

Determines how the Service is exposed.

---

##### `clusterIP`<sup>Optional</sup> <a name="clusterIP" id="cdk8s-plus-28.Service.property.clusterIP"></a>

```typescript
public readonly clusterIP: string;
```

- *Type:* string

The IP address of the service and is usually assigned randomly by the master.

---

##### `externalName`<sup>Optional</sup> <a name="externalName" id="cdk8s-plus-28.Service.property.externalName"></a>

```typescript
public readonly externalName: string;
```

- *Type:* string

The externalName to be used for EXTERNAL_NAME types.

---


### ServiceAccount <a name="ServiceAccount" id="cdk8s-plus-28.ServiceAccount"></a>

- *Implements:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the apiserver.
When they do, they are authenticated as a particular Service Account (for
example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ServiceAccount.Initializer"></a>

```typescript
import { ServiceAccount } from 'cdk8s-plus-28'

new ServiceAccount(scope: Construct, id: string, props?: ServiceAccountProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ServiceAccountProps">ServiceAccountProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.ServiceAccount.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceAccountProps">ServiceAccountProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.addSecret">addSecret</a></code> | Allow a secret to be accessed by pods using this service account. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.ServiceAccount.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ServiceAccount.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ServiceAccount.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addSecret` <a name="addSecret" id="cdk8s-plus-28.ServiceAccount.addSecret"></a>

```typescript
public addSecret(secr: ISecret): void
```

Allow a secret to be accessed by pods using this service account.

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.ServiceAccount.addSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret.

---

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.ServiceAccount.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.fromServiceAccountName">fromServiceAccountName</a></code> | Imports a service account from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.ServiceAccount.isConstruct"></a>

```typescript
import { ServiceAccount } from 'cdk8s-plus-28'

ServiceAccount.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ServiceAccount.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromServiceAccountName` <a name="fromServiceAccountName" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName"></a>

```typescript
import { ServiceAccount } from 'cdk8s-plus-28'

ServiceAccount.fromServiceAccountName(scope: Construct, id: string, name: string, options?: FromServiceAccountNameOptions)
```

Imports a service account from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.name"></a>

- *Type:* string

The name of the service account resource.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.ServiceAccount.fromServiceAccountName.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.FromServiceAccountNameOptions">FromServiceAccountNameOptions</a>

additional options.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.automountToken">automountToken</a></code> | <code>boolean</code> | Whether or not a token is automatically mounted for this service account. |
| <code><a href="#cdk8s-plus-28.ServiceAccount.property.secrets">secrets</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a>[]</code> | List of secrets allowed to be used by pods running using this service account. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ServiceAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ServiceAccount.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ServiceAccount.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ServiceAccount.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccount.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ServiceAccount.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ServiceAccount.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ServiceAccount.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountToken`<sup>Required</sup> <a name="automountToken" id="cdk8s-plus-28.ServiceAccount.property.automountToken"></a>

```typescript
public readonly automountToken: boolean;
```

- *Type:* boolean

Whether or not a token is automatically mounted for this service account.

---

##### `secrets`<sup>Required</sup> <a name="secrets" id="cdk8s-plus-28.ServiceAccount.property.secrets"></a>

```typescript
public readonly secrets: ISecret[];
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>[]

List of secrets allowed to be used by pods running using this service account.

Returns a copy. To add a secret, use `addSecret()`.

---


### ServiceAccountTokenSecret <a name="ServiceAccountTokenSecret" id="cdk8s-plus-28.ServiceAccountTokenSecret"></a>

Create a secret for a service account token.

> [https://kubernetes.io/docs/concepts/configuration/secret/#service-account-token-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#service-account-token-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer"></a>

```typescript
import { ServiceAccountTokenSecret } from 'cdk8s-plus-28'

new ServiceAccountTokenSecret(scope: Construct, id: string, props: ServiceAccountTokenSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps">ServiceAccountTokenSecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.ServiceAccountTokenSecret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps">ServiceAccountTokenSecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.ServiceAccountTokenSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ServiceAccountTokenSecret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ServiceAccountTokenSecret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.ServiceAccountTokenSecret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.ServiceAccountTokenSecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.ServiceAccountTokenSecret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ServiceAccountTokenSecret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct"></a>

```typescript
import { ServiceAccountTokenSecret } from 'cdk8s-plus-28'

ServiceAccountTokenSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.ServiceAccountTokenSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName"></a>

```typescript
import { ServiceAccountTokenSecret } from 'cdk8s-plus-28'

ServiceAccountTokenSecret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccountTokenSecret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.ServiceAccountTokenSecret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### SshAuthSecret <a name="SshAuthSecret" id="cdk8s-plus-28.SshAuthSecret"></a>

Create a secret for ssh authentication.

> [https://kubernetes.io/docs/concepts/configuration/secret/#ssh-authentication-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#ssh-authentication-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.SshAuthSecret.Initializer"></a>

```typescript
import { SshAuthSecret } from 'cdk8s-plus-28'

new SshAuthSecret(scope: Construct, id: string, props: SshAuthSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.SshAuthSecretProps">SshAuthSecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.SshAuthSecret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.SshAuthSecretProps">SshAuthSecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.SshAuthSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.SshAuthSecret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.SshAuthSecret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.SshAuthSecret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.SshAuthSecret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.SshAuthSecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.SshAuthSecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.SshAuthSecret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SshAuthSecret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.SshAuthSecret.isConstruct"></a>

```typescript
import { SshAuthSecret } from 'cdk8s-plus-28'

SshAuthSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.SshAuthSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.SshAuthSecret.fromSecretName"></a>

```typescript
import { SshAuthSecret } from 'cdk8s-plus-28'

SshAuthSecret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SshAuthSecret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.SshAuthSecret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.SshAuthSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.SshAuthSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.SshAuthSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.SshAuthSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.SshAuthSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SshAuthSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.SshAuthSecret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.SshAuthSecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.SshAuthSecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.SshAuthSecret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### StatefulSet <a name="StatefulSet" id="cdk8s-plus-28.StatefulSet"></a>

- *Implements:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

StatefulSet is the workload API object used to manage stateful applications.

Manages the deployment and scaling of a set of Pods, and provides guarantees
about the ordering and uniqueness of these Pods.

Like a Deployment, a StatefulSet manages Pods that are based on an identical
container spec. Unlike a Deployment, a StatefulSet maintains a sticky identity
for each of their Pods. These pods are created from the same spec, but are not
interchangeable: each has a persistent identifier that it maintains across any
rescheduling.

If you want to use storage volumes to provide persistence for your workload, you
can use a StatefulSet as part of the solution. Although individual Pods in a StatefulSet
are susceptible to failure, the persistent Pod identifiers make it easier to match existing
volumes to the new Pods that replace any that have failed.

Using StatefulSets
------------------
StatefulSets are valuable for applications that require one or more of the following.

- Stable, unique network identifiers.
- Stable, persistent storage.
- Ordered, graceful deployment and scaling.
- Ordered, automated rolling updates.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.StatefulSet.Initializer"></a>

```typescript
import { StatefulSet } from 'cdk8s-plus-28'

new StatefulSet(scope: Construct, id: string, props: StatefulSetProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetProps">StatefulSetProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.StatefulSet.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.StatefulSetProps">StatefulSetProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.StatefulSet.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.StatefulSet.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.StatefulSet.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.StatefulSet.select">select</a></code> | Configure selectors for this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSet.markHasAutoscaler">markHasAutoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.StatefulSet.toScalingTarget">toScalingTarget</a></code> | Return the target spec properties of this Scalable. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.StatefulSet.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.StatefulSet.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.StatefulSet.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.StatefulSet.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.StatefulSet.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.StatefulSet.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.StatefulSet.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.StatefulSet.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.StatefulSet.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.StatefulSet.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.StatefulSet.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.StatefulSet.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.StatefulSet.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.StatefulSet.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.StatefulSet.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.StatefulSet.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.StatefulSet.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.StatefulSet.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.StatefulSet.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

##### `markHasAutoscaler` <a name="markHasAutoscaler" id="cdk8s-plus-28.StatefulSet.markHasAutoscaler"></a>

```typescript
public markHasAutoscaler(): void
```

Called on all IScalable targets when they are associated with an autoscaler.

> [IScalable.markHasAutoscaler()](IScalable.markHasAutoscaler())

##### `toScalingTarget` <a name="toScalingTarget" id="cdk8s-plus-28.StatefulSet.toScalingTarget"></a>

```typescript
public toScalingTarget(): ScalingTarget
```

Return the target spec properties of this Scalable.

> [IScalable.toScalingTarget()](IScalable.toScalingTarget())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.StatefulSet.isConstruct"></a>

```typescript
import { StatefulSet } from 'cdk8s-plus-28'

StatefulSet.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.StatefulSet.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.minReady">minReady</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.podManagementPolicy">podManagementPolicy</a></code> | <code><a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a></code> | Management policy to use for the set. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.service">service</a></code> | <code><a href="#cdk8s-plus-28.Service">Service</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a></code> | The update startegy of this stateful set. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.replicas">replicas</a></code> | <code>number</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.StatefulSet.property.hasAutoscaler">hasAutoscaler</a></code> | <code>boolean</code> | If this is a target of an autoscaler. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.StatefulSet.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.StatefulSet.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.StatefulSet.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.StatefulSet.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.StatefulSet.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.StatefulSet.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.StatefulSet.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.StatefulSet.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.StatefulSet.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.StatefulSet.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.StatefulSet.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.StatefulSet.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.StatefulSet.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.StatefulSet.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.StatefulSet.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.StatefulSet.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.StatefulSet.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.StatefulSet.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.StatefulSet.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.StatefulSet.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.StatefulSet.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.StatefulSet.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.StatefulSet.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.StatefulSet.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.StatefulSet.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.StatefulSet.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---

##### `minReady`<sup>Required</sup> <a name="minReady" id="cdk8s-plus-28.StatefulSet.property.minReady"></a>

```typescript
public readonly minReady: Duration;
```

- *Type:* cdk8s.Duration

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

##### `podManagementPolicy`<sup>Required</sup> <a name="podManagementPolicy" id="cdk8s-plus-28.StatefulSet.property.podManagementPolicy"></a>

```typescript
public readonly podManagementPolicy: PodManagementPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a>

Management policy to use for the set.

---

##### `service`<sup>Required</sup> <a name="service" id="cdk8s-plus-28.StatefulSet.property.service"></a>

```typescript
public readonly service: Service;
```

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.StatefulSet.property.strategy"></a>

```typescript
public readonly strategy: StatefulSetUpdateStrategy;
```

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a>

The update startegy of this stateful set.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.StatefulSet.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

Number of desired pods.

---

##### `hasAutoscaler`<sup>Required</sup> <a name="hasAutoscaler" id="cdk8s-plus-28.StatefulSet.property.hasAutoscaler"></a>

```typescript
public readonly hasAutoscaler: boolean;
```

- *Type:* boolean

If this is a target of an autoscaler.

---


### TlsSecret <a name="TlsSecret" id="cdk8s-plus-28.TlsSecret"></a>

Create a secret for storing a TLS certificate and its associated key.

> [https://kubernetes.io/docs/concepts/configuration/secret/#tls-secrets](https://kubernetes.io/docs/concepts/configuration/secret/#tls-secrets)

#### Initializers <a name="Initializers" id="cdk8s-plus-28.TlsSecret.Initializer"></a>

```typescript
import { TlsSecret } from 'cdk8s-plus-28'

new TlsSecret(scope: Construct, id: string, props: TlsSecretProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.TlsSecretProps">TlsSecretProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.TlsSecret.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.TlsSecretProps">TlsSecretProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.TlsSecret.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.TlsSecret.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.TlsSecret.addStringData">addStringData</a></code> | Adds a string data field to the secert. |
| <code><a href="#cdk8s-plus-28.TlsSecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |
| <code><a href="#cdk8s-plus-28.TlsSecret.getStringData">getStringData</a></code> | Gets a string data by key or undefined. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.TlsSecret.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.TlsSecret.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.TlsSecret.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addStringData` <a name="addStringData" id="cdk8s-plus-28.TlsSecret.addStringData"></a>

```typescript
public addStringData(key: string, value: string): void
```

Adds a string data field to the secert.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.addStringData.parameter.key"></a>

- *Type:* string

Key.

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.TlsSecret.addStringData.parameter.value"></a>

- *Type:* string

Value.

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.TlsSecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.envValue.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.TlsSecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

---

##### `getStringData` <a name="getStringData" id="cdk8s-plus-28.TlsSecret.getStringData"></a>

```typescript
public getStringData(key: string): string
```

Gets a string data by key or undefined.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.TlsSecret.getStringData.parameter.key"></a>

- *Type:* string

Key.

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.TlsSecret.fromSecretName">fromSecretName</a></code> | Imports a secret from the cluster as a reference. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.TlsSecret.isConstruct"></a>

```typescript
import { TlsSecret } from 'cdk8s-plus-28'

TlsSecret.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.TlsSecret.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromSecretName` <a name="fromSecretName" id="cdk8s-plus-28.TlsSecret.fromSecretName"></a>

```typescript
import { TlsSecret } from 'cdk8s-plus-28'

TlsSecret.fromSecretName(scope: Construct, id: string, name: string)
```

Imports a secret from the cluster as a reference.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.TlsSecret.fromSecretName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.TlsSecret.property.immutable">immutable</a></code> | <code>boolean</code> | Whether or not the secret is immutable. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.TlsSecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.TlsSecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.TlsSecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.TlsSecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.TlsSecret.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.TlsSecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.TlsSecret.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.TlsSecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.TlsSecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `immutable`<sup>Required</sup> <a name="immutable" id="cdk8s-plus-28.TlsSecret.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Whether or not the secret is immutable.

---


### User <a name="User" id="cdk8s-plus-28.User"></a>

- *Implements:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents a user.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.User.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.User.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.User.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.User.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.User.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.User.fromName">fromName</a></code> | Reference a user in the cluster by name. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.User.isConstruct"></a>

```typescript
import { User } from 'cdk8s-plus-28'

User.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.User.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromName` <a name="fromName" id="cdk8s-plus-28.User.fromName"></a>

```typescript
import { User } from 'cdk8s-plus-28'

User.fromName(scope: Construct, id: string, name: string)
```

Reference a user in the cluster by name.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.User.fromName.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.User.fromName.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.User.fromName.parameter.name"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.User.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.User.property.kind">kind</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.User.property.name">name</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.User.property.apiGroup">apiGroup</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.User.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.User.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.User.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.User.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

---


### Volume <a name="Volume" id="cdk8s-plus-28.Volume"></a>

- *Implements:* <a href="#cdk8s-plus-28.IStorage">IStorage</a>

Volume represents a named volume in a pod that may be accessed by any container in the pod.

Docker also has a concept of volumes, though it is somewhat looser and less
managed. In Docker, a volume is simply a directory on disk or in another
Container. Lifetimes are not managed and until very recently there were only
local-disk-backed volumes. Docker now provides volume drivers, but the
functionality is very limited for now (e.g. as of Docker 1.7 only one volume
driver is allowed per Container and there is no way to pass parameters to
volumes).

A Kubernetes volume, on the other hand, has an explicit lifetime - the same
as the Pod that encloses it. Consequently, a volume outlives any Containers
that run within the Pod, and data is preserved across Container restarts. Of
course, when a Pod ceases to exist, the volume will cease to exist, too.
Perhaps more importantly than this, Kubernetes supports many types of
volumes, and a Pod can use any number of them simultaneously.

At its core, a volume is just a directory, possibly with some data in it,
which is accessible to the Containers in a Pod. How that directory comes to
be, the medium that backs it, and the contents of it are determined by the
particular volume type used.

To use a volume, a Pod specifies what volumes to provide for the Pod (the
.spec.volumes field) and where to mount those into Containers (the
.spec.containers[*].volumeMounts field).

A process in a container sees a filesystem view composed from their Docker
image and volumes. The Docker image is at the root of the filesystem
hierarchy, and any volumes are mounted at the specified paths within the
image. Volumes can not mount onto other volumes

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Volume.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Volume.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.Volume.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |
| <code><a href="#cdk8s-plus-28.Volume.fromAwsElasticBlockStore">fromAwsElasticBlockStore</a></code> | Mounts an Amazon Web Services (AWS) EBS volume into your pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromAzureDisk">fromAzureDisk</a></code> | Mounts a Microsoft Azure Data Disk into a pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromConfigMap">fromConfigMap</a></code> | Populate the volume from a ConfigMap. |
| <code><a href="#cdk8s-plus-28.Volume.fromCsi">fromCsi</a></code> | Populate the volume from a CSI driver, for example the Secrets Store CSI Driver: https://secrets-store-csi-driver.sigs.k8s.io/introduction.html. Which in turn needs an associated provider to source the secrets, such as the AWS Secrets Manager and Systems Manager Parameter Store provider: https://aws.github.io/secrets-store-csi-driver-provider-aws/. |
| <code><a href="#cdk8s-plus-28.Volume.fromEmptyDir">fromEmptyDir</a></code> | An emptyDir volume is first created when a Pod is assigned to a Node, and exists as long as that Pod is running on that node. |
| <code><a href="#cdk8s-plus-28.Volume.fromGcePersistentDisk">fromGcePersistentDisk</a></code> | Mounts a Google Compute Engine (GCE) persistent disk (PD) into your Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromHostPath">fromHostPath</a></code> | Used to mount a file or directory from the host node's filesystem into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromNfs">fromNfs</a></code> | Used to mount an NFS share into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromPersistentVolumeClaim">fromPersistentVolumeClaim</a></code> | Used to mount a PersistentVolume into a Pod. |
| <code><a href="#cdk8s-plus-28.Volume.fromSecret">fromSecret</a></code> | Populate the volume from a Secret. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Volume.isConstruct"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Volume.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

##### `fromAwsElasticBlockStore` <a name="fromAwsElasticBlockStore" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromAwsElasticBlockStore(scope: Construct, id: string, volumeId: string, options?: AwsElasticBlockStoreVolumeOptions)
```

Mounts an Amazon Web Services (AWS) EBS volume into your pod.

Unlike emptyDir, which is erased when a pod is removed, the contents of an EBS volume are
persisted and the volume is unmounted. This means that an EBS volume can be pre-populated with data,
and that data can be shared between pods.

There are some restrictions when using an awsElasticBlockStore volume:

- the nodes on which pods are running must be AWS EC2 instances.
- those instances need to be in the same region and availability zone as the EBS volume.
- EBS only supports a single EC2 instance mounting a volume.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.id"></a>

- *Type:* string

---

###### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.volumeId"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromAwsElasticBlockStore.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions">AwsElasticBlockStoreVolumeOptions</a>

---

##### `fromAzureDisk` <a name="fromAzureDisk" id="cdk8s-plus-28.Volume.fromAzureDisk"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromAzureDisk(scope: Construct, id: string, diskName: string, diskUri: string, options?: AzureDiskVolumeOptions)
```

Mounts a Microsoft Azure Data Disk into a pod.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.id"></a>

- *Type:* string

---

###### `diskName`<sup>Required</sup> <a name="diskName" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.diskName"></a>

- *Type:* string

---

###### `diskUri`<sup>Required</sup> <a name="diskUri" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.diskUri"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromAzureDisk.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.AzureDiskVolumeOptions">AzureDiskVolumeOptions</a>

---

##### `fromConfigMap` <a name="fromConfigMap" id="cdk8s-plus-28.Volume.fromConfigMap"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromConfigMap(scope: Construct, id: string, configMap: IConfigMap, options?: ConfigMapVolumeOptions)
```

Populate the volume from a ConfigMap.

The configMap resource provides a way to inject configuration data into
Pods. The data stored in a ConfigMap object can be referenced in a volume
of type configMap and then consumed by containerized applications running
in a Pod.

When referencing a configMap object, you can simply provide its name in the
volume to reference it. You can also customize the path to use for a
specific entry in the ConfigMap.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.id"></a>

- *Type:* string

---

###### `configMap`<sup>Required</sup> <a name="configMap" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

The config map to use to populate the volume.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromConfigMap.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ConfigMapVolumeOptions">ConfigMapVolumeOptions</a>

Options.

---

##### `fromCsi` <a name="fromCsi" id="cdk8s-plus-28.Volume.fromCsi"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromCsi(scope: Construct, id: string, driver: string, options?: CsiVolumeOptions)
```

Populate the volume from a CSI driver, for example the Secrets Store CSI Driver: https://secrets-store-csi-driver.sigs.k8s.io/introduction.html. Which in turn needs an associated provider to source the secrets, such as the AWS Secrets Manager and Systems Manager Parameter Store provider: https://aws.github.io/secrets-store-csi-driver-provider-aws/.

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromCsi.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromCsi.parameter.id"></a>

- *Type:* string

---

###### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.Volume.fromCsi.parameter.driver"></a>

- *Type:* string

The name of the CSI driver to use to populate the volume.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromCsi.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.CsiVolumeOptions">CsiVolumeOptions</a>

Options for the CSI volume, including driver-specific ones.

---

##### `fromEmptyDir` <a name="fromEmptyDir" id="cdk8s-plus-28.Volume.fromEmptyDir"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromEmptyDir(scope: Construct, id: string, name: string, options?: EmptyDirVolumeOptions)
```

An emptyDir volume is first created when a Pod is assigned to a Node, and exists as long as that Pod is running on that node.

As the name says, it is
initially empty. Containers in the Pod can all read and write the same
files in the emptyDir volume, though that volume can be mounted at the same
or different paths in each Container. When a Pod is removed from a node for
any reason, the data in the emptyDir is deleted forever.

> [http://kubernetes.io/docs/user-guide/volumes#emptydir](http://kubernetes.io/docs/user-guide/volumes#emptydir)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromEmptyDir.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EmptyDirVolumeOptions">EmptyDirVolumeOptions</a>

Additional options.

---

##### `fromGcePersistentDisk` <a name="fromGcePersistentDisk" id="cdk8s-plus-28.Volume.fromGcePersistentDisk"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromGcePersistentDisk(scope: Construct, id: string, pdName: string, options?: GCEPersistentDiskVolumeOptions)
```

Mounts a Google Compute Engine (GCE) persistent disk (PD) into your Pod.

Unlike emptyDir, which is erased when a pod is removed, the contents of a PD are
preserved and the volume is merely unmounted. This means that a PD can be pre-populated
with data, and that data can be shared between pods.

There are some restrictions when using a gcePersistentDisk:

- the nodes on which Pods are running must be GCE VMs
- those VMs need to be in the same GCE project and zone as the persistent disk

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.id"></a>

- *Type:* string

---

###### `pdName`<sup>Required</sup> <a name="pdName" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.pdName"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromGcePersistentDisk.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions">GCEPersistentDiskVolumeOptions</a>

---

##### `fromHostPath` <a name="fromHostPath" id="cdk8s-plus-28.Volume.fromHostPath"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromHostPath(scope: Construct, id: string, name: string, options: HostPathVolumeOptions)
```

Used to mount a file or directory from the host node's filesystem into a Pod.

This is not something that most Pods will need, but it offers a powerful
escape hatch for some applications.

> [https://kubernetes.io/docs/concepts/storage/volumes/#hostpath](https://kubernetes.io/docs/concepts/storage/volumes/#hostpath)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromHostPath.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromHostPath.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromHostPath.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Volume.fromHostPath.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.HostPathVolumeOptions">HostPathVolumeOptions</a>

---

##### `fromNfs` <a name="fromNfs" id="cdk8s-plus-28.Volume.fromNfs"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromNfs(scope: Construct, id: string, name: string, options: NfsVolumeOptions)
```

Used to mount an NFS share into a Pod.

> [https://kubernetes.io/docs/concepts/storage/volumes/#nfs](https://kubernetes.io/docs/concepts/storage/volumes/#nfs)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromNfs.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromNfs.parameter.id"></a>

- *Type:* string

---

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.fromNfs.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Volume.fromNfs.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.NfsVolumeOptions">NfsVolumeOptions</a>

---

##### `fromPersistentVolumeClaim` <a name="fromPersistentVolumeClaim" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromPersistentVolumeClaim(scope: Construct, id: string, claim: IPersistentVolumeClaim, options?: PersistentVolumeClaimVolumeOptions)
```

Used to mount a PersistentVolume into a Pod.

PersistentVolumeClaims are a way for users to "claim" durable storage (such as a GCE PersistentDisk or an iSCSI volume)
without knowing the details of the particular cloud environment.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/](https://kubernetes.io/docs/concepts/storage/persistent-volumes/)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.id"></a>

- *Type:* string

---

###### `claim`<sup>Required</sup> <a name="claim" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.claim"></a>

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromPersistentVolumeClaim.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeClaimVolumeOptions">PersistentVolumeClaimVolumeOptions</a>

---

##### `fromSecret` <a name="fromSecret" id="cdk8s-plus-28.Volume.fromSecret"></a>

```typescript
import { Volume } from 'cdk8s-plus-28'

Volume.fromSecret(scope: Construct, id: string, secr: ISecret, options?: SecretVolumeOptions)
```

Populate the volume from a Secret.

A secret volume is used to pass sensitive information, such as passwords, to Pods.
You can store secrets in the Kubernetes API and mount them as files for use by pods
without coupling to Kubernetes directly.

secret volumes are backed by tmpfs (a RAM-backed filesystem)
so they are never written to non-volatile storage.

> [https://kubernetes.io/docs/concepts/storage/volumes/#secret](https://kubernetes.io/docs/concepts/storage/volumes/#secret)

###### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Volume.fromSecret.parameter.scope"></a>

- *Type:* constructs.Construct

---

###### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Volume.fromSecret.parameter.id"></a>

- *Type:* string

---

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.Volume.fromSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret to use to populate the volume.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Volume.fromSecret.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.SecretVolumeOptions">SecretVolumeOptions</a>

Options.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Volume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Volume.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Volume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Volume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---


### Workload <a name="Workload" id="cdk8s-plus-28.Workload"></a>

A workload is an application running on Kubernetes.

Whether your workload is a single
component or several that work together, on Kubernetes you run it inside a set of pods.
In Kubernetes, a Pod represents a set of running containers on your cluster.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Workload.Initializer"></a>

```typescript
import { Workload } from 'cdk8s-plus-28'

new Workload(scope: Construct, id: string, props: WorkloadProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.WorkloadProps">WorkloadProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.Workload.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="cdk8s-plus-28.Workload.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.Workload.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.WorkloadProps">WorkloadProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.toString">toString</a></code> | Returns a string representation of this construct. |
| <code><a href="#cdk8s-plus-28.Workload.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.Workload.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |
| <code><a href="#cdk8s-plus-28.Workload.addContainer">addContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addHostAlias">addHostAlias</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addInitContainer">addInitContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.addVolume">addVolume</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.attachContainer">attachContainer</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.Workload.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |
| <code><a href="#cdk8s-plus-28.Workload.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |
| <code><a href="#cdk8s-plus-28.Workload.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |
| <code><a href="#cdk8s-plus-28.Workload.select">select</a></code> | Configure selectors for this workload. |

---

##### `toString` <a name="toString" id="cdk8s-plus-28.Workload.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.Workload.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.Workload.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

##### `addContainer` <a name="addContainer" id="cdk8s-plus-28.Workload.addContainer"></a>

```typescript
public addContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Workload.addContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addHostAlias` <a name="addHostAlias" id="cdk8s-plus-28.Workload.addHostAlias"></a>

```typescript
public addHostAlias(hostAlias: HostAlias): void
```

###### `hostAlias`<sup>Required</sup> <a name="hostAlias" id="cdk8s-plus-28.Workload.addHostAlias.parameter.hostAlias"></a>

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>

---

##### `addInitContainer` <a name="addInitContainer" id="cdk8s-plus-28.Workload.addInitContainer"></a>

```typescript
public addInitContainer(cont: ContainerProps): Container
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Workload.addInitContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

##### `addVolume` <a name="addVolume" id="cdk8s-plus-28.Workload.addVolume"></a>

```typescript
public addVolume(vol: Volume): void
```

###### `vol`<sup>Required</sup> <a name="vol" id="cdk8s-plus-28.Workload.addVolume.parameter.vol"></a>

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

---

##### `attachContainer` <a name="attachContainer" id="cdk8s-plus-28.Workload.attachContainer"></a>

```typescript
public attachContainer(cont: Container): void
```

###### `cont`<sup>Required</sup> <a name="cont" id="cdk8s-plus-28.Workload.attachContainer.parameter.cont"></a>

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.Workload.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

> [INetworkPolicyPeer.toNetworkPolicyPeerConfig()](INetworkPolicyPeer.toNetworkPolicyPeerConfig())

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.Workload.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

> [INetworkPolicyPeer.toPodSelector()](INetworkPolicyPeer.toPodSelector())

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.Workload.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

> [IPodSelector.toPodSelectorConfig()](IPodSelector.toPodSelectorConfig())

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.Workload.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

> [ISubect.toSubjectConfiguration()](ISubect.toSubjectConfiguration())

##### `select` <a name="select" id="cdk8s-plus-28.Workload.select"></a>

```typescript
public select(selectors: LabelSelector): void
```

Configure selectors for this workload.

###### `selectors`<sup>Required</sup> <a name="selectors" id="cdk8s-plus-28.Workload.select.parameter.selectors"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### `isConstruct` <a name="isConstruct" id="cdk8s-plus-28.Workload.isConstruct"></a>

```typescript
import { Workload } from 'cdk8s-plus-28'

Workload.isConstruct(x: any)
```

Checks if `x` is a construct.

Use this method instead of `instanceof` to properly detect `Construct`
instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the `constructs` library on
disk are seen as independent, completely different libraries. As a
consequence, the class `Construct` in each copy of the `constructs` library
is seen as a different class, and an instance of one class will not test as
`instanceof` the other class. `npm install` will not create installations
like this, but users may manually symlink construct libraries together or
use a monorepo tool: in those cases, multiple copies of the `constructs`
library can be accidentally installed, and `instanceof` will behave
unpredictably. It is safest to avoid using `instanceof`, and using
this type-testing method instead.

###### `x`<sup>Required</sup> <a name="x" id="cdk8s-plus-28.Workload.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Workload.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.Workload.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. "authorization.k8s.io"). |
| <code><a href="#cdk8s-plus-28.Workload.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.Workload.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.Workload.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.name">name</a></code> | <code>string</code> | The name of this API object. |
| <code><a href="#cdk8s-plus-28.Workload.property.permissions">permissions</a></code> | <code><a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.Workload.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.Workload.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDns">PodDns</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadataDefinition</code> | The metadata of pods in this workload. |
| <code><a href="#cdk8s-plus-28.Workload.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.connections">connections</a></code> | <code><a href="#cdk8s-plus-28.PodConnections">PodConnections</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Workload.property.matchExpressions">matchExpressions</a></code> | <code><a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]</code> | The expression matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Workload.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | The label matchers this workload will use in order to select pods. |
| <code><a href="#cdk8s-plus-28.Workload.property.scheduling">scheduling</a></code> | <code><a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a></code> | *No description.* |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.Workload.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.Workload.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. "authorization.k8s.io").

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.Workload.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.Workload.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `metadata`<sup>Required</sup> <a name="metadata" id="cdk8s-plus-28.Workload.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Workload.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this API object.

---

##### `permissions`<sup>Required</sup> <a name="permissions" id="cdk8s-plus-28.Workload.property.permissions"></a>

```typescript
public readonly permissions: ResourcePermissions;
```

- *Type:* <a href="#cdk8s-plus-28.ResourcePermissions">ResourcePermissions</a>

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.Workload.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

---

##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.Workload.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `automountServiceAccountToken`<sup>Required</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.Workload.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.Workload.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `dns`<sup>Required</sup> <a name="dns" id="cdk8s-plus-28.Workload.property.dns"></a>

```typescript
public readonly dns: PodDns;
```

- *Type:* <a href="#cdk8s-plus-28.PodDns">PodDns</a>

---

##### `hostAliases`<sup>Required</sup> <a name="hostAliases" id="cdk8s-plus-28.Workload.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

---

##### `initContainers`<sup>Required</sup> <a name="initContainers" id="cdk8s-plus-28.Workload.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

---

##### `podMetadata`<sup>Required</sup> <a name="podMetadata" id="cdk8s-plus-28.Workload.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadataDefinition;
```

- *Type:* cdk8s.ApiObjectMetadataDefinition

The metadata of pods in this workload.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.Workload.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContext">PodSecurityContext</a>

---

##### `volumes`<sup>Required</sup> <a name="volumes" id="cdk8s-plus-28.Workload.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.Workload.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.Workload.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.Workload.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.Workload.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.Workload.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration

---

##### `connections`<sup>Required</sup> <a name="connections" id="cdk8s-plus-28.Workload.property.connections"></a>

```typescript
public readonly connections: PodConnections;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnections">PodConnections</a>

---

##### `matchExpressions`<sup>Required</sup> <a name="matchExpressions" id="cdk8s-plus-28.Workload.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorRequirement">LabelSelectorRequirement</a>[]

The expression matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add expression matchers.

---

##### `matchLabels`<sup>Required</sup> <a name="matchLabels" id="cdk8s-plus-28.Workload.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

The label matchers this workload will use in order to select pods.

Returns a a copy. Use `select()` to add label matchers.

---

##### `scheduling`<sup>Required</sup> <a name="scheduling" id="cdk8s-plus-28.Workload.property.scheduling"></a>

```typescript
public readonly scheduling: WorkloadScheduling;
```

- *Type:* <a href="#cdk8s-plus-28.WorkloadScheduling">WorkloadScheduling</a>

---


## Structs <a name="Structs" id="Structs"></a>

### AbstractPodProps <a name="AbstractPodProps" id="cdk8s-plus-28.AbstractPodProps"></a>

Properties for `AbstractPod`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AbstractPodProps.Initializer"></a>

```typescript
import { AbstractPodProps } from 'cdk8s-plus-28'

const abstractPodProps: AbstractPodProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.AbstractPodProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AbstractPodProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.AbstractPodProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.AbstractPodProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.AbstractPodProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.AbstractPodProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.AbstractPodProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.AbstractPodProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.AbstractPodProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.AbstractPodProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.AbstractPodProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.AbstractPodProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.AbstractPodProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.AbstractPodProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.AbstractPodProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

### AddDeploymentOptions <a name="AddDeploymentOptions" id="cdk8s-plus-28.AddDeploymentOptions"></a>

Options to add a deployment to a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AddDeploymentOptions.Initializer"></a>

```typescript
import { AddDeploymentOptions } from 'cdk8s-plus-28'

const addDeploymentOptions: AddDeploymentOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.name">name</a></code> | <code>string</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.nodePort">nodePort</a></code> | <code>number</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.targetPort">targetPort</a></code> | <code>number</code> | The port number the service will redirect to. |
| <code><a href="#cdk8s-plus-28.AddDeploymentOptions.property.port">port</a></code> | <code>number</code> | The port number the service will bind to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AddDeploymentOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `nodePort`<sup>Optional</sup> <a name="nodePort" id="cdk8s-plus-28.AddDeploymentOptions.property.nodePort"></a>

```typescript
public readonly nodePort: number;
```

- *Type:* number
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.AddDeploymentOptions.property.protocol"></a>

```typescript
public readonly protocol: Protocol;
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `targetPort`<sup>Optional</sup> <a name="targetPort" id="cdk8s-plus-28.AddDeploymentOptions.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.AddDeploymentOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* Copied from the first container of the deployment.

The port number the service will bind to.

---

### AddDirectoryOptions <a name="AddDirectoryOptions" id="cdk8s-plus-28.AddDirectoryOptions"></a>

Options for `configmap.addDirectory()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AddDirectoryOptions.Initializer"></a>

```typescript
import { AddDirectoryOptions } from 'cdk8s-plus-28'

const addDirectoryOptions: AddDirectoryOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AddDirectoryOptions.property.exclude">exclude</a></code> | <code>string[]</code> | Glob patterns to exclude when adding files. |
| <code><a href="#cdk8s-plus-28.AddDirectoryOptions.property.keyPrefix">keyPrefix</a></code> | <code>string</code> | A prefix to add to all keys in the config map. |

---

##### `exclude`<sup>Optional</sup> <a name="exclude" id="cdk8s-plus-28.AddDirectoryOptions.property.exclude"></a>

```typescript
public readonly exclude: string[];
```

- *Type:* string[]
- *Default:* include all files

Glob patterns to exclude when adding files.

---

##### `keyPrefix`<sup>Optional</sup> <a name="keyPrefix" id="cdk8s-plus-28.AddDirectoryOptions.property.keyPrefix"></a>

```typescript
public readonly keyPrefix: string;
```

- *Type:* string
- *Default:* ""

A prefix to add to all keys in the config map.

---

### Affinity <a name="Affinity" id="cdk8s-plus-28.k8s.Affinity"></a>

Affinity is a group of affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Affinity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const affinity: k8s.Affinity = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.nodeAffinity">nodeAffinity</a></code> | <code>cdk8s-plus-28.k8s.NodeAffinity</code> | Describes node affinity scheduling rules for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.podAffinity">podAffinity</a></code> | <code>cdk8s-plus-28.k8s.PodAffinity</code> | Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)). |
| <code><a href="#cdk8s-plus-28.k8s.Affinity.property.podAntiAffinity">podAntiAffinity</a></code> | <code>cdk8s-plus-28.k8s.PodAntiAffinity</code> | Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)). |

---

##### `nodeAffinity`<sup>Optional</sup> <a name="nodeAffinity" id="cdk8s-plus-28.k8s.Affinity.property.nodeAffinity"></a>

```typescript
public readonly nodeAffinity: NodeAffinity;
```

- *Type:* cdk8s-plus-28.k8s.NodeAffinity

Describes node affinity scheduling rules for the pod.

---

##### `podAffinity`<sup>Optional</sup> <a name="podAffinity" id="cdk8s-plus-28.k8s.Affinity.property.podAffinity"></a>

```typescript
public readonly podAffinity: PodAffinity;
```

- *Type:* cdk8s-plus-28.k8s.PodAffinity

Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).

---

##### `podAntiAffinity`<sup>Optional</sup> <a name="podAntiAffinity" id="cdk8s-plus-28.k8s.Affinity.property.podAntiAffinity"></a>

```typescript
public readonly podAntiAffinity: PodAntiAffinity;
```

- *Type:* cdk8s-plus-28.k8s.PodAntiAffinity

Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).

---

### AggregationRule <a name="AggregationRule" id="cdk8s-plus-28.k8s.AggregationRule"></a>

AggregationRule describes how to locate ClusterRoles to aggregate into the ClusterRole.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AggregationRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const aggregationRule: k8s.AggregationRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AggregationRule.property.clusterRoleSelectors">clusterRoleSelectors</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector[]</code> | ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules. |

---

##### `clusterRoleSelectors`<sup>Optional</sup> <a name="clusterRoleSelectors" id="cdk8s-plus-28.k8s.AggregationRule.property.clusterRoleSelectors"></a>

```typescript
public readonly clusterRoleSelectors: LabelSelector[];
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector[]

ClusterRoleSelectors holds a list of selectors which will be used to find ClusterRoles and create the rules.

If any of the selectors match, then the ClusterRole's permissions will be added

---

### ApiResourceOptions <a name="ApiResourceOptions" id="cdk8s-plus-28.ApiResourceOptions"></a>

Options for `ApiResource`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ApiResourceOptions.Initializer"></a>

```typescript
import { ApiResourceOptions } from 'cdk8s-plus-28'

const apiResourceOptions: ApiResourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResourceOptions.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ApiResourceOptions.property.resourceType">resourceType</a></code> | <code>string</code> | The name of the resource type as it appears in the relevant API endpoint. |

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ApiResourceOptions.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ApiResourceOptions.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of the resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


### ApiServiceSpec <a name="ApiServiceSpec" id="cdk8s-plus-28.k8s.ApiServiceSpec"></a>

APIServiceSpec contains information for locating and communicating with a server.

Only https is supported, though you are able to disable certificate verification.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ApiServiceSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const apiServiceSpec: k8s.ApiServiceSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.groupPriorityMinimum">groupPriorityMinimum</a></code> | <code>number</code> | GroupPriorityMininum is the priority this group should have at least. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.versionPriority">versionPriority</a></code> | <code>number</code> | VersionPriority controls the ordering of this API version inside of its group. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.caBundle">caBundle</a></code> | <code>string</code> | CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.group">group</a></code> | <code>string</code> | Group is the API group name this server hosts. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.insecureSkipTlsVerify">insecureSkipTlsVerify</a></code> | <code>boolean</code> | InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.service">service</a></code> | <code>cdk8s-plus-28.k8s.ServiceReference</code> | Service is a reference to the service for this API server. |
| <code><a href="#cdk8s-plus-28.k8s.ApiServiceSpec.property.version">version</a></code> | <code>string</code> | Version is the API version this server hosts. |

---

##### `groupPriorityMinimum`<sup>Required</sup> <a name="groupPriorityMinimum" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.groupPriorityMinimum"></a>

```typescript
public readonly groupPriorityMinimum: number;
```

- *Type:* number

GroupPriorityMininum is the priority this group should have at least.

Higher priority means that the group is preferred by clients over lower priority ones. Note that other versions of this group might specify even higher GroupPriorityMininum values such that the whole group gets a higher priority. The primary sort is based on GroupPriorityMinimum, ordered highest number to lowest (20 before 10). The secondary sort is based on the alphabetical comparison of the name of the object.  (v1.bar before v1.foo) We'd recommend something like: *.k8s.io (except extensions) at 18000 and PaaSes (OpenShift, Deis) are recommended to be in the 2000s

---

##### `versionPriority`<sup>Required</sup> <a name="versionPriority" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.versionPriority"></a>

```typescript
public readonly versionPriority: number;
```

- *Type:* number

VersionPriority controls the ordering of this API version inside of its group.

Must be greater than zero. The primary sort is based on VersionPriority, ordered highest to lowest (20 before 10). Since it's inside of a group, the number can be small, probably in the 10s. In case of equal version priorities, the version string will be used to compute the order inside a group. If the version string is "kube-like", it will sort above non "kube-like" version strings, which are ordered lexicographically. "Kube-like" versions start with a "v", then are followed by a number (the major version), then optionally the string "alpha" or "beta" and another number (the minor version). These are sorted first by GA > beta > alpha (where GA is a version with no suffix such as beta or alpha), and then by comparing major version, then minor version. An example sorted list of versions: v10, v2, v1, v11beta2, v10beta3, v3beta1, v12alpha1, v11alpha2, foo1, foo10.

---

##### `caBundle`<sup>Optional</sup> <a name="caBundle" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.caBundle"></a>

```typescript
public readonly caBundle: string;
```

- *Type:* string

CABundle is a PEM encoded CA bundle which will be used to validate an API server's serving certificate.

If unspecified, system trust roots on the apiserver are used.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string

Group is the API group name this server hosts.

---

##### `insecureSkipTlsVerify`<sup>Optional</sup> <a name="insecureSkipTlsVerify" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.insecureSkipTlsVerify"></a>

```typescript
public readonly insecureSkipTlsVerify: boolean;
```

- *Type:* boolean

InsecureSkipTLSVerify disables TLS certificate verification when communicating with this server.

This is strongly discouraged.  You should use the CABundle instead.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.service"></a>

```typescript
public readonly service: ServiceReference;
```

- *Type:* cdk8s-plus-28.k8s.ServiceReference

Service is a reference to the service for this API server.

It must communicate on port 443. If the Service is nil, that means the handling for the API groupversion is handled locally on this server. The call will simply delegate to the normal handler chain to be fulfilled.

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk8s-plus-28.k8s.ApiServiceSpec.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Version is the API version this server hosts.

For example, "v1"

---

### AuditAnnotationV1Alpha1 <a name="AuditAnnotationV1Alpha1" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1"></a>

AuditAnnotation describes how to produce an audit annotation for an API request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const auditAnnotationV1Alpha1: k8s.AuditAnnotationV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.key">key</a></code> | <code>string</code> | key specifies the audit annotation key. |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.valueExpression">valueExpression</a></code> | <code>string</code> | valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

key specifies the audit annotation key.

The audit annotation keys of a ValidatingAdmissionPolicy must be unique. The key must be a qualified name ([A-Za-z0-9][-A-Za-z0-9_.]*) no more than 63 bytes in length.

The key is combined with the resource name of the ValidatingAdmissionPolicy to construct an audit annotation key: "{ValidatingAdmissionPolicy name}/{key}".

If an admission webhook uses the same resource name as this ValidatingAdmissionPolicy and the same audit annotation key, the annotation key will be identical. In this case, the first annotation written with the key will be included in the audit event and all subsequent annotations with the same key will be discarded.

Required.

---

##### `valueExpression`<sup>Required</sup> <a name="valueExpression" id="cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1.property.valueExpression"></a>

```typescript
public readonly valueExpression: string;
```

- *Type:* string

valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value.

The expression must evaluate to either a string or null value. If the expression evaluates to a string, the audit annotation is included with the string value. If the expression evaluates to null or empty string the audit annotation will be omitted. The valueExpression may be no longer than 5kb in length. If the result of the valueExpression is more than 10kb in length, it will be truncated to 10kb.

If multiple ValidatingAdmissionPolicyBinding resources match an API request, then the valueExpression will be evaluated for each binding. All unique values produced by the valueExpressions will be joined together in a comma-separated list.

Required.

---

### AuditAnnotationV1Beta1 <a name="AuditAnnotationV1Beta1" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1"></a>

AuditAnnotation describes how to produce an audit annotation for an API request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const auditAnnotationV1Beta1: k8s.AuditAnnotationV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.key">key</a></code> | <code>string</code> | key specifies the audit annotation key. |
| <code><a href="#cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.valueExpression">valueExpression</a></code> | <code>string</code> | valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

key specifies the audit annotation key.

The audit annotation keys of a ValidatingAdmissionPolicy must be unique. The key must be a qualified name ([A-Za-z0-9][-A-Za-z0-9_.]*) no more than 63 bytes in length.

The key is combined with the resource name of the ValidatingAdmissionPolicy to construct an audit annotation key: "{ValidatingAdmissionPolicy name}/{key}".

If an admission webhook uses the same resource name as this ValidatingAdmissionPolicy and the same audit annotation key, the annotation key will be identical. In this case, the first annotation written with the key will be included in the audit event and all subsequent annotations with the same key will be discarded.

Required.

---

##### `valueExpression`<sup>Required</sup> <a name="valueExpression" id="cdk8s-plus-28.k8s.AuditAnnotationV1Beta1.property.valueExpression"></a>

```typescript
public readonly valueExpression: string;
```

- *Type:* string

valueExpression represents the expression which is evaluated by CEL to produce an audit annotation value.

The expression must evaluate to either a string or null value. If the expression evaluates to a string, the audit annotation is included with the string value. If the expression evaluates to null or empty string the audit annotation will be omitted. The valueExpression may be no longer than 5kb in length. If the result of the valueExpression is more than 10kb in length, it will be truncated to 10kb.

If multiple ValidatingAdmissionPolicyBinding resources match an API request, then the valueExpression will be evaluated for each binding. All unique values produced by the valueExpressions will be joined together in a comma-separated list.

Required.

---

### AwsElasticBlockStorePersistentVolumeProps <a name="AwsElasticBlockStorePersistentVolumeProps" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps"></a>

Properties for `AwsElasticBlockStorePersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.Initializer"></a>

```typescript
import { AwsElasticBlockStorePersistentVolumeProps } from 'cdk8s-plus-28'

const awsElasticBlockStorePersistentVolumeProps: AwsElasticBlockStorePersistentVolumeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeId">volumeId</a></code> | <code>string</code> | Unique ID of the persistent disk resource in AWS (Amazon EBS volume). |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.partition">partition</a></code> | <code>number</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.readOnly">readOnly</a></code> | <code>boolean</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaimPolicy`<sup>Optional</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

Unique ID of the persistent disk resource in AWS (Amazon EBS volume).

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.AwsElasticBlockStorePersistentVolumeProps.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### AwsElasticBlockStoreVolumeOptions <a name="AwsElasticBlockStoreVolumeOptions" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions"></a>

Options of `Volume.fromAwsElasticBlockStore`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.Initializer"></a>

```typescript
import { AwsElasticBlockStoreVolumeOptions } from 'cdk8s-plus-28'

const awsElasticBlockStoreVolumeOptions: AwsElasticBlockStoreVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.partition">partition</a></code> | <code>number</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.AwsElasticBlockStoreVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### AwsElasticBlockStoreVolumeSource <a name="AwsElasticBlockStoreVolumeSource" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource"></a>

Represents a Persistent Disk resource in AWS.

An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const awsElasticBlockStoreVolumeSource: k8s.AwsElasticBlockStoreVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.volumeId">volumeId</a></code> | <code>string</code> | volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume). |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.partition">partition</a></code> | <code>number</code> | partition is the partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly value true will force the readOnly setting in VolumeMounts. |

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume).

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number

partition is the partition in the volume that you want to mount.

If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly value true will force the readOnly setting in VolumeMounts.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

### AzureDiskPersistentVolumeProps <a name="AzureDiskPersistentVolumeProps" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps"></a>

Properties for `AzureDiskPersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.Initializer"></a>

```typescript
import { AzureDiskPersistentVolumeProps } from 'cdk8s-plus-28'

const azureDiskPersistentVolumeProps: AzureDiskPersistentVolumeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskName">diskName</a></code> | <code>string</code> | The Name of the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskUri">diskUri</a></code> | <code>string</code> | The URI the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.cachingMode">cachingMode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Host Caching mode. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.kind">kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Kind of disk. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.readOnly">readOnly</a></code> | <code>boolean</code> | Force the ReadOnly setting in VolumeMounts. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaimPolicy`<sup>Optional</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `diskName`<sup>Required</sup> <a name="diskName" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskName"></a>

```typescript
public readonly diskName: string;
```

- *Type:* string

The Name of the data disk in the blob storage.

---

##### `diskUri`<sup>Required</sup> <a name="diskUri" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.diskUri"></a>

```typescript
public readonly diskUri: string;
```

- *Type:* string

The URI the data disk in the blob storage.

---

##### `cachingMode`<sup>Optional</sup> <a name="cachingMode" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.cachingMode"></a>

```typescript
public readonly cachingMode: AzureDiskPersistentVolumeCachingMode;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.kind"></a>

```typescript
public readonly kind: AzureDiskPersistentVolumeKind;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.AzureDiskPersistentVolumeProps.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

### AzureDiskVolumeOptions <a name="AzureDiskVolumeOptions" id="cdk8s-plus-28.AzureDiskVolumeOptions"></a>

Options of `Volume.fromAzureDisk`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.AzureDiskVolumeOptions.Initializer"></a>

```typescript
import { AzureDiskVolumeOptions } from 'cdk8s-plus-28'

const azureDiskVolumeOptions: AzureDiskVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.cachingMode">cachingMode</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a></code> | Host Caching mode. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.kind">kind</a></code> | <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a></code> | Kind of disk. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.AzureDiskVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Force the ReadOnly setting in VolumeMounts. |

---

##### `cachingMode`<sup>Optional</sup> <a name="cachingMode" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.cachingMode"></a>

```typescript
public readonly cachingMode: AzureDiskPersistentVolumeCachingMode;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode">AzureDiskPersistentVolumeCachingMode</a>
- *Default:* AzureDiskPersistentVolumeCachingMode.NONE.

Host Caching mode.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type to mount.

Must be a filesystem type supported by the host operating system.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.kind"></a>

```typescript
public readonly kind: AzureDiskPersistentVolumeKind;
```

- *Type:* <a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind">AzureDiskPersistentVolumeKind</a>
- *Default:* AzureDiskPersistentVolumeKind.SHARED

Kind of disk.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.AzureDiskVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Force the ReadOnly setting in VolumeMounts.

---

### AzureDiskVolumeSource <a name="AzureDiskVolumeSource" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource"></a>

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const azureDiskVolumeSource: k8s.AzureDiskVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskName">diskName</a></code> | <code>string</code> | diskName is the Name of the data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskUri">diskUri</a></code> | <code>string</code> | diskURI is the URI of data disk in the blob storage. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.cachingMode">cachingMode</a></code> | <code>string</code> | cachingMode is the Host Caching mode: None, Read Only, Read Write. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.kind">kind</a></code> | <code>string</code> | kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). |
| <code><a href="#cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly Defaults to false (read/write). |

---

##### `diskName`<sup>Required</sup> <a name="diskName" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskName"></a>

```typescript
public readonly diskName: string;
```

- *Type:* string

diskName is the Name of the data disk in the blob storage.

---

##### `diskUri`<sup>Required</sup> <a name="diskUri" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.diskUri"></a>

```typescript
public readonly diskUri: string;
```

- *Type:* string

diskURI is the URI of data disk in the blob storage.

---

##### `cachingMode`<sup>Optional</sup> <a name="cachingMode" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.cachingMode"></a>

```typescript
public readonly cachingMode: string;
```

- *Type:* string

cachingMode is the Host Caching mode: None, Read Only, Read Write.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set).

defaults to shared

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.AzureDiskVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### AzureFilePersistentVolumeSource <a name="AzureFilePersistentVolumeSource" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource"></a>

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const azureFilePersistentVolumeSource: k8s.AzureFilePersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretName">secretName</a></code> | <code>string</code> | secretName is the name of secret that contains Azure Storage Account Name and Key. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.shareName">shareName</a></code> | <code>string</code> | shareName is the azure Share Name. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretNamespace">secretNamespace</a></code> | <code>string</code> | secretNamespace is the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod. |

---

##### `secretName`<sup>Required</sup> <a name="secretName" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretName"></a>

```typescript
public readonly secretName: string;
```

- *Type:* string

secretName is the name of secret that contains Azure Storage Account Name and Key.

---

##### `shareName`<sup>Required</sup> <a name="shareName" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.shareName"></a>

```typescript
public readonly shareName: string;
```

- *Type:* string

shareName is the azure Share Name.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secretNamespace`<sup>Optional</sup> <a name="secretNamespace" id="cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource.property.secretNamespace"></a>

```typescript
public readonly secretNamespace: string;
```

- *Type:* string

secretNamespace is the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod.

---

### AzureFileVolumeSource <a name="AzureFileVolumeSource" id="cdk8s-plus-28.k8s.AzureFileVolumeSource"></a>

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const azureFileVolumeSource: k8s.AzureFileVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.secretName">secretName</a></code> | <code>string</code> | secretName is the  name of secret that contains Azure Storage Account Name and Key. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.shareName">shareName</a></code> | <code>string</code> | shareName is the azure share Name. |
| <code><a href="#cdk8s-plus-28.k8s.AzureFileVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |

---

##### `secretName`<sup>Required</sup> <a name="secretName" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.secretName"></a>

```typescript
public readonly secretName: string;
```

- *Type:* string

secretName is the  name of secret that contains Azure Storage Account Name and Key.

---

##### `shareName`<sup>Required</sup> <a name="shareName" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.shareName"></a>

```typescript
public readonly shareName: string;
```

- *Type:* string

shareName is the azure share Name.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.AzureFileVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### BasicAuthSecretProps <a name="BasicAuthSecretProps" id="cdk8s-plus-28.BasicAuthSecretProps"></a>

Options for `BasicAuthSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.BasicAuthSecretProps.Initializer"></a>

```typescript
import { BasicAuthSecretProps } from 'cdk8s-plus-28'

const basicAuthSecretProps: BasicAuthSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.password">password</a></code> | <code>string</code> | The password or token for authentication. |
| <code><a href="#cdk8s-plus-28.BasicAuthSecretProps.property.username">username</a></code> | <code>string</code> | The user name for authentication. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.BasicAuthSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.BasicAuthSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `password`<sup>Required</sup> <a name="password" id="cdk8s-plus-28.BasicAuthSecretProps.property.password"></a>

```typescript
public readonly password: string;
```

- *Type:* string

The password or token for authentication.

---

##### `username`<sup>Required</sup> <a name="username" id="cdk8s-plus-28.BasicAuthSecretProps.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

The user name for authentication.

---

### BoundObjectReference <a name="BoundObjectReference" id="cdk8s-plus-28.k8s.BoundObjectReference"></a>

BoundObjectReference is a reference to an object that a token is bound to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.BoundObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const boundObjectReference: k8s.BoundObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.apiVersion">apiVersion</a></code> | <code>string</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.kind">kind</a></code> | <code>string</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.BoundObjectReference.property.uid">uid</a></code> | <code>string</code> | UID of the referent. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.BoundObjectReference.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

API version of the referent.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.BoundObjectReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind of the referent.

Valid kinds are 'Pod' and 'Secret'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.BoundObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.BoundObjectReference.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID of the referent.

---

### Capabilities <a name="Capabilities" id="cdk8s-plus-28.k8s.Capabilities"></a>

Adds and removes POSIX capabilities from running containers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Capabilities.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const capabilities: k8s.Capabilities = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Capabilities.property.add">add</a></code> | <code>string[]</code> | Added capabilities. |
| <code><a href="#cdk8s-plus-28.k8s.Capabilities.property.drop">drop</a></code> | <code>string[]</code> | Removed capabilities. |

---

##### `add`<sup>Optional</sup> <a name="add" id="cdk8s-plus-28.k8s.Capabilities.property.add"></a>

```typescript
public readonly add: string[];
```

- *Type:* string[]

Added capabilities.

---

##### `drop`<sup>Optional</sup> <a name="drop" id="cdk8s-plus-28.k8s.Capabilities.property.drop"></a>

```typescript
public readonly drop: string[];
```

- *Type:* string[]

Removed capabilities.

---

### CephFsPersistentVolumeSource <a name="CephFsPersistentVolumeSource" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource"></a>

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const cephFsPersistentVolumeSource: k8s.CephFsPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.monitors">monitors</a></code> | <code>string[]</code> | monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.path">path</a></code> | <code>string</code> | path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretFile">secretFile</a></code> | <code>string</code> | secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.user">user</a></code> | <code>string</code> | user is Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.monitors"></a>

```typescript
public readonly monitors: string[];
```

- *Type:* string[]

monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `secretFile`<sup>Optional</sup> <a name="secretFile" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretFile"></a>

```typescript
public readonly secretFile: string;
```

- *Type:* string

secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty.

More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.CephFsPersistentVolumeSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

user is Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

### CephFsVolumeSource <a name="CephFsVolumeSource" id="cdk8s-plus-28.k8s.CephFsVolumeSource"></a>

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CephFsVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const cephFsVolumeSource: k8s.CephFsVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.monitors">monitors</a></code> | <code>string[]</code> | monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.path">path</a></code> | <code>string</code> | path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretFile">secretFile</a></code> | <code>string</code> | secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. |
| <code><a href="#cdk8s-plus-28.k8s.CephFsVolumeSource.property.user">user</a></code> | <code>string</code> | user is optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it. |

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.monitors"></a>

```typescript
public readonly monitors: string[];
```

- *Type:* string[]

monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `secretFile`<sup>Optional</sup> <a name="secretFile" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretFile"></a>

```typescript
public readonly secretFile: string;
```

- *Type:* string

secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty.

More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.CephFsVolumeSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

user is optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it.

---

### CertificateSigningRequestSpec <a name="CertificateSigningRequestSpec" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec"></a>

CertificateSigningRequestSpec contains the certificate request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const certificateSigningRequestSpec: k8s.CertificateSigningRequestSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.request">request</a></code> | <code>string</code> | request contains an x509 certificate signing request encoded in a "CERTIFICATE REQUEST" PEM block. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.signerName">signerName</a></code> | <code>string</code> | signerName indicates the requested signer, and is a qualified name. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.expirationSeconds">expirationSeconds</a></code> | <code>number</code> | expirationSeconds is the requested duration of validity of the issued certificate. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.extra">extra</a></code> | <code>{[ key: string ]: string[]}</code> | extra contains extra attributes of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.groups">groups</a></code> | <code>string[]</code> | groups contains group membership of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.uid">uid</a></code> | <code>string</code> | uid contains the uid of the user that created the CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.usages">usages</a></code> | <code>string[]</code> | usages specifies a set of key usages requested in the issued certificate. |
| <code><a href="#cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.username">username</a></code> | <code>string</code> | username contains the name of the user that created the CertificateSigningRequest. |

---

##### `request`<sup>Required</sup> <a name="request" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.request"></a>

```typescript
public readonly request: string;
```

- *Type:* string

request contains an x509 certificate signing request encoded in a "CERTIFICATE REQUEST" PEM block.

When serialized as JSON or YAML, the data is additionally base64-encoded.

---

##### `signerName`<sup>Required</sup> <a name="signerName" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.signerName"></a>

```typescript
public readonly signerName: string;
```

- *Type:* string

signerName indicates the requested signer, and is a qualified name.

List/watch requests for CertificateSigningRequests can filter on this field using a "spec.signerName=NAME" fieldSelector.

Well-known Kubernetes signers are:
1. "kubernetes.io/kube-apiserver-client": issues client certificates that can be used to authenticate to kube-apiserver.
Requests for this signer are never auto-approved by kube-controller-manager, can be issued by the "csrsigning" controller in kube-controller-manager.
2. "kubernetes.io/kube-apiserver-client-kubelet": issues client certificates that kubelets use to authenticate to kube-apiserver.
Requests for this signer can be auto-approved by the "csrapproving" controller in kube-controller-manager, and can be issued by the "csrsigning" controller in kube-controller-manager.
3. "kubernetes.io/kubelet-serving" issues serving certificates that kubelets use to serve TLS endpoints, which kube-apiserver can connect to securely.
Requests for this signer are never auto-approved by kube-controller-manager, and can be issued by the "csrsigning" controller in kube-controller-manager.

More details are available at https://k8s.io/docs/reference/access-authn-authz/certificate-signing-requests/#kubernetes-signers

Custom signerNames can also be specified. The signer defines:
1. Trust distribution: how trust (CA bundles) are distributed.
2. Permitted subjects: and behavior when a disallowed subject is requested.
3. Required, permitted, or forbidden x509 extensions in the request (including whether subjectAltNames are allowed, which types, restrictions on allowed values) and behavior when a disallowed extension is requested.
4. Required, permitted, or forbidden key usages / extended key usages.
5. Expiration/certificate lifetime: whether it is fixed by the signer, configurable by the admin.
6. Whether or not requests for CA certificates are allowed.

---

##### `expirationSeconds`<sup>Optional</sup> <a name="expirationSeconds" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.expirationSeconds"></a>

```typescript
public readonly expirationSeconds: number;
```

- *Type:* number

expirationSeconds is the requested duration of validity of the issued certificate.

The certificate signer may issue a certificate with a different validity duration so a client must check the delta between the notBefore and and notAfter fields in the issued certificate to determine the actual duration.

The v1.22+ in-tree implementations of the well-known Kubernetes signers will honor this field as long as the requested duration is not greater than the maximum duration they will honor per the --cluster-signing-duration CLI flag to the Kubernetes controller manager.

Certificate signers may not honor this field for various reasons:

1. Old signer that is unaware of the field (such as the in-tree
implementations prior to v1.22)
2. Signer whose configured maximum is shorter than the requested duration
3. Signer whose configured minimum is longer than the requested duration

The minimum valid value for expirationSeconds is 600, i.e. 10 minutes.

---

##### `extra`<sup>Optional</sup> <a name="extra" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.extra"></a>

```typescript
public readonly extra: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

extra contains extra attributes of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `groups`<sup>Optional</sup> <a name="groups" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.groups"></a>

```typescript
public readonly groups: string[];
```

- *Type:* string[]

groups contains group membership of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

uid contains the uid of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

##### `usages`<sup>Optional</sup> <a name="usages" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.usages"></a>

```typescript
public readonly usages: string[];
```

- *Type:* string[]

usages specifies a set of key usages requested in the issued certificate.

Requests for TLS client certificates typically request: "digital signature", "key encipherment", "client auth".

Requests for TLS serving certificates typically request: "key encipherment", "digital signature", "server auth".

Valid values are:
"signing", "digital signature", "content commitment",
"key encipherment", "key agreement", "data encipherment",
"cert sign", "crl sign", "encipher only", "decipher only", "any",
"server auth", "client auth",
"code signing", "email protection", "s/mime",
"ipsec end system", "ipsec tunnel", "ipsec user",
"timestamping", "ocsp signing", "microsoft sgc", "netscape sgc"

---

##### `username`<sup>Optional</sup> <a name="username" id="cdk8s-plus-28.k8s.CertificateSigningRequestSpec.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

username contains the name of the user that created the CertificateSigningRequest.

Populated by the API server on creation and immutable.

---

### CinderPersistentVolumeSource <a name="CinderPersistentVolumeSource" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource"></a>

Represents a cinder volume resource in Openstack.

A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const cinderPersistentVolumeSource: k8s.CinderPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.volumeId">volumeId</a></code> | <code>string</code> | volumeID used to identify the volume in cinder. |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef is Optional: points to a secret object containing parameters used to connect to OpenStack. |

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

volumeID used to identify the volume in cinder.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.CinderPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

secretRef is Optional: points to a secret object containing parameters used to connect to OpenStack.

---

### CinderVolumeSource <a name="CinderVolumeSource" id="cdk8s-plus-28.k8s.CinderVolumeSource"></a>

Represents a cinder volume resource in Openstack.

A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CinderVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const cinderVolumeSource: k8s.CinderVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.volumeId">volumeId</a></code> | <code>string</code> | volumeID used to identify the volume in cinder. |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.CinderVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef is optional: points to a secret object containing parameters used to connect to OpenStack. |

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

volumeID used to identify the volume in cinder.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.CinderVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef is optional: points to a secret object containing parameters used to connect to OpenStack.

---

### ClaimSource <a name="ClaimSource" id="cdk8s-plus-28.k8s.ClaimSource"></a>

ClaimSource describes a reference to a ResourceClaim.

Exactly one of these fields should be set.  Consumers of this type must treat an empty object as if it has an unknown value.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClaimSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const claimSource: k8s.ClaimSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimName">resourceClaimName</a></code> | <code>string</code> | ResourceClaimName is the name of a ResourceClaim object in the same namespace as this pod. |
| <code><a href="#cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimTemplateName">resourceClaimTemplateName</a></code> | <code>string</code> | ResourceClaimTemplateName is the name of a ResourceClaimTemplate object in the same namespace as this pod. |

---

##### `resourceClaimName`<sup>Optional</sup> <a name="resourceClaimName" id="cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimName"></a>

```typescript
public readonly resourceClaimName: string;
```

- *Type:* string

ResourceClaimName is the name of a ResourceClaim object in the same namespace as this pod.

---

##### `resourceClaimTemplateName`<sup>Optional</sup> <a name="resourceClaimTemplateName" id="cdk8s-plus-28.k8s.ClaimSource.property.resourceClaimTemplateName"></a>

```typescript
public readonly resourceClaimTemplateName: string;
```

- *Type:* string

ResourceClaimTemplateName is the name of a ResourceClaimTemplate object in the same namespace as this pod.

The template will be used to create a new ResourceClaim, which will be bound to this pod. When this pod is deleted, the ResourceClaim will also be deleted. The pod name and resource name, along with a generated component, will be used to form a unique name for the ResourceClaim, which will be recorded in pod.status.resourceClaimStatuses.

This field is immutable and no changes will be made to the corresponding ResourceClaim by the control plane after creating the ResourceClaim.

---

### ClientIpConfig <a name="ClientIpConfig" id="cdk8s-plus-28.k8s.ClientIpConfig"></a>

ClientIPConfig represents the configurations of Client IP based session affinity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClientIpConfig.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const clientIpConfig: k8s.ClientIpConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClientIpConfig.property.timeoutSeconds">timeoutSeconds</a></code> | <code>number</code> | timeoutSeconds specifies the seconds of ClientIP type session sticky time. |

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.k8s.ClientIpConfig.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: number;
```

- *Type:* number

timeoutSeconds specifies the seconds of ClientIP type session sticky time.

The value must be >0 && <=86400(for 1 day) if ServiceAffinity == "ClientIP". Default value is 10800(for 3 hours).

---

### ClusterCidrSpecV1Alpha1 <a name="ClusterCidrSpecV1Alpha1" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1"></a>

ClusterCIDRSpec defines the desired state of ClusterCIDR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const clusterCidrSpecV1Alpha1: k8s.ClusterCidrSpecV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.perNodeHostBits">perNodeHostBits</a></code> | <code>number</code> | perNodeHostBits defines the number of host bits to be configured per node. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv4">ipv4</a></code> | <code>string</code> | ipv4 defines an IPv4 IP block in CIDR notation(e.g. "10.0.0.0/8"). At least one of ipv4 and ipv6 must be specified. This field is immutable. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv6">ipv6</a></code> | <code>string</code> | ipv6 defines an IPv6 IP block in CIDR notation(e.g. "2001:db8::/64"). At least one of ipv4 and ipv6 must be specified. This field is immutable. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.nodeSelector">nodeSelector</a></code> | <code>cdk8s-plus-28.k8s.NodeSelector</code> | nodeSelector defines which nodes the config is applicable to. |

---

##### `perNodeHostBits`<sup>Required</sup> <a name="perNodeHostBits" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.perNodeHostBits"></a>

```typescript
public readonly perNodeHostBits: number;
```

- *Type:* number

perNodeHostBits defines the number of host bits to be configured per node.

A subnet mask determines how much of the address is used for network bits and host bits. For example an IPv4 address of 192.168.0.0/24, splits the address into 24 bits for the network portion and 8 bits for the host portion. To allocate 256 IPs, set this field to 8 (a /24 mask for IPv4 or a /120 for IPv6). Minimum value is 4 (16 IPs). This field is immutable.

---

##### `ipv4`<sup>Optional</sup> <a name="ipv4" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv4"></a>

```typescript
public readonly ipv4: string;
```

- *Type:* string

ipv4 defines an IPv4 IP block in CIDR notation(e.g. "10.0.0.0/8"). At least one of ipv4 and ipv6 must be specified. This field is immutable.

---

##### `ipv6`<sup>Optional</sup> <a name="ipv6" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.ipv6"></a>

```typescript
public readonly ipv6: string;
```

- *Type:* string

ipv6 defines an IPv6 IP block in CIDR notation(e.g. "2001:db8::/64"). At least one of ipv4 and ipv6 must be specified. This field is immutable.

---

##### `nodeSelector`<sup>Optional</sup> <a name="nodeSelector" id="cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1.property.nodeSelector"></a>

```typescript
public readonly nodeSelector: NodeSelector;
```

- *Type:* cdk8s-plus-28.k8s.NodeSelector

nodeSelector defines which nodes the config is applicable to.

An empty or nil nodeSelector selects all nodes. This field is immutable.

---

### ClusterRoleBindingProps <a name="ClusterRoleBindingProps" id="cdk8s-plus-28.ClusterRoleBindingProps"></a>

Properties for `ClusterRoleBinding`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRoleBindingProps.Initializer"></a>

```typescript
import { ClusterRoleBindingProps } from 'cdk8s-plus-28'

const clusterRoleBindingProps: ClusterRoleBindingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRoleBindingProps.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a></code> | The role to bind to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleBindingProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.ClusterRoleBindingProps.property.role"></a>

```typescript
public readonly role: IClusterRole;
```

- *Type:* <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

The role to bind to.

---

### ClusterRolePolicyRule <a name="ClusterRolePolicyRule" id="cdk8s-plus-28.ClusterRolePolicyRule"></a>

Policy rule of a `ClusterRole.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRolePolicyRule.Initializer"></a>

```typescript
import { ClusterRolePolicyRule } from 'cdk8s-plus-28'

const clusterRolePolicyRule: ClusterRolePolicyRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule.property.endpoints">endpoints</a></code> | <code><a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>[]</code> | Endpoints this rule applies to. |
| <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule.property.verbs">verbs</a></code> | <code>string[]</code> | Verbs to allow. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.ClusterRolePolicyRule.property.endpoints"></a>

```typescript
public readonly endpoints: IApiEndpoint[];
```

- *Type:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>[]

Endpoints this rule applies to.

Can be either api resources
or non api resources.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.ClusterRolePolicyRule.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

Verbs to allow.

(e.g ['get', 'watch'])

---

### ClusterRoleProps <a name="ClusterRoleProps" id="cdk8s-plus-28.ClusterRoleProps"></a>

Properties for `ClusterRole`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ClusterRoleProps.Initializer"></a>

```typescript
import { ClusterRoleProps } from 'cdk8s-plus-28'

const clusterRoleProps: ClusterRoleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.aggregationLabels">aggregationLabels</a></code> | <code>{[ key: string ]: string}</code> | Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules. |
| <code><a href="#cdk8s-plus-28.ClusterRoleProps.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>[]</code> | A list of rules the role should allow. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ClusterRoleProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `aggregationLabels`<sup>Optional</sup> <a name="aggregationLabels" id="cdk8s-plus-28.ClusterRoleProps.property.aggregationLabels"></a>

```typescript
public readonly aggregationLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Specify labels that should be used to locate ClusterRoles, whose rules will be automatically filled into this ClusterRole's rules.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.ClusterRoleProps.property.rules"></a>

```typescript
public readonly rules: ClusterRolePolicyRule[];
```

- *Type:* <a href="#cdk8s-plus-28.ClusterRolePolicyRule">ClusterRolePolicyRule</a>[]
- *Default:* []

A list of rules the role should allow.

---

### ClusterTrustBundleSpecV1Alpha1 <a name="ClusterTrustBundleSpecV1Alpha1" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1"></a>

ClusterTrustBundleSpec contains the signer and trust anchors.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const clusterTrustBundleSpecV1Alpha1: k8s.ClusterTrustBundleSpecV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.trustBundle">trustBundle</a></code> | <code>string</code> | trustBundle contains the individual X.509 trust anchors for this bundle, as PEM bundle of PEM-wrapped, DER-formatted X.509 certificates. |
| <code><a href="#cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.signerName">signerName</a></code> | <code>string</code> | signerName indicates the associated signer, if any. |

---

##### `trustBundle`<sup>Required</sup> <a name="trustBundle" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.trustBundle"></a>

```typescript
public readonly trustBundle: string;
```

- *Type:* string

trustBundle contains the individual X.509 trust anchors for this bundle, as PEM bundle of PEM-wrapped, DER-formatted X.509 certificates.

The data must consist only of PEM certificate blocks that parse as valid X.509 certificates.  Each certificate must include a basic constraints extension with the CA bit set.  The API server will reject objects that contain duplicate certificates, or that use PEM block headers.

Users of ClusterTrustBundles, including Kubelet, are free to reorder and deduplicate certificate blocks in this file according to their own logic, as well as to drop PEM block headers and inter-block data.

---

##### `signerName`<sup>Optional</sup> <a name="signerName" id="cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1.property.signerName"></a>

```typescript
public readonly signerName: string;
```

- *Type:* string

signerName indicates the associated signer, if any.

In order to create or update a ClusterTrustBundle that sets signerName, you must have the following cluster-scoped permission: group=certificates.k8s.io resource=signers resourceName=<the signer name> verb=attest.

If signerName is not empty, then the ClusterTrustBundle object must be named with the signer name as a prefix (translating slashes to colons). For example, for the signer name `example.com/foo`, valid ClusterTrustBundle object names include `example.com:foo:abc` and `example.com:foo:v1`.

If signerName is empty, then the ClusterTrustBundle object's name must not have such a prefix.

List/watch requests for ClusterTrustBundles can filter on this field using a `spec.signerName=NAME` field selector.

---

### CommandProbeOptions <a name="CommandProbeOptions" id="cdk8s-plus-28.CommandProbeOptions"></a>

Options for `Probe.fromCommand()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CommandProbeOptions.Initializer"></a>

```typescript
import { CommandProbeOptions } from 'cdk8s-plus-28'

const commandProbeOptions: CommandProbeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.failureThreshold">failureThreshold</a></code> | <code>number</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.initialDelaySeconds">initialDelaySeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.periodSeconds">periodSeconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.successThreshold">successThreshold</a></code> | <code>number</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.CommandProbeOptions.property.timeoutSeconds">timeoutSeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |

---

##### `failureThreshold`<sup>Optional</sup> <a name="failureThreshold" id="cdk8s-plus-28.CommandProbeOptions.property.failureThreshold"></a>

```typescript
public readonly failureThreshold: number;
```

- *Type:* number
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initialDelaySeconds`<sup>Optional</sup> <a name="initialDelaySeconds" id="cdk8s-plus-28.CommandProbeOptions.property.initialDelaySeconds"></a>

```typescript
public readonly initialDelaySeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `periodSeconds`<sup>Optional</sup> <a name="periodSeconds" id="cdk8s-plus-28.CommandProbeOptions.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `successThreshold`<sup>Optional</sup> <a name="successThreshold" id="cdk8s-plus-28.CommandProbeOptions.property.successThreshold"></a>

```typescript
public readonly successThreshold: number;
```

- *Type:* number
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.CommandProbeOptions.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

### CommonSecretProps <a name="CommonSecretProps" id="cdk8s-plus-28.CommonSecretProps"></a>

Common properties for `Secret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CommonSecretProps.Initializer"></a>

```typescript
import { CommonSecretProps } from 'cdk8s-plus-28'

const commonSecretProps: CommonSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CommonSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.CommonSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.CommonSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.CommonSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

### ComponentCondition <a name="ComponentCondition" id="cdk8s-plus-28.k8s.ComponentCondition"></a>

Information about the condition of a component.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ComponentCondition.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const componentCondition: k8s.ComponentCondition = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.status">status</a></code> | <code>string</code> | Status of the condition for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.type">type</a></code> | <code>string</code> | Type of condition for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.error">error</a></code> | <code>string</code> | Condition error code for a component. |
| <code><a href="#cdk8s-plus-28.k8s.ComponentCondition.property.message">message</a></code> | <code>string</code> | Message about the condition for a component. |

---

##### `status`<sup>Required</sup> <a name="status" id="cdk8s-plus-28.k8s.ComponentCondition.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string

Status of the condition for a component.

Valid values for "Healthy": "True", "False", or "Unknown".

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.ComponentCondition.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Type of condition for a component.

Valid value: "Healthy"

---

##### `error`<sup>Optional</sup> <a name="error" id="cdk8s-plus-28.k8s.ComponentCondition.property.error"></a>

```typescript
public readonly error: string;
```

- *Type:* string

Condition error code for a component.

For example, a health check error code.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ComponentCondition.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

Message about the condition for a component.

For example, information about a health check.

---

### ConfigMapEnvSource <a name="ConfigMapEnvSource" id="cdk8s-plus-28.k8s.ConfigMapEnvSource"></a>

ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap's Data field will represent the key-value pairs as environment variables.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const configMapEnvSource: k8s.ConfigMapEnvSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapEnvSource.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapEnvSource.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the ConfigMap must be defined. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapEnvSource.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

Specify whether the ConfigMap must be defined.

---

### ConfigMapKeySelector <a name="ConfigMapKeySelector" id="cdk8s-plus-28.k8s.ConfigMapKeySelector"></a>

Selects a key from a ConfigMap.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const configMapKeySelector: k8s.ConfigMapKeySelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.key">key</a></code> | <code>string</code> | The key to select. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapKeySelector.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the ConfigMap or its key must be defined. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The key to select.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapKeySelector.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

Specify whether the ConfigMap or its key must be defined.

---

### ConfigMapNodeConfigSource <a name="ConfigMapNodeConfigSource" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource"></a>

ConfigMapNodeConfigSource contains the information to reference a ConfigMap as a config source for the Node.

This API is deprecated since 1.22: https://git.k8s.io/enhancements/keps/sig-node/281-dynamic-kubelet-configuration

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const configMapNodeConfigSource: k8s.ConfigMapNodeConfigSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.kubeletConfigKey">kubeletConfigKey</a></code> | <code>string</code> | KubeletConfigKey declares which key of the referenced ConfigMap corresponds to the KubeletConfiguration structure This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.name">name</a></code> | <code>string</code> | Name is the metadata.name of the referenced ConfigMap. This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.namespace">namespace</a></code> | <code>string</code> | Namespace is the metadata.namespace of the referenced ConfigMap. This field is required in all cases. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.resourceVersion">resourceVersion</a></code> | <code>string</code> | ResourceVersion is the metadata.ResourceVersion of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.uid">uid</a></code> | <code>string</code> | UID is the metadata.UID of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status. |

---

##### `kubeletConfigKey`<sup>Required</sup> <a name="kubeletConfigKey" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.kubeletConfigKey"></a>

```typescript
public readonly kubeletConfigKey: string;
```

- *Type:* string

KubeletConfigKey declares which key of the referenced ConfigMap corresponds to the KubeletConfiguration structure This field is required in all cases.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the metadata.name of the referenced ConfigMap. This field is required in all cases.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace is the metadata.namespace of the referenced ConfigMap. This field is required in all cases.

---

##### `resourceVersion`<sup>Optional</sup> <a name="resourceVersion" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.resourceVersion"></a>

```typescript
public readonly resourceVersion: string;
```

- *Type:* string

ResourceVersion is the metadata.ResourceVersion of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ConfigMapNodeConfigSource.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID is the metadata.UID of the referenced ConfigMap. This field is forbidden in Node.Spec, and required in Node.Status.

---

### ConfigMapProjection <a name="ConfigMapProjection" id="cdk8s-plus-28.k8s.ConfigMapProjection"></a>

Adapts a ConfigMap into a projected volume.

The contents of the target ConfigMap's Data field will be presented in a projected volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. Note that this is identical to a configmap volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapProjection.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const configMapProjection: k8s.ConfigMapProjection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KeyToPath[]</code> | items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapProjection.property.optional">optional</a></code> | <code>boolean</code> | optional specify whether the ConfigMap or its keys must be defined. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.items"></a>

```typescript
public readonly items: KeyToPath[];
```

- *Type:* cdk8s-plus-28.k8s.KeyToPath[]

items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapProjection.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

optional specify whether the ConfigMap or its keys must be defined.

---

### ConfigMapProps <a name="ConfigMapProps" id="cdk8s-plus-28.ConfigMapProps"></a>

Properties for initialization of `ConfigMap`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ConfigMapProps.Initializer"></a>

```typescript
import { ConfigMapProps } from 'cdk8s-plus-28'

const configMapProps: ConfigMapProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.binaryData">binaryData</a></code> | <code>{[ key: string ]: string}</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.data">data</a></code> | <code>{[ key: string ]: string}</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.ConfigMapProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ConfigMapProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `binaryData`<sup>Optional</sup> <a name="binaryData" id="cdk8s-plus-28.ConfigMapProps.property.binaryData"></a>

```typescript
public readonly binaryData: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'.
BinaryData can contain byte sequences that are not in the UTF-8 range. The
keys stored in BinaryData must not overlap with the ones in the Data field,
this is enforced during validation process.

You can also add binary data using `configMap.addBinaryData()`.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.ConfigMapProps.property.data"></a>

```typescript
public readonly data: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values
with non-UTF-8 byte sequences must use the BinaryData field. The keys
stored in Data must not overlap with the keys in the BinaryData field, this
is enforced during validation process.

You can also add data using `configMap.addData()`.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ConfigMapProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

### ConfigMapVolumeOptions <a name="ConfigMapVolumeOptions" id="cdk8s-plus-28.ConfigMapVolumeOptions"></a>

Options for the ConfigMap-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ConfigMapVolumeOptions.Initializer"></a>

```typescript
import { ConfigMapVolumeOptions } from 'cdk8s-plus-28'

const configMapVolumeOptions: ConfigMapVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.defaultMode">defaultMode</a></code> | <code>number</code> | Mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.items">items</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.PathMapping">PathMapping</a>}</code> | If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.ConfigMapVolumeOptions.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the ConfigMap or its keys must be defined. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.items"></a>

```typescript
public readonly items: {[ key: string ]: PathMapping};
```

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.PathMapping">PathMapping</a>}
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the ConfigMap, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.ConfigMapVolumeOptions.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean
- *Default:* undocumented

Specify whether the ConfigMap or its keys must be defined.

---

### ConfigMapVolumeSource <a name="ConfigMapVolumeSource" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource"></a>

Adapts a ConfigMap into a volume.

The contents of the target ConfigMap's Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const configMapVolumeSource: k8s.ConfigMapVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.defaultMode">defaultMode</a></code> | <code>number</code> | defaultMode is optional: mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KeyToPath[]</code> | items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.optional">optional</a></code> | <code>boolean</code> | optional specify whether the ConfigMap or its keys must be defined. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

defaultMode is optional: mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.items"></a>

```typescript
public readonly items: KeyToPath[];
```

- *Type:* cdk8s-plus-28.k8s.KeyToPath[]

items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.ConfigMapVolumeSource.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

optional specify whether the ConfigMap or its keys must be defined.

---

### Container <a name="Container" id="cdk8s-plus-28.k8s.Container"></a>

A single application container that you want to run within a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Container.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const container: k8s.Container = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.name">name</a></code> | <code>string</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.args">args</a></code> | <code>string[]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.command">command</a></code> | <code>string[]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.env">env</a></code> | <code>cdk8s-plus-28.k8s.EnvVar[]</code> | List of environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.envFrom">envFrom</a></code> | <code>cdk8s-plus-28.k8s.EnvFromSource[]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.image">image</a></code> | <code>string</code> | Container image name. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.imagePullPolicy">imagePullPolicy</a></code> | <code>string</code> | Image pull policy. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.lifecycle">lifecycle</a></code> | <code>cdk8s-plus-28.k8s.Lifecycle</code> | Actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.livenessProbe">livenessProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.ContainerPort[]</code> | List of ports to expose from the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.readinessProbe">readinessProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | Periodic probe of container service readiness. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.resizePolicy">resizePolicy</a></code> | <code>cdk8s-plus-28.k8s.ContainerResizePolicy[]</code> | Resources resize policy for the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.resources">resources</a></code> | <code>cdk8s-plus-28.k8s.ResourceRequirements</code> | Compute Resources required by this container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.restartPolicy">restartPolicy</a></code> | <code>string</code> | RestartPolicy defines the restart behavior of individual containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.securityContext">securityContext</a></code> | <code>cdk8s-plus-28.k8s.SecurityContext</code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.startupProbe">startupProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.stdin">stdin</a></code> | <code>boolean</code> | Whether this container should allocate a buffer for stdin in the container runtime. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.stdinOnce">stdinOnce</a></code> | <code>boolean</code> | Whether the container runtime should close the stdin channel after it has been opened by a single attach. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.terminationMessagePath">terminationMessagePath</a></code> | <code>string</code> | Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.terminationMessagePolicy">terminationMessagePolicy</a></code> | <code>string</code> | Indicate how the termination message should be populated. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.tty">tty</a></code> | <code>boolean</code> | Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.volumeDevices">volumeDevices</a></code> | <code>cdk8s-plus-28.k8s.VolumeDevice[]</code> | volumeDevices is the list of block devices to be used by the container. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.volumeMounts">volumeMounts</a></code> | <code>cdk8s-plus-28.k8s.VolumeMount[]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.Container.property.workingDir">workingDir</a></code> | <code>string</code> | Container's working directory. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Container.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.k8s.Container.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Arguments to the entrypoint.

The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.Container.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

Entrypoint array.

Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env`<sup>Optional</sup> <a name="env" id="cdk8s-plus-28.k8s.Container.property.env"></a>

```typescript
public readonly env: EnvVar[];
```

- *Type:* cdk8s-plus-28.k8s.EnvVar[]

List of environment variables to set in the container.

Cannot be updated.

---

##### `envFrom`<sup>Optional</sup> <a name="envFrom" id="cdk8s-plus-28.k8s.Container.property.envFrom"></a>

```typescript
public readonly envFrom: EnvFromSource[];
```

- *Type:* cdk8s-plus-28.k8s.EnvFromSource[]

List of sources to populate environment variables in the container.

The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

---

##### `image`<sup>Optional</sup> <a name="image" id="cdk8s-plus-28.k8s.Container.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

Container image name.

More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.

---

##### `imagePullPolicy`<sup>Optional</sup> <a name="imagePullPolicy" id="cdk8s-plus-28.k8s.Container.property.imagePullPolicy"></a>

```typescript
public readonly imagePullPolicy: string;
```

- *Type:* string
- *Default:* Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Image pull policy.

One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.k8s.Container.property.lifecycle"></a>

```typescript
public readonly lifecycle: Lifecycle;
```

- *Type:* cdk8s-plus-28.k8s.Lifecycle

Actions that the management system should take in response to container lifecycle events.

Cannot be updated.

---

##### `livenessProbe`<sup>Optional</sup> <a name="livenessProbe" id="cdk8s-plus-28.k8s.Container.property.livenessProbe"></a>

```typescript
public readonly livenessProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

Periodic probe of container liveness.

Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.Container.property.ports"></a>

```typescript
public readonly ports: ContainerPort[];
```

- *Type:* cdk8s-plus-28.k8s.ContainerPort[]

List of ports to expose from the container.

Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Modifying this array with strategic merge patch may corrupt the data. For more information See https://github.com/kubernetes/kubernetes/issues/108255. Cannot be updated.

---

##### `readinessProbe`<sup>Optional</sup> <a name="readinessProbe" id="cdk8s-plus-28.k8s.Container.property.readinessProbe"></a>

```typescript
public readonly readinessProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

Periodic probe of container service readiness.

Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `resizePolicy`<sup>Optional</sup> <a name="resizePolicy" id="cdk8s-plus-28.k8s.Container.property.resizePolicy"></a>

```typescript
public readonly resizePolicy: ContainerResizePolicy[];
```

- *Type:* cdk8s-plus-28.k8s.ContainerResizePolicy[]

Resources resize policy for the container.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.Container.property.resources"></a>

```typescript
public readonly resources: ResourceRequirements;
```

- *Type:* cdk8s-plus-28.k8s.ResourceRequirements

Compute Resources required by this container.

Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.k8s.Container.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: string;
```

- *Type:* string

RestartPolicy defines the restart behavior of individual containers in a pod.

This field may only be set for init containers, and the only allowed value is "Always". For non-init containers or when this field is not specified, the restart behavior is defined by the Pod's restart policy and the container type. Setting the RestartPolicy as "Always" for the init container will have the following effect: this init container will be continually restarted on exit until all regular containers have terminated. Once all regular containers have completed, all init containers with restartPolicy "Always" will be shut down. This lifecycle differs from normal init containers and is often referred to as a "sidecar" container. Although this init container still starts in the init container sequence, it does not wait for the container to complete before proceeding to the next init container. Instead, the next init container starts immediately after this init container is started, or after any startupProbe has successfully completed.

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.k8s.Container.property.securityContext"></a>

```typescript
public readonly securityContext: SecurityContext;
```

- *Type:* cdk8s-plus-28.k8s.SecurityContext

SecurityContext defines the security options the container should be run with.

If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/

---

##### `startupProbe`<sup>Optional</sup> <a name="startupProbe" id="cdk8s-plus-28.k8s.Container.property.startupProbe"></a>

```typescript
public readonly startupProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `stdin`<sup>Optional</sup> <a name="stdin" id="cdk8s-plus-28.k8s.Container.property.stdin"></a>

```typescript
public readonly stdin: boolean;
```

- *Type:* boolean
- *Default:* false.

Whether this container should allocate a buffer for stdin in the container runtime.

If this is not set, reads from stdin in the container will always result in EOF. Default is false.

---

##### `stdinOnce`<sup>Optional</sup> <a name="stdinOnce" id="cdk8s-plus-28.k8s.Container.property.stdinOnce"></a>

```typescript
public readonly stdinOnce: boolean;
```

- *Type:* boolean
- *Default:* false

Whether the container runtime should close the stdin channel after it has been opened by a single attach.

When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

---

##### `terminationMessagePath`<sup>Optional</sup> <a name="terminationMessagePath" id="cdk8s-plus-28.k8s.Container.property.terminationMessagePath"></a>

```typescript
public readonly terminationMessagePath: string;
```

- *Type:* string
- *Default:* dev/termination-log. Cannot be updated.

Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem.

Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

---

##### `terminationMessagePolicy`<sup>Optional</sup> <a name="terminationMessagePolicy" id="cdk8s-plus-28.k8s.Container.property.terminationMessagePolicy"></a>

```typescript
public readonly terminationMessagePolicy: string;
```

- *Type:* string
- *Default:* File. Cannot be updated.

Indicate how the termination message should be populated.

File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

---

##### `tty`<sup>Optional</sup> <a name="tty" id="cdk8s-plus-28.k8s.Container.property.tty"></a>

```typescript
public readonly tty: boolean;
```

- *Type:* boolean
- *Default:* false.

Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.

Default is false.

---

##### `volumeDevices`<sup>Optional</sup> <a name="volumeDevices" id="cdk8s-plus-28.k8s.Container.property.volumeDevices"></a>

```typescript
public readonly volumeDevices: VolumeDevice[];
```

- *Type:* cdk8s-plus-28.k8s.VolumeDevice[]

volumeDevices is the list of block devices to be used by the container.

---

##### `volumeMounts`<sup>Optional</sup> <a name="volumeMounts" id="cdk8s-plus-28.k8s.Container.property.volumeMounts"></a>

```typescript
public readonly volumeMounts: VolumeMount[];
```

- *Type:* cdk8s-plus-28.k8s.VolumeMount[]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `workingDir`<sup>Optional</sup> <a name="workingDir" id="cdk8s-plus-28.k8s.Container.property.workingDir"></a>

```typescript
public readonly workingDir: string;
```

- *Type:* string

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### ContainerLifecycle <a name="ContainerLifecycle" id="cdk8s-plus-28.ContainerLifecycle"></a>

Container lifecycle properties.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerLifecycle.Initializer"></a>

```typescript
import { ContainerLifecycle } from 'cdk8s-plus-28'

const containerLifecycle: ContainerLifecycle = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerLifecycle.property.postStart">postStart</a></code> | <code><a href="#cdk8s-plus-28.Handler">Handler</a></code> | This hook is executed immediately after a container is created. |
| <code><a href="#cdk8s-plus-28.ContainerLifecycle.property.preStop">preStop</a></code> | <code><a href="#cdk8s-plus-28.Handler">Handler</a></code> | This hook is called immediately before a container is terminated due to an API request or management event such as a liveness/startup probe failure, preemption, resource contention and others. |

---

##### `postStart`<sup>Optional</sup> <a name="postStart" id="cdk8s-plus-28.ContainerLifecycle.property.postStart"></a>

```typescript
public readonly postStart: Handler;
```

- *Type:* <a href="#cdk8s-plus-28.Handler">Handler</a>
- *Default:* No post start handler.

This hook is executed immediately after a container is created.

However,
there is no guarantee that the hook will execute before the container ENTRYPOINT.

---

##### `preStop`<sup>Optional</sup> <a name="preStop" id="cdk8s-plus-28.ContainerLifecycle.property.preStop"></a>

```typescript
public readonly preStop: Handler;
```

- *Type:* <a href="#cdk8s-plus-28.Handler">Handler</a>
- *Default:* No pre stop handler.

This hook is called immediately before a container is terminated due to an API request or management event such as a liveness/startup probe failure, preemption, resource contention and others.

A call to the PreStop hook fails if the container is already in a terminated or completed state
and the hook must complete before the TERM signal to stop the container can be sent.
The Pod's termination grace period countdown begins before the PreStop hook is executed,
so regardless of the outcome of the handler, the container will eventually terminate
within the Pod's termination grace period. No parameters are passed to the handler.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination)

---

### ContainerOpts <a name="ContainerOpts" id="cdk8s-plus-28.ContainerOpts"></a>

Optional properties of a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerOpts.Initializer"></a>

```typescript
import { ContainerOpts } from 'cdk8s-plus-28'

const containerOpts: ContainerOpts = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.args">args</a></code> | <code>string[]</code> | Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.command">command</a></code> | <code>string[]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.envFrom">envFrom</a></code> | <code><a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.envVariables">envVariables</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}</code> | Environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.imagePullPolicy">imagePullPolicy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.lifecycle">lifecycle</a></code> | <code><a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a></code> | Describes actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.liveness">liveness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.name">name</a></code> | <code>string</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.portNumber">portNumber</a></code> | <code>number</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]</code> | List of ports to expose from this container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.readiness">readiness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Determines when the container is ready to serve traffic. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.startup">startup</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.volumeMounts">volumeMounts</a></code> | <code><a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerOpts.property.workingDir">workingDir</a></code> | <code>string</code> | Container's working directory. |

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.ContainerOpts.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.ContainerOpts.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `envFrom`<sup>Optional</sup> <a name="envFrom" id="cdk8s-plus-28.ContainerOpts.property.envFrom"></a>

```typescript
public readonly envFrom: EnvFrom[];
```

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

##### `envVariables`<sup>Optional</sup> <a name="envVariables" id="cdk8s-plus-28.ContainerOpts.property.envVariables"></a>

```typescript
public readonly envVariables: {[ key: string ]: EnvValue};
```

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}
- *Default:* No environment variables.

Environment variables to set in the container.

---

##### `imagePullPolicy`<sup>Optional</sup> <a name="imagePullPolicy" id="cdk8s-plus-28.ContainerOpts.property.imagePullPolicy"></a>

```typescript
public readonly imagePullPolicy: ImagePullPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.ContainerOpts.property.lifecycle"></a>

```typescript
public readonly lifecycle: ContainerLifecycle;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

##### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.ContainerOpts.property.liveness"></a>

```typescript
public readonly liveness: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerOpts.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ContainerOpts.property.port"></a>

- *Deprecated:* - use `portNumber`.

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `portNumber`<sup>Optional</sup> <a name="portNumber" id="cdk8s-plus-28.ContainerOpts.property.portNumber"></a>

```typescript
public readonly portNumber: number;
```

- *Type:* number
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ContainerOpts.property.ports"></a>

```typescript
public readonly ports: ContainerPort[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

##### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.ContainerOpts.property.readiness"></a>

```typescript
public readonly readiness: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.ContainerOpts.property.resources"></a>

```typescript
public readonly resources: ContainerResources;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.ContainerOpts.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: ContainerRestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.ContainerOpts.property.securityContext"></a>

```typescript
public readonly securityContext: ContainerSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

##### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.ContainerOpts.property.startup"></a>

```typescript
public readonly startup: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

##### `volumeMounts`<sup>Optional</sup> <a name="volumeMounts" id="cdk8s-plus-28.ContainerOpts.property.volumeMounts"></a>

```typescript
public readonly volumeMounts: VolumeMount[];
```

- *Type:* <a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `workingDir`<sup>Optional</sup> <a name="workingDir" id="cdk8s-plus-28.ContainerOpts.property.workingDir"></a>

```typescript
public readonly workingDir: string;
```

- *Type:* string
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### ContainerPort <a name="ContainerPort" id="cdk8s-plus-28.ContainerPort"></a>

Represents a network port in a single container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerPort.Initializer"></a>

```typescript
import { ContainerPort } from 'cdk8s-plus-28'

const containerPort: ContainerPort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.number">number</a></code> | <code>number</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.hostIp">hostIp</a></code> | <code>string</code> | What host IP to bind the external port to. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.hostPort">hostPort</a></code> | <code>number</code> | Number of port to expose on the host. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.name">name</a></code> | <code>string</code> | If specified, this must be an IANA_SVC_NAME and unique within the pod. |
| <code><a href="#cdk8s-plus-28.ContainerPort.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | Protocol for port. |

---

##### `number`<sup>Required</sup> <a name="number" id="cdk8s-plus-28.ContainerPort.property.number"></a>

```typescript
public readonly number: number;
```

- *Type:* number

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

---

##### `hostIp`<sup>Optional</sup> <a name="hostIp" id="cdk8s-plus-28.ContainerPort.property.hostIp"></a>

```typescript
public readonly hostIp: string;
```

- *Type:* string
- *Default:* 127.0.0.1.

What host IP to bind the external port to.

---

##### `hostPort`<sup>Optional</sup> <a name="hostPort" id="cdk8s-plus-28.ContainerPort.property.hostPort"></a>

```typescript
public readonly hostPort: number;
```

- *Type:* number
- *Default:* auto generated by kubernetes and might change on restarts.

Number of port to expose on the host.

If specified, this must be a valid port number, 0 < x < 65536.
Most containers do not need this.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerPort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* port is not named.

If specified, this must be an IANA_SVC_NAME and unique within the pod.

Each named port in a pod must have a unique name.
Name for the port that can be referred to by services.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ContainerPort.property.protocol"></a>

```typescript
public readonly protocol: Protocol;
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

Protocol for port.

Must be UDP, TCP, or SCTP. Defaults to "TCP".

---

### ContainerPort <a name="ContainerPort" id="cdk8s-plus-28.k8s.ContainerPort"></a>

ContainerPort represents a network port in a single container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerPort.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const containerPort: k8s.ContainerPort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.containerPort">containerPort</a></code> | <code>number</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.hostIp">hostIp</a></code> | <code>string</code> | What host IP to bind the external port to. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.hostPort">hostPort</a></code> | <code>number</code> | Number of port to expose on the host. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.name">name</a></code> | <code>string</code> | If specified, this must be an IANA_SVC_NAME and unique within the pod. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerPort.property.protocol">protocol</a></code> | <code>string</code> | Protocol for port. |

---

##### `containerPort`<sup>Required</sup> <a name="containerPort" id="cdk8s-plus-28.k8s.ContainerPort.property.containerPort"></a>

```typescript
public readonly containerPort: number;
```

- *Type:* number

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

---

##### `hostIp`<sup>Optional</sup> <a name="hostIp" id="cdk8s-plus-28.k8s.ContainerPort.property.hostIp"></a>

```typescript
public readonly hostIp: string;
```

- *Type:* string

What host IP to bind the external port to.

---

##### `hostPort`<sup>Optional</sup> <a name="hostPort" id="cdk8s-plus-28.k8s.ContainerPort.property.hostPort"></a>

```typescript
public readonly hostPort: number;
```

- *Type:* number

Number of port to expose on the host.

If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ContainerPort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

If specified, this must be an IANA_SVC_NAME and unique within the pod.

Each named port in a pod must have a unique name. Name for the port that can be referred to by services.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.ContainerPort.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string
- *Default:* TCP".

Protocol for port.

Must be UDP, TCP, or SCTP. Defaults to "TCP".

---

### ContainerProps <a name="ContainerProps" id="cdk8s-plus-28.ContainerProps"></a>

Properties for creating a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerProps.Initializer"></a>

```typescript
import { ContainerProps } from 'cdk8s-plus-28'

const containerProps: ContainerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.args">args</a></code> | <code>string[]</code> | Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.command">command</a></code> | <code>string[]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.envFrom">envFrom</a></code> | <code><a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.envVariables">envVariables</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}</code> | Environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.imagePullPolicy">imagePullPolicy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.lifecycle">lifecycle</a></code> | <code><a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a></code> | Describes actions that the management system should take in response to container lifecycle events. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.liveness">liveness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Periodic probe of container liveness. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.name">name</a></code> | <code>string</code> | Name of the container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.portNumber">portNumber</a></code> | <code>number</code> | Number of port to expose on the pod's IP address. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]</code> | List of ports to expose from this container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.readiness">readiness</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | Determines when the container is ready to serve traffic. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | SecurityContext defines the security options the container should be run with. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.startup">startup</a></code> | <code><a href="#cdk8s-plus-28.Probe">Probe</a></code> | StartupProbe indicates that the Pod has successfully initialized. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.volumeMounts">volumeMounts</a></code> | <code><a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.workingDir">workingDir</a></code> | <code>string</code> | Container's working directory. |
| <code><a href="#cdk8s-plus-28.ContainerProps.property.image">image</a></code> | <code>string</code> | Docker image name. |

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.ContainerProps.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]
- *Default:* []

Arguments to the entrypoint. The docker image's CMD is used if `command` is not provided.

Variable references $(VAR_NAME) are expanded using the container's
environment. If a variable cannot be resolved, the reference in the input
string will be unchanged. The $(VAR_NAME) syntax can be escaped with a
double $$, ie: $$(VAR_NAME). Escaped references will never be expanded,
regardless of whether the variable exists or not.

Cannot be updated.

> [https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell](https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell)

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.ContainerProps.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]
- *Default:* The docker image's ENTRYPOINT.

Entrypoint array.

Not executed within a shell. The docker image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment.
If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME).
Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated.
More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `envFrom`<sup>Optional</sup> <a name="envFrom" id="cdk8s-plus-28.ContainerProps.property.envFrom"></a>

```typescript
public readonly envFrom: EnvFrom[];
```

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]
- *Default:* No sources.

List of sources to populate environment variables in the container.

When a key exists in multiple sources, the value associated with
the last source will take precedence. Values defined by the `envVariables` property
with a duplicate key will take precedence.

---

##### `envVariables`<sup>Optional</sup> <a name="envVariables" id="cdk8s-plus-28.ContainerProps.property.envVariables"></a>

```typescript
public readonly envVariables: {[ key: string ]: EnvValue};
```

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}
- *Default:* No environment variables.

Environment variables to set in the container.

---

##### `imagePullPolicy`<sup>Optional</sup> <a name="imagePullPolicy" id="cdk8s-plus-28.ContainerProps.property.imagePullPolicy"></a>

```typescript
public readonly imagePullPolicy: ImagePullPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>
- *Default:* ImagePullPolicy.ALWAYS

Image pull policy for this container.

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.ContainerProps.property.lifecycle"></a>

```typescript
public readonly lifecycle: ContainerLifecycle;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerLifecycle">ContainerLifecycle</a>

Describes actions that the management system should take in response to container lifecycle events.

---

##### `liveness`<sup>Optional</sup> <a name="liveness" id="cdk8s-plus-28.ContainerProps.property.liveness"></a>

```typescript
public readonly liveness: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no liveness probe is defined

Periodic probe of container liveness.

Container will be restarted if the probe fails.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ContainerProps.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* 'main'

Name of the container specified as a DNS_LABEL.

Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ContainerProps.property.port"></a>

- *Deprecated:* - use `portNumber`.

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `portNumber`<sup>Optional</sup> <a name="portNumber" id="cdk8s-plus-28.ContainerProps.property.portNumber"></a>

```typescript
public readonly portNumber: number;
```

- *Type:* number
- *Default:* Only the ports mentiond in the `ports` property are exposed.

Number of port to expose on the pod's IP address.

This must be a valid port number, 0 < x < 65536.

This is a convinience property if all you need a single TCP numbered port.
In case more advanced configuartion is required, use the `ports` property.

This port is added to the list of ports mentioned in the `ports` property.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ContainerProps.property.ports"></a>

```typescript
public readonly ports: ContainerPort[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]
- *Default:* Only the port mentioned in the `portNumber` property is exposed.

List of ports to expose from this container.

---

##### `readiness`<sup>Optional</sup> <a name="readiness" id="cdk8s-plus-28.ContainerProps.property.readiness"></a>

```typescript
public readonly readiness: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* no readiness probe is defined

Determines when the container is ready to serve traffic.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.ContainerProps.property.resources"></a>

```typescript
public readonly resources: ContainerResources;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>
- *Default:* cpu:      request: 1000 millis      limit: 1500 millis    memory:      request: 512 mebibytes      limit: 2048 mebibytes

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.ContainerProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: ContainerRestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>
- *Default:* no restart policy is defined and the pod restart policy is applied

Kubelet will start init containers with restartPolicy=Always in the order with other init containers, but instead of waiting for its completion, it will wait for the container startup completion Currently, only accepted value is Always.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.ContainerProps.property.securityContext"></a>

```typescript
public readonly securityContext: ContainerSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>
- *Default:* ensureNonRoot: true   privileged: false   readOnlyRootFilesystem: true   allowPrivilegeEscalation: false   user: 25000   group: 26000

SecurityContext defines the security options the container should be run with.

If set, the fields override equivalent fields of the pod's security context.

> [https://kubernetes.io/docs/tasks/configure-pod-container/security-context/](https://kubernetes.io/docs/tasks/configure-pod-container/security-context/)

---

##### `startup`<sup>Optional</sup> <a name="startup" id="cdk8s-plus-28.ContainerProps.property.startup"></a>

```typescript
public readonly startup: Probe;
```

- *Type:* <a href="#cdk8s-plus-28.Probe">Probe</a>
- *Default:* If a port is provided, then knocks on that port to determine when the container is ready for readiness and liveness probe checks. Otherwise, no startup probe is defined.

StartupProbe indicates that the Pod has successfully initialized.

If specified, no other probes are executed until this completes successfully

---

##### `volumeMounts`<sup>Optional</sup> <a name="volumeMounts" id="cdk8s-plus-28.ContainerProps.property.volumeMounts"></a>

```typescript
public readonly volumeMounts: VolumeMount[];
```

- *Type:* <a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]

Pod volumes to mount into the container's filesystem.

Cannot be updated.

---

##### `workingDir`<sup>Optional</sup> <a name="workingDir" id="cdk8s-plus-28.ContainerProps.property.workingDir"></a>

```typescript
public readonly workingDir: string;
```

- *Type:* string
- *Default:* The container runtime's default.

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.ContainerProps.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

Docker image name.

---

### ContainerResizePolicy <a name="ContainerResizePolicy" id="cdk8s-plus-28.k8s.ContainerResizePolicy"></a>

ContainerResizePolicy represents resource resize policy for the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerResizePolicy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const containerResizePolicy: k8s.ContainerResizePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResizePolicy.property.resourceName">resourceName</a></code> | <code>string</code> | Name of the resource to which this resource resize policy applies. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResizePolicy.property.restartPolicy">restartPolicy</a></code> | <code>string</code> | Restart policy to apply when specified resource is resized. |

---

##### `resourceName`<sup>Required</sup> <a name="resourceName" id="cdk8s-plus-28.k8s.ContainerResizePolicy.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

Name of the resource to which this resource resize policy applies.

Supported values: cpu, memory.

---

##### `restartPolicy`<sup>Required</sup> <a name="restartPolicy" id="cdk8s-plus-28.k8s.ContainerResizePolicy.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: string;
```

- *Type:* string

Restart policy to apply when specified resource is resized.

If not specified, it defaults to NotRequired.

---

### ContainerResourceMetricSourceV2 <a name="ContainerResourceMetricSourceV2" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2"></a>

ContainerResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.  Only one "target" type should be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const containerResourceMetricSourceV2: k8s.ContainerResourceMetricSourceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.container">container</a></code> | <code>string</code> | container is the name of the container in the pods of the scaling target. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.name">name</a></code> | <code>string</code> | name is the name of the resource in question. |
| <code><a href="#cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.container"></a>

```typescript
public readonly container: string;
```

- *Type:* string

container is the name of the container in the pods of the scaling target.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the resource in question.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2.property.target"></a>

```typescript
public readonly target: MetricTargetV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ContainerResources <a name="ContainerResources" id="cdk8s-plus-28.ContainerResources"></a>

CPU and memory compute resources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerResources.Initializer"></a>

```typescript
import { ContainerResources } from 'cdk8s-plus-28'

const containerResources: ContainerResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.cpu">cpu</a></code> | <code><a href="#cdk8s-plus-28.CpuResources">CpuResources</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.ephemeralStorage">ephemeralStorage</a></code> | <code><a href="#cdk8s-plus-28.EphemeralStorageResources">EphemeralStorageResources</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerResources.property.memory">memory</a></code> | <code><a href="#cdk8s-plus-28.MemoryResources">MemoryResources</a></code> | *No description.* |

---

##### `cpu`<sup>Optional</sup> <a name="cpu" id="cdk8s-plus-28.ContainerResources.property.cpu"></a>

```typescript
public readonly cpu: CpuResources;
```

- *Type:* <a href="#cdk8s-plus-28.CpuResources">CpuResources</a>

---

##### `ephemeralStorage`<sup>Optional</sup> <a name="ephemeralStorage" id="cdk8s-plus-28.ContainerResources.property.ephemeralStorage"></a>

```typescript
public readonly ephemeralStorage: EphemeralStorageResources;
```

- *Type:* <a href="#cdk8s-plus-28.EphemeralStorageResources">EphemeralStorageResources</a>

---

##### `memory`<sup>Optional</sup> <a name="memory" id="cdk8s-plus-28.ContainerResources.property.memory"></a>

```typescript
public readonly memory: MemoryResources;
```

- *Type:* <a href="#cdk8s-plus-28.MemoryResources">MemoryResources</a>

---

### ContainerSecurityContextProps <a name="ContainerSecurityContextProps" id="cdk8s-plus-28.ContainerSecurityContextProps"></a>

Properties for `ContainerSecurityContext`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerSecurityContextProps.Initializer"></a>

```typescript
import { ContainerSecurityContextProps } from 'cdk8s-plus-28'

const containerSecurityContextProps: ContainerSecurityContextProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.allowPrivilegeEscalation">allowPrivilegeEscalation</a></code> | <code>boolean</code> | Whether a process can gain more privileges than its parent process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.capabilities">capabilities</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a></code> | POSIX capabilities for running containers. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.ensureNonRoot">ensureNonRoot</a></code> | <code>boolean</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.group">group</a></code> | <code>number</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.privileged">privileged</a></code> | <code>boolean</code> | Run container in privileged mode. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.readOnlyRootFilesystem">readOnlyRootFilesystem</a></code> | <code>boolean</code> | Whether this container has a read-only root filesystem. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.seccompProfile">seccompProfile</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a></code> | Container's seccomp profile settings. |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps.property.user">user</a></code> | <code>number</code> | The UID to run the entrypoint of the container process. |

---

##### `allowPrivilegeEscalation`<sup>Optional</sup> <a name="allowPrivilegeEscalation" id="cdk8s-plus-28.ContainerSecurityContextProps.property.allowPrivilegeEscalation"></a>

```typescript
public readonly allowPrivilegeEscalation: boolean;
```

- *Type:* boolean
- *Default:* false

Whether a process can gain more privileges than its parent process.

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.ContainerSecurityContextProps.property.capabilities"></a>

```typescript
public readonly capabilities: ContainerSecutiryContextCapabilities;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a>
- *Default:* none

POSIX capabilities for running containers.

---

##### `ensureNonRoot`<sup>Optional</sup> <a name="ensureNonRoot" id="cdk8s-plus-28.ContainerSecurityContextProps.property.ensureNonRoot"></a>

```typescript
public readonly ensureNonRoot: boolean;
```

- *Type:* boolean
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.ContainerSecurityContextProps.property.group"></a>

```typescript
public readonly group: number;
```

- *Type:* number
- *Default:* 26000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The GID to run the entrypoint of the container process.

---

##### `privileged`<sup>Optional</sup> <a name="privileged" id="cdk8s-plus-28.ContainerSecurityContextProps.property.privileged"></a>

```typescript
public readonly privileged: boolean;
```

- *Type:* boolean
- *Default:* false

Run container in privileged mode.

Processes in privileged containers are essentially equivalent to root on the host.

---

##### `readOnlyRootFilesystem`<sup>Optional</sup> <a name="readOnlyRootFilesystem" id="cdk8s-plus-28.ContainerSecurityContextProps.property.readOnlyRootFilesystem"></a>

```typescript
public readonly readOnlyRootFilesystem: boolean;
```

- *Type:* boolean
- *Default:* true

Whether this container has a read-only root filesystem.

---

##### `seccompProfile`<sup>Optional</sup> <a name="seccompProfile" id="cdk8s-plus-28.ContainerSecurityContextProps.property.seccompProfile"></a>

```typescript
public readonly seccompProfile: SeccompProfile;
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a>
- *Default:* none

Container's seccomp profile settings.

Only one profile source may be set

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.ContainerSecurityContextProps.property.user"></a>

```typescript
public readonly user: number;
```

- *Type:* number
- *Default:* 25000. An arbitrary number bigger than 9999 is selected here. This is so that the container is blocked to access host files even if somehow it manages to get access to host file system.

The UID to run the entrypoint of the container process.

---

### ContainerSecutiryContextCapabilities <a name="ContainerSecutiryContextCapabilities" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.Initializer"></a>

```typescript
import { ContainerSecutiryContextCapabilities } from 'cdk8s-plus-28'

const containerSecutiryContextCapabilities: ContainerSecutiryContextCapabilities = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.add">add</a></code> | <code><a href="#cdk8s-plus-28.Capability">Capability</a>[]</code> | Added capabilities. |
| <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.drop">drop</a></code> | <code><a href="#cdk8s-plus-28.Capability">Capability</a>[]</code> | Removed capabilities. |

---

##### `add`<sup>Optional</sup> <a name="add" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.add"></a>

```typescript
public readonly add: Capability[];
```

- *Type:* <a href="#cdk8s-plus-28.Capability">Capability</a>[]

Added capabilities.

---

##### `drop`<sup>Optional</sup> <a name="drop" id="cdk8s-plus-28.ContainerSecutiryContextCapabilities.property.drop"></a>

```typescript
public readonly drop: Capability[];
```

- *Type:* <a href="#cdk8s-plus-28.Capability">Capability</a>[]

Removed capabilities.

---

### CpuResources <a name="CpuResources" id="cdk8s-plus-28.CpuResources"></a>

CPU request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CpuResources.Initializer"></a>

```typescript
import { CpuResources } from 'cdk8s-plus-28'

const cpuResources: CpuResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CpuResources.property.limit">limit</a></code> | <code><a href="#cdk8s-plus-28.Cpu">Cpu</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.CpuResources.property.request">request</a></code> | <code><a href="#cdk8s-plus-28.Cpu">Cpu</a></code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.CpuResources.property.limit"></a>

```typescript
public readonly limit: Cpu;
```

- *Type:* <a href="#cdk8s-plus-28.Cpu">Cpu</a>

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.CpuResources.property.request"></a>

```typescript
public readonly request: Cpu;
```

- *Type:* <a href="#cdk8s-plus-28.Cpu">Cpu</a>

---

### CronJobProps <a name="CronJobProps" id="cdk8s-plus-28.CronJobProps"></a>

Properties for `CronJob`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CronJobProps.Initializer"></a>

```typescript
import { CronJobProps } from 'cdk8s-plus-28'

const cronJobProps: CronJobProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.activeDeadline">activeDeadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.backoffLimit">backoffLimit</a></code> | <code>number</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.ttlAfterFinished">ttlAfterFinished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.schedule">schedule</a></code> | <code>cdk8s.Cron</code> | Specifies the time in which the job would run again. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.concurrencyPolicy">concurrencyPolicy</a></code> | <code><a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a></code> | Specifies the concurrency policy for the job. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.failedJobsRetained">failedJobsRetained</a></code> | <code>number</code> | Specifies the number of failed jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.startingDeadline">startingDeadline</a></code> | <code>cdk8s.Duration</code> | Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.successfulJobsRetained">successfulJobsRetained</a></code> | <code>number</code> | Specifies the number of successful jobs history retained. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.suspend">suspend</a></code> | <code>boolean</code> | Specifies if the cron job should be suspended. |
| <code><a href="#cdk8s-plus-28.CronJobProps.property.timeZone">timeZone</a></code> | <code>string</code> | Specifies the timezone for the job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.CronJobProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.CronJobProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.CronJobProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.CronJobProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.CronJobProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.CronJobProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.CronJobProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.CronJobProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.CronJobProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.CronJobProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.CronJobProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.CronJobProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.CronJobProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.CronJobProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.CronJobProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.CronJobProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.CronJobProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `activeDeadline`<sup>Optional</sup> <a name="activeDeadline" id="cdk8s-plus-28.CronJobProps.property.activeDeadline"></a>

```typescript
public readonly activeDeadline: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoffLimit`<sup>Optional</sup> <a name="backoffLimit" id="cdk8s-plus-28.CronJobProps.property.backoffLimit"></a>

```typescript
public readonly backoffLimit: number;
```

- *Type:* number
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttlAfterFinished`<sup>Optional</sup> <a name="ttlAfterFinished" id="cdk8s-plus-28.CronJobProps.property.ttlAfterFinished"></a>

```typescript
public readonly ttlAfterFinished: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.CronJobProps.property.schedule"></a>

```typescript
public readonly schedule: Cron;
```

- *Type:* cdk8s.Cron

Specifies the time in which the job would run again.

This is defined as a cron expression in the CronJob resource.

---

##### `concurrencyPolicy`<sup>Optional</sup> <a name="concurrencyPolicy" id="cdk8s-plus-28.CronJobProps.property.concurrencyPolicy"></a>

```typescript
public readonly concurrencyPolicy: ConcurrencyPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ConcurrencyPolicy">ConcurrencyPolicy</a>
- *Default:* ConcurrencyPolicy.Forbid

Specifies the concurrency policy for the job.

---

##### `failedJobsRetained`<sup>Optional</sup> <a name="failedJobsRetained" id="cdk8s-plus-28.CronJobProps.property.failedJobsRetained"></a>

```typescript
public readonly failedJobsRetained: number;
```

- *Type:* number
- *Default:* 1

Specifies the number of failed jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `startingDeadline`<sup>Optional</sup> <a name="startingDeadline" id="cdk8s-plus-28.CronJobProps.property.startingDeadline"></a>

```typescript
public readonly startingDeadline: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10)

Kubernetes attempts to start cron jobs at its schedule time, but this is not guaranteed.

This deadline specifies
how much time can pass after a schedule point, for which kubernetes can still start the job.
For example, if this is set to 100 seconds, kubernetes is allowed to start the job at a maximum 100 seconds after
the scheduled time.

Note that the Kubernetes CronJobController checks for things every 10 seconds, for this reason, a deadline below 10
seconds is not allowed, as it may cause your job to never be scheduled.

In addition, kubernetes will stop scheduling jobs if more than 100 schedules were missed (for any reason).
This property also controls what time interval should kubernetes consider when counting for missed schedules.

For example, suppose a CronJob is set to schedule a new Job every one minute beginning at 08:30:00,
and its `startingDeadline` field is not set. If the CronJob controller happens to be down from 08:29:00 to 10:21:00,
the job will not start as the number of missed jobs which missed their schedule is greater than 100.
However, if `startingDeadline` is set to 200 seconds, kubernetes will only count 3 missed schedules, and thus
start a new execution at 10:22:00.

---

##### `successfulJobsRetained`<sup>Optional</sup> <a name="successfulJobsRetained" id="cdk8s-plus-28.CronJobProps.property.successfulJobsRetained"></a>

```typescript
public readonly successfulJobsRetained: number;
```

- *Type:* number
- *Default:* 3

Specifies the number of successful jobs history retained.

This would retain the Job and the associated Pod resource and can be useful for debugging.

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.CronJobProps.property.suspend"></a>

```typescript
public readonly suspend: boolean;
```

- *Type:* boolean
- *Default:* false

Specifies if the cron job should be suspended.

Only applies to future executions, current ones are remained untouched.

---

##### `timeZone`<sup>Optional</sup> <a name="timeZone" id="cdk8s-plus-28.CronJobProps.property.timeZone"></a>

```typescript
public readonly timeZone: string;
```

- *Type:* string
- *Default:* Timezone of kube-controller-manager process.

Specifies the timezone for the job.

This helps aligining the schedule to follow the specified timezone.

> [{@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.]({@link https://en.wikipedia.org/wiki/List_of_tz_database_time_zones} for list of valid timezone values.)

---

### CronJobSpec <a name="CronJobSpec" id="cdk8s-plus-28.k8s.CronJobSpec"></a>

CronJobSpec describes how the job execution will look like and when it will actually run.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CronJobSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const cronJobSpec: k8s.CronJobSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.jobTemplate">jobTemplate</a></code> | <code>cdk8s-plus-28.k8s.JobTemplateSpec</code> | Specifies the job that will be created when executing a CronJob. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.schedule">schedule</a></code> | <code>string</code> | The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.concurrencyPolicy">concurrencyPolicy</a></code> | <code>string</code> | Specifies how to treat concurrent executions of a Job. Valid values are:. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.failedJobsHistoryLimit">failedJobsHistoryLimit</a></code> | <code>number</code> | The number of failed finished jobs to retain. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.startingDeadlineSeconds">startingDeadlineSeconds</a></code> | <code>number</code> | Optional deadline in seconds for starting the job if it misses scheduled time for any reason. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.successfulJobsHistoryLimit">successfulJobsHistoryLimit</a></code> | <code>number</code> | The number of successful finished jobs to retain. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.suspend">suspend</a></code> | <code>boolean</code> | This flag tells the controller to suspend subsequent executions, it does not apply to already started executions. |
| <code><a href="#cdk8s-plus-28.k8s.CronJobSpec.property.timeZone">timeZone</a></code> | <code>string</code> | The time zone name for the given schedule, see https://en.wikipedia.org/wiki/List_of_tz_database_time_zones. If not specified, this will default to the time zone of the kube-controller-manager process. The set of valid time zone names and the time zone offset is loaded from the system-wide time zone database by the API server during CronJob validation and the controller manager during execution. If no system-wide time zone database can be found a bundled version of the database is used instead. If the time zone name becomes invalid during the lifetime of a CronJob or due to a change in host configuration, the controller will stop creating new new Jobs and will create a system event with the reason UnknownTimeZone. More information can be found in https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/#time-zones. |

---

##### `jobTemplate`<sup>Required</sup> <a name="jobTemplate" id="cdk8s-plus-28.k8s.CronJobSpec.property.jobTemplate"></a>

```typescript
public readonly jobTemplate: JobTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.JobTemplateSpec

Specifies the job that will be created when executing a CronJob.

---

##### `schedule`<sup>Required</sup> <a name="schedule" id="cdk8s-plus-28.k8s.CronJobSpec.property.schedule"></a>

```typescript
public readonly schedule: string;
```

- *Type:* string

The schedule in Cron format, see https://en.wikipedia.org/wiki/Cron.

---

##### `concurrencyPolicy`<sup>Optional</sup> <a name="concurrencyPolicy" id="cdk8s-plus-28.k8s.CronJobSpec.property.concurrencyPolicy"></a>

```typescript
public readonly concurrencyPolicy: string;
```

- *Type:* string

Specifies how to treat concurrent executions of a Job. Valid values are:.

"Allow" (default): allows CronJobs to run concurrently; - "Forbid": forbids concurrent runs, skipping next run if previous run hasn't finished yet; - "Replace": cancels currently running job and replaces it with a new one

---

##### `failedJobsHistoryLimit`<sup>Optional</sup> <a name="failedJobsHistoryLimit" id="cdk8s-plus-28.k8s.CronJobSpec.property.failedJobsHistoryLimit"></a>

```typescript
public readonly failedJobsHistoryLimit: number;
```

- *Type:* number
- *Default:* 1.

The number of failed finished jobs to retain.

Value must be non-negative integer. Defaults to 1.

---

##### `startingDeadlineSeconds`<sup>Optional</sup> <a name="startingDeadlineSeconds" id="cdk8s-plus-28.k8s.CronJobSpec.property.startingDeadlineSeconds"></a>

```typescript
public readonly startingDeadlineSeconds: number;
```

- *Type:* number

Optional deadline in seconds for starting the job if it misses scheduled time for any reason.

Missed jobs executions will be counted as failed ones.

---

##### `successfulJobsHistoryLimit`<sup>Optional</sup> <a name="successfulJobsHistoryLimit" id="cdk8s-plus-28.k8s.CronJobSpec.property.successfulJobsHistoryLimit"></a>

```typescript
public readonly successfulJobsHistoryLimit: number;
```

- *Type:* number
- *Default:* 3.

The number of successful finished jobs to retain.

Value must be non-negative integer. Defaults to 3.

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.k8s.CronJobSpec.property.suspend"></a>

```typescript
public readonly suspend: boolean;
```

- *Type:* boolean
- *Default:* false.

This flag tells the controller to suspend subsequent executions, it does not apply to already started executions.

Defaults to false.

---

##### `timeZone`<sup>Optional</sup> <a name="timeZone" id="cdk8s-plus-28.k8s.CronJobSpec.property.timeZone"></a>

```typescript
public readonly timeZone: string;
```

- *Type:* string

The time zone name for the given schedule, see https://en.wikipedia.org/wiki/List_of_tz_database_time_zones. If not specified, this will default to the time zone of the kube-controller-manager process. The set of valid time zone names and the time zone offset is loaded from the system-wide time zone database by the API server during CronJob validation and the controller manager during execution. If no system-wide time zone database can be found a bundled version of the database is used instead. If the time zone name becomes invalid during the lifetime of a CronJob or due to a change in host configuration, the controller will stop creating new new Jobs and will create a system event with the reason UnknownTimeZone. More information can be found in https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/#time-zones.

---

### CrossVersionObjectReference <a name="CrossVersionObjectReference" id="cdk8s-plus-28.k8s.CrossVersionObjectReference"></a>

CrossVersionObjectReference contains enough information to let you identify the referred resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const crossVersionObjectReference: k8s.CrossVersionObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.kind">kind</a></code> | <code>string</code> | kind is the kind of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.name">name</a></code> | <code>string</code> | name is the name of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReference.property.apiVersion">apiVersion</a></code> | <code>string</code> | apiVersion is the API version of the referent. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

kind is the kind of the referent;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the referent;

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.CrossVersionObjectReference.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

apiVersion is the API version of the referent.

---

### CrossVersionObjectReferenceV2 <a name="CrossVersionObjectReferenceV2" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2"></a>

CrossVersionObjectReference contains enough information to let you identify the referred resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const crossVersionObjectReferenceV2: k8s.CrossVersionObjectReferenceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.kind">kind</a></code> | <code>string</code> | kind is the kind of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.name">name</a></code> | <code>string</code> | name is the name of the referent; |
| <code><a href="#cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.apiVersion">apiVersion</a></code> | <code>string</code> | apiVersion is the API version of the referent. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

kind is the kind of the referent;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the referent;

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

apiVersion is the API version of the referent.

---

### CsiDriverSpec <a name="CsiDriverSpec" id="cdk8s-plus-28.k8s.CsiDriverSpec"></a>

CSIDriverSpec is the specification of a CSIDriver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiDriverSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const csiDriverSpec: k8s.CsiDriverSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.attachRequired">attachRequired</a></code> | <code>boolean</code> | attachRequired indicates this CSI volume driver requires an attach operation (because it implements the CSI ControllerPublishVolume() method), and that the Kubernetes attach detach controller should call the attach volume interface which checks the volumeattachment status and waits until the volume is attached before proceeding to mounting. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.fsGroupPolicy">fsGroupPolicy</a></code> | <code>string</code> | fsGroupPolicy defines if the underlying volume supports changing ownership and permission of the volume before being mounted. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.podInfoOnMount">podInfoOnMount</a></code> | <code>boolean</code> | podInfoOnMount indicates this CSI volume driver requires additional pod information (like podName, podUID, etc.) during mount operations, if set to true. If set to false, pod information will not be passed on mount. Default is false. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.requiresRepublish">requiresRepublish</a></code> | <code>boolean</code> | requiresRepublish indicates the CSI driver wants `NodePublishVolume` being periodically called to reflect any possible change in the mounted volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.seLinuxMount">seLinuxMount</a></code> | <code>boolean</code> | seLinuxMount specifies if the CSI driver supports "-o context" mount option. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.storageCapacity">storageCapacity</a></code> | <code>boolean</code> | storageCapacity indicates that the CSI volume driver wants pod scheduling to consider the storage capacity that the driver deployment will report by creating CSIStorageCapacity objects with capacity information, if set to true. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.tokenRequests">tokenRequests</a></code> | <code>cdk8s-plus-28.k8s.TokenRequest[]</code> | tokenRequests indicates the CSI driver needs pods' service account tokens it is mounting volume for to do necessary authentication. |
| <code><a href="#cdk8s-plus-28.k8s.CsiDriverSpec.property.volumeLifecycleModes">volumeLifecycleModes</a></code> | <code>string[]</code> | volumeLifecycleModes defines what kind of volumes this CSI volume driver supports. |

---

##### `attachRequired`<sup>Optional</sup> <a name="attachRequired" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.attachRequired"></a>

```typescript
public readonly attachRequired: boolean;
```

- *Type:* boolean

attachRequired indicates this CSI volume driver requires an attach operation (because it implements the CSI ControllerPublishVolume() method), and that the Kubernetes attach detach controller should call the attach volume interface which checks the volumeattachment status and waits until the volume is attached before proceeding to mounting.

The CSI external-attacher coordinates with CSI volume driver and updates the volumeattachment status when the attach operation is complete. If the CSIDriverRegistry feature gate is enabled and the value is specified to false, the attach operation will be skipped. Otherwise the attach operation will be called.

This field is immutable.

---

##### `fsGroupPolicy`<sup>Optional</sup> <a name="fsGroupPolicy" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.fsGroupPolicy"></a>

```typescript
public readonly fsGroupPolicy: string;
```

- *Type:* string
- *Default:* ReadWriteOnceWithFSType, which will examine each volume to determine if Kubernetes should modify ownership and permissions of the volume. With the default policy the defined fsGroup will only be applied if a fstype is defined and the volume's access mode contains ReadWriteOnce.

fsGroupPolicy defines if the underlying volume supports changing ownership and permission of the volume before being mounted.

Refer to the specific FSGroupPolicy values for additional details.

This field is immutable.

Defaults to ReadWriteOnceWithFSType, which will examine each volume to determine if Kubernetes should modify ownership and permissions of the volume. With the default policy the defined fsGroup will only be applied if a fstype is defined and the volume's access mode contains ReadWriteOnce.

---

##### `podInfoOnMount`<sup>Optional</sup> <a name="podInfoOnMount" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.podInfoOnMount"></a>

```typescript
public readonly podInfoOnMount: boolean;
```

- *Type:* boolean
- *Default:* false.

podInfoOnMount indicates this CSI volume driver requires additional pod information (like podName, podUID, etc.) during mount operations, if set to true. If set to false, pod information will not be passed on mount. Default is false.

The CSI driver specifies podInfoOnMount as part of driver deployment. If true, Kubelet will pass pod information as VolumeContext in the CSI NodePublishVolume() calls. The CSI driver is responsible for parsing and validating the information passed in as VolumeContext.

The following VolumeConext will be passed if podInfoOnMount is set to true. This list might grow, but the prefix will be used. "csi.storage.k8s.io/pod.name": pod.Name "csi.storage.k8s.io/pod.namespace": pod.Namespace "csi.storage.k8s.io/pod.uid": string(pod.UID) "csi.storage.k8s.io/ephemeral": "true" if the volume is an ephemeral inline volume
defined by a CSIVolumeSource, otherwise "false"

"csi.storage.k8s.io/ephemeral" is a new feature in Kubernetes 1.16. It is only required for drivers which support both the "Persistent" and "Ephemeral" VolumeLifecycleMode. Other drivers can leave pod info disabled and/or ignore this field. As Kubernetes 1.15 doesn't support this field, drivers can only support one mode when deployed on such a cluster and the deployment determines which mode that is, for example via a command line parameter of the driver.

This field is immutable.

---

##### `requiresRepublish`<sup>Optional</sup> <a name="requiresRepublish" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.requiresRepublish"></a>

```typescript
public readonly requiresRepublish: boolean;
```

- *Type:* boolean

requiresRepublish indicates the CSI driver wants `NodePublishVolume` being periodically called to reflect any possible change in the mounted volume.

This field defaults to false.

Note: After a successful initial NodePublishVolume call, subsequent calls to NodePublishVolume should only update the contents of the volume. New mount points will not be seen by a running container.

---

##### `seLinuxMount`<sup>Optional</sup> <a name="seLinuxMount" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.seLinuxMount"></a>

```typescript
public readonly seLinuxMount: boolean;
```

- *Type:* boolean
- *Default:* false".

seLinuxMount specifies if the CSI driver supports "-o context" mount option.

When "true", the CSI driver must ensure that all volumes provided by this CSI driver can be mounted separately with different `-o context` options. This is typical for storage backends that provide volumes as filesystems on block devices or as independent shared volumes. Kubernetes will call NodeStage / NodePublish with "-o context=xyz" mount option when mounting a ReadWriteOncePod volume used in Pod that has explicitly set SELinux context. In the future, it may be expanded to other volume AccessModes. In any case, Kubernetes will ensure that the volume is mounted only with a single SELinux context.

When "false", Kubernetes won't pass any special SELinux mount options to the driver. This is typical for volumes that represent subdirectories of a bigger shared filesystem.

Default is "false".

---

##### `storageCapacity`<sup>Optional</sup> <a name="storageCapacity" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.storageCapacity"></a>

```typescript
public readonly storageCapacity: boolean;
```

- *Type:* boolean

storageCapacity indicates that the CSI volume driver wants pod scheduling to consider the storage capacity that the driver deployment will report by creating CSIStorageCapacity objects with capacity information, if set to true.

The check can be enabled immediately when deploying a driver. In that case, provisioning new volumes with late binding will pause until the driver deployment has published some suitable CSIStorageCapacity object.

Alternatively, the driver can be deployed with the field unset or false and it can be flipped later when storage capacity information has been published.

This field was immutable in Kubernetes <= 1.22 and now is mutable.

---

##### `tokenRequests`<sup>Optional</sup> <a name="tokenRequests" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.tokenRequests"></a>

```typescript
public readonly tokenRequests: TokenRequest[];
```

- *Type:* cdk8s-plus-28.k8s.TokenRequest[]

tokenRequests indicates the CSI driver needs pods' service account tokens it is mounting volume for to do necessary authentication.

Kubelet will pass the tokens in VolumeContext in the CSI NodePublishVolume calls. The CSI driver should parse and validate the following VolumeContext: "csi.storage.k8s.io/serviceAccount.tokens": {
"<audience>": {
"token": <token>,
"expirationTimestamp": <expiration timestamp in RFC3339>,
},
...
}

Note: Audience in each TokenRequest should be different and at most one token is empty string. To receive a new token after expiry, RequiresRepublish can be used to trigger NodePublishVolume periodically.

---

##### `volumeLifecycleModes`<sup>Optional</sup> <a name="volumeLifecycleModes" id="cdk8s-plus-28.k8s.CsiDriverSpec.property.volumeLifecycleModes"></a>

```typescript
public readonly volumeLifecycleModes: string[];
```

- *Type:* string[]

volumeLifecycleModes defines what kind of volumes this CSI volume driver supports.

The default if the list is empty is "Persistent", which is the usage defined by the CSI specification and implemented in Kubernetes via the usual PV/PVC mechanism.

The other mode is "Ephemeral". In this mode, volumes are defined inline inside the pod spec with CSIVolumeSource and their lifecycle is tied to the lifecycle of that pod. A driver has to be aware of this because it is only going to get a NodePublishVolume call for such a volume.

For more information about implementing this mode, see https://kubernetes-csi.github.io/docs/ephemeral-local-volumes.html A driver can support one or more of these modes and more modes may be added in the future.

This field is beta. This field is immutable.

---

### CsiNodeDriver <a name="CsiNodeDriver" id="cdk8s-plus-28.k8s.CsiNodeDriver"></a>

CSINodeDriver holds information about the specification of one CSI driver installed on a node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiNodeDriver.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const csiNodeDriver: k8s.CsiNodeDriver = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.name">name</a></code> | <code>string</code> | name represents the name of the CSI driver that this object refers to. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.nodeId">nodeId</a></code> | <code>string</code> | nodeID of the node from the driver point of view. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.allocatable">allocatable</a></code> | <code>cdk8s-plus-28.k8s.VolumeNodeResources</code> | allocatable represents the volume resources of a node that are available for scheduling. |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeDriver.property.topologyKeys">topologyKeys</a></code> | <code>string[]</code> | topologyKeys is the list of keys supported by the driver. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name represents the name of the CSI driver that this object refers to.

This MUST be the same name returned by the CSI GetPluginName() call for that driver.

---

##### `nodeId`<sup>Required</sup> <a name="nodeId" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.nodeId"></a>

```typescript
public readonly nodeId: string;
```

- *Type:* string

nodeID of the node from the driver point of view.

This field enables Kubernetes to communicate with storage systems that do not share the same nomenclature for nodes. For example, Kubernetes may refer to a given node as "node1", but the storage system may refer to the same node as "nodeA". When Kubernetes issues a command to the storage system to attach a volume to a specific node, it can use this field to refer to the node name using the ID that the storage system will understand, e.g. "nodeA" instead of "node1". This field is required.

---

##### `allocatable`<sup>Optional</sup> <a name="allocatable" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.allocatable"></a>

```typescript
public readonly allocatable: VolumeNodeResources;
```

- *Type:* cdk8s-plus-28.k8s.VolumeNodeResources

allocatable represents the volume resources of a node that are available for scheduling.

This field is beta.

---

##### `topologyKeys`<sup>Optional</sup> <a name="topologyKeys" id="cdk8s-plus-28.k8s.CsiNodeDriver.property.topologyKeys"></a>

```typescript
public readonly topologyKeys: string[];
```

- *Type:* string[]

topologyKeys is the list of keys supported by the driver.

When a driver is initialized on a cluster, it provides a set of topology keys that it understands (e.g. "company.com/zone", "company.com/region"). When a driver is initialized on a node, it provides the same topology keys along with values. Kubelet will expose these topology keys as labels on its own node object. When Kubernetes does topology aware provisioning, it can use this list to determine which labels it should retrieve from the node object and pass back to the driver. It is possible for different nodes to use different topology keys. This can be empty if driver does not support topology.

---

### CsiNodeSpec <a name="CsiNodeSpec" id="cdk8s-plus-28.k8s.CsiNodeSpec"></a>

CSINodeSpec holds information about the specification of all CSI drivers installed on a node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiNodeSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const csiNodeSpec: k8s.CsiNodeSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiNodeSpec.property.drivers">drivers</a></code> | <code>cdk8s-plus-28.k8s.CsiNodeDriver[]</code> | drivers is a list of information of all CSI Drivers existing on a node. |

---

##### `drivers`<sup>Required</sup> <a name="drivers" id="cdk8s-plus-28.k8s.CsiNodeSpec.property.drivers"></a>

```typescript
public readonly drivers: CsiNodeDriver[];
```

- *Type:* cdk8s-plus-28.k8s.CsiNodeDriver[]

drivers is a list of information of all CSI Drivers existing on a node.

If all drivers in the list are uninstalled, this can become empty.

---

### CsiPersistentVolumeSource <a name="CsiPersistentVolumeSource" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource"></a>

Represents storage that is managed by an external CSI volume driver (Beta feature).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const csiPersistentVolumeSource: k8s.CsiPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.driver">driver</a></code> | <code>string</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeHandle">volumeHandle</a></code> | <code>string</code> | volumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerExpandSecretRef">controllerExpandSecretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | controllerExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerExpandVolume call. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerPublishSecretRef">controllerPublishSecretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | controllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeExpandSecretRef">nodeExpandSecretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | nodeExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeExpandVolume call. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodePublishSecretRef">nodePublishSecretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeStageSecretRef">nodeStageSecretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | nodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly value to pass to ControllerPublishVolumeRequest. |
| <code><a href="#cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeAttributes">volumeAttributes</a></code> | <code>{[ key: string ]: string}</code> | volumeAttributes of the volume to publish. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.driver"></a>

```typescript
public readonly driver: string;
```

- *Type:* string

driver is the name of the driver to use for this volume.

Required.

---

##### `volumeHandle`<sup>Required</sup> <a name="volumeHandle" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeHandle"></a>

```typescript
public readonly volumeHandle: string;
```

- *Type:* string

volumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls.

Required.

---

##### `controllerExpandSecretRef`<sup>Optional</sup> <a name="controllerExpandSecretRef" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerExpandSecretRef"></a>

```typescript
public readonly controllerExpandSecretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

controllerExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerExpandVolume call.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `controllerPublishSecretRef`<sup>Optional</sup> <a name="controllerPublishSecretRef" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.controllerPublishSecretRef"></a>

```typescript
public readonly controllerPublishSecretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

controllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs".

---

##### `nodeExpandSecretRef`<sup>Optional</sup> <a name="nodeExpandSecretRef" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeExpandSecretRef"></a>

```typescript
public readonly nodeExpandSecretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

nodeExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeExpandVolume call.

This is a beta field which is enabled default by CSINodeExpandSecret feature gate. This field is optional, may be omitted if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `nodePublishSecretRef`<sup>Optional</sup> <a name="nodePublishSecretRef" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodePublishSecretRef"></a>

```typescript
public readonly nodePublishSecretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `nodeStageSecretRef`<sup>Optional</sup> <a name="nodeStageSecretRef" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.nodeStageSecretRef"></a>

```typescript
public readonly nodeStageSecretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

nodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls.

This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write).

readOnly value to pass to ControllerPublishVolumeRequest.

Defaults to false (read/write).

---

##### `volumeAttributes`<sup>Optional</sup> <a name="volumeAttributes" id="cdk8s-plus-28.k8s.CsiPersistentVolumeSource.property.volumeAttributes"></a>

```typescript
public readonly volumeAttributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

volumeAttributes of the volume to publish.

---

### CsiVolumeOptions <a name="CsiVolumeOptions" id="cdk8s-plus-28.CsiVolumeOptions"></a>

Options for the CSI driver based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.CsiVolumeOptions.Initializer"></a>

```typescript
import { CsiVolumeOptions } from 'cdk8s-plus-28'

const csiVolumeOptions: CsiVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.attributes">attributes</a></code> | <code>{[ key: string ]: string}</code> | Any driver-specific attributes to pass to the CSI volume builder. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.fsType">fsType</a></code> | <code>string</code> | The filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.CsiVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Whether the mounted volume should be read-only or not. |

---

##### `attributes`<sup>Optional</sup> <a name="attributes" id="cdk8s-plus-28.CsiVolumeOptions.property.attributes"></a>

```typescript
public readonly attributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* undefined

Any driver-specific attributes to pass to the CSI volume builder.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.CsiVolumeOptions.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* driver-dependent

The filesystem type to mount.

Ex. "ext4", "xfs", "ntfs". If not provided,
the empty value is passed to the associated CSI driver, which will
determine the default filesystem to apply.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.CsiVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.CsiVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Whether the mounted volume should be read-only or not.

---

### CsiVolumeSource <a name="CsiVolumeSource" id="cdk8s-plus-28.k8s.CsiVolumeSource"></a>

Represents a source location of a volume to mount, managed by an external CSI driver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CsiVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const csiVolumeSource: k8s.CsiVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.driver">driver</a></code> | <code>string</code> | driver is the name of the CSI driver that handles this volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType to mount. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.nodePublishSecretRef">nodePublishSecretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly specifies a read-only configuration for the volume. |
| <code><a href="#cdk8s-plus-28.k8s.CsiVolumeSource.property.volumeAttributes">volumeAttributes</a></code> | <code>{[ key: string ]: string}</code> | volumeAttributes stores driver-specific properties that are passed to the CSI driver. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.driver"></a>

```typescript
public readonly driver: string;
```

- *Type:* string

driver is the name of the CSI driver that handles this volume.

Consult with your admin for the correct name as registered in the cluster.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType to mount.

Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.

---

##### `nodePublishSecretRef`<sup>Optional</sup> <a name="nodePublishSecretRef" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.nodePublishSecretRef"></a>

```typescript
public readonly nodePublishSecretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls.

This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write).

readOnly specifies a read-only configuration for the volume.

Defaults to false (read/write).

---

##### `volumeAttributes`<sup>Optional</sup> <a name="volumeAttributes" id="cdk8s-plus-28.k8s.CsiVolumeSource.property.volumeAttributes"></a>

```typescript
public readonly volumeAttributes: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

volumeAttributes stores driver-specific properties that are passed to the CSI driver.

Consult your driver's documentation for supported values.

---

### CustomResourceColumnDefinition <a name="CustomResourceColumnDefinition" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition"></a>

CustomResourceColumnDefinition specifies a column for server side printing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceColumnDefinition: k8s.CustomResourceColumnDefinition = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.jsonPath">jsonPath</a></code> | <code>string</code> | jsonPath is a simple JSON path (i.e. with array notation) which is evaluated against each custom resource to produce the value for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.name">name</a></code> | <code>string</code> | name is a human readable name for the column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.type">type</a></code> | <code>string</code> | type is an OpenAPI type definition for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.description">description</a></code> | <code>string</code> | description is a human readable description of this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.format">format</a></code> | <code>string</code> | format is an optional OpenAPI type definition for this column. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.priority">priority</a></code> | <code>number</code> | priority is an integer defining the relative importance of this column compared to others. |

---

##### `jsonPath`<sup>Required</sup> <a name="jsonPath" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.jsonPath"></a>

```typescript
public readonly jsonPath: string;
```

- *Type:* string

jsonPath is a simple JSON path (i.e. with array notation) which is evaluated against each custom resource to produce the value for this column.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is a human readable name for the column.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type is an OpenAPI type definition for this column.

See https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#data-types for details.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

description is a human readable description of this column.

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

format is an optional OpenAPI type definition for this column.

The 'name' format is applied to the primary identifier column to assist in clients identifying column is the resource name. See https://github.com/OAI/OpenAPI-Specification/blob/master/versions/2.0.md#data-types for details.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="cdk8s-plus-28.k8s.CustomResourceColumnDefinition.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

priority is an integer defining the relative importance of this column compared to others.

Lower numbers are considered higher priority. Columns that may be omitted in limited space scenarios should be given a priority greater than 0.

---

### CustomResourceConversion <a name="CustomResourceConversion" id="cdk8s-plus-28.k8s.CustomResourceConversion"></a>

CustomResourceConversion describes how to convert different versions of a CR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceConversion.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceConversion: k8s.CustomResourceConversion = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceConversion.property.strategy">strategy</a></code> | <code>string</code> | strategy specifies how custom resources are converted between versions. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceConversion.property.webhook">webhook</a></code> | <code>cdk8s-plus-28.k8s.WebhookConversion</code> | webhook describes how to call the conversion webhook. |

---

##### `strategy`<sup>Required</sup> <a name="strategy" id="cdk8s-plus-28.k8s.CustomResourceConversion.property.strategy"></a>

```typescript
public readonly strategy: string;
```

- *Type:* string

strategy specifies how custom resources are converted between versions.

Allowed values are: - `"None"`: The converter only change the apiVersion and would not touch any other field in the custom resource. - `"Webhook"`: API Server will call to an external webhook to do the conversion. Additional information
is needed for this option. This requires spec.preserveUnknownFields to be false, and spec.conversion.webhook to be set.

---

##### `webhook`<sup>Optional</sup> <a name="webhook" id="cdk8s-plus-28.k8s.CustomResourceConversion.property.webhook"></a>

```typescript
public readonly webhook: WebhookConversion;
```

- *Type:* cdk8s-plus-28.k8s.WebhookConversion

webhook describes how to call the conversion webhook.

Required when `strategy` is set to `"Webhook"`.

---

### CustomResourceDefinitionNames <a name="CustomResourceDefinitionNames" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames"></a>

CustomResourceDefinitionNames indicates the names to serve this CustomResourceDefinition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceDefinitionNames: k8s.CustomResourceDefinitionNames = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.kind">kind</a></code> | <code>string</code> | kind is the serialized kind of the resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.plural">plural</a></code> | <code>string</code> | plural is the plural name of the resource to serve. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.categories">categories</a></code> | <code>string[]</code> | categories is a list of grouped resources this custom resource belongs to (e.g. 'all'). This is published in API discovery documents, and used by clients to support invocations like `kubectl get all`. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.listKind">listKind</a></code> | <code>string</code> | listKind is the serialized kind of the list for this resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.shortNames">shortNames</a></code> | <code>string[]</code> | shortNames are short names for the resource, exposed in API discovery documents, and used by clients to support invocations like `kubectl get <shortname>`. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.singular">singular</a></code> | <code>string</code> | singular is the singular name of the resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

kind is the serialized kind of the resource.

It is normally CamelCase and singular. Custom resource instances will use this value as the `kind` attribute in API calls.

---

##### `plural`<sup>Required</sup> <a name="plural" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.plural"></a>

```typescript
public readonly plural: string;
```

- *Type:* string

plural is the plural name of the resource to serve.

The custom resources are served under `/apis/<group>/<version>/.../<plural>`. Must match the name of the CustomResourceDefinition (in the form `<names.plural>.<group>`). Must be all lowercase.

---

##### `categories`<sup>Optional</sup> <a name="categories" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.categories"></a>

```typescript
public readonly categories: string[];
```

- *Type:* string[]

categories is a list of grouped resources this custom resource belongs to (e.g. 'all'). This is published in API discovery documents, and used by clients to support invocations like `kubectl get all`.

---

##### `listKind`<sup>Optional</sup> <a name="listKind" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.listKind"></a>

```typescript
public readonly listKind: string;
```

- *Type:* string
- *Default:* kind`List".

listKind is the serialized kind of the list for this resource.

Defaults to "`kind`List".

---

##### `shortNames`<sup>Optional</sup> <a name="shortNames" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.shortNames"></a>

```typescript
public readonly shortNames: string[];
```

- *Type:* string[]

shortNames are short names for the resource, exposed in API discovery documents, and used by clients to support invocations like `kubectl get <shortname>`.

It must be all lowercase.

---

##### `singular`<sup>Optional</sup> <a name="singular" id="cdk8s-plus-28.k8s.CustomResourceDefinitionNames.property.singular"></a>

```typescript
public readonly singular: string;
```

- *Type:* string
- *Default:* lowercased `kind`.

singular is the singular name of the resource.

It must be all lowercase. Defaults to lowercased `kind`.

---

### CustomResourceDefinitionSpec <a name="CustomResourceDefinitionSpec" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec"></a>

CustomResourceDefinitionSpec describes how a user wants their resource to appear.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceDefinitionSpec: k8s.CustomResourceDefinitionSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.group">group</a></code> | <code>string</code> | group is the API group of the defined custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.names">names</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceDefinitionNames</code> | names specify the resource and kind names for the custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.scope">scope</a></code> | <code>string</code> | scope indicates whether the defined custom resource is cluster- or namespace-scoped. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.versions">versions</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceDefinitionVersion[]</code> | versions is the list of all API versions of the defined custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.conversion">conversion</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceConversion</code> | conversion defines conversion settings for the CRD. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.preserveUnknownFields">preserveUnknownFields</a></code> | <code>boolean</code> | preserveUnknownFields indicates that object fields which are not specified in the OpenAPI schema should be preserved when persisting to storage. |

---

##### `group`<sup>Required</sup> <a name="group" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string

group is the API group of the defined custom resource.

The custom resources are served under `/apis/<group>/...`. Must match the name of the CustomResourceDefinition (in the form `<names.plural>.<group>`).

---

##### `names`<sup>Required</sup> <a name="names" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.names"></a>

```typescript
public readonly names: CustomResourceDefinitionNames;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceDefinitionNames

names specify the resource and kind names for the custom resource.

---

##### `scope`<sup>Required</sup> <a name="scope" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.scope"></a>

```typescript
public readonly scope: string;
```

- *Type:* string

scope indicates whether the defined custom resource is cluster- or namespace-scoped.

Allowed values are `Cluster` and `Namespaced`.

---

##### `versions`<sup>Required</sup> <a name="versions" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.versions"></a>

```typescript
public readonly versions: CustomResourceDefinitionVersion[];
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceDefinitionVersion[]

versions is the list of all API versions of the defined custom resource.

Version names are used to compute the order in which served versions are listed in API discovery. If the version string is "kube-like", it will sort above non "kube-like" version strings, which are ordered lexicographically. "Kube-like" versions start with a "v", then are followed by a number (the major version), then optionally the string "alpha" or "beta" and another number (the minor version). These are sorted first by GA > beta > alpha (where GA is a version with no suffix such as beta or alpha), and then by comparing major version, then minor version. An example sorted list of versions: v10, v2, v1, v11beta2, v10beta3, v3beta1, v12alpha1, v11alpha2, foo1, foo10.

---

##### `conversion`<sup>Optional</sup> <a name="conversion" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.conversion"></a>

```typescript
public readonly conversion: CustomResourceConversion;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceConversion

conversion defines conversion settings for the CRD.

---

##### `preserveUnknownFields`<sup>Optional</sup> <a name="preserveUnknownFields" id="cdk8s-plus-28.k8s.CustomResourceDefinitionSpec.property.preserveUnknownFields"></a>

```typescript
public readonly preserveUnknownFields: boolean;
```

- *Type:* boolean

preserveUnknownFields indicates that object fields which are not specified in the OpenAPI schema should be preserved when persisting to storage.

apiVersion, kind, metadata and known fields inside metadata are always preserved. This field is deprecated in favor of setting `x-preserve-unknown-fields` to true in `spec.versions[*].schema.openAPIV3Schema`. See https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/#field-pruning for details.

---

### CustomResourceDefinitionVersion <a name="CustomResourceDefinitionVersion" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion"></a>

CustomResourceDefinitionVersion describes a version for CRD.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceDefinitionVersion: k8s.CustomResourceDefinitionVersion = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.name">name</a></code> | <code>string</code> | name is the version name, e.g. “v1”, “v2beta1”, etc. The custom resources are served under this version at `/apis/<group>/<version>/...` if `served` is true. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.served">served</a></code> | <code>boolean</code> | served is a flag enabling/disabling this version from being served via REST APIs. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.storage">storage</a></code> | <code>boolean</code> | storage indicates this version should be used when persisting custom resources to storage. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.additionalPrinterColumns">additionalPrinterColumns</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceColumnDefinition[]</code> | additionalPrinterColumns specifies additional columns returned in Table output. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecated">deprecated</a></code> | <code>boolean</code> | deprecated indicates this version of the custom resource API is deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecationWarning">deprecationWarning</a></code> | <code>string</code> | deprecationWarning overrides the default warning returned to API clients. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.schema">schema</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceValidation</code> | schema describes the schema used for validation, pruning, and defaulting of this version of the custom resource. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.subresources">subresources</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceSubresources</code> | subresources specify what subresources this version of the defined custom resource have. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the version name, e.g. “v1”, “v2beta1”, etc. The custom resources are served under this version at `/apis/<group>/<version>/...` if `served` is true.

---

##### `served`<sup>Required</sup> <a name="served" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.served"></a>

```typescript
public readonly served: boolean;
```

- *Type:* boolean

served is a flag enabling/disabling this version from being served via REST APIs.

---

##### `storage`<sup>Required</sup> <a name="storage" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.storage"></a>

```typescript
public readonly storage: boolean;
```

- *Type:* boolean

storage indicates this version should be used when persisting custom resources to storage.

There must be exactly one version with storage=true.

---

##### `additionalPrinterColumns`<sup>Optional</sup> <a name="additionalPrinterColumns" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.additionalPrinterColumns"></a>

```typescript
public readonly additionalPrinterColumns: CustomResourceColumnDefinition[];
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceColumnDefinition[]

additionalPrinterColumns specifies additional columns returned in Table output.

See https://kubernetes.io/docs/reference/using-api/api-concepts/#receiving-resources-as-tables for details. If no columns are specified, a single column displaying the age of the custom resource is used.

---

##### `deprecated`<sup>Optional</sup> <a name="deprecated" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecated"></a>

```typescript
public readonly deprecated: boolean;
```

- *Type:* boolean
- *Default:* false.

deprecated indicates this version of the custom resource API is deprecated.

When set to true, API requests to this version receive a warning header in the server response. Defaults to false.

---

##### `deprecationWarning`<sup>Optional</sup> <a name="deprecationWarning" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.deprecationWarning"></a>

```typescript
public readonly deprecationWarning: string;
```

- *Type:* string

deprecationWarning overrides the default warning returned to API clients.

May only be set when `deprecated` is true. The default warning indicates this version is deprecated and recommends use of the newest served version of equal or greater stability, if one exists.

---

##### `schema`<sup>Optional</sup> <a name="schema" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.schema"></a>

```typescript
public readonly schema: CustomResourceValidation;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceValidation

schema describes the schema used for validation, pruning, and defaulting of this version of the custom resource.

---

##### `subresources`<sup>Optional</sup> <a name="subresources" id="cdk8s-plus-28.k8s.CustomResourceDefinitionVersion.property.subresources"></a>

```typescript
public readonly subresources: CustomResourceSubresources;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceSubresources

subresources specify what subresources this version of the defined custom resource have.

---

### CustomResourceSubresources <a name="CustomResourceSubresources" id="cdk8s-plus-28.k8s.CustomResourceSubresources"></a>

CustomResourceSubresources defines the status and scale subresources for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceSubresources.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceSubresources: k8s.CustomResourceSubresources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresources.property.scale">scale</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceSubresourceScale</code> | scale indicates the custom resource should serve a `/scale` subresource that returns an `autoscaling/v1` Scale object. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresources.property.status">status</a></code> | <code>any</code> | status indicates the custom resource should serve a `/status` subresource. |

---

##### `scale`<sup>Optional</sup> <a name="scale" id="cdk8s-plus-28.k8s.CustomResourceSubresources.property.scale"></a>

```typescript
public readonly scale: CustomResourceSubresourceScale;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceSubresourceScale

scale indicates the custom resource should serve a `/scale` subresource that returns an `autoscaling/v1` Scale object.

---

##### `status`<sup>Optional</sup> <a name="status" id="cdk8s-plus-28.k8s.CustomResourceSubresources.property.status"></a>

```typescript
public readonly status: any;
```

- *Type:* any

status indicates the custom resource should serve a `/status` subresource.

When enabled: 1. requests to the custom resource primary endpoint ignore changes to the `status` stanza of the object. 2. requests to the custom resource `/status` subresource ignore changes to anything other than the `status` stanza of the object.

---

### CustomResourceSubresourceScale <a name="CustomResourceSubresourceScale" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale"></a>

CustomResourceSubresourceScale defines how to serve the scale subresource for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceSubresourceScale: k8s.CustomResourceSubresourceScale = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.specReplicasPath">specReplicasPath</a></code> | <code>string</code> | specReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `spec.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.spec`. If there is no value under the given path in the custom resource, the `/scale` subresource will return an error on GET. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.statusReplicasPath">statusReplicasPath</a></code> | <code>string</code> | statusReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `status.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status`. If there is no value under the given path in the custom resource, the `status.replicas` value in the `/scale` subresource will default to 0. |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.labelSelectorPath">labelSelectorPath</a></code> | <code>string</code> | labelSelectorPath defines the JSON path inside of a custom resource that corresponds to Scale `status.selector`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status` or `.spec`. Must be set to work with HorizontalPodAutoscaler. The field pointed by this JSON path must be a string field (not a complex selector struct) which contains a serialized label selector in string form. More info: https://kubernetes.io/docs/tasks/access-kubernetes-api/custom-resources/custom-resource-definitions#scale-subresource If there is no value under the given path in the custom resource, the `status.selector` value in the `/scale` subresource will default to the empty string. |

---

##### `specReplicasPath`<sup>Required</sup> <a name="specReplicasPath" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.specReplicasPath"></a>

```typescript
public readonly specReplicasPath: string;
```

- *Type:* string

specReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `spec.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.spec`. If there is no value under the given path in the custom resource, the `/scale` subresource will return an error on GET.

---

##### `statusReplicasPath`<sup>Required</sup> <a name="statusReplicasPath" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.statusReplicasPath"></a>

```typescript
public readonly statusReplicasPath: string;
```

- *Type:* string

statusReplicasPath defines the JSON path inside of a custom resource that corresponds to Scale `status.replicas`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status`. If there is no value under the given path in the custom resource, the `status.replicas` value in the `/scale` subresource will default to 0.

---

##### `labelSelectorPath`<sup>Optional</sup> <a name="labelSelectorPath" id="cdk8s-plus-28.k8s.CustomResourceSubresourceScale.property.labelSelectorPath"></a>

```typescript
public readonly labelSelectorPath: string;
```

- *Type:* string

labelSelectorPath defines the JSON path inside of a custom resource that corresponds to Scale `status.selector`. Only JSON paths without the array notation are allowed. Must be a JSON Path under `.status` or `.spec`. Must be set to work with HorizontalPodAutoscaler. The field pointed by this JSON path must be a string field (not a complex selector struct) which contains a serialized label selector in string form. More info: https://kubernetes.io/docs/tasks/access-kubernetes-api/custom-resources/custom-resource-definitions#scale-subresource If there is no value under the given path in the custom resource, the `status.selector` value in the `/scale` subresource will default to the empty string.

---

### CustomResourceValidation <a name="CustomResourceValidation" id="cdk8s-plus-28.k8s.CustomResourceValidation"></a>

CustomResourceValidation is a list of validation methods for CustomResources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.CustomResourceValidation.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const customResourceValidation: k8s.CustomResourceValidation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.CustomResourceValidation.property.openApiv3Schema">openApiv3Schema</a></code> | <code>cdk8s-plus-28.k8s.JsonSchemaProps</code> | openAPIV3Schema is the OpenAPI v3 schema to use for validation and pruning. |

---

##### `openApiv3Schema`<sup>Optional</sup> <a name="openApiv3Schema" id="cdk8s-plus-28.k8s.CustomResourceValidation.property.openApiv3Schema"></a>

```typescript
public readonly openApiv3Schema: JsonSchemaProps;
```

- *Type:* cdk8s-plus-28.k8s.JsonSchemaProps

openAPIV3Schema is the OpenAPI v3 schema to use for validation and pruning.

---

### DaemonSetProps <a name="DaemonSetProps" id="cdk8s-plus-28.DaemonSetProps"></a>

Properties for `DaemonSet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DaemonSetProps.Initializer"></a>

```typescript
import { DaemonSetProps } from 'cdk8s-plus-28'

const daemonSetProps: DaemonSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.DaemonSetProps.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DaemonSetProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.DaemonSetProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.DaemonSetProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.DaemonSetProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.DaemonSetProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.DaemonSetProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.DaemonSetProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.DaemonSetProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.DaemonSetProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.DaemonSetProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.DaemonSetProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.DaemonSetProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.DaemonSetProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.DaemonSetProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.DaemonSetProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.DaemonSetProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.DaemonSetProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.DaemonSetProps.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

---

### DaemonSetSpec <a name="DaemonSetSpec" id="cdk8s-plus-28.k8s.DaemonSetSpec"></a>

DaemonSetSpec is the specification of a daemon set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DaemonSetSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const daemonSetSpec: k8s.DaemonSetSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | A label query over pods that are managed by the daemon set. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | An object that describes the pod that will be created. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.revisionHistoryLimit">revisionHistoryLimit</a></code> | <code>number</code> | The number of old history to retain to allow rollback. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetSpec.property.updateStrategy">updateStrategy</a></code> | <code>cdk8s-plus-28.k8s.DaemonSetUpdateStrategy</code> | An update strategy to replace existing DaemonSet pods with new pods. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

A label query over pods that are managed by the daemon set.

Must match in order to be controlled. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

An object that describes the pod that will be created.

The DaemonSet will create exactly one copy of this pod on every node that matches the template's node selector (or on every node if no node selector is specified). The only allowed template.spec.restartPolicy value is "Always". More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0 (pod will be considered available as soon as it is ready).

The minimum number of seconds for which a newly created DaemonSet pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready).

---

##### `revisionHistoryLimit`<sup>Optional</sup> <a name="revisionHistoryLimit" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.revisionHistoryLimit"></a>

```typescript
public readonly revisionHistoryLimit: number;
```

- *Type:* number
- *Default:* 10.

The number of old history to retain to allow rollback.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.

---

##### `updateStrategy`<sup>Optional</sup> <a name="updateStrategy" id="cdk8s-plus-28.k8s.DaemonSetSpec.property.updateStrategy"></a>

```typescript
public readonly updateStrategy: DaemonSetUpdateStrategy;
```

- *Type:* cdk8s-plus-28.k8s.DaemonSetUpdateStrategy

An update strategy to replace existing DaemonSet pods with new pods.

---

### DaemonSetUpdateStrategy <a name="DaemonSetUpdateStrategy" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy"></a>

DaemonSetUpdateStrategy is a struct used to control the update strategy for a DaemonSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const daemonSetUpdateStrategy: k8s.DaemonSetUpdateStrategy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.rollingUpdate">rollingUpdate</a></code> | <code>cdk8s-plus-28.k8s.RollingUpdateDaemonSet</code> | Rolling update config params. |
| <code><a href="#cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.type">type</a></code> | <code>string</code> | Type of daemon set update. |

---

##### `rollingUpdate`<sup>Optional</sup> <a name="rollingUpdate" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.rollingUpdate"></a>

```typescript
public readonly rollingUpdate: RollingUpdateDaemonSet;
```

- *Type:* cdk8s-plus-28.k8s.RollingUpdateDaemonSet

Rolling update config params.

Present only if type = "RollingUpdate".

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.DaemonSetUpdateStrategy.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* RollingUpdate.

Type of daemon set update.

Can be "RollingUpdate" or "OnDelete". Default is RollingUpdate.

---

### DeleteOptions <a name="DeleteOptions" id="cdk8s-plus-28.k8s.DeleteOptions"></a>

DeleteOptions may be provided when deleting an API object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeleteOptions.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const deleteOptions: k8s.DeleteOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.apiVersion">apiVersion</a></code> | <code>string</code> | APIVersion defines the versioned schema of this representation of an object. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.dryRun">dryRun</a></code> | <code>string[]</code> | When present, indicates that modifications should not be persisted. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.gracePeriodSeconds">gracePeriodSeconds</a></code> | <code>number</code> | The duration in seconds before the object should be deleted. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.kind">kind</a></code> | <code>cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind</code> | Kind is a string value representing the REST resource this object represents. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.orphanDependents">orphanDependents</a></code> | <code>boolean</code> | Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.preconditions">preconditions</a></code> | <code>cdk8s-plus-28.k8s.Preconditions</code> | Must be fulfilled before a deletion is carried out. |
| <code><a href="#cdk8s-plus-28.k8s.DeleteOptions.property.propagationPolicy">propagationPolicy</a></code> | <code>string</code> | Whether and how garbage collection will be performed. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.DeleteOptions.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

APIVersion defines the versioned schema of this representation of an object.

Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

---

##### `dryRun`<sup>Optional</sup> <a name="dryRun" id="cdk8s-plus-28.k8s.DeleteOptions.property.dryRun"></a>

```typescript
public readonly dryRun: string[];
```

- *Type:* string[]

When present, indicates that modifications should not be persisted.

An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed

---

##### `gracePeriodSeconds`<sup>Optional</sup> <a name="gracePeriodSeconds" id="cdk8s-plus-28.k8s.DeleteOptions.property.gracePeriodSeconds"></a>

```typescript
public readonly gracePeriodSeconds: number;
```

- *Type:* number
- *Default:* a per object value if not specified. zero means delete immediately.

The duration in seconds before the object should be deleted.

Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.DeleteOptions.property.kind"></a>

```typescript
public readonly kind: IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind;
```

- *Type:* cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind

Kind is a string value representing the REST resource this object represents.

Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `orphanDependents`<sup>Optional</sup> <a name="orphanDependents" id="cdk8s-plus-28.k8s.DeleteOptions.property.orphanDependents"></a>

```typescript
public readonly orphanDependents: boolean;
```

- *Type:* boolean

Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.

---

##### `preconditions`<sup>Optional</sup> <a name="preconditions" id="cdk8s-plus-28.k8s.DeleteOptions.property.preconditions"></a>

```typescript
public readonly preconditions: Preconditions;
```

- *Type:* cdk8s-plus-28.k8s.Preconditions

Must be fulfilled before a deletion is carried out.

If not possible, a 409 Conflict status will be returned.

---

##### `propagationPolicy`<sup>Optional</sup> <a name="propagationPolicy" id="cdk8s-plus-28.k8s.DeleteOptions.property.propagationPolicy"></a>

```typescript
public readonly propagationPolicy: string;
```

- *Type:* string

Whether and how garbage collection will be performed.

Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.

---

### DeploymentExposeViaServiceOptions <a name="DeploymentExposeViaServiceOptions" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions"></a>

Options for `Deployment.exposeViaService`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.Initializer"></a>

```typescript
import { DeploymentExposeViaServiceOptions } from 'cdk8s-plus-28'

const deploymentExposeViaServiceOptions: DeploymentExposeViaServiceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.name">name</a></code> | <code>string</code> | The name of the service to expose. |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]</code> | The ports that the service should bind to. |
| <code><a href="#cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.serviceType">serviceType</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | The type of the exposed service. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.ports"></a>

```typescript
public readonly ports: ServicePort[];
```

- *Type:* <a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

##### `serviceType`<sup>Optional</sup> <a name="serviceType" id="cdk8s-plus-28.DeploymentExposeViaServiceOptions.property.serviceType"></a>

```typescript
public readonly serviceType: ServiceType;
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

### DeploymentProps <a name="DeploymentProps" id="cdk8s-plus-28.DeploymentProps"></a>

Properties for `Deployment`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentProps.Initializer"></a>

```typescript
import { DeploymentProps } from 'cdk8s-plus-28'

const deploymentProps: DeploymentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.minReady">minReady</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.progressDeadline">progressDeadline</a></code> | <code>cdk8s.Duration</code> | The maximum duration for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.replicas">replicas</a></code> | <code>number</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.DeploymentProps.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a></code> | Specifies the strategy used to replace old Pods by new ones. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DeploymentProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.DeploymentProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.DeploymentProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.DeploymentProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.DeploymentProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.DeploymentProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.DeploymentProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.DeploymentProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.DeploymentProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.DeploymentProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.DeploymentProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.DeploymentProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.DeploymentProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.DeploymentProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.DeploymentProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.DeploymentProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.DeploymentProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `minReady`<sup>Optional</sup> <a name="minReady" id="cdk8s-plus-28.DeploymentProps.property.minReady"></a>

```typescript
public readonly minReady: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `progressDeadline`<sup>Optional</sup> <a name="progressDeadline" id="cdk8s-plus-28.DeploymentProps.property.progressDeadline"></a>

```typescript
public readonly progressDeadline: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(600)

The maximum duration for a deployment to make progress before it is considered to be failed.

The deployment controller will continue
to process failed deployments and a condition with a ProgressDeadlineExceeded
reason will be surfaced in the deployment status.

Note that progress will not be estimated during the time a deployment is paused.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#progress-deadline-seconds)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.DeploymentProps.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 2

Number of desired pods.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.DeploymentProps.property.strategy"></a>

```typescript
public readonly strategy: DeploymentStrategy;
```

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategy">DeploymentStrategy</a>
- *Default:* RollingUpdate with maxSurge and maxUnavailable set to 25%.

Specifies the strategy used to replace old Pods by new ones.

---

### DeploymentSpec <a name="DeploymentSpec" id="cdk8s-plus-28.k8s.DeploymentSpec"></a>

DeploymentSpec is the specification of the desired behavior of the Deployment.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeploymentSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const deploymentSpec: k8s.DeploymentSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | Label selector for pods. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | Template describes the pods that will be created. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.paused">paused</a></code> | <code>boolean</code> | Indicates that the deployment is paused. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.progressDeadlineSeconds">progressDeadlineSeconds</a></code> | <code>number</code> | The maximum time in seconds for a deployment to make progress before it is considered to be failed. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.replicas">replicas</a></code> | <code>number</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.revisionHistoryLimit">revisionHistoryLimit</a></code> | <code>number</code> | The number of old ReplicaSets to retain to allow rollback. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentSpec.property.strategy">strategy</a></code> | <code>cdk8s-plus-28.k8s.DeploymentStrategy</code> | The deployment strategy to use to replace existing pods with new ones. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.DeploymentSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

Label selector for pods.

Existing ReplicaSets whose pods are selected by this will be the ones affected by this deployment. It must match the pod template's labels.

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.DeploymentSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

Template describes the pods that will be created.

The only allowed template.spec.restartPolicy value is "Always".

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.k8s.DeploymentSpec.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `paused`<sup>Optional</sup> <a name="paused" id="cdk8s-plus-28.k8s.DeploymentSpec.property.paused"></a>

```typescript
public readonly paused: boolean;
```

- *Type:* boolean

Indicates that the deployment is paused.

---

##### `progressDeadlineSeconds`<sup>Optional</sup> <a name="progressDeadlineSeconds" id="cdk8s-plus-28.k8s.DeploymentSpec.property.progressDeadlineSeconds"></a>

```typescript
public readonly progressDeadlineSeconds: number;
```

- *Type:* number
- *Default:* 600s.

The maximum time in seconds for a deployment to make progress before it is considered to be failed.

The deployment controller will continue to process failed deployments and a condition with a ProgressDeadlineExceeded reason will be surfaced in the deployment status. Note that progress will not be estimated during the time a deployment is paused. Defaults to 600s.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.DeploymentSpec.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 1.

Number of desired pods.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 1.

---

##### `revisionHistoryLimit`<sup>Optional</sup> <a name="revisionHistoryLimit" id="cdk8s-plus-28.k8s.DeploymentSpec.property.revisionHistoryLimit"></a>

```typescript
public readonly revisionHistoryLimit: number;
```

- *Type:* number
- *Default:* 10.

The number of old ReplicaSets to retain to allow rollback.

This is a pointer to distinguish between explicit zero and not specified. Defaults to 10.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.k8s.DeploymentSpec.property.strategy"></a>

```typescript
public readonly strategy: DeploymentStrategy;
```

- *Type:* cdk8s-plus-28.k8s.DeploymentStrategy

The deployment strategy to use to replace existing pods with new ones.

---

### DeploymentStrategy <a name="DeploymentStrategy" id="cdk8s-plus-28.k8s.DeploymentStrategy"></a>

DeploymentStrategy describes how to replace existing pods with new ones.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DeploymentStrategy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const deploymentStrategy: k8s.DeploymentStrategy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentStrategy.property.rollingUpdate">rollingUpdate</a></code> | <code>cdk8s-plus-28.k8s.RollingUpdateDeployment</code> | Rolling update config params. |
| <code><a href="#cdk8s-plus-28.k8s.DeploymentStrategy.property.type">type</a></code> | <code>string</code> | Type of deployment. |

---

##### `rollingUpdate`<sup>Optional</sup> <a name="rollingUpdate" id="cdk8s-plus-28.k8s.DeploymentStrategy.property.rollingUpdate"></a>

```typescript
public readonly rollingUpdate: RollingUpdateDeployment;
```

- *Type:* cdk8s-plus-28.k8s.RollingUpdateDeployment

Rolling update config params.

Present only if DeploymentStrategyType = RollingUpdate.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.DeploymentStrategy.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* RollingUpdate.

Type of deployment.

Can be "Recreate" or "RollingUpdate". Default is RollingUpdate.

---

### DeploymentStrategyRollingUpdateOptions <a name="DeploymentStrategyRollingUpdateOptions" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions"></a>

Options for `DeploymentStrategy.rollingUpdate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.Initializer"></a>

```typescript
import { DeploymentStrategyRollingUpdateOptions } from 'cdk8s-plus-28'

const deploymentStrategyRollingUpdateOptions: DeploymentStrategyRollingUpdateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxSurge">maxSurge</a></code> | <code><a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a></code> | The maximum number of pods that can be scheduled above the desired number of pods. |
| <code><a href="#cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxUnavailable">maxUnavailable</a></code> | <code><a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a></code> | The maximum number of pods that can be unavailable during the update. |

---

##### `maxSurge`<sup>Optional</sup> <a name="maxSurge" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxSurge"></a>

```typescript
public readonly maxSurge: PercentOrAbsolute;
```

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be scheduled above the desired number of pods.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding up.
This can not be 0 if `maxUnavailable` is 0.

Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update
starts, such that the total number of old and new pods do not exceed 130% of desired pods.
Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that
total number of pods running at any time during the update is at most 130% of desired pods.

---

##### `maxUnavailable`<sup>Optional</sup> <a name="maxUnavailable" id="cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: PercentOrAbsolute;
```

- *Type:* <a href="#cdk8s-plus-28.PercentOrAbsolute">PercentOrAbsolute</a>
- *Default:* '25%'

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%).
Absolute number is calculated from percentage by rounding down.
This can not be 0 if `maxSurge` is 0.

Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired
pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can
be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total
number of pods available at all times during the update is at least 70% of desired pods.

---

### DnsOption <a name="DnsOption" id="cdk8s-plus-28.DnsOption"></a>

Custom DNS option.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DnsOption.Initializer"></a>

```typescript
import { DnsOption } from 'cdk8s-plus-28'

const dnsOption: DnsOption = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DnsOption.property.name">name</a></code> | <code>string</code> | Option name. |
| <code><a href="#cdk8s-plus-28.DnsOption.property.value">value</a></code> | <code>string</code> | Option value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.DnsOption.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Option name.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.DnsOption.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string
- *Default:* No value.

Option value.

---

### DockerConfigSecretProps <a name="DockerConfigSecretProps" id="cdk8s-plus-28.DockerConfigSecretProps"></a>

Options for `DockerConfigSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.DockerConfigSecretProps.Initializer"></a>

```typescript
import { DockerConfigSecretProps } from 'cdk8s-plus-28'

const dockerConfigSecretProps: DockerConfigSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.DockerConfigSecretProps.property.data">data</a></code> | <code>{[ key: string ]: any}</code> | JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.DockerConfigSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.DockerConfigSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `data`<sup>Required</sup> <a name="data" id="cdk8s-plus-28.DockerConfigSecretProps.property.data"></a>

```typescript
public readonly data: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

JSON content to provide for the `~/.docker/config.json` file. This will be stringified and inserted as stringData.

> [https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file](https://docs.docker.com/engine/reference/commandline/cli/#sample-configuration-file)

---

### DownwardApiProjection <a name="DownwardApiProjection" id="cdk8s-plus-28.k8s.DownwardApiProjection"></a>

Represents downward API info for projecting into a projected volume.

Note that this is identical to a downwardAPI volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiProjection.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const downwardApiProjection: k8s.DownwardApiProjection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiProjection.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.DownwardApiVolumeFile[]</code> | Items is a list of DownwardAPIVolume file. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.DownwardApiProjection.property.items"></a>

```typescript
public readonly items: DownwardApiVolumeFile[];
```

- *Type:* cdk8s-plus-28.k8s.DownwardApiVolumeFile[]

Items is a list of DownwardAPIVolume file.

---

### DownwardApiVolumeFile <a name="DownwardApiVolumeFile" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile"></a>

DownwardAPIVolumeFile represents information to create the file containing the pod field.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const downwardApiVolumeFile: k8s.DownwardApiVolumeFile = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.path">path</a></code> | <code>string</code> | Required: Path is  the relative path name of the file to be created. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.fieldRef">fieldRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectFieldSelector</code> | Required: Selects a field of the pod: only annotations, labels, name and namespace are supported. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.mode">mode</a></code> | <code>number</code> | Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.resourceFieldRef">resourceFieldRef</a></code> | <code>cdk8s-plus-28.k8s.ResourceFieldSelector</code> | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Required: Path is  the relative path name of the file to be created.

Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'

---

##### `fieldRef`<sup>Optional</sup> <a name="fieldRef" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.fieldRef"></a>

```typescript
public readonly fieldRef: ObjectFieldSelector;
```

- *Type:* cdk8s-plus-28.k8s.ObjectFieldSelector

Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.mode"></a>

```typescript
public readonly mode: number;
```

- *Type:* number

Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511.

YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `resourceFieldRef`<sup>Optional</sup> <a name="resourceFieldRef" id="cdk8s-plus-28.k8s.DownwardApiVolumeFile.property.resourceFieldRef"></a>

```typescript
public readonly resourceFieldRef: ResourceFieldSelector;
```

- *Type:* cdk8s-plus-28.k8s.ResourceFieldSelector

Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.

---

### DownwardApiVolumeSource <a name="DownwardApiVolumeSource" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource"></a>

DownwardAPIVolumeSource represents a volume containing downward API info.

Downward API volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const downwardApiVolumeSource: k8s.DownwardApiVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.defaultMode">defaultMode</a></code> | <code>number</code> | Optional: mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.DownwardApiVolumeFile[]</code> | Items is a list of downward API volume file. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Optional: mode bits to use on created files by default.

Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.DownwardApiVolumeSource.property.items"></a>

```typescript
public readonly items: DownwardApiVolumeFile[];
```

- *Type:* cdk8s-plus-28.k8s.DownwardApiVolumeFile[]

Items is a list of downward API volume file.

---

### EmptyDirVolumeOptions <a name="EmptyDirVolumeOptions" id="cdk8s-plus-28.EmptyDirVolumeOptions"></a>

Options for volumes populated with an empty directory.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EmptyDirVolumeOptions.Initializer"></a>

```typescript
import { EmptyDirVolumeOptions } from 'cdk8s-plus-28'

const emptyDirVolumeOptions: EmptyDirVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EmptyDirVolumeOptions.property.medium">medium</a></code> | <code><a href="#cdk8s-plus-28.EmptyDirMedium">EmptyDirMedium</a></code> | By default, emptyDir volumes are stored on whatever medium is backing the node - that might be disk or SSD or network storage, depending on your environment. |
| <code><a href="#cdk8s-plus-28.EmptyDirVolumeOptions.property.sizeLimit">sizeLimit</a></code> | <code>cdk8s.Size</code> | Total amount of local storage required for this EmptyDir volume. |

---

##### `medium`<sup>Optional</sup> <a name="medium" id="cdk8s-plus-28.EmptyDirVolumeOptions.property.medium"></a>

```typescript
public readonly medium: EmptyDirMedium;
```

- *Type:* <a href="#cdk8s-plus-28.EmptyDirMedium">EmptyDirMedium</a>
- *Default:* EmptyDirMedium.DEFAULT

By default, emptyDir volumes are stored on whatever medium is backing the node - that might be disk or SSD or network storage, depending on your environment.

However, you can set the emptyDir.medium field to
`EmptyDirMedium.MEMORY` to tell Kubernetes to mount a tmpfs (RAM-backed
filesystem) for you instead. While tmpfs is very fast, be aware that unlike
disks, tmpfs is cleared on node reboot and any files you write will count
against your Container's memory limit.

---

##### `sizeLimit`<sup>Optional</sup> <a name="sizeLimit" id="cdk8s-plus-28.EmptyDirVolumeOptions.property.sizeLimit"></a>

```typescript
public readonly sizeLimit: Size;
```

- *Type:* cdk8s.Size
- *Default:* limit is undefined

Total amount of local storage required for this EmptyDir volume.

The size
limit is also applicable for memory medium. The maximum usage on memory
medium EmptyDir would be the minimum value between the SizeLimit specified
here and the sum of memory limits of all containers in a pod.

---

### EmptyDirVolumeSource <a name="EmptyDirVolumeSource" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource"></a>

Represents an empty directory for a pod.

Empty directory volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const emptyDirVolumeSource: k8s.EmptyDirVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.medium">medium</a></code> | <code>string</code> | medium represents what type of storage medium should back this directory. |
| <code><a href="#cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.sizeLimit">sizeLimit</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | sizeLimit is the total amount of local storage required for this EmptyDir volume. |

---

##### `medium`<sup>Optional</sup> <a name="medium" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.medium"></a>

```typescript
public readonly medium: string;
```

- *Type:* string

medium represents what type of storage medium should back this directory.

The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

##### `sizeLimit`<sup>Optional</sup> <a name="sizeLimit" id="cdk8s-plus-28.k8s.EmptyDirVolumeSource.property.sizeLimit"></a>

```typescript
public readonly sizeLimit: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

sizeLimit is the total amount of local storage required for this EmptyDir volume.

The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

### Endpoint <a name="Endpoint" id="cdk8s-plus-28.k8s.Endpoint"></a>

Endpoint represents a single logical "backend" implementing a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Endpoint.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpoint: k8s.Endpoint = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.addresses">addresses</a></code> | <code>string[]</code> | addresses of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.conditions">conditions</a></code> | <code>cdk8s-plus-28.k8s.EndpointConditions</code> | conditions contains information about the current status of the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.deprecatedTopology">deprecatedTopology</a></code> | <code>{[ key: string ]: string}</code> | deprecatedTopology contains topology information part of the v1beta1 API. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.hints">hints</a></code> | <code>cdk8s-plus-28.k8s.EndpointHints</code> | hints contains information associated with how an endpoint should be consumed. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.hostname">hostname</a></code> | <code>string</code> | hostname of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.nodeName">nodeName</a></code> | <code>string</code> | nodeName represents the name of the Node hosting this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.targetRef">targetRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | targetRef is a reference to a Kubernetes object that represents this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.Endpoint.property.zone">zone</a></code> | <code>string</code> | zone is the name of the Zone this endpoint exists in. |

---

##### `addresses`<sup>Required</sup> <a name="addresses" id="cdk8s-plus-28.k8s.Endpoint.property.addresses"></a>

```typescript
public readonly addresses: string[];
```

- *Type:* string[]

addresses of this endpoint.

The contents of this field are interpreted according to the corresponding EndpointSlice addressType field. Consumers must handle different types of addresses in the context of their own capabilities. This must contain at least one address but no more than 100. These are all assumed to be fungible and clients may choose to only use the first element. Refer to: https://issue.k8s.io/106267

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.Endpoint.property.conditions"></a>

```typescript
public readonly conditions: EndpointConditions;
```

- *Type:* cdk8s-plus-28.k8s.EndpointConditions

conditions contains information about the current status of the endpoint.

---

##### `deprecatedTopology`<sup>Optional</sup> <a name="deprecatedTopology" id="cdk8s-plus-28.k8s.Endpoint.property.deprecatedTopology"></a>

```typescript
public readonly deprecatedTopology: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

deprecatedTopology contains topology information part of the v1beta1 API.

This field is deprecated, and will be removed when the v1beta1 API is removed (no sooner than kubernetes v1.24).  While this field can hold values, it is not writable through the v1 API, and any attempts to write to it will be silently ignored. Topology information can be found in the zone and nodeName fields instead.

---

##### `hints`<sup>Optional</sup> <a name="hints" id="cdk8s-plus-28.k8s.Endpoint.property.hints"></a>

```typescript
public readonly hints: EndpointHints;
```

- *Type:* cdk8s-plus-28.k8s.EndpointHints

hints contains information associated with how an endpoint should be consumed.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.Endpoint.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

hostname of this endpoint.

This field may be used by consumers of endpoints to distinguish endpoints from each other (e.g. in DNS names). Multiple endpoints which use the same hostname should be considered fungible (e.g. multiple A values in DNS). Must be lowercase and pass DNS Label (RFC 1123) validation.

---

##### `nodeName`<sup>Optional</sup> <a name="nodeName" id="cdk8s-plus-28.k8s.Endpoint.property.nodeName"></a>

```typescript
public readonly nodeName: string;
```

- *Type:* string

nodeName represents the name of the Node hosting this endpoint.

This can be used to determine endpoints local to a Node.

---

##### `targetRef`<sup>Optional</sup> <a name="targetRef" id="cdk8s-plus-28.k8s.Endpoint.property.targetRef"></a>

```typescript
public readonly targetRef: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

targetRef is a reference to a Kubernetes object that represents this endpoint.

---

##### `zone`<sup>Optional</sup> <a name="zone" id="cdk8s-plus-28.k8s.Endpoint.property.zone"></a>

```typescript
public readonly zone: string;
```

- *Type:* string

zone is the name of the Zone this endpoint exists in.

---

### EndpointAddress <a name="EndpointAddress" id="cdk8s-plus-28.k8s.EndpointAddress"></a>

EndpointAddress is a tuple that describes single IP address.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointAddress.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpointAddress: k8s.EndpointAddress = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.ip">ip</a></code> | <code>string</code> | The IP of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.hostname">hostname</a></code> | <code>string</code> | The Hostname of this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.nodeName">nodeName</a></code> | <code>string</code> | Optional: Node hosting this endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointAddress.property.targetRef">targetRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | Reference to object providing the endpoint. |

---

##### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.k8s.EndpointAddress.property.ip"></a>

```typescript
public readonly ip: string;
```

- *Type:* string

The IP of this endpoint.

May not be loopback (127.0.0.0/8 or ::1), link-local (169.254.0.0/16 or fe80::/10), or link-local multicast (224.0.0.0/24 or ff02::/16).

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.EndpointAddress.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

The Hostname of this endpoint.

---

##### `nodeName`<sup>Optional</sup> <a name="nodeName" id="cdk8s-plus-28.k8s.EndpointAddress.property.nodeName"></a>

```typescript
public readonly nodeName: string;
```

- *Type:* string

Optional: Node hosting this endpoint.

This can be used to determine endpoints local to a node.

---

##### `targetRef`<sup>Optional</sup> <a name="targetRef" id="cdk8s-plus-28.k8s.EndpointAddress.property.targetRef"></a>

```typescript
public readonly targetRef: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

Reference to object providing the endpoint.

---

### EndpointConditions <a name="EndpointConditions" id="cdk8s-plus-28.k8s.EndpointConditions"></a>

EndpointConditions represents the current condition of an endpoint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointConditions.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpointConditions: k8s.EndpointConditions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.ready">ready</a></code> | <code>boolean</code> | ready indicates that this endpoint is prepared to receive traffic, according to whatever system is managing the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.serving">serving</a></code> | <code>boolean</code> | serving is identical to ready except that it is set regardless of the terminating state of endpoints. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointConditions.property.terminating">terminating</a></code> | <code>boolean</code> | terminating indicates that this endpoint is terminating. |

---

##### `ready`<sup>Optional</sup> <a name="ready" id="cdk8s-plus-28.k8s.EndpointConditions.property.ready"></a>

```typescript
public readonly ready: boolean;
```

- *Type:* boolean

ready indicates that this endpoint is prepared to receive traffic, according to whatever system is managing the endpoint.

A nil value indicates an unknown state. In most cases consumers should interpret this unknown state as ready. For compatibility reasons, ready should never be "true" for terminating endpoints, except when the normal readiness behavior is being explicitly overridden, for example when the associated Service has set the publishNotReadyAddresses flag.

---

##### `serving`<sup>Optional</sup> <a name="serving" id="cdk8s-plus-28.k8s.EndpointConditions.property.serving"></a>

```typescript
public readonly serving: boolean;
```

- *Type:* boolean

serving is identical to ready except that it is set regardless of the terminating state of endpoints.

This condition should be set to true for a ready endpoint that is terminating. If nil, consumers should defer to the ready condition.

---

##### `terminating`<sup>Optional</sup> <a name="terminating" id="cdk8s-plus-28.k8s.EndpointConditions.property.terminating"></a>

```typescript
public readonly terminating: boolean;
```

- *Type:* boolean

terminating indicates that this endpoint is terminating.

A nil value indicates an unknown state. Consumers should interpret this unknown state to mean that the endpoint is not terminating.

---

### EndpointHints <a name="EndpointHints" id="cdk8s-plus-28.k8s.EndpointHints"></a>

EndpointHints provides hints describing how an endpoint should be consumed.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointHints.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpointHints: k8s.EndpointHints = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointHints.property.forZones">forZones</a></code> | <code>cdk8s-plus-28.k8s.ForZone[]</code> | forZones indicates the zone(s) this endpoint should be consumed by to enable topology aware routing. |

---

##### `forZones`<sup>Optional</sup> <a name="forZones" id="cdk8s-plus-28.k8s.EndpointHints.property.forZones"></a>

```typescript
public readonly forZones: ForZone[];
```

- *Type:* cdk8s-plus-28.k8s.ForZone[]

forZones indicates the zone(s) this endpoint should be consumed by to enable topology aware routing.

---

### EndpointPort <a name="EndpointPort" id="cdk8s-plus-28.k8s.EndpointPort"></a>

EndpointPort is a tuple that describes a single port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointPort.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpointPort: k8s.EndpointPort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.port">port</a></code> | <code>number</code> | The port number of the endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.appProtocol">appProtocol</a></code> | <code>string</code> | The application protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.name">name</a></code> | <code>string</code> | The name of this port. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointPort.property.protocol">protocol</a></code> | <code>string</code> | The IP protocol for this port. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.EndpointPort.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

The port number of the endpoint.

---

##### `appProtocol`<sup>Optional</sup> <a name="appProtocol" id="cdk8s-plus-28.k8s.EndpointPort.property.appProtocol"></a>

```typescript
public readonly appProtocol: string;
```

- *Type:* string

The application protocol for this port.

This is used as a hint for implementations to offer richer behavior for protocols that they understand. This field follows standard Kubernetes label syntax. Valid values are either:

* Un-prefixed protocol names - reserved for IANA standard service names (as per RFC-6335 and https://www.iana.org/assignments/service-names).

* Kubernetes-defined prefixed names:
* 'kubernetes.io/h2c' - HTTP/2 over cleartext as described in https://www.rfc-editor.org/rfc/rfc7540
* 'kubernetes.io/ws'  - WebSocket over cleartext as described in https://www.rfc-editor.org/rfc/rfc6455
* 'kubernetes.io/wss' - WebSocket over TLS as described in https://www.rfc-editor.org/rfc/rfc6455

* Other protocols should use implementation-defined prefixed names such as mycompany.com/my-custom-protocol.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.EndpointPort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this port.

This must match the 'name' field in the corresponding ServicePort. Must be a DNS_LABEL. Optional only if one port is defined.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.EndpointPort.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string
- *Default:* TCP.

The IP protocol for this port.

Must be UDP, TCP, or SCTP. Default is TCP.

---

### EndpointSubset <a name="EndpointSubset" id="cdk8s-plus-28.k8s.EndpointSubset"></a>

EndpointSubset is a group of addresses with a common set of ports.

The expanded set of endpoints is the Cartesian product of Addresses x Ports. For example, given:

{
Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
Ports:     [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
}

The resulting set of endpoints can be viewed as:

a: [ 10.10.1.1:8675, 10.10.2.2:8675 ],
b: [ 10.10.1.1:309, 10.10.2.2:309 ]

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EndpointSubset.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const endpointSubset: k8s.EndpointSubset = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.addresses">addresses</a></code> | <code>cdk8s-plus-28.k8s.EndpointAddress[]</code> | IP addresses which offer the related ports that are marked as ready. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.notReadyAddresses">notReadyAddresses</a></code> | <code>cdk8s-plus-28.k8s.EndpointAddress[]</code> | IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check. |
| <code><a href="#cdk8s-plus-28.k8s.EndpointSubset.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.EndpointPort[]</code> | Port numbers available on the related IP addresses. |

---

##### `addresses`<sup>Optional</sup> <a name="addresses" id="cdk8s-plus-28.k8s.EndpointSubset.property.addresses"></a>

```typescript
public readonly addresses: EndpointAddress[];
```

- *Type:* cdk8s-plus-28.k8s.EndpointAddress[]

IP addresses which offer the related ports that are marked as ready.

These endpoints should be considered safe for load balancers and clients to utilize.

---

##### `notReadyAddresses`<sup>Optional</sup> <a name="notReadyAddresses" id="cdk8s-plus-28.k8s.EndpointSubset.property.notReadyAddresses"></a>

```typescript
public readonly notReadyAddresses: EndpointAddress[];
```

- *Type:* cdk8s-plus-28.k8s.EndpointAddress[]

IP addresses which offer the related ports but are not currently marked as ready because they have not yet finished starting, have recently failed a readiness check, or have recently failed a liveness check.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.EndpointSubset.property.ports"></a>

```typescript
public readonly ports: EndpointPort[];
```

- *Type:* cdk8s-plus-28.k8s.EndpointPort[]

Port numbers available on the related IP addresses.

---

### EnvFromSource <a name="EnvFromSource" id="cdk8s-plus-28.k8s.EnvFromSource"></a>

EnvFromSource represents the source of a set of ConfigMaps.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvFromSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const envFromSource: k8s.EnvFromSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.configMapRef">configMapRef</a></code> | <code>cdk8s-plus-28.k8s.ConfigMapEnvSource</code> | The ConfigMap to select from. |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.prefix">prefix</a></code> | <code>string</code> | An optional identifier to prepend to each key in the ConfigMap. |
| <code><a href="#cdk8s-plus-28.k8s.EnvFromSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretEnvSource</code> | The Secret to select from. |

---

##### `configMapRef`<sup>Optional</sup> <a name="configMapRef" id="cdk8s-plus-28.k8s.EnvFromSource.property.configMapRef"></a>

```typescript
public readonly configMapRef: ConfigMapEnvSource;
```

- *Type:* cdk8s-plus-28.k8s.ConfigMapEnvSource

The ConfigMap to select from.

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.k8s.EnvFromSource.property.prefix"></a>

```typescript
public readonly prefix: string;
```

- *Type:* string

An optional identifier to prepend to each key in the ConfigMap.

Must be a C_IDENTIFIER.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.EnvFromSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretEnvSource;
```

- *Type:* cdk8s-plus-28.k8s.SecretEnvSource

The Secret to select from.

---

### EnvValueFromConfigMapOptions <a name="EnvValueFromConfigMapOptions" id="cdk8s-plus-28.EnvValueFromConfigMapOptions"></a>

Options to specify an envionment variable value from a ConfigMap key.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromConfigMapOptions.Initializer"></a>

```typescript
import { EnvValueFromConfigMapOptions } from 'cdk8s-plus-28'

const envValueFromConfigMapOptions: EnvValueFromConfigMapOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromConfigMapOptions.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the ConfigMap or its key must be defined. |

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValueFromConfigMapOptions.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean
- *Default:* false

Specify whether the ConfigMap or its key must be defined.

---

### EnvValueFromFieldRefOptions <a name="EnvValueFromFieldRefOptions" id="cdk8s-plus-28.EnvValueFromFieldRefOptions"></a>

Options to specify an environment variable value from a field reference.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.Initializer"></a>

```typescript
import { EnvValueFromFieldRefOptions } from 'cdk8s-plus-28'

const envValueFromFieldRefOptions: EnvValueFromFieldRefOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromFieldRefOptions.property.apiVersion">apiVersion</a></code> | <code>string</code> | Version of the schema the FieldPath is written in terms of. |
| <code><a href="#cdk8s-plus-28.EnvValueFromFieldRefOptions.property.key">key</a></code> | <code>string</code> | The key to select the pod label or annotation. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

Version of the schema the FieldPath is written in terms of.

---

##### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.EnvValueFromFieldRefOptions.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The key to select the pod label or annotation.

---

### EnvValueFromProcessOptions <a name="EnvValueFromProcessOptions" id="cdk8s-plus-28.EnvValueFromProcessOptions"></a>

Options to specify an environment variable value from the process environment.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromProcessOptions.Initializer"></a>

```typescript
import { EnvValueFromProcessOptions } from 'cdk8s-plus-28'

const envValueFromProcessOptions: EnvValueFromProcessOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromProcessOptions.property.required">required</a></code> | <code>boolean</code> | Specify whether the key must exist in the environment. |

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.EnvValueFromProcessOptions.property.required"></a>

```typescript
public readonly required: boolean;
```

- *Type:* boolean
- *Default:* false

Specify whether the key must exist in the environment.

If this is set to true, and the key does not exist, an error will thrown.

---

### EnvValueFromResourceOptions <a name="EnvValueFromResourceOptions" id="cdk8s-plus-28.EnvValueFromResourceOptions"></a>

Options to specify an environment variable value from a resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromResourceOptions.Initializer"></a>

```typescript
import { EnvValueFromResourceOptions } from 'cdk8s-plus-28'

const envValueFromResourceOptions: EnvValueFromResourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromResourceOptions.property.container">container</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a></code> | The container to select the value from. |
| <code><a href="#cdk8s-plus-28.EnvValueFromResourceOptions.property.divisor">divisor</a></code> | <code>string</code> | The output format of the exposed resource. |

---

##### `container`<sup>Optional</sup> <a name="container" id="cdk8s-plus-28.EnvValueFromResourceOptions.property.container"></a>

```typescript
public readonly container: Container;
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

The container to select the value from.

---

##### `divisor`<sup>Optional</sup> <a name="divisor" id="cdk8s-plus-28.EnvValueFromResourceOptions.property.divisor"></a>

```typescript
public readonly divisor: string;
```

- *Type:* string

The output format of the exposed resource.

---

### EnvValueFromSecretOptions <a name="EnvValueFromSecretOptions" id="cdk8s-plus-28.EnvValueFromSecretOptions"></a>

Options to specify an environment variable value from a Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EnvValueFromSecretOptions.Initializer"></a>

```typescript
import { EnvValueFromSecretOptions } from 'cdk8s-plus-28'

const envValueFromSecretOptions: EnvValueFromSecretOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValueFromSecretOptions.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the Secret or its key must be defined. |

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.EnvValueFromSecretOptions.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean
- *Default:* false

Specify whether the Secret or its key must be defined.

---

### EnvVar <a name="EnvVar" id="cdk8s-plus-28.k8s.EnvVar"></a>

EnvVar represents an environment variable present in a Container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvVar.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const envVar: k8s.EnvVar = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.name">name</a></code> | <code>string</code> | Name of the environment variable. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.value">value</a></code> | <code>string</code> | Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVar.property.valueFrom">valueFrom</a></code> | <code>cdk8s-plus-28.k8s.EnvVarSource</code> | Source for the environment variable's value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.EnvVar.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the environment variable.

Must be a C_IDENTIFIER.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.EnvVar.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string
- *Default:* .

Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables.

If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".

---

##### `valueFrom`<sup>Optional</sup> <a name="valueFrom" id="cdk8s-plus-28.k8s.EnvVar.property.valueFrom"></a>

```typescript
public readonly valueFrom: EnvVarSource;
```

- *Type:* cdk8s-plus-28.k8s.EnvVarSource

Source for the environment variable's value.

Cannot be used if value is not empty.

---

### EnvVarSource <a name="EnvVarSource" id="cdk8s-plus-28.k8s.EnvVarSource"></a>

EnvVarSource represents a source for the value of an EnvVar.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EnvVarSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const envVarSource: k8s.EnvVarSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.configMapKeyRef">configMapKeyRef</a></code> | <code>cdk8s-plus-28.k8s.ConfigMapKeySelector</code> | Selects a key of a ConfigMap. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.fieldRef">fieldRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectFieldSelector</code> | Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.resourceFieldRef">resourceFieldRef</a></code> | <code>cdk8s-plus-28.k8s.ResourceFieldSelector</code> | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported. |
| <code><a href="#cdk8s-plus-28.k8s.EnvVarSource.property.secretKeyRef">secretKeyRef</a></code> | <code>cdk8s-plus-28.k8s.SecretKeySelector</code> | Selects a key of a secret in the pod's namespace. |

---

##### `configMapKeyRef`<sup>Optional</sup> <a name="configMapKeyRef" id="cdk8s-plus-28.k8s.EnvVarSource.property.configMapKeyRef"></a>

```typescript
public readonly configMapKeyRef: ConfigMapKeySelector;
```

- *Type:* cdk8s-plus-28.k8s.ConfigMapKeySelector

Selects a key of a ConfigMap.

---

##### `fieldRef`<sup>Optional</sup> <a name="fieldRef" id="cdk8s-plus-28.k8s.EnvVarSource.property.fieldRef"></a>

```typescript
public readonly fieldRef: ObjectFieldSelector;
```

- *Type:* cdk8s-plus-28.k8s.ObjectFieldSelector

Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.

---

##### `resourceFieldRef`<sup>Optional</sup> <a name="resourceFieldRef" id="cdk8s-plus-28.k8s.EnvVarSource.property.resourceFieldRef"></a>

```typescript
public readonly resourceFieldRef: ResourceFieldSelector;
```

- *Type:* cdk8s-plus-28.k8s.ResourceFieldSelector

Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.

---

##### `secretKeyRef`<sup>Optional</sup> <a name="secretKeyRef" id="cdk8s-plus-28.k8s.EnvVarSource.property.secretKeyRef"></a>

```typescript
public readonly secretKeyRef: SecretKeySelector;
```

- *Type:* cdk8s-plus-28.k8s.SecretKeySelector

Selects a key of a secret in the pod's namespace.

---

### EphemeralContainer <a name="EphemeralContainer" id="cdk8s-plus-28.k8s.EphemeralContainer"></a>

An EphemeralContainer is a temporary container that you may add to an existing Pod for user-initiated activities such as debugging.

Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a Pod is removed or restarted. The kubelet may evict a Pod if an ephemeral container causes the Pod to exceed its resource allocation.

To add an ephemeral container, use the ephemeralcontainers subresource of an existing Pod. Ephemeral containers may not be removed or restarted.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EphemeralContainer.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ephemeralContainer: k8s.EphemeralContainer = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.name">name</a></code> | <code>string</code> | Name of the ephemeral container specified as a DNS_LABEL. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.args">args</a></code> | <code>string[]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.command">command</a></code> | <code>string[]</code> | Entrypoint array. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.env">env</a></code> | <code>cdk8s-plus-28.k8s.EnvVar[]</code> | List of environment variables to set in the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.envFrom">envFrom</a></code> | <code>cdk8s-plus-28.k8s.EnvFromSource[]</code> | List of sources to populate environment variables in the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.image">image</a></code> | <code>string</code> | Container image name. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.imagePullPolicy">imagePullPolicy</a></code> | <code>string</code> | Image pull policy. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.lifecycle">lifecycle</a></code> | <code>cdk8s-plus-28.k8s.Lifecycle</code> | Lifecycle is not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.livenessProbe">livenessProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.ContainerPort[]</code> | Ports are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.readinessProbe">readinessProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.resizePolicy">resizePolicy</a></code> | <code>cdk8s-plus-28.k8s.ContainerResizePolicy[]</code> | Resources resize policy for the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.resources">resources</a></code> | <code>cdk8s-plus-28.k8s.ResourceRequirements</code> | Resources are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.restartPolicy">restartPolicy</a></code> | <code>string</code> | Restart policy for the container to manage the restart behavior of each container within a pod. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.securityContext">securityContext</a></code> | <code>cdk8s-plus-28.k8s.SecurityContext</code> | Optional: SecurityContext defines the security options the ephemeral container should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.startupProbe">startupProbe</a></code> | <code>cdk8s-plus-28.k8s.Probe</code> | Probes are not allowed for ephemeral containers. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.stdin">stdin</a></code> | <code>boolean</code> | Whether this container should allocate a buffer for stdin in the container runtime. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.stdinOnce">stdinOnce</a></code> | <code>boolean</code> | Whether the container runtime should close the stdin channel after it has been opened by a single attach. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.targetContainerName">targetContainerName</a></code> | <code>string</code> | If set, the name of the container from PodSpec that this ephemeral container targets. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePath">terminationMessagePath</a></code> | <code>string</code> | Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePolicy">terminationMessagePolicy</a></code> | <code>string</code> | Indicate how the termination message should be populated. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.tty">tty</a></code> | <code>boolean</code> | Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.volumeDevices">volumeDevices</a></code> | <code>cdk8s-plus-28.k8s.VolumeDevice[]</code> | volumeDevices is the list of block devices to be used by the container. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.volumeMounts">volumeMounts</a></code> | <code>cdk8s-plus-28.k8s.VolumeMount[]</code> | Pod volumes to mount into the container's filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralContainer.property.workingDir">workingDir</a></code> | <code>string</code> | Container's working directory. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.EphemeralContainer.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the ephemeral container specified as a DNS_LABEL.

This name must be unique among all containers, init containers and ephemeral containers.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.k8s.EphemeralContainer.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Arguments to the entrypoint.

The image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.EphemeralContainer.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

Entrypoint array.

Not executed within a shell. The image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

---

##### `env`<sup>Optional</sup> <a name="env" id="cdk8s-plus-28.k8s.EphemeralContainer.property.env"></a>

```typescript
public readonly env: EnvVar[];
```

- *Type:* cdk8s-plus-28.k8s.EnvVar[]

List of environment variables to set in the container.

Cannot be updated.

---

##### `envFrom`<sup>Optional</sup> <a name="envFrom" id="cdk8s-plus-28.k8s.EphemeralContainer.property.envFrom"></a>

```typescript
public readonly envFrom: EnvFromSource[];
```

- *Type:* cdk8s-plus-28.k8s.EnvFromSource[]

List of sources to populate environment variables in the container.

The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

---

##### `image`<sup>Optional</sup> <a name="image" id="cdk8s-plus-28.k8s.EphemeralContainer.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

Container image name.

More info: https://kubernetes.io/docs/concepts/containers/images

---

##### `imagePullPolicy`<sup>Optional</sup> <a name="imagePullPolicy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.imagePullPolicy"></a>

```typescript
public readonly imagePullPolicy: string;
```

- *Type:* string
- *Default:* Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Image pull policy.

One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

---

##### `lifecycle`<sup>Optional</sup> <a name="lifecycle" id="cdk8s-plus-28.k8s.EphemeralContainer.property.lifecycle"></a>

```typescript
public readonly lifecycle: Lifecycle;
```

- *Type:* cdk8s-plus-28.k8s.Lifecycle

Lifecycle is not allowed for ephemeral containers.

---

##### `livenessProbe`<sup>Optional</sup> <a name="livenessProbe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.livenessProbe"></a>

```typescript
public readonly livenessProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.EphemeralContainer.property.ports"></a>

```typescript
public readonly ports: ContainerPort[];
```

- *Type:* cdk8s-plus-28.k8s.ContainerPort[]

Ports are not allowed for ephemeral containers.

---

##### `readinessProbe`<sup>Optional</sup> <a name="readinessProbe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.readinessProbe"></a>

```typescript
public readonly readinessProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `resizePolicy`<sup>Optional</sup> <a name="resizePolicy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.resizePolicy"></a>

```typescript
public readonly resizePolicy: ContainerResizePolicy[];
```

- *Type:* cdk8s-plus-28.k8s.ContainerResizePolicy[]

Resources resize policy for the container.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.EphemeralContainer.property.resources"></a>

```typescript
public readonly resources: ResourceRequirements;
```

- *Type:* cdk8s-plus-28.k8s.ResourceRequirements

Resources are not allowed for ephemeral containers.

Ephemeral containers use spare resources already allocated to the pod.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: string;
```

- *Type:* string

Restart policy for the container to manage the restart behavior of each container within a pod.

This may only be set for init containers. You cannot set this field on ephemeral containers.

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.k8s.EphemeralContainer.property.securityContext"></a>

```typescript
public readonly securityContext: SecurityContext;
```

- *Type:* cdk8s-plus-28.k8s.SecurityContext

Optional: SecurityContext defines the security options the ephemeral container should be run with.

If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext.

---

##### `startupProbe`<sup>Optional</sup> <a name="startupProbe" id="cdk8s-plus-28.k8s.EphemeralContainer.property.startupProbe"></a>

```typescript
public readonly startupProbe: Probe;
```

- *Type:* cdk8s-plus-28.k8s.Probe

Probes are not allowed for ephemeral containers.

---

##### `stdin`<sup>Optional</sup> <a name="stdin" id="cdk8s-plus-28.k8s.EphemeralContainer.property.stdin"></a>

```typescript
public readonly stdin: boolean;
```

- *Type:* boolean
- *Default:* false.

Whether this container should allocate a buffer for stdin in the container runtime.

If this is not set, reads from stdin in the container will always result in EOF. Default is false.

---

##### `stdinOnce`<sup>Optional</sup> <a name="stdinOnce" id="cdk8s-plus-28.k8s.EphemeralContainer.property.stdinOnce"></a>

```typescript
public readonly stdinOnce: boolean;
```

- *Type:* boolean
- *Default:* false

Whether the container runtime should close the stdin channel after it has been opened by a single attach.

When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

---

##### `targetContainerName`<sup>Optional</sup> <a name="targetContainerName" id="cdk8s-plus-28.k8s.EphemeralContainer.property.targetContainerName"></a>

```typescript
public readonly targetContainerName: string;
```

- *Type:* string

If set, the name of the container from PodSpec that this ephemeral container targets.

The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container. If not set then the ephemeral container uses the namespaces configured in the Pod spec.

The container runtime must implement support for this feature. If the runtime does not support namespace targeting then the result of setting this field is undefined.

---

##### `terminationMessagePath`<sup>Optional</sup> <a name="terminationMessagePath" id="cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePath"></a>

```typescript
public readonly terminationMessagePath: string;
```

- *Type:* string
- *Default:* dev/termination-log. Cannot be updated.

Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem.

Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

---

##### `terminationMessagePolicy`<sup>Optional</sup> <a name="terminationMessagePolicy" id="cdk8s-plus-28.k8s.EphemeralContainer.property.terminationMessagePolicy"></a>

```typescript
public readonly terminationMessagePolicy: string;
```

- *Type:* string
- *Default:* File. Cannot be updated.

Indicate how the termination message should be populated.

File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

---

##### `tty`<sup>Optional</sup> <a name="tty" id="cdk8s-plus-28.k8s.EphemeralContainer.property.tty"></a>

```typescript
public readonly tty: boolean;
```

- *Type:* boolean
- *Default:* false.

Whether this container should allocate a TTY for itself, also requires 'stdin' to be true.

Default is false.

---

##### `volumeDevices`<sup>Optional</sup> <a name="volumeDevices" id="cdk8s-plus-28.k8s.EphemeralContainer.property.volumeDevices"></a>

```typescript
public readonly volumeDevices: VolumeDevice[];
```

- *Type:* cdk8s-plus-28.k8s.VolumeDevice[]

volumeDevices is the list of block devices to be used by the container.

---

##### `volumeMounts`<sup>Optional</sup> <a name="volumeMounts" id="cdk8s-plus-28.k8s.EphemeralContainer.property.volumeMounts"></a>

```typescript
public readonly volumeMounts: VolumeMount[];
```

- *Type:* cdk8s-plus-28.k8s.VolumeMount[]

Pod volumes to mount into the container's filesystem.

Subpath mounts are not allowed for ephemeral containers. Cannot be updated.

---

##### `workingDir`<sup>Optional</sup> <a name="workingDir" id="cdk8s-plus-28.k8s.EphemeralContainer.property.workingDir"></a>

```typescript
public readonly workingDir: string;
```

- *Type:* string

Container's working directory.

If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

---

### EphemeralStorageResources <a name="EphemeralStorageResources" id="cdk8s-plus-28.EphemeralStorageResources"></a>

Emphemeral storage request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.EphemeralStorageResources.Initializer"></a>

```typescript
import { EphemeralStorageResources } from 'cdk8s-plus-28'

const ephemeralStorageResources: EphemeralStorageResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EphemeralStorageResources.property.limit">limit</a></code> | <code>cdk8s.Size</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EphemeralStorageResources.property.request">request</a></code> | <code>cdk8s.Size</code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.EphemeralStorageResources.property.limit"></a>

```typescript
public readonly limit: Size;
```

- *Type:* cdk8s.Size

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.EphemeralStorageResources.property.request"></a>

```typescript
public readonly request: Size;
```

- *Type:* cdk8s.Size

---

### EphemeralVolumeSource <a name="EphemeralVolumeSource" id="cdk8s-plus-28.k8s.EphemeralVolumeSource"></a>

Represents an ephemeral volume that is handled by a normal storage driver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EphemeralVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ephemeralVolumeSource: k8s.EphemeralVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EphemeralVolumeSource.property.volumeClaimTemplate">volumeClaimTemplate</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate</code> | Will be used to create a stand-alone PVC to provision the volume. |

---

##### `volumeClaimTemplate`<sup>Optional</sup> <a name="volumeClaimTemplate" id="cdk8s-plus-28.k8s.EphemeralVolumeSource.property.volumeClaimTemplate"></a>

```typescript
public readonly volumeClaimTemplate: PersistentVolumeClaimTemplate;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate

Will be used to create a stand-alone PVC to provision the volume.

The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).

An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.

This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.

Required, must not be nil.

---

### EventSeries <a name="EventSeries" id="cdk8s-plus-28.k8s.EventSeries"></a>

EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time. How often to update the EventSeries is up to the event reporters. The default event reporter in "k8s.io/client-go/tools/events/event_broadcaster.go" shows how this struct is updated on heartbeats and can guide customized reporter implementations.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EventSeries.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const eventSeries: k8s.EventSeries = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EventSeries.property.count">count</a></code> | <code>number</code> | count is the number of occurrences in this series up to the last heartbeat time. |
| <code><a href="#cdk8s-plus-28.k8s.EventSeries.property.lastObservedTime">lastObservedTime</a></code> | <code>Date</code> | lastObservedTime is the time when last Event from the series was seen before last heartbeat. |

---

##### `count`<sup>Required</sup> <a name="count" id="cdk8s-plus-28.k8s.EventSeries.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

count is the number of occurrences in this series up to the last heartbeat time.

---

##### `lastObservedTime`<sup>Required</sup> <a name="lastObservedTime" id="cdk8s-plus-28.k8s.EventSeries.property.lastObservedTime"></a>

```typescript
public readonly lastObservedTime: Date;
```

- *Type:* Date

lastObservedTime is the time when last Event from the series was seen before last heartbeat.

---

### EventSource <a name="EventSource" id="cdk8s-plus-28.k8s.EventSource"></a>

EventSource contains information for an event.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.EventSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const eventSource: k8s.EventSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.EventSource.property.component">component</a></code> | <code>string</code> | Component from which the event is generated. |
| <code><a href="#cdk8s-plus-28.k8s.EventSource.property.host">host</a></code> | <code>string</code> | Node name on which the event is generated. |

---

##### `component`<sup>Optional</sup> <a name="component" id="cdk8s-plus-28.k8s.EventSource.property.component"></a>

```typescript
public readonly component: string;
```

- *Type:* string

Component from which the event is generated.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.EventSource.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Node name on which the event is generated.

---

### ExecAction <a name="ExecAction" id="cdk8s-plus-28.k8s.ExecAction"></a>

ExecAction describes a "run in container" action.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExecAction.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const execAction: k8s.ExecAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExecAction.property.command">command</a></code> | <code>string[]</code> | Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. |

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.k8s.ExecAction.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem.

The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.

---

### ExemptPriorityLevelConfigurationV1Beta2 <a name="ExemptPriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2"></a>

ExemptPriorityLevelConfiguration describes the configurable aspects of the handling of exempt requests.

In the mandatory exempt configuration object the values in the fields here can be modified by authorized users, unlike the rest of the `spec`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const exemptPriorityLevelConfigurationV1Beta2: k8s.ExemptPriorityLevelConfigurationV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.lendablePercent">lendablePercent</a></code> | <code>number</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.nominalConcurrencyShares">nominalConcurrencyShares</a></code> | <code>number</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `lendablePercent`<sup>Optional</sup> <a name="lendablePercent" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.lendablePercent"></a>

```typescript
public readonly lendablePercent: number;
```

- *Type:* number

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

This value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `nominalConcurrencyShares`<sup>Optional</sup> <a name="nominalConcurrencyShares" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2.property.nominalConcurrencyShares"></a>

```typescript
public readonly nominalConcurrencyShares: number;
```

- *Type:* number

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats nominally reserved for this priority level. This DOES NOT limit the dispatching from this priority level but affects the other priority levels through the borrowing mechanism. The server's concurrency limit (ServerCL) is divided among all the priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of zero.

---

### ExemptPriorityLevelConfigurationV1Beta3 <a name="ExemptPriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3"></a>

ExemptPriorityLevelConfiguration describes the configurable aspects of the handling of exempt requests.

In the mandatory exempt configuration object the values in the fields here can be modified by authorized users, unlike the rest of the `spec`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const exemptPriorityLevelConfigurationV1Beta3: k8s.ExemptPriorityLevelConfigurationV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.lendablePercent">lendablePercent</a></code> | <code>number</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares">nominalConcurrencyShares</a></code> | <code>number</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `lendablePercent`<sup>Optional</sup> <a name="lendablePercent" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.lendablePercent"></a>

```typescript
public readonly lendablePercent: number;
```

- *Type:* number

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

This value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `nominalConcurrencyShares`<sup>Optional</sup> <a name="nominalConcurrencyShares" id="cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares"></a>

```typescript
public readonly nominalConcurrencyShares: number;
```

- *Type:* number

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats nominally reserved for this priority level. This DOES NOT limit the dispatching from this priority level but affects the other priority levels through the borrowing mechanism. The server's concurrency limit (ServerCL) is divided among all the priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of zero.

---

### ExposeDeploymentViaIngressOptions <a name="ExposeDeploymentViaIngressOptions" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions"></a>

Options for exposing a deployment via an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.Initializer"></a>

```typescript
import { ExposeDeploymentViaIngressOptions } from 'cdk8s-plus-28'

const exposeDeploymentViaIngressOptions: ExposeDeploymentViaIngressOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.name">name</a></code> | <code>string</code> | The name of the service to expose. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]</code> | The ports that the service should bind to. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.serviceType">serviceType</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | The type of the exposed service. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.Ingress">Ingress</a></code> | The ingress to add rules to. |
| <code><a href="#cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.pathType">pathType</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | The type of the path. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto generated.

The name of the service to expose.

If you'd like to expose the deployment multiple times,
you must explicitly set a name starting from the second expose call.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ports"></a>

```typescript
public readonly ports: ServicePort[];
```

- *Type:* <a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]
- *Default:* extracted from the deployment.

The ports that the service should bind to.

---

##### `serviceType`<sup>Optional</sup> <a name="serviceType" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.serviceType"></a>

```typescript
public readonly serviceType: ServiceType;
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ClusterIP.

The type of the exposed service.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.ingress"></a>

```typescript
public readonly ingress: Ingress;
```

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

##### `pathType`<sup>Optional</sup> <a name="pathType" id="cdk8s-plus-28.ExposeDeploymentViaIngressOptions.property.pathType"></a>

```typescript
public readonly pathType: HttpIngressPathType;
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

### ExposeServiceViaIngressOptions <a name="ExposeServiceViaIngressOptions" id="cdk8s-plus-28.ExposeServiceViaIngressOptions"></a>

Options for exposing a service using an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.Initializer"></a>

```typescript
import { ExposeServiceViaIngressOptions } from 'cdk8s-plus-28'

const exposeServiceViaIngressOptions: ExposeServiceViaIngressOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ExposeServiceViaIngressOptions.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.Ingress">Ingress</a></code> | The ingress to add rules to. |
| <code><a href="#cdk8s-plus-28.ExposeServiceViaIngressOptions.property.pathType">pathType</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | The type of the path. |

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.property.ingress"></a>

```typescript
public readonly ingress: Ingress;
```

- *Type:* <a href="#cdk8s-plus-28.Ingress">Ingress</a>
- *Default:* An ingress will be automatically created.

The ingress to add rules to.

---

##### `pathType`<sup>Optional</sup> <a name="pathType" id="cdk8s-plus-28.ExposeServiceViaIngressOptions.property.pathType"></a>

```typescript
public readonly pathType: HttpIngressPathType;
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>
- *Default:* HttpIngressPathType.PREFIX

The type of the path.

---

### ExternalDocumentation <a name="ExternalDocumentation" id="cdk8s-plus-28.k8s.ExternalDocumentation"></a>

ExternalDocumentation allows referencing an external resource for extended documentation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExternalDocumentation.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const externalDocumentation: k8s.ExternalDocumentation = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExternalDocumentation.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.ExternalDocumentation.property.url">url</a></code> | <code>string</code> | *No description.* |

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.ExternalDocumentation.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `url`<sup>Optional</sup> <a name="url" id="cdk8s-plus-28.k8s.ExternalDocumentation.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

---

### ExternalMetricSourceV2 <a name="ExternalMetricSourceV2" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2"></a>

ExternalMetricSource indicates how to scale on a metric not associated with any Kubernetes object (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const externalMetricSourceV2: k8s.ExternalMetricSourceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s-plus-28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.metric"></a>

```typescript
public readonly metric: MetricIdentifierV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ExternalMetricSourceV2.property.target"></a>

```typescript
public readonly target: MetricTargetV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### FcVolumeSource <a name="FcVolumeSource" id="cdk8s-plus-28.k8s.FcVolumeSource"></a>

Represents a Fibre Channel volume.

Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FcVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const fcVolumeSource: k8s.FcVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.lun">lun</a></code> | <code>number</code> | lun is Optional: FC target lun number. |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.targetWwNs">targetWwNs</a></code> | <code>string[]</code> | targetWWNs is Optional: FC target worldwide names (WWNs). |
| <code><a href="#cdk8s-plus-28.k8s.FcVolumeSource.property.wwids">wwids</a></code> | <code>string[]</code> | wwids Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously. |

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.FcVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `lun`<sup>Optional</sup> <a name="lun" id="cdk8s-plus-28.k8s.FcVolumeSource.property.lun"></a>

```typescript
public readonly lun: number;
```

- *Type:* number

lun is Optional: FC target lun number.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.FcVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly is Optional: Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `targetWwNs`<sup>Optional</sup> <a name="targetWwNs" id="cdk8s-plus-28.k8s.FcVolumeSource.property.targetWwNs"></a>

```typescript
public readonly targetWwNs: string[];
```

- *Type:* string[]

targetWWNs is Optional: FC target worldwide names (WWNs).

---

##### `wwids`<sup>Optional</sup> <a name="wwids" id="cdk8s-plus-28.k8s.FcVolumeSource.property.wwids"></a>

```typescript
public readonly wwids: string[];
```

- *Type:* string[]

wwids Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.

---

### FlexPersistentVolumeSource <a name="FlexPersistentVolumeSource" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource"></a>

FlexPersistentVolumeSource represents a generic persistent volume resource that is provisioned/attached using an exec based plugin.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flexPersistentVolumeSource: k8s.FlexPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.driver">driver</a></code> | <code>string</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the Filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.options">options</a></code> | <code>{[ key: string ]: string}</code> | options is Optional: this field holds extra command options if any. |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef is Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.driver"></a>

```typescript
public readonly driver: string;
```

- *Type:* string

driver is the name of the driver to use for this volume.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the Filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.options"></a>

```typescript
public readonly options: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

options is Optional: this field holds extra command options if any.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly is Optional: defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.FlexPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

secretRef is Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts.

This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

---

### FlexVolumeSource <a name="FlexVolumeSource" id="cdk8s-plus-28.k8s.FlexVolumeSource"></a>

FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlexVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flexVolumeSource: k8s.FlexVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.driver">driver</a></code> | <code>string</code> | driver is the name of the driver to use for this volume. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.options">options</a></code> | <code>{[ key: string ]: string}</code> | options is Optional: this field holds extra command options if any. |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly is Optional: defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.FlexVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef is Optional: secretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. |

---

##### `driver`<sup>Required</sup> <a name="driver" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.driver"></a>

```typescript
public readonly driver: string;
```

- *Type:* string

driver is the name of the driver to use for this volume.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.options"></a>

```typescript
public readonly options: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

options is Optional: this field holds extra command options if any.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly is Optional: defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.FlexVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef is Optional: secretRef is reference to the secret object containing sensitive information to pass to the plugin scripts.

This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

---

### FlockerVolumeSource <a name="FlockerVolumeSource" id="cdk8s-plus-28.k8s.FlockerVolumeSource"></a>

Represents a Flocker volume mounted by the Flocker agent.

One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlockerVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flockerVolumeSource: k8s.FlockerVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetName">datasetName</a></code> | <code>string</code> | datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetUuid">datasetUuid</a></code> | <code>string</code> | datasetUUID is the UUID of the dataset. |

---

##### `datasetName`<sup>Optional</sup> <a name="datasetName" id="cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetName"></a>

```typescript
public readonly datasetName: string;
```

- *Type:* string

datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated.

---

##### `datasetUuid`<sup>Optional</sup> <a name="datasetUuid" id="cdk8s-plus-28.k8s.FlockerVolumeSource.property.datasetUuid"></a>

```typescript
public readonly datasetUuid: string;
```

- *Type:* string

datasetUUID is the UUID of the dataset.

This is unique identifier of a Flocker dataset

---

### FlowDistinguisherMethodV1Beta2 <a name="FlowDistinguisherMethodV1Beta2" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2"></a>

FlowDistinguisherMethod specifies the method of a flow distinguisher.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flowDistinguisherMethodV1Beta2: k8s.FlowDistinguisherMethodV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.property.type">type</a></code> | <code>string</code> | `type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace". |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace".

Required.

---

### FlowDistinguisherMethodV1Beta3 <a name="FlowDistinguisherMethodV1Beta3" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3"></a>

FlowDistinguisherMethod specifies the method of a flow distinguisher.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flowDistinguisherMethodV1Beta3: k8s.FlowDistinguisherMethodV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.property.type">type</a></code> | <code>string</code> | `type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace". |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` is the type of flow distinguisher method The supported types are "ByUser" and "ByNamespace".

Required.

---

### FlowSchemaSpecV1Beta2 <a name="FlowSchemaSpecV1Beta2" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2"></a>

FlowSchemaSpec describes how the FlowSchema's specification looks like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flowSchemaSpecV1Beta2: k8s.FlowSchemaSpecV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.priorityLevelConfiguration">priorityLevelConfiguration</a></code> | <code>cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2</code> | `priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.distinguisherMethod">distinguisherMethod</a></code> | <code>cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2</code> | `distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.matchingPrecedence">matchingPrecedence</a></code> | <code>number</code> | `matchingPrecedence` is used to choose among the FlowSchemas that match a given request. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2[]</code> | `rules` describes which requests will match this flow schema. |

---

##### `priorityLevelConfiguration`<sup>Required</sup> <a name="priorityLevelConfiguration" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.priorityLevelConfiguration"></a>

```typescript
public readonly priorityLevelConfiguration: PriorityLevelConfigurationReferenceV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2

`priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster.

If the reference cannot be resolved, the FlowSchema will be ignored and marked as invalid in its status. Required.

---

##### `distinguisherMethod`<sup>Optional</sup> <a name="distinguisherMethod" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.distinguisherMethod"></a>

```typescript
public readonly distinguisherMethod: FlowDistinguisherMethodV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta2

`distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema.

`nil` specifies that the distinguisher is disabled and thus will always be the empty string.

---

##### `matchingPrecedence`<sup>Optional</sup> <a name="matchingPrecedence" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.matchingPrecedence"></a>

```typescript
public readonly matchingPrecedence: number;
```

- *Type:* number

`matchingPrecedence` is used to choose among the FlowSchemas that match a given request.

The chosen FlowSchema is among those with the numerically lowest (which we take to be logically highest) MatchingPrecedence.  Each MatchingPrecedence value must be ranged in [1,10000]. Note that if the precedence is not specified, it will be set to 1000 as default.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2.property.rules"></a>

```typescript
public readonly rules: PolicyRulesWithSubjectsV1Beta2[];
```

- *Type:* cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2[]

`rules` describes which requests will match this flow schema.

This FlowSchema matches a request if and only if at least one member of rules matches the request. if it is an empty slice, there will be no requests matching the FlowSchema.

---

### FlowSchemaSpecV1Beta3 <a name="FlowSchemaSpecV1Beta3" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3"></a>

FlowSchemaSpec describes how the FlowSchema's specification looks like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const flowSchemaSpecV1Beta3: k8s.FlowSchemaSpecV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.priorityLevelConfiguration">priorityLevelConfiguration</a></code> | <code>cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3</code> | `priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.distinguisherMethod">distinguisherMethod</a></code> | <code>cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3</code> | `distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.matchingPrecedence">matchingPrecedence</a></code> | <code>number</code> | `matchingPrecedence` is used to choose among the FlowSchemas that match a given request. |
| <code><a href="#cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3[]</code> | `rules` describes which requests will match this flow schema. |

---

##### `priorityLevelConfiguration`<sup>Required</sup> <a name="priorityLevelConfiguration" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.priorityLevelConfiguration"></a>

```typescript
public readonly priorityLevelConfiguration: PriorityLevelConfigurationReferenceV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3

`priorityLevelConfiguration` should reference a PriorityLevelConfiguration in the cluster.

If the reference cannot be resolved, the FlowSchema will be ignored and marked as invalid in its status. Required.

---

##### `distinguisherMethod`<sup>Optional</sup> <a name="distinguisherMethod" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.distinguisherMethod"></a>

```typescript
public readonly distinguisherMethod: FlowDistinguisherMethodV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.FlowDistinguisherMethodV1Beta3

`distinguisherMethod` defines how to compute the flow distinguisher for requests that match this schema.

`nil` specifies that the distinguisher is disabled and thus will always be the empty string.

---

##### `matchingPrecedence`<sup>Optional</sup> <a name="matchingPrecedence" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.matchingPrecedence"></a>

```typescript
public readonly matchingPrecedence: number;
```

- *Type:* number

`matchingPrecedence` is used to choose among the FlowSchemas that match a given request.

The chosen FlowSchema is among those with the numerically lowest (which we take to be logically highest) MatchingPrecedence.  Each MatchingPrecedence value must be ranged in [1,10000]. Note that if the precedence is not specified, it will be set to 1000 as default.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3.property.rules"></a>

```typescript
public readonly rules: PolicyRulesWithSubjectsV1Beta3[];
```

- *Type:* cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3[]

`rules` describes which requests will match this flow schema.

This FlowSchema matches a request if and only if at least one member of rules matches the request. if it is an empty slice, there will be no requests matching the FlowSchema.

---

### ForZone <a name="ForZone" id="cdk8s-plus-28.k8s.ForZone"></a>

ForZone provides information about which zones should consume this endpoint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ForZone.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const forZone: k8s.ForZone = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ForZone.property.name">name</a></code> | <code>string</code> | name represents the name of the zone. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ForZone.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name represents the name of the zone.

---

### FromServiceAccountNameOptions <a name="FromServiceAccountNameOptions" id="cdk8s-plus-28.FromServiceAccountNameOptions"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.FromServiceAccountNameOptions.Initializer"></a>

```typescript
import { FromServiceAccountNameOptions } from 'cdk8s-plus-28'

const fromServiceAccountNameOptions: FromServiceAccountNameOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.FromServiceAccountNameOptions.property.namespaceName">namespaceName</a></code> | <code>string</code> | The name of the namespace the service account belongs to. |

---

##### `namespaceName`<sup>Optional</sup> <a name="namespaceName" id="cdk8s-plus-28.FromServiceAccountNameOptions.property.namespaceName"></a>

```typescript
public readonly namespaceName: string;
```

- *Type:* string
- *Default:* "default"

The name of the namespace the service account belongs to.

---

### GCEPersistentDiskPersistentVolumeProps <a name="GCEPersistentDiskPersistentVolumeProps" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps"></a>

Properties for `GCEPersistentDiskPersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.Initializer"></a>

```typescript
import { GCEPersistentDiskPersistentVolumeProps } from 'cdk8s-plus-28'

const gCEPersistentDiskPersistentVolumeProps: GCEPersistentDiskPersistentVolumeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.pdName">pdName</a></code> | <code>string</code> | Unique name of the PD resource in GCE. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.partition">partition</a></code> | <code>number</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.readOnly">readOnly</a></code> | <code>boolean</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaimPolicy`<sup>Optional</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

##### `pdName`<sup>Required</sup> <a name="pdName" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.pdName"></a>

```typescript
public readonly pdName: string;
```

- *Type:* string

Unique name of the PD resource in GCE.

Used to identify the disk in GCE.

> [https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk](https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk)

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.GCEPersistentDiskPersistentVolumeProps.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### GCEPersistentDiskVolumeOptions <a name="GCEPersistentDiskVolumeOptions" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions"></a>

Options of `Volume.fromGcePersistentDisk`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.Initializer"></a>

```typescript
import { GCEPersistentDiskVolumeOptions } from 'cdk8s-plus-28'

const gCEPersistentDiskVolumeOptions: GCEPersistentDiskVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.fsType">fsType</a></code> | <code>string</code> | Filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.partition">partition</a></code> | <code>number</code> | The partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". |

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* 'ext4'

Filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system.

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number
- *Default:* No partition.

The partition in the volume that you want to mount.

If omitted, the default is to mount by volume name.
Examples: For volume /dev/sda1, you specify the partition as "1".
Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.GCEPersistentDiskVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Specify "true" to force and set the ReadOnly property in VolumeMounts to "true".

> [https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore](https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore)

---

### GcePersistentDiskVolumeSource <a name="GcePersistentDiskVolumeSource" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource"></a>

Represents a Persistent Disk resource in Google Compute Engine.

A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const gcePersistentDiskVolumeSource: k8s.GcePersistentDiskVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.pdName">pdName</a></code> | <code>string</code> | pdName is unique name of the PD resource in GCE. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.partition">partition</a></code> | <code>number</code> | partition is the partition in the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |

---

##### `pdName`<sup>Required</sup> <a name="pdName" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.pdName"></a>

```typescript
public readonly pdName: string;
```

- *Type:* string

pdName is unique name of the PD resource in GCE.

Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number

partition is the partition in the volume that you want to mount.

If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

### GitRepoVolumeSource <a name="GitRepoVolumeSource" id="cdk8s-plus-28.k8s.GitRepoVolumeSource"></a>

Represents a volume that is populated with the contents of a git repository.

Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.

DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const gitRepoVolumeSource: k8s.GitRepoVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.repository">repository</a></code> | <code>string</code> | repository is the URL. |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.directory">directory</a></code> | <code>string</code> | directory is the target directory name. |
| <code><a href="#cdk8s-plus-28.k8s.GitRepoVolumeSource.property.revision">revision</a></code> | <code>string</code> | revision is the commit hash for the specified revision. |

---

##### `repository`<sup>Required</sup> <a name="repository" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.repository"></a>

```typescript
public readonly repository: string;
```

- *Type:* string

repository is the URL.

---

##### `directory`<sup>Optional</sup> <a name="directory" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.directory"></a>

```typescript
public readonly directory: string;
```

- *Type:* string

directory is the target directory name.

Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.

---

##### `revision`<sup>Optional</sup> <a name="revision" id="cdk8s-plus-28.k8s.GitRepoVolumeSource.property.revision"></a>

```typescript
public readonly revision: string;
```

- *Type:* string

revision is the commit hash for the specified revision.

---

### GlusterfsPersistentVolumeSource <a name="GlusterfsPersistentVolumeSource" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource"></a>

Represents a Glusterfs mount that lasts the lifetime of a pod.

Glusterfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const glusterfsPersistentVolumeSource: k8s.GlusterfsPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpoints">endpoints</a></code> | <code>string</code> | endpoints is the endpoint name that details Glusterfs topology. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.path">path</a></code> | <code>string</code> | path is the Glusterfs volume path. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpointsNamespace">endpointsNamespace</a></code> | <code>string</code> | endpointsNamespace is the namespace that contains Glusterfs endpoint. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the Glusterfs volume to be mounted with read-only permissions. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpoints"></a>

```typescript
public readonly endpoints: string;
```

- *Type:* string

endpoints is the endpoint name that details Glusterfs topology.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is the Glusterfs volume path.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `endpointsNamespace`<sup>Optional</sup> <a name="endpointsNamespace" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.endpointsNamespace"></a>

```typescript
public readonly endpointsNamespace: string;
```

- *Type:* string

endpointsNamespace is the namespace that contains Glusterfs endpoint.

If this field is empty, the EndpointNamespace defaults to the same namespace as the bound PVC. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

readOnly here will force the Glusterfs volume to be mounted with read-only permissions.

Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

### GlusterfsVolumeSource <a name="GlusterfsVolumeSource" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource"></a>

Represents a Glusterfs mount that lasts the lifetime of a pod.

Glusterfs volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const glusterfsVolumeSource: k8s.GlusterfsVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.endpoints">endpoints</a></code> | <code>string</code> | endpoints is the endpoint name that details Glusterfs topology. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.path">path</a></code> | <code>string</code> | path is the Glusterfs volume path. |
| <code><a href="#cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the Glusterfs volume to be mounted with read-only permissions. |

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.endpoints"></a>

```typescript
public readonly endpoints: string;
```

- *Type:* string

endpoints is the endpoint name that details Glusterfs topology.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is the Glusterfs volume path.

More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.GlusterfsVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

readOnly here will force the Glusterfs volume to be mounted with read-only permissions.

Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

---

### GroupSubjectV1Beta2 <a name="GroupSubjectV1Beta2" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2"></a>

GroupSubject holds detailed information for group-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const groupSubjectV1Beta2: k8s.GroupSubjectV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GroupSubjectV1Beta2.property.name">name</a></code> | <code>string</code> | name is the user group that matches, or "*" to match all user groups. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the user group that matches, or "*" to match all user groups.

See https://github.com/kubernetes/apiserver/blob/master/pkg/authentication/user/user.go for some well-known group names. Required.

---

### GroupSubjectV1Beta3 <a name="GroupSubjectV1Beta3" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3"></a>

GroupSubject holds detailed information for group-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const groupSubjectV1Beta3: k8s.GroupSubjectV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GroupSubjectV1Beta3.property.name">name</a></code> | <code>string</code> | name is the user group that matches, or "*" to match all user groups. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.GroupSubjectV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the user group that matches, or "*" to match all user groups.

See https://github.com/kubernetes/apiserver/blob/master/pkg/authentication/user/user.go for some well-known group names. Required.

---

### GrpcAction <a name="GrpcAction" id="cdk8s-plus-28.k8s.GrpcAction"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.GrpcAction.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const grpcAction: k8s.GrpcAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.GrpcAction.property.port">port</a></code> | <code>number</code> | Port number of the gRPC service. |
| <code><a href="#cdk8s-plus-28.k8s.GrpcAction.property.service">service</a></code> | <code>string</code> | Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md). |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.GrpcAction.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

Port number of the gRPC service.

Number must be in the range 1 to 65535.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.GrpcAction.property.service"></a>

```typescript
public readonly service: string;
```

- *Type:* string

Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).

If this is not specified, the default behavior is defined by gRPC.

---

### HandlerFromHttpGetOptions <a name="HandlerFromHttpGetOptions" id="cdk8s-plus-28.HandlerFromHttpGetOptions"></a>

Options for `Handler.fromHttpGet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HandlerFromHttpGetOptions.Initializer"></a>

```typescript
import { HandlerFromHttpGetOptions } from 'cdk8s-plus-28'

const handlerFromHttpGetOptions: HandlerFromHttpGetOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HandlerFromHttpGetOptions.property.port">port</a></code> | <code>number</code> | The TCP port to use when sending the GET request. |

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HandlerFromHttpGetOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

### HandlerFromTcpSocketOptions <a name="HandlerFromTcpSocketOptions" id="cdk8s-plus-28.HandlerFromTcpSocketOptions"></a>

Options for `Handler.fromTcpSocket`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.Initializer"></a>

```typescript
import { HandlerFromTcpSocketOptions } from 'cdk8s-plus-28'

const handlerFromTcpSocketOptions: HandlerFromTcpSocketOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HandlerFromTcpSocketOptions.property.host">host</a></code> | <code>string</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.HandlerFromTcpSocketOptions.property.port">port</a></code> | <code>number</code> | The TCP port to connect to on the container. |

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HandlerFromTcpSocketOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---

### HorizontalPodAutoscalerBehaviorV2 <a name="HorizontalPodAutoscalerBehaviorV2" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2"></a>

HorizontalPodAutoscalerBehavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const horizontalPodAutoscalerBehaviorV2: k8s.HorizontalPodAutoscalerBehaviorV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleDown">scaleDown</a></code> | <code>cdk8s-plus-28.k8s.HpaScalingRulesV2</code> | scaleDown is scaling policy for scaling Down. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleUp">scaleUp</a></code> | <code>cdk8s-plus-28.k8s.HpaScalingRulesV2</code> | scaleUp is scaling policy for scaling Up. |

---

##### `scaleDown`<sup>Optional</sup> <a name="scaleDown" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleDown"></a>

```typescript
public readonly scaleDown: HpaScalingRulesV2;
```

- *Type:* cdk8s-plus-28.k8s.HpaScalingRulesV2

scaleDown is scaling policy for scaling Down.

If not set, the default value is to allow to scale down to minReplicas pods, with a 300 second stabilization window (i.e., the highest recommendation for the last 300sec is used).

---

##### `scaleUp`<sup>Optional</sup> <a name="scaleUp" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2.property.scaleUp"></a>

```typescript
public readonly scaleUp: HpaScalingRulesV2;
```

- *Type:* cdk8s-plus-28.k8s.HpaScalingRulesV2

scaleUp is scaling policy for scaling Up.

If not set, the default value is the higher of:
* increase no more than 4 pods per 60 seconds
* double the number of pods per 60 seconds
No stabilization is used.

---

### HorizontalPodAutoscalerProps <a name="HorizontalPodAutoscalerProps" id="cdk8s-plus-28.HorizontalPodAutoscalerProps"></a>

Properties for HorizontalPodAutoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.Initializer"></a>

```typescript
import { HorizontalPodAutoscalerProps } from 'cdk8s-plus-28'

const horizontalPodAutoscalerProps: HorizontalPodAutoscalerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.maxReplicas">maxReplicas</a></code> | <code>number</code> | The maximum number of replicas that can be scaled up to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.IScalable">IScalable</a></code> | The workload to scale up or down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metrics">metrics</a></code> | <code><a href="#cdk8s-plus-28.Metric">Metric</a>[]</code> | The metric conditions that trigger a scale up or scale down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.minReplicas">minReplicas</a></code> | <code>number</code> | The minimum number of replicas that can be scaled down to. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleDown">scaleDown</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling down. |
| <code><a href="#cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleUp">scaleUp</a></code> | <code><a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a></code> | The scaling behavior when scaling up. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `maxReplicas`<sup>Required</sup> <a name="maxReplicas" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.maxReplicas"></a>

```typescript
public readonly maxReplicas: number;
```

- *Type:* number

The maximum number of replicas that can be scaled up to.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.target"></a>

```typescript
public readonly target: IScalable;
```

- *Type:* <a href="#cdk8s-plus-28.IScalable">IScalable</a>

The workload to scale up or down.

Scalable workload types:
* Deployment
* StatefulSet

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.metrics"></a>

```typescript
public readonly metrics: Metric[];
```

- *Type:* <a href="#cdk8s-plus-28.Metric">Metric</a>[]
- *Default:* If metrics are not provided, then the target resource constraints (e.g. cpu limit) will be used as scaling metrics.

The metric conditions that trigger a scale up or scale down.

---

##### `minReplicas`<sup>Optional</sup> <a name="minReplicas" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.minReplicas"></a>

```typescript
public readonly minReplicas: number;
```

- *Type:* number
- *Default:* 1

The minimum number of replicas that can be scaled down to.

Can be set to 0 if the alpha feature gate `HPAScaleToZero` is enabled and
at least one Object or External metric is configured.

---

##### `scaleDown`<sup>Optional</sup> <a name="scaleDown" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleDown"></a>

```typescript
public readonly scaleDown: ScalingRules;
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Scale down to minReplica count with a 5 minute stabilization window.

The scaling behavior when scaling down.

---

##### `scaleUp`<sup>Optional</sup> <a name="scaleUp" id="cdk8s-plus-28.HorizontalPodAutoscalerProps.property.scaleUp"></a>

```typescript
public readonly scaleUp: ScalingRules;
```

- *Type:* <a href="#cdk8s-plus-28.ScalingRules">ScalingRules</a>
- *Default:* Is the higher of: * Increase no more than 4 pods per 60 seconds * Double the number of pods per 60 seconds

The scaling behavior when scaling up.

---

### HorizontalPodAutoscalerSpec <a name="HorizontalPodAutoscalerSpec" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec"></a>

specification of a horizontal pod autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const horizontalPodAutoscalerSpec: k8s.HorizontalPodAutoscalerSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.maxReplicas">maxReplicas</a></code> | <code>number</code> | maxReplicas is the upper limit for the number of pods that can be set by the autoscaler; |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.scaleTargetRef">scaleTargetRef</a></code> | <code>cdk8s-plus-28.k8s.CrossVersionObjectReference</code> | reference to scaled resource; |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.minReplicas">minReplicas</a></code> | <code>number</code> | minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.targetCpuUtilizationPercentage">targetCpuUtilizationPercentage</a></code> | <code>number</code> | targetCPUUtilizationPercentage is the target average CPU utilization (represented as a percentage of requested CPU) over all the pods; |

---

##### `maxReplicas`<sup>Required</sup> <a name="maxReplicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.maxReplicas"></a>

```typescript
public readonly maxReplicas: number;
```

- *Type:* number

maxReplicas is the upper limit for the number of pods that can be set by the autoscaler;

cannot be smaller than MinReplicas.

---

##### `scaleTargetRef`<sup>Required</sup> <a name="scaleTargetRef" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.scaleTargetRef"></a>

```typescript
public readonly scaleTargetRef: CrossVersionObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.CrossVersionObjectReference

reference to scaled resource;

horizontal pod autoscaler will learn the current resource consumption and will set the desired number of pods by using its Scale subresource.

---

##### `minReplicas`<sup>Optional</sup> <a name="minReplicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.minReplicas"></a>

```typescript
public readonly minReplicas: number;
```

- *Type:* number

minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down.

It defaults to 1 pod.  minReplicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured.  Scaling is active as long as at least one metric value is available.

---

##### `targetCpuUtilizationPercentage`<sup>Optional</sup> <a name="targetCpuUtilizationPercentage" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec.property.targetCpuUtilizationPercentage"></a>

```typescript
public readonly targetCpuUtilizationPercentage: number;
```

- *Type:* number

targetCPUUtilizationPercentage is the target average CPU utilization (represented as a percentage of requested CPU) over all the pods;

if not specified the default autoscaling policy will be used.

---

### HorizontalPodAutoscalerSpecV2 <a name="HorizontalPodAutoscalerSpecV2" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2"></a>

HorizontalPodAutoscalerSpec describes the desired functionality of the HorizontalPodAutoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const horizontalPodAutoscalerSpecV2: k8s.HorizontalPodAutoscalerSpecV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.maxReplicas">maxReplicas</a></code> | <code>number</code> | maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.scaleTargetRef">scaleTargetRef</a></code> | <code>cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2</code> | scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.behavior">behavior</a></code> | <code>cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2</code> | behavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively). |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.metrics">metrics</a></code> | <code>cdk8s-plus-28.k8s.MetricSpecV2[]</code> | metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used). |
| <code><a href="#cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.minReplicas">minReplicas</a></code> | <code>number</code> | minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down. |

---

##### `maxReplicas`<sup>Required</sup> <a name="maxReplicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.maxReplicas"></a>

```typescript
public readonly maxReplicas: number;
```

- *Type:* number

maxReplicas is the upper limit for the number of replicas to which the autoscaler can scale up.

It cannot be less that minReplicas.

---

##### `scaleTargetRef`<sup>Required</sup> <a name="scaleTargetRef" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.scaleTargetRef"></a>

```typescript
public readonly scaleTargetRef: CrossVersionObjectReferenceV2;
```

- *Type:* cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2

scaleTargetRef points to the target resource to scale, and is used to the pods for which metrics should be collected, as well as to actually change the replica count.

---

##### `behavior`<sup>Optional</sup> <a name="behavior" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.behavior"></a>

```typescript
public readonly behavior: HorizontalPodAutoscalerBehaviorV2;
```

- *Type:* cdk8s-plus-28.k8s.HorizontalPodAutoscalerBehaviorV2

behavior configures the scaling behavior of the target in both Up and Down directions (scaleUp and scaleDown fields respectively).

If not set, the default HPAScalingRules for scale up and scale down are used.

---

##### `metrics`<sup>Optional</sup> <a name="metrics" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.metrics"></a>

```typescript
public readonly metrics: MetricSpecV2[];
```

- *Type:* cdk8s-plus-28.k8s.MetricSpecV2[]

metrics contains the specifications for which to use to calculate the desired replica count (the maximum replica count across all metrics will be used).

The desired replica count is calculated multiplying the ratio between the target value and the current value by the current number of pods.  Ergo, metrics used must decrease as the pod count is increased, and vice-versa.  See the individual metric source types for more information about how each type of metric must respond. If not set, the default metric will be set to 80% average CPU utilization.

---

##### `minReplicas`<sup>Optional</sup> <a name="minReplicas" id="cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2.property.minReplicas"></a>

```typescript
public readonly minReplicas: number;
```

- *Type:* number

minReplicas is the lower limit for the number of replicas to which the autoscaler can scale down.

It defaults to 1 pod.  minReplicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured.  Scaling is active as long as at least one metric value is available.

---

### HostAlias <a name="HostAlias" id="cdk8s-plus-28.HostAlias"></a>

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's /etc/hosts file.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HostAlias.Initializer"></a>

```typescript
import { HostAlias } from 'cdk8s-plus-28'

const hostAlias: HostAlias = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HostAlias.property.hostnames">hostnames</a></code> | <code>string[]</code> | Hostnames for the chosen IP address. |
| <code><a href="#cdk8s-plus-28.HostAlias.property.ip">ip</a></code> | <code>string</code> | IP address of the host file entry. |

---

##### `hostnames`<sup>Required</sup> <a name="hostnames" id="cdk8s-plus-28.HostAlias.property.hostnames"></a>

```typescript
public readonly hostnames: string[];
```

- *Type:* string[]

Hostnames for the chosen IP address.

---

##### `ip`<sup>Required</sup> <a name="ip" id="cdk8s-plus-28.HostAlias.property.ip"></a>

```typescript
public readonly ip: string;
```

- *Type:* string

IP address of the host file entry.

---

### HostAlias <a name="HostAlias" id="cdk8s-plus-28.k8s.HostAlias"></a>

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HostAlias.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const hostAlias: k8s.HostAlias = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HostAlias.property.hostnames">hostnames</a></code> | <code>string[]</code> | Hostnames for the above IP address. |
| <code><a href="#cdk8s-plus-28.k8s.HostAlias.property.ip">ip</a></code> | <code>string</code> | IP address of the host file entry. |

---

##### `hostnames`<sup>Optional</sup> <a name="hostnames" id="cdk8s-plus-28.k8s.HostAlias.property.hostnames"></a>

```typescript
public readonly hostnames: string[];
```

- *Type:* string[]

Hostnames for the above IP address.

---

##### `ip`<sup>Optional</sup> <a name="ip" id="cdk8s-plus-28.k8s.HostAlias.property.ip"></a>

```typescript
public readonly ip: string;
```

- *Type:* string

IP address of the host file entry.

---

### HostPathVolumeOptions <a name="HostPathVolumeOptions" id="cdk8s-plus-28.HostPathVolumeOptions"></a>

Options for a HostPathVolume-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HostPathVolumeOptions.Initializer"></a>

```typescript
import { HostPathVolumeOptions } from 'cdk8s-plus-28'

const hostPathVolumeOptions: HostPathVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HostPathVolumeOptions.property.path">path</a></code> | <code>string</code> | The path of the directory on the host. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeOptions.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.HostPathVolumeType">HostPathVolumeType</a></code> | The expected type of the path found on the host. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.HostPathVolumeOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

The path of the directory on the host.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.HostPathVolumeOptions.property.type"></a>

```typescript
public readonly type: HostPathVolumeType;
```

- *Type:* <a href="#cdk8s-plus-28.HostPathVolumeType">HostPathVolumeType</a>
- *Default:* HostPathVolumeType.DEFAULT

The expected type of the path found on the host.

---

### HostPathVolumeSource <a name="HostPathVolumeSource" id="cdk8s-plus-28.k8s.HostPathVolumeSource"></a>

Represents a host path mapped into a pod.

Host path volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HostPathVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const hostPathVolumeSource: k8s.HostPathVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HostPathVolumeSource.property.path">path</a></code> | <code>string</code> | path of the directory on the host. |
| <code><a href="#cdk8s-plus-28.k8s.HostPathVolumeSource.property.type">type</a></code> | <code>string</code> | type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.HostPathVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path of the directory on the host.

If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.HostPathVolumeSource.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath.

---

### HpaScalingPolicyV2 <a name="HpaScalingPolicyV2" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2"></a>

HPAScalingPolicy is a single policy which must hold true for a specified past interval.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const hpaScalingPolicyV2: k8s.HpaScalingPolicyV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.periodSeconds">periodSeconds</a></code> | <code>number</code> | periodSeconds specifies the window of time for which the policy should hold true. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.type">type</a></code> | <code>string</code> | type is used to specify the scaling policy. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.value">value</a></code> | <code>number</code> | value contains the amount of change which is permitted by the policy. |

---

##### `periodSeconds`<sup>Required</sup> <a name="periodSeconds" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: number;
```

- *Type:* number

periodSeconds specifies the window of time for which the policy should hold true.

PeriodSeconds must be greater than zero and less than or equal to 1800 (30 min).

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type is used to specify the scaling policy.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.HpaScalingPolicyV2.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* number

value contains the amount of change which is permitted by the policy.

It must be greater than zero

---

### HpaScalingRulesV2 <a name="HpaScalingRulesV2" id="cdk8s-plus-28.k8s.HpaScalingRulesV2"></a>

HPAScalingRules configures the scaling behavior for one direction.

These Rules are applied after calculating DesiredReplicas from metrics for the HPA. They can limit the scaling velocity by specifying scaling policies. They can prevent flapping by specifying the stabilization window, so that the number of replicas is not set instantly, instead, the safest value from the stabilization window is chosen.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const hpaScalingRulesV2: k8s.HpaScalingRulesV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.policies">policies</a></code> | <code>cdk8s-plus-28.k8s.HpaScalingPolicyV2[]</code> | policies is a list of potential scaling polices which can be used during scaling. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.selectPolicy">selectPolicy</a></code> | <code>string</code> | selectPolicy is used to specify which policy should be used. |
| <code><a href="#cdk8s-plus-28.k8s.HpaScalingRulesV2.property.stabilizationWindowSeconds">stabilizationWindowSeconds</a></code> | <code>number</code> | stabilizationWindowSeconds is the number of seconds for which past recommendations should be considered while scaling up or scaling down. |

---

##### `policies`<sup>Optional</sup> <a name="policies" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.policies"></a>

```typescript
public readonly policies: HpaScalingPolicyV2[];
```

- *Type:* cdk8s-plus-28.k8s.HpaScalingPolicyV2[]

policies is a list of potential scaling polices which can be used during scaling.

At least one policy must be specified, otherwise the HPAScalingRules will be discarded as invalid

---

##### `selectPolicy`<sup>Optional</sup> <a name="selectPolicy" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.selectPolicy"></a>

```typescript
public readonly selectPolicy: string;
```

- *Type:* string

selectPolicy is used to specify which policy should be used.

If not set, the default value Max is used.

---

##### `stabilizationWindowSeconds`<sup>Optional</sup> <a name="stabilizationWindowSeconds" id="cdk8s-plus-28.k8s.HpaScalingRulesV2.property.stabilizationWindowSeconds"></a>

```typescript
public readonly stabilizationWindowSeconds: number;
```

- *Type:* number

stabilizationWindowSeconds is the number of seconds for which past recommendations should be considered while scaling up or scaling down.

StabilizationWindowSeconds must be greater than or equal to zero and less than or equal to 3600 (one hour). If not set, use the default values: - For scale up: 0 (i.e. no stabilization is done). - For scale down: 300 (i.e. the stabilization window is 300 seconds long).

---

### HttpGetAction <a name="HttpGetAction" id="cdk8s-plus-28.k8s.HttpGetAction"></a>

HTTPGetAction describes an action based on HTTP Get requests.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpGetAction.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const httpGetAction: k8s.HttpGetAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.port">port</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | Name or number of the port to access on the container. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.host">host</a></code> | <code>string</code> | Host name to connect to, defaults to the pod IP. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.httpHeaders">httpHeaders</a></code> | <code>cdk8s-plus-28.k8s.HttpHeader[]</code> | Custom headers to set in the request. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.path">path</a></code> | <code>string</code> | Path to access on the HTTP server. |
| <code><a href="#cdk8s-plus-28.k8s.HttpGetAction.property.scheme">scheme</a></code> | <code>string</code> | Scheme to use for connecting to the host. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.HttpGetAction.property.port"></a>

```typescript
public readonly port: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

Name or number of the port to access on the container.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.HttpGetAction.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Host name to connect to, defaults to the pod IP.

You probably want to set "Host" in httpHeaders instead.

---

##### `httpHeaders`<sup>Optional</sup> <a name="httpHeaders" id="cdk8s-plus-28.k8s.HttpGetAction.property.httpHeaders"></a>

```typescript
public readonly httpHeaders: HttpHeader[];
```

- *Type:* cdk8s-plus-28.k8s.HttpHeader[]

Custom headers to set in the request.

HTTP allows repeated headers.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.HttpGetAction.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Path to access on the HTTP server.

---

##### `scheme`<sup>Optional</sup> <a name="scheme" id="cdk8s-plus-28.k8s.HttpGetAction.property.scheme"></a>

```typescript
public readonly scheme: string;
```

- *Type:* string
- *Default:* HTTP.

Scheme to use for connecting to the host.

Defaults to HTTP.

---

### HttpGetProbeOptions <a name="HttpGetProbeOptions" id="cdk8s-plus-28.HttpGetProbeOptions"></a>

Options for `Probe.fromHttpGet()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.HttpGetProbeOptions.Initializer"></a>

```typescript
import { HttpGetProbeOptions } from 'cdk8s-plus-28'

const httpGetProbeOptions: HttpGetProbeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.failureThreshold">failureThreshold</a></code> | <code>number</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.initialDelaySeconds">initialDelaySeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.periodSeconds">periodSeconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.successThreshold">successThreshold</a></code> | <code>number</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.timeoutSeconds">timeoutSeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.host">host</a></code> | <code>string</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.port">port</a></code> | <code>number</code> | The TCP port to use when sending the GET request. |
| <code><a href="#cdk8s-plus-28.HttpGetProbeOptions.property.scheme">scheme</a></code> | <code><a href="#cdk8s-plus-28.ConnectionScheme">ConnectionScheme</a></code> | Scheme to use for connecting to the host (HTTP or HTTPS). |

---

##### `failureThreshold`<sup>Optional</sup> <a name="failureThreshold" id="cdk8s-plus-28.HttpGetProbeOptions.property.failureThreshold"></a>

```typescript
public readonly failureThreshold: number;
```

- *Type:* number
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initialDelaySeconds`<sup>Optional</sup> <a name="initialDelaySeconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.initialDelaySeconds"></a>

```typescript
public readonly initialDelaySeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `periodSeconds`<sup>Optional</sup> <a name="periodSeconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `successThreshold`<sup>Optional</sup> <a name="successThreshold" id="cdk8s-plus-28.HttpGetProbeOptions.property.successThreshold"></a>

```typescript
public readonly successThreshold: number;
```

- *Type:* number
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.HttpGetProbeOptions.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.HttpGetProbeOptions.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.HttpGetProbeOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* defaults to `container.port`.

The TCP port to use when sending the GET request.

---

##### `scheme`<sup>Optional</sup> <a name="scheme" id="cdk8s-plus-28.HttpGetProbeOptions.property.scheme"></a>

```typescript
public readonly scheme: ConnectionScheme;
```

- *Type:* <a href="#cdk8s-plus-28.ConnectionScheme">ConnectionScheme</a>
- *Default:* ConnectionScheme.HTTP

Scheme to use for connecting to the host (HTTP or HTTPS).

---

### HttpHeader <a name="HttpHeader" id="cdk8s-plus-28.k8s.HttpHeader"></a>

HTTPHeader describes a custom header to be used in HTTP probes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpHeader.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const httpHeader: k8s.HttpHeader = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpHeader.property.name">name</a></code> | <code>string</code> | The header field name. |
| <code><a href="#cdk8s-plus-28.k8s.HttpHeader.property.value">value</a></code> | <code>string</code> | The header field value. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.HttpHeader.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The header field name.

This will be canonicalized upon output, so case-variant names will be understood as the same header.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.HttpHeader.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The header field value.

---

### HttpIngressPath <a name="HttpIngressPath" id="cdk8s-plus-28.k8s.HttpIngressPath"></a>

HTTPIngressPath associates a path with a backend.

Incoming urls matching the path are forwarded to the backend.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpIngressPath.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const httpIngressPath: k8s.HttpIngressPath = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.backend">backend</a></code> | <code>cdk8s-plus-28.k8s.IngressBackend</code> | backend defines the referenced service endpoint to which the traffic will be forwarded to. |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.pathType">pathType</a></code> | <code>string</code> | pathType determines the interpretation of the path matching. |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressPath.property.path">path</a></code> | <code>string</code> | path is matched against the path of an incoming request. |

---

##### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.k8s.HttpIngressPath.property.backend"></a>

```typescript
public readonly backend: IngressBackend;
```

- *Type:* cdk8s-plus-28.k8s.IngressBackend

backend defines the referenced service endpoint to which the traffic will be forwarded to.

---

##### `pathType`<sup>Required</sup> <a name="pathType" id="cdk8s-plus-28.k8s.HttpIngressPath.property.pathType"></a>

```typescript
public readonly pathType: string;
```

- *Type:* string

pathType determines the interpretation of the path matching.

PathType can be one of the following values: * Exact: Matches the URL path exactly. * Prefix: Matches based on a URL path prefix split by '/'. Matching is
done on a path element by element basis. A path element refers is the
list of labels in the path split by the '/' separator. A request is a
match for path p if every p is an element-wise prefix of p of the
request path. Note that if the last element of the path is a substring
of the last element in request path, it is not a match (e.g. /foo/bar
matches /foo/bar/baz, but does not match /foo/barbaz).
* ImplementationSpecific: Interpretation of the Path matching is up to
the IngressClass. Implementations can treat this as a separate PathType
or treat it identically to Prefix or Exact path types.
Implementations are required to support all path types.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.HttpIngressPath.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is matched against the path of an incoming request.

Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/' and must be present when using PathType with value "Exact" or "Prefix".

---

### HttpIngressRuleValue <a name="HttpIngressRuleValue" id="cdk8s-plus-28.k8s.HttpIngressRuleValue"></a>

HTTPIngressRuleValue is a list of http selectors pointing to backends.

In the example: http://<host>/<path>?<searchpart> -> backend where where parts of the url correspond to RFC 3986, this resource will be used to match against everything after the last '/' and before the first '?' or '#'.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.HttpIngressRuleValue.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const httpIngressRuleValue: k8s.HttpIngressRuleValue = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.HttpIngressRuleValue.property.paths">paths</a></code> | <code>cdk8s-plus-28.k8s.HttpIngressPath[]</code> | paths is a collection of paths that map requests to backends. |

---

##### `paths`<sup>Required</sup> <a name="paths" id="cdk8s-plus-28.k8s.HttpIngressRuleValue.property.paths"></a>

```typescript
public readonly paths: HttpIngressPath[];
```

- *Type:* cdk8s-plus-28.k8s.HttpIngressPath[]

paths is a collection of paths that map requests to backends.

---

### IngressBackend <a name="IngressBackend" id="cdk8s-plus-28.k8s.IngressBackend"></a>

IngressBackend describes all endpoints for a given service and port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressBackend.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressBackend: k8s.IngressBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressBackend.property.resource">resource</a></code> | <code>cdk8s-plus-28.k8s.TypedLocalObjectReference</code> | resource is an ObjectRef to another Kubernetes resource in the namespace of the Ingress object. |
| <code><a href="#cdk8s-plus-28.k8s.IngressBackend.property.service">service</a></code> | <code>cdk8s-plus-28.k8s.IngressServiceBackend</code> | service references a service as a backend. |

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.IngressBackend.property.resource"></a>

```typescript
public readonly resource: TypedLocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.TypedLocalObjectReference

resource is an ObjectRef to another Kubernetes resource in the namespace of the Ingress object.

If resource is specified, a service.Name and service.Port must not be specified. This is a mutually exclusive setting with "Service".

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.IngressBackend.property.service"></a>

```typescript
public readonly service: IngressServiceBackend;
```

- *Type:* cdk8s-plus-28.k8s.IngressServiceBackend

service references a service as a backend.

This is a mutually exclusive setting with "Resource".

---

### IngressClassParametersReference <a name="IngressClassParametersReference" id="cdk8s-plus-28.k8s.IngressClassParametersReference"></a>

IngressClassParametersReference identifies an API object.

This can be used to specify a cluster or namespace-scoped resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressClassParametersReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressClassParametersReference: k8s.IngressClassParametersReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.kind">kind</a></code> | <code>string</code> | kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.name">name</a></code> | <code>string</code> | name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.apiGroup">apiGroup</a></code> | <code>string</code> | apiGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.namespace">namespace</a></code> | <code>string</code> | namespace is the namespace of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassParametersReference.property.scope">scope</a></code> | <code>string</code> | scope represents if this refers to a cluster or namespace scoped resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of resource being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

apiGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

namespace is the namespace of the resource being referenced.

This field is required when scope is set to "Namespace" and must be unset when scope is set to "Cluster".

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.IngressClassParametersReference.property.scope"></a>

```typescript
public readonly scope: string;
```

- *Type:* string

scope represents if this refers to a cluster or namespace scoped resource.

This may be set to "Cluster" (default) or "Namespace".

---

### IngressClassSpec <a name="IngressClassSpec" id="cdk8s-plus-28.k8s.IngressClassSpec"></a>

IngressClassSpec provides information about the class of an Ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressClassSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressClassSpec: k8s.IngressClassSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassSpec.property.controller">controller</a></code> | <code>string</code> | controller refers to the name of the controller that should handle this class. |
| <code><a href="#cdk8s-plus-28.k8s.IngressClassSpec.property.parameters">parameters</a></code> | <code>cdk8s-plus-28.k8s.IngressClassParametersReference</code> | parameters is a link to a custom resource containing additional configuration for the controller. |

---

##### `controller`<sup>Optional</sup> <a name="controller" id="cdk8s-plus-28.k8s.IngressClassSpec.property.controller"></a>

```typescript
public readonly controller: string;
```

- *Type:* string

controller refers to the name of the controller that should handle this class.

This allows for different "flavors" that are controlled by the same controller. For example, you may have different parameters for the same implementing controller. This should be specified as a domain-prefixed path no more than 250 characters in length, e.g. "acme.io/ingress-controller". This field is immutable.

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.IngressClassSpec.property.parameters"></a>

```typescript
public readonly parameters: IngressClassParametersReference;
```

- *Type:* cdk8s-plus-28.k8s.IngressClassParametersReference

parameters is a link to a custom resource containing additional configuration for the controller.

This is optional if the controller does not require extra parameters.

---

### IngressProps <a name="IngressProps" id="cdk8s-plus-28.IngressProps"></a>

Properties for `Ingress`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressProps.Initializer"></a>

```typescript
import { IngressProps } from 'cdk8s-plus-28'

const ingressProps: IngressProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.className">className</a></code> | <code>string</code> | Class Name for this ingress. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.defaultBackend">defaultBackend</a></code> | <code><a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a></code> | The default backend services requests that do not match any rule. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.IngressRule">IngressRule</a>[]</code> | Routing rules for this ingress. |
| <code><a href="#cdk8s-plus-28.IngressProps.property.tls">tls</a></code> | <code><a href="#cdk8s-plus-28.IngressTls">IngressTls</a>[]</code> | TLS settings for this ingress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.IngressProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `className`<sup>Optional</sup> <a name="className" id="cdk8s-plus-28.IngressProps.property.className"></a>

```typescript
public readonly className: string;
```

- *Type:* string

Class Name for this ingress.

This field is a reference to an IngressClass resource that contains
additional Ingress configuration, including the name of the Ingress controller.

---

##### `defaultBackend`<sup>Optional</sup> <a name="defaultBackend" id="cdk8s-plus-28.IngressProps.property.defaultBackend"></a>

```typescript
public readonly defaultBackend: IngressBackend;
```

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

The default backend services requests that do not match any rule.

Using this option or the `addDefaultBackend()` method is equivalent to
adding a rule with both `path` and `host` undefined.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.IngressProps.property.rules"></a>

```typescript
public readonly rules: IngressRule[];
```

- *Type:* <a href="#cdk8s-plus-28.IngressRule">IngressRule</a>[]

Routing rules for this ingress.

Each rule must define an `IngressBackend` that will receive the requests
that match this rule. If both `host` and `path` are not specifiec, this
backend will be used as the default backend of the ingress.

You can also add rules later using `addRule()`, `addHostRule()`,
`addDefaultBackend()` and `addHostDefaultBackend()`.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="cdk8s-plus-28.IngressProps.property.tls"></a>

```typescript
public readonly tls: IngressTls[];
```

- *Type:* <a href="#cdk8s-plus-28.IngressTls">IngressTls</a>[]

TLS settings for this ingress.

Using this option tells the ingress controller to expose a TLS endpoint.
Currently the Ingress only supports a single TLS port, 443. If multiple
members of this list specify different hosts, they will be multiplexed on
the same port according to the hostname specified through the SNI TLS
extension, if the ingress controller fulfilling the ingress supports SNI.

---

### IngressRule <a name="IngressRule" id="cdk8s-plus-28.IngressRule"></a>

Represents the rules mapping the paths under a specified host to the related backend services.

Incoming requests are first evaluated for a host match,
then routed to the backend associated with the matching path.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressRule.Initializer"></a>

```typescript
import { IngressRule } from 'cdk8s-plus-28'

const ingressRule: IngressRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressRule.property.backend">backend</a></code> | <code><a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a></code> | Backend defines the referenced service endpoint to which the traffic will be forwarded to. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.host">host</a></code> | <code>string</code> | Host is the fully qualified domain name of a network host, as defined by RFC 3986. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.path">path</a></code> | <code>string</code> | Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/'. |
| <code><a href="#cdk8s-plus-28.IngressRule.property.pathType">pathType</a></code> | <code><a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a></code> | Specify how the path is matched against request paths. |

---

##### `backend`<sup>Required</sup> <a name="backend" id="cdk8s-plus-28.IngressRule.property.backend"></a>

```typescript
public readonly backend: IngressBackend;
```

- *Type:* <a href="#cdk8s-plus-28.IngressBackend">IngressBackend</a>

Backend defines the referenced service endpoint to which the traffic will be forwarded to.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.IngressRule.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string
- *Default:* If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.

Host is the fully qualified domain name of a network host, as defined by RFC 3986.

Note the following deviations from the "host" part of the URI as
defined in the RFC: 1. IPs are not allowed. Currently an IngressRuleValue
can only apply to the IP in the Spec of the parent Ingress. 2. The `:`
delimiter is not respected because ports are not allowed. Currently the
port of an Ingress is implicitly :80 for http and :443 for https. Both
these may change in the future. Incoming requests are matched against the
host before the IngressRuleValue.

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.IngressRule.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string
- *Default:* If unspecified, the path defaults to a catch all sending traffic to the backend.

Path is an extended POSIX regex as defined by IEEE Std 1003.1, (i.e this follows the egrep/unix syntax, not the perl syntax) matched against the path of an incoming request. Currently it can contain characters disallowed from the conventional "path" part of a URL as defined by RFC 3986. Paths must begin with a '/'.

---

##### `pathType`<sup>Optional</sup> <a name="pathType" id="cdk8s-plus-28.IngressRule.property.pathType"></a>

```typescript
public readonly pathType: HttpIngressPathType;
```

- *Type:* <a href="#cdk8s-plus-28.HttpIngressPathType">HttpIngressPathType</a>

Specify how the path is matched against request paths.

By default, path
types will be matched by prefix.

> [https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types](https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types)

---

### IngressRule <a name="IngressRule" id="cdk8s-plus-28.k8s.IngressRule"></a>

IngressRule represents the rules mapping the paths under a specified host to the related backend services.

Incoming requests are first evaluated for a host match, then routed to the backend associated with the matching IngressRuleValue.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressRule: k8s.IngressRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressRule.property.host">host</a></code> | <code>string</code> | host is the fully qualified domain name of a network host, as defined by RFC 3986. |
| <code><a href="#cdk8s-plus-28.k8s.IngressRule.property.http">http</a></code> | <code>cdk8s-plus-28.k8s.HttpIngressRuleValue</code> | *No description.* |

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.IngressRule.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

host is the fully qualified domain name of a network host, as defined by RFC 3986.

Note the following deviations from the "host" part of the URI as defined in RFC 3986: 1. IPs are not allowed. Currently an IngressRuleValue can only apply to
the IP in the Spec of the parent Ingress.
2. The `:` delimiter is not respected because ports are not allowed.
Currently the port of an Ingress is implicitly :80 for http and
:443 for https.
Both these may change in the future. Incoming requests are matched against the host before the IngressRuleValue. If the host is unspecified, the Ingress routes all traffic based on the specified IngressRuleValue.

host can be "precise" which is a domain name without the terminating dot of a network host (e.g. "foo.bar.com") or "wildcard", which is a domain name prefixed with a single wildcard label (e.g. "*.foo.com"). The wildcard character '*' must appear by itself as the first DNS label and matches only a single label. You cannot have a wildcard label by itself (e.g. Host == "*"). Requests will be matched against the Host field in the following way: 1. If host is precise, the request matches this rule if the http host header is equal to Host. 2. If host is a wildcard, then the request matches this rule if the http host header is to equal to the suffix (removing the first label) of the wildcard rule.

---

##### `http`<sup>Optional</sup> <a name="http" id="cdk8s-plus-28.k8s.IngressRule.property.http"></a>

```typescript
public readonly http: HttpIngressRuleValue;
```

- *Type:* cdk8s-plus-28.k8s.HttpIngressRuleValue

---

### IngressServiceBackend <a name="IngressServiceBackend" id="cdk8s-plus-28.k8s.IngressServiceBackend"></a>

IngressServiceBackend references a Kubernetes Service as a Backend.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressServiceBackend.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressServiceBackend: k8s.IngressServiceBackend = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressServiceBackend.property.name">name</a></code> | <code>string</code> | name is the referenced service. |
| <code><a href="#cdk8s-plus-28.k8s.IngressServiceBackend.property.port">port</a></code> | <code>cdk8s-plus-28.k8s.ServiceBackendPort</code> | port of the referenced service. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.IngressServiceBackend.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the referenced service.

The service must exist in the same namespace as the Ingress object.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.IngressServiceBackend.property.port"></a>

```typescript
public readonly port: ServiceBackendPort;
```

- *Type:* cdk8s-plus-28.k8s.ServiceBackendPort

port of the referenced service.

A port name or port number is required for a IngressServiceBackend.

---

### IngressSpec <a name="IngressSpec" id="cdk8s-plus-28.k8s.IngressSpec"></a>

IngressSpec describes the Ingress the user wishes to exist.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressSpec: k8s.IngressSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.defaultBackend">defaultBackend</a></code> | <code>cdk8s-plus-28.k8s.IngressBackend</code> | defaultBackend is the backend that should handle requests that don't match any rule. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.ingressClassName">ingressClassName</a></code> | <code>string</code> | ingressClassName is the name of an IngressClass cluster resource. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.IngressRule[]</code> | rules is a list of host rules used to configure the Ingress. |
| <code><a href="#cdk8s-plus-28.k8s.IngressSpec.property.tls">tls</a></code> | <code>cdk8s-plus-28.k8s.IngressTls[]</code> | tls represents the TLS configuration. |

---

##### `defaultBackend`<sup>Optional</sup> <a name="defaultBackend" id="cdk8s-plus-28.k8s.IngressSpec.property.defaultBackend"></a>

```typescript
public readonly defaultBackend: IngressBackend;
```

- *Type:* cdk8s-plus-28.k8s.IngressBackend

defaultBackend is the backend that should handle requests that don't match any rule.

If Rules are not specified, DefaultBackend must be specified. If DefaultBackend is not set, the handling of requests that do not match any of the rules will be up to the Ingress controller.

---

##### `ingressClassName`<sup>Optional</sup> <a name="ingressClassName" id="cdk8s-plus-28.k8s.IngressSpec.property.ingressClassName"></a>

```typescript
public readonly ingressClassName: string;
```

- *Type:* string

ingressClassName is the name of an IngressClass cluster resource.

Ingress controller implementations use this field to know whether they should be serving this Ingress resource, by a transitive connection (controller -> IngressClass -> Ingress resource). Although the `kubernetes.io/ingress.class` annotation (simple constant name) was never formally defined, it was widely supported by Ingress controllers to create a direct binding between Ingress controller and Ingress resources. Newly created Ingress resources should prefer using the field. However, even though the annotation is officially deprecated, for backwards compatibility reasons, ingress controllers should still honor that annotation if present.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.IngressSpec.property.rules"></a>

```typescript
public readonly rules: IngressRule[];
```

- *Type:* cdk8s-plus-28.k8s.IngressRule[]

rules is a list of host rules used to configure the Ingress.

If unspecified, or no rule matches, all traffic is sent to the default backend.

---

##### `tls`<sup>Optional</sup> <a name="tls" id="cdk8s-plus-28.k8s.IngressSpec.property.tls"></a>

```typescript
public readonly tls: IngressTls[];
```

- *Type:* cdk8s-plus-28.k8s.IngressTls[]

tls represents the TLS configuration.

Currently the Ingress only supports a single TLS port, 443. If multiple members of this list specify different hosts, they will be multiplexed on the same port according to the hostname specified through the SNI TLS extension, if the ingress controller fulfilling the ingress supports SNI.

---

### IngressTls <a name="IngressTls" id="cdk8s-plus-28.IngressTls"></a>

Represents the TLS configuration mapping that is passed to the ingress controller for SSL termination.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.IngressTls.Initializer"></a>

```typescript
import { IngressTls } from 'cdk8s-plus-28'

const ingressTls: IngressTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IngressTls.property.hosts">hosts</a></code> | <code>string[]</code> | Hosts are a list of hosts included in the TLS certificate. |
| <code><a href="#cdk8s-plus-28.IngressTls.property.secret">secret</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | Secret is the secret that contains the certificate and key used to terminate SSL traffic on 443. |

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="cdk8s-plus-28.IngressTls.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]
- *Default:* If unspecified, it defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress.

Hosts are a list of hosts included in the TLS certificate.

The values in
this list must match the name/s used in the TLS Secret.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.IngressTls.property.secret"></a>

```typescript
public readonly secret: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* If unspecified, it allows SSL routing based on SNI hostname.

Secret is the secret that contains the certificate and key used to terminate SSL traffic on 443.

If the SNI host in a listener conflicts with
the "Host" header field used by an IngressRule, the SNI host is used for
termination and value of the Host header is used for routing.

---

### IngressTls <a name="IngressTls" id="cdk8s-plus-28.k8s.IngressTls"></a>

IngressTLS describes the transport layer security associated with an ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IngressTls.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ingressTls: k8s.IngressTls = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IngressTls.property.hosts">hosts</a></code> | <code>string[]</code> | hosts is a list of hosts included in the TLS certificate. |
| <code><a href="#cdk8s-plus-28.k8s.IngressTls.property.secretName">secretName</a></code> | <code>string</code> | secretName is the name of the secret used to terminate TLS traffic on port 443. |

---

##### `hosts`<sup>Optional</sup> <a name="hosts" id="cdk8s-plus-28.k8s.IngressTls.property.hosts"></a>

```typescript
public readonly hosts: string[];
```

- *Type:* string[]
- *Default:* the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.

hosts is a list of hosts included in the TLS certificate.

The values in this list must match the name/s used in the tlsSecret. Defaults to the wildcard host setting for the loadbalancer controller fulfilling this Ingress, if left unspecified.

---

##### `secretName`<sup>Optional</sup> <a name="secretName" id="cdk8s-plus-28.k8s.IngressTls.property.secretName"></a>

```typescript
public readonly secretName: string;
```

- *Type:* string

secretName is the name of the secret used to terminate TLS traffic on port 443.

Field is left optional to allow TLS routing based on SNI hostname alone. If the SNI host in a listener conflicts with the "Host" header field used by an IngressRule, the SNI host is used for termination and value of the "Host" header is used for routing.

---

### IpAddressSpecV1Alpha1 <a name="IpAddressSpecV1Alpha1" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1"></a>

IPAddressSpec describe the attributes in an IP Address.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ipAddressSpecV1Alpha1: k8s.IpAddressSpecV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.property.parentRef">parentRef</a></code> | <code>cdk8s-plus-28.k8s.ParentReferenceV1Alpha1</code> | ParentRef references the resource that an IPAddress is attached to. |

---

##### `parentRef`<sup>Optional</sup> <a name="parentRef" id="cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1.property.parentRef"></a>

```typescript
public readonly parentRef: ParentReferenceV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ParentReferenceV1Alpha1

ParentRef references the resource that an IPAddress is attached to.

An IPAddress must reference a parent object.

---

### IpBlock <a name="IpBlock" id="cdk8s-plus-28.k8s.IpBlock"></a>

IPBlock describes a particular CIDR (Ex.

"192.168.1.0/24","2001:db8::/64") that is allowed to the pods matched by a NetworkPolicySpec's podSelector. The except entry describes CIDRs that should not be included within this rule.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IpBlock.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ipBlock: k8s.IpBlock = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IpBlock.property.cidr">cidr</a></code> | <code>string</code> | cidr is a string representing the IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64". |
| <code><a href="#cdk8s-plus-28.k8s.IpBlock.property.except">except</a></code> | <code>string[]</code> | except is a slice of CIDRs that should not be included within an IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64" Except values will be rejected if they are outside the cidr range. |

---

##### `cidr`<sup>Required</sup> <a name="cidr" id="cdk8s-plus-28.k8s.IpBlock.property.cidr"></a>

```typescript
public readonly cidr: string;
```

- *Type:* string

cidr is a string representing the IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64".

---

##### `except`<sup>Optional</sup> <a name="except" id="cdk8s-plus-28.k8s.IpBlock.property.except"></a>

```typescript
public readonly except: string[];
```

- *Type:* string[]

except is a slice of CIDRs that should not be included within an IPBlock Valid examples are "192.168.1.0/24" or "2001:db8::/64" Except values will be rejected if they are outside the cidr range.

---

### IscsiPersistentVolumeSource <a name="IscsiPersistentVolumeSource" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource"></a>

ISCSIPersistentVolumeSource represents an ISCSI disk.

ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const iscsiPersistentVolumeSource: k8s.IscsiPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iqn">iqn</a></code> | <code>string</code> | iqn is Target iSCSI Qualified Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.lun">lun</a></code> | <code>number</code> | lun is iSCSI Target Lun number. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.targetPortal">targetPortal</a></code> | <code>string</code> | targetPortal is iSCSI Target Portal. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthDiscovery">chapAuthDiscovery</a></code> | <code>boolean</code> | chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthSession">chapAuthSession</a></code> | <code>boolean</code> | chapAuthSession defines whether support iSCSI Session CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.initiatorName">initiatorName</a></code> | <code>string</code> | initiatorName is the custom iSCSI Initiator Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iscsiInterface">iscsiInterface</a></code> | <code>string</code> | iscsiInterface is the interface Name that uses an iSCSI transport. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.portals">portals</a></code> | <code>string[]</code> | portals is the iSCSI Target Portal List. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef is the CHAP Secret for iSCSI target and initiator authentication. |

---

##### `iqn`<sup>Required</sup> <a name="iqn" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iqn"></a>

```typescript
public readonly iqn: string;
```

- *Type:* string

iqn is Target iSCSI Qualified Name.

---

##### `lun`<sup>Required</sup> <a name="lun" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.lun"></a>

```typescript
public readonly lun: number;
```

- *Type:* number

lun is iSCSI Target Lun number.

---

##### `targetPortal`<sup>Required</sup> <a name="targetPortal" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.targetPortal"></a>

```typescript
public readonly targetPortal: string;
```

- *Type:* string

targetPortal is iSCSI Target Portal.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `chapAuthDiscovery`<sup>Optional</sup> <a name="chapAuthDiscovery" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthDiscovery"></a>

```typescript
public readonly chapAuthDiscovery: boolean;
```

- *Type:* boolean

chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication.

---

##### `chapAuthSession`<sup>Optional</sup> <a name="chapAuthSession" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.chapAuthSession"></a>

```typescript
public readonly chapAuthSession: boolean;
```

- *Type:* boolean

chapAuthSession defines whether support iSCSI Session CHAP authentication.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

---

##### `initiatorName`<sup>Optional</sup> <a name="initiatorName" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.initiatorName"></a>

```typescript
public readonly initiatorName: string;
```

- *Type:* string

initiatorName is the custom iSCSI Initiator Name.

If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

---

##### `iscsiInterface`<sup>Optional</sup> <a name="iscsiInterface" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.iscsiInterface"></a>

```typescript
public readonly iscsiInterface: string;
```

- *Type:* string
- *Default:* default' (tcp).

iscsiInterface is the interface Name that uses an iSCSI transport.

Defaults to 'default' (tcp).

---

##### `portals`<sup>Optional</sup> <a name="portals" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.portals"></a>

```typescript
public readonly portals: string[];
```

- *Type:* string[]

portals is the iSCSI Target Portal List.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false.

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.IscsiPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

secretRef is the CHAP Secret for iSCSI target and initiator authentication.

---

### IscsiVolumeSource <a name="IscsiVolumeSource" id="cdk8s-plus-28.k8s.IscsiVolumeSource"></a>

Represents an ISCSI disk.

ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.IscsiVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const iscsiVolumeSource: k8s.IscsiVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.iqn">iqn</a></code> | <code>string</code> | iqn is the target iSCSI Qualified Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.lun">lun</a></code> | <code>number</code> | lun represents iSCSI Target Lun number. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.targetPortal">targetPortal</a></code> | <code>string</code> | targetPortal is iSCSI Target Portal. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthDiscovery">chapAuthDiscovery</a></code> | <code>boolean</code> | chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthSession">chapAuthSession</a></code> | <code>boolean</code> | chapAuthSession defines whether support iSCSI Session CHAP authentication. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.initiatorName">initiatorName</a></code> | <code>string</code> | initiatorName is the custom iSCSI Initiator Name. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.iscsiInterface">iscsiInterface</a></code> | <code>string</code> | iscsiInterface is the interface Name that uses an iSCSI transport. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.portals">portals</a></code> | <code>string[]</code> | portals is the iSCSI Target Portal List. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.IscsiVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef is the CHAP Secret for iSCSI target and initiator authentication. |

---

##### `iqn`<sup>Required</sup> <a name="iqn" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.iqn"></a>

```typescript
public readonly iqn: string;
```

- *Type:* string

iqn is the target iSCSI Qualified Name.

---

##### `lun`<sup>Required</sup> <a name="lun" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.lun"></a>

```typescript
public readonly lun: number;
```

- *Type:* number

lun represents iSCSI Target Lun number.

---

##### `targetPortal`<sup>Required</sup> <a name="targetPortal" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.targetPortal"></a>

```typescript
public readonly targetPortal: string;
```

- *Type:* string

targetPortal is iSCSI Target Portal.

The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `chapAuthDiscovery`<sup>Optional</sup> <a name="chapAuthDiscovery" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthDiscovery"></a>

```typescript
public readonly chapAuthDiscovery: boolean;
```

- *Type:* boolean

chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication.

---

##### `chapAuthSession`<sup>Optional</sup> <a name="chapAuthSession" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.chapAuthSession"></a>

```typescript
public readonly chapAuthSession: boolean;
```

- *Type:* boolean

chapAuthSession defines whether support iSCSI Session CHAP authentication.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

---

##### `initiatorName`<sup>Optional</sup> <a name="initiatorName" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.initiatorName"></a>

```typescript
public readonly initiatorName: string;
```

- *Type:* string

initiatorName is the custom iSCSI Initiator Name.

If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

---

##### `iscsiInterface`<sup>Optional</sup> <a name="iscsiInterface" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.iscsiInterface"></a>

```typescript
public readonly iscsiInterface: string;
```

- *Type:* string
- *Default:* default' (tcp).

iscsiInterface is the interface Name that uses an iSCSI transport.

Defaults to 'default' (tcp).

---

##### `portals`<sup>Optional</sup> <a name="portals" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.portals"></a>

```typescript
public readonly portals: string[];
```

- *Type:* string[]

portals is the iSCSI Target Portal List.

The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false.

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.IscsiVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef is the CHAP Secret for iSCSI target and initiator authentication.

---

### JobProps <a name="JobProps" id="cdk8s-plus-28.JobProps"></a>

Properties for `Job`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.JobProps.Initializer"></a>

```typescript
import { JobProps } from 'cdk8s-plus-28'

const jobProps: JobProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.JobProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.JobProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.JobProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.JobProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.JobProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.JobProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.JobProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.JobProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.JobProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.JobProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.JobProps.property.activeDeadline">activeDeadline</a></code> | <code>cdk8s.Duration</code> | Specifies the duration the job may be active before the system tries to terminate it. |
| <code><a href="#cdk8s-plus-28.JobProps.property.backoffLimit">backoffLimit</a></code> | <code>number</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.JobProps.property.ttlAfterFinished">ttlAfterFinished</a></code> | <code>cdk8s.Duration</code> | Limits the lifetime of a Job that has finished execution (either Complete or Failed). |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.JobProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.JobProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.JobProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.JobProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.JobProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.JobProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.JobProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.JobProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.JobProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.JobProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.JobProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.JobProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.JobProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.JobProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.JobProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.JobProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.JobProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `activeDeadline`<sup>Optional</sup> <a name="activeDeadline" id="cdk8s-plus-28.JobProps.property.activeDeadline"></a>

```typescript
public readonly activeDeadline: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* If unset, then there is no deadline.

Specifies the duration the job may be active before the system tries to terminate it.

---

##### `backoffLimit`<sup>Optional</sup> <a name="backoffLimit" id="cdk8s-plus-28.JobProps.property.backoffLimit"></a>

```typescript
public readonly backoffLimit: number;
```

- *Type:* number
- *Default:* If not set, system defaults to 6.

Specifies the number of retries before marking this job failed.

---

##### `ttlAfterFinished`<sup>Optional</sup> <a name="ttlAfterFinished" id="cdk8s-plus-28.JobProps.property.ttlAfterFinished"></a>

```typescript
public readonly ttlAfterFinished: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* If this field is unset, the Job won't be automatically deleted.

Limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, after the Job finishes, it is eligible to
be automatically deleted. When the Job is being deleted, its lifecycle
guarantees (e.g. finalizers) will be honored. If this field is set to zero,
the Job becomes eligible to be deleted immediately after it finishes. This
field is alpha-level and is only honored by servers that enable the
`TTLAfterFinished` feature.

---

### JobSpec <a name="JobSpec" id="cdk8s-plus-28.k8s.JobSpec"></a>

JobSpec describes how the job execution will look like.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JobSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const jobSpec: k8s.JobSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | Describes the pod that will be created when executing a job. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.activeDeadlineSeconds">activeDeadlineSeconds</a></code> | <code>number</code> | Specifies the duration in seconds relative to the startTime that the job may be continuously active before the system tries to terminate it; |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.backoffLimit">backoffLimit</a></code> | <code>number</code> | Specifies the number of retries before marking this job failed. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.backoffLimitPerIndex">backoffLimitPerIndex</a></code> | <code>number</code> | Specifies the limit for the number of retries within an index before marking this index as failed. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.completionMode">completionMode</a></code> | <code>string</code> | completionMode specifies how Pod completions are tracked. It can be `NonIndexed` (default) or `Indexed`. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.completions">completions</a></code> | <code>number</code> | Specifies the desired number of successfully finished pods the job should be run with. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.manualSelector">manualSelector</a></code> | <code>boolean</code> | manualSelector controls generation of pod labels and pod selectors. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.maxFailedIndexes">maxFailedIndexes</a></code> | <code>number</code> | Specifies the maximal number of failed indexes before marking the Job as failed, when backoffLimitPerIndex is set. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.parallelism">parallelism</a></code> | <code>number</code> | Specifies the maximum desired number of pods the job should run at any given time. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.podFailurePolicy">podFailurePolicy</a></code> | <code>cdk8s-plus-28.k8s.PodFailurePolicy</code> | Specifies the policy of handling failed pods. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.podReplacementPolicy">podReplacementPolicy</a></code> | <code>string</code> | podReplacementPolicy specifies when to create replacement Pods. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | A label query over pods that should match the pod count. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.suspend">suspend</a></code> | <code>boolean</code> | suspend specifies whether the Job controller should create Pods or not. |
| <code><a href="#cdk8s-plus-28.k8s.JobSpec.property.ttlSecondsAfterFinished">ttlSecondsAfterFinished</a></code> | <code>number</code> | ttlSecondsAfterFinished limits the lifetime of a Job that has finished execution (either Complete or Failed). |

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.JobSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

Describes the pod that will be created when executing a job.

The only allowed template.spec.restartPolicy values are "Never" or "OnFailure". More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `activeDeadlineSeconds`<sup>Optional</sup> <a name="activeDeadlineSeconds" id="cdk8s-plus-28.k8s.JobSpec.property.activeDeadlineSeconds"></a>

```typescript
public readonly activeDeadlineSeconds: number;
```

- *Type:* number

Specifies the duration in seconds relative to the startTime that the job may be continuously active before the system tries to terminate it;

value must be positive integer. If a Job is suspended (at creation or through an update), this timer will effectively be stopped and reset when the Job is resumed again.

---

##### `backoffLimit`<sup>Optional</sup> <a name="backoffLimit" id="cdk8s-plus-28.k8s.JobSpec.property.backoffLimit"></a>

```typescript
public readonly backoffLimit: number;
```

- *Type:* number
- *Default:* 6

Specifies the number of retries before marking this job failed.

Defaults to 6

---

##### `backoffLimitPerIndex`<sup>Optional</sup> <a name="backoffLimitPerIndex" id="cdk8s-plus-28.k8s.JobSpec.property.backoffLimitPerIndex"></a>

```typescript
public readonly backoffLimitPerIndex: number;
```

- *Type:* number

Specifies the limit for the number of retries within an index before marking this index as failed.

When enabled the number of failures per index is kept in the pod's batch.kubernetes.io/job-index-failure-count annotation. It can only be set when Job's completionMode=Indexed, and the Pod's restart policy is Never. The field is immutable. This field is alpha-level. It can be used when the `JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).

---

##### `completionMode`<sup>Optional</sup> <a name="completionMode" id="cdk8s-plus-28.k8s.JobSpec.property.completionMode"></a>

```typescript
public readonly completionMode: string;
```

- *Type:* string

completionMode specifies how Pod completions are tracked. It can be `NonIndexed` (default) or `Indexed`.

`NonIndexed` means that the Job is considered complete when there have been .spec.completions successfully completed Pods. Each Pod completion is homologous to each other.

`Indexed` means that the Pods of a Job get an associated completion index from 0 to (.spec.completions - 1), available in the annotation batch.kubernetes.io/job-completion-index. The Job is considered complete when there is one successfully completed Pod for each index. When value is `Indexed`, .spec.completions must be specified and `.spec.parallelism` must be less than or equal to 10^5. In addition, The Pod name takes the form `$(job-name)-$(index)-$(random-string)`, the Pod hostname takes the form `$(job-name)-$(index)`.

More completion modes can be added in the future. If the Job controller observes a mode that it doesn't recognize, which is possible during upgrades due to version skew, the controller skips updates for the Job.

---

##### `completions`<sup>Optional</sup> <a name="completions" id="cdk8s-plus-28.k8s.JobSpec.property.completions"></a>

```typescript
public readonly completions: number;
```

- *Type:* number

Specifies the desired number of successfully finished pods the job should be run with.

Setting to null means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value.  Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `manualSelector`<sup>Optional</sup> <a name="manualSelector" id="cdk8s-plus-28.k8s.JobSpec.property.manualSelector"></a>

```typescript
public readonly manualSelector: boolean;
```

- *Type:* boolean

manualSelector controls generation of pod labels and pod selectors.

Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template.  When true, the user is responsible for picking unique labels and specifying the selector.  Failure to pick a unique label may cause this and other jobs to not function correctly.  However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector

---

##### `maxFailedIndexes`<sup>Optional</sup> <a name="maxFailedIndexes" id="cdk8s-plus-28.k8s.JobSpec.property.maxFailedIndexes"></a>

```typescript
public readonly maxFailedIndexes: number;
```

- *Type:* number

Specifies the maximal number of failed indexes before marking the Job as failed, when backoffLimitPerIndex is set.

Once the number of failed indexes exceeds this number the entire Job is marked as Failed and its execution is terminated. When left as null the job continues execution of all of its indexes and is marked with the `Complete` Job condition. It can only be specified when backoffLimitPerIndex is set. It can be null or up to completions. It is required and must be less than or equal to 10^4 when is completions greater than 10^5. This field is alpha-level. It can be used when the `JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).

---

##### `parallelism`<sup>Optional</sup> <a name="parallelism" id="cdk8s-plus-28.k8s.JobSpec.property.parallelism"></a>

```typescript
public readonly parallelism: number;
```

- *Type:* number

Specifies the maximum desired number of pods the job should run at any given time.

The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/

---

##### `podFailurePolicy`<sup>Optional</sup> <a name="podFailurePolicy" id="cdk8s-plus-28.k8s.JobSpec.property.podFailurePolicy"></a>

```typescript
public readonly podFailurePolicy: PodFailurePolicy;
```

- *Type:* cdk8s-plus-28.k8s.PodFailurePolicy

Specifies the policy of handling failed pods.

In particular, it allows to specify the set of actions and conditions which need to be satisfied to take the associated action. If empty, the default behaviour applies - the counter of failed pods, represented by the jobs's .status.failed field, is incremented and it is checked against the backoffLimit. This field cannot be used in combination with restartPolicy=OnFailure.

This field is beta-level. It can be used when the `JobPodFailurePolicy` feature gate is enabled (enabled by default).

---

##### `podReplacementPolicy`<sup>Optional</sup> <a name="podReplacementPolicy" id="cdk8s-plus-28.k8s.JobSpec.property.podReplacementPolicy"></a>

```typescript
public readonly podReplacementPolicy: string;
```

- *Type:* string

podReplacementPolicy specifies when to create replacement Pods.

Possible values are: - TerminatingOrFailed means that we recreate pods
when they are terminating (has a metadata.deletionTimestamp) or failed.
- Failed means to wait until a previously created Pod is fully terminated (has phase
Failed or Succeeded) before creating a replacement Pod.

When using podFailurePolicy, Failed is the the only allowed value. TerminatingOrFailed and Failed are allowed values when podFailurePolicy is not in use. This is an alpha field. Enable JobPodReplacementPolicy to be able to use this field.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.JobSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

A label query over pods that should match the pod count.

Normally, the system sets this field for you. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `suspend`<sup>Optional</sup> <a name="suspend" id="cdk8s-plus-28.k8s.JobSpec.property.suspend"></a>

```typescript
public readonly suspend: boolean;
```

- *Type:* boolean
- *Default:* false.

suspend specifies whether the Job controller should create Pods or not.

If a Job is created with suspend set to true, no Pods are created by the Job controller. If a Job is suspended after creation (i.e. the flag goes from false to true), the Job controller will delete all active Pods associated with this Job. Users must design their workload to gracefully handle this. Suspending a Job will reset the StartTime field of the Job, effectively resetting the ActiveDeadlineSeconds timer too. Defaults to false.

---

##### `ttlSecondsAfterFinished`<sup>Optional</sup> <a name="ttlSecondsAfterFinished" id="cdk8s-plus-28.k8s.JobSpec.property.ttlSecondsAfterFinished"></a>

```typescript
public readonly ttlSecondsAfterFinished: number;
```

- *Type:* number

ttlSecondsAfterFinished limits the lifetime of a Job that has finished execution (either Complete or Failed).

If this field is set, ttlSecondsAfterFinished after the Job finishes, it is eligible to be automatically deleted. When the Job is being deleted, its lifecycle guarantees (e.g. finalizers) will be honored. If this field is unset, the Job won't be automatically deleted. If this field is set to zero, the Job becomes eligible to be deleted immediately after it finishes.

---

### JobTemplateSpec <a name="JobTemplateSpec" id="cdk8s-plus-28.k8s.JobTemplateSpec"></a>

JobTemplateSpec describes the data a Job should have when created from a template.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JobTemplateSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const jobTemplateSpec: k8s.JobTemplateSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JobTemplateSpec.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata of the jobs created from this template. |
| <code><a href="#cdk8s-plus-28.k8s.JobTemplateSpec.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.JobSpec</code> | Specification of the desired behavior of the job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.JobTemplateSpec.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata of the jobs created from this template.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.JobTemplateSpec.property.spec"></a>

```typescript
public readonly spec: JobSpec;
```

- *Type:* cdk8s-plus-28.k8s.JobSpec

Specification of the desired behavior of the job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### JsonSchemaProps <a name="JsonSchemaProps" id="cdk8s-plus-28.k8s.JsonSchemaProps"></a>

JSONSchemaProps is a JSON-Schema following Specification Draft 4 (http://json-schema.org/).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.JsonSchemaProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const jsonSchemaProps: k8s.JsonSchemaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalItems">additionalItems</a></code> | <code>any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalProperties">additionalProperties</a></code> | <code>any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.allOf">allOf</a></code> | <code>cdk8s-plus-28.k8s.JsonSchemaProps[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.anyOf">anyOf</a></code> | <code>cdk8s-plus-28.k8s.JsonSchemaProps[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.default">default</a></code> | <code>any</code> | default is a default value for undefined object fields. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.definitions">definitions</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.dependencies">dependencies</a></code> | <code>{[ key: string ]: any}</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.description">description</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.enum">enum</a></code> | <code>any[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.example">example</a></code> | <code>any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMaximum">exclusiveMaximum</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMinimum">exclusiveMinimum</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.externalDocs">externalDocs</a></code> | <code>cdk8s-plus-28.k8s.ExternalDocumentation</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.format">format</a></code> | <code>string</code> | format is an OpenAPI v3 format string. Unknown formats are ignored. The following formats are validated:. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.items">items</a></code> | <code>any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maximum">maximum</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxItems">maxItems</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxLength">maxLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.maxProperties">maxProperties</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minimum">minimum</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minItems">minItems</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minLength">minLength</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.minProperties">minProperties</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.multipleOf">multipleOf</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.not">not</a></code> | <code>cdk8s-plus-28.k8s.JsonSchemaProps</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.nullable">nullable</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.oneOf">oneOf</a></code> | <code>cdk8s-plus-28.k8s.JsonSchemaProps[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.pattern">pattern</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.patternProperties">patternProperties</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.properties">properties</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.ref">ref</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.required">required</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.schema">schema</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.title">title</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.type">type</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.uniqueItems">uniqueItems</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesEmbeddedResource">xKubernetesEmbeddedResource</a></code> | <code>boolean</code> | x-kubernetes-embedded-resource defines that the value is an embedded Kubernetes runtime.Object, with TypeMeta and ObjectMeta. The type must be object. It is allowed to further restrict the embedded object. kind, apiVersion and metadata are validated automatically. x-kubernetes-preserve-unknown-fields is allowed to be true, but does not have to be if the object is fully specified (up to kind, apiVersion, metadata). |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesIntOrString">xKubernetesIntOrString</a></code> | <code>boolean</code> | x-kubernetes-int-or-string specifies that this value is either an integer or a string. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListMapKeys">xKubernetesListMapKeys</a></code> | <code>string[]</code> | x-kubernetes-list-map-keys annotates an array with the x-kubernetes-list-type `map` by specifying the keys used as the index of the map. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListType">xKubernetesListType</a></code> | <code>string</code> | x-kubernetes-list-type annotates an array to further describe its topology. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesMapType">xKubernetesMapType</a></code> | <code>string</code> | x-kubernetes-map-type annotates an object to further describe its topology. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesPreserveUnknownFields">xKubernetesPreserveUnknownFields</a></code> | <code>boolean</code> | x-kubernetes-preserve-unknown-fields stops the API server decoding step from pruning fields which are not specified in the validation schema. |
| <code><a href="#cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesValidations">xKubernetesValidations</a></code> | <code>cdk8s-plus-28.k8s.ValidationRule[]</code> | x-kubernetes-validations describes a list of validation rules written in the CEL expression language. |

---

##### `additionalItems`<sup>Optional</sup> <a name="additionalItems" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalItems"></a>

```typescript
public readonly additionalItems: any;
```

- *Type:* any

---

##### `additionalProperties`<sup>Optional</sup> <a name="additionalProperties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.additionalProperties"></a>

```typescript
public readonly additionalProperties: any;
```

- *Type:* any

---

##### `allOf`<sup>Optional</sup> <a name="allOf" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.allOf"></a>

```typescript
public readonly allOf: JsonSchemaProps[];
```

- *Type:* cdk8s-plus-28.k8s.JsonSchemaProps[]

---

##### `anyOf`<sup>Optional</sup> <a name="anyOf" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.anyOf"></a>

```typescript
public readonly anyOf: JsonSchemaProps[];
```

- *Type:* cdk8s-plus-28.k8s.JsonSchemaProps[]

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.default"></a>

```typescript
public readonly default: any;
```

- *Type:* any

default is a default value for undefined object fields.

Defaulting is a beta feature under the CustomResourceDefaulting feature gate. Defaulting requires spec.preserveUnknownFields to be false.

---

##### `definitions`<sup>Optional</sup> <a name="definitions" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.definitions"></a>

```typescript
public readonly definitions: {[ key: string ]: JsonSchemaProps};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}

---

##### `dependencies`<sup>Optional</sup> <a name="dependencies" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.dependencies"></a>

```typescript
public readonly dependencies: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

---

##### `enum`<sup>Optional</sup> <a name="enum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.enum"></a>

```typescript
public readonly enum: any[];
```

- *Type:* any[]

---

##### `example`<sup>Optional</sup> <a name="example" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.example"></a>

```typescript
public readonly example: any;
```

- *Type:* any

---

##### `exclusiveMaximum`<sup>Optional</sup> <a name="exclusiveMaximum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMaximum"></a>

```typescript
public readonly exclusiveMaximum: boolean;
```

- *Type:* boolean

---

##### `exclusiveMinimum`<sup>Optional</sup> <a name="exclusiveMinimum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.exclusiveMinimum"></a>

```typescript
public readonly exclusiveMinimum: boolean;
```

- *Type:* boolean

---

##### `externalDocs`<sup>Optional</sup> <a name="externalDocs" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.externalDocs"></a>

```typescript
public readonly externalDocs: ExternalDocumentation;
```

- *Type:* cdk8s-plus-28.k8s.ExternalDocumentation

---

##### `format`<sup>Optional</sup> <a name="format" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.format"></a>

```typescript
public readonly format: string;
```

- *Type:* string

format is an OpenAPI v3 format string. Unknown formats are ignored. The following formats are validated:.

bsonobjectid: a bson object ID, i.e. a 24 characters hex string - uri: an URI as parsed by Golang net/url.ParseRequestURI - email: an email address as parsed by Golang net/mail.ParseAddress - hostname: a valid representation for an Internet host name, as defined by RFC 1034, section 3.1 [RFC1034]. - ipv4: an IPv4 IP as parsed by Golang net.ParseIP - ipv6: an IPv6 IP as parsed by Golang net.ParseIP - cidr: a CIDR as parsed by Golang net.ParseCIDR - mac: a MAC address as parsed by Golang net.ParseMAC - uuid: an UUID that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid3: an UUID3 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?3[0-9a-f]{3}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid4: an UUID4 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?4[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - uuid5: an UUID5 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?5[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - isbn: an ISBN10 or ISBN13 number string like "0321751043" or "978-0321751041" - isbn10: an ISBN10 number string like "0321751043" - isbn13: an ISBN13 number string like "978-0321751041" - creditcard: a credit card number defined by the regex ^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})$ with any non digit characters mixed in - ssn: a U.S. social security number following the regex ^\d{3}[- ]?\d{2}[- ]?\d{4}$ - hexcolor: an hexadecimal color code like "#FFFFFF: following the regex ^#?([0-9a-fA-F]{3}|[0-9a-fA-F]{6})$ - rgbcolor: an RGB color code like rgb like "rgb(255,255,2559" - byte: base64 encoded binary data - password: any kind of string - date: a date string like "2006-01-02" as defined by full-date in RFC3339 - duration: a duration string like "22 ns" as parsed by Golang time.ParseDuration or compatible with Scala duration format - datetime: a date time string like "2014-12-15T19:30:20.000Z" as defined by date-time in RFC3339.

---

##### `id`<sup>Optional</sup> <a name="id" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.id"></a>

```typescript
public readonly id: string;
```

- *Type:* string

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.items"></a>

```typescript
public readonly items: any;
```

- *Type:* any

---

##### `maximum`<sup>Optional</sup> <a name="maximum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maximum"></a>

```typescript
public readonly maximum: number;
```

- *Type:* number

---

##### `maxItems`<sup>Optional</sup> <a name="maxItems" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxItems"></a>

```typescript
public readonly maxItems: number;
```

- *Type:* number

---

##### `maxLength`<sup>Optional</sup> <a name="maxLength" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxLength"></a>

```typescript
public readonly maxLength: number;
```

- *Type:* number

---

##### `maxProperties`<sup>Optional</sup> <a name="maxProperties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.maxProperties"></a>

```typescript
public readonly maxProperties: number;
```

- *Type:* number

---

##### `minimum`<sup>Optional</sup> <a name="minimum" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minimum"></a>

```typescript
public readonly minimum: number;
```

- *Type:* number

---

##### `minItems`<sup>Optional</sup> <a name="minItems" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minItems"></a>

```typescript
public readonly minItems: number;
```

- *Type:* number

---

##### `minLength`<sup>Optional</sup> <a name="minLength" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minLength"></a>

```typescript
public readonly minLength: number;
```

- *Type:* number

---

##### `minProperties`<sup>Optional</sup> <a name="minProperties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.minProperties"></a>

```typescript
public readonly minProperties: number;
```

- *Type:* number

---

##### `multipleOf`<sup>Optional</sup> <a name="multipleOf" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.multipleOf"></a>

```typescript
public readonly multipleOf: number;
```

- *Type:* number

---

##### `not`<sup>Optional</sup> <a name="not" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.not"></a>

```typescript
public readonly not: JsonSchemaProps;
```

- *Type:* cdk8s-plus-28.k8s.JsonSchemaProps

---

##### `nullable`<sup>Optional</sup> <a name="nullable" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.nullable"></a>

```typescript
public readonly nullable: boolean;
```

- *Type:* boolean

---

##### `oneOf`<sup>Optional</sup> <a name="oneOf" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.oneOf"></a>

```typescript
public readonly oneOf: JsonSchemaProps[];
```

- *Type:* cdk8s-plus-28.k8s.JsonSchemaProps[]

---

##### `pattern`<sup>Optional</sup> <a name="pattern" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.pattern"></a>

```typescript
public readonly pattern: string;
```

- *Type:* string

---

##### `patternProperties`<sup>Optional</sup> <a name="patternProperties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.patternProperties"></a>

```typescript
public readonly patternProperties: {[ key: string ]: JsonSchemaProps};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}

---

##### `properties`<sup>Optional</sup> <a name="properties" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.properties"></a>

```typescript
public readonly properties: {[ key: string ]: JsonSchemaProps};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.JsonSchemaProps}

---

##### `ref`<sup>Optional</sup> <a name="ref" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.ref"></a>

```typescript
public readonly ref: string;
```

- *Type:* string

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.required"></a>

```typescript
public readonly required: string[];
```

- *Type:* string[]

---

##### `schema`<sup>Optional</sup> <a name="schema" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.schema"></a>

```typescript
public readonly schema: string;
```

- *Type:* string

---

##### `title`<sup>Optional</sup> <a name="title" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.title"></a>

```typescript
public readonly title: string;
```

- *Type:* string

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---

##### `uniqueItems`<sup>Optional</sup> <a name="uniqueItems" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.uniqueItems"></a>

```typescript
public readonly uniqueItems: boolean;
```

- *Type:* boolean

---

##### `xKubernetesEmbeddedResource`<sup>Optional</sup> <a name="xKubernetesEmbeddedResource" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesEmbeddedResource"></a>

```typescript
public readonly xKubernetesEmbeddedResource: boolean;
```

- *Type:* boolean

x-kubernetes-embedded-resource defines that the value is an embedded Kubernetes runtime.Object, with TypeMeta and ObjectMeta. The type must be object. It is allowed to further restrict the embedded object. kind, apiVersion and metadata are validated automatically. x-kubernetes-preserve-unknown-fields is allowed to be true, but does not have to be if the object is fully specified (up to kind, apiVersion, metadata).

---

##### `xKubernetesIntOrString`<sup>Optional</sup> <a name="xKubernetesIntOrString" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesIntOrString"></a>

```typescript
public readonly xKubernetesIntOrString: boolean;
```

- *Type:* boolean

x-kubernetes-int-or-string specifies that this value is either an integer or a string.

If this is true, an empty type is allowed and type as child of anyOf is permitted if following one of the following patterns:

1) anyOf:
- type: integer
- type: string
2) allOf:
- anyOf:
- type: integer
- type: string
- ... zero or more

---

##### `xKubernetesListMapKeys`<sup>Optional</sup> <a name="xKubernetesListMapKeys" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListMapKeys"></a>

```typescript
public readonly xKubernetesListMapKeys: string[];
```

- *Type:* string[]

x-kubernetes-list-map-keys annotates an array with the x-kubernetes-list-type `map` by specifying the keys used as the index of the map.

This tag MUST only be used on lists that have the "x-kubernetes-list-type" extension set to "map". Also, the values specified for this attribute must be a scalar typed field of the child structure (no nesting is supported).

The properties specified must either be required or have a default value, to ensure those properties are present for all list items.

---

##### `xKubernetesListType`<sup>Optional</sup> <a name="xKubernetesListType" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesListType"></a>

```typescript
public readonly xKubernetesListType: string;
```

- *Type:* string
- *Default:* atomic for arrays.

x-kubernetes-list-type annotates an array to further describe its topology.

This extension must only be used on lists and may have 3 possible values:

1) `atomic`: the list is treated as a single entity, like a scalar.
Atomic lists will be entirely replaced when updated. This extension
may be used on any type of list (struct, scalar, ...).
2) `set`:
Sets are lists that must not have multiple items with the same value. Each
value must be a scalar, an object with x-kubernetes-map-type `atomic` or an
array with x-kubernetes-list-type `atomic`.
3) `map`:
These lists are like maps in that their elements have a non-index key
used to identify them. Order is preserved upon merge. The map tag
must only be used on a list with elements of type object.
Defaults to atomic for arrays.

---

##### `xKubernetesMapType`<sup>Optional</sup> <a name="xKubernetesMapType" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesMapType"></a>

```typescript
public readonly xKubernetesMapType: string;
```

- *Type:* string

x-kubernetes-map-type annotates an object to further describe its topology.

This extension must only be used when type is object and may have 2 possible values:

1) `granular`:
These maps are actual maps (key-value pairs) and each fields are independent
from each other (they can each be manipulated by separate actors). This is
the default behaviour for all maps.
2) `atomic`: the list is treated as a single entity, like a scalar.
Atomic maps will be entirely replaced when updated.

---

##### `xKubernetesPreserveUnknownFields`<sup>Optional</sup> <a name="xKubernetesPreserveUnknownFields" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesPreserveUnknownFields"></a>

```typescript
public readonly xKubernetesPreserveUnknownFields: boolean;
```

- *Type:* boolean

x-kubernetes-preserve-unknown-fields stops the API server decoding step from pruning fields which are not specified in the validation schema.

This affects fields recursively, but switches back to normal pruning behaviour if nested properties or additionalProperties are specified in the schema. This can either be true or undefined. False is forbidden.

---

##### `xKubernetesValidations`<sup>Optional</sup> <a name="xKubernetesValidations" id="cdk8s-plus-28.k8s.JsonSchemaProps.property.xKubernetesValidations"></a>

```typescript
public readonly xKubernetesValidations: ValidationRule[];
```

- *Type:* cdk8s-plus-28.k8s.ValidationRule[]

x-kubernetes-validations describes a list of validation rules written in the CEL expression language.

This field is an alpha-level. Using this field requires the feature gate `CustomResourceValidationExpressions` to be enabled.

---

### KeyToPath <a name="KeyToPath" id="cdk8s-plus-28.k8s.KeyToPath"></a>

Maps a string key to a path within a volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KeyToPath.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const keyToPath: k8s.KeyToPath = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.key">key</a></code> | <code>string</code> | key is the key to project. |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.path">path</a></code> | <code>string</code> | path is the relative path of the file to map the key to. |
| <code><a href="#cdk8s-plus-28.k8s.KeyToPath.property.mode">mode</a></code> | <code>number</code> | mode is Optional: mode bits used to set permissions on this file. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.KeyToPath.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

key is the key to project.

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.KeyToPath.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is the relative path of the file to map the key to.

May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.k8s.KeyToPath.property.mode"></a>

```typescript
public readonly mode: number;
```

- *Type:* number

mode is Optional: mode bits used to set permissions on this file.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

### KubeApiServiceListProps <a name="KubeApiServiceListProps" id="cdk8s-plus-28.k8s.KubeApiServiceListProps"></a>

APIServiceList is a list of APIService objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeApiServiceListProps: k8s.KubeApiServiceListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeApiServiceProps[]</code> | Items is the list of APIService. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.property.items"></a>

```typescript
public readonly items: KubeApiServiceProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeApiServiceProps[]

Items is the list of APIService.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeApiServiceProps <a name="KubeApiServiceProps" id="cdk8s-plus-28.k8s.KubeApiServiceProps"></a>

APIService represents a server for a particular GroupVersion.

Name must be "version.group".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeApiServiceProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeApiServiceProps: k8s.KubeApiServiceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeApiServiceProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ApiServiceSpec</code> | Spec contains information for locating and communicating with a server. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeApiServiceProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeApiServiceProps.property.spec"></a>

```typescript
public readonly spec: ApiServiceSpec;
```

- *Type:* cdk8s-plus-28.k8s.ApiServiceSpec

Spec contains information for locating and communicating with a server.

---

### KubeBindingProps <a name="KubeBindingProps" id="cdk8s-plus-28.k8s.KubeBindingProps"></a>

Binding ties one object to another;

for example, a pod is bound to a node by a scheduler. Deprecated in 1.7, please use the bindings subresource of pods instead.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeBindingProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeBindingProps: k8s.KubeBindingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeBindingProps.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | The target object that you want to bind to the standard object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeBindingProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.KubeBindingProps.property.target"></a>

```typescript
public readonly target: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

The target object that you want to bind to the standard object.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeBindingProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCertificateSigningRequestListProps <a name="KubeCertificateSigningRequestListProps" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps"></a>

CertificateSigningRequestList is a collection of CertificateSigningRequest objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCertificateSigningRequestListProps: k8s.KubeCertificateSigningRequestListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps[]</code> | items is a collection of CertificateSigningRequest objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | *No description.* |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.items"></a>

```typescript
public readonly items: KubeCertificateSigningRequestProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps[]

items is a collection of CertificateSigningRequest objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

---

### KubeCertificateSigningRequestProps <a name="KubeCertificateSigningRequestProps" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps"></a>

CertificateSigningRequest objects provide a mechanism to obtain x509 certificates by submitting a certificate signing request, and having it asynchronously approved and issued.

Kubelets use this API to obtain:
1. client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client-kubelet" signerName).
2. serving certificates for TLS endpoints kube-apiserver can connect to securely (with the "kubernetes.io/kubelet-serving" signerName).

This API can be used to request client certificates to authenticate to kube-apiserver (with the "kubernetes.io/kube-apiserver-client" signerName), or to obtain certificates from custom non-Kubernetes signers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCertificateSigningRequestProps: k8s.KubeCertificateSigningRequestProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.CertificateSigningRequestSpec</code> | spec contains the certificate request, and is immutable after creation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | *No description.* |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.spec"></a>

```typescript
public readonly spec: CertificateSigningRequestSpec;
```

- *Type:* cdk8s-plus-28.k8s.CertificateSigningRequestSpec

spec contains the certificate request, and is immutable after creation.

Only the request, signerName, expirationSeconds, and usages fields can be set on creation. Other fields are derived by Kubernetes and cannot be modified by users.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCertificateSigningRequestProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

---

### KubeClusterCidrListV1Alpha1Props <a name="KubeClusterCidrListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props"></a>

ClusterCIDRList contains a list of ClusterCIDR.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterCidrListV1Alpha1Props: k8s.KubeClusterCidrListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props[]</code> | items is the list of ClusterCIDRs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeClusterCidrv1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props[]

items is the list of ClusterCIDRs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeClusterCidrv1Alpha1Props <a name="KubeClusterCidrv1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props"></a>

ClusterCIDR represents a single configuration for per-Node Pod CIDR allocations when the MultiCIDRRangeAllocator is enabled (see the config for kube-controller-manager).

A cluster may have any number of ClusterCIDR resources, all of which will be considered when allocating a CIDR for a Node.  A ClusterCIDR is eligible to be used for a given Node when the node selector matches the node in question and has free CIDRs to allocate.  In case of multiple matching ClusterCIDR resources, the allocator will attempt to break ties using internal heuristics, but any ClusterCIDR whose node selector matches the Node may be used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterCidrv1Alpha1Props: k8s.KubeClusterCidrv1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1</code> | spec is the desired state of the ClusterCIDR. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterCidrv1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: ClusterCidrSpecV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ClusterCidrSpecV1Alpha1

spec is the desired state of the ClusterCIDR.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeClusterRoleBindingListProps <a name="KubeClusterRoleBindingListProps" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps"></a>

ClusterRoleBindingList is a collection of ClusterRoleBindings.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterRoleBindingListProps: k8s.KubeClusterRoleBindingListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleBindingProps[]</code> | Items is a list of ClusterRoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.items"></a>

```typescript
public readonly items: KubeClusterRoleBindingProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleBindingProps[]

Items is a list of ClusterRoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

---

### KubeClusterRoleBindingProps <a name="KubeClusterRoleBindingProps" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps"></a>

ClusterRoleBinding references a ClusterRole, but not contain it.

It can reference a ClusterRole in the global namespace, and adds who information via Subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterRoleBindingProps: k8s.KubeClusterRoleBindingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.roleRef">roleRef</a></code> | <code>cdk8s-plus-28.k8s.RoleRef</code> | RoleRef can only reference a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.subjects">subjects</a></code> | <code>cdk8s-plus-28.k8s.Subject[]</code> | Subjects holds references to the objects the role applies to. |

---

##### `roleRef`<sup>Required</sup> <a name="roleRef" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.roleRef"></a>

```typescript
public readonly roleRef: RoleRef;
```

- *Type:* cdk8s-plus-28.k8s.RoleRef

RoleRef can only reference a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeClusterRoleBindingProps.property.subjects"></a>

```typescript
public readonly subjects: Subject[];
```

- *Type:* cdk8s-plus-28.k8s.Subject[]

Subjects holds references to the objects the role applies to.

---

### KubeClusterRoleListProps <a name="KubeClusterRoleListProps" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps"></a>

ClusterRoleList is a collection of ClusterRoles.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterRoleListProps: k8s.KubeClusterRoleListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterRoleProps[]</code> | Items is a list of ClusterRoles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.items"></a>

```typescript
public readonly items: KubeClusterRoleProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeClusterRoleProps[]

Items is a list of ClusterRoles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

---

### KubeClusterRoleProps <a name="KubeClusterRoleProps" id="cdk8s-plus-28.k8s.KubeClusterRoleProps"></a>

ClusterRole is a cluster level, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding or ClusterRoleBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterRoleProps: k8s.KubeClusterRoleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.aggregationRule">aggregationRule</a></code> | <code>cdk8s-plus-28.k8s.AggregationRule</code> | AggregationRule is an optional field that describes how to build the Rules for this ClusterRole. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterRoleProps.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.PolicyRule[]</code> | Rules holds all the PolicyRules for this ClusterRole. |

---

##### `aggregationRule`<sup>Optional</sup> <a name="aggregationRule" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.aggregationRule"></a>

```typescript
public readonly aggregationRule: AggregationRule;
```

- *Type:* cdk8s-plus-28.k8s.AggregationRule

AggregationRule is an optional field that describes how to build the Rules for this ClusterRole.

If AggregationRule is set, then the Rules are controller managed and direct changes to Rules will be stomped by the controller.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeClusterRoleProps.property.rules"></a>

```typescript
public readonly rules: PolicyRule[];
```

- *Type:* cdk8s-plus-28.k8s.PolicyRule[]

Rules holds all the PolicyRules for this ClusterRole.

---

### KubeClusterTrustBundleListV1Alpha1Props <a name="KubeClusterTrustBundleListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props"></a>

ClusterTrustBundleList is a collection of ClusterTrustBundle objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterTrustBundleListV1Alpha1Props: k8s.KubeClusterTrustBundleListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props[]</code> | items is a collection of ClusterTrustBundle objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | metadata contains the list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeClusterTrustBundleV1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props[]

items is a collection of ClusterTrustBundle objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

metadata contains the list metadata.

---

### KubeClusterTrustBundleV1Alpha1Props <a name="KubeClusterTrustBundleV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props"></a>

ClusterTrustBundle is a cluster-scoped container for X.509 trust anchors (root certificates).

ClusterTrustBundle objects are considered to be readable by any authenticated user in the cluster, because they can be mounted by pods using the `clusterTrustBundle` projection.  All service accounts have read access to ClusterTrustBundles by default.  Users who only have namespace-level access to a cluster can read ClusterTrustBundles by impersonating a serviceaccount that they have access to.

It can be optionally associated with a particular assigner, in which case it contains one valid set of trust anchors for that signer. Signers may have multiple associated ClusterTrustBundles; each is an independent set of trust anchors for that signer. Admission control is used to enforce that only users with permissions on the signer can create or modify the corresponding bundle.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeClusterTrustBundleV1Alpha1Props: k8s.KubeClusterTrustBundleV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1</code> | spec contains the signer (if any) and trust anchors. |
| <code><a href="#cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | metadata contains the object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: ClusterTrustBundleSpecV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ClusterTrustBundleSpecV1Alpha1

spec contains the signer (if any) and trust anchors.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeClusterTrustBundleV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

metadata contains the object metadata.

---

### KubeComponentStatusListProps <a name="KubeComponentStatusListProps" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps"></a>

Status of all the conditions for the component as a list of ComponentStatus objects.

Deprecated: This API is deprecated in v1.19+

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeComponentStatusListProps: k8s.KubeComponentStatusListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeComponentStatusProps[]</code> | List of ComponentStatus objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.items"></a>

```typescript
public readonly items: KubeComponentStatusProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeComponentStatusProps[]

List of ComponentStatus objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeComponentStatusProps <a name="KubeComponentStatusProps" id="cdk8s-plus-28.k8s.KubeComponentStatusProps"></a>

ComponentStatus (and ComponentStatusList) holds the cluster validation info.

Deprecated: This API is deprecated in v1.19+

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeComponentStatusProps: k8s.KubeComponentStatusProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusProps.property.conditions">conditions</a></code> | <code>cdk8s-plus-28.k8s.ComponentCondition[]</code> | List of component conditions observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeComponentStatusProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `conditions`<sup>Optional</sup> <a name="conditions" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.property.conditions"></a>

```typescript
public readonly conditions: ComponentCondition[];
```

- *Type:* cdk8s-plus-28.k8s.ComponentCondition[]

List of component conditions observed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeComponentStatusProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeConfigMapListProps <a name="KubeConfigMapListProps" id="cdk8s-plus-28.k8s.KubeConfigMapListProps"></a>

ConfigMapList is a resource containing a list of ConfigMap objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeConfigMapListProps: k8s.KubeConfigMapListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeConfigMapProps[]</code> | Items is the list of ConfigMaps. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.property.items"></a>

```typescript
public readonly items: KubeConfigMapProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeConfigMapProps[]

Items is the list of ConfigMaps.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeConfigMapProps <a name="KubeConfigMapProps" id="cdk8s-plus-28.k8s.KubeConfigMapProps"></a>

ConfigMap holds configuration data for pods to consume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeConfigMapProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeConfigMapProps: k8s.KubeConfigMapProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.binaryData">binaryData</a></code> | <code>{[ key: string ]: string}</code> | BinaryData contains the binary data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.data">data</a></code> | <code>{[ key: string ]: string}</code> | Data contains the configuration data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.immutable">immutable</a></code> | <code>boolean</code> | Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeConfigMapProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `binaryData`<sup>Optional</sup> <a name="binaryData" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.binaryData"></a>

```typescript
public readonly binaryData: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

BinaryData contains the binary data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. BinaryData can contain byte sequences that are not in the UTF-8 range. The keys stored in BinaryData must not overlap with the ones in the Data field, this is enforced during validation process. Using this field will require 1.10+ apiserver and kubelet.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.data"></a>

```typescript
public readonly data: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Data contains the configuration data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. Values with non-UTF-8 byte sequences must use the BinaryData field. The keys stored in Data must not overlap with the keys in the BinaryData field, this is enforced during validation process.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Immutable, if set to true, ensures that data stored in the ConfigMap cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeConfigMapProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeControllerRevisionListProps <a name="KubeControllerRevisionListProps" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps"></a>

ControllerRevisionList is a resource containing a list of ControllerRevision objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeControllerRevisionListProps: k8s.KubeControllerRevisionListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeControllerRevisionProps[]</code> | Items is the list of ControllerRevisions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.items"></a>

```typescript
public readonly items: KubeControllerRevisionProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeControllerRevisionProps[]

Items is the list of ControllerRevisions.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeControllerRevisionProps <a name="KubeControllerRevisionProps" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps"></a>

ControllerRevision implements an immutable snapshot of state data.

Clients are responsible for serializing and deserializing the objects that contain their internal state. Once a ControllerRevision has been successfully created, it can not be updated. The API Server will fail validation of all requests that attempt to mutate the Data field. ControllerRevisions may, however, be deleted. Note that, due to its use by both the DaemonSet and StatefulSet controllers for update and rollback, this object is beta. However, it may be subject to name and representation changes in future releases, and clients should not depend on its stability. It is primarily for internal use by controllers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeControllerRevisionProps: k8s.KubeControllerRevisionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.revision">revision</a></code> | <code>number</code> | Revision indicates the revision of the state represented by Data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.data">data</a></code> | <code>any</code> | Data is the serialized representation of the state. |
| <code><a href="#cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `revision`<sup>Required</sup> <a name="revision" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.revision"></a>

```typescript
public readonly revision: number;
```

- *Type:* number

Revision indicates the revision of the state represented by Data.

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.data"></a>

```typescript
public readonly data: any;
```

- *Type:* any

Data is the serialized representation of the state.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeControllerRevisionProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCronJobListProps <a name="KubeCronJobListProps" id="cdk8s-plus-28.k8s.KubeCronJobListProps"></a>

CronJobList is a collection of cron jobs.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCronJobListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCronJobListProps: k8s.KubeCronJobListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCronJobProps[]</code> | items is the list of CronJobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCronJobListProps.property.items"></a>

```typescript
public readonly items: KubeCronJobProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCronJobProps[]

items is the list of CronJobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCronJobProps <a name="KubeCronJobProps" id="cdk8s-plus-28.k8s.KubeCronJobProps"></a>

CronJob represents the configuration of a single cron job.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCronJobProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCronJobProps: k8s.KubeCronJobProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCronJobProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.CronJobSpec</code> | Specification of the desired behavior of a cron job, including the schedule. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCronJobProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCronJobProps.property.spec"></a>

```typescript
public readonly spec: CronJobSpec;
```

- *Type:* cdk8s-plus-28.k8s.CronJobSpec

Specification of the desired behavior of a cron job, including the schedule.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeCsiDriverListProps <a name="KubeCsiDriverListProps" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps"></a>

CSIDriverList is a collection of CSIDriver objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiDriverListProps: k8s.KubeCsiDriverListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiDriverProps[]</code> | items is the list of CSIDriver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.items"></a>

```typescript
public readonly items: KubeCsiDriverProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCsiDriverProps[]

items is the list of CSIDriver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiDriverProps <a name="KubeCsiDriverProps" id="cdk8s-plus-28.k8s.KubeCsiDriverProps"></a>

CSIDriver captures information about a Container Storage Interface (CSI) volume driver deployed on the cluster.

Kubernetes attach detach controller uses this object to determine whether attach is required. Kubelet uses this object to determine whether pod information needs to be passed on mount. CSIDriver objects are non-namespaced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiDriverProps: k8s.KubeCsiDriverProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.CsiDriverSpec</code> | spec represents the specification of the CSI Driver. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiDriverProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.property.spec"></a>

```typescript
public readonly spec: CsiDriverSpec;
```

- *Type:* cdk8s-plus-28.k8s.CsiDriverSpec

spec represents the specification of the CSI Driver.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiDriverProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

metadata.Name indicates the name of the CSI driver that this object refers to; it MUST be the same name returned by the CSI GetPluginName() call for that driver. The driver name must be 63 characters or less, beginning and ending with an alphanumeric character ([a-z0-9A-Z]) with dashes (-), dots (.), and alphanumerics between. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeCsiNodeListProps <a name="KubeCsiNodeListProps" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps"></a>

CSINodeList is a collection of CSINode objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiNodeListProps: k8s.KubeCsiNodeListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiNodeProps[]</code> | items is the list of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.items"></a>

```typescript
public readonly items: KubeCsiNodeProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCsiNodeProps[]

items is the list of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiNodeProps <a name="KubeCsiNodeProps" id="cdk8s-plus-28.k8s.KubeCsiNodeProps"></a>

CSINode holds information about all CSI drivers installed on a node.

CSI drivers do not need to create the CSINode object directly. As long as they use the node-driver-registrar sidecar container, the kubelet will automatically populate the CSINode object for the CSI driver as part of kubelet plugin registration. CSINode has the same name as a node. If the object is missing, it means either there are no CSI Drivers available on the node, or the Kubelet version is low enough that it doesn't create this object. CSINode has an OwnerReference that points to the corresponding node object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiNodeProps: k8s.KubeCsiNodeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.CsiNodeSpec</code> | spec is the specification of CSINode. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiNodeProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.property.spec"></a>

```typescript
public readonly spec: CsiNodeSpec;
```

- *Type:* cdk8s-plus-28.k8s.CsiNodeSpec

spec is the specification of CSINode.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiNodeProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

metadata.name must be the Kubernetes node name.

---

### KubeCsiStorageCapacityListProps <a name="KubeCsiStorageCapacityListProps" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps"></a>

CSIStorageCapacityList is a collection of CSIStorageCapacity objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiStorageCapacityListProps: k8s.KubeCsiStorageCapacityListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps[]</code> | items is the list of CSIStorageCapacity objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.items"></a>

```typescript
public readonly items: KubeCsiStorageCapacityProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps[]

items is the list of CSIStorageCapacity objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCsiStorageCapacityProps <a name="KubeCsiStorageCapacityProps" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps"></a>

CSIStorageCapacity stores the result of one CSI GetCapacity call.

For a given StorageClass, this describes the available capacity in a particular topology segment.  This can be used when considering where to instantiate new PersistentVolumes.

For example this can express things like: - StorageClass "standard" has "1234 GiB" available in "topology.kubernetes.io/zone=us-east1" - StorageClass "localssd" has "10 GiB" available in "kubernetes.io/hostname=knode-abc123"

The following three cases all imply that no capacity is available for a certain combination: - no object exists with suitable topology and storage class name - such an object exists, but the capacity is unset - such an object exists, but the capacity is zero

The producer of these objects can decide which approach is more suitable.

They are consumed by the kube-scheduler when a CSI driver opts into capacity-aware scheduling with CSIDriverSpec.StorageCapacity. The scheduler compares the MaximumVolumeSize against the requested size of pending volumes to filter out unsuitable nodes. If MaximumVolumeSize is unset, it falls back to a comparison against the less precise Capacity. If that is also unset, the scheduler assumes that capacity is insufficient and tries some other node.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCsiStorageCapacityProps: k8s.KubeCsiStorageCapacityProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | storageClassName represents the name of the StorageClass that the reported capacity applies to. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.capacity">capacity</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.maximumVolumeSize">maximumVolumeSize</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.nodeTopology">nodeTopology</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | nodeTopology defines which nodes have access to the storage for which capacity was reported. |

---

##### `storageClassName`<sup>Required</sup> <a name="storageClassName" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

storageClassName represents the name of the StorageClass that the reported capacity applies to.

It must meet the same requirements as the name of a StorageClass object (non-empty, DNS subdomain). If that object no longer exists, the CSIStorageCapacity object is obsolete and should be removed by its creator. This field is immutable.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.capacity"></a>

```typescript
public readonly capacity: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

capacity is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

The semantic is currently (CSI spec 1.2) defined as: The available capacity, in bytes, of the storage that can be used to provision volumes. If not set, that information is currently unavailable.

---

##### `maximumVolumeSize`<sup>Optional</sup> <a name="maximumVolumeSize" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.maximumVolumeSize"></a>

```typescript
public readonly maximumVolumeSize: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

maximumVolumeSize is the value reported by the CSI driver in its GetCapacityResponse for a GetCapacityRequest with topology and parameters that match the previous fields.

This is defined since CSI spec 1.4.0 as the largest size that may be used in a CreateVolumeRequest.capacity_range.required_bytes field to create a volume with the same parameters as those in GetCapacityRequest. The corresponding value in the Kubernetes API is ResourceRequirements.Requests in a volume claim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

The name has no particular meaning. It must be a DNS subdomain (dots allowed, 253 characters). To ensure that there are no conflicts with other CSI drivers on the cluster, the recommendation is to use csisc-<uuid>, a generated name, or a reverse-domain name which ends with the unique CSI driver name.

Objects are namespaced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `nodeTopology`<sup>Optional</sup> <a name="nodeTopology" id="cdk8s-plus-28.k8s.KubeCsiStorageCapacityProps.property.nodeTopology"></a>

```typescript
public readonly nodeTopology: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

nodeTopology defines which nodes have access to the storage for which capacity was reported.

If not set, the storage is not accessible from any node in the cluster. If empty, the storage is accessible from all nodes. This field is immutable.

---

### KubeCustomResourceDefinitionListProps <a name="KubeCustomResourceDefinitionListProps" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps"></a>

CustomResourceDefinitionList is a list of CustomResourceDefinition objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCustomResourceDefinitionListProps: k8s.KubeCustomResourceDefinitionListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps[]</code> | items list individual CustomResourceDefinition objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.items"></a>

```typescript
public readonly items: KubeCustomResourceDefinitionProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps[]

items list individual CustomResourceDefinition objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeCustomResourceDefinitionProps <a name="KubeCustomResourceDefinitionProps" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps"></a>

CustomResourceDefinition represents a resource that should be exposed on the API server.

Its name MUST be in the format <.spec.name>.<.spec.group>.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeCustomResourceDefinitionProps: k8s.KubeCustomResourceDefinitionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.CustomResourceDefinitionSpec</code> | spec describes how the user wants the resources to appear. |
| <code><a href="#cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.spec"></a>

```typescript
public readonly spec: CustomResourceDefinitionSpec;
```

- *Type:* cdk8s-plus-28.k8s.CustomResourceDefinitionSpec

spec describes how the user wants the resources to appear.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeCustomResourceDefinitionProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeDaemonSetListProps <a name="KubeDaemonSetListProps" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps"></a>

DaemonSetList is a collection of daemon sets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeDaemonSetListProps: k8s.KubeDaemonSetListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeDaemonSetProps[]</code> | A list of daemon sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.items"></a>

```typescript
public readonly items: KubeDaemonSetProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeDaemonSetProps[]

A list of daemon sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeDaemonSetProps <a name="KubeDaemonSetProps" id="cdk8s-plus-28.k8s.KubeDaemonSetProps"></a>

DaemonSet represents the configuration of a daemon set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeDaemonSetProps: k8s.KubeDaemonSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDaemonSetProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.DaemonSetSpec</code> | The desired behavior of this daemon set. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDaemonSetProps.property.spec"></a>

```typescript
public readonly spec: DaemonSetSpec;
```

- *Type:* cdk8s-plus-28.k8s.DaemonSetSpec

The desired behavior of this daemon set.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeDeploymentListProps <a name="KubeDeploymentListProps" id="cdk8s-plus-28.k8s.KubeDeploymentListProps"></a>

DeploymentList is a list of Deployments.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeDeploymentListProps: k8s.KubeDeploymentListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeDeploymentProps[]</code> | Items is the list of Deployments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.property.items"></a>

```typescript
public readonly items: KubeDeploymentProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeDeploymentProps[]

Items is the list of Deployments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeDeploymentProps <a name="KubeDeploymentProps" id="cdk8s-plus-28.k8s.KubeDeploymentProps"></a>

Deployment enables declarative updates for Pods and ReplicaSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeDeploymentProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeDeploymentProps: k8s.KubeDeploymentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeDeploymentProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.DeploymentSpec</code> | Specification of the desired behavior of the Deployment. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeDeploymentProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeDeploymentProps.property.spec"></a>

```typescript
public readonly spec: DeploymentSpec;
```

- *Type:* cdk8s-plus-28.k8s.DeploymentSpec

Specification of the desired behavior of the Deployment.

---

### KubeEndpointSliceListProps <a name="KubeEndpointSliceListProps" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps"></a>

EndpointSliceList represents a list of endpoint slices.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEndpointSliceListProps: k8s.KubeEndpointSliceListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointSliceProps[]</code> | items is the list of endpoint slices. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.items"></a>

```typescript
public readonly items: KubeEndpointSliceProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeEndpointSliceProps[]

items is the list of endpoint slices.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeEndpointSliceProps <a name="KubeEndpointSliceProps" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps"></a>

EndpointSlice represents a subset of the endpoints that implement a service.

For a given service there may be multiple EndpointSlice objects, selected by labels, which must be joined to produce the full set of endpoints.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEndpointSliceProps: k8s.KubeEndpointSliceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.addressType">addressType</a></code> | <code>string</code> | addressType specifies the type of address carried by this EndpointSlice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.endpoints">endpoints</a></code> | <code>cdk8s-plus-28.k8s.Endpoint[]</code> | endpoints is a list of unique endpoints in this slice. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.EndpointPort[]</code> | ports specifies the list of network ports exposed by each endpoint in this slice. |

---

##### `addressType`<sup>Required</sup> <a name="addressType" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.addressType"></a>

```typescript
public readonly addressType: string;
```

- *Type:* string

addressType specifies the type of address carried by this EndpointSlice.

All addresses in this slice must be the same type. This field is immutable after creation. The following address types are currently supported: * IPv4: Represents an IPv4 Address. * IPv6: Represents an IPv6 Address. * FQDN: Represents a Fully Qualified Domain Name.

---

##### `endpoints`<sup>Required</sup> <a name="endpoints" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.endpoints"></a>

```typescript
public readonly endpoints: Endpoint[];
```

- *Type:* cdk8s-plus-28.k8s.Endpoint[]

endpoints is a list of unique endpoints in this slice.

Each slice may include a maximum of 1000 endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.KubeEndpointSliceProps.property.ports"></a>

```typescript
public readonly ports: EndpointPort[];
```

- *Type:* cdk8s-plus-28.k8s.EndpointPort[]

ports specifies the list of network ports exposed by each endpoint in this slice.

Each port must have a unique name. When ports is empty, it indicates that there are no defined ports. When a port is defined with a nil port value, it indicates "all ports". Each slice may include a maximum of 100 ports.

---

### KubeEndpointsListProps <a name="KubeEndpointsListProps" id="cdk8s-plus-28.k8s.KubeEndpointsListProps"></a>

EndpointsList is a list of endpoints.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEndpointsListProps: k8s.KubeEndpointsListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeEndpointsProps[]</code> | List of endpoints. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.property.items"></a>

```typescript
public readonly items: KubeEndpointsProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeEndpointsProps[]

List of endpoints.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeEndpointsProps <a name="KubeEndpointsProps" id="cdk8s-plus-28.k8s.KubeEndpointsProps"></a>

Endpoints is a collection of endpoints that implement the actual service. Example:.

Name: "mysvc",
Subsets: [
{
Addresses: [{"ip": "10.10.1.1"}, {"ip": "10.10.2.2"}],
Ports: [{"name": "a", "port": 8675}, {"name": "b", "port": 309}]
},
{
Addresses: [{"ip": "10.10.3.3"}],
Ports: [{"name": "a", "port": 93}, {"name": "b", "port": 76}]
},
]

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEndpointsProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEndpointsProps: k8s.KubeEndpointsProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEndpointsProps.property.subsets">subsets</a></code> | <code>cdk8s-plus-28.k8s.EndpointSubset[]</code> | The set of all endpoints is the union of all subsets. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEndpointsProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `subsets`<sup>Optional</sup> <a name="subsets" id="cdk8s-plus-28.k8s.KubeEndpointsProps.property.subsets"></a>

```typescript
public readonly subsets: EndpointSubset[];
```

- *Type:* cdk8s-plus-28.k8s.EndpointSubset[]

The set of all endpoints is the union of all subsets.

Addresses are placed into subsets according to the IPs they share. A single address with multiple ports, some of which are ready and some of which are not (because they come from different containers) will result in the address being displayed in different subsets for the different ports. No address will appear in both Addresses and NotReadyAddresses in the same subset. Sets of addresses and ports that comprise a service.

---

### KubeEventListProps <a name="KubeEventListProps" id="cdk8s-plus-28.k8s.KubeEventListProps"></a>

EventList is a list of Event objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEventListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEventListProps: k8s.KubeEventListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeEventProps[]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeEventListProps.property.items"></a>

```typescript
public readonly items: KubeEventProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeEventProps[]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeEventProps <a name="KubeEventProps" id="cdk8s-plus-28.k8s.KubeEventProps"></a>

Event is a report of an event somewhere in the cluster.

It generally denotes some state change in the system. Events have a limited retention time and triggers and messages may evolve with time.  Event consumers should not rely on the timing of an event with a given Reason reflecting a consistent underlying trigger, or the continued existence of events with that Reason.  Events should be treated as informative, best-effort, supplemental data.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEventProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEventProps: k8s.KubeEventProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.eventTime">eventTime</a></code> | <code>Date</code> | eventTime is the time when this Event was first observed. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.action">action</a></code> | <code>string</code> | action is what action was taken/failed regarding to the regarding object. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedCount">deprecatedCount</a></code> | <code>number</code> | deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedFirstTimestamp">deprecatedFirstTimestamp</a></code> | <code>Date</code> | deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedLastTimestamp">deprecatedLastTimestamp</a></code> | <code>Date</code> | deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedSource">deprecatedSource</a></code> | <code>cdk8s-plus-28.k8s.EventSource</code> | deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.note">note</a></code> | <code>string</code> | note is a human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reason">reason</a></code> | <code>string</code> | reason is why the action was taken. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.regarding">regarding</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | regarding contains the object this Event is about. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.related">related</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | related is the optional secondary object for more complex actions. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reportingController">reportingController</a></code> | <code>string</code> | reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.reportingInstance">reportingInstance</a></code> | <code>string</code> | reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.series">series</a></code> | <code>cdk8s-plus-28.k8s.EventSeries</code> | series is data about the Event series this event represents or nil if it's a singleton Event. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEventProps.property.type">type</a></code> | <code>string</code> | type is the type of this event (Normal, Warning), new types could be added in the future. |

---

##### `eventTime`<sup>Required</sup> <a name="eventTime" id="cdk8s-plus-28.k8s.KubeEventProps.property.eventTime"></a>

```typescript
public readonly eventTime: Date;
```

- *Type:* Date

eventTime is the time when this Event was first observed.

It is required.

---

##### `action`<sup>Optional</sup> <a name="action" id="cdk8s-plus-28.k8s.KubeEventProps.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* string

action is what action was taken/failed regarding to the regarding object.

It is machine-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `deprecatedCount`<sup>Optional</sup> <a name="deprecatedCount" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedCount"></a>

```typescript
public readonly deprecatedCount: number;
```

- *Type:* number

deprecatedCount is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecatedFirstTimestamp`<sup>Optional</sup> <a name="deprecatedFirstTimestamp" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedFirstTimestamp"></a>

```typescript
public readonly deprecatedFirstTimestamp: Date;
```

- *Type:* Date

deprecatedFirstTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecatedLastTimestamp`<sup>Optional</sup> <a name="deprecatedLastTimestamp" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedLastTimestamp"></a>

```typescript
public readonly deprecatedLastTimestamp: Date;
```

- *Type:* Date

deprecatedLastTimestamp is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `deprecatedSource`<sup>Optional</sup> <a name="deprecatedSource" id="cdk8s-plus-28.k8s.KubeEventProps.property.deprecatedSource"></a>

```typescript
public readonly deprecatedSource: EventSource;
```

- *Type:* cdk8s-plus-28.k8s.EventSource

deprecatedSource is the deprecated field assuring backward compatibility with core.v1 Event type.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEventProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `note`<sup>Optional</sup> <a name="note" id="cdk8s-plus-28.k8s.KubeEventProps.property.note"></a>

```typescript
public readonly note: string;
```

- *Type:* string

note is a human-readable description of the status of this operation.

Maximal length of the note is 1kB, but libraries should be prepared to handle values up to 64kB.

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeEventProps.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

reason is why the action was taken.

It is human-readable. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `regarding`<sup>Optional</sup> <a name="regarding" id="cdk8s-plus-28.k8s.KubeEventProps.property.regarding"></a>

```typescript
public readonly regarding: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

regarding contains the object this Event is about.

In most cases it's an Object reporting controller implements, e.g. ReplicaSetController implements ReplicaSets and this event is emitted because it acts on some changes in a ReplicaSet object.

---

##### `related`<sup>Optional</sup> <a name="related" id="cdk8s-plus-28.k8s.KubeEventProps.property.related"></a>

```typescript
public readonly related: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

related is the optional secondary object for more complex actions.

E.g. when regarding object triggers a creation or deletion of related object.

---

##### `reportingController`<sup>Optional</sup> <a name="reportingController" id="cdk8s-plus-28.k8s.KubeEventProps.property.reportingController"></a>

```typescript
public readonly reportingController: string;
```

- *Type:* string

reportingController is the name of the controller that emitted this Event, e.g. `kubernetes.io/kubelet`. This field cannot be empty for new Events.

---

##### `reportingInstance`<sup>Optional</sup> <a name="reportingInstance" id="cdk8s-plus-28.k8s.KubeEventProps.property.reportingInstance"></a>

```typescript
public readonly reportingInstance: string;
```

- *Type:* string

reportingInstance is the ID of the controller instance, e.g. `kubelet-xyzf`. This field cannot be empty for new Events and it can have at most 128 characters.

---

##### `series`<sup>Optional</sup> <a name="series" id="cdk8s-plus-28.k8s.KubeEventProps.property.series"></a>

```typescript
public readonly series: EventSeries;
```

- *Type:* cdk8s-plus-28.k8s.EventSeries

series is data about the Event series this event represents or nil if it's a singleton Event.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeEventProps.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type is the type of this event (Normal, Warning), new types could be added in the future.

It is machine-readable. This field cannot be empty for new Events.

---

### KubeEvictionProps <a name="KubeEvictionProps" id="cdk8s-plus-28.k8s.KubeEvictionProps"></a>

Eviction evicts a pod from its node subject to certain policies and safety constraints.

This is a subresource of Pod.  A request to cause such an eviction is created by POSTing to .../pods/<pod name>/evictions.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeEvictionProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeEvictionProps: k8s.KubeEvictionProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvictionProps.property.deleteOptions">deleteOptions</a></code> | <code>cdk8s-plus-28.k8s.DeleteOptions</code> | DeleteOptions may be provided. |
| <code><a href="#cdk8s-plus-28.k8s.KubeEvictionProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | ObjectMeta describes the pod that is being evicted. |

---

##### `deleteOptions`<sup>Optional</sup> <a name="deleteOptions" id="cdk8s-plus-28.k8s.KubeEvictionProps.property.deleteOptions"></a>

```typescript
public readonly deleteOptions: DeleteOptions;
```

- *Type:* cdk8s-plus-28.k8s.DeleteOptions

DeleteOptions may be provided.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeEvictionProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

ObjectMeta describes the pod that is being evicted.

---

### KubeFlowSchemaListV1Beta2Props <a name="KubeFlowSchemaListV1Beta2Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeFlowSchemaListV1Beta2Props: k8s.KubeFlowSchemaListV1Beta2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props[]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.items"></a>

```typescript
public readonly items: KubeFlowSchemaV1Beta2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props[]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeFlowSchemaListV1Beta3Props <a name="KubeFlowSchemaListV1Beta3Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props"></a>

FlowSchemaList is a list of FlowSchema objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeFlowSchemaListV1Beta3Props: k8s.KubeFlowSchemaListV1Beta3Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props[]</code> | `items` is a list of FlowSchemas. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | `metadata` is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.items"></a>

```typescript
public readonly items: KubeFlowSchemaV1Beta3Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props[]

`items` is a list of FlowSchemas.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaListV1Beta3Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

`metadata` is the standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeFlowSchemaV1Beta2Props <a name="KubeFlowSchemaV1Beta2Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeFlowSchemaV1Beta2Props: k8s.KubeFlowSchemaV1Beta2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta2Props.property.spec"></a>

```typescript
public readonly spec: FlowSchemaSpecV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta2

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeFlowSchemaV1Beta3Props <a name="KubeFlowSchemaV1Beta3Props" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props"></a>

FlowSchema defines the schema of a group of flows.

Note that a flow is made up of a set of inbound API requests with similar attributes and is identified by a pair of strings: the name of the FlowSchema and a "flow distinguisher".

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeFlowSchemaV1Beta3Props: k8s.KubeFlowSchemaV1Beta3Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a FlowSchema. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeFlowSchemaV1Beta3Props.property.spec"></a>

```typescript
public readonly spec: FlowSchemaSpecV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.FlowSchemaSpecV1Beta3

`spec` is the specification of the desired behavior of a FlowSchema.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeHorizontalPodAutoscalerListProps <a name="KubeHorizontalPodAutoscalerListProps" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps"></a>

list of horizontal pod autoscaler objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeHorizontalPodAutoscalerListProps: k8s.KubeHorizontalPodAutoscalerListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps[]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.items"></a>

```typescript
public readonly items: KubeHorizontalPodAutoscalerProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps[]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeHorizontalPodAutoscalerListV2Props <a name="KubeHorizontalPodAutoscalerListV2Props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props"></a>

HorizontalPodAutoscalerList is a list of horizontal pod autoscaler objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeHorizontalPodAutoscalerListV2Props: k8s.KubeHorizontalPodAutoscalerListV2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props[]</code> | items is the list of horizontal pod autoscaler objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | metadata is the standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.items"></a>

```typescript
public readonly items: KubeHorizontalPodAutoscalerV2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props[]

items is the list of horizontal pod autoscaler objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerListV2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

metadata is the standard list metadata.

---

### KubeHorizontalPodAutoscalerProps <a name="KubeHorizontalPodAutoscalerProps" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps"></a>

configuration of a horizontal pod autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeHorizontalPodAutoscalerProps: k8s.KubeHorizontalPodAutoscalerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec</code> | spec defines the behaviour of autoscaler. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerProps.property.spec"></a>

```typescript
public readonly spec: HorizontalPodAutoscalerSpec;
```

- *Type:* cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpec

spec defines the behaviour of autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeHorizontalPodAutoscalerV2Props <a name="KubeHorizontalPodAutoscalerV2Props" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props"></a>

HorizontalPodAutoscaler is the configuration for a horizontal pod autoscaler, which automatically manages the replica count of any resource implementing the scale subresource based on the metrics specified.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeHorizontalPodAutoscalerV2Props: k8s.KubeHorizontalPodAutoscalerV2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | metadata is the standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2</code> | spec is the specification for the behaviour of the autoscaler. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

metadata is the standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeHorizontalPodAutoscalerV2Props.property.spec"></a>

```typescript
public readonly spec: HorizontalPodAutoscalerSpecV2;
```

- *Type:* cdk8s-plus-28.k8s.HorizontalPodAutoscalerSpecV2

spec is the specification for the behaviour of the autoscaler.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeIngressClassListProps <a name="KubeIngressClassListProps" id="cdk8s-plus-28.k8s.KubeIngressClassListProps"></a>

IngressClassList is a collection of IngressClasses.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIngressClassListProps: k8s.KubeIngressClassListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressClassProps[]</code> | items is the list of IngressClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.property.items"></a>

```typescript
public readonly items: KubeIngressClassProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeIngressClassProps[]

items is the list of IngressClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeIngressClassProps <a name="KubeIngressClassProps" id="cdk8s-plus-28.k8s.KubeIngressClassProps"></a>

IngressClass represents the class of the Ingress, referenced by the Ingress Spec.

The `ingressclass.kubernetes.io/is-default-class` annotation can be used to indicate that an IngressClass should be considered default. When a single IngressClass resource has this annotation set to true, new Ingress resources without a class specified will be assigned this default class.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressClassProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIngressClassProps: k8s.KubeIngressClassProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressClassProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.IngressClassSpec</code> | spec is the desired state of the IngressClass. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressClassProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressClassProps.property.spec"></a>

```typescript
public readonly spec: IngressClassSpec;
```

- *Type:* cdk8s-plus-28.k8s.IngressClassSpec

spec is the desired state of the IngressClass.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeIngressListProps <a name="KubeIngressListProps" id="cdk8s-plus-28.k8s.KubeIngressListProps"></a>

IngressList is a collection of Ingress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIngressListProps: k8s.KubeIngressListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeIngressProps[]</code> | items is the list of Ingress. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIngressListProps.property.items"></a>

```typescript
public readonly items: KubeIngressProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeIngressProps[]

items is the list of Ingress.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeIngressProps <a name="KubeIngressProps" id="cdk8s-plus-28.k8s.KubeIngressProps"></a>

Ingress is a collection of rules that allow inbound connections to reach the endpoints defined by a backend.

An Ingress can be configured to give services externally-reachable urls, load balance traffic, terminate SSL, offer name based virtual hosting etc.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIngressProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIngressProps: k8s.KubeIngressProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIngressProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.IngressSpec</code> | spec is the desired state of the Ingress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIngressProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIngressProps.property.spec"></a>

```typescript
public readonly spec: IngressSpec;
```

- *Type:* cdk8s-plus-28.k8s.IngressSpec

spec is the desired state of the Ingress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeIpAddressListV1Alpha1Props <a name="KubeIpAddressListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props"></a>

IPAddressList contains a list of IPAddress.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIpAddressListV1Alpha1Props: k8s.KubeIpAddressListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props[]</code> | items is the list of IPAddresses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeIpAddressV1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props[]

items is the list of IPAddresses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeIpAddressV1Alpha1Props <a name="KubeIpAddressV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props"></a>

IPAddress represents a single IP of a single IP Family.

The object is designed to be used by APIs that operate on IP addresses. The object is used by the Service core API for allocation of IP addresses. An IP address can be represented in different formats, to guarantee the uniqueness of the IP, the name of the object is the IP address in canonical format, four decimal digits separated by dots suppressing leading zeros for IPv4 and the representation defined by RFC 5952 for IPv6. Valid: 192.168.1.5 or 2001:db8::1 or 2001:db8:aaaa:bbbb:cccc:dddd:eeee:1 Invalid: 10.01.2.3 or 2001:db8:0:0:0::1

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeIpAddressV1Alpha1Props: k8s.KubeIpAddressV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1</code> | spec is the desired state of the IPAddress. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeIpAddressV1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: IpAddressSpecV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.IpAddressSpecV1Alpha1

spec is the desired state of the IPAddress.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeJobListProps <a name="KubeJobListProps" id="cdk8s-plus-28.k8s.KubeJobListProps"></a>

JobList is a collection of jobs.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeJobListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeJobListProps: k8s.KubeJobListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeJobProps[]</code> | items is the list of Jobs. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeJobListProps.property.items"></a>

```typescript
public readonly items: KubeJobProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeJobProps[]

items is the list of Jobs.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeJobProps <a name="KubeJobProps" id="cdk8s-plus-28.k8s.KubeJobProps"></a>

Job represents the configuration of a single job.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeJobProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeJobProps: k8s.KubeJobProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeJobProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.JobSpec</code> | Specification of the desired behavior of a job. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeJobProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeJobProps.property.spec"></a>

```typescript
public readonly spec: JobSpec;
```

- *Type:* cdk8s-plus-28.k8s.JobSpec

Specification of the desired behavior of a job.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLeaseListProps <a name="KubeLeaseListProps" id="cdk8s-plus-28.k8s.KubeLeaseListProps"></a>

LeaseList is a list of Lease objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLeaseListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeLeaseListProps: k8s.KubeLeaseListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeLeaseProps[]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLeaseListProps.property.items"></a>

```typescript
public readonly items: KubeLeaseProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeLeaseProps[]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeLeaseProps <a name="KubeLeaseProps" id="cdk8s-plus-28.k8s.KubeLeaseProps"></a>

Lease defines a lease concept.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLeaseProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeLeaseProps: k8s.KubeLeaseProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLeaseProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.LeaseSpec</code> | spec contains the specification of the Lease. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLeaseProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLeaseProps.property.spec"></a>

```typescript
public readonly spec: LeaseSpec;
```

- *Type:* cdk8s-plus-28.k8s.LeaseSpec

spec contains the specification of the Lease.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLimitRangeListProps <a name="KubeLimitRangeListProps" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps"></a>

LimitRangeList is a list of LimitRange items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeLimitRangeListProps: k8s.KubeLimitRangeListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeLimitRangeProps[]</code> | Items is a list of LimitRange objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.items"></a>

```typescript
public readonly items: KubeLimitRangeProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeLimitRangeProps[]

Items is a list of LimitRange objects.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeLimitRangeProps <a name="KubeLimitRangeProps" id="cdk8s-plus-28.k8s.KubeLimitRangeProps"></a>

LimitRange sets resource usage limits for each kind of resource in a Namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeLimitRangeProps: k8s.KubeLimitRangeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLimitRangeProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.LimitRangeSpec</code> | Spec defines the limits enforced. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLimitRangeProps.property.spec"></a>

```typescript
public readonly spec: LimitRangeSpec;
```

- *Type:* cdk8s-plus-28.k8s.LimitRangeSpec

Spec defines the limits enforced.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeLocalSubjectAccessReviewProps <a name="KubeLocalSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps"></a>

LocalSubjectAccessReview checks whether or not a user or group can perform an action in a given namespace.

Having a namespace scoped resource makes it much easier to grant namespace scoped policy that includes permissions checking.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeLocalSubjectAccessReviewProps: k8s.KubeLocalSubjectAccessReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.spec"></a>

```typescript
public readonly spec: SubjectAccessReviewSpec;
```

- *Type:* cdk8s-plus-28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

spec.namespace must be equal to the namespace you made the request against.  If empty, it is defaulted.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeLocalSubjectAccessReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeMutatingWebhookConfigurationListProps <a name="KubeMutatingWebhookConfigurationListProps" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps"></a>

MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeMutatingWebhookConfigurationListProps: k8s.KubeMutatingWebhookConfigurationListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps[]</code> | List of MutatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.items"></a>

```typescript
public readonly items: KubeMutatingWebhookConfigurationProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps[]

List of MutatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeMutatingWebhookConfigurationProps <a name="KubeMutatingWebhookConfigurationProps" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps"></a>

MutatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and may change the object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeMutatingWebhookConfigurationProps: k8s.KubeMutatingWebhookConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.webhooks">webhooks</a></code> | <code>cdk8s-plus-28.k8s.MutatingWebhook[]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeMutatingWebhookConfigurationProps.property.webhooks"></a>

```typescript
public readonly webhooks: MutatingWebhook[];
```

- *Type:* cdk8s-plus-28.k8s.MutatingWebhook[]

Webhooks is a list of webhooks and the affected resources and operations.

---

### KubeNamespaceListProps <a name="KubeNamespaceListProps" id="cdk8s-plus-28.k8s.KubeNamespaceListProps"></a>

NamespaceList is a list of Namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNamespaceListProps: k8s.KubeNamespaceListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeNamespaceProps[]</code> | Items is the list of Namespace objects in the list. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.property.items"></a>

```typescript
public readonly items: KubeNamespaceProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeNamespaceProps[]

Items is the list of Namespace objects in the list.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeNamespaceProps <a name="KubeNamespaceProps" id="cdk8s-plus-28.k8s.KubeNamespaceProps"></a>

Namespace provides a scope for Names.

Use of multiple namespaces is optional.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNamespaceProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNamespaceProps: k8s.KubeNamespaceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNamespaceProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.NamespaceSpec</code> | Spec defines the behavior of the Namespace. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNamespaceProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNamespaceProps.property.spec"></a>

```typescript
public readonly spec: NamespaceSpec;
```

- *Type:* cdk8s-plus-28.k8s.NamespaceSpec

Spec defines the behavior of the Namespace.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeNetworkPolicyListProps <a name="KubeNetworkPolicyListProps" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps"></a>

NetworkPolicyList is a list of NetworkPolicy objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNetworkPolicyListProps: k8s.KubeNetworkPolicyListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeNetworkPolicyProps[]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.items"></a>

```typescript
public readonly items: KubeNetworkPolicyProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeNetworkPolicyProps[]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeNetworkPolicyProps <a name="KubeNetworkPolicyProps" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps"></a>

NetworkPolicy describes what network traffic is allowed for a set of Pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNetworkPolicyProps: k8s.KubeNetworkPolicyProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicySpec</code> | spec represents the specification of the desired behavior for this NetworkPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNetworkPolicyProps.property.spec"></a>

```typescript
public readonly spec: NetworkPolicySpec;
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicySpec

spec represents the specification of the desired behavior for this NetworkPolicy.

---

### KubeNodeListProps <a name="KubeNodeListProps" id="cdk8s-plus-28.k8s.KubeNodeListProps"></a>

NodeList is the whole list of all Nodes which have been registered with master.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNodeListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNodeListProps: k8s.KubeNodeListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeNodeProps[]</code> | List of nodes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeNodeListProps.property.items"></a>

```typescript
public readonly items: KubeNodeProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeNodeProps[]

List of nodes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeNodeProps <a name="KubeNodeProps" id="cdk8s-plus-28.k8s.KubeNodeProps"></a>

Node is a worker node in Kubernetes.

Each node will have a unique identifier in the cache (i.e. in etcd).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeNodeProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeNodeProps: k8s.KubeNodeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeNodeProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.NodeSpec</code> | Spec defines the behavior of a node. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeNodeProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeNodeProps.property.spec"></a>

```typescript
public readonly spec: NodeSpec;
```

- *Type:* cdk8s-plus-28.k8s.NodeSpec

Spec defines the behavior of a node.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePersistentVolumeClaimListProps <a name="KubePersistentVolumeClaimListProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps"></a>

PersistentVolumeClaimList is a list of PersistentVolumeClaim items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePersistentVolumeClaimListProps: k8s.KubePersistentVolumeClaimListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps[]</code> | items is a list of persistent volume claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.items"></a>

```typescript
public readonly items: KubePersistentVolumeClaimProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps[]

items is a list of persistent volume claims.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePersistentVolumeClaimProps <a name="KubePersistentVolumeClaimProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps"></a>

PersistentVolumeClaim is a user's request for and claim to a persistent volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePersistentVolumeClaimProps: k8s.KubePersistentVolumeClaimProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeClaimSpec</code> | spec defines the desired characteristics of a volume requested by a pod author. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps.property.spec"></a>

```typescript
public readonly spec: PersistentVolumeClaimSpec;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeClaimSpec

spec defines the desired characteristics of a volume requested by a pod author.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

### KubePersistentVolumeListProps <a name="KubePersistentVolumeListProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps"></a>

PersistentVolumeList is a list of PersistentVolume items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePersistentVolumeListProps: k8s.KubePersistentVolumeListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeProps[]</code> | items is a list of persistent volumes. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.items"></a>

```typescript
public readonly items: KubePersistentVolumeProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeProps[]

items is a list of persistent volumes.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePersistentVolumeProps <a name="KubePersistentVolumeProps" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps"></a>

PersistentVolume (PV) is a storage resource provisioned by an administrator.

It is analogous to a node. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePersistentVolumeProps: k8s.KubePersistentVolumeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeSpec</code> | spec defines a specification of a persistent volume owned by the cluster. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePersistentVolumeProps.property.spec"></a>

```typescript
public readonly spec: PersistentVolumeSpec;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeSpec

spec defines a specification of a persistent volume owned by the cluster.

Provisioned by an administrator. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistent-volumes

---

### KubePodDisruptionBudgetListProps <a name="KubePodDisruptionBudgetListProps" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps"></a>

PodDisruptionBudgetList is a collection of PodDisruptionBudgets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodDisruptionBudgetListProps: k8s.KubePodDisruptionBudgetListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps[]</code> | Items is a list of PodDisruptionBudgets. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.items"></a>

```typescript
public readonly items: KubePodDisruptionBudgetProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps[]

Items is a list of PodDisruptionBudgets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePodDisruptionBudgetProps <a name="KubePodDisruptionBudgetProps" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps"></a>

PodDisruptionBudget is an object to define the max disruption that can be caused to a collection of pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodDisruptionBudgetProps: k8s.KubePodDisruptionBudgetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PodDisruptionBudgetSpec</code> | Specification of the desired behavior of the PodDisruptionBudget. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodDisruptionBudgetProps.property.spec"></a>

```typescript
public readonly spec: PodDisruptionBudgetSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodDisruptionBudgetSpec

Specification of the desired behavior of the PodDisruptionBudget.

---

### KubePodListProps <a name="KubePodListProps" id="cdk8s-plus-28.k8s.KubePodListProps"></a>

PodList is a list of Pods.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodListProps: k8s.KubePodListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePodProps[]</code> | List of pods. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodListProps.property.items"></a>

```typescript
public readonly items: KubePodProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePodProps[]

List of pods.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePodProps <a name="KubePodProps" id="cdk8s-plus-28.k8s.KubePodProps"></a>

Pod is a collection of containers that can run on a host.

This resource is created by clients and scheduled onto hosts.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodProps: k8s.KubePodProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PodSpec</code> | Specification of the desired behavior of the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodProps.property.spec"></a>

```typescript
public readonly spec: PodSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePodSchedulingContextListV1Alpha2Props <a name="KubePodSchedulingContextListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props"></a>

PodSchedulingContextList is a collection of Pod scheduling objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodSchedulingContextListV1Alpha2Props: k8s.KubePodSchedulingContextListV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props[]</code> | Items is the list of PodSchedulingContext objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.items"></a>

```typescript
public readonly items: KubePodSchedulingContextV1Alpha2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props[]

Items is the list of PodSchedulingContext objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextListV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubePodSchedulingContextV1Alpha2Props <a name="KubePodSchedulingContextV1Alpha2Props" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props"></a>

PodSchedulingContext objects hold information that is needed to schedule a Pod with ResourceClaims that use "WaitForFirstConsumer" allocation mode.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodSchedulingContextV1Alpha2Props: k8s.KubePodSchedulingContextV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2</code> | Spec describes where resources for the Pod are needed. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.spec"></a>

```typescript
public readonly spec: PodSchedulingContextSpecV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2

Spec describes where resources for the Pod are needed.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodSchedulingContextV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

---

### KubePodTemplateListProps <a name="KubePodTemplateListProps" id="cdk8s-plus-28.k8s.KubePodTemplateListProps"></a>

PodTemplateList is a list of PodTemplates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodTemplateListProps: k8s.KubePodTemplateListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePodTemplateProps[]</code> | List of pod templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.property.items"></a>

```typescript
public readonly items: KubePodTemplateProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePodTemplateProps[]

List of pod templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubePodTemplateProps <a name="KubePodTemplateProps" id="cdk8s-plus-28.k8s.KubePodTemplateProps"></a>

PodTemplate describes a template for creating copies of a predefined pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePodTemplateProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePodTemplateProps: k8s.KubePodTemplateProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePodTemplateProps.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | Template defines the pods that will be created from this pod template. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePodTemplateProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.KubePodTemplateProps.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

Template defines the pods that will be created from this pod template.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePriorityClassListProps <a name="KubePriorityClassListProps" id="cdk8s-plus-28.k8s.KubePriorityClassListProps"></a>

PriorityClassList is a collection of priority classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityClassListProps: k8s.KubePriorityClassListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityClassProps[]</code> | items is the list of PriorityClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.property.items"></a>

```typescript
public readonly items: KubePriorityClassProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePriorityClassProps[]

items is the list of PriorityClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubePriorityClassProps <a name="KubePriorityClassProps" id="cdk8s-plus-28.k8s.KubePriorityClassProps"></a>

PriorityClass defines mapping from a priority class name to the priority integer value.

The value can be any valid integer.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityClassProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityClassProps: k8s.KubePriorityClassProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.value">value</a></code> | <code>number</code> | value represents the integer value of this priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.description">description</a></code> | <code>string</code> | description is an arbitrary string that usually provides guidelines on when this priority class should be used. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.globalDefault">globalDefault</a></code> | <code>boolean</code> | globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityClassProps.property.preemptionPolicy">preemptionPolicy</a></code> | <code>string</code> | preemptionPolicy is the Policy for preempting pods with lower priority. |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.value"></a>

```typescript
public readonly value: number;
```

- *Type:* number

value represents the integer value of this priority class.

This is the actual priority that pods receive when they have the name of this class in their pod spec.

---

##### `description`<sup>Optional</sup> <a name="description" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

description is an arbitrary string that usually provides guidelines on when this priority class should be used.

---

##### `globalDefault`<sup>Optional</sup> <a name="globalDefault" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.globalDefault"></a>

```typescript
public readonly globalDefault: boolean;
```

- *Type:* boolean

globalDefault specifies whether this PriorityClass should be considered as the default priority for pods that do not have any priority class.

Only one PriorityClass can be marked as `globalDefault`. However, if more than one PriorityClasses exists with their `globalDefault` field set to true, the smallest value of such global default PriorityClasses will be used as the default priority.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `preemptionPolicy`<sup>Optional</sup> <a name="preemptionPolicy" id="cdk8s-plus-28.k8s.KubePriorityClassProps.property.preemptionPolicy"></a>

```typescript
public readonly preemptionPolicy: string;
```

- *Type:* string
- *Default:* PreemptLowerPriority if unset.

preemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

### KubePriorityLevelConfigurationListV1Beta2Props <a name="KubePriorityLevelConfigurationListV1Beta2Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityLevelConfigurationListV1Beta2Props: k8s.KubePriorityLevelConfigurationListV1Beta2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props[]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.items"></a>

```typescript
public readonly items: KubePriorityLevelConfigurationV1Beta2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props[]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePriorityLevelConfigurationListV1Beta3Props <a name="KubePriorityLevelConfigurationListV1Beta3Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props"></a>

PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityLevelConfigurationListV1Beta3Props: k8s.KubePriorityLevelConfigurationListV1Beta3Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props[]</code> | `items` is a list of request-priorities. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | `metadata` is the standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.items"></a>

```typescript
public readonly items: KubePriorityLevelConfigurationV1Beta3Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props[]

`items` is a list of request-priorities.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationListV1Beta3Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubePriorityLevelConfigurationV1Beta2Props <a name="KubePriorityLevelConfigurationV1Beta2Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityLevelConfigurationV1Beta2Props: k8s.KubePriorityLevelConfigurationV1Beta2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta2Props.property.spec"></a>

```typescript
public readonly spec: PriorityLevelConfigurationSpecV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubePriorityLevelConfigurationV1Beta3Props <a name="KubePriorityLevelConfigurationV1Beta3Props" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props"></a>

PriorityLevelConfiguration represents the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubePriorityLevelConfigurationV1Beta3Props: k8s.KubePriorityLevelConfigurationV1Beta3Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | `metadata` is the standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3</code> | `spec` is the specification of the desired behavior of a "request-priority". |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

`metadata` is the standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubePriorityLevelConfigurationV1Beta3Props.property.spec"></a>

```typescript
public readonly spec: PriorityLevelConfigurationSpecV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3

`spec` is the specification of the desired behavior of a "request-priority".

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeReplicaSetListProps <a name="KubeReplicaSetListProps" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps"></a>

ReplicaSetList is a collection of ReplicaSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeReplicaSetListProps: k8s.KubeReplicaSetListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicaSetProps[]</code> | List of ReplicaSets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.items"></a>

```typescript
public readonly items: KubeReplicaSetProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeReplicaSetProps[]

List of ReplicaSets.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeReplicaSetProps <a name="KubeReplicaSetProps" id="cdk8s-plus-28.k8s.KubeReplicaSetProps"></a>

ReplicaSet ensures that a specified number of pod replicas are running at any given time.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeReplicaSetProps: k8s.KubeReplicaSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicaSetProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ReplicaSetSpec</code> | Spec defines the specification of the desired behavior of the ReplicaSet. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

If the Labels of a ReplicaSet are empty, they are defaulted to be the same as the Pod(s) that the ReplicaSet manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicaSetProps.property.spec"></a>

```typescript
public readonly spec: ReplicaSetSpec;
```

- *Type:* cdk8s-plus-28.k8s.ReplicaSetSpec

Spec defines the specification of the desired behavior of the ReplicaSet.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeReplicationControllerListProps <a name="KubeReplicationControllerListProps" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps"></a>

ReplicationControllerList is a collection of replication controllers.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeReplicationControllerListProps: k8s.KubeReplicationControllerListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeReplicationControllerProps[]</code> | List of replication controllers. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.items"></a>

```typescript
public readonly items: KubeReplicationControllerProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeReplicationControllerProps[]

List of replication controllers.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeReplicationControllerProps <a name="KubeReplicationControllerProps" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps"></a>

ReplicationController represents the configuration of a replication controller.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeReplicationControllerProps: k8s.KubeReplicationControllerProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages. |
| <code><a href="#cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ReplicationControllerSpec</code> | Spec defines the specification of the desired behavior of the replication controller. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

If the Labels of a ReplicationController are empty, they are defaulted to be the same as the Pod(s) that the replication controller manages.

Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeReplicationControllerProps.property.spec"></a>

```typescript
public readonly spec: ReplicationControllerSpec;
```

- *Type:* cdk8s-plus-28.k8s.ReplicationControllerSpec

Spec defines the specification of the desired behavior of the replication controller.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeResourceClaimListV1Alpha2Props <a name="KubeResourceClaimListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props"></a>

ResourceClaimList is a collection of claims.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClaimListV1Alpha2Props: k8s.KubeResourceClaimListV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props[]</code> | Items is the list of resource claims. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.items"></a>

```typescript
public readonly items: KubeResourceClaimV1Alpha2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props[]

Items is the list of resource claims.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimListV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClaimTemplateListV1Alpha2Props <a name="KubeResourceClaimTemplateListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props"></a>

ResourceClaimTemplateList is a collection of claim templates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClaimTemplateListV1Alpha2Props: k8s.KubeResourceClaimTemplateListV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props[]</code> | Items is the list of resource claim templates. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.items"></a>

```typescript
public readonly items: KubeResourceClaimTemplateV1Alpha2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props[]

Items is the list of resource claim templates.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateListV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClaimTemplateV1Alpha2Props <a name="KubeResourceClaimTemplateV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props"></a>

ResourceClaimTemplate is used to produce ResourceClaim objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClaimTemplateV1Alpha2Props: k8s.KubeResourceClaimTemplateV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2</code> | Describes the ResourceClaim that is to be generated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.spec"></a>

```typescript
public readonly spec: ResourceClaimTemplateSpecV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2

Describes the ResourceClaim that is to be generated.

This field is immutable. A ResourceClaim will get created by the control plane for a Pod when needed and then not get updated anymore.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimTemplateV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

---

### KubeResourceClaimV1Alpha2Props <a name="KubeResourceClaimV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props"></a>

ResourceClaim describes which resources are needed by a resource consumer.

Its status tracks whether the resource has been allocated and what the resulting attributes are.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClaimV1Alpha2Props: k8s.KubeResourceClaimV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2</code> | Spec describes the desired attributes of a resource that then needs to be allocated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.spec"></a>

```typescript
public readonly spec: ResourceClaimSpecV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2

Spec describes the desired attributes of a resource that then needs to be allocated.

It can only be set once when creating the ResourceClaim.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClaimV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

---

### KubeResourceClassListV1Alpha2Props <a name="KubeResourceClassListV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props"></a>

ResourceClassList is a collection of classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClassListV1Alpha2Props: k8s.KubeResourceClassListV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props[]</code> | Items is the list of resource classes. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.items"></a>

```typescript
public readonly items: KubeResourceClassV1Alpha2Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props[]

Items is the list of resource classes.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassListV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

---

### KubeResourceClassV1Alpha2Props <a name="KubeResourceClassV1Alpha2Props" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props"></a>

ResourceClass is used by administrators to influence how resources are allocated.

This is an alpha type and requires enabling the DynamicResourceAllocation feature gate.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceClassV1Alpha2Props: k8s.KubeResourceClassV1Alpha2Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.driverName">driverName</a></code> | <code>string</code> | DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.parametersRef">parametersRef</a></code> | <code>cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2</code> | ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.suitableNodes">suitableNodes</a></code> | <code>cdk8s-plus-28.k8s.NodeSelector</code> | Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet. |

---

##### `driverName`<sup>Required</sup> <a name="driverName" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.driverName"></a>

```typescript
public readonly driverName: string;
```

- *Type:* string

DriverName defines the name of the dynamic resource driver that is used for allocation of a ResourceClaim that uses this class.

Resource drivers have a unique name in forward domain order (acme.example.com).

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

---

##### `parametersRef`<sup>Optional</sup> <a name="parametersRef" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.parametersRef"></a>

```typescript
public readonly parametersRef: ResourceClassParametersReferenceV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2

ParametersRef references an arbitrary separate object that may hold parameters that will be used by the driver when allocating a resource that uses this class.

A dynamic resource driver can distinguish between parameters stored here and and those stored in ResourceClaimSpec.

---

##### `suitableNodes`<sup>Optional</sup> <a name="suitableNodes" id="cdk8s-plus-28.k8s.KubeResourceClassV1Alpha2Props.property.suitableNodes"></a>

```typescript
public readonly suitableNodes: NodeSelector;
```

- *Type:* cdk8s-plus-28.k8s.NodeSelector

Only nodes matching the selector will be considered by the scheduler when trying to find a Node that fits a Pod when that Pod uses a ResourceClaim that has not been allocated yet.

Setting this field is optional. If null, all nodes are candidates.

---

### KubeResourceQuotaListProps <a name="KubeResourceQuotaListProps" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps"></a>

ResourceQuotaList is a list of ResourceQuota items.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceQuotaListProps: k8s.KubeResourceQuotaListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeResourceQuotaProps[]</code> | Items is a list of ResourceQuota objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.items"></a>

```typescript
public readonly items: KubeResourceQuotaProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeResourceQuotaProps[]

Items is a list of ResourceQuota objects.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeResourceQuotaProps <a name="KubeResourceQuotaProps" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps"></a>

ResourceQuota sets aggregate quota restrictions enforced per namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeResourceQuotaProps: k8s.KubeResourceQuotaProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ResourceQuotaSpec</code> | Spec defines the desired quota. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeResourceQuotaProps.property.spec"></a>

```typescript
public readonly spec: ResourceQuotaSpec;
```

- *Type:* cdk8s-plus-28.k8s.ResourceQuotaSpec

Spec defines the desired quota.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeRoleBindingListProps <a name="KubeRoleBindingListProps" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps"></a>

RoleBindingList is a collection of RoleBindings.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRoleBindingListProps: k8s.KubeRoleBindingListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleBindingProps[]</code> | Items is a list of RoleBindings. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.items"></a>

```typescript
public readonly items: KubeRoleBindingProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeRoleBindingProps[]

Items is a list of RoleBindings.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

---

### KubeRoleBindingProps <a name="KubeRoleBindingProps" id="cdk8s-plus-28.k8s.KubeRoleBindingProps"></a>

RoleBinding references a role, but does not contain it.

It can reference a Role in the same namespace or a ClusterRole in the global namespace. It adds who information via Subjects and namespace information by which namespace it exists in.  RoleBindings in a given namespace only have effect in that namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRoleBindingProps: k8s.KubeRoleBindingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.roleRef">roleRef</a></code> | <code>cdk8s-plus-28.k8s.RoleRef</code> | RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleBindingProps.property.subjects">subjects</a></code> | <code>cdk8s-plus-28.k8s.Subject[]</code> | Subjects holds references to the objects the role applies to. |

---

##### `roleRef`<sup>Required</sup> <a name="roleRef" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.roleRef"></a>

```typescript
public readonly roleRef: RoleRef;
```

- *Type:* cdk8s-plus-28.k8s.RoleRef

RoleRef can reference a Role in the current namespace or a ClusterRole in the global namespace.

If the RoleRef cannot be resolved, the Authorizer must return an error. This field is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

---

##### `subjects`<sup>Optional</sup> <a name="subjects" id="cdk8s-plus-28.k8s.KubeRoleBindingProps.property.subjects"></a>

```typescript
public readonly subjects: Subject[];
```

- *Type:* cdk8s-plus-28.k8s.Subject[]

Subjects holds references to the objects the role applies to.

---

### KubeRoleListProps <a name="KubeRoleListProps" id="cdk8s-plus-28.k8s.KubeRoleListProps"></a>

RoleList is a collection of Roles.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRoleListProps: k8s.KubeRoleListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeRoleProps[]</code> | Items is a list of Roles. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard object's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRoleListProps.property.items"></a>

```typescript
public readonly items: KubeRoleProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeRoleProps[]

Items is a list of Roles.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard object's metadata.

---

### KubeRoleProps <a name="KubeRoleProps" id="cdk8s-plus-28.k8s.KubeRoleProps"></a>

Role is a namespaced, logical grouping of PolicyRules that can be referenced as a unit by a RoleBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRoleProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRoleProps: k8s.KubeRoleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRoleProps.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.PolicyRule[]</code> | Rules holds all the PolicyRules for this Role. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRoleProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.KubeRoleProps.property.rules"></a>

```typescript
public readonly rules: PolicyRule[];
```

- *Type:* cdk8s-plus-28.k8s.PolicyRule[]

Rules holds all the PolicyRules for this Role.

---

### KubeRuntimeClassListProps <a name="KubeRuntimeClassListProps" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps"></a>

RuntimeClassList is a list of RuntimeClass objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRuntimeClassListProps: k8s.KubeRuntimeClassListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeRuntimeClassProps[]</code> | items is a list of schema objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.items"></a>

```typescript
public readonly items: KubeRuntimeClassProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeRuntimeClassProps[]

items is a list of schema objects.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeRuntimeClassProps <a name="KubeRuntimeClassProps" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps"></a>

RuntimeClass defines a class of container runtime supported in the cluster.

The RuntimeClass is used to determine which container runtime is used to run all containers in a pod. RuntimeClasses are manually defined by a user or cluster provisioner, and referenced in the PodSpec. The Kubelet is responsible for resolving the RuntimeClassName reference before running the pod.  For more details, see https://kubernetes.io/docs/concepts/containers/runtime-class/

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeRuntimeClassProps: k8s.KubeRuntimeClassProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.handler">handler</a></code> | <code>string</code> | handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.overhead">overhead</a></code> | <code>cdk8s-plus-28.k8s.Overhead</code> | overhead represents the resource overhead associated with running a pod for a given RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.scheduling">scheduling</a></code> | <code>cdk8s-plus-28.k8s.Scheduling</code> | scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it. |

---

##### `handler`<sup>Required</sup> <a name="handler" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.handler"></a>

```typescript
public readonly handler: string;
```

- *Type:* string

handler specifies the underlying runtime and configuration that the CRI implementation will use to handle pods of this class.

The possible values are specific to the node & CRI configuration.  It is assumed that all handlers are available on every node, and handlers of the same name are equivalent on every node. For example, a handler called "runc" might specify that the runc OCI runtime (using native Linux containers) will be used to run the containers in a pod. The Handler must be lowercase, conform to the DNS Label (RFC 1123) requirements, and is immutable.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.overhead"></a>

```typescript
public readonly overhead: Overhead;
```

- *Type:* cdk8s-plus-28.k8s.Overhead

overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

For more details, see
https://kubernetes.io/docs/concepts/scheduling-eviction/pod-overhead/

---

##### `scheduling`<sup>Optional</sup> <a name="scheduling" id="cdk8s-plus-28.k8s.KubeRuntimeClassProps.property.scheduling"></a>

```typescript
public readonly scheduling: Scheduling;
```

- *Type:* cdk8s-plus-28.k8s.Scheduling

scheduling holds the scheduling constraints to ensure that pods running with this RuntimeClass are scheduled to nodes that support it.

If scheduling is nil, this RuntimeClass is assumed to be supported by all nodes.

---

### KubeScaleProps <a name="KubeScaleProps" id="cdk8s-plus-28.k8s.KubeScaleProps"></a>

Scale represents a scaling request for a resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeScaleProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeScaleProps: k8s.KubeScaleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeScaleProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeScaleProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ScaleSpec</code> | spec defines the behavior of the scale. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeScaleProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeScaleProps.property.spec"></a>

```typescript
public readonly spec: ScaleSpec;
```

- *Type:* cdk8s-plus-28.k8s.ScaleSpec

spec defines the behavior of the scale.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status.

---

### KubeSecretListProps <a name="KubeSecretListProps" id="cdk8s-plus-28.k8s.KubeSecretListProps"></a>

SecretList is a list of Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSecretListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSecretListProps: k8s.KubeSecretListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeSecretProps[]</code> | Items is a list of secret objects. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeSecretListProps.property.items"></a>

```typescript
public readonly items: KubeSecretProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeSecretProps[]

Items is a list of secret objects.

More info: https://kubernetes.io/docs/concepts/configuration/secret

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeSecretProps <a name="KubeSecretProps" id="cdk8s-plus-28.k8s.KubeSecretProps"></a>

Secret holds secret data of a certain type.

The total bytes of the values in the Data field must be less than MaxSecretSize bytes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSecretProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSecretProps: k8s.KubeSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.data">data</a></code> | <code>{[ key: string ]: string}</code> | Data contains the secret data. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.stringData">stringData</a></code> | <code>{[ key: string ]: string}</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSecretProps.property.type">type</a></code> | <code>string</code> | Used to facilitate programmatic handling of secret data. |

---

##### `data`<sup>Optional</sup> <a name="data" id="cdk8s-plus-28.k8s.KubeSecretProps.property.data"></a>

```typescript
public readonly data: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Data contains the secret data.

Each key must consist of alphanumeric characters, '-', '_' or '.'. The serialized form of the secret data is a base64 encoded string, representing the arbitrary (possibly non-string) data value here. Described in https://tools.ietf.org/html/rfc4648#section-4

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.k8s.KubeSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean

Immutable, if set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time. Defaulted to nil.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `stringData`<sup>Optional</sup> <a name="stringData" id="cdk8s-plus-28.k8s.KubeSecretProps.property.stringData"></a>

```typescript
public readonly stringData: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

stringData allows specifying non-binary secret data in string form.

It is provided as a write-only input field for convenience. All keys and values are merged into the data field on write, overwriting any existing values. The stringData field is never output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.KubeSecretProps.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Used to facilitate programmatic handling of secret data.

More info: https://kubernetes.io/docs/concepts/configuration/secret/#secret-types

---

### KubeSelfSubjectAccessReviewProps <a name="KubeSelfSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps"></a>

SelfSubjectAccessReview checks whether or the current user can perform an action.

Not filling in a spec.namespace means "in all namespaces".  Self is a special case, because users should always be able to check whether they can perform an action

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSelfSubjectAccessReviewProps: k8s.KubeSelfSubjectAccessReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.spec"></a>

```typescript
public readonly spec: SelfSubjectAccessReviewSpec;
```

- *Type:* cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec

Spec holds information about the request being evaluated.

user and groups must be empty

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectAccessReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewProps <a name="KubeSelfSubjectReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSelfSubjectReviewProps: k8s.KubeSelfSubjectReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewV1Alpha1Props <a name="KubeSelfSubjectReviewV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSelfSubjectReviewV1Alpha1Props: k8s.KubeSelfSubjectReviewV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectReviewV1Beta1Props <a name="KubeSelfSubjectReviewV1Beta1Props" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props"></a>

SelfSubjectReview contains the user information that the kube-apiserver has about the user making this request.

When using impersonation, users will receive the user info of the user being impersonated.  If impersonation or request header authentication is used, any extra keys will have their case ignored and returned as lowercase.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSelfSubjectReviewV1Beta1Props: k8s.KubeSelfSubjectReviewV1Beta1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectReviewV1Beta1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeSelfSubjectRulesReviewProps <a name="KubeSelfSubjectRulesReviewProps" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps"></a>

SelfSubjectRulesReview enumerates the set of actions the current user can perform within a namespace.

The returned list of actions may be incomplete depending on the server's authorization mode, and any errors experienced during the evaluation. SelfSubjectRulesReview should be used by UIs to show/hide actions, or to quickly let an end user reason about their permissions. It should NOT Be used by external systems to drive authorization decisions as this raises confused deputy, cache lifetime/revocation, and correctness concerns. SubjectAccessReview, and LocalAccessReview are the correct way to defer authorization decisions to the API server.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSelfSubjectRulesReviewProps: k8s.KubeSelfSubjectRulesReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.spec"></a>

```typescript
public readonly spec: SelfSubjectRulesReviewSpec;
```

- *Type:* cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSelfSubjectRulesReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeServiceAccountListProps <a name="KubeServiceAccountListProps" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps"></a>

ServiceAccountList is a list of ServiceAccount objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeServiceAccountListProps: k8s.KubeServiceAccountListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceAccountProps[]</code> | List of ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.items"></a>

```typescript
public readonly items: KubeServiceAccountProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeServiceAccountProps[]

List of ServiceAccounts.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeServiceAccountProps <a name="KubeServiceAccountProps" id="cdk8s-plus-28.k8s.KubeServiceAccountProps"></a>

ServiceAccount binds together: * a name, understood by users, and perhaps by peripheral systems, for an identity * a principal that can be authenticated and authorized * a set of secrets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeServiceAccountProps: k8s.KubeServiceAccountProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.imagePullSecrets">imagePullSecrets</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference[]</code> | ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceAccountProps.property.secrets">secrets</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference[]</code> | Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use. |

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

AutomountServiceAccountToken indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

---

##### `imagePullSecrets`<sup>Optional</sup> <a name="imagePullSecrets" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.imagePullSecrets"></a>

```typescript
public readonly imagePullSecrets: LocalObjectReference[];
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference[]

ImagePullSecrets is a list of references to secrets in the same namespace to use for pulling any images in pods that reference this ServiceAccount.

ImagePullSecrets are distinct from Secrets because Secrets can be mounted in the pod, but ImagePullSecrets are only accessed by the kubelet. More info: https://kubernetes.io/docs/concepts/containers/images/#specifying-imagepullsecrets-on-a-pod

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.k8s.KubeServiceAccountProps.property.secrets"></a>

```typescript
public readonly secrets: ObjectReference[];
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference[]

Secrets is a list of the secrets in the same namespace that pods running using this ServiceAccount are allowed to use.

Pods are only limited to this list if this service account has a "kubernetes.io/enforce-mountable-secrets" annotation set to "true". This field should not be used to find auto-generated service account token secrets for use outside of pods. Instead, tokens can be requested directly using the TokenRequest API, or service account token secrets can be manually created. More info: https://kubernetes.io/docs/concepts/configuration/secret

---

### KubeServiceListProps <a name="KubeServiceListProps" id="cdk8s-plus-28.k8s.KubeServiceListProps"></a>

ServiceList holds a list of services.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeServiceListProps: k8s.KubeServiceListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeServiceProps[]</code> | List of services. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeServiceListProps.property.items"></a>

```typescript
public readonly items: KubeServiceProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeServiceProps[]

List of services.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeServiceProps <a name="KubeServiceProps" id="cdk8s-plus-28.k8s.KubeServiceProps"></a>

Service is a named abstraction of software service (for example, mysql) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeServiceProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeServiceProps: k8s.KubeServiceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeServiceProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ServiceSpec</code> | Spec defines the behavior of a service. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeServiceProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeServiceProps.property.spec"></a>

```typescript
public readonly spec: ServiceSpec;
```

- *Type:* cdk8s-plus-28.k8s.ServiceSpec

Spec defines the behavior of a service.

https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### KubeStatefulSetListProps <a name="KubeStatefulSetListProps" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps"></a>

StatefulSetList is a collection of StatefulSets.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStatefulSetListProps: k8s.KubeStatefulSetListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeStatefulSetProps[]</code> | Items is the list of stateful sets. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list's metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.items"></a>

```typescript
public readonly items: KubeStatefulSetProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeStatefulSetProps[]

Items is the list of stateful sets.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeStatefulSetProps <a name="KubeStatefulSetProps" id="cdk8s-plus-28.k8s.KubeStatefulSetProps"></a>

StatefulSet represents a set of pods with consistent identities.

Identities are defined as:
- Network: A single stable DNS and hostname.
- Storage: As many VolumeClaims as requested.

The StatefulSet guarantees that a given network identity will always map to the same storage identity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStatefulSetProps: k8s.KubeStatefulSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatefulSetProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.StatefulSetSpec</code> | Spec defines the desired identities of pods in this set. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStatefulSetProps.property.spec"></a>

```typescript
public readonly spec: StatefulSetSpec;
```

- *Type:* cdk8s-plus-28.k8s.StatefulSetSpec

Spec defines the desired identities of pods in this set.

---

### KubeStatusProps <a name="KubeStatusProps" id="cdk8s-plus-28.k8s.KubeStatusProps"></a>

Status is a return value for calls that don't return other objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStatusProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStatusProps: k8s.KubeStatusProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.code">code</a></code> | <code>number</code> | Suggested HTTP return code for this status, 0 if not set. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.details">details</a></code> | <code>cdk8s-plus-28.k8s.StatusDetails</code> | Extended data associated with the reason. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.message">message</a></code> | <code>string</code> | A human-readable description of the status of this operation. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStatusProps.property.reason">reason</a></code> | <code>string</code> | A machine-readable description of why this operation is in the "Failure" status. |

---

##### `code`<sup>Optional</sup> <a name="code" id="cdk8s-plus-28.k8s.KubeStatusProps.property.code"></a>

```typescript
public readonly code: number;
```

- *Type:* number

Suggested HTTP return code for this status, 0 if not set.

---

##### `details`<sup>Optional</sup> <a name="details" id="cdk8s-plus-28.k8s.KubeStatusProps.property.details"></a>

```typescript
public readonly details: StatusDetails;
```

- *Type:* cdk8s-plus-28.k8s.StatusDetails

Extended data associated with the reason.

Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.KubeStatusProps.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

A human-readable description of the status of this operation.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStatusProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.KubeStatusProps.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

A machine-readable description of why this operation is in the "Failure" status.

If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.

---

### KubeStorageClassListProps <a name="KubeStorageClassListProps" id="cdk8s-plus-28.k8s.KubeStorageClassListProps"></a>

StorageClassList is a collection of storage classes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStorageClassListProps: k8s.KubeStorageClassListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageClassProps[]</code> | items is the list of StorageClasses. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.property.items"></a>

```typescript
public readonly items: KubeStorageClassProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeStorageClassProps[]

items is the list of StorageClasses.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeStorageClassProps <a name="KubeStorageClassProps" id="cdk8s-plus-28.k8s.KubeStorageClassProps"></a>

StorageClass describes the parameters for a class of storage for which PersistentVolumes can be dynamically provisioned.

StorageClasses are non-namespaced; the name of the storage class according to etcd is in ObjectMeta.Name.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageClassProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStorageClassProps: k8s.KubeStorageClassProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.provisioner">provisioner</a></code> | <code>string</code> | provisioner indicates the type of the provisioner. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowedTopologies">allowedTopologies</a></code> | <code>cdk8s-plus-28.k8s.TopologySelectorTerm[]</code> | allowedTopologies restrict the node topologies where volumes can be dynamically provisioned. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowVolumeExpansion">allowVolumeExpansion</a></code> | <code>boolean</code> | allowVolumeExpansion shows whether the storage class allow volume expand. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.parameters">parameters</a></code> | <code>{[ key: string ]: string}</code> | parameters holds the parameters for the provisioner that should create volumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.reclaimPolicy">reclaimPolicy</a></code> | <code>string</code> | reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageClassProps.property.volumeBindingMode">volumeBindingMode</a></code> | <code>string</code> | volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound. |

---

##### `provisioner`<sup>Required</sup> <a name="provisioner" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.provisioner"></a>

```typescript
public readonly provisioner: string;
```

- *Type:* string

provisioner indicates the type of the provisioner.

---

##### `allowedTopologies`<sup>Optional</sup> <a name="allowedTopologies" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowedTopologies"></a>

```typescript
public readonly allowedTopologies: TopologySelectorTerm[];
```

- *Type:* cdk8s-plus-28.k8s.TopologySelectorTerm[]

allowedTopologies restrict the node topologies where volumes can be dynamically provisioned.

Each volume plugin defines its own supported topology specifications. An empty TopologySelectorTerm list means there is no topology restriction. This field is only honored by servers that enable the VolumeScheduling feature.

---

##### `allowVolumeExpansion`<sup>Optional</sup> <a name="allowVolumeExpansion" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.allowVolumeExpansion"></a>

```typescript
public readonly allowVolumeExpansion: boolean;
```

- *Type:* boolean

allowVolumeExpansion shows whether the storage class allow volume expand.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

mountOptions controls the mountOptions for dynamically provisioned PersistentVolumes of this storage class.

e.g. ["ro", "soft"]. Not validated - mount of the PVs will simply fail if one is invalid.

---

##### `parameters`<sup>Optional</sup> <a name="parameters" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.parameters"></a>

```typescript
public readonly parameters: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

parameters holds the parameters for the provisioner that should create volumes of this storage class.

---

##### `reclaimPolicy`<sup>Optional</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: string;
```

- *Type:* string
- *Default:* Delete.

reclaimPolicy controls the reclaimPolicy for dynamically provisioned PersistentVolumes of this storage class.

Defaults to Delete.

---

##### `volumeBindingMode`<sup>Optional</sup> <a name="volumeBindingMode" id="cdk8s-plus-28.k8s.KubeStorageClassProps.property.volumeBindingMode"></a>

```typescript
public readonly volumeBindingMode: string;
```

- *Type:* string

volumeBindingMode indicates how PersistentVolumeClaims should be provisioned and bound.

When unset, VolumeBindingImmediate is used. This field is only honored by servers that enable the VolumeScheduling feature.

---

### KubeStorageVersionListV1Alpha1Props <a name="KubeStorageVersionListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props"></a>

A list of StorageVersions.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStorageVersionListV1Alpha1Props: k8s.KubeStorageVersionListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props[]</code> | Items holds a list of StorageVersion. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeStorageVersionV1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props[]

Items holds a list of StorageVersion.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeStorageVersionV1Alpha1Props <a name="KubeStorageVersionV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props"></a>

Storage version of a specific resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeStorageVersionV1Alpha1Props: k8s.KubeStorageVersionV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.spec">spec</a></code> | <code>any</code> | Spec is an empty spec. |
| <code><a href="#cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | The name is <group>.<resource>. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: any;
```

- *Type:* any

Spec is an empty spec.

It is here to comply with Kubernetes API style.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeStorageVersionV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

The name is <group>.<resource>.

---

### KubeSubjectAccessReviewProps <a name="KubeSubjectAccessReviewProps" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps"></a>

SubjectAccessReview checks whether or not a user or group can perform an action.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeSubjectAccessReviewProps: k8s.KubeSubjectAccessReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.SubjectAccessReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard list metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.spec"></a>

```typescript
public readonly spec: SubjectAccessReviewSpec;
```

- *Type:* cdk8s-plus-28.k8s.SubjectAccessReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeSubjectAccessReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeTokenRequestProps <a name="KubeTokenRequestProps" id="cdk8s-plus-28.k8s.KubeTokenRequestProps"></a>

TokenRequest requests a token for a given service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeTokenRequestProps: k8s.KubeTokenRequestProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequestProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.TokenRequestSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenRequestProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.property.spec"></a>

```typescript
public readonly spec: TokenRequestSpec;
```

- *Type:* cdk8s-plus-28.k8s.TokenRequestSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenRequestProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeTokenReviewProps <a name="KubeTokenReviewProps" id="cdk8s-plus-28.k8s.KubeTokenReviewProps"></a>

TokenReview attempts to authenticate a token to a known user.

Note: TokenReview requests may be cached by the webhook token authenticator plugin in the kube-apiserver.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeTokenReviewProps: k8s.KubeTokenReviewProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReviewProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.TokenReviewSpec</code> | Spec holds information about the request being evaluated. |
| <code><a href="#cdk8s-plus-28.k8s.KubeTokenReviewProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.property.spec"></a>

```typescript
public readonly spec: TokenReviewSpec;
```

- *Type:* cdk8s-plus-28.k8s.TokenReviewSpec

Spec holds information about the request being evaluated.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeTokenReviewProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### KubeValidatingAdmissionPolicyBindingListV1Alpha1Props <a name="KubeValidatingAdmissionPolicyBindingListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyBindingListV1Alpha1Props: k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props[]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeValidatingAdmissionPolicyBindingV1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props[]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyBindingListV1Beta1Props <a name="KubeValidatingAdmissionPolicyBindingListV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props"></a>

ValidatingAdmissionPolicyBindingList is a list of ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyBindingListV1Beta1Props: k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props[]</code> | List of PolicyBinding. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.items"></a>

```typescript
public readonly items: KubeValidatingAdmissionPolicyBindingV1Beta1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props[]

List of PolicyBinding.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingListV1Beta1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyBindingV1Alpha1Props <a name="KubeValidatingAdmissionPolicyBindingV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyBindingV1Alpha1Props: k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: ValidatingAdmissionPolicyBindingSpecV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

### KubeValidatingAdmissionPolicyBindingV1Beta1Props <a name="KubeValidatingAdmissionPolicyBindingV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props"></a>

ValidatingAdmissionPolicyBinding binds the ValidatingAdmissionPolicy with paramerized resources.

ValidatingAdmissionPolicyBinding and parameter CRDs together define how cluster administrators configure policies for clusters.

For a given admission request, each binding will cause its policy to be evaluated N times, where N is 1 for policies/bindings that don't use params, otherwise N is the number of parameters selected by the binding.

The CEL expressions of a policy must have a computed CEL cost below the maximum CEL budget. Each evaluation of the policy is given an independent CEL cost budget. Adding/removing policies, bindings, or params can not affect whether a given (policy, binding, param) combination is within its own CEL budget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyBindingV1Beta1Props: k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicyBinding. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyBindingV1Beta1Props.property.spec"></a>

```typescript
public readonly spec: ValidatingAdmissionPolicyBindingSpecV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicyBinding.

---

### KubeValidatingAdmissionPolicyListV1Alpha1Props <a name="KubeValidatingAdmissionPolicyListV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyListV1Alpha1Props: k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props[]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.items"></a>

```typescript
public readonly items: KubeValidatingAdmissionPolicyV1Alpha1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props[]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyListV1Beta1Props <a name="KubeValidatingAdmissionPolicyListV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props"></a>

ValidatingAdmissionPolicyList is a list of ValidatingAdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyListV1Beta1Props: k8s.KubeValidatingAdmissionPolicyListV1Beta1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props[]</code> | List of ValidatingAdmissionPolicy. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.items"></a>

```typescript
public readonly items: KubeValidatingAdmissionPolicyV1Beta1Props[];
```

- *Type:* cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props[]

List of ValidatingAdmissionPolicy.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyListV1Beta1Props.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingAdmissionPolicyV1Alpha1Props <a name="KubeValidatingAdmissionPolicyV1Alpha1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyV1Alpha1Props: k8s.KubeValidatingAdmissionPolicyV1Alpha1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Alpha1Props.property.spec"></a>

```typescript
public readonly spec: ValidatingAdmissionPolicySpecV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

### KubeValidatingAdmissionPolicyV1Beta1Props <a name="KubeValidatingAdmissionPolicyV1Beta1Props" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props"></a>

ValidatingAdmissionPolicy describes the definition of an admission validation policy that accepts or rejects an object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingAdmissionPolicyV1Beta1Props: k8s.KubeValidatingAdmissionPolicyV1Beta1Props = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1</code> | Specification of the desired behavior of the ValidatingAdmissionPolicy. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeValidatingAdmissionPolicyV1Beta1Props.property.spec"></a>

```typescript
public readonly spec: ValidatingAdmissionPolicySpecV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1

Specification of the desired behavior of the ValidatingAdmissionPolicy.

---

### KubeValidatingWebhookConfigurationListProps <a name="KubeValidatingWebhookConfigurationListProps" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps"></a>

ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingWebhookConfigurationListProps: k8s.KubeValidatingWebhookConfigurationListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps[]</code> | List of ValidatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.items"></a>

```typescript
public readonly items: KubeValidatingWebhookConfigurationProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps[]

List of ValidatingWebhookConfiguration.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

### KubeValidatingWebhookConfigurationProps <a name="KubeValidatingWebhookConfigurationProps" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps"></a>

ValidatingWebhookConfiguration describes the configuration of and admission webhook that accept or reject and object without changing it.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeValidatingWebhookConfigurationProps: k8s.KubeValidatingWebhookConfigurationProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata; |
| <code><a href="#cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.webhooks">webhooks</a></code> | <code>cdk8s-plus-28.k8s.ValidatingWebhook[]</code> | Webhooks is a list of webhooks and the affected resources and operations. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata;

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

##### `webhooks`<sup>Optional</sup> <a name="webhooks" id="cdk8s-plus-28.k8s.KubeValidatingWebhookConfigurationProps.property.webhooks"></a>

```typescript
public readonly webhooks: ValidatingWebhook[];
```

- *Type:* cdk8s-plus-28.k8s.ValidatingWebhook[]

Webhooks is a list of webhooks and the affected resources and operations.

---

### KubeVolumeAttachmentListProps <a name="KubeVolumeAttachmentListProps" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps"></a>

VolumeAttachmentList is a collection of VolumeAttachment objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeVolumeAttachmentListProps: k8s.KubeVolumeAttachmentListProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KubeVolumeAttachmentProps[]</code> | items is the list of VolumeAttachments. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ListMeta</code> | Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata. |

---

##### `items`<sup>Required</sup> <a name="items" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.items"></a>

```typescript
public readonly items: KubeVolumeAttachmentProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubeVolumeAttachmentProps[]

items is the list of VolumeAttachments.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentListProps.property.metadata"></a>

```typescript
public readonly metadata: ListMeta;
```

- *Type:* cdk8s-plus-28.k8s.ListMeta

Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata.

---

### KubeVolumeAttachmentProps <a name="KubeVolumeAttachmentProps" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps"></a>

VolumeAttachment captures the intent to attach or detach the specified volume to/from the specified node.

VolumeAttachment objects are non-namespaced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const kubeVolumeAttachmentProps: k8s.KubeVolumeAttachmentProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.VolumeAttachmentSpec</code> | spec represents specification of the desired attach/detach volume behavior. |
| <code><a href="#cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object metadata. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.spec"></a>

```typescript
public readonly spec: VolumeAttachmentSpec;
```

- *Type:* cdk8s-plus-28.k8s.VolumeAttachmentSpec

spec represents specification of the desired attach/detach volume behavior.

Populated by the Kubernetes system.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.KubeVolumeAttachmentProps.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

### LabelSelector <a name="LabelSelector" id="cdk8s-plus-28.k8s.LabelSelector"></a>

A label selector is a label query over a set of resources.

The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LabelSelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const labelSelector: k8s.LabelSelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelector.property.matchExpressions">matchExpressions</a></code> | <code>cdk8s-plus-28.k8s.LabelSelectorRequirement[]</code> | matchExpressions is a list of label selector requirements. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelector.property.matchLabels">matchLabels</a></code> | <code>{[ key: string ]: string}</code> | matchLabels is a map of {key,value} pairs. |

---

##### `matchExpressions`<sup>Optional</sup> <a name="matchExpressions" id="cdk8s-plus-28.k8s.LabelSelector.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: LabelSelectorRequirement[];
```

- *Type:* cdk8s-plus-28.k8s.LabelSelectorRequirement[]

matchExpressions is a list of label selector requirements.

The requirements are ANDed.

---

##### `matchLabels`<sup>Optional</sup> <a name="matchLabels" id="cdk8s-plus-28.k8s.LabelSelector.property.matchLabels"></a>

```typescript
public readonly matchLabels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

matchLabels is a map of {key,value} pairs.

A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

---

### LabelSelectorOptions <a name="LabelSelectorOptions" id="cdk8s-plus-28.LabelSelectorOptions"></a>

Options for `LabelSelector.of`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.LabelSelectorOptions.Initializer"></a>

```typescript
import { LabelSelectorOptions } from 'cdk8s-plus-28'

const labelSelectorOptions: LabelSelectorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelectorOptions.property.expressions">expressions</a></code> | <code><a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]</code> | Expression based label matchers. |
| <code><a href="#cdk8s-plus-28.LabelSelectorOptions.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Strict label matchers. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.LabelSelectorOptions.property.expressions"></a>

```typescript
public readonly expressions: LabelExpression[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]

Expression based label matchers.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.LabelSelectorOptions.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Strict label matchers.

---

### LabelSelectorRequirement <a name="LabelSelectorRequirement" id="cdk8s-plus-28.LabelSelectorRequirement"></a>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.LabelSelectorRequirement.Initializer"></a>

```typescript
import { LabelSelectorRequirement } from 'cdk8s-plus-28'

const labelSelectorRequirement: LabelSelectorRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.key">key</a></code> | <code>string</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.operator">operator</a></code> | <code>string</code> | Represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.LabelSelectorRequirement.property.values">values</a></code> | <code>string[]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelSelectorRequirement.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.LabelSelectorRequirement.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

Represents a key's relationship to a set of values.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.LabelSelectorRequirement.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

An array of string values.

If the operator is In or NotIn, the values array
must be non-empty. If the operator is Exists or DoesNotExist,
the values array must be empty. This array is replaced during a strategic merge patch.

---

### LabelSelectorRequirement <a name="LabelSelectorRequirement" id="cdk8s-plus-28.k8s.LabelSelectorRequirement"></a>

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const labelSelectorRequirement: k8s.LabelSelectorRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.key">key</a></code> | <code>string</code> | key is the label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.operator">operator</a></code> | <code>string</code> | operator represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.LabelSelectorRequirement.property.values">values</a></code> | <code>string[]</code> | values is an array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

key is the label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

operator represents a key's relationship to a set of values.

Valid operators are In, NotIn, Exists and DoesNotExist.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.LabelSelectorRequirement.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

values is an array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

---

### LeaseSpec <a name="LeaseSpec" id="cdk8s-plus-28.k8s.LeaseSpec"></a>

LeaseSpec is a specification of a Lease.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LeaseSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const leaseSpec: k8s.LeaseSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.acquireTime">acquireTime</a></code> | <code>Date</code> | acquireTime is a time when the current lease was acquired. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.holderIdentity">holderIdentity</a></code> | <code>string</code> | holderIdentity contains the identity of the holder of a current lease. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.leaseDurationSeconds">leaseDurationSeconds</a></code> | <code>number</code> | leaseDurationSeconds is a duration that candidates for a lease need to wait to force acquire it. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.leaseTransitions">leaseTransitions</a></code> | <code>number</code> | leaseTransitions is the number of transitions of a lease between holders. |
| <code><a href="#cdk8s-plus-28.k8s.LeaseSpec.property.renewTime">renewTime</a></code> | <code>Date</code> | renewTime is a time when the current holder of a lease has last updated the lease. |

---

##### `acquireTime`<sup>Optional</sup> <a name="acquireTime" id="cdk8s-plus-28.k8s.LeaseSpec.property.acquireTime"></a>

```typescript
public readonly acquireTime: Date;
```

- *Type:* Date

acquireTime is a time when the current lease was acquired.

---

##### `holderIdentity`<sup>Optional</sup> <a name="holderIdentity" id="cdk8s-plus-28.k8s.LeaseSpec.property.holderIdentity"></a>

```typescript
public readonly holderIdentity: string;
```

- *Type:* string

holderIdentity contains the identity of the holder of a current lease.

---

##### `leaseDurationSeconds`<sup>Optional</sup> <a name="leaseDurationSeconds" id="cdk8s-plus-28.k8s.LeaseSpec.property.leaseDurationSeconds"></a>

```typescript
public readonly leaseDurationSeconds: number;
```

- *Type:* number

leaseDurationSeconds is a duration that candidates for a lease need to wait to force acquire it.

This is measure against time of last observed renewTime.

---

##### `leaseTransitions`<sup>Optional</sup> <a name="leaseTransitions" id="cdk8s-plus-28.k8s.LeaseSpec.property.leaseTransitions"></a>

```typescript
public readonly leaseTransitions: number;
```

- *Type:* number

leaseTransitions is the number of transitions of a lease between holders.

---

##### `renewTime`<sup>Optional</sup> <a name="renewTime" id="cdk8s-plus-28.k8s.LeaseSpec.property.renewTime"></a>

```typescript
public readonly renewTime: Date;
```

- *Type:* Date

renewTime is a time when the current holder of a lease has last updated the lease.

---

### Lifecycle <a name="Lifecycle" id="cdk8s-plus-28.k8s.Lifecycle"></a>

Lifecycle describes actions that the management system should take in response to container lifecycle events.

For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Lifecycle.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const lifecycle: k8s.Lifecycle = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Lifecycle.property.postStart">postStart</a></code> | <code>cdk8s-plus-28.k8s.LifecycleHandler</code> | PostStart is called immediately after a container is created. |
| <code><a href="#cdk8s-plus-28.k8s.Lifecycle.property.preStop">preStop</a></code> | <code>cdk8s-plus-28.k8s.LifecycleHandler</code> | PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. |

---

##### `postStart`<sup>Optional</sup> <a name="postStart" id="cdk8s-plus-28.k8s.Lifecycle.property.postStart"></a>

```typescript
public readonly postStart: LifecycleHandler;
```

- *Type:* cdk8s-plus-28.k8s.LifecycleHandler

PostStart is called immediately after a container is created.

If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

---

##### `preStop`<sup>Optional</sup> <a name="preStop" id="cdk8s-plus-28.k8s.Lifecycle.property.preStop"></a>

```typescript
public readonly preStop: LifecycleHandler;
```

- *Type:* cdk8s-plus-28.k8s.LifecycleHandler

PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc.

The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

---

### LifecycleHandler <a name="LifecycleHandler" id="cdk8s-plus-28.k8s.LifecycleHandler"></a>

LifecycleHandler defines a specific action that should be taken in a lifecycle hook.

One and only one of the fields, except TCPSocket must be specified.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LifecycleHandler.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const lifecycleHandler: k8s.LifecycleHandler = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.exec">exec</a></code> | <code>cdk8s-plus-28.k8s.ExecAction</code> | Exec specifies the action to take. |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.httpGet">httpGet</a></code> | <code>cdk8s-plus-28.k8s.HttpGetAction</code> | HTTPGet specifies the http request to perform. |
| <code><a href="#cdk8s-plus-28.k8s.LifecycleHandler.property.tcpSocket">tcpSocket</a></code> | <code>cdk8s-plus-28.k8s.TcpSocketAction</code> | Deprecated. |

---

##### `exec`<sup>Optional</sup> <a name="exec" id="cdk8s-plus-28.k8s.LifecycleHandler.property.exec"></a>

```typescript
public readonly exec: ExecAction;
```

- *Type:* cdk8s-plus-28.k8s.ExecAction

Exec specifies the action to take.

---

##### `httpGet`<sup>Optional</sup> <a name="httpGet" id="cdk8s-plus-28.k8s.LifecycleHandler.property.httpGet"></a>

```typescript
public readonly httpGet: HttpGetAction;
```

- *Type:* cdk8s-plus-28.k8s.HttpGetAction

HTTPGet specifies the http request to perform.

---

##### `tcpSocket`<sup>Optional</sup> <a name="tcpSocket" id="cdk8s-plus-28.k8s.LifecycleHandler.property.tcpSocket"></a>

```typescript
public readonly tcpSocket: TcpSocketAction;
```

- *Type:* cdk8s-plus-28.k8s.TcpSocketAction

Deprecated.

TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.

---

### LimitedPriorityLevelConfigurationV1Beta2 <a name="LimitedPriorityLevelConfigurationV1Beta2" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2"></a>

LimitedPriorityLevelConfiguration specifies how to handle requests that are subject to limits.

It addresses two issues:
- How are requests for this priority level limited?
- What should be done with requests that exceed the limit?

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitedPriorityLevelConfigurationV1Beta2: k8s.LimitedPriorityLevelConfigurationV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.assuredConcurrencyShares">assuredConcurrencyShares</a></code> | <code>number</code> | `assuredConcurrencyShares` (ACS) configures the execution limit, which is a limit on the number of requests of this priority level that may be exeucting at a given time. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.borrowingLimitPercent">borrowingLimitPercent</a></code> | <code>number</code> | `borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.lendablePercent">lendablePercent</a></code> | <code>number</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.limitResponse">limitResponse</a></code> | <code>cdk8s-plus-28.k8s.LimitResponseV1Beta2</code> | `limitResponse` indicates what to do with requests that can not be executed right now. |

---

##### `assuredConcurrencyShares`<sup>Optional</sup> <a name="assuredConcurrencyShares" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.assuredConcurrencyShares"></a>

```typescript
public readonly assuredConcurrencyShares: number;
```

- *Type:* number

`assuredConcurrencyShares` (ACS) configures the execution limit, which is a limit on the number of requests of this priority level that may be exeucting at a given time.

ACS must be a positive number. The server's concurrency limit (SCL) is divided among the concurrency-controlled priority levels in proportion to their assured concurrency shares. This produces the assured concurrency value (ACV) --- the number of requests that may be executing at a time --- for each such priority level:

ACV(l) = ceil( SCL * ACS(l) / ( sum[priority levels k] ACS(k) ) )

bigger numbers of ACS mean more reserved concurrent requests (at the expense of every other PL). This field has a default value of 30.

---

##### `borrowingLimitPercent`<sup>Optional</sup> <a name="borrowingLimitPercent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.borrowingLimitPercent"></a>

```typescript
public readonly borrowingLimitPercent: number;
```

- *Type:* number

`borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels.

The limit is known as this level's BorrowingConcurrencyLimit (BorrowingCL) and is a limit on the total number of seats that this level may borrow at any one time. This field holds the ratio of that limit to the level's nominal concurrency limit. When this field is non-nil, it must hold a non-negative integer and the limit is calculated as follows.

BorrowingCL(i) = round( NominalCL(i) * borrowingLimitPercent(i)/100.0 )

The value of this field can be more than 100, implying that this priority level can borrow a number of seats that is greater than its own nominal concurrency limit (NominalCL). When this field is left `nil`, the limit is effectively infinite.

---

##### `lendablePercent`<sup>Optional</sup> <a name="lendablePercent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.lendablePercent"></a>

```typescript
public readonly lendablePercent: number;
```

- *Type:* number

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

The value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `limitResponse`<sup>Optional</sup> <a name="limitResponse" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2.property.limitResponse"></a>

```typescript
public readonly limitResponse: LimitResponseV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.LimitResponseV1Beta2

`limitResponse` indicates what to do with requests that can not be executed right now.

---

### LimitedPriorityLevelConfigurationV1Beta3 <a name="LimitedPriorityLevelConfigurationV1Beta3" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3"></a>

LimitedPriorityLevelConfiguration specifies how to handle requests that are subject to limits.

It addresses two issues:
- How are requests for this priority level limited?
- What should be done with requests that exceed the limit?

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitedPriorityLevelConfigurationV1Beta3: k8s.LimitedPriorityLevelConfigurationV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.borrowingLimitPercent">borrowingLimitPercent</a></code> | <code>number</code> | `borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.lendablePercent">lendablePercent</a></code> | <code>number</code> | `lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.limitResponse">limitResponse</a></code> | <code>cdk8s-plus-28.k8s.LimitResponseV1Beta3</code> | `limitResponse` indicates what to do with requests that can not be executed right now. |
| <code><a href="#cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares">nominalConcurrencyShares</a></code> | <code>number</code> | `nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level. |

---

##### `borrowingLimitPercent`<sup>Optional</sup> <a name="borrowingLimitPercent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.borrowingLimitPercent"></a>

```typescript
public readonly borrowingLimitPercent: number;
```

- *Type:* number

`borrowingLimitPercent`, if present, configures a limit on how many seats this priority level can borrow from other priority levels.

The limit is known as this level's BorrowingConcurrencyLimit (BorrowingCL) and is a limit on the total number of seats that this level may borrow at any one time. This field holds the ratio of that limit to the level's nominal concurrency limit. When this field is non-nil, it must hold a non-negative integer and the limit is calculated as follows.

BorrowingCL(i) = round( NominalCL(i) * borrowingLimitPercent(i)/100.0 )

The value of this field can be more than 100, implying that this priority level can borrow a number of seats that is greater than its own nominal concurrency limit (NominalCL). When this field is left `nil`, the limit is effectively infinite.

---

##### `lendablePercent`<sup>Optional</sup> <a name="lendablePercent" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.lendablePercent"></a>

```typescript
public readonly lendablePercent: number;
```

- *Type:* number

`lendablePercent` prescribes the fraction of the level's NominalCL that can be borrowed by other priority levels.

The value of this field must be between 0 and 100, inclusive, and it defaults to 0. The number of seats that other levels can borrow from this level, known as this level's LendableConcurrencyLimit (LendableCL), is defined as follows.

LendableCL(i) = round( NominalCL(i) * lendablePercent(i)/100.0 )

---

##### `limitResponse`<sup>Optional</sup> <a name="limitResponse" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.limitResponse"></a>

```typescript
public readonly limitResponse: LimitResponseV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.LimitResponseV1Beta3

`limitResponse` indicates what to do with requests that can not be executed right now.

---

##### `nominalConcurrencyShares`<sup>Optional</sup> <a name="nominalConcurrencyShares" id="cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3.property.nominalConcurrencyShares"></a>

```typescript
public readonly nominalConcurrencyShares: number;
```

- *Type:* number

`nominalConcurrencyShares` (NCS) contributes to the computation of the NominalConcurrencyLimit (NominalCL) of this level.

This is the number of execution seats available at this priority level. This is used both for requests dispatched from this priority level as well as requests dispatched from other priority levels borrowing seats from this level. The server's concurrency limit (ServerCL) is divided among the Limited priority levels in proportion to their NCS values:

NominalCL(i)  = ceil( ServerCL * NCS(i) / sum_ncs ) sum_ncs = sum[priority level k] NCS(k)

Bigger numbers mean a larger nominal concurrency limit, at the expense of every other priority level. This field has a default value of 30.

---

### LimitRangeItem <a name="LimitRangeItem" id="cdk8s-plus-28.k8s.LimitRangeItem"></a>

LimitRangeItem defines a min/max usage limit for any resource that matches on kind.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitRangeItem.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitRangeItem: k8s.LimitRangeItem = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.type">type</a></code> | <code>string</code> | Type of resource that this limit applies to. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.default">default</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Default resource requirement limit value by resource name if resource limit is omitted. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.defaultRequest">defaultRequest</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | DefaultRequest is the default resource requirement request value by resource name if resource request is omitted. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.max">max</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Max usage constraints on this kind by resource name. |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.maxLimitRequestRatio">maxLimitRequestRatio</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value; |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeItem.property.min">min</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Min usage constraints on this kind by resource name. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitRangeItem.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Type of resource that this limit applies to.

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.k8s.LimitRangeItem.property.default"></a>

```typescript
public readonly default: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Default resource requirement limit value by resource name if resource limit is omitted.

---

##### `defaultRequest`<sup>Optional</sup> <a name="defaultRequest" id="cdk8s-plus-28.k8s.LimitRangeItem.property.defaultRequest"></a>

```typescript
public readonly defaultRequest: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

DefaultRequest is the default resource requirement request value by resource name if resource request is omitted.

---

##### `max`<sup>Optional</sup> <a name="max" id="cdk8s-plus-28.k8s.LimitRangeItem.property.max"></a>

```typescript
public readonly max: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Max usage constraints on this kind by resource name.

---

##### `maxLimitRequestRatio`<sup>Optional</sup> <a name="maxLimitRequestRatio" id="cdk8s-plus-28.k8s.LimitRangeItem.property.maxLimitRequestRatio"></a>

```typescript
public readonly maxLimitRequestRatio: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

MaxLimitRequestRatio if specified, the named resource must have a request and limit that are both non-zero where limit divided by request is less than or equal to the enumerated value;

this represents the max burst for the named resource.

---

##### `min`<sup>Optional</sup> <a name="min" id="cdk8s-plus-28.k8s.LimitRangeItem.property.min"></a>

```typescript
public readonly min: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Min usage constraints on this kind by resource name.

---

### LimitRangeSpec <a name="LimitRangeSpec" id="cdk8s-plus-28.k8s.LimitRangeSpec"></a>

LimitRangeSpec defines a min/max usage limit for resources that match on kind.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitRangeSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitRangeSpec: k8s.LimitRangeSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitRangeSpec.property.limits">limits</a></code> | <code>cdk8s-plus-28.k8s.LimitRangeItem[]</code> | Limits is the list of LimitRangeItem objects that are enforced. |

---

##### `limits`<sup>Required</sup> <a name="limits" id="cdk8s-plus-28.k8s.LimitRangeSpec.property.limits"></a>

```typescript
public readonly limits: LimitRangeItem[];
```

- *Type:* cdk8s-plus-28.k8s.LimitRangeItem[]

Limits is the list of LimitRangeItem objects that are enforced.

---

### LimitResponseV1Beta2 <a name="LimitResponseV1Beta2" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2"></a>

LimitResponse defines how to handle requests that can not be executed right now.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitResponseV1Beta2: k8s.LimitResponseV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.type">type</a></code> | <code>string</code> | `type` is "Queue" or "Reject". |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.queuing">queuing</a></code> | <code>cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2</code> | `queuing` holds the configuration parameters for queuing. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` is "Queue" or "Reject".

"Queue" means that requests that can not be executed upon arrival are held in a queue until they can be executed or a queuing limit is reached. "Reject" means that requests that can not be executed upon arrival are rejected. Required.

---

##### `queuing`<sup>Optional</sup> <a name="queuing" id="cdk8s-plus-28.k8s.LimitResponseV1Beta2.property.queuing"></a>

```typescript
public readonly queuing: QueuingConfigurationV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2

`queuing` holds the configuration parameters for queuing.

This field may be non-empty only if `type` is `"Queue"`.

---

### LimitResponseV1Beta3 <a name="LimitResponseV1Beta3" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3"></a>

LimitResponse defines how to handle requests that can not be executed right now.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const limitResponseV1Beta3: k8s.LimitResponseV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.type">type</a></code> | <code>string</code> | `type` is "Queue" or "Reject". |
| <code><a href="#cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.queuing">queuing</a></code> | <code>cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3</code> | `queuing` holds the configuration parameters for queuing. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` is "Queue" or "Reject".

"Queue" means that requests that can not be executed upon arrival are held in a queue until they can be executed or a queuing limit is reached. "Reject" means that requests that can not be executed upon arrival are rejected. Required.

---

##### `queuing`<sup>Optional</sup> <a name="queuing" id="cdk8s-plus-28.k8s.LimitResponseV1Beta3.property.queuing"></a>

```typescript
public readonly queuing: QueuingConfigurationV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3

`queuing` holds the configuration parameters for queuing.

This field may be non-empty only if `type` is `"Queue"`.

---

### ListMeta <a name="ListMeta" id="cdk8s-plus-28.k8s.ListMeta"></a>

ListMeta describes metadata that synthetic resources must have, including lists and various status objects.

A resource may have only one of {ObjectMeta, ListMeta}.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ListMeta.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const listMeta: k8s.ListMeta = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.continue">continue</a></code> | <code>string</code> | continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.remainingItemCount">remainingItemCount</a></code> | <code>number</code> | remainingItemCount is the number of subsequent items in the list which are not included in this list response. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.resourceVersion">resourceVersion</a></code> | <code>string</code> | String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. |
| <code><a href="#cdk8s-plus-28.k8s.ListMeta.property.selfLink">selfLink</a></code> | <code>string</code> | Deprecated: selfLink is a legacy read-only field that is no longer populated by the system. |

---

##### `continue`<sup>Optional</sup> <a name="continue" id="cdk8s-plus-28.k8s.ListMeta.property.continue"></a>

```typescript
public readonly continue: string;
```

- *Type:* string

continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available.

The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.

---

##### `remainingItemCount`<sup>Optional</sup> <a name="remainingItemCount" id="cdk8s-plus-28.k8s.ListMeta.property.remainingItemCount"></a>

```typescript
public readonly remainingItemCount: number;
```

- *Type:* number

remainingItemCount is the number of subsequent items in the list which are not included in this list response.

If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact.

---

##### `resourceVersion`<sup>Optional</sup> <a name="resourceVersion" id="cdk8s-plus-28.k8s.ListMeta.property.resourceVersion"></a>

```typescript
public readonly resourceVersion: string;
```

- *Type:* string

String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed.

Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `selfLink`<sup>Optional</sup> <a name="selfLink" id="cdk8s-plus-28.k8s.ListMeta.property.selfLink"></a>

```typescript
public readonly selfLink: string;
```

- *Type:* string

Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

---

### LocalObjectReference <a name="LocalObjectReference" id="cdk8s-plus-28.k8s.LocalObjectReference"></a>

LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LocalObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const localObjectReference: k8s.LocalObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LocalObjectReference.property.name">name</a></code> | <code>string</code> | Name of the referent. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.LocalObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

### LocalVolumeSource <a name="LocalVolumeSource" id="cdk8s-plus-28.k8s.LocalVolumeSource"></a>

Local represents directly-attached storage with node affinity (Beta feature).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.LocalVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const localVolumeSource: k8s.LocalVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.LocalVolumeSource.property.path">path</a></code> | <code>string</code> | path of the full path to the volume on the node. |
| <code><a href="#cdk8s-plus-28.k8s.LocalVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.LocalVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path of the full path to the volume on the node.

It can be either a directory or block device (disk, partition, ...).

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.LocalVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

It applies only when the Path is a block device. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default value is to auto-select a filesystem if unspecified.

---

### ManagedFieldsEntry <a name="ManagedFieldsEntry" id="cdk8s-plus-28.k8s.ManagedFieldsEntry"></a>

ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource that the fieldset applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const managedFieldsEntry: k8s.ManagedFieldsEntry = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.apiVersion">apiVersion</a></code> | <code>string</code> | APIVersion defines the version of this resource that this field set applies to. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsType">fieldsType</a></code> | <code>string</code> | FieldsType is the discriminator for the different fields format and version. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsV1">fieldsV1</a></code> | <code>any</code> | FieldsV1 holds the first JSON version format as described in the "FieldsV1" type. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.manager">manager</a></code> | <code>string</code> | Manager is an identifier of the workflow managing these fields. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.operation">operation</a></code> | <code>string</code> | Operation is the type of operation which lead to this ManagedFieldsEntry being created. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.subresource">subresource</a></code> | <code>string</code> | Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource. |
| <code><a href="#cdk8s-plus-28.k8s.ManagedFieldsEntry.property.time">time</a></code> | <code>Date</code> | Time is the timestamp of when the ManagedFields entry was added. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

APIVersion defines the version of this resource that this field set applies to.

The format is "group/version" just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

---

##### `fieldsType`<sup>Optional</sup> <a name="fieldsType" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsType"></a>

```typescript
public readonly fieldsType: string;
```

- *Type:* string

FieldsType is the discriminator for the different fields format and version.

There is currently only one possible value: "FieldsV1"

---

##### `fieldsV1`<sup>Optional</sup> <a name="fieldsV1" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.fieldsV1"></a>

```typescript
public readonly fieldsV1: any;
```

- *Type:* any

FieldsV1 holds the first JSON version format as described in the "FieldsV1" type.

---

##### `manager`<sup>Optional</sup> <a name="manager" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.manager"></a>

```typescript
public readonly manager: string;
```

- *Type:* string

Manager is an identifier of the workflow managing these fields.

---

##### `operation`<sup>Optional</sup> <a name="operation" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.operation"></a>

```typescript
public readonly operation: string;
```

- *Type:* string

Operation is the type of operation which lead to this ManagedFieldsEntry being created.

The only valid values for this field are 'Apply' and 'Update'.

---

##### `subresource`<sup>Optional</sup> <a name="subresource" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.subresource"></a>

```typescript
public readonly subresource: string;
```

- *Type:* string

Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource.

The value of this field is used to distinguish between managers, even if they share the same name. For example, a status update will be distinct from a regular update using the same manager name. Note that the APIVersion field is not related to the Subresource field and it always corresponds to the version of the main resource.

---

##### `time`<sup>Optional</sup> <a name="time" id="cdk8s-plus-28.k8s.ManagedFieldsEntry.property.time"></a>

```typescript
public readonly time: Date;
```

- *Type:* Date

Time is the timestamp of when the ManagedFields entry was added.

The timestamp will also be updated if a field is added, the manager changes any of the owned fields value or removes a field. The timestamp does not update when a field is removed from the entry because another manager took it over.

---

### MatchCondition <a name="MatchCondition" id="cdk8s-plus-28.k8s.MatchCondition"></a>

MatchCondition represents a condition which must by fulfilled for a request to be sent to a webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchCondition.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const matchCondition: k8s.MatchCondition = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchCondition.property.expression">expression</a></code> | <code>string</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchCondition.property.name">name</a></code> | <code>string</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchCondition.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchCondition.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '_' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchConditionV1Alpha1 <a name="MatchConditionV1Alpha1" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const matchConditionV1Alpha1: k8s.MatchConditionV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.expression">expression</a></code> | <code>string</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.name">name</a></code> | <code>string</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchConditionV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '_' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchConditionV1Beta1 <a name="MatchConditionV1Beta1" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1"></a>

MatchCondition represents a condition which must be fulfilled for a request to be sent to a webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const matchConditionV1Beta1: k8s.MatchConditionV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.expression">expression</a></code> | <code>string</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.name">name</a></code> | <code>string</code> | Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression represents the expression which will be evaluated by CEL.

Must evaluate to bool. CEL expressions have access to the contents of the AdmissionRequest and Authorizer, organized into CEL variables:

'object' - The object from the incoming request. The value is null for DELETE requests. 'oldObject' - The existing object. The value is null for CREATE requests. 'request' - Attributes of the admission request(/pkg/apis/admission/types.go#AdmissionRequest). 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.
Documentation on CEL: https://kubernetes.io/docs/reference/using-api/cel/

Required.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MatchConditionV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is an identifier for this match condition, used for strategic merging of MatchConditions, as well as providing an identifier for logging purposes.

A good name should be descriptive of the associated expression. Name must be a qualified name consisting of alphanumeric characters, '-', '_' or '.', and must start and end with an alphanumeric character (e.g. 'MyName',  or 'my.name',  or '123-abc', regex used for validation is '([A-Za-z0-9][-A-Za-z0-9_.]*)?[A-Za-z0-9]') with an optional DNS subdomain prefix and '/' (e.g. 'example.com/MyName')

Required.

---

### MatchResourcesV1Alpha1 <a name="MatchResourcesV1Alpha1" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1"></a>

MatchResources decides whether to run the admission control policy on an object based on whether it meets the match criteria.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const matchResourcesV1Alpha1: k8s.MatchResourcesV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.excludeResourceRules">excludeResourceRules</a></code> | <code>cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1[]</code> | ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.matchPolicy">matchPolicy</a></code> | <code>string</code> | matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.objectSelector">objectSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the validation based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.resourceRules">resourceRules</a></code> | <code>cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1[]</code> | ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches. |

---

##### `excludeResourceRules`<sup>Optional</sup> <a name="excludeResourceRules" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.excludeResourceRules"></a>

```typescript
public readonly excludeResourceRules: NamedRuleWithOperationsV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1[]

ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

---

##### `matchPolicy`<sup>Optional</sup> <a name="matchPolicy" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.matchPolicy"></a>

```typescript
public readonly matchPolicy: string;
```

- *Type:* string
- *Default:* Equivalent"

matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the ValidatingAdmissionPolicy.

- Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the ValidatingAdmissionPolicy.

Defaults to "Equivalent"

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the policy.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the policy on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `objectSelector`<sup>Optional</sup> <a name="objectSelector" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.objectSelector"></a>

```typescript
public readonly objectSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the validation based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the cel validation, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `resourceRules`<sup>Optional</sup> <a name="resourceRules" id="cdk8s-plus-28.k8s.MatchResourcesV1Alpha1.property.resourceRules"></a>

```typescript
public readonly resourceRules: NamedRuleWithOperationsV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1[]

ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches.

The policy cares about an operation if it matches _any_ Rule.

---

### MatchResourcesV1Beta1 <a name="MatchResourcesV1Beta1" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1"></a>

MatchResources decides whether to run the admission control policy on an object based on whether it meets the match criteria.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const matchResourcesV1Beta1: k8s.MatchResourcesV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.excludeResourceRules">excludeResourceRules</a></code> | <code>cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1[]</code> | ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.matchPolicy">matchPolicy</a></code> | <code>string</code> | matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.objectSelector">objectSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the validation based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.resourceRules">resourceRules</a></code> | <code>cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1[]</code> | ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches. |

---

##### `excludeResourceRules`<sup>Optional</sup> <a name="excludeResourceRules" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.excludeResourceRules"></a>

```typescript
public readonly excludeResourceRules: NamedRuleWithOperationsV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1[]

ExcludeResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy should not care about.

The exclude rules take precedence over include rules (if a resource matches both, it is excluded)

---

##### `matchPolicy`<sup>Optional</sup> <a name="matchPolicy" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.matchPolicy"></a>

```typescript
public readonly matchPolicy: string;
```

- *Type:* string
- *Default:* Equivalent"

matchPolicy defines how the "MatchResources" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the ValidatingAdmissionPolicy.

- Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the ValidatingAdmissionPolicy.

Defaults to "Equivalent"

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the admission control policy on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the policy.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the policy on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `objectSelector`<sup>Optional</sup> <a name="objectSelector" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.objectSelector"></a>

```typescript
public readonly objectSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the validation based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the cel validation, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `resourceRules`<sup>Optional</sup> <a name="resourceRules" id="cdk8s-plus-28.k8s.MatchResourcesV1Beta1.property.resourceRules"></a>

```typescript
public readonly resourceRules: NamedRuleWithOperationsV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1[]

ResourceRules describes what operations on what resources/subresources the ValidatingAdmissionPolicy matches.

The policy cares about an operation if it matches _any_ Rule.

---

### MemoryResources <a name="MemoryResources" id="cdk8s-plus-28.MemoryResources"></a>

Memory request and limit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MemoryResources.Initializer"></a>

```typescript
import { MemoryResources } from 'cdk8s-plus-28'

const memoryResources: MemoryResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MemoryResources.property.limit">limit</a></code> | <code>cdk8s.Size</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.MemoryResources.property.request">request</a></code> | <code>cdk8s.Size</code> | *No description.* |

---

##### `limit`<sup>Optional</sup> <a name="limit" id="cdk8s-plus-28.MemoryResources.property.limit"></a>

```typescript
public readonly limit: Size;
```

- *Type:* cdk8s.Size

---

##### `request`<sup>Optional</sup> <a name="request" id="cdk8s-plus-28.MemoryResources.property.request"></a>

```typescript
public readonly request: Size;
```

- *Type:* cdk8s.Size

---

### MetricContainerResourceOptions <a name="MetricContainerResourceOptions" id="cdk8s-plus-28.MetricContainerResourceOptions"></a>

Options for `Metric.containerResource()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricContainerResourceOptions.Initializer"></a>

```typescript
import { MetricContainerResourceOptions } from 'cdk8s-plus-28'

const metricContainerResourceOptions: MetricContainerResourceOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricContainerResourceOptions.property.container">container</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a></code> | Container where the metric can be found. |
| <code><a href="#cdk8s-plus-28.MetricContainerResourceOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | Target metric value that will trigger scaling. |

---

##### `container`<sup>Required</sup> <a name="container" id="cdk8s-plus-28.MetricContainerResourceOptions.property.container"></a>

```typescript
public readonly container: Container;
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>

Container where the metric can be found.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricContainerResourceOptions.property.target"></a>

```typescript
public readonly target: MetricTarget;
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

Target metric value that will trigger scaling.

---

### MetricIdentifierV2 <a name="MetricIdentifierV2" id="cdk8s-plus-28.k8s.MetricIdentifierV2"></a>

MetricIdentifier defines the name and optionally selector for a metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricIdentifierV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const metricIdentifierV2: k8s.MetricIdentifierV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricIdentifierV2.property.name">name</a></code> | <code>string</code> | name is the name of the given metric. |
| <code><a href="#cdk8s-plus-28.k8s.MetricIdentifierV2.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | selector is the string-encoded form of a standard kubernetes label selector for the given metric When set, it is passed as an additional parameter to the metrics server for more specific metrics scoping. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MetricIdentifierV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the given metric.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.MetricIdentifierV2.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

selector is the string-encoded form of a standard kubernetes label selector for the given metric When set, it is passed as an additional parameter to the metrics server for more specific metrics scoping.

When unset, just the metricName will be used to gather metrics.

---

### MetricObjectOptions <a name="MetricObjectOptions" id="cdk8s-plus-28.MetricObjectOptions"></a>

Options for `Metric.object()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricObjectOptions.Initializer"></a>

```typescript
import { MetricObjectOptions } from 'cdk8s-plus-28'

const metricObjectOptions: MetricObjectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.name">name</a></code> | <code>string</code> | The name of the metric to scale on. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | The target metric value that will trigger scaling. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to find a metric by label. |
| <code><a href="#cdk8s-plus-28.MetricObjectOptions.property.object">object</a></code> | <code><a href="#cdk8s-plus-28.IResource">IResource</a></code> | Resource where the metric can be found. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.MetricObjectOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the metric to scale on.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricObjectOptions.property.target"></a>

```typescript
public readonly target: MetricTarget;
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

##### `labelSelector`<sup>Optional</sup> <a name="labelSelector" id="cdk8s-plus-28.MetricObjectOptions.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

##### `object`<sup>Required</sup> <a name="object" id="cdk8s-plus-28.MetricObjectOptions.property.object"></a>

```typescript
public readonly object: IResource;
```

- *Type:* <a href="#cdk8s-plus-28.IResource">IResource</a>

Resource where the metric can be found.

---

### MetricOptions <a name="MetricOptions" id="cdk8s-plus-28.MetricOptions"></a>

Base options for a Metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MetricOptions.Initializer"></a>

```typescript
import { MetricOptions } from 'cdk8s-plus-28'

const metricOptions: MetricOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.name">name</a></code> | <code>string</code> | The name of the metric to scale on. |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.target">target</a></code> | <code><a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a></code> | The target metric value that will trigger scaling. |
| <code><a href="#cdk8s-plus-28.MetricOptions.property.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to find a metric by label. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.MetricOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the metric to scale on.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.MetricOptions.property.target"></a>

```typescript
public readonly target: MetricTarget;
```

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

The target metric value that will trigger scaling.

---

##### `labelSelector`<sup>Optional</sup> <a name="labelSelector" id="cdk8s-plus-28.MetricOptions.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>
- *Default:* Just the metric 'name' will be used to gather metrics.

A selector to find a metric by label.

When set, it is passed as an additional parameter to the metrics server
for more specific metrics scoping.

---

### MetricSpecV2 <a name="MetricSpecV2" id="cdk8s-plus-28.k8s.MetricSpecV2"></a>

MetricSpec specifies how to scale based on a single metric (only `type` and one other matching field should be set at once).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricSpecV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const metricSpecV2: k8s.MetricSpecV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.type">type</a></code> | <code>string</code> | type is the type of metric source. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.containerResource">containerResource</a></code> | <code>cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2</code> | containerResource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing a single container in each pod of the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. This is an alpha feature and can be enabled by the HPAContainerMetrics feature flag. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.external">external</a></code> | <code>cdk8s-plus-28.k8s.ExternalMetricSourceV2</code> | external refers to a global metric that is not associated with any Kubernetes object. |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.object">object</a></code> | <code>cdk8s-plus-28.k8s.ObjectMetricSourceV2</code> | object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object). |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.pods">pods</a></code> | <code>cdk8s-plus-28.k8s.PodsMetricSourceV2</code> | pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second). |
| <code><a href="#cdk8s-plus-28.k8s.MetricSpecV2.property.resource">resource</a></code> | <code>cdk8s-plus-28.k8s.ResourceMetricSourceV2</code> | resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.MetricSpecV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type is the type of metric source.

It should be one of "ContainerResource", "External", "Object", "Pods" or "Resource", each mapping to a matching field in the object. Note: "ContainerResource" type is available on when the feature-gate HPAContainerMetrics is enabled

---

##### `containerResource`<sup>Optional</sup> <a name="containerResource" id="cdk8s-plus-28.k8s.MetricSpecV2.property.containerResource"></a>

```typescript
public readonly containerResource: ContainerResourceMetricSourceV2;
```

- *Type:* cdk8s-plus-28.k8s.ContainerResourceMetricSourceV2

containerResource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing a single container in each pod of the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source. This is an alpha feature and can be enabled by the HPAContainerMetrics feature flag.

---

##### `external`<sup>Optional</sup> <a name="external" id="cdk8s-plus-28.k8s.MetricSpecV2.property.external"></a>

```typescript
public readonly external: ExternalMetricSourceV2;
```

- *Type:* cdk8s-plus-28.k8s.ExternalMetricSourceV2

external refers to a global metric that is not associated with any Kubernetes object.

It allows autoscaling based on information coming from components running outside of cluster (for example length of queue in cloud messaging service, or QPS from loadbalancer running outside of cluster).

---

##### `object`<sup>Optional</sup> <a name="object" id="cdk8s-plus-28.k8s.MetricSpecV2.property.object"></a>

```typescript
public readonly object: ObjectMetricSourceV2;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMetricSourceV2

object refers to a metric describing a single kubernetes object (for example, hits-per-second on an Ingress object).

---

##### `pods`<sup>Optional</sup> <a name="pods" id="cdk8s-plus-28.k8s.MetricSpecV2.property.pods"></a>

```typescript
public readonly pods: PodsMetricSourceV2;
```

- *Type:* cdk8s-plus-28.k8s.PodsMetricSourceV2

pods refers to a metric describing each pod in the current scale target (for example, transactions-processed-per-second).

The values will be averaged together before being compared to the target value.

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.MetricSpecV2.property.resource"></a>

```typescript
public readonly resource: ResourceMetricSourceV2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceMetricSourceV2

resource refers to a resource metric (such as those specified in requests and limits) known to Kubernetes describing each pod in the current scale target (e.g. CPU or memory). Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.

---

### MetricTargetV2 <a name="MetricTargetV2" id="cdk8s-plus-28.k8s.MetricTargetV2"></a>

MetricTarget defines the target value, average value, or average utilization of a specific metric.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MetricTargetV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const metricTargetV2: k8s.MetricTargetV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.type">type</a></code> | <code>string</code> | type represents whether the metric type is Utilization, Value, or AverageValue. |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.averageUtilization">averageUtilization</a></code> | <code>number</code> | averageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods. |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.averageValue">averageValue</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | averageValue is the target value of the average of the metric across all relevant pods (as a quantity). |
| <code><a href="#cdk8s-plus-28.k8s.MetricTargetV2.property.value">value</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | value is the target value of the metric (as a quantity). |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.MetricTargetV2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type represents whether the metric type is Utilization, Value, or AverageValue.

---

##### `averageUtilization`<sup>Optional</sup> <a name="averageUtilization" id="cdk8s-plus-28.k8s.MetricTargetV2.property.averageUtilization"></a>

```typescript
public readonly averageUtilization: number;
```

- *Type:* number

averageUtilization is the target value of the average of the resource metric across all relevant pods, represented as a percentage of the requested value of the resource for the pods.

Currently only valid for Resource metric source type

---

##### `averageValue`<sup>Optional</sup> <a name="averageValue" id="cdk8s-plus-28.k8s.MetricTargetV2.property.averageValue"></a>

```typescript
public readonly averageValue: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

averageValue is the target value of the average of the metric across all relevant pods (as a quantity).

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.MetricTargetV2.property.value"></a>

```typescript
public readonly value: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

value is the target value of the metric (as a quantity).

---

### MountOptions <a name="MountOptions" id="cdk8s-plus-28.MountOptions"></a>

Options for mounts.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.MountOptions.Initializer"></a>

```typescript
import { MountOptions } from 'cdk8s-plus-28'

const mountOptions: MountOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.MountOptions.property.propagation">propagation</a></code> | <code><a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a></code> | Determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.MountOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.MountOptions.property.subPath">subPath</a></code> | <code>string</code> | Path within the volume from which the container's volume should be mounted.). |
| <code><a href="#cdk8s-plus-28.MountOptions.property.subPathExpr">subPathExpr</a></code> | <code>string</code> | Expanded path within the volume from which the container's volume should be mounted. |

---

##### `propagation`<sup>Optional</sup> <a name="propagation" id="cdk8s-plus-28.MountOptions.property.propagation"></a>

```typescript
public readonly propagation: MountPropagation;
```

- *Type:* <a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a>
- *Default:* MountPropagation.NONE

Determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used.

Mount propagation allows for sharing volumes mounted by a Container to
other Containers in the same Pod, or even to other Pods on the same node.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.MountOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `subPath`<sup>Optional</sup> <a name="subPath" id="cdk8s-plus-28.MountOptions.property.subPath"></a>

```typescript
public readonly subPath: string;
```

- *Type:* string
- *Default:* "" the volume's root

Path within the volume from which the container's volume should be mounted.).

---

##### `subPathExpr`<sup>Optional</sup> <a name="subPathExpr" id="cdk8s-plus-28.MountOptions.property.subPathExpr"></a>

```typescript
public readonly subPathExpr: string;
```

- *Type:* string
- *Default:* "" volume's root.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references
$(VAR_NAME) are expanded using the container's environment. Defaults to ""
(volume's root).

`subPathExpr` and `subPath` are mutually exclusive.

---

### MutatingWebhook <a name="MutatingWebhook" id="cdk8s-plus-28.k8s.MutatingWebhook"></a>

MutatingWebhook describes an admission webhook and the resources and operations it applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.MutatingWebhook.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const mutatingWebhook: k8s.MutatingWebhook = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.admissionReviewVersions">admissionReviewVersions</a></code> | <code>string[]</code> | AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.clientConfig">clientConfig</a></code> | <code>cdk8s-plus-28.k8s.WebhookClientConfig</code> | ClientConfig defines how to communicate with the hook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.name">name</a></code> | <code>string</code> | The name of the admission webhook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.sideEffects">sideEffects</a></code> | <code>string</code> | SideEffects states whether this webhook has side effects. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.failurePolicy">failurePolicy</a></code> | <code>string</code> | FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.matchConditions">matchConditions</a></code> | <code>cdk8s-plus-28.k8s.MatchCondition[]</code> | MatchConditions is a list of conditions that must be met for a request to be sent to this webhook. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.matchPolicy">matchPolicy</a></code> | <code>string</code> | matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.objectSelector">objectSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the webhook based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.reinvocationPolicy">reinvocationPolicy</a></code> | <code>string</code> | reinvocationPolicy indicates whether this webhook should be called multiple times as part of a single admission evaluation. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.RuleWithOperations[]</code> | Rules describes what operations on what resources/subresources the webhook cares about. |
| <code><a href="#cdk8s-plus-28.k8s.MutatingWebhook.property.timeoutSeconds">timeoutSeconds</a></code> | <code>number</code> | TimeoutSeconds specifies the timeout for this webhook. |

---

##### `admissionReviewVersions`<sup>Required</sup> <a name="admissionReviewVersions" id="cdk8s-plus-28.k8s.MutatingWebhook.property.admissionReviewVersions"></a>

```typescript
public readonly admissionReviewVersions: string[];
```

- *Type:* string[]

AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects.

API server will try to use first version in the list which it supports. If none of the versions specified in this list supported by API server, validation will fail for this object. If a persisted webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail and be subject to the failure policy.

---

##### `clientConfig`<sup>Required</sup> <a name="clientConfig" id="cdk8s-plus-28.k8s.MutatingWebhook.property.clientConfig"></a>

```typescript
public readonly clientConfig: WebhookClientConfig;
```

- *Type:* cdk8s-plus-28.k8s.WebhookClientConfig

ClientConfig defines how to communicate with the hook.

Required

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.MutatingWebhook.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the admission webhook.

Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where "imagepolicy" is the name of the webhook, and kubernetes.io is the name of the organization. Required.

---

##### `sideEffects`<sup>Required</sup> <a name="sideEffects" id="cdk8s-plus-28.k8s.MutatingWebhook.property.sideEffects"></a>

```typescript
public readonly sideEffects: string;
```

- *Type:* string

SideEffects states whether this webhook has side effects.

Acceptable values are: None, NoneOnDryRun (webhooks created via v1beta1 may also specify Some or Unknown). Webhooks with side effects MUST implement a reconciliation system, since a request may be rejected by a future step in the admission chain and the side effects therefore need to be undone. Requests with the dryRun attribute will be auto-rejected if they match a webhook with sideEffects == Unknown or Some.

---

##### `failurePolicy`<sup>Optional</sup> <a name="failurePolicy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.failurePolicy"></a>

```typescript
public readonly failurePolicy: string;
```

- *Type:* string
- *Default:* Fail.

FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail.

Defaults to Fail.

---

##### `matchConditions`<sup>Optional</sup> <a name="matchConditions" id="cdk8s-plus-28.k8s.MutatingWebhook.property.matchConditions"></a>

```typescript
public readonly matchConditions: MatchCondition[];
```

- *Type:* cdk8s-plus-28.k8s.MatchCondition[]

MatchConditions is a list of conditions that must be met for a request to be sent to this webhook.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

The exact matching logic is (in order):
1. If ANY matchCondition evaluates to FALSE, the webhook is skipped.
2. If ALL matchConditions evaluate to TRUE, the webhook is called.
3. If any matchCondition evaluates to an error (but none are FALSE):
- If failurePolicy=Fail, reject the request
- If failurePolicy=Ignore, the error is ignored and the webhook is skipped

This is a beta feature and managed by the AdmissionWebhookMatchConditions feature gate.

---

##### `matchPolicy`<sup>Optional</sup> <a name="matchPolicy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.matchPolicy"></a>

```typescript
public readonly matchPolicy: string;
```

- *Type:* string
- *Default:* Equivalent"

matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the webhook.

- Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the webhook.

Defaults to "Equivalent"

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.MutatingWebhook.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the webhook.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the webhook on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/ for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `objectSelector`<sup>Optional</sup> <a name="objectSelector" id="cdk8s-plus-28.k8s.MutatingWebhook.property.objectSelector"></a>

```typescript
public readonly objectSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the webhook based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the webhook, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `reinvocationPolicy`<sup>Optional</sup> <a name="reinvocationPolicy" id="cdk8s-plus-28.k8s.MutatingWebhook.property.reinvocationPolicy"></a>

```typescript
public readonly reinvocationPolicy: string;
```

- *Type:* string
- *Default:* Never".

reinvocationPolicy indicates whether this webhook should be called multiple times as part of a single admission evaluation.

Allowed values are "Never" and "IfNeeded".

Never: the webhook will not be called more than once in a single admission evaluation.

IfNeeded: the webhook will be called at least one additional time as part of the admission evaluation if the object being admitted is modified by other admission plugins after the initial webhook call. Webhooks that specify this option *must* be idempotent, able to process objects they previously admitted. Note: * the number of additional invocations is not guaranteed to be exactly one. * if additional invocations result in further modifications to the object, webhooks are not guaranteed to be invoked again. * webhooks that use this option may be reordered to minimize the number of additional invocations. * to validate an object after all mutations are guaranteed complete, use a validating admission webhook instead.

Defaults to "Never".

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.MutatingWebhook.property.rules"></a>

```typescript
public readonly rules: RuleWithOperations[];
```

- *Type:* cdk8s-plus-28.k8s.RuleWithOperations[]

Rules describes what operations on what resources/subresources the webhook cares about.

The webhook cares about an operation if it matches _any_ Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.k8s.MutatingWebhook.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: number;
```

- *Type:* number
- *Default:* 10 seconds.

TimeoutSeconds specifies the timeout for this webhook.

After the timeout passes, the webhook call will be ignored or the API call will fail based on the failure policy. The timeout value must be between 1 and 30 seconds. Default to 10 seconds.

---

### NamedRuleWithOperationsV1Alpha1 <a name="NamedRuleWithOperationsV1Alpha1" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1"></a>

NamedRuleWithOperations is a tuple of Operations and Resources with ResourceNames.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const namedRuleWithOperationsV1Alpha1: k8s.NamedRuleWithOperationsV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiVersions">apiVersions</a></code> | <code>string[]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.operations">operations</a></code> | <code>string[]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resourceNames">resourceNames</a></code> | <code>string[]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resources">resources</a></code> | <code>string[]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.scope">scope</a></code> | <code>string</code> | scope specifies the scope of this rule. |

---

##### `apiGroups`<sup>Optional</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `apiVersions`<sup>Optional</sup> <a name="apiVersions" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.apiVersions"></a>

```typescript
public readonly apiVersions: string[];
```

- *Type:* string[]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* string[]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resourceNames`<sup>Optional</sup> <a name="resourceNames" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resourceNames"></a>

```typescript
public readonly resourceNames: string[];
```

- *Type:* string[]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '_/scale' means all scale subresources. '_/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Alpha1.property.scope"></a>

```typescript
public readonly scope: string;
```

- *Type:* string
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### NamedRuleWithOperationsV1Beta1 <a name="NamedRuleWithOperationsV1Beta1" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1"></a>

NamedRuleWithOperations is a tuple of Operations and Resources with ResourceNames.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const namedRuleWithOperationsV1Beta1: k8s.NamedRuleWithOperationsV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiVersions">apiVersions</a></code> | <code>string[]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.operations">operations</a></code> | <code>string[]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resourceNames">resourceNames</a></code> | <code>string[]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resources">resources</a></code> | <code>string[]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.scope">scope</a></code> | <code>string</code> | scope specifies the scope of this rule. |

---

##### `apiGroups`<sup>Optional</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `apiVersions`<sup>Optional</sup> <a name="apiVersions" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.apiVersions"></a>

```typescript
public readonly apiVersions: string[];
```

- *Type:* string[]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* string[]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resourceNames`<sup>Optional</sup> <a name="resourceNames" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resourceNames"></a>

```typescript
public readonly resourceNames: string[];
```

- *Type:* string[]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '_/scale' means all scale subresources. '_/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.NamedRuleWithOperationsV1Beta1.property.scope"></a>

```typescript
public readonly scope: string;
```

- *Type:* string
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### NamespaceProps <a name="NamespaceProps" id="cdk8s-plus-28.NamespaceProps"></a>

Properties for `Namespace`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespaceProps.Initializer"></a>

```typescript
import { NamespaceProps } from 'cdk8s-plus-28'

const namespaceProps: NamespaceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespaceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.NamespaceProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

### NamespaceSelectorConfig <a name="NamespaceSelectorConfig" id="cdk8s-plus-28.NamespaceSelectorConfig"></a>

Configuration for selecting namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespaceSelectorConfig.Initializer"></a>

```typescript
import { NamespaceSelectorConfig } from 'cdk8s-plus-28'

const namespaceSelectorConfig: NamespaceSelectorConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig.property.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to select namespaces by labels. |
| <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig.property.names">names</a></code> | <code>string[]</code> | A list of names to select namespaces by names. |

---

##### `labelSelector`<sup>Optional</sup> <a name="labelSelector" id="cdk8s-plus-28.NamespaceSelectorConfig.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

A selector to select namespaces by labels.

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.NamespaceSelectorConfig.property.names"></a>

```typescript
public readonly names: string[];
```

- *Type:* string[]

A list of names to select namespaces by names.

---

### NamespaceSpec <a name="NamespaceSpec" id="cdk8s-plus-28.k8s.NamespaceSpec"></a>

NamespaceSpec describes the attributes on a Namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NamespaceSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const namespaceSpec: k8s.NamespaceSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NamespaceSpec.property.finalizers">finalizers</a></code> | <code>string[]</code> | Finalizers is an opaque list of values that must be empty to permanently remove object from storage. |

---

##### `finalizers`<sup>Optional</sup> <a name="finalizers" id="cdk8s-plus-28.k8s.NamespaceSpec.property.finalizers"></a>

```typescript
public readonly finalizers: string[];
```

- *Type:* string[]

Finalizers is an opaque list of values that must be empty to permanently remove object from storage.

More info: https://kubernetes.io/docs/tasks/administer-cluster/namespaces/

---

### NamespacesSelectOptions <a name="NamespacesSelectOptions" id="cdk8s-plus-28.NamespacesSelectOptions"></a>

Options for `Namespaces.select`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NamespacesSelectOptions.Initializer"></a>

```typescript
import { NamespacesSelectOptions } from 'cdk8s-plus-28'

const namespacesSelectOptions: NamespacesSelectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.expressions">expressions</a></code> | <code><a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]</code> | Namespaces must satisfy these selectors. |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Labels the namespaces must have. |
| <code><a href="#cdk8s-plus-28.NamespacesSelectOptions.property.names">names</a></code> | <code>string[]</code> | Namespaces names must be one of these. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.NamespacesSelectOptions.property.expressions"></a>

```typescript
public readonly expressions: LabelExpression[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]
- *Default:* no selector requirements.

Namespaces must satisfy these selectors.

The selectors query labels, just like the `labels` property, but they
provide a more advanced matching mechanism.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.NamespacesSelectOptions.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* no strict labels requirements.

Labels the namespaces must have.

This is equivalent to using an 'Is' selector.

---

##### `names`<sup>Optional</sup> <a name="names" id="cdk8s-plus-28.NamespacesSelectOptions.property.names"></a>

```typescript
public readonly names: string[];
```

- *Type:* string[]
- *Default:* no name requirements.

Namespaces names must be one of these.

---

### NetworkPolicyAddEgressRuleOptions <a name="NetworkPolicyAddEgressRuleOptions" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions"></a>

Options for `NetworkPolicy.addEgressRule`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.Initializer"></a>

```typescript
import { NetworkPolicyAddEgressRuleOptions } from 'cdk8s-plus-28'

const networkPolicyAddEgressRuleOptions: NetworkPolicyAddEgressRuleOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]</code> | Ports the rule should allow outgoing traffic to. |

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicyAddEgressRuleOptions.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]
- *Default:* If the peer is a managed pod, take its ports. Otherwise, all ports are allowed.

Ports the rule should allow outgoing traffic to.

---

### NetworkPolicyEgressRule <a name="NetworkPolicyEgressRule" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule"></a>

NetworkPolicyEgressRule describes a particular set of traffic that is allowed out of pods matched by a NetworkPolicySpec's podSelector.

The traffic must match both ports and to. This type is beta-level in 1.8

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const networkPolicyEgressRule: k8s.NetworkPolicyEgressRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyPort[]</code> | ports is a list of destination ports for outgoing traffic. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.to">to</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyPeer[]</code> | to is a list of destinations for outgoing traffic of pods selected for this rule. |

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyPort[]

ports is a list of destination ports for outgoing traffic.

Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.

---

##### `to`<sup>Optional</sup> <a name="to" id="cdk8s-plus-28.k8s.NetworkPolicyEgressRule.property.to"></a>

```typescript
public readonly to: NetworkPolicyPeer[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyPeer[]

to is a list of destinations for outgoing traffic of pods selected for this rule.

Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all destinations (traffic not restricted by destination). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the to list.

---

### NetworkPolicyIngressRule <a name="NetworkPolicyIngressRule" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule"></a>

NetworkPolicyIngressRule describes a particular set of traffic that is allowed to the pods matched by a NetworkPolicySpec's podSelector.

The traffic must match both ports and from.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const networkPolicyIngressRule: k8s.NetworkPolicyIngressRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.from">from</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyPeer[]</code> | from is a list of sources which should be able to access the pods selected for this rule. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyPort[]</code> | ports is a list of ports which should be made accessible on the pods selected for this rule. |

---

##### `from`<sup>Optional</sup> <a name="from" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.from"></a>

```typescript
public readonly from: NetworkPolicyPeer[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyPeer[]

from is a list of sources which should be able to access the pods selected for this rule.

Items in this list are combined using a logical OR operation. If this field is empty or missing, this rule matches all sources (traffic not restricted by source). If this field is present and contains at least one item, this rule allows traffic only if the traffic matches at least one item in the from list.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.NetworkPolicyIngressRule.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyPort[]

ports is a list of ports which should be made accessible on the pods selected for this rule.

Each item in this list is combined using a logical OR. If this field is empty or missing, this rule matches all ports (traffic not restricted by port). If this field is present and contains at least one item, then this rule allows traffic only if the traffic matches at least one port in the list.

---

### NetworkPolicyPeer <a name="NetworkPolicyPeer" id="cdk8s-plus-28.k8s.NetworkPolicyPeer"></a>

NetworkPolicyPeer describes a peer to allow traffic to/from.

Only certain combinations of fields are allowed

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const networkPolicyPeer: k8s.NetworkPolicyPeer = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.ipBlock">ipBlock</a></code> | <code>cdk8s-plus-28.k8s.IpBlock</code> | ipBlock defines policy on a particular IPBlock. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | namespaceSelector selects namespaces using cluster-scoped labels. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPeer.property.podSelector">podSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | podSelector is a label selector which selects pods. |

---

##### `ipBlock`<sup>Optional</sup> <a name="ipBlock" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.ipBlock"></a>

```typescript
public readonly ipBlock: IpBlock;
```

- *Type:* cdk8s-plus-28.k8s.IpBlock

ipBlock defines policy on a particular IPBlock.

If this field is set then neither of the other fields can be.

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

namespaceSelector selects namespaces using cluster-scoped labels.

This field follows standard label selector semantics; if present but empty, it selects all namespaces.

If podSelector is also set, then the NetworkPolicyPeer as a whole selects the pods matching podSelector in the namespaces selected by namespaceSelector. Otherwise it selects all pods in the namespaces selected by namespaceSelector.

---

##### `podSelector`<sup>Optional</sup> <a name="podSelector" id="cdk8s-plus-28.k8s.NetworkPolicyPeer.property.podSelector"></a>

```typescript
public readonly podSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

podSelector is a label selector which selects pods.

This field follows standard label selector semantics; if present but empty, it selects all pods.

If namespaceSelector is also set, then the NetworkPolicyPeer as a whole selects the pods matching podSelector in the Namespaces selected by NamespaceSelector. Otherwise it selects the pods matching podSelector in the policy's own namespace.

---

### NetworkPolicyPeerConfig <a name="NetworkPolicyPeerConfig" id="cdk8s-plus-28.NetworkPolicyPeerConfig"></a>

Configuration for network peers.

A peer can either by an ip block, or a selection of pods, not both.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyPeerConfig.Initializer"></a>

```typescript
import { NetworkPolicyPeerConfig } from 'cdk8s-plus-28'

const networkPolicyPeerConfig: NetworkPolicyPeerConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPeerConfig.property.ipBlock">ipBlock</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a></code> | The ip block this peer represents. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPeerConfig.property.podSelector">podSelector</a></code> | <code><a href="#cdk8s-plus-28.PodSelectorConfig">PodSelectorConfig</a></code> | The pod selector this peer represents. |

---

##### `ipBlock`<sup>Optional</sup> <a name="ipBlock" id="cdk8s-plus-28.NetworkPolicyPeerConfig.property.ipBlock"></a>

```typescript
public readonly ipBlock: NetworkPolicyIpBlock;
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a>

The ip block this peer represents.

---

##### `podSelector`<sup>Optional</sup> <a name="podSelector" id="cdk8s-plus-28.NetworkPolicyPeerConfig.property.podSelector"></a>

```typescript
public readonly podSelector: PodSelectorConfig;
```

- *Type:* <a href="#cdk8s-plus-28.PodSelectorConfig">PodSelectorConfig</a>

The pod selector this peer represents.

---

### NetworkPolicyPort <a name="NetworkPolicyPort" id="cdk8s-plus-28.k8s.NetworkPolicyPort"></a>

NetworkPolicyPort describes a port to allow traffic on.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicyPort.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const networkPolicyPort: k8s.NetworkPolicyPort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.endPort">endPort</a></code> | <code>number</code> | endPort indicates that the range of ports from port to endPort if set, inclusive, should be allowed by the policy. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.port">port</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | port represents the port on the given protocol. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicyPort.property.protocol">protocol</a></code> | <code>string</code> | protocol represents the protocol (TCP, UDP, or SCTP) which traffic must match. |

---

##### `endPort`<sup>Optional</sup> <a name="endPort" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.endPort"></a>

```typescript
public readonly endPort: number;
```

- *Type:* number

endPort indicates that the range of ports from port to endPort if set, inclusive, should be allowed by the policy.

This field cannot be defined if the port field is not defined or if the port field is defined as a named (string) port. The endPort must be equal or greater than port.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.port"></a>

```typescript
public readonly port: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

port represents the port on the given protocol.

This can either be a numerical or named port on a pod. If this field is not provided, this matches all port names and numbers. If present, only traffic on the specified protocol AND port will be matched.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.NetworkPolicyPort.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string

protocol represents the protocol (TCP, UDP, or SCTP) which traffic must match.

If not specified, this field defaults to TCP.

---

### NetworkPolicyPortProps <a name="NetworkPolicyPortProps" id="cdk8s-plus-28.NetworkPolicyPortProps"></a>

Properties for `NetworkPolicyPort`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyPortProps.Initializer"></a>

```typescript
import { NetworkPolicyPortProps } from 'cdk8s-plus-28'

const networkPolicyPortProps: NetworkPolicyPortProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.endPort">endPort</a></code> | <code>number</code> | End port (relative to `port`). |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.port">port</a></code> | <code>number</code> | Specific port number. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPortProps.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.NetworkProtocol">NetworkProtocol</a></code> | Protocol. |

---

##### `endPort`<sup>Optional</sup> <a name="endPort" id="cdk8s-plus-28.NetworkPolicyPortProps.property.endPort"></a>

```typescript
public readonly endPort: number;
```

- *Type:* number
- *Default:* not a port range.

End port (relative to `port`).

Only applies if `port` is defined.
Use this to specify a port range, rather that a specific one.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPortProps.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* all ports are allowed.

Specific port number.

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.NetworkPolicyPortProps.property.protocol"></a>

```typescript
public readonly protocol: NetworkProtocol;
```

- *Type:* <a href="#cdk8s-plus-28.NetworkProtocol">NetworkProtocol</a>
- *Default:* NetworkProtocol.TCP

Protocol.

---

### NetworkPolicyProps <a name="NetworkPolicyProps" id="cdk8s-plus-28.NetworkPolicyProps"></a>

Properties for `NetworkPolicy`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyProps.Initializer"></a>

```typescript
import { NetworkPolicyProps } from 'cdk8s-plus-28'

const networkPolicyProps: NetworkPolicyProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.egress">egress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Egress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.ingress">ingress</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a></code> | Ingress traffic configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyProps.property.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods does this policy object applies to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.NetworkPolicyProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="cdk8s-plus-28.NetworkPolicyProps.property.egress"></a>

```typescript
public readonly egress: NetworkPolicyTraffic;
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change egress behavior of the pods it selects.

Egress traffic configuration.

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.NetworkPolicyProps.property.ingress"></a>

```typescript
public readonly ingress: NetworkPolicyTraffic;
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTraffic">NetworkPolicyTraffic</a>
- *Default:* the policy doesn't change ingress behavior of the pods it selects.

Ingress traffic configuration.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.NetworkPolicyProps.property.selector"></a>

```typescript
public readonly selector: IPodSelector;
```

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* will select all pods in the namespace of the policy.

Which pods does this policy object applies to.

This can either be a single pod / workload, or a grouping of pods selected
via the `Pods.select` function. Rules is applied to any pods selected by this property.
Multiple network policies can select the same set of pods.
In this case, the rules for each are combined additively.

Note that

---

### NetworkPolicyRule <a name="NetworkPolicyRule" id="cdk8s-plus-28.NetworkPolicyRule"></a>

Describes a rule allowing traffic from / to pods matched by a network policy selector.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyRule.Initializer"></a>

```typescript
import { NetworkPolicyRule } from 'cdk8s-plus-28'

const networkPolicyRule: NetworkPolicyRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyRule.property.peer">peer</a></code> | <code><a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a></code> | Peer this rule interacts with. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyRule.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]</code> | The ports of the rule. |

---

##### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.NetworkPolicyRule.property.peer"></a>

```typescript
public readonly peer: INetworkPolicyPeer;
```

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Peer this rule interacts with.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.NetworkPolicyRule.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]
- *Default:* traffic is allowed on all ports.

The ports of the rule.

---

### NetworkPolicySpec <a name="NetworkPolicySpec" id="cdk8s-plus-28.k8s.NetworkPolicySpec"></a>

NetworkPolicySpec provides the specification of a NetworkPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NetworkPolicySpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const networkPolicySpec: k8s.NetworkPolicySpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.podSelector">podSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | podSelector selects the pods to which this NetworkPolicy object applies. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.egress">egress</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyEgressRule[]</code> | egress is a list of egress rules to be applied to the selected pods. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.ingress">ingress</a></code> | <code>cdk8s-plus-28.k8s.NetworkPolicyIngressRule[]</code> | ingress is a list of ingress rules to be applied to the selected pods. |
| <code><a href="#cdk8s-plus-28.k8s.NetworkPolicySpec.property.policyTypes">policyTypes</a></code> | <code>string[]</code> | policyTypes is a list of rule types that the NetworkPolicy relates to. |

---

##### `podSelector`<sup>Required</sup> <a name="podSelector" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.podSelector"></a>

```typescript
public readonly podSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

podSelector selects the pods to which this NetworkPolicy object applies.

The array of ingress rules is applied to any pods selected by this field. Multiple network policies can select the same set of pods. In this case, the ingress rules for each are combined additively. This field is NOT optional and follows standard label selector semantics. An empty podSelector matches all pods in this namespace.

---

##### `egress`<sup>Optional</sup> <a name="egress" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.egress"></a>

```typescript
public readonly egress: NetworkPolicyEgressRule[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyEgressRule[]

egress is a list of egress rules to be applied to the selected pods.

Outgoing traffic is allowed if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic matches at least one egress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy limits all outgoing traffic (and serves solely to ensure that the pods it selects are isolated by default). This field is beta-level in 1.8

---

##### `ingress`<sup>Optional</sup> <a name="ingress" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.ingress"></a>

```typescript
public readonly ingress: NetworkPolicyIngressRule[];
```

- *Type:* cdk8s-plus-28.k8s.NetworkPolicyIngressRule[]

ingress is a list of ingress rules to be applied to the selected pods.

Traffic is allowed to a pod if there are no NetworkPolicies selecting the pod (and cluster policy otherwise allows the traffic), OR if the traffic source is the pod's local node, OR if the traffic matches at least one ingress rule across all of the NetworkPolicy objects whose podSelector matches the pod. If this field is empty then this NetworkPolicy does not allow any traffic (and serves solely to ensure that the pods it selects are isolated by default)

---

##### `policyTypes`<sup>Optional</sup> <a name="policyTypes" id="cdk8s-plus-28.k8s.NetworkPolicySpec.property.policyTypes"></a>

```typescript
public readonly policyTypes: string[];
```

- *Type:* string[]

policyTypes is a list of rule types that the NetworkPolicy relates to.

Valid options are ["Ingress"], ["Egress"], or ["Ingress", "Egress"]. If this field is not specified, it will default based on the existence of ingress or egress rules; policies that contain an egress section are assumed to affect egress, and all policies (whether or not they contain an ingress section) are assumed to affect ingress. If you want to write an egress-only policy, you must explicitly specify policyTypes [ "Egress" ]. Likewise, if you want to write a policy that specifies that no egress is allowed, you must specify a policyTypes value that include "Egress" (since such a policy would not include an egress section and would otherwise default to just [ "Ingress" ]). This field is beta-level in 1.8

---

### NetworkPolicyTraffic <a name="NetworkPolicyTraffic" id="cdk8s-plus-28.NetworkPolicyTraffic"></a>

Describes how the network policy should configure egress / ingress traffic.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NetworkPolicyTraffic.Initializer"></a>

```typescript
import { NetworkPolicyTraffic } from 'cdk8s-plus-28'

const networkPolicyTraffic: NetworkPolicyTraffic = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic.property.default">default</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault">NetworkPolicyTrafficDefault</a></code> | Specifies the default behavior of the policy when no rules are defined. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTraffic.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyRule">NetworkPolicyRule</a>[]</code> | List of rules to be applied to the selected pods. |

---

##### `default`<sup>Optional</sup> <a name="default" id="cdk8s-plus-28.NetworkPolicyTraffic.property.default"></a>

```typescript
public readonly default: NetworkPolicyTrafficDefault;
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault">NetworkPolicyTrafficDefault</a>
- *Default:* unset, the policy does not change the behavior.

Specifies the default behavior of the policy when no rules are defined.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.NetworkPolicyTraffic.property.rules"></a>

```typescript
public readonly rules: NetworkPolicyRule[];
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyRule">NetworkPolicyRule</a>[]
- *Default:* no rules

List of rules to be applied to the selected pods.

If empty, the behavior of the policy is dictated by the `default` property.

---

### NfsVolumeOptions <a name="NfsVolumeOptions" id="cdk8s-plus-28.NfsVolumeOptions"></a>

Options for the NFS based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NfsVolumeOptions.Initializer"></a>

```typescript
import { NfsVolumeOptions } from 'cdk8s-plus-28'

const nfsVolumeOptions: NfsVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.path">path</a></code> | <code>string</code> | Path that is exported by the NFS server. |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.server">server</a></code> | <code>string</code> | Server is the hostname or IP address of the NFS server. |
| <code><a href="#cdk8s-plus-28.NfsVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | If set to true, will force the NFS export to be mounted with read-only permissions. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.NfsVolumeOptions.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Path that is exported by the NFS server.

---

##### `server`<sup>Required</sup> <a name="server" id="cdk8s-plus-28.NfsVolumeOptions.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

Server is the hostname or IP address of the NFS server.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.NfsVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, will force the NFS export to be mounted with read-only permissions.

---

### NfsVolumeSource <a name="NfsVolumeSource" id="cdk8s-plus-28.k8s.NfsVolumeSource"></a>

Represents an NFS mount that lasts the lifetime of a pod.

NFS volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NfsVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nfsVolumeSource: k8s.NfsVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.path">path</a></code> | <code>string</code> | path that is exported by the NFS server. |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.server">server</a></code> | <code>string</code> | server is the hostname or IP address of the NFS server. |
| <code><a href="#cdk8s-plus-28.k8s.NfsVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the NFS export to be mounted with read-only permissions. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path that is exported by the NFS server.

More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `server`<sup>Required</sup> <a name="server" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.server"></a>

```typescript
public readonly server: string;
```

- *Type:* string

server is the hostname or IP address of the NFS server.

More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.NfsVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

readOnly here will force the NFS export to be mounted with read-only permissions.

Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

### NodeAffinity <a name="NodeAffinity" id="cdk8s-plus-28.k8s.NodeAffinity"></a>

Node affinity is a group of node affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeAffinity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeAffinity: k8s.NodeAffinity = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.PreferredSchedulingTerm[]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.NodeAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">requiredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.NodeSelector</code> | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="preferredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.NodeAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly preferredDuringSchedulingIgnoredDuringExecution: PreferredSchedulingTerm[];
```

- *Type:* cdk8s-plus-28.k8s.PreferredSchedulingTerm[]

The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.

---

##### `requiredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="requiredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.NodeAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly requiredDuringSchedulingIgnoredDuringExecution: NodeSelector;
```

- *Type:* cdk8s-plus-28.k8s.NodeSelector

If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.

---

### NodeConfigSource <a name="NodeConfigSource" id="cdk8s-plus-28.k8s.NodeConfigSource"></a>

NodeConfigSource specifies a source of node configuration.

Exactly one subfield (excluding metadata) must be non-nil. This API is deprecated since 1.22

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeConfigSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeConfigSource: k8s.NodeConfigSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeConfigSource.property.configMap">configMap</a></code> | <code>cdk8s-plus-28.k8s.ConfigMapNodeConfigSource</code> | ConfigMap is a reference to a Node's ConfigMap. |

---

##### `configMap`<sup>Optional</sup> <a name="configMap" id="cdk8s-plus-28.k8s.NodeConfigSource.property.configMap"></a>

```typescript
public readonly configMap: ConfigMapNodeConfigSource;
```

- *Type:* cdk8s-plus-28.k8s.ConfigMapNodeConfigSource

ConfigMap is a reference to a Node's ConfigMap.

---

### NodeSelector <a name="NodeSelector" id="cdk8s-plus-28.k8s.NodeSelector"></a>

A node selector represents the union of the results of one or more label queries over a set of nodes;

that is, it represents the OR of the selectors represented by the node selector terms.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeSelector: k8s.NodeSelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelector.property.nodeSelectorTerms">nodeSelectorTerms</a></code> | <code>cdk8s-plus-28.k8s.NodeSelectorTerm[]</code> | Required. |

---

##### `nodeSelectorTerms`<sup>Required</sup> <a name="nodeSelectorTerms" id="cdk8s-plus-28.k8s.NodeSelector.property.nodeSelectorTerms"></a>

```typescript
public readonly nodeSelectorTerms: NodeSelectorTerm[];
```

- *Type:* cdk8s-plus-28.k8s.NodeSelectorTerm[]

Required.

A list of node selector terms. The terms are ORed.

---

### NodeSelectorRequirement <a name="NodeSelectorRequirement" id="cdk8s-plus-28.k8s.NodeSelectorRequirement"></a>

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeSelectorRequirement: k8s.NodeSelectorRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.key">key</a></code> | <code>string</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.operator">operator</a></code> | <code>string</code> | Represents a key's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorRequirement.property.values">values</a></code> | <code>string[]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The label key that the selector applies to.

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

Represents a key's relationship to a set of values.

Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.NodeSelectorRequirement.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

An array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.

---

### NodeSelectorTerm <a name="NodeSelectorTerm" id="cdk8s-plus-28.k8s.NodeSelectorTerm"></a>

A null or empty node selector term matches no objects.

The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSelectorTerm.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeSelectorTerm: k8s.NodeSelectorTerm = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchExpressions">matchExpressions</a></code> | <code>cdk8s-plus-28.k8s.NodeSelectorRequirement[]</code> | A list of node selector requirements by node's labels. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchFields">matchFields</a></code> | <code>cdk8s-plus-28.k8s.NodeSelectorRequirement[]</code> | A list of node selector requirements by node's fields. |

---

##### `matchExpressions`<sup>Optional</sup> <a name="matchExpressions" id="cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: NodeSelectorRequirement[];
```

- *Type:* cdk8s-plus-28.k8s.NodeSelectorRequirement[]

A list of node selector requirements by node's labels.

---

##### `matchFields`<sup>Optional</sup> <a name="matchFields" id="cdk8s-plus-28.k8s.NodeSelectorTerm.property.matchFields"></a>

```typescript
public readonly matchFields: NodeSelectorRequirement[];
```

- *Type:* cdk8s-plus-28.k8s.NodeSelectorRequirement[]

A list of node selector requirements by node's fields.

---

### NodeSpec <a name="NodeSpec" id="cdk8s-plus-28.k8s.NodeSpec"></a>

NodeSpec describes the attributes that a node is created with.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NodeSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nodeSpec: k8s.NodeSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.configSource">configSource</a></code> | <code>cdk8s-plus-28.k8s.NodeConfigSource</code> | Deprecated: Previously used to specify the source of the node's configuration for the DynamicKubeletConfig feature. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.externalId">externalId</a></code> | <code>string</code> | Deprecated. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.podCidr">podCidr</a></code> | <code>string</code> | PodCIDR represents the pod IP range assigned to the node. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.podCidRs">podCidRs</a></code> | <code>string[]</code> | podCIDRs represents the IP ranges assigned to the node for usage by Pods on that node. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.providerId">providerId</a></code> | <code>string</code> | ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.taints">taints</a></code> | <code>cdk8s-plus-28.k8s.Taint[]</code> | If specified, the node's taints. |
| <code><a href="#cdk8s-plus-28.k8s.NodeSpec.property.unschedulable">unschedulable</a></code> | <code>boolean</code> | Unschedulable controls node schedulability of new pods. |

---

##### `configSource`<sup>Optional</sup> <a name="configSource" id="cdk8s-plus-28.k8s.NodeSpec.property.configSource"></a>

```typescript
public readonly configSource: NodeConfigSource;
```

- *Type:* cdk8s-plus-28.k8s.NodeConfigSource

Deprecated: Previously used to specify the source of the node's configuration for the DynamicKubeletConfig feature.

This feature is removed.

---

##### `externalId`<sup>Optional</sup> <a name="externalId" id="cdk8s-plus-28.k8s.NodeSpec.property.externalId"></a>

```typescript
public readonly externalId: string;
```

- *Type:* string

Deprecated.

Not all kubelets will set this field. Remove field after 1.13. see: https://issues.k8s.io/61966

---

##### `podCidr`<sup>Optional</sup> <a name="podCidr" id="cdk8s-plus-28.k8s.NodeSpec.property.podCidr"></a>

```typescript
public readonly podCidr: string;
```

- *Type:* string

PodCIDR represents the pod IP range assigned to the node.

---

##### `podCidRs`<sup>Optional</sup> <a name="podCidRs" id="cdk8s-plus-28.k8s.NodeSpec.property.podCidRs"></a>

```typescript
public readonly podCidRs: string[];
```

- *Type:* string[]

podCIDRs represents the IP ranges assigned to the node for usage by Pods on that node.

If this field is specified, the 0th entry must match the podCIDR field. It may contain at most 1 value for each of IPv4 and IPv6.

---

##### `providerId`<sup>Optional</sup> <a name="providerId" id="cdk8s-plus-28.k8s.NodeSpec.property.providerId"></a>

```typescript
public readonly providerId: string;
```

- *Type:* string

ID of the node assigned by the cloud provider in the format: <ProviderName>://<ProviderSpecificNodeID>.

---

##### `taints`<sup>Optional</sup> <a name="taints" id="cdk8s-plus-28.k8s.NodeSpec.property.taints"></a>

```typescript
public readonly taints: Taint[];
```

- *Type:* cdk8s-plus-28.k8s.Taint[]

If specified, the node's taints.

---

##### `unschedulable`<sup>Optional</sup> <a name="unschedulable" id="cdk8s-plus-28.k8s.NodeSpec.property.unschedulable"></a>

```typescript
public readonly unschedulable: boolean;
```

- *Type:* boolean

Unschedulable controls node schedulability of new pods.

By default, node is schedulable. More info: https://kubernetes.io/docs/concepts/nodes/node/#manual-node-administration

---

### NodeTaintQueryOptions <a name="NodeTaintQueryOptions" id="cdk8s-plus-28.NodeTaintQueryOptions"></a>

Options for `NodeTaintQuery`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.NodeTaintQueryOptions.Initializer"></a>

```typescript
import { NodeTaintQueryOptions } from 'cdk8s-plus-28'

const nodeTaintQueryOptions: NodeTaintQueryOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NodeTaintQueryOptions.property.effect">effect</a></code> | <code><a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a></code> | The taint effect to match. |
| <code><a href="#cdk8s-plus-28.NodeTaintQueryOptions.property.evictAfter">evictAfter</a></code> | <code>cdk8s.Duration</code> | How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node. |

---

##### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.NodeTaintQueryOptions.property.effect"></a>

```typescript
public readonly effect: TaintEffect;
```

- *Type:* <a href="#cdk8s-plus-28.TaintEffect">TaintEffect</a>
- *Default:* all effects are matched.

The taint effect to match.

---

##### `evictAfter`<sup>Optional</sup> <a name="evictAfter" id="cdk8s-plus-28.NodeTaintQueryOptions.property.evictAfter"></a>

```typescript
public readonly evictAfter: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* bound forever.

How much time should a pod that tolerates the `NO_EXECUTE` effect be bound to the node.

Only applies for the `NO_EXECUTE` effect.

---

### NonResourceAttributes <a name="NonResourceAttributes" id="cdk8s-plus-28.k8s.NonResourceAttributes"></a>

NonResourceAttributes includes the authorization attributes available for non-resource requests to the Authorizer interface.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourceAttributes.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nonResourceAttributes: k8s.NonResourceAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourceAttributes.property.path">path</a></code> | <code>string</code> | Path is the URL path of the request. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourceAttributes.property.verb">verb</a></code> | <code>string</code> | Verb is the standard HTTP verb. |

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.NonResourceAttributes.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Path is the URL path of the request.

---

##### `verb`<sup>Optional</sup> <a name="verb" id="cdk8s-plus-28.k8s.NonResourceAttributes.property.verb"></a>

```typescript
public readonly verb: string;
```

- *Type:* string

Verb is the standard HTTP verb.

---

### NonResourcePolicyRuleV1Beta2 <a name="NonResourcePolicyRuleV1Beta2" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2"></a>

NonResourcePolicyRule is a predicate that matches non-resource requests according to their verb and the target non-resource URL.

A NonResourcePolicyRule matches a request if and only if both (a) at least one member of verbs matches the request and (b) at least one member of nonResourceURLs matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nonResourcePolicyRuleV1Beta2: k8s.NonResourcePolicyRuleV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.nonResourceUrLs">nonResourceUrLs</a></code> | <code>string[]</code> | `nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.verbs">verbs</a></code> | <code>string[]</code> | `verbs` is a list of matching verbs and may not be empty. |

---

##### `nonResourceUrLs`<sup>Required</sup> <a name="nonResourceUrLs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.nonResourceUrLs"></a>

```typescript
public readonly nonResourceUrLs: string[];
```

- *Type:* string[]

`nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty.

For example:
- "/healthz" is legal
- "/hea*" is illegal
- "/hea" is legal but matches nothing
- "/hea/*" also matches nothing
- "/healthz/*" matches all per-component health checks.
"*" matches all non-resource urls. if it is present, it must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs. If it is present, it must be the only entry. Required.

---

### NonResourcePolicyRuleV1Beta3 <a name="NonResourcePolicyRuleV1Beta3" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3"></a>

NonResourcePolicyRule is a predicate that matches non-resource requests according to their verb and the target non-resource URL.

A NonResourcePolicyRule matches a request if and only if both (a) at least one member of verbs matches the request and (b) at least one member of nonResourceURLs matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const nonResourcePolicyRuleV1Beta3: k8s.NonResourcePolicyRuleV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.nonResourceUrLs">nonResourceUrLs</a></code> | <code>string[]</code> | `nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.verbs">verbs</a></code> | <code>string[]</code> | `verbs` is a list of matching verbs and may not be empty. |

---

##### `nonResourceUrLs`<sup>Required</sup> <a name="nonResourceUrLs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.nonResourceUrLs"></a>

```typescript
public readonly nonResourceUrLs: string[];
```

- *Type:* string[]

`nonResourceURLs` is a set of url prefixes that a user should have access to and may not be empty.

For example:
- "/healthz" is legal
- "/hea*" is illegal
- "/hea" is legal but matches nothing
- "/hea/*" also matches nothing
- "/healthz/*" matches all per-component health checks.
"*" matches all non-resource urls. if it is present, it must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs. If it is present, it must be the only entry. Required.

---

### ObjectFieldSelector <a name="ObjectFieldSelector" id="cdk8s-plus-28.k8s.ObjectFieldSelector"></a>

ObjectFieldSelector selects an APIVersioned field of an object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectFieldSelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const objectFieldSelector: k8s.ObjectFieldSelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectFieldSelector.property.fieldPath">fieldPath</a></code> | <code>string</code> | Path of the field to select in the specified API version. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectFieldSelector.property.apiVersion">apiVersion</a></code> | <code>string</code> | Version of the schema the FieldPath is written in terms of, defaults to "v1". |

---

##### `fieldPath`<sup>Required</sup> <a name="fieldPath" id="cdk8s-plus-28.k8s.ObjectFieldSelector.property.fieldPath"></a>

```typescript
public readonly fieldPath: string;
```

- *Type:* string

Path of the field to select in the specified API version.

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.ObjectFieldSelector.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

Version of the schema the FieldPath is written in terms of, defaults to "v1".

---

### ObjectMeta <a name="ObjectMeta" id="cdk8s-plus-28.k8s.ObjectMeta"></a>

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectMeta.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const objectMeta: k8s.ObjectMeta = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.annotations">annotations</a></code> | <code>{[ key: string ]: string}</code> | Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.creationTimestamp">creationTimestamp</a></code> | <code>Date</code> | CreationTimestamp is a timestamp representing the server time when this object was created. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.deletionGracePeriodSeconds">deletionGracePeriodSeconds</a></code> | <code>number</code> | Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.deletionTimestamp">deletionTimestamp</a></code> | <code>Date</code> | DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.finalizers">finalizers</a></code> | <code>string[]</code> | Must be empty before the object is deleted from the registry. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.generateName">generateName</a></code> | <code>string</code> | GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.generation">generation</a></code> | <code>number</code> | A sequence number representing a specific generation of the desired state. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Map of string keys and values that can be used to organize and categorize (scope and select) objects. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.managedFields">managedFields</a></code> | <code>cdk8s-plus-28.k8s.ManagedFieldsEntry[]</code> | ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.name">name</a></code> | <code>string</code> | Name must be unique within a namespace. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.namespace">namespace</a></code> | <code>string</code> | Namespace defines the space within which each name must be unique. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.ownerReferences">ownerReferences</a></code> | <code>cdk8s-plus-28.k8s.OwnerReference[]</code> | List of objects depended by this object. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.resourceVersion">resourceVersion</a></code> | <code>string</code> | An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.selfLink">selfLink</a></code> | <code>string</code> | Deprecated: selfLink is a legacy read-only field that is no longer populated by the system. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMeta.property.uid">uid</a></code> | <code>string</code> | UID is the unique in time and space value for this object. |

---

##### `annotations`<sup>Optional</sup> <a name="annotations" id="cdk8s-plus-28.k8s.ObjectMeta.property.annotations"></a>

```typescript
public readonly annotations: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata.

They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations

---

##### `creationTimestamp`<sup>Optional</sup> <a name="creationTimestamp" id="cdk8s-plus-28.k8s.ObjectMeta.property.creationTimestamp"></a>

```typescript
public readonly creationTimestamp: Date;
```

- *Type:* Date

CreationTimestamp is a timestamp representing the server time when this object was created.

It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

Populated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `deletionGracePeriodSeconds`<sup>Optional</sup> <a name="deletionGracePeriodSeconds" id="cdk8s-plus-28.k8s.ObjectMeta.property.deletionGracePeriodSeconds"></a>

```typescript
public readonly deletionGracePeriodSeconds: number;
```

- *Type:* number

Number of seconds allowed for this object to gracefully terminate before it will be removed from the system.

Only set when deletionTimestamp is also set. May only be shortened. Read-only.

---

##### `deletionTimestamp`<sup>Optional</sup> <a name="deletionTimestamp" id="cdk8s-plus-28.k8s.ObjectMeta.property.deletionTimestamp"></a>

```typescript
public readonly deletionTimestamp: Date;
```

- *Type:* Date

DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted.

This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `finalizers`<sup>Optional</sup> <a name="finalizers" id="cdk8s-plus-28.k8s.ObjectMeta.property.finalizers"></a>

```typescript
public readonly finalizers: string[];
```

- *Type:* string[]

Must be empty before the object is deleted from the registry.

Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order.  Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list.

---

##### `generateName`<sup>Optional</sup> <a name="generateName" id="cdk8s-plus-28.k8s.ObjectMeta.property.generateName"></a>

```typescript
public readonly generateName: string;
```

- *Type:* string

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided.

If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will return a 409.

Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency

---

##### `generation`<sup>Optional</sup> <a name="generation" id="cdk8s-plus-28.k8s.ObjectMeta.property.generation"></a>

```typescript
public readonly generation: number;
```

- *Type:* number

A sequence number representing a specific generation of the desired state.

Populated by the system. Read-only.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.k8s.ObjectMeta.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Map of string keys and values that can be used to organize and categorize (scope and select) objects.

May match selectors of replication controllers and services. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels

---

##### `managedFields`<sup>Optional</sup> <a name="managedFields" id="cdk8s-plus-28.k8s.ObjectMeta.property.managedFields"></a>

```typescript
public readonly managedFields: ManagedFieldsEntry[];
```

- *Type:* cdk8s-plus-28.k8s.ManagedFieldsEntry[]

ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow.

This is mostly for internal housekeeping, and users typically shouldn't need to set or understand this field. A workflow can be the user's name, a controller's name, or the name of a specific apply path like "ci-cd". The set of fields is always in the version that the workflow used when modifying the object.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ObjectMeta.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name must be unique within a namespace.

Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ObjectMeta.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace defines the space within which each name must be unique.

An empty namespace is equivalent to the "default" namespace, but "default" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces

---

##### `ownerReferences`<sup>Optional</sup> <a name="ownerReferences" id="cdk8s-plus-28.k8s.ObjectMeta.property.ownerReferences"></a>

```typescript
public readonly ownerReferences: OwnerReference[];
```

- *Type:* cdk8s-plus-28.k8s.OwnerReference[]

List of objects depended by this object.

If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.

---

##### `resourceVersion`<sup>Optional</sup> <a name="resourceVersion" id="cdk8s-plus-28.k8s.ObjectMeta.property.resourceVersion"></a>

```typescript
public readonly resourceVersion: string;
```

- *Type:* string

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed.

May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `selfLink`<sup>Optional</sup> <a name="selfLink" id="cdk8s-plus-28.k8s.ObjectMeta.property.selfLink"></a>

```typescript
public readonly selfLink: string;
```

- *Type:* string

Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ObjectMeta.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID is the unique in time and space value for this object.

It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

### ObjectMetricSourceV2 <a name="ObjectMetricSourceV2" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2"></a>

ObjectMetricSource indicates how to scale on a metric describing a kubernetes object (for example, hits-per-second on an Ingress object).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const objectMetricSourceV2: k8s.ObjectMetricSourceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.describedObject">describedObject</a></code> | <code>cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2</code> | describedObject specifies the descriptions of a object,such as kind,name apiVersion. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s-plus-28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `describedObject`<sup>Required</sup> <a name="describedObject" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.describedObject"></a>

```typescript
public readonly describedObject: CrossVersionObjectReferenceV2;
```

- *Type:* cdk8s-plus-28.k8s.CrossVersionObjectReferenceV2

describedObject specifies the descriptions of a object,such as kind,name apiVersion.

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.metric"></a>

```typescript
public readonly metric: MetricIdentifierV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ObjectMetricSourceV2.property.target"></a>

```typescript
public readonly target: MetricTargetV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ObjectReference <a name="ObjectReference" id="cdk8s-plus-28.k8s.ObjectReference"></a>

ObjectReference contains enough information to let you inspect or modify the referred object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const objectReference: k8s.ObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.apiVersion">apiVersion</a></code> | <code>string</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.fieldPath">fieldPath</a></code> | <code>string</code> | If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.kind">kind</a></code> | <code>string</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.namespace">namespace</a></code> | <code>string</code> | Namespace of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.resourceVersion">resourceVersion</a></code> | <code>string</code> | Specific resourceVersion to which this reference is made, if any. |
| <code><a href="#cdk8s-plus-28.k8s.ObjectReference.property.uid">uid</a></code> | <code>string</code> | UID of the referent. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.ObjectReference.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

API version of the referent.

---

##### `fieldPath`<sup>Optional</sup> <a name="fieldPath" id="cdk8s-plus-28.k8s.ObjectReference.property.fieldPath"></a>

```typescript
public readonly fieldPath: string;
```

- *Type:* string

If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ObjectReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind of the referent.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ObjectReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

---

##### `resourceVersion`<sup>Optional</sup> <a name="resourceVersion" id="cdk8s-plus-28.k8s.ObjectReference.property.resourceVersion"></a>

```typescript
public readonly resourceVersion: string;
```

- *Type:* string

Specific resourceVersion to which this reference is made, if any.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ObjectReference.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

---

### Overhead <a name="Overhead" id="cdk8s-plus-28.k8s.Overhead"></a>

Overhead structure represents the resource overhead associated with running a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Overhead.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const overhead: k8s.Overhead = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Overhead.property.podFixed">podFixed</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | podFixed represents the fixed resource overhead associated with running a pod. |

---

##### `podFixed`<sup>Optional</sup> <a name="podFixed" id="cdk8s-plus-28.k8s.Overhead.property.podFixed"></a>

```typescript
public readonly podFixed: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

podFixed represents the fixed resource overhead associated with running a pod.

---

### OwnerReference <a name="OwnerReference" id="cdk8s-plus-28.k8s.OwnerReference"></a>

OwnerReference contains enough information to let you identify an owning object.

An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.OwnerReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ownerReference: k8s.OwnerReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.apiVersion">apiVersion</a></code> | <code>string</code> | API version of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.kind">kind</a></code> | <code>string</code> | Kind of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.uid">uid</a></code> | <code>string</code> | UID of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.blockOwnerDeletion">blockOwnerDeletion</a></code> | <code>boolean</code> | If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. |
| <code><a href="#cdk8s-plus-28.k8s.OwnerReference.property.controller">controller</a></code> | <code>boolean</code> | If true, this reference points to the managing controller. |

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.OwnerReference.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

API version of the referent.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.OwnerReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind of the referent.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.OwnerReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

---

##### `uid`<sup>Required</sup> <a name="uid" id="cdk8s-plus-28.k8s.OwnerReference.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

##### `blockOwnerDeletion`<sup>Optional</sup> <a name="blockOwnerDeletion" id="cdk8s-plus-28.k8s.OwnerReference.property.blockOwnerDeletion"></a>

```typescript
public readonly blockOwnerDeletion: boolean;
```

- *Type:* boolean
- *Default:* false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.

If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed.

See https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion for how the garbage collector interacts with this field and enforces the foreground deletion. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.

---

##### `controller`<sup>Optional</sup> <a name="controller" id="cdk8s-plus-28.k8s.OwnerReference.property.controller"></a>

```typescript
public readonly controller: boolean;
```

- *Type:* boolean

If true, this reference points to the managing controller.

---

### ParamKindV1Alpha1 <a name="ParamKindV1Alpha1" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1"></a>

ParamKind is a tuple of Group Kind and Version.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const paramKindV1Alpha1: k8s.ParamKindV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.apiVersion">apiVersion</a></code> | <code>string</code> | APIVersion is the API group version the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.kind">kind</a></code> | <code>string</code> | Kind is the API kind the resources belong to. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

APIVersion is the API group version the resources belong to.

In format of "group/version". Required.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ParamKindV1Alpha1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the API kind the resources belong to.

Required.

---

### ParamKindV1Beta1 <a name="ParamKindV1Beta1" id="cdk8s-plus-28.k8s.ParamKindV1Beta1"></a>

ParamKind is a tuple of Group Kind and Version.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const paramKindV1Beta1: k8s.ParamKindV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Beta1.property.apiVersion">apiVersion</a></code> | <code>string</code> | APIVersion is the API group version the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.ParamKindV1Beta1.property.kind">kind</a></code> | <code>string</code> | Kind is the API kind the resources belong to. |

---

##### `apiVersion`<sup>Optional</sup> <a name="apiVersion" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

APIVersion is the API group version the resources belong to.

In format of "group/version". Required.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.ParamKindV1Beta1.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the API kind the resources belong to.

Required.

---

### ParamRefV1Alpha1 <a name="ParamRefV1Alpha1" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1"></a>

ParamRef describes how to locate the params to be used as input to expressions of rules applied by a policy binding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const paramRefV1Alpha1: k8s.ParamRefV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.name">name</a></code> | <code>string</code> | `name` is the name of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.namespace">namespace</a></code> | <code>string</code> | namespace is the namespace of the referenced resource. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.parameterNotFoundAction">parameterNotFoundAction</a></code> | <code>string</code> | `parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | selector can be used to match multiple param objects based on their labels. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of the resource being referenced.

`name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

namespace is the namespace of the referenced resource.

Allows limiting the search for params to a specific namespace. Applies to both `name` and `selector` fields.

A per-namespace parameter may be used by specifying a namespace-scoped `paramKind` in the policy and leaving this field empty.

- If `paramKind` is cluster-scoped, this field MUST be unset. Setting this field results in a configuration error.

- If `paramKind` is namespace-scoped, the namespace of the object being evaluated for admission will be used when this field is left unset. Take care that if this is left empty the binding must not match any cluster-scoped resources, which will result in an error.

---

##### `parameterNotFoundAction`<sup>Optional</sup> <a name="parameterNotFoundAction" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.parameterNotFoundAction"></a>

```typescript
public readonly parameterNotFoundAction: string;
```

- *Type:* string
- *Default:* Deny`

`parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding.

If the value is set to `Allow`, then no matched parameters will be treated as successful validation by the binding. If set to `Deny`, then no matched parameters will be subject to the `failurePolicy` of the policy.

Allowed values are `Allow` or `Deny` Default to `Deny`

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ParamRefV1Alpha1.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

selector can be used to match multiple param objects based on their labels.

Supply selector: {} to match all resources of the ParamKind.

If multiple params are found, they are all evaluated with the policy expressions and the results are ANDed together.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

### ParamRefV1Beta1 <a name="ParamRefV1Beta1" id="cdk8s-plus-28.k8s.ParamRefV1Beta1"></a>

ParamRef describes how to locate the params to be used as input to expressions of rules applied by a policy binding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const paramRefV1Beta1: k8s.ParamRefV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.name">name</a></code> | <code>string</code> | name is the name of the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.namespace">namespace</a></code> | <code>string</code> | namespace is the namespace of the referenced resource. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.parameterNotFoundAction">parameterNotFoundAction</a></code> | <code>string</code> | `parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding. |
| <code><a href="#cdk8s-plus-28.k8s.ParamRefV1Beta1.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | selector can be used to match multiple param objects based on their labels. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the resource being referenced.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

A single parameter used for all admission requests can be configured by setting the `name` field, leaving `selector` blank, and setting namespace if `paramKind` is namespace-scoped.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

namespace is the namespace of the referenced resource.

Allows limiting the search for params to a specific namespace. Applies to both `name` and `selector` fields.

A per-namespace parameter may be used by specifying a namespace-scoped `paramKind` in the policy and leaving this field empty.

- If `paramKind` is cluster-scoped, this field MUST be unset. Setting this field results in a configuration error.

- If `paramKind` is namespace-scoped, the namespace of the object being evaluated for admission will be used when this field is left unset. Take care that if this is left empty the binding must not match any cluster-scoped resources, which will result in an error.

---

##### `parameterNotFoundAction`<sup>Optional</sup> <a name="parameterNotFoundAction" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.parameterNotFoundAction"></a>

```typescript
public readonly parameterNotFoundAction: string;
```

- *Type:* string

`parameterNotFoundAction` controls the behavior of the binding when the resource exists, and name or selector is valid, but there are no parameters matched by the binding.

If the value is set to `Allow`, then no matched parameters will be treated as successful validation by the binding. If set to `Deny`, then no matched parameters will be subject to the `failurePolicy` of the policy.

Allowed values are `Allow` or `Deny`

Required

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ParamRefV1Beta1.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

selector can be used to match multiple param objects based on their labels.

Supply selector: {} to match all resources of the ParamKind.

If multiple params are found, they are all evaluated with the policy expressions and the results are ANDed together.

One of `name` or `selector` must be set, but `name` and `selector` are mutually exclusive properties. If one is set, the other must be unset.

---

### ParentReferenceV1Alpha1 <a name="ParentReferenceV1Alpha1" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1"></a>

ParentReference describes a reference to a parent object.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const parentReferenceV1Alpha1: k8s.ParentReferenceV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.group">group</a></code> | <code>string</code> | Group is the group of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.name">name</a></code> | <code>string</code> | Name is the name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.namespace">namespace</a></code> | <code>string</code> | Namespace is the namespace of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.resource">resource</a></code> | <code>string</code> | Resource is the resource of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.uid">uid</a></code> | <code>string</code> | UID is the uid of the object being referenced. |

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string

Group is the group of the object being referenced.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of the object being referenced.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace is the namespace of the object being referenced.

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.resource"></a>

```typescript
public readonly resource: string;
```

- *Type:* string

Resource is the resource of the object being referenced.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.ParentReferenceV1Alpha1.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID is the uid of the object being referenced.

---

### PathMapping <a name="PathMapping" id="cdk8s-plus-28.PathMapping"></a>

Maps a string key to a path within a volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PathMapping.Initializer"></a>

```typescript
import { PathMapping } from 'cdk8s-plus-28'

const pathMapping: PathMapping = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PathMapping.property.path">path</a></code> | <code>string</code> | The relative path of the file to map the key to. |
| <code><a href="#cdk8s-plus-28.PathMapping.property.mode">mode</a></code> | <code>number</code> | Optional: mode bits to use on this file, must be a value between 0 and 0777. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.PathMapping.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

The relative path of the file to map the key to.

May not be an absolute
path. May not contain the path element '..'. May not start with the string
'..'.

---

##### `mode`<sup>Optional</sup> <a name="mode" id="cdk8s-plus-28.PathMapping.property.mode"></a>

```typescript
public readonly mode: number;
```

- *Type:* number

Optional: mode bits to use on this file, must be a value between 0 and 0777.

If not specified, the volume defaultMode will be used. This might be
in conflict with other options that affect the file mode, like fsGroup, and
the result can be other mode bits set.

---

### PersistentVolumeClaimProps <a name="PersistentVolumeClaimProps" id="cdk8s-plus-28.PersistentVolumeClaimProps"></a>

Properties for `PersistentVolumeClaim`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeClaimProps.Initializer"></a>

```typescript
import { PersistentVolumeClaimProps } from 'cdk8s-plus-28'

const persistentVolumeClaimProps: PersistentVolumeClaimProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Contains the access modes the volume should support. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | Minimum storage size the volume should have. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a></code> | The PersistentVolume backing this claim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimProps.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]
- *Default:* No access modes requirement.

Contains the access modes the volume should support.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size
- *Default:* No storage requirement.

Minimum storage size the volume should have.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string
- *Default:* Not set.

Name of the StorageClass required by the claim. When this property is not set, the behavior is as follows:.

If the admission plugin is turned on, the storage class marked as default will be used.
- If the admission plugin is turned off, the pvc can only be bound to volumes without a storage class.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1](https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1)

---

##### `volume`<sup>Optional</sup> <a name="volume" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.volume"></a>

```typescript
public readonly volume: IPersistentVolume;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>
- *Default:* No specific volume binding.

The PersistentVolume backing this claim.

The control plane still checks that storage class, access modes,
and requested storage size on the volume are valid.

Note that in order to guarantee a proper binding, the volume should
also define a `claimRef` referring to this claim. Otherwise, the volume may be
claimed be other pvc's before it gets a chance to bind to this one.

If the volume is managed (i.e not imported), you can use `pv.claim()` to easily
create a bi-directional bounded claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#binding.)

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.PersistentVolumeClaimProps.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

### PersistentVolumeClaimSpec <a name="PersistentVolumeClaimSpec" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec"></a>

PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const persistentVolumeClaimSpec: k8s.PersistentVolumeClaimSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.accessModes">accessModes</a></code> | <code>string[]</code> | accessModes contains the desired access modes the volume should have. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSource">dataSource</a></code> | <code>cdk8s-plus-28.k8s.TypedLocalObjectReference</code> | dataSource field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. When the AnyVolumeDataSource feature gate is enabled, dataSource contents will be copied to dataSourceRef, and dataSourceRef contents will be copied to dataSource when dataSourceRef.namespace is not specified. If the namespace is specified, then dataSourceRef will not be copied to dataSource. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSourceRef">dataSourceRef</a></code> | <code>cdk8s-plus-28.k8s.TypedObjectReference</code> | dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.resources">resources</a></code> | <code>cdk8s-plus-28.k8s.ResourceRequirements</code> | resources represents the minimum resources the volume should have. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | selector is a label query over volumes to consider for binding. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.storageClassName">storageClassName</a></code> | <code>string</code> | storageClassName is the name of the StorageClass required by the claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeMode">volumeMode</a></code> | <code>string</code> | volumeMode defines what type of volume is required by the claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeName">volumeName</a></code> | <code>string</code> | volumeName is the binding reference to the PersistentVolume backing this claim. |

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.accessModes"></a>

```typescript
public readonly accessModes: string[];
```

- *Type:* string[]

accessModes contains the desired access modes the volume should have.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1

---

##### `dataSource`<sup>Optional</sup> <a name="dataSource" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSource"></a>

```typescript
public readonly dataSource: TypedLocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.TypedLocalObjectReference

dataSource field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. When the AnyVolumeDataSource feature gate is enabled, dataSource contents will be copied to dataSourceRef, and dataSourceRef contents will be copied to dataSource when dataSourceRef.namespace is not specified. If the namespace is specified, then dataSourceRef will not be copied to dataSource.

---

##### `dataSourceRef`<sup>Optional</sup> <a name="dataSourceRef" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.dataSourceRef"></a>

```typescript
public readonly dataSourceRef: TypedObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.TypedObjectReference

dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired.

This may be any object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the dataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, when namespace isn't specified in dataSourceRef, both fields (dataSource and dataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. When namespace is specified in dataSourceRef, dataSource isn't set to the same value and must be empty. There are three important differences between dataSource and dataSourceRef: * While dataSource only allows two specific types of objects, dataSourceRef
allows any non-core object, as well as PersistentVolumeClaim objects.
* While dataSource ignores disallowed values (dropping them), dataSourceRef
preserves all values, and generates an error if a disallowed value is
specified.
* While dataSource only allows local objects, dataSourceRef allows objects
in any namespaces.
(Beta) Using this field requires the AnyVolumeDataSource feature gate to be enabled. (Alpha) Using the namespace field of dataSourceRef requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.resources"></a>

```typescript
public readonly resources: ResourceRequirements;
```

- *Type:* cdk8s-plus-28.k8s.ResourceRequirements

resources represents the minimum resources the volume should have.

If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

selector is a label query over volumes to consider for binding.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

storageClassName is the name of the StorageClass required by the claim.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeMode"></a>

```typescript
public readonly volumeMode: string;
```

- *Type:* string

volumeMode defines what type of volume is required by the claim.

Value of Filesystem is implied when not included in claim spec.

---

##### `volumeName`<sup>Optional</sup> <a name="volumeName" id="cdk8s-plus-28.k8s.PersistentVolumeClaimSpec.property.volumeName"></a>

```typescript
public readonly volumeName: string;
```

- *Type:* string

volumeName is the binding reference to the PersistentVolume backing this claim.

---

### PersistentVolumeClaimTemplate <a name="PersistentVolumeClaimTemplate" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate"></a>

PersistentVolumeClaimTemplate is used to produce PersistentVolumeClaim objects as part of an EphemeralVolumeSource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const persistentVolumeClaimTemplate: k8s.PersistentVolumeClaimTemplate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeClaimSpec</code> | The specification for the PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | May contain labels and annotations that will be copied into the PVC when creating it. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.spec"></a>

```typescript
public readonly spec: PersistentVolumeClaimSpec;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeClaimSpec

The specification for the PersistentVolumeClaim.

The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.PersistentVolumeClaimTemplate.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

May contain labels and annotations that will be copied into the PVC when creating it.

No other fields are allowed and will be rejected during validation.

---

### PersistentVolumeClaimVolumeOptions <a name="PersistentVolumeClaimVolumeOptions" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions"></a>

Options for a PersistentVolumeClaim-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.Initializer"></a>

```typescript
import { PersistentVolumeClaimVolumeOptions } from 'cdk8s-plus-28'

const persistentVolumeClaimVolumeOptions: PersistentVolumeClaimVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.readOnly">readOnly</a></code> | <code>boolean</code> | Will force the ReadOnly setting in VolumeMounts. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* Derived from the PVC name.

The volume name.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.PersistentVolumeClaimVolumeOptions.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Will force the ReadOnly setting in VolumeMounts.

---

### PersistentVolumeClaimVolumeSource <a name="PersistentVolumeClaimVolumeSource" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource"></a>

PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace.

This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const persistentVolumeClaimVolumeSource: k8s.PersistentVolumeClaimVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.claimName">claimName</a></code> | <code>string</code> | claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly Will force the ReadOnly setting in VolumeMounts. |

---

##### `claimName`<sup>Required</sup> <a name="claimName" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.claimName"></a>

```typescript
public readonly claimName: string;
```

- *Type:* string

claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly Will force the ReadOnly setting in VolumeMounts.

Default false.

---

### PersistentVolumeProps <a name="PersistentVolumeProps" id="cdk8s-plus-28.PersistentVolumeProps"></a>

Properties for `PersistentVolume`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PersistentVolumeProps.Initializer"></a>

```typescript
import { PersistentVolumeProps } from 'cdk8s-plus-28'

const persistentVolumeProps: PersistentVolumeProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.accessModes">accessModes</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]</code> | Contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.claim">claim</a></code> | <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a></code> | Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.reclaimPolicy">reclaimPolicy</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a></code> | When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.storage">storage</a></code> | <code>cdk8s.Size</code> | What is the storage capacity of this volume. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.storageClassName">storageClassName</a></code> | <code>string</code> | Name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeProps.property.volumeMode">volumeMode</a></code> | <code><a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a></code> | Defines what type of volume is required by the claim. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PersistentVolumeProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.PersistentVolumeProps.property.accessModes"></a>

```typescript
public readonly accessModes: PersistentVolumeAccessMode[];
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeAccessMode">PersistentVolumeAccessMode</a>[]
- *Default:* No access modes.

Contains all ways the volume can be mounted.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes](https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes)

---

##### `claim`<sup>Optional</sup> <a name="claim" id="cdk8s-plus-28.PersistentVolumeProps.property.claim"></a>

```typescript
public readonly claim: IPersistentVolumeClaim;
```

- *Type:* <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>
- *Default:* Not bound to a specific claim.

Part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding](https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding)

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.PersistentVolumeProps.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]
- *Default:* No options.

A list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options](https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options)

---

##### `reclaimPolicy`<sup>Optional</sup> <a name="reclaimPolicy" id="cdk8s-plus-28.PersistentVolumeProps.property.reclaimPolicy"></a>

```typescript
public readonly reclaimPolicy: PersistentVolumeReclaimPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy">PersistentVolumeReclaimPolicy</a>
- *Default:* PersistentVolumeReclaimPolicy.RETAIN

When a user is done with their volume, they can delete the PVC objects from the API that allows reclamation of the resource.

The reclaim policy tells the cluster what to do with
the volume after it has been released of its claim.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming](https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming)

---

##### `storage`<sup>Optional</sup> <a name="storage" id="cdk8s-plus-28.PersistentVolumeProps.property.storage"></a>

```typescript
public readonly storage: Size;
```

- *Type:* cdk8s.Size
- *Default:* No specified.

What is the storage capacity of this volume.

> [https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources](https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources)

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.PersistentVolumeProps.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string
- *Default:* Volume does not belong to any storage class.

Name of StorageClass to which this persistent volume belongs.

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.PersistentVolumeProps.property.volumeMode"></a>

```typescript
public readonly volumeMode: PersistentVolumeMode;
```

- *Type:* <a href="#cdk8s-plus-28.PersistentVolumeMode">PersistentVolumeMode</a>
- *Default:* VolumeMode.FILE_SYSTEM

Defines what type of volume is required by the claim.

---

### PersistentVolumeSpec <a name="PersistentVolumeSpec" id="cdk8s-plus-28.k8s.PersistentVolumeSpec"></a>

PersistentVolumeSpec is the specification of a persistent volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const persistentVolumeSpec: k8s.PersistentVolumeSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.accessModes">accessModes</a></code> | <code>string[]</code> | accessModes contains all ways the volume can be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.awsElasticBlockStore">awsElasticBlockStore</a></code> | <code>cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource</code> | awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureDisk">azureDisk</a></code> | <code>cdk8s-plus-28.k8s.AzureDiskVolumeSource</code> | azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureFile">azureFile</a></code> | <code>cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource</code> | azureFile represents an Azure File Service mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.capacity">capacity</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | capacity is the description of the persistent volume's resources and capacity. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cephfs">cephfs</a></code> | <code>cdk8s-plus-28.k8s.CephFsPersistentVolumeSource</code> | cephFS represents a Ceph FS mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cinder">cinder</a></code> | <code>cdk8s-plus-28.k8s.CinderPersistentVolumeSource</code> | cinder represents a cinder volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.claimRef">claimRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | claimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.csi">csi</a></code> | <code>cdk8s-plus-28.k8s.CsiPersistentVolumeSource</code> | csi represents storage that is handled by an external CSI driver (Beta feature). |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.fc">fc</a></code> | <code>cdk8s-plus-28.k8s.FcVolumeSource</code> | fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flexVolume">flexVolume</a></code> | <code>cdk8s-plus-28.k8s.FlexPersistentVolumeSource</code> | flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flocker">flocker</a></code> | <code>cdk8s-plus-28.k8s.FlockerVolumeSource</code> | flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.gcePersistentDisk">gcePersistentDisk</a></code> | <code>cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource</code> | gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.glusterfs">glusterfs</a></code> | <code>cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource</code> | glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.hostPath">hostPath</a></code> | <code>cdk8s-plus-28.k8s.HostPathVolumeSource</code> | hostPath represents a directory on the host. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.iscsi">iscsi</a></code> | <code>cdk8s-plus-28.k8s.IscsiPersistentVolumeSource</code> | iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.local">local</a></code> | <code>cdk8s-plus-28.k8s.LocalVolumeSource</code> | local represents directly-attached storage with node affinity. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.mountOptions">mountOptions</a></code> | <code>string[]</code> | mountOptions is the list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nfs">nfs</a></code> | <code>cdk8s-plus-28.k8s.NfsVolumeSource</code> | nfs represents an NFS mount on the host. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nodeAffinity">nodeAffinity</a></code> | <code>cdk8s-plus-28.k8s.VolumeNodeAffinity</code> | nodeAffinity defines constraints that limit what nodes this volume can be accessed from. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.persistentVolumeReclaimPolicy">persistentVolumeReclaimPolicy</a></code> | <code>string</code> | persistentVolumeReclaimPolicy defines what happens to a persistent volume when released from its claim. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.photonPersistentDisk">photonPersistentDisk</a></code> | <code>cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource</code> | photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.portworxVolume">portworxVolume</a></code> | <code>cdk8s-plus-28.k8s.PortworxVolumeSource</code> | portworxVolume represents a portworx volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.quobyte">quobyte</a></code> | <code>cdk8s-plus-28.k8s.QuobyteVolumeSource</code> | quobyte represents a Quobyte mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.rbd">rbd</a></code> | <code>cdk8s-plus-28.k8s.RbdPersistentVolumeSource</code> | rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.scaleIo">scaleIo</a></code> | <code>cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource</code> | scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageClassName">storageClassName</a></code> | <code>string</code> | storageClassName is the name of StorageClass to which this persistent volume belongs. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageos">storageos</a></code> | <code>cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource</code> | storageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://examples.k8s.io/volumes/storageos/README.md. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.volumeMode">volumeMode</a></code> | <code>string</code> | volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. |
| <code><a href="#cdk8s-plus-28.k8s.PersistentVolumeSpec.property.vsphereVolume">vsphereVolume</a></code> | <code>cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource</code> | vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine. |

---

##### `accessModes`<sup>Optional</sup> <a name="accessModes" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.accessModes"></a>

```typescript
public readonly accessModes: string[];
```

- *Type:* string[]

accessModes contains all ways the volume can be mounted.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes

---

##### `awsElasticBlockStore`<sup>Optional</sup> <a name="awsElasticBlockStore" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.awsElasticBlockStore"></a>

```typescript
public readonly awsElasticBlockStore: AwsElasticBlockStoreVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource

awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `azureDisk`<sup>Optional</sup> <a name="azureDisk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureDisk"></a>

```typescript
public readonly azureDisk: AzureDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AzureDiskVolumeSource

azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

---

##### `azureFile`<sup>Optional</sup> <a name="azureFile" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.azureFile"></a>

```typescript
public readonly azureFile: AzureFilePersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AzureFilePersistentVolumeSource

azureFile represents an Azure File Service mount on the host and bind mount to the pod.

---

##### `capacity`<sup>Optional</sup> <a name="capacity" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.capacity"></a>

```typescript
public readonly capacity: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

capacity is the description of the persistent volume's resources and capacity.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity

---

##### `cephfs`<sup>Optional</sup> <a name="cephfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cephfs"></a>

```typescript
public readonly cephfs: CephFsPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CephFsPersistentVolumeSource

cephFS represents a Ceph FS mount on the host that shares a pod's lifetime.

---

##### `cinder`<sup>Optional</sup> <a name="cinder" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.cinder"></a>

```typescript
public readonly cinder: CinderPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CinderPersistentVolumeSource

cinder represents a cinder volume attached and mounted on kubelets host machine.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `claimRef`<sup>Optional</sup> <a name="claimRef" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.claimRef"></a>

```typescript
public readonly claimRef: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

claimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim.

Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding

---

##### `csi`<sup>Optional</sup> <a name="csi" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.csi"></a>

```typescript
public readonly csi: CsiPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CsiPersistentVolumeSource

csi represents storage that is handled by an external CSI driver (Beta feature).

---

##### `fc`<sup>Optional</sup> <a name="fc" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.fc"></a>

```typescript
public readonly fc: FcVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FcVolumeSource

fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

---

##### `flexVolume`<sup>Optional</sup> <a name="flexVolume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flexVolume"></a>

```typescript
public readonly flexVolume: FlexPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FlexPersistentVolumeSource

flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

---

##### `flocker`<sup>Optional</sup> <a name="flocker" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.flocker"></a>

```typescript
public readonly flocker: FlockerVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FlockerVolumeSource

flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage.

This depends on the Flocker control service being running

---

##### `gcePersistentDisk`<sup>Optional</sup> <a name="gcePersistentDisk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.gcePersistentDisk"></a>

```typescript
public readonly gcePersistentDisk: GcePersistentDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource

gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `glusterfs`<sup>Optional</sup> <a name="glusterfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.glusterfs"></a>

```typescript
public readonly glusterfs: GlusterfsPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.GlusterfsPersistentVolumeSource

glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod.

Provisioned by an admin. More info: https://examples.k8s.io/volumes/glusterfs/README.md

---

##### `hostPath`<sup>Optional</sup> <a name="hostPath" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.hostPath"></a>

```typescript
public readonly hostPath: HostPathVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.HostPathVolumeSource

hostPath represents a directory on the host.

Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `iscsi`<sup>Optional</sup> <a name="iscsi" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.iscsi"></a>

```typescript
public readonly iscsi: IscsiPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.IscsiPersistentVolumeSource

iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

Provisioned by an admin.

---

##### `local`<sup>Optional</sup> <a name="local" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.local"></a>

```typescript
public readonly local: LocalVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.LocalVolumeSource

local represents directly-attached storage with node affinity.

---

##### `mountOptions`<sup>Optional</sup> <a name="mountOptions" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.mountOptions"></a>

```typescript
public readonly mountOptions: string[];
```

- *Type:* string[]

mountOptions is the list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options.

---

##### `nfs`<sup>Optional</sup> <a name="nfs" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nfs"></a>

```typescript
public readonly nfs: NfsVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.NfsVolumeSource

nfs represents an NFS mount on the host.

Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

---

##### `nodeAffinity`<sup>Optional</sup> <a name="nodeAffinity" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.nodeAffinity"></a>

```typescript
public readonly nodeAffinity: VolumeNodeAffinity;
```

- *Type:* cdk8s-plus-28.k8s.VolumeNodeAffinity

nodeAffinity defines constraints that limit what nodes this volume can be accessed from.

This field influences the scheduling of pods that use this volume.

---

##### `persistentVolumeReclaimPolicy`<sup>Optional</sup> <a name="persistentVolumeReclaimPolicy" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.persistentVolumeReclaimPolicy"></a>

```typescript
public readonly persistentVolumeReclaimPolicy: string;
```

- *Type:* string

persistentVolumeReclaimPolicy defines what happens to a persistent volume when released from its claim.

Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming

---

##### `photonPersistentDisk`<sup>Optional</sup> <a name="photonPersistentDisk" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.photonPersistentDisk"></a>

```typescript
public readonly photonPersistentDisk: PhotonPersistentDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource

photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine.

---

##### `portworxVolume`<sup>Optional</sup> <a name="portworxVolume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.portworxVolume"></a>

```typescript
public readonly portworxVolume: PortworxVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.PortworxVolumeSource

portworxVolume represents a portworx volume attached and mounted on kubelets host machine.

---

##### `quobyte`<sup>Optional</sup> <a name="quobyte" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.quobyte"></a>

```typescript
public readonly quobyte: QuobyteVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.QuobyteVolumeSource

quobyte represents a Quobyte mount on the host that shares a pod's lifetime.

---

##### `rbd`<sup>Optional</sup> <a name="rbd" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.rbd"></a>

```typescript
public readonly rbd: RbdPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.RbdPersistentVolumeSource

rbd represents a Rados Block Device mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/rbd/README.md

---

##### `scaleIo`<sup>Optional</sup> <a name="scaleIo" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.scaleIo"></a>

```typescript
public readonly scaleIo: ScaleIoPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource

scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

---

##### `storageClassName`<sup>Optional</sup> <a name="storageClassName" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageClassName"></a>

```typescript
public readonly storageClassName: string;
```

- *Type:* string

storageClassName is the name of StorageClass to which this persistent volume belongs.

Empty value means that this volume does not belong to any StorageClass.

---

##### `storageos`<sup>Optional</sup> <a name="storageos" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.storageos"></a>

```typescript
public readonly storageos: StorageOsPersistentVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource

storageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://examples.k8s.io/volumes/storageos/README.md.

---

##### `volumeMode`<sup>Optional</sup> <a name="volumeMode" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.volumeMode"></a>

```typescript
public readonly volumeMode: string;
```

- *Type:* string

volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state.

Value of Filesystem is implied when not included in spec.

---

##### `vsphereVolume`<sup>Optional</sup> <a name="vsphereVolume" id="cdk8s-plus-28.k8s.PersistentVolumeSpec.property.vsphereVolume"></a>

```typescript
public readonly vsphereVolume: VsphereVirtualDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource

vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine.

---

### PhotonPersistentDiskVolumeSource <a name="PhotonPersistentDiskVolumeSource" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource"></a>

Represents a Photon Controller persistent disk resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const photonPersistentDiskVolumeSource: k8s.PhotonPersistentDiskVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.pdId">pdId</a></code> | <code>string</code> | pdID is the ID that identifies Photon Controller persistent disk. |
| <code><a href="#cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |

---

##### `pdId`<sup>Required</sup> <a name="pdId" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.pdId"></a>

```typescript
public readonly pdId: string;
```

- *Type:* string

pdID is the ID that identifies Photon Controller persistent disk.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

### PodAffinity <a name="PodAffinity" id="cdk8s-plus-28.k8s.PodAffinity"></a>

Pod affinity is a group of inter pod affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAffinity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podAffinity: k8s.PodAffinity = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.WeightedPodAffinityTerm[]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">requiredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.PodAffinityTerm[]</code> | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="preferredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.PodAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly preferredDuringSchedulingIgnoredDuringExecution: WeightedPodAffinityTerm[];
```

- *Type:* cdk8s-plus-28.k8s.WeightedPodAffinityTerm[]

The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

---

##### `requiredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="requiredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.PodAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly requiredDuringSchedulingIgnoredDuringExecution: PodAffinityTerm[];
```

- *Type:* cdk8s-plus-28.k8s.PodAffinityTerm[]

If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

---

### PodAffinityTerm <a name="PodAffinityTerm" id="cdk8s-plus-28.k8s.PodAffinityTerm"></a>

Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAffinityTerm.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podAffinityTerm: k8s.PodAffinityTerm = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.topologyKey">topologyKey</a></code> | <code>string</code> | This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.labelSelector">labelSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | A label query over a set of resources, in this case pods. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaces">namespaces</a></code> | <code>string[]</code> | namespaces specifies a static list of namespace names that the term applies to. |
| <code><a href="#cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | A label query over the set of namespaces that the term applies to. |

---

##### `topologyKey`<sup>Required</sup> <a name="topologyKey" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.topologyKey"></a>

```typescript
public readonly topologyKey: string;
```

- *Type:* string

This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running.

Empty topologyKey is not allowed.

---

##### `labelSelector`<sup>Optional</sup> <a name="labelSelector" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

A label query over a set of resources, in this case pods.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaces"></a>

```typescript
public readonly namespaces: string[];
```

- *Type:* string[]

namespaces specifies a static list of namespace names that the term applies to.

The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace".

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.PodAffinityTerm.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

A label query over the set of namespaces that the term applies to.

The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces.

---

### PodAntiAffinity <a name="PodAntiAffinity" id="cdk8s-plus-28.k8s.PodAntiAffinity"></a>

Pod anti affinity is a group of inter pod anti affinity scheduling rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodAntiAffinity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podAntiAffinity: k8s.PodAntiAffinity = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodAntiAffinity.property.preferredDuringSchedulingIgnoredDuringExecution">preferredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.WeightedPodAffinityTerm[]</code> | The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. |
| <code><a href="#cdk8s-plus-28.k8s.PodAntiAffinity.property.requiredDuringSchedulingIgnoredDuringExecution">requiredDuringSchedulingIgnoredDuringExecution</a></code> | <code>cdk8s-plus-28.k8s.PodAffinityTerm[]</code> | If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. |

---

##### `preferredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="preferredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.PodAntiAffinity.property.preferredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly preferredDuringSchedulingIgnoredDuringExecution: WeightedPodAffinityTerm[];
```

- *Type:* cdk8s-plus-28.k8s.WeightedPodAffinityTerm[]

The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions.

The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

---

##### `requiredDuringSchedulingIgnoredDuringExecution`<sup>Optional</sup> <a name="requiredDuringSchedulingIgnoredDuringExecution" id="cdk8s-plus-28.k8s.PodAntiAffinity.property.requiredDuringSchedulingIgnoredDuringExecution"></a>

```typescript
public readonly requiredDuringSchedulingIgnoredDuringExecution: PodAffinityTerm[];
```

- *Type:* cdk8s-plus-28.k8s.PodAffinityTerm[]

If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node.

If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

---

### PodConnectionsAllowFromOptions <a name="PodConnectionsAllowFromOptions" id="cdk8s-plus-28.PodConnectionsAllowFromOptions"></a>

Options for `PodConnections.allowFrom`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.Initializer"></a>

```typescript
import { PodConnectionsAllowFromOptions } from 'cdk8s-plus-28'

const podConnectionsAllowFromOptions: PodConnectionsAllowFromOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowFromOptions.property.isolation">isolation</a></code> | <code><a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a></code> | Which isolation should be applied to establish the connection. |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowFromOptions.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]</code> | Ports to allow incoming traffic to. |

---

##### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.property.isolation"></a>

```typescript
public readonly isolation: PodConnectionsIsolation;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnectionsAllowFromOptions.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]
- *Default:* The pod ports.

Ports to allow incoming traffic to.

---

### PodConnectionsAllowToOptions <a name="PodConnectionsAllowToOptions" id="cdk8s-plus-28.PodConnectionsAllowToOptions"></a>

Options for `PodConnections.allowTo`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodConnectionsAllowToOptions.Initializer"></a>

```typescript
import { PodConnectionsAllowToOptions } from 'cdk8s-plus-28'

const podConnectionsAllowToOptions: PodConnectionsAllowToOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowToOptions.property.isolation">isolation</a></code> | <code><a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a></code> | Which isolation should be applied to establish the connection. |
| <code><a href="#cdk8s-plus-28.PodConnectionsAllowToOptions.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]</code> | Ports to allow outgoing traffic to. |

---

##### `isolation`<sup>Optional</sup> <a name="isolation" id="cdk8s-plus-28.PodConnectionsAllowToOptions.property.isolation"></a>

```typescript
public readonly isolation: PodConnectionsIsolation;
```

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsIsolation">PodConnectionsIsolation</a>
- *Default:* unset, isolates both the pod and the peer.

Which isolation should be applied to establish the connection.

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.PodConnectionsAllowToOptions.property.ports"></a>

```typescript
public readonly ports: NetworkPolicyPort[];
```

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPort">NetworkPolicyPort</a>[]
- *Default:* If the peer is a managed pod, take its ports. Otherwise, all ports are allowed.

Ports to allow outgoing traffic to.

---

### PodDisruptionBudgetSpec <a name="PodDisruptionBudgetSpec" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec"></a>

PodDisruptionBudgetSpec is a description of a PodDisruptionBudget.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podDisruptionBudgetSpec: k8s.PodDisruptionBudgetSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.maxUnavailable">maxUnavailable</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | An eviction is allowed if at most "maxUnavailable" pods selected by "selector" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with "minAvailable". |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.minAvailable">minAvailable</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | An eviction is allowed if at least "minAvailable" pods selected by "selector" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying "100%". |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | Label query over pods whose evictions are managed by the disruption budget. |
| <code><a href="#cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.unhealthyPodEvictionPolicy">unhealthyPodEvictionPolicy</a></code> | <code>string</code> | UnhealthyPodEvictionPolicy defines the criteria for when unhealthy pods should be considered for eviction. |

---

##### `maxUnavailable`<sup>Optional</sup> <a name="maxUnavailable" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

An eviction is allowed if at most "maxUnavailable" pods selected by "selector" are unavailable after the eviction, i.e. even in absence of the evicted pod. For example, one can prevent all voluntary evictions by specifying 0. This is a mutually exclusive setting with "minAvailable".

---

##### `minAvailable`<sup>Optional</sup> <a name="minAvailable" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.minAvailable"></a>

```typescript
public readonly minAvailable: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

An eviction is allowed if at least "minAvailable" pods selected by "selector" will still be available after the eviction, i.e. even in the absence of the evicted pod.  So for example you can prevent all voluntary evictions by specifying "100%".

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

Label query over pods whose evictions are managed by the disruption budget.

A null selector will match no pods, while an empty ({}) selector will select all pods within the namespace.

---

##### `unhealthyPodEvictionPolicy`<sup>Optional</sup> <a name="unhealthyPodEvictionPolicy" id="cdk8s-plus-28.k8s.PodDisruptionBudgetSpec.property.unhealthyPodEvictionPolicy"></a>

```typescript
public readonly unhealthyPodEvictionPolicy: string;
```

- *Type:* string

UnhealthyPodEvictionPolicy defines the criteria for when unhealthy pods should be considered for eviction.

Current implementation considers healthy pods, as pods that have status.conditions item with type="Ready",status="True".

Valid policies are IfHealthyBudget and AlwaysAllow. If no policy is specified, the default behavior will be used, which corresponds to the IfHealthyBudget policy.

IfHealthyBudget policy means that running pods (status.phase="Running"), but not yet healthy can be evicted only if the guarded application is not disrupted (status.currentHealthy is at least equal to status.desiredHealthy). Healthy pods will be subject to the PDB for eviction.

AlwaysAllow policy means that all running pods (status.phase="Running"), but not yet healthy are considered disrupted and can be evicted regardless of whether the criteria in a PDB is met. This means perspective running pods of a disrupted application might not get a chance to become healthy. Healthy pods will be subject to the PDB for eviction.

Additional policies may be added in the future. Clients making eviction decisions should disallow eviction of unhealthy pods if they encounter an unrecognized policy in this field.

This field is beta-level. The eviction API uses this field when the feature gate PDBUnhealthyPodEvictionPolicy is enabled (enabled by default).

---

### PodDnsConfig <a name="PodDnsConfig" id="cdk8s-plus-28.k8s.PodDnsConfig"></a>

PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDnsConfig.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podDnsConfig: k8s.PodDnsConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.nameservers">nameservers</a></code> | <code>string[]</code> | A list of DNS name server IP addresses. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.options">options</a></code> | <code>cdk8s-plus-28.k8s.PodDnsConfigOption[]</code> | A list of DNS resolver options. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfig.property.searches">searches</a></code> | <code>string[]</code> | A list of DNS search domains for host-name lookup. |

---

##### `nameservers`<sup>Optional</sup> <a name="nameservers" id="cdk8s-plus-28.k8s.PodDnsConfig.property.nameservers"></a>

```typescript
public readonly nameservers: string[];
```

- *Type:* string[]

A list of DNS name server IP addresses.

This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.k8s.PodDnsConfig.property.options"></a>

```typescript
public readonly options: PodDnsConfigOption[];
```

- *Type:* cdk8s-plus-28.k8s.PodDnsConfigOption[]

A list of DNS resolver options.

This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.

---

##### `searches`<sup>Optional</sup> <a name="searches" id="cdk8s-plus-28.k8s.PodDnsConfig.property.searches"></a>

```typescript
public readonly searches: string[];
```

- *Type:* string[]

A list of DNS search domains for host-name lookup.

This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.

---

### PodDnsConfigOption <a name="PodDnsConfigOption" id="cdk8s-plus-28.k8s.PodDnsConfigOption"></a>

PodDNSConfigOption defines DNS resolver options of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodDnsConfigOption.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podDnsConfigOption: k8s.PodDnsConfigOption = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfigOption.property.name">name</a></code> | <code>string</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.PodDnsConfigOption.property.value">value</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.PodDnsConfigOption.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Required.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.PodDnsConfigOption.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

---

### PodDnsProps <a name="PodDnsProps" id="cdk8s-plus-28.PodDnsProps"></a>

Properties for `PodDns`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodDnsProps.Initializer"></a>

```typescript
import { PodDnsProps } from 'cdk8s-plus-28'

const podDnsProps: PodDnsProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.hostname">hostname</a></code> | <code>string</code> | Specifies the hostname of the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.hostnameAsFQDN">hostnameAsFQDN</a></code> | <code>boolean</code> | If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.nameservers">nameservers</a></code> | <code>string[]</code> | A list of IP addresses that will be used as DNS servers for the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.options">options</a></code> | <code><a href="#cdk8s-plus-28.DnsOption">DnsOption</a>[]</code> | List of objects where each object may have a name property (required) and a value property (optional). |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.policy">policy</a></code> | <code><a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a></code> | Set DNS policy for the pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.searches">searches</a></code> | <code>string[]</code> | A list of DNS search domains for hostname lookup in the Pod. |
| <code><a href="#cdk8s-plus-28.PodDnsProps.property.subdomain">subdomain</a></code> | <code>string</code> | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". |

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.PodDnsProps.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string
- *Default:* Set to a system-defined value.

Specifies the hostname of the Pod.

---

##### `hostnameAsFQDN`<sup>Optional</sup> <a name="hostnameAsFQDN" id="cdk8s-plus-28.PodDnsProps.property.hostnameAsFQDN"></a>

```typescript
public readonly hostnameAsFQDN: boolean;
```

- *Type:* boolean
- *Default:* false

If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).

In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname).
In Windows containers, this means setting the registry value of hostname for the registry
key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN.
If a pod does not have FQDN, this has no effect.

---

##### `nameservers`<sup>Optional</sup> <a name="nameservers" id="cdk8s-plus-28.PodDnsProps.property.nameservers"></a>

```typescript
public readonly nameservers: string[];
```

- *Type:* string[]

A list of IP addresses that will be used as DNS servers for the Pod.

There can be at most 3 IP addresses specified.
When the policy is set to "NONE", the list must contain at least one IP address,
otherwise this property is optional.
The servers listed will be combined to the base nameservers generated from
the specified DNS policy with duplicate addresses removed.

---

##### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodDnsProps.property.options"></a>

```typescript
public readonly options: DnsOption[];
```

- *Type:* <a href="#cdk8s-plus-28.DnsOption">DnsOption</a>[]

List of objects where each object may have a name property (required) and a value property (optional).

The contents in this property
will be merged to the options generated from the specified DNS policy.
Duplicate entries are removed.

---

##### `policy`<sup>Optional</sup> <a name="policy" id="cdk8s-plus-28.PodDnsProps.property.policy"></a>

```typescript
public readonly policy: DnsPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a>
- *Default:* DnsPolicy.CLUSTER_FIRST

Set DNS policy for the pod.

If policy is set to `None`, other configuration must be supplied.

---

##### `searches`<sup>Optional</sup> <a name="searches" id="cdk8s-plus-28.PodDnsProps.property.searches"></a>

```typescript
public readonly searches: string[];
```

- *Type:* string[]

A list of DNS search domains for hostname lookup in the Pod.

When specified, the provided list will be merged into the base
search domain names generated from the chosen DNS policy.
Duplicate domain names are removed.

Kubernetes allows for at most 6 search domains.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.PodDnsProps.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string
- *Default:* No subdomain.

If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>".

---

### PodFailurePolicy <a name="PodFailurePolicy" id="cdk8s-plus-28.k8s.PodFailurePolicy"></a>

PodFailurePolicy describes how failed pods influence the backoffLimit.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podFailurePolicy: k8s.PodFailurePolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicy.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.PodFailurePolicyRule[]</code> | A list of pod failure policy rules. |

---

##### `rules`<sup>Required</sup> <a name="rules" id="cdk8s-plus-28.k8s.PodFailurePolicy.property.rules"></a>

```typescript
public readonly rules: PodFailurePolicyRule[];
```

- *Type:* cdk8s-plus-28.k8s.PodFailurePolicyRule[]

A list of pod failure policy rules.

The rules are evaluated in order. Once a rule matches a Pod failure, the remaining of the rules are ignored. When no rule matches the Pod failure, the default handling applies - the counter of pod failures is incremented and it is checked against the backoffLimit. At most 20 elements are allowed.

---

### PodFailurePolicyOnExitCodesRequirement <a name="PodFailurePolicyOnExitCodesRequirement" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement"></a>

PodFailurePolicyOnExitCodesRequirement describes the requirement for handling a failed pod based on its container exit codes.

In particular, it lookups the .state.terminated.exitCode for each app container and init container status, represented by the .status.containerStatuses and .status.initContainerStatuses fields in the Pod status, respectively. Containers completed with success (exit code 0) are excluded from the requirement check.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podFailurePolicyOnExitCodesRequirement: k8s.PodFailurePolicyOnExitCodesRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.operator">operator</a></code> | <code>string</code> | Represents the relationship between the container exit code(s) and the specified values. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.values">values</a></code> | <code>number[]</code> | Specifies the set of values. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.containerName">containerName</a></code> | <code>string</code> | Restricts the check for exit codes to the container with the specified name. |

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

Represents the relationship between the container exit code(s) and the specified values.

Containers completed with success (exit code 0) are excluded from the requirement check. Possible values are:

- In: the requirement is satisfied if at least one container exit code
(might be multiple if there are multiple containers not restricted
by the 'containerName' field) is in the set of specified values.
- NotIn: the requirement is satisfied if at least one container exit code
(might be multiple if there are multiple containers not restricted
by the 'containerName' field) is not in the set of specified values.
Additional values are considered to be added in the future. Clients should react to an unknown operator by assuming the requirement is not satisfied.

---

##### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.values"></a>

```typescript
public readonly values: number[];
```

- *Type:* number[]

Specifies the set of values.

Each returned container exit code (might be multiple in case of multiple containers) is checked against this set of values with respect to the operator. The list of values must be ordered and must not contain duplicates. Value '0' cannot be used for the In operator. At least one element is required. At most 255 elements are allowed.

---

##### `containerName`<sup>Optional</sup> <a name="containerName" id="cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement.property.containerName"></a>

```typescript
public readonly containerName: string;
```

- *Type:* string

Restricts the check for exit codes to the container with the specified name.

When null, the rule applies to all containers. When specified, it should match one the container or initContainer names in the pod template.

---

### PodFailurePolicyOnPodConditionsPattern <a name="PodFailurePolicyOnPodConditionsPattern" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern"></a>

PodFailurePolicyOnPodConditionsPattern describes a pattern for matching an actual pod condition type.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podFailurePolicyOnPodConditionsPattern: k8s.PodFailurePolicyOnPodConditionsPattern = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.status">status</a></code> | <code>string</code> | Specifies the required Pod condition status. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.type">type</a></code> | <code>string</code> | Specifies the required Pod condition type. |

---

##### `status`<sup>Required</sup> <a name="status" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.status"></a>

```typescript
public readonly status: string;
```

- *Type:* string
- *Default:* True.

Specifies the required Pod condition status.

To match a pod condition it is required that the specified status equals the pod condition status. Defaults to True.

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Specifies the required Pod condition type.

To match a pod condition it is required that specified type equals the pod condition type.

---

### PodFailurePolicyRule <a name="PodFailurePolicyRule" id="cdk8s-plus-28.k8s.PodFailurePolicyRule"></a>

PodFailurePolicyRule describes how a pod failure is handled when the requirements are met.

One of onExitCodes and onPodConditions, but not both, can be used in each rule.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podFailurePolicyRule: k8s.PodFailurePolicyRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.action">action</a></code> | <code>string</code> | Specifies the action taken on a pod failure when the requirements are satisfied. Possible values are:. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onPodConditions">onPodConditions</a></code> | <code>cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern[]</code> | Represents the requirement on the pod conditions. |
| <code><a href="#cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onExitCodes">onExitCodes</a></code> | <code>cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement</code> | Represents the requirement on the container exit codes. |

---

##### `action`<sup>Required</sup> <a name="action" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.action"></a>

```typescript
public readonly action: string;
```

- *Type:* string

Specifies the action taken on a pod failure when the requirements are satisfied. Possible values are:.

FailJob: indicates that the pod's job is marked as Failed and all
running pods are terminated.
- FailIndex: indicates that the pod's index is marked as Failed and will
not be restarted.
This value is alpha-level. It can be used when the
`JobBackoffLimitPerIndex` feature gate is enabled (disabled by default).
- Ignore: indicates that the counter towards the .backoffLimit is not
incremented and a replacement pod is created.
- Count: indicates that the pod is handled in the default way - the
counter towards the .backoffLimit is incremented.
Additional values are considered to be added in the future. Clients should react to an unknown action by skipping the rule.

---

##### `onPodConditions`<sup>Required</sup> <a name="onPodConditions" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onPodConditions"></a>

```typescript
public readonly onPodConditions: PodFailurePolicyOnPodConditionsPattern[];
```

- *Type:* cdk8s-plus-28.k8s.PodFailurePolicyOnPodConditionsPattern[]

Represents the requirement on the pod conditions.

The requirement is represented as a list of pod condition patterns. The requirement is satisfied if at least one pattern matches an actual pod condition. At most 20 elements are allowed.

---

##### `onExitCodes`<sup>Optional</sup> <a name="onExitCodes" id="cdk8s-plus-28.k8s.PodFailurePolicyRule.property.onExitCodes"></a>

```typescript
public readonly onExitCodes: PodFailurePolicyOnExitCodesRequirement;
```

- *Type:* cdk8s-plus-28.k8s.PodFailurePolicyOnExitCodesRequirement

Represents the requirement on the container exit codes.

---

### PodOs <a name="PodOs" id="cdk8s-plus-28.k8s.PodOs"></a>

PodOS defines the OS parameters of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodOs.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podOs: k8s.PodOs = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodOs.property.name">name</a></code> | <code>string</code> | Name is the name of the operating system. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodOs.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of the operating system.

The currently supported values are linux and windows. Additional value may be defined in future and can be one of: https://github.com/opencontainers/runtime-spec/blob/master/config.md#platform-specific-configuration Clients should expect to handle additional values and treat unrecognized values in this field as os: null

---

### PodProps <a name="PodProps" id="cdk8s-plus-28.PodProps"></a>

Properties for `Pod`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodProps.Initializer"></a>

```typescript
import { PodProps } from 'cdk8s-plus-28'

const podProps: PodProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.PodProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.PodProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.PodProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.PodProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.PodProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.PodProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.PodProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.PodProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.PodProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.PodProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.PodProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.PodProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.PodProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.PodProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.PodProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.PodProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.PodProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.PodProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.PodProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.PodProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.PodProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

### PodReadinessGate <a name="PodReadinessGate" id="cdk8s-plus-28.k8s.PodReadinessGate"></a>

PodReadinessGate contains the reference to a pod condition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodReadinessGate.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podReadinessGate: k8s.PodReadinessGate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodReadinessGate.property.conditionType">conditionType</a></code> | <code>string</code> | ConditionType refers to a condition in the pod's condition list with matching type. |

---

##### `conditionType`<sup>Required</sup> <a name="conditionType" id="cdk8s-plus-28.k8s.PodReadinessGate.property.conditionType"></a>

```typescript
public readonly conditionType: string;
```

- *Type:* string

ConditionType refers to a condition in the pod's condition list with matching type.

---

### PodResourceClaim <a name="PodResourceClaim" id="cdk8s-plus-28.k8s.PodResourceClaim"></a>

PodResourceClaim references exactly one ResourceClaim through a ClaimSource.

It adds a name to it that uniquely identifies the ResourceClaim inside the Pod. Containers that need access to the ResourceClaim reference it with this name.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodResourceClaim.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podResourceClaim: k8s.PodResourceClaim = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodResourceClaim.property.name">name</a></code> | <code>string</code> | Name uniquely identifies this resource claim inside the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodResourceClaim.property.source">source</a></code> | <code>cdk8s-plus-28.k8s.ClaimSource</code> | Source describes where to find the ResourceClaim. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodResourceClaim.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name uniquely identifies this resource claim inside the pod.

This must be a DNS_LABEL.

---

##### `source`<sup>Optional</sup> <a name="source" id="cdk8s-plus-28.k8s.PodResourceClaim.property.source"></a>

```typescript
public readonly source: ClaimSource;
```

- *Type:* cdk8s-plus-28.k8s.ClaimSource

Source describes where to find the ResourceClaim.

---

### PodsAllOptions <a name="PodsAllOptions" id="cdk8s-plus-28.PodsAllOptions"></a>

Options for `Pods.all`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodsAllOptions.Initializer"></a>

```typescript
import { PodsAllOptions } from 'cdk8s-plus-28'

const podsAllOptions: PodsAllOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodsAllOptions.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.Namespaces">Namespaces</a></code> | Namespaces the pods are allowed to be in. |

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodsAllOptions.property.namespaces"></a>

```typescript
public readonly namespaces: Namespaces;
```

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

### PodSchedulingAttractOptions <a name="PodSchedulingAttractOptions" id="cdk8s-plus-28.PodSchedulingAttractOptions"></a>

Options for `PodScheduling.attract`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingAttractOptions.Initializer"></a>

```typescript
import { PodSchedulingAttractOptions } from 'cdk8s-plus-28'

const podSchedulingAttractOptions: PodSchedulingAttractOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingAttractOptions.property.weight">weight</a></code> | <code>number</code> | Indicates the attraction is optional (soft), with this weight score. |

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingAttractOptions.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number
- *Default:* no weight. assignment is assumed to be required (hard).

Indicates the attraction is optional (soft), with this weight score.

---

### PodSchedulingColocateOptions <a name="PodSchedulingColocateOptions" id="cdk8s-plus-28.PodSchedulingColocateOptions"></a>

Options for `PodScheduling.colocate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingColocateOptions.Initializer"></a>

```typescript
import { PodSchedulingColocateOptions } from 'cdk8s-plus-28'

const podSchedulingColocateOptions: PodSchedulingColocateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingColocateOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to coloate on. |
| <code><a href="#cdk8s-plus-28.PodSchedulingColocateOptions.property.weight">weight</a></code> | <code>number</code> | Indicates the co-location is optional (soft), with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodSchedulingColocateOptions.property.topology"></a>

```typescript
public readonly topology: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to coloate on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingColocateOptions.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number
- *Default:* no weight. co-location is assumed to be required (hard).

Indicates the co-location is optional (soft), with this weight score.

---

### PodSchedulingContextSpecV1Alpha2 <a name="PodSchedulingContextSpecV1Alpha2" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2"></a>

PodSchedulingContextSpec describes where resources for the Pod are needed.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podSchedulingContextSpecV1Alpha2: k8s.PodSchedulingContextSpecV1Alpha2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.potentialNodes">potentialNodes</a></code> | <code>string[]</code> | PotentialNodes lists nodes where the Pod might be able to run. |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.selectedNode">selectedNode</a></code> | <code>string</code> | SelectedNode is the node for which allocation of ResourceClaims that are referenced by the Pod and that use "WaitForFirstConsumer" allocation is to be attempted. |

---

##### `potentialNodes`<sup>Optional</sup> <a name="potentialNodes" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.potentialNodes"></a>

```typescript
public readonly potentialNodes: string[];
```

- *Type:* string[]

PotentialNodes lists nodes where the Pod might be able to run.

The size of this field is limited to 128. This is large enough for many clusters. Larger clusters may need more attempts to find a node that suits all pending resources. This may get increased in the future, but not reduced.

---

##### `selectedNode`<sup>Optional</sup> <a name="selectedNode" id="cdk8s-plus-28.k8s.PodSchedulingContextSpecV1Alpha2.property.selectedNode"></a>

```typescript
public readonly selectedNode: string;
```

- *Type:* string

SelectedNode is the node for which allocation of ResourceClaims that are referenced by the Pod and that use "WaitForFirstConsumer" allocation is to be attempted.

---

### PodSchedulingGate <a name="PodSchedulingGate" id="cdk8s-plus-28.k8s.PodSchedulingGate"></a>

PodSchedulingGate is associated to a Pod to guard its scheduling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSchedulingGate.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podSchedulingGate: k8s.PodSchedulingGate = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSchedulingGate.property.name">name</a></code> | <code>string</code> | Name of the scheduling gate. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PodSchedulingGate.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the scheduling gate.

Each scheduling gate must have a unique name field.

---

### PodSchedulingSeparateOptions <a name="PodSchedulingSeparateOptions" id="cdk8s-plus-28.PodSchedulingSeparateOptions"></a>

Options for `PodScheduling.separate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSchedulingSeparateOptions.Initializer"></a>

```typescript
import { PodSchedulingSeparateOptions } from 'cdk8s-plus-28'

const podSchedulingSeparateOptions: PodSchedulingSeparateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSchedulingSeparateOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to separate on. |
| <code><a href="#cdk8s-plus-28.PodSchedulingSeparateOptions.property.weight">weight</a></code> | <code>number</code> | Indicates the separation is optional (soft), with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.PodSchedulingSeparateOptions.property.topology"></a>

```typescript
public readonly topology: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to separate on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.PodSchedulingSeparateOptions.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number
- *Default:* no weight. separation is assumed to be required (hard).

Indicates the separation is optional (soft), with this weight score.

---

### PodSecurityContext <a name="PodSecurityContext" id="cdk8s-plus-28.k8s.PodSecurityContext"></a>

PodSecurityContext holds pod-level security attributes and common container settings.

Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSecurityContext.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podSecurityContext: k8s.PodSecurityContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroup">fsGroup</a></code> | <code>number</code> | A special supplemental group that applies to all containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroupChangePolicy">fsGroupChangePolicy</a></code> | <code>string</code> | fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsGroup">runAsGroup</a></code> | <code>number</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsNonRoot">runAsNonRoot</a></code> | <code>boolean</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.runAsUser">runAsUser</a></code> | <code>number</code> | The UID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.seccompProfile">seccompProfile</a></code> | <code>cdk8s-plus-28.k8s.SeccompProfile</code> | The seccomp options to use by the containers in this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.seLinuxOptions">seLinuxOptions</a></code> | <code>cdk8s-plus-28.k8s.SeLinuxOptions</code> | The SELinux context to be applied to all containers. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.supplementalGroups">supplementalGroups</a></code> | <code>number[]</code> | A list of groups applied to the first process run in each container, in addition to the container's primary GID, the fsGroup (if specified), and group memberships defined in the container image for the uid of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.sysctls">sysctls</a></code> | <code>cdk8s-plus-28.k8s.Sysctl[]</code> | Sysctls hold a list of namespaced sysctls used for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSecurityContext.property.windowsOptions">windowsOptions</a></code> | <code>cdk8s-plus-28.k8s.WindowsSecurityContextOptions</code> | The Windows specific settings applied to all containers. |

---

##### `fsGroup`<sup>Optional</sup> <a name="fsGroup" id="cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroup"></a>

```typescript
public readonly fsGroup: number;
```

- *Type:* number

A special supplemental group that applies to all containers in a pod.

Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:

1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----

If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.

---

##### `fsGroupChangePolicy`<sup>Optional</sup> <a name="fsGroupChangePolicy" id="cdk8s-plus-28.k8s.PodSecurityContext.property.fsGroupChangePolicy"></a>

```typescript
public readonly fsGroupChangePolicy: string;
```

- *Type:* string

fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod.

This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.

---

##### `runAsGroup`<sup>Optional</sup> <a name="runAsGroup" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsGroup"></a>

```typescript
public readonly runAsGroup: number;
```

- *Type:* number

The GID to run the entrypoint of the container process.

Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `runAsNonRoot`<sup>Optional</sup> <a name="runAsNonRoot" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsNonRoot"></a>

```typescript
public readonly runAsNonRoot: boolean;
```

- *Type:* boolean

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

##### `runAsUser`<sup>Optional</sup> <a name="runAsUser" id="cdk8s-plus-28.k8s.PodSecurityContext.property.runAsUser"></a>

```typescript
public readonly runAsUser: number;
```

- *Type:* number
- *Default:* user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

The UID to run the entrypoint of the container process.

Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `seccompProfile`<sup>Optional</sup> <a name="seccompProfile" id="cdk8s-plus-28.k8s.PodSecurityContext.property.seccompProfile"></a>

```typescript
public readonly seccompProfile: SeccompProfile;
```

- *Type:* cdk8s-plus-28.k8s.SeccompProfile

The seccomp options to use by the containers in this pod.

Note that this field cannot be set when spec.os.name is windows.

---

##### `seLinuxOptions`<sup>Optional</sup> <a name="seLinuxOptions" id="cdk8s-plus-28.k8s.PodSecurityContext.property.seLinuxOptions"></a>

```typescript
public readonly seLinuxOptions: SeLinuxOptions;
```

- *Type:* cdk8s-plus-28.k8s.SeLinuxOptions

The SELinux context to be applied to all containers.

If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

---

##### `supplementalGroups`<sup>Optional</sup> <a name="supplementalGroups" id="cdk8s-plus-28.k8s.PodSecurityContext.property.supplementalGroups"></a>

```typescript
public readonly supplementalGroups: number[];
```

- *Type:* number[]

A list of groups applied to the first process run in each container, in addition to the container's primary GID, the fsGroup (if specified), and group memberships defined in the container image for the uid of the container process.

If unspecified, no additional groups are added to any container. Note that group memberships defined in the container image for the uid of the container process are still effective, even if they are not included in this list. Note that this field cannot be set when spec.os.name is windows.

---

##### `sysctls`<sup>Optional</sup> <a name="sysctls" id="cdk8s-plus-28.k8s.PodSecurityContext.property.sysctls"></a>

```typescript
public readonly sysctls: Sysctl[];
```

- *Type:* cdk8s-plus-28.k8s.Sysctl[]

Sysctls hold a list of namespaced sysctls used for the pod.

Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.

---

##### `windowsOptions`<sup>Optional</sup> <a name="windowsOptions" id="cdk8s-plus-28.k8s.PodSecurityContext.property.windowsOptions"></a>

```typescript
public readonly windowsOptions: WindowsSecurityContextOptions;
```

- *Type:* cdk8s-plus-28.k8s.WindowsSecurityContextOptions

The Windows specific settings applied to all containers.

If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

---

### PodSecurityContextProps <a name="PodSecurityContextProps" id="cdk8s-plus-28.PodSecurityContextProps"></a>

Properties for `PodSecurityContext`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSecurityContextProps.Initializer"></a>

```typescript
import { PodSecurityContextProps } from 'cdk8s-plus-28'

const podSecurityContextProps: PodSecurityContextProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.ensureNonRoot">ensureNonRoot</a></code> | <code>boolean</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.fsGroup">fsGroup</a></code> | <code>number</code> | Modify the ownership and permissions of pod volumes to this GID. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.fsGroupChangePolicy">fsGroupChangePolicy</a></code> | <code><a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a></code> | Defines behavior of changing ownership and permission of the volume before being exposed inside Pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.group">group</a></code> | <code>number</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.sysctls">sysctls</a></code> | <code><a href="#cdk8s-plus-28.Sysctl">Sysctl</a>[]</code> | Sysctls hold a list of namespaced sysctls used for the pod. |
| <code><a href="#cdk8s-plus-28.PodSecurityContextProps.property.user">user</a></code> | <code>number</code> | The UID to run the entrypoint of the container process. |

---

##### `ensureNonRoot`<sup>Optional</sup> <a name="ensureNonRoot" id="cdk8s-plus-28.PodSecurityContextProps.property.ensureNonRoot"></a>

```typescript
public readonly ensureNonRoot: boolean;
```

- *Type:* boolean
- *Default:* true

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does
not run as UID 0 (root) and fail to start the container if it does.

---

##### `fsGroup`<sup>Optional</sup> <a name="fsGroup" id="cdk8s-plus-28.PodSecurityContextProps.property.fsGroup"></a>

```typescript
public readonly fsGroup: number;
```

- *Type:* number
- *Default:* Volume ownership is not changed.

Modify the ownership and permissions of pod volumes to this GID.

---

##### `fsGroupChangePolicy`<sup>Optional</sup> <a name="fsGroupChangePolicy" id="cdk8s-plus-28.PodSecurityContextProps.property.fsGroupChangePolicy"></a>

```typescript
public readonly fsGroupChangePolicy: FsGroupChangePolicy;
```

- *Type:* <a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a>
- *Default:* FsGroupChangePolicy.ALWAYS

Defines behavior of changing ownership and permission of the volume before being exposed inside Pod.

This field will only apply to volume types which support fsGroup based ownership(and permissions).
It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.PodSecurityContextProps.property.group"></a>

```typescript
public readonly group: number;
```

- *Type:* number
- *Default:* Group configured by container runtime

The GID to run the entrypoint of the container process.

---

##### `sysctls`<sup>Optional</sup> <a name="sysctls" id="cdk8s-plus-28.PodSecurityContextProps.property.sysctls"></a>

```typescript
public readonly sysctls: Sysctl[];
```

- *Type:* <a href="#cdk8s-plus-28.Sysctl">Sysctl</a>[]
- *Default:* No sysctls

Sysctls hold a list of namespaced sysctls used for the pod.

Pods with unsupported sysctls (by the container runtime) might fail to launch.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.PodSecurityContextProps.property.user"></a>

```typescript
public readonly user: number;
```

- *Type:* number
- *Default:* User specified in image metadata

The UID to run the entrypoint of the container process.

---

### PodSelectorConfig <a name="PodSelectorConfig" id="cdk8s-plus-28.PodSelectorConfig"></a>

Configuration for selecting pods, optionally in particular namespaces.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodSelectorConfig.Initializer"></a>

```typescript
import { PodSelectorConfig } from 'cdk8s-plus-28'

const podSelectorConfig: PodSelectorConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSelectorConfig.property.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a></code> | A selector to select pods by labels. |
| <code><a href="#cdk8s-plus-28.PodSelectorConfig.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.NamespaceSelectorConfig">NamespaceSelectorConfig</a></code> | Configuration for selecting which namepsaces are the pods allowed to be in. |

---

##### `labelSelector`<sup>Required</sup> <a name="labelSelector" id="cdk8s-plus-28.PodSelectorConfig.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* <a href="#cdk8s-plus-28.LabelSelector">LabelSelector</a>

A selector to select pods by labels.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodSelectorConfig.property.namespaces"></a>

```typescript
public readonly namespaces: NamespaceSelectorConfig;
```

- *Type:* <a href="#cdk8s-plus-28.NamespaceSelectorConfig">NamespaceSelectorConfig</a>

Configuration for selecting which namepsaces are the pods allowed to be in.

---

### PodsMetricSourceV2 <a name="PodsMetricSourceV2" id="cdk8s-plus-28.k8s.PodsMetricSourceV2"></a>

PodsMetricSource indicates how to scale on a metric describing each pod in the current scale target (for example, transactions-processed-per-second).

The values will be averaged together before being compared to the target value.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podsMetricSourceV2: k8s.PodsMetricSourceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodsMetricSourceV2.property.metric">metric</a></code> | <code>cdk8s-plus-28.k8s.MetricIdentifierV2</code> | metric identifies the target metric by name and selector. |
| <code><a href="#cdk8s-plus-28.k8s.PodsMetricSourceV2.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `metric`<sup>Required</sup> <a name="metric" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.property.metric"></a>

```typescript
public readonly metric: MetricIdentifierV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricIdentifierV2

metric identifies the target metric by name and selector.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.PodsMetricSourceV2.property.target"></a>

```typescript
public readonly target: MetricTargetV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### PodSpec <a name="PodSpec" id="cdk8s-plus-28.k8s.PodSpec"></a>

PodSpec is a description of a pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podSpec: k8s.PodSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.containers">containers</a></code> | <code>cdk8s-plus-28.k8s.Container[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.activeDeadlineSeconds">activeDeadlineSeconds</a></code> | <code>number</code> | Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.affinity">affinity</a></code> | <code>cdk8s-plus-28.k8s.Affinity</code> | If specified, the pod's scheduling constraints. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | AutomountServiceAccountToken indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.dnsConfig">dnsConfig</a></code> | <code>cdk8s-plus-28.k8s.PodDnsConfig</code> | Specifies the DNS parameters of a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.dnsPolicy">dnsPolicy</a></code> | <code>string</code> | Set DNS policy for the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.enableServiceLinks">enableServiceLinks</a></code> | <code>boolean</code> | EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.ephemeralContainers">ephemeralContainers</a></code> | <code>cdk8s-plus-28.k8s.EphemeralContainer[]</code> | List of ephemeral containers run in this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostAliases">hostAliases</a></code> | <code>cdk8s-plus-28.k8s.HostAlias[]</code> | HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostIpc">hostIpc</a></code> | <code>boolean</code> | Use the host's ipc namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostname">hostname</a></code> | <code>string</code> | Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host networking requested for this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostPid">hostPid</a></code> | <code>boolean</code> | Use the host's pid namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.hostUsers">hostUsers</a></code> | <code>boolean</code> | Use the host's user namespace. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.imagePullSecrets">imagePullSecrets</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference[]</code> | ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.initContainers">initContainers</a></code> | <code>cdk8s-plus-28.k8s.Container[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.nodeName">nodeName</a></code> | <code>string</code> | NodeName is a request to schedule this pod onto a specific node. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.nodeSelector">nodeSelector</a></code> | <code>{[ key: string ]: string}</code> | NodeSelector is a selector which must be true for the pod to fit on a node. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.os">os</a></code> | <code>cdk8s-plus-28.k8s.PodOs</code> | Specifies the OS of the containers in the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.overhead">overhead</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Overhead represents the resource overhead associated with running a pod for a given RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.preemptionPolicy">preemptionPolicy</a></code> | <code>string</code> | PreemptionPolicy is the Policy for preempting pods with lower priority. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.priority">priority</a></code> | <code>number</code> | The priority value. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.priorityClassName">priorityClassName</a></code> | <code>string</code> | If specified, indicates the pod's priority. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.readinessGates">readinessGates</a></code> | <code>cdk8s-plus-28.k8s.PodReadinessGate[]</code> | If specified, all readiness gates will be evaluated for pod readiness. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.resourceClaims">resourceClaims</a></code> | <code>cdk8s-plus-28.k8s.PodResourceClaim[]</code> | ResourceClaims defines which ResourceClaims must be allocated and reserved before the Pod is allowed to start. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.restartPolicy">restartPolicy</a></code> | <code>string</code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.runtimeClassName">runtimeClassName</a></code> | <code>string</code> | RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.schedulerName">schedulerName</a></code> | <code>string</code> | If specified, the pod will be dispatched by specified scheduler. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.schedulingGates">schedulingGates</a></code> | <code>cdk8s-plus-28.k8s.PodSchedulingGate[]</code> | SchedulingGates is an opaque list of values that if specified will block scheduling the pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.securityContext">securityContext</a></code> | <code>cdk8s-plus-28.k8s.PodSecurityContext</code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.serviceAccount">serviceAccount</a></code> | <code>string</code> | DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.serviceAccountName">serviceAccountName</a></code> | <code>string</code> | ServiceAccountName is the name of the ServiceAccount to use to run this pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.setHostnameAsFqdn">setHostnameAsFqdn</a></code> | <code>boolean</code> | If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.shareProcessNamespace">shareProcessNamespace</a></code> | <code>boolean</code> | Share a single process namespace between all of the containers in a pod. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.subdomain">subdomain</a></code> | <code>string</code> | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.terminationGracePeriodSeconds">terminationGracePeriodSeconds</a></code> | <code>number</code> | Optional duration in seconds the pod needs to terminate gracefully. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.tolerations">tolerations</a></code> | <code>cdk8s-plus-28.k8s.Toleration[]</code> | If specified, the pod's tolerations. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.topologySpreadConstraints">topologySpreadConstraints</a></code> | <code>cdk8s-plus-28.k8s.TopologySpreadConstraint[]</code> | TopologySpreadConstraints describes how a group of pods ought to spread across topology domains. |
| <code><a href="#cdk8s-plus-28.k8s.PodSpec.property.volumes">volumes</a></code> | <code>cdk8s-plus-28.k8s.Volume[]</code> | List of volumes that can be mounted by containers belonging to the pod. |

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.k8s.PodSpec.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* cdk8s-plus-28.k8s.Container[]

List of containers belonging to the pod.

Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.

---

##### `activeDeadlineSeconds`<sup>Optional</sup> <a name="activeDeadlineSeconds" id="cdk8s-plus-28.k8s.PodSpec.property.activeDeadlineSeconds"></a>

```typescript
public readonly activeDeadlineSeconds: number;
```

- *Type:* number

Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers.

Value must be a positive integer.

---

##### `affinity`<sup>Optional</sup> <a name="affinity" id="cdk8s-plus-28.k8s.PodSpec.property.affinity"></a>

```typescript
public readonly affinity: Affinity;
```

- *Type:* cdk8s-plus-28.k8s.Affinity

If specified, the pod's scheduling constraints.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.k8s.PodSpec.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean

AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.

---

##### `dnsConfig`<sup>Optional</sup> <a name="dnsConfig" id="cdk8s-plus-28.k8s.PodSpec.property.dnsConfig"></a>

```typescript
public readonly dnsConfig: PodDnsConfig;
```

- *Type:* cdk8s-plus-28.k8s.PodDnsConfig

Specifies the DNS parameters of a pod.

Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.

---

##### `dnsPolicy`<sup>Optional</sup> <a name="dnsPolicy" id="cdk8s-plus-28.k8s.PodSpec.property.dnsPolicy"></a>

```typescript
public readonly dnsPolicy: string;
```

- *Type:* string
- *Default:* ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.

Set DNS policy for the pod.

Defaults to "ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.

---

##### `enableServiceLinks`<sup>Optional</sup> <a name="enableServiceLinks" id="cdk8s-plus-28.k8s.PodSpec.property.enableServiceLinks"></a>

```typescript
public readonly enableServiceLinks: boolean;
```

- *Type:* boolean
- *Default:* true.

EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links.

Optional: Defaults to true.

---

##### `ephemeralContainers`<sup>Optional</sup> <a name="ephemeralContainers" id="cdk8s-plus-28.k8s.PodSpec.property.ephemeralContainers"></a>

```typescript
public readonly ephemeralContainers: EphemeralContainer[];
```

- *Type:* cdk8s-plus-28.k8s.EphemeralContainer[]

List of ephemeral containers run in this pod.

Ephemeral containers may be run in an existing pod to perform user-initiated actions such as debugging. This list cannot be specified when creating a pod, and it cannot be modified by updating the pod spec. In order to add an ephemeral container to an existing pod, use the pod's ephemeralcontainers subresource.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.k8s.PodSpec.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* cdk8s-plus-28.k8s.HostAlias[]

HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified.

This is only valid for non-hostNetwork pods.

---

##### `hostIpc`<sup>Optional</sup> <a name="hostIpc" id="cdk8s-plus-28.k8s.PodSpec.property.hostIpc"></a>

```typescript
public readonly hostIpc: boolean;
```

- *Type:* boolean
- *Default:* false.

Use the host's ipc namespace.

Optional: Default to false.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.k8s.PodSpec.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.k8s.PodSpec.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false.

Host networking requested for this pod.

Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.

---

##### `hostPid`<sup>Optional</sup> <a name="hostPid" id="cdk8s-plus-28.k8s.PodSpec.property.hostPid"></a>

```typescript
public readonly hostPid: boolean;
```

- *Type:* boolean
- *Default:* false.

Use the host's pid namespace.

Optional: Default to false.

---

##### `hostUsers`<sup>Optional</sup> <a name="hostUsers" id="cdk8s-plus-28.k8s.PodSpec.property.hostUsers"></a>

```typescript
public readonly hostUsers: boolean;
```

- *Type:* boolean
- *Default:* true. If set to true or not present, the pod will be run in the host user namespace, useful for when the pod needs a feature only available to the host user namespace, such as loading a kernel module with CAP_SYS_MODULE. When set to false, a new userns is created for the pod. Setting false is useful for mitigating container breakout vulnerabilities even allowing users to run their containers as root without actually having root privileges on the host. This field is alpha-level and is only honored by servers that enable the UserNamespacesSupport feature.

Use the host's user namespace.

Optional: Default to true. If set to true or not present, the pod will be run in the host user namespace, useful for when the pod needs a feature only available to the host user namespace, such as loading a kernel module with CAP_SYS_MODULE. When set to false, a new userns is created for the pod. Setting false is useful for mitigating container breakout vulnerabilities even allowing users to run their containers as root without actually having root privileges on the host. This field is alpha-level and is only honored by servers that enable the UserNamespacesSupport feature.

---

##### `imagePullSecrets`<sup>Optional</sup> <a name="imagePullSecrets" id="cdk8s-plus-28.k8s.PodSpec.property.imagePullSecrets"></a>

```typescript
public readonly imagePullSecrets: LocalObjectReference[];
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference[]

ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec.

If specified, these secrets will be passed to individual puller implementations for them to use. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.k8s.PodSpec.property.initContainers"></a>

```typescript
public readonly initContainers: Container[];
```

- *Type:* cdk8s-plus-28.k8s.Container[]

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/

---

##### `nodeName`<sup>Optional</sup> <a name="nodeName" id="cdk8s-plus-28.k8s.PodSpec.property.nodeName"></a>

```typescript
public readonly nodeName: string;
```

- *Type:* string

NodeName is a request to schedule this pod onto a specific node.

If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.

---

##### `nodeSelector`<sup>Optional</sup> <a name="nodeSelector" id="cdk8s-plus-28.k8s.PodSpec.property.nodeSelector"></a>

```typescript
public readonly nodeSelector: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

NodeSelector is a selector which must be true for the pod to fit on a node.

Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/

---

##### `os`<sup>Optional</sup> <a name="os" id="cdk8s-plus-28.k8s.PodSpec.property.os"></a>

```typescript
public readonly os: PodOs;
```

- *Type:* cdk8s-plus-28.k8s.PodOs

Specifies the OS of the containers in the pod.

Some pod and container fields are restricted if this is set.

If the OS field is set to linux, the following fields must be unset: -securityContext.windowsOptions

If the OS field is set to windows, following fields must be unset: - spec.hostPID - spec.hostIPC - spec.hostUsers - spec.securityContext.seLinuxOptions - spec.securityContext.seccompProfile - spec.securityContext.fsGroup - spec.securityContext.fsGroupChangePolicy - spec.securityContext.sysctls - spec.shareProcessNamespace - spec.securityContext.runAsUser - spec.securityContext.runAsGroup - spec.securityContext.supplementalGroups - spec.containers[*].securityContext.seLinuxOptions - spec.containers[*].securityContext.seccompProfile - spec.containers[*].securityContext.capabilities - spec.containers[*].securityContext.readOnlyRootFilesystem - spec.containers[*].securityContext.privileged - spec.containers[*].securityContext.allowPrivilegeEscalation - spec.containers[*].securityContext.procMount - spec.containers[*].securityContext.runAsUser - spec.containers[*].securityContext.runAsGroup

---

##### `overhead`<sup>Optional</sup> <a name="overhead" id="cdk8s-plus-28.k8s.PodSpec.property.overhead"></a>

```typescript
public readonly overhead: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Overhead represents the resource overhead associated with running a pod for a given RuntimeClass.

This field will be autopopulated at admission time by the RuntimeClass admission controller. If the RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests. The RuntimeClass admission controller will reject Pod create requests which have the overhead already set. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value defined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero. More info: https://git.k8s.io/enhancements/keps/sig-node/688-pod-overhead/README.md

---

##### `preemptionPolicy`<sup>Optional</sup> <a name="preemptionPolicy" id="cdk8s-plus-28.k8s.PodSpec.property.preemptionPolicy"></a>

```typescript
public readonly preemptionPolicy: string;
```

- *Type:* string
- *Default:* PreemptLowerPriority if unset.

PreemptionPolicy is the Policy for preempting pods with lower priority.

One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

---

##### `priority`<sup>Optional</sup> <a name="priority" id="cdk8s-plus-28.k8s.PodSpec.property.priority"></a>

```typescript
public readonly priority: number;
```

- *Type:* number

The priority value.

Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.

---

##### `priorityClassName`<sup>Optional</sup> <a name="priorityClassName" id="cdk8s-plus-28.k8s.PodSpec.property.priorityClassName"></a>

```typescript
public readonly priorityClassName: string;
```

- *Type:* string

If specified, indicates the pod's priority.

"system-node-critical" and "system-cluster-critical" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.

---

##### `readinessGates`<sup>Optional</sup> <a name="readinessGates" id="cdk8s-plus-28.k8s.PodSpec.property.readinessGates"></a>

```typescript
public readonly readinessGates: PodReadinessGate[];
```

- *Type:* cdk8s-plus-28.k8s.PodReadinessGate[]

If specified, all readiness gates will be evaluated for pod readiness.

A pod is ready when all its containers are ready AND all conditions specified in the readiness gates have status equal to "True" More info: https://git.k8s.io/enhancements/keps/sig-network/580-pod-readiness-gates

---

##### `resourceClaims`<sup>Optional</sup> <a name="resourceClaims" id="cdk8s-plus-28.k8s.PodSpec.property.resourceClaims"></a>

```typescript
public readonly resourceClaims: PodResourceClaim[];
```

- *Type:* cdk8s-plus-28.k8s.PodResourceClaim[]

ResourceClaims defines which ResourceClaims must be allocated and reserved before the Pod is allowed to start.

The resources will be made available to those containers which consume them by name.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.k8s.PodSpec.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: string;
```

- *Type:* string
- *Default:* Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy

Restart policy for all containers within the pod.

One of Always, OnFailure, Never. In some contexts, only a subset of those values may be permitted. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy

---

##### `runtimeClassName`<sup>Optional</sup> <a name="runtimeClassName" id="cdk8s-plus-28.k8s.PodSpec.property.runtimeClassName"></a>

```typescript
public readonly runtimeClassName: string;
```

- *Type:* string

RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class.

---

##### `schedulerName`<sup>Optional</sup> <a name="schedulerName" id="cdk8s-plus-28.k8s.PodSpec.property.schedulerName"></a>

```typescript
public readonly schedulerName: string;
```

- *Type:* string

If specified, the pod will be dispatched by specified scheduler.

If not specified, the pod will be dispatched by default scheduler.

---

##### `schedulingGates`<sup>Optional</sup> <a name="schedulingGates" id="cdk8s-plus-28.k8s.PodSpec.property.schedulingGates"></a>

```typescript
public readonly schedulingGates: PodSchedulingGate[];
```

- *Type:* cdk8s-plus-28.k8s.PodSchedulingGate[]

SchedulingGates is an opaque list of values that if specified will block scheduling the pod.

If schedulingGates is not empty, the pod will stay in the SchedulingGated state and the scheduler will not attempt to schedule the pod.

SchedulingGates can only be set at pod creation time, and be removed only afterwards.

This is a beta feature enabled by the PodSchedulingReadiness feature gate.

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.k8s.PodSpec.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContext;
```

- *Type:* cdk8s-plus-28.k8s.PodSecurityContext
- *Default:* empty.  See type description for default values of each field.

SecurityContext holds pod-level security attributes and common container settings.

Optional: Defaults to empty.  See type description for default values of each field.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.k8s.PodSpec.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: string;
```

- *Type:* string

DeprecatedServiceAccount is a depreciated alias for ServiceAccountName.

Deprecated: Use serviceAccountName instead.

---

##### `serviceAccountName`<sup>Optional</sup> <a name="serviceAccountName" id="cdk8s-plus-28.k8s.PodSpec.property.serviceAccountName"></a>

```typescript
public readonly serviceAccountName: string;
```

- *Type:* string

ServiceAccountName is the name of the ServiceAccount to use to run this pod.

More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

---

##### `setHostnameAsFqdn`<sup>Optional</sup> <a name="setHostnameAsFqdn" id="cdk8s-plus-28.k8s.PodSpec.property.setHostnameAsFqdn"></a>

```typescript
public readonly setHostnameAsFqdn: boolean;
```

- *Type:* boolean
- *Default:* false.

If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).

In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname). In Windows containers, this means setting the registry value of hostname for the registry key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN. If a pod does not have FQDN, this has no effect. Default to false.

---

##### `shareProcessNamespace`<sup>Optional</sup> <a name="shareProcessNamespace" id="cdk8s-plus-28.k8s.PodSpec.property.shareProcessNamespace"></a>

```typescript
public readonly shareProcessNamespace: boolean;
```

- *Type:* boolean
- *Default:* false.

Share a single process namespace between all of the containers in a pod.

When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.k8s.PodSpec.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all.

---

##### `terminationGracePeriodSeconds`<sup>Optional</sup> <a name="terminationGracePeriodSeconds" id="cdk8s-plus-28.k8s.PodSpec.property.terminationGracePeriodSeconds"></a>

```typescript
public readonly terminationGracePeriodSeconds: number;
```

- *Type:* number
- *Default:* 30 seconds.

Optional duration in seconds the pod needs to terminate gracefully.

May be decreased in delete request. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.

---

##### `tolerations`<sup>Optional</sup> <a name="tolerations" id="cdk8s-plus-28.k8s.PodSpec.property.tolerations"></a>

```typescript
public readonly tolerations: Toleration[];
```

- *Type:* cdk8s-plus-28.k8s.Toleration[]

If specified, the pod's tolerations.

---

##### `topologySpreadConstraints`<sup>Optional</sup> <a name="topologySpreadConstraints" id="cdk8s-plus-28.k8s.PodSpec.property.topologySpreadConstraints"></a>

```typescript
public readonly topologySpreadConstraints: TopologySpreadConstraint[];
```

- *Type:* cdk8s-plus-28.k8s.TopologySpreadConstraint[]

TopologySpreadConstraints describes how a group of pods ought to spread across topology domains.

Scheduler will schedule pods in a way which abides by the constraints. All topologySpreadConstraints are ANDed.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.k8s.PodSpec.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* cdk8s-plus-28.k8s.Volume[]

List of volumes that can be mounted by containers belonging to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes

---

### PodsSelectOptions <a name="PodsSelectOptions" id="cdk8s-plus-28.PodsSelectOptions"></a>

Options for `Pods.select`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.PodsSelectOptions.Initializer"></a>

```typescript
import { PodsSelectOptions } from 'cdk8s-plus-28'

const podsSelectOptions: PodsSelectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.expressions">expressions</a></code> | <code><a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]</code> | Expressions the pods must satisify. |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.labels">labels</a></code> | <code>{[ key: string ]: string}</code> | Labels the pods must have. |
| <code><a href="#cdk8s-plus-28.PodsSelectOptions.property.namespaces">namespaces</a></code> | <code><a href="#cdk8s-plus-28.Namespaces">Namespaces</a></code> | Namespaces the pods are allowed to be in. |

---

##### `expressions`<sup>Optional</sup> <a name="expressions" id="cdk8s-plus-28.PodsSelectOptions.property.expressions"></a>

```typescript
public readonly expressions: LabelExpression[];
```

- *Type:* <a href="#cdk8s-plus-28.LabelExpression">LabelExpression</a>[]
- *Default:* no expressions requirements.

Expressions the pods must satisify.

---

##### `labels`<sup>Optional</sup> <a name="labels" id="cdk8s-plus-28.PodsSelectOptions.property.labels"></a>

```typescript
public readonly labels: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* no strict labels requirements.

Labels the pods must have.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.PodsSelectOptions.property.namespaces"></a>

```typescript
public readonly namespaces: Namespaces;
```

- *Type:* <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>
- *Default:* unset, implies the namespace of the resource this selection is used in.

Namespaces the pods are allowed to be in.

Use `Namespaces.all()` to allow all namespaces.

---

### PodTemplateSpec <a name="PodTemplateSpec" id="cdk8s-plus-28.k8s.PodTemplateSpec"></a>

PodTemplateSpec describes the data a pod should have when created from a template.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PodTemplateSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const podTemplateSpec: k8s.PodTemplateSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PodTemplateSpec.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | Standard object's metadata. |
| <code><a href="#cdk8s-plus-28.k8s.PodTemplateSpec.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.PodSpec</code> | Specification of the desired behavior of the pod. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.PodTemplateSpec.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

Standard object's metadata.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

---

##### `spec`<sup>Optional</sup> <a name="spec" id="cdk8s-plus-28.k8s.PodTemplateSpec.property.spec"></a>

```typescript
public readonly spec: PodSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodSpec

Specification of the desired behavior of the pod.

More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

---

### PolicyRule <a name="PolicyRule" id="cdk8s-plus-28.k8s.PolicyRule"></a>

PolicyRule holds information that describes a policy rule, but does not contain information about who the rule applies to or which namespace the rule applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const policyRule: k8s.PolicyRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.verbs">verbs</a></code> | <code>string[]</code> | Verbs is a list of Verbs that apply to ALL the ResourceKinds contained in this rule. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | APIGroups is the name of the APIGroup that contains the resources. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.nonResourceUrLs">nonResourceUrLs</a></code> | <code>string[]</code> | NonResourceURLs is a set of partial urls that a user should have access to. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.resourceNames">resourceNames</a></code> | <code>string[]</code> | ResourceNames is an optional white list of names that the rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRule.property.resources">resources</a></code> | <code>string[]</code> | Resources is a list of resources this rule applies to. |

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.PolicyRule.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

Verbs is a list of Verbs that apply to ALL the ResourceKinds contained in this rule.

'*' represents all verbs.

---

##### `apiGroups`<sup>Optional</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.PolicyRule.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

APIGroups is the name of the APIGroup that contains the resources.

If multiple API groups are specified, any action requested against one of the enumerated resources in any API group will be allowed. "" represents the core API group and "*" represents all API groups.

---

##### `nonResourceUrLs`<sup>Optional</sup> <a name="nonResourceUrLs" id="cdk8s-plus-28.k8s.PolicyRule.property.nonResourceUrLs"></a>

```typescript
public readonly nonResourceUrLs: string[];
```

- *Type:* string[]

NonResourceURLs is a set of partial urls that a user should have access to.

*s are allowed, but only as the full, final step in the path Since non-resource URLs are not namespaced, this field is only applicable for ClusterRoles referenced from a ClusterRoleBinding. Rules can either apply to API resources (such as "pods" or "secrets") or non-resource URL paths (such as "/api"),  but not both.

---

##### `resourceNames`<sup>Optional</sup> <a name="resourceNames" id="cdk8s-plus-28.k8s.PolicyRule.property.resourceNames"></a>

```typescript
public readonly resourceNames: string[];
```

- *Type:* string[]

ResourceNames is an optional white list of names that the rule applies to.

An empty set means that everything is allowed.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.PolicyRule.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

Resources is a list of resources this rule applies to.

'*' represents all resources.

---

### PolicyRulesWithSubjectsV1Beta2 <a name="PolicyRulesWithSubjectsV1Beta2" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2"></a>

PolicyRulesWithSubjects prescribes a test that applies to a request to an apiserver.

The test considers the subject making the request, the verb being requested, and the resource to be acted upon. This PolicyRulesWithSubjects matches a request if and only if both (a) at least one member of subjects matches the request and (b) at least one member of resourceRules or nonResourceRules matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const policyRulesWithSubjectsV1Beta2: k8s.PolicyRulesWithSubjectsV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.subjects">subjects</a></code> | <code>cdk8s-plus-28.k8s.SubjectV1Beta2[]</code> | subjects is the list of normal user, serviceaccount, or group that this rule cares about. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.nonResourceRules">nonResourceRules</a></code> | <code>cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2[]</code> | `nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.resourceRules">resourceRules</a></code> | <code>cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2[]</code> | `resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource. |

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.subjects"></a>

```typescript
public readonly subjects: SubjectV1Beta2[];
```

- *Type:* cdk8s-plus-28.k8s.SubjectV1Beta2[]

subjects is the list of normal user, serviceaccount, or group that this rule cares about.

There must be at least one member in this slice. A slice that includes both the system:authenticated and system:unauthenticated user groups matches every request. Required.

---

##### `nonResourceRules`<sup>Optional</sup> <a name="nonResourceRules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.nonResourceRules"></a>

```typescript
public readonly nonResourceRules: NonResourcePolicyRuleV1Beta2[];
```

- *Type:* cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta2[]

`nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL.

---

##### `resourceRules`<sup>Optional</sup> <a name="resourceRules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta2.property.resourceRules"></a>

```typescript
public readonly resourceRules: ResourcePolicyRuleV1Beta2[];
```

- *Type:* cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2[]

`resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource.

At least one of `resourceRules` and `nonResourceRules` has to be non-empty.

---

### PolicyRulesWithSubjectsV1Beta3 <a name="PolicyRulesWithSubjectsV1Beta3" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3"></a>

PolicyRulesWithSubjects prescribes a test that applies to a request to an apiserver.

The test considers the subject making the request, the verb being requested, and the resource to be acted upon. This PolicyRulesWithSubjects matches a request if and only if both (a) at least one member of subjects matches the request and (b) at least one member of resourceRules or nonResourceRules matches the request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const policyRulesWithSubjectsV1Beta3: k8s.PolicyRulesWithSubjectsV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.subjects">subjects</a></code> | <code>cdk8s-plus-28.k8s.SubjectV1Beta3[]</code> | subjects is the list of normal user, serviceaccount, or group that this rule cares about. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.nonResourceRules">nonResourceRules</a></code> | <code>cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3[]</code> | `nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL. |
| <code><a href="#cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.resourceRules">resourceRules</a></code> | <code>cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3[]</code> | `resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource. |

---

##### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.subjects"></a>

```typescript
public readonly subjects: SubjectV1Beta3[];
```

- *Type:* cdk8s-plus-28.k8s.SubjectV1Beta3[]

subjects is the list of normal user, serviceaccount, or group that this rule cares about.

There must be at least one member in this slice. A slice that includes both the system:authenticated and system:unauthenticated user groups matches every request. Required.

---

##### `nonResourceRules`<sup>Optional</sup> <a name="nonResourceRules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.nonResourceRules"></a>

```typescript
public readonly nonResourceRules: NonResourcePolicyRuleV1Beta3[];
```

- *Type:* cdk8s-plus-28.k8s.NonResourcePolicyRuleV1Beta3[]

`nonResourceRules` is a list of NonResourcePolicyRules that identify matching requests according to their verb and the target non-resource URL.

---

##### `resourceRules`<sup>Optional</sup> <a name="resourceRules" id="cdk8s-plus-28.k8s.PolicyRulesWithSubjectsV1Beta3.property.resourceRules"></a>

```typescript
public readonly resourceRules: ResourcePolicyRuleV1Beta3[];
```

- *Type:* cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3[]

`resourceRules` is a slice of ResourcePolicyRules that identify matching requests according to their verb and the target resource.

At least one of `resourceRules` and `nonResourceRules` has to be non-empty.

---

### PortworxVolumeSource <a name="PortworxVolumeSource" id="cdk8s-plus-28.k8s.PortworxVolumeSource"></a>

PortworxVolumeSource represents a Portworx volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PortworxVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const portworxVolumeSource: k8s.PortworxVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.volumeId">volumeId</a></code> | <code>string</code> | volumeID uniquely identifies a Portworx volume. |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. |
| <code><a href="#cdk8s-plus-28.k8s.PortworxVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |

---

##### `volumeId`<sup>Required</sup> <a name="volumeId" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.volumeId"></a>

```typescript
public readonly volumeId: string;
```

- *Type:* string

volumeID uniquely identifies a Portworx volume.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system.

Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.PortworxVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

### Preconditions <a name="Preconditions" id="cdk8s-plus-28.k8s.Preconditions"></a>

Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Preconditions.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const preconditions: k8s.Preconditions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Preconditions.property.resourceVersion">resourceVersion</a></code> | <code>string</code> | Specifies the target ResourceVersion. |
| <code><a href="#cdk8s-plus-28.k8s.Preconditions.property.uid">uid</a></code> | <code>string</code> | Specifies the target UID. |

---

##### `resourceVersion`<sup>Optional</sup> <a name="resourceVersion" id="cdk8s-plus-28.k8s.Preconditions.property.resourceVersion"></a>

```typescript
public readonly resourceVersion: string;
```

- *Type:* string

Specifies the target ResourceVersion.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.Preconditions.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

Specifies the target UID.

---

### PreferredSchedulingTerm <a name="PreferredSchedulingTerm" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm"></a>

An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const preferredSchedulingTerm: k8s.PreferredSchedulingTerm = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.preference">preference</a></code> | <code>cdk8s-plus-28.k8s.NodeSelectorTerm</code> | A node selector term, associated with the corresponding weight. |
| <code><a href="#cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.weight">weight</a></code> | <code>number</code> | Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100. |

---

##### `preference`<sup>Required</sup> <a name="preference" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.preference"></a>

```typescript
public readonly preference: NodeSelectorTerm;
```

- *Type:* cdk8s-plus-28.k8s.NodeSelectorTerm

A node selector term, associated with the corresponding weight.

---

##### `weight`<sup>Required</sup> <a name="weight" id="cdk8s-plus-28.k8s.PreferredSchedulingTerm.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.

---

### PriorityLevelConfigurationReferenceV1Beta2 <a name="PriorityLevelConfigurationReferenceV1Beta2" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2"></a>

PriorityLevelConfigurationReference contains information that points to the "request-priority" being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const priorityLevelConfigurationReferenceV1Beta2: k8s.PriorityLevelConfigurationReferenceV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.property.name">name</a></code> | <code>string</code> | `name` is the name of the priority level configuration being referenced Required. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of the priority level configuration being referenced Required.

---

### PriorityLevelConfigurationReferenceV1Beta3 <a name="PriorityLevelConfigurationReferenceV1Beta3" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3"></a>

PriorityLevelConfigurationReference contains information that points to the "request-priority" being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const priorityLevelConfigurationReferenceV1Beta3: k8s.PriorityLevelConfigurationReferenceV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.property.name">name</a></code> | <code>string</code> | `name` is the name of the priority level configuration being referenced Required. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationReferenceV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of the priority level configuration being referenced Required.

---

### PriorityLevelConfigurationSpecV1Beta2 <a name="PriorityLevelConfigurationSpecV1Beta2" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2"></a>

PriorityLevelConfigurationSpec specifies the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const priorityLevelConfigurationSpecV1Beta2: k8s.PriorityLevelConfigurationSpecV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.type">type</a></code> | <code>string</code> | `type` indicates whether this priority level is subject to limitation on request execution. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.exempt">exempt</a></code> | <code>cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2</code> | `exempt` specifies how requests are handled for an exempt priority level. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.limited">limited</a></code> | <code>cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2</code> | `limited` specifies how requests are handled for a Limited priority level. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` indicates whether this priority level is subject to limitation on request execution.

A value of `"Exempt"` means that requests of this priority level are not subject to a limit (and thus are never queued) and do not detract from the capacity made available to other priority levels.  A value of `"Limited"` means that (a) requests of this priority level _are_ subject to limits and (b) some of the server's limited capacity is made available exclusively to this priority level. Required.

---

##### `exempt`<sup>Optional</sup> <a name="exempt" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.exempt"></a>

```typescript
public readonly exempt: ExemptPriorityLevelConfigurationV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta2

`exempt` specifies how requests are handled for an exempt priority level.

This field MUST be empty if `type` is `"Limited"`. This field MAY be non-empty if `type` is `"Exempt"`. If empty and `type` is `"Exempt"` then the default values for `ExemptPriorityLevelConfiguration` apply.

---

##### `limited`<sup>Optional</sup> <a name="limited" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta2.property.limited"></a>

```typescript
public readonly limited: LimitedPriorityLevelConfigurationV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta2

`limited` specifies how requests are handled for a Limited priority level.

This field must be non-empty if and only if `type` is `"Limited"`.

---

### PriorityLevelConfigurationSpecV1Beta3 <a name="PriorityLevelConfigurationSpecV1Beta3" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3"></a>

PriorityLevelConfigurationSpec specifies the configuration of a priority level.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const priorityLevelConfigurationSpecV1Beta3: k8s.PriorityLevelConfigurationSpecV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.type">type</a></code> | <code>string</code> | `type` indicates whether this priority level is subject to limitation on request execution. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.exempt">exempt</a></code> | <code>cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3</code> | `exempt` specifies how requests are handled for an exempt priority level. |
| <code><a href="#cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.limited">limited</a></code> | <code>cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3</code> | `limited` specifies how requests are handled for a Limited priority level. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

`type` indicates whether this priority level is subject to limitation on request execution.

A value of `"Exempt"` means that requests of this priority level are not subject to a limit (and thus are never queued) and do not detract from the capacity made available to other priority levels.  A value of `"Limited"` means that (a) requests of this priority level _are_ subject to limits and (b) some of the server's limited capacity is made available exclusively to this priority level. Required.

---

##### `exempt`<sup>Optional</sup> <a name="exempt" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.exempt"></a>

```typescript
public readonly exempt: ExemptPriorityLevelConfigurationV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.ExemptPriorityLevelConfigurationV1Beta3

`exempt` specifies how requests are handled for an exempt priority level.

This field MUST be empty if `type` is `"Limited"`. This field MAY be non-empty if `type` is `"Exempt"`. If empty and `type` is `"Exempt"` then the default values for `ExemptPriorityLevelConfiguration` apply.

---

##### `limited`<sup>Optional</sup> <a name="limited" id="cdk8s-plus-28.k8s.PriorityLevelConfigurationSpecV1Beta3.property.limited"></a>

```typescript
public readonly limited: LimitedPriorityLevelConfigurationV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.LimitedPriorityLevelConfigurationV1Beta3

`limited` specifies how requests are handled for a Limited priority level.

This field must be non-empty if and only if `type` is `"Limited"`.

---

### Probe <a name="Probe" id="cdk8s-plus-28.k8s.Probe"></a>

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Probe.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const probe: k8s.Probe = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.exec">exec</a></code> | <code>cdk8s-plus-28.k8s.ExecAction</code> | Exec specifies the action to take. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.failureThreshold">failureThreshold</a></code> | <code>number</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.grpc">grpc</a></code> | <code>cdk8s-plus-28.k8s.GrpcAction</code> | GRPC specifies an action involving a GRPC port. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.httpGet">httpGet</a></code> | <code>cdk8s-plus-28.k8s.HttpGetAction</code> | HTTPGet specifies the http request to perform. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.initialDelaySeconds">initialDelaySeconds</a></code> | <code>number</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.periodSeconds">periodSeconds</a></code> | <code>number</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.successThreshold">successThreshold</a></code> | <code>number</code> | Minimum consecutive successes for the probe to be considered successful after having failed. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.tcpSocket">tcpSocket</a></code> | <code>cdk8s-plus-28.k8s.TcpSocketAction</code> | TCPSocket specifies an action involving a TCP port. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.terminationGracePeriodSeconds">terminationGracePeriodSeconds</a></code> | <code>number</code> | Optional duration in seconds the pod needs to terminate gracefully upon probe failure. |
| <code><a href="#cdk8s-plus-28.k8s.Probe.property.timeoutSeconds">timeoutSeconds</a></code> | <code>number</code> | Number of seconds after which the probe times out. |

---

##### `exec`<sup>Optional</sup> <a name="exec" id="cdk8s-plus-28.k8s.Probe.property.exec"></a>

```typescript
public readonly exec: ExecAction;
```

- *Type:* cdk8s-plus-28.k8s.ExecAction

Exec specifies the action to take.

---

##### `failureThreshold`<sup>Optional</sup> <a name="failureThreshold" id="cdk8s-plus-28.k8s.Probe.property.failureThreshold"></a>

```typescript
public readonly failureThreshold: number;
```

- *Type:* number
- *Default:* 3. Minimum value is 1.

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `grpc`<sup>Optional</sup> <a name="grpc" id="cdk8s-plus-28.k8s.Probe.property.grpc"></a>

```typescript
public readonly grpc: GrpcAction;
```

- *Type:* cdk8s-plus-28.k8s.GrpcAction

GRPC specifies an action involving a GRPC port.

---

##### `httpGet`<sup>Optional</sup> <a name="httpGet" id="cdk8s-plus-28.k8s.Probe.property.httpGet"></a>

```typescript
public readonly httpGet: HttpGetAction;
```

- *Type:* cdk8s-plus-28.k8s.HttpGetAction

HTTPGet specifies the http request to perform.

---

##### `initialDelaySeconds`<sup>Optional</sup> <a name="initialDelaySeconds" id="cdk8s-plus-28.k8s.Probe.property.initialDelaySeconds"></a>

```typescript
public readonly initialDelaySeconds: number;
```

- *Type:* number

Number of seconds after the container has started before liveness probes are initiated.

More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

##### `periodSeconds`<sup>Optional</sup> <a name="periodSeconds" id="cdk8s-plus-28.k8s.Probe.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: number;
```

- *Type:* number
- *Default:* 10 seconds. Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `successThreshold`<sup>Optional</sup> <a name="successThreshold" id="cdk8s-plus-28.k8s.Probe.property.successThreshold"></a>

```typescript
public readonly successThreshold: number;
```

- *Type:* number
- *Default:* 1. Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed.

Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.

---

##### `tcpSocket`<sup>Optional</sup> <a name="tcpSocket" id="cdk8s-plus-28.k8s.Probe.property.tcpSocket"></a>

```typescript
public readonly tcpSocket: TcpSocketAction;
```

- *Type:* cdk8s-plus-28.k8s.TcpSocketAction

TCPSocket specifies an action involving a TCP port.

---

##### `terminationGracePeriodSeconds`<sup>Optional</sup> <a name="terminationGracePeriodSeconds" id="cdk8s-plus-28.k8s.Probe.property.terminationGracePeriodSeconds"></a>

```typescript
public readonly terminationGracePeriodSeconds: number;
```

- *Type:* number

Optional duration in seconds the pod needs to terminate gracefully upon probe failure.

The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.k8s.Probe.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: number;
```

- *Type:* number
- *Default:* 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

---

### ProbeOptions <a name="ProbeOptions" id="cdk8s-plus-28.ProbeOptions"></a>

Probe options.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ProbeOptions.Initializer"></a>

```typescript
import { ProbeOptions } from 'cdk8s-plus-28'

const probeOptions: ProbeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.failureThreshold">failureThreshold</a></code> | <code>number</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.initialDelaySeconds">initialDelaySeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.periodSeconds">periodSeconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.successThreshold">successThreshold</a></code> | <code>number</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.ProbeOptions.property.timeoutSeconds">timeoutSeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |

---

##### `failureThreshold`<sup>Optional</sup> <a name="failureThreshold" id="cdk8s-plus-28.ProbeOptions.property.failureThreshold"></a>

```typescript
public readonly failureThreshold: number;
```

- *Type:* number
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initialDelaySeconds`<sup>Optional</sup> <a name="initialDelaySeconds" id="cdk8s-plus-28.ProbeOptions.property.initialDelaySeconds"></a>

```typescript
public readonly initialDelaySeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `periodSeconds`<sup>Optional</sup> <a name="periodSeconds" id="cdk8s-plus-28.ProbeOptions.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `successThreshold`<sup>Optional</sup> <a name="successThreshold" id="cdk8s-plus-28.ProbeOptions.property.successThreshold"></a>

```typescript
public readonly successThreshold: number;
```

- *Type:* number
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.ProbeOptions.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

### ProjectedVolumeSource <a name="ProjectedVolumeSource" id="cdk8s-plus-28.k8s.ProjectedVolumeSource"></a>

Represents a projected volume source.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const projectedVolumeSource: k8s.ProjectedVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ProjectedVolumeSource.property.defaultMode">defaultMode</a></code> | <code>number</code> | defaultMode are the mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.ProjectedVolumeSource.property.sources">sources</a></code> | <code>cdk8s-plus-28.k8s.VolumeProjection[]</code> | sources is the list of volume projections. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number

defaultMode are the mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `sources`<sup>Optional</sup> <a name="sources" id="cdk8s-plus-28.k8s.ProjectedVolumeSource.property.sources"></a>

```typescript
public readonly sources: VolumeProjection[];
```

- *Type:* cdk8s-plus-28.k8s.VolumeProjection[]

sources is the list of volume projections.

---

### QueuingConfigurationV1Beta2 <a name="QueuingConfigurationV1Beta2" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2"></a>

QueuingConfiguration holds the configuration parameters for queuing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const queuingConfigurationV1Beta2: k8s.QueuingConfigurationV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.handSize">handSize</a></code> | <code>number</code> | `handSize` is a small positive number that configures the shuffle sharding of requests into queues. |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queueLengthLimit">queueLengthLimit</a></code> | <code>number</code> | `queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time; |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queues">queues</a></code> | <code>number</code> | `queues` is the number of queues for this priority level. |

---

##### `handSize`<sup>Optional</sup> <a name="handSize" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.handSize"></a>

```typescript
public readonly handSize: number;
```

- *Type:* number

`handSize` is a small positive number that configures the shuffle sharding of requests into queues.

When enqueuing a request at this priority level the request's flow identifier (a string pair) is hashed and the hash value is used to shuffle the list of queues and deal a hand of the size specified here.  The request is put into one of the shortest queues in that hand. `handSize` must be no larger than `queues`, and should be significantly smaller (so that a few heavy flows do not saturate most of the queues).  See the user-facing documentation for more extensive guidance on setting this field.  This field has a default value of 8.

---

##### `queueLengthLimit`<sup>Optional</sup> <a name="queueLengthLimit" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queueLengthLimit"></a>

```typescript
public readonly queueLengthLimit: number;
```

- *Type:* number

`queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time;

excess requests are rejected.  This value must be positive.  If not specified, it will be defaulted to 50.

---

##### `queues`<sup>Optional</sup> <a name="queues" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta2.property.queues"></a>

```typescript
public readonly queues: number;
```

- *Type:* number

`queues` is the number of queues for this priority level.

The queues exist independently at each apiserver. The value must be positive.  Setting it to 1 effectively precludes shufflesharding and thus makes the distinguisher method of associated flow schemas irrelevant.  This field has a default value of 64.

---

### QueuingConfigurationV1Beta3 <a name="QueuingConfigurationV1Beta3" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3"></a>

QueuingConfiguration holds the configuration parameters for queuing.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const queuingConfigurationV1Beta3: k8s.QueuingConfigurationV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.handSize">handSize</a></code> | <code>number</code> | `handSize` is a small positive number that configures the shuffle sharding of requests into queues. |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queueLengthLimit">queueLengthLimit</a></code> | <code>number</code> | `queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time; |
| <code><a href="#cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queues">queues</a></code> | <code>number</code> | `queues` is the number of queues for this priority level. |

---

##### `handSize`<sup>Optional</sup> <a name="handSize" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.handSize"></a>

```typescript
public readonly handSize: number;
```

- *Type:* number

`handSize` is a small positive number that configures the shuffle sharding of requests into queues.

When enqueuing a request at this priority level the request's flow identifier (a string pair) is hashed and the hash value is used to shuffle the list of queues and deal a hand of the size specified here.  The request is put into one of the shortest queues in that hand. `handSize` must be no larger than `queues`, and should be significantly smaller (so that a few heavy flows do not saturate most of the queues).  See the user-facing documentation for more extensive guidance on setting this field.  This field has a default value of 8.

---

##### `queueLengthLimit`<sup>Optional</sup> <a name="queueLengthLimit" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queueLengthLimit"></a>

```typescript
public readonly queueLengthLimit: number;
```

- *Type:* number

`queueLengthLimit` is the maximum number of requests allowed to be waiting in a given queue of this priority level at a time;

excess requests are rejected.  This value must be positive.  If not specified, it will be defaulted to 50.

---

##### `queues`<sup>Optional</sup> <a name="queues" id="cdk8s-plus-28.k8s.QueuingConfigurationV1Beta3.property.queues"></a>

```typescript
public readonly queues: number;
```

- *Type:* number

`queues` is the number of queues for this priority level.

The queues exist independently at each apiserver. The value must be positive.  Setting it to 1 effectively precludes shufflesharding and thus makes the distinguisher method of associated flow schemas irrelevant.  This field has a default value of 64.

---

### QuobyteVolumeSource <a name="QuobyteVolumeSource" id="cdk8s-plus-28.k8s.QuobyteVolumeSource"></a>

Represents a Quobyte mount that lasts the lifetime of a pod.

Quobyte volumes do not support ownership management or SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const quobyteVolumeSource: k8s.QuobyteVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.registry">registry</a></code> | <code>string</code> | registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.volume">volume</a></code> | <code>string</code> | volume is a string that references an already created Quobyte volume by name. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.group">group</a></code> | <code>string</code> | group to map volume access to Default is no group. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the Quobyte volume to be mounted with read-only permissions. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.tenant">tenant</a></code> | <code>string</code> | tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin. |
| <code><a href="#cdk8s-plus-28.k8s.QuobyteVolumeSource.property.user">user</a></code> | <code>string</code> | user to map volume access to Defaults to serivceaccount user. |

---

##### `registry`<sup>Required</sup> <a name="registry" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.registry"></a>

```typescript
public readonly registry: string;
```

- *Type:* string

registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes.

---

##### `volume`<sup>Required</sup> <a name="volume" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.volume"></a>

```typescript
public readonly volume: string;
```

- *Type:* string

volume is a string that references an already created Quobyte volume by name.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string
- *Default:* no group

group to map volume access to Default is no group.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false.

readOnly here will force the Quobyte volume to be mounted with read-only permissions.

Defaults to false.

---

##### `tenant`<sup>Optional</sup> <a name="tenant" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.tenant"></a>

```typescript
public readonly tenant: string;
```

- *Type:* string

tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.QuobyteVolumeSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string
- *Default:* serivceaccount user

user to map volume access to Defaults to serivceaccount user.

---

### RbdPersistentVolumeSource <a name="RbdPersistentVolumeSource" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource"></a>

Represents a Rados Block Device mount that lasts the lifetime of a pod.

RBD volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const rbdPersistentVolumeSource: k8s.RbdPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.image">image</a></code> | <code>string</code> | image is the rados image name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.monitors">monitors</a></code> | <code>string[]</code> | monitors is a collection of Ceph monitors. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.keyring">keyring</a></code> | <code>string</code> | keyring is the path to key ring for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.pool">pool</a></code> | <code>string</code> | pool is the rados pool name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef is name of the authentication secret for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.user">user</a></code> | <code>string</code> | user is the rados user name. |

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

image is the rados image name.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.monitors"></a>

```typescript
public readonly monitors: string[];
```

- *Type:* string[]

monitors is a collection of Ceph monitors.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

---

##### `keyring`<sup>Optional</sup> <a name="keyring" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.keyring"></a>

```typescript
public readonly keyring: string;
```

- *Type:* string
- *Default:* etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

keyring is the path to key ring for RBDUser.

Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `pool`<sup>Optional</sup> <a name="pool" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string
- *Default:* rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

pool is the rados pool name.

Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference
- *Default:* nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

secretRef is name of the authentication secret for RBDUser.

If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.RbdPersistentVolumeSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string
- *Default:* admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

user is the rados user name.

Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

### RbdVolumeSource <a name="RbdVolumeSource" id="cdk8s-plus-28.k8s.RbdVolumeSource"></a>

Represents a Rados Block Device mount that lasts the lifetime of a pod.

RBD volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RbdVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const rbdVolumeSource: k8s.RbdVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.image">image</a></code> | <code>string</code> | image is the rados image name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.monitors">monitors</a></code> | <code>string[]</code> | monitors is a collection of Ceph monitors. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type of the volume that you want to mount. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.keyring">keyring</a></code> | <code>string</code> | keyring is the path to key ring for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.pool">pool</a></code> | <code>string</code> | pool is the rados pool name. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly here will force the ReadOnly setting in VolumeMounts. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef is name of the authentication secret for RBDUser. |
| <code><a href="#cdk8s-plus-28.k8s.RbdVolumeSource.property.user">user</a></code> | <code>string</code> | user is the rados user name. |

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

image is the rados image name.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `monitors`<sup>Required</sup> <a name="monitors" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.monitors"></a>

```typescript
public readonly monitors: string[];
```

- *Type:* string[]

monitors is a collection of Ceph monitors.

More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type of the volume that you want to mount.

Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

---

##### `keyring`<sup>Optional</sup> <a name="keyring" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.keyring"></a>

```typescript
public readonly keyring: string;
```

- *Type:* string
- *Default:* etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

keyring is the path to key ring for RBDUser.

Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `pool`<sup>Optional</sup> <a name="pool" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.pool"></a>

```typescript
public readonly pool: string;
```

- *Type:* string
- *Default:* rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

pool is the rados pool name.

Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

readOnly here will force the ReadOnly setting in VolumeMounts.

Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference
- *Default:* nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

secretRef is name of the authentication secret for RBDUser.

If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.RbdVolumeSource.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string
- *Default:* admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

user is the rados user name.

Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

---

### ReplicaSetSpec <a name="ReplicaSetSpec" id="cdk8s-plus-28.k8s.ReplicaSetSpec"></a>

ReplicaSetSpec is the specification of a ReplicaSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ReplicaSetSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const replicaSetSpec: k8s.ReplicaSetSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | Selector is a label query over pods that should match the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.replicas">replicas</a></code> | <code>number</code> | Replicas is the number of desired replicas. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicaSetSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | Template is the object that describes the pod that will be created if insufficient replicas are detected. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

Selector is a label query over pods that should match the replica count.

Label keys and values that must match in order to be controlled by this replica set. It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller

Replicas is the number of desired replicas.

This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller/#what-is-a-replicationcontroller

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.ReplicaSetSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

Template is the object that describes the pod that will be created if insufficient replicas are detected.

More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

### ReplicationControllerSpec <a name="ReplicationControllerSpec" id="cdk8s-plus-28.k8s.ReplicationControllerSpec"></a>

ReplicationControllerSpec is the specification of a replication controller.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const replicationControllerSpec: k8s.ReplicationControllerSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.replicas">replicas</a></code> | <code>number</code> | Replicas is the number of desired replicas. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.selector">selector</a></code> | <code>{[ key: string ]: string}</code> | Selector is a label query over pods that should match the Replicas count. |
| <code><a href="#cdk8s-plus-28.k8s.ReplicationControllerSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | Template is the object that describes the pod that will be created if insufficient replicas are detected. |

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller

Replicas is the number of desired replicas.

This is a pointer to distinguish between explicit zero and unspecified. Defaults to 1. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#what-is-a-replicationcontroller

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.selector"></a>

```typescript
public readonly selector: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Selector is a label query over pods that should match the Replicas count.

If Selector is empty, it is defaulted to the labels present on the Pod template. Label keys and values that must match in order to be controlled by this replication controller, if empty defaulted to labels on Pod template. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `template`<sup>Optional</sup> <a name="template" id="cdk8s-plus-28.k8s.ReplicationControllerSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

Template is the object that describes the pod that will be created if insufficient replicas are detected.

This takes precedence over a TemplateRef. The only allowed template.spec.restartPolicy value is "Always". More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller#pod-template

---

### ResourceAttributes <a name="ResourceAttributes" id="cdk8s-plus-28.k8s.ResourceAttributes"></a>

ResourceAttributes includes the authorization attributes available for resource requests to the Authorizer interface.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceAttributes.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceAttributes: k8s.ResourceAttributes = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.group">group</a></code> | <code>string</code> | Group is the API Group of the Resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.name">name</a></code> | <code>string</code> | Name is the name of the resource being requested for a "get" or deleted for a "delete". |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.namespace">namespace</a></code> | <code>string</code> | Namespace is the namespace of the action being requested. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.resource">resource</a></code> | <code>string</code> | Resource is one of the existing resource types. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.subresource">subresource</a></code> | <code>string</code> | Subresource is one of the existing resource types. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.verb">verb</a></code> | <code>string</code> | Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceAttributes.property.version">version</a></code> | <code>string</code> | Version is the API Version of the Resource. |

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.ResourceAttributes.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string

Group is the API Group of the Resource.

"*" means all.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceAttributes.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of the resource being requested for a "get" or deleted for a "delete".

"" (empty) means all.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ResourceAttributes.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace is the namespace of the action being requested.

Currently, there is no distinction between no namespace and all namespaces "" (empty) is defaulted for LocalSubjectAccessReviews "" (empty) is empty for cluster-scoped resources "" (empty) means "all" for namespace scoped resources from a SubjectAccessReview or SelfSubjectAccessReview

---

##### `resource`<sup>Optional</sup> <a name="resource" id="cdk8s-plus-28.k8s.ResourceAttributes.property.resource"></a>

```typescript
public readonly resource: string;
```

- *Type:* string

Resource is one of the existing resource types.

"*" means all.

---

##### `subresource`<sup>Optional</sup> <a name="subresource" id="cdk8s-plus-28.k8s.ResourceAttributes.property.subresource"></a>

```typescript
public readonly subresource: string;
```

- *Type:* string

Subresource is one of the existing resource types.

"" means none.

---

##### `verb`<sup>Optional</sup> <a name="verb" id="cdk8s-plus-28.k8s.ResourceAttributes.property.verb"></a>

```typescript
public readonly verb: string;
```

- *Type:* string

Verb is a kubernetes resource API verb, like: get, list, watch, create, update, delete, proxy.

"*" means all.

---

##### `version`<sup>Optional</sup> <a name="version" id="cdk8s-plus-28.k8s.ResourceAttributes.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Version is the API Version of the Resource.

"*" means all.

---

### ResourceClaim <a name="ResourceClaim" id="cdk8s-plus-28.k8s.ResourceClaim"></a>

ResourceClaim references one entry in PodSpec.ResourceClaims.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaim.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceClaim: k8s.ResourceClaim = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaim.property.name">name</a></code> | <code>string</code> | Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClaim.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container.

---

### ResourceClaimParametersReferenceV1Alpha2 <a name="ResourceClaimParametersReferenceV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2"></a>

ResourceClaimParametersReference contains enough information to let you locate the parameters for a ResourceClaim.

The object must be in the same namespace as the ResourceClaim.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceClaimParametersReferenceV1Alpha2: k8s.ResourceClaimParametersReferenceV1Alpha2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.kind">kind</a></code> | <code>string</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.name">name</a></code> | <code>string</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup is the group for the resource being referenced. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the type of resource being referenced.

This is the same value as in the parameter object's metadata, for example "ConfigMap".

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of resource being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup is the group for the resource being referenced.

It is empty for the core API. This matches the group in the APIVersion that is used when creating the resources.

---

### ResourceClaimSpecV1Alpha2 <a name="ResourceClaimSpecV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2"></a>

ResourceClaimSpec defines how a resource is to be allocated.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceClaimSpecV1Alpha2: k8s.ResourceClaimSpecV1Alpha2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.resourceClassName">resourceClassName</a></code> | <code>string</code> | ResourceClassName references the driver and additional parameters via the name of a ResourceClass that was created as part of the driver deployment. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.allocationMode">allocationMode</a></code> | <code>string</code> | Allocation can start immediately or when a Pod wants to use the resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.parametersRef">parametersRef</a></code> | <code>cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2</code> | ParametersRef references a separate object with arbitrary parameters that will be used by the driver when allocating a resource for the claim. |

---

##### `resourceClassName`<sup>Required</sup> <a name="resourceClassName" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.resourceClassName"></a>

```typescript
public readonly resourceClassName: string;
```

- *Type:* string

ResourceClassName references the driver and additional parameters via the name of a ResourceClass that was created as part of the driver deployment.

---

##### `allocationMode`<sup>Optional</sup> <a name="allocationMode" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.allocationMode"></a>

```typescript
public readonly allocationMode: string;
```

- *Type:* string

Allocation can start immediately or when a Pod wants to use the resource.

"WaitForFirstConsumer" is the default.

---

##### `parametersRef`<sup>Optional</sup> <a name="parametersRef" id="cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2.property.parametersRef"></a>

```typescript
public readonly parametersRef: ResourceClaimParametersReferenceV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceClaimParametersReferenceV1Alpha2

ParametersRef references a separate object with arbitrary parameters that will be used by the driver when allocating a resource for the claim.

The object must be in the same namespace as the ResourceClaim.

---

### ResourceClaimTemplateSpecV1Alpha2 <a name="ResourceClaimTemplateSpecV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2"></a>

ResourceClaimTemplateSpec contains the metadata and fields for a ResourceClaim.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceClaimTemplateSpecV1Alpha2: k8s.ResourceClaimTemplateSpecV1Alpha2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.spec">spec</a></code> | <code>cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2</code> | Spec for the ResourceClaim. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.metadata">metadata</a></code> | <code>cdk8s-plus-28.k8s.ObjectMeta</code> | ObjectMeta may contain labels and annotations that will be copied into the PVC when creating it. |

---

##### `spec`<sup>Required</sup> <a name="spec" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.spec"></a>

```typescript
public readonly spec: ResourceClaimSpecV1Alpha2;
```

- *Type:* cdk8s-plus-28.k8s.ResourceClaimSpecV1Alpha2

Spec for the ResourceClaim.

The entire content is copied unchanged into the ResourceClaim that gets created from this template. The same fields as in a ResourceClaim are also valid here.

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.k8s.ResourceClaimTemplateSpecV1Alpha2.property.metadata"></a>

```typescript
public readonly metadata: ObjectMeta;
```

- *Type:* cdk8s-plus-28.k8s.ObjectMeta

ObjectMeta may contain labels and annotations that will be copied into the PVC when creating it.

No other fields are allowed and will be rejected during validation.

---

### ResourceClassParametersReferenceV1Alpha2 <a name="ResourceClassParametersReferenceV1Alpha2" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2"></a>

ResourceClassParametersReference contains enough information to let you locate the parameters for a ResourceClass.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceClassParametersReferenceV1Alpha2: k8s.ResourceClassParametersReferenceV1Alpha2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.kind">kind</a></code> | <code>string</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.name">name</a></code> | <code>string</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.namespace">namespace</a></code> | <code>string</code> | Namespace that contains the referenced resource. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the type of resource being referenced.

This is the same value as in the parameter object's metadata.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of resource being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup is the group for the resource being referenced.

It is empty for the core API. This matches the group in the APIVersion that is used when creating the resources.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ResourceClassParametersReferenceV1Alpha2.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace that contains the referenced resource.

Must be empty for cluster-scoped resources and non-empty for namespaced resources.

---

### ResourceFieldSelector <a name="ResourceFieldSelector" id="cdk8s-plus-28.k8s.ResourceFieldSelector"></a>

ResourceFieldSelector represents container resources (cpu, memory) and their output format.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceFieldSelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceFieldSelector: k8s.ResourceFieldSelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.resource">resource</a></code> | <code>string</code> | Required: resource to select. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.containerName">containerName</a></code> | <code>string</code> | Container name: required for volumes, optional for env vars. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceFieldSelector.property.divisor">divisor</a></code> | <code>cdk8s-plus-28.k8s.Quantity</code> | Specifies the output format of the exposed resources, defaults to "1". |

---

##### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.resource"></a>

```typescript
public readonly resource: string;
```

- *Type:* string

Required: resource to select.

---

##### `containerName`<sup>Optional</sup> <a name="containerName" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.containerName"></a>

```typescript
public readonly containerName: string;
```

- *Type:* string

Container name: required for volumes, optional for env vars.

---

##### `divisor`<sup>Optional</sup> <a name="divisor" id="cdk8s-plus-28.k8s.ResourceFieldSelector.property.divisor"></a>

```typescript
public readonly divisor: Quantity;
```

- *Type:* cdk8s-plus-28.k8s.Quantity

Specifies the output format of the exposed resources, defaults to "1".

---

### ResourceMetricSourceV2 <a name="ResourceMetricSourceV2" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2"></a>

ResourceMetricSource indicates how to scale on a resource metric known to Kubernetes, as specified in requests and limits, describing each pod in the current scale target (e.g. CPU or memory).  The values will be averaged together before being compared to the target.  Such metrics are built in to Kubernetes, and have special scaling options on top of those available to normal per-pod metrics using the "pods" source.  Only one "target" type should be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceMetricSourceV2: k8s.ResourceMetricSourceV2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.name">name</a></code> | <code>string</code> | name is the name of the resource in question. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.target">target</a></code> | <code>cdk8s-plus-28.k8s.MetricTargetV2</code> | target specifies the target value for the given metric. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the resource in question.

---

##### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.k8s.ResourceMetricSourceV2.property.target"></a>

```typescript
public readonly target: MetricTargetV2;
```

- *Type:* cdk8s-plus-28.k8s.MetricTargetV2

target specifies the target value for the given metric.

---

### ResourcePolicyRuleV1Beta2 <a name="ResourcePolicyRuleV1Beta2" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2"></a>

ResourcePolicyRule is a predicate that matches some resource requests, testing the request's verb and the target resource.

A ResourcePolicyRule matches a resource request if and only if: (a) at least one member of verbs matches the request, (b) at least one member of apiGroups matches the request, (c) at least one member of resources matches the request, and (d) either (d1) the request does not specify a namespace (i.e., `Namespace==""`) and clusterScope is true or (d2) the request specifies a namespace and least one member of namespaces matches the request's namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourcePolicyRuleV1Beta2: k8s.ResourcePolicyRuleV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | `apiGroups` is a list of matching API groups and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.resources">resources</a></code> | <code>string[]</code> | `resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.verbs">verbs</a></code> | <code>string[]</code> | `verbs` is a list of matching verbs and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.clusterScope">clusterScope</a></code> | <code>boolean</code> | `clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces). |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.namespaces">namespaces</a></code> | <code>string[]</code> | `namespaces` is a list of target namespaces that restricts matches. |

---

##### `apiGroups`<sup>Required</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

`apiGroups` is a list of matching API groups and may not be empty.

"*" matches all API groups and, if present, must be the only entry. Required.

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

`resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs and, if present, must be the only entry. Required.

---

##### `clusterScope`<sup>Optional</sup> <a name="clusterScope" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.clusterScope"></a>

```typescript
public readonly clusterScope: boolean;
```

- *Type:* boolean

`clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces).

If this field is omitted or false then the `namespaces` field must contain a non-empty list.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta2.property.namespaces"></a>

```typescript
public readonly namespaces: string[];
```

- *Type:* string[]

`namespaces` is a list of target namespaces that restricts matches.

A request that specifies a target namespace matches only if either (a) this list contains that target namespace or (b) this list contains "*".  Note that "*" matches any specified namespace but does not match a request that _does not specify_ a namespace (see the `clusterScope` field for that). This list may be empty, but only if `clusterScope` is true.

---

### ResourcePolicyRuleV1Beta3 <a name="ResourcePolicyRuleV1Beta3" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3"></a>

ResourcePolicyRule is a predicate that matches some resource requests, testing the request's verb and the target resource.

A ResourcePolicyRule matches a resource request if and only if: (a) at least one member of verbs matches the request, (b) at least one member of apiGroups matches the request, (c) at least one member of resources matches the request, and (d) either (d1) the request does not specify a namespace (i.e., `Namespace==""`) and clusterScope is true or (d2) the request specifies a namespace and least one member of namespaces matches the request's namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourcePolicyRuleV1Beta3: k8s.ResourcePolicyRuleV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | `apiGroups` is a list of matching API groups and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.resources">resources</a></code> | <code>string[]</code> | `resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.verbs">verbs</a></code> | <code>string[]</code> | `verbs` is a list of matching verbs and may not be empty. |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.clusterScope">clusterScope</a></code> | <code>boolean</code> | `clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces). |
| <code><a href="#cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.namespaces">namespaces</a></code> | <code>string[]</code> | `namespaces` is a list of target namespaces that restricts matches. |

---

##### `apiGroups`<sup>Required</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

`apiGroups` is a list of matching API groups and may not be empty.

"*" matches all API groups and, if present, must be the only entry. Required.

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

`resources` is a list of matching resources (i.e., lowercase and plural) with, if desired, subresource.  For example, [ "services", "nodes/status" ].  This list may not be empty. "*" matches all resources and, if present, must be the only entry. Required.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

`verbs` is a list of matching verbs and may not be empty.

"*" matches all verbs and, if present, must be the only entry. Required.

---

##### `clusterScope`<sup>Optional</sup> <a name="clusterScope" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.clusterScope"></a>

```typescript
public readonly clusterScope: boolean;
```

- *Type:* boolean

`clusterScope` indicates whether to match requests that do not specify a namespace (which happens either because the resource is not namespaced or the request targets all namespaces).

If this field is omitted or false then the `namespaces` field must contain a non-empty list.

---

##### `namespaces`<sup>Optional</sup> <a name="namespaces" id="cdk8s-plus-28.k8s.ResourcePolicyRuleV1Beta3.property.namespaces"></a>

```typescript
public readonly namespaces: string[];
```

- *Type:* string[]

`namespaces` is a list of target namespaces that restricts matches.

A request that specifies a target namespace matches only if either (a) this list contains that target namespace or (b) this list contains "*".  Note that "*" matches any specified namespace but does not match a request that _does not specify_ a namespace (see the `clusterScope` field for that). This list may be empty, but only if `clusterScope` is true.

---

### ResourceProps <a name="ResourceProps" id="cdk8s-plus-28.ResourceProps"></a>

Initialization properties for resources.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ResourceProps.Initializer"></a>

```typescript
import { ResourceProps } from 'cdk8s-plus-28'

const resourceProps: ResourceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ResourceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ResourceProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

### ResourceQuotaSpec <a name="ResourceQuotaSpec" id="cdk8s-plus-28.k8s.ResourceQuotaSpec"></a>

ResourceQuotaSpec defines the desired hard limits to enforce for Quota.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceQuotaSpec: k8s.ResourceQuotaSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.hard">hard</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | hard is the set of desired hard limits for each named resource. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopes">scopes</a></code> | <code>string[]</code> | A collection of filters that must match each object tracked by a quota. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopeSelector">scopeSelector</a></code> | <code>cdk8s-plus-28.k8s.ScopeSelector</code> | scopeSelector is also a collection of filters like scopes that must match each object tracked by a quota but expressed using ScopeSelectorOperator in combination with possible values. |

---

##### `hard`<sup>Optional</sup> <a name="hard" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.hard"></a>

```typescript
public readonly hard: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

hard is the set of desired hard limits for each named resource.

More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

---

##### `scopes`<sup>Optional</sup> <a name="scopes" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopes"></a>

```typescript
public readonly scopes: string[];
```

- *Type:* string[]

A collection of filters that must match each object tracked by a quota.

If not specified, the quota matches all objects.

---

##### `scopeSelector`<sup>Optional</sup> <a name="scopeSelector" id="cdk8s-plus-28.k8s.ResourceQuotaSpec.property.scopeSelector"></a>

```typescript
public readonly scopeSelector: ScopeSelector;
```

- *Type:* cdk8s-plus-28.k8s.ScopeSelector

scopeSelector is also a collection of filters like scopes that must match each object tracked by a quota but expressed using ScopeSelectorOperator in combination with possible values.

For a resource to match, both scopes AND scopeSelector (if specified in spec), must be matched.

---

### ResourceRequirements <a name="ResourceRequirements" id="cdk8s-plus-28.k8s.ResourceRequirements"></a>

ResourceRequirements describes the compute resource requirements.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ResourceRequirements.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const resourceRequirements: k8s.ResourceRequirements = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.claims">claims</a></code> | <code>cdk8s-plus-28.k8s.ResourceClaim[]</code> | Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.limits">limits</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Limits describes the maximum amount of compute resources allowed. |
| <code><a href="#cdk8s-plus-28.k8s.ResourceRequirements.property.requests">requests</a></code> | <code>{[ key: string ]: cdk8s-plus-28.k8s.Quantity}</code> | Requests describes the minimum amount of compute resources required. |

---

##### `claims`<sup>Optional</sup> <a name="claims" id="cdk8s-plus-28.k8s.ResourceRequirements.property.claims"></a>

```typescript
public readonly claims: ResourceClaim[];
```

- *Type:* cdk8s-plus-28.k8s.ResourceClaim[]

Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable. It can only be set for containers.

---

##### `limits`<sup>Optional</sup> <a name="limits" id="cdk8s-plus-28.k8s.ResourceRequirements.property.limits"></a>

```typescript
public readonly limits: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Limits describes the maximum amount of compute resources allowed.

More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

##### `requests`<sup>Optional</sup> <a name="requests" id="cdk8s-plus-28.k8s.ResourceRequirements.property.requests"></a>

```typescript
public readonly requests: {[ key: string ]: Quantity};
```

- *Type:* {[ key: string ]: cdk8s-plus-28.k8s.Quantity}

Requests describes the minimum amount of compute resources required.

If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. Requests cannot exceed Limits. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

---

### RoleBindingProps <a name="RoleBindingProps" id="cdk8s-plus-28.RoleBindingProps"></a>

Properties for `RoleBinding`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RoleBindingProps.Initializer"></a>

```typescript
import { RoleBindingProps } from 'cdk8s-plus-28'

const roleBindingProps: RoleBindingProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleBindingProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.RoleBindingProps.property.role">role</a></code> | <code><a href="#cdk8s-plus-28.IRole">IRole</a></code> | The role to bind to. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.RoleBindingProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `role`<sup>Required</sup> <a name="role" id="cdk8s-plus-28.RoleBindingProps.property.role"></a>

```typescript
public readonly role: IRole;
```

- *Type:* <a href="#cdk8s-plus-28.IRole">IRole</a>

The role to bind to.

A RoleBinding can reference a Role or a ClusterRole.

---

### RolePolicyRule <a name="RolePolicyRule" id="cdk8s-plus-28.RolePolicyRule"></a>

Policy rule of a `Role.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RolePolicyRule.Initializer"></a>

```typescript
import { RolePolicyRule } from 'cdk8s-plus-28'

const rolePolicyRule: RolePolicyRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RolePolicyRule.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.IApiResource">IApiResource</a>[]</code> | Resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.RolePolicyRule.property.verbs">verbs</a></code> | <code>string[]</code> | Verbs to allow. |

---

##### `resources`<sup>Required</sup> <a name="resources" id="cdk8s-plus-28.RolePolicyRule.property.resources"></a>

```typescript
public readonly resources: IApiResource[];
```

- *Type:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>[]

Resources this rule applies to.

---

##### `verbs`<sup>Required</sup> <a name="verbs" id="cdk8s-plus-28.RolePolicyRule.property.verbs"></a>

```typescript
public readonly verbs: string[];
```

- *Type:* string[]

Verbs to allow.

(e.g ['get', 'watch'])

---

### RoleProps <a name="RoleProps" id="cdk8s-plus-28.RoleProps"></a>

Properties for `Role`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.RoleProps.Initializer"></a>

```typescript
import { RoleProps } from 'cdk8s-plus-28'

const roleProps: RoleProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.RoleProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.RoleProps.property.rules">rules</a></code> | <code><a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>[]</code> | A list of rules the role should allow. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.RoleProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.RoleProps.property.rules"></a>

```typescript
public readonly rules: RolePolicyRule[];
```

- *Type:* <a href="#cdk8s-plus-28.RolePolicyRule">RolePolicyRule</a>[]
- *Default:* []

A list of rules the role should allow.

---

### RoleRef <a name="RoleRef" id="cdk8s-plus-28.k8s.RoleRef"></a>

RoleRef contains information that points to the role being used.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RoleRef.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const roleRef: k8s.RoleRef = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.kind">kind</a></code> | <code>string</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.RoleRef.property.name">name</a></code> | <code>string</code> | Name is the name of resource being referenced. |

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.RoleRef.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup is the group for the resource being referenced.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.RoleRef.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.RoleRef.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of resource being referenced.

---

### RollingUpdateDaemonSet <a name="RollingUpdateDaemonSet" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet"></a>

Spec to control the desired behavior of daemon set rolling update.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const rollingUpdateDaemonSet: k8s.RollingUpdateDaemonSet = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxSurge">maxSurge</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | The maximum number of nodes with an existing available DaemonSet pod that can have an updated DaemonSet pod during during an update. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxUnavailable">maxUnavailable</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | The maximum number of DaemonSet pods that can be unavailable during the update. |

---

##### `maxSurge`<sup>Optional</sup> <a name="maxSurge" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxSurge"></a>

```typescript
public readonly maxSurge: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

The maximum number of nodes with an existing available DaemonSet pod that can have an updated DaemonSet pod during during an update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up to a minimum of 1. Default value is 0. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their a new pod created before the old pod is marked as deleted. The update starts by launching new pods on 30% of nodes. Once an updated pod is available (Ready for at least minReadySeconds) the old DaemonSet pod on that node is marked deleted. If the old pod becomes unavailable for any reason (Ready transitions to false, is evicted, or is drained) an updated pod is immediatedly created on that node without considering surge limits. Allowing surge implies the possibility that the resources consumed by the daemonset on any given node can double if the readiness check fails, and so resource intensive daemonsets should take into account that they may cause evictions during disruption.

---

##### `maxUnavailable`<sup>Optional</sup> <a name="maxUnavailable" id="cdk8s-plus-28.k8s.RollingUpdateDaemonSet.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

The maximum number of DaemonSet pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of total number of DaemonSet pods at the start of the update (ex: 10%). Absolute number is calculated from percentage by rounding up. This cannot be 0 if MaxSurge is 0 Default value is 1. Example: when this is set to 30%, at most 30% of the total number of nodes that should be running the daemon pod (i.e. status.desiredNumberScheduled) can have their pods stopped for an update at any given time. The update starts by stopping at most 30% of those DaemonSet pods and then brings up new DaemonSet pods in their place. Once the new pods are available, it then proceeds onto other DaemonSet pods, thus ensuring that at least 70% of original number of DaemonSet pods are available at all times during the update.

---

### RollingUpdateDeployment <a name="RollingUpdateDeployment" id="cdk8s-plus-28.k8s.RollingUpdateDeployment"></a>

Spec to control the desired behavior of rolling update.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const rollingUpdateDeployment: k8s.RollingUpdateDeployment = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxSurge">maxSurge</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | The maximum number of pods that can be scheduled above the desired number of pods. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxUnavailable">maxUnavailable</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | The maximum number of pods that can be unavailable during the update. |

---

##### `maxSurge`<sup>Optional</sup> <a name="maxSurge" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxSurge"></a>

```typescript
public readonly maxSurge: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString
- *Default:* 25%. Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.

The maximum number of pods that can be scheduled above the desired number of pods.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). This can not be 0 if MaxUnavailable is 0. Absolute number is calculated from percentage by rounding up. Defaults to 25%. Example: when this is set to 30%, the new ReplicaSet can be scaled up immediately when the rolling update starts, such that the total number of old and new pods do not exceed 130% of desired pods. Once old pods have been killed, new ReplicaSet can be scaled up further, ensuring that total number of pods running at any time during the update is at most 130% of desired pods.

---

##### `maxUnavailable`<sup>Optional</sup> <a name="maxUnavailable" id="cdk8s-plus-28.k8s.RollingUpdateDeployment.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString
- *Default:* 25%. Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding down. This can not be 0 if MaxSurge is 0. Defaults to 25%. Example: when this is set to 30%, the old ReplicaSet can be scaled down to 70% of desired pods immediately when the rolling update starts. Once new pods are ready, old ReplicaSet can be scaled down further, followed by scaling up the new ReplicaSet, ensuring that the total number of pods available at all times during the update is at least 70% of desired pods.

---

### RollingUpdateStatefulSetStrategy <a name="RollingUpdateStatefulSetStrategy" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy"></a>

RollingUpdateStatefulSetStrategy is used to communicate parameter for RollingUpdateStatefulSetStrategyType.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const rollingUpdateStatefulSetStrategy: k8s.RollingUpdateStatefulSetStrategy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.maxUnavailable">maxUnavailable</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | The maximum number of pods that can be unavailable during the update. |
| <code><a href="#cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.partition">partition</a></code> | <code>number</code> | Partition indicates the ordinal at which the StatefulSet should be partitioned for updates. |

---

##### `maxUnavailable`<sup>Optional</sup> <a name="maxUnavailable" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.maxUnavailable"></a>

```typescript
public readonly maxUnavailable: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString
- *Default:* 1. This field is alpha-level and is only honored by servers that enable the MaxUnavailableStatefulSet feature. The field applies to all pods in the range 0 to Replicas-1. That means if there is any unavailable pod in the range 0 to Replicas-1, it will be counted towards MaxUnavailable.

The maximum number of pods that can be unavailable during the update.

Value can be an absolute number (ex: 5) or a percentage of desired pods (ex: 10%). Absolute number is calculated from percentage by rounding up. This can not be 0. Defaults to 1. This field is alpha-level and is only honored by servers that enable the MaxUnavailableStatefulSet feature. The field applies to all pods in the range 0 to Replicas-1. That means if there is any unavailable pod in the range 0 to Replicas-1, it will be counted towards MaxUnavailable.

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number

Partition indicates the ordinal at which the StatefulSet should be partitioned for updates.

During a rolling update, all pods from ordinal Replicas-1 to Partition are updated. All pods from ordinal Partition-1 to 0 remain untouched. This is helpful in being able to do a canary based deployment. The default value is 0.

---

### RuleWithOperations <a name="RuleWithOperations" id="cdk8s-plus-28.k8s.RuleWithOperations"></a>

RuleWithOperations is a tuple of Operations and Resources.

It is recommended to make sure that all the tuple expansions are valid.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.RuleWithOperations.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const ruleWithOperations: k8s.RuleWithOperations = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.apiGroups">apiGroups</a></code> | <code>string[]</code> | APIGroups is the API groups the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.apiVersions">apiVersions</a></code> | <code>string[]</code> | APIVersions is the API versions the resources belong to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.operations">operations</a></code> | <code>string[]</code> | Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.resources">resources</a></code> | <code>string[]</code> | Resources is a list of resources this rule applies to. |
| <code><a href="#cdk8s-plus-28.k8s.RuleWithOperations.property.scope">scope</a></code> | <code>string</code> | scope specifies the scope of this rule. |

---

##### `apiGroups`<sup>Optional</sup> <a name="apiGroups" id="cdk8s-plus-28.k8s.RuleWithOperations.property.apiGroups"></a>

```typescript
public readonly apiGroups: string[];
```

- *Type:* string[]

APIGroups is the API groups the resources belong to.

'*' is all groups. If '*' is present, the length of the slice must be one. Required.

---

##### `apiVersions`<sup>Optional</sup> <a name="apiVersions" id="cdk8s-plus-28.k8s.RuleWithOperations.property.apiVersions"></a>

```typescript
public readonly apiVersions: string[];
```

- *Type:* string[]

APIVersions is the API versions the resources belong to.

'*' is all versions. If '*' is present, the length of the slice must be one. Required.

---

##### `operations`<sup>Optional</sup> <a name="operations" id="cdk8s-plus-28.k8s.RuleWithOperations.property.operations"></a>

```typescript
public readonly operations: string[];
```

- *Type:* string[]

Operations is the operations the admission hook cares about - CREATE, UPDATE, DELETE, CONNECT or * for all of those operations and any future admission operations that are added.

If '*' is present, the length of the slice must be one. Required.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.k8s.RuleWithOperations.property.resources"></a>

```typescript
public readonly resources: string[];
```

- *Type:* string[]

Resources is a list of resources this rule applies to.

For example: 'pods' means pods. 'pods/log' means the log subresource of pods. '*' means all resources, but not subresources. 'pods/*' means all subresources of pods. '_/scale' means all scale subresources. '_/*' means all resources and their subresources.

If wildcard is present, the validation rule will ensure resources do not overlap with each other.

Depending on the enclosing object, subresources might not be allowed. Required.

---

##### `scope`<sup>Optional</sup> <a name="scope" id="cdk8s-plus-28.k8s.RuleWithOperations.property.scope"></a>

```typescript
public readonly scope: string;
```

- *Type:* string
- *Default:* .

scope specifies the scope of this rule.

Valid values are "Cluster", "Namespaced", and "*" "Cluster" means that only cluster-scoped resources will match this rule. Namespace API objects are cluster-scoped. "Namespaced" means that only namespaced resources will match this rule. "*" means that there are no scope restrictions. Subresources match the scope of their parent resource. Default is "*".

---

### ScaleIoPersistentVolumeSource <a name="ScaleIoPersistentVolumeSource" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource"></a>

ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scaleIoPersistentVolumeSource: k8s.ScaleIoPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.gateway">gateway</a></code> | <code>string</code> | gateway is the host address of the ScaleIO API Gateway. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.SecretReference</code> | secretRef references to the secret for ScaleIO user and other sensitive information. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.system">system</a></code> | <code>string</code> | system is the name of the storage system as configured in ScaleIO. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.protectionDomain">protectionDomain</a></code> | <code>string</code> | protectionDomain is the name of the ScaleIO Protection Domain for the configured storage. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.sslEnabled">sslEnabled</a></code> | <code>boolean</code> | sslEnabled is the flag to enable/disable SSL communication with Gateway, default false. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storageMode">storageMode</a></code> | <code>string</code> | storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storagePool">storagePool</a></code> | <code>string</code> | storagePool is the ScaleIO Storage Pool associated with the protection domain. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.volumeName">volumeName</a></code> | <code>string</code> | volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source. |

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

gateway is the host address of the ScaleIO API Gateway.

---

##### `secretRef`<sup>Required</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: SecretReference;
```

- *Type:* cdk8s-plus-28.k8s.SecretReference

secretRef references to the secret for ScaleIO user and other sensitive information.

If this is not provided, Login operation will fail.

---

##### `system`<sup>Required</sup> <a name="system" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.system"></a>

```typescript
public readonly system: string;
```

- *Type:* string

system is the name of the storage system as configured in ScaleIO.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* xfs"

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs"

---

##### `protectionDomain`<sup>Optional</sup> <a name="protectionDomain" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.protectionDomain"></a>

```typescript
public readonly protectionDomain: string;
```

- *Type:* string

protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `sslEnabled`<sup>Optional</sup> <a name="sslEnabled" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.sslEnabled"></a>

```typescript
public readonly sslEnabled: boolean;
```

- *Type:* boolean

sslEnabled is the flag to enable/disable SSL communication with Gateway, default false.

---

##### `storageMode`<sup>Optional</sup> <a name="storageMode" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storageMode"></a>

```typescript
public readonly storageMode: string;
```

- *Type:* string
- *Default:* ThinProvisioned.

storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.

Default is ThinProvisioned.

---

##### `storagePool`<sup>Optional</sup> <a name="storagePool" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.storagePool"></a>

```typescript
public readonly storagePool: string;
```

- *Type:* string

storagePool is the ScaleIO Storage Pool associated with the protection domain.

---

##### `volumeName`<sup>Optional</sup> <a name="volumeName" id="cdk8s-plus-28.k8s.ScaleIoPersistentVolumeSource.property.volumeName"></a>

```typescript
public readonly volumeName: string;
```

- *Type:* string

volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

---

### ScaleIoVolumeSource <a name="ScaleIoVolumeSource" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource"></a>

ScaleIOVolumeSource represents a persistent ScaleIO volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scaleIoVolumeSource: k8s.ScaleIoVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.gateway">gateway</a></code> | <code>string</code> | gateway is the host address of the ScaleIO API Gateway. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef references to the secret for ScaleIO user and other sensitive information. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.system">system</a></code> | <code>string</code> | system is the name of the storage system as configured in ScaleIO. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.protectionDomain">protectionDomain</a></code> | <code>string</code> | protectionDomain is the name of the ScaleIO Protection Domain for the configured storage. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly Defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.sslEnabled">sslEnabled</a></code> | <code>boolean</code> | sslEnabled Flag enable/disable SSL communication with Gateway, default false. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storageMode">storageMode</a></code> | <code>string</code> | storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storagePool">storagePool</a></code> | <code>string</code> | storagePool is the ScaleIO Storage Pool associated with the protection domain. |
| <code><a href="#cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.volumeName">volumeName</a></code> | <code>string</code> | volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source. |

---

##### `gateway`<sup>Required</sup> <a name="gateway" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.gateway"></a>

```typescript
public readonly gateway: string;
```

- *Type:* string

gateway is the host address of the ScaleIO API Gateway.

---

##### `secretRef`<sup>Required</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef references to the secret for ScaleIO user and other sensitive information.

If this is not provided, Login operation will fail.

---

##### `system`<sup>Required</sup> <a name="system" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.system"></a>

```typescript
public readonly system: string;
```

- *Type:* string

system is the name of the storage system as configured in ScaleIO.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string
- *Default:* xfs".

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".

---

##### `protectionDomain`<sup>Optional</sup> <a name="protectionDomain" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.protectionDomain"></a>

```typescript
public readonly protectionDomain: string;
```

- *Type:* string

protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

readOnly Defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `sslEnabled`<sup>Optional</sup> <a name="sslEnabled" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.sslEnabled"></a>

```typescript
public readonly sslEnabled: boolean;
```

- *Type:* boolean

sslEnabled Flag enable/disable SSL communication with Gateway, default false.

---

##### `storageMode`<sup>Optional</sup> <a name="storageMode" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storageMode"></a>

```typescript
public readonly storageMode: string;
```

- *Type:* string
- *Default:* ThinProvisioned.

storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned.

Default is ThinProvisioned.

---

##### `storagePool`<sup>Optional</sup> <a name="storagePool" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.storagePool"></a>

```typescript
public readonly storagePool: string;
```

- *Type:* string

storagePool is the ScaleIO Storage Pool associated with the protection domain.

---

##### `volumeName`<sup>Optional</sup> <a name="volumeName" id="cdk8s-plus-28.k8s.ScaleIoVolumeSource.property.volumeName"></a>

```typescript
public readonly volumeName: string;
```

- *Type:* string

volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

---

### ScaleSpec <a name="ScaleSpec" id="cdk8s-plus-28.k8s.ScaleSpec"></a>

ScaleSpec describes the attributes of a scale subresource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScaleSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scaleSpec: k8s.ScaleSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScaleSpec.property.replicas">replicas</a></code> | <code>number</code> | replicas is the desired number of instances for the scaled object. |

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.ScaleSpec.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

replicas is the desired number of instances for the scaled object.

---

### ScalingPolicy <a name="ScalingPolicy" id="cdk8s-plus-28.ScalingPolicy"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingPolicy.Initializer"></a>

```typescript
import { ScalingPolicy } from 'cdk8s-plus-28'

const scalingPolicy: ScalingPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingPolicy.property.replicas">replicas</a></code> | <code><a href="#cdk8s-plus-28.Replicas">Replicas</a></code> | The type and quantity of replicas to change. |
| <code><a href="#cdk8s-plus-28.ScalingPolicy.property.duration">duration</a></code> | <code>cdk8s.Duration</code> | The amount of time the scaling policy has to continue scaling before the target metric must be revalidated. |

---

##### `replicas`<sup>Required</sup> <a name="replicas" id="cdk8s-plus-28.ScalingPolicy.property.replicas"></a>

```typescript
public readonly replicas: Replicas;
```

- *Type:* <a href="#cdk8s-plus-28.Replicas">Replicas</a>

The type and quantity of replicas to change.

---

##### `duration`<sup>Optional</sup> <a name="duration" id="cdk8s-plus-28.ScalingPolicy.property.duration"></a>

```typescript
public readonly duration: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* 15 seconds

The amount of time the scaling policy has to continue scaling before the target metric must be revalidated.

Must be greater than 0 seconds and no longer than 30 minutes.

---

### ScalingRules <a name="ScalingRules" id="cdk8s-plus-28.ScalingRules"></a>

Defines the scaling behavior for one direction.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingRules.Initializer"></a>

```typescript
import { ScalingRules } from 'cdk8s-plus-28'

const scalingRules: ScalingRules = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.policies">policies</a></code> | <code><a href="#cdk8s-plus-28.ScalingPolicy">ScalingPolicy</a>[]</code> | The scaling policies. |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.stabilizationWindow">stabilizationWindow</a></code> | <code>cdk8s.Duration</code> | Defines the window of past metrics that the autoscaler should consider when calculating wether or not autoscaling should occur. |
| <code><a href="#cdk8s-plus-28.ScalingRules.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.ScalingStrategy">ScalingStrategy</a></code> | The strategy to use when scaling. |

---

##### `policies`<sup>Optional</sup> <a name="policies" id="cdk8s-plus-28.ScalingRules.property.policies"></a>

```typescript
public readonly policies: ScalingPolicy[];
```

- *Type:* <a href="#cdk8s-plus-28.ScalingPolicy">ScalingPolicy</a>[]
- *Default:* * Scale up   * Increase no more than 4 pods per 60 seconds   * Double the number of pods per 60 seconds * Scale down   * Decrease to minReplica count

The scaling policies.

---

##### `stabilizationWindow`<sup>Optional</sup> <a name="stabilizationWindow" id="cdk8s-plus-28.ScalingRules.property.stabilizationWindow"></a>

```typescript
public readonly stabilizationWindow: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* * On scale down no stabilization is performed. * On scale up stabilization is performed for 5 minutes.

Defines the window of past metrics that the autoscaler should consider when calculating wether or not autoscaling should occur.

Minimum duration is 1 second, max is 1 hour.

---

*Example*

```typescript
stabilizationWindow: Duration.minutes(30)
// Autoscaler considers the last 30 minutes of metrics when deciding whether to scale.
```


##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.ScalingRules.property.strategy"></a>

```typescript
public readonly strategy: ScalingStrategy;
```

- *Type:* <a href="#cdk8s-plus-28.ScalingStrategy">ScalingStrategy</a>
- *Default:* MAX_CHANGE

The strategy to use when scaling.

---

### ScalingTarget <a name="ScalingTarget" id="cdk8s-plus-28.ScalingTarget"></a>

Properties used to configure the target of an Autoscaler.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ScalingTarget.Initializer"></a>

```typescript
import { ScalingTarget } from 'cdk8s-plus-28'

const scalingTarget: ScalingTarget = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.Container">Container</a>[]</code> | Container definitions associated with the target. |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |
| <code><a href="#cdk8s-plus-28.ScalingTarget.property.replicas">replicas</a></code> | <code>number</code> | The fixed number of replicas defined on the target. |

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ScalingTarget.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `containers`<sup>Required</sup> <a name="containers" id="cdk8s-plus-28.ScalingTarget.property.containers"></a>

```typescript
public readonly containers: Container[];
```

- *Type:* <a href="#cdk8s-plus-28.Container">Container</a>[]

Container definitions associated with the target.

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ScalingTarget.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ScalingTarget.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.ScalingTarget.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

The fixed number of replicas defined on the target.

This is used
for validation purposes as Scalable targets should not have a
fixed number of replicas.

---

### Scheduling <a name="Scheduling" id="cdk8s-plus-28.k8s.Scheduling"></a>

Scheduling specifies the scheduling constraints for nodes supporting a RuntimeClass.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Scheduling.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scheduling: k8s.Scheduling = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Scheduling.property.nodeSelector">nodeSelector</a></code> | <code>{[ key: string ]: string}</code> | nodeSelector lists labels that must be present on nodes that support this RuntimeClass. |
| <code><a href="#cdk8s-plus-28.k8s.Scheduling.property.tolerations">tolerations</a></code> | <code>cdk8s-plus-28.k8s.Toleration[]</code> | tolerations are appended (excluding duplicates) to pods running with this RuntimeClass during admission, effectively unioning the set of nodes tolerated by the pod and the RuntimeClass. |

---

##### `nodeSelector`<sup>Optional</sup> <a name="nodeSelector" id="cdk8s-plus-28.k8s.Scheduling.property.nodeSelector"></a>

```typescript
public readonly nodeSelector: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

nodeSelector lists labels that must be present on nodes that support this RuntimeClass.

Pods using this RuntimeClass can only be scheduled to a node matched by this selector. The RuntimeClass nodeSelector is merged with a pod's existing nodeSelector. Any conflicts will cause the pod to be rejected in admission.

---

##### `tolerations`<sup>Optional</sup> <a name="tolerations" id="cdk8s-plus-28.k8s.Scheduling.property.tolerations"></a>

```typescript
public readonly tolerations: Toleration[];
```

- *Type:* cdk8s-plus-28.k8s.Toleration[]

tolerations are appended (excluding duplicates) to pods running with this RuntimeClass during admission, effectively unioning the set of nodes tolerated by the pod and the RuntimeClass.

---

### ScopedResourceSelectorRequirement <a name="ScopedResourceSelectorRequirement" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement"></a>

A scoped-resource selector requirement is a selector that contains values, a scope name, and an operator that relates the scope name and values.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scopedResourceSelectorRequirement: k8s.ScopedResourceSelectorRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.operator">operator</a></code> | <code>string</code> | Represents a scope's relationship to a set of values. |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.scopeName">scopeName</a></code> | <code>string</code> | The name of the scope that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.values">values</a></code> | <code>string[]</code> | An array of string values. |

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

Represents a scope's relationship to a set of values.

Valid operators are In, NotIn, Exists, DoesNotExist.

---

##### `scopeName`<sup>Required</sup> <a name="scopeName" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.scopeName"></a>

```typescript
public readonly scopeName: string;
```

- *Type:* string

The name of the scope that the selector applies to.

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

An array of string values.

If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

---

### ScopeSelector <a name="ScopeSelector" id="cdk8s-plus-28.k8s.ScopeSelector"></a>

A scope selector represents the AND of the selectors represented by the scoped-resource selector requirements.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ScopeSelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const scopeSelector: k8s.ScopeSelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ScopeSelector.property.matchExpressions">matchExpressions</a></code> | <code>cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement[]</code> | A list of scope selector requirements by scope of the resources. |

---

##### `matchExpressions`<sup>Optional</sup> <a name="matchExpressions" id="cdk8s-plus-28.k8s.ScopeSelector.property.matchExpressions"></a>

```typescript
public readonly matchExpressions: ScopedResourceSelectorRequirement[];
```

- *Type:* cdk8s-plus-28.k8s.ScopedResourceSelectorRequirement[]

A list of scope selector requirements by scope of the resources.

---

### SeccompProfile <a name="SeccompProfile" id="cdk8s-plus-28.SeccompProfile"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SeccompProfile.Initializer"></a>

```typescript
import { SeccompProfile } from 'cdk8s-plus-28'

const seccompProfile: SeccompProfile = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SeccompProfile.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfileType">SeccompProfileType</a></code> | Indicates which kind of seccomp profile will be applied. |
| <code><a href="#cdk8s-plus-28.SeccompProfile.property.localhostProfile">localhostProfile</a></code> | <code>string</code> | localhostProfile indicates a profile defined in a file on the node should be used. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.SeccompProfile.property.type"></a>

```typescript
public readonly type: SeccompProfileType;
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfileType">SeccompProfileType</a>

Indicates which kind of seccomp profile will be applied.

---

##### `localhostProfile`<sup>Optional</sup> <a name="localhostProfile" id="cdk8s-plus-28.SeccompProfile.property.localhostProfile"></a>

```typescript
public readonly localhostProfile: string;
```

- *Type:* string
- *Default:* empty string

localhostProfile indicates a profile defined in a file on the node should be used.

The profile must be preconfigured on the node to work. Must be a descending path,
relative to the kubelet's configured seccomp profile location.
Must only be set if type is "Localhost".

---

### SeccompProfile <a name="SeccompProfile" id="cdk8s-plus-28.k8s.SeccompProfile"></a>

SeccompProfile defines a pod/container's seccomp profile settings.

Only one profile source may be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SeccompProfile.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const seccompProfile: k8s.SeccompProfile = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SeccompProfile.property.type">type</a></code> | <code>string</code> | type indicates which kind of seccomp profile will be applied. Valid options are:. |
| <code><a href="#cdk8s-plus-28.k8s.SeccompProfile.property.localhostProfile">localhostProfile</a></code> | <code>string</code> | localhostProfile indicates a profile defined in a file on the node should be used. |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.k8s.SeccompProfile.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

type indicates which kind of seccomp profile will be applied. Valid options are:.

Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.

---

##### `localhostProfile`<sup>Optional</sup> <a name="localhostProfile" id="cdk8s-plus-28.k8s.SeccompProfile.property.localhostProfile"></a>

```typescript
public readonly localhostProfile: string;
```

- *Type:* string

localhostProfile indicates a profile defined in a file on the node should be used.

The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must be set if type is "Localhost". Must NOT be set for any other type.

---

### SecretEnvSource <a name="SecretEnvSource" id="cdk8s-plus-28.k8s.SecretEnvSource"></a>

SecretEnvSource selects a Secret to populate the environment variables with.

The contents of the target Secret's Data field will represent the key-value pairs as environment variables.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretEnvSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const secretEnvSource: k8s.SecretEnvSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretEnvSource.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretEnvSource.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the Secret must be defined. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretEnvSource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretEnvSource.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

Specify whether the Secret must be defined.

---

### SecretKeySelector <a name="SecretKeySelector" id="cdk8s-plus-28.k8s.SecretKeySelector"></a>

SecretKeySelector selects a key of a Secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretKeySelector.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const secretKeySelector: k8s.SecretKeySelector = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.key">key</a></code> | <code>string</code> | The key of the secret to select from. |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretKeySelector.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the Secret or its key must be defined. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.SecretKeySelector.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The key of the secret to select from.

Must be a valid secret key.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretKeySelector.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretKeySelector.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

Specify whether the Secret or its key must be defined.

---

### SecretProjection <a name="SecretProjection" id="cdk8s-plus-28.k8s.SecretProjection"></a>

Adapts a secret into a projected volume.

The contents of the target Secret's Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretProjection.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const secretProjection: k8s.SecretProjection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KeyToPath[]</code> | items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.name">name</a></code> | <code>string</code> | Name of the referent. |
| <code><a href="#cdk8s-plus-28.k8s.SecretProjection.property.optional">optional</a></code> | <code>boolean</code> | optional field specify whether the Secret or its key must be defined. |

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.SecretProjection.property.items"></a>

```typescript
public readonly items: KeyToPath[];
```

- *Type:* cdk8s-plus-28.k8s.KeyToPath[]

items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretProjection.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the referent.

More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretProjection.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

optional field specify whether the Secret or its key must be defined.

---

### SecretProps <a name="SecretProps" id="cdk8s-plus-28.SecretProps"></a>

Options for `Secret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretProps.Initializer"></a>

```typescript
import { SecretProps } from 'cdk8s-plus-28'

const secretProps: SecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.SecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.SecretProps.property.stringData">stringData</a></code> | <code>{[ key: string ]: string}</code> | stringData allows specifying non-binary secret data in string form. |
| <code><a href="#cdk8s-plus-28.SecretProps.property.type">type</a></code> | <code>string</code> | Optional type associated with the secret. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.SecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.SecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `stringData`<sup>Optional</sup> <a name="stringData" id="cdk8s-plus-28.SecretProps.property.stringData"></a>

```typescript
public readonly stringData: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

stringData allows specifying non-binary secret data in string form.

It is
provided as a write-only convenience method. All keys and values are merged
into the data field on write, overwriting any existing values. It is never
output when reading from the API.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.SecretProps.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* undefined - Don't set a type.

Optional type associated with the secret.

Used to facilitate programmatic
handling of secret data by various controllers.

---

### SecretReference <a name="SecretReference" id="cdk8s-plus-28.k8s.SecretReference"></a>

SecretReference represents a Secret Reference.

It has enough information to retrieve secret in any namespace

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const secretReference: k8s.SecretReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretReference.property.name">name</a></code> | <code>string</code> | name is unique within a namespace to reference a secret resource. |
| <code><a href="#cdk8s-plus-28.k8s.SecretReference.property.namespace">namespace</a></code> | <code>string</code> | namespace defines the space within which the secret name must be unique. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.SecretReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is unique within a namespace to reference a secret resource.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.SecretReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

namespace defines the space within which the secret name must be unique.

---

### SecretValue <a name="SecretValue" id="cdk8s-plus-28.SecretValue"></a>

Represents a specific value in JSON secret.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretValue.Initializer"></a>

```typescript
import { SecretValue } from 'cdk8s-plus-28'

const secretValue: SecretValue = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretValue.property.key">key</a></code> | <code>string</code> | The JSON key. |
| <code><a href="#cdk8s-plus-28.SecretValue.property.secret">secret</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | The secret. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.SecretValue.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The JSON key.

---

##### `secret`<sup>Required</sup> <a name="secret" id="cdk8s-plus-28.SecretValue.property.secret"></a>

```typescript
public readonly secret: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

The secret.

---

### SecretVolumeOptions <a name="SecretVolumeOptions" id="cdk8s-plus-28.SecretVolumeOptions"></a>

Options for the Secret-based volume.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SecretVolumeOptions.Initializer"></a>

```typescript
import { SecretVolumeOptions } from 'cdk8s-plus-28'

const secretVolumeOptions: SecretVolumeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.defaultMode">defaultMode</a></code> | <code>number</code> | Mode bits to use on created files by default. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.items">items</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.PathMapping">PathMapping</a>}</code> | If unspecified, each key-value pair in the Data field of the referenced secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.name">name</a></code> | <code>string</code> | The volume name. |
| <code><a href="#cdk8s-plus-28.SecretVolumeOptions.property.optional">optional</a></code> | <code>boolean</code> | Specify whether the secret or its keys must be defined. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.SecretVolumeOptions.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

Mode bits to use on created files by default.

Must be a value between 0 and
0777. Defaults to 0644. Directories within the path are not affected by
this setting. This might be in conflict with other options that affect the
file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.SecretVolumeOptions.property.items"></a>

```typescript
public readonly items: {[ key: string ]: PathMapping};
```

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.PathMapping">PathMapping</a>}
- *Default:* no mapping

If unspecified, each key-value pair in the Data field of the referenced secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected
into the specified paths, and unlisted keys will not be present. If a key
is specified which is not present in the secret, the volume setup will
error unless it is marked optional. Paths must be relative and may not
contain the '..' path or start with '..'.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.SecretVolumeOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* auto-generated

The volume name.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.SecretVolumeOptions.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean
- *Default:* undocumented

Specify whether the secret or its keys must be defined.

---

### SecretVolumeSource <a name="SecretVolumeSource" id="cdk8s-plus-28.k8s.SecretVolumeSource"></a>

Adapts a Secret into a volume.

The contents of the target Secret's Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecretVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const secretVolumeSource: k8s.SecretVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.defaultMode">defaultMode</a></code> | <code>number</code> | defaultMode is Optional: mode bits used to set permissions on created files by default. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.items">items</a></code> | <code>cdk8s-plus-28.k8s.KeyToPath[]</code> | items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.optional">optional</a></code> | <code>boolean</code> | optional field specify whether the Secret or its keys must be defined. |
| <code><a href="#cdk8s-plus-28.k8s.SecretVolumeSource.property.secretName">secretName</a></code> | <code>string</code> | secretName is the name of the secret in the pod's namespace to use. |

---

##### `defaultMode`<sup>Optional</sup> <a name="defaultMode" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.defaultMode"></a>

```typescript
public readonly defaultMode: number;
```

- *Type:* number
- *Default:* 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

defaultMode is Optional: mode bits used to set permissions on created files by default.

Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

---

##### `items`<sup>Optional</sup> <a name="items" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.items"></a>

```typescript
public readonly items: KeyToPath[];
```

- *Type:* cdk8s-plus-28.k8s.KeyToPath[]

items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value.

If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

---

##### `optional`<sup>Optional</sup> <a name="optional" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.optional"></a>

```typescript
public readonly optional: boolean;
```

- *Type:* boolean

optional field specify whether the Secret or its keys must be defined.

---

##### `secretName`<sup>Optional</sup> <a name="secretName" id="cdk8s-plus-28.k8s.SecretVolumeSource.property.secretName"></a>

```typescript
public readonly secretName: string;
```

- *Type:* string

secretName is the name of the secret in the pod's namespace to use.

More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

---

### SecurityContext <a name="SecurityContext" id="cdk8s-plus-28.k8s.SecurityContext"></a>

SecurityContext holds security configuration that will be applied to a container.

Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SecurityContext.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const securityContext: k8s.SecurityContext = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.allowPrivilegeEscalation">allowPrivilegeEscalation</a></code> | <code>boolean</code> | AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.capabilities">capabilities</a></code> | <code>cdk8s-plus-28.k8s.Capabilities</code> | The capabilities to add/drop when running containers. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.privileged">privileged</a></code> | <code>boolean</code> | Run container in privileged mode. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.procMount">procMount</a></code> | <code>string</code> | procMount denotes the type of proc mount to use for the containers. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.readOnlyRootFilesystem">readOnlyRootFilesystem</a></code> | <code>boolean</code> | Whether this container has a read-only root filesystem. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsGroup">runAsGroup</a></code> | <code>number</code> | The GID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsNonRoot">runAsNonRoot</a></code> | <code>boolean</code> | Indicates that the container must run as a non-root user. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.runAsUser">runAsUser</a></code> | <code>number</code> | The UID to run the entrypoint of the container process. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.seccompProfile">seccompProfile</a></code> | <code>cdk8s-plus-28.k8s.SeccompProfile</code> | The seccomp options to use by this container. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.seLinuxOptions">seLinuxOptions</a></code> | <code>cdk8s-plus-28.k8s.SeLinuxOptions</code> | The SELinux context to be applied to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SecurityContext.property.windowsOptions">windowsOptions</a></code> | <code>cdk8s-plus-28.k8s.WindowsSecurityContextOptions</code> | The Windows specific settings applied to all containers. |

---

##### `allowPrivilegeEscalation`<sup>Optional</sup> <a name="allowPrivilegeEscalation" id="cdk8s-plus-28.k8s.SecurityContext.property.allowPrivilegeEscalation"></a>

```typescript
public readonly allowPrivilegeEscalation: boolean;
```

- *Type:* boolean

AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process.

This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.k8s.SecurityContext.property.capabilities"></a>

```typescript
public readonly capabilities: Capabilities;
```

- *Type:* cdk8s-plus-28.k8s.Capabilities
- *Default:* the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.

The capabilities to add/drop when running containers.

Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.

---

##### `privileged`<sup>Optional</sup> <a name="privileged" id="cdk8s-plus-28.k8s.SecurityContext.property.privileged"></a>

```typescript
public readonly privileged: boolean;
```

- *Type:* boolean
- *Default:* false. Note that this field cannot be set when spec.os.name is windows.

Run container in privileged mode.

Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.

---

##### `procMount`<sup>Optional</sup> <a name="procMount" id="cdk8s-plus-28.k8s.SecurityContext.property.procMount"></a>

```typescript
public readonly procMount: string;
```

- *Type:* string

procMount denotes the type of proc mount to use for the containers.

The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.

---

##### `readOnlyRootFilesystem`<sup>Optional</sup> <a name="readOnlyRootFilesystem" id="cdk8s-plus-28.k8s.SecurityContext.property.readOnlyRootFilesystem"></a>

```typescript
public readonly readOnlyRootFilesystem: boolean;
```

- *Type:* boolean
- *Default:* false. Note that this field cannot be set when spec.os.name is windows.

Whether this container has a read-only root filesystem.

Default is false. Note that this field cannot be set when spec.os.name is windows.

---

##### `runAsGroup`<sup>Optional</sup> <a name="runAsGroup" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsGroup"></a>

```typescript
public readonly runAsGroup: number;
```

- *Type:* number

The GID to run the entrypoint of the container process.

Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `runAsNonRoot`<sup>Optional</sup> <a name="runAsNonRoot" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsNonRoot"></a>

```typescript
public readonly runAsNonRoot: boolean;
```

- *Type:* boolean

Indicates that the container must run as a non-root user.

If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

##### `runAsUser`<sup>Optional</sup> <a name="runAsUser" id="cdk8s-plus-28.k8s.SecurityContext.property.runAsUser"></a>

```typescript
public readonly runAsUser: number;
```

- *Type:* number
- *Default:* user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

The UID to run the entrypoint of the container process.

Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `seccompProfile`<sup>Optional</sup> <a name="seccompProfile" id="cdk8s-plus-28.k8s.SecurityContext.property.seccompProfile"></a>

```typescript
public readonly seccompProfile: SeccompProfile;
```

- *Type:* cdk8s-plus-28.k8s.SeccompProfile

The seccomp options to use by this container.

If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.

---

##### `seLinuxOptions`<sup>Optional</sup> <a name="seLinuxOptions" id="cdk8s-plus-28.k8s.SecurityContext.property.seLinuxOptions"></a>

```typescript
public readonly seLinuxOptions: SeLinuxOptions;
```

- *Type:* cdk8s-plus-28.k8s.SeLinuxOptions

The SELinux context to be applied to the container.

If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

---

##### `windowsOptions`<sup>Optional</sup> <a name="windowsOptions" id="cdk8s-plus-28.k8s.SecurityContext.property.windowsOptions"></a>

```typescript
public readonly windowsOptions: WindowsSecurityContextOptions;
```

- *Type:* cdk8s-plus-28.k8s.WindowsSecurityContextOptions

The Windows specific settings applied to all containers.

If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

---

### SelfSubjectAccessReviewSpec <a name="SelfSubjectAccessReviewSpec" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec"></a>

SelfSubjectAccessReviewSpec is a description of the access request.

Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const selfSubjectAccessReviewSpec: k8s.SelfSubjectAccessReviewSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.nonResourceAttributes">nonResourceAttributes</a></code> | <code>cdk8s-plus-28.k8s.NonResourceAttributes</code> | NonResourceAttributes describes information for a non-resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.resourceAttributes">resourceAttributes</a></code> | <code>cdk8s-plus-28.k8s.ResourceAttributes</code> | ResourceAuthorizationAttributes describes information for a resource access request. |

---

##### `nonResourceAttributes`<sup>Optional</sup> <a name="nonResourceAttributes" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.nonResourceAttributes"></a>

```typescript
public readonly nonResourceAttributes: NonResourceAttributes;
```

- *Type:* cdk8s-plus-28.k8s.NonResourceAttributes

NonResourceAttributes describes information for a non-resource access request.

---

##### `resourceAttributes`<sup>Optional</sup> <a name="resourceAttributes" id="cdk8s-plus-28.k8s.SelfSubjectAccessReviewSpec.property.resourceAttributes"></a>

```typescript
public readonly resourceAttributes: ResourceAttributes;
```

- *Type:* cdk8s-plus-28.k8s.ResourceAttributes

ResourceAuthorizationAttributes describes information for a resource access request.

---

### SelfSubjectRulesReviewSpec <a name="SelfSubjectRulesReviewSpec" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec"></a>

SelfSubjectRulesReviewSpec defines the specification for SelfSubjectRulesReview.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const selfSubjectRulesReviewSpec: k8s.SelfSubjectRulesReviewSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.property.namespace">namespace</a></code> | <code>string</code> | Namespace to evaluate rules for. |

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.SelfSubjectRulesReviewSpec.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace to evaluate rules for.

Required.

---

### SeLinuxOptions <a name="SeLinuxOptions" id="cdk8s-plus-28.k8s.SeLinuxOptions"></a>

SELinuxOptions are the labels to be applied to the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SeLinuxOptions.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const seLinuxOptions: k8s.SeLinuxOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.level">level</a></code> | <code>string</code> | Level is SELinux level label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.role">role</a></code> | <code>string</code> | Role is a SELinux role label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.type">type</a></code> | <code>string</code> | Type is a SELinux type label that applies to the container. |
| <code><a href="#cdk8s-plus-28.k8s.SeLinuxOptions.property.user">user</a></code> | <code>string</code> | User is a SELinux user label that applies to the container. |

---

##### `level`<sup>Optional</sup> <a name="level" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.level"></a>

```typescript
public readonly level: string;
```

- *Type:* string

Level is SELinux level label that applies to the container.

---

##### `role`<sup>Optional</sup> <a name="role" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.role"></a>

```typescript
public readonly role: string;
```

- *Type:* string

Role is a SELinux role label that applies to the container.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

Type is a SELinux type label that applies to the container.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SeLinuxOptions.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

User is a SELinux user label that applies to the container.

---

### ServiceAccountProps <a name="ServiceAccountProps" id="cdk8s-plus-28.ServiceAccountProps"></a>

Properties for initialization of `ServiceAccount`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceAccountProps.Initializer"></a>

```typescript
import { ServiceAccountProps } from 'cdk8s-plus-28'

const serviceAccountProps: ServiceAccountProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.automountToken">automountToken</a></code> | <code>boolean</code> | Indicates whether pods running as this service account should have an API token automatically mounted. |
| <code><a href="#cdk8s-plus-28.ServiceAccountProps.property.secrets">secrets</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a>[]</code> | List of secrets allowed to be used by pods running using this ServiceAccount. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountToken`<sup>Optional</sup> <a name="automountToken" id="cdk8s-plus-28.ServiceAccountProps.property.automountToken"></a>

```typescript
public readonly automountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether pods running as this service account should have an API token automatically mounted.

Can be overridden at the pod level.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `secrets`<sup>Optional</sup> <a name="secrets" id="cdk8s-plus-28.ServiceAccountProps.property.secrets"></a>

```typescript
public readonly secrets: ISecret[];
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>[]

List of secrets allowed to be used by pods running using this ServiceAccount.

> [https://kubernetes.io/docs/concepts/configuration/secret](https://kubernetes.io/docs/concepts/configuration/secret)

---

### ServiceAccountSubjectV1Beta2 <a name="ServiceAccountSubjectV1Beta2" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2"></a>

ServiceAccountSubject holds detailed information for service-account-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceAccountSubjectV1Beta2: k8s.ServiceAccountSubjectV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.name">name</a></code> | <code>string</code> | `name` is the name of matching ServiceAccount objects, or "*" to match regardless of name. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.namespace">namespace</a></code> | <code>string</code> | `namespace` is the namespace of matching ServiceAccount objects. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of matching ServiceAccount objects, or "*" to match regardless of name.

Required.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

`namespace` is the namespace of matching ServiceAccount objects.

Required.

---

### ServiceAccountSubjectV1Beta3 <a name="ServiceAccountSubjectV1Beta3" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3"></a>

ServiceAccountSubject holds detailed information for service-account-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceAccountSubjectV1Beta3: k8s.ServiceAccountSubjectV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.name">name</a></code> | <code>string</code> | `name` is the name of matching ServiceAccount objects, or "*" to match regardless of name. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.namespace">namespace</a></code> | <code>string</code> | `namespace` is the namespace of matching ServiceAccount objects. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of matching ServiceAccount objects, or "*" to match regardless of name.

Required.

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

`namespace` is the namespace of matching ServiceAccount objects.

Required.

---

### ServiceAccountTokenProjection <a name="ServiceAccountTokenProjection" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection"></a>

ServiceAccountTokenProjection represents a projected service account token volume.

This projection can be used to insert a service account token into the pods runtime filesystem for use against APIs (Kubernetes API Server or otherwise).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceAccountTokenProjection: k8s.ServiceAccountTokenProjection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.path">path</a></code> | <code>string</code> | path is the path relative to the mount point of the file to project the token into. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.audience">audience</a></code> | <code>string</code> | audience is the intended audience of the token. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.expirationSeconds">expirationSeconds</a></code> | <code>number</code> | expirationSeconds is the requested duration of validity of the service account token. |

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

path is the path relative to the mount point of the file to project the token into.

---

##### `audience`<sup>Optional</sup> <a name="audience" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.audience"></a>

```typescript
public readonly audience: string;
```

- *Type:* string

audience is the intended audience of the token.

A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.

---

##### `expirationSeconds`<sup>Optional</sup> <a name="expirationSeconds" id="cdk8s-plus-28.k8s.ServiceAccountTokenProjection.property.expirationSeconds"></a>

```typescript
public readonly expirationSeconds: number;
```

- *Type:* number
- *Default:* 1 hour and must be at least 10 minutes.

expirationSeconds is the requested duration of validity of the service account token.

As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.

---

### ServiceAccountTokenSecretProps <a name="ServiceAccountTokenSecretProps" id="cdk8s-plus-28.ServiceAccountTokenSecretProps"></a>

Options for `ServiceAccountTokenSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.Initializer"></a>

```typescript
import { ServiceAccountTokenSecretProps } from 'cdk8s-plus-28'

const serviceAccountTokenSecretProps: ServiceAccountTokenSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.ServiceAccountTokenSecretProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | The service account to store a secret for. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `serviceAccount`<sup>Required</sup> <a name="serviceAccount" id="cdk8s-plus-28.ServiceAccountTokenSecretProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

The service account to store a secret for.

---

### ServiceBackendPort <a name="ServiceBackendPort" id="cdk8s-plus-28.k8s.ServiceBackendPort"></a>

ServiceBackendPort is the service port being referenced.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceBackendPort.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceBackendPort: k8s.ServiceBackendPort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceBackendPort.property.name">name</a></code> | <code>string</code> | name is the name of the port on the Service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceBackendPort.property.number">number</a></code> | <code>number</code> | number is the numerical port number (e.g. 80) on the Service. This is a mutually exclusive setting with "Name". |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceBackendPort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name is the name of the port on the Service.

This is a mutually exclusive setting with "Number".

---

##### `number`<sup>Optional</sup> <a name="number" id="cdk8s-plus-28.k8s.ServiceBackendPort.property.number"></a>

```typescript
public readonly number: number;
```

- *Type:* number

number is the numerical port number (e.g. 80) on the Service. This is a mutually exclusive setting with "Name".

---

### ServiceBindOptions <a name="ServiceBindOptions" id="cdk8s-plus-28.ServiceBindOptions"></a>

Options for `Service.bind`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceBindOptions.Initializer"></a>

```typescript
import { ServiceBindOptions } from 'cdk8s-plus-28'

const serviceBindOptions: ServiceBindOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.name">name</a></code> | <code>string</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.nodePort">nodePort</a></code> | <code>number</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.ServiceBindOptions.property.targetPort">targetPort</a></code> | <code>number</code> | The port number the service will redirect to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ServiceBindOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `nodePort`<sup>Optional</sup> <a name="nodePort" id="cdk8s-plus-28.ServiceBindOptions.property.nodePort"></a>

```typescript
public readonly nodePort: number;
```

- *Type:* number
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ServiceBindOptions.property.protocol"></a>

```typescript
public readonly protocol: Protocol;
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `targetPort`<sup>Optional</sup> <a name="targetPort" id="cdk8s-plus-28.ServiceBindOptions.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

### ServiceIngressBackendOptions <a name="ServiceIngressBackendOptions" id="cdk8s-plus-28.ServiceIngressBackendOptions"></a>

Options for setting up backends for ingress rules.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceIngressBackendOptions.Initializer"></a>

```typescript
import { ServiceIngressBackendOptions } from 'cdk8s-plus-28'

const serviceIngressBackendOptions: ServiceIngressBackendOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceIngressBackendOptions.property.port">port</a></code> | <code>number</code> | The port to use to access the service. |

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.ServiceIngressBackendOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* if the service exposes a single port, this port will be used.

The port to use to access the service.

This option will fail if the service does not expose any ports.
- If the service exposes multiple ports, this option must be specified.
- If the service exposes a single port, this option is optional and if
   specified, it must be the same port exposed by the service.

---

### ServicePort <a name="ServicePort" id="cdk8s-plus-28.ServicePort"></a>

Definition of a service port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServicePort.Initializer"></a>

```typescript
import { ServicePort } from 'cdk8s-plus-28'

const servicePort: ServicePort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServicePort.property.name">name</a></code> | <code>string</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.nodePort">nodePort</a></code> | <code>number</code> | The port on each node on which this service is exposed when type=NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.protocol">protocol</a></code> | <code><a href="#cdk8s-plus-28.Protocol">Protocol</a></code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.targetPort">targetPort</a></code> | <code>number</code> | The port number the service will redirect to. |
| <code><a href="#cdk8s-plus-28.ServicePort.property.port">port</a></code> | <code>number</code> | The port number the service will bind to. |

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.ServicePort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this port within the service.

This must be a DNS_LABEL. All
ports within a ServiceSpec must have unique names. This maps to the 'Name'
field in EndpointPort objects. Optional if only one ServicePort is defined
on this service.

---

##### `nodePort`<sup>Optional</sup> <a name="nodePort" id="cdk8s-plus-28.ServicePort.property.nodePort"></a>

```typescript
public readonly nodePort: number;
```

- *Type:* number
- *Default:* auto-allocate a port if the ServiceType of this Service requires one.

The port on each node on which this service is exposed when type=NodePort or LoadBalancer.

Usually assigned by the system. If specified, it will be
allocated to the service if unused or else creation of the service will
fail. Default is to auto-allocate a port if the ServiceType of this Service
requires one.

> [https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport](https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport)

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.ServicePort.property.protocol"></a>

```typescript
public readonly protocol: Protocol;
```

- *Type:* <a href="#cdk8s-plus-28.Protocol">Protocol</a>
- *Default:* Protocol.TCP

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `targetPort`<sup>Optional</sup> <a name="targetPort" id="cdk8s-plus-28.ServicePort.property.targetPort"></a>

```typescript
public readonly targetPort: number;
```

- *Type:* number
- *Default:* The value of `port` will be used.

The port number the service will redirect to.

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.ServicePort.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

The port number the service will bind to.

---

### ServicePort <a name="ServicePort" id="cdk8s-plus-28.k8s.ServicePort"></a>

ServicePort contains information on service's port.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServicePort.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const servicePort: k8s.ServicePort = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.port">port</a></code> | <code>number</code> | The port that will be exposed by this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.appProtocol">appProtocol</a></code> | <code>string</code> | The application protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.name">name</a></code> | <code>string</code> | The name of this port within the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.nodePort">nodePort</a></code> | <code>number</code> | The port on each node on which this service is exposed when type is NodePort or LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.protocol">protocol</a></code> | <code>string</code> | The IP protocol for this port. |
| <code><a href="#cdk8s-plus-28.k8s.ServicePort.property.targetPort">targetPort</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | Number or name of the port to access on the pods targeted by the service. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.ServicePort.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number

The port that will be exposed by this service.

---

##### `appProtocol`<sup>Optional</sup> <a name="appProtocol" id="cdk8s-plus-28.k8s.ServicePort.property.appProtocol"></a>

```typescript
public readonly appProtocol: string;
```

- *Type:* string

The application protocol for this port.

This is used as a hint for implementations to offer richer behavior for protocols that they understand. This field follows standard Kubernetes label syntax. Valid values are either:

* Un-prefixed protocol names - reserved for IANA standard service names (as per RFC-6335 and https://www.iana.org/assignments/service-names).

* Kubernetes-defined prefixed names:
* 'kubernetes.io/h2c' - HTTP/2 over cleartext as described in https://www.rfc-editor.org/rfc/rfc7540
* 'kubernetes.io/ws'  - WebSocket over cleartext as described in https://www.rfc-editor.org/rfc/rfc6455
* 'kubernetes.io/wss' - WebSocket over TLS as described in https://www.rfc-editor.org/rfc/rfc6455

* Other protocols should use implementation-defined prefixed names such as mycompany.com/my-custom-protocol.

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.ServicePort.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of this port within the service.

This must be a DNS_LABEL. All ports within a ServiceSpec must have unique names. When considering the endpoints for a Service, this must match the 'name' field in the EndpointPort. Optional if only one ServicePort is defined on this service.

---

##### `nodePort`<sup>Optional</sup> <a name="nodePort" id="cdk8s-plus-28.k8s.ServicePort.property.nodePort"></a>

```typescript
public readonly nodePort: number;
```

- *Type:* number

The port on each node on which this service is exposed when type is NodePort or LoadBalancer.

Usually assigned by the system. If a value is specified, in-range, and not in use it will be used, otherwise the operation will fail.  If not specified, a port will be allocated if this Service requires one.  If this field is specified when creating a Service which does not need it, creation will fail. This field will be wiped when updating a Service to no longer need it (e.g. changing type from NodePort to ClusterIP). More info: https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport

---

##### `protocol`<sup>Optional</sup> <a name="protocol" id="cdk8s-plus-28.k8s.ServicePort.property.protocol"></a>

```typescript
public readonly protocol: string;
```

- *Type:* string
- *Default:* TCP.

The IP protocol for this port.

Supports "TCP", "UDP", and "SCTP". Default is TCP.

---

##### `targetPort`<sup>Optional</sup> <a name="targetPort" id="cdk8s-plus-28.k8s.ServicePort.property.targetPort"></a>

```typescript
public readonly targetPort: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

Number or name of the port to access on the pods targeted by the service.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. If this is a string, it will be looked up as a named port in the target Pod's container ports. If this is not specified, the value of the 'port' field is used (an identity map). This field is ignored for services with clusterIP=None, and should be omitted or set equal to the 'port' field. More info: https://kubernetes.io/docs/concepts/services-networking/service/#defining-a-service

---

### ServiceProps <a name="ServiceProps" id="cdk8s-plus-28.ServiceProps"></a>

Properties for `Service`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.ServiceProps.Initializer"></a>

```typescript
import { ServiceProps } from 'cdk8s-plus-28'

const serviceProps: ServiceProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.clusterIP">clusterIP</a></code> | <code>string</code> | The IP address of the service and is usually assigned randomly by the master. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.externalIPs">externalIPs</a></code> | <code>string[]</code> | A list of IP addresses for which nodes in the cluster will also accept traffic for this service. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.externalName">externalName</a></code> | <code>string</code> | The externalName to be used when ServiceType.EXTERNAL_NAME is set. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.loadBalancerSourceRanges">loadBalancerSourceRanges</a></code> | <code>string[]</code> | A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]</code> | The ports this service binds to. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.publishNotReadyAddresses">publishNotReadyAddresses</a></code> | <code>boolean</code> | The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.selector">selector</a></code> | <code><a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a></code> | Which pods should the service select and route to. |
| <code><a href="#cdk8s-plus-28.ServiceProps.property.type">type</a></code> | <code><a href="#cdk8s-plus-28.ServiceType">ServiceType</a></code> | Determines how the Service is exposed. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.ServiceProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `clusterIP`<sup>Optional</sup> <a name="clusterIP" id="cdk8s-plus-28.ServiceProps.property.clusterIP"></a>

```typescript
public readonly clusterIP: string;
```

- *Type:* string
- *Default:* Automatically assigned.

The IP address of the service and is usually assigned randomly by the master.

If an address is specified manually and is not in use by others, it
will be allocated to the service; otherwise, creation of the service will
fail. This field can not be changed through updates. Valid values are
"None", empty string (""), or a valid IP address. "None" can be specified
for headless services when proxying is not required. Only applies to types
ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName.

> [https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies](https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies)

---

##### `externalIPs`<sup>Optional</sup> <a name="externalIPs" id="cdk8s-plus-28.ServiceProps.property.externalIPs"></a>

```typescript
public readonly externalIPs: string[];
```

- *Type:* string[]
- *Default:* No external IPs.

A list of IP addresses for which nodes in the cluster will also accept traffic for this service.

These IPs are not managed by Kubernetes. The user
is responsible for ensuring that traffic arrives at a node with this IP. A
common example is external load-balancers that are not part of the
Kubernetes system.

---

##### `externalName`<sup>Optional</sup> <a name="externalName" id="cdk8s-plus-28.ServiceProps.property.externalName"></a>

```typescript
public readonly externalName: string;
```

- *Type:* string
- *Default:* No external name.

The externalName to be used when ServiceType.EXTERNAL_NAME is set.

---

##### `loadBalancerSourceRanges`<sup>Optional</sup> <a name="loadBalancerSourceRanges" id="cdk8s-plus-28.ServiceProps.property.loadBalancerSourceRanges"></a>

```typescript
public readonly loadBalancerSourceRanges: string[];
```

- *Type:* string[]

A list of CIDR IP addresses, if specified and supported by the platform, will restrict traffic through the cloud-provider load-balancer to the specified client IPs.

More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.ServiceProps.property.ports"></a>

```typescript
public readonly ports: ServicePort[];
```

- *Type:* <a href="#cdk8s-plus-28.ServicePort">ServicePort</a>[]
- *Default:* either the selector ports, or none.

The ports this service binds to.

If the selector of the service is a managed pod / workload,
its ports will are automatically extracted and used as the default value.
Otherwise, no ports are bound.

---

##### `publishNotReadyAddresses`<sup>Optional</sup> <a name="publishNotReadyAddresses" id="cdk8s-plus-28.ServiceProps.property.publishNotReadyAddresses"></a>

```typescript
public readonly publishNotReadyAddresses: boolean;
```

- *Type:* boolean
- *Default:* false

The publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready.

More info: https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.30/#servicespec-v1-core

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.ServiceProps.property.selector"></a>

```typescript
public readonly selector: IPodSelector;
```

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>
- *Default:* unset, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify.

Which pods should the service select and route to.

You can pass one of the following:

- An instance of `Pod` or any workload resource (e.g `Deployment`, `StatefulSet`, ...)
- Pods selected by the `Pods.select` function. Note that in this case only labels can be specified.

---

*Example*

```typescript
// select the pods of a specific deployment
const backend = new kplus.Deployment(this, 'Backend', ...);
new kplus.Service(this, 'Service', { selector: backend });

// select all pods labeled with the `tier=backend` label
const backend = kplus.Pod.labeled({ tier: 'backend' });
new kplus.Service(this, 'Service', { selector: backend });
```


##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.ServiceProps.property.type"></a>

```typescript
public readonly type: ServiceType;
```

- *Type:* <a href="#cdk8s-plus-28.ServiceType">ServiceType</a>
- *Default:* ServiceType.ClusterIP

Determines how the Service is exposed.

More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

---

### ServiceReference <a name="ServiceReference" id="cdk8s-plus-28.k8s.ServiceReference"></a>

ServiceReference holds a reference to Service.legacy.k8s.io.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceReference: k8s.ServiceReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.name">name</a></code> | <code>string</code> | `name` is the name of the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.namespace">namespace</a></code> | <code>string</code> | `namespace` is the namespace of the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.path">path</a></code> | <code>string</code> | `path` is an optional URL path which will be sent in any request to this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceReference.property.port">port</a></code> | <code>number</code> | If specified, the port on the service that hosting webhook. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ServiceReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the name of the service.

Required

---

##### `namespace`<sup>Required</sup> <a name="namespace" id="cdk8s-plus-28.k8s.ServiceReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

`namespace` is the namespace of the service.

Required

---

##### `path`<sup>Optional</sup> <a name="path" id="cdk8s-plus-28.k8s.ServiceReference.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

`path` is an optional URL path which will be sent in any request to this service.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.k8s.ServiceReference.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* 443 for backward compatibility. `port` should be a valid port number (1-65535, inclusive).

If specified, the port on the service that hosting webhook.

Default to 443 for backward compatibility. `port` should be a valid port number (1-65535, inclusive).

---

### ServiceSpec <a name="ServiceSpec" id="cdk8s-plus-28.k8s.ServiceSpec"></a>

ServiceSpec describes the attributes that a user creates on a service.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ServiceSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const serviceSpec: k8s.ServiceSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.allocateLoadBalancerNodePorts">allocateLoadBalancerNodePorts</a></code> | <code>boolean</code> | allocateLoadBalancerNodePorts defines if NodePorts will be automatically allocated for services with type LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.clusterIp">clusterIp</a></code> | <code>string</code> | clusterIP is the IP address of the service and is usually assigned randomly. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.clusterIPs">clusterIPs</a></code> | <code>string[]</code> | ClusterIPs is a list of IP addresses assigned to this service, and are usually assigned randomly. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalIPs">externalIPs</a></code> | <code>string[]</code> | externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalName">externalName</a></code> | <code>string</code> | externalName is the external reference that discovery mechanisms will return as an alias for this service (e.g. a DNS CNAME record). No proxying will be involved.  Must be a lowercase RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires `type` to be "ExternalName". |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.externalTrafficPolicy">externalTrafficPolicy</a></code> | <code>string</code> | externalTrafficPolicy describes how nodes distribute service traffic they receive on one of the Service's "externally-facing" addresses (NodePorts, ExternalIPs, and LoadBalancer IPs). |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.healthCheckNodePort">healthCheckNodePort</a></code> | <code>number</code> | healthCheckNodePort specifies the healthcheck nodePort for the service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.internalTrafficPolicy">internalTrafficPolicy</a></code> | <code>string</code> | InternalTrafficPolicy describes how nodes distribute service traffic they receive on the ClusterIP. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilies">ipFamilies</a></code> | <code>string[]</code> | IPFamilies is a list of IP families (e.g. IPv4, IPv6) assigned to this service. This field is usually assigned automatically based on cluster configuration and the ipFamilyPolicy field. If this field is specified manually, the requested family is available in the cluster, and ipFamilyPolicy allows it, it will be used; otherwise creation of the service will fail. This field is conditionally mutable: it allows for adding or removing a secondary IP family, but it does not allow changing the primary IP family of the Service. Valid values are "IPv4" and "IPv6".  This field only applies to Services of types ClusterIP, NodePort, and LoadBalancer, and does apply to "headless" services. This field will be wiped when updating a Service to type ExternalName. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilyPolicy">ipFamilyPolicy</a></code> | <code>string</code> | IPFamilyPolicy represents the dual-stack-ness requested or required by this Service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerClass">loadBalancerClass</a></code> | <code>string</code> | loadBalancerClass is the class of the load balancer implementation this Service belongs to. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerIp">loadBalancerIp</a></code> | <code>string</code> | Only applies to Service Type: LoadBalancer. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerSourceRanges">loadBalancerSourceRanges</a></code> | <code>string[]</code> | If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.ports">ports</a></code> | <code>cdk8s-plus-28.k8s.ServicePort[]</code> | The list of ports that are exposed by this service. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.publishNotReadyAddresses">publishNotReadyAddresses</a></code> | <code>boolean</code> | publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.selector">selector</a></code> | <code>{[ key: string ]: string}</code> | Route service traffic to pods with label keys and values matching this selector. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinity">sessionAffinity</a></code> | <code>string</code> | Supports "ClientIP" and "None". |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinityConfig">sessionAffinityConfig</a></code> | <code>cdk8s-plus-28.k8s.SessionAffinityConfig</code> | sessionAffinityConfig contains the configurations of session affinity. |
| <code><a href="#cdk8s-plus-28.k8s.ServiceSpec.property.type">type</a></code> | <code>string</code> | type determines how the Service is exposed. |

---

##### `allocateLoadBalancerNodePorts`<sup>Optional</sup> <a name="allocateLoadBalancerNodePorts" id="cdk8s-plus-28.k8s.ServiceSpec.property.allocateLoadBalancerNodePorts"></a>

```typescript
public readonly allocateLoadBalancerNodePorts: boolean;
```

- *Type:* boolean
- *Default:* true". It may be set to "false" if the cluster load-balancer does not rely on NodePorts.  If the caller requests specific NodePorts (by specifying a value), those requests will be respected, regardless of this field. This field may only be set for services with type LoadBalancer and will be cleared if the type is changed to any other type.

allocateLoadBalancerNodePorts defines if NodePorts will be automatically allocated for services with type LoadBalancer.

Default is "true". It may be set to "false" if the cluster load-balancer does not rely on NodePorts.  If the caller requests specific NodePorts (by specifying a value), those requests will be respected, regardless of this field. This field may only be set for services with type LoadBalancer and will be cleared if the type is changed to any other type.

---

##### `clusterIp`<sup>Optional</sup> <a name="clusterIp" id="cdk8s-plus-28.k8s.ServiceSpec.property.clusterIp"></a>

```typescript
public readonly clusterIp: string;
```

- *Type:* string

clusterIP is the IP address of the service and is usually assigned randomly.

If an address is specified manually, is in-range (as per system configuration), and is not in use, it will be allocated to the service; otherwise creation of the service will fail. This field may not be changed through updates unless the type field is also being changed to ExternalName (which requires this field to be blank) or the type field is being changed from ExternalName (in which case this field may optionally be specified, as describe above).  Valid values are "None", empty string (""), or a valid IP address. Setting this to "None" makes a "headless service" (no virtual IP), which is useful when direct endpoint connections are preferred and proxying is not required.  Only applies to types ClusterIP, NodePort, and LoadBalancer. If this field is specified when creating a Service of type ExternalName, creation will fail. This field will be wiped when updating a Service to type ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `clusterIPs`<sup>Optional</sup> <a name="clusterIPs" id="cdk8s-plus-28.k8s.ServiceSpec.property.clusterIPs"></a>

```typescript
public readonly clusterIPs: string[];
```

- *Type:* string[]

ClusterIPs is a list of IP addresses assigned to this service, and are usually assigned randomly.

If an address is specified manually, is in-range (as per system configuration), and is not in use, it will be allocated to the service; otherwise creation of the service will fail. This field may not be changed through updates unless the type field is also being changed to ExternalName (which requires this field to be empty) or the type field is being changed from ExternalName (in which case this field may optionally be specified, as describe above).  Valid values are "None", empty string (""), or a valid IP address.  Setting this to "None" makes a "headless service" (no virtual IP), which is useful when direct endpoint connections are preferred and proxying is not required.  Only applies to types ClusterIP, NodePort, and LoadBalancer. If this field is specified when creating a Service of type ExternalName, creation will fail. This field will be wiped when updating a Service to type ExternalName.  If this field is not specified, it will be initialized from the clusterIP field.  If this field is specified, clients must ensure that clusterIPs[0] and clusterIP have the same value.

This field may hold a maximum of two entries (dual-stack IPs, in either order). These IPs must correspond to the values of the ipFamilies field. Both clusterIPs and ipFamilies are governed by the ipFamilyPolicy field. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `externalIPs`<sup>Optional</sup> <a name="externalIPs" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalIPs"></a>

```typescript
public readonly externalIPs: string[];
```

- *Type:* string[]

externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service.

These IPs are not managed by Kubernetes.  The user is responsible for ensuring that traffic arrives at a node with this IP.  A common example is external load-balancers that are not part of the Kubernetes system.

---

##### `externalName`<sup>Optional</sup> <a name="externalName" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalName"></a>

```typescript
public readonly externalName: string;
```

- *Type:* string

externalName is the external reference that discovery mechanisms will return as an alias for this service (e.g. a DNS CNAME record). No proxying will be involved.  Must be a lowercase RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires `type` to be "ExternalName".

---

##### `externalTrafficPolicy`<sup>Optional</sup> <a name="externalTrafficPolicy" id="cdk8s-plus-28.k8s.ServiceSpec.property.externalTrafficPolicy"></a>

```typescript
public readonly externalTrafficPolicy: string;
```

- *Type:* string

externalTrafficPolicy describes how nodes distribute service traffic they receive on one of the Service's "externally-facing" addresses (NodePorts, ExternalIPs, and LoadBalancer IPs).

If set to "Local", the proxy will configure the service in a way that assumes that external load balancers will take care of balancing the service traffic between nodes, and so each node will deliver traffic only to the node-local endpoints of the service, without masquerading the client source IP. (Traffic mistakenly sent to a node with no endpoints will be dropped.) The default value, "Cluster", uses the standard behavior of routing to all endpoints evenly (possibly modified by topology and other features). Note that traffic sent to an External IP or LoadBalancer IP from within the cluster will always get "Cluster" semantics, but clients sending to a NodePort from within the cluster may need to take traffic policy into account when picking a node.

---

##### `healthCheckNodePort`<sup>Optional</sup> <a name="healthCheckNodePort" id="cdk8s-plus-28.k8s.ServiceSpec.property.healthCheckNodePort"></a>

```typescript
public readonly healthCheckNodePort: number;
```

- *Type:* number

healthCheckNodePort specifies the healthcheck nodePort for the service.

This only applies when type is set to LoadBalancer and externalTrafficPolicy is set to Local. If a value is specified, is in-range, and is not in use, it will be used.  If not specified, a value will be automatically allocated.  External systems (e.g. load-balancers) can use this port to determine if a given node holds endpoints for this service or not.  If this field is specified when creating a Service which does not need it, creation will fail. This field will be wiped when updating a Service to no longer need it (e.g. changing type). This field cannot be updated once set.

---

##### `internalTrafficPolicy`<sup>Optional</sup> <a name="internalTrafficPolicy" id="cdk8s-plus-28.k8s.ServiceSpec.property.internalTrafficPolicy"></a>

```typescript
public readonly internalTrafficPolicy: string;
```

- *Type:* string

InternalTrafficPolicy describes how nodes distribute service traffic they receive on the ClusterIP.

If set to "Local", the proxy will assume that pods only want to talk to endpoints of the service on the same node as the pod, dropping the traffic if there are no local endpoints. The default value, "Cluster", uses the standard behavior of routing to all endpoints evenly (possibly modified by topology and other features).

---

##### `ipFamilies`<sup>Optional</sup> <a name="ipFamilies" id="cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilies"></a>

```typescript
public readonly ipFamilies: string[];
```

- *Type:* string[]

IPFamilies is a list of IP families (e.g. IPv4, IPv6) assigned to this service. This field is usually assigned automatically based on cluster configuration and the ipFamilyPolicy field. If this field is specified manually, the requested family is available in the cluster, and ipFamilyPolicy allows it, it will be used; otherwise creation of the service will fail. This field is conditionally mutable: it allows for adding or removing a secondary IP family, but it does not allow changing the primary IP family of the Service. Valid values are "IPv4" and "IPv6".  This field only applies to Services of types ClusterIP, NodePort, and LoadBalancer, and does apply to "headless" services. This field will be wiped when updating a Service to type ExternalName.

This field may hold a maximum of two entries (dual-stack families, in either order).  These families must correspond to the values of the clusterIPs field, if specified. Both clusterIPs and ipFamilies are governed by the ipFamilyPolicy field.

---

##### `ipFamilyPolicy`<sup>Optional</sup> <a name="ipFamilyPolicy" id="cdk8s-plus-28.k8s.ServiceSpec.property.ipFamilyPolicy"></a>

```typescript
public readonly ipFamilyPolicy: string;
```

- *Type:* string

IPFamilyPolicy represents the dual-stack-ness requested or required by this Service.

If there is no value provided, then this field will be set to SingleStack. Services can be "SingleStack" (a single IP family), "PreferDualStack" (two IP families on dual-stack configured clusters or a single IP family on single-stack clusters), or "RequireDualStack" (two IP families on dual-stack configured clusters, otherwise fail). The ipFamilies and clusterIPs fields depend on the value of this field. This field will be wiped when updating a service to type ExternalName.

---

##### `loadBalancerClass`<sup>Optional</sup> <a name="loadBalancerClass" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerClass"></a>

```typescript
public readonly loadBalancerClass: string;
```

- *Type:* string

loadBalancerClass is the class of the load balancer implementation this Service belongs to.

If specified, the value of this field must be a label-style identifier, with an optional prefix, e.g. "internal-vip" or "example.com/internal-vip". Unprefixed names are reserved for end-users. This field can only be set when the Service type is 'LoadBalancer'. If not set, the default load balancer implementation is used, today this is typically done through the cloud provider integration, but should apply for any default implementation. If set, it is assumed that a load balancer implementation is watching for Services with a matching class. Any default load balancer implementation (e.g. cloud providers) should ignore Services that set this field. This field can only be set when creating or updating a Service to type 'LoadBalancer'. Once set, it can not be changed. This field will be wiped when a service is updated to a non 'LoadBalancer' type.

---

##### `loadBalancerIp`<sup>Optional</sup> <a name="loadBalancerIp" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerIp"></a>

```typescript
public readonly loadBalancerIp: string;
```

- *Type:* string

Only applies to Service Type: LoadBalancer.

This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature. Deprecated: This field was under-specified and its meaning varies across implementations. Using it is non-portable and it may not support dual-stack. Users are encouraged to use implementation-specific annotations when available.

---

##### `loadBalancerSourceRanges`<sup>Optional</sup> <a name="loadBalancerSourceRanges" id="cdk8s-plus-28.k8s.ServiceSpec.property.loadBalancerSourceRanges"></a>

```typescript
public readonly loadBalancerSourceRanges: string[];
```

- *Type:* string[]

If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs.

This field will be ignored if the cloud-provider does not support the feature." More info: https://kubernetes.io/docs/tasks/access-application-cluster/create-external-load-balancer/

---

##### `ports`<sup>Optional</sup> <a name="ports" id="cdk8s-plus-28.k8s.ServiceSpec.property.ports"></a>

```typescript
public readonly ports: ServicePort[];
```

- *Type:* cdk8s-plus-28.k8s.ServicePort[]

The list of ports that are exposed by this service.

More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `publishNotReadyAddresses`<sup>Optional</sup> <a name="publishNotReadyAddresses" id="cdk8s-plus-28.k8s.ServiceSpec.property.publishNotReadyAddresses"></a>

```typescript
public readonly publishNotReadyAddresses: boolean;
```

- *Type:* boolean

publishNotReadyAddresses indicates that any agent which deals with endpoints for this Service should disregard any indications of ready/not-ready.

The primary use case for setting this field is for a StatefulSet's Headless Service to propagate SRV DNS records for its Pods for the purpose of peer discovery. The Kubernetes controllers that generate Endpoints and EndpointSlice resources for Services interpret this to mean that all endpoints are considered "ready" even if the Pods themselves are not. Agents which consume only Kubernetes generated endpoints through the Endpoints or EndpointSlice resources can safely assume this behavior.

---

##### `selector`<sup>Optional</sup> <a name="selector" id="cdk8s-plus-28.k8s.ServiceSpec.property.selector"></a>

```typescript
public readonly selector: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Route service traffic to pods with label keys and values matching this selector.

If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/

---

##### `sessionAffinity`<sup>Optional</sup> <a name="sessionAffinity" id="cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinity"></a>

```typescript
public readonly sessionAffinity: string;
```

- *Type:* string
- *Default:* None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

Supports "ClientIP" and "None".

Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies

---

##### `sessionAffinityConfig`<sup>Optional</sup> <a name="sessionAffinityConfig" id="cdk8s-plus-28.k8s.ServiceSpec.property.sessionAffinityConfig"></a>

```typescript
public readonly sessionAffinityConfig: SessionAffinityConfig;
```

- *Type:* cdk8s-plus-28.k8s.SessionAffinityConfig

sessionAffinityConfig contains the configurations of session affinity.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.ServiceSpec.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. "ClusterIP" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object or EndpointSlice objects. If clusterIP is "None", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a virtual IP. "NodePort" builds on ClusterIP and allocates a port on every node which routes to the same endpoints as the clusterIP. "LoadBalancer" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the same endpoints as the clusterIP. "ExternalName" aliases this service to the specified externalName. Several other fields do not apply to ExternalName services. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

type determines how the Service is exposed.

Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. "ClusterIP" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object or EndpointSlice objects. If clusterIP is "None", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a virtual IP. "NodePort" builds on ClusterIP and allocates a port on every node which routes to the same endpoints as the clusterIP. "LoadBalancer" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the same endpoints as the clusterIP. "ExternalName" aliases this service to the specified externalName. Several other fields do not apply to ExternalName services. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types

---

### SessionAffinityConfig <a name="SessionAffinityConfig" id="cdk8s-plus-28.k8s.SessionAffinityConfig"></a>

SessionAffinityConfig represents the configurations of session affinity.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SessionAffinityConfig.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const sessionAffinityConfig: k8s.SessionAffinityConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SessionAffinityConfig.property.clientIp">clientIp</a></code> | <code>cdk8s-plus-28.k8s.ClientIpConfig</code> | clientIP contains the configurations of Client IP based session affinity. |

---

##### `clientIp`<sup>Optional</sup> <a name="clientIp" id="cdk8s-plus-28.k8s.SessionAffinityConfig.property.clientIp"></a>

```typescript
public readonly clientIp: ClientIpConfig;
```

- *Type:* cdk8s-plus-28.k8s.ClientIpConfig

clientIP contains the configurations of Client IP based session affinity.

---

### SshAuthSecretProps <a name="SshAuthSecretProps" id="cdk8s-plus-28.SshAuthSecretProps"></a>

Options for `SshAuthSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SshAuthSecretProps.Initializer"></a>

```typescript
import { SshAuthSecretProps } from 'cdk8s-plus-28'

const sshAuthSecretProps: SshAuthSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.SshAuthSecretProps.property.sshPrivateKey">sshPrivateKey</a></code> | <code>string</code> | The SSH private key to use. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.SshAuthSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.SshAuthSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `sshPrivateKey`<sup>Required</sup> <a name="sshPrivateKey" id="cdk8s-plus-28.SshAuthSecretProps.property.sshPrivateKey"></a>

```typescript
public readonly sshPrivateKey: string;
```

- *Type:* string

The SSH private key to use.

---

### StatefulSetOrdinals <a name="StatefulSetOrdinals" id="cdk8s-plus-28.k8s.StatefulSetOrdinals"></a>

StatefulSetOrdinals describes the policy used for replica ordinal assignment in this StatefulSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetOrdinals.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statefulSetOrdinals: k8s.StatefulSetOrdinals = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetOrdinals.property.start">start</a></code> | <code>number</code> | start is the number representing the first replica's index. |

---

##### `start`<sup>Optional</sup> <a name="start" id="cdk8s-plus-28.k8s.StatefulSetOrdinals.property.start"></a>

```typescript
public readonly start: number;
```

- *Type:* number

start is the number representing the first replica's index.

It may be used to number replicas from an alternate index (eg: 1-indexed) over the default 0-indexed names, or to orchestrate progressive movement of replicas from one StatefulSet to another. If set, replica indices will be in the range:
[.spec.ordinals.start, .spec.ordinals.start + .spec.replicas).
If unset, defaults to 0. Replica indices will be in the range:
[0, .spec.replicas).

---

### StatefulSetPersistentVolumeClaimRetentionPolicy <a name="StatefulSetPersistentVolumeClaimRetentionPolicy" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy"></a>

StatefulSetPersistentVolumeClaimRetentionPolicy describes the policy used for PVCs created from the StatefulSet VolumeClaimTemplates.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statefulSetPersistentVolumeClaimRetentionPolicy: k8s.StatefulSetPersistentVolumeClaimRetentionPolicy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenDeleted">whenDeleted</a></code> | <code>string</code> | WhenDeleted specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is deleted. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenScaled">whenScaled</a></code> | <code>string</code> | WhenScaled specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is scaled down. |

---

##### `whenDeleted`<sup>Optional</sup> <a name="whenDeleted" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenDeleted"></a>

```typescript
public readonly whenDeleted: string;
```

- *Type:* string

WhenDeleted specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is deleted.

The default policy of `Retain` causes PVCs to not be affected by StatefulSet deletion. The `Delete` policy causes those PVCs to be deleted.

---

##### `whenScaled`<sup>Optional</sup> <a name="whenScaled" id="cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy.property.whenScaled"></a>

```typescript
public readonly whenScaled: string;
```

- *Type:* string

WhenScaled specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is scaled down.

The default policy of `Retain` causes PVCs to not be affected by a scaledown. The `Delete` policy causes the associated PVCs for any excess pods above the replica count to be deleted.

---

### StatefulSetProps <a name="StatefulSetProps" id="cdk8s-plus-28.StatefulSetProps"></a>

Properties for initialization of `StatefulSet`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.StatefulSetProps.Initializer"></a>

```typescript
import { StatefulSetProps } from 'cdk8s-plus-28'

const statefulSetProps: StatefulSetProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.minReady">minReady</a></code> | <code>cdk8s.Duration</code> | Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.podManagementPolicy">podManagementPolicy</a></code> | <code><a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a></code> | Pod management policy to use for this statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.replicas">replicas</a></code> | <code>number</code> | Number of desired pods. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.service">service</a></code> | <code><a href="#cdk8s-plus-28.Service">Service</a></code> | Service to associate with the statefulset. |
| <code><a href="#cdk8s-plus-28.StatefulSetProps.property.strategy">strategy</a></code> | <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a></code> | Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.StatefulSetProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.StatefulSetProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.StatefulSetProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.StatefulSetProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.StatefulSetProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.StatefulSetProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.StatefulSetProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.StatefulSetProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.StatefulSetProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.StatefulSetProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.StatefulSetProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.StatefulSetProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.StatefulSetProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.StatefulSetProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.StatefulSetProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.StatefulSetProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.StatefulSetProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

##### `minReady`<sup>Optional</sup> <a name="minReady" id="cdk8s-plus-28.StatefulSetProps.property.minReady"></a>

```typescript
public readonly minReady: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(0)

Minimum duration for which a newly created pod should be ready without any of its container crashing, for it to be considered available.

Zero means the pod will be considered available as soon as it is ready.

This is an alpha field and requires enabling StatefulSetMinReadySeconds feature gate.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#min-ready-seconds)

---

##### `podManagementPolicy`<sup>Optional</sup> <a name="podManagementPolicy" id="cdk8s-plus-28.StatefulSetProps.property.podManagementPolicy"></a>

```typescript
public readonly podManagementPolicy: PodManagementPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.PodManagementPolicy">PodManagementPolicy</a>
- *Default:* PodManagementPolicy.ORDERED_READY

Pod management policy to use for this statefulset.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.StatefulSetProps.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number
- *Default:* 1

Number of desired pods.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.StatefulSetProps.property.service"></a>

```typescript
public readonly service: Service;
```

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>
- *Default:* A new headless service will be created.

Service to associate with the statefulset.

---

##### `strategy`<sup>Optional</sup> <a name="strategy" id="cdk8s-plus-28.StatefulSetProps.property.strategy"></a>

```typescript
public readonly strategy: StatefulSetUpdateStrategy;
```

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategy">StatefulSetUpdateStrategy</a>
- *Default:* RollingUpdate with partition set to 0

Indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.

---

### StatefulSetSpec <a name="StatefulSetSpec" id="cdk8s-plus-28.k8s.StatefulSetSpec"></a>

A StatefulSetSpec is the specification of a StatefulSet.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statefulSetSpec: k8s.StatefulSetSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.selector">selector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | selector is a label query over pods that should match the replica count. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.serviceName">serviceName</a></code> | <code>string</code> | serviceName is the name of the service that governs this StatefulSet. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.template">template</a></code> | <code>cdk8s-plus-28.k8s.PodTemplateSpec</code> | template is the object that describes the pod that will be created if insufficient replicas are detected. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.minReadySeconds">minReadySeconds</a></code> | <code>number</code> | Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.ordinals">ordinals</a></code> | <code>cdk8s-plus-28.k8s.StatefulSetOrdinals</code> | ordinals controls the numbering of replica indices in a StatefulSet. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.persistentVolumeClaimRetentionPolicy">persistentVolumeClaimRetentionPolicy</a></code> | <code>cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy</code> | persistentVolumeClaimRetentionPolicy describes the lifecycle of persistent volume claims created from volumeClaimTemplates. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.podManagementPolicy">podManagementPolicy</a></code> | <code>string</code> | podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.replicas">replicas</a></code> | <code>number</code> | replicas is the desired number of replicas of the given Template. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.revisionHistoryLimit">revisionHistoryLimit</a></code> | <code>number</code> | revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.updateStrategy">updateStrategy</a></code> | <code>cdk8s-plus-28.k8s.StatefulSetUpdateStrategy</code> | updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetSpec.property.volumeClaimTemplates">volumeClaimTemplates</a></code> | <code>cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps[]</code> | volumeClaimTemplates is a list of claims that pods are allowed to reference. |

---

##### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.selector"></a>

```typescript
public readonly selector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

selector is a label query over pods that should match the replica count.

It must match the pod template's labels. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels/#label-selectors

---

##### `serviceName`<sup>Required</sup> <a name="serviceName" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.serviceName"></a>

```typescript
public readonly serviceName: string;
```

- *Type:* string

serviceName is the name of the service that governs this StatefulSet.

This service must exist before the StatefulSet, and is responsible for the network identity of the set. Pods get DNS/hostnames that follow the pattern: pod-specific-string.serviceName.default.svc.cluster.local where "pod-specific-string" is managed by the StatefulSet controller.

---

##### `template`<sup>Required</sup> <a name="template" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.template"></a>

```typescript
public readonly template: PodTemplateSpec;
```

- *Type:* cdk8s-plus-28.k8s.PodTemplateSpec

template is the object that describes the pod that will be created if insufficient replicas are detected.

Each pod stamped out by the StatefulSet will fulfill this Template, but have a unique identity from the rest of the StatefulSet. Each pod will be named with the format <statefulsetname>-<podindex>. For example, a pod in a StatefulSet named "web" with index number "3" would be named "web-3". The only allowed template.spec.restartPolicy value is "Always".

---

##### `minReadySeconds`<sup>Optional</sup> <a name="minReadySeconds" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.minReadySeconds"></a>

```typescript
public readonly minReadySeconds: number;
```

- *Type:* number
- *Default:* 0 (pod will be considered available as soon as it is ready)

Minimum number of seconds for which a newly created pod should be ready without any of its container crashing for it to be considered available.

Defaults to 0 (pod will be considered available as soon as it is ready)

---

##### `ordinals`<sup>Optional</sup> <a name="ordinals" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.ordinals"></a>

```typescript
public readonly ordinals: StatefulSetOrdinals;
```

- *Type:* cdk8s-plus-28.k8s.StatefulSetOrdinals

ordinals controls the numbering of replica indices in a StatefulSet.

The default ordinals behavior assigns a "0" index to the first replica and increments the index by one for each additional replica requested. Using the ordinals field requires the StatefulSetStartOrdinal feature gate to be enabled, which is beta.

---

##### `persistentVolumeClaimRetentionPolicy`<sup>Optional</sup> <a name="persistentVolumeClaimRetentionPolicy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.persistentVolumeClaimRetentionPolicy"></a>

```typescript
public readonly persistentVolumeClaimRetentionPolicy: StatefulSetPersistentVolumeClaimRetentionPolicy;
```

- *Type:* cdk8s-plus-28.k8s.StatefulSetPersistentVolumeClaimRetentionPolicy

persistentVolumeClaimRetentionPolicy describes the lifecycle of persistent volume claims created from volumeClaimTemplates.

By default, all persistent volume claims are created as needed and retained until manually deleted. This policy allows the lifecycle to be altered, for example by deleting persistent volume claims when their stateful set is deleted, or when their pod is scaled down. This requires the StatefulSetAutoDeletePVC feature gate to be enabled, which is alpha.  +optional

---

##### `podManagementPolicy`<sup>Optional</sup> <a name="podManagementPolicy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.podManagementPolicy"></a>

```typescript
public readonly podManagementPolicy: string;
```

- *Type:* string

podManagementPolicy controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down.

The default policy is `OrderedReady`, where pods are created in increasing order (pod-0, then pod-1, etc) and the controller will wait until each pod is ready before continuing. When scaling down, the pods are removed in the opposite order. The alternative policy is `Parallel` which will create pods in parallel to match the desired scale without waiting, and on scale down will delete all pods at once.

---

##### `replicas`<sup>Optional</sup> <a name="replicas" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.replicas"></a>

```typescript
public readonly replicas: number;
```

- *Type:* number

replicas is the desired number of replicas of the given Template.

These are replicas in the sense that they are instantiations of the same Template, but individual replicas also have a consistent identity. If unspecified, defaults to 1.

---

##### `revisionHistoryLimit`<sup>Optional</sup> <a name="revisionHistoryLimit" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.revisionHistoryLimit"></a>

```typescript
public readonly revisionHistoryLimit: number;
```

- *Type:* number

revisionHistoryLimit is the maximum number of revisions that will be maintained in the StatefulSet's revision history.

The revision history consists of all revisions not represented by a currently applied StatefulSetSpec version. The default value is 10.

---

##### `updateStrategy`<sup>Optional</sup> <a name="updateStrategy" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.updateStrategy"></a>

```typescript
public readonly updateStrategy: StatefulSetUpdateStrategy;
```

- *Type:* cdk8s-plus-28.k8s.StatefulSetUpdateStrategy

updateStrategy indicates the StatefulSetUpdateStrategy that will be employed to update Pods in the StatefulSet when a revision is made to Template.

---

##### `volumeClaimTemplates`<sup>Optional</sup> <a name="volumeClaimTemplates" id="cdk8s-plus-28.k8s.StatefulSetSpec.property.volumeClaimTemplates"></a>

```typescript
public readonly volumeClaimTemplates: KubePersistentVolumeClaimProps[];
```

- *Type:* cdk8s-plus-28.k8s.KubePersistentVolumeClaimProps[]

volumeClaimTemplates is a list of claims that pods are allowed to reference.

The StatefulSet controller is responsible for mapping network identities to claims in a way that maintains the identity of a pod. Every claim in this list must have at least one matching (by name) volumeMount in one container in the template. A claim in this list takes precedence over any volumes in the template, with the same name.

---

### StatefulSetUpdateStrategy <a name="StatefulSetUpdateStrategy" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy"></a>

StatefulSetUpdateStrategy indicates the strategy that the StatefulSet controller will use to perform updates.

It includes any additional parameters necessary to perform the update for the indicated strategy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statefulSetUpdateStrategy: k8s.StatefulSetUpdateStrategy = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.rollingUpdate">rollingUpdate</a></code> | <code>cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy</code> | RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType. |
| <code><a href="#cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.type">type</a></code> | <code>string</code> | Type indicates the type of the StatefulSetUpdateStrategy. |

---

##### `rollingUpdate`<sup>Optional</sup> <a name="rollingUpdate" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.rollingUpdate"></a>

```typescript
public readonly rollingUpdate: RollingUpdateStatefulSetStrategy;
```

- *Type:* cdk8s-plus-28.k8s.RollingUpdateStatefulSetStrategy

RollingUpdate is used to communicate parameters when Type is RollingUpdateStatefulSetStrategyType.

---

##### `type`<sup>Optional</sup> <a name="type" id="cdk8s-plus-28.k8s.StatefulSetUpdateStrategy.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string
- *Default:* RollingUpdate.

Type indicates the type of the StatefulSetUpdateStrategy.

Default is RollingUpdate.

---

### StatefulSetUpdateStrategyRollingUpdateOptions <a name="StatefulSetUpdateStrategyRollingUpdateOptions" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions"></a>

Options for `StatefulSetUpdateStrategy.rollingUpdate`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.Initializer"></a>

```typescript
import { StatefulSetUpdateStrategyRollingUpdateOptions } from 'cdk8s-plus-28'

const statefulSetUpdateStrategyRollingUpdateOptions: StatefulSetUpdateStrategyRollingUpdateOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.property.partition">partition</a></code> | <code>number</code> | If specified, all Pods with an ordinal that is greater than or equal to the partition will be updated when the StatefulSet's .spec.template is updated. All Pods with an ordinal that is less than the partition will not be updated, and, even if they are deleted, they will be recreated at the previous version. |

---

##### `partition`<sup>Optional</sup> <a name="partition" id="cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions.property.partition"></a>

```typescript
public readonly partition: number;
```

- *Type:* number
- *Default:* 0

If specified, all Pods with an ordinal that is greater than or equal to the partition will be updated when the StatefulSet's .spec.template is updated. All Pods with an ordinal that is less than the partition will not be updated, and, even if they are deleted, they will be recreated at the previous version.

If the partition is greater than replicas, updates to the pod template will not be propagated to Pods.
In most cases you will not need to use a partition, but they are useful if you want to stage an
update, roll out a canary, or perform a phased roll out.

> [https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions](https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/#partitions)

---

### StatusCause <a name="StatusCause" id="cdk8s-plus-28.k8s.StatusCause"></a>

StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatusCause.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statusCause: k8s.StatusCause = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.field">field</a></code> | <code>string</code> | The field of the resource that has caused this error, as named by its JSON serialization. |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.message">message</a></code> | <code>string</code> | A human-readable description of the cause of the error. |
| <code><a href="#cdk8s-plus-28.k8s.StatusCause.property.reason">reason</a></code> | <code>string</code> | A machine-readable description of the cause of the error. |

---

##### `field`<sup>Optional</sup> <a name="field" id="cdk8s-plus-28.k8s.StatusCause.property.field"></a>

```typescript
public readonly field: string;
```

- *Type:* string

The field of the resource that has caused this error, as named by its JSON serialization.

May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.

Examples:
"name" - the field "name" on the current resource
"items[0].name" - the field "name" on the first array entry in "items"

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.StatusCause.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

A human-readable description of the cause of the error.

This field may be presented as-is to a reader.

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.StatusCause.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

A machine-readable description of the cause of the error.

If this value is empty there is no information available.

---

### StatusDetails <a name="StatusDetails" id="cdk8s-plus-28.k8s.StatusDetails"></a>

StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response.

The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StatusDetails.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const statusDetails: k8s.StatusDetails = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.causes">causes</a></code> | <code>cdk8s-plus-28.k8s.StatusCause[]</code> | The Causes array includes more details associated with the StatusReason failure. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.group">group</a></code> | <code>string</code> | The group attribute of the resource associated with the status StatusReason. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.kind">kind</a></code> | <code>string</code> | The kind attribute of the resource associated with the status StatusReason. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.name">name</a></code> | <code>string</code> | The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described). |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.retryAfterSeconds">retryAfterSeconds</a></code> | <code>number</code> | If specified, the time in seconds before the operation should be retried. |
| <code><a href="#cdk8s-plus-28.k8s.StatusDetails.property.uid">uid</a></code> | <code>string</code> | UID of the resource. |

---

##### `causes`<sup>Optional</sup> <a name="causes" id="cdk8s-plus-28.k8s.StatusDetails.property.causes"></a>

```typescript
public readonly causes: StatusCause[];
```

- *Type:* cdk8s-plus-28.k8s.StatusCause[]

The Causes array includes more details associated with the StatusReason failure.

Not all StatusReasons may provide detailed causes.

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.StatusDetails.property.group"></a>

```typescript
public readonly group: string;
```

- *Type:* string

The group attribute of the resource associated with the status StatusReason.

---

##### `kind`<sup>Optional</sup> <a name="kind" id="cdk8s-plus-28.k8s.StatusDetails.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The kind attribute of the resource associated with the status StatusReason.

On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

---

##### `name`<sup>Optional</sup> <a name="name" id="cdk8s-plus-28.k8s.StatusDetails.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).

---

##### `retryAfterSeconds`<sup>Optional</sup> <a name="retryAfterSeconds" id="cdk8s-plus-28.k8s.StatusDetails.property.retryAfterSeconds"></a>

```typescript
public readonly retryAfterSeconds: number;
```

- *Type:* number

If specified, the time in seconds before the operation should be retried.

Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.StatusDetails.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID of the resource.

(when there is a single resource which can be described). More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

---

### StorageOsPersistentVolumeSource <a name="StorageOsPersistentVolumeSource" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource"></a>

Represents a StorageOS persistent volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const storageOsPersistentVolumeSource: k8s.StorageOsPersistentVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.ObjectReference</code> | secretRef specifies the secret to use for obtaining the StorageOS API credentials. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeName">volumeName</a></code> | <code>string</code> | volumeName is the human-readable name of the StorageOS volume. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeNamespace">volumeNamespace</a></code> | <code>string</code> | volumeNamespace specifies the scope of the volume within StorageOS. |

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: ObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.ObjectReference

secretRef specifies the secret to use for obtaining the StorageOS API credentials.

If not specified, default values will be attempted.

---

##### `volumeName`<sup>Optional</sup> <a name="volumeName" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeName"></a>

```typescript
public readonly volumeName: string;
```

- *Type:* string

volumeName is the human-readable name of the StorageOS volume.

Volume names are only unique within a namespace.

---

##### `volumeNamespace`<sup>Optional</sup> <a name="volumeNamespace" id="cdk8s-plus-28.k8s.StorageOsPersistentVolumeSource.property.volumeNamespace"></a>

```typescript
public readonly volumeNamespace: string;
```

- *Type:* string

volumeNamespace specifies the scope of the volume within StorageOS.

If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

---

### StorageOsVolumeSource <a name="StorageOsVolumeSource" id="cdk8s-plus-28.k8s.StorageOsVolumeSource"></a>

Represents a StorageOS persistent volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const storageOsVolumeSource: k8s.StorageOsVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is the filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.readOnly">readOnly</a></code> | <code>boolean</code> | readOnly defaults to false (read/write). |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.secretRef">secretRef</a></code> | <code>cdk8s-plus-28.k8s.LocalObjectReference</code> | secretRef specifies the secret to use for obtaining the StorageOS API credentials. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeName">volumeName</a></code> | <code>string</code> | volumeName is the human-readable name of the StorageOS volume. |
| <code><a href="#cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeNamespace">volumeNamespace</a></code> | <code>string</code> | volumeNamespace specifies the scope of the volume within StorageOS. |

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is the filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean

readOnly defaults to false (read/write).

ReadOnly here will force the ReadOnly setting in VolumeMounts.

---

##### `secretRef`<sup>Optional</sup> <a name="secretRef" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.secretRef"></a>

```typescript
public readonly secretRef: LocalObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.LocalObjectReference

secretRef specifies the secret to use for obtaining the StorageOS API credentials.

If not specified, default values will be attempted.

---

##### `volumeName`<sup>Optional</sup> <a name="volumeName" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeName"></a>

```typescript
public readonly volumeName: string;
```

- *Type:* string

volumeName is the human-readable name of the StorageOS volume.

Volume names are only unique within a namespace.

---

##### `volumeNamespace`<sup>Optional</sup> <a name="volumeNamespace" id="cdk8s-plus-28.k8s.StorageOsVolumeSource.property.volumeNamespace"></a>

```typescript
public readonly volumeNamespace: string;
```

- *Type:* string

volumeNamespace specifies the scope of the volume within StorageOS.

If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

---

### Subject <a name="Subject" id="cdk8s-plus-28.k8s.Subject"></a>

Subject contains a reference to the object or user identities a role binding applies to.

This can either hold a direct API object reference, or a value for non-objects such as user and group names.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Subject.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const subject: k8s.Subject = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.kind">kind</a></code> | <code>string</code> | Kind of object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.name">name</a></code> | <code>string</code> | Name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup holds the API group of the referenced subject. |
| <code><a href="#cdk8s-plus-28.k8s.Subject.property.namespace">namespace</a></code> | <code>string</code> | Namespace of the referenced object. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.Subject.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind of object being referenced.

Values defined by this API group are "User", "Group", and "ServiceAccount". If the Authorizer does not recognized the kind value, the Authorizer should report an error.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Subject.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the object being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.Subject.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string
- *Default:* for ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User and Group subjects.

APIGroup holds the API group of the referenced subject.

Defaults to "" for ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User and Group subjects.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.Subject.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace of the referenced object.

If the object kind is non-namespace, such as "User" or "Group", and this value is not empty the Authorizer should report an error.

---

### SubjectAccessReviewSpec <a name="SubjectAccessReviewSpec" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec"></a>

SubjectAccessReviewSpec is a description of the access request.

Exactly one of ResourceAuthorizationAttributes and NonResourceAuthorizationAttributes must be set

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const subjectAccessReviewSpec: k8s.SubjectAccessReviewSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.extra">extra</a></code> | <code>{[ key: string ]: string[]}</code> | Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.groups">groups</a></code> | <code>string[]</code> | Groups is the groups you're testing for. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.nonResourceAttributes">nonResourceAttributes</a></code> | <code>cdk8s-plus-28.k8s.NonResourceAttributes</code> | NonResourceAttributes describes information for a non-resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.resourceAttributes">resourceAttributes</a></code> | <code>cdk8s-plus-28.k8s.ResourceAttributes</code> | ResourceAuthorizationAttributes describes information for a resource access request. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.uid">uid</a></code> | <code>string</code> | UID information about the requesting user. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.user">user</a></code> | <code>string</code> | User is the user you're testing for. |

---

##### `extra`<sup>Optional</sup> <a name="extra" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.extra"></a>

```typescript
public readonly extra: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

Extra corresponds to the user.Info.GetExtra() method from the authenticator.  Since that is input to the authorizer it needs a reflection here.

---

##### `groups`<sup>Optional</sup> <a name="groups" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.groups"></a>

```typescript
public readonly groups: string[];
```

- *Type:* string[]

Groups is the groups you're testing for.

---

##### `nonResourceAttributes`<sup>Optional</sup> <a name="nonResourceAttributes" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.nonResourceAttributes"></a>

```typescript
public readonly nonResourceAttributes: NonResourceAttributes;
```

- *Type:* cdk8s-plus-28.k8s.NonResourceAttributes

NonResourceAttributes describes information for a non-resource access request.

---

##### `resourceAttributes`<sup>Optional</sup> <a name="resourceAttributes" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.resourceAttributes"></a>

```typescript
public readonly resourceAttributes: ResourceAttributes;
```

- *Type:* cdk8s-plus-28.k8s.ResourceAttributes

ResourceAuthorizationAttributes describes information for a resource access request.

---

##### `uid`<sup>Optional</sup> <a name="uid" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.uid"></a>

```typescript
public readonly uid: string;
```

- *Type:* string

UID information about the requesting user.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectAccessReviewSpec.property.user"></a>

```typescript
public readonly user: string;
```

- *Type:* string

User is the user you're testing for.

If you specify "User" but not "Groups", then is it interpreted as "What if User were not a member of any groups

---

### SubjectConfiguration <a name="SubjectConfiguration" id="cdk8s-plus-28.SubjectConfiguration"></a>

Subject contains a reference to the object or user identities a role binding applies to.

This can either hold a direct API object reference, or a value
for non-objects such as user and group names.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.SubjectConfiguration.Initializer"></a>

```typescript
import { SubjectConfiguration } from 'cdk8s-plus-28'

const subjectConfiguration: SubjectConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.kind">kind</a></code> | <code>string</code> | Kind of object being referenced. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.name">name</a></code> | <code>string</code> | Name of the object being referenced. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup holds the API group of the referenced subject. |
| <code><a href="#cdk8s-plus-28.SubjectConfiguration.property.namespace">namespace</a></code> | <code>string</code> | Namespace of the referenced object. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.SubjectConfiguration.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind of object being referenced.

Values defined by this API group are
"User", "Group", and "ServiceAccount". If the Authorizer does not
recognized the kind value, the Authorizer should report an error.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.SubjectConfiguration.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of the object being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.SubjectConfiguration.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup holds the API group of the referenced subject.

Defaults to "" for
ServiceAccount subjects. Defaults to "rbac.authorization.k8s.io" for User
and Group subjects.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.SubjectConfiguration.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace of the referenced object.

If the object kind is non-namespace,
such as "User" or "Group", and this value is not empty the Authorizer
should report an error.

---

### SubjectV1Beta2 <a name="SubjectV1Beta2" id="cdk8s-plus-28.k8s.SubjectV1Beta2"></a>

Subject matches the originator of a request, as identified by the request authentication system.

There are three ways of matching an originator; by user, group, or service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const subjectV1Beta2: k8s.SubjectV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.kind">kind</a></code> | <code>string</code> | `kind` indicates which one of the other fields is non-empty. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.group">group</a></code> | <code>cdk8s-plus-28.k8s.GroupSubjectV1Beta2</code> | `group` matches based on user group name. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.serviceAccount">serviceAccount</a></code> | <code>cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2</code> | `serviceAccount` matches ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta2.property.user">user</a></code> | <code>cdk8s-plus-28.k8s.UserSubjectV1Beta2</code> | `user` matches based on username. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

`kind` indicates which one of the other fields is non-empty.

Required

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.group"></a>

```typescript
public readonly group: GroupSubjectV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.GroupSubjectV1Beta2

`group` matches based on user group name.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccountSubjectV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta2

`serviceAccount` matches ServiceAccounts.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectV1Beta2.property.user"></a>

```typescript
public readonly user: UserSubjectV1Beta2;
```

- *Type:* cdk8s-plus-28.k8s.UserSubjectV1Beta2

`user` matches based on username.

---

### SubjectV1Beta3 <a name="SubjectV1Beta3" id="cdk8s-plus-28.k8s.SubjectV1Beta3"></a>

Subject matches the originator of a request, as identified by the request authentication system.

There are three ways of matching an originator; by user, group, or service account.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.SubjectV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const subjectV1Beta3: k8s.SubjectV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.kind">kind</a></code> | <code>string</code> | `kind` indicates which one of the other fields is non-empty. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.group">group</a></code> | <code>cdk8s-plus-28.k8s.GroupSubjectV1Beta3</code> | `group` matches based on user group name. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.serviceAccount">serviceAccount</a></code> | <code>cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3</code> | `serviceAccount` matches ServiceAccounts. |
| <code><a href="#cdk8s-plus-28.k8s.SubjectV1Beta3.property.user">user</a></code> | <code>cdk8s-plus-28.k8s.UserSubjectV1Beta3</code> | `user` matches based on username. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

`kind` indicates which one of the other fields is non-empty.

Required

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.group"></a>

```typescript
public readonly group: GroupSubjectV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.GroupSubjectV1Beta3

`group` matches based on user group name.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: ServiceAccountSubjectV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.ServiceAccountSubjectV1Beta3

`serviceAccount` matches ServiceAccounts.

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.k8s.SubjectV1Beta3.property.user"></a>

```typescript
public readonly user: UserSubjectV1Beta3;
```

- *Type:* cdk8s-plus-28.k8s.UserSubjectV1Beta3

`user` matches based on username.

---

### Sysctl <a name="Sysctl" id="cdk8s-plus-28.Sysctl"></a>

Sysctl defines a kernel parameter to be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.Sysctl.Initializer"></a>

```typescript
import { Sysctl } from 'cdk8s-plus-28'

const sysctl: Sysctl = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Sysctl.property.name">name</a></code> | <code>string</code> | Name of a property to set. |
| <code><a href="#cdk8s-plus-28.Sysctl.property.value">value</a></code> | <code>string</code> | Value of a property to set. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Sysctl.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of a property to set.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Sysctl.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

Value of a property to set.

---

### Sysctl <a name="Sysctl" id="cdk8s-plus-28.k8s.Sysctl"></a>

Sysctl defines a kernel parameter to be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Sysctl.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const sysctl: k8s.Sysctl = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Sysctl.property.name">name</a></code> | <code>string</code> | Name of a property to set. |
| <code><a href="#cdk8s-plus-28.k8s.Sysctl.property.value">value</a></code> | <code>string</code> | Value of a property to set. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Sysctl.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of a property to set.

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Sysctl.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

Value of a property to set.

---

### Taint <a name="Taint" id="cdk8s-plus-28.k8s.Taint"></a>

The node this Taint is attached to has the "effect" on any pod that does not tolerate the Taint.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Taint.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const taint: k8s.Taint = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.effect">effect</a></code> | <code>string</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.key">key</a></code> | <code>string</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.timeAdded">timeAdded</a></code> | <code>Date</code> | TimeAdded represents the time at which the taint was added. |
| <code><a href="#cdk8s-plus-28.k8s.Taint.property.value">value</a></code> | <code>string</code> | The taint value corresponding to the taint key. |

---

##### `effect`<sup>Required</sup> <a name="effect" id="cdk8s-plus-28.k8s.Taint.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* string

Required.

The effect of the taint on pods that do not tolerate the taint. Valid effects are NoSchedule, PreferNoSchedule and NoExecute.

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.Taint.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

Required.

The taint key to be applied to a node.

---

##### `timeAdded`<sup>Optional</sup> <a name="timeAdded" id="cdk8s-plus-28.k8s.Taint.property.timeAdded"></a>

```typescript
public readonly timeAdded: Date;
```

- *Type:* Date

TimeAdded represents the time at which the taint was added.

It is only written for NoExecute taints.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.Taint.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

The taint value corresponding to the taint key.

---

### TcpSocketAction <a name="TcpSocketAction" id="cdk8s-plus-28.k8s.TcpSocketAction"></a>

TCPSocketAction describes an action based on opening a socket.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TcpSocketAction.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const tcpSocketAction: k8s.TcpSocketAction = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TcpSocketAction.property.port">port</a></code> | <code>cdk8s-plus-28.k8s.IntOrString</code> | Number or name of the port to access on the container. |
| <code><a href="#cdk8s-plus-28.k8s.TcpSocketAction.property.host">host</a></code> | <code>string</code> | Optional: Host name to connect to, defaults to the pod IP. |

---

##### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.k8s.TcpSocketAction.property.port"></a>

```typescript
public readonly port: IntOrString;
```

- *Type:* cdk8s-plus-28.k8s.IntOrString

Number or name of the port to access on the container.

Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.k8s.TcpSocketAction.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string

Optional: Host name to connect to, defaults to the pod IP.

---

### TcpSocketProbeOptions <a name="TcpSocketProbeOptions" id="cdk8s-plus-28.TcpSocketProbeOptions"></a>

Options for `Probe.fromTcpSocket()`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.TcpSocketProbeOptions.Initializer"></a>

```typescript
import { TcpSocketProbeOptions } from 'cdk8s-plus-28'

const tcpSocketProbeOptions: TcpSocketProbeOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.failureThreshold">failureThreshold</a></code> | <code>number</code> | Minimum consecutive failures for the probe to be considered failed after having succeeded. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.initialDelaySeconds">initialDelaySeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after the container has started before liveness probes are initiated. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.periodSeconds">periodSeconds</a></code> | <code>cdk8s.Duration</code> | How often (in seconds) to perform the probe. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.successThreshold">successThreshold</a></code> | <code>number</code> | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.timeoutSeconds">timeoutSeconds</a></code> | <code>cdk8s.Duration</code> | Number of seconds after which the probe times out. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.host">host</a></code> | <code>string</code> | The host name to connect to on the container. |
| <code><a href="#cdk8s-plus-28.TcpSocketProbeOptions.property.port">port</a></code> | <code>number</code> | The TCP port to connect to on the container. |

---

##### `failureThreshold`<sup>Optional</sup> <a name="failureThreshold" id="cdk8s-plus-28.TcpSocketProbeOptions.property.failureThreshold"></a>

```typescript
public readonly failureThreshold: number;
```

- *Type:* number
- *Default:* 3

Minimum consecutive failures for the probe to be considered failed after having succeeded.

Defaults to 3. Minimum value is 1.

---

##### `initialDelaySeconds`<sup>Optional</sup> <a name="initialDelaySeconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.initialDelaySeconds"></a>

```typescript
public readonly initialDelaySeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* immediate

Number of seconds after the container has started before liveness probes are initiated.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `periodSeconds`<sup>Optional</sup> <a name="periodSeconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.periodSeconds"></a>

```typescript
public readonly periodSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(10) Minimum value is 1.

How often (in seconds) to perform the probe.

Default to 10 seconds. Minimum value is 1.

---

##### `successThreshold`<sup>Optional</sup> <a name="successThreshold" id="cdk8s-plus-28.TcpSocketProbeOptions.property.successThreshold"></a>

```typescript
public readonly successThreshold: number;
```

- *Type:* number
- *Default:* 1 Must be 1 for liveness and startup. Minimum value is 1.

Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1.

Must be 1 for liveness and startup. Minimum value is 1.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.TcpSocketProbeOptions.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(1)

Number of seconds after which the probe times out.

Defaults to 1 second. Minimum value is 1.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes)

---

##### `host`<sup>Optional</sup> <a name="host" id="cdk8s-plus-28.TcpSocketProbeOptions.property.host"></a>

```typescript
public readonly host: string;
```

- *Type:* string
- *Default:* defaults to the pod IP

The host name to connect to on the container.

---

##### `port`<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.TcpSocketProbeOptions.property.port"></a>

```typescript
public readonly port: number;
```

- *Type:* number
- *Default:* defaults to `container.port`.

The TCP port to connect to on the container.

---

### TlsSecretProps <a name="TlsSecretProps" id="cdk8s-plus-28.TlsSecretProps"></a>

Options for `TlsSecret`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.TlsSecretProps.Initializer"></a>

```typescript
import { TlsSecretProps } from 'cdk8s-plus-28'

const tlsSecretProps: TlsSecretProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.immutable">immutable</a></code> | <code>boolean</code> | If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified). |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.tlsCert">tlsCert</a></code> | <code>string</code> | The TLS cert. |
| <code><a href="#cdk8s-plus-28.TlsSecretProps.property.tlsKey">tlsKey</a></code> | <code>string</code> | The TLS key. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.TlsSecretProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `immutable`<sup>Optional</sup> <a name="immutable" id="cdk8s-plus-28.TlsSecretProps.property.immutable"></a>

```typescript
public readonly immutable: boolean;
```

- *Type:* boolean
- *Default:* false

If set to true, ensures that data stored in the Secret cannot be updated (only object metadata can be modified).

If not set to true, the field can be modified at any time.

---

##### `tlsCert`<sup>Required</sup> <a name="tlsCert" id="cdk8s-plus-28.TlsSecretProps.property.tlsCert"></a>

```typescript
public readonly tlsCert: string;
```

- *Type:* string

The TLS cert.

---

##### `tlsKey`<sup>Required</sup> <a name="tlsKey" id="cdk8s-plus-28.TlsSecretProps.property.tlsKey"></a>

```typescript
public readonly tlsKey: string;
```

- *Type:* string

The TLS key.

---

### TokenRequest <a name="TokenRequest" id="cdk8s-plus-28.k8s.TokenRequest"></a>

TokenRequest contains parameters of a service account token.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenRequest.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const tokenRequest: k8s.TokenRequest = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequest.property.audience">audience</a></code> | <code>string</code> | audience is the intended audience of the token in "TokenRequestSpec". |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequest.property.expirationSeconds">expirationSeconds</a></code> | <code>number</code> | expirationSeconds is the duration of validity of the token in "TokenRequestSpec". |

---

##### `audience`<sup>Required</sup> <a name="audience" id="cdk8s-plus-28.k8s.TokenRequest.property.audience"></a>

```typescript
public readonly audience: string;
```

- *Type:* string

audience is the intended audience of the token in "TokenRequestSpec".

It will default to the audiences of kube apiserver.

---

##### `expirationSeconds`<sup>Optional</sup> <a name="expirationSeconds" id="cdk8s-plus-28.k8s.TokenRequest.property.expirationSeconds"></a>

```typescript
public readonly expirationSeconds: number;
```

- *Type:* number

expirationSeconds is the duration of validity of the token in "TokenRequestSpec".

It has the same default value of "ExpirationSeconds" in "TokenRequestSpec".

---

### TokenRequestSpec <a name="TokenRequestSpec" id="cdk8s-plus-28.k8s.TokenRequestSpec"></a>

TokenRequestSpec contains client provided parameters of a token request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenRequestSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const tokenRequestSpec: k8s.TokenRequestSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.audiences">audiences</a></code> | <code>string[]</code> | Audiences are the intendend audiences of the token. |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.boundObjectRef">boundObjectRef</a></code> | <code>cdk8s-plus-28.k8s.BoundObjectReference</code> | BoundObjectRef is a reference to an object that the token will be bound to. |
| <code><a href="#cdk8s-plus-28.k8s.TokenRequestSpec.property.expirationSeconds">expirationSeconds</a></code> | <code>number</code> | ExpirationSeconds is the requested duration of validity of the request. |

---

##### `audiences`<sup>Required</sup> <a name="audiences" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.audiences"></a>

```typescript
public readonly audiences: string[];
```

- *Type:* string[]

Audiences are the intendend audiences of the token.

A recipient of a token must identify themself with an identifier in the list of audiences of the token, and otherwise should reject the token. A token issued for multiple audiences may be used to authenticate against any of the audiences listed but implies a high degree of trust between the target audiences.

---

##### `boundObjectRef`<sup>Optional</sup> <a name="boundObjectRef" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.boundObjectRef"></a>

```typescript
public readonly boundObjectRef: BoundObjectReference;
```

- *Type:* cdk8s-plus-28.k8s.BoundObjectReference

BoundObjectRef is a reference to an object that the token will be bound to.

The token will only be valid for as long as the bound object exists. NOTE: The API server's TokenReview endpoint will validate the BoundObjectRef, but other audiences may not. Keep ExpirationSeconds small if you want prompt revocation.

---

##### `expirationSeconds`<sup>Optional</sup> <a name="expirationSeconds" id="cdk8s-plus-28.k8s.TokenRequestSpec.property.expirationSeconds"></a>

```typescript
public readonly expirationSeconds: number;
```

- *Type:* number

ExpirationSeconds is the requested duration of validity of the request.

The token issuer may return a token with a different validity duration so a client needs to check the 'expiration' field in a response.

---

### TokenReviewSpec <a name="TokenReviewSpec" id="cdk8s-plus-28.k8s.TokenReviewSpec"></a>

TokenReviewSpec is a description of the token authentication request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TokenReviewSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const tokenReviewSpec: k8s.TokenReviewSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TokenReviewSpec.property.audiences">audiences</a></code> | <code>string[]</code> | Audiences is a list of the identifiers that the resource server presented with the token identifies as. |
| <code><a href="#cdk8s-plus-28.k8s.TokenReviewSpec.property.token">token</a></code> | <code>string</code> | Token is the opaque bearer token. |

---

##### `audiences`<sup>Optional</sup> <a name="audiences" id="cdk8s-plus-28.k8s.TokenReviewSpec.property.audiences"></a>

```typescript
public readonly audiences: string[];
```

- *Type:* string[]

Audiences is a list of the identifiers that the resource server presented with the token identifies as.

Audience-aware token authenticators will verify that the token was intended for at least one of the audiences in this list. If no audiences are provided, the audience will default to the audience of the Kubernetes apiserver.

---

##### `token`<sup>Optional</sup> <a name="token" id="cdk8s-plus-28.k8s.TokenReviewSpec.property.token"></a>

```typescript
public readonly token: string;
```

- *Type:* string

Token is the opaque bearer token.

---

### Toleration <a name="Toleration" id="cdk8s-plus-28.k8s.Toleration"></a>

The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Toleration.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const toleration: k8s.Toleration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.effect">effect</a></code> | <code>string</code> | Effect indicates the taint effect to match. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.key">key</a></code> | <code>string</code> | Key is the taint key that the toleration applies to. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.operator">operator</a></code> | <code>string</code> | Operator represents a key's relationship to the value. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.tolerationSeconds">tolerationSeconds</a></code> | <code>number</code> | TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. |
| <code><a href="#cdk8s-plus-28.k8s.Toleration.property.value">value</a></code> | <code>string</code> | Value is the taint value the toleration matches to. |

---

##### `effect`<sup>Optional</sup> <a name="effect" id="cdk8s-plus-28.k8s.Toleration.property.effect"></a>

```typescript
public readonly effect: string;
```

- *Type:* string

Effect indicates the taint effect to match.

Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.

---

##### `key`<sup>Optional</sup> <a name="key" id="cdk8s-plus-28.k8s.Toleration.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

Key is the taint key that the toleration applies to.

Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.

---

##### `operator`<sup>Optional</sup> <a name="operator" id="cdk8s-plus-28.k8s.Toleration.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string
- *Default:* Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

Operator represents a key's relationship to the value.

Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

---

##### `tolerationSeconds`<sup>Optional</sup> <a name="tolerationSeconds" id="cdk8s-plus-28.k8s.Toleration.property.tolerationSeconds"></a>

```typescript
public readonly tolerationSeconds: number;
```

- *Type:* number

TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint.

By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.k8s.Toleration.property.value"></a>

```typescript
public readonly value: string;
```

- *Type:* string

Value is the taint value the toleration matches to.

If the operator is Exists, the value should be empty, otherwise just a regular string.

---

### TopologySelectorLabelRequirement <a name="TopologySelectorLabelRequirement" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement"></a>

A topology selector requirement is a selector that matches given label.

This is an alpha feature and may change in the future.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const topologySelectorLabelRequirement: k8s.TopologySelectorLabelRequirement = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.key">key</a></code> | <code>string</code> | The label key that the selector applies to. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.values">values</a></code> | <code>string[]</code> | An array of string values. |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

The label key that the selector applies to.

---

##### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.k8s.TopologySelectorLabelRequirement.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

An array of string values.

One value must match the label to be selected. Each entry in Values is ORed.

---

### TopologySelectorTerm <a name="TopologySelectorTerm" id="cdk8s-plus-28.k8s.TopologySelectorTerm"></a>

A topology selector term represents the result of label queries.

A null or empty topology selector term matches no objects. The requirements of them are ANDed. It provides a subset of functionality as NodeSelectorTerm. This is an alpha feature and may change in the future.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySelectorTerm.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const topologySelectorTerm: k8s.TopologySelectorTerm = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySelectorTerm.property.matchLabelExpressions">matchLabelExpressions</a></code> | <code>cdk8s-plus-28.k8s.TopologySelectorLabelRequirement[]</code> | A list of topology selector requirements by labels. |

---

##### `matchLabelExpressions`<sup>Optional</sup> <a name="matchLabelExpressions" id="cdk8s-plus-28.k8s.TopologySelectorTerm.property.matchLabelExpressions"></a>

```typescript
public readonly matchLabelExpressions: TopologySelectorLabelRequirement[];
```

- *Type:* cdk8s-plus-28.k8s.TopologySelectorLabelRequirement[]

A list of topology selector requirements by labels.

---

### TopologySpreadConstraint <a name="TopologySpreadConstraint" id="cdk8s-plus-28.k8s.TopologySpreadConstraint"></a>

TopologySpreadConstraint specifies how to spread matching pods among the given topology.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const topologySpreadConstraint: k8s.TopologySpreadConstraint = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.maxSkew">maxSkew</a></code> | <code>number</code> | MaxSkew describes the degree to which pods may be unevenly distributed. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.topologyKey">topologyKey</a></code> | <code>string</code> | TopologyKey is the key of node labels. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.whenUnsatisfiable">whenUnsatisfiable</a></code> | <code>string</code> | WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.labelSelector">labelSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | LabelSelector is used to find matching pods. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.matchLabelKeys">matchLabelKeys</a></code> | <code>string[]</code> | MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.minDomains">minDomains</a></code> | <code>number</code> | MinDomains indicates a minimum number of eligible domains. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeAffinityPolicy">nodeAffinityPolicy</a></code> | <code>string</code> | NodeAffinityPolicy indicates how we will treat Pod's nodeAffinity/nodeSelector when calculating pod topology spread skew. |
| <code><a href="#cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeTaintsPolicy">nodeTaintsPolicy</a></code> | <code>string</code> | NodeTaintsPolicy indicates how we will treat node taints when calculating pod topology spread skew. |

---

##### `maxSkew`<sup>Required</sup> <a name="maxSkew" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.maxSkew"></a>

```typescript
public readonly maxSkew: number;
```

- *Type:* number

MaxSkew describes the degree to which pods may be unevenly distributed.

When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. The global minimum is the minimum number of matching pods in an eligible domain or zero if the number of eligible domains is less than MinDomains. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 2/2/1: In this case, the global minimum is 1. | zone1 | zone2 | zone3 | |  P P  |  P P  |   P   | - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 2/2/2; scheduling it onto zone1(zone2) would make the ActualSkew(3-1) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.

---

##### `topologyKey`<sup>Required</sup> <a name="topologyKey" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.topologyKey"></a>

```typescript
public readonly topologyKey: string;
```

- *Type:* string

TopologyKey is the key of node labels.

Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. We define a domain as a particular instance of a topology. Also, we define an eligible domain as a domain whose nodes meet the requirements of nodeAffinityPolicy and nodeTaintsPolicy. e.g. If TopologyKey is "kubernetes.io/hostname", each Node is a domain of that topology. And, if TopologyKey is "topology.kubernetes.io/zone", each zone is a domain of that topology. It's a required field.

---

##### `whenUnsatisfiable`<sup>Required</sup> <a name="whenUnsatisfiable" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.whenUnsatisfiable"></a>

```typescript
public readonly whenUnsatisfiable: string;
```

- *Type:* string

WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint.

DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location,
but giving higher precedence to topologies that would help reduce the
skew.
A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: | zone1 | zone2 | zone3 | | P P P |   P   |   P   | If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.

---

##### `labelSelector`<sup>Optional</sup> <a name="labelSelector" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.labelSelector"></a>

```typescript
public readonly labelSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector

LabelSelector is used to find matching pods.

Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.

---

##### `matchLabelKeys`<sup>Optional</sup> <a name="matchLabelKeys" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.matchLabelKeys"></a>

```typescript
public readonly matchLabelKeys: string[];
```

- *Type:* string[]

MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated.

The keys are used to lookup values from the incoming pod labels, those key-value labels are ANDed with labelSelector to select the group of existing pods over which spreading will be calculated for the incoming pod. The same key is forbidden to exist in both MatchLabelKeys and LabelSelector. MatchLabelKeys cannot be set when LabelSelector isn't set. Keys that don't exist in the incoming pod labels will be ignored. A null or empty list means only match against labelSelector.

This is a beta field and requires the MatchLabelKeysInPodTopologySpread feature gate to be enabled (enabled by default).

---

##### `minDomains`<sup>Optional</sup> <a name="minDomains" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.minDomains"></a>

```typescript
public readonly minDomains: number;
```

- *Type:* number

MinDomains indicates a minimum number of eligible domains.

When the number of eligible domains with matching topology keys is less than minDomains, Pod Topology Spread treats "global minimum" as 0, and then the calculation of Skew is performed. And when the number of eligible domains with matching topology keys equals or greater than minDomains, this value has no effect on scheduling. As a result, when the number of eligible domains is less than minDomains, scheduler won't schedule more than maxSkew Pods to those domains. If value is nil, the constraint behaves as if MinDomains is equal to 1. Valid values are integers greater than 0. When value is not nil, WhenUnsatisfiable must be DoNotSchedule.

For example, in a 3-zone cluster, MaxSkew is set to 2, MinDomains is set to 5 and pods with the same labelSelector spread as 2/2/2: | zone1 | zone2 | zone3 | |  P P  |  P P  |  P P  | The number of domains is less than 5(MinDomains), so "global minimum" is treated as 0. In this situation, new pod with the same labelSelector cannot be scheduled, because computed skew will be 3(3 - 0) if new Pod is scheduled to any of the three zones, it will violate MaxSkew.

This is a beta field and requires the MinDomainsInPodTopologySpread feature gate to be enabled (enabled by default).

---

##### `nodeAffinityPolicy`<sup>Optional</sup> <a name="nodeAffinityPolicy" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeAffinityPolicy"></a>

```typescript
public readonly nodeAffinityPolicy: string;
```

- *Type:* string

NodeAffinityPolicy indicates how we will treat Pod's nodeAffinity/nodeSelector when calculating pod topology spread skew.

Options are: - Honor: only nodes matching nodeAffinity/nodeSelector are included in the calculations. - Ignore: nodeAffinity/nodeSelector are ignored. All nodes are included in the calculations.

If this value is nil, the behavior is equivalent to the Honor policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

---

##### `nodeTaintsPolicy`<sup>Optional</sup> <a name="nodeTaintsPolicy" id="cdk8s-plus-28.k8s.TopologySpreadConstraint.property.nodeTaintsPolicy"></a>

```typescript
public readonly nodeTaintsPolicy: string;
```

- *Type:* string

NodeTaintsPolicy indicates how we will treat node taints when calculating pod topology spread skew.

Options are: - Honor: nodes without taints, along with tainted nodes for which the incoming pod has a toleration, are included. - Ignore: node taints are ignored. All nodes are included.

If this value is nil, the behavior is equivalent to the Ignore policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

---

### TypedLocalObjectReference <a name="TypedLocalObjectReference" id="cdk8s-plus-28.k8s.TypedLocalObjectReference"></a>

TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const typedLocalObjectReference: k8s.TypedLocalObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.kind">kind</a></code> | <code>string</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.name">name</a></code> | <code>string</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedLocalObjectReference.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup is the group for the resource being referenced. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of resource being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.TypedLocalObjectReference.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

### TypedObjectReference <a name="TypedObjectReference" id="cdk8s-plus-28.k8s.TypedObjectReference"></a>

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.TypedObjectReference.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const typedObjectReference: k8s.TypedObjectReference = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.kind">kind</a></code> | <code>string</code> | Kind is the type of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.name">name</a></code> | <code>string</code> | Name is the name of resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.apiGroup">apiGroup</a></code> | <code>string</code> | APIGroup is the group for the resource being referenced. |
| <code><a href="#cdk8s-plus-28.k8s.TypedObjectReference.property.namespace">namespace</a></code> | <code>string</code> | Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled. |

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.k8s.TypedObjectReference.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

Kind is the type of resource being referenced.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.TypedObjectReference.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of resource being referenced.

---

##### `apiGroup`<sup>Optional</sup> <a name="apiGroup" id="cdk8s-plus-28.k8s.TypedObjectReference.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

APIGroup is the group for the resource being referenced.

If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

---

##### `namespace`<sup>Optional</sup> <a name="namespace" id="cdk8s-plus-28.k8s.TypedObjectReference.property.namespace"></a>

```typescript
public readonly namespace: string;
```

- *Type:* string

Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

---

### UserSubjectV1Beta2 <a name="UserSubjectV1Beta2" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2"></a>

UserSubject holds detailed information for user-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const userSubjectV1Beta2: k8s.UserSubjectV1Beta2 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.UserSubjectV1Beta2.property.name">name</a></code> | <code>string</code> | `name` is the username that matches, or "*" to match all usernames. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.UserSubjectV1Beta2.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the username that matches, or "*" to match all usernames.

Required.

---

### UserSubjectV1Beta3 <a name="UserSubjectV1Beta3" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3"></a>

UserSubject holds detailed information for user-kind subject.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const userSubjectV1Beta3: k8s.UserSubjectV1Beta3 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.UserSubjectV1Beta3.property.name">name</a></code> | <code>string</code> | `name` is the username that matches, or "*" to match all usernames. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.UserSubjectV1Beta3.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

`name` is the username that matches, or "*" to match all usernames.

Required.

---

### ValidatingAdmissionPolicyBindingSpecV1Alpha1 <a name="ValidatingAdmissionPolicyBindingSpecV1Alpha1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1"></a>

ValidatingAdmissionPolicyBindingSpec is the specification of the ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validatingAdmissionPolicyBindingSpecV1Alpha1: k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.matchResources">matchResources</a></code> | <code>cdk8s-plus-28.k8s.MatchResourcesV1Alpha1</code> | MatchResources declares what resources match this binding and will be validated by it. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.paramRef">paramRef</a></code> | <code>cdk8s-plus-28.k8s.ParamRefV1Alpha1</code> | paramRef specifies the parameter resource used to configure the admission control policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.policyName">policyName</a></code> | <code>string</code> | PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.validationActions">validationActions</a></code> | <code>string[]</code> | validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced. |

---

##### `matchResources`<sup>Optional</sup> <a name="matchResources" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.matchResources"></a>

```typescript
public readonly matchResources: MatchResourcesV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.MatchResourcesV1Alpha1

MatchResources declares what resources match this binding and will be validated by it.

Note that this is intersected with the policy's matchConstraints, so only requests that are matched by the policy can be selected by this. If this is unset, all resources matched by the policy are validated by this binding When resourceRules is unset, it does not constrain resource matching. If a resource is matched by the other fields of this object, it will be validated. Note that this is differs from ValidatingAdmissionPolicy matchConstraints, where resourceRules are required.

---

##### `paramRef`<sup>Optional</sup> <a name="paramRef" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.paramRef"></a>

```typescript
public readonly paramRef: ParamRefV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ParamRefV1Alpha1

paramRef specifies the parameter resource used to configure the admission control policy.

It should point to a resource of the type specified in ParamKind of the bound ValidatingAdmissionPolicy. If the policy specifies a ParamKind and the resource referred to by ParamRef does not exist, this binding is considered mis-configured and the FailurePolicy of the ValidatingAdmissionPolicy applied. If the policy does not specify a ParamKind then this field is ignored, and the rules are evaluated without a param.

---

##### `policyName`<sup>Optional</sup> <a name="policyName" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.policyName"></a>

```typescript
public readonly policyName: string;
```

- *Type:* string

PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to.

If the referenced resource does not exist, this binding is considered invalid and will be ignored Required.

---

##### `validationActions`<sup>Optional</sup> <a name="validationActions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Alpha1.property.validationActions"></a>

```typescript
public readonly validationActions: string[];
```

- *Type:* string[]

validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced.

If a validation evaluates to false it is always enforced according to these actions.

Failures defined by the ValidatingAdmissionPolicy's FailurePolicy are enforced according to these actions only if the FailurePolicy is set to Fail, otherwise the failures are ignored. This includes compilation errors, runtime errors and misconfigurations of the policy.

validationActions is declared as a set of action values. Order does not matter. validationActions may not contain duplicates of the same action.

The supported actions values are:

"Deny" specifies that a validation failure results in a denied request.

"Warn" specifies that a validation failure is reported to the request client in HTTP Warning headers, with a warning code of 299. Warnings can be sent both for allowed or denied admission responses.

"Audit" specifies that a validation failure is included in the published audit event for the request. The audit event will contain a `validation.policy.admission.k8s.io/validation_failure` audit annotation with a value containing the details of the validation failures, formatted as a JSON list of objects, each with the following fields: - message: The validation failure message string - policy: The resource name of the ValidatingAdmissionPolicy - binding: The resource name of the ValidatingAdmissionPolicyBinding - expressionIndex: The index of the failed validations in the ValidatingAdmissionPolicy - validationActions: The enforcement actions enacted for the validation failure Example audit annotation: `"validation.policy.admission.k8s.io/validation_failure": "[{"message": "Invalid value", {"policy": "policy.example.com", {"binding": "policybinding.example.com", {"expressionIndex": "1", {"validationActions": ["Audit"]}]"`

Clients should expect to handle additional values by ignoring any values not recognized.

"Deny" and "Warn" may not be used together since this combination needlessly duplicates the validation failure both in the API response body and the HTTP warning headers.

Required.

---

### ValidatingAdmissionPolicyBindingSpecV1Beta1 <a name="ValidatingAdmissionPolicyBindingSpecV1Beta1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1"></a>

ValidatingAdmissionPolicyBindingSpec is the specification of the ValidatingAdmissionPolicyBinding.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validatingAdmissionPolicyBindingSpecV1Beta1: k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.matchResources">matchResources</a></code> | <code>cdk8s-plus-28.k8s.MatchResourcesV1Beta1</code> | MatchResources declares what resources match this binding and will be validated by it. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.paramRef">paramRef</a></code> | <code>cdk8s-plus-28.k8s.ParamRefV1Beta1</code> | paramRef specifies the parameter resource used to configure the admission control policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.policyName">policyName</a></code> | <code>string</code> | PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.validationActions">validationActions</a></code> | <code>string[]</code> | validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced. |

---

##### `matchResources`<sup>Optional</sup> <a name="matchResources" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.matchResources"></a>

```typescript
public readonly matchResources: MatchResourcesV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.MatchResourcesV1Beta1

MatchResources declares what resources match this binding and will be validated by it.

Note that this is intersected with the policy's matchConstraints, so only requests that are matched by the policy can be selected by this. If this is unset, all resources matched by the policy are validated by this binding When resourceRules is unset, it does not constrain resource matching. If a resource is matched by the other fields of this object, it will be validated. Note that this is differs from ValidatingAdmissionPolicy matchConstraints, where resourceRules are required.

---

##### `paramRef`<sup>Optional</sup> <a name="paramRef" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.paramRef"></a>

```typescript
public readonly paramRef: ParamRefV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.ParamRefV1Beta1

paramRef specifies the parameter resource used to configure the admission control policy.

It should point to a resource of the type specified in ParamKind of the bound ValidatingAdmissionPolicy. If the policy specifies a ParamKind and the resource referred to by ParamRef does not exist, this binding is considered mis-configured and the FailurePolicy of the ValidatingAdmissionPolicy applied. If the policy does not specify a ParamKind then this field is ignored, and the rules are evaluated without a param.

---

##### `policyName`<sup>Optional</sup> <a name="policyName" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.policyName"></a>

```typescript
public readonly policyName: string;
```

- *Type:* string

PolicyName references a ValidatingAdmissionPolicy name which the ValidatingAdmissionPolicyBinding binds to.

If the referenced resource does not exist, this binding is considered invalid and will be ignored Required.

---

##### `validationActions`<sup>Optional</sup> <a name="validationActions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicyBindingSpecV1Beta1.property.validationActions"></a>

```typescript
public readonly validationActions: string[];
```

- *Type:* string[]

validationActions declares how Validations of the referenced ValidatingAdmissionPolicy are enforced.

If a validation evaluates to false it is always enforced according to these actions.

Failures defined by the ValidatingAdmissionPolicy's FailurePolicy are enforced according to these actions only if the FailurePolicy is set to Fail, otherwise the failures are ignored. This includes compilation errors, runtime errors and misconfigurations of the policy.

validationActions is declared as a set of action values. Order does not matter. validationActions may not contain duplicates of the same action.

The supported actions values are:

"Deny" specifies that a validation failure results in a denied request.

"Warn" specifies that a validation failure is reported to the request client in HTTP Warning headers, with a warning code of 299. Warnings can be sent both for allowed or denied admission responses.

"Audit" specifies that a validation failure is included in the published audit event for the request. The audit event will contain a `validation.policy.admission.k8s.io/validation_failure` audit annotation with a value containing the details of the validation failures, formatted as a JSON list of objects, each with the following fields: - message: The validation failure message string - policy: The resource name of the ValidatingAdmissionPolicy - binding: The resource name of the ValidatingAdmissionPolicyBinding - expressionIndex: The index of the failed validations in the ValidatingAdmissionPolicy - validationActions: The enforcement actions enacted for the validation failure Example audit annotation: `"validation.policy.admission.k8s.io/validation_failure": "[{"message": "Invalid value", {"policy": "policy.example.com", {"binding": "policybinding.example.com", {"expressionIndex": "1", {"validationActions": ["Audit"]}]"`

Clients should expect to handle additional values by ignoring any values not recognized.

"Deny" and "Warn" may not be used together since this combination needlessly duplicates the validation failure both in the API response body and the HTTP warning headers.

Required.

---

### ValidatingAdmissionPolicySpecV1Alpha1 <a name="ValidatingAdmissionPolicySpecV1Alpha1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1"></a>

ValidatingAdmissionPolicySpec is the specification of the desired behavior of the AdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validatingAdmissionPolicySpecV1Alpha1: k8s.ValidatingAdmissionPolicySpecV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.auditAnnotations">auditAnnotations</a></code> | <code>cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1[]</code> | auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.failurePolicy">failurePolicy</a></code> | <code>string</code> | failurePolicy defines how to handle failures for the admission policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConditions">matchConditions</a></code> | <code>cdk8s-plus-28.k8s.MatchConditionV1Alpha1[]</code> | MatchConditions is a list of conditions that must be met for a request to be validated. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConstraints">matchConstraints</a></code> | <code>cdk8s-plus-28.k8s.MatchResourcesV1Alpha1</code> | MatchConstraints specifies what resources this policy is designed to validate. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.paramKind">paramKind</a></code> | <code>cdk8s-plus-28.k8s.ParamKindV1Alpha1</code> | ParamKind specifies the kind of resources used to parameterize this policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.validations">validations</a></code> | <code>cdk8s-plus-28.k8s.ValidationV1Alpha1[]</code> | Validations contain CEL expressions which is used to apply the validation. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.variables">variables</a></code> | <code>cdk8s-plus-28.k8s.VariableV1Alpha1[]</code> | Variables contain definitions of variables that can be used in composition of other expressions. |

---

##### `auditAnnotations`<sup>Optional</sup> <a name="auditAnnotations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.auditAnnotations"></a>

```typescript
public readonly auditAnnotations: AuditAnnotationV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.AuditAnnotationV1Alpha1[]

auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request.

validations and auditAnnotations may not both be empty; a least one of validations or auditAnnotations is required.

---

##### `failurePolicy`<sup>Optional</sup> <a name="failurePolicy" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.failurePolicy"></a>

```typescript
public readonly failurePolicy: string;
```

- *Type:* string
- *Default:* Fail.

failurePolicy defines how to handle failures for the admission policy.

Failures can occur from CEL expression parse errors, type check errors, runtime errors and invalid or mis-configured policy definitions or bindings.

A policy is invalid if spec.paramKind refers to a non-existent Kind. A binding is invalid if spec.paramRef.name refers to a non-existent resource.

failurePolicy does not define how validations that evaluate to false are handled.

When failurePolicy is set to Fail, ValidatingAdmissionPolicyBinding validationActions define how failures are enforced.

Allowed values are Ignore or Fail. Defaults to Fail.

---

##### `matchConditions`<sup>Optional</sup> <a name="matchConditions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConditions"></a>

```typescript
public readonly matchConditions: MatchConditionV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.MatchConditionV1Alpha1[]

MatchConditions is a list of conditions that must be met for a request to be validated.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

If a parameter object is provided, it can be accessed via the `params` handle in the same manner as validation expressions.

The exact matching logic is (in order):
1. If ANY matchCondition evaluates to FALSE, the policy is skipped.
2. If ALL matchConditions evaluate to TRUE, the policy is evaluated.
3. If any matchCondition evaluates to an error (but none are FALSE):
- If failurePolicy=Fail, reject the request
- If failurePolicy=Ignore, the policy is skipped

---

##### `matchConstraints`<sup>Optional</sup> <a name="matchConstraints" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.matchConstraints"></a>

```typescript
public readonly matchConstraints: MatchResourcesV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.MatchResourcesV1Alpha1

MatchConstraints specifies what resources this policy is designed to validate.

The AdmissionPolicy cares about a request if it matches _all_ Constraints. However, in order to prevent clusters from being put into an unstable state that cannot be recovered from via the API ValidatingAdmissionPolicy cannot match ValidatingAdmissionPolicy and ValidatingAdmissionPolicyBinding. Required.

---

##### `paramKind`<sup>Optional</sup> <a name="paramKind" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.paramKind"></a>

```typescript
public readonly paramKind: ParamKindV1Alpha1;
```

- *Type:* cdk8s-plus-28.k8s.ParamKindV1Alpha1

ParamKind specifies the kind of resources used to parameterize this policy.

If absent, there are no parameters for this policy and the param CEL variable will not be provided to validation expressions. If ParamKind refers to a non-existent kind, this policy definition is mis-configured and the FailurePolicy is applied. If paramKind is specified but paramRef is unset in ValidatingAdmissionPolicyBinding, the params variable will be null.

---

##### `validations`<sup>Optional</sup> <a name="validations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.validations"></a>

```typescript
public readonly validations: ValidationV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.ValidationV1Alpha1[]

Validations contain CEL expressions which is used to apply the validation.

Validations and AuditAnnotations may not both be empty; a minimum of one Validations or AuditAnnotations is required.

---

##### `variables`<sup>Optional</sup> <a name="variables" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Alpha1.property.variables"></a>

```typescript
public readonly variables: VariableV1Alpha1[];
```

- *Type:* cdk8s-plus-28.k8s.VariableV1Alpha1[]

Variables contain definitions of variables that can be used in composition of other expressions.

Each variable is defined as a named CEL expression. The variables defined here will be available under `variables` in other expressions of the policy except MatchConditions because MatchConditions are evaluated before the rest of the policy.

The expression of a variable can refer to other variables defined earlier in the list but not those after. Thus, Variables must be sorted by the order of first appearance and acyclic.

---

### ValidatingAdmissionPolicySpecV1Beta1 <a name="ValidatingAdmissionPolicySpecV1Beta1" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1"></a>

ValidatingAdmissionPolicySpec is the specification of the desired behavior of the AdmissionPolicy.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validatingAdmissionPolicySpecV1Beta1: k8s.ValidatingAdmissionPolicySpecV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.auditAnnotations">auditAnnotations</a></code> | <code>cdk8s-plus-28.k8s.AuditAnnotationV1Beta1[]</code> | auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.failurePolicy">failurePolicy</a></code> | <code>string</code> | failurePolicy defines how to handle failures for the admission policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConditions">matchConditions</a></code> | <code>cdk8s-plus-28.k8s.MatchConditionV1Beta1[]</code> | MatchConditions is a list of conditions that must be met for a request to be validated. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConstraints">matchConstraints</a></code> | <code>cdk8s-plus-28.k8s.MatchResourcesV1Beta1</code> | MatchConstraints specifies what resources this policy is designed to validate. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.paramKind">paramKind</a></code> | <code>cdk8s-plus-28.k8s.ParamKindV1Beta1</code> | ParamKind specifies the kind of resources used to parameterize this policy. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.validations">validations</a></code> | <code>cdk8s-plus-28.k8s.ValidationV1Beta1[]</code> | Validations contain CEL expressions which is used to apply the validation. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.variables">variables</a></code> | <code>cdk8s-plus-28.k8s.VariableV1Beta1[]</code> | Variables contain definitions of variables that can be used in composition of other expressions. |

---

##### `auditAnnotations`<sup>Optional</sup> <a name="auditAnnotations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.auditAnnotations"></a>

```typescript
public readonly auditAnnotations: AuditAnnotationV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.AuditAnnotationV1Beta1[]

auditAnnotations contains CEL expressions which are used to produce audit annotations for the audit event of the API request.

validations and auditAnnotations may not both be empty; a least one of validations or auditAnnotations is required.

---

##### `failurePolicy`<sup>Optional</sup> <a name="failurePolicy" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.failurePolicy"></a>

```typescript
public readonly failurePolicy: string;
```

- *Type:* string
- *Default:* Fail.

failurePolicy defines how to handle failures for the admission policy.

Failures can occur from CEL expression parse errors, type check errors, runtime errors and invalid or mis-configured policy definitions or bindings.

A policy is invalid if spec.paramKind refers to a non-existent Kind. A binding is invalid if spec.paramRef.name refers to a non-existent resource.

failurePolicy does not define how validations that evaluate to false are handled.

When failurePolicy is set to Fail, ValidatingAdmissionPolicyBinding validationActions define how failures are enforced.

Allowed values are Ignore or Fail. Defaults to Fail.

---

##### `matchConditions`<sup>Optional</sup> <a name="matchConditions" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConditions"></a>

```typescript
public readonly matchConditions: MatchConditionV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.MatchConditionV1Beta1[]

MatchConditions is a list of conditions that must be met for a request to be validated.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

If a parameter object is provided, it can be accessed via the `params` handle in the same manner as validation expressions.

The exact matching logic is (in order):
1. If ANY matchCondition evaluates to FALSE, the policy is skipped.
2. If ALL matchConditions evaluate to TRUE, the policy is evaluated.
3. If any matchCondition evaluates to an error (but none are FALSE):
- If failurePolicy=Fail, reject the request
- If failurePolicy=Ignore, the policy is skipped

---

##### `matchConstraints`<sup>Optional</sup> <a name="matchConstraints" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.matchConstraints"></a>

```typescript
public readonly matchConstraints: MatchResourcesV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.MatchResourcesV1Beta1

MatchConstraints specifies what resources this policy is designed to validate.

The AdmissionPolicy cares about a request if it matches _all_ Constraints. However, in order to prevent clusters from being put into an unstable state that cannot be recovered from via the API ValidatingAdmissionPolicy cannot match ValidatingAdmissionPolicy and ValidatingAdmissionPolicyBinding. Required.

---

##### `paramKind`<sup>Optional</sup> <a name="paramKind" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.paramKind"></a>

```typescript
public readonly paramKind: ParamKindV1Beta1;
```

- *Type:* cdk8s-plus-28.k8s.ParamKindV1Beta1

ParamKind specifies the kind of resources used to parameterize this policy.

If absent, there are no parameters for this policy and the param CEL variable will not be provided to validation expressions. If ParamKind refers to a non-existent kind, this policy definition is mis-configured and the FailurePolicy is applied. If paramKind is specified but paramRef is unset in ValidatingAdmissionPolicyBinding, the params variable will be null.

---

##### `validations`<sup>Optional</sup> <a name="validations" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.validations"></a>

```typescript
public readonly validations: ValidationV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.ValidationV1Beta1[]

Validations contain CEL expressions which is used to apply the validation.

Validations and AuditAnnotations may not both be empty; a minimum of one Validations or AuditAnnotations is required.

---

##### `variables`<sup>Optional</sup> <a name="variables" id="cdk8s-plus-28.k8s.ValidatingAdmissionPolicySpecV1Beta1.property.variables"></a>

```typescript
public readonly variables: VariableV1Beta1[];
```

- *Type:* cdk8s-plus-28.k8s.VariableV1Beta1[]

Variables contain definitions of variables that can be used in composition of other expressions.

Each variable is defined as a named CEL expression. The variables defined here will be available under `variables` in other expressions of the policy except MatchConditions because MatchConditions are evaluated before the rest of the policy.

The expression of a variable can refer to other variables defined earlier in the list but not those after. Thus, Variables must be sorted by the order of first appearance and acyclic.

---

### ValidatingWebhook <a name="ValidatingWebhook" id="cdk8s-plus-28.k8s.ValidatingWebhook"></a>

ValidatingWebhook describes an admission webhook and the resources and operations it applies to.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidatingWebhook.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validatingWebhook: k8s.ValidatingWebhook = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.admissionReviewVersions">admissionReviewVersions</a></code> | <code>string[]</code> | AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.clientConfig">clientConfig</a></code> | <code>cdk8s-plus-28.k8s.WebhookClientConfig</code> | ClientConfig defines how to communicate with the hook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.name">name</a></code> | <code>string</code> | The name of the admission webhook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.sideEffects">sideEffects</a></code> | <code>string</code> | SideEffects states whether this webhook has side effects. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.failurePolicy">failurePolicy</a></code> | <code>string</code> | FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.matchConditions">matchConditions</a></code> | <code>cdk8s-plus-28.k8s.MatchCondition[]</code> | MatchConditions is a list of conditions that must be met for a request to be sent to this webhook. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.matchPolicy">matchPolicy</a></code> | <code>string</code> | matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent". |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.namespaceSelector">namespaceSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.objectSelector">objectSelector</a></code> | <code>cdk8s-plus-28.k8s.LabelSelector</code> | ObjectSelector decides whether to run the webhook based on if the object has matching labels. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.rules">rules</a></code> | <code>cdk8s-plus-28.k8s.RuleWithOperations[]</code> | Rules describes what operations on what resources/subresources the webhook cares about. |
| <code><a href="#cdk8s-plus-28.k8s.ValidatingWebhook.property.timeoutSeconds">timeoutSeconds</a></code> | <code>number</code> | TimeoutSeconds specifies the timeout for this webhook. |

---

##### `admissionReviewVersions`<sup>Required</sup> <a name="admissionReviewVersions" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.admissionReviewVersions"></a>

```typescript
public readonly admissionReviewVersions: string[];
```

- *Type:* string[]

AdmissionReviewVersions is an ordered list of preferred `AdmissionReview` versions the Webhook expects.

API server will try to use first version in the list which it supports. If none of the versions specified in this list supported by API server, validation will fail for this object. If a persisted webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail and be subject to the failure policy.

---

##### `clientConfig`<sup>Required</sup> <a name="clientConfig" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.clientConfig"></a>

```typescript
public readonly clientConfig: WebhookClientConfig;
```

- *Type:* cdk8s-plus-28.k8s.WebhookClientConfig

ClientConfig defines how to communicate with the hook.

Required

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the admission webhook.

Name should be fully qualified, e.g., imagepolicy.kubernetes.io, where "imagepolicy" is the name of the webhook, and kubernetes.io is the name of the organization. Required.

---

##### `sideEffects`<sup>Required</sup> <a name="sideEffects" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.sideEffects"></a>

```typescript
public readonly sideEffects: string;
```

- *Type:* string

SideEffects states whether this webhook has side effects.

Acceptable values are: None, NoneOnDryRun (webhooks created via v1beta1 may also specify Some or Unknown). Webhooks with side effects MUST implement a reconciliation system, since a request may be rejected by a future step in the admission chain and the side effects therefore need to be undone. Requests with the dryRun attribute will be auto-rejected if they match a webhook with sideEffects == Unknown or Some.

---

##### `failurePolicy`<sup>Optional</sup> <a name="failurePolicy" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.failurePolicy"></a>

```typescript
public readonly failurePolicy: string;
```

- *Type:* string
- *Default:* Fail.

FailurePolicy defines how unrecognized errors from the admission endpoint are handled - allowed values are Ignore or Fail.

Defaults to Fail.

---

##### `matchConditions`<sup>Optional</sup> <a name="matchConditions" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.matchConditions"></a>

```typescript
public readonly matchConditions: MatchCondition[];
```

- *Type:* cdk8s-plus-28.k8s.MatchCondition[]

MatchConditions is a list of conditions that must be met for a request to be sent to this webhook.

Match conditions filter requests that have already been matched by the rules, namespaceSelector, and objectSelector. An empty list of matchConditions matches all requests. There are a maximum of 64 match conditions allowed.

The exact matching logic is (in order):
1. If ANY matchCondition evaluates to FALSE, the webhook is skipped.
2. If ALL matchConditions evaluate to TRUE, the webhook is called.
3. If any matchCondition evaluates to an error (but none are FALSE):
- If failurePolicy=Fail, reject the request
- If failurePolicy=Ignore, the error is ignored and the webhook is skipped

This is a beta feature and managed by the AdmissionWebhookMatchConditions feature gate.

---

##### `matchPolicy`<sup>Optional</sup> <a name="matchPolicy" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.matchPolicy"></a>

```typescript
public readonly matchPolicy: string;
```

- *Type:* string
- *Default:* Equivalent"

matchPolicy defines how the "rules" list is used to match incoming requests. Allowed values are "Exact" or "Equivalent".

Exact: match a request only if it exactly matches a specified rule. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, but "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would not be sent to the webhook.

- Equivalent: match a request if modifies a resource listed in rules, even via another API group or version. For example, if deployments can be modified via apps/v1, apps/v1beta1, and extensions/v1beta1, and "rules" only included `apiGroups:["apps"], apiVersions:["v1"], resources: ["deployments"]`, a request to apps/v1beta1 or extensions/v1beta1 would be converted to apps/v1 and sent to the webhook.

Defaults to "Equivalent"

---

##### `namespaceSelector`<sup>Optional</sup> <a name="namespaceSelector" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.namespaceSelector"></a>

```typescript
public readonly namespaceSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

NamespaceSelector decides whether to run the webhook on an object based on whether the namespace for that object matches the selector.

If the object itself is a namespace, the matching is performed on object.metadata.labels. If the object is another cluster scoped resource, it never skips the webhook.

For example, to run the webhook on any objects whose namespace is not associated with "runlevel" of "0" or "1";  you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "runlevel",
"operator": "NotIn",
"values": [
"0",
"1"
]
}
]
}

If instead you want to only run the webhook on any objects whose namespace is associated with the "environment" of "prod" or "staging"; you will set the selector as follows: "namespaceSelector": {
"matchExpressions": [
{
"key": "environment",
"operator": "In",
"values": [
"prod",
"staging"
]
}
]
}

See https://kubernetes.io/docs/concepts/overview/working-with-objects/labels for more examples of label selectors.

Default to the empty LabelSelector, which matches everything.

---

##### `objectSelector`<sup>Optional</sup> <a name="objectSelector" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.objectSelector"></a>

```typescript
public readonly objectSelector: LabelSelector;
```

- *Type:* cdk8s-plus-28.k8s.LabelSelector
- *Default:* the empty LabelSelector, which matches everything.

ObjectSelector decides whether to run the webhook based on if the object has matching labels.

objectSelector is evaluated against both the oldObject and newObject that would be sent to the webhook, and is considered to match if either object matches the selector. A null object (oldObject in the case of create, or newObject in the case of delete) or an object that cannot have labels (like a DeploymentRollback or a PodProxyOptions object) is not considered to match. Use the object selector only if the webhook is opt-in, because end users may skip the admission webhook by setting the labels. Default to the empty LabelSelector, which matches everything.

---

##### `rules`<sup>Optional</sup> <a name="rules" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.rules"></a>

```typescript
public readonly rules: RuleWithOperations[];
```

- *Type:* cdk8s-plus-28.k8s.RuleWithOperations[]

Rules describes what operations on what resources/subresources the webhook cares about.

The webhook cares about an operation if it matches _any_ Rule. However, in order to prevent ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks from putting the cluster in a state which cannot be recovered from without completely disabling the plugin, ValidatingAdmissionWebhooks and MutatingAdmissionWebhooks are never called on admission requests for ValidatingWebhookConfiguration and MutatingWebhookConfiguration objects.

---

##### `timeoutSeconds`<sup>Optional</sup> <a name="timeoutSeconds" id="cdk8s-plus-28.k8s.ValidatingWebhook.property.timeoutSeconds"></a>

```typescript
public readonly timeoutSeconds: number;
```

- *Type:* number
- *Default:* 10 seconds.

TimeoutSeconds specifies the timeout for this webhook.

After the timeout passes, the webhook call will be ignored or the API call will fail based on the failure policy. The timeout value must be between 1 and 30 seconds. Default to 10 seconds.

---

### ValidationRule <a name="ValidationRule" id="cdk8s-plus-28.k8s.ValidationRule"></a>

ValidationRule describes a validation rule written in the CEL expression language.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationRule.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validationRule: k8s.ValidationRule = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.rule">rule</a></code> | <code>string</code> | Rule represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.fieldPath">fieldPath</a></code> | <code>string</code> | fieldPath represents the field path returned when the validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.message">message</a></code> | <code>string</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.messageExpression">messageExpression</a></code> | <code>string</code> | MessageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationRule.property.reason">reason</a></code> | <code>string</code> | reason provides a machine-readable validation failure reason that is returned to the caller when a request fails this validation rule. |

---

##### `rule`<sup>Required</sup> <a name="rule" id="cdk8s-plus-28.k8s.ValidationRule.property.rule"></a>

```typescript
public readonly rule: string;
```

- *Type:* string

Rule represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec The Rule is scoped to the location of the x-kubernetes-validations extension in the schema. The `self` variable in the CEL expression is bound to the scoped value. Example: - Rule scoped to the root of a resource with a status subresource: {"rule": "self.status.actual <= self.spec.maxDesired"}

If the Rule is scoped to an object with properties, the accessible properties of the object are field selectable via `self.field` and field presence can be checked via `has(self.field)`. Null valued fields are treated as absent fields in CEL expressions. If the Rule is scoped to an object with additionalProperties (i.e. a map) the value of the map are accessible via `self[mapKey]`, map containment can be checked via `mapKey in self` and all entries of the map are accessible via CEL macros and functions such as `self.all(...)`. If the Rule is scoped to an array, the elements of the array are accessible via `self[i]` and also by macros and functions. If the Rule is scoped to a scalar, `self` is bound to the scalar value. Examples: - Rule scoped to a map of objects: {"rule": "self.components['Widget'].priority < 10"} - Rule scoped to a list of integers: {"rule": "self.values.all(value, value >= 0 && value < 100)"} - Rule scoped to a string value: {"rule": "self.startsWith('kube')"}

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object and from any x-kubernetes-embedded-resource annotated objects. No other metadata properties are accessible.

Unknown data preserved in custom resources via x-kubernetes-preserve-unknown-fields is not accessible in CEL expressions. This includes: - Unknown field values that are preserved by object schemas with x-kubernetes-preserve-unknown-fields. - Object properties where the property schema is of an "unknown type". An "unknown type" is recursively defined as:
- A schema with no type and x-kubernetes-preserve-unknown-fields set to true
- An array where the items schema is of an "unknown type"
- An object where the additionalProperties schema is of an "unknown type"

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '__' escapes to '__underscores__' - '.' escapes to '__dot__' - '-' escapes to '__dash__' - '/' escapes to '__slash__' - Property names that exactly match a CEL RESERVED keyword escape to '__{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:
- Rule accessing a property named "namespace": {"rule": "self.__namespace__ > 0"}
- Rule accessing a property named "x-prop": {"rule": "self.x__dash__prop > 0"}
- Rule accessing a property named "redact__d": {"rule": "self.redact__underscores__d > 0"}

Equality on arrays with x-kubernetes-list-type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:
- 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
non-intersecting elements in `Y` are appended, retaining their partial order.
- 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
non-intersecting keys are appended, retaining their partial order.

---

##### `fieldPath`<sup>Optional</sup> <a name="fieldPath" id="cdk8s-plus-28.k8s.ValidationRule.property.fieldPath"></a>

```typescript
public readonly fieldPath: string;
```

- *Type:* string

fieldPath represents the field path returned when the validation fails.

It must be a relative JSON path (i.e. with array notation) scoped to the location of this x-kubernetes-validations extension in the schema and refer to an existing field. e.g. when validation checks if a specific attribute `foo` under a map `testMap`, the fieldPath could be set to `.testMap.foo` If the validation checks two lists must have unique attributes, the fieldPath could be set to either of the list: e.g. `.testList` It does not support list numeric index. It supports child operation to refer to an existing field currently. Refer to [JSONPath support in Kubernetes](https://kubernetes.io/docs/reference/kubectl/jsonpath/) for more info. Numeric index of array is not supported. For field name which contains special characters, use `['specialName']` to refer the field name. e.g. for attribute `foo.34$` appears in a list `testList`, the fieldPath could be set to `.testList['foo.34$']`

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationRule.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

Message represents the message displayed when validation fails.

The message is required if the Rule contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host"

---

##### `messageExpression`<sup>Optional</sup> <a name="messageExpression" id="cdk8s-plus-28.k8s.ValidationRule.property.messageExpression"></a>

```typescript
public readonly messageExpression: string;
```

- *Type:* string

MessageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a rule, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the rule; the only difference is the return type. Example: "x must be less than max ("+string(self.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationRule.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

reason provides a machine-readable validation failure reason that is returned to the caller when a request fails this validation rule.

The HTTP status code returned to the caller will match the reason of the reason of the first failed validation rule. The currently supported reasons are: "FieldValueInvalid", "FieldValueForbidden", "FieldValueRequired", "FieldValueDuplicate". If not set, default to use "FieldValueInvalid". All future added reasons must be accepted by clients when reading this value and unknown reasons should be treated as FieldValueInvalid.

---

### ValidationV1Alpha1 <a name="ValidationV1Alpha1" id="cdk8s-plus-28.k8s.ValidationV1Alpha1"></a>

Validation specifies the CEL expression which is used to apply the validation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validationV1Alpha1: k8s.ValidationV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.expression">expression</a></code> | <code>string</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.message">message</a></code> | <code>string</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.messageExpression">messageExpression</a></code> | <code>string</code> | messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Alpha1.property.reason">reason</a></code> | <code>string</code> | Reason represents a machine-readable description of why this validation failed. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec CEL expressions have access to the contents of the API request/response, organized into CEL variables as well as some other useful variables:

- 'object' - The object from the incoming request. The value is null for DELETE requests. - 'oldObject' - The existing object. The value is null for CREATE requests. - 'request' - Attributes of the API request([ref](/pkg/apis/admission/types.go#AdmissionRequest)). - 'params' - Parameter resource referred to by the policy binding being evaluated. Only populated if the policy has a ParamKind. - 'namespaceObject' - The namespace object that the incoming object belongs to. The value is null for cluster-scoped resources. - 'variables' - Map of composited variables, from its name to its lazily evaluated value.
For example, a variable named 'foo' can be accessed as 'variables.foo'.
- 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
- 'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object. No other metadata properties are accessible.

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '__' escapes to '__underscores__' - '.' escapes to '__dot__' - '-' escapes to '__dash__' - '/' escapes to '__slash__' - Property names that exactly match a CEL RESERVED keyword escape to '__{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:
- Expression accessing a property named "namespace": {"Expression": "object.__namespace__ > 0"}
- Expression accessing a property named "x-prop": {"Expression": "object.x__dash__prop > 0"}
- Expression accessing a property named "redact__d": {"Expression": "object.redact__underscores__d > 0"}

Equality on arrays with list type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:
- 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
non-intersecting elements in `Y` are appended, retaining their partial order.
- 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
non-intersecting keys are appended, retaining their partial order.
Required.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

Message represents the message displayed when validation fails.

The message is required if the Expression contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host" If the Expression contains line breaks. Message is required. The message must not contain line breaks. If unset, the message is "failed Expression: {Expression}".

---

##### `messageExpression`<sup>Optional</sup> <a name="messageExpression" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.messageExpression"></a>

```typescript
public readonly messageExpression: string;
```

- *Type:* string

messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a validation, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the `expression` except for 'authorizer' and 'authorizer.requestResource'. Example: "object.x must be less than max ("+string(params.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationV1Alpha1.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

Reason represents a machine-readable description of why this validation failed.

If this is the first validation in the list to fail, this reason, as well as the corresponding HTTP response code, are used in the HTTP response to the client. The currently supported reasons are: "Unauthorized", "Forbidden", "Invalid", "RequestEntityTooLarge". If not set, StatusReasonInvalid is used in the response to the client.

---

### ValidationV1Beta1 <a name="ValidationV1Beta1" id="cdk8s-plus-28.k8s.ValidationV1Beta1"></a>

Validation specifies the CEL expression which is used to apply the validation.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.ValidationV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const validationV1Beta1: k8s.ValidationV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.expression">expression</a></code> | <code>string</code> | Expression represents the expression which will be evaluated by CEL. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.message">message</a></code> | <code>string</code> | Message represents the message displayed when validation fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.messageExpression">messageExpression</a></code> | <code>string</code> | messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. |
| <code><a href="#cdk8s-plus-28.k8s.ValidationV1Beta1.property.reason">reason</a></code> | <code>string</code> | Reason represents a machine-readable description of why this validation failed. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression represents the expression which will be evaluated by CEL.

ref: https://github.com/google/cel-spec CEL expressions have access to the contents of the API request/response, organized into CEL variables as well as some other useful variables:

- 'object' - The object from the incoming request. The value is null for DELETE requests. - 'oldObject' - The existing object. The value is null for CREATE requests. - 'request' - Attributes of the API request([ref](/pkg/apis/admission/types.go#AdmissionRequest)). - 'params' - Parameter resource referred to by the policy binding being evaluated. Only populated if the policy has a ParamKind. - 'namespaceObject' - The namespace object that the incoming object belongs to. The value is null for cluster-scoped resources. - 'variables' - Map of composited variables, from its name to its lazily evaluated value.
For example, a variable named 'foo' can be accessed as 'variables.foo'.
- 'authorizer' - A CEL Authorizer. May be used to perform authorization checks for the principal (user or service account) of the request.
See https://pkg.go.dev/k8s.io/apiserver/pkg/cel/library#Authz
- 'authorizer.requestResource' - A CEL ResourceCheck constructed from the 'authorizer' and configured with the
request resource.

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object. No other metadata properties are accessible.

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '__' escapes to '__underscores__' - '.' escapes to '__dot__' - '-' escapes to '__dash__' - '/' escapes to '__slash__' - Property names that exactly match a CEL RESERVED keyword escape to '__{keyword}__'. The keywords are:
"true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
"import", "let", "loop", "package", "namespace", "return".
Examples:
- Expression accessing a property named "namespace": {"Expression": "object.__namespace__ > 0"}
- Expression accessing a property named "x-prop": {"Expression": "object.x__dash__prop > 0"}
- Expression accessing a property named "redact__d": {"Expression": "object.redact__underscores__d > 0"}

Equality on arrays with list type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:
- 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
non-intersecting elements in `Y` are appended, retaining their partial order.
- 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
non-intersecting keys are appended, retaining their partial order.
Required.

---

##### `message`<sup>Optional</sup> <a name="message" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.message"></a>

```typescript
public readonly message: string;
```

- *Type:* string

Message represents the message displayed when validation fails.

The message is required if the Expression contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host" If the Expression contains line breaks. Message is required. The message must not contain line breaks. If unset, the message is "failed Expression: {Expression}".

---

##### `messageExpression`<sup>Optional</sup> <a name="messageExpression" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.messageExpression"></a>

```typescript
public readonly messageExpression: string;
```

- *Type:* string

messageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails.

Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a validation, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the `expression` except for 'authorizer' and 'authorizer.requestResource'. Example: "object.x must be less than max ("+string(params.max)+")"

---

##### `reason`<sup>Optional</sup> <a name="reason" id="cdk8s-plus-28.k8s.ValidationV1Beta1.property.reason"></a>

```typescript
public readonly reason: string;
```

- *Type:* string

Reason represents a machine-readable description of why this validation failed.

If this is the first validation in the list to fail, this reason, as well as the corresponding HTTP response code, are used in the HTTP response to the client. The currently supported reasons are: "Unauthorized", "Forbidden", "Invalid", "RequestEntityTooLarge". If not set, StatusReasonInvalid is used in the response to the client.

---

### VariableV1Alpha1 <a name="VariableV1Alpha1" id="cdk8s-plus-28.k8s.VariableV1Alpha1"></a>

Variable is the definition of a variable that is used for composition.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VariableV1Alpha1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const variableV1Alpha1: k8s.VariableV1Alpha1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Alpha1.property.expression">expression</a></code> | <code>string</code> | Expression is the expression that will be evaluated as the value of the variable. |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Alpha1.property.name">name</a></code> | <code>string</code> | Name is the name of the variable. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.VariableV1Alpha1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression is the expression that will be evaluated as the value of the variable.

The CEL expression has access to the same identifiers as the CEL expressions in Validation.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VariableV1Alpha1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of the variable.

The name must be a valid CEL identifier and unique among all variables. The variable can be accessed in other expressions through `variables` For example, if name is "foo", the variable will be available as `variables.foo`

---

### VariableV1Beta1 <a name="VariableV1Beta1" id="cdk8s-plus-28.k8s.VariableV1Beta1"></a>

Variable is the definition of a variable that is used for composition.

A variable is defined as a named expression.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VariableV1Beta1.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const variableV1Beta1: k8s.VariableV1Beta1 = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Beta1.property.expression">expression</a></code> | <code>string</code> | Expression is the expression that will be evaluated as the value of the variable. |
| <code><a href="#cdk8s-plus-28.k8s.VariableV1Beta1.property.name">name</a></code> | <code>string</code> | Name is the name of the variable. |

---

##### `expression`<sup>Required</sup> <a name="expression" id="cdk8s-plus-28.k8s.VariableV1Beta1.property.expression"></a>

```typescript
public readonly expression: string;
```

- *Type:* string

Expression is the expression that will be evaluated as the value of the variable.

The CEL expression has access to the same identifiers as the CEL expressions in Validation.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VariableV1Beta1.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name is the name of the variable.

The name must be a valid CEL identifier and unique among all variables. The variable can be accessed in other expressions through `variables` For example, if name is "foo", the variable will be available as `variables.foo`

---

### Volume <a name="Volume" id="cdk8s-plus-28.k8s.Volume"></a>

Volume represents a named volume in a pod that may be accessed by any container in the pod.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.Volume.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volume: k8s.Volume = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.name">name</a></code> | <code>string</code> | name of the volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.awsElasticBlockStore">awsElasticBlockStore</a></code> | <code>cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource</code> | awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.azureDisk">azureDisk</a></code> | <code>cdk8s-plus-28.k8s.AzureDiskVolumeSource</code> | azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.azureFile">azureFile</a></code> | <code>cdk8s-plus-28.k8s.AzureFileVolumeSource</code> | azureFile represents an Azure File Service mount on the host and bind mount to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.cephfs">cephfs</a></code> | <code>cdk8s-plus-28.k8s.CephFsVolumeSource</code> | cephFS represents a Ceph FS mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.cinder">cinder</a></code> | <code>cdk8s-plus-28.k8s.CinderVolumeSource</code> | cinder represents a cinder volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.configMap">configMap</a></code> | <code>cdk8s-plus-28.k8s.ConfigMapVolumeSource</code> | configMap represents a configMap that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.csi">csi</a></code> | <code>cdk8s-plus-28.k8s.CsiVolumeSource</code> | csi (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature). |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.downwardApi">downwardApi</a></code> | <code>cdk8s-plus-28.k8s.DownwardApiVolumeSource</code> | downwardAPI represents downward API about the pod that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.emptyDir">emptyDir</a></code> | <code>cdk8s-plus-28.k8s.EmptyDirVolumeSource</code> | emptyDir represents a temporary directory that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.ephemeral">ephemeral</a></code> | <code>cdk8s-plus-28.k8s.EphemeralVolumeSource</code> | ephemeral represents a volume that is handled by a cluster storage driver. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.fc">fc</a></code> | <code>cdk8s-plus-28.k8s.FcVolumeSource</code> | fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.flexVolume">flexVolume</a></code> | <code>cdk8s-plus-28.k8s.FlexVolumeSource</code> | flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.flocker">flocker</a></code> | <code>cdk8s-plus-28.k8s.FlockerVolumeSource</code> | flocker represents a Flocker volume attached to a kubelet's host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.gcePersistentDisk">gcePersistentDisk</a></code> | <code>cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource</code> | gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.gitRepo">gitRepo</a></code> | <code>cdk8s-plus-28.k8s.GitRepoVolumeSource</code> | gitRepo represents a git repository at a particular revision. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.glusterfs">glusterfs</a></code> | <code>cdk8s-plus-28.k8s.GlusterfsVolumeSource</code> | glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.hostPath">hostPath</a></code> | <code>cdk8s-plus-28.k8s.HostPathVolumeSource</code> | hostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.iscsi">iscsi</a></code> | <code>cdk8s-plus-28.k8s.IscsiVolumeSource</code> | iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.nfs">nfs</a></code> | <code>cdk8s-plus-28.k8s.NfsVolumeSource</code> | nfs represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.persistentVolumeClaim">persistentVolumeClaim</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource</code> | persistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.photonPersistentDisk">photonPersistentDisk</a></code> | <code>cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource</code> | photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.portworxVolume">portworxVolume</a></code> | <code>cdk8s-plus-28.k8s.PortworxVolumeSource</code> | portworxVolume represents a portworx volume attached and mounted on kubelets host machine. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.projected">projected</a></code> | <code>cdk8s-plus-28.k8s.ProjectedVolumeSource</code> | projected items for all in one resources secrets, configmaps, and downward API. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.quobyte">quobyte</a></code> | <code>cdk8s-plus-28.k8s.QuobyteVolumeSource</code> | quobyte represents a Quobyte mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.rbd">rbd</a></code> | <code>cdk8s-plus-28.k8s.RbdVolumeSource</code> | rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.scaleIo">scaleIo</a></code> | <code>cdk8s-plus-28.k8s.ScaleIoVolumeSource</code> | scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.secret">secret</a></code> | <code>cdk8s-plus-28.k8s.SecretVolumeSource</code> | secret represents a secret that should populate this volume. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.storageos">storageos</a></code> | <code>cdk8s-plus-28.k8s.StorageOsVolumeSource</code> | storageOS represents a StorageOS volume attached and mounted on Kubernetes nodes. |
| <code><a href="#cdk8s-plus-28.k8s.Volume.property.vsphereVolume">vsphereVolume</a></code> | <code>cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource</code> | vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine. |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.Volume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name of the volume.

Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

---

##### `awsElasticBlockStore`<sup>Optional</sup> <a name="awsElasticBlockStore" id="cdk8s-plus-28.k8s.Volume.property.awsElasticBlockStore"></a>

```typescript
public readonly awsElasticBlockStore: AwsElasticBlockStoreVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AwsElasticBlockStoreVolumeSource

awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

---

##### `azureDisk`<sup>Optional</sup> <a name="azureDisk" id="cdk8s-plus-28.k8s.Volume.property.azureDisk"></a>

```typescript
public readonly azureDisk: AzureDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AzureDiskVolumeSource

azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

---

##### `azureFile`<sup>Optional</sup> <a name="azureFile" id="cdk8s-plus-28.k8s.Volume.property.azureFile"></a>

```typescript
public readonly azureFile: AzureFileVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.AzureFileVolumeSource

azureFile represents an Azure File Service mount on the host and bind mount to the pod.

---

##### `cephfs`<sup>Optional</sup> <a name="cephfs" id="cdk8s-plus-28.k8s.Volume.property.cephfs"></a>

```typescript
public readonly cephfs: CephFsVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CephFsVolumeSource

cephFS represents a Ceph FS mount on the host that shares a pod's lifetime.

---

##### `cinder`<sup>Optional</sup> <a name="cinder" id="cdk8s-plus-28.k8s.Volume.property.cinder"></a>

```typescript
public readonly cinder: CinderVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CinderVolumeSource

cinder represents a cinder volume attached and mounted on kubelets host machine.

More info: https://examples.k8s.io/mysql-cinder-pd/README.md

---

##### `configMap`<sup>Optional</sup> <a name="configMap" id="cdk8s-plus-28.k8s.Volume.property.configMap"></a>

```typescript
public readonly configMap: ConfigMapVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.ConfigMapVolumeSource

configMap represents a configMap that should populate this volume.

---

##### `csi`<sup>Optional</sup> <a name="csi" id="cdk8s-plus-28.k8s.Volume.property.csi"></a>

```typescript
public readonly csi: CsiVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.CsiVolumeSource

csi (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).

---

##### `downwardApi`<sup>Optional</sup> <a name="downwardApi" id="cdk8s-plus-28.k8s.Volume.property.downwardApi"></a>

```typescript
public readonly downwardApi: DownwardApiVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.DownwardApiVolumeSource

downwardAPI represents downward API about the pod that should populate this volume.

---

##### `emptyDir`<sup>Optional</sup> <a name="emptyDir" id="cdk8s-plus-28.k8s.Volume.property.emptyDir"></a>

```typescript
public readonly emptyDir: EmptyDirVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.EmptyDirVolumeSource

emptyDir represents a temporary directory that shares a pod's lifetime.

More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

---

##### `ephemeral`<sup>Optional</sup> <a name="ephemeral" id="cdk8s-plus-28.k8s.Volume.property.ephemeral"></a>

```typescript
public readonly ephemeral: EphemeralVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.EphemeralVolumeSource

ephemeral represents a volume that is handled by a cluster storage driver.

The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.

Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity
tracking are needed,
c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through
a PersistentVolumeClaim (see EphemeralVolumeSource for more
information on the connection between this volume type
and PersistentVolumeClaim).

Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.

Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.

A pod can use both types of ephemeral volumes and persistent volumes at the same time.

---

##### `fc`<sup>Optional</sup> <a name="fc" id="cdk8s-plus-28.k8s.Volume.property.fc"></a>

```typescript
public readonly fc: FcVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FcVolumeSource

fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

---

##### `flexVolume`<sup>Optional</sup> <a name="flexVolume" id="cdk8s-plus-28.k8s.Volume.property.flexVolume"></a>

```typescript
public readonly flexVolume: FlexVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FlexVolumeSource

flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

---

##### `flocker`<sup>Optional</sup> <a name="flocker" id="cdk8s-plus-28.k8s.Volume.property.flocker"></a>

```typescript
public readonly flocker: FlockerVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.FlockerVolumeSource

flocker represents a Flocker volume attached to a kubelet's host machine.

This depends on the Flocker control service being running

---

##### `gcePersistentDisk`<sup>Optional</sup> <a name="gcePersistentDisk" id="cdk8s-plus-28.k8s.Volume.property.gcePersistentDisk"></a>

```typescript
public readonly gcePersistentDisk: GcePersistentDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.GcePersistentDiskVolumeSource

gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

---

##### `gitRepo`<sup>Optional</sup> <a name="gitRepo" id="cdk8s-plus-28.k8s.Volume.property.gitRepo"></a>

```typescript
public readonly gitRepo: GitRepoVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.GitRepoVolumeSource

gitRepo represents a git repository at a particular revision.

DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.

---

##### `glusterfs`<sup>Optional</sup> <a name="glusterfs" id="cdk8s-plus-28.k8s.Volume.property.glusterfs"></a>

```typescript
public readonly glusterfs: GlusterfsVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.GlusterfsVolumeSource

glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/glusterfs/README.md

---

##### `hostPath`<sup>Optional</sup> <a name="hostPath" id="cdk8s-plus-28.k8s.Volume.property.hostPath"></a>

```typescript
public readonly hostPath: HostPathVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.HostPathVolumeSource

hostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container.

This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

---

##### `iscsi`<sup>Optional</sup> <a name="iscsi" id="cdk8s-plus-28.k8s.Volume.property.iscsi"></a>

```typescript
public readonly iscsi: IscsiVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.IscsiVolumeSource

iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod.

More info: https://examples.k8s.io/volumes/iscsi/README.md

---

##### `nfs`<sup>Optional</sup> <a name="nfs" id="cdk8s-plus-28.k8s.Volume.property.nfs"></a>

```typescript
public readonly nfs: NfsVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.NfsVolumeSource

nfs represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs.

---

##### `persistentVolumeClaim`<sup>Optional</sup> <a name="persistentVolumeClaim" id="cdk8s-plus-28.k8s.Volume.property.persistentVolumeClaim"></a>

```typescript
public readonly persistentVolumeClaim: PersistentVolumeClaimVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeClaimVolumeSource

persistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace.

More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

---

##### `photonPersistentDisk`<sup>Optional</sup> <a name="photonPersistentDisk" id="cdk8s-plus-28.k8s.Volume.property.photonPersistentDisk"></a>

```typescript
public readonly photonPersistentDisk: PhotonPersistentDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.PhotonPersistentDiskVolumeSource

photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine.

---

##### `portworxVolume`<sup>Optional</sup> <a name="portworxVolume" id="cdk8s-plus-28.k8s.Volume.property.portworxVolume"></a>

```typescript
public readonly portworxVolume: PortworxVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.PortworxVolumeSource

portworxVolume represents a portworx volume attached and mounted on kubelets host machine.

---

##### `projected`<sup>Optional</sup> <a name="projected" id="cdk8s-plus-28.k8s.Volume.property.projected"></a>

```typescript
public readonly projected: ProjectedVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.ProjectedVolumeSource

projected items for all in one resources secrets, configmaps, and downward API.

---

##### `quobyte`<sup>Optional</sup> <a name="quobyte" id="cdk8s-plus-28.k8s.Volume.property.quobyte"></a>

```typescript
public readonly quobyte: QuobyteVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.QuobyteVolumeSource

quobyte represents a Quobyte mount on the host that shares a pod's lifetime.

---

##### `rbd`<sup>Optional</sup> <a name="rbd" id="cdk8s-plus-28.k8s.Volume.property.rbd"></a>

```typescript
public readonly rbd: RbdVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.RbdVolumeSource

rbd represents a Rados Block Device mount on the host that shares a pod's lifetime.

More info: https://examples.k8s.io/volumes/rbd/README.md

---

##### `scaleIo`<sup>Optional</sup> <a name="scaleIo" id="cdk8s-plus-28.k8s.Volume.property.scaleIo"></a>

```typescript
public readonly scaleIo: ScaleIoVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.ScaleIoVolumeSource

scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.k8s.Volume.property.secret"></a>

```typescript
public readonly secret: SecretVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.SecretVolumeSource

secret represents a secret that should populate this volume.

More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

---

##### `storageos`<sup>Optional</sup> <a name="storageos" id="cdk8s-plus-28.k8s.Volume.property.storageos"></a>

```typescript
public readonly storageos: StorageOsVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.StorageOsVolumeSource

storageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.

---

##### `vsphereVolume`<sup>Optional</sup> <a name="vsphereVolume" id="cdk8s-plus-28.k8s.Volume.property.vsphereVolume"></a>

```typescript
public readonly vsphereVolume: VsphereVirtualDiskVolumeSource;
```

- *Type:* cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource

vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine.

---

### VolumeAttachmentSource <a name="VolumeAttachmentSource" id="cdk8s-plus-28.k8s.VolumeAttachmentSource"></a>

VolumeAttachmentSource represents a volume that should be attached.

Right now only PersistenVolumes can be attached via external attacher, in future we may allow also inline volumes in pods. Exactly one member can be set.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeAttachmentSource: k8s.VolumeAttachmentSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSource.property.inlineVolumeSpec">inlineVolumeSpec</a></code> | <code>cdk8s-plus-28.k8s.PersistentVolumeSpec</code> | inlineVolumeSpec contains all the information necessary to attach a persistent volume defined by a pod's inline VolumeSource. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSource.property.persistentVolumeName">persistentVolumeName</a></code> | <code>string</code> | persistentVolumeName represents the name of the persistent volume to attach. |

---

##### `inlineVolumeSpec`<sup>Optional</sup> <a name="inlineVolumeSpec" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.property.inlineVolumeSpec"></a>

```typescript
public readonly inlineVolumeSpec: PersistentVolumeSpec;
```

- *Type:* cdk8s-plus-28.k8s.PersistentVolumeSpec

inlineVolumeSpec contains all the information necessary to attach a persistent volume defined by a pod's inline VolumeSource.

This field is populated only for the CSIMigration feature. It contains translated fields from a pod's inline VolumeSource to a PersistentVolumeSpec. This field is beta-level and is only honored by servers that enabled the CSIMigration feature.

---

##### `persistentVolumeName`<sup>Optional</sup> <a name="persistentVolumeName" id="cdk8s-plus-28.k8s.VolumeAttachmentSource.property.persistentVolumeName"></a>

```typescript
public readonly persistentVolumeName: string;
```

- *Type:* string

persistentVolumeName represents the name of the persistent volume to attach.

---

### VolumeAttachmentSpec <a name="VolumeAttachmentSpec" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec"></a>

VolumeAttachmentSpec is the specification of a VolumeAttachment request.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeAttachmentSpec: k8s.VolumeAttachmentSpec = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.attacher">attacher</a></code> | <code>string</code> | attacher indicates the name of the volume driver that MUST handle this request. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.nodeName">nodeName</a></code> | <code>string</code> | nodeName represents the node that the volume should be attached to. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.source">source</a></code> | <code>cdk8s-plus-28.k8s.VolumeAttachmentSource</code> | source represents the volume that should be attached. |

---

##### `attacher`<sup>Required</sup> <a name="attacher" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.attacher"></a>

```typescript
public readonly attacher: string;
```

- *Type:* string

attacher indicates the name of the volume driver that MUST handle this request.

This is the name returned by GetPluginName().

---

##### `nodeName`<sup>Required</sup> <a name="nodeName" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.nodeName"></a>

```typescript
public readonly nodeName: string;
```

- *Type:* string

nodeName represents the node that the volume should be attached to.

---

##### `source`<sup>Required</sup> <a name="source" id="cdk8s-plus-28.k8s.VolumeAttachmentSpec.property.source"></a>

```typescript
public readonly source: VolumeAttachmentSource;
```

- *Type:* cdk8s-plus-28.k8s.VolumeAttachmentSource

source represents the volume that should be attached.

---

### VolumeDevice <a name="VolumeDevice" id="cdk8s-plus-28.k8s.VolumeDevice"></a>

volumeDevice describes a mapping of a raw block device within a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeDevice.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeDevice: k8s.VolumeDevice = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeDevice.property.devicePath">devicePath</a></code> | <code>string</code> | devicePath is the path inside of the container that the device will be mapped to. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeDevice.property.name">name</a></code> | <code>string</code> | name must match the name of a persistentVolumeClaim in the pod. |

---

##### `devicePath`<sup>Required</sup> <a name="devicePath" id="cdk8s-plus-28.k8s.VolumeDevice.property.devicePath"></a>

```typescript
public readonly devicePath: string;
```

- *Type:* string

devicePath is the path inside of the container that the device will be mapped to.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VolumeDevice.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

name must match the name of a persistentVolumeClaim in the pod.

---

### VolumeMount <a name="VolumeMount" id="cdk8s-plus-28.VolumeMount"></a>

Mount a volume from the pod to the container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.VolumeMount.Initializer"></a>

```typescript
import { VolumeMount } from 'cdk8s-plus-28'

const volumeMount: VolumeMount = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.propagation">propagation</a></code> | <code><a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a></code> | Determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.readOnly">readOnly</a></code> | <code>boolean</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.subPath">subPath</a></code> | <code>string</code> | Path within the volume from which the container's volume should be mounted.). |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.subPathExpr">subPathExpr</a></code> | <code>string</code> | Expanded path within the volume from which the container's volume should be mounted. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.path">path</a></code> | <code>string</code> | Path within the container at which the volume should be mounted. |
| <code><a href="#cdk8s-plus-28.VolumeMount.property.volume">volume</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a></code> | The volume to mount. |

---

##### `propagation`<sup>Optional</sup> <a name="propagation" id="cdk8s-plus-28.VolumeMount.property.propagation"></a>

```typescript
public readonly propagation: MountPropagation;
```

- *Type:* <a href="#cdk8s-plus-28.MountPropagation">MountPropagation</a>
- *Default:* MountPropagation.NONE

Determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used.

Mount propagation allows for sharing volumes mounted by a Container to
other Containers in the same Pod, or even to other Pods on the same node.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.VolumeMount.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `subPath`<sup>Optional</sup> <a name="subPath" id="cdk8s-plus-28.VolumeMount.property.subPath"></a>

```typescript
public readonly subPath: string;
```

- *Type:* string
- *Default:* "" the volume's root

Path within the volume from which the container's volume should be mounted.).

---

##### `subPathExpr`<sup>Optional</sup> <a name="subPathExpr" id="cdk8s-plus-28.VolumeMount.property.subPathExpr"></a>

```typescript
public readonly subPathExpr: string;
```

- *Type:* string
- *Default:* "" volume's root.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references
$(VAR_NAME) are expanded using the container's environment. Defaults to ""
(volume's root).

`subPathExpr` and `subPath` are mutually exclusive.

---

##### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.VolumeMount.property.path"></a>

```typescript
public readonly path: string;
```

- *Type:* string

Path within the container at which the volume should be mounted.

Must not
contain ':'.

---

##### `volume`<sup>Required</sup> <a name="volume" id="cdk8s-plus-28.VolumeMount.property.volume"></a>

```typescript
public readonly volume: Volume;
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>

The volume to mount.

---

### VolumeMount <a name="VolumeMount" id="cdk8s-plus-28.k8s.VolumeMount"></a>

VolumeMount describes a mounting of a Volume within a container.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeMount.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeMount: k8s.VolumeMount = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.mountPath">mountPath</a></code> | <code>string</code> | Path within the container at which the volume should be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.name">name</a></code> | <code>string</code> | This must match the Name of a Volume. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.mountPropagation">mountPropagation</a></code> | <code>string</code> | mountPropagation determines how mounts are propagated from the host to container and the other way around. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.readOnly">readOnly</a></code> | <code>boolean</code> | Mounted read-only if true, read-write otherwise (false or unspecified). |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.subPath">subPath</a></code> | <code>string</code> | Path within the volume from which the container's volume should be mounted. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeMount.property.subPathExpr">subPathExpr</a></code> | <code>string</code> | Expanded path within the volume from which the container's volume should be mounted. |

---

##### `mountPath`<sup>Required</sup> <a name="mountPath" id="cdk8s-plus-28.k8s.VolumeMount.property.mountPath"></a>

```typescript
public readonly mountPath: string;
```

- *Type:* string

Path within the container at which the volume should be mounted.

Must not contain ':'.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.k8s.VolumeMount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

This must match the Name of a Volume.

---

##### `mountPropagation`<sup>Optional</sup> <a name="mountPropagation" id="cdk8s-plus-28.k8s.VolumeMount.property.mountPropagation"></a>

```typescript
public readonly mountPropagation: string;
```

- *Type:* string

mountPropagation determines how mounts are propagated from the host to container and the other way around.

When not set, MountPropagationNone is used. This field is beta in 1.10.

---

##### `readOnly`<sup>Optional</sup> <a name="readOnly" id="cdk8s-plus-28.k8s.VolumeMount.property.readOnly"></a>

```typescript
public readonly readOnly: boolean;
```

- *Type:* boolean
- *Default:* false.

Mounted read-only if true, read-write otherwise (false or unspecified).

Defaults to false.

---

##### `subPath`<sup>Optional</sup> <a name="subPath" id="cdk8s-plus-28.k8s.VolumeMount.property.subPath"></a>

```typescript
public readonly subPath: string;
```

- *Type:* string
- *Default:* volume's root).

Path within the volume from which the container's volume should be mounted.

Defaults to "" (volume's root).

---

##### `subPathExpr`<sup>Optional</sup> <a name="subPathExpr" id="cdk8s-plus-28.k8s.VolumeMount.property.subPathExpr"></a>

```typescript
public readonly subPathExpr: string;
```

- *Type:* string
- *Default:* volume's root). SubPathExpr and SubPath are mutually exclusive.

Expanded path within the volume from which the container's volume should be mounted.

Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.

---

### VolumeNodeAffinity <a name="VolumeNodeAffinity" id="cdk8s-plus-28.k8s.VolumeNodeAffinity"></a>

VolumeNodeAffinity defines constraints that limit what nodes this volume can be accessed from.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeNodeAffinity.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeNodeAffinity: k8s.VolumeNodeAffinity = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeNodeAffinity.property.required">required</a></code> | <code>cdk8s-plus-28.k8s.NodeSelector</code> | required specifies hard node constraints that must be met. |

---

##### `required`<sup>Optional</sup> <a name="required" id="cdk8s-plus-28.k8s.VolumeNodeAffinity.property.required"></a>

```typescript
public readonly required: NodeSelector;
```

- *Type:* cdk8s-plus-28.k8s.NodeSelector

required specifies hard node constraints that must be met.

---

### VolumeNodeResources <a name="VolumeNodeResources" id="cdk8s-plus-28.k8s.VolumeNodeResources"></a>

VolumeNodeResources is a set of resource limits for scheduling of volumes.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeNodeResources.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeNodeResources: k8s.VolumeNodeResources = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeNodeResources.property.count">count</a></code> | <code>number</code> | count indicates the maximum number of unique volumes managed by the CSI driver that can be used on a node. |

---

##### `count`<sup>Optional</sup> <a name="count" id="cdk8s-plus-28.k8s.VolumeNodeResources.property.count"></a>

```typescript
public readonly count: number;
```

- *Type:* number

count indicates the maximum number of unique volumes managed by the CSI driver that can be used on a node.

A volume that is both attached and mounted on a node is considered to be used once, not twice. The same rule applies for a unique volume that is shared among multiple pods on the same node. If this field is not specified, then the supported number of volumes on this node is unbounded.

---

### VolumeProjection <a name="VolumeProjection" id="cdk8s-plus-28.k8s.VolumeProjection"></a>

Projection that may be projected along with other supported volume types.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VolumeProjection.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const volumeProjection: k8s.VolumeProjection = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.configMap">configMap</a></code> | <code>cdk8s-plus-28.k8s.ConfigMapProjection</code> | configMap information about the configMap data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.downwardApi">downwardApi</a></code> | <code>cdk8s-plus-28.k8s.DownwardApiProjection</code> | downwardAPI information about the downwardAPI data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.secret">secret</a></code> | <code>cdk8s-plus-28.k8s.SecretProjection</code> | secret information about the secret data to project. |
| <code><a href="#cdk8s-plus-28.k8s.VolumeProjection.property.serviceAccountToken">serviceAccountToken</a></code> | <code>cdk8s-plus-28.k8s.ServiceAccountTokenProjection</code> | serviceAccountToken is information about the serviceAccountToken data to project. |

---

##### `configMap`<sup>Optional</sup> <a name="configMap" id="cdk8s-plus-28.k8s.VolumeProjection.property.configMap"></a>

```typescript
public readonly configMap: ConfigMapProjection;
```

- *Type:* cdk8s-plus-28.k8s.ConfigMapProjection

configMap information about the configMap data to project.

---

##### `downwardApi`<sup>Optional</sup> <a name="downwardApi" id="cdk8s-plus-28.k8s.VolumeProjection.property.downwardApi"></a>

```typescript
public readonly downwardApi: DownwardApiProjection;
```

- *Type:* cdk8s-plus-28.k8s.DownwardApiProjection

downwardAPI information about the downwardAPI data to project.

---

##### `secret`<sup>Optional</sup> <a name="secret" id="cdk8s-plus-28.k8s.VolumeProjection.property.secret"></a>

```typescript
public readonly secret: SecretProjection;
```

- *Type:* cdk8s-plus-28.k8s.SecretProjection

secret information about the secret data to project.

---

##### `serviceAccountToken`<sup>Optional</sup> <a name="serviceAccountToken" id="cdk8s-plus-28.k8s.VolumeProjection.property.serviceAccountToken"></a>

```typescript
public readonly serviceAccountToken: ServiceAccountTokenProjection;
```

- *Type:* cdk8s-plus-28.k8s.ServiceAccountTokenProjection

serviceAccountToken is information about the serviceAccountToken data to project.

---

### VsphereVirtualDiskVolumeSource <a name="VsphereVirtualDiskVolumeSource" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource"></a>

Represents a vSphere volume resource.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const vsphereVirtualDiskVolumeSource: k8s.VsphereVirtualDiskVolumeSource = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.volumePath">volumePath</a></code> | <code>string</code> | volumePath is the path that identifies vSphere volume vmdk. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.fsType">fsType</a></code> | <code>string</code> | fsType is filesystem type to mount. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyId">storagePolicyId</a></code> | <code>string</code> | storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName. |
| <code><a href="#cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyName">storagePolicyName</a></code> | <code>string</code> | storagePolicyName is the storage Policy Based Management (SPBM) profile name. |

---

##### `volumePath`<sup>Required</sup> <a name="volumePath" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.volumePath"></a>

```typescript
public readonly volumePath: string;
```

- *Type:* string

volumePath is the path that identifies vSphere volume vmdk.

---

##### `fsType`<sup>Optional</sup> <a name="fsType" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.fsType"></a>

```typescript
public readonly fsType: string;
```

- *Type:* string

fsType is filesystem type to mount.

Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

---

##### `storagePolicyId`<sup>Optional</sup> <a name="storagePolicyId" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyId"></a>

```typescript
public readonly storagePolicyId: string;
```

- *Type:* string

storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.

---

##### `storagePolicyName`<sup>Optional</sup> <a name="storagePolicyName" id="cdk8s-plus-28.k8s.VsphereVirtualDiskVolumeSource.property.storagePolicyName"></a>

```typescript
public readonly storagePolicyName: string;
```

- *Type:* string

storagePolicyName is the storage Policy Based Management (SPBM) profile name.

---

### WebhookClientConfig <a name="WebhookClientConfig" id="cdk8s-plus-28.k8s.WebhookClientConfig"></a>

WebhookClientConfig contains the information to make a TLS connection with the webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WebhookClientConfig.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const webhookClientConfig: k8s.WebhookClientConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.caBundle">caBundle</a></code> | <code>string</code> | `caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.service">service</a></code> | <code>cdk8s-plus-28.k8s.ServiceReference</code> | `service` is a reference to the service for this webhook. Either `service` or `url` must be specified. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookClientConfig.property.url">url</a></code> | <code>string</code> | `url` gives the location of the webhook, in standard URL form (`scheme://host:port/path`). |

---

##### `caBundle`<sup>Optional</sup> <a name="caBundle" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.caBundle"></a>

```typescript
public readonly caBundle: string;
```

- *Type:* string

`caBundle` is a PEM encoded CA bundle which will be used to validate the webhook's server certificate.

If unspecified, system trust roots on the apiserver are used.

---

##### `service`<sup>Optional</sup> <a name="service" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.service"></a>

```typescript
public readonly service: ServiceReference;
```

- *Type:* cdk8s-plus-28.k8s.ServiceReference

`service` is a reference to the service for this webhook. Either `service` or `url` must be specified.

If the webhook is running within the cluster, then you should use `service`.

---

##### `url`<sup>Optional</sup> <a name="url" id="cdk8s-plus-28.k8s.WebhookClientConfig.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string

`url` gives the location of the webhook, in standard URL form (`scheme://host:port/path`).

Exactly one of `url` or `service` must be specified.

The `host` should not refer to a service running in the cluster; use the `service` field instead. The host might be resolved via external DNS in some apiservers (e.g., `kube-apiserver` cannot resolve in-cluster DNS as that would be a layering violation). `host` may also be an IP address.

Please note that using `localhost` or `127.0.0.1` as a `host` is risky unless you take great care to run this webhook on all hosts which run an apiserver which might need to make calls to this webhook. Such installs are likely to be non-portable, i.e., not easy to turn up in a new cluster.

The scheme must be "https"; the URL must begin with "https://".

A path is optional, and if present may be any string permissible in a URL. You may use the path to pass an arbitrary string to the webhook, for example, a cluster identifier.

Attempting to use a user or basic auth e.g. "user:password@" is not allowed. Fragments ("#...") and query parameters ("?...") are not allowed, either.

---

### WebhookConversion <a name="WebhookConversion" id="cdk8s-plus-28.k8s.WebhookConversion"></a>

WebhookConversion describes how to call a conversion webhook.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WebhookConversion.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const webhookConversion: k8s.WebhookConversion = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WebhookConversion.property.conversionReviewVersions">conversionReviewVersions</a></code> | <code>string[]</code> | conversionReviewVersions is an ordered list of preferred `ConversionReview` versions the Webhook expects. |
| <code><a href="#cdk8s-plus-28.k8s.WebhookConversion.property.clientConfig">clientConfig</a></code> | <code>cdk8s-plus-28.k8s.WebhookClientConfig</code> | clientConfig is the instructions for how to call the webhook if strategy is `Webhook`. |

---

##### `conversionReviewVersions`<sup>Required</sup> <a name="conversionReviewVersions" id="cdk8s-plus-28.k8s.WebhookConversion.property.conversionReviewVersions"></a>

```typescript
public readonly conversionReviewVersions: string[];
```

- *Type:* string[]

conversionReviewVersions is an ordered list of preferred `ConversionReview` versions the Webhook expects.

The API server will use the first version in the list which it supports. If none of the versions specified in this list are supported by API server, conversion will fail for the custom resource. If a persisted Webhook configuration specifies allowed versions and does not include any versions known to the API Server, calls to the webhook will fail.

---

##### `clientConfig`<sup>Optional</sup> <a name="clientConfig" id="cdk8s-plus-28.k8s.WebhookConversion.property.clientConfig"></a>

```typescript
public readonly clientConfig: WebhookClientConfig;
```

- *Type:* cdk8s-plus-28.k8s.WebhookClientConfig

clientConfig is the instructions for how to call the webhook if strategy is `Webhook`.

---

### WeightedPodAffinityTerm <a name="WeightedPodAffinityTerm" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm"></a>

The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s).

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const weightedPodAffinityTerm: k8s.WeightedPodAffinityTerm = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.podAffinityTerm">podAffinityTerm</a></code> | <code>cdk8s-plus-28.k8s.PodAffinityTerm</code> | Required. |
| <code><a href="#cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.weight">weight</a></code> | <code>number</code> | weight associated with matching the corresponding podAffinityTerm, in the range 1-100. |

---

##### `podAffinityTerm`<sup>Required</sup> <a name="podAffinityTerm" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.podAffinityTerm"></a>

```typescript
public readonly podAffinityTerm: PodAffinityTerm;
```

- *Type:* cdk8s-plus-28.k8s.PodAffinityTerm

Required.

A pod affinity term, associated with the corresponding weight.

---

##### `weight`<sup>Required</sup> <a name="weight" id="cdk8s-plus-28.k8s.WeightedPodAffinityTerm.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number

weight associated with matching the corresponding podAffinityTerm, in the range 1-100.

---

### WindowsSecurityContextOptions <a name="WindowsSecurityContextOptions" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions"></a>

WindowsSecurityContextOptions contain Windows-specific options and credentials.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.Initializer"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

const windowsSecurityContextOptions: k8s.WindowsSecurityContextOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpec">gmsaCredentialSpec</a></code> | <code>string</code> | GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpecName">gmsaCredentialSpecName</a></code> | <code>string</code> | GMSACredentialSpecName is the name of the GMSA credential spec to use. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.hostProcess">hostProcess</a></code> | <code>boolean</code> | HostProcess determines if a container should be run as a 'Host Process' container. |
| <code><a href="#cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.runAsUserName">runAsUserName</a></code> | <code>string</code> | The UserName in Windows to run the entrypoint of the container process. |

---

##### `gmsaCredentialSpec`<sup>Optional</sup> <a name="gmsaCredentialSpec" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpec"></a>

```typescript
public readonly gmsaCredentialSpec: string;
```

- *Type:* string

GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.

---

##### `gmsaCredentialSpecName`<sup>Optional</sup> <a name="gmsaCredentialSpecName" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.gmsaCredentialSpecName"></a>

```typescript
public readonly gmsaCredentialSpecName: string;
```

- *Type:* string

GMSACredentialSpecName is the name of the GMSA credential spec to use.

---

##### `hostProcess`<sup>Optional</sup> <a name="hostProcess" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.hostProcess"></a>

```typescript
public readonly hostProcess: boolean;
```

- *Type:* boolean

HostProcess determines if a container should be run as a 'Host Process' container.

All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers). In addition, if HostProcess is true then HostNetwork must also be set to true.

---

##### `runAsUserName`<sup>Optional</sup> <a name="runAsUserName" id="cdk8s-plus-28.k8s.WindowsSecurityContextOptions.property.runAsUserName"></a>

```typescript
public readonly runAsUserName: string;
```

- *Type:* string
- *Default:* the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

The UserName in Windows to run the entrypoint of the container process.

Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

---

### WorkloadProps <a name="WorkloadProps" id="cdk8s-plus-28.WorkloadProps"></a>

Properties for `Workload`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.WorkloadProps.Initializer"></a>

```typescript
import { WorkloadProps } from 'cdk8s-plus-28'

const workloadProps: WorkloadProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.metadata">metadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | Metadata that all persisted resources must have, which includes all objects users must create. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.automountServiceAccountToken">automountServiceAccountToken</a></code> | <code>boolean</code> | Indicates whether a service account token should be automatically mounted. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.containers">containers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.dns">dns</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | DNS settings for the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.dockerRegistryAuth">dockerRegistryAuth</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | A secret containing docker credentials for authenticating to a registry. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.hostAliases">hostAliases</a></code> | <code><a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]</code> | HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.hostNetwork">hostNetwork</a></code> | <code>boolean</code> | Host network for the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.initContainers">initContainers</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]</code> | List of initialization containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.isolate">isolate</a></code> | <code>boolean</code> | Isolates the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a></code> | Restart policy for all containers within the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | SecurityContext holds pod-level security attributes and common container settings. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.serviceAccount">serviceAccount</a></code> | <code><a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a></code> | A service account provides an identity for processes that run in a Pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.terminationGracePeriod">terminationGracePeriod</a></code> | <code>cdk8s.Duration</code> | Grace period until the pod is terminated. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.volumes">volumes</a></code> | <code><a href="#cdk8s-plus-28.Volume">Volume</a>[]</code> | List of volumes that can be mounted by containers belonging to the pod. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.podMetadata">podMetadata</a></code> | <code>cdk8s.ApiObjectMetadata</code> | The pod metadata of this workload. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.select">select</a></code> | <code>boolean</code> | Automatically allocates a pod label selector for this workload and add it to the pod metadata. |
| <code><a href="#cdk8s-plus-28.WorkloadProps.property.spread">spread</a></code> | <code>boolean</code> | Automatically spread pods across hostname and zones. |

---

##### `metadata`<sup>Optional</sup> <a name="metadata" id="cdk8s-plus-28.WorkloadProps.property.metadata"></a>

```typescript
public readonly metadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

Metadata that all persisted resources must have, which includes all objects users must create.

---

##### `automountServiceAccountToken`<sup>Optional</sup> <a name="automountServiceAccountToken" id="cdk8s-plus-28.WorkloadProps.property.automountServiceAccountToken"></a>

```typescript
public readonly automountServiceAccountToken: boolean;
```

- *Type:* boolean
- *Default:* false

Indicates whether a service account token should be automatically mounted.

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/#use-the-default-service-account-to-access-the-api-server)

---

##### `containers`<sup>Optional</sup> <a name="containers" id="cdk8s-plus-28.WorkloadProps.property.containers"></a>

```typescript
public readonly containers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No containers. Note that a pod spec must include at least one container.

List of containers belonging to the pod.

Containers cannot currently be
added or removed. There must be at least one container in a Pod.

You can add additionnal containers using `podSpec.addContainer()`

---

##### `dns`<sup>Optional</sup> <a name="dns" id="cdk8s-plus-28.WorkloadProps.property.dns"></a>

```typescript
public readonly dns: PodDnsProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>
- *Default:* policy: DnsPolicy.CLUSTER_FIRST  hostnameAsFQDN: false

DNS settings for the pod.

> [https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/](https://kubernetes.io/docs/concepts/services-networking/dns-pod-service/)

---

##### `dockerRegistryAuth`<sup>Optional</sup> <a name="dockerRegistryAuth" id="cdk8s-plus-28.WorkloadProps.property.dockerRegistryAuth"></a>

```typescript
public readonly dockerRegistryAuth: ISecret;
```

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>
- *Default:* No auth. Images are assumed to be publicly available.

A secret containing docker credentials for authenticating to a registry.

---

##### `hostAliases`<sup>Optional</sup> <a name="hostAliases" id="cdk8s-plus-28.WorkloadProps.property.hostAliases"></a>

```typescript
public readonly hostAliases: HostAlias[];
```

- *Type:* <a href="#cdk8s-plus-28.HostAlias">HostAlias</a>[]

HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.

---

##### `hostNetwork`<sup>Optional</sup> <a name="hostNetwork" id="cdk8s-plus-28.WorkloadProps.property.hostNetwork"></a>

```typescript
public readonly hostNetwork: boolean;
```

- *Type:* boolean
- *Default:* false

Host network for the pod.

---

##### `initContainers`<sup>Optional</sup> <a name="initContainers" id="cdk8s-plus-28.WorkloadProps.property.initContainers"></a>

```typescript
public readonly initContainers: ContainerProps[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>[]
- *Default:* No init containers.

List of initialization containers belonging to the pod.

Init containers are executed in order prior to containers being started.
If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy.
The name for an init container or normal container must be unique among all containers.
Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.
The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit
for each resource type, and then using the max of of that value or the sum of the normal containers.
Limits are applied to init containers in a similar fashion.

Init containers cannot currently be added ,removed or updated.

> [https://kubernetes.io/docs/concepts/workloads/pods/init-containers/](https://kubernetes.io/docs/concepts/workloads/pods/init-containers/)

---

##### `isolate`<sup>Optional</sup> <a name="isolate" id="cdk8s-plus-28.WorkloadProps.property.isolate"></a>

```typescript
public readonly isolate: boolean;
```

- *Type:* boolean
- *Default:* false

Isolates the pod.

This will prevent any ingress or egress connections to / from this pod.
You can however allow explicit connections post instantiation by using the `.connections` property.

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.WorkloadProps.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: RestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.RestartPolicy">RestartPolicy</a>
- *Default:* RestartPolicy.ALWAYS

Restart policy for all containers within the pod.

> [https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy)

---

##### `securityContext`<sup>Optional</sup> <a name="securityContext" id="cdk8s-plus-28.WorkloadProps.property.securityContext"></a>

```typescript
public readonly securityContext: PodSecurityContextProps;
```

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>
- *Default:* fsGroupChangePolicy: FsGroupChangePolicy.FsGroupChangePolicy.ALWAYS   ensureNonRoot: true

SecurityContext holds pod-level security attributes and common container settings.

---

##### `serviceAccount`<sup>Optional</sup> <a name="serviceAccount" id="cdk8s-plus-28.WorkloadProps.property.serviceAccount"></a>

```typescript
public readonly serviceAccount: IServiceAccount;
```

- *Type:* <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>
- *Default:* No service account.

A service account provides an identity for processes that run in a Pod.

When you (a human) access the cluster (for example, using kubectl), you are
authenticated by the apiserver as a particular User Account (currently this
is usually admin, unless your cluster administrator has customized your
cluster). Processes in containers inside pods can also contact the
apiserver. When they do, they are authenticated as a particular Service
Account (for example, default).

> [https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/](https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/)

---

##### `terminationGracePeriod`<sup>Optional</sup> <a name="terminationGracePeriod" id="cdk8s-plus-28.WorkloadProps.property.terminationGracePeriod"></a>

```typescript
public readonly terminationGracePeriod: Duration;
```

- *Type:* cdk8s.Duration
- *Default:* Duration.seconds(30)

Grace period until the pod is terminated.

---

##### `volumes`<sup>Optional</sup> <a name="volumes" id="cdk8s-plus-28.WorkloadProps.property.volumes"></a>

```typescript
public readonly volumes: Volume[];
```

- *Type:* <a href="#cdk8s-plus-28.Volume">Volume</a>[]
- *Default:* No volumes.

List of volumes that can be mounted by containers belonging to the pod.

You can also add volumes later using `podSpec.addVolume()`

> [https://kubernetes.io/docs/concepts/storage/volumes](https://kubernetes.io/docs/concepts/storage/volumes)

---

##### `podMetadata`<sup>Optional</sup> <a name="podMetadata" id="cdk8s-plus-28.WorkloadProps.property.podMetadata"></a>

```typescript
public readonly podMetadata: ApiObjectMetadata;
```

- *Type:* cdk8s.ApiObjectMetadata

The pod metadata of this workload.

---

##### `select`<sup>Optional</sup> <a name="select" id="cdk8s-plus-28.WorkloadProps.property.select"></a>

```typescript
public readonly select: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically allocates a pod label selector for this workload and add it to the pod metadata.

This ensures this workload manages pods created by
its pod template.

---

##### `spread`<sup>Optional</sup> <a name="spread" id="cdk8s-plus-28.WorkloadProps.property.spread"></a>

```typescript
public readonly spread: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically spread pods across hostname and zones.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints](https://kubernetes.io/docs/concepts/scheduling-eviction/topology-spread-constraints/#internal-default-constraints)

---

### WorkloadSchedulingSpreadOptions <a name="WorkloadSchedulingSpreadOptions" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions"></a>

Options for `WorkloadScheduling.spread`.

#### Initializer <a name="Initializer" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.Initializer"></a>

```typescript
import { WorkloadSchedulingSpreadOptions } from 'cdk8s-plus-28'

const workloadSchedulingSpreadOptions: WorkloadSchedulingSpreadOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.topology">topology</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | Which topology to spread on. |
| <code><a href="#cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.weight">weight</a></code> | <code>number</code> | Indicates the spread is optional, with this weight score. |

---

##### `topology`<sup>Optional</sup> <a name="topology" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.topology"></a>

```typescript
public readonly topology: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>
- *Default:* Topology.HOSTNAME

Which topology to spread on.

---

##### `weight`<sup>Optional</sup> <a name="weight" id="cdk8s-plus-28.WorkloadSchedulingSpreadOptions.property.weight"></a>

```typescript
public readonly weight: number;
```

- *Type:* number
- *Default:* no weight. spread is assumed to be required.

Indicates the spread is optional, with this weight score.

---

## Classes <a name="Classes" id="Classes"></a>

### ApiResource <a name="ApiResource" id="cdk8s-plus-28.ApiResource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Represents information about an API resource type.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.ApiResource.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |

---

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.ApiResource.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.ApiResource.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.custom">custom</a></code> | API resource information for a custom resource type. |

---

##### `custom` <a name="custom" id="cdk8s-plus-28.ApiResource.custom"></a>

```typescript
import { ApiResource } from 'cdk8s-plus-28'

ApiResource.custom(options: ApiResourceOptions)
```

API resource information for a custom resource type.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.ApiResource.custom.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ApiResourceOptions">ApiResourceOptions</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ApiResource.property.resourceType">resourceType</a></code> | <code>string</code> | The name of the resource type as it appears in the relevant API endpoint. |

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ApiResource.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ApiResource.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of the resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ApiResource.property.API_SERVICES">API_SERVICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for APIService. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.BINDINGS">BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Binding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CERTIFICATE_SIGNING_REQUESTS">CERTIFICATE_SIGNING_REQUESTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CertificateSigningRequest. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CLUSTER_ROLE_BINDINGS">CLUSTER_ROLE_BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ClusterRoleBinding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CLUSTER_ROLES">CLUSTER_ROLES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ClusterRole. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.COMPONENT_STATUSES">COMPONENT_STATUSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ComponentStatus. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CONFIG_MAPS">CONFIG_MAPS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ConfigMap. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CONTROLLER_REVISIONS">CONTROLLER_REVISIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ControllerRevision. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CRON_JOBS">CRON_JOBS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CronJob. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_DRIVERS">CSI_DRIVERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSIDriver. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_NODES">CSI_NODES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSINode. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CSI_STORAGE_CAPACITIES">CSI_STORAGE_CAPACITIES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CSIStorageCapacity. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.CUSTOM_RESOURCE_DEFINITIONS">CUSTOM_RESOURCE_DEFINITIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for CustomResourceDefinition. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.DAEMON_SETS">DAEMON_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for DaemonSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.DEPLOYMENTS">DEPLOYMENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Deployment. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ENDPOINT_SLICES">ENDPOINT_SLICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for EndpointSlice. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ENDPOINTS">ENDPOINTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Endpoints. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.EVENTS">EVENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Event. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.FLOW_SCHEMAS">FLOW_SCHEMAS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for FlowSchema. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.HORIZONTAL_POD_AUTOSCALERS">HORIZONTAL_POD_AUTOSCALERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for HorizontalPodAutoscaler. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.INGRESS_CLASSES">INGRESS_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for IngressClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.INGRESSES">INGRESSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Ingress. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.JOBS">JOBS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Job. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LEASES">LEASES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Lease. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LIMIT_RANGES">LIMIT_RANGES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for LimitRange. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.LOCAL_SUBJECT_ACCESS_REVIEWS">LOCAL_SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for LocalSubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.MUTATING_WEBHOOK_CONFIGURATIONS">MUTATING_WEBHOOK_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for MutatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NAMESPACES">NAMESPACES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Namespace. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NETWORK_POLICIES">NETWORK_POLICIES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for NetworkPolicy. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.NODES">NODES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Node. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUME_CLAIMS">PERSISTENT_VOLUME_CLAIMS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PersistentVolumeClaim. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUMES">PERSISTENT_VOLUMES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PersistentVolume. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.POD_DISRUPTION_BUDGETS">POD_DISRUPTION_BUDGETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PodDisruptionBudget. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.POD_TEMPLATES">POD_TEMPLATES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PodTemplate. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PODS">PODS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Pod. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PRIORITY_CLASSES">PRIORITY_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PriorityClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.PRIORITY_LEVEL_CONFIGURATIONS">PRIORITY_LEVEL_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for PriorityLevelConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.REPLICA_SETS">REPLICA_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ReplicaSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.REPLICATION_CONTROLLERS">REPLICATION_CONTROLLERS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ReplicationController. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.RESOURCE_QUOTAS">RESOURCE_QUOTAS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ResourceQuota. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ROLE_BINDINGS">ROLE_BINDINGS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for RoleBinding. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.ROLES">ROLES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Role. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.RUNTIME_CLASSES">RUNTIME_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for RuntimeClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SECRETS">SECRETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Secret. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_ACCESS_REVIEWS">SELF_SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SelfSubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_RULES_REVIEWS">SELF_SUBJECT_RULES_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SelfSubjectRulesReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SERVICE_ACCOUNTS">SERVICE_ACCOUNTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ServiceAccount. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SERVICES">SERVICES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for Service. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.STATEFUL_SETS">STATEFUL_SETS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for StatefulSet. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.STORAGE_CLASSES">STORAGE_CLASSES</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for StorageClass. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.SUBJECT_ACCESS_REVIEWS">SUBJECT_ACCESS_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for SubjectAccessReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.TOKEN_REVIEWS">TOKEN_REVIEWS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for TokenReview. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.VALIDATING_WEBHOOK_CONFIGURATIONS">VALIDATING_WEBHOOK_CONFIGURATIONS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for ValidatingWebhookConfiguration. |
| <code><a href="#cdk8s-plus-28.ApiResource.property.VOLUME_ATTACHMENTS">VOLUME_ATTACHMENTS</a></code> | <code><a href="#cdk8s-plus-28.ApiResource">ApiResource</a></code> | API resource information for VolumeAttachment. |

---

##### `API_SERVICES`<sup>Required</sup> <a name="API_SERVICES" id="cdk8s-plus-28.ApiResource.property.API_SERVICES"></a>

```typescript
public readonly API_SERVICES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for APIService.

---

##### `BINDINGS`<sup>Required</sup> <a name="BINDINGS" id="cdk8s-plus-28.ApiResource.property.BINDINGS"></a>

```typescript
public readonly BINDINGS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Binding.

---

##### `CERTIFICATE_SIGNING_REQUESTS`<sup>Required</sup> <a name="CERTIFICATE_SIGNING_REQUESTS" id="cdk8s-plus-28.ApiResource.property.CERTIFICATE_SIGNING_REQUESTS"></a>

```typescript
public readonly CERTIFICATE_SIGNING_REQUESTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CertificateSigningRequest.

---

##### `CLUSTER_ROLE_BINDINGS`<sup>Required</sup> <a name="CLUSTER_ROLE_BINDINGS" id="cdk8s-plus-28.ApiResource.property.CLUSTER_ROLE_BINDINGS"></a>

```typescript
public readonly CLUSTER_ROLE_BINDINGS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ClusterRoleBinding.

---

##### `CLUSTER_ROLES`<sup>Required</sup> <a name="CLUSTER_ROLES" id="cdk8s-plus-28.ApiResource.property.CLUSTER_ROLES"></a>

```typescript
public readonly CLUSTER_ROLES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ClusterRole.

---

##### `COMPONENT_STATUSES`<sup>Required</sup> <a name="COMPONENT_STATUSES" id="cdk8s-plus-28.ApiResource.property.COMPONENT_STATUSES"></a>

```typescript
public readonly COMPONENT_STATUSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ComponentStatus.

---

##### `CONFIG_MAPS`<sup>Required</sup> <a name="CONFIG_MAPS" id="cdk8s-plus-28.ApiResource.property.CONFIG_MAPS"></a>

```typescript
public readonly CONFIG_MAPS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ConfigMap.

---

##### `CONTROLLER_REVISIONS`<sup>Required</sup> <a name="CONTROLLER_REVISIONS" id="cdk8s-plus-28.ApiResource.property.CONTROLLER_REVISIONS"></a>

```typescript
public readonly CONTROLLER_REVISIONS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ControllerRevision.

---

##### `CRON_JOBS`<sup>Required</sup> <a name="CRON_JOBS" id="cdk8s-plus-28.ApiResource.property.CRON_JOBS"></a>

```typescript
public readonly CRON_JOBS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CronJob.

---

##### `CSI_DRIVERS`<sup>Required</sup> <a name="CSI_DRIVERS" id="cdk8s-plus-28.ApiResource.property.CSI_DRIVERS"></a>

```typescript
public readonly CSI_DRIVERS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSIDriver.

---

##### `CSI_NODES`<sup>Required</sup> <a name="CSI_NODES" id="cdk8s-plus-28.ApiResource.property.CSI_NODES"></a>

```typescript
public readonly CSI_NODES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSINode.

---

##### `CSI_STORAGE_CAPACITIES`<sup>Required</sup> <a name="CSI_STORAGE_CAPACITIES" id="cdk8s-plus-28.ApiResource.property.CSI_STORAGE_CAPACITIES"></a>

```typescript
public readonly CSI_STORAGE_CAPACITIES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CSIStorageCapacity.

---

##### `CUSTOM_RESOURCE_DEFINITIONS`<sup>Required</sup> <a name="CUSTOM_RESOURCE_DEFINITIONS" id="cdk8s-plus-28.ApiResource.property.CUSTOM_RESOURCE_DEFINITIONS"></a>

```typescript
public readonly CUSTOM_RESOURCE_DEFINITIONS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for CustomResourceDefinition.

---

##### `DAEMON_SETS`<sup>Required</sup> <a name="DAEMON_SETS" id="cdk8s-plus-28.ApiResource.property.DAEMON_SETS"></a>

```typescript
public readonly DAEMON_SETS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for DaemonSet.

---

##### `DEPLOYMENTS`<sup>Required</sup> <a name="DEPLOYMENTS" id="cdk8s-plus-28.ApiResource.property.DEPLOYMENTS"></a>

```typescript
public readonly DEPLOYMENTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Deployment.

---

##### `ENDPOINT_SLICES`<sup>Required</sup> <a name="ENDPOINT_SLICES" id="cdk8s-plus-28.ApiResource.property.ENDPOINT_SLICES"></a>

```typescript
public readonly ENDPOINT_SLICES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for EndpointSlice.

---

##### `ENDPOINTS`<sup>Required</sup> <a name="ENDPOINTS" id="cdk8s-plus-28.ApiResource.property.ENDPOINTS"></a>

```typescript
public readonly ENDPOINTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Endpoints.

---

##### `EVENTS`<sup>Required</sup> <a name="EVENTS" id="cdk8s-plus-28.ApiResource.property.EVENTS"></a>

```typescript
public readonly EVENTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Event.

---

##### `FLOW_SCHEMAS`<sup>Required</sup> <a name="FLOW_SCHEMAS" id="cdk8s-plus-28.ApiResource.property.FLOW_SCHEMAS"></a>

```typescript
public readonly FLOW_SCHEMAS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for FlowSchema.

---

##### `HORIZONTAL_POD_AUTOSCALERS`<sup>Required</sup> <a name="HORIZONTAL_POD_AUTOSCALERS" id="cdk8s-plus-28.ApiResource.property.HORIZONTAL_POD_AUTOSCALERS"></a>

```typescript
public readonly HORIZONTAL_POD_AUTOSCALERS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for HorizontalPodAutoscaler.

---

##### `INGRESS_CLASSES`<sup>Required</sup> <a name="INGRESS_CLASSES" id="cdk8s-plus-28.ApiResource.property.INGRESS_CLASSES"></a>

```typescript
public readonly INGRESS_CLASSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for IngressClass.

---

##### `INGRESSES`<sup>Required</sup> <a name="INGRESSES" id="cdk8s-plus-28.ApiResource.property.INGRESSES"></a>

```typescript
public readonly INGRESSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Ingress.

---

##### `JOBS`<sup>Required</sup> <a name="JOBS" id="cdk8s-plus-28.ApiResource.property.JOBS"></a>

```typescript
public readonly JOBS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Job.

---

##### `LEASES`<sup>Required</sup> <a name="LEASES" id="cdk8s-plus-28.ApiResource.property.LEASES"></a>

```typescript
public readonly LEASES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Lease.

---

##### `LIMIT_RANGES`<sup>Required</sup> <a name="LIMIT_RANGES" id="cdk8s-plus-28.ApiResource.property.LIMIT_RANGES"></a>

```typescript
public readonly LIMIT_RANGES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for LimitRange.

---

##### `LOCAL_SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="LOCAL_SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.LOCAL_SUBJECT_ACCESS_REVIEWS"></a>

```typescript
public readonly LOCAL_SUBJECT_ACCESS_REVIEWS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for LocalSubjectAccessReview.

---

##### `MUTATING_WEBHOOK_CONFIGURATIONS`<sup>Required</sup> <a name="MUTATING_WEBHOOK_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.MUTATING_WEBHOOK_CONFIGURATIONS"></a>

```typescript
public readonly MUTATING_WEBHOOK_CONFIGURATIONS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for MutatingWebhookConfiguration.

---

##### `NAMESPACES`<sup>Required</sup> <a name="NAMESPACES" id="cdk8s-plus-28.ApiResource.property.NAMESPACES"></a>

```typescript
public readonly NAMESPACES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Namespace.

---

##### `NETWORK_POLICIES`<sup>Required</sup> <a name="NETWORK_POLICIES" id="cdk8s-plus-28.ApiResource.property.NETWORK_POLICIES"></a>

```typescript
public readonly NETWORK_POLICIES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for NetworkPolicy.

---

##### `NODES`<sup>Required</sup> <a name="NODES" id="cdk8s-plus-28.ApiResource.property.NODES"></a>

```typescript
public readonly NODES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Node.

---

##### `PERSISTENT_VOLUME_CLAIMS`<sup>Required</sup> <a name="PERSISTENT_VOLUME_CLAIMS" id="cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUME_CLAIMS"></a>

```typescript
public readonly PERSISTENT_VOLUME_CLAIMS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PersistentVolumeClaim.

---

##### `PERSISTENT_VOLUMES`<sup>Required</sup> <a name="PERSISTENT_VOLUMES" id="cdk8s-plus-28.ApiResource.property.PERSISTENT_VOLUMES"></a>

```typescript
public readonly PERSISTENT_VOLUMES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PersistentVolume.

---

##### `POD_DISRUPTION_BUDGETS`<sup>Required</sup> <a name="POD_DISRUPTION_BUDGETS" id="cdk8s-plus-28.ApiResource.property.POD_DISRUPTION_BUDGETS"></a>

```typescript
public readonly POD_DISRUPTION_BUDGETS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PodDisruptionBudget.

---

##### `POD_TEMPLATES`<sup>Required</sup> <a name="POD_TEMPLATES" id="cdk8s-plus-28.ApiResource.property.POD_TEMPLATES"></a>

```typescript
public readonly POD_TEMPLATES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PodTemplate.

---

##### `PODS`<sup>Required</sup> <a name="PODS" id="cdk8s-plus-28.ApiResource.property.PODS"></a>

```typescript
public readonly PODS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Pod.

---

##### `PRIORITY_CLASSES`<sup>Required</sup> <a name="PRIORITY_CLASSES" id="cdk8s-plus-28.ApiResource.property.PRIORITY_CLASSES"></a>

```typescript
public readonly PRIORITY_CLASSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PriorityClass.

---

##### `PRIORITY_LEVEL_CONFIGURATIONS`<sup>Required</sup> <a name="PRIORITY_LEVEL_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.PRIORITY_LEVEL_CONFIGURATIONS"></a>

```typescript
public readonly PRIORITY_LEVEL_CONFIGURATIONS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for PriorityLevelConfiguration.

---

##### `REPLICA_SETS`<sup>Required</sup> <a name="REPLICA_SETS" id="cdk8s-plus-28.ApiResource.property.REPLICA_SETS"></a>

```typescript
public readonly REPLICA_SETS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ReplicaSet.

---

##### `REPLICATION_CONTROLLERS`<sup>Required</sup> <a name="REPLICATION_CONTROLLERS" id="cdk8s-plus-28.ApiResource.property.REPLICATION_CONTROLLERS"></a>

```typescript
public readonly REPLICATION_CONTROLLERS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ReplicationController.

---

##### `RESOURCE_QUOTAS`<sup>Required</sup> <a name="RESOURCE_QUOTAS" id="cdk8s-plus-28.ApiResource.property.RESOURCE_QUOTAS"></a>

```typescript
public readonly RESOURCE_QUOTAS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ResourceQuota.

---

##### `ROLE_BINDINGS`<sup>Required</sup> <a name="ROLE_BINDINGS" id="cdk8s-plus-28.ApiResource.property.ROLE_BINDINGS"></a>

```typescript
public readonly ROLE_BINDINGS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for RoleBinding.

---

##### `ROLES`<sup>Required</sup> <a name="ROLES" id="cdk8s-plus-28.ApiResource.property.ROLES"></a>

```typescript
public readonly ROLES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Role.

---

##### `RUNTIME_CLASSES`<sup>Required</sup> <a name="RUNTIME_CLASSES" id="cdk8s-plus-28.ApiResource.property.RUNTIME_CLASSES"></a>

```typescript
public readonly RUNTIME_CLASSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for RuntimeClass.

---

##### `SECRETS`<sup>Required</sup> <a name="SECRETS" id="cdk8s-plus-28.ApiResource.property.SECRETS"></a>

```typescript
public readonly SECRETS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Secret.

---

##### `SELF_SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="SELF_SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_ACCESS_REVIEWS"></a>

```typescript
public readonly SELF_SUBJECT_ACCESS_REVIEWS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SelfSubjectAccessReview.

---

##### `SELF_SUBJECT_RULES_REVIEWS`<sup>Required</sup> <a name="SELF_SUBJECT_RULES_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SELF_SUBJECT_RULES_REVIEWS"></a>

```typescript
public readonly SELF_SUBJECT_RULES_REVIEWS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SelfSubjectRulesReview.

---

##### `SERVICE_ACCOUNTS`<sup>Required</sup> <a name="SERVICE_ACCOUNTS" id="cdk8s-plus-28.ApiResource.property.SERVICE_ACCOUNTS"></a>

```typescript
public readonly SERVICE_ACCOUNTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ServiceAccount.

---

##### `SERVICES`<sup>Required</sup> <a name="SERVICES" id="cdk8s-plus-28.ApiResource.property.SERVICES"></a>

```typescript
public readonly SERVICES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for Service.

---

##### `STATEFUL_SETS`<sup>Required</sup> <a name="STATEFUL_SETS" id="cdk8s-plus-28.ApiResource.property.STATEFUL_SETS"></a>

```typescript
public readonly STATEFUL_SETS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for StatefulSet.

---

##### `STORAGE_CLASSES`<sup>Required</sup> <a name="STORAGE_CLASSES" id="cdk8s-plus-28.ApiResource.property.STORAGE_CLASSES"></a>

```typescript
public readonly STORAGE_CLASSES: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for StorageClass.

---

##### `SUBJECT_ACCESS_REVIEWS`<sup>Required</sup> <a name="SUBJECT_ACCESS_REVIEWS" id="cdk8s-plus-28.ApiResource.property.SUBJECT_ACCESS_REVIEWS"></a>

```typescript
public readonly SUBJECT_ACCESS_REVIEWS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for SubjectAccessReview.

---

##### `TOKEN_REVIEWS`<sup>Required</sup> <a name="TOKEN_REVIEWS" id="cdk8s-plus-28.ApiResource.property.TOKEN_REVIEWS"></a>

```typescript
public readonly TOKEN_REVIEWS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for TokenReview.

---

##### `VALIDATING_WEBHOOK_CONFIGURATIONS`<sup>Required</sup> <a name="VALIDATING_WEBHOOK_CONFIGURATIONS" id="cdk8s-plus-28.ApiResource.property.VALIDATING_WEBHOOK_CONFIGURATIONS"></a>

```typescript
public readonly VALIDATING_WEBHOOK_CONFIGURATIONS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for ValidatingWebhookConfiguration.

---

##### `VOLUME_ATTACHMENTS`<sup>Required</sup> <a name="VOLUME_ATTACHMENTS" id="cdk8s-plus-28.ApiResource.property.VOLUME_ATTACHMENTS"></a>

```typescript
public readonly VOLUME_ATTACHMENTS: ApiResource;
```

- *Type:* <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>

API resource information for VolumeAttachment.

---

### Container <a name="Container" id="cdk8s-plus-28.Container"></a>

A single application container that you want to run within a pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Container.Initializer"></a>

```typescript
import { Container } from 'cdk8s-plus-28'

new Container(props: ContainerProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Container.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a></code> | *No description.* |

---

##### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.Container.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerProps">ContainerProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Container.addPort">addPort</a></code> | Add a port to expose from this container. |
| <code><a href="#cdk8s-plus-28.Container.mount">mount</a></code> | Mount a volume to a specific path so that it is accessible by the container. |

---

##### `addPort` <a name="addPort" id="cdk8s-plus-28.Container.addPort"></a>

```typescript
public addPort(port: ContainerPort): void
```

Add a port to expose from this container.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.Container.addPort.parameter.port"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>

---

##### `mount` <a name="mount" id="cdk8s-plus-28.Container.mount"></a>

```typescript
public mount(path: string, storage: IStorage, options?: MountOptions): void
```

Mount a volume to a specific path so that it is accessible by the container.

Every pod that is configured to use this container will autmoatically have access to the volume.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Container.mount.parameter.path"></a>

- *Type:* string

The desired path in the container.

---

###### `storage`<sup>Required</sup> <a name="storage" id="cdk8s-plus-28.Container.mount.parameter.storage"></a>

- *Type:* <a href="#cdk8s-plus-28.IStorage">IStorage</a>

The storage to mount.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Container.mount.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MountOptions">MountOptions</a>

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Container.property.env">env</a></code> | <code><a href="#cdk8s-plus-28.Env">Env</a></code> | The environment of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.image">image</a></code> | <code>string</code> | The container image. |
| <code><a href="#cdk8s-plus-28.Container.property.imagePullPolicy">imagePullPolicy</a></code> | <code><a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a></code> | Image pull policy for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.mounts">mounts</a></code> | <code><a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]</code> | Volume mounts configured for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.name">name</a></code> | <code>string</code> | The name of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.ports">ports</a></code> | <code><a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]</code> | Ports exposed by this containers. |
| <code><a href="#cdk8s-plus-28.Container.property.securityContext">securityContext</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContext">ContainerSecurityContext</a></code> | The security context of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.args">args</a></code> | <code>string[]</code> | Arguments to the entrypoint. |
| <code><a href="#cdk8s-plus-28.Container.property.command">command</a></code> | <code>string[]</code> | Entrypoint array (the command to execute when the container starts). |
| <code><a href="#cdk8s-plus-28.Container.property.port">port</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Container.property.portNumber">portNumber</a></code> | <code>number</code> | The port number that was configured for this container. |
| <code><a href="#cdk8s-plus-28.Container.property.resources">resources</a></code> | <code><a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a></code> | Compute resources (CPU and memory requests and limits) required by the container. |
| <code><a href="#cdk8s-plus-28.Container.property.restartPolicy">restartPolicy</a></code> | <code><a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a></code> | The restart policy of the container. |
| <code><a href="#cdk8s-plus-28.Container.property.workingDir">workingDir</a></code> | <code>string</code> | The working directory inside the container. |

---

##### `env`<sup>Required</sup> <a name="env" id="cdk8s-plus-28.Container.property.env"></a>

```typescript
public readonly env: Env;
```

- *Type:* <a href="#cdk8s-plus-28.Env">Env</a>

The environment of the container.

---

##### `image`<sup>Required</sup> <a name="image" id="cdk8s-plus-28.Container.property.image"></a>

```typescript
public readonly image: string;
```

- *Type:* string

The container image.

---

##### `imagePullPolicy`<sup>Required</sup> <a name="imagePullPolicy" id="cdk8s-plus-28.Container.property.imagePullPolicy"></a>

```typescript
public readonly imagePullPolicy: ImagePullPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ImagePullPolicy">ImagePullPolicy</a>

Image pull policy for this container.

---

##### `mounts`<sup>Required</sup> <a name="mounts" id="cdk8s-plus-28.Container.property.mounts"></a>

```typescript
public readonly mounts: VolumeMount[];
```

- *Type:* <a href="#cdk8s-plus-28.VolumeMount">VolumeMount</a>[]

Volume mounts configured for this container.

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Container.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The name of the container.

---

##### `ports`<sup>Required</sup> <a name="ports" id="cdk8s-plus-28.Container.property.ports"></a>

```typescript
public readonly ports: ContainerPort[];
```

- *Type:* <a href="#cdk8s-plus-28.ContainerPort">ContainerPort</a>[]

Ports exposed by this containers.

Returns a copy, use `addPort` to modify.

---

##### `securityContext`<sup>Required</sup> <a name="securityContext" id="cdk8s-plus-28.Container.property.securityContext"></a>

```typescript
public readonly securityContext: ContainerSecurityContext;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContext">ContainerSecurityContext</a>

The security context of the container.

---

##### `args`<sup>Optional</sup> <a name="args" id="cdk8s-plus-28.Container.property.args"></a>

```typescript
public readonly args: string[];
```

- *Type:* string[]

Arguments to the entrypoint.

---

##### `command`<sup>Optional</sup> <a name="command" id="cdk8s-plus-28.Container.property.command"></a>

```typescript
public readonly command: string[];
```

- *Type:* string[]

Entrypoint array (the command to execute when the container starts).

---

##### ~~`port`~~<sup>Optional</sup> <a name="port" id="cdk8s-plus-28.Container.property.port"></a>

- *Deprecated:* - use `portNumber`.

```typescript
public readonly port: number;
```

- *Type:* number

---

##### `portNumber`<sup>Optional</sup> <a name="portNumber" id="cdk8s-plus-28.Container.property.portNumber"></a>

```typescript
public readonly portNumber: number;
```

- *Type:* number

The port number that was configured for this container.

If undefined, either the container doesn't expose a port, or its
port configuration is stored in the `ports` field.

---

##### `resources`<sup>Optional</sup> <a name="resources" id="cdk8s-plus-28.Container.property.resources"></a>

```typescript
public readonly resources: ContainerResources;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerResources">ContainerResources</a>

Compute resources (CPU and memory requests and limits) required by the container.

> [https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/](https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/)

---

##### `restartPolicy`<sup>Optional</sup> <a name="restartPolicy" id="cdk8s-plus-28.Container.property.restartPolicy"></a>

```typescript
public readonly restartPolicy: ContainerRestartPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerRestartPolicy">ContainerRestartPolicy</a>

The restart policy of the container.

---

##### `workingDir`<sup>Optional</sup> <a name="workingDir" id="cdk8s-plus-28.Container.property.workingDir"></a>

```typescript
public readonly workingDir: string;
```

- *Type:* string

The working directory inside the container.

---


### ContainerSecurityContext <a name="ContainerSecurityContext" id="cdk8s-plus-28.ContainerSecurityContext"></a>

Container security attributes and settings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ContainerSecurityContext.Initializer"></a>

```typescript
import { ContainerSecurityContext } from 'cdk8s-plus-28'

new ContainerSecurityContext(props?: ContainerSecurityContextProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a></code> | *No description.* |

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.ContainerSecurityContext.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.ContainerSecurityContextProps">ContainerSecurityContextProps</a>

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.ensureNonRoot">ensureNonRoot</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.privileged">privileged</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.readOnlyRootFilesystem">readOnlyRootFilesystem</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.allowPrivilegeEscalation">allowPrivilegeEscalation</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.capabilities">capabilities</a></code> | <code><a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.group">group</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.seccompProfile">seccompProfile</a></code> | <code><a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.ContainerSecurityContext.property.user">user</a></code> | <code>number</code> | *No description.* |

---

##### `ensureNonRoot`<sup>Required</sup> <a name="ensureNonRoot" id="cdk8s-plus-28.ContainerSecurityContext.property.ensureNonRoot"></a>

```typescript
public readonly ensureNonRoot: boolean;
```

- *Type:* boolean

---

##### `privileged`<sup>Required</sup> <a name="privileged" id="cdk8s-plus-28.ContainerSecurityContext.property.privileged"></a>

```typescript
public readonly privileged: boolean;
```

- *Type:* boolean

---

##### `readOnlyRootFilesystem`<sup>Required</sup> <a name="readOnlyRootFilesystem" id="cdk8s-plus-28.ContainerSecurityContext.property.readOnlyRootFilesystem"></a>

```typescript
public readonly readOnlyRootFilesystem: boolean;
```

- *Type:* boolean

---

##### `allowPrivilegeEscalation`<sup>Optional</sup> <a name="allowPrivilegeEscalation" id="cdk8s-plus-28.ContainerSecurityContext.property.allowPrivilegeEscalation"></a>

```typescript
public readonly allowPrivilegeEscalation: boolean;
```

- *Type:* boolean

---

##### `capabilities`<sup>Optional</sup> <a name="capabilities" id="cdk8s-plus-28.ContainerSecurityContext.property.capabilities"></a>

```typescript
public readonly capabilities: ContainerSecutiryContextCapabilities;
```

- *Type:* <a href="#cdk8s-plus-28.ContainerSecutiryContextCapabilities">ContainerSecutiryContextCapabilities</a>

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.ContainerSecurityContext.property.group"></a>

```typescript
public readonly group: number;
```

- *Type:* number

---

##### `seccompProfile`<sup>Optional</sup> <a name="seccompProfile" id="cdk8s-plus-28.ContainerSecurityContext.property.seccompProfile"></a>

```typescript
public readonly seccompProfile: SeccompProfile;
```

- *Type:* <a href="#cdk8s-plus-28.SeccompProfile">SeccompProfile</a>

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.ContainerSecurityContext.property.user"></a>

```typescript
public readonly user: number;
```

- *Type:* number

---


### Cpu <a name="Cpu" id="cdk8s-plus-28.Cpu"></a>

Represents the amount of CPU.

The amount can be passed as millis or units.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Cpu.millis">millis</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Cpu.units">units</a></code> | *No description.* |

---

##### `millis` <a name="millis" id="cdk8s-plus-28.Cpu.millis"></a>

```typescript
import { Cpu } from 'cdk8s-plus-28'

Cpu.millis(amount: number)
```

###### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.millis.parameter.amount"></a>

- *Type:* number

---

##### `units` <a name="units" id="cdk8s-plus-28.Cpu.units"></a>

```typescript
import { Cpu } from 'cdk8s-plus-28'

Cpu.units(amount: number)
```

###### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.units.parameter.amount"></a>

- *Type:* number

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Cpu.property.amount">amount</a></code> | <code>string</code> | *No description.* |

---

##### `amount`<sup>Required</sup> <a name="amount" id="cdk8s-plus-28.Cpu.property.amount"></a>

```typescript
public readonly amount: string;
```

- *Type:* string

---


### DeploymentStrategy <a name="DeploymentStrategy" id="cdk8s-plus-28.DeploymentStrategy"></a>

Deployment strategies.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DeploymentStrategy.recreate">recreate</a></code> | All existing Pods are killed before new ones are created. |
| <code><a href="#cdk8s-plus-28.DeploymentStrategy.rollingUpdate">rollingUpdate</a></code> | *No description.* |

---

##### `recreate` <a name="recreate" id="cdk8s-plus-28.DeploymentStrategy.recreate"></a>

```typescript
import { DeploymentStrategy } from 'cdk8s-plus-28'

DeploymentStrategy.recreate()
```

All existing Pods are killed before new ones are created.

> [https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#recreate-deployment](https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#recreate-deployment)

##### `rollingUpdate` <a name="rollingUpdate" id="cdk8s-plus-28.DeploymentStrategy.rollingUpdate"></a>

```typescript
import { DeploymentStrategy } from 'cdk8s-plus-28'

DeploymentStrategy.rollingUpdate(options?: DeploymentStrategyRollingUpdateOptions)
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.DeploymentStrategy.rollingUpdate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.DeploymentStrategyRollingUpdateOptions">DeploymentStrategyRollingUpdateOptions</a>

---



### Env <a name="Env" id="cdk8s-plus-28.Env"></a>

Container environment variables.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Env.Initializer"></a>

```typescript
import { Env } from 'cdk8s-plus-28'

new Env(sources: EnvFrom[], variables: {[ key: string ]: EnvValue})
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Env.Initializer.parameter.sources">sources</a></code> | <code><a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.Env.Initializer.parameter.variables">variables</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}</code> | *No description.* |

---

##### `sources`<sup>Required</sup> <a name="sources" id="cdk8s-plus-28.Env.Initializer.parameter.sources"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]

---

##### `variables`<sup>Required</sup> <a name="variables" id="cdk8s-plus-28.Env.Initializer.parameter.variables"></a>

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Env.addVariable">addVariable</a></code> | Add a single variable by name and value. |
| <code><a href="#cdk8s-plus-28.Env.copyFrom">copyFrom</a></code> | Add a collection of variables by copying from another source. |

---

##### `addVariable` <a name="addVariable" id="cdk8s-plus-28.Env.addVariable"></a>

```typescript
public addVariable(name: string, value: EnvValue): void
```

Add a single variable by name and value.

The variable value can come from various dynamic sources such a secrets of config maps.
Use `EnvValue.fromXXX` to select sources.

###### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.Env.addVariable.parameter.name"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Env.addVariable.parameter.value"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>

---

##### `copyFrom` <a name="copyFrom" id="cdk8s-plus-28.Env.copyFrom"></a>

```typescript
public copyFrom(from: EnvFrom): void
```

Add a collection of variables by copying from another source.

Use `Env.fromXXX` functions to select sources.

###### `from`<sup>Required</sup> <a name="from" id="cdk8s-plus-28.Env.copyFrom.parameter.from"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Env.fromConfigMap">fromConfigMap</a></code> | Selects a ConfigMap to populate the environment variables with. |
| <code><a href="#cdk8s-plus-28.Env.fromSecret">fromSecret</a></code> | Selects a Secret to populate the environment variables with. |

---

##### `fromConfigMap` <a name="fromConfigMap" id="cdk8s-plus-28.Env.fromConfigMap"></a>

```typescript
import { Env } from 'cdk8s-plus-28'

Env.fromConfigMap(configMap: IConfigMap, prefix?: string)
```

Selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap's Data field will represent
the key-value pairs as environment variables.

###### `configMap`<sup>Required</sup> <a name="configMap" id="cdk8s-plus-28.Env.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

---

###### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.Env.fromConfigMap.parameter.prefix"></a>

- *Type:* string

---

##### `fromSecret` <a name="fromSecret" id="cdk8s-plus-28.Env.fromSecret"></a>

```typescript
import { Env } from 'cdk8s-plus-28'

Env.fromSecret(secr: ISecret)
```

Selects a Secret to populate the environment variables with.

The contents of the target Secret's Data field will represent
the key-value pairs as environment variables.

###### `secr`<sup>Required</sup> <a name="secr" id="cdk8s-plus-28.Env.fromSecret.parameter.secr"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Env.property.sources">sources</a></code> | <code><a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]</code> | The list of sources used to populate the container environment, in addition to the `variables`. |
| <code><a href="#cdk8s-plus-28.Env.property.variables">variables</a></code> | <code>{[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}</code> | The environment variables for this container. |

---

##### `sources`<sup>Required</sup> <a name="sources" id="cdk8s-plus-28.Env.property.sources"></a>

```typescript
public readonly sources: EnvFrom[];
```

- *Type:* <a href="#cdk8s-plus-28.EnvFrom">EnvFrom</a>[]

The list of sources used to populate the container environment, in addition to the `variables`.

Returns a copy. To add a source use `container.env.copyFrom()`.

---

##### `variables`<sup>Required</sup> <a name="variables" id="cdk8s-plus-28.Env.property.variables"></a>

```typescript
public readonly variables: {[ key: string ]: EnvValue};
```

- *Type:* {[ key: string ]: <a href="#cdk8s-plus-28.EnvValue">EnvValue</a>}

The environment variables for this container.

Returns a copy. To add environment variables use `container.env.addVariable()`.

---


### EnvFrom <a name="EnvFrom" id="cdk8s-plus-28.EnvFrom"></a>

A collection of env variables defined in other resources.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.EnvFrom.Initializer"></a>

```typescript
import { EnvFrom } from 'cdk8s-plus-28'

new EnvFrom(configMap?: IConfigMap, prefix?: string, sec?: ISecret)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.configMap">configMap</a></code> | <code><a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.prefix">prefix</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvFrom.Initializer.parameter.sec">sec</a></code> | <code><a href="#cdk8s-plus-28.ISecret">ISecret</a></code> | *No description.* |

---

##### `configMap`<sup>Optional</sup> <a name="configMap" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

---

##### `prefix`<sup>Optional</sup> <a name="prefix" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.prefix"></a>

- *Type:* string

---

##### `sec`<sup>Optional</sup> <a name="sec" id="cdk8s-plus-28.EnvFrom.Initializer.parameter.sec"></a>

- *Type:* <a href="#cdk8s-plus-28.ISecret">ISecret</a>

---





### EnvValue <a name="EnvValue" id="cdk8s-plus-28.EnvValue"></a>

Utility class for creating reading env values from various sources.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValue.fromConfigMap">fromConfigMap</a></code> | Create a value by reading a specific key inside a config map. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromFieldRef">fromFieldRef</a></code> | Create a value from a field reference. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromProcess">fromProcess</a></code> | Create a value from a key in the current process environment. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromResource">fromResource</a></code> | Create a value from a resource. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromSecretValue">fromSecretValue</a></code> | Defines an environment value from a secret JSON value. |
| <code><a href="#cdk8s-plus-28.EnvValue.fromValue">fromValue</a></code> | Create a value from the given argument. |

---

##### `fromConfigMap` <a name="fromConfigMap" id="cdk8s-plus-28.EnvValue.fromConfigMap"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromConfigMap(configMap: IConfigMap, key: string, options?: EnvValueFromConfigMapOptions)
```

Create a value by reading a specific key inside a config map.

###### `configMap`<sup>Required</sup> <a name="configMap" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.configMap"></a>

- *Type:* <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

The config map.

---

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.key"></a>

- *Type:* string

The key to extract the value from.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.EnvValue.fromConfigMap.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromConfigMapOptions">EnvValueFromConfigMapOptions</a>

Additional options.

---

##### `fromFieldRef` <a name="fromFieldRef" id="cdk8s-plus-28.EnvValue.fromFieldRef"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromFieldRef(fieldPath: EnvFieldPaths, options?: EnvValueFromFieldRefOptions)
```

Create a value from a field reference.

###### `fieldPath`<sup>Required</sup> <a name="fieldPath" id="cdk8s-plus-28.EnvValue.fromFieldRef.parameter.fieldPath"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvFieldPaths">EnvFieldPaths</a>

: The field reference.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.EnvValue.fromFieldRef.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromFieldRefOptions">EnvValueFromFieldRefOptions</a>

: Additional options.

---

##### `fromProcess` <a name="fromProcess" id="cdk8s-plus-28.EnvValue.fromProcess"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromProcess(key: string, options?: EnvValueFromProcessOptions)
```

Create a value from a key in the current process environment.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.EnvValue.fromProcess.parameter.key"></a>

- *Type:* string

The key to read.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.EnvValue.fromProcess.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromProcessOptions">EnvValueFromProcessOptions</a>

Additional options.

---

##### `fromResource` <a name="fromResource" id="cdk8s-plus-28.EnvValue.fromResource"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromResource(resource: ResourceFieldPaths, options?: EnvValueFromResourceOptions)
```

Create a value from a resource.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.EnvValue.fromResource.parameter.resource"></a>

- *Type:* <a href="#cdk8s-plus-28.ResourceFieldPaths">ResourceFieldPaths</a>

: Resource to select the value from.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.EnvValue.fromResource.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromResourceOptions">EnvValueFromResourceOptions</a>

: Additional options.

---

##### `fromSecretValue` <a name="fromSecretValue" id="cdk8s-plus-28.EnvValue.fromSecretValue"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromSecretValue(secretValue: SecretValue, options?: EnvValueFromSecretOptions)
```

Defines an environment value from a secret JSON value.

###### `secretValue`<sup>Required</sup> <a name="secretValue" id="cdk8s-plus-28.EnvValue.fromSecretValue.parameter.secretValue"></a>

- *Type:* <a href="#cdk8s-plus-28.SecretValue">SecretValue</a>

The secret value (secrent + key).

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.EnvValue.fromSecretValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

Additional options.

---

##### `fromValue` <a name="fromValue" id="cdk8s-plus-28.EnvValue.fromValue"></a>

```typescript
import { EnvValue } from 'cdk8s-plus-28'

EnvValue.fromValue(value: string)
```

Create a value from the given argument.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.EnvValue.fromValue.parameter.value"></a>

- *Type:* string

The value.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.EnvValue.property.value">value</a></code> | <code>any</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.EnvValue.property.valueFrom">valueFrom</a></code> | <code>any</code> | *No description.* |

---

##### `value`<sup>Optional</sup> <a name="value" id="cdk8s-plus-28.EnvValue.property.value"></a>

```typescript
public readonly value: any;
```

- *Type:* any

---

##### `valueFrom`<sup>Optional</sup> <a name="valueFrom" id="cdk8s-plus-28.EnvValue.property.valueFrom"></a>

```typescript
public readonly valueFrom: any;
```

- *Type:* any

---


### Handler <a name="Handler" id="cdk8s-plus-28.Handler"></a>

Defines a specific action that should be taken.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Handler.fromCommand">fromCommand</a></code> | Defines a handler based on a command which is executed within the container. |
| <code><a href="#cdk8s-plus-28.Handler.fromHttpGet">fromHttpGet</a></code> | Defines a handler based on an HTTP GET request to the IP address of the container. |
| <code><a href="#cdk8s-plus-28.Handler.fromTcpSocket">fromTcpSocket</a></code> | Defines a handler based opening a connection to a TCP socket on the container. |

---

##### `fromCommand` <a name="fromCommand" id="cdk8s-plus-28.Handler.fromCommand"></a>

```typescript
import { Handler } from 'cdk8s-plus-28'

Handler.fromCommand(command: string[])
```

Defines a handler based on a command which is executed within the container.

###### `command`<sup>Required</sup> <a name="command" id="cdk8s-plus-28.Handler.fromCommand.parameter.command"></a>

- *Type:* string[]

The command to execute.

---

##### `fromHttpGet` <a name="fromHttpGet" id="cdk8s-plus-28.Handler.fromHttpGet"></a>

```typescript
import { Handler } from 'cdk8s-plus-28'

Handler.fromHttpGet(path: string, options?: HandlerFromHttpGetOptions)
```

Defines a handler based on an HTTP GET request to the IP address of the container.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Handler.fromHttpGet.parameter.path"></a>

- *Type:* string

The URL path to hit.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Handler.fromHttpGet.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.HandlerFromHttpGetOptions">HandlerFromHttpGetOptions</a>

Options.

---

##### `fromTcpSocket` <a name="fromTcpSocket" id="cdk8s-plus-28.Handler.fromTcpSocket"></a>

```typescript
import { Handler } from 'cdk8s-plus-28'

Handler.fromTcpSocket(options?: HandlerFromTcpSocketOptions)
```

Defines a handler based opening a connection to a TCP socket on the container.

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Handler.fromTcpSocket.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.HandlerFromTcpSocketOptions">HandlerFromTcpSocketOptions</a>

Options.

---



### IngressBackend <a name="IngressBackend" id="cdk8s-plus-28.IngressBackend"></a>

The backend for an ingress path.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IngressBackend.fromResource">fromResource</a></code> | A Resource backend is an ObjectRef to another Kubernetes resource within the same namespace as the Ingress object. |
| <code><a href="#cdk8s-plus-28.IngressBackend.fromService">fromService</a></code> | A Kubernetes `Service` to use as the backend for this path. |

---

##### `fromResource` <a name="fromResource" id="cdk8s-plus-28.IngressBackend.fromResource"></a>

```typescript
import { IngressBackend } from 'cdk8s-plus-28'

IngressBackend.fromResource(resource: IResource)
```

A Resource backend is an ObjectRef to another Kubernetes resource within the same namespace as the Ingress object.

A common usage for a Resource backend is to ingress data to an object
storage backend with static assets.

###### `resource`<sup>Required</sup> <a name="resource" id="cdk8s-plus-28.IngressBackend.fromResource.parameter.resource"></a>

- *Type:* <a href="#cdk8s-plus-28.IResource">IResource</a>

---

##### `fromService` <a name="fromService" id="cdk8s-plus-28.IngressBackend.fromService"></a>

```typescript
import { IngressBackend } from 'cdk8s-plus-28'

IngressBackend.fromService(serv: Service, options?: ServiceIngressBackendOptions)
```

A Kubernetes `Service` to use as the backend for this path.

###### `serv`<sup>Required</sup> <a name="serv" id="cdk8s-plus-28.IngressBackend.fromService.parameter.serv"></a>

- *Type:* <a href="#cdk8s-plus-28.Service">Service</a>

The service object.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.IngressBackend.fromService.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.ServiceIngressBackendOptions">ServiceIngressBackendOptions</a>

---



### IntOrString <a name="IntOrString" id="cdk8s-plus-28.k8s.IntOrString"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.fromNumber">fromNumber</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.fromString">fromString</a></code> | *No description.* |

---

##### `fromNumber` <a name="fromNumber" id="cdk8s-plus-28.k8s.IntOrString.fromNumber"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.IntOrString.fromNumber(value: number)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.fromNumber.parameter.value"></a>

- *Type:* number

---

##### `fromString` <a name="fromString" id="cdk8s-plus-28.k8s.IntOrString.fromString"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.IntOrString.fromString(value: string)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.fromString.parameter.value"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IntOrString.property.value">value</a></code> | <code>string \| number</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.IntOrString.property.value"></a>

```typescript
public readonly value: string | number;
```

- *Type:* string | number

---


### LabeledNode <a name="LabeledNode" id="cdk8s-plus-28.LabeledNode"></a>

A node that is matched by label selectors.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.LabeledNode.Initializer"></a>

```typescript
import { LabeledNode } from 'cdk8s-plus-28'

new LabeledNode(labelSelector: NodeLabelQuery[])
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabeledNode.Initializer.parameter.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>[]</code> | *No description.* |

---

##### `labelSelector`<sup>Required</sup> <a name="labelSelector" id="cdk8s-plus-28.LabeledNode.Initializer.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>[]

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabeledNode.property.labelSelector">labelSelector</a></code> | <code><a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>[]</code> | *No description.* |

---

##### `labelSelector`<sup>Required</sup> <a name="labelSelector" id="cdk8s-plus-28.LabeledNode.property.labelSelector"></a>

```typescript
public readonly labelSelector: NodeLabelQuery[];
```

- *Type:* <a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>[]

---


### LabelExpression <a name="LabelExpression" id="cdk8s-plus-28.LabelExpression"></a>

Represents a query that can be performed against resources with labels.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelExpression.doesNotExist">doesNotExist</a></code> | Requires label `key` to not exist. |
| <code><a href="#cdk8s-plus-28.LabelExpression.exists">exists</a></code> | Requires label `key` to exist. |
| <code><a href="#cdk8s-plus-28.LabelExpression.in">in</a></code> | Requires value of label `key` to be one of `values`. |
| <code><a href="#cdk8s-plus-28.LabelExpression.notIn">notIn</a></code> | Requires value of label `key` to be none of `values`. |

---

##### `doesNotExist` <a name="doesNotExist" id="cdk8s-plus-28.LabelExpression.doesNotExist"></a>

```typescript
import { LabelExpression } from 'cdk8s-plus-28'

LabelExpression.doesNotExist(key: string)
```

Requires label `key` to not exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.doesNotExist.parameter.key"></a>

- *Type:* string

---

##### `exists` <a name="exists" id="cdk8s-plus-28.LabelExpression.exists"></a>

```typescript
import { LabelExpression } from 'cdk8s-plus-28'

LabelExpression.exists(key: string)
```

Requires label `key` to exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.exists.parameter.key"></a>

- *Type:* string

---

##### `in` <a name="in" id="cdk8s-plus-28.LabelExpression.in"></a>

```typescript
import { LabelExpression } from 'cdk8s-plus-28'

LabelExpression.in(key: string, values: string[])
```

Requires value of label `key` to be one of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.in.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.in.parameter.values"></a>

- *Type:* string[]

---

##### `notIn` <a name="notIn" id="cdk8s-plus-28.LabelExpression.notIn"></a>

```typescript
import { LabelExpression } from 'cdk8s-plus-28'

LabelExpression.notIn(key: string, values: string[])
```

Requires value of label `key` to be none of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.notIn.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.notIn.parameter.values"></a>

- *Type:* string[]

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.key">key</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.operator">operator</a></code> | <code>string</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.LabelExpression.property.values">values</a></code> | <code>string[]</code> | *No description.* |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.LabelExpression.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

---

##### `operator`<sup>Required</sup> <a name="operator" id="cdk8s-plus-28.LabelExpression.property.operator"></a>

```typescript
public readonly operator: string;
```

- *Type:* string

---

##### `values`<sup>Optional</sup> <a name="values" id="cdk8s-plus-28.LabelExpression.property.values"></a>

```typescript
public readonly values: string[];
```

- *Type:* string[]

---


### LabelSelector <a name="LabelSelector" id="cdk8s-plus-28.LabelSelector"></a>

Match a resource by labels.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelector.isEmpty">isEmpty</a></code> | *No description.* |

---

##### `isEmpty` <a name="isEmpty" id="cdk8s-plus-28.LabelSelector.isEmpty"></a>

```typescript
public isEmpty(): boolean
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.LabelSelector.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk8s-plus-28.LabelSelector.of"></a>

```typescript
import { LabelSelector } from 'cdk8s-plus-28'

LabelSelector.of(options?: LabelSelectorOptions)
```

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.LabelSelector.of.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.LabelSelectorOptions">LabelSelectorOptions</a>

---



### Metric <a name="Metric" id="cdk8s-plus-28.Metric"></a>

A metric condition that HorizontalPodAutoscaler's scale on.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Metric.containerCpu">containerCpu</a></code> | Metric that tracks the CPU of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerEphemeralStorage">containerEphemeralStorage</a></code> | Metric that tracks the local ephemeral storage of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerMemory">containerMemory</a></code> | Metric that tracks the Memory of a container. |
| <code><a href="#cdk8s-plus-28.Metric.containerStorage">containerStorage</a></code> | Metric that tracks the volume size of a container. |
| <code><a href="#cdk8s-plus-28.Metric.external">external</a></code> | A global metric that is not associated with any Kubernetes object. |
| <code><a href="#cdk8s-plus-28.Metric.object">object</a></code> | Metric that describes a metric of a kubernetes object. |
| <code><a href="#cdk8s-plus-28.Metric.pods">pods</a></code> | A pod metric that will be averaged across all pods of the current scale target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceCpu">resourceCpu</a></code> | Tracks the available CPU of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceEphemeralStorage">resourceEphemeralStorage</a></code> | Tracks the available Ephemeral Storage of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceMemory">resourceMemory</a></code> | Tracks the available Memory of the pods in a target. |
| <code><a href="#cdk8s-plus-28.Metric.resourceStorage">resourceStorage</a></code> | Tracks the available Storage of the pods in a target. |

---

##### `containerCpu` <a name="containerCpu" id="cdk8s-plus-28.Metric.containerCpu"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.containerCpu(options: MetricContainerResourceOptions)
```

Metric that tracks the CPU of a container.

This metric
will be tracked across all pods of the current scale target.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.containerCpu.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricContainerResourceOptions">MetricContainerResourceOptions</a>

---

##### `containerEphemeralStorage` <a name="containerEphemeralStorage" id="cdk8s-plus-28.Metric.containerEphemeralStorage"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.containerEphemeralStorage(options: MetricContainerResourceOptions)
```

Metric that tracks the local ephemeral storage of a container.

This metric
will be tracked across all pods of the current scale target.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.containerEphemeralStorage.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricContainerResourceOptions">MetricContainerResourceOptions</a>

---

##### `containerMemory` <a name="containerMemory" id="cdk8s-plus-28.Metric.containerMemory"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.containerMemory(options: MetricContainerResourceOptions)
```

Metric that tracks the Memory of a container.

This metric
will be tracked across all pods of the current scale target.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.containerMemory.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricContainerResourceOptions">MetricContainerResourceOptions</a>

---

##### `containerStorage` <a name="containerStorage" id="cdk8s-plus-28.Metric.containerStorage"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.containerStorage(options: MetricContainerResourceOptions)
```

Metric that tracks the volume size of a container.

This metric
will be tracked across all pods of the current scale target.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.containerStorage.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricContainerResourceOptions">MetricContainerResourceOptions</a>

---

##### `external` <a name="external" id="cdk8s-plus-28.Metric.external"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.external(options: MetricOptions)
```

A global metric that is not associated with any Kubernetes object.

Allows for autoscaling based on information coming from components running outside of
the cluster.

Use case:
* Scale up when the length of an SQS queue is greater than 10 messages.
* Scale down when an outside load balancer's queries are less than 10000 per second.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.external.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricOptions">MetricOptions</a>

---

##### `object` <a name="object" id="cdk8s-plus-28.Metric.object"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.object(options: MetricObjectOptions)
```

Metric that describes a metric of a kubernetes object.

Use case:
* Scale on a Kubernetes Ingress's hits-per-second metric.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.object.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricObjectOptions">MetricObjectOptions</a>

---

##### `pods` <a name="pods" id="cdk8s-plus-28.Metric.pods"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.pods(options: MetricOptions)
```

A pod metric that will be averaged across all pods of the current scale target.

Use case:
* Average CPU utilization across all pods
* Transactions processed per second across all pods

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.Metric.pods.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricOptions">MetricOptions</a>

---

##### `resourceCpu` <a name="resourceCpu" id="cdk8s-plus-28.Metric.resourceCpu"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.resourceCpu(target: MetricTarget)
```

Tracks the available CPU of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

Use case:
* Scale up when CPU is above 40%.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceCpu.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resourceEphemeralStorage` <a name="resourceEphemeralStorage" id="cdk8s-plus-28.Metric.resourceEphemeralStorage"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.resourceEphemeralStorage(target: MetricTarget)
```

Tracks the available Ephemeral Storage of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceEphemeralStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resourceMemory` <a name="resourceMemory" id="cdk8s-plus-28.Metric.resourceMemory"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.resourceMemory(target: MetricTarget)
```

Tracks the available Memory of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

Use case:
* Scale up when Memory is above 512MB.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceMemory.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

##### `resourceStorage` <a name="resourceStorage" id="cdk8s-plus-28.Metric.resourceStorage"></a>

```typescript
import { Metric } from 'cdk8s-plus-28'

Metric.resourceStorage(target: MetricTarget)
```

Tracks the available Storage of the pods in a target.

Note: Since the resource usages of all the containers are summed up the total
pod utilization may not accurately represent the individual container resource
usage. This could lead to situations where a single container might be running
with high usage and the HPA will not scale out because the overall pod usage
is still within acceptable limits.

###### `target`<sup>Required</sup> <a name="target" id="cdk8s-plus-28.Metric.resourceStorage.parameter.target"></a>

- *Type:* <a href="#cdk8s-plus-28.MetricTarget">MetricTarget</a>

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Metric.property.type">type</a></code> | <code>string</code> | *No description.* |

---

##### `type`<sup>Required</sup> <a name="type" id="cdk8s-plus-28.Metric.property.type"></a>

```typescript
public readonly type: string;
```

- *Type:* string

---


### MetricTarget <a name="MetricTarget" id="cdk8s-plus-28.MetricTarget"></a>

A metric condition that will trigger scaling behavior when satisfied.

*Example*

```typescript
MetricTarget.averageUtilization(70); // 70% average utilization
```



#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.MetricTarget.averageUtilization">averageUtilization</a></code> | Target a percentage value across all relevant pods. |
| <code><a href="#cdk8s-plus-28.MetricTarget.averageValue">averageValue</a></code> | Target the average value across all relevant pods. |
| <code><a href="#cdk8s-plus-28.MetricTarget.value">value</a></code> | Target a specific target value. |

---

##### `averageUtilization` <a name="averageUtilization" id="cdk8s-plus-28.MetricTarget.averageUtilization"></a>

```typescript
import { MetricTarget } from 'cdk8s-plus-28'

MetricTarget.averageUtilization(averageUtilization: number)
```

Target a percentage value across all relevant pods.

###### `averageUtilization`<sup>Required</sup> <a name="averageUtilization" id="cdk8s-plus-28.MetricTarget.averageUtilization.parameter.averageUtilization"></a>

- *Type:* number

The percentage of the utilization metric.

e.g. `50` for 50%.

---

##### `averageValue` <a name="averageValue" id="cdk8s-plus-28.MetricTarget.averageValue"></a>

```typescript
import { MetricTarget } from 'cdk8s-plus-28'

MetricTarget.averageValue(averageValue: number)
```

Target the average value across all relevant pods.

###### `averageValue`<sup>Required</sup> <a name="averageValue" id="cdk8s-plus-28.MetricTarget.averageValue.parameter.averageValue"></a>

- *Type:* number

The average metric value.

---

##### `value` <a name="value" id="cdk8s-plus-28.MetricTarget.value"></a>

```typescript
import { MetricTarget } from 'cdk8s-plus-28'

MetricTarget.value(value: number)
```

Target a specific target value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.MetricTarget.value.parameter.value"></a>

- *Type:* number

The target value.

---



### NamedNode <a name="NamedNode" id="cdk8s-plus-28.NamedNode"></a>

A node that is matched by its name.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.NamedNode.Initializer"></a>

```typescript
import { NamedNode } from 'cdk8s-plus-28'

new NamedNode(name: string)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamedNode.Initializer.parameter.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NamedNode.Initializer.parameter.name"></a>

- *Type:* string

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.NamedNode.property.name">name</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.NamedNode.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

---


### NetworkPolicyPort <a name="NetworkPolicyPort" id="cdk8s-plus-28.NetworkPolicyPort"></a>

Describes a port to allow traffic on.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.allTcp">allTcp</a></code> | Any TCP traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.allUdp">allUdp</a></code> | Any UDP traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.of">of</a></code> | Custom port configuration. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.tcp">tcp</a></code> | Distinct TCP ports. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.tcpRange">tcpRange</a></code> | A TCP port range. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.udp">udp</a></code> | Distinct UDP ports. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyPort.udpRange">udpRange</a></code> | A UDP port range. |

---

##### `allTcp` <a name="allTcp" id="cdk8s-plus-28.NetworkPolicyPort.allTcp"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.allTcp()
```

Any TCP traffic.

##### `allUdp` <a name="allUdp" id="cdk8s-plus-28.NetworkPolicyPort.allUdp"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.allUdp()
```

Any UDP traffic.

##### `of` <a name="of" id="cdk8s-plus-28.NetworkPolicyPort.of"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.of(props: NetworkPolicyPortProps)
```

Custom port configuration.

###### `props`<sup>Required</sup> <a name="props" id="cdk8s-plus-28.NetworkPolicyPort.of.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.NetworkPolicyPortProps">NetworkPolicyPortProps</a>

---

##### `tcp` <a name="tcp" id="cdk8s-plus-28.NetworkPolicyPort.tcp"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.tcp(port: number)
```

Distinct TCP ports.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPort.tcp.parameter.port"></a>

- *Type:* number

---

##### `tcpRange` <a name="tcpRange" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.tcpRange(startPort: number, endPort: number)
```

A TCP port range.

###### `startPort`<sup>Required</sup> <a name="startPort" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange.parameter.startPort"></a>

- *Type:* number

---

###### `endPort`<sup>Required</sup> <a name="endPort" id="cdk8s-plus-28.NetworkPolicyPort.tcpRange.parameter.endPort"></a>

- *Type:* number

---

##### `udp` <a name="udp" id="cdk8s-plus-28.NetworkPolicyPort.udp"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.udp(port: number)
```

Distinct UDP ports.

###### `port`<sup>Required</sup> <a name="port" id="cdk8s-plus-28.NetworkPolicyPort.udp.parameter.port"></a>

- *Type:* number

---

##### `udpRange` <a name="udpRange" id="cdk8s-plus-28.NetworkPolicyPort.udpRange"></a>

```typescript
import { NetworkPolicyPort } from 'cdk8s-plus-28'

NetworkPolicyPort.udpRange(startPort: number, endPort: number)
```

A UDP port range.

###### `startPort`<sup>Required</sup> <a name="startPort" id="cdk8s-plus-28.NetworkPolicyPort.udpRange.parameter.startPort"></a>

- *Type:* number

---

###### `endPort`<sup>Required</sup> <a name="endPort" id="cdk8s-plus-28.NetworkPolicyPort.udpRange.parameter.endPort"></a>

- *Type:* number

---



### Node <a name="Node" id="cdk8s-plus-28.Node"></a>

Represents a node in the cluster.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.Node.Initializer"></a>

```typescript
import { Node } from 'cdk8s-plus-28'

new Node()
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |

---


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Node.labeled">labeled</a></code> | Match a node by its labels. |
| <code><a href="#cdk8s-plus-28.Node.named">named</a></code> | Match a node by its name. |
| <code><a href="#cdk8s-plus-28.Node.tainted">tainted</a></code> | Match a node by its taints. |

---

##### `labeled` <a name="labeled" id="cdk8s-plus-28.Node.labeled"></a>

```typescript
import { Node } from 'cdk8s-plus-28'

Node.labeled(labelSelector: NodeLabelQuery)
```

Match a node by its labels.

###### `labelSelector`<sup>Required</sup> <a name="labelSelector" id="cdk8s-plus-28.Node.labeled.parameter.labelSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeLabelQuery">NodeLabelQuery</a>

---

##### `named` <a name="named" id="cdk8s-plus-28.Node.named"></a>

```typescript
import { Node } from 'cdk8s-plus-28'

Node.named(nodeName: string)
```

Match a node by its name.

###### `nodeName`<sup>Required</sup> <a name="nodeName" id="cdk8s-plus-28.Node.named.parameter.nodeName"></a>

- *Type:* string

---

##### `tainted` <a name="tainted" id="cdk8s-plus-28.Node.tainted"></a>

```typescript
import { Node } from 'cdk8s-plus-28'

Node.tainted(taintSelector: NodeTaintQuery)
```

Match a node by its taints.

###### `taintSelector`<sup>Required</sup> <a name="taintSelector" id="cdk8s-plus-28.Node.tainted.parameter.taintSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>

---



### NodeLabelQuery <a name="NodeLabelQuery" id="cdk8s-plus-28.NodeLabelQuery"></a>

Represents a query that can be performed against nodes with labels.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.doesNotExist">doesNotExist</a></code> | Requires label `key` to not exist. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.exists">exists</a></code> | Requires label `key` to exist. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.gt">gt</a></code> | Requires value of label `key` to greater than all elements in `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.in">in</a></code> | Requires value of label `key` to be one of `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.is">is</a></code> | Requires value of label `key` to equal `value`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.lt">lt</a></code> | Requires value of label `key` to less than all elements in `values`. |
| <code><a href="#cdk8s-plus-28.NodeLabelQuery.notIn">notIn</a></code> | Requires value of label `key` to be none of `values`. |

---

##### `doesNotExist` <a name="doesNotExist" id="cdk8s-plus-28.NodeLabelQuery.doesNotExist"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.doesNotExist(key: string)
```

Requires label `key` to not exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.doesNotExist.parameter.key"></a>

- *Type:* string

---

##### `exists` <a name="exists" id="cdk8s-plus-28.NodeLabelQuery.exists"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.exists(key: string)
```

Requires label `key` to exist.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.exists.parameter.key"></a>

- *Type:* string

---

##### `gt` <a name="gt" id="cdk8s-plus-28.NodeLabelQuery.gt"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.gt(key: string, values: string[])
```

Requires value of label `key` to greater than all elements in `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.gt.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.gt.parameter.values"></a>

- *Type:* string[]

---

##### `in` <a name="in" id="cdk8s-plus-28.NodeLabelQuery.in"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.in(key: string, values: string[])
```

Requires value of label `key` to be one of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.in.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.in.parameter.values"></a>

- *Type:* string[]

---

##### `is` <a name="is" id="cdk8s-plus-28.NodeLabelQuery.is"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.is(key: string, value: string)
```

Requires value of label `key` to equal `value`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.is.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.NodeLabelQuery.is.parameter.value"></a>

- *Type:* string

---

##### `lt` <a name="lt" id="cdk8s-plus-28.NodeLabelQuery.lt"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.lt(key: string, values: string[])
```

Requires value of label `key` to less than all elements in `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.lt.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.lt.parameter.values"></a>

- *Type:* string[]

---

##### `notIn` <a name="notIn" id="cdk8s-plus-28.NodeLabelQuery.notIn"></a>

```typescript
import { NodeLabelQuery } from 'cdk8s-plus-28'

NodeLabelQuery.notIn(key: string, values: string[])
```

Requires value of label `key` to be none of `values`.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeLabelQuery.notIn.parameter.key"></a>

- *Type:* string

---

###### `values`<sup>Required</sup> <a name="values" id="cdk8s-plus-28.NodeLabelQuery.notIn.parameter.values"></a>

- *Type:* string[]

---



### NodeTaintQuery <a name="NodeTaintQuery" id="cdk8s-plus-28.NodeTaintQuery"></a>

Taint queries that can be perfomed against nodes.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.any">any</a></code> | Matches any taint. |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.exists">exists</a></code> | Matches a tain with any value of a specific key. |
| <code><a href="#cdk8s-plus-28.NodeTaintQuery.is">is</a></code> | Matches a taint with a specific key and value. |

---

##### `any` <a name="any" id="cdk8s-plus-28.NodeTaintQuery.any"></a>

```typescript
import { NodeTaintQuery } from 'cdk8s-plus-28'

NodeTaintQuery.any()
```

Matches any taint.

##### `exists` <a name="exists" id="cdk8s-plus-28.NodeTaintQuery.exists"></a>

```typescript
import { NodeTaintQuery } from 'cdk8s-plus-28'

NodeTaintQuery.exists(key: string, options?: NodeTaintQueryOptions)
```

Matches a tain with any value of a specific key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeTaintQuery.exists.parameter.key"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.NodeTaintQuery.exists.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQueryOptions">NodeTaintQueryOptions</a>

---

##### `is` <a name="is" id="cdk8s-plus-28.NodeTaintQuery.is"></a>

```typescript
import { NodeTaintQuery } from 'cdk8s-plus-28'

NodeTaintQuery.is(key: string, value: string, options?: NodeTaintQueryOptions)
```

Matches a taint with a specific key and value.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.key"></a>

- *Type:* string

---

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.value"></a>

- *Type:* string

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.NodeTaintQuery.is.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQueryOptions">NodeTaintQueryOptions</a>

---



### NonApiResource <a name="NonApiResource" id="cdk8s-plus-28.NonApiResource"></a>

- *Implements:* <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

Factory for creating non api resources.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NonApiResource.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.NonApiResource.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |

---

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.NonApiResource.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.NonApiResource.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NonApiResource.of">of</a></code> | *No description.* |

---

##### `of` <a name="of" id="cdk8s-plus-28.NonApiResource.of"></a>

```typescript
import { NonApiResource } from 'cdk8s-plus-28'

NonApiResource.of(url: string)
```

###### `url`<sup>Required</sup> <a name="url" id="cdk8s-plus-28.NonApiResource.of.parameter.url"></a>

- *Type:* string

---



### PercentOrAbsolute <a name="PercentOrAbsolute" id="cdk8s-plus-28.PercentOrAbsolute"></a>

Union like class repsenting either a ration in percents or an absolute number.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.isZero">isZero</a></code> | *No description.* |

---

##### `isZero` <a name="isZero" id="cdk8s-plus-28.PercentOrAbsolute.isZero"></a>

```typescript
public isZero(): boolean
```

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.absolute">absolute</a></code> | Absolute number. |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.percent">percent</a></code> | Percent ratio. |

---

##### `absolute` <a name="absolute" id="cdk8s-plus-28.PercentOrAbsolute.absolute"></a>

```typescript
import { PercentOrAbsolute } from 'cdk8s-plus-28'

PercentOrAbsolute.absolute(num: number)
```

Absolute number.

###### `num`<sup>Required</sup> <a name="num" id="cdk8s-plus-28.PercentOrAbsolute.absolute.parameter.num"></a>

- *Type:* number

---

##### `percent` <a name="percent" id="cdk8s-plus-28.PercentOrAbsolute.percent"></a>

```typescript
import { PercentOrAbsolute } from 'cdk8s-plus-28'

PercentOrAbsolute.percent(percent: number)
```

Percent ratio.

###### `percent`<sup>Required</sup> <a name="percent" id="cdk8s-plus-28.PercentOrAbsolute.percent.parameter.percent"></a>

- *Type:* number

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PercentOrAbsolute.property.value">value</a></code> | <code>any</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.PercentOrAbsolute.property.value"></a>

```typescript
public readonly value: any;
```

- *Type:* any

---


### PodConnections <a name="PodConnections" id="cdk8s-plus-28.PodConnections"></a>

Controls network isolation rules for inter-pod communication.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodConnections.Initializer"></a>

```typescript
import { PodConnections } from 'cdk8s-plus-28'

new PodConnections(instance: AbstractPod)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnections.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.PodConnections.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnections.allowFrom">allowFrom</a></code> | Allow network traffic from the peer to this pod. |
| <code><a href="#cdk8s-plus-28.PodConnections.allowTo">allowTo</a></code> | Allow network traffic from this pod to the peer. |
| <code><a href="#cdk8s-plus-28.PodConnections.isolate">isolate</a></code> | Sets the default network policy for Pod/Workload to have all egress and ingress connections as disabled. |

---

##### `allowFrom` <a name="allowFrom" id="cdk8s-plus-28.PodConnections.allowFrom"></a>

```typescript
public allowFrom(peer: INetworkPolicyPeer, options?: PodConnectionsAllowFromOptions): void
```

Allow network traffic from the peer to this pod.

By default, this will create an ingress network policy for this pod, and an egress
network policy for the peer. This is required if both sides are already isolated.
Use `options.isolation` to control this behavior.

*Example*

```typescript
// create only an egress policy that selects the 'web' pod to allow outgoing traffic
// to the 'redis' pod. this requires the 'redis' pod to not be isolated for ingress.
redis.connections.allowFrom(web, { isolation: Isolation.PEER })

// create only an ingress policy that selects the 'redis' peer to allow incoming traffic
// from the 'web' pod. this requires the 'web' pod to not be isolated for egress.
redis.connections.allowFrom(web, { isolation: Isolation.POD })
```


###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.PodConnections.allowFrom.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodConnections.allowFrom.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsAllowFromOptions">PodConnectionsAllowFromOptions</a>

---

##### `allowTo` <a name="allowTo" id="cdk8s-plus-28.PodConnections.allowTo"></a>

```typescript
public allowTo(peer: INetworkPolicyPeer, options?: PodConnectionsAllowToOptions): void
```

Allow network traffic from this pod to the peer.

By default, this will create an egress network policy for this pod, and an ingress
network policy for the peer. This is required if both sides are already isolated.
Use `options.isolation` to control this behavior.

*Example*

```typescript
// create only an egress policy that selects the 'web' pod to allow outgoing traffic
// to the 'redis' pod. this requires the 'redis' pod to not be isolated for ingress.
web.connections.allowTo(redis, { isolation: Isolation.POD })

// create only an ingress policy that selects the 'redis' peer to allow incoming traffic
// from the 'web' pod. this requires the 'web' pod to not be isolated for egress.
web.connections.allowTo(redis, { isolation: Isolation.PEER })
```


###### `peer`<sup>Required</sup> <a name="peer" id="cdk8s-plus-28.PodConnections.allowTo.parameter.peer"></a>

- *Type:* <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodConnections.allowTo.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodConnectionsAllowToOptions">PodConnectionsAllowToOptions</a>

---

##### `isolate` <a name="isolate" id="cdk8s-plus-28.PodConnections.isolate"></a>

```typescript
public isolate(): void
```

Sets the default network policy for Pod/Workload to have all egress and ingress connections as disabled.




### PodDns <a name="PodDns" id="cdk8s-plus-28.PodDns"></a>

Holds dns settings of the pod.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodDns.Initializer"></a>

```typescript
import { PodDns } from 'cdk8s-plus-28'

new PodDns(props?: PodDnsProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a></code> | *No description.* |

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.PodDns.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.PodDnsProps">PodDnsProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.addNameserver">addNameserver</a></code> | Add a nameserver. |
| <code><a href="#cdk8s-plus-28.PodDns.addOption">addOption</a></code> | Add a custom option. |
| <code><a href="#cdk8s-plus-28.PodDns.addSearch">addSearch</a></code> | Add a search domain. |

---

##### `addNameserver` <a name="addNameserver" id="cdk8s-plus-28.PodDns.addNameserver"></a>

```typescript
public addNameserver(nameservers: string): void
```

Add a nameserver.

###### `nameservers`<sup>Required</sup> <a name="nameservers" id="cdk8s-plus-28.PodDns.addNameserver.parameter.nameservers"></a>

- *Type:* string

---

##### `addOption` <a name="addOption" id="cdk8s-plus-28.PodDns.addOption"></a>

```typescript
public addOption(options: DnsOption): void
```

Add a custom option.

###### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.PodDns.addOption.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.DnsOption">DnsOption</a>

---

##### `addSearch` <a name="addSearch" id="cdk8s-plus-28.PodDns.addSearch"></a>

```typescript
public addSearch(searches: string): void
```

Add a search domain.

###### `searches`<sup>Required</sup> <a name="searches" id="cdk8s-plus-28.PodDns.addSearch.parameter.searches"></a>

- *Type:* string

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodDns.property.hostnameAsFQDN">hostnameAsFQDN</a></code> | <code>boolean</code> | Whether or not the pods hostname is set to its FQDN. |
| <code><a href="#cdk8s-plus-28.PodDns.property.nameservers">nameservers</a></code> | <code>string[]</code> | Nameservers defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.options">options</a></code> | <code><a href="#cdk8s-plus-28.DnsOption">DnsOption</a>[]</code> | Custom dns options defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.policy">policy</a></code> | <code><a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a></code> | The DNS policy of this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.searches">searches</a></code> | <code>string[]</code> | Search domains defined for this pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.hostname">hostname</a></code> | <code>string</code> | The configured hostname of the pod. |
| <code><a href="#cdk8s-plus-28.PodDns.property.subdomain">subdomain</a></code> | <code>string</code> | The configured subdomain of the pod. |

---

##### `hostnameAsFQDN`<sup>Required</sup> <a name="hostnameAsFQDN" id="cdk8s-plus-28.PodDns.property.hostnameAsFQDN"></a>

```typescript
public readonly hostnameAsFQDN: boolean;
```

- *Type:* boolean

Whether or not the pods hostname is set to its FQDN.

---

##### `nameservers`<sup>Required</sup> <a name="nameservers" id="cdk8s-plus-28.PodDns.property.nameservers"></a>

```typescript
public readonly nameservers: string[];
```

- *Type:* string[]

Nameservers defined for this pod.

---

##### `options`<sup>Required</sup> <a name="options" id="cdk8s-plus-28.PodDns.property.options"></a>

```typescript
public readonly options: DnsOption[];
```

- *Type:* <a href="#cdk8s-plus-28.DnsOption">DnsOption</a>[]

Custom dns options defined for this pod.

---

##### `policy`<sup>Required</sup> <a name="policy" id="cdk8s-plus-28.PodDns.property.policy"></a>

```typescript
public readonly policy: DnsPolicy;
```

- *Type:* <a href="#cdk8s-plus-28.DnsPolicy">DnsPolicy</a>

The DNS policy of this pod.

---

##### `searches`<sup>Required</sup> <a name="searches" id="cdk8s-plus-28.PodDns.property.searches"></a>

```typescript
public readonly searches: string[];
```

- *Type:* string[]

Search domains defined for this pod.

---

##### `hostname`<sup>Optional</sup> <a name="hostname" id="cdk8s-plus-28.PodDns.property.hostname"></a>

```typescript
public readonly hostname: string;
```

- *Type:* string

The configured hostname of the pod.

Undefined means its set to a system-defined value.

---

##### `subdomain`<sup>Optional</sup> <a name="subdomain" id="cdk8s-plus-28.PodDns.property.subdomain"></a>

```typescript
public readonly subdomain: string;
```

- *Type:* string

The configured subdomain of the pod.

---


### PodScheduling <a name="PodScheduling" id="cdk8s-plus-28.PodScheduling"></a>

Controls the pod scheduling strategy.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodScheduling.Initializer"></a>

```typescript
import { PodScheduling } from 'cdk8s-plus-28'

new PodScheduling(instance: AbstractPod)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodScheduling.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.PodScheduling.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodScheduling.assign">assign</a></code> | Assign this pod a specific node by name. |
| <code><a href="#cdk8s-plus-28.PodScheduling.attract">attract</a></code> | Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`. |
| <code><a href="#cdk8s-plus-28.PodScheduling.colocate">colocate</a></code> | Co-locate this pod with a scheduling selection. |
| <code><a href="#cdk8s-plus-28.PodScheduling.separate">separate</a></code> | Seperate this pod from a scheduling selection. |
| <code><a href="#cdk8s-plus-28.PodScheduling.tolerate">tolerate</a></code> | Allow this pod to tolerate taints matching these tolerations. |

---

##### `assign` <a name="assign" id="cdk8s-plus-28.PodScheduling.assign"></a>

```typescript
public assign(node: NamedNode): void
```

Assign this pod a specific node by name.

The scheduler ignores the Pod, and the kubelet on the named node
tries to place the Pod on that node. Overrules any affinity rules of the pod.

Some limitations of static assignment are:

- If the named node does not exist, the Pod will not run, and in some
   cases may be automatically deleted.
- If the named node does not have the resources to accommodate the Pod,
   the Pod will fail and its reason will indicate why, for example OutOfmemory or OutOfcpu.
- Node names in cloud environments are not always predictable or stable.

Will throw is the pod is already assigned to named node.

Under the hood, this method utilizes the `nodeName` property.

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.assign.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.NamedNode">NamedNode</a>

---

##### `attract` <a name="attract" id="cdk8s-plus-28.PodScheduling.attract"></a>

```typescript
public attract(node: LabeledNode, options?: PodSchedulingAttractOptions): void
```

Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`.

Attracting to multiple nodes (i.e invoking this method multiple times) acts as
an OR condition, meaning the pod will be assigned to either one of the nodes.

Under the hood, this method utilizes the `nodeAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.attract.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.LabeledNode">LabeledNode</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodScheduling.attract.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingAttractOptions">PodSchedulingAttractOptions</a>

---

##### `colocate` <a name="colocate" id="cdk8s-plus-28.PodScheduling.colocate"></a>

```typescript
public colocate(selector: IPodSelector, options?: PodSchedulingColocateOptions): void
```

Co-locate this pod with a scheduling selection.

A selection can be one of:

- An instance of a `Pod`.
- An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
- An un-managed pod that can be selected via `Pods.select()`.

Co-locating with multiple selections ((i.e invoking this method multiple times)) acts as
an AND condition. meaning the pod will be assigned to a node that satisfies all
selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.PodScheduling.colocate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodScheduling.colocate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingColocateOptions">PodSchedulingColocateOptions</a>

---

##### `separate` <a name="separate" id="cdk8s-plus-28.PodScheduling.separate"></a>

```typescript
public separate(selector: IPodSelector, options?: PodSchedulingSeparateOptions): void
```

Seperate this pod from a scheduling selection.

A selection can be one of:

- An instance of a `Pod`.
- An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
- An un-managed pod that can be selected via `Pods.select()`.

Seperating from multiple selections acts as an AND condition. meaning the pod
will not be assigned to a node that satisfies all selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAntiAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.PodScheduling.separate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.PodScheduling.separate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingSeparateOptions">PodSchedulingSeparateOptions</a>

---

##### `tolerate` <a name="tolerate" id="cdk8s-plus-28.PodScheduling.tolerate"></a>

```typescript
public tolerate(node: TaintedNode): void
```

Allow this pod to tolerate taints matching these tolerations.

You can put multiple taints on the same node and multiple tolerations on the same pod.
The way Kubernetes processes multiple taints and tolerations is like a filter: start with
all of a node's taints, then ignore the ones for which the pod has a matching toleration;
the remaining un-ignored taints have the indicated effects on the pod. In particular:

- if there is at least one un-ignored taint with effect NoSchedule then Kubernetes will
   not schedule the pod onto that node
- if there is no un-ignored taint with effect NoSchedule but there is at least one un-ignored
   taint with effect PreferNoSchedule then Kubernetes will try to not schedule the pod onto the node
- if there is at least one un-ignored taint with effect NoExecute then the pod will be evicted from
   the node (if it is already running on the node), and will not be scheduled onto the node (if it is
   not yet running on the node).

Under the hood, this method utilizes the `tolerations` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/](https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.PodScheduling.tolerate.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintedNode">TaintedNode</a>

---




### PodSecurityContext <a name="PodSecurityContext" id="cdk8s-plus-28.PodSecurityContext"></a>

Holds pod-level security attributes and common container settings.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.PodSecurityContext.Initializer"></a>

```typescript
import { PodSecurityContext } from 'cdk8s-plus-28'

new PodSecurityContext(props?: PodSecurityContextProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.Initializer.parameter.props">props</a></code> | <code><a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a></code> | *No description.* |

---

##### `props`<sup>Optional</sup> <a name="props" id="cdk8s-plus-28.PodSecurityContext.Initializer.parameter.props"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSecurityContextProps">PodSecurityContextProps</a>

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.ensureNonRoot">ensureNonRoot</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.fsGroupChangePolicy">fsGroupChangePolicy</a></code> | <code><a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.sysctls">sysctls</a></code> | <code><a href="#cdk8s-plus-28.Sysctl">Sysctl</a>[]</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.fsGroup">fsGroup</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.group">group</a></code> | <code>number</code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodSecurityContext.property.user">user</a></code> | <code>number</code> | *No description.* |

---

##### `ensureNonRoot`<sup>Required</sup> <a name="ensureNonRoot" id="cdk8s-plus-28.PodSecurityContext.property.ensureNonRoot"></a>

```typescript
public readonly ensureNonRoot: boolean;
```

- *Type:* boolean

---

##### `fsGroupChangePolicy`<sup>Required</sup> <a name="fsGroupChangePolicy" id="cdk8s-plus-28.PodSecurityContext.property.fsGroupChangePolicy"></a>

```typescript
public readonly fsGroupChangePolicy: FsGroupChangePolicy;
```

- *Type:* <a href="#cdk8s-plus-28.FsGroupChangePolicy">FsGroupChangePolicy</a>

---

##### `sysctls`<sup>Required</sup> <a name="sysctls" id="cdk8s-plus-28.PodSecurityContext.property.sysctls"></a>

```typescript
public readonly sysctls: Sysctl[];
```

- *Type:* <a href="#cdk8s-plus-28.Sysctl">Sysctl</a>[]

---

##### `fsGroup`<sup>Optional</sup> <a name="fsGroup" id="cdk8s-plus-28.PodSecurityContext.property.fsGroup"></a>

```typescript
public readonly fsGroup: number;
```

- *Type:* number

---

##### `group`<sup>Optional</sup> <a name="group" id="cdk8s-plus-28.PodSecurityContext.property.group"></a>

```typescript
public readonly group: number;
```

- *Type:* number

---

##### `user`<sup>Optional</sup> <a name="user" id="cdk8s-plus-28.PodSecurityContext.property.user"></a>

```typescript
public readonly user: number;
```

- *Type:* number

---


### Probe <a name="Probe" id="cdk8s-plus-28.Probe"></a>

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Probe.fromCommand">fromCommand</a></code> | Defines a probe based on a command which is executed within the container. |
| <code><a href="#cdk8s-plus-28.Probe.fromHttpGet">fromHttpGet</a></code> | Defines a probe based on an HTTP GET request to the IP address of the container. |
| <code><a href="#cdk8s-plus-28.Probe.fromTcpSocket">fromTcpSocket</a></code> | Defines a probe based opening a connection to a TCP socket on the container. |

---

##### `fromCommand` <a name="fromCommand" id="cdk8s-plus-28.Probe.fromCommand"></a>

```typescript
import { Probe } from 'cdk8s-plus-28'

Probe.fromCommand(command: string[], options?: CommandProbeOptions)
```

Defines a probe based on a command which is executed within the container.

###### `command`<sup>Required</sup> <a name="command" id="cdk8s-plus-28.Probe.fromCommand.parameter.command"></a>

- *Type:* string[]

The command to execute.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Probe.fromCommand.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.CommandProbeOptions">CommandProbeOptions</a>

Options.

---

##### `fromHttpGet` <a name="fromHttpGet" id="cdk8s-plus-28.Probe.fromHttpGet"></a>

```typescript
import { Probe } from 'cdk8s-plus-28'

Probe.fromHttpGet(path: string, options?: HttpGetProbeOptions)
```

Defines a probe based on an HTTP GET request to the IP address of the container.

###### `path`<sup>Required</sup> <a name="path" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.path"></a>

- *Type:* string

The URL path to hit.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Probe.fromHttpGet.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.HttpGetProbeOptions">HttpGetProbeOptions</a>

Options.

---

##### `fromTcpSocket` <a name="fromTcpSocket" id="cdk8s-plus-28.Probe.fromTcpSocket"></a>

```typescript
import { Probe } from 'cdk8s-plus-28'

Probe.fromTcpSocket(options?: TcpSocketProbeOptions)
```

Defines a probe based opening a connection to a TCP socket on the container.

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.Probe.fromTcpSocket.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.TcpSocketProbeOptions">TcpSocketProbeOptions</a>

Options.

---



### Quantity <a name="Quantity" id="cdk8s-plus-28.k8s.Quantity"></a>


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.fromNumber">fromNumber</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.fromString">fromString</a></code> | *No description.* |

---

##### `fromNumber` <a name="fromNumber" id="cdk8s-plus-28.k8s.Quantity.fromNumber"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.Quantity.fromNumber(value: number)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.fromNumber.parameter.value"></a>

- *Type:* number

---

##### `fromString` <a name="fromString" id="cdk8s-plus-28.k8s.Quantity.fromString"></a>

```typescript
import { k8s } from 'cdk8s-plus-28'

k8s.Quantity.fromString(value: string)
```

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.fromString.parameter.value"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.Quantity.property.value">value</a></code> | <code>string \| number</code> | *No description.* |

---

##### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.k8s.Quantity.property.value"></a>

```typescript
public readonly value: string | number;
```

- *Type:* string | number

---


### Replicas <a name="Replicas" id="cdk8s-plus-28.Replicas"></a>

The amount of replicas that will change.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Replicas.absolute">absolute</a></code> | Changes the pods by a percentage of the it's current value. |
| <code><a href="#cdk8s-plus-28.Replicas.percent">percent</a></code> | Changes the pods by a percentage of the it's current value. |

---

##### `absolute` <a name="absolute" id="cdk8s-plus-28.Replicas.absolute"></a>

```typescript
import { Replicas } from 'cdk8s-plus-28'

Replicas.absolute(value: number)
```

Changes the pods by a percentage of the it's current value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Replicas.absolute.parameter.value"></a>

- *Type:* number

The amount of change to apply.

Must be greater than 0.

---

##### `percent` <a name="percent" id="cdk8s-plus-28.Replicas.percent"></a>

```typescript
import { Replicas } from 'cdk8s-plus-28'

Replicas.percent(value: number)
```

Changes the pods by a percentage of the it's current value.

###### `value`<sup>Required</sup> <a name="value" id="cdk8s-plus-28.Replicas.percent.parameter.value"></a>

- *Type:* number

The percentage of change to apply.

Must be greater than 0.

---



### ResourcePermissions <a name="ResourcePermissions" id="cdk8s-plus-28.ResourcePermissions"></a>

Controls permissions for operations on resources.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.ResourcePermissions.Initializer"></a>

```typescript
import { ResourcePermissions } from 'cdk8s-plus-28'

new ResourcePermissions(instance: Resource)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.Resource">Resource</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.ResourcePermissions.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.Resource">Resource</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.grantRead">grantRead</a></code> | Grants the list of subjects permissions to read this resource. |
| <code><a href="#cdk8s-plus-28.ResourcePermissions.grantReadWrite">grantReadWrite</a></code> | Grants the list of subjects permissions to read and write this resource. |

---

##### `grantRead` <a name="grantRead" id="cdk8s-plus-28.ResourcePermissions.grantRead"></a>

```typescript
public grantRead(subjects: ISubject): RoleBinding
```

Grants the list of subjects permissions to read this resource.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ResourcePermissions.grantRead.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

---

##### `grantReadWrite` <a name="grantReadWrite" id="cdk8s-plus-28.ResourcePermissions.grantReadWrite"></a>

```typescript
public grantReadWrite(subjects: ISubject): RoleBinding
```

Grants the list of subjects permissions to read and write this resource.

###### `subjects`<sup>Required</sup> <a name="subjects" id="cdk8s-plus-28.ResourcePermissions.grantReadWrite.parameter.subjects"></a>

- *Type:* <a href="#cdk8s-plus-28.ISubject">ISubject</a>

---




### StatefulSetUpdateStrategy <a name="StatefulSetUpdateStrategy" id="cdk8s-plus-28.StatefulSetUpdateStrategy"></a>

StatefulSet update strategies.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy.onDelete">onDelete</a></code> | The controller will not automatically update the Pods in a StatefulSet. |
| <code><a href="#cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate">rollingUpdate</a></code> | The controller will delete and recreate each Pod in the StatefulSet. |

---

##### `onDelete` <a name="onDelete" id="cdk8s-plus-28.StatefulSetUpdateStrategy.onDelete"></a>

```typescript
import { StatefulSetUpdateStrategy } from 'cdk8s-plus-28'

StatefulSetUpdateStrategy.onDelete()
```

The controller will not automatically update the Pods in a StatefulSet.

Users must manually delete Pods to cause the controller to create new Pods
that reflect modifications.

##### `rollingUpdate` <a name="rollingUpdate" id="cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate"></a>

```typescript
import { StatefulSetUpdateStrategy } from 'cdk8s-plus-28'

StatefulSetUpdateStrategy.rollingUpdate(options?: StatefulSetUpdateStrategyRollingUpdateOptions)
```

The controller will delete and recreate each Pod in the StatefulSet.

It will proceed in the same order as Pod termination (from the largest ordinal to the smallest),
updating each Pod one at a time. The Kubernetes control plane waits until an updated
Pod is Running and Ready prior to updating its predecessor.

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.StatefulSetUpdateStrategy.rollingUpdate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.StatefulSetUpdateStrategyRollingUpdateOptions">StatefulSetUpdateStrategyRollingUpdateOptions</a>

---



### TaintedNode <a name="TaintedNode" id="cdk8s-plus-28.TaintedNode"></a>

A node that is matched by taint selectors.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.TaintedNode.Initializer"></a>

```typescript
import { TaintedNode } from 'cdk8s-plus-28'

new TaintedNode(taintSelector: NodeTaintQuery[])
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TaintedNode.Initializer.parameter.taintSelector">taintSelector</a></code> | <code><a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>[]</code> | *No description.* |

---

##### `taintSelector`<sup>Required</sup> <a name="taintSelector" id="cdk8s-plus-28.TaintedNode.Initializer.parameter.taintSelector"></a>

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>[]

---



#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.TaintedNode.property.taintSelector">taintSelector</a></code> | <code><a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>[]</code> | *No description.* |

---

##### `taintSelector`<sup>Required</sup> <a name="taintSelector" id="cdk8s-plus-28.TaintedNode.property.taintSelector"></a>

```typescript
public readonly taintSelector: NodeTaintQuery[];
```

- *Type:* <a href="#cdk8s-plus-28.NodeTaintQuery">NodeTaintQuery</a>[]

---


### Topology <a name="Topology" id="cdk8s-plus-28.Topology"></a>

Available topology domains.


#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.custom">custom</a></code> | Custom key for the node label that the system uses to denote the topology domain. |

---

##### `custom` <a name="custom" id="cdk8s-plus-28.Topology.custom"></a>

```typescript
import { Topology } from 'cdk8s-plus-28'

Topology.custom(key: string)
```

Custom key for the node label that the system uses to denote the topology domain.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Topology.custom.parameter.key"></a>

- *Type:* string

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.property.key">key</a></code> | <code>string</code> | *No description.* |

---

##### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.Topology.property.key"></a>

```typescript
public readonly key: string;
```

- *Type:* string

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.Topology.property.HOSTNAME">HOSTNAME</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A hostname represents a single node in the cluster. |
| <code><a href="#cdk8s-plus-28.Topology.property.REGION">REGION</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A region represents a larger domain, made up of one or more zones. |
| <code><a href="#cdk8s-plus-28.Topology.property.ZONE">ZONE</a></code> | <code><a href="#cdk8s-plus-28.Topology">Topology</a></code> | A zone represents a logical failure domain. |

---

##### `HOSTNAME`<sup>Required</sup> <a name="HOSTNAME" id="cdk8s-plus-28.Topology.property.HOSTNAME"></a>

```typescript
public readonly HOSTNAME: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A hostname represents a single node in the cluster.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#kubernetesiohostname](https://kubernetes.io/docs/reference/labels-annotations-taints/#kubernetesiohostname)

---

##### `REGION`<sup>Required</sup> <a name="REGION" id="cdk8s-plus-28.Topology.property.REGION"></a>

```typescript
public readonly REGION: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A region represents a larger domain, made up of one or more zones.

It is uncommon
for Kubernetes clusters to span multiple regions. While the exact definition of a
zone or region is left to infrastructure implementations, common properties of a region
include higher network latency between them than within them, non-zero cost for network
traffic between them, and failure independence from other zones or regions.

For example, nodes within a region might share power infrastructure (e.g. a UPS or generator), but
nodes in different regions typically would not.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesioregion](https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesioregion)

---

##### `ZONE`<sup>Required</sup> <a name="ZONE" id="cdk8s-plus-28.Topology.property.ZONE"></a>

```typescript
public readonly ZONE: Topology;
```

- *Type:* <a href="#cdk8s-plus-28.Topology">Topology</a>

A zone represents a logical failure domain.

It is common for Kubernetes clusters to
span multiple zones for increased availability. While the exact definition of a zone is
left to infrastructure implementations, common properties of a zone include very low
network latency within a zone, no-cost network traffic within a zone, and failure
independence from other zones. For example, nodes within a zone might share a network
switch, but nodes in different zones should not.

> [https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesiozone](https://kubernetes.io/docs/reference/labels-annotations-taints/#topologykubernetesiozone)

---

### WorkloadScheduling <a name="WorkloadScheduling" id="cdk8s-plus-28.WorkloadScheduling"></a>

Controls the pod scheduling strategy of this workload.

It offers some additional API's on top of the core pod scheduling.

#### Initializers <a name="Initializers" id="cdk8s-plus-28.WorkloadScheduling.Initializer"></a>

```typescript
import { WorkloadScheduling } from 'cdk8s-plus-28'

new WorkloadScheduling(instance: AbstractPod)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.Initializer.parameter.instance">instance</a></code> | <code><a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a></code> | *No description.* |

---

##### `instance`<sup>Required</sup> <a name="instance" id="cdk8s-plus-28.WorkloadScheduling.Initializer.parameter.instance"></a>

- *Type:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.assign">assign</a></code> | Assign this pod a specific node by name. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.attract">attract</a></code> | Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.colocate">colocate</a></code> | Co-locate this pod with a scheduling selection. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.separate">separate</a></code> | Seperate this pod from a scheduling selection. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.tolerate">tolerate</a></code> | Allow this pod to tolerate taints matching these tolerations. |
| <code><a href="#cdk8s-plus-28.WorkloadScheduling.spread">spread</a></code> | Spread the pods in this workload by the topology key. |

---

##### `assign` <a name="assign" id="cdk8s-plus-28.WorkloadScheduling.assign"></a>

```typescript
public assign(node: NamedNode): void
```

Assign this pod a specific node by name.

The scheduler ignores the Pod, and the kubelet on the named node
tries to place the Pod on that node. Overrules any affinity rules of the pod.

Some limitations of static assignment are:

- If the named node does not exist, the Pod will not run, and in some
   cases may be automatically deleted.
- If the named node does not have the resources to accommodate the Pod,
   the Pod will fail and its reason will indicate why, for example OutOfmemory or OutOfcpu.
- Node names in cloud environments are not always predictable or stable.

Will throw is the pod is already assigned to named node.

Under the hood, this method utilizes the `nodeName` property.

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.assign.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.NamedNode">NamedNode</a>

---

##### `attract` <a name="attract" id="cdk8s-plus-28.WorkloadScheduling.attract"></a>

```typescript
public attract(node: LabeledNode, options?: PodSchedulingAttractOptions): void
```

Attract this pod to a node matched by selectors. You can select a node by using `Node.labeled()`.

Attracting to multiple nodes (i.e invoking this method multiple times) acts as
an OR condition, meaning the pod will be assigned to either one of the nodes.

Under the hood, this method utilizes the `nodeAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#node-affinity)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.attract.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.LabeledNode">LabeledNode</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.WorkloadScheduling.attract.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingAttractOptions">PodSchedulingAttractOptions</a>

---

##### `colocate` <a name="colocate" id="cdk8s-plus-28.WorkloadScheduling.colocate"></a>

```typescript
public colocate(selector: IPodSelector, options?: PodSchedulingColocateOptions): void
```

Co-locate this pod with a scheduling selection.

A selection can be one of:

- An instance of a `Pod`.
- An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
- An un-managed pod that can be selected via `Pods.select()`.

Co-locating with multiple selections ((i.e invoking this method multiple times)) acts as
an AND condition. meaning the pod will be assigned to a node that satisfies all
selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.WorkloadScheduling.colocate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.WorkloadScheduling.colocate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingColocateOptions">PodSchedulingColocateOptions</a>

---

##### `separate` <a name="separate" id="cdk8s-plus-28.WorkloadScheduling.separate"></a>

```typescript
public separate(selector: IPodSelector, options?: PodSchedulingSeparateOptions): void
```

Seperate this pod from a scheduling selection.

A selection can be one of:

- An instance of a `Pod`.
- An instance of a `Workload` (e.g `Deployment`, `StatefulSet`).
- An un-managed pod that can be selected via `Pods.select()`.

Seperating from multiple selections acts as an AND condition. meaning the pod
will not be assigned to a node that satisfies all selections (i.e runs at least one pod that satisifies each selection).

Under the hood, this method utilizes the `podAntiAffinity` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity](https://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#inter-pod-affinity-and-anti-affinity)

###### `selector`<sup>Required</sup> <a name="selector" id="cdk8s-plus-28.WorkloadScheduling.separate.parameter.selector"></a>

- *Type:* <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.WorkloadScheduling.separate.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.PodSchedulingSeparateOptions">PodSchedulingSeparateOptions</a>

---

##### `tolerate` <a name="tolerate" id="cdk8s-plus-28.WorkloadScheduling.tolerate"></a>

```typescript
public tolerate(node: TaintedNode): void
```

Allow this pod to tolerate taints matching these tolerations.

You can put multiple taints on the same node and multiple tolerations on the same pod.
The way Kubernetes processes multiple taints and tolerations is like a filter: start with
all of a node's taints, then ignore the ones for which the pod has a matching toleration;
the remaining un-ignored taints have the indicated effects on the pod. In particular:

- if there is at least one un-ignored taint with effect NoSchedule then Kubernetes will
   not schedule the pod onto that node
- if there is no un-ignored taint with effect NoSchedule but there is at least one un-ignored
   taint with effect PreferNoSchedule then Kubernetes will try to not schedule the pod onto the node
- if there is at least one un-ignored taint with effect NoExecute then the pod will be evicted from
   the node (if it is already running on the node), and will not be scheduled onto the node (if it is
   not yet running on the node).

Under the hood, this method utilizes the `tolerations` property.

> [https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/](https://kubernetes.io/docs/concepts/scheduling-eviction/taint-and-toleration/)

###### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.WorkloadScheduling.tolerate.parameter.node"></a>

- *Type:* <a href="#cdk8s-plus-28.TaintedNode">TaintedNode</a>

---

##### `spread` <a name="spread" id="cdk8s-plus-28.WorkloadScheduling.spread"></a>

```typescript
public spread(options?: WorkloadSchedulingSpreadOptions): void
```

Spread the pods in this workload by the topology key.

A spread is a separation of the pod from itself and is used to
balance out pod replicas across a given topology.

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.WorkloadScheduling.spread.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.WorkloadSchedulingSpreadOptions">WorkloadSchedulingSpreadOptions</a>

---




## Protocols <a name="Protocols" id="Protocols"></a>

### IApiEndpoint <a name="IApiEndpoint" id="cdk8s-plus-28.IApiEndpoint"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.NonApiResource">NonApiResource</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IApiEndpoint">IApiEndpoint</a>

An API Endpoint can either be a resource descriptor (e.g /pods) or a non resource url (e.g /healthz). It must be one or the other, and not both.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IApiEndpoint.asApiResource">asApiResource</a></code> | Return the IApiResource this object represents. |
| <code><a href="#cdk8s-plus-28.IApiEndpoint.asNonApiResource">asNonApiResource</a></code> | Return the non resource url this object represents. |

---

##### `asApiResource` <a name="asApiResource" id="cdk8s-plus-28.IApiEndpoint.asApiResource"></a>

```typescript
public asApiResource(): IApiResource
```

Return the IApiResource this object represents.

##### `asNonApiResource` <a name="asNonApiResource" id="cdk8s-plus-28.IApiEndpoint.asNonApiResource"></a>

```typescript
public asNonApiResource(): string
```

Return the non resource url this object represents.


### IApiResource <a name="IApiResource" id="cdk8s-plus-28.IApiResource"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.ApiResource">ApiResource</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

Represents a resource or collection of resources.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IApiResource.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IApiResource.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IApiResource.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IApiResource.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IApiResource.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IApiResource.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

### IClusterRole <a name="IClusterRole" id="cdk8s-plus-28.IClusterRole"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>

Represents a cluster-level role.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IClusterRole.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IClusterRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IClusterRole.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IClusterRole.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IClusterRole.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IClusterRole.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IClusterRole.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IClusterRole.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IConfigMap <a name="IConfigMap" id="cdk8s-plus-28.IConfigMap"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>

Represents a config map.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IConfigMap.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IConfigMap.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IConfigMap.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IConfigMap.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IConfigMap.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IConfigMap.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IConfigMap.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IConfigMap.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### INamespaceSelector <a name="INamespaceSelector" id="cdk8s-plus-28.INamespaceSelector"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>, <a href="#cdk8s-plus-28.INamespaceSelector">INamespaceSelector</a>

Represents an object that can select namespaces.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.INamespaceSelector.toNamespaceSelectorConfig">toNamespaceSelectorConfig</a></code> | Return the configuration of this selector. |

---

##### `toNamespaceSelectorConfig` <a name="toNamespaceSelectorConfig" id="cdk8s-plus-28.INamespaceSelector.toNamespaceSelectorConfig"></a>

```typescript
public toNamespaceSelectorConfig(): NamespaceSelectorConfig
```

Return the configuration of this selector.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.INamespaceSelector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.INamespaceSelector.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

### INetworkPolicyPeer <a name="INetworkPolicyPeer" id="cdk8s-plus-28.INetworkPolicyPeer"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.Namespaces">Namespaces</a>, <a href="#cdk8s-plus-28.NetworkPolicyIpBlock">NetworkPolicyIpBlock</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.INetworkPolicyPeer">INetworkPolicyPeer</a>

Describes a peer to allow traffic to/from.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.toNetworkPolicyPeerConfig">toNetworkPolicyPeerConfig</a></code> | Return the configuration of this peer. |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.toPodSelector">toPodSelector</a></code> | Convert the peer into a pod selector, if possible. |

---

##### `toNetworkPolicyPeerConfig` <a name="toNetworkPolicyPeerConfig" id="cdk8s-plus-28.INetworkPolicyPeer.toNetworkPolicyPeerConfig"></a>

```typescript
public toNetworkPolicyPeerConfig(): NetworkPolicyPeerConfig
```

Return the configuration of this peer.

##### `toPodSelector` <a name="toPodSelector" id="cdk8s-plus-28.INetworkPolicyPeer.toPodSelector"></a>

```typescript
public toPodSelector(): IPodSelector
```

Convert the peer into a pod selector, if possible.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.INetworkPolicyPeer.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.INetworkPolicyPeer.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

### IPersistentVolume <a name="IPersistentVolume" id="cdk8s-plus-28.IPersistentVolume"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>

Contract of a `PersistentVolumeClaim`.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolume.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPersistentVolume.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IPersistentVolume.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IPersistentVolume.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IPersistentVolume.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IPersistentVolume.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IPersistentVolume.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IPersistentVolume.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IPersistentVolumeClaim <a name="IPersistentVolumeClaim" id="cdk8s-plus-28.IPersistentVolumeClaim"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>

Contract of a `PersistentVolumeClaim`.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IPersistentVolumeClaim.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPersistentVolumeClaim.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IPersistentVolumeClaim.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IPersistentVolumeClaim.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IPersistentVolumeClaim.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IPersistentVolumeClaim.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IPersistentVolumeClaim.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IPersistentVolumeClaim.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IPodSelector <a name="IPodSelector" id="cdk8s-plus-28.IPodSelector"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Pods">Pods</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IPodSelector">IPodSelector</a>

Represents an object that can select pods.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IPodSelector.toPodSelectorConfig">toPodSelectorConfig</a></code> | Return the configuration of this selector. |

---

##### `toPodSelectorConfig` <a name="toPodSelectorConfig" id="cdk8s-plus-28.IPodSelector.toPodSelectorConfig"></a>

```typescript
public toPodSelectorConfig(): PodSelectorConfig
```

Return the configuration of this selector.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IPodSelector.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IPodSelector.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

### IResource <a name="IResource" id="cdk8s-plus-28.IResource"></a>

- *Extends:* constructs.IConstruct, <a href="#cdk8s-plus-28.IApiResource">IApiResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.ClusterRoleBinding">ClusterRoleBinding</a>, <a href="#cdk8s-plus-28.ConfigMap">ConfigMap</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.HorizontalPodAutoscaler">HorizontalPodAutoscaler</a>, <a href="#cdk8s-plus-28.Ingress">Ingress</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Namespace">Namespace</a>, <a href="#cdk8s-plus-28.NetworkPolicy">NetworkPolicy</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolumeClaim">PersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.Resource">Resource</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.RoleBinding">RoleBinding</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.Service">Service</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IClusterRole">IClusterRole</a>, <a href="#cdk8s-plus-28.IConfigMap">IConfigMap</a>, <a href="#cdk8s-plus-28.IPersistentVolume">IPersistentVolume</a>, <a href="#cdk8s-plus-28.IPersistentVolumeClaim">IPersistentVolumeClaim</a>, <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>

Represents a resource.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IResource.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IResource.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IResource.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IResource.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IResource.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IResource.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IResource.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IResource.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IResource.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IResource.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IResource.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IResource.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IResource.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IResource.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IRole <a name="IRole" id="cdk8s-plus-28.IRole"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ClusterRole">ClusterRole</a>, <a href="#cdk8s-plus-28.Role">Role</a>, <a href="#cdk8s-plus-28.IRole">IRole</a>

A reference to any Role or ClusterRole.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IRole.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IRole.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IRole.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IRole.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IRole.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IRole.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IRole.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IRole.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IRole.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IRole.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IRole.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IRole.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IRole.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IRole.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IScalable <a name="IScalable" id="cdk8s-plus-28.IScalable"></a>

- *Implemented By:* <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.IScalable">IScalable</a>

Represents a scalable workload.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IScalable.markHasAutoscaler">markHasAutoscaler</a></code> | Called on all IScalable targets when they are associated with an autoscaler. |
| <code><a href="#cdk8s-plus-28.IScalable.toScalingTarget">toScalingTarget</a></code> | Return the target spec properties of this Scalable. |

---

##### `markHasAutoscaler` <a name="markHasAutoscaler" id="cdk8s-plus-28.IScalable.markHasAutoscaler"></a>

```typescript
public markHasAutoscaler(): void
```

Called on all IScalable targets when they are associated with an autoscaler.

##### `toScalingTarget` <a name="toScalingTarget" id="cdk8s-plus-28.IScalable.toScalingTarget"></a>

```typescript
public toScalingTarget(): ScalingTarget
```

Return the target spec properties of this Scalable.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IScalable.property.hasAutoscaler">hasAutoscaler</a></code> | <code>boolean</code> | If this is a target of an autoscaler. |

---

##### `hasAutoscaler`<sup>Required</sup> <a name="hasAutoscaler" id="cdk8s-plus-28.IScalable.property.hasAutoscaler"></a>

```typescript
public readonly hasAutoscaler: boolean;
```

- *Type:* boolean

If this is a target of an autoscaler.

---

### ISecret <a name="ISecret" id="cdk8s-plus-28.ISecret"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>

- *Implemented By:* <a href="#cdk8s-plus-28.BasicAuthSecret">BasicAuthSecret</a>, <a href="#cdk8s-plus-28.DockerConfigSecret">DockerConfigSecret</a>, <a href="#cdk8s-plus-28.Secret">Secret</a>, <a href="#cdk8s-plus-28.ServiceAccountTokenSecret">ServiceAccountTokenSecret</a>, <a href="#cdk8s-plus-28.SshAuthSecret">SshAuthSecret</a>, <a href="#cdk8s-plus-28.TlsSecret">TlsSecret</a>, <a href="#cdk8s-plus-28.ISecret">ISecret</a>

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ISecret.envValue">envValue</a></code> | Returns EnvValue object from a secret's key. |

---

##### `envValue` <a name="envValue" id="cdk8s-plus-28.ISecret.envValue"></a>

```typescript
public envValue(key: string, options?: EnvValueFromSecretOptions): EnvValue
```

Returns EnvValue object from a secret's key.

###### `key`<sup>Required</sup> <a name="key" id="cdk8s-plus-28.ISecret.envValue.parameter.key"></a>

- *Type:* string

Secret's key.

---

###### `options`<sup>Optional</sup> <a name="options" id="cdk8s-plus-28.ISecret.envValue.parameter.options"></a>

- *Type:* <a href="#cdk8s-plus-28.EnvValueFromSecretOptions">EnvValueFromSecretOptions</a>

Additional EnvValue options.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ISecret.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.ISecret.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.ISecret.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.ISecret.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.ISecret.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.ISecret.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.ISecret.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ISecret.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.ISecret.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.ISecret.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.ISecret.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.ISecret.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.ISecret.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.ISecret.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IServiceAccount <a name="IServiceAccount" id="cdk8s-plus-28.IServiceAccount"></a>

- *Extends:* <a href="#cdk8s-plus-28.IResource">IResource</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

- *Implemented By:* <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.apiGroup">apiGroup</a></code> | <code>string</code> | The group portion of the API version (e.g. `authorization.k8s.io`). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.resourceType">resourceType</a></code> | <code>string</code> | The name of a resource type as it appears in the relevant API endpoint. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.resourceName">resourceName</a></code> | <code>string</code> | The unique, namespace-global, name of an object inside the Kubernetes cluster. |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.apiVersion">apiVersion</a></code> | <code>string</code> | The object's API version (e.g. "authorization.k8s.io/v1"). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.kind">kind</a></code> | <code>string</code> | The object kind (e.g. "Deployment"). |
| <code><a href="#cdk8s-plus-28.IServiceAccount.property.name">name</a></code> | <code>string</code> | The Kubernetes name of this resource. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IServiceAccount.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

##### `apiGroup`<sup>Required</sup> <a name="apiGroup" id="cdk8s-plus-28.IServiceAccount.property.apiGroup"></a>

```typescript
public readonly apiGroup: string;
```

- *Type:* string

The group portion of the API version (e.g. `authorization.k8s.io`).

---

##### `resourceType`<sup>Required</sup> <a name="resourceType" id="cdk8s-plus-28.IServiceAccount.property.resourceType"></a>

```typescript
public readonly resourceType: string;
```

- *Type:* string

The name of a resource type as it appears in the relevant API endpoint.

> [https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources](https://kubernetes.io/docs/reference/access-authn-authz/rbac/#referring-to-resources)

---

*Example*

```typescript
- "pods" or "pods/log"
```


##### `resourceName`<sup>Optional</sup> <a name="resourceName" id="cdk8s-plus-28.IServiceAccount.property.resourceName"></a>

```typescript
public readonly resourceName: string;
```

- *Type:* string

The unique, namespace-global, name of an object inside the Kubernetes cluster.

If this is omitted, the ApiResource should represent all objects of the given type.

---

##### `apiVersion`<sup>Required</sup> <a name="apiVersion" id="cdk8s-plus-28.IServiceAccount.property.apiVersion"></a>

```typescript
public readonly apiVersion: string;
```

- *Type:* string

The object's API version (e.g. "authorization.k8s.io/v1").

---

##### `kind`<sup>Required</sup> <a name="kind" id="cdk8s-plus-28.IServiceAccount.property.kind"></a>

```typescript
public readonly kind: string;
```

- *Type:* string

The object kind (e.g. "Deployment").

---

##### `name`<sup>Required</sup> <a name="name" id="cdk8s-plus-28.IServiceAccount.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

The Kubernetes name of this resource.

---

### IStorage <a name="IStorage" id="cdk8s-plus-28.IStorage"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AwsElasticBlockStorePersistentVolume">AwsElasticBlockStorePersistentVolume</a>, <a href="#cdk8s-plus-28.AzureDiskPersistentVolume">AzureDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.GCEPersistentDiskPersistentVolume">GCEPersistentDiskPersistentVolume</a>, <a href="#cdk8s-plus-28.PersistentVolume">PersistentVolume</a>, <a href="#cdk8s-plus-28.Volume">Volume</a>, <a href="#cdk8s-plus-28.IStorage">IStorage</a>

Represents a piece of storage in the cluster.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.IStorage.asVolume">asVolume</a></code> | Convert the piece of storage into a concrete volume. |

---

##### `asVolume` <a name="asVolume" id="cdk8s-plus-28.IStorage.asVolume"></a>

```typescript
public asVolume(): Volume
```

Convert the piece of storage into a concrete volume.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.IStorage.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.IStorage.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

### ISubject <a name="ISubject" id="cdk8s-plus-28.ISubject"></a>

- *Extends:* constructs.IConstruct

- *Implemented By:* <a href="#cdk8s-plus-28.AbstractPod">AbstractPod</a>, <a href="#cdk8s-plus-28.CronJob">CronJob</a>, <a href="#cdk8s-plus-28.DaemonSet">DaemonSet</a>, <a href="#cdk8s-plus-28.Deployment">Deployment</a>, <a href="#cdk8s-plus-28.Group">Group</a>, <a href="#cdk8s-plus-28.Job">Job</a>, <a href="#cdk8s-plus-28.Pod">Pod</a>, <a href="#cdk8s-plus-28.ServiceAccount">ServiceAccount</a>, <a href="#cdk8s-plus-28.StatefulSet">StatefulSet</a>, <a href="#cdk8s-plus-28.User">User</a>, <a href="#cdk8s-plus-28.Workload">Workload</a>, <a href="#cdk8s-plus-28.IServiceAccount">IServiceAccount</a>, <a href="#cdk8s-plus-28.ISubject">ISubject</a>

Represents an object that can be used as a role binding subject.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ISubject.toSubjectConfiguration">toSubjectConfiguration</a></code> | Return the subject configuration. |

---

##### `toSubjectConfiguration` <a name="toSubjectConfiguration" id="cdk8s-plus-28.ISubject.toSubjectConfiguration"></a>

```typescript
public toSubjectConfiguration(): SubjectConfiguration
```

Return the subject configuration.

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#cdk8s-plus-28.ISubject.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="cdk8s-plus-28.ISubject.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---

## Enums <a name="Enums" id="Enums"></a>

### AzureDiskPersistentVolumeCachingMode <a name="AzureDiskPersistentVolumeCachingMode" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode"></a>

Azure disk caching modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.NONE">NONE</a></code> | None. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_ONLY">READ_ONLY</a></code> | ReadOnly. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_WRITE">READ_WRITE</a></code> | ReadWrite. |

---

##### `NONE` <a name="NONE" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.NONE"></a>

None.

---


##### `READ_ONLY` <a name="READ_ONLY" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_ONLY"></a>

ReadOnly.

---


##### `READ_WRITE` <a name="READ_WRITE" id="cdk8s-plus-28.AzureDiskPersistentVolumeCachingMode.READ_WRITE"></a>

ReadWrite.

---


### AzureDiskPersistentVolumeKind <a name="AzureDiskPersistentVolumeKind" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind"></a>

Azure Disk kinds.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.SHARED">SHARED</a></code> | Multiple blob disks per storage account. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.DEDICATED">DEDICATED</a></code> | Single blob disk per storage account. |
| <code><a href="#cdk8s-plus-28.AzureDiskPersistentVolumeKind.MANAGED">MANAGED</a></code> | Azure managed data disk. |

---

##### `SHARED` <a name="SHARED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.SHARED"></a>

Multiple blob disks per storage account.

---


##### `DEDICATED` <a name="DEDICATED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.DEDICATED"></a>

Single blob disk per storage account.

---


##### `MANAGED` <a name="MANAGED" id="cdk8s-plus-28.AzureDiskPersistentVolumeKind.MANAGED"></a>

Azure managed data disk.

---


### Capability <a name="Capability" id="cdk8s-plus-28.Capability"></a>

Capability - complete list of POSIX capabilities.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Capability.ALL">ALL</a></code> | ALL. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_CONTROL">AUDIT_CONTROL</a></code> | CAP_AUDIT_CONTROL. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_READ">AUDIT_READ</a></code> | CAP_AUDIT_READ. |
| <code><a href="#cdk8s-plus-28.Capability.AUDIT_WRITE">AUDIT_WRITE</a></code> | CAP_AUDIT_WRITE. |
| <code><a href="#cdk8s-plus-28.Capability.BLOCK_SUSPEND">BLOCK_SUSPEND</a></code> | CAP_BLOCK_SUSPEND. |
| <code><a href="#cdk8s-plus-28.Capability.BPF">BPF</a></code> | CAP_BPF. |
| <code><a href="#cdk8s-plus-28.Capability.CHECKPOINT_RESTORE">CHECKPOINT_RESTORE</a></code> | CAP_CHECKPOINT_RESTORE. |
| <code><a href="#cdk8s-plus-28.Capability.CHOWN">CHOWN</a></code> | CAP_CHOWN. |
| <code><a href="#cdk8s-plus-28.Capability.DAC_OVERRIDE">DAC_OVERRIDE</a></code> | CAP_DAC_OVERRIDE. |
| <code><a href="#cdk8s-plus-28.Capability.DAC_READ_SEARCH">DAC_READ_SEARCH</a></code> | CAP_DAC_READ_SEARCH. |
| <code><a href="#cdk8s-plus-28.Capability.FOWNER">FOWNER</a></code> | CAP_FOWNER. |
| <code><a href="#cdk8s-plus-28.Capability.FSETID">FSETID</a></code> | CAP_FSETID. |
| <code><a href="#cdk8s-plus-28.Capability.IPC_LOCK">IPC_LOCK</a></code> | CAP_IPC_LOCK. |
| <code><a href="#cdk8s-plus-28.Capability.IPC_OWNER">IPC_OWNER</a></code> | CAP_IPC_OWNER. |
| <code><a href="#cdk8s-plus-28.Capability.KILL">KILL</a></code> | CAP_KILL. |
| <code><a href="#cdk8s-plus-28.Capability.LEASE">LEASE</a></code> | CAP_LEASE. |
| <code><a href="#cdk8s-plus-28.Capability.LINUX_IMMUTABLE">LINUX_IMMUTABLE</a></code> | CAP_LINUX_IMMUTABLE. |
| <code><a href="#cdk8s-plus-28.Capability.MAC_ADMIN">MAC_ADMIN</a></code> | CAP_MAC_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.MAC_OVERRIDE">MAC_OVERRIDE</a></code> | CAP_MAC_OVERRIDE. |
| <code><a href="#cdk8s-plus-28.Capability.MKNOD">MKNOD</a></code> | CAP_MKNOD. |
| <code><a href="#cdk8s-plus-28.Capability.NET_ADMIN">NET_ADMIN</a></code> | CAP_NET_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.NET_BIND_SERVICE">NET_BIND_SERVICE</a></code> | CAP_NET_BIND_SERVICE. |
| <code><a href="#cdk8s-plus-28.Capability.NET_BROADCAST">NET_BROADCAST</a></code> | CAP_NET_BROADCAST. |
| <code><a href="#cdk8s-plus-28.Capability.NET_RAW">NET_RAW</a></code> | CAP_NET_RAW. |
| <code><a href="#cdk8s-plus-28.Capability.PERFMON">PERFMON</a></code> | CAP_PERFMON. |
| <code><a href="#cdk8s-plus-28.Capability.SETGID">SETGID</a></code> | CAP_SETGID. |
| <code><a href="#cdk8s-plus-28.Capability.SETFCAP">SETFCAP</a></code> | CAP_SETFCAP. |
| <code><a href="#cdk8s-plus-28.Capability.SETPCAP">SETPCAP</a></code> | CAP_SETPCAP. |
| <code><a href="#cdk8s-plus-28.Capability.SETUID">SETUID</a></code> | CAP_SETUID. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_ADMIN">SYS_ADMIN</a></code> | CAP_SYS_ADMIN. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_BOOT">SYS_BOOT</a></code> | CAP_SYS_BOOT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_CHROOT">SYS_CHROOT</a></code> | CAP_SYS_CHROOT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_MODULE">SYS_MODULE</a></code> | CAP_SYS_MODULE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_NICE">SYS_NICE</a></code> | CAP_SYS_NICE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_PACCT">SYS_PACCT</a></code> | CAP_SYS_PACCT. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_PTRACE">SYS_PTRACE</a></code> | CAP_SYS_PTRACE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_RAWIO">SYS_RAWIO</a></code> | CAP_SYS_RAWIO. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_RESOURCE">SYS_RESOURCE</a></code> | CAP_SYS_RESOURCE. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_TIME">SYS_TIME</a></code> | CAP_SYS_TIME. |
| <code><a href="#cdk8s-plus-28.Capability.SYS_TTY_CONFIG">SYS_TTY_CONFIG</a></code> | CAP_SYS_TTY_CONFIG. |
| <code><a href="#cdk8s-plus-28.Capability.SYSLOG">SYSLOG</a></code> | CAP_SYSLOG. |
| <code><a href="#cdk8s-plus-28.Capability.WAKE_ALARM">WAKE_ALARM</a></code> | CAP_WAKE_ALARM. |

---

##### `ALL` <a name="ALL" id="cdk8s-plus-28.Capability.ALL"></a>

ALL.

---


##### `AUDIT_CONTROL` <a name="AUDIT_CONTROL" id="cdk8s-plus-28.Capability.AUDIT_CONTROL"></a>

CAP_AUDIT_CONTROL.

---


##### `AUDIT_READ` <a name="AUDIT_READ" id="cdk8s-plus-28.Capability.AUDIT_READ"></a>

CAP_AUDIT_READ.

---


##### `AUDIT_WRITE` <a name="AUDIT_WRITE" id="cdk8s-plus-28.Capability.AUDIT_WRITE"></a>

CAP_AUDIT_WRITE.

---


##### `BLOCK_SUSPEND` <a name="BLOCK_SUSPEND" id="cdk8s-plus-28.Capability.BLOCK_SUSPEND"></a>

CAP_BLOCK_SUSPEND.

---


##### `BPF` <a name="BPF" id="cdk8s-plus-28.Capability.BPF"></a>

CAP_BPF.

---


##### `CHECKPOINT_RESTORE` <a name="CHECKPOINT_RESTORE" id="cdk8s-plus-28.Capability.CHECKPOINT_RESTORE"></a>

CAP_CHECKPOINT_RESTORE.

---


##### `CHOWN` <a name="CHOWN" id="cdk8s-plus-28.Capability.CHOWN"></a>

CAP_CHOWN.

---


##### `DAC_OVERRIDE` <a name="DAC_OVERRIDE" id="cdk8s-plus-28.Capability.DAC_OVERRIDE"></a>

CAP_DAC_OVERRIDE.

---


##### `DAC_READ_SEARCH` <a name="DAC_READ_SEARCH" id="cdk8s-plus-28.Capability.DAC_READ_SEARCH"></a>

CAP_DAC_READ_SEARCH.

---


##### `FOWNER` <a name="FOWNER" id="cdk8s-plus-28.Capability.FOWNER"></a>

CAP_FOWNER.

---


##### `FSETID` <a name="FSETID" id="cdk8s-plus-28.Capability.FSETID"></a>

CAP_FSETID.

---


##### `IPC_LOCK` <a name="IPC_LOCK" id="cdk8s-plus-28.Capability.IPC_LOCK"></a>

CAP_IPC_LOCK.

---


##### `IPC_OWNER` <a name="IPC_OWNER" id="cdk8s-plus-28.Capability.IPC_OWNER"></a>

CAP_IPC_OWNER.

---


##### `KILL` <a name="KILL" id="cdk8s-plus-28.Capability.KILL"></a>

CAP_KILL.

---


##### `LEASE` <a name="LEASE" id="cdk8s-plus-28.Capability.LEASE"></a>

CAP_LEASE.

---


##### `LINUX_IMMUTABLE` <a name="LINUX_IMMUTABLE" id="cdk8s-plus-28.Capability.LINUX_IMMUTABLE"></a>

CAP_LINUX_IMMUTABLE.

---


##### `MAC_ADMIN` <a name="MAC_ADMIN" id="cdk8s-plus-28.Capability.MAC_ADMIN"></a>

CAP_MAC_ADMIN.

---


##### `MAC_OVERRIDE` <a name="MAC_OVERRIDE" id="cdk8s-plus-28.Capability.MAC_OVERRIDE"></a>

CAP_MAC_OVERRIDE.

---


##### `MKNOD` <a name="MKNOD" id="cdk8s-plus-28.Capability.MKNOD"></a>

CAP_MKNOD.

---


##### `NET_ADMIN` <a name="NET_ADMIN" id="cdk8s-plus-28.Capability.NET_ADMIN"></a>

CAP_NET_ADMIN.

---


##### `NET_BIND_SERVICE` <a name="NET_BIND_SERVICE" id="cdk8s-plus-28.Capability.NET_BIND_SERVICE"></a>

CAP_NET_BIND_SERVICE.

---


##### `NET_BROADCAST` <a name="NET_BROADCAST" id="cdk8s-plus-28.Capability.NET_BROADCAST"></a>

CAP_NET_BROADCAST.

---


##### `NET_RAW` <a name="NET_RAW" id="cdk8s-plus-28.Capability.NET_RAW"></a>

CAP_NET_RAW.

---


##### `PERFMON` <a name="PERFMON" id="cdk8s-plus-28.Capability.PERFMON"></a>

CAP_PERFMON.

---


##### `SETGID` <a name="SETGID" id="cdk8s-plus-28.Capability.SETGID"></a>

CAP_SETGID.

---


##### `SETFCAP` <a name="SETFCAP" id="cdk8s-plus-28.Capability.SETFCAP"></a>

CAP_SETFCAP.

---


##### `SETPCAP` <a name="SETPCAP" id="cdk8s-plus-28.Capability.SETPCAP"></a>

CAP_SETPCAP.

---


##### `SETUID` <a name="SETUID" id="cdk8s-plus-28.Capability.SETUID"></a>

CAP_SETUID.

---


##### `SYS_ADMIN` <a name="SYS_ADMIN" id="cdk8s-plus-28.Capability.SYS_ADMIN"></a>

CAP_SYS_ADMIN.

---


##### `SYS_BOOT` <a name="SYS_BOOT" id="cdk8s-plus-28.Capability.SYS_BOOT"></a>

CAP_SYS_BOOT.

---


##### `SYS_CHROOT` <a name="SYS_CHROOT" id="cdk8s-plus-28.Capability.SYS_CHROOT"></a>

CAP_SYS_CHROOT.

---


##### `SYS_MODULE` <a name="SYS_MODULE" id="cdk8s-plus-28.Capability.SYS_MODULE"></a>

CAP_SYS_MODULE.

---


##### `SYS_NICE` <a name="SYS_NICE" id="cdk8s-plus-28.Capability.SYS_NICE"></a>

CAP_SYS_NICE.

---


##### `SYS_PACCT` <a name="SYS_PACCT" id="cdk8s-plus-28.Capability.SYS_PACCT"></a>

CAP_SYS_PACCT.

---


##### `SYS_PTRACE` <a name="SYS_PTRACE" id="cdk8s-plus-28.Capability.SYS_PTRACE"></a>

CAP_SYS_PTRACE.

---


##### `SYS_RAWIO` <a name="SYS_RAWIO" id="cdk8s-plus-28.Capability.SYS_RAWIO"></a>

CAP_SYS_RAWIO.

---


##### `SYS_RESOURCE` <a name="SYS_RESOURCE" id="cdk8s-plus-28.Capability.SYS_RESOURCE"></a>

CAP_SYS_RESOURCE.

---


##### `SYS_TIME` <a name="SYS_TIME" id="cdk8s-plus-28.Capability.SYS_TIME"></a>

CAP_SYS_TIME.

---


##### `SYS_TTY_CONFIG` <a name="SYS_TTY_CONFIG" id="cdk8s-plus-28.Capability.SYS_TTY_CONFIG"></a>

CAP_SYS_TTY_CONFIG.

---


##### `SYSLOG` <a name="SYSLOG" id="cdk8s-plus-28.Capability.SYSLOG"></a>

CAP_SYSLOG.

---


##### `WAKE_ALARM` <a name="WAKE_ALARM" id="cdk8s-plus-28.Capability.WAKE_ALARM"></a>

CAP_WAKE_ALARM.

---


### ConcurrencyPolicy <a name="ConcurrencyPolicy" id="cdk8s-plus-28.ConcurrencyPolicy"></a>

Concurrency policy for CronJobs.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.ALLOW">ALLOW</a></code> | This policy allows to run job concurrently. |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.FORBID">FORBID</a></code> | This policy does not allow to run job concurrently. |
| <code><a href="#cdk8s-plus-28.ConcurrencyPolicy.REPLACE">REPLACE</a></code> | This policy replaces the currently running job if a new job is being scheduled. |

---

##### `ALLOW` <a name="ALLOW" id="cdk8s-plus-28.ConcurrencyPolicy.ALLOW"></a>

This policy allows to run job concurrently.

---


##### `FORBID` <a name="FORBID" id="cdk8s-plus-28.ConcurrencyPolicy.FORBID"></a>

This policy does not allow to run job concurrently.

It does not let a new job to be scheduled if the previous one is not finished yet.

---


##### `REPLACE` <a name="REPLACE" id="cdk8s-plus-28.ConcurrencyPolicy.REPLACE"></a>

This policy replaces the currently running job if a new job is being scheduled.

---


### ConnectionScheme <a name="ConnectionScheme" id="cdk8s-plus-28.ConnectionScheme"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ConnectionScheme.HTTP">HTTP</a></code> | Use HTTP request for connecting to host. |
| <code><a href="#cdk8s-plus-28.ConnectionScheme.HTTPS">HTTPS</a></code> | Use HTTPS request for connecting to host. |

---

##### `HTTP` <a name="HTTP" id="cdk8s-plus-28.ConnectionScheme.HTTP"></a>

Use HTTP request for connecting to host.

---


##### `HTTPS` <a name="HTTPS" id="cdk8s-plus-28.ConnectionScheme.HTTPS"></a>

Use HTTPS request for connecting to host.

---


### ContainerRestartPolicy <a name="ContainerRestartPolicy" id="cdk8s-plus-28.ContainerRestartPolicy"></a>

RestartPolicy defines the restart behavior of individual containers in a pod.

This field may only be set for init containers, and the only allowed value is "Always".
For non-init containers or when this field is not specified,
the restart behavior is defined by the Pod's restart policy and the container type.
Setting the RestartPolicy as "Always" for the init container will have the following effect:
this init container will be continually restarted on exit until all regular containers have terminated.
Once all regular containers have completed, all init containers with restartPolicy "Always" will be shut down.
This lifecycle differs from normal init containers and is often referred to as a "sidecar" container.

> [https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/](https://kubernetes.io/docs/concepts/workloads/pods/sidecar-containers/)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ContainerRestartPolicy.ALWAYS">ALWAYS</a></code> | If an init container is created with its restartPolicy set to Always, it will start and remain running during the entire life of the Pod. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.ContainerRestartPolicy.ALWAYS"></a>

If an init container is created with its restartPolicy set to Always, it will start and remain running during the entire life of the Pod.

For regular containers, this is ignored by Kubernetes.

---


### DnsPolicy <a name="DnsPolicy" id="cdk8s-plus-28.DnsPolicy"></a>

Pod DNS policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST">CLUSTER_FIRST</a></code> | Any DNS query that does not match the configured cluster domain suffix, such as "www.kubernetes.io", is forwarded to the upstream nameserver inherited from the node. Cluster administrators may have extra stub-domain and upstream DNS servers configured. |
| <code><a href="#cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST_WITH_HOST_NET">CLUSTER_FIRST_WITH_HOST_NET</a></code> | For Pods running with hostNetwork, you should explicitly set its DNS policy "ClusterFirstWithHostNet". |
| <code><a href="#cdk8s-plus-28.DnsPolicy.DEFAULT">DEFAULT</a></code> | The Pod inherits the name resolution configuration from the node that the pods run on. |
| <code><a href="#cdk8s-plus-28.DnsPolicy.NONE">NONE</a></code> | It allows a Pod to ignore DNS settings from the Kubernetes environment. |

---

##### `CLUSTER_FIRST` <a name="CLUSTER_FIRST" id="cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST"></a>

Any DNS query that does not match the configured cluster domain suffix, such as "www.kubernetes.io", is forwarded to the upstream nameserver inherited from the node. Cluster administrators may have extra stub-domain and upstream DNS servers configured.

---


##### `CLUSTER_FIRST_WITH_HOST_NET` <a name="CLUSTER_FIRST_WITH_HOST_NET" id="cdk8s-plus-28.DnsPolicy.CLUSTER_FIRST_WITH_HOST_NET"></a>

For Pods running with hostNetwork, you should explicitly set its DNS policy "ClusterFirstWithHostNet".

---


##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.DnsPolicy.DEFAULT"></a>

The Pod inherits the name resolution configuration from the node that the pods run on.

---


##### `NONE` <a name="NONE" id="cdk8s-plus-28.DnsPolicy.NONE"></a>

It allows a Pod to ignore DNS settings from the Kubernetes environment.

All DNS settings are supposed to be provided using the dnsConfig
field in the Pod Spec.

---


### EmptyDirMedium <a name="EmptyDirMedium" id="cdk8s-plus-28.EmptyDirMedium"></a>

The medium on which to store the volume.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EmptyDirMedium.DEFAULT">DEFAULT</a></code> | The default volume of the backing node. |
| <code><a href="#cdk8s-plus-28.EmptyDirMedium.MEMORY">MEMORY</a></code> | Mount a tmpfs (RAM-backed filesystem) for you instead. |

---

##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.EmptyDirMedium.DEFAULT"></a>

The default volume of the backing node.

---


##### `MEMORY` <a name="MEMORY" id="cdk8s-plus-28.EmptyDirMedium.MEMORY"></a>

Mount a tmpfs (RAM-backed filesystem) for you instead.

While tmpfs is very
fast, be aware that unlike disks, tmpfs is cleared on node reboot and any
files you write will count against your Container's memory limit.

---


### EnvFieldPaths <a name="EnvFieldPaths" id="cdk8s-plus-28.EnvFieldPaths"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_NAME">POD_NAME</a></code> | The name of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_NAMESPACE">POD_NAMESPACE</a></code> | The namespace of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_UID">POD_UID</a></code> | The uid of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_LABEL">POD_LABEL</a></code> | The labels of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_ANNOTATION">POD_ANNOTATION</a></code> | The annotations of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_IP">POD_IP</a></code> | The ipAddress of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.SERVICE_ACCOUNT_NAME">SERVICE_ACCOUNT_NAME</a></code> | The service account name of the pod. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.NODE_NAME">NODE_NAME</a></code> | The name of the node. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.NODE_IP">NODE_IP</a></code> | The ipAddress of the node. |
| <code><a href="#cdk8s-plus-28.EnvFieldPaths.POD_IPS">POD_IPS</a></code> | The ipAddresess of the pod. |

---

##### `POD_NAME` <a name="POD_NAME" id="cdk8s-plus-28.EnvFieldPaths.POD_NAME"></a>

The name of the pod.

---


##### `POD_NAMESPACE` <a name="POD_NAMESPACE" id="cdk8s-plus-28.EnvFieldPaths.POD_NAMESPACE"></a>

The namespace of the pod.

---


##### `POD_UID` <a name="POD_UID" id="cdk8s-plus-28.EnvFieldPaths.POD_UID"></a>

The uid of the pod.

---


##### `POD_LABEL` <a name="POD_LABEL" id="cdk8s-plus-28.EnvFieldPaths.POD_LABEL"></a>

The labels of the pod.

---


##### `POD_ANNOTATION` <a name="POD_ANNOTATION" id="cdk8s-plus-28.EnvFieldPaths.POD_ANNOTATION"></a>

The annotations of the pod.

---


##### `POD_IP` <a name="POD_IP" id="cdk8s-plus-28.EnvFieldPaths.POD_IP"></a>

The ipAddress of the pod.

---


##### `SERVICE_ACCOUNT_NAME` <a name="SERVICE_ACCOUNT_NAME" id="cdk8s-plus-28.EnvFieldPaths.SERVICE_ACCOUNT_NAME"></a>

The service account name of the pod.

---


##### `NODE_NAME` <a name="NODE_NAME" id="cdk8s-plus-28.EnvFieldPaths.NODE_NAME"></a>

The name of the node.

---


##### `NODE_IP` <a name="NODE_IP" id="cdk8s-plus-28.EnvFieldPaths.NODE_IP"></a>

The ipAddress of the node.

---


##### `POD_IPS` <a name="POD_IPS" id="cdk8s-plus-28.EnvFieldPaths.POD_IPS"></a>

The ipAddresess of the pod.

---


### FsGroupChangePolicy <a name="FsGroupChangePolicy" id="cdk8s-plus-28.FsGroupChangePolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.FsGroupChangePolicy.ON_ROOT_MISMATCH">ON_ROOT_MISMATCH</a></code> | Only change permissions and ownership if permission and ownership of root directory does not match with expected permissions of the volume. |
| <code><a href="#cdk8s-plus-28.FsGroupChangePolicy.ALWAYS">ALWAYS</a></code> | Always change permission and ownership of the volume when volume is mounted. |

---

##### `ON_ROOT_MISMATCH` <a name="ON_ROOT_MISMATCH" id="cdk8s-plus-28.FsGroupChangePolicy.ON_ROOT_MISMATCH"></a>

Only change permissions and ownership if permission and ownership of root directory does not match with expected permissions of the volume.

This could help shorten the time it takes to change ownership and permission of a volume

---


##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.FsGroupChangePolicy.ALWAYS"></a>

Always change permission and ownership of the volume when volume is mounted.

---


### HostPathVolumeType <a name="HostPathVolumeType" id="cdk8s-plus-28.HostPathVolumeType"></a>

Host path types.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DEFAULT">DEFAULT</a></code> | Empty string (default) is for backward compatibility, which means that no checks will be performed before mounting the hostPath volume. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DIRECTORY_OR_CREATE">DIRECTORY_OR_CREATE</a></code> | If nothing exists at the given path, an empty directory will be created there as needed with permission set to 0755, having the same group and ownership with Kubelet. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.DIRECTORY">DIRECTORY</a></code> | A directory must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.FILE_OR_CREATE">FILE_OR_CREATE</a></code> | If nothing exists at the given path, an empty file will be created there as needed with permission set to 0644, having the same group and ownership with Kubelet. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.FILE">FILE</a></code> | A file must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.SOCKET">SOCKET</a></code> | A UNIX socket must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.CHAR_DEVICE">CHAR_DEVICE</a></code> | A character device must exist at the given path. |
| <code><a href="#cdk8s-plus-28.HostPathVolumeType.BLOCK_DEVICE">BLOCK_DEVICE</a></code> | A block device must exist at the given path. |

---

##### `DEFAULT` <a name="DEFAULT" id="cdk8s-plus-28.HostPathVolumeType.DEFAULT"></a>

Empty string (default) is for backward compatibility, which means that no checks will be performed before mounting the hostPath volume.

---


##### `DIRECTORY_OR_CREATE` <a name="DIRECTORY_OR_CREATE" id="cdk8s-plus-28.HostPathVolumeType.DIRECTORY_OR_CREATE"></a>

If nothing exists at the given path, an empty directory will be created there as needed with permission set to 0755, having the same group and ownership with Kubelet.

---


##### `DIRECTORY` <a name="DIRECTORY" id="cdk8s-plus-28.HostPathVolumeType.DIRECTORY"></a>

A directory must exist at the given path.

---


##### `FILE_OR_CREATE` <a name="FILE_OR_CREATE" id="cdk8s-plus-28.HostPathVolumeType.FILE_OR_CREATE"></a>

If nothing exists at the given path, an empty file will be created there as needed with permission set to 0644, having the same group and ownership with Kubelet.

---


##### `FILE` <a name="FILE" id="cdk8s-plus-28.HostPathVolumeType.FILE"></a>

A file must exist at the given path.

---


##### `SOCKET` <a name="SOCKET" id="cdk8s-plus-28.HostPathVolumeType.SOCKET"></a>

A UNIX socket must exist at the given path.

---


##### `CHAR_DEVICE` <a name="CHAR_DEVICE" id="cdk8s-plus-28.HostPathVolumeType.CHAR_DEVICE"></a>

A character device must exist at the given path.

---


##### `BLOCK_DEVICE` <a name="BLOCK_DEVICE" id="cdk8s-plus-28.HostPathVolumeType.BLOCK_DEVICE"></a>

A block device must exist at the given path.

---


### HttpIngressPathType <a name="HttpIngressPathType" id="cdk8s-plus-28.HttpIngressPathType"></a>

Specify how the path is matched against request paths.

> [https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types](https://kubernetes.io/docs/concepts/services-networking/ingress/#path-types)

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.PREFIX">PREFIX</a></code> | Matches the URL path exactly. |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.EXACT">EXACT</a></code> | Matches based on a URL path prefix split by '/'. |
| <code><a href="#cdk8s-plus-28.HttpIngressPathType.IMPLEMENTATION_SPECIFIC">IMPLEMENTATION_SPECIFIC</a></code> | Matching is specified by the underlying IngressClass. |

---

##### `PREFIX` <a name="PREFIX" id="cdk8s-plus-28.HttpIngressPathType.PREFIX"></a>

Matches the URL path exactly.

---


##### `EXACT` <a name="EXACT" id="cdk8s-plus-28.HttpIngressPathType.EXACT"></a>

Matches based on a URL path prefix split by '/'.

---


##### `IMPLEMENTATION_SPECIFIC` <a name="IMPLEMENTATION_SPECIFIC" id="cdk8s-plus-28.HttpIngressPathType.IMPLEMENTATION_SPECIFIC"></a>

Matching is specified by the underlying IngressClass.

---


### ImagePullPolicy <a name="ImagePullPolicy" id="cdk8s-plus-28.ImagePullPolicy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.ALWAYS">ALWAYS</a></code> | Every time the kubelet launches a container, the kubelet queries the container image registry to resolve the name to an image digest. |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.IF_NOT_PRESENT">IF_NOT_PRESENT</a></code> | The image is pulled only if it is not already present locally. |
| <code><a href="#cdk8s-plus-28.ImagePullPolicy.NEVER">NEVER</a></code> | The image is assumed to exist locally. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.ImagePullPolicy.ALWAYS"></a>

Every time the kubelet launches a container, the kubelet queries the container image registry to resolve the name to an image digest.

If the kubelet has a container image with that exact
digest cached locally, the kubelet uses its cached image; otherwise, the kubelet downloads
(pulls) the image with the resolved digest, and uses that image to launch the container.

Default is Always if ImagePullPolicy is omitted and either the image tag is :latest or
the image tag is omitted.

---


##### `IF_NOT_PRESENT` <a name="IF_NOT_PRESENT" id="cdk8s-plus-28.ImagePullPolicy.IF_NOT_PRESENT"></a>

The image is pulled only if it is not already present locally.

Default is IfNotPresent if ImagePullPolicy is omitted and the image tag is present but
not :latest

---


##### `NEVER` <a name="NEVER" id="cdk8s-plus-28.ImagePullPolicy.NEVER"></a>

The image is assumed to exist locally.

No attempt is made to pull the image.

---


### IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind <a name="IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind" id="cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind"></a>

Kind is a string value representing the REST resource this object represents.

Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind.DELETE_OPTIONS">DELETE_OPTIONS</a></code> | DeleteOptions. |

---

##### `DELETE_OPTIONS` <a name="DELETE_OPTIONS" id="cdk8s-plus-28.k8s.IoK8SApimachineryPkgApisMetaV1DeleteOptionsKind.DELETE_OPTIONS"></a>

DeleteOptions.

---


### MountPropagation <a name="MountPropagation" id="cdk8s-plus-28.MountPropagation"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.MountPropagation.NONE">NONE</a></code> | This volume mount will not receive any subsequent mounts that are mounted to this volume or any of its subdirectories by the host. |
| <code><a href="#cdk8s-plus-28.MountPropagation.HOST_TO_CONTAINER">HOST_TO_CONTAINER</a></code> | This volume mount will receive all subsequent mounts that are mounted to this volume or any of its subdirectories. |
| <code><a href="#cdk8s-plus-28.MountPropagation.BIDIRECTIONAL">BIDIRECTIONAL</a></code> | This volume mount behaves the same the HostToContainer mount. |

---

##### `NONE` <a name="NONE" id="cdk8s-plus-28.MountPropagation.NONE"></a>

This volume mount will not receive any subsequent mounts that are mounted to this volume or any of its subdirectories by the host.

In similar
fashion, no mounts created by the Container will be visible on the host.

This is the default mode.

This mode is equal to `private` mount propagation as described in the Linux
kernel documentation

---


##### `HOST_TO_CONTAINER` <a name="HOST_TO_CONTAINER" id="cdk8s-plus-28.MountPropagation.HOST_TO_CONTAINER"></a>

This volume mount will receive all subsequent mounts that are mounted to this volume or any of its subdirectories.

In other words, if the host mounts anything inside the volume mount, the
Container will see it mounted there.

Similarly, if any Pod with Bidirectional mount propagation to the same
volume mounts anything there, the Container with HostToContainer mount
propagation will see it.

This mode is equal to `rslave` mount propagation as described in the Linux
kernel documentation

---


##### `BIDIRECTIONAL` <a name="BIDIRECTIONAL" id="cdk8s-plus-28.MountPropagation.BIDIRECTIONAL"></a>

This volume mount behaves the same the HostToContainer mount.

In addition,
all volume mounts created by the Container will be propagated back to the
host and to all Containers of all Pods that use the same volume

A typical use case for this mode is a Pod with a FlexVolume or CSI driver
or a Pod that needs to mount something on the host using a hostPath volume.

This mode is equal to `rshared` mount propagation as described in the Linux
kernel documentation

Caution: Bidirectional mount propagation can be dangerous. It can damage
the host operating system and therefore it is allowed only in privileged
Containers. Familiarity with Linux kernel behavior is strongly recommended.
In addition, any volume mounts created by Containers in Pods must be
destroyed (unmounted) by the Containers on termination.

---


### NetworkPolicyTrafficDefault <a name="NetworkPolicyTrafficDefault" id="cdk8s-plus-28.NetworkPolicyTrafficDefault"></a>

Default behaviors of network traffic in policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault.DENY">DENY</a></code> | The policy denies all traffic. |
| <code><a href="#cdk8s-plus-28.NetworkPolicyTrafficDefault.ALLOW">ALLOW</a></code> | The policy allows all traffic (either ingress or egress). |

---

##### `DENY` <a name="DENY" id="cdk8s-plus-28.NetworkPolicyTrafficDefault.DENY"></a>

The policy denies all traffic.

Since rules are additive, additional rules or policies can allow
specific traffic.

---


##### `ALLOW` <a name="ALLOW" id="cdk8s-plus-28.NetworkPolicyTrafficDefault.ALLOW"></a>

The policy allows all traffic (either ingress or egress).

Since rules are additive, no additional rule or policies can
subsequently deny the traffic.

---


### NetworkProtocol <a name="NetworkProtocol" id="cdk8s-plus-28.NetworkProtocol"></a>

Network protocols.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.TCP">TCP</a></code> | TCP. |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.UDP">UDP</a></code> | UDP. |
| <code><a href="#cdk8s-plus-28.NetworkProtocol.SCTP">SCTP</a></code> | SCTP. |

---

##### `TCP` <a name="TCP" id="cdk8s-plus-28.NetworkProtocol.TCP"></a>

TCP.

---


##### `UDP` <a name="UDP" id="cdk8s-plus-28.NetworkProtocol.UDP"></a>

UDP.

---


##### `SCTP` <a name="SCTP" id="cdk8s-plus-28.NetworkProtocol.SCTP"></a>

SCTP.

---


### PersistentVolumeAccessMode <a name="PersistentVolumeAccessMode" id="cdk8s-plus-28.PersistentVolumeAccessMode"></a>

Access Modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE">READ_WRITE_ONCE</a></code> | The volume can be mounted as read-write by a single node. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_ONLY_MANY">READ_ONLY_MANY</a></code> | The volume can be mounted as read-only by many nodes. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_MANY">READ_WRITE_MANY</a></code> | The volume can be mounted as read-write by many nodes. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE_POD">READ_WRITE_ONCE_POD</a></code> | The volume can be mounted as read-write by a single Pod. |

---

##### `READ_WRITE_ONCE` <a name="READ_WRITE_ONCE" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE"></a>

The volume can be mounted as read-write by a single node.

ReadWriteOnce access mode still can allow multiple pods to access
the volume when the pods are running on the same node.

---


##### `READ_ONLY_MANY` <a name="READ_ONLY_MANY" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_ONLY_MANY"></a>

The volume can be mounted as read-only by many nodes.

---


##### `READ_WRITE_MANY` <a name="READ_WRITE_MANY" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_MANY"></a>

The volume can be mounted as read-write by many nodes.

---


##### `READ_WRITE_ONCE_POD` <a name="READ_WRITE_ONCE_POD" id="cdk8s-plus-28.PersistentVolumeAccessMode.READ_WRITE_ONCE_POD"></a>

The volume can be mounted as read-write by a single Pod.

Use ReadWriteOncePod access mode if you want to ensure that
only one pod across whole cluster can read that PVC or write to it.
This is only supported for CSI volumes and Kubernetes version 1.22+.

---


### PersistentVolumeMode <a name="PersistentVolumeMode" id="cdk8s-plus-28.PersistentVolumeMode"></a>

Volume Modes.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeMode.FILE_SYSTEM">FILE_SYSTEM</a></code> | Volume is ounted into Pods into a directory. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeMode.BLOCK">BLOCK</a></code> | Use a volume as a raw block device. |

---

##### `FILE_SYSTEM` <a name="FILE_SYSTEM" id="cdk8s-plus-28.PersistentVolumeMode.FILE_SYSTEM"></a>

Volume is ounted into Pods into a directory.

If the volume is backed by a block device and the device is empty,
Kubernetes creates a filesystem on the device before mounting it
for the first time.

---


##### `BLOCK` <a name="BLOCK" id="cdk8s-plus-28.PersistentVolumeMode.BLOCK"></a>

Use a volume as a raw block device.

Such volume is presented into a Pod as a block device,
without any filesystem on it. This mode is useful to provide a Pod the fastest possible way
to access a volume, without any filesystem layer between the Pod
and the volume. On the other hand, the application running in
the Pod must know how to handle a raw block device

---


### PersistentVolumeReclaimPolicy <a name="PersistentVolumeReclaimPolicy" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy"></a>

Reclaim Policies.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy.RETAIN">RETAIN</a></code> | The Retain reclaim policy allows for manual reclamation of the resource. |
| <code><a href="#cdk8s-plus-28.PersistentVolumeReclaimPolicy.DELETE">DELETE</a></code> | For volume plugins that support the Delete reclaim policy, deletion removes both the PersistentVolume object from Kubernetes, as well as the associated storage asset in the external infrastructure, such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume. |

---

##### `RETAIN` <a name="RETAIN" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy.RETAIN"></a>

The Retain reclaim policy allows for manual reclamation of the resource.

When the PersistentVolumeClaim is deleted, the PersistentVolume still exists and the
volume is considered "released". But it is not yet available for another claim
because the previous claimant's data remains on the volume.
An administrator can manually reclaim the volume with the following steps:

1. Delete the PersistentVolume. The associated storage asset in external
    infrastructure (such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume) still exists after the PV is deleted.
2. Manually clean up the data on the associated storage asset accordingly.
3. Manually delete the associated storage asset.

If you want to reuse the same storage asset, create a new PersistentVolume
with the same storage asset definition.

---


##### `DELETE` <a name="DELETE" id="cdk8s-plus-28.PersistentVolumeReclaimPolicy.DELETE"></a>

For volume plugins that support the Delete reclaim policy, deletion removes both the PersistentVolume object from Kubernetes, as well as the associated storage asset in the external infrastructure, such as an AWS EBS, GCE PD, Azure Disk, or Cinder volume.

Volumes that were dynamically provisioned inherit the reclaim policy of their StorageClass, which defaults to Delete.
The administrator should configure the StorageClass according to users' expectations; otherwise,
the PV must be edited or patched after it is created

---


### PodConnectionsIsolation <a name="PodConnectionsIsolation" id="cdk8s-plus-28.PodConnectionsIsolation"></a>

Isolation determines which policies are created when allowing connections from a a pod / workload to peers.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodConnectionsIsolation.POD">POD</a></code> | Only creates network policies that select the pod. |
| <code><a href="#cdk8s-plus-28.PodConnectionsIsolation.PEER">PEER</a></code> | Only creates network policies that select the peer. |

---

##### `POD` <a name="POD" id="cdk8s-plus-28.PodConnectionsIsolation.POD"></a>

Only creates network policies that select the pod.

---


##### `PEER` <a name="PEER" id="cdk8s-plus-28.PodConnectionsIsolation.PEER"></a>

Only creates network policies that select the peer.

---


### PodManagementPolicy <a name="PodManagementPolicy" id="cdk8s-plus-28.PodManagementPolicy"></a>

Controls how pods are created during initial scale up, when replacing pods on nodes, or when scaling down.

The default policy is `OrderedReady`, where pods are created in increasing order
(pod-0, then pod-1, etc) and the controller will wait until each pod is ready before
continuing. When scaling down, the pods are removed in the opposite order.

The alternative policy is `Parallel` which will create pods in parallel to match the
desired scale without waiting, and on scale down will delete all pods at once.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.PodManagementPolicy.ORDERED_READY">ORDERED_READY</a></code> | *No description.* |
| <code><a href="#cdk8s-plus-28.PodManagementPolicy.PARALLEL">PARALLEL</a></code> | *No description.* |

---

##### `ORDERED_READY` <a name="ORDERED_READY" id="cdk8s-plus-28.PodManagementPolicy.ORDERED_READY"></a>

---


##### `PARALLEL` <a name="PARALLEL" id="cdk8s-plus-28.PodManagementPolicy.PARALLEL"></a>

---


### Protocol <a name="Protocol" id="cdk8s-plus-28.Protocol"></a>

Network protocols.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.Protocol.TCP">TCP</a></code> | TCP. |
| <code><a href="#cdk8s-plus-28.Protocol.UDP">UDP</a></code> | UDP. |
| <code><a href="#cdk8s-plus-28.Protocol.SCTP">SCTP</a></code> | SCTP. |

---

##### `TCP` <a name="TCP" id="cdk8s-plus-28.Protocol.TCP"></a>

TCP.

---


##### `UDP` <a name="UDP" id="cdk8s-plus-28.Protocol.UDP"></a>

UDP.

---


##### `SCTP` <a name="SCTP" id="cdk8s-plus-28.Protocol.SCTP"></a>

SCTP.

---


### ResourceFieldPaths <a name="ResourceFieldPaths" id="cdk8s-plus-28.ResourceFieldPaths"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.CPU_LIMIT">CPU_LIMIT</a></code> | CPU limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.MEMORY_LIMIT">MEMORY_LIMIT</a></code> | Memory limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.CPU_REQUEST">CPU_REQUEST</a></code> | CPU request of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.MEMORY_REQUEST">MEMORY_REQUEST</a></code> | Memory request of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.STORAGE_LIMIT">STORAGE_LIMIT</a></code> | Ephemeral storage limit of the container. |
| <code><a href="#cdk8s-plus-28.ResourceFieldPaths.STORAGE_REQUEST">STORAGE_REQUEST</a></code> | Ephemeral storage request of the container. |

---

##### `CPU_LIMIT` <a name="CPU_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.CPU_LIMIT"></a>

CPU limit of the container.

---


##### `MEMORY_LIMIT` <a name="MEMORY_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.MEMORY_LIMIT"></a>

Memory limit of the container.

---


##### `CPU_REQUEST` <a name="CPU_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.CPU_REQUEST"></a>

CPU request of the container.

---


##### `MEMORY_REQUEST` <a name="MEMORY_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.MEMORY_REQUEST"></a>

Memory request of the container.

---


##### `STORAGE_LIMIT` <a name="STORAGE_LIMIT" id="cdk8s-plus-28.ResourceFieldPaths.STORAGE_LIMIT"></a>

Ephemeral storage limit of the container.

---


##### `STORAGE_REQUEST` <a name="STORAGE_REQUEST" id="cdk8s-plus-28.ResourceFieldPaths.STORAGE_REQUEST"></a>

Ephemeral storage request of the container.

---


### RestartPolicy <a name="RestartPolicy" id="cdk8s-plus-28.RestartPolicy"></a>

Restart policy for all containers within the pod.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.RestartPolicy.ALWAYS">ALWAYS</a></code> | Always restart the pod after it exits. |
| <code><a href="#cdk8s-plus-28.RestartPolicy.ON_FAILURE">ON_FAILURE</a></code> | Only restart if the pod exits with a non-zero exit code. |
| <code><a href="#cdk8s-plus-28.RestartPolicy.NEVER">NEVER</a></code> | Never restart the pod. |

---

##### `ALWAYS` <a name="ALWAYS" id="cdk8s-plus-28.RestartPolicy.ALWAYS"></a>

Always restart the pod after it exits.

---


##### `ON_FAILURE` <a name="ON_FAILURE" id="cdk8s-plus-28.RestartPolicy.ON_FAILURE"></a>

Only restart if the pod exits with a non-zero exit code.

---


##### `NEVER` <a name="NEVER" id="cdk8s-plus-28.RestartPolicy.NEVER"></a>

Never restart the pod.

---


### ScalingStrategy <a name="ScalingStrategy" id="cdk8s-plus-28.ScalingStrategy"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.MAX_CHANGE">MAX_CHANGE</a></code> | Use the policy that provisions the most changes. |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.MIN_CHANGE">MIN_CHANGE</a></code> | Use the policy that provisions the least amount of changes. |
| <code><a href="#cdk8s-plus-28.ScalingStrategy.DISABLED">DISABLED</a></code> | Disables scaling in this direction. |

---

##### `MAX_CHANGE` <a name="MAX_CHANGE" id="cdk8s-plus-28.ScalingStrategy.MAX_CHANGE"></a>

Use the policy that provisions the most changes.

---


##### `MIN_CHANGE` <a name="MIN_CHANGE" id="cdk8s-plus-28.ScalingStrategy.MIN_CHANGE"></a>

Use the policy that provisions the least amount of changes.

---


##### ~~`DISABLED`~~ <a name="DISABLED" id="cdk8s-plus-28.ScalingStrategy.DISABLED"></a>

- *Deprecated:* - Omit the ScalingRule instead

Disables scaling in this direction.

---


### SeccompProfileType <a name="SeccompProfileType" id="cdk8s-plus-28.SeccompProfileType"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.LOCALHOST">LOCALHOST</a></code> | A profile defined in a file on the node should be used. |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.RUNTIME_DEFAULT">RUNTIME_DEFAULT</a></code> | The container runtime default profile should be used. |
| <code><a href="#cdk8s-plus-28.SeccompProfileType.UNCONFINED">UNCONFINED</a></code> | No profile should be applied. |

---

##### `LOCALHOST` <a name="LOCALHOST" id="cdk8s-plus-28.SeccompProfileType.LOCALHOST"></a>

A profile defined in a file on the node should be used.

---


##### `RUNTIME_DEFAULT` <a name="RUNTIME_DEFAULT" id="cdk8s-plus-28.SeccompProfileType.RUNTIME_DEFAULT"></a>

The container runtime default profile should be used.

---


##### `UNCONFINED` <a name="UNCONFINED" id="cdk8s-plus-28.SeccompProfileType.UNCONFINED"></a>

No profile should be applied.

---


### ServiceType <a name="ServiceType" id="cdk8s-plus-28.ServiceType"></a>

For some parts of your application (for example, frontends) you may want to expose a Service onto an external IP address, that's outside of your cluster.

Kubernetes ServiceTypes allow you to specify what kind of Service you want.
The default is ClusterIP.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.ServiceType.CLUSTER_IP">CLUSTER_IP</a></code> | Exposes the Service on a cluster-internal IP. |
| <code><a href="#cdk8s-plus-28.ServiceType.NODE_PORT">NODE_PORT</a></code> | Exposes the Service on each Node's IP at a static port (the NodePort). |
| <code><a href="#cdk8s-plus-28.ServiceType.LOAD_BALANCER">LOAD_BALANCER</a></code> | Exposes the Service externally using a cloud provider's load balancer. |
| <code><a href="#cdk8s-plus-28.ServiceType.EXTERNAL_NAME">EXTERNAL_NAME</a></code> | Maps the Service to the contents of the externalName field (e.g. foo.bar.example.com), by returning a CNAME record with its value. No proxying of any kind is set up. |

---

##### `CLUSTER_IP` <a name="CLUSTER_IP" id="cdk8s-plus-28.ServiceType.CLUSTER_IP"></a>

Exposes the Service on a cluster-internal IP.

Choosing this value makes the Service only reachable from within the cluster.
This is the default ServiceType

---


##### `NODE_PORT` <a name="NODE_PORT" id="cdk8s-plus-28.ServiceType.NODE_PORT"></a>

Exposes the Service on each Node's IP at a static port (the NodePort).

A ClusterIP Service, to which the NodePort Service routes, is automatically created.
You'll be able to contact the NodePort Service, from outside the cluster,
by requesting <NodeIP>:<NodePort>.

---


##### `LOAD_BALANCER` <a name="LOAD_BALANCER" id="cdk8s-plus-28.ServiceType.LOAD_BALANCER"></a>

Exposes the Service externally using a cloud provider's load balancer.

NodePort and ClusterIP Services, to which the external load balancer routes,
are automatically created.

---


##### `EXTERNAL_NAME` <a name="EXTERNAL_NAME" id="cdk8s-plus-28.ServiceType.EXTERNAL_NAME"></a>

Maps the Service to the contents of the externalName field (e.g. foo.bar.example.com), by returning a CNAME record with its value. No proxying of any kind is set up.

> Note: You need either kube-dns version 1.7 or CoreDNS version 0.0.8 or higher to use the ExternalName type.

---


### TaintEffect <a name="TaintEffect" id="cdk8s-plus-28.TaintEffect"></a>

Taint effects.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#cdk8s-plus-28.TaintEffect.NO_SCHEDULE">NO_SCHEDULE</a></code> | This means that no pod will be able to schedule onto the node unless it has a matching toleration. |
| <code><a href="#cdk8s-plus-28.TaintEffect.PREFER_NO_SCHEDULE">PREFER_NO_SCHEDULE</a></code> | This is a "preference" or "soft" version of `NO_SCHEDULE` -- the system will try to avoid placing a pod that does not tolerate the taint on the node, but it is not required. |
| <code><a href="#cdk8s-plus-28.TaintEffect.NO_EXECUTE">NO_EXECUTE</a></code> | This affects pods that are already running on the node as follows:. |

---

##### `NO_SCHEDULE` <a name="NO_SCHEDULE" id="cdk8s-plus-28.TaintEffect.NO_SCHEDULE"></a>

This means that no pod will be able to schedule onto the node unless it has a matching toleration.

---


##### `PREFER_NO_SCHEDULE` <a name="PREFER_NO_SCHEDULE" id="cdk8s-plus-28.TaintEffect.PREFER_NO_SCHEDULE"></a>

This is a "preference" or "soft" version of `NO_SCHEDULE` -- the system will try to avoid placing a pod that does not tolerate the taint on the node, but it is not required.

---


##### `NO_EXECUTE` <a name="NO_EXECUTE" id="cdk8s-plus-28.TaintEffect.NO_EXECUTE"></a>

This affects pods that are already running on the node as follows:.

Pods that do not tolerate the taint are evicted immediately.
- Pods that tolerate the taint without specifying `duration` remain bound forever.
- Pods that tolerate the taint with a specified `duration` remain bound for
   the specified amount of time.

---

